/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/tools/IXMAK/ixmak.c,v 1.2 2003/05/07 23:02:24 Lann Exp $ */
/* $Log: ixmak.c,v $
/* Revision 1.2  2003/05/07 23:02:24  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:38  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.22   02 Aug 1995 15:11:54   JOE
 * Changed platform names in printf's to lessen confusion over
 * Sun platform products (by dbk).
 * 
 *    Rev 1.21   06 Apr 1995 11:21:36   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.20   03 May 1994 08:28:40   JOE
 * Change MAXTF from 50 to 100.
 * Change MAXLIBNAME from 3000 to 6000.
 * 
 *    Rev 1.19   22 Apr 1994 08:19:38   LISA
 * 
 * Made additional modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.18   20 Apr 1994 09:22:08   LISA
 * 
 * Inserted new Copyright information for 1994.
 * 
 *    Rev 1.17   17 Feb 1994 15:20:10   JOE
 * Create output file IF.FNT or HQ3.FNT based on user selection.
 * 
 *    Rev 1.16   17 Feb 1994 13:11:54   JOE
 * Added prompt for the type of file to create (IF.FNT or HQ3.FNT).
 * 
 *    Rev 1.15   15 Feb 1994 16:21:52   JOE
 * 
 * Replaced DBGx() calls with printf() calls when displaying
 * error messages.
 * 
 *    Rev 1.14   08 Dec 1993 18:57:26   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.13   20 Sep 1993 16:08:56   JOE
 * In process_lib(), swap the lo and hi words of "tfnum" and "tfbuf" if
 * necessary to resolve the cross-platform problem which exists when running
 * on MOTOROLA platform using INTEL fonts.
 * In find_bucket_type(), call "xSWAPTST" macro after data is read from 
 * the font (instead of before) for "type", "key", "off", "count", "NFACES",
 * "tmplong", "NFATS", "NXREF" and "FACENUM". This resolves a bus alignment
 * problem.
 * 
 *    Rev 1.12   09 Sep 1993 08:58:08   MAIB
 * Removed a previous bug fix to allow cross-platform index file creation 
 * 
 *    Rev 1.11   23 Jul 1993 13:48:52   MAIB
 * Based structure alignment on NAT_ALIGNMENT, MEM_ALIGN
 * 
 *    Rev 1.10   14 Jul 1993 12:04:58   MIKE
 * Allow optional 2nd argument, "TT", in input file; see comments.
 * 
 *    Rev 1.9   04 May 1993 08:19:44   JOE
 * Changed MAXTF from 32 to 50 so that it is large enough to build an HQ4
 * font block.
 * 
 *    Rev 1.8   22 Feb 1993 11:50:10   JOE
 * 
 * Changed all occurrences of "inline" to "inputline" because of conflict
 * with VXWORKS.
 * 
 *    Rev 1.7   12 Feb 1993 10:44:50   JOE
 * VXWorks support.
 * 
 *    Rev 1.6   20 Jan 1993 10:36:06   JOE
 * Cross-platform changes.
 * 
 *    Rev 1.5   23 Dec 1992 13:49:28   JOE
 * Defining PATH_DELIM differently if INTEL 960.
 * 
 *    Rev 1.4   18 Dec 1992 17:38:12   ROB
 * Fix problems relating to running on i80960 and ROM blocks.
 * Change from low level to high level I/O (fopen, fread, etc).
 * 
 *    Rev 1.3   15 Dec 1992 17:06:26   ROB
 * added #include <sys\stat.h> even for not ROM.
 * added permission flag to open() call for "if.fnt" - need if it doesn't exist.
 * 
 *    Rev 1.2   14 Dec 1992 18:55:58   ROB
 * Fix compile error with cast in call to read().
 * 
 *    Rev 1.1   14 Dec 1992 08:38:20   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:40:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:24 $ */
/* ixmak.c */

/*   12-Mar-90   jfd   If requested font is italic, set bit 2 of
 *                     bucket number.
 *    9-Aug-90   awr   Merged Barbara's compression changes.
 *   11-Aug-90   awr   In process_lib() but a check for file directory
 *                     buffer overflow.
 *   20 Dec 90   ss    Moved cgconfig.h to top of CG includes
 *                     Added ROM/font_block support
 *   07-Jan-91   jfd   Initialize "tfbuf[*].tfnum" to -1 at start of
 *                     process_lib() to enable proper reading of
 *                     HQ3 update file.
 *   24-Jan-91   jfd   In process_face(), store index entry info into
 *                     temporary structure and write structure to file
 *                     to facilitate handling of different structure
 *                     formats based on configuration.
 *
 *                     In write_libsNoffsets(), updating lib_offset field
 *                     of each entry by doing a read-write instead of a
 *                     seek-write. In addition, removed definition for
 *                     TFOFF_FIELD.
 *
 *                     In main(), open output file (block_if.fnt or if.fnt)
 *                     as READ/WRITE instead of WRITEONLY.
 *
 *                     Always include "cgif.h" and "ix.h".
 *   04-Mar-91   jfd   Included "cgmach.h" and "ifmem.h".
 *   16 May 91   ss    Deleted references to COMPRESS.
 *                     Cleaned up bucket related code
 *   25-May-91   awr   Fixed for slim and ultraslim to allow for either or
 *                     both of the "font alias" or "typeface header" segments
 *                     to be missing
 *   06-Jun-91   jfd   Added SUN support
 *                     (FIX FROM EARLIER VERSION)
 *    5 Jun 91   ss    Added support for FIXED_PITCH.
 *   24 Jun 91   ss    Deleted cgmach.h
 *                     Added casts in find_bucket_type() and process_lib().
 *   25 Jun 91   ss    Added default return in FMseek_read().
 *   26 Jun 91   ss    Changed some "BYTE *" to PBYTE.
 *    3 Jul 91   ss    Added casts for comparisons of -1 to tfnum.
 *    8 Jul 91   ss    Added support for SPARC.
 *   15 Nov 91   ss    Eliminated prompt to user for font block.  If ROM
 *                     always create block_if.fnt.
 *                     Deleted extra declaration of errno.
 *                     Changed declaration of count/arg to a system call.
 *    09-Apr-92  jfd   Portability cleanup (see port.h).
 *    18 May 92  ss    Changed FIXED_PITCH to CGFIXED_PITCH.
 *     8 Jun 92  ss    Changed hq3updt.tyq name requirement for font block
 *                     creation to only use first 3 chars of "hq3".
 *    12 Jun 92  ss    Fixed previous change to work correctly on SPARC.
 *     1 Jul 92  ss    Added code to perform case insensitive test of "hq3"
 *                     for systems that don't have case insensitive "str"
 *                     functions.
 *                     Fixed reset of upated for font blocks.
 *                     Changed conditions on SUN to UNIX to be more general.
 *                     Changed write_libsNoffsets() to skip over problem
 *                     files to write as much as possible.
 *    08-Jul-92  rs    Code cleanup.
 *    18-Aug-92  rs    Port to Watcom C386 (__FLAT__).
 *    19-Aug-92  rs    Fix problem making HQ3's negative on DOS platforms.
 *    02-Oct-92  jfd   Replaced "cgsparc.h" with "cgmacros.h".
 *    12-Oct-92  jfd   INTEL 960 conditional changes.
 *    19-Nov-92  rs    Port to Macintosh - #include unix.h.
 *    05-Dec-92  rs    Fix compile problems - cast call to read().
 *    15-Dec-92  rs    Add permission flag to open() call for if.fnt.
 *                     Add #include <stat.h> for all cases (used to be ROM
 *                     only).
 *    15-Dec-92  jfd   Included <errno.h>, <types.h> and <reent.h> for
 *                     INTEL960.
 *                     Changed "f" from SW16 to "FILE *".
 *                     Changed "open" --> "fopen"
 *                             "read" --> "fread"
 *                             "write" --> "fwrite"
 *                             "close" --> "fclose"
 *                             "lseek" --> "fseek"
 *    22-Dec-92  jfd   Changed definition of PATH_DELIM for INTEL960.
 *    11-Jan-93  jfd   X-platform changes.
 *    08-Feb-93  jfd   VXWorks support.
 *                     Modified structures "tmpw" and "tmpl" to remove
 *                     conflicts in field names.
 *                     Made appropriate changes to macros WSWAPTST and
 *                     LSWAPTST.
 *                     In find_bucket_type(), changed variable "tmpl" to
 *                     "tmplong" to remove conflict with structure "tmpl".
 *                     In process_lib(), added missing subscripts when
 *                     referencing array "tfbuf_words".
 *    22-Feb-93  jfd   Changed all occurrences of "inline" to "inputline"
 *                     because of conflict with VXWORKS.
 *    04-May-93  jfd   Change MAXTF from 32 to 50 so that it is large enough
 *                     to build an HQ4 font block.
 *    14-Jul-93  mby   Input file can have an optional second argument, "TT",
 *                     after the pathname. This sets the B_PLUGIN_TYPE_TT bit
 *                     in 'bucket_num' in the INDEX_ENTRY structure.
 *    23-Jul-93  maib  changed (MEM_ALIGN == 3) to (NAT_ALIGN == 4) in the 
 *		                 cases where it was used to write data on 4 byte
 *		                 boundaries (SPARC vs non-SPARC). this change was required
 *		                 because it was inconsistent with the way UFST was 
 *		                 reading the data	(based on NAT_ALIGN)
 *    09-Sep-93  maib  Removed the above change (changing MEM_ALIGN==3 to
 *                     NAT_ALIGN==4). this prevented ixmak from creating
 *                     a cross-platform index file.
 *    20-Sep-93  jfd   In process_lib(), after swapping bytes of lo and
 *                     hi words of "tfnum" and "tfoff", swap the words
 *                     themselves (if necessary). This will resolve the
 *                     cross-platform problem which exists when running
 *                     IXMAK on MOTOROLA platform using INTEL fonts.
 *                     In find_bucket_type(), now calling xSWAPTST macro
 *                     to swap data after it is read from the font (instead
 *                     of before) for "type", "size", "key", "off", count",
 *                     "NFACES", "tmplong", "NFATS", "NXREF", and "FACENUM".
 *                     This resolves an alignment problem.
 *    08-Dec-93  rs    General cleanup - DOS FLAT -> CGFLAT32.
 *    14-Feb-94  jfd   Replaced DBGx() calls with printf() calls when
 *                     displaying error messages.
 *    17-Feb-94  jfd   Now prompting for the type of file to create
 *                     (IF.FNT or HQ3.FNT). In the past, the user was
 *                     required to build IXMAK in DEBUG mode to generate
 *                     the negative typeface numbers, and then had to
 *                     rename the output file to HQ3.FNT.
 *                     Create output file IF.FNT or HQ3.FNT based on
 *                     user selection.
 *    02-May-94  jfd   Change MAXTF from 50 to 100.
 *                     Change MAXLIBNAME from 3000 to 6000.
 *    02-Aug-95  dbk   Changed platform names in printf's to lessen confusion
 *                     over Sun platform products.
 */

/* Modified such that directory for the input and output files are obtained from lj.ini */

#include "cgconfig.h"
#include    "port.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include    <stdio.h>
#include    <fcntl.h>
#define _POSIX_
#include	 <limits.h>

#if defined (MSDOS) || defined (__OS2__) || defined (_WIN32)
#include <errno.h> /* can probably clean up inclusion of this file better */
#endif

#ifdef UNIX
#include    <unistd.h>
#define     O_BINARY    0

#elif defined (MACINTOSH)
#include <unix.h>
#include <errno.h>
#include <console.h>
int ccommand (char ***p);

#elif !defined(__i960) && !defined(VXWORKS)  /* 10-12-92 jfd*/
#include    <io.h>
#endif  /*  UNIX  */

#ifdef UNIX
#include    <sys/types.h>
#include    <sys/stat.h>
#else
#include    <sys\types.h>
#include    <sys\stat.h>
#endif  /*  UNIX  */

#ifndef MIPS
#include <stdlib.h>
#endif

#if defined(__i960) || defined(VXWORKS)
#include <types.h>
#include <errno.h>
#ifndef VXWORKS
#include <reent.h>
#endif
#endif

#include    <string.h>

#if !defined (__i960) && !defined (MACINTOSH) && !defined(VXWORKS)
#include    <malloc.h>
#endif  /* !defined(__i960) */

#include    "debug.h"
#include    "ifmem.h"
#include    "cgif.h"
#include    "ix.h"
#if CGFIXED_PITCH
#include    "segments.h"                 /*  -ss 6/10/91      */
#endif


#include    "cgmacros.h"                 /* after port.h  -ss 8/27/91 */
                                         /* always include - jfd 10-12-92 */

/* [5] is symbol set (.ss) files
   [6] is Intellifont files and directory for if.fnt 
	[7] is TrueType font files     
*/



#if ROM
#include    <ctype.h>     /* for isupper() and tolower()    -ss 6/30/92 */

#if defined(MSDOS) && !defined(CGFLAT32)
           /*  This is the closest I can get to 64K for a malloc  */
           /*  (3-17-92) Had to lower this even more for MSC 6.0 - jfd */
           /*  (Had been 0xFFEC!!) */
#define     u64K           ( (UW16)0xFFE0 )
#endif  /*  MSDOS  */

MLOCAL SW16 num_faces;
#endif /* ROM */

/* Set TrueType flag bit in bucket_num */
MLOCAL SW16 ix_tt_flag;

#if INTLENGTH == 32
#define SCANF_D(destp)  scanf( "%hd", destp );
#else
#define SCANF_D(destp)  scanf( "%d", destp );
#endif

#if 0 /* open files in binary mode on DOS platforms */
#if defined(MSDOS) || defined(__i960) || defined (__OS2__)
#define ORFLAGS (O_RDONLY | O_BINARY)
#else
#define ORFLAGS (O_RDONLY)
#endif
#endif

  /* Changed the following for new fopen calls  12-17-92 */

 /* need to open files in binary mode on DOS platforms */
#if defined(MSDOS) || defined (__OS2__) || defined(__i960) || defined(VXWORKS)	|| defined(_WIN32)
#define ORFLAGS "rb"
#else
#define ORFLAGS "r"
#endif


/*--------------------------------*/
/*       font index entry         */
/*--------------------------------*/
/*  Bit definitions for bucket_type */
#define B_BOLD          0x0001
#define B_SANS_SERIF    0x0002
#define B_ITALIC        0x0004


#if defined(LINT_ARGS)
GLOBAL BOOLEAN FMseek_read (SL32 offset, int count, SB8 *buffer);
MLOCAL BOOLEAN error (VOID);
GLOBAL int main (int argc, char *argv[]);
MLOCAL LPSB8 basename (SB8 *);
MLOCAL VOID write_libsNoffsets (FILE  *, SW16, SW16[]);
#if (!ROM)
MLOCAL VOID write_lib_names (VOID);
#endif
MLOCAL VOID process_lib (VOID);
MLOCAL BOOLEAN process_face (SL32, SL32, UW16, UW16);
MLOCAL BOOLEAN find_bucket_type (SL32, UL32, UW16, UW16 *);
MLOCAL BOOLEAN get_line (FILE *, SB8 *);

MLOCAL VOID wLONG (SL32);
MLOCAL VOID wWORD (SW16);

MLOCAL SL32 rLONG (VOID);
MLOCAL SW16 rWORD (VOID);
MLOCAL BOOLEAN error (VOID);

#else /* no LINT_ARGS */
GLOBAL BOOLEAN FMseek_read ();
MLOCAL BOOLEAN error ();
GLOBAL int   main ();
MLOCAL LPSB8 basename ();
MLOCAL VOID write_libsNoffsets ();
#if (!ROM)
MLOCAL VOID write_lib_names ();
#endif
MLOCAL VOID process_lib ();
MLOCAL BOOLEAN process_face ();
MLOCAL BOOLEAN find_bucket_type ();
MLOCAL BOOLEAN get_line ();

MLOCAL VOID wLONG ();
MLOCAL VOID wWORD ();

MLOCAL SL32 rLONG ();
MLOCAL SW16 rWORD ();
MLOCAL BOOLEAN error ();
#endif /* LINT_ARGS */

#if defined (UNIX) && !defined(VXWORKS)   /* 11-20-92 */ /* 02-18-93 */
/* not using port.h define cuz errno is owned by the system, not Intellifont */
extern int  errno;
#endif

               /* ------------------------------------ */
               /* Typeface Header Structure Definition */
               /* ------------------------------------ */

struct typefaceHeaderType {
  unsigned short      NFACES;
  char                typeFaceName[50];
  char                familyName[20];
  char                weight[20];
  long                typeFaceSet[12];
};

struct descriptorSetType {
       unsigned char  stemStyle;
       unsigned char  stemMod;
       unsigned char  stemWeight;
       unsigned char  slantStyle;
       unsigned char  horizStyle;
       unsigned char  vertXHeight;
       unsigned char  videoStyle;
       unsigned char  copyUsage;
} ;

               /* ------------------------------------ */
               /* Font Alias Data Structure Definition */
               /* ------------------------------------ */

struct fontAliasTableType {
  char                        aliasTableName[20];
  unsigned short              NXREF;
  char                        xRefArray[100];
  unsigned long               CGtfnum;
};

struct fontAliasDataType {
  unsigned short              NFATS;
  struct fontAliasTableType   fontAliasTable[1];
};


/*
  This file contains the definition of the HP/PCL font alias segment
  as an offset into the 100 byte structure
 */

#define FATYPEABBREV    (0) /* two character typeface abbrev (char) */
#define FATREATMENT (3) /* one character treatment code (char)  */
#define FASPACING   (5) /* fixed / prop    (char)  added -ss 6/5/91 */
#define FAPCLWIDTH  (7) /* width type + 5       (int)   */
                /* reserved         (int)   */
#define FASTRUCTURE (12)    /* style structure      (int)   */
#define FAWIDTH     (15)    /* style width          (int)   */
#define FAPOSTURE   (17)    /* style posture        (int)   */
#define FAWEIGHT    (19)    /* weight + 8           (int)   */
#define FATYPEFAMILY    (22)    /* typeface family      (int)   */
#define FASERIF     (28)    /* serif style          (int)   */
#define FASIMPLESERIF   (31)    /* simple serif flag        (int)   */
#define FACOMPRESSFLG   (33)    /* compressed flag      (int)   */
#define FASHORTNAME (35)    /* short typeface name      (char)  */
#define FASHORTNAMESIZE (16)
#define FACGNUMBER  (52)    /* CG typeface number       (long)  */
#define FACLASSINDEX    (59)    /* family class index       (int)   */

#define FONTALIASNAME "HP                  "


#define MAXLINE 133
#define MAXTF   100
#define MAXLIBNAME 6000

#define NLS_FACES         4
#define NBUCK_DESCRIPTORS 3

SB8 bucket_descriptors[NLS_FACES * NBUCK_DESCRIPTORS] =
{
  /* stem style,      stem weight, slant style   */
  /* 10 = sans serif, 30 = medium, 10 = upright  */
  /* 20 = serif,      40 = bold,   20 = italic   */

        20,            30,         10,         /* Type Face 5720  */
        20,            40,         10,         /* Type Face 5721  */
        10,            30,         10,         /* Type Face 5723  */
        10,            40,         10,         /* Type Face 5724  */
};



MLOCAL SW16 trace_sw;          /* Print debug data if not 0.            */
MLOCAL SW16 update;            /* 0 = normal font index file
                                * 1 = all typeface numbers will be negated
                                * in the font index file (which will be
                                * called HQ3.FNT).
                                */

MLOCAL char  inputline[MAXLINE];  /* Next line from input file             */
MLOCAL char  infile[MAXLINE];  /* Input file name                       */
MLOCAL char  outfile[MAXLINE]; /* Input file name                       */
MLOCAL FILE *instream;         /* Input file stream                     */
/*  MLOCAL int  fout; */  /* Output file change SW16 -> int - 11/19/92 - rs   */
MLOCAL FILE *fout; /* 12-17-92 */


MLOCAL SB8  libname[64];
#if 0
MLOCAL SW16  f;               /* library file */
#endif
MLOCAL FILE *f;               /* library file */  /* 12-17-92 */


MLOCAL SW16  entry_ct;

/*
 * 9/9/93 maib, allow cross platform index file creation
 */
#if (MEM_ALIGN == 3)
MLOCAL SL32 lentry_ct;
#endif

#if !ROM
MLOCAL SB8  libnames[MAXLIBNAME];
#endif
MLOCAL UW16 name_off;   /* total length of strings written in above */

  /* Added the following structures and macros for cross-platform support
   * (01-11-93) jfd 
   */

MLOCAL BOOLEAN lohi_byte_order;  /* 01-11-93 */
MLOCAL BOOLEAN lib_byte_swap;    /* 01-11-93 */

MLOCAL  union {
              SW16 w;
              struct{
                        SB8 b0w;
                        SB8 b1w;
                    }bw;
           } tmpw;

MLOCAL  union {
              SL32 l;
              struct{
                        SB8 b0l;
                        SB8 b1l;
                        SB8 b2l;
                        SB8 b3l;
                    }bl;
           } tmpl;

MLOCAL  SB8 tmpb;

#define WSWAPTST(p)  if(lib_byte_swap) { \
                           tmpw.w = *(LPUW16)p;   \
                           tmpb = tmpw.bw.b0w;      \
                           tmpw.bw.b0w = tmpw.bw.b1w; \
                           tmpw.bw.b1w = tmpb;      \
                           *(LPUW16)p = tmpw.w;   \
                     } 


#define LSWAPTST(p)  if(lib_byte_swap) { \
                           tmpl.l = *(LPUL32)p;   \
                           tmpb = tmpl.bl.b0l;      \
                           tmpl.bl.b0l = tmpl.bl.b3l; \
                           tmpl.bl.b3l = tmpb;      \
                           tmpb = tmpl.bl.b1l;      \
                           tmpl.bl.b1l = tmpl.bl.b2l; \
                           tmpl.bl.b2l = tmpb;      \
                           *(LPUL32)p = tmpl.l;   \
                     } 



typedef struct
	{
	char s[3];
	}COMM;

#define Max_tbl 8

char d[1000];
char * p_fontext[8];

int PIreadini(void)

	{ 	
	FILE * ini_file;
	int i, j = 0;
	COMM pcl_table[Max_tbl] = {	
	"bm", "sc", "st", "pt", "ss", "if", "tt", "fl"};
	char * p_value;
	char string[500];

	if ( (ini_file = fopen("lj.ini", "ra")) == NULL )
		 {
         if ( (ini_file = fopen("/lj.ini", "ra")) == NULL )
          if ( (ini_file = fopen("/lj/lj.ini", "ra")) == NULL )
			return 0;
        }

	while ( fscanf(ini_file, "%s", string) != EOF )
		{
		char * p_equal = strchr(string, '=');
		if ( p_equal != NULL )
			{
			* p_equal = '\0';
			p_value = p_equal + 1;
			if ( strlen(string) == 2 )	 /* can be bm, sc, st, pt, fl */
				{
				for ( i = 0; i < Max_tbl; ++ i )
					{
					if ( strcmp(string, pcl_table[i].s) == 0 )
						break;
					}
				if ( (p_value = ( i < Max_tbl ) ? p_equal + 1 : NULL) != NULL )
					{
					if ( i < Max_tbl - 1 )
						{
						strcpy(&d[j], p_value);
						p_fontext[i] = &d[j];
						j += strlen(p_value) + 1;
						}
					}
				}
			}
		}
	return 0;
	}

/*------------------*/
/*  FMseek_read     */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL BOOLEAN FMseek_read (SL32 offset, int count, SB8 *buffer)
#else
GLOBAL BOOLEAN
FMseek_read (offset, count, buffer)
    SL32   offset;     /* offset within file       */
           /* change type to match its usage.          -ss 7/8/91 */
    int    count;      /* number of SB8s to read  */
    SB8  *buffer;     /* buffer to raed data into */
#endif
{
    DBG2("                FMseek_read()   offset: %ld   count: %u\n",
                                                          offset, count);

/*    if(lseek(f, offset, SEEK_SET) != offset) */
    if(fseek(f, offset, SEEK_SET))
    {
        printf("                    lseek() failed\n"); /* 2-14-94 jfd */
        return FALSE;
    }

#if defined(MSDOS) && !defined(CGFLAT32)
/*    if(read(f, buffer, (unsigned)count) != (unsigned)count) */
    if(fread(buffer, sizeof(char), (size_t)count, f) != (unsigned)count)
    {
        printf("                    read() failed\n"); /* 2-14-94 jfd */
        return FALSE;
    }
#else
/*    if(read(f, buffer, (int)count) != (int)count) */
    if(fread(buffer, sizeof(char), (size_t)count, f) != (int)count)
    {
        printf("                    read() failed\n"); /* 2-14-94 jfd */
        return FALSE;
    }
#endif /* defined(MSDOS) && !defined(CGFLAT32) */

    return TRUE;                /* added -ss 6/25/91  */
}




/*-------------*/
/*  error      */
/*-------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN error ()
#else
MLOCAL BOOLEAN
error()
#endif
{
    printf("%s is not a valid library file\n", libname);
    return FALSE;
}




#if defined (ANSI_DEFS)
MLOCAL SW16 rWORD ()
#else
MLOCAL SW16
rWORD()
#endif
{
    SW16 i;
    int num_read;

/*    if(read(f,(SB8*)&i,2) != 2) */
    num_read = fread((void *)&i,sizeof(char),2,f);
    if (num_read != 2)
    {
        printf("rWORD error\n"); /* 2-14-94 jfd */
        error();
    }
    return i;
}


#if defined (ANSI_DEFS)
MLOCAL SL32 rLONG ()
#else
MLOCAL SL32
rLONG()
#endif
{
    SL32 i;

/*    if(read(f,(SB8*)&i,4) != 4) */
    if(fread((SB8*)&i,sizeof(char),4,f) != 4)
    {
        printf("rLONG error\n");
        error();
    }
    return i;
}

#if 0 /* not used 18-Aug-92 - rs */
MLOCAL VOID
wBYTE(x)
    SB8 x;
{
/*    write(fout, (SB8*)&x, 1); */
    fwrite((SB8*)&x, sizeof(char), 1, fout);
}
#endif /* 0 */

#if defined (ANSI_DEFS)
MLOCAL VOID wWORD (SW16 x)
#else
MLOCAL VOID
wWORD(x)
    SW16 x;
#endif
{
/*    write(fout, (SB8*)&x, 2); */
    fwrite((SB8*)&x, sizeof(char), 2, fout);
}

#if defined (ANSI_DEFS)
MLOCAL VOID wLONG (SL32 x)
#else
MLOCAL VOID
wLONG(x)
    SL32 x;
#endif
{
/*    write(fout, (SB8*)&x, 4); */
    fwrite((SB8*)&x, sizeof(char), 4, fout);
}



/*-------------------------*/
/*  get_line               */
/*-------------------------*/
/*  Load the next non-blank line from text stream "s" into line
 *  buffer "line". Return TRUE if successful, FALSE if end of
 *  file is reached.
 */

#if defined (ANSI_DEFS)
MLOCAL BOOLEAN get_line(FILE *s, SB8 *line)
#else
MLOCAL BOOLEAN
get_line(s, line)
    FILE *s;
    SB8 *line;
#endif
{
    SB8 *cp;

    while(TRUE)
    {
        if(fgets( line, MAXLINE, s) == NULL)
            return FALSE;
        cp = line;
        while( ((*cp == ' ') || (*cp == '\t')) && *cp != '\n' ) cp++;
        if(*cp != '\n') return TRUE;
    }
}


/*--------------------*/
/*  find_bucket_type  */
/*--------------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN find_bucket_type(SL32 tfnum, UL32 globoff, UW16 globcount, UW16 *p_bucket_type)
#else
MLOCAL BOOLEAN
find_bucket_type(tfnum, globoff, globcount, p_bucket_type)
    SL32   tfnum;
    UL32  globoff;
    UW16  globcount;
    UW16 *p_bucket_type;
#endif
{
    SB8 *fgseg;
    SB8 *typeface_seg;
    SB8 *fontalias_seg;

    SB8 *p, *pp;

    UW16 type;
    UL32 size;

    UW16 key;
    UL32 off;
    UW16 count;

    SB8  *segptr;


  /*  Fontalias segment */

static SB8
       faisweights[15] = {0x01, 0x01, 0x01, 0x01, 0x02, 0x02, 0x03, 0x03,
                          0x03, 0x04, 0x04, 0x05, 0x05, 0x05, 0x05};

    UW16    NFATS;
    UW16    NXREF;
    UL32    FACENUM;
    UW16    i,j;
    BOOLEAN  found_table_name;
    SB8    *fa_table;
#if CGFIXED_PITCH
    SB8      fp = 0;
    PFACE_ATT attribute;
#endif
    UL32     tmplong;

  /* Typeface header segment */

    UW16  NFACES;

  /* bucket matching */

    SW16  stem_wt,
          stem_style,
          slant_style;
    SW16  tf_stem_wt,
          tf_stem_style,
          tf_slant_style;
    UW16 current, closest;


    DBG2("\n        find_bucket_type()  offset: %ld   count: %d\n",
                           globoff, globcount);

  /* get face global buffer */

    if(!(fgseg = malloc((size_t)globcount)))
    {
        printf("            malloc failed\n"); /* 2-14-94 jfd */
        return error();
    }


  /* read face global data into buffer */
       if(!FMseek_read(globoff, (int)globcount, fgseg))
       {
           printf("            face global file error\n"); /* 2-14-94 jfd */
           free(fgseg);
           return error();
       }

  /*  Read segment directory and set segment pointers. First
   *  set segment ptrs to nul- not all segments may be present
   */

    typeface_seg   = (SB8*)0;
    fontalias_seg  = (SB8*)0;

    p = fgseg;

    type = *((UW16*)p);

    WSWAPTST(&type)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

    p += 2;

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
    MAKELONG( size, p );
#else
    size   =   *((UL32*)p);
#endif
    LSWAPTST(&size)  /* swap long for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */
    p += 4;
    DBG2("            type = %d    size = %ld\n",type, size);

    DBG("\n            directory\n");
    do
    {
        key =   *((UW16*)p);     p += 2;

        WSWAPTST(&key)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
        MAKELONG( off, p );
#else
        off    =   *((UL32*)p);
#endif

        LSWAPTST(&off)  /* swap long for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

        p += 4;

        count = *((UW16*)p);     p += 2;

        WSWAPTST(&count)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

        DBG3("            key / offset / count  %d   %ld   %d\n",
                                              key,off,count);

        segptr = (SB8*)(fgseg + off);
        switch (key)
        {
#if CGFIXED_PITCH
            case 105:  attribute =
                          (PFACE_ATT)( segptr + sizeof(SW16) + sizeof(SL32) );
                       break;
#endif
            case 107:  typeface_seg = segptr + sizeof(SW16) + sizeof(SL32);
                       break;
            case 110:  fontalias_seg = segptr + sizeof(SW16) + sizeof(SL32);
                       break;
            default:   break;
        }
    }
    while (key != (UW16)-1);                 /*  added cast -ss 6/24/91  */

  /*  Set default in case both font alias segment
   *  and typeface header segments are missing.
   */

    tf_stem_style = 10;      /* sans serif    */
    tf_stem_wt =30;          /* normal weight */
    tf_slant_style = 10;     /* upright       */

    if(!fontalias_seg && !typeface_seg)
    {
        DBG("missing both typeface header and font alias segment\n");
    }

    if(typeface_seg)
    {
        DBG("\n\n    T y p e f a c e    H e a d e r    S e g m e n t\n\n");
        p = typeface_seg;

        NFACES = *(UW16*)p;     p += 2;

        WSWAPTST(&NFACES)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

        DBG1("NFACES = %d\n", NFACES);

        DBG1("    Primary name: --%50.50s--\n", p);
        p += 50;

        DBG1("    Family name: --%20.20s--\n", p);
        p += 20;

        DBG1("    Weight description: --%20.20s--\n", p);
        p += 20;

        pp = p + (4*NFACES);   /*  point to face description array */

        DBG("    Typefaces:\n");
        for(i=0; i<NFACES; i++)
        {
            DBG1("        %lu\n", *(UL32*)p);

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
            MAKELONGB( tmplong, p );
#else
            tmplong = *(LPUL32)p;
#endif
            LSWAPTST(&tmplong)  /* swap long for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

            if( tmplong == tfnum )
               break;

            p += 4;
        }
        /*  i is now set to index of typeface  */

        if(i==NFACES)
        {
            printf("tfnum %ld not found in typeface header segment\n", tfnum); /* 2-14-94 jfd */
            return FALSE;
        }

        p = pp + (8*i);     /*  index into descriptor array */
        
        DBG("    Face Description:\n");        
        DBG1("        stem style:   %u\n", *p);
        DBG1("        stem mode:    %u\n", *(p+1));
        DBG1("        stem weight:  %u\n", *(p+2));
        DBG1("        slant style:  %u\n", *(p+3));
        DBG1("        horiz. style: %u\n", *(p+4));
        DBG1("        vert. style:  %u\n", *(p+5));
        DBG1("        video style:  %u\n", *(p+6));
        DBG1("        copy usage:   %u\n", *(p+7));

        tf_stem_style   = *p;
        tf_stem_wt      = *(p+2);
        tf_slant_style  = *(p+3);
    }

    if(fontalias_seg)
    {
        DBG("\n\n    F o n t a l i a s    S e g m e n t\n\n");

        p = fontalias_seg;
        fa_table = (SB8*)0;

        NFATS = *(UW16*)p;    p += 2;

        WSWAPTST(&NFATS)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

        DBG1("    NFATS = %d\n", NFATS);
        for(i=0; i<NFATS; i++)
        {
            DBG1("    Alias table name: --%20.20s--\n", p);

            found_table_name = (strncmp(FONTALIASNAME, p, 20) == 0);
            p += 20;

            NXREF = *(UW16*)p;  p += 2;

            WSWAPTST(&NXREF)  /* swap word for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

            DBG1("        NXREF = %d\n", NXREF);
            for(j=0; j<NXREF; j++)
            {

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
                MAKELONG( FACENUM, p+100 );
#else
                FACENUM = *(UL32*)(p+100);
#endif

                LSWAPTST(&FACENUM)  /* swap long for cross-platform if necessary */
                     /* Moved from before previous line  9-20-93 jfd */

                DBG1("            %lu\n", FACENUM);
                DBG1("            %25.25s\n", p);
                DBG1("            %25.25s\n", p+25);
                DBG1("            %25.25s\n", p+50);
                DBG1("            %25.25s\n", p+75);

                if(found_table_name && (FACENUM == tfnum))
                {
                    fa_table = p;
                    break;
                }
                p += 104;
            }
            if(fa_table) break;
        }
        if(i == NFATS)
        {
            printf("font alias table not found\n"); /* 2-14-94 jfd */
            return FALSE;
        }

        DBG("Replacing classification data from font alias table:\n\n");

      /* Stem style */
        DBG("    stem style:\n");
        DBG1("        fa_table[FASIMPLESERIF] = %d\n", 
                                        atoi (&fa_table[FASIMPLESERIF]));
        DBG1("        old stem style = %d\n", tf_stem_style);
        tf_stem_style = (SB8)(10 * (atoi(&fa_table[FASIMPLESERIF]) + 1));
        DBG1("        new stem style = %d\n", tf_stem_style);

      /* stem weight */

        DBG("    stem weight:\n");
        DBG1("    fa_table[FAWEIGHT]) - 1 = %d\n",
                                             atoi(&fa_table[FAWEIGHT]) - 1);
        DBG1("        old stem weight = %d\n", tf_stem_wt);
        tf_stem_wt = (SB8)(10 * faisweights[atoi(&fa_table[FAWEIGHT]) - 1]);
        DBG1("        new stem weight = %d\n", tf_stem_wt);

      /* slant style */

        DBG("    slant style:\n");
        DBG1("        fa_table[FAPOSTURE] = %d\n",
                                         atoi(&fa_table[FAPOSTURE]));
        DBG1("        old slant style = %d\n", tf_slant_style);
        tf_slant_style = (SB8)(10 * ((atoi(&fa_table[FAPOSTURE])&1) + 1));
        DBG1("        new slant style = %d\n", tf_slant_style);
#if CGFIXED_PITCH
        if( fa_table[FASPACING] == 'F' )    /* check for fixed pitch flag */
           fp = 1;
#endif
    }   /*  end - if( fontalias_seg )  */

  /*  Compute limited sensitive bucket */

    closest = 0xffff;
    p = bucket_descriptors;
    for( i = 0; i < NLS_FACES; i++ )
    {
        stem_wt     = (tf_stem_wt     - p[1])/10;
        slant_style = (tf_slant_style - p[2])/10;
        stem_style  = (tf_stem_style  - p[0])/10;

        current = (((UW16)stem_wt & 0x8000)    >> 7) +
                  ((UW16)((ABS(stem_wt))    << 9)) +
                  (((UW16)slant_style & 0x8000)  >> 11) +
                  ((UW16)((ABS(slant_style)) << 5)) +
                  (((UW16)stem_style & 0x8000) >> 15) +
                  (UW16)((ABS(stem_style)) << 1);
               
        if (closest > current)
        {
            closest = current;
            *p_bucket_type = i;
        }
        p += NBUCK_DESCRIPTORS;
    }

    if (tf_slant_style > (SB8)10)
        *p_bucket_type |= B_ITALIC;  /* if italic, set bit 2 */
                                     /* 12-Mar-90 jfd        */

#if CGFIXED_PITCH             /* turn on flags for the fixed pitch case */
    if( attribute && attribute->isFixedPitch )
    {

        WSWAPTST((LPSB8)(&(attribute->spaceBand)))
                           /* swap word for cross-platform if necessary */

        switch( attribute->spaceBand )
        {
           /*  The width of a typeface must exactly match one we have */
           /* or we cannot provide the plugins.                       */
           case COURIER_WIDTH:
                    *p_bucket_type |= B_COURIER;
                    break;
           case LETTER_GOTHIC_WIDTH:
                    *p_bucket_type |= B_LETTER_GOTHIC;
                    break;
           default:                         /* fixed pitch, no plugins */
                    *p_bucket_type |= B_FIXED_PITCH;
                    break;
        }
    }
    else if( fp )
            *p_bucket_type |= B_FIXED_PITCH;
#endif  /*  CGFIXED_PITCH  */

    free(fgseg);
    return TRUE;
}

/*----------------*/
/*  process_face  */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN process_face (SL32 tfnum, SL32 fhoff, UW16 fhcount, UW16 type)
#else
MLOCAL BOOLEAN
process_face(tfnum, fhoff, fhcount, type)
    SL32 tfnum, fhoff;
    UW16 fhcount;
    UW16 type;            /* 'D', 'S', 'U', etc.  */
#endif
{
    SB8  *char_dir;   /* face header segment */
    SL32 globoff;
    UW16 globcount;
#if !ROM
    UW16  name_len;
#endif
    UW16  bucket_type;

    int num_writ;

    INDEX_ENTRY tmp_ix; /* 01-24-91 jfd */

    DBG1("\nType Face %ld\n",tfnum);

    DBG("Face header segment\n");

    if(!(char_dir = malloc((size_t)fhcount)))
    {
        printf("            malloc failed\n"); /* 2-14-94 jfd */
        return FALSE;
    }


  /* read face header link to face global segment */
            /* deleted cast of 6 since its used as the argument to read */
            /* We really want the args of system calls to match the     */
            /* type expected by the system.                  -ss 7/8/92 */
       if(!FMseek_read(fhoff, 6, char_dir))
       {
           printf("FMseek_read error\n"); /* 2-14-94 jfd */
           free(char_dir);
           error();
           return FALSE;
       }

  /* Type face global segment */

    LSWAPTST(char_dir)  /* swap long for cross-platform if necessary */

    globoff =   *(SL32*)char_dir;

    WSWAPTST((LPSB8)(char_dir + 4))  /* swap word for cross-platform if necessary */

    globcount = *(UW16*)(char_dir + 4);
    free(char_dir);
    DBG2("    global off / count   %ld  %d\n",globoff, globcount);

    DBG1("                                              total = %d\n",
                                 fhcount+globcount);
  /* Find type of limited sensitive bucket */

    if(!find_bucket_type(tfnum, globoff, globcount, &bucket_type))
        return FALSE;

    bucket_type |= ix_tt_flag;     /* mby 7-14-93 */

    if(update) tfnum = - tfnum;    /* negate typeface number for update */
    DBG5("%ld %s %ld %u %u\n", tfnum, libname, fhoff, fhcount, bucket_type);

  /* Store entry in our new temporary structure */

    tmp_ix.tfnum          = tfnum;
    tmp_ix.fhoff          = fhoff;
    tmp_ix.fhcount        = fhcount;
    tmp_ix.bucket_num     = bucket_type; /* bucket number: 0 - 3 */

    switch(type)
    {
        case 'D':  tmp_ix.bucket_num |= D_LIB;    break;
        case 'S':  tmp_ix.bucket_num |= S_LIB;    break;
        case 'U':  tmp_ix.bucket_num |= U_LIB;    break;
    }

#if ROM
    tmp_ix.bucket_num |= ROM_TYPE;
    tmp_ix.p_r.lib_offset = 0L;
#else
    tmp_ix.name_off       = name_off;
#endif

#if !ROM
    LSWAPTST((LPSB8)(&(tmp_ix.tfnum)))      /* swap long for cross-platform if necessary */
    WSWAPTST((LPSB8)(&(tmp_ix.name_off)))   /*  "   word  "       "         "     "      */
    LSWAPTST((LPSB8)(&(tmp_ix.fhoff)))      /*  "   long  "       "         "     "      */
    WSWAPTST((LPSB8)(&(tmp_ix.fhcount)))    /*  "   word  "       "         "     "      */
    WSWAPTST((LPSB8)(&(tmp_ix.bucket_num))) /*  "   word  "       "         "     "      */
#endif
  /* Write entry in output file */

#if !ROM
    wLONG(tmp_ix.tfnum);
    wWORD(tmp_ix.name_off);
/*
 * 9/9/93 maib, allow cross platform index file creation
 */
#if (MEM_ALIGN == 3)
    wWORD((SW16)0);
#endif
    wLONG(tmp_ix.fhoff);
    wWORD(tmp_ix.fhcount);
    wWORD(tmp_ix.bucket_num);
#else
    num_writ = fwrite((SB8 *)&tmp_ix, sizeof(char), sizeof(INDEX_ENTRY), fout);
    if (num_writ !=  sizeof(INDEX_ENTRY))  
    {
        printf("process_face error\n"); /* 2-14-94 jfd */
        printf("Error writing library index entry\n");
        return FALSE;
    }
#endif  /* !ROM */

    entry_ct++;

#if !ROM
    name_len = strlen(libname) + 1;      /* account for \0 */
    DBG1("    strlen = %d\n", name_len);
    if(name_off + name_len > MAXLIBNAME)
    {
        printf("Library names exceed limit\n");
        return FALSE;
    }

    strcpy(&libnames[name_off], libname);
    name_off += name_len;

#endif  /*  ROM  */

    return TRUE;
}




/*----------------*/
/*  process_lib   */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID process_lib ()
#else
MLOCAL VOID
process_lib()
#endif
{
    UW16 type;

    SW16  i;
#if !ROM
    SW16  num_faces;
#endif

    UW16 key,count;      /* File segment directroy */
    SL32 off;

    SL32 fdoff;           /* File directory */
    int fdcount;          /* changed type to match usage   -ss 7/8/91  */

    struct tfseg {
      SL32  tfnum;
      SL32  tfoff;
      UW16 tfcount;
    } tfbuf[MAXTF];

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
    struct tfseg_words {
      UW16  tfnum_hi;
      UW16  tfnum_lo;
      UW16  tfoff_hi;
      UW16  tfoff_lo;
      UW16  tfcount;
    } tfbuf_words[MAXTF];
#endif

#if (NAT_ALIGN == 4 && BYTEORDER == LOHI)  /* changed from #ifdef SPARC -jfd 10-12-92 */
    UW16 num_left;
#endif
    
    UW16 tmp_word;
    
    for (i=0; i<MAXTF; i++)    /* 01-07-91 jfd */
    {
#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
       tfbuf_words[i].tfnum_hi = tfbuf_words[i].tfnum_lo = -1;
#else
       tfbuf[i].tfnum = (SL32)-1;  /* added cast -ss 7/3/91  */
#endif
    }

    DBG("process_lib\n");

    type = rWORD();

    /* Determine byte order of library and set swap flag if target byte
     * order dos not match host byte order (01-11-93 jfd).
     */

#if (BYTEORDER == LOHI)
    if (type == (UW16)0x0053 || type == (UW16)0x0055 || type == (UW16)0x0044)
       lohi_byte_order = TRUE;
    else
       lohi_byte_order = FALSE;
#else
    if (type == (UW16)0x0053 || type == (UW16)0x0055 || type == (UW16)0x0044)
       lohi_byte_order = FALSE;
    else
       lohi_byte_order = TRUE;
#endif

#if (BYTEORDER == LOHI)
    if (lohi_byte_order)
       lib_byte_swap = FALSE;
    else
       lib_byte_swap = TRUE;
#else
    if (lohi_byte_order)
       lib_byte_swap = TRUE;
    else
       lib_byte_swap = FALSE;
#endif

    WSWAPTST(&type)   /* swap word for cross-platform if necessary */

    DBG1("File type = %d\n",type);
    if(type != 'D' && type != 'U'&& type != 'S')
    {
        error();
        return;
    }

  /* File segment directory */

    DBG("\nFile segment directory\n");
    do
    {
        key = rWORD();

        WSWAPTST(&key)   /* swap word for cross-platform if necessary */

        off = rLONG();

        LSWAPTST(&off)   /* swap long for cross-platform if necessary */

        count = rWORD();

        WSWAPTST(&count) /* swap word for cross-platform if necessary */

        DBG3("    key / offset / count  %d   %ld   %d\n",key,off,count);
        if(key == 2)
        {
            fdoff = off;       /* save file directory segment */
            fdcount = (int)count;            /*  added cast   -ss 7/8/91  */
        }
    }
    while (key != (UW16)-1);                 /*  added cast -ss 6/24/91  */

  /* File Directory Segment */

    DBG("\nFile directory segment\n");
    if(fdcount > 10 * MAXTF)
    {
        printf("Error: too many typefaces in library\n"); /* 2-14-94 jfd */
        return;
    }
/*    if( lseek(f, fdoff, SEEK_SET) != fdoff) */
    if(fseek(f, fdoff, SEEK_SET))
    {
        printf("seek error\n"); /* 2-14-94 jfd */
        error();
        return;
    }
#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
/*    if( read(f, (char *) tfbuf_words, fdcount) != fdcount ) */
    if( fread((char *) tfbuf_words, sizeof(char), (size_t)fdcount, f) != fdcount )
    {
        printf("read error\n"); /* 2-14-94 jfd */
        error();
        return;
    }

    for (i=0; i<(fdcount / sizeof(tfbuf_words[0])); i++)
    {
      WSWAPTST((LPSB8)(&(tfbuf_words[i].tfnum_hi)))  /* swap word for cross-platform if necessary */
      WSWAPTST((LPSB8)(&(tfbuf_words[i].tfnum_lo)))  /*  "     "   "       "          "     "     */

      /* Swap each word now if necessary   9-20-93 jfd */

      if(lib_byte_swap)
      {
         tmp_word = tfbuf_words[i].tfnum_hi;
         tfbuf_words[i].tfnum_hi = tfbuf_words[i].tfnum_lo;
         tfbuf_words[i].tfnum_lo = tmp_word;
      }

      WSWAPTST((LPSB8)(&(tfbuf_words[i].tfoff_hi)))  /*  "     "   "       "          "     "     */
      WSWAPTST((LPSB8)(&(tfbuf_words[i].tfoff_lo)))  /*  "     "   "       "          "     "     */

      /* Swap each word now if necessary   9-20-93 jfd */

      if(lib_byte_swap)
      {
         tmp_word = tfbuf_words[i].tfoff_hi;
         tfbuf_words[i].tfoff_hi = tfbuf_words[i].tfoff_lo;
         tfbuf_words[i].tfoff_lo = tmp_word;
      }

      WSWAPTST((LPSB8)(&(tfbuf_words[i].tfcount)))   /*  "     "   "       "          "     "     */
    }
#elif (NAT_ALIGN == 4 && BYTEORDER == LOHI)  /* needed for INTEL960?? */
    num_left = fdcount;
    i = 0;
    while (num_left)
    {
       tfbuf[i].tfnum   = rLONG();

       LSWAPTST((LPSB8)(&(tfbuf[i].tfnum)))   /* swap long for cross-platform if necessary */

       tfbuf[i].tfoff   = rLONG();

       LSWAPTST((LPSB8)(&(tfbuf[i].tfoff)))   /* swap long for cross-platform if necessary */

       tfbuf[i].tfcount = rWORD();

       WSWAPTST((LPSB8)(&(tfbuf[i].tfcount))) /* swap word for cross-platform if necessary */

       i++;
       num_left -= (sizeof(SL32) + sizeof(SL32) + sizeof(UW16));
    }
#else
/*    if( read(f, (char *) tfbuf, fdcount) != fdcount ) */
    if( fread((char *) tfbuf, sizeof(char), (size_t)fdcount, f) != fdcount )
    {
        printf("read error\n"); /* 2-14-94 jfd */
        error();
        return;
    }
    for (i=0; i<(fdcount / sizeof(tfbuf[0])); i++)
    {
      LSWAPTST((LPSB8)(&(tfbuf[i].tfnum)))    /* swap long for cross-platform if necessary */
      LSWAPTST((LPSB8)(&(tfbuf[i].tfoff)))    /*  "    "    "       "         "      "     */
      WSWAPTST((LPSB8)(&(tfbuf[i].tfcount)))  /*  "   word  "       "         "      "     */
    }
#endif


    for(i=0; i<MAXTF; i++)
    {
#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from #ifdef SPARC -jfd 10-12-92 */
        tfbuf[i].tfoff = ( (UL32)tfbuf_words[i].tfoff_hi << (2*BITSPERBYTE) )
                                + tfbuf_words[i].tfoff_lo;
        tfbuf[i].tfnum = ( (UL32)tfbuf_words[i].tfnum_hi << (2*BITSPERBYTE) )
                                + tfbuf_words[i].tfnum_lo;
        tfbuf[i].tfcount = tfbuf_words[i].tfcount;
#endif
        DBG3("    face / offset / count %ld   %ld  %d\n",
                       tfbuf[i].tfnum, tfbuf[i].tfoff, tfbuf[i].tfcount);
        if(tfbuf[i].tfnum == (SL32)-1)  /* added cast -ss 7/3/91  */
              break;
    }
    num_faces = i;
    DBG1("%d faces in library\n", num_faces);


    for(i=0; i<num_faces; i++)
        if(!process_face(tfbuf[i].tfnum,tfbuf[i].tfoff,tfbuf[i].tfcount,type))
            return;

}



#if !ROM

/*------------------*/
/*  write_lib_names */
/*------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID write_lib_names ()
#else
MLOCAL VOID
write_lib_names()
#endif
{
    DBG("write_lib_names\n");

  /* Write out all library name strings */

#if defined(MSDOS) && !defined(CGFLAT32)
/*    write(fout, (SB8*)&libnames[0], name_off); */
    fwrite((SB8*)&libnames[0], sizeof(char), (size_t)name_off, fout);
#else
/*    write(fout, (SB8*)&libnames[0], (int)name_off); */
    fwrite((SB8*)&libnames[0], sizeof(char), (size_t)name_off, fout);
#endif

  /* Write entry count at start of file */

/*    if( lseek(fout, 0L, SEEK_SET) != 0L) */
    if(fseek(fout, 0L, SEEK_SET))
    {
        printf("seek error\n");
        return;
    }

/*
 * 9/9/93 maib, allow cross platform index file creation
 */
#if (MEM_ALIGN == 3)
                      /* 01-11-93 */
    lentry_ct = (SL32)entry_ct;;

    LSWAPTST(&lentry_ct)  /* swap long for cross-platform if necessary */

    wLONG(lentry_ct);
#else

    WSWAPTST(&entry_ct)  /* swap word for cross-platform if necessary */

    wWORD(entry_ct);
#endif

}


#else

/*----------------------*/
/*  write_libsNoffsets  */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID write_libsNoffsets (FILE *liblist, SW16 nlibs, SW16 ntf_in_lib[MAXTF])
#else
MLOCAL VOID
write_libsNoffsets( liblist, nlibs, ntf_in_lib )
  FILE  *liblist;
  SW16   nlibs;
  SW16   ntf_in_lib[MAXTF];
#endif
{
/*  UL32*/ long  loc;   /* change from UL32 to long - 12/18/92 - rs */
  LPSB8  lib_buf;
  UB8  min_buf[ sizeof( SL32 ) ];
  char   lib_name[128],
         line[132]; /* change from UB8 to char - 12/18/92 - rs */

/*  int    lib; */ /* use "int" vs. SW16 to be sure of correct size in system call */
  FILE *lib; /* 12-17-92 */
  unsigned int count; /* made unsigned to get all bits available -ss 11/15/91 */
  UW16  i,
         j;
  SL32   lib_offset[ MAXTF ];
  struct stat st_buf;

  INDEX_ENTRY tmp_ix;  /* 01-24-91 jfd */
  SW16 num_bytes;      /* 01-24-91 jfd */

  memset( min_buf, 0, sizeof( SL32 ) );

    DBG("write_libsNoffsets\n");

    /*  rewind file of library names   */
    if(fseek( liblist, 0L, SEEK_SET))
    {
       printf("seek error\n");
       return;
    }

#if defined(MSDOS) && !defined(CGFLAT32)
    /*  DOS can only handle 64K at at time  */
    if( (lib_buf = (LPSB8)malloc( (size_t)u64K )) == (LPSB8)NULL )
    {
       printf( "Error allocating memory.\n" );
       return;
    }
#endif

    for( i = 0; i < nlibs; i++ )
    {
       /*  get lib name                  */
       if( !get_line( liblist, line ))
          break;       /*  no more */
       DBG1( "%s\n", line );
       sscanf( line,"%s", lib_name );
       DBG1( "%s\n",lib_name );
		if ( p_fontext[5] == NULL )
			path[0] = '\0';
		else
			strcpy(path, p_fontext[5]);	 /* IF directory  */
	   strcat(path, lib_name);
       if( stat( lib_name, &st_buf ) )
       {
          printf( "Warning: Error getting status for %s \n", lib_name );
          continue;
       }

       /*  Long align each library                 */
       loc   = ftell( fout );  /* change from tell to ftell - 12/18/92 - rs */
       j = (SW16)(loc % sizeof(SL32));
       if(j)
       {
#if defined(MSDOS) && !defined(CGFLAT32)
/*          if( write( fout, min_buf, j ) != j ) */
          if( fwrite( min_buf, sizeof(char), (size_t)j, fout ) != j )
#else
/*          if( write( fout, min_buf, (int)j ) != (int)j ) */
          if( fwrite( min_buf, sizeof(char), (size_t)j, fout ) != (int)j )
#endif
          { 
             printf( "Error writing %d alignment bytes to BLOCK_IF.FNT\n", j);
             fclose( lib ); /* 12-17-92 */
             free( lib_buf );
             return;
          }
       }
                  /* change from tell to ftell - 12/18/92 - rs */
       lib_offset[ i ] = ftell( fout ); /* save where this lib begins */

       /**  Read in individual libraries and write into font block  **/
#if defined(MSDOS) && !defined(CGFLAT32)
       /*  already allocated buffer  */
/*       if( (lib = open( lib_name, ORFLAGS)) == NULL ) */
       if(!(lib = fopen( lib_name, ORFLAGS)))  /* 12-17-92 */
       {
          printf( "Error openning %s \n", lib_name );
          free( lib_buf );
          return;
       }

       /*  DOS will only read/write 64K at a time  */
/*       while( (count = read( lib, lib_buf, (size_t)u64K )) > 0 ) */
       while( (count = fread( lib_buf, sizeof(char), (size_t)u64K, lib )) > 0 )
       {
/*          if( write( fout, lib_buf, count ) != count ) */
          if( fwrite( lib_buf, sizeof(char), (size_t)count, fout ) != count )
          { 
             printf( "Error writing %s to BLOCK_IF.FNT for %d bytes.\n",
                          lib_name, count );
             fclose( lib ); /* 12-17-92 */
             free( lib_buf );
             return;
          }
       }  /* end - while  */

       if( count < 0 )
       {
          /*  handle Error  */
          free( lib_buf );
          return;
       }

#else
       if( (lib_buf = (LPSB8)malloc( (size_t)st_buf.st_size )) == (LPSB8)NULL )
       {
          printf( "Error allocating memory.\n" );
          return;
       }
/*       if( (lib = open( lib_name, ORFLAGS ))  == NULL ) */
       if(!(lib = fopen( lib_name, ORFLAGS))) /* 12-17-92 */
       {
          printf( "Error openning %s \n", lib_name );
          free( lib_buf );
          return;
       }

/*       if( (count = read( lib, lib_buf, (int)st_buf.st_size )) */
       if( (count = fread( lib_buf, sizeof(char), (size_t)st_buf.st_size, lib ))
                                != st_buf.st_size )
       { 
          printf( "Error reading %s, \n\tst_size=%lu, count %lu, errno %d\n",
                      lib_name, (off_t)st_buf.st_size, count, errno );
          fclose( lib ); /* 12-17-92 */
          free( lib_buf );
          return;
       }

/*       if( (count = write( fout, lib_buf, (int)st_buf.st_size )) */
       if( (count = fwrite( lib_buf, sizeof(char), (size_t)st_buf.st_size, fout ))
                                != st_buf.st_size )
       { 
          printf( "Error writing %s, \n\tst_size=%lu, count %lu, errno %d\n",
                       lib_name, (off_t)st_buf.st_size, count, errno );
          fclose( lib ); /* 12-17-92 */
          free( lib_buf );
          return;
       }

       free( lib_buf );
#endif  /*  MSDOS  */

      /*  shut down this file                     */
      fclose( lib ); /* 12-17-92 */
   }  /*  end - for  */


    /* Write entry count at start of file   */
/*    if( lseek(fout, 0L, SEEK_SET) != 0L) */
    if(fseek(fout, 0L, SEEK_SET))
    {
        printf("seek error\n");
        return;
    }
/*
 * 9/9/93 maib, allow cross platform index file creation
 */
#if (MEM_ALIGN == 3)
                      /* 01-11-93 */
    lentry_ct = (SL32)entry_ct;

    LSWAPTST(&lentry_ct)  /* swap long for cross-platform if necessary */

    wLONG( lentry_ct );   /* write # entries to beginning of file      */
#else

    WSWAPTST(&entry_ct)  /* swap word for cross-platform if necessary */

    wWORD( entry_ct );   /* write # entries to beginning of file      */
#endif

    for( i = 0; i < nlibs; i++ )
    {
      /*  need to write the "beg of lib" location for each TF in the lib  */
      for( j = 0; j < ntf_in_lib[ i ]; j++ )
      {
      /*
         NOTE: cannot read & write without intervening fseek - 12/18/92 - rs
      */
           if (fseek (fout, 0L, SEEK_CUR))
            {
               printf ("Error seeking SEEK_CUR on fout\n");
               return ;
            }
#if defined(MSDOS) && !defined(CGFLAT32)
/*         num_bytes = read(fout, (SB8 *)&tmp_ix, sizeof(INDEX_ENTRY)); */
         num_bytes = fread((SB8 *)&tmp_ix, sizeof(char), sizeof(INDEX_ENTRY), fout);
         if (num_bytes != sizeof(INDEX_ENTRY))
         {
             printf("read error\n");
             return;
         }
#else
/*         num_bytes = read(fout, (SB8 *)&tmp_ix, (int)sizeof(INDEX_ENTRY)); */
         num_bytes = fread((SB8 *)&tmp_ix, sizeof(char), (size_t)sizeof(INDEX_ENTRY), fout);
         if (num_bytes != (int)sizeof(INDEX_ENTRY))
         {
             printf("read error\n");
             return;
         }
#endif /* defined(MSDOS) && !defined(CGFLAT32) */
 
         tmp_ix.p_r.lib_offset = lib_offset[i];

         /* (3-17-92)
          * Had to change parameter 2 from "(SL32)-(sizeof(INDEX_ENTRY))"
          * to "-(SL32)(sizeof(INDEX_ENTRY)) for MSC 6.0 - jfd
          */

/*         lseek(fout, -(SL32)(sizeof(INDEX_ENTRY)), SEEK_CUR); */
         fseek(fout, -(SL32)(sizeof(INDEX_ENTRY)), SEEK_CUR);

         LSWAPTST((LPSB8)(&(tmp_ix.tfnum)))          /* swap long for cross-platform if necessary */
         LSWAPTST((LPSB8)(&(tmp_ix.fhoff)))          /*  "     "   "       "         "     "      */
         LSWAPTST((LPSB8)(&(tmp_ix.p_r.lib_offset))) /*  "     "   "       "         "     "      */
         WSWAPTST((LPSB8)(&(tmp_ix.fhcount)))        /*  "   word  "       "         "     "      */
         WSWAPTST((LPSB8)(&(tmp_ix.bucket_num)))     /*  "     "   "       "         "     "      */

#if defined(MSDOS) && !defined(CGFLAT32)
/*         num_bytes = write(fout, (SB8 *)&tmp_ix, sizeof(INDEX_ENTRY)); */
         num_bytes = fwrite((SB8 *)&tmp_ix, sizeof(char), sizeof(INDEX_ENTRY), fout);
         if (num_bytes != sizeof(INDEX_ENTRY))
         {
             printf("write error\n");
             return;
         }
#else
/*         num_bytes = write(fout, (SB8 *)&tmp_ix, (int)sizeof(INDEX_ENTRY)); */
         num_bytes = fwrite((SB8 *)&tmp_ix, sizeof(char), sizeof(INDEX_ENTRY), fout);
         if (num_bytes != sizeof(INDEX_ENTRY))
         {
             printf("write error\n");
             return;
         }
#endif /* defined(MSDOS) && !defined(CGFLAT32) */

      }

    }  /*  end - for i  */


#if defined(MSDOS) && !defined(CGFLAT32)
   free( lib_buf );    /* others  already free'd  */
#endif

   return;
} /*  end - write_libsNoffsets  */


#if defined (MSDOS) || defined (__OS2__) || defined(__i960)  /* 12-22-92 */
#define PATH_DELIM '\\'
#elif defined (MACINTOSH)
#define PATH_DELIM ':'
#else
#define PATH_DELIM '/'
#endif

/*----------------*/
/*    basename    */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL LPSB8 basename (SB8 *pathname )
#else
MLOCAL LPSB8
basename( pathname )
   SB8 *pathname;
#endif
{
   int   i;

   /*  Minimal check for valid string   */
   if( strlen( pathname ) <= 0 )
      return NULL;
   for( i = strlen(pathname)-1; i >= 0; i-- )
   {
      if( *(pathname + i) == PATH_DELIM )
         break;
   } 

   return( pathname + i + 1 );

}    /*  end - basename  */

#endif  /*  ROM  */

/*----------------*/
/*  main          */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL int main (int argc, char *argv[])
#else
GLOBAL int
main (argc, argv)
int argc;
char *argv[];
#endif
{
	#define _POSIX_PATH_MAX 256
	 char path[_POSIX_PATH_MAX];
#if ROM
    SW16   ntf_in_lib[ MAXTF ];         /* # typefaces in lib N */
    SW16   nlibs = 0;
    char   tmp_str[4];
    int    i;
#endif  /*  ROM  */

	if ( PIreadini())
		path[0] = '\0';
	else
		if ( p_fontext[1] == NULL )
			path[0] = '\0';
		else
			strcpy(path, p_fontext[1]);	 /* IF directory  */

#if defined (MACINTOSH)
    argc = ccommand (&argv);
#endif

    printf("\nCross-Platform IXMAK");
    printf("\n--------------------");
    printf("\nMEM_ALIGN == %d\n", MEM_ALIGN);
#if (MEM_ALIGN == 3)
    printf("\nUse MOTOROLA fonts if target is MACINTOSH, SPARC or MIPS.\n");
    printf("\nUse INTEL fonts if target is 80960.\n");
    printf("\nSet MEM_ALIGN to 1 or 0 and rebuild IXMAK if target is");
    printf("\nAMIGA, SUN 3, MSDOS, OS2 or VMS. \n\n");
#else
    printf("\nUse MOTOROLA fonts if target is AMIGA or SUN.\n");
    printf("\nUse INTEL fonts if target is MSDOS, OS2 or VMS.\n");
    printf("\nSet MEM_ALIGN to 3 and rebuild IXMAK if target is");
    printf("\nMACINTOSH, Sun SPARC, MIPS, or Intel 80960.\n\n");
#endif

#ifdef DEBUG
    printf("trace: ");
    SCANF_D(&trace_sw);
#else  /* !DEBUG */
    trace_sw = 0;
#endif

    update   = 0;

#ifdef NEVER
#if ROM
    /*  Special handling of update is done else where for ROM   */
#else
    printf("Enter type of file to create (0 = IF.FNT, 1 = HQ3.FNT) ");
    SCANF_D(&update);
#endif /*  !ROM  */

    printf("Input data file: "); 
    scanf("%s",infile);
#endif

	if ( p_fontext[5] == NULL )
		infile[0] = '\0';
	else
		strcpy(infile, p_fontext[5]);	 /* IF directory  */
	strcat(infile, "if.txt");
    if (!(instream = fopen(infile, "r")))
    {
        printf("File %s not found\n", infile);  /* 2-14-94 jfd */
        return (1);
    }

#if ROM
    /* Don't ask user any more.                      -ss 11/15/91 */
    printf("\nROM enabled.  Font block, block_if.fnt, being created.\n");
    strcpy( outfile, "block_if.fnt" );
#else
    if (!update)
		{
		if ( p_fontext[1] == NULL )
			path[0] = '\0';
		else
			strcpy(path, p_fontext[1]);	 /* IF directory  */

		strcpy(outfile, path);
       strcat( outfile, "if.fnt" );
		}
    else
       strcpy( outfile, "hq3.fnt" );
#endif /*  ROM  */

#if 0
#ifdef UNIX
    fout = open(outfile,  O_CREAT|O_TRUNC|O_RDWR, 0644);
#else
    fout = open(outfile,  O_BINARY|O_CREAT|O_TRUNC|O_RDWR, S_IREAD|S_IWRITE);
#endif
#endif /* 0 */
    fout = fopen(outfile,  "w+b");  /* 12-17-92 */
    if (!fout)
    {
        printf ("Cannot open %s : %d\n", outfile, errno);
        return (1);
    }
	if ( p_fontext[5] == NULL )
		path[0] = '\0';
	else
		strcpy(path, p_fontext[5]);	 /* IF directory for getting library names */


    name_off = 0;   /* total length of name strings so far */
    entry_ct = 0;   /* total output file entries */
/*
 * 9/9/93 maib, allow cross platform index file creation
 */
#if (MEM_ALIGN == 3)
                      /* 01-11-93 */
    wLONG( (SL32)entry_ct);
#else
    wWORD(entry_ct);
#endif
    while ( get_line(instream, inputline))
    {
        int nn;
        char tt_arg[10];
		 char temp[255];

        DBG1("%s\n", inputline);
        nn = sscanf(inputline,"%s%s", temp, tt_arg);
        if (nn == 2  &&  strncmp(tt_arg, "TT", 2) == 0)  /* mby 7-14-93 */
            ix_tt_flag = B_PLUGIN_TYPE_TT;
        else
            ix_tt_flag = 0;
		if (temp[0] == '#')	  /* to comment out a library */
			continue;
		strcpy(libname, path);
		strcat(libname, temp);
        DBG2("%s %s\n",libname, tt_arg);
/*        if ((f = open(libname, ORFLAGS)) == -1) */
        if (!(f = fopen(libname, ORFLAGS)))  /* 12-17-92 */
        {
            printf("Library file %s not found\n", libname);
        }
        else
        {
#if ROM
            /*  Hack processing of HQ3 to generate negative tfnums.  */
            /* Grab first 3 chars without path.          -ss 6/11/92 */
            strncpy( tmp_str, basename( libname ), 3 );
            tmp_str[3] = '\0';   /* add 19-Aug-92 - rs */

            /* Make lower case for compare in case system doesn't    */
            /* have case insensitive test.               -ss 6/30/92 */
            for( i = 0; i < 3; i++ )
               if( isupper(tmp_str[i]) ) 
                  tmp_str[i] =  tolower(tmp_str[i]);

            /* check for first 3 chars to match HQ3.      -ss 6/8/92 */
            if( strcmp( tmp_str, "hq3" ) == 0 )
               update = 1;
#endif  /*  end - ROM  */

            process_lib();
            fclose(f); /* 12-17-92 */

#if ROM
            update = 0;                           /* Reset */
            ntf_in_lib[ nlibs++ ] = num_faces;    /* save */
#endif  /*  end - ROM  */
        }
    }

#if ROM
    write_libsNoffsets( instream, nlibs, ntf_in_lib );
#else
    write_lib_names();
#endif


    fclose(instream);
    fclose(fout);  /* 12-17-92 */
    return (0);
}
