/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/tools/UFSS/ufssmak.c,v 1.2 2003/05/07 23:02:24 Lann Exp $ */
/* $Log: ufssmak.c,v $
/* Revision 1.2  2003/05/07 23:02:24  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:38  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.10   06 Apr 1995 11:21:34   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.9   16 Jan 1995 14:02:16   JOE
 * Added support for MicroType symbol sets (MTxx.SYM).
 * 
 *    Rev 1.8   10 May 1994 09:25:54   JOE
 * If MIPS, do not include <stdlib.h>.
 * 
 *    Rev 1.7   22 Apr 1994 08:19:36   LISA
 * 
 * Made additional modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.6   20 Apr 1994 09:22:10   LISA
 * 
 * Inserted new Copyright information for 1994.
 * 
 *    Rev 1.5   29 Oct 1993 17:31:40   MAIB
 * 
 * Increaed FILE_NAME buffer size
 * 
 *    Rev 1.4   27 Aug 1993 08:35:06   JOE
 * Changed all occurrences of "inline" to "inputline" to resolve VXWORKS 
 * conflict.
 * Moved "vxWorks.h" include before "port.h" to resolve VXWORKS conflict.
 * In main(), if VXWORKS, call fflush() on "ssstream", "fout_if" and "fout_tt"
 * streams to prevent program from hanging when running off 960 board.
 * 
 *    Rev 1.3   12 Feb 1993 10:50:44   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   14 Jan 1993 11:26:40   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:38:00   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:40:58   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:24 $ */

/*                          UFSSMAK.C                          */


/*  29-Jan-91  jfd  Added cgconfig.h
 *  05-Jun-91  jfd  Add SUN compatability (FIX FROM EARLIER VERSION)
 *  24-Jun-91  ss   Deleted cgmach.h.
 *                  Added new includes ifmem.h and sym.h
 *  25-Oct-91  ss   Added use of SS_COUNT_SIZE and SS_COUNT_TYPE to help
 *                  with SPARC port.
 *  09-Apr-92  jfd  Portability cleanup (see port.h).
 *   1-Jul-92  ss   Changed conditionals on SUN to UNIX to be more general.
 *                  Added replacement for stricmp() for UNIX SysV which
 *                  doesn't have it.
 *                  Moved port.h to top to access defines earlier.
 *  08-Jul-92  rs   Code cleanup.
 *
 *  24-Sep-92  mby  ufssmak.c evolves out of the ooze.
 *  16-Oct-92  mby  Remove GET_xWORD and GET_xLONG macros. They're in sym.h.
 *                  Fix problem where TT UGL symbol sets from HP don't
 *                  have a space character (32).
 *  20-Oct-92  jfd  In write_symbolset(), if compiling with MSC 5.1, scanning
 *                  in TT unicodes differently because "sscanf" can not
 *                  scan in hex numbers beginning with "0x" properly.
 *  22-Oct-92  jfd  Including cgmacros.h.
 *  02-Nov-92  rs   Fix problem scanning hex values in TT symbol sets.
 *  03-Nov-92  dbk  In write_symbolset(), cast malloc() call to (UB8*).
 *                  Changed function prototype for !LINT_ARGS for
 *                  build_directory_entry() to BOOLEAN.
 *  21-Nov-92  rs   Port to Macintosh - don't include <malloc.h>, add ANSI
 *                  function defs.
 *  08-Feb-93  jfd  VXWorks support.
 *  26-Aug-93  jfd  Changed all occurrences of "inline" to "inputline" to resolve VXWORKS 
 *                  conflict.
 *                  Moved "vxWorks.h" include before "port.h" to resolve conflict.
 *                  In main(), if VXWORKS, call fflush() on "ssstream",
 *                  "fout_if" and "fout_tt" streams to prevent program
 *                  from hanging when running off 960 board.
 *  29-Oct-93  maib Increased FILE_NAME to MAXLINE size
 *  10-May-94  jfd  If MIPS, do not include <stdlib.h>.
 *  04-Jan-95  jfd  Added support for MicroType symbol sets (MTxx.SYM).
 *                  
 */

/*  Derived from SSMAK.C.  September 1992.
 *  Compiles Type Director symbol set files (.SYM) into two binary symbol
 *  set files for UFST. The output files are UIF.SS (Agfa/CG encoding), and
 *  UTT.SS (Microsoft Unicode encoding). The symbol set directory in UTT.SS
 *  also includes the platform ID and specific ID.
 */

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>

#ifndef MIPS  /* 5-9-94 */
#include <stdlib.h>
#endif
#define _POSIX_
#include	 <limits.h>

#include <fcntl.h>
#include <ctype.h>
#include <string.h>

#if !defined (MACINTOSH) && !defined(VXWORKS)
#include <malloc.h>
#endif

#if defined UNIX
#include <values.h>
#elif !defined (MACINTOSH)
#include <io.h>
#endif

#if defined (MACINTOSH)
#include <console.h>
#endif

#include "debug.h"
#include "ifmem.h"
#include "cgif.h"
#include "ix.h"
#include "sym.h"
#include "cgmacros.h"

typedef union
	{
	unsigned long offs;
#ifdef MSC86
	char huge * addr;
#else
	char * addr;
#endif
	} OFFS_ADDR;

typedef struct
	{
    unsigned short ss_type;
    unsigned short class;
    unsigned short f_code;
    unsigned short l_code;
    unsigned short *  p_pss;
	unsigned short msl_no[1];	/* for scdownld and others ? */
    }
    SS;

struct sym
	{
	unsigned short ssw;					/* UFST identifier (0 for user defined */
	unsigned short sym_set;				/* ss id */
	unsigned char flags;					/* permanent or temporary */
	unsigned char format;	  			/* MSL = 0, UNICODE = 1 */
	unsigned char requirements[8];		/* requirements array */
	struct sym * nx_sym_ID;	/* next one in list */
	struct sym * pv_sym_ID;	/* previous one in list */
	SS ss;					/* where the table actually is */
	};

typedef struct sym USER_SYM;
typedef struct sym OB_SYM;

#ifdef NEVER
typedef struct				   /* should agree with the structure in scaly_ff.h */
	{
	unsigned short ssw;			/* e.g. "PC" as a word - used as index into uif.ss or utt.ss */
	unsigned short sscode;		/* e.g. 10U -> 10 * 32 + (85 - 64) */
	unsigned char format;		/* 0 = MSL 1 = Unicode */
	unsigned char type;
	unsigned short f_code;
	unsigned short l_code;
	unsigned char requirements[8];  /* all 0 means this is bound to a particular font */
	}
	OB_SYM;				/* predefined symbol sets (listed in utt.ss or uif.ss */
#endif



#define MAXLINE      133        /* Maximum line length */
#define MAX_SSDIR    128        /* Up to 128 symbol sets each of IF, TT */


#ifdef DEBUG
MLOCAL SW16 trace_sw;           /* Print debug data if not 0.         */
#endif

MLOCAL FILE *ssstream;          /* Input symbol file stream           */
MLOCAL char  ssline[MAXLINE];    /* Next line from input file          */

MLOCAL FILE *fout_if, *fout_tt, *fout_mt; /* Output files              */

typedef char FILE_NAME[MAXLINE];

MLOCAL SS_DIRECTORY    ifss_directory[MAX_SSDIR];
MLOCAL UFSS_DIRECTORY  ttss_directory[MAX_SSDIR];
MLOCAL UFSS_DIRECTORY  mtss_directory[MAX_SSDIR];
MLOCAL FILE_NAME  valid_ifss_files[MAX_SSDIR];
MLOCAL FILE_NAME  valid_ttss_files[MAX_SSDIR];
MLOCAL FILE_NAME  valid_mtss_files[MAX_SSDIR];


/* Macros to copy two or four bytes of data from SRC pointer to DST pointer.
   Data is written to DST in MOTOROLA order (hi-lo). For completeness we could
   add to write four more macros that write to DST in INTEL order (lo-hi)
   Example:
            UB8*  buffer;
            PUTW_M( buffer,    &ifss_directory[ii].first_code);
            PUTW_M((buffer+2), &ifss_directory[ii].num_codes);
            PUTL_M((buffer+4), &ifss_directory[ii].offset);
            fwrite(buffer, 1, 8, fout);
   copies 3 members of a structure to a byte buffer, then writes to a
   file in Motorola byte order, regardless of the CPU platform.
*/
#if BYTEORDER == LOHI   /* byte ordering is Lo-Hi bytes (Intel) */

#define PUTW_M( DST,SRC )  (*(char*)(DST) = *((char*)(SRC)+1), \
                    *((char*)(DST)+1) = *(char*)(SRC) )
#define PUTL_M( DST,SRC )  (*(char*)(DST) = *((char*)(SRC)+3), \
                    *((char*)(DST)+1) = *((char*)(SRC)+2), \
                    *((char*)(DST)+2) = *((char*)(SRC)+1), \
                    *((char*)(DST)+3) = *(char*)(SRC) )

#else                /* byte order is Hi-Lo (Motorola 680x0) */
#define PUTW_M( DST,SRC )  (*(char*)(DST) = *(char*)(SRC), \
                    *((char*)(DST)+1) = *((char*)(SRC)+1) )
#define PUTL_M( DST,SRC )  (*(char*)(DST) = *(char*)(SRC), \
                    *((char*)(DST)+1) = *((char*)(SRC)+1), \
                    *((char*)(DST)+2) = *((char*)(SRC)+2), \
                    *((char*)(DST)+3) = *((char*)(SRC)+3) )
#endif /* BYTEORDER */


#ifdef LINT_ARGS
MLOCAL BOOLEAN get_line (FILE*, char*);
MLOCAL BOOLEAN build_directory_entry (UW16*, UW16*, UW16*, char*);
MLOCAL BOOLEAN write_directories (UW16, UW16, UW16);
MLOCAL BOOLEAN write_symbolset (UW16, UW16, FILE*, int, UW16, UW16);
MLOCAL BOOLEAN get_match (char*, char*);
MLOCAL BOOLEAN get_match_line (char*);
GLOBAL VOID main (int argc, char *argv[]);

#else   /* !LINT_ARGS */
MLOCAL BOOLEAN get_line();
MLOCAL BOOLEAN build_directory_entry();
MLOCAL BOOLEAN write_directories();
MLOCAL BOOLEAN write_symbolset();
MLOCAL BOOLEAN get_match();
MLOCAL BOOLEAN get_match_line();
GLOBAL VOID main ();
#endif  /* LINT_ARGS */


FILE * req_file;

typedef struct
	{
	char s[3];
	}COMM;

#define Max_tbl 8

char d[1000];
char * p_fontext[8];

int PIreadini(void)

	{ 	
	FILE * ini_file;
	int i, j = 0;
	COMM pcl_table[Max_tbl] = {	
	"bm", "sc", "st", "pt", "ss", "if", "tt", "fl"};
	char * p_value;
	char string[500];

	if ( (ini_file = fopen("lj.ini", "ra")) == NULL )
		 {
         if ( (ini_file = fopen("/lj.ini", "ra")) == NULL )
           if ( (ini_file = fopen("/lj/lj.ini", "ra")) == NULL )
			return 0;
        }

	while ( fscanf(ini_file, "%s", string) != EOF )
		{
		char * p_equal = strchr(string, '=');
		if ( p_equal != NULL )
			{
			* p_equal = '\0';
			p_value = p_equal + 1;
			if ( strlen(string) == 2 )	 /* can be bm, sc, st, pt, fl */
				{
				for ( i = 0; i < Max_tbl; ++ i )
					{
					if ( strcmp(string, pcl_table[i].s) == 0 )
						break;
					}
				if ( (p_value = ( i < Max_tbl ) ? p_equal + 1 : NULL) != NULL )
					{
					if ( i < Max_tbl - 1 )
						{
						strcpy(&d[j], p_value);
						p_fontext[i] = &d[j];
						j += strlen(p_value) + 1;
						}
					}
				}
			}
		}
	return 0;
	}


/*===================================================================*/
/*                S t r i n g    S t u f f                           */

/*-------------------------*/
/*  get_line               */
/*-------------------------*/
/*  Load the next non-blank line from text stream "s" into line
 *  buffer "line". Return TRUE if successful, FALSE if end of
 *  file is reached.
 */

#if defined (ANSI_DEFS)
MLOCAL BOOLEAN get_line (FILE *s, char *line)
#else
MLOCAL BOOLEAN
get_line(s, line)
    FILE *s;
    char *line;
#endif
{
    char *cp;

    while(TRUE)
    {
        if(fgets( line, MAXLINE, s) == NULL) 
            return FALSE;
        cp = line;
        while( ((*cp == ' ') || (*cp == '\t')) && *cp != '\n' ) 
            cp++;
        if(*cp != '\n') 
            return TRUE;
    }
}


/*-------------------------*/
/*  get_match              */
/*-------------------------*/
/*  return truth value of "p2 is initial substring of p1"  */

#if defined (ANSI_DEFS)
MLOCAL BOOLEAN get_match (char *p1, char *p2)
#else
MLOCAL BOOLEAN
get_match(p1,p2)
    char *p1;
    char *p2;
#endif
{
    while(*p1)
    {
      /* So far p2 is a substring of p1 */

        if(!*p2) 
            return TRUE;  /* All done with p2 */
        if(*p1++ != *p2++) 
            return FALSE;
    }

  /* Nothing left in p1 */
    if (*p2)
        return FALSE;   /* more in p1- no good */
    else
        return FALSE;   /* nothing left in p2 either */
}



/*-------------------------*/
/*  get_match_line         */
/*-------------------------*/
/*  Move to line in ssstream starting with key */

#if defined (ANSI_DEFS)
MLOCAL BOOLEAN get_match_line (char *key)
#else
MLOCAL BOOLEAN
get_match_line(key)
    char *key;
#endif
{
    DBG1("        get_match_line()  %s", key);
    while(get_line(ssstream, ssline))
        if(get_match(ssline, key)) 
            return TRUE;
    return FALSE;
}


/*                S t r i n g    S t u f f                           */
/*===================================================================*/




#define FSBIT_IF  1
#define FSBIT_TT  2
#define FSBIT_MT  3
#define FLAGASC 0x1     /* SYMBOL SET  */
#define FLAGPCH 0x2     /* /pcl char   */
#define FLAGPNR 0x4     /* /pcl num    */
#define FLAGTYP 0x8     /* /type       */
#define FLAGCLA 0x10    /* /class      */
#define FLAGFCD 0x20    /* /first code */
#define FLAGLCD 0x40    /* /last code  */
#define FLAGALL 0x7F

/*-------------------------*/
/*  build_directory_entry  */
/*-------------------------*/
/*  Build parallel arrays of structures and pathnames, for Intellifont,
 *  TrueType and MicroType symbol sets. These are distinuished by
 *  examining the /index keyword. The argument is either ACG, Unicode
 *  or UnicodeMT.
 *
 *  Return  ssct_if, ssct_tt, ssct_mt, one of which is incremented if the
 *          symbol set file is valid.
 *  pathname is stored in valid_XXss_files[] for 2nd pass.
 */
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN  build_directory_entry (UW16 * ssct_if, UW16 *ssct_tt, UW16 *ssct_mt, char *pathname )
#else
MLOCAL BOOLEAN  build_directory_entry( ssct_if, ssct_tt, ssct_mt, pathname )
   UW16 *ssct_if;
   UW16 *ssct_tt;
   UW16 *ssct_mt;
   char  *pathname;
#endif
{
char  cc[2];
char  ch;
SW16 last_code;
int  ii;
int  index_flags = 0;
UB8  PCLchar;
UW16 PCLnum;
UFSS_DIRECTORY sym;
SS_DIRECTORY *sym_if;
UFSS_DIRECTORY *sym_tt;
UFSS_DIRECTORY *sym_mt;
int  sym_fsType = FSBIT_IF;  /* defaults to Intellifont if /index keyword isn't found */
char string[80];
char tmpstr[20];
OB_SYM ob_sym;


DBG("build_directory_entry()\n");
sym.platformID = sym.specificID = 0;

{
int i;
for ( i = 0; i < 8; ++ i )
	ob_sym.requirements[i] = 0;	/* in case we do not get one */
}
while (1)    /* start_list init at declaration above */
    {
    ch = (char)fgetc(ssstream);
    if (ch=='S'  ||  ch=='s')
        {
        fscanf(ssstream,"%[^=]",string);
        for( ii = 0; ii < 9; ii++ )
            tmpstr[ii] = (char)toupper((int)string[ii]);
        if (strncmp(tmpstr,"YMBOL SET",9) == 0)
            {
            fscanf(ssstream,"%*[ =] %c%c", &cc[0], &cc[1]);
            sym.ss_code = GET_xWORD(cc);
            index_flags |= FLAGASC;
			ob_sym.ssw = GET_xWORD(&sym.ss_code);
            }
        }
    if ((char)ch=='/')   /* Start of a header line */ 
        {
        fscanf(ssstream,"%[^=]",string);
        if (strncmp(string,"type",4) == 0)
            {
            fscanf(ssstream,"%*[ =]%hd",&sym.type);
            index_flags |= FLAGTYP;
			ob_sym.ss.ss_type = (unsigned short)sym.type;
            }
        if (strncmp(string,"class",5) == 0)
            {
            fscanf(ssstream,"%*[ =]%hd",&sym.class);
            index_flags |= FLAGCLA;
            }
        if (strncmp(string,"pcl num",7) == 0)
            {
            fscanf(ssstream,"%*[ =]%hd",&PCLnum);
            index_flags |= FLAGPNR;
            }
        if (strncmp(string,"pcl char",8) == 0)
            {
            fscanf(ssstream,"%*[ =]%c",&PCLchar);
            index_flags |= FLAGPCH;
            }
        if (strncmp(string,"first code",10) == 0)
            {
            fscanf(ssstream,"%*[ =]%hd",&sym.first_code);
            index_flags |= FLAGFCD;
            }
        if (strncmp(string,"last code",9) == 0)
            {
            fscanf(ssstream,"%*[ =]%hd",&last_code);
            index_flags |= FLAGLCD;
			ob_sym.ss.l_code = last_code;
            }
        if (strncmp(string,"index",5) == 0)
            {
            fscanf(ssstream,"%*[ =]%9s", tmpstr);
            if (strcmp(tmpstr, "ACG") == 0)
				{
                sym_fsType = FSBIT_IF;
				ob_sym.format = 0;
				}
            else if (strcmp(tmpstr, "Unicode") == 0)
				{
                sym_fsType = FSBIT_TT;
				ob_sym.format = 1;
				}
            else if (strcmp(tmpstr, "UnicodeMT") == 0)
                sym_fsType = FSBIT_MT;
            }
		if (strncmp(string, "requirements", 12)	== 0 && sym_fsType != FSBIT_MT )
			{
			int i;
			unsigned int n;
			char * p_str;
			char hexstr[3];
			hexstr[2] = '\0';
            fscanf(ssstream,"%*[ =]%18s", tmpstr);
/*< convert the string from the right into r[7], r[6] ... r[0] >*/
			p_str = tmpstr + strlen(tmpstr) - 1;
			for ( i = 7; i >= 0; -- i )
				{
				hexstr[1] = * p_str --;
				hexstr[0] = * p_str --;
				sscanf(hexstr, "%x", &n); 
				ob_sym.requirements[i] = (unsigned char)n;
				}
			}

        if (strncmp(string,"platformID",10) == 0)
            fscanf(ssstream,"%*[ =]%hd", &sym.platformID);
        if (strncmp(string,"specificID",10) == 0)
            fscanf(ssstream,"%*[ =]%hd", &sym.specificID);
        if (strncmp(string,"symbols",7) == 0)    /* symbol list follows */
            break;
        }   /* end of if '/' */

    while (fgetc(ssstream) != '\n') 
        ;     /* clear rest of line */

    }       /* Stop reading when we get to the symbol list data */

if (index_flags != FLAGALL)
    {
    printf("Missing keyword\n");
    return FALSE;
    }

/* If first code is "33", make it "32" so that we handle the space char properly. */
if (sym.first_code == 33)
    sym.first_code--;
ob_sym.ss.f_code = sym.first_code;
sym.symSetCode = 32 * PCLnum + (short)PCLchar - 64;
ob_sym.sym_set = sym.symSetCode;
ob_sym.ss.p_pss = NULL; /* get the codes later */
if ( sym_fsType != FSBIT_MT )
	{
	if ( fwrite(&ob_sym, sizeof(ob_sym), 1, req_file) != 1 )
		{
		printf("Error in write to symbol definition file\n");
		return FALSE;
		}
	}
sym.num_codes  = last_code - sym.first_code + 1;
if (sym_fsType == FSBIT_TT)
    {
    if (*ssct_tt == MAX_SSDIR - 1)
        {
        printf("Maximum of %d TrueType symbol set files allowed\n", MAX_SSDIR);
        return FALSE;
        }
    sym_tt = ttss_directory + *ssct_tt;
    memcpy(sym_tt, &sym, sizeof(UFSS_DIRECTORY));
    strcpy(valid_ttss_files[*ssct_tt], pathname);
    (*ssct_tt)++;
    }
else if (sym_fsType == FSBIT_MT)
    {
    if (*ssct_mt == MAX_SSDIR - 1)
        {
        printf("Maximum of %d MicroType symbol set files allowed\n", MAX_SSDIR);
        return FALSE;
        }
    sym_mt = mtss_directory + *ssct_mt;
    memcpy(sym_mt, &sym, sizeof(UFSS_DIRECTORY));
    strcpy(valid_mtss_files[*ssct_mt], pathname);
    (*ssct_mt)++;
    }
else
    {
    if (*ssct_if == MAX_SSDIR - 1)
        {
        printf("Maximum of %d Intellifont symbol set files allowed\n", MAX_SSDIR);
        return FALSE;
        }
    sym_if = ifss_directory + *ssct_if;
    sym_if->ss_code = sym.ss_code;
    sym_if->symSetCode = sym.symSetCode;
    sym_if->type = sym.type;
    sym_if->class = sym.class;
    sym_if->first_code = sym.first_code;
    sym_if->num_codes = sym.num_codes;
    strcpy(valid_ifss_files[*ssct_if], pathname);
    (*ssct_if)++;
    }

return TRUE;
}
#undef FSBIT_IF
#undef FSBIT_TT
#undef FSBIT_MT
#undef FLAGASC
#undef FLAGPCH
#undef FLAGPNR
#undef FLAGTYP
#undef FLAGCLA
#undef FLAGFCD
#undef FLAGLCD
#undef FLAGALL





/*-------------------------*/
/*  write_directories
 *
 *  All data is written in Motorola byte order.
/*-------------------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN  write_directories (UW16 ssct_if, UW16 ssct_tt, UW16 ssct_mt )
#else
MLOCAL BOOLEAN  write_directories( ssct_if, ssct_tt, ssct_mt )
   UW16 ssct_if;
   UW16 ssct_tt;
   UW16 ssct_mt;
#endif
{
char  buffer[8];
UW16  ii;
UL32  off;
UB8  *pss;
UW16  temp16;
UL32  temp32;
SS_DIRECTORY    sstmp;
UFSS_DIRECTORY  usstmp;
UFSS_DIRECTORY  mt_usstmp;

DBG("write_directories()\n");
DBG3("    There are %u, %u, %u symbol sets\n", ssct_if, ssct_tt, ssct_mt);

/* .SS file identifier; symbol set count */
temp32 = IFSSIDN;
PUTL_M( buffer, &temp32 );
temp16 = ssct_if;
PUTW_M( (buffer+4), &temp16 );
temp16 = SSDIR_SIZE;
PUTW_M( (buffer+6), &temp16 );
if (fwrite(buffer, 1, 8, fout_if) != 8)
    return FALSE;
temp32 = TTSSIDN;
PUTL_M( buffer, &temp32 );
temp16 = ssct_tt;
PUTW_M( (buffer+4), &temp16 );
temp16 = UFSSDIR_SIZE;
PUTW_M( (buffer+6), &temp16 );
if (fwrite(buffer, 1, 8, fout_tt) != 8)
    return FALSE;
temp32 = MTSSIDN;
PUTL_M( buffer, &temp32 );
temp16 = ssct_mt;
PUTW_M( (buffer+4), &temp16 );
temp16 = UFSSDIR_SIZE;
PUTW_M( (buffer+6), &temp16 );
#ifdef DO_MT
if (fwrite(buffer, 1, 8, fout_mt) != 8)
    return FALSE;
#endif

/*  Write one more directory entry so we can use
 *  directory offsets to compute symbol set sizes.
 */
ifss_directory[ssct_if].ss_code = 0x2020;
ttss_directory[ssct_tt].ss_code = 0x2020;
mtss_directory[ssct_mt].ss_code = 0x2020;

/* skip over directory section */
off = (SL32)SSD_DOFF + SSDIR_SIZE * (ssct_if + 1);
for(ii=0; ii<ssct_if + 1; ii++)
    {
    DBG1("%s\n", valid_ifss_files[ii]);
    ifss_directory[ii].offset = off;
    pss = (UB8*)&sstmp;
    PUTW_M((pss+SSD_CODE), &ifss_directory[ii].ss_code);
    PUTW_M((pss+SSD_SYMCODE), &ifss_directory[ii].symSetCode);
    PUTW_M((pss+SSD_TYPE), &ifss_directory[ii].type);
    PUTW_M((pss+SSD_CLASS), &ifss_directory[ii].class);
    PUTW_M((pss+SSD_FIRSTC), &ifss_directory[ii].first_code);
    PUTW_M((pss+SSD_NUMC), &ifss_directory[ii].num_codes);
    PUTL_M((pss+SSD_OFF), &ifss_directory[ii].offset);
    if (fwrite(pss, 1, SSDIR_SIZE, fout_if) != SSDIR_SIZE)
        return FALSE;
    off += ifss_directory[ii].num_codes * 2;
    }

/* skip over directory section */
off = (SL32)SSD_DOFF + UFSSDIR_SIZE * (ssct_tt + 1);
for(ii=0; ii<ssct_tt + 1; ii++)
    {
    DBG1("%s\n", valid_ttss_files[ii]);
    ttss_directory[ii].offset = off;
    pss = (UB8*)&usstmp;
    PUTW_M((pss+SSD_CODE), &ttss_directory[ii].ss_code);
    PUTW_M((pss+SSD_SYMCODE), &ttss_directory[ii].symSetCode);
    PUTW_M((pss+SSD_TYPE), &ttss_directory[ii].type);
    PUTW_M((pss+SSD_CLASS), &ttss_directory[ii].class);
    PUTW_M((pss+SSD_FIRSTC), &ttss_directory[ii].first_code);
    PUTW_M((pss+SSD_NUMC), &ttss_directory[ii].num_codes);
    PUTL_M((pss+SSD_OFF), &ttss_directory[ii].offset);
    PUTW_M((pss+SSD_PLID), &ttss_directory[ii].platformID);
    PUTW_M((pss+SSD_SPID), &ttss_directory[ii].specificID);
    if (fwrite(pss, 1, UFSSDIR_SIZE, fout_tt) != UFSSDIR_SIZE)
        return FALSE;
    off += ttss_directory[ii].num_codes * 2;
    }

/* skip over directory section */
off = (SL32)SSD_DOFF + UFSSDIR_SIZE * (ssct_mt + 1);
for(ii=0; ii<ssct_mt + 1; ii++)
    {
    DBG1("%s\n", valid_mtss_files[ii]);
    mtss_directory[ii].offset = off;
    pss = (UB8*)&mt_usstmp;
    PUTW_M((pss+SSD_CODE), &mtss_directory[ii].ss_code);
    PUTW_M((pss+SSD_SYMCODE), &mtss_directory[ii].symSetCode);
    PUTW_M((pss+SSD_TYPE), &mtss_directory[ii].type);
    PUTW_M((pss+SSD_CLASS), &mtss_directory[ii].class);
    PUTW_M((pss+SSD_FIRSTC), &mtss_directory[ii].first_code);
    PUTW_M((pss+SSD_NUMC), &mtss_directory[ii].num_codes);
    PUTL_M((pss+SSD_OFF), &mtss_directory[ii].offset);
    PUTW_M((pss+SSD_PLID), &mtss_directory[ii].platformID);
    PUTW_M((pss+SSD_SPID), &mtss_directory[ii].specificID);
#ifdef DO_MT
    if (fwrite(pss, 1, UFSSDIR_SIZE, fout_mt) != UFSSDIR_SIZE)
        return FALSE;
#endif
    off += mtss_directory[ii].num_codes * 2;
    }

return TRUE;
}




/*-------------------------*/
/*  write_symbolset        */
/*-------------------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN write_symbolset (UW16 first_code, UW16 last_code, FILE *fout, 
                                int fs_type, UW16 platID, UW16 specID)
#else
MLOCAL BOOLEAN
write_symbolset(first_code, last_code, fout, fs_type, platID, specID)
    UW16 first_code;
    UW16 last_code;
    FILE* fout;
    int  fs_type;           /* 0 = Intellifont; 1 = TrueType */
    UW16 platID, specID;    /* only used when fs_type = TT   */
#endif
{
UW16    cur_entry_index;
UW16    code;
UW16    s_num;
UW16    n_num = 0;          /* num = 0 for unused entries */
UB8    *pdata;
int     ssize;

DBG("write_symbolset()\n");

if(!get_match_line("/symbols")) 
    return FALSE;
ssize = 2 * (last_code - first_code + 1);
if ((pdata = (UB8*)malloc(ssize)) == NULL)
    {
    printf("malloc(%u) failure\n", ssize);
    return FALSE;
    }
cur_entry_index = first_code;
while((cur_entry_index <= last_code) && get_line(ssstream,ssline))
    {
    if(get_match(ssline, "/end")) 
        break;

    if (fs_type)    /* TrueType Unicodes are written in hex */
        sscanf(ssline, "%hu 0x%hx", &code, &s_num);
    else
        sscanf(ssline, "%hu%hu", &code, &s_num); 

    if(code>last_code)
        {
        free(pdata);
        return FALSE;
        }

    while(cur_entry_index < code)
        {
        DBG2("    %u    %u\n", cur_entry_index, n_num);
        PUTW_M((pdata + (cur_entry_index - first_code) * 2), &n_num);
        cur_entry_index++;
        }

    PUTW_M((pdata + (cur_entry_index - first_code) * 2), &s_num);
    cur_entry_index++;
    DBG2("    %u    %u\n", code, s_num);
    }

while(cur_entry_index <= last_code)
    {
    PUTW_M((pdata + (cur_entry_index - first_code) * 2), &n_num);
    cur_entry_index++;
    }

/*  Fix possible space char missing from symbol set (TT).
 *  If TT sym set and Microsoft Unicode UGL is supported, set space char
 *  to 32 in symbol set instead of 0.
 */
n_num = 32;
if (fs_type  &&  (platID == 3 && specID == 1))
    {
    if (first_code <= 32  &&  GET_xWORD(pdata + (32 - first_code) * 2) == 0)
        PUTW_M((pdata + (32 - first_code) * 2), &n_num);
    }

fwrite(pdata, ssize, 1, fout);

free(pdata);
return TRUE;
}





/*----------------*/
/*  main          */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID main (int argc, char *argv[])
#else
GLOBAL VOID
main (argc, argv)
int argc;
char *argv[];
#endif
{
int   ii;
char   infile[MAXLINE];
char   inputline[MAXLINE];
FILE *instream;
FILE_NAME  pathname;
UW16  ssct_if = 0;
UW16  ssct_tt = 0;
UW16  ssct_mt = 0;
#define _POSIX_PATH_MAX 256
char path[_POSIX_PATH_MAX];
char outfile[_POSIX_PATH_MAX];

#if defined (MACINTOSH)
    argc = ccommand (&argv);
#endif

#ifdef DEBUG
    printf("Trace (nonzero to print debug data): ");
    scanf("%hd", &trace_sw);
#endif
	if ( PIreadini())
		infile[0] = '\0';
	else
		if ( p_fontext[4] == NULL )
			infile[0] = '\0';
		else
			strcpy(infile, p_fontext[4]);	 /* SS directory  */
	strcat(infile, "ufssmak.txt");

	if ( p_fontext[1] == NULL )
		path[0] = '\0';
	else
		strcpy(path, p_fontext[1]);	 /* IF directory  */

#ifdef NEVER
printf("Input symbol set list file: "); 
scanf("%s",infile);
#endif
if (!(instream = fopen(infile, "r")))
    {
    printf("File %s not found\n", infile);
    return;
    }
strcpy(outfile, path);
strcat(outfile, "uif.ss");

if (!(fout_if = fopen(outfile, "wb")))
    {
    printf("File uif.ss problem\n");
    return;
    }
strcpy(outfile, path);
strcat(outfile, "utt.ss");

if (!(fout_tt = fopen(outfile, "wb")))
    {
    printf("File utt.ss problem\n");
    return;
    }

#ifdef DO_MT
strcpy(outfile, path);
strcat(outfile, "umt.ss");

if (!(fout_mt = fopen(outfile, "wb")))
    {
    printf("File umt.ss problem\n");
    return;
    }
#endif

strcpy(outfile, path);
strcat(outfile, "char_set.ico");

if (!(req_file = fopen(outfile, "wb")))
    {
    printf("File char_set.ico problem\n");
    return;
    }

if ( p_fontext[4] == NULL )
	path[0] = '\0';
else
	strcpy(path, p_fontext[4]);	 /* SS directory  */

/* PASS 1:  build directory */

while (get_line(instream, inputline))
    {
    DBG1("%s\n", inputline);
    sscanf(inputline,"%s", pathname);
    DBG1("        %s\n",pathname);
	strcpy(outfile, "sym\\");
	strcat(outfile, pathname);

    if (!(ssstream = fopen(outfile, "r")))
        printf("Symbol set file %s not found\n", outfile);
    else
        {
        if (!build_directory_entry(&ssct_if, &ssct_tt, &ssct_mt, outfile))
            printf("Error in %s; not added to .SS file\n", outfile);
#ifdef VXWORKS  /* 8-26-93 jfd */
        fflush(ssstream);
#endif
        fclose(ssstream);
        }
    }
fclose(instream);
if (!write_directories(ssct_if, ssct_tt, ssct_mt))
    goto eRr_01;


/* PASS 2:  build symbol sets */
DBG1("\n\n\nPass2   Building %u Intellifont symbol sets\n", ssct_if);
for (ii=0; ii < (int)ssct_if; ii++)
    {
    DBG1("%s\n",valid_ifss_files[ii]);
    if (!(ssstream = fopen(valid_ifss_files[ii], "r")))
        printf("Symbol set file %s not found\n", valid_ifss_files[ii]);
    else
        {
        if (!write_symbolset(ifss_directory[ii].first_code,
               ifss_directory[ii].first_code + ifss_directory[ii].num_codes - 1,
               fout_if, 0,
               (UW16)0, (UW16)0 ))
            {
            printf("    bad input symbol table file\n");
            return;
            }
#ifdef VXWORKS    /* 8-26-93 jfd */
        fflush(ssstream);
#endif
        fclose(ssstream);
        }
    }

DBG1("\n\n\nPass2   Building %u TrueType symbol sets\n", ssct_tt);
for (ii=0; ii < (int)ssct_tt; ii++)
    {
    DBG1("%s\n",valid_ttss_files[ii]);
    if (!(ssstream = fopen(valid_ttss_files[ii], "r")))
        printf("Symbol set file %s not found\n", valid_ttss_files[ii]);
    else
        {
        if (!write_symbolset(ttss_directory[ii].first_code,
               ttss_directory[ii].first_code + ttss_directory[ii].num_codes - 1,
               fout_tt, 1,
               ttss_directory[ii].platformID, ttss_directory[ii].specificID ))
            {
            printf("    bad input symbol table file\n");
            return;
            }
#ifdef VXWORKS  /* 8-26-93 jfd */
        fflush(ssstream);
#endif
        fclose(ssstream);
        }
    }

DBG1("\n\n\nPass2   Building %u MicroType symbol sets\n", ssct_mt);
for (ii=0; ii < (int)ssct_mt; ii++)
    {
    DBG1("%s\n",valid_mtss_files[ii]);
    if (!(ssstream = fopen(valid_mtss_files[ii], "r")))
        printf("Symbol set file %s not found\n", valid_mtss_files[ii]);
    else
        {
#ifdef DO_MT
        if (!write_symbolset(mtss_directory[ii].first_code,
               mtss_directory[ii].first_code + mtss_directory[ii].num_codes - 1,
               fout_mt, 1,
               mtss_directory[ii].platformID, mtss_directory[ii].specificID ))
            {
            printf("    bad input symbol table file\n");
            return;
            }
#endif
#ifdef VXWORKS  /* 8-26-93 jfd */
        fflush(ssstream);
#endif
        fclose(ssstream);
        }
    }

#ifdef VXWORKS   /* 8-26-93 jfd */
fflush(fout_if);
#endif
fclose(fout_if);

#ifdef VXWORKS  /* 8-26-93 jfd */
fflush(fout_tt);
#endif
fclose(fout_tt);
#ifdef VXWORKS  /* 8-26-93 jfd */
fflush(fout_mt);
#endif
#ifdef DO_MT
fclose(fout_mt);
#endif
#ifdef VXWORKS
printf("\n End of session! ");
#endif
exit(0);

eRr_01:
    fclose(fout_if);
    fclose(fout_tt);
#ifdef DO_MT
    fclose(fout_mt);
#endif
    remove("uif.ss");
    remove("utt.ss");
#ifdef DO_MT
    remove("umt.ss");
#endif
}


