/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/tools/tt_if.c,v 1.2 2003/05/07 23:02:24 Lann Exp $ */
/* $Log: tt_if.c,v $
/* Revision 1.2  2003/05/07 23:02:24  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:38  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.51   18 Apr 1995 16:59:28   JOE
 * 
 * In ttset_char(), added support for the removal of symbol set mapping.
 * Removed obsolete function prototype.
 * 
 *    Rev 1.50   07 Apr 1995 11:17:56   LISA
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.49   11 Dec 1994 17:11:30   MIKE
 * Change ttmake_gaso_and_stats to fix 16-bit overflow.
 * 
 *    Rev 1.48   02 Dec 1994 21:29:48   MIKE
 * KSC (YAN).
 * 
 *    Rev 1.47   22 Sep 1994 10:50:56   MIKE
 * Removed MSHUGE to fix ANSI compilation error.
 * 
 *    Rev 1.46   20 Jun 1994 13:36:22   JOE
 * 
 * In ttload_DiskSfnt(), if __i960, break up READF call into multiple
 * calls if byte count exceeds 996 bytes due to limitation with i960
 * compiler.
 * 
 *    Rev 1.45   10 May 1994 09:27:42   JOE
 * 
 * If MIPS, include <unistd.h>.
 * 
 *    Rev 1.44   06 May 1994 13:34:24   MIKE
 * Changed ttget_FontBBox() to solve "rogue" character problem.
 * 
 *    Rev 1.43   22 Apr 1994 15:53:58   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !SUN) to resolve UNIX Metaware compiler error.
 * Changed 'UNIX' to 'SUN' within conditional compile statement prior
 * to including <fcntl.h>.
 * 
 *    Rev 1.42   22 Apr 1994 14:55:30   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.41   29 Mar 1994 10:04:36   JOE
 * Replaced macro calls OPEN and CLOSE with IXopen_file() and
 * IXclose_file() so that the number of open files will be updated
 * properly.
 * 
 *    Rev 1.40   17 Feb 1994 14:06:44   MAIB
 * 
 * Return an error if unable to map JIS and Unicode character codes
 * 
 *    Rev 1.39   09 Feb 1994 13:47:44   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.38   02 Feb 1994 16:22:10   JOE
 * Conditionally compile "io.h" based on MSDOS || OS2.
 * 
 *    Rev 1.37   02 Feb 1994 13:24:44   JOE
 * In ttrender(), save previous x,y points in "if_state".
 * 
 *    Rev 1.36   02 Feb 1994 09:38:14   JOE
 * 
 * Replaces I/O calls with macros (OPEN, LSEEK, READF and CLOSE) in
 * ttload_DiskSfnt(), tt_GetSfntGlyphPtr() and unload_memory().
 * In ttset_char(), fixed bug with zero glyph ID.
 * 
 *    Rev 1.35   05 Jan 1994 18:12:00   ROB
 * Add support for "GB" encoding.
 * 
 *    Rev 1.34   03 Jan 1994 12:24:30   MIKE
 * Fixed character origin in ttmake_gaso().
 * 
 *    Rev 1.33   16 Dec 1993 10:25:18   JOE
 * In tt_BBoxAndStats(), bump "tran_run_ct" by 2 for first run in case
 * we're starting in the middle of a run.
 * 
 *    Rev 1.32   08 Dec 1993 18:57:52   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.31   01 Dec 1993 09:24:16   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.30   30 Nov 1993 14:49:10   ROB
 * Add BIG5 support and TCA hooks.
 * 
 *    Rev 1.29   09 Nov 1993 10:33:54   MIKE
 * Support for UNICODE encoding in ttset_char().
 * 
 *    Rev 1.28   03 Nov 1993 18:11:12   MIKE
 * Fixed casting in ttload_DiskSfnt() to fix error when loading v. large fonts
 * 
 *    Rev 1.27   27 Oct 1993 19:48:32   MIKE
 * 
 * if MULTICALLER, call PCLchId2ptr() & PCLglyphID2Ptr() with callerID argumen
 * 
 *    Rev 1.26   26 Oct 1993 13:17:02   JOE
 * Conditionally compiling include statement for <unistd.h> based on SUN
 * instead of SPARC to resolve compiler error.
 * 
 *    Rev 1.25   20 Oct 1993 11:03:10   JOE
 * 
 * In tt_BBoxAndStats(), if NON_Z_WIND is enabled, added check to see if
 * it is being selected before executing NON_Z_WIND code.
 * 
 *    Rev 1.24   12 Oct 1993 09:52:16   MAIB
 * 
 * put in ansi defs to allow sparc compilation
 * 
 *    Rev 1.23   07 Oct 1993 19:11:52   MIKE
 * 
 * FONTBBOX changes: ttload_font() and ttget_Font_BBox(). BBox is in bucket.
 * 
 *    Rev 1.22   28 Sep 1993 14:30:22   JOE
 * Included "<unistd.h>" for SPARC to resolve compiler errors for SEEK_SET.
 * 
 *    Rev 1.21   24 Sep 1993 12:10:26   MIKE
 * Changes to load_font(), set_char(), GetSfntGlobalPtr(), GetSfntGlyphPtr().
 * Defined MSHUGE for DOS; restructured ROM loader; ROM1 support.
 * 
 *    Rev 1.20   24 Aug 1993 15:34:30   LISA
 * 
 * Made change for TrueType spotsize.
 * 
 *    Rev 1.19   19 Aug 1993 08:51:44   MAIB
 * Changed origin calculation to use devLeftSideBearing
 * 
 *    Rev 1.18   29 Jul 1993 12:27:28   AL
 * 
 * More nzw changes
 * 
 *    Rev 1.17   27 Jul 1993 12:37:08   AL
 * Non-zero winding changes
 * 
 *    Rev 1.16   16 Jul 1993 14:53:36   MAIB
 * now calculating character origin, not assuming at (0,0)
 * 
 *    Rev 1.15   08 Jul 1993 10:13:24   LISA
 * Incorporated TrueType spot size.
 * 
 *    Rev 1.14   01 Jul 1993 15:24:00   JOE
 * 
 * EUC KANJI support.
 * 
 *    Rev 1.13   10 Jun 1993 09:02:24   JOE
 * Changed all references to "char" to "SB8" for portability.
 * 
 *    Rev 1.12   24 May 1993 17:49:58   MIKE
 * Fix bug in PCLETTO part of tt_GetSfntGlyphPtr() by substracting 4 from the
 * glyph length.
 * 
 *    Rev 1.11   24 May 1993 13:29:00   JOE
 * In ttget_width() and ttmake_gaso_and_stats(), sace a few bytes of code
 * by conditionally compiling "nn = (int32)ttOutput->emResolution;".
 * 
 *    Rev 1.10   27 Apr 1993 15:49:32   ROB
 * Clean up compiler warnings.
 * 
 *    Rev 1.9   31 Mar 1993 11:03:28   MIKE
 * In set_plugin_bit_field() look for either PCLT or OS_2 tables.
 * 
 *    Rev 1.8   29 Mar 1993 11:03:18   ROB
 * Changes for Kanji support - break out into separate file (ttkan.c).
 * 
 *    Rev 1.7   11 Mar 1993 15:07:44   MAIB
 * Initial changes to support Asian character encoding (TrueType 1st pass)
 * 
 *    Rev 1.6   12 Feb 1993 16:12:56   JOE
 * VXWorks support.
 * 
 *    Rev 1.5   05 Feb 1993 12:02:32   MIKE
 * Add new function ttget_FontBBox() to support CGIFbound_box()
 * 
 *    Rev 1.4   04 Feb 1993 14:01:42   JOE
 * In ttget_width(), compensate for rounding when TT is converted to
 * 8782-based.
 * 
 *    Rev 1.3   29 Jan 1993 09:32:26   JOE
 * In ttget_width() and ttmake_gaso_and_stats(), saved em box size and
 * escapement in either native design units or 8782's based on
 * DU_ESCAPEMENT.
 * 
 *    Rev 1.2   15 Jan 1993 09:50:48   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:51:50   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:16:34   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:24 $ */
/*
 *  Module to call TrueType interpreter through UFST interface
 *
 *
 *
 *
 *  21-Jan-92  mby  created
 *  05-Feb-92  jfd  Moved "sfnt.h" before "fnt.h"
 *  07-Feb-92  rs   Conditionalize entire file.
 *  11-Feb-92  mby  return ct_loop = 0 if space char in tt_BBoxAndStats()
 *  14-Feb-92  mby  set bits in bucket for plugin fonts
 *  04-Mar-92  mby  in ttset_char() added code to map PCL codes to Microsoft
 *                  Unicode (and PostScript names too). See charmap.c
 *  16-Mar-92  ss   Port to SPARC.
 *  17-Mar-92  mby  "Depointerize" code. Make allocated memory
 *                  handle-based rather than pointer-based.
 *  25-Mar-92  mby  Eliminated MSC60 W3s!!
 *  26-Mar-92  ss   Fixed arg in !LINT_ARGS prototype for tt_freemem().
 *  21-May-92  jfd  Changed function prototype and call for ras_start_char()
 *                  so that first argument is a PVOID.
 *  04-Jun-92  jfd  Added external "olstats" (gets passed to "start_char()").
 *                  In ttrender(), when calling "start_char()", pass
 *                  "&olstats".
 *                  The following name changes were made to fields which had
 *                  belonged to the old CHAR_STATS structure and which are
 *                  now a part of the new CHAR_STATS which combines parts of
 *                  OLSTATS and parts of CHAR_STATS:
 *                     ct_loop --> nloop
 *                     x0_pix  --> xscale
 *                     y0_pix  --> yscale
 *                  In tt_BBoxAndStats(), wherever "pcs->" is loaded, load
 *                  the same info in "olstats".
 *                  Added routine "estimate_tt_outline()" to estimate size
 *                  of outline requested.
 *  08-Jun-92  jfd  Removed all references to "olstats".
 *                  In ttrender(), check return status from
 *                  "ras_start_char()".
 *  09-Jun-92  jfd  In ttmake_gaso_and_stats(), initialize "pcs->dorigin"
 *                  to 0.
 * 1-10 Jun-92 mby  New code to handle PCLEOs; new way of handling
 *                  disk-based files. Rework ttload_char(), ttset_char(),
 *                  ttunload_char(), tt_GetSfntFragmentPtr(), and
 *                  tt_ReleaseSfntFragment(). Add ttload_DiskSfnt(),
 *                  tt_GetXSfntGlyphPtr(), tt_RelXSfntGlyphPtr()
 *                  Rename load_failure() to unload_memory().
 *  10-Jun-92  jfd  In ttmake_gaso_and_stats(), load "pcs->xscale" and
 *                  "pcs->yscale" with "if_state.x.pixel_size" and
 *                  "if_state.y.pixel_size".
 *  12-Jun-92  ss   Added !LINT_ARGS case for ttload_DiskSfnt() definition.
 *                  Conditional compile fopen call for MSC with "+b"
 *  19-Jun-92  rs   Changed 'MSC' to 'MSDOS'.
 *  21-Jun-92  awr  Changed calls to output functions
 *  22-Jun-92  jfd  Changed last two arguments for "ttrender()" from SL32 
 *                  to INTR.
 *  24-Jun-92  mby  Merged my changes with awr & jfd's.
 *                  ttload_font: with a PCLEO set ->platformID to 0xffff,
 *                    otherwise the Font Scaler tries to read cmap table.
 *                    In bucket init baseGlyphID to 0xffff.
 *                  ttset_char: save baseGlyphID, baseGlyphPtr, and
 *                    baseGlyphLen in bucket.
 *                  ttmake_gaso_and_stats: turn off glyph ID matching after
 *                    fs_ContourScan()
 *                  tt_GetMSfntGlyphPtr() OK for simp chars; compound not yet.
 *  28-Jun-92  awr  Changed ttrender() for 16bit scan conversion
 *  29-Jun-92  awr  Merged all versions of estimate_outline()
 *  01-Jul-92  mby  Implement PCLEO compound characters. GetMSfntGlyphPtr()
 *                  calls application-provided function that returns glyph
 *                  pointer from the glyph ID number.
 *                  Merged with awr version 6-29.
 *  06-Jul-92  jfd  Added "ttget_width()" function. (Disabled for now.)
 *  06-Jul-92  mby  Moved error codes to cgif.h
 *                  Removed PCLEO-dependent code in tt_GetSfntFragmentPtr().
 *                  Merged with jfd 7/6 change.
 *  07-Jul-92  mby  Implemented ttget_width() with call to fs_GetDesignWidth()
 *  08-Jul-92  rs   Change 'GET_$...' to 'GET_x...', could not compile with
 *                  BCC.
 *  10-Jul-92  jfd  In ttrender(), if quadratic is requested but not 
 *                  installed, return error.
 *                  If linear is requested but not installed, return error.
 *                  If cubic is requested but not installed, return error.
 *  20-Jul-92  mby  New function tt_GetSfntGlyphPtr() to handle disk, PCLEO,
 *                  or ROM fonts. Replaces GetM... and GetH... functions.
 *                  Remove TT_PCLEOI conditional code from make_gaso_and_stats().
 *  21-Jul-92  mby  Allow any combination of at least one of
 *                  TT_DISK, TT_ROM, TT_PCLEOI as set in cgconfig.h
 *                  Add ROM code to tt_GetSfntGlobalFragment().
 *  22-Jul-92  mby  Add new function ttload_ROMSfnt().
 *                  Fix bug that didn't deallocate global memory buffer
 *                  if ttload_font aborted. Conditionalize code depending on
 *                  TT_DISK, TT_ROM, TT_PCLEOI
 *  11-Aug-92  mby  Optimization: in ttrender() declared function pointers
 *                  to if_state.out.quadto and ...lineto as local variables.
 *                  Declared variables as ints for theoretical efficiency
 *                  on 32-bit machines.
 *  08-Sep-92  jfd  Removed function prototypes for cm_ixToPSName()
 *                  (never called).
 *  28-Sep-92  awr  Changed BUCKET.media to BUCKET.rom_font
 *  09 Oct-92  mby  load_font() sets platform & specific ID from info in bucket.
 *                  Removed call to cm_ixToTTCode() in ttset_char().
 *                  Added #include "sym.h".
 *  13-Oct-92  mby  ttload_font should not set PBUCKET->pathname.
 *  15-Oct-92  mby  ttload_font initializes BUCKET.p.tt.TTfc (FONTCONTEXT).
 *  20-Oct-92  mby  Added casts to all SWAPx() macros.
 *  26-Oct-92  mby  Fix mirrored compound char problem. In ttrender(),
 *                  start_loop() should not always use argument BLACK_ON_RIGHT.
 *                  Instead check "ttOutput->contourPolarity[]" to detect
 *                  loop polarity reversal.
 *  06-Nov-92  mby  [Disk fonts] Test fseek() and fread() calls for error in
 *                  tt_GetSfntGlyphPtr() and ttload_DiskSFNT().
 *                  In set_char(), return ERR_no_cgnum if SYMmap() returns 0.
 *  10-Nov-92  jfd  In ttload_DiskSfnt(), changed conditional compile for
 *                  fopen() call to "if defined(MSDOS) || defined(__i960))
 *  20-Nov-92  mby  Fixed bug where disk files weren't getting fclose()'ed
 *                  if ttload_font() failed. Moved fclose() out of
 *                  ttunload_font() to unload_memory().
 *  23-Nov-92  jfd  In ttmake_gaso_and_stats(), when calculating escapement,
 *                  cast operands as long if necessary.
 *  23-Nov-92  mby  Make same change in ttget_width().
 *  23-Nov-92  rs   Fix ttload_DiskSfnt() fopen() call for all non-unix systems.
 *  30-Nov-92  jfd  Port to Mac - ANSI function definitions using ANSI_DEFS
 *  25-Jan-93  jfd  In ttget_width() and ttmake_gaso_and_stats(), store
 *                  escapement in either 8782 units per em or in native
 *                  design units based on DU_ESCAPEMENT.
 *  04-Feb-93  jfd  In ttget_width(), compensate for rounding when TT is 
 *                  converted to 8782-based.
 *  04-Feb-93  mby  Add ttget_FontBBox() function. Support routine for CGIFbound_box().
 *  08-Feb-93  jfd  VXWorks support.
 *  10-Mar-93  rs   Modify ttset_char() to not call SYMmap() if using
 *                  JIS or shift JIS mapping, just use the chID directly.
 *                  Of course it must be swapped on Intel. Include 'kanji.h'.
 *  25-Mar-93  mby  In set_plugin_bit_field() look for either PCLT or OS_2 table.
 *  28-Mar-93  rs   Changes to support Kanji half width Kana (1 byte codes).
 *  27-Apr-93  rs   Clean up compiler warnings.
 *  21-May-93  mby  In ttget_width() and ttmake_gaso_and_stats(), save a few
 *                  bytes of code by conditionally compiling
 *                  "nn = (int32)ttOutput->emResolution;"
 *  24-May-93  mby  Fix bug in PCLETTO part of tt_GetSfntGlyphPtr() by
 *                  subtracting 4 from the glyph length.
 *  10-Jun-93  jfd  Changed all references to "char" to "SB8" for portability.
 *  30-Jun-93 jfd/gy EUC KANJI support.
 *  16-Jul-93  maib changed how the character origin is calculated
 *  25-Jul-93  awr  Added error checking in ttrender().  Fixed logic
 *                  problem: when last, first & second pts are off contour.
 *                  Added computation for tran_run_ct for nz winding fill.
 *  19-Aug-93  maib Changed origin calculation to use devLeftSideBearing
 *                  rather than leftSideBearing
 *  24-Aug-93 my/lk Added Truetype spot size to set_trans.
 *  22-Sep-93  mby  Changes to load_font(), set_char(), GetSfntGlobalPtr(), GetSfntGlyphPtr()
 *                  Defined MSHUGE for DOS systems.
 *                  Restructured ROM font loader; ROM1 support.
 *  28-Sep-93  jfd  Included "<unistd.h>" for SPARC to resolve compiler
 *                  errors.
 *  05-Oct-93  mby  FONTBBOX changes: ttload_font() puts font bbox in bucket.
 *                  ttget_FontBBox() gets bbox from bucket instead of fs_GetFontBBox().
 *  10-Oct-93 maib  Added ansi def checks around ttget_FontBBox
 *  20-Oct-93 jfd   In tt_BBoxAndStats(), if NON_Z_WIND is enabled,
 *                  added check to see if it is being selected before
 *                  executing NON_Z_WIND code.
 *  26-Oct-93  jfd  Conditionally compiling include statement for <unistd.h>
 *                  based on SUN instead of SPARC to resolve compiler error.
 *  27-Oct-93  mby  if MULTICALLER enabled, call PCLchId2ptr() and
 *                  PCLglyphID2Ptr() with callerID argument.
 *                  Declare uLastCallerId EXTERNAL.
 *  03-Nov-93  mby  Fix casting in ttload_DiskSfnt to fix loading error in
 *                  very large TT fonts.
 *  09-Nov-92  my/gy  Support for UNICODE encoding in ttset_char().
 *  01-Dec-93  jfd  Changed KANJI_ENCODING to ASIAN_ENCODING.
 *  08-Dec-93  rs   General cleanup - MSDOS & FLAT -> CGFLAT32.
 *  16-Dec-93  jfd/jc In tt_BBoxAndStats(),  bump "tran_run_ct" by 2 for
 *                  first run in case we're starting in the middle of a run.
 *  16-Dec-93  mby  Add debugging print code to make_gaso - set DEBUG & UDEBUG.
 *                  Must also set UDEBUG in fontscal.c.
 *                  Fixed character origin in make_gaso. (1)Use leftSideBearing,
 *                  not devLeftSideBearing. (2)Must also adjust pcs->origin.y  5 days!!
 *  05-Jan-94  rs   Add support for "GB" encoding.
 *  31-Jan-94  jfd  Replaced I/O calls with macros (OPEN, LSEEK, READF and
 *                  CLOSE) in ttload_DiskSfnt(), tt_GetSfntGlyphPtr() and
 *                  unload_memory().
 *                  In ttset_char(), fixed bug with zero glyphid.
 *  02-Feb-94  jfd  In ttrender(), save previous x,y points in if_state.
 *                  Conditionally compile "io.h" based on MSDOS || OS2.
 *  04-Feb-94  jfd  Conditionally compiled "fcntl.h" based on (!defined(_AM29K)
 *                  || (defined(AM29K) && !defined(UNIX))).
 *                  Including "hif.h" if _AM29K.
 *  18-Feb-94  maib Return status set by ttkanset_char() if an error exists
 *  28-Mar-94  jfd  In ttload_DiskSfnt(), replaced macro call OPEN with
 *                  call to IXopen_file() so that number of open files
 *                  will be updated properly.
 *                  In unload_memory(), replaced macro call CLOSE with
 *                  call to IXclose_file()  for the same reason.
 *  22-Apr-94  jfd  Changed conditional compile statement prior to
 *                  including <hif.h> to #if (_AM29K && !SUN) to
 *                  resolve UNIX Metaware compiler error.
 *                  Changed 'UNIX' to 'SUN' within conditional compile 
 *                  statement prior to including <fcntl.h>.
 *  06-May-94  mby  Changed ttget_FontBBox() to expand the TT font bbox by
 *                  about 3% on all sides to cover "rogue" characters that
 *                  expand outside of their bounding box. This is to fix
 *                  CGIFbound_box() bugs.
 *  10-May-94  jfd  If MIPS, include <unistd.h>.
 *  20-Jun-94  jfd  In ttload_DiskSfnt(), if __i960, break up READF
 *                  call into multiple calls if byte count exceeds
 *                  996 bytes due to limitation with i960 compiler.
 *  22-Sep-94  mby  Removed MSHUGE to fix error with ANSI compiler.
 *  11-Dec-94  mby  In ttmake_gaso_and_stats() cast pcs->origin to SL32;
 *                  Added 4 four bounding box arguments to fs_FindCharBearings().
 *  18-Mar-95  jfd  In ttset_char(), added support for the removal of 
 *                  symbol set mapping.
 *                  Removed function prototype for cm_cgidToIndex() because
 *                  it is not referenced in this module.
 */

/*
   ** TO DO **      We really shouldn't leave open TT files lying around.
                    ttload_font() should always close the TT file.
                    tt_GetSfntGlyphPtr() will call fopen, fseek, fread,
                    and fclose, when it needs character data.
 */


#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <setjmp.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(SUN)))
#include <fcntl.h>
#endif

#if (defined(_AM29K) && !defined(SUN))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined(MSDOS) || defined(__OS2__)
#include <io.h>
#endif

#include <stdio.h>
#include <string.h>

#if defined(SUN) || defined(MIPS)
#include <unistd.h>
#endif

#if TT_RDR  /* conditionalize entire file */

#include "port.h"
#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "cgif.h"
#include "ix.h"
#include "sym.h"
#include "if_type.h"    /* used in ttmake_gaso...() and ttrender()  */
#include "pcleo.h"
#include "cgmacros.h"

#include "fscdefs.h"
#include "ttpcleo.h"
#include "fserror.h"
#include "fontscal.h"
#include "fontmath.h"
#include "sfnt.h"
#include "fnt.h"
#include "sc.h"
#include "fsglue.h"
#if TT_ROM1
#include "ttroment.h"
#endif

#if ASIAN_ENCODING     /* 3/11/93 maib */
#include "kanji.h"  /* add 3/10/93 - rs */
#endif

#if 0
#define TTDEBUG
#define TTDEBUG1
#endif

#define  FONT_TYPE_DISK      1
#define  FONT_TYPE_EXTERN    2
#define  FONT_TYPE_ROM       3
#define  FONT_TYPE_ROM1      4

#define  BLACK_ON_RIGHT      0          /* polarity code for start_char() */
#define  BLACK_ON_LEFT       1
#define  IFDESIGNUNITS       8782


#ifdef LINT_ARGS
GLOBAL UW16  ttload_font( PFONT_DES, PBUCKET );
GLOBAL UW16  ttunload_font( PBUCKET );
GLOBAL UW16  ttset_trans( PBUCKET, SL32, SL32, SL32, SL32 );
GLOBAL UW16  ttset_char( PBUCKET, UW16 );
GLOBAL UW16  ttmake_gaso_and_stats( PBUCKET, PCHAR_STATS );
GLOBAL UW16  ttrender( PBUCKET, INTR, INTR );
#if WIDTHS
GLOBAL UW16  ttget_width( PBUCKET );
#endif /* WIDTHS */
#if FONTBBOX
GLOBAL UW16  ttget_FontBBox( PBUCKET, BBoxRes* );
#endif  /* FONTBBOX */

MLOCAL VOID  tt_BBoxAndStats( fs_GlyphInfoType*, PCHAR_STATS );
GLOBAL MEM_HANDLE  tt_allocmem( uint32 );
GLOBAL VOID  tt_freemem( MEM_HANDLE );
MLOCAL GetSFNTFunc      tt_GetSfntGlobalFragment( voidPtr, long, long );
MLOCAL ReleaseSFNTFunc  tt_RelSfntGlobalFragment( void );
MLOCAL voidPtr tt_GetSfntGlyphPtr (voidPtr, uint16, uint32, uint32*, PMEM_HANDLE);
MLOCAL void    tt_RelSfntGlyphPtr(MEM_HANDLE);

#if TT_PCLEOI
#if !MULTICALLER
EXTERN LPUB8 PCLchId2ptr (UW16);
EXTERN LPUB8 PCLglyphID2Ptr( UW16 );
#else   /* Multicaller is enabled */
EXTERN LPUB8 PCLchId2ptr( UW16, UW16 );
EXTERN LPUB8 PCLglyphID2Ptr( UW16, UW16 );
#endif  /* MULTICALLER */
#endif  /* TT_PCLEOI */

#if TT_DISK
MLOCAL UW16  ttload_DiskSfnt( SB8*, PBUCKET );
#endif
#if TT_ROM
MLOCAL UW16  ttload_ROMEntity( LPUB8, PBUCKET );
#endif
#if (TT_ROM1 || TT_ROM)
GLOBAL int  ttload_ROMSfnt( PBUCKET );
#endif
#if (TT_DISK || TT_ROM)
MLOCAL VOID  set_plugin_bit_field(fs_GlyphInputType*, SW16*, uint16);
#endif
MLOCAL VOID  unload_memory ( PBUCKET, fs_GlyphInputType* , int );
EXTERN UW16  cm_cgidToIndex(UW16);
EXTERN MEM_HANDLE BUFalloc(SL32);               /* bucket.c */
EXTERN VOID       BUFfree(MEM_HANDLE);

#if ASIAN_ENCODING
GLOBAL UW16  ttkanset_char (PBUCKET b, UW16 chId, fs_GlyphInputType *ttInput);
#endif

#if !ROM
EXTERN VOID       IXclose_file(PBUCKET);
EXTERN UW16       IXopen_file(PINDEX_ENTRY, PBUCKET);
#endif

#else /* !LINT_ARGS */
GLOBAL UW16  ttload_font( );
GLOBAL UW16  ttunload_font();
GLOBAL UW16  ttset_trans( );
GLOBAL UW16  ttset_char( );
GLOBAL UW16  ttmake_gaso_and_stats( );
GLOBAL UW16  ttrender( );
#if WIDTHS
GLOBAL UW16  ttget_width( );
#endif /* WIDTHS */
#if FONTBBOX
GLOBAL UW16  ttget_FontBBox();
#endif  /* FONTBBOX */

MLOCAL VOID  tt_BBoxAndStats( );
GLOBAL MEM_HANDLE  tt_allocmem( );
GLOBAL VOID  tt_freemem( );
MLOCAL GetSFNTFunc      tt_GetSfntGlobalFragment();
MLOCAL ReleaseSFNTFunc  tt_RelSfntGlobalFragment();
MLOCAL voidPtr tt_GetSfntGlyphPtr();
MLOCAL void    tt_RelSfntGlyphPtr();
#if TT_PCLEOI
EXTERN LPUB8 PCLchId2ptr();
EXTERN LPUB8 PCLglyphID2Ptr();
#endif  /* TT_PCLEOI */
#if TT_DISK
MLOCAL UW16  ttload_DiskSfnt( );
#endif
#if TT_ROM
MLOCAL UW16  ttload_ROMEntity();
#endif
#if (TT_ROM1 || TT_ROM)
GLOBAL int  ttload_ROMSfnt();
#endif
#if (TT_DISK || TT_ROM)
MLOCAL VOID  set_plugin_bit_field();
#endif
MLOCAL VOID  unload_memory();
EXTERN MEM_HANDLE BUFalloc( );
EXTERN VOID       BUFfree( );

#if ASIAN_ENCODING
GLOBAL UW16  ttkanset_char ();
#endif

#if !ROM
EXTERN VOID       IXclose_file();
EXTERN UW16       IXopen_file();
#endif

#endif /* LINT_ARGS */


/*****************************************************/
/*********                                   *********/
EXTERN IF_STATE if_state;
#if MULTICALLER         /* mby, 10/27/93 */
EXTERN  UW16  uLastCallerId;
#endif
/*********                                   *********/
/*****************************************************/


/*****************************************************
 *********                                   *********
 **                   TTLOAD_FONT                   **
 *********                                   *********
 *****************************************************
 *
 *  Open TrueType font file
 *  Allocate fs_GlyphInfoType & fs_GlyphInputType structures
 *  Put pathname in bucket or call special loader if external PCLETTO font
 *  Call fs_OpenFonts(); allocate memory
 *  Call fs_Initialize()
 *  In input data structure for Font Scaler, set pointers to
 *    tt_GetSfntGlobalFragment() and tt_RelSfntGlobalFrag().
 *    Set clientID, platformID, specificID.
 *    clientID is the pointer to the bucket. The bucket has some goodies
 *    that the font scaler needs later when it gets font data.
 *  Call fs_NewSfnt(); allocate more memory (font-specific)
 *  Set bucket number (normal-bold/serif-sans/roman-italic/fixed pitch)
 *    to the best of our ability
 *
 *  If fails, clean up the mess (free memory, close any open files);
 *    then return error code to UFST.
 */

#if defined (ANSI_DEFS)
GLOBAL UW16  ttload_font( PFONT_DES pFontDesc, PBUCKET pBkt )

#else 
GLOBAL UW16  
ttload_font( pFontDesc, pBkt )
   PFONT_DES pFontDesc;
   PBUCKET   pBkt;
#endif
{
int      font_type;
int32    fsError;
int      ii;
int      status;
fs_GlyphInputType *ttInput;
fs_GlyphInfoType  *ttOutput;

#if  !(TT_DISK || TT_ROM || TT_PCLEOI || TT_ROM1)
return ERR_TT_BADCONFIG;
#endif

/* Allocate memory for fs_GlyphInfoType, fs_GlyphInputType structures
 *   and a 3x3 transformation matrix.
 * The bucket has pointers to them in the TT private data.
 */
if ((pBkt->p.tt.buffInfo = tt_allocmem((uint32)sizeof(fs_GlyphInfoType))) == 0)
    return ERR_TT_MEMFAIL;
if ((pBkt->p.tt.buffInput = tt_allocmem((uint32)sizeof(fs_GlyphInputType))) == 0)
    {
    tt_freemem(pBkt->p.tt.buffInfo);
    return ERR_TT_MEMFAIL;
    }
if ((pBkt->p.tt.trMatrix = tt_allocmem((uint32)sizeof(transMatrix))) == 0)
    {
    tt_freemem(pBkt->p.tt.buffInput);
    tt_freemem(pBkt->p.tt.buffInfo);
    return ERR_TT_MEMFAIL;
    }

/*
 * Initialization
 */
ttInput = (fs_GlyphInputType *)MEMptr(pBkt->p.tt.buffInput);
ttOutput = (fs_GlyphInfoType *)MEMptr(pBkt->p.tt.buffInfo);
pBkt->p.tt.GlobalTTHndl = NIL_MH;

/* Determine font type -- disk based, ROM, or PCLEO */
    if (pBkt->rom_font)
    {
#if TT_ROM1
        if (pBkt->p.tt.entity1)
            font_type = FONT_TYPE_ROM1;
        else
#endif
            font_type = FONT_TYPE_ROM;
    }

    else if (pBkt->extern_font)
        font_type = FONT_TYPE_EXTERN;
    else
        font_type = FONT_TYPE_DISK;

ttInput->param.newsfnt.extern_font = 0;
switch (font_type)
    {
#if TT_DISK
    case FONT_TYPE_DISK:
        status = ttload_DiskSfnt( (SB8 *)pFontDesc, pBkt );
        break;
#endif  /* TT_DISK */

#if TT_ROM      /* ROM input enabled */
    case FONT_TYPE_ROM:
        status = ttload_ROMEntity( (LPUB8)pFontDesc, pBkt );
        break;
#endif  /* TT_ROM */

#if TT_ROM1
    case FONT_TYPE_ROM1:
        status = ttload_ROM1Entity( (LPUB8)pFontDesc, pBkt );
        break;
#endif  /* TT_ROM1 */

#if TT_PCLEOI   /* PCLETTO input enabled */
    case FONT_TYPE_EXTERN:
        ttInput->param.newsfnt.extern_font = 1;
        status = ttload_PCLEO( (LPUB8)pFontDesc, pBkt );
        break;
#endif  /* TT_PCLEOI */

    default:
        unload_memory (pBkt, ttInput, -1);
        return ERR_TT_BADCONFIG;
    }           /* switch (font_type) */

if (status != SUCCESS)
    {
    unload_memory (pBkt, ttInput, -1);
    return status;
    }

fsError = fs_OpenFonts (ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
    unload_memory (pBkt, ttInput, -1);
    return ERR_TT_FSOPEN;
    }

/* Allocate memory for memoryBases from first 3 elements of memorySizes. */
for (ii=KEY_PTR_BASE; ii<=SCAN_PTR_BASE; ii++)
    {
    if ((ttInput->memoryBases[ii] =
                  tt_allocmem((uint32)ttOutput->memorySizes[ii])) == 0)
        {
#ifdef TTDEBUG
        printf("Memory allocation failed, font scaler buffer %d\n", ii);
#endif
        unload_memory( pBkt, ttInput, ii-1 );
        return ERR_TT_MEMFAIL;
        }
    }

fsError = fs_Initialize (ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
    unload_memory( pBkt, ttInput, SCAN_PTR_BASE );
    return ERR_TT_FSINIT;
    }

/* Fill in required parts of fs_GlyphInputType structure.
 * Then call fs_NewSfnt() to set up new TrueType font and
 * make sure it is a valid font.
 */
ttInput->GetSfntFragmentPtr = (GetSFNTFunc)tt_GetSfntGlobalFragment;
ttInput->ReleaseSfntFrag = (ReleaseSFNTFunc)tt_RelSfntGlobalFragment;
ttInput->GetSfntGlyphPtr = tt_GetSfntGlyphPtr;
ttInput->RelSfntGlyphPtr = tt_RelSfntGlyphPtr;
ttInput->clientID = pBkt;
ttInput->param.newsfnt.platformID = pBkt->p.tt.platId;
ttInput->param.newsfnt.specificID = pBkt->p.tt.specId;
#if (TT_PCLEOI || TT_ROM1)
if (font_type == FONT_TYPE_EXTERN || font_type == FONT_TYPE_ROM1)
    ttInput->param.newsfnt.platformID = 0xffff;     /* Disables */
                       /* character mapping in the Font Scaler. */
#endif

fsError = fs_NewSfnt (ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
#ifdef TTDEBUG
    printf("Error %X: fs_NewSfnt\n", fsError);
#endif
    unload_memory( pBkt, ttInput, SCAN_PTR_BASE );
    return ERR_TT_FSNEWSFNT;
    }

/* Allocate two more memory blocks */
for (ii=WORK_SPACE_BASE; ii<=PRIVATE_FONT_SPACE_BASE; ii++)
    {
    if ((ttInput->memoryBases[ii] =
              tt_allocmem((uint32)ttOutput->memorySizes[ii])) == 0)
        {
#ifdef TTDEBUG
        printf("Memory allocation failed, font scaler buffer %d\n", ii);
#endif
        unload_memory( pBkt, ttInput, ii-1 );
        return ERR_TT_MEMFAIL;
        }
    }

#if FONTBBOX    /* font bbox is stored in bboxInfo by fs_NewSfnt() */
    pBkt->p.tt.emResolution = ttOutput->emResolution;
    pBkt->p.tt.FontBBox[0] = (SW16)ttOutput->bboxInfo.xMin;
    pBkt->p.tt.FontBBox[1] = (SW16)ttOutput->bboxInfo.yMin;
    pBkt->p.tt.FontBBox[2] = (SW16)ttOutput->bboxInfo.xMax;
    pBkt->p.tt.FontBBox[3] = (SW16)ttOutput->bboxInfo.yMax;
#endif
#if TT_PCLEOI
    pBkt->p.tt.baseGlyphID = 0xFFFF;    /* Initialize glyph ID != match. */
#endif

#if (TT_DISK || TT_ROM)         /* if disk or ROM type, call function */
#if (TT_PCLEOI || TT_ROM1)      /* to set up bits in pBkt->bucket_num */
if (font_type == FONT_TYPE_DISK || font_type == FONT_TYPE_ROM)
#endif
    set_plugin_bit_field(ttInput, &pBkt->bucket_num, ttOutput->emResolution);
#endif

#ifdef TTDEBUG
printf("ttload_font()\n");
#endif

#if TT_TTPLUG
pBkt->p.tt.TTfc.format = FC_IF_TYPE;    /* so that initial comparison will fail */
#endif

return SUCCESS;
}




/*****************************************************
 *********                                   *********
 **                  TTUNLOAD_FONT                  **
 *********                                   *********
 *****************************************************
 */

#if defined (ANSI_DEFS)
GLOBAL UW16  ttunload_font( PBUCKET pBkt )
#else 
GLOBAL UW16  
ttunload_font( pBkt )
   PBUCKET pBkt;
#endif
{
fs_GlyphInputType *ttInput;
fs_GlyphInfoType  *ttOutput;

ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput);
ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);
fs_CloseFonts(ttInput, ttOutput);

/* Free memory and close files for pBkt */
unload_memory (pBkt, ttInput, PRIVATE_FONT_SPACE_BASE);

return SUCCESS;
}




/******************************************************
 *********                                    *********
 **                    TTSET_CHAR                    **
 *********                                    *********
 ******************************************************
 *
 * Maps character code (chId) to the TrueType glyph ID.
 * This goes into the output data structure.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  ttset_char( PBUCKET pBkt, UW16 chId )
#else 
GLOBAL UW16  
ttset_char( pBkt, chId )
   PBUCKET pBkt;
   UW16   chId;
#endif
{
fs_GlyphInputType *ttInput;
fs_GlyphInfoType  *ttOutput;
int32  fsError;

ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput);
ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);

#if TT_PCLEOI   /* PCLEO input enabled */
if (pBkt->extern_font)     /* TrueType PCLEO */
    {
    PPCLETTO_CHR_HDR  pCharD;
    LPUB8 pByte;
#if !MULTICALLER        /* mby, 10/27/93 */
    if ((pCharD = (PPCLETTO_CHR_HDR)PCLchId2ptr(chId)) != NULL)
#else   /* Multicaller is enabled */
    if ((pCharD = (PPCLETTO_CHR_HDR)PCLchId2ptr(uLastCallerId, chId)) != NULL)
#endif  /* MULTICALLER */
        {
        pByte = (uint8 *)pCharD + pCharD->descriptorsize + 2;
        pBkt->p.tt.baseGlyphLen = GET_xWORD(pByte) - 4;
        pBkt->p.tt.baseGlyphID = GET_xWORD_OFF(pByte, 2);
        pBkt->p.tt.baseGlyphPtr = (uint8 *)pCharD + pCharD->descriptorsize + 6;
        ttInput->param.newglyph.glyphIndex = pBkt->p.tt.baseGlyphID;
        ttInput->param.newglyph.characterCode = NONVALID;
        }
    else
        return ERR_no_cgnum;
    }
  else                  /* disk or ROM font */
  {
#endif          /* TT_PCLEOI */

#if (TT_DISK || TT_ROM || TT_ROM1)

#if ASIAN_ENCODING     /* 3/11/93 maib */
    if (pBkt->cur_ssnum == JIS || pBkt->cur_ssnum == SHIFT_JIS
            || pBkt->cur_ssnum == EUC || pBkt->cur_ssnum == UNICODE
            || pBkt->cur_ssnum == BIG5 || pBkt->cur_ssnum == TCA
            || pBkt->cur_ssnum == GB  || pBkt->cur_ssnum == KSC
        )
    {
        UW16  status;
        if (status = ttkanset_char (pBkt, chId, ttInput))
            return status;
    }
    else
#endif /* ASIAN_ENCODING */

    {
#if TT_ROM1
        if (pBkt->p.tt.entity1)
        {
            ttInput->param.newglyph.glyphIndex = cve1_chIDtoIx(chId, pBkt);
            ttInput->param.newglyph.characterCode = NONVALID;
        }
        else
#endif
        {
#if NO_SYMSET_MAPPING
            if ( (ttInput->param.newglyph.characterCode =
                                chId) == 0 )
#else
            if ( (ttInput->param.newglyph.characterCode =
                                SYMmap(chId, FC_TT_TYPE)) == 0 )
#endif  /* NO_SYMSET_MAPPING */
                return ERR_no_cgnum;
        }
    }
#endif /* (TT_DISK || TT_ROM || TT_ROM1) */

#if TT_PCLEOI
  }
#endif

ttInput->clientID = pBkt;
fsError = fs_NewGlyph (ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
#ifdef TTDEBUG
    printf("Error %X: fs_NewGlyph\n", fsError);
#endif
    return ERR_no_cgnum;
    }

if ((ttOutput->glyphIndex == 0) && !pBkt->extern_font) /* JPK */  /* the "not found" glyph */
    return ERR_no_cgnum;

#ifdef TTDEBUG
    printf("ttset_char() OK\n");
#endif
return SUCCESS;
}




/*****************************************************
 *********                                   *********
 **                   TTSET_TRANS                   **
 *********                                   *********
 *****************************************************
 *
 * Passes font scaling information to the TrueType Font Scaler.
 *
 * The point size is set by default to 1.0 and the x and y device
 *   resolution to 72 dpi.
 * The m(i) values are a 2x2 transformation matrix from a "unit character"
 *   design space to output space. For example a matrix of
 *   [ 10 0  ] will produce a character 10 pixels high.
 *   [  0 10 ]
 * The m(i) are in 16.16 fixed point format.
 *
 * The 2x2 transformation matrix is expanded to an equivalent 3x3 matrix
 *   for use by the Font Scaler. There is a pointer to the 3x3 matrix
 *   in the TrueType part of the bucket.
 */
#define TT_POINTSIZENOM  (1L << 16)
#define TT_RESNOM        72

#if defined (ANSI_DEFS)
GLOBAL UW16  ttset_trans( PBUCKET pBkt, SL32 m0, SL32 m1, SL32 m2, SL32 m3 )
#else 
GLOBAL UW16  
ttset_trans( pBkt, m0, m1, m2, m3 )
   PBUCKET pBkt;
   SL32    m0, m1, m2, m3;
#endif
{
fs_GlyphInputType *ttInput;
fs_GlyphInfoType  *ttOutput;
int32 fsError;
Fixed*  m;

ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput);
ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);
m = (Fixed *) MEMptr(pBkt->p.tt.trMatrix);
m[0] = (Fixed) m0;
m[1] = (Fixed) m1;
m[3] = (Fixed) m2;
m[4] = (Fixed) m3;
m[2] = m[5] = m[6] = m[7] = 0;
m[8] = (Fixed) ONEFRAC;
ttInput->clientID = pBkt;
ttInput->param.newtrans.transformMatrix = pBkt->p.tt.trMatrix;
ttInput->param.newtrans.pointSize = TT_POINTSIZENOM;
ttInput->param.newtrans.xResolution = TT_RESNOM;
ttInput->param.newtrans.yResolution = TT_RESNOM;

if (pBkt->p.tt.spotsize == 0x10000L)
    ttInput->param.newtrans.pixelDiameter = FIXEDSQRT2;
else
    ttInput->param.newtrans.pixelDiameter = FIXEDSQRT2 + ((((pBkt->p.tt.spotsize - 0x10000L) * 239) + 84) / 169);

ttInput->param.newtrans.traceFunc = NULL;
fsError = fs_NewTransformation(ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
#ifdef TTDEBUG
    printf("Error %X: fs_NewTransformation\n", fsError);
#endif
    return ERR_TT_FSNEWTRANS;
    }
#ifdef TTDEBUG
    printf("fs_NewTransformation()\n");
#endif

return SUCCESS;
}
#undef  TT_POINTSIZENOM
#undef  TT_RESNOM



#if WIDTHS

/******************************************************
 *********                                    *********
 **                   TTGET_WIDTH                    **
 *********                                    *********
 ******************************************************
 *
 * Returns width in design units associated with character code (chId).
 *
 * Arguments: pBkt -- bucket info for desired character
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  ttget_width( PBUCKET pBkt )

#else 
GLOBAL UW16  ttget_width( pBkt )
  PBUCKET pBkt;
#endif

{
UW16  escapement;
#if !DU_ESCAPEMENT
UL32  nn;
#endif

fs_GlyphInputType *ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput);
fs_GlyphInfoType  *ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);
fs_GetDesignWidth(ttInput, ttOutput, 0);

  /* Store escapement in either native units or 8782/em  01-25-93 - jfd */

#if DU_ESCAPEMENT
if_state.cs.du_emx = (SW16)ttOutput->emResolution;
if_state.cs.du_emy = (SW16)ttOutput->emResolution;
escapement         = (UW16)ttOutput->metricInfo.escapement;
#else
nn = (int32)ttOutput->emResolution;
if_state.cs.du_emx = (SW16)IFDESIGNUNITS;
if_state.cs.du_emy = (SW16)IFDESIGNUNITS;
escapement         = (UW16)(((SL32)ttOutput->metricInfo.escapement *
                         (SL32)IFDESIGNUNITS + (nn >> 1)) / nn);

  /* Compensate for rounding when PS or TT is converted to 8782-based
     Multiply by TT or PS point size / Inteliifont point size
             = (1/72) / 0.01383 = 100,000/(72 * 1383)
             = 12500 / (9 * 1383) = 12500 / 12447     -ss,awr 8/20/92
  */
if( if_state.pbucket->fst_type == FC_TT_TYPE )
   escapement  = (UW16)( (((SL32)escapement * 12500L) + 6223L) / 12447L );


#endif  /* !DU_ESCAPEMENT */

if_state.cs.escapement = (SW16)escapement;

return escapement;
}
#endif  /* WIDTHS */




/*****************************************************
 *********                                   *********
 **              TTMAKE_GASO_AND_STATS              **
 *********                                   *********
 *****************************************************
 *
 * Make a grid-aligned, scaled outline for the current character
 * Arguments: pBkt -- pointers to TT Font Scaler structures
 *            pcs  -- character statistics placed here.
 *                    Parse gaso to obtain bounding box and count
 *                    loops, lines, and quads.
 *                    x0_pix, y0_pix are set to constant (6)
 *                    character origin is (0,0)
 */

#if defined (ANSI_DEFS)
GLOBAL UW16  ttmake_gaso_and_stats( PBUCKET pBkt, PCHAR_STATS pcs )
#else 
GLOBAL UW16  
ttmake_gaso_and_stats( pBkt, pcs )
   PBUCKET     pBkt;
   PCHAR_STATS pcs;
#endif
{
fs_GlyphInputType *ttInput;
fs_GlyphInfoType  *ttOutput;
int32 fsError;
#if !DU_ESCAPEMENT
int32 nn;
#endif


ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput);
ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);
ttInput->clientID = pBkt;
ttInput->param.gridfit.styleFunc = NULL;
ttInput->param.gridfit.traceFunc = NULL;

fsError = fs_ContourGridFit(ttInput, ttOutput);
if  (fsError != NO_ERR)
    {
#ifdef TTDEBUG
    printf("Error %X: fs_ContourGridFit\n", fsError);
#endif
    return ERR_TT_FSGRIDFIT;
    }
#if TT_PCLEOI
pBkt->p.tt.baseGlyphID = 0xFFFF;    /* Turn off glyph ID matching. */
#endif

tt_BBoxAndStats( ttOutput, pcs );

/*
 * 7/16/93 maib
 * calling this function to determine left side bearing, later
 * used to calculate the correct character origin.
 * 12-11-94 mby: Pass 4 bounding box arguments in output units.
 */
fsError = fs_FindCharBearings(ttInput, ttOutput,
              (int32)pcs->xmin, (int32)pcs->ymin, (int32)pcs->xmax, (int32)pcs->ymax);
if  (fsError != NO_ERR)
    {
#ifdef TTDEBUG
    printf("Error %X: fs_FindCharBearings\n", fsError);
#endif
    return ERR_TT_FSCHARBEARINGS;
    }

#if 0
pcs->xscale = pcs->yscale = fnt_pixelShift;     /* 6 bit shift */
#endif
pcs->xscale = if_state.x.pixel_size;
pcs->yscale = if_state.y.pixel_size;

    DBG1("  file: %s\n", pBkt->pathname);
#ifdef UDEBUG
    fs_GetCharBBox(ttInput, ttOutput);
    DBG4("  BBox design space: \{ %d %d %d %d \}\n",
         ttOutput->bboxInfo.xMin, ttOutput->bboxInfo.yMin,
         ttOutput->bboxInfo.xMax, ttOutput->bboxInfo.yMax);
#endif
    DBG4("  BBox pcs:          \{ %08lx %08lx %08lx %08lx \}\n",
         pcs->xmin << 10, pcs->ymin << 10,
         pcs->xmax << 10, pcs->ymax << 10);
    DBG2("  advanceWidth:           %08lx %08lx\n",
         ttOutput->metricInfo.advanceWidth.x, ttOutput->metricInfo.advanceWidth.y);
    DBG2("  devAdvanceWidth:        %08lx %08lx\n",
         ttOutput->metricInfo.devAdvanceWidth.x, ttOutput->metricInfo.devAdvanceWidth.y);
    DBG2("  leftSideBearing:        %08lx %08lx\n",
         ttOutput->metricInfo.leftSideBearing.x, ttOutput->metricInfo.leftSideBearing.y);
    DBG2("  devLeftSideBearing:     %08lx %08lx\n",
         ttOutput->metricInfo.devLeftSideBearing.x, ttOutput->metricInfo.devLeftSideBearing.y);
    DBG2("  leftSideBearingLine:    %08lx %08lx\n",
         ttOutput->metricInfo.leftSideBearingLine.x, ttOutput->metricInfo.leftSideBearingLine.y);
    DBG2("  devLeftSideBearingLine: %08lx %08lx\n",
         ttOutput->metricInfo.devLeftSideBearingLine.x, ttOutput->metricInfo.devLeftSideBearingLine.y);
    DBG2("  LEFTSIDEBEARING:        %08lx %08lx\n",
         ttOutput->xPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + LEFTSIDEBEARING],
         ttOutput->yPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + LEFTSIDEBEARING] );
    DBG2("  RIGHTSIDEBEARING:       %08lx %08lx\n",
         ttOutput->xPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + RIGHTSIDEBEARING],
         ttOutput->yPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + RIGHTSIDEBEARING] );
    DBG2("  ORIGINPOINT:            %08lx %08lx\n",
         ttOutput->xPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + ORIGINPOINT],
         ttOutput->yPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + ORIGINPOINT] );
    DBG2("  LEFTEDGEPOINT:          %08lx %08lx\n",
         ttOutput->xPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + LEFTEDGEPOINT],
         ttOutput->yPtr[ttOutput->endPtr[ttOutput->numberOfContours-1] + 1 + LEFTEDGEPOINT] );
/*
 * 7/16/93 maib
 * origin not assumed to be at (0,0), calculated by taking the minimum
 * x point found and subracting the left side bearing
 *
 * 12/16/93 mby
 * Subtract y left side bearing from ymax to handle rotations.
 * Use leftSideBearing, not devLeftSideBearing.
 */
pcs->origin_cs.x = (SL32)(pcs->xmin - (ttOutput->metricInfo.leftSideBearing.x >> 10));
pcs->origin_cs.y = (SL32)(pcs->ymax - (ttOutput->metricInfo.leftSideBearing.y >> 10));

pcs->dorigin.x = pcs->dorigin.y = 0;
fs_GetDesignWidth(ttInput, ttOutput, 1);

  /* Store escapement in either native units or 8782/em  01-25-93 - jfd */

#if DU_ESCAPEMENT
pcs->du_emx     = (SW16)ttOutput->emResolution;
pcs->du_emy     = (SW16)ttOutput->emResolution;
pcs->escapement = (UW16)ttOutput->metricInfo.escapement;
#else
nn = (int32)ttOutput->emResolution;
pcs->du_emx     = (SW16)IFDESIGNUNITS;
pcs->du_emy     = (SW16)IFDESIGNUNITS;
pcs->escapement = (UW16)(((SL32)ttOutput->metricInfo.escapement *
                         (SL32)IFDESIGNUNITS + (nn >> 1)) / nn);
#endif  /* !DU_ESCAPEMENT */


#ifdef TTDEBUG
    printf("ttmake_gaso_and_stats() OK\n");
#endif
return SUCCESS;
}


#if defined (ANSI_DEFS)
MLOCAL VOID  tt_BBoxAndStats( fs_GlyphInfoType *ttOutput, PCHAR_STATS pcs )
#else 
MLOCAL VOID  
tt_BBoxAndStats( ttOutput, pcs )
   fs_GlyphInfoType *ttOutput;
   PCHAR_STATS       pcs;
#endif
{
/*
 * Returns character bounding box in output units; counts number of loops,
 * lines and quadratic Beziers. The bounding box uses the Bezier control
 * points and therefore must contain the outline, but may be larger.
 */
uint16   ctr;
int      thisPoint, endPoint, startPoint;
int      firstTime = true;
register F26Dot6  xmin, xmax, ymin, ymax;
register F26Dot6  tx, ty;
register F26Dot6 *xx, *yy;
register uint8   *onC;
register uint8    prevOnC, thisOnC;
#if NON_Z_WIND
int     y_goes_up;
F26Dot6 firstY;
F26Dot6 yprev;
#endif

pcs->ct_lineto = pcs->ct_quadto = pcs->ct_cubeto = 0;
if (!ttOutput->outlinesExist)
    {                           /* no outline data ==> space char */
    pcs->nloop = 0;
    pcs->xmin = pcs->ymin = pcs->xmax = pcs->ymax = 0;  /* may not need to do this */
    return;
    }

#if NON_Z_WIND
pcs->tran_run_ct = 0;
#endif

for (ctr = 0; ctr < ttOutput->numberOfContours; ctr++)
    {
    endPoint = ttOutput->endPtr[ctr];
    startPoint = ttOutput->startPtr[ctr];
    xx = &(ttOutput->xPtr[startPoint]);
    yy = &(ttOutput->yPtr[startPoint]);
    onC = &(ttOutput->onCurve[startPoint]);
    if (startPoint == endPoint) 
        continue; /* We need to do this for anchor points for composites */
    if (firstTime)
        {
        xmin = xmax = *xx;
        ymin = ymax = *yy;
        firstTime = false;
        }

#if NON_Z_WIND
    if (if_state.non_z_wind)
    {

    yprev = firstY = *yy;
    pcs->tran_run_ct += 2; /*  bump for first tran run and add an extra
                            *  in case we're starting in the middle of a
                            *  run.
                            */
    y_goes_up = (firstY <= *(yy+1));

    }
#endif

    prevOnC = (ttOutput->onCurve[endPoint] & (uint8)1);
    for (thisPoint = startPoint; thisPoint <= endPoint; thisPoint++)
        {
        tx = *xx++;
        ty = *yy++;
        if (tx > xmax)
            xmax = tx;
        else if (tx < xmin)
            xmin = tx;
        if (ty > ymax)
            ymax = ty;
        else if (ty < ymin)
            ymin = ty;

        thisOnC = ((*onC++) & (uint8)1);
        if (!prevOnC)
            ++pcs->ct_quadto;
        else if (thisOnC)
            ++pcs->ct_lineto;
        prevOnC = thisOnC;

#if NON_Z_WIND
    if (if_state.non_z_wind)
    {
        if((y_goes_up && (yprev > ty)) || (!y_goes_up && (yprev < ty)))
            {
            ++pcs->tran_run_ct;
            y_goes_up = !y_goes_up;
            }
        yprev = ty;

     }
#endif

        }  /* for each point in contour */
#if NON_Z_WIND
    if (if_state.non_z_wind)
    {

    if((y_goes_up && (yprev > firstY)) || (!y_goes_up && (yprev < firstY)))
        ++pcs->tran_run_ct;

    }
#endif

    }
pcs->nloop = ctr;             /* number of contours */
pcs->xmin = (SL32)xmin;  pcs->ymin = (SL32)ymin;
pcs->xmax = (SL32)xmax;  pcs->ymax = (SL32)ymax;
}







/******************************************************
 *********                                    *********
 **                     TTRENDER                     **
 *********                                    *********
 ******************************************************
 *
 * Parses the gaso and calls the output processing functions.
 *
 * Arguments: pBkt -- pointers to structures containing gaso
 *            xoffset, yoffset -- offset from character origin to upper
 *                                left corner of the character in fops.
 */
#if INTR_SIZE == 16
#define rs(v)    (INTR)((v) >> if_state.right_shift)
#else
#define rs(v)    (INTR)(v)
#endif

#define MOVETO(x, y)   {status = if_state.out.moveto(rs(x), rs(y)); \
                       if(status) return status;}
#define LINETO(x, y)   {status = if_state.out.lineto(rs(x), rs(y)); \
                       if(status) return status;}
#define QUADTO(px, py, x, y) {status = if_state.out.quadto(rs(px), rs(py), \
                                                           rs(x), rs(y)); \
                             if (status) return (status);}
#define SPLINETO(px, py, x, y) {status = if_state.out.quadto(rs(px), rs(py), \
                                          rs((px+x)>>1), rs((py+y)>>1)); \
                             if (status) return (status);}

#if defined (ANSI_DEFS)
GLOBAL UW16  ttrender( PBUCKET pBkt, INTR xoffset, INTR yoffset )
#else 
GLOBAL UW16
ttrender( pBkt, xoffset, yoffset )
   PBUCKET pBkt;
   INTR    xoffset, yoffset;
#endif
{
/* fs_GlyphInputType *ttInput; */
fs_GlyphInfoType  *ttOutput;
int      ctr;
int      thisPoint, endPoint, startPoint;
F26Dot6  firstX, firstY, secondX, secondY;
register F26Dot6  prX, prY;
register F26Dot6  tx, ty;
register F26Dot6 *xx, *yy;
register uint8   *onC;
register int      prevOnC, thisOnC;
int      firstOnC, secondOnC;
UW16     status;
UW16     polarity;

#if 0
#if defined (ANSI_DEFS)
register UW16  (*r_quadto) (INTR, INTR, INTR, INTR) = if_state.out.quadto;
#else
register UW16  (*r_quadto) () = if_state.out.quadto;
#endif 
#endif


/* ttInput = (fs_GlyphInputType *) MEMptr(pBkt->p.tt.buffInput); */
ttOutput = (fs_GlyphInfoType *) MEMptr(pBkt->p.tt.buffInfo);
#ifdef TTDEBUG
    printf("ttrender() begins\n");
#endif

   /* Make certain that output format is valid for TT */

#if !LINEAR
   if (if_state.cs.format == FC_LINEAR_TYPE)
      return ERR_linear_not_installed;
#endif
#if !CUBIC
   if (if_state.cs.format == FC_CUBIC_TYPE)
      return ERR_cubic_not_installed;
#endif
#if !QUADRA
   if (if_state.cs.format == FC_QUAD_TYPE)
      return ERR_quadratic_not_installed;
#endif

status = if_state.out.start_char((PVOID)&if_state.cs);
if (status)
   return (status);
for (ctr = 0; ctr < (int)ttOutput->numberOfContours; ctr++)
    {
    endPoint = ttOutput->endPtr[ctr];
    startPoint = ttOutput->startPtr[ctr];
    xx = &(ttOutput->xPtr[startPoint]);
    yy = &(ttOutput->yPtr[startPoint]);
    onC = &(ttOutput->onCurve[startPoint]);
    if (startPoint == endPoint) 
        continue; /* We need to do this for anchor points for composites */

    if (!ttOutput->contourPolarity[ctr])    /* standard filled region is */
        polarity = BLACK_ON_RIGHT;          /* on the right */
    else                                    /* mirrored */
        polarity = BLACK_ON_LEFT;

    status = if_state.out.start_loop(polarity);
    if(status)
        return status;
/*
 * Save the first (and second) point(s). Call moveto()
 * If the low bit of *onC is set, the point is on the curve.
 * If there are 2 consecutive off-curve points, interpolate an on-curve
 * point at the midpoint.
 */
    firstOnC = (int)((*onC++) & 1);
    firstX = *xx++ + xoffset;  firstY = *yy++ + yoffset;
    if (firstOnC)
        {
        MOVETO(firstX, firstY)
        thisPoint = startPoint + 1;
        prevOnC = firstOnC;
        if_state.p0.x = rs(firstX); /* previous x must be saved JPK */
        if_state.p0.y = rs(firstY); /* previous y must be saved JPK */
        }
    else        /* It IS possible for the 1st point to be off-curve. */
        {
        secondOnC = (int)((*onC++) & 1);
        secondX = *xx++ + xoffset;  secondY = *yy++ + yoffset;
        prevOnC = secondOnC;
        thisPoint = startPoint + 2;
        if (secondOnC)
            {
            MOVETO(secondX, secondY)
            if_state.p0.x = rs(secondX); /* previous x must be saved JPK */
            if_state.p0.y = rs(secondY); /* previous y must be saved JPK */
            }
        else
            {
            MOVETO((firstX + secondX) >> 1, (firstY + secondY) >> 1)
            prX = secondX;  prY = secondY;
            if_state.p0.x = rs(((firstX + secondX) >> 1)); /* previous x must be saved JPK */
            if_state.p0.y = rs(((firstY + secondY) >> 1)); /* previous y must be saved JPK */
            }
        }
    for ( ; thisPoint <= endPoint; thisPoint++)
        {
        tx = *xx++ + xoffset;
        ty = *yy++ + yoffset;
        thisOnC = (int)((*onC++) & 1);
        if (!prevOnC)
            {
            if (thisOnC)
                {
                QUADTO(prX, prY, tx, ty)
                if_state.p0.x = rs(tx); /* previous x must be saved JPK */
                if_state.p0.y = rs(ty); /* previous y must be saved JPK */
                }
            else
                {
                SPLINETO(prX, prY, tx, ty)
                if_state.p0.x = rs(((tx+prX) >> 1)); /* previous x must be saved JPK */
                if_state.p0.y = rs(((ty+prY) >> 1)); /* previous y must be saved JPK */
                }
            }
        else
            {
            if (thisOnC)
                {
                LINETO(tx, ty)
                if_state.p0.x = rs(tx); /* previous x must be saved JPK */
                if_state.p0.y = rs(ty); /* previous y must be saved JPK */
                }
            }
        prevOnC = thisOnC;
        prX = tx;  prY = ty;
        }   /* for ( ; thisPoint <= endPoint; thisPoint++) */

    if (firstOnC)
        {
        if (prevOnC)
            {
            LINETO(firstX, firstY)
            if_state.p0.x = rs(firstX); /* previous x must be saved JPK */
            if_state.p0.y = rs(firstY); /* previous y must be saved JPK */
            }
        else
            {
            QUADTO(prX, prY, firstX, firstY)
            if_state.p0.x = rs(firstX); /* previous x must be saved JPK */
            if_state.p0.y = rs(firstY); /* previous y must be saved JPK */
            }
        }
    else
        {
        if(!prevOnC)
            {
            SPLINETO(prX, prY, firstX, firstY)
            if_state.p0.x = rs(((firstX + prX) >> 1)); /* previous x must be saved JPK */
            if_state.p0.y = rs(((firstY + prY) >> 1)); /* previous y must be saved JPK */
            }
        if (secondOnC)
            {
            QUADTO(firstX, firstY, secondX, secondY)
            if_state.p0.x = rs(secondX); /* previous x must be saved JPK */
            if_state.p0.y = rs(secondY); /* previous y must be saved JPK */
            }
        else
            {
            SPLINETO(firstX, firstY, secondX, secondY)
            if_state.p0.x = rs(((firstX + secondX) >> 1)); /* previous x must be saved JPK */
            if_state.p0.y = rs(((firstY + secondY) >> 1)); /* previous y must be saved JPK */
            }
        }
    status = if_state.out.end_loop();
    if (status)
        return (status);

    }   /* for (ctr = 0; ctr < ttOutput->numberOfContours; ctr++) */

#ifdef TTDEBUG
    printf("ttrender() ends\n");
#endif

return if_state.out.end_char();
}



#if FONTBBOX

/******************************************************
 *********                                    *********
 **                  TTGET_FONTBBOX                  **
 *********                                    *********
 ******************************************************
 *
 * Returns font bbox and design resolution.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16 ttget_FontBBox( PBUCKET pBucket, BBoxRes* basefont )
#else
GLOBAL UW16 ttget_FontBBox(pBucket, basefont)
  PBUCKET pBucket;
  BBoxRes* basefont;
#endif /* ANSI_DEFS */
{
    int ii;
    int fudge_factor[4];
    for (ii=0; ii<4; ii++)
        basefont->BBox[ii] = pBucket->p.tt.FontBBox[ii];
    basefont->emRes = pBucket->p.tt.emResolution;

    /* In some TrueType fonts the hints expand characters outside of their
     * bounding boxes proportionate to the point size. This blows away
     * the font bounding box at large sizes. To guard against this we
     * expand the font bounding box by about 3% on all four sides.
     * mby, 5-6-94   */
    fudge_factor[2] = (basefont->BBox[2] - basefont->BBox[0]) >> 5;
    fudge_factor[3] = (basefont->BBox[3] - basefont->BBox[1]) >> 5;
    fudge_factor[0] = -fudge_factor[2];
    fudge_factor[1] = -fudge_factor[3];
    for (ii=0; ii<4; ii++)
        basefont->BBox[ii] += fudge_factor[ii];

    return SUCCESS;
}
#endif  /* FONTBBOX */





#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE  tt_allocmem( uint32 m )
#else 
GLOBAL MEM_HANDLE 
tt_allocmem( m )
   uint32 m;
#endif
{
/*
 * Returns a memory handle.
 * The calling routine dereferences the handle with MEMptr()
 * to get a pointer to a block of memory.
 */
#ifdef TTDEBUG1
MEM_HANDLE hndl = BUFalloc((SL32)m);
printf("  TT_ALLOCMEM(%lu): hnd=%lu\n", m, hndl);
return(hndl);
#else

return (BUFalloc ((SL32)m));

#endif
}


#if defined (ANSI_DEFS)
GLOBAL VOID  tt_freemem( MEM_HANDLE hndl )
#else 
GLOBAL VOID  
tt_freemem( hndl )
   MEM_HANDLE hndl;
#endif
{

if (hndl == (MEM_HANDLE)NIL_MH)          /* trap null handle */
    return;
BUFfree(hndl);
#ifdef TTDEBUG1
printf("  TT_FREEMEM(%lu)\n", hndl);
#endif
}




/*      tt_GetSfntGlobalFragment
 *
 * Returns a pointer to requested data.
 *         NULL if access request is out of range.
 *
 * ttInput->GetSfntFragmentPtr is a pointer to this function, which
 * is called by the Font Scaler whenever it needs data from the font.
 * In the UFST implementation global data is returned here; character data
 * must be accessed by the function ttInput->GetSfntGlyphPtr().
 * Note that 'clientID' is really the PBUCKET structure.
 *
 * On INTEL CPUs in 16-bit mode we will run into trouble, if the global data
 * is >= 64K.
 */
#if defined (ANSI_DEFS)
MLOCAL GetSFNTFunc  tt_GetSfntGlobalFragment (voidPtr clientID, long offset,
                                              long length)
#else 
MLOCAL GetSFNTFunc  tt_GetSfntGlobalFragment (clientID, offset, length)
   voidPtr clientID;
   long offset;
   long length;
#endif
{
PBUCKET pBucket = (PBUCKET)clientID;

#ifdef TTDEBUG1
printf("GetSfntGlobalFrag(%ld %ld)\n", offset, length);
#endif

#if  !(TT_DISK || TT_ROM || TT_PCLEOI || TT_ROM1)
    return (NULL);      /* Bad configuration! */
#endif

if ((uint32)(offset+length) > pBucket->p.tt.GlobalTTSize)
    return (NULL);      /* request out of range */

/* For ROM fonts ROMHndl is the base address of the font.
 * For disk fonts or PCLEOs GlobalTTHndl is a handle to the base address
 * of the font global data. */
#if (TT_ROM || TT_ROM1)
if (pBucket->rom_font)
    return (GetSFNTFunc)((LPUB8)pBucket->p.tt.ROMHndl + offset);
else
#if !(TT_DISK || TT_PCLEOI)
    return (GetSFNTFunc)0;
#endif
#endif  /* (TT_ROM || TT_ROM1) */

#if (TT_DISK || TT_PCLEOI)
    return (GetSFNTFunc)(MEMptr(pBucket->p.tt.GlobalTTHndl) + offset);
#endif
}


#if defined (ANSI_DEFS)
MLOCAL ReleaseSFNTFunc  tt_RelSfntGlobalFragment(void)

#else 
MLOCAL ReleaseSFNTFunc  tt_RelSfntGlobalFragment()
#endif
{
#ifdef TTDEBUG1
printf("RelSfntGlobalFrag -- dummy routine\n");
#endif
return (ReleaseSFNTFunc)0;

/* The memory is not released until unload_font is called. */
}




/*      tt_GetSfntGlyphPtr
 *
 * Returns: a pointer to requested glyph ID, or NULL
 *          a handle to dynamically allocated glyph memory (or NIL) in 'pHndl'
 *          size of glyph data in 'gLength'
 *
 * The Font Scaler calls this function through fs_GlyphInputType.GetSfntGlyphPtr.
 * If Disk/ROM the offset and length are supplied; we read the data from disk
 * or point to it in ROM. If a PCLEO, the pointer to the data and its length
 * might already be in the bucket. If not, call printer-supplied function
 * 'PCLglyphID2Ptr()'.
 * Note that 'clientID' is really the PBUCKET structure.
 */
#if defined (ANSI_DEFS)
MLOCAL voidPtr tt_GetSfntGlyphPtr (voidPtr clientID, uint16 gIndex,
                          uint32 gOffset, uint32 *gLength, PMEM_HANDLE pHndl)

#else 
MLOCAL voidPtr tt_GetSfntGlyphPtr (clientID, gIndex, gOffset, gLength, pHndl)
   voidPtr clientID;
   uint16 gIndex;
   uint32 gOffset;
   uint32 *gLength;
   PMEM_HANDLE pHndl;
#endif
{
PBUCKET  pBucket = (PBUCKET)clientID;
*pHndl = NIL_MH;
#if  !(TT_DISK || TT_ROM || TT_PCLEOI || TT_ROM1)
return (voidPtr)0;              /* Bad configuration! */
#endif

#if TT_PCLEOI   /* PCLEO input enabled */
if (pBucket->extern_font)
    {
    PPCLETTO_CHR_HDR  pCharD;
    if (gIndex == pBucket->p.tt.baseGlyphID)
        {                           /* we have the information in the bucket */
        *gLength = (uint32)pBucket->p.tt.baseGlyphLen;
        return (voidPtr)(pBucket->p.tt.baseGlyphPtr);
        }
    else                            /* a compound character piece, I presume */
        {
#if !MULTICALLER        /* mby, 10/27/93 */
        if ((pCharD = (PPCLETTO_CHR_HDR)PCLglyphID2Ptr(gIndex)) != NULL)
#else   /* Multicaller is enabled */
        if ((pCharD = (PPCLETTO_CHR_HDR)PCLglyphID2Ptr(uLastCallerId, gIndex)) != NULL)
#endif  /* MULTICALLER */
            {
            uint8* byteP = (uint8 *)pCharD + pCharD->descriptorsize + 2;
            *gLength = GET_xWORD(byteP) - 4;
            return (voidPtr)(byteP + 4);
            }
        else
            {
            *gLength = 0;
            return (voidPtr)0;
            }
        }
    }
else
#endif /* TT_PCLEOI */

    {                   /* Disk or ROM */
    voidPtr  glyphPtr = (voidPtr)0;
#if  (TT_ROM || TT_DISK || TT_ROM1)
    if (gOffset + *gLength > pBucket->p.tt.glyphTableSize)
        return glyphPtr;            /* out of bounds error */
#endif  /* (TT_ROM || TT_DISK || TT_ROM1) */
#if (TT_ROM || TT_ROM1)
    if (pBucket->rom_font)
        glyphPtr = (voidPtr)((LPUB8)pBucket->p.tt.ROMHndl +
                             (gOffset + pBucket->p.tt.glyphTableOffset));
#endif  /* (TT_ROM || TT_ROM1) */
#if  TT_DISK
    if (!pBucket->rom_font)     /* disk font */
        {
        if (LSEEK (pBucket->fh,  /* 1-28-94 jfd */
                   pBucket->p.tt.glyphTableOffset + gOffset, SEEK_SET ) == -1L)
            return glyphPtr;        /* seek error */
        *pHndl = tt_allocmem(*gLength);
        if (*pHndl == NIL_MH )
            return glyphPtr;        /* no memory */
        glyphPtr = (voidPtr)MEMptr(*pHndl);
        if (READF (pBucket->fh, glyphPtr, (int)*gLength) != 
                   (unsigned int)*gLength)   /* 1-28-94 jfd */
            {
            tt_freemem(*pHndl);
            *pHndl = NIL_MH;
            return (voidPtr)0;      /* read error */
            }
        }
#endif  /* TT_DISK */
    return glyphPtr;
    }
}




#if defined (ANSI_DEFS)
MLOCAL void tt_RelSfntGlyphPtr (MEM_HANDLE hndl)

#else 
MLOCAL void tt_RelSfntGlyphPtr (hndl)
   MEM_HANDLE hndl;
#endif
{
tt_freemem(hndl);
return;
}





#if TT_DISK

#define NUMBEROFTABLES  12
typedef struct {
  int     Index;
  uint32  Length;
} IndexLength;

/*
 * ttload_DiskSfnt
 *
 * Read TrueType font from disk. Extract global data tables and copy them
 * into dynamic memory.
 * Save open file pointer in bucket. We still need it for reading
 * character data.
 *   head, hhea, hmtx, maxp, cmap, loca -- are required tables.
 *   fpgm, prep, cvt  -- are optional; typically in hinted TT fonts.
 *   PCLT, OS/2, post -- not required by the font scaler. We hope these exist
 *                     so we can fill in bits for font substitution.
 *
 * Returns  UW16 SUCCESS or error code.
 * On error: close file; set PBUCKET->fh = -1.
 */
#if defined (ANSI_DEFS)
MLOCAL UW16 ttload_DiskSfnt (SB8 *pathname, PBUCKET pBkt)
#else
MLOCAL UW16 
ttload_DiskSfnt (pathname, pBkt)
   SB8   *pathname;
   PBUCKET pBkt;
#endif
{
int    ii, nn;
int    nrTab;
LPSB8  pGTTBase;
sfnt_DirectoryEntry *dir;
sfnt_DirectoryEntry *pGTT;
sfnt_DirectoryEntry *sfntDir;
MEM_HANDLE    sdHndl = 0;
unsigned int  tsize, tcount;
uint32        gsize, toffset;
IndexLength   tableLengthMap[NUMBEROFTABLES];
sfnt_OffsetTable     tt_OffsetTbl;
uint16 error;
int status;

    status = IXopen_file((PINDEX_ENTRY)NULL, pBkt);
    if (status)
        return ERR_TT_OPENDISK;

/* Read sfnt offset table and directory entries. */
LSEEK (pBkt->fh, 0L, SEEK_SET); /* 1-28-94 jfd */
if (READF (pBkt->fh, (SB8 *)&tt_OffsetTbl, OFFSETTABLESIZE) != OFFSETTABLESIZE)  /* 1-28-94 jfd */
    {
    error = ERR_TT_DISKREAD;
    goto loadError;
    }
nrTab = (int16)SWAPW(tt_OffsetTbl.numOffsets);
tsize = sizeof(sfnt_DirectoryEntry) * nrTab;
if ((sdHndl = tt_allocmem((uint32)tsize)) == 0)
    {
#ifdef TTDEBUG
    printf("Memory allocation failed, sfnt table directories\n");
#endif
    error = ERR_TT_DISKNOMEM;
    goto loadError;
    }
dir = sfntDir = (sfnt_DirectoryEntry *)MEMptr (sdHndl);
if (READF (pBkt->fh, (SB8 *)sfntDir, tsize) != tsize)  /* 1-28-94 jfd */
    {
    error = ERR_TT_DISKREAD;
    goto loadError;
    }
for (ii=0; ii<NUMBEROFTABLES; ii++)
    tableLengthMap[ii].Index = -1;

/* Scan through font tables, find the ones we need and how big they are. */
for (tcount=0, tsize=0, gsize=0, ii=0; ii<nrTab; ii++, dir++)
    {
    sfnt_TableTag tag = dir->tag;
    uint32      xleng = (uint32)SWAPL(dir->length);
    if (tag == tag_FontHeader)          /* head */
        {
        tableLengthMap[0].Index = ii;
        tableLengthMap[0].Length = xleng;
        }
    else if (tag == tag_HoriHeader)     /* hhea */
        {
        tableLengthMap[1].Index = ii;
        tableLengthMap[1].Length = xleng;
        }
    else if (tag == tag_MaxProfile)     /* maxp */
        {
        tableLengthMap[2].Index = ii;
        tableLengthMap[2].Length = xleng;
        }
#if !defined ROB_TEST
    else if (tag == tag_IndexToLoc)     /* loca */
        {
        tableLengthMap[3].Index = ii;
        tableLengthMap[3].Length = xleng;
        }
#endif /* ROB_TEST */
    else if (tag == tag_CharToIndexMap) /* cmap */
        {
        tableLengthMap[4].Index = ii;
        tableLengthMap[4].Length = xleng;
        }
#if !defined ROB_TEST
    else if (tag == tag_HorizontalMetrics)  /* hmtx */
        {
        tableLengthMap[5].Index = ii;
        tableLengthMap[5].Length = xleng;
        }
#endif /* ROB_TEST */
    else if (tag == tag_ControlValue)   /* cvt  */
        {
        tableLengthMap[6].Index = ii;
        tableLengthMap[6].Length = xleng;
        }
    else if (tag == tag_PreProgram)     /* prep */
        {
        tableLengthMap[7].Index = ii;
        tableLengthMap[7].Length = xleng;
        }
    else if (tag == tag_FontProgram)    /* fpgm */
        {
        tableLengthMap[8].Index = ii;
        tableLengthMap[8].Length = xleng;
        }
    else if (tag == tag_Postscript)     /* post */
        {
        tableLengthMap[9].Index = ii;
        tableLengthMap[9].Length = xleng;
        }
    else if (tag == tag_OS_2)           /* OS/2 */
        {
        tableLengthMap[10].Index = ii;
        tableLengthMap[10].Length = xleng;
        }
    else if (tag == tag_PCLT)           /* PCLT */
        {
        tableLengthMap[11].Index = ii;
        tableLengthMap[11].Length = xleng;
        }
    else if (tag == tag_GlyphData)      /* glyf */
        {
        pBkt->p.tt.glyphTableOffset = (UL32)SWAPL(dir->offset);
        pBkt->p.tt.glyphTableSize = xleng;
        continue;               /* save the offset & length but don't copy */
        }                       /* into global area */
    else
        continue;

    gsize += ((xleng + 3) & 0xFFFFFFFCL);
    tsize += sizeof(sfnt_DirectoryEntry);
    tcount++;
    }

toffset = (tsize + OFFSETTABLESIZE + 3) & 0xFFFFFFFCL;
pBkt->p.tt.GlobalTTSize = gsize + toffset;
if ((pBkt->p.tt.GlobalTTHndl = tt_allocmem(pBkt->p.tt.GlobalTTSize)) == 0)
    {
#ifdef TTDEBUG
    printf("Memory allocation failed, ttload_DiskSfnt, %ld\n", pBkt->p.tt.GlobalTTSize);
#endif
    error = ERR_TT_DISKNOMEM;
    goto loadError;
    }
pGTTBase = MEMptr(pBkt->p.tt.GlobalTTHndl);

/* Write a new font directory and copy tables to dynamic memory. */
((sfnt_OffsetTable *)pGTTBase)->numOffsets = (uint16)SWAPW((uint16)tcount);
pGTT = (sfnt_DirectoryEntry *)(pGTTBase + OFFSETTABLESIZE);
for (ii=0; ii<NUMBEROFTABLES; ii++)
    {
    if ((nn = tableLengthMap[ii].Index) >= 0)
        {
        MEMCPY(pGTT, &sfntDir[nn], sizeof(sfnt_DirectoryEntry));
        pGTT->offset = (uint32)SWAPL(toffset);
        tsize = (unsigned int)tableLengthMap[ii].Length;
        if (LSEEK (pBkt->fh, (int32)SWAPL(sfntDir[nn].offset), SEEK_SET) == -1L) /* 1-28-94 jfd */
            {
            error = ERR_TT_DISKREAD;
            goto loadError;
            }
#if !defined(__i960)    /* 6-20-94 jfd */
        if (READF (pBkt->fh, pGTTBase + (unsigned int)toffset, tsize) != tsize)  /* 1-28-94 jfd */
          /* Changed cast from UW16 to unsigned int! mby, 11-03-93 */
            {
            error = ERR_TT_DISKREAD;
            goto loadError;
            }
#else
        /* For INTEL960, can't read more than 996 bytes at a time,
           so break up read() call into multiple reads if necessary
         */
       {
       unsigned int num_read;
       unsigned int maxcount;
       unsigned int loops;
       unsigned int left;
       LPSB8 buffer;
       LPSB8  buffer2;
       unsigned int i;

        buffer = pGTTBase + (unsigned int)toffset;
        if (tsize <= 996)
        {
           num_read = READF(pBkt->fh, buffer, tsize);
           if (num_read != tsize)
           {
            error = ERR_TT_DISKREAD;
            goto loadError;
           }
        }
        else
        {
           maxcount = 996;
           loops = tsize / maxcount;
           left  = tsize - (loops * maxcount);
    
           buffer2 = buffer;
           for (i=0; i<loops; i++)
           {
              num_read = READF(pBkt->fh, buffer2, maxcount);
              if (num_read != maxcount)
              {
               error = ERR_TT_DISKREAD;
               goto loadError;
              }
              buffer2 += maxcount;
           }
           num_read = READF(pBkt->fh, buffer2, left);
           if (num_read != left)
           {
            error = ERR_TT_DISKREAD;
            goto loadError;
           }
        }
       }
#endif
        pGTT++;
        toffset += ((tsize + 3) & 0xFFFFFFFCL);
        }
    }

tt_freemem(sdHndl);
return SUCCESS;

loadError:
  IXclose_file(pBkt);   /* 3-28-94 jfd */
  tt_freemem(sdHndl);   /* does nothing if sdHndl = 0 */
  return error;
}
#endif  /* TT_DISK */




#define TAG_glyf   0x676c7966L
#if TT_ROM

#if defined (ANSI_DEFS)
MLOCAL UW16 ttload_ROMEntity (LPUB8 sfntPtr, PBUCKET pBucket)

#else   
MLOCAL UW16 ttload_ROMEntity (sfntPtr, pBucket)
   LPUB8   sfntPtr;
   PBUCKET pBucket;
#endif 
{
    if (sfntPtr == NULL)
        return ERR_TT_ROMPTR;
    pBucket->p.tt.ROMHndl = sfntPtr;
    return (UW16)(ttload_ROMSfnt(pBucket));
}
#endif  /* TT_ROM */



#if (TT_ROM1 || TT_ROM)

#if defined (ANSI_DEFS)
GLOBAL int  ttload_ROMSfnt( PBUCKET pBucket )

#else
GLOBAL int  ttload_ROMSfnt( pBucket )
   PBUCKET pBucket;
#endif
{
    LPUB8  dir;
    int    ii, error;
    int    nrTab;
    UL32   length, offset, size;
    LPUB8  sfntPtr;

    sfntPtr = pBucket->p.tt.ROMHndl;
    nrTab = (int)(GET_xWORD_OFF(sfntPtr, SFNTD_NUMTABLES));
    dir = sfntPtr + OFFSETTABLESIZE;
    for (size=0,ii=0,error=1; ii<nrTab; ii++, dir += SFNTD_TABLESIZE)
    {
        length = GET_xLONG_OFF(dir, SFNTD_LENGTH);
        offset = GET_xLONG_OFF(dir, SFNTD_OFFSET);
        if (length + offset > size)
            size = length + offset;
        if (GET_xLONG_OFF(dir, SFNTD_TAG) == TAG_glyf)
        {
            pBucket->p.tt.glyphTableOffset = offset;
            pBucket->p.tt.glyphTableSize = length;
            error = 0;
        }
    }
    if (error)      /* no glyf table! */
        return ERR_TT_ROMPTR;
    pBucket->p.tt.GlobalTTSize = size;
    return SUCCESS;
}
#endif  /* (TT_ROM1 || TT_ROM) */
#undef TAG_glyf





#if (TT_DISK || TT_ROM)     /* conditionalize if PCLEOs only are enabled */

typedef struct {
  uint16  pad1[15];
  uint8   sfntFamilyClass[2];
  uint16  pad2[15];
  uint16  sfntSelection;
  uint16  pad3[7];
} sfnt_OS2Table;

#define PCLT_STYLELSB   13
#define PCLT_STROKEWT   50
#define PCLT_SERIFSTYLE 52
#define SFLAGBOLD       0x20
#define SFLAGITALIC     0x01
#define BUCKBITBOLD     0x01
#define BUCKBITNOSERIF  0x02
#define BUCKBITITALIC   0x04
#define BUCKBITNOFP     0x08
#define BUCKBITCOUR     0x10
#define BUCKBITLGOT     0x20

#if defined (ANSI_DEFS)
MLOCAL VOID  set_plugin_bit_field (fs_GlyphInputType* tt, SW16* bucknum,
                                   uint16 emres)
#else 
MLOCAL VOID  
set_plugin_bit_field (tt, bucknum, emres)
   fs_GlyphInputType *tt;
   SW16             *bucknum;
   uint16           emres;
#endif

/* Fills in bits 0-5 in PBUCKET->bucket_num for plugin font selection    */
/* This function is not called for PCLEOs, because ttload_PCLEO obtained */
/* the information from the PCLEO header. */
{
uint16   ii;
uint16   fpwidth, pitch;
uint16  *wbuffer;
sfnt_PostScriptInfo  *postData;

*bucknum = 0;           /* initialize */
  {
  /* Look for PCLT or OS/2 table to set bold, italic, serif-style bits. */
     LPUB8 pPCLT_table;
     sfnt_OS2Table* os2Data;
     uint16 tmps;
     int    val;

     pPCLT_table = (LPUB8)fs_GetTablePtr (tt, sfnt_PCLT);
     if (pPCLT_table)
     {
        val = ((int)*(pPCLT_table + PCLT_SERIFSTYLE)) & 0x3F;
        if (val <= 1 || val == 9)
           *bucknum |= BUCKBITNOSERIF;
        if (*(pPCLT_table + PCLT_STROKEWT) > 0)
           *bucknum |= BUCKBITBOLD;
        if (*(pPCLT_table + PCLT_STYLELSB) & 0x03)
           *bucknum |= BUCKBITITALIC;
     }
     else
     {
        os2Data = (sfnt_OS2Table *)fs_GetTablePtr (tt, sfnt_OS_2);
        if (os2Data)
        {
           tmps = (uint16)SWAPW(os2Data->sfntSelection);
           if (tmps & SFLAGBOLD)
               *bucknum |= BUCKBITBOLD;
           if (tmps & SFLAGITALIC)
               *bucknum |= BUCKBITITALIC;
           if (os2Data->sfntFamilyClass[0] == 8)
               *bucknum |= BUCKBITNOSERIF;
           /* Agfa's TT fonts have the two bytes reversed! */
           else if (!os2Data->sfntFamilyClass[0] && os2Data->sfntFamilyClass[0] == 8)
               *bucknum |= BUCKBITNOSERIF;
        }
     }
  }

/* From the "post" table find out if font is fixed pitch.
 * Then look at the "hmtx" table. Find the first nonzero escapement,
 * and calculate the pitch.
 */
postData = (sfnt_PostScriptInfo *)fs_GetTablePtr (tt, sfnt_PostScript);
if (postData)
    {
    if (postData->isFixedPitch || postData->pad)
        {       /* Yes, it's monospaced. Now figure out if 10 or 12 pitch */
        wbuffer = (uint16 *)fs_GetTablePtr (tt, sfnt_horizontalMetrics);
        if (wbuffer)
            {
            for (ii=0; ii<16; ii += 2) /* assume there will be a nonzero   */
                {              /* escapement value in the first 8 metrics. */
				uint16 temp = wbuffer[ii];
                if ( (fpwidth = (uint16)SWAPW(temp)) != 0)
                    break;
                }
            pitch = (uint16)((6 * (int32)emres + (emres >> 1)) / fpwidth);
            if (pitch == 10)
                *bucknum |= BUCKBITCOUR;
            else if (pitch == 12)
                *bucknum |= BUCKBITLGOT;
            }
        else
            *bucknum |= BUCKBITNOFP;
        }
    }
}   /* set_plugin_bit_field()  */
#endif  /* (TT_DISK || TT_ROM) */





/*  Support routine for ttunload_font().
 *  Also called on ttload_font() error.
 */

#if defined (ANSI_DEFS)
MLOCAL  VOID  unload_memory (PBUCKET pBkt, fs_GlyphInputType* ttInput, int nn)
#else 
MLOCAL  VOID  
unload_memory (pBkt, ttInput, nn)
   PBUCKET            pBkt;
   fs_GlyphInputType *ttInput;
   int                nn;
#endif
{
int ii;

#if TT_DISK             /* if disk-based font, close file */
if ((!pBkt->extern_font  &&  !pBkt->rom_font)  &&  (pBkt->fh != -1) )
  IXclose_file(pBkt);   /* 3-28-94 jfd */
#endif

tt_freemem(pBkt->p.tt.GlobalTTHndl);    /* free global memory */
/* Free other memory buffers */
for (ii = nn; ii >= 0; ii--)
    tt_freemem(ttInput->memoryBases[ii]);
tt_freemem(pBkt->p.tt.trMatrix);
tt_freemem(pBkt->p.tt.buffInput);
tt_freemem(pBkt->p.tt.buffInfo);
}

#endif /* TT_RDR   conditionalize entire file */

