/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/bmp/bitmap.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: bitmap.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.23   06 Apr 1995 15:07:56   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.22   14 Feb 1995 20:49:22   MIKE
 * 
 * Reduce memory allocation for NZW buffer.
 * 
 *    Rev 1.21   03 Jun 1994 10:05:48   JOE
 * 
 * Changed all occurrences of ENTRY to CGENTRY to resolve conflict on
 * some compilers.
 * 
 *    Rev 1.20   22 Apr 1994 09:20:24   LISA
 * 
 * Modified copyright/disclaimer notice.
 * 
 *    Rev 1.19   06 Jan 1994 09:48:20   JOE
 * 
 * In compound_character(), restructured checks to determine if memory
 * requirements for compound parts are calculated correctly.
 * 
 *    Rev 1.18   15 Dec 1993 14:37:34   JOE
 * 
 * In compound_character(), if CHAR_SIZE, disabled memory check when
 * processing part 00 (already done earlier). In same routine, when 
 * processing parts 1 thru "n", changed calculation of "b.orb" to
 * "cc_buf " bm_size" to prevent memory overwrite.
 * 
 *    Rev 1.17   21 Sep 1993 15:15:58   JOE
 * 
 * In CGIFtile_nzw_buf()", corrected DBG1() statement ("size[1]"
 * becomes "*psize").
 * 
 *    Rev 1.16   15 Sep 1993 14:07:32   JOE
 * Added external declaration for "uLastCallerId" to resolve compiler error
 * when MULTICALLER is enabled.
 * 
 *    Rev 1.15   31 Aug 1993 14:12:54   AL
 * 
 * Added CGIFtile_nzw_buf()
 * 
 *    Rev 1.14   02 Aug 1993 14:28:52   MAIB
 * 
 * Changes to support multi-tasking
 * 
 *    Rev 1.13   29 Jul 1993 12:37:06   AL
 * 
 * More nzw changes
 * 
 *    Rev 1.12   27 Jul 1993 12:32:56   AL
 * Non-zero winding changes
 * 
 *    Rev 1.11   01 Jul 1993 14:18:12   MAIB
 * changed making_bold to non_z_wind
 * 
 *    Rev 1.10   17 May 1993 18:07:28   JOE
 * In simple_character(), when calling raster() and cgfill(), cast "bm->bm"
 * as LPUB8 due to change made in IFBITMAP structure.
 * 
 *    Rev 1.9   07 Apr 1993 11:50:48   JOE
 * Removed MAKE_BITMAP #define and all references to it.
 * 
 *    Rev 1.8   12 Feb 1993 16:55:04   JOE
 * Check for potential buffer overflow in compound_character() if CHAR_SIZE is
 * enabled.
 * 
 *    Rev 1.7   12 Feb 1993 11:01:16   JOE
 * VXWorks support.
 * 
 *    Rev 1.6   29 Jan 1993 09:22:44   JOE
 * In character(), saved em box size in "state.bmb.bm".
 * 
 *    Rev 1.5   22 Jan 1993 08:55:28   JOE
 * In CGIFmakechar(), removed escapement adjustment code because it is 
 * now done in MAKifbmheader (maker.c).
 * 
 *    Rev 1.4   20 Jan 1993 09:57:54   JOE
 * In character(), removed checking of "size" for overflow because it should
 * be done in application after call to CGIFchar_size().
 * 
 *    Rev 1.3   15 Jan 1993 13:27:40   JOE
 * If CHAR_SIZE, adjust escapement if master point size and x-scan 
 * resolution are not in IF 8782's.
 * 
 *    Rev 1.2   05 Jan 1993 15:43:38   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:30:22   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:32:48   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */

/*---------------------------------------------------------------------
     23-Nov-90  awr   Created. Leveraged from maker.c
     8-Feb-91   awr   Changed name des2wrkbm() to des2bm()
     16-Apr-91  dET   Add squiping() function and made or buffer larger.
     19-May-91  awr   Squiping() prototype and bug fix.
      1-Jun-91  awr   HQ4 changes
      4-Jun-91  awr   cc merging under construction-- warning
     17-Jun-91  jfd   Moved "debug.h" after "port.h".
                      Moved "profile.h" after "port.h".
      4-Jul-91  awr   Tiling
     14-Aug-91  awr   In grow_and_merge(), filled in black_width & depth.
                      Disabled all calls to margin().
     20 Aug 91  ss    Added casts in simple_character() to eliminate warnings.
     24-Aug-91  awr   Moved function decls to include file
     27-Aug-91  bjg   Add special case handling for mirrored chars 
      1-Sep-91  awr   Included "bitmap.h"
      6-Sep-91  awr   Changed HEADERSIZE to BMHEADERSIZE
     19-Sep-91  jfd   In bitmap_tile(), when calculating tile_bm.xorigin
                      and tile_bm.yorigin, cast operand as LONG due to
                      change in type to LONG for xorigin and yorigin.
     12-Oct-91  awr   Missing pixel recovery and pseudo bold are no
                      longer mutually exclusive.
     18-Oct-91  jfd   Declare "scan_convert" conditionally based on
                      TILE.
     25-Oct-91  jfd   Changed declaration for "scan_convert" from GLOBAL
                      to EXTERN so as to resolve a linker error which
                      occurs if CHAR_SIZE is enabled.
     02-Feb-92   rs  Clean up compiler warnings.
      7-Mar-92  awr   Changed metrics() parameters
     03-Apr-92  rs    Portability cleanup (see port.h).
     04-Apr-92  awr   Changed calling sequence of find_part2whole()
     06-Apr-92  jfd   In bitmap(), conditionally compiled call to 
                      bitmap_ufst() (if PST1I ||  TT_RDR)
     08-Apr-92  rs    Modify 'simple_character()' to handle fixed space chars.
                      Do not call 'raster()' & 'fill()' if no contours based
                      upon 'if_state.num_loops' == 0.
                      Fix warnings in 'set_bitmap_memory()'.
      8 Apr 92  ss    In bitmap_ufst(), copy metrics generated earlier to
                      return with bitmap as expected by rest of code.
     10 Apr 92  ss    In bitmap_if(), don't do code that sets special_case.
     10-Apr-92  rs    Change 'special_case' to EXTERN, declared in 'maker.c'.
     12-Apr-92  awr   Moved in bitmap generating code from maker.
     19-Apr-92  awr   Combined CHAR_SIZE and CHAR_HANDLE tile code.
     21-Apr-92  jfd   Temporarily conditionally compiling entire module
                      based on CGBITMAP. Will optimize later!
     05-May-92  jfd   In bitmap_dyn(), changed "bmdim.x" to "state.bmdim.x"
                      when allocating bitmap buffer plus fluff.
      6 May 92  ss    In simple_character(), added casts to eliminate warnings
     12 May 92  jfd   Added #define for "MAX_CHARSIZE_SIZE" (size of buffer
                      used if CHAR_SIZE is enabled.
                      In character(), before calling clear_mem(), check if
                      size of tiled bitmap exceeds buffer size to avoid
                      writing outside of memory. This is necessary only
                      if CHAR_SIZE is enabled because bitmap_dyn()
                      previously checks for enough memory.
     29-May-92  jfd   Changed type "OLSTATS" to "CHAR_STATS" due to change 
                      in "ix.h".
      8-Jun-92  jfd   Removed all references to "olstats" and replaced
                      with "if_state.cs".
     21-Jun-92  awr   changed if_state.xlate and if_state.tbound to INTRs
                      Conditionally compiled portions
     19-Jun-92  jfd   In bitmap_dyn(), added special case for handling
                      space character.
      1-Jul-92  jfd   In compound_character(), when computing "if_state.xlate.y"
                      and "if_state.tbound.ur.y", use "trans_diff.y", not
                      "trans_diff.x".
      4-Jul-92  awr   Adjusted conditional compiles
     10 Jul 92  ss,awr In compound_character(), now set b.orb for CACHE and
                      CHAR_HANDLE code.
     14-Jul-92  awr   Changed call to make_gaso().
     22-Jul-92  awr   Preserve xlate and tbound in compund_character()
                      for part 0. Was getting trashed for compound characters
                      using tiling.
     05-Aug-92  jfd   Replaced calls to "clear_mem()" with MEMSET for
                      optimization.
     02-Sep-92  mby   Fixed bug in compound_char() ( CHAR_SIZE = 1 ).
                      or-buffer pointer was set incorrectly and either
                      clobbered the bm-header and crashed, or produced
                      garbled bitmaps.
     24-Oct-92  awr   Added MAKE_BITMAP define for timing tests
     14-Nov-92  rs    Port to Mac - fill() renamed to cgfill().
     05-Jan-93  jfd   ANSI C function declaration changes.
     20-Jan-93  jfd   In character(), removed checking of "size" for overflow
                      because it should be done in applcation after call to
                      CGIFchar_size(). Removed #define for MAX_CHARSIZE_SIZE.
     27-Jan-93  jfd   In character(), store em box size in "state.bmb.bm".
     08-Feb-93  jfd   VXWorks support.
     09-Feb-93  jfd   In compound_character(), if CHAR_SIZE, when processing
                      first part of a character, check for memory overflow
                      and disable missing pixel recovery if necessary
                      before calling character().
     07-Apr-93  jfd   Removed MAKE_BITMAP #define (Always assume TRUE).
     17-May-93  jfd   In simple_character(), when calling raster() and
                      cgfill(), cast "bm->bm" as LPUB8 due to change made
                      in IFBITMAP structure.
     01-Jul-93 maib  Changed making_bold to non_z_wind
     02-Jul-93 awr   Changes for improved non zero winding fill.  This
                     changed parameters for CGIFmakechar() and
                     CGIFtilebitMap()
    02-Aug-93 maib   Changed interface to prevent CGIFxxx() routines from calling
                     other CGIFxxx() routines, required for multi-tasking. also
                     added multicaller support code to CGIFxxx() routines
    30-Aug-93 awr    Added CGIFtile_nzw_buf()
     15-Sep-93 jfd   Added external declaratifon for "uLastCallerId" to
                     resolve compiler error when MULTICALLER is enabled.
     21-Sep-93 jfd   In CGIFtile_nzw_buf(), corrected printf() statement
                     ("size[1] becomes "*psize").
     09-Dec-93 jfd   In compound_character(), if CHAR_SIZE, disabled memory 
                     check when processing part 0 (already done earlier).
                     In same routine, when processing parts 1 thru "n",
                     changed calculation of "b.orb" to "cc_buf + bm_size"
                     to prevent memory overwrite.

  05-Jan-94 jfd/jwd  In compound_character(), restructured checks to determine
                     if memory requirements for compound parts are calculated
                     correctly.
  03-Jun-94 jfd      Changed all occurrences of ENTRY to CGENTRY to resolve
                     conflict on some compilers.
  14-Feb-95 mby   In bitmap_dyn() and CGIFtile_nzw_buf(), correct alignment
                  of NZW buffer and thus slightly reduce memory allocation.

-----------------------------------------------------------------------*/


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <string.h>

#include "cgconfig.h"

#if CGBITMAP            /* Conditionally compile entire module */

#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "cgif.h"
#include "cache.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "bitmap.h"

#define MAX_BM_SIZE (MAX_BM - BMHEADERSIZE)

typedef struct
{
    MEM_HANDLE hbm;
    MEM_HANDLE horb;
    PIFBITMAP bm;
    LPUB8 orb;
} BITMAP_BUFFERS;
typedef BITMAP_BUFFERS FARPTR * PBITMAP_BUFFERS;


struct
{
    int            bmbufs_dyn;
    BOX            tile_box;
    SW16VECTOR     bmdim;
    SL32       nzw_size;
    MEM_HANDLE hnzw;   /* non zero winding buffer handle */
    LPUB8      nzw;
    BITMAP_BUFFERS bmb;     /* For entire bitmap */
} state;


#ifdef LINT_ARGS
MLOCAL UW16      simple_character(PBITMAP_BUFFERS, SW16VECTOR);
MLOCAL int       tile_in_part(SW16VECTOR, BOX);
MLOCAL UW16      compound_character(VOID);
MLOCAL UW16      character(VOID);
MLOCAL UW16      bitmap_dyn(PHIFBITMAP);
GLOBAL UW16      bitmap_tile(PIFTILE, PHIFBITMAP);
GLOBAL UW16      bitmap(PHIFBITMAP);
EXTERN UW16      outbuffer(PIFOUTLINE);
#ifdef DEBUG
EXTERN VOID      pr_tran(LPUB8, SW16, SW16);
#endif
#else   /* not LINTARGS */
MLOCAL UW16      simple_character();
MLOCAL int       tile_in_part();
MLOCAL UW16      compound_character();
MLOCAL UW16      character();
MLOCAL UW16      bitmap_dyn();
GLOBAL UW16      bitmap_tile();
GLOBAL UW16      bitmap();

EXTERN UW16      outbuffer();
#ifdef DEBUG
EXTERN VOID      pr_tran();
#endif
#endif


/*-------------------------------------------------*/
#if CHAR_SIZE
EXTERN LPUB8   cc_buf;    /* compound character buffer */
EXTERN SL32     cc_size;   /* size of comp. char buffer */
#endif

EXTERN IF_STATE if_state;
EXTERN CHR_DEF_HDR chr_def_hdr;
EXTERN CHR_DEF chr_def[];
#if SLIM_FONTS
EXTERN SW16 special_case;
#endif

                       /* now use this for !TILE cases also -ss 4/8/92 */
EXTERN IFBITMAP   entire_bm;     /* header of entire bitmap w/ metrics */
/* #if TILE */
EXTERN SCAN_CONVERT scan_convert;
/* #endif   */


#if MULTICALLER
EXTERN  UW16  uLastCallerId;              /* an initial value */
#endif  

/*-------------------------------------------------*/


/*----------------------*/
/*   simple_character   */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  simple_character(PBITMAP_BUFFERS pbmb, SW16VECTOR bmdim)
#else
MLOCAL UW16
simple_character(pbmb, bmdim)
    PBITMAP_BUFFERS pbmb;
    SW16VECTOR      bmdim;
#endif
{
    UW16       status;
    SL32       num_bytes;
    PIFBITMAP  bm;
    LPUB8      orb;

    DBG("simple_character()\n");

  /*------------------------------------------------------------
   *  Clear Buffers
   */

    bm  = pbmb->bm;
    orb = pbmb->orb;

    num_bytes = (SL32)bmdim.x * (SL32)bmdim.y;
    if(if_state.or_on)
        MEMSET((LPUB8)orb, (int)0, (int)((int)num_bytes + (bmdim.x<<1)));

  /*------------------------------------------------------------
   *  Make the character bitmap
   *    If there are no contours (ie space), do not call raster() or fill().
   *       Add 4/10/92 - rs
   */

    if (if_state.num_loops)
    {
        status = raster((LPUB8)bm->bm, orb+bmdim.x, state.nzw, bmdim);
        if(status)
        {
            DBG("raster() error\n");
            return status;
        }
        cgfill((LPUB8)bm->bm, (LPUB8)bm->bm, (int)bm->width, (int)bm->depth,
                                                        orb+bmdim.x);
    }

    DBG("part bitmap\n");
    print_bm(bm);

    return SUCCESS;
}

#if IF_RDR
#define STAT_no_tile_intersect  16000
/*----------------------*/
/*     tile_in_part     */
/*----------------------*/
/*  1. Computes the subtile within the character part that we must build.
 *  2. Sets the global clip box "scan_convert.tb" used in raster().
 *  3. Returns FALSE if there is no intersection of the tile and the part.
 *     Returns TRUE otherwise.
 */
#if defined (ANSI_DEFS)
MLOCAL int   tile_in_part(SW16VECTOR p2w, BOX part_box_pix)
#else
MLOCAL int
tile_in_part(p2w, part_box_pix)
    SW16VECTOR p2w;
    BOX        part_box_pix;
#endif
{

    DBG("tile_in_part()\n");
    DBG4("bm (pix):    (%d %d)   (%d, %d)\n",
                                                part_box_pix.ll.x,
                                                part_box_pix.ll.y,
                                                part_box_pix.ur.x,
                                                part_box_pix.ur.y);
  /* Translate tile back to part */
    scan_convert.tb.ll.x = state.tile_box.ll.x - p2w.x;
    scan_convert.tb.ll.y = state.tile_box.ll.y - p2w.y;
    scan_convert.tb.ur.x = state.tile_box.ur.x - p2w.x;
    scan_convert.tb.ur.y = state.tile_box.ur.y - p2w.y;
    DBG4("Tile within bm (pix):    (%d %d)   (%d, %d)\n",
                                                scan_convert.tb.ll.x,
                                                scan_convert.tb.ll.y,
                                                scan_convert.tb.ur.x,
                                                scan_convert.tb.ur.y);
  /* intersect the boxes */
    scan_convert.tb.ll.x = MAX(scan_convert.tb.ll.x, part_box_pix.ll.x);
    scan_convert.tb.ll.y = MAX(scan_convert.tb.ll.y, part_box_pix.ll.y);
    scan_convert.tb.ur.x = MIN(scan_convert.tb.ur.x, part_box_pix.ur.x);
    scan_convert.tb.ur.y = MIN(scan_convert.tb.ur.y, part_box_pix.ur.y);
    DBG4("Tile intersect bm (pix):    (%d %d)   (%d, %d)\n",
                                                scan_convert.tb.ll.x,
                                                scan_convert.tb.ll.y,
                                                scan_convert.tb.ur.x,
                                                scan_convert.tb.ur.y);
  /* Return truth value of "tb is not empty" */

    return    (scan_convert.tb.ll.x < scan_convert.tb.ur.x)
           && (scan_convert.tb.ll.y < scan_convert.tb.ur.y);
}
/*----------------------*/
/*  compound_character  */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  compound_character()
#else
MLOCAL UW16
compound_character()
#endif
{
    UW16           status = SUCCESS;
    UW16           pn;
    PCHR_DEF       cd;
    SW16VECTOR     p2w;
    SW16VECTOR     bmdim;     /* tile dim in bytes x rasters */
    SW16           black_width;
    BITMAP_BUFFERS b;
    SL32           num_bytes, bm_size;
    INTRVECTOR     trans_diff;

    BOOLEAN    save_or_on;

    DBG("\n\n\n\ncompound_character()\n");

    save_or_on = if_state.or_on;

  /*  Make first part of (possible compound) character in tile_bm. */

    cd = chr_def;

    cd->pix_bound.ur.x += cd->bmorigin.x;
    cd->pix_bound.ur.y += cd->bmorigin.y;
  /* find part's origin (0,0) in whole bitmap. We translated part 0
   * already by chr_def[0].bmorigin to align it with the overall bitmap
   */
    p2w.x = 0;
    p2w.y = 0;
    if(tile_in_part(p2w, cd->pix_bound))
    {
        status = make_gaso(0,cd);
        if(status)
            return status;

      /*  Translate first part into position in overall bitmap  */

        trans_diff.x = (INTR)cd->bmorigin.x * (INTR)xpix;
        trans_diff.y = (INTR)cd->bmorigin.y * (INTR)ypix;

        if_state.xlate.x += trans_diff.x;
        if_state.xlate.y += trans_diff.y;

        if_state.tbound.ur.x += trans_diff.x;
        if_state.tbound.ur.y += trans_diff.y;

#if CHAR_SIZE
      /* Check for enough memory here  (02-09-93 jfd) */

        num_bytes = (SL32)state.bmdim.x * (SL32)state.bmdim.y;
        bm_size = num_bytes + (SL32)BMHEADERSIZE;

        if(!state.bmbufs_dyn)
              /* split up cc_buf: fixed buf allocated at start up */
        {
            if(if_state.or_on && (bm_size + num_bytes + 2*state.bmdim.x > cc_size))
                if_state.or_on = FALSE;
        }
#endif  /* CHAR_SIZE */

        status = simple_character(&state.bmb, state.bmdim);
        if(status)
            return status;

        if_state.xlate.x -= trans_diff.x;
        if_state.xlate.y -= trans_diff.y;

        if_state.tbound.ur.x -= trans_diff.x;
        if_state.tbound.ur.y -= trans_diff.y;
    }

  /*  Make remaining parts of compound character in compound
   *  character buffer and or them into tile_bm.
   */

    for(pn=1; pn<chr_def_hdr.num_parts; pn++)
    {
        cd++;
        p2w = chr_def[pn].bmorigin;  /* part's origin (0,0) in whole bm */
        if(tile_in_part(p2w, cd->pix_bound))
        {
          /*  Adjust p2w. There are two adjustments:
           *      1. Origin of tile part is at tb.ll in entire part bitmap.
           *      2. Must include vector from entire to tile in whole bitmap.
           */
            p2w.x += scan_convert.tb.ll.x - state.tile_box.ll.x;
            p2w.y += scan_convert.tb.ll.y - state.tile_box.ll.y;
            DBG2("adjusted p2w: (%d, %d)\n", p2w.x, p2w.y);

            status = make_gaso((int)pn,cd);
            if(status)
                return status;

          /*  Set up memory buffers  */

            black_width =
            bmdim.x = (scan_convert.tb.ur.x - scan_convert.tb.ll.x) + 1;
                                                       /* off transition */
            bmdim.y = (scan_convert.tb.ur.y - scan_convert.tb.ll.y);
            bmdim.x = (1 + (bmdim.x-1)/if_state.bit_map_width)
                                    * (if_state.bit_map_width >>3);
            DBG2("    alignment = %d, width in bytes %u\n",
                                       if_state.bit_map_width, bmdim.x);


            num_bytes = (SL32)bmdim.x * (SL32)bmdim.y;
            bm_size = num_bytes + (SL32)BMHEADERSIZE;
#if CACHE || CHAR_HANDLE
            if(state.bmbufs_dyn)
            {
                b.hbm = (HIFBITMAP)CHARalloc(bm_size);
                if(b.hbm == (HIFBITMAP)NIL_MH)
                    return ERR_bm_buff;
                b.bm = (PIFBITMAP)MEMptr(b.hbm);
                b.orb =  state.bmb.orb;    /* ss-7/9/92 */
             }
#endif
#if CHAR_SIZE
            if(!state.bmbufs_dyn)
                  /* split up cc_buf: fixed buf allocated at start up */
            {
                b.bm = (PIFBITMAP)cc_buf;
                if(if_state.or_on)
                    b.orb =  cc_buf + bm_size;  /* 12-09-93 jfd */

                if((num_bytes > cc_size)
                  ||
                 (if_state.or_on && (num_bytes + 2*bmdim.x > cc_size)))
                {
                    DBG("    or_on bitmap > cc_size\n");
                    return ERR_bm_gt_oron;
                }
            }
#endif
            MEMSET((LPUB8)b.bm->bm, (int)0, (int)num_bytes);
            b.bm->width = bmdim.x;
            b.bm->depth = bmdim.y;
            b.bm->left_indent =
            b.bm->top_indent  = 0;
            b.bm->black_width = black_width - 1;   /* pixels */
            b.bm->black_depth = bmdim.y;

            status = simple_character(&b, bmdim);
            if(status)
            {
                if(state.bmbufs_dyn)
                    CHARfree(b.hbm);
                goto done;
            }
            merge(b.bm, state.bmb.bm, p2w);
            if(state.bmbufs_dyn)
                CHARfree(b.hbm);
        }

    }

done:
    if_state.or_on = save_or_on;
    return status;
}
#endif  /* IF_RDR */

/*----------------------*/
/*    character         */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  character()
#else
MLOCAL UW16
character()
#endif
{
    SW16  black_width;
    SL32           size;

    DBG("character()\n");

  /* Intersect app supplied tile against entire bitmap */
    /* clip box against entire bitmap */
    if(state.tile_box.ll.x < 0)
       state.tile_box.ll.x = 0;
    if(state.tile_box.ll.y < 0)
       state.tile_box.ll.y = 0;
    if(state.tile_box.ur.x > entire_bm.black_width)
       state.tile_box.ur.x = entire_bm.black_width;
    if(state.tile_box.ur.y > entire_bm.black_depth)
       state.tile_box.ur.y = entire_bm.black_depth;

/* at this point, tile_box is set correctly for a single part character
   (ufst) and could be copied right into scan_convert.tb  */

    scan_convert.tb = state.tile_box;

  /* Protect against app supplied inside out tile */

    if(state.tile_box.ll.x > state.tile_box.ur.x ||
       state.tile_box.ll.y > state.tile_box.ur.y )
        return ERR_invalid_tile;

  /*  Set up memory buffers  */

    black_width =
    state.bmdim.x = (state.tile_box.ur.x - state.tile_box.ll.x) + 1;   /* off transition */
    state.bmdim.y = (state.tile_box.ur.y - state.tile_box.ll.y);
    state.bmdim.x = (1 + (state.bmdim.x-1)/if_state.bit_map_width)
                            * (if_state.bit_map_width >>3);
    DBG2("    alignment = %d, width in bytes %u\n",
                                  if_state.bit_map_width, state.bmdim.x);

/*DYNAMIC  could set dynamic memory here for consistency in sizes
           with non dyn. Would only save spce. dimensions are the same
 */

    size = (SL32)state.bmdim.x * (SL32)state.bmdim.y;

  /*  Fill in bitmap header */

    MEMSET((LPUB8)state.bmb.bm->bm, (int)0, (int)size);
    state.bmb.bm->width       = state.bmdim.x;       /* byte width   */
    state.bmb.bm->depth       = state.bmdim.y;       /* raster depth */
    state.bmb.bm->left_indent =
    state.bmb.bm->top_indent  = 0;
    state.bmb.bm->black_width = black_width - 1;       /* pixel width */
    state.bmb.bm->black_depth = state.bmdim.y;               /* pixel depth */
    state.bmb.bm->xorigin     = entire_bm.xorigin
                              + (SL32)(((SL32)state.tile_box.ll.x << 4L));
    state.bmb.bm->yorigin     = entire_bm.yorigin
            - ((SL32)((SL32)(entire_bm.depth - state.tile_box.ur.y)<< 4L));
    state.bmb.bm->escapement  = entire_bm.escapement;

    /* Store em box size   - 01-27-93 jfd */
    state.bmb.bm->du_emx      = entire_bm.du_emx;
    state.bmb.bm->du_emy      = entire_bm.du_emy;

#if IF_RDR
    if(if_state.fst_type == FC_IF_TYPE)
        return compound_character();
    else
#endif
        return simple_character(&state.bmb, state.bmdim);
}
/*================================================================

The functions below are the entry points into this module.
Functions external to this module call these functions which then
set up internal parameters and buffers and then call the fucntion
"character()" above to build the character bitmap.


There are four entry functions:

    CGIFtilebitMap()
    CGIFmakechar()
    bitmap()
    bitmap_tile()

All of these entry functions do:

    1.  Set the tile box "state.tile_box"
    2.  Set the bitmap memory buffer structure "state.bmb"
    3.  Call the function above "character()".

The functions CGIFtilebitMap() and CGIFmakechar() supply the bitmap
memory and any auxillary buffers ("or" transitions or bold).  The functions
bitmap() and bitmap_tile() dynamically acquire any memory needed through
calls to CHARalloc() and CHARfree().
==================================================================*/
#if CHAR_SIZE
#if TILE
#if NON_Z_WIND
/*----------------------*/
/*   CGIFtile_nzw_buf   */
/*----------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFtile_nzw_buf(UW16 uCallerId, PIFTILE piftile, 
                      LPSL32 psize)
#else
GLOBAL UW16 CGENTRY
CGIFtile_nzw_buf(uCallerId, piftile, psize)
    UW16       uCallerId;
    PIFTILE    piftile;
    LPSL32     psize;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFtile_nzw_buf(PIFTILE piftile, LPSL32 psize)
#else
GLOBAL UW16 CGENTRY
CGIFtile_nzw_buf(piftile, psize)
    PIFTILE    piftile;
    LPSL32      psize;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status = SUCCESS;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    if(if_state.non_z_wind)
    {
        *psize = (SL32)if_state.cs.tran_run_ct * (
                        (SL32)((sizeof(NZ_NODE) + MEM_ALIGN) & ~MEM_ALIGN)
                      + (SL32)(piftile->depth) * (SL32)(sizeof(NZCOUNTER))
                                                 );
        if(*psize > (SL32)MAX_BM)
        {
            status = ERRnzw_mem_overflow;
            goto done;
        }
       DBG1("nzw buf size %ld\n", *psize);
    }
    else
        *psize = 0L;

done:
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /*  NON_Z_WIND  */

/*----------------------*/
/*    CGIFtilebitMap    */
/*----------------------*/
/*   Make the bitmap tile in tile_bm.  */
#if MULTICALLER
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFtilebitMap(UW16 uCallerId, PIFTILE piftile, 
                      PIFBITMAP tile_bm, LPUB8 bold_buf1)
#else
GLOBAL UW16 CGENTRY
CGIFtilebitMap(uCallerId, piftile, tile_bm, bold_buf1)
    UW16       uCallerId;
    PIFTILE    piftile;
    PIFBITMAP  tile_bm;            /* Final result goes here */
    LPUB8      bold_buf1;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFtilebitMap(PIFTILE piftile, PIFBITMAP tile_bm,
    LPUB8 bold_buf1)
#else
GLOBAL UW16 CGENTRY
CGIFtilebitMap(piftile, tile_bm, bold_buf1)
    PIFTILE    piftile;
    PIFBITMAP  tile_bm;            /* Final result goes here */
    LPUB8      bold_buf1;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    BOOLEAN    save_or_on;
    UW16       status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    scan_convert.tile_on = 1;
    save_or_on = if_state.or_on;
    if_state.or_on=FALSE;
    state.bmbufs_dyn = FALSE;

    state.tile_box.ll.x = piftile->x;
    state.tile_box.ll.y = piftile->y;
    state.tile_box.ur.x = state.tile_box.ll.x + piftile->width;
    state.tile_box.ur.y = state.tile_box.ll.y + piftile->depth;

    state.bmb.bm  = tile_bm;
    state.bmb.orb = (LPUB8)0;
    state.nzw = bold_buf1;

    status = character();

    if_state.or_on = save_or_on;
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif
/*----------------------*/
/*    CGIFmakechar      */
/*----------------------*/
/*   Make the character bitmap in bm.  */
#if MULTICALLER
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFmakechar(UW16 uCallerId, PIFBITMAP bm, LPUB8 bold_buf1)
#else
GLOBAL UW16 CGENTRY
CGIFmakechar(uCallerId, bm, bold_buf1)
    UW16 uCallerId;
    PIFBITMAP bm;             /* Final result goes here */
    LPUB8    bold_buf1;      /* If this is not nul, we're doing bold */
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
GLOBAL UW16 CGENTRY CGIFmakechar(PIFBITMAP bm, LPUB8 bold_buf1)
#else
GLOBAL UW16 CGENTRY
CGIFmakechar(bm, bold_buf1)
    PIFBITMAP bm;             /* Final result goes here */
    LPUB8    bold_buf1;      /* If this is not nul, we're doing bold */
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

    DBG("\n\n\n\nCGIFmakechar()\n");

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

#if OUTLINE
  /* Make an outline in the app's buffer if that's what the format says */
    if (if_state.cs.format) 
    {
      status = outbuffer((PIFOUTLINE)bm);
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }
#endif

    scan_convert.tile_on = 0;
    state.bmbufs_dyn = FALSE;

    state.tile_box.ll.x =
    state.tile_box.ll.y = 0;
    state.tile_box.ur.x = entire_bm.black_width;
    state.tile_box.ur.y = entire_bm.black_depth;

    state.bmb.bm  = bm;
    state.bmb.orb = cc_buf;
    state.nzw = bold_buf1;

    status = character();
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /* CHAR_SIZE */
#if CACHE || CHAR_HANDLE
/*----------------------*/
/*    bitmap_dyn        */
/*----------------------*/
/*  This function is called by bitmap() and bitmap_tile() below.

    This function acquires and frees memory needed for bitmap construction
    through calls to CHARalloc() and CHARfree() and calls character() to
    actually build the character bitmap.  The steps are

    1. Acquire memory for the character bitmap and auxillary buffers and
       load references to the acquired memory in the bitmap buffer
        structure "state.bmb".
    2. Call character() to make the character bitmap.
    3. Free any auxillary buffers.  Normally, the character bitmap buffer
       is not freed but returned to the caller who is responsible for
       freeing it via CHARfree().  However, if character() returns an
       error, the character bitmap memory is also freed.
*/
#if defined (ANSI_DEFS)
MLOCAL UW16  bitmap_dyn(PHIFBITMAP phbm)
#else
MLOCAL UW16
bitmap_dyn(phbm)
    PHIFBITMAP     phbm;        /* Final result goes here */
#endif
{
    UW16           status;
    SL32           size;
    SL32           bm_size;

    DBG("bitmap_dyn()\n");
  /*-----------------------------------------------------
   *  Set up bitmap memory
   */

  /* Special case: 
   *     if space character, set "state.bmdim" to 0, get handle 
   *     and return!
   */

    if (!if_state.num_loops)  /* 6-19-92 */
       state.bmdim.x = state.bmdim.y = 0;  /* space character */
    else
    {
       state.bmdim.x = state.tile_box.ur.x - state.tile_box.ll.x + 1; /* off tran */
       state.bmdim.y = state.tile_box.ur.y - state.tile_box.ll.y;
       state.bmdim.x = (1 + (state.bmdim.x-1)/if_state.bit_map_width)
                               * (if_state.bit_map_width >>3);
       DBG2("    alignment = %d, width in bytes %u\n",
                                    if_state.bit_map_width, state.bmdim.x);
    }


  /* Nil out the handles in order to make error clean up work */

    state.bmb.horb = NIL_MH;
    state.hnzw     = NIL_MH;
    state.bmb.hbm = (HIFBITMAP)NIL_MH;

  /* compute bitmap size. */

    size = (SL32)state.bmdim.x * (SL32)state.bmdim.y;

    if(size > MAX_BM_SIZE)
      return ERR_bm_too_big;

    bm_size = size + (SL32)BMHEADERSIZE;


  /*  Get a new IFBITMAP */

    state.bmb.hbm = (HIFBITMAP)CHARalloc(bm_size);
    if(state.bmb.hbm == NIL_MH)
        goto error;
    state.bmb.bm = (PIFBITMAP)MEMptr(state.bmb.hbm);

    /* Special case:
     *     if space character, load handle into "phbm" and return
     */

    if (!if_state.num_loops)  /* 6-19-92 */
    {
       *phbm = state.bmb.hbm;
       return ERR_fixed_space;
    }

  /*  Add the number of bytes needed for a row (top and bottom fluff)
   *  times two so that missing pixel recovery will not overflow buffer
   *  and add to size of buffer.
   */
    if(if_state.or_on)
    {
           /* changed "bmdim.x" to "state.bmdim.x" - jfd 5-5-92 */
        state.bmb.horb = CHARalloc(size + (state.bmdim.x << 1));  /* dET 16-Apr 91 */
        if(state.bmb.horb == NIL_MH)
            goto error;
        state.bmb.orb = (LPUB8)MEMptr(state.bmb.horb);  /* added casts -ss 8/20/91 */
    }

    state.nzw_size = 0L;
#if NON_Z_WIND
    if(if_state.non_z_wind)
    {
        state.nzw_size = (SL32)if_state.cs.tran_run_ct * (
                           (SL32)((sizeof(NZ_NODE) + MEM_ALIGN) & ~MEM_ALIGN)
                         + (SL32)state.bmdim.y * (SL32)(sizeof(NZCOUNTER))
                                                         );

        DBG2("nzw: tran_run_ct %d    nzw_size  %ld\n",
                      if_state.cs.tran_run_ct, state.nzw_size);
        state.hnzw = CHARalloc(state.nzw_size);
        if (state.hnzw == NIL_MH)
            goto error;
        state.nzw = (LPUB8)MEMptr(state.hnzw);
    }
#endif

    goto good;

error:
    if(state.bmb.hbm != NIL_MH)
        CHARfree(state.bmb.hbm);
    if(state.bmb.horb != NIL_MH)
        CHARfree(state.bmb.horb);
    if(state.hnzw != NIL_MH)
        CHARfree(state.hnzw);
    status = ERR_bm_buff;
    state.bmb.hbm = (HIFBITMAP)NIL_MH;
    goto done;

good:

  /*-----------------------------------------------------
   *  Build the character bitmap
   */

    state.bmbufs_dyn = TRUE;
    status = character();
    if(status)
    {
        CHARfree(state.bmb.hbm);
        state.bmb.hbm = (HIFBITMAP)NIL_MH;
    }

  /*-----------------------------------------------------
   *  Free the auxillary buffers
   */

    if(state.bmb.horb != NIL_MH)
        CHARfree(state.bmb.horb);
    if(state.hnzw != NIL_MH)
        CHARfree(state.hnzw);

done:
    *phbm = state.bmb.hbm;
    return status;
}
#if TILE
/*----------------------*/
/*    bitmap_tile       */
/*----------------------*/
/*  Build a bitmap tile in memory dynamically allocated by CHARalloc().
 *  Return the handle of the bitmap tile.  Return NIL_MH if error.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  bitmap_tile(PIFTILE piftile, PHIFBITMAP phbm)
#else
GLOBAL UW16
bitmap_tile(piftile, phbm)
    PIFTILE        piftile;
    PHIFBITMAP     phbm;        /* Final result goes here */
#endif
{
    UW16    status;
    BOOLEAN save_or_on;

    DBG("bitmap_tile()\n");
    scan_convert.tile_on = 1;
    save_or_on = if_state.or_on;
    if_state.or_on=FALSE;

    state.tile_box.ll.x = piftile->x;
    state.tile_box.ll.y = piftile->y;
    state.tile_box.ur.x = state.tile_box.ll.x + piftile->width;
    state.tile_box.ur.y = state.tile_box.ll.y + piftile->depth;

    status = bitmap_dyn(phbm);

    if_state.or_on = save_or_on;
    return status;
}
#endif
/*----------------------*/
/*    bitmap            */
/*----------------------*/
/*  Build a bitmap in memory dynamically allocated by CHARalloc().
 *  Return the handle of the bitmap.  Return NIL_MH if error.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  bitmap(PHIFBITMAP phbm)
#else
GLOBAL UW16
bitmap(phbm)
    PHIFBITMAP  phbm;         /* Final result goes here */
#endif
{
    DBG("bitmap()\n");


    scan_convert.tile_on = 0;

    state.tile_box.ll.x =
    state.tile_box.ll.y = 0;
    state.tile_box.ur.x = entire_bm.black_width;
    state.tile_box.ur.y = entire_bm.black_depth;

    return bitmap_dyn(phbm);
}
#endif /* CACHE || CHAR_HANDLE */
#endif    /* CGBITMAP */
