/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/bmp/fill.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: fill.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.14   06 Apr 1995 15:08:22   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.13   22 Apr 1994 09:20:42   LISA
 * 
 * Modified copyright/disclaimer notice.
 * 
 *    Rev 1.12   09 Feb 1994 13:28:46   JOE
 * 
 * Changed cgfill() arg types for args 3 and 4 from SW16 to int to 
 * match !ANSI_DEFS version.
 * 
 *    Rev 1.11   02 Sep 1993 13:24:48   JOE
 * 
 * In THIRTYTWO_BIT_CHUNK version of get_bytes() macro, added missing ";"
 * before closing "}".
 * 
 *    Rev 1.10   27 Jul 1993 12:31:42   AL
 * Non-zero winding changes
 * 
 *    Rev 1.8   14 May 1993 16:02:00   JOE
 * Rewrote byte_position() function so as too work on SPARC.
 * Fixed fill_bold() so as to work on SPARC.
 * 
 *    Rev 1.7   14 Apr 1993 08:45:24   JOE
 * Added ANSI_DEFS declaration for function byte_position().
 * 
 *    Rev 1.6   13 Apr 1993 09:13:02   JOE
 * Added external declaration for "bit[]" table because it has been moved 
 * from BITMAP.H .
 * 
 *    Rev 1.5   12 Apr 1993 10:45:34   JOE
 * In fill() and fill_bold(), fixed compiler errors when attempting to
 * autoincrement a pointer variable which is being cast to a different
 * type.
 * 
 *    Rev 1.4   07 Apr 1993 12:02:46   JOE
 * Added raster line organization support.
 * 
 *    Rev 1.3   12 Feb 1993 11:11:52   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   05 Jan 1993 16:03:28   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:28:16   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:33:10   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* fill.c */
/*
 *
 *
 * HISTORY:
 *
 *  27-Nov-90  bg   Changed type of "or_on" in EXTERN statement from
 *                  WORD to BOOLEAN to resolve some missing pixel
 *                  problems.
 *  30-Jan-91 dET   added funtion prototyping for MSC
 *  31-Jan-91 dET   Modify for MSC multi-model compilation. Change (BYTE)1-...
 *                  to (UBYTE)1-...
 *  10-Feb-91 awr   Moved making_bold and or_on to SCALE structure.
 *  17-Apr-91 awr   Conditionally compiled fill_bold()
 *  17-Jun-91 jfd   Moved "debug.h" after "port.h".
 *   1-Sep-91 awr   Included "bitmap.h"
 *  12-Oct-91 awr   Missing pixel recovery and pseudo bold are no 
 *                  longer mutually exclusive.
 *  24-Feb-92 jfd   Added include for <stdio.h>.
 *  03-Apr-92 rs    Portability cleanup (see port.h).
 *  15-Nov-92 rs    Port to Macintosh - rename fill() to cgfill().
 *  05-Jan-93 jfd   ANSI C function declaration changes.
 *  08-Feb-93 jfd   VXWorks support.
 *  07-Apr-93 jfd   Added support for raster line organizations.
 *  12-Apr-93 jfd   In fill() and fill_bold(), fixed compiler errors when
 *                  attempting to autoincrement a pointer variable which
 *                  is being cast to a different type.
 *  13-Apr-93 jfd   Added external declaration for "bit[]" table because it
 *                  has been removed from BITMAP.H.
 *  14-Apr-93 jfd   Added ANSI_DEFS declaration for function byte_position().
 *  13-May-93 jfd   Rewrote byte_position() function so as to work on
 *                  non-INTEL platforms.
 *                  Fixed fill_bold() so as to work on non-INTEL platforms.
 *  30-Jun-93 awr   Created more efficient nzw fill.
 *  02-Sep-93 jfd   In THIRTYTWO_BIT_CHUNK version of get_bytes() definition,
 *                  added missing ";" before closing "}".
 *  07-Feb-94 jfd   Changed cgfill() arg types for args 3 and 4 from SW16
 *                  to int to match !ANSI_DEFS version.
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "filltab.h"     /* definition of fill tables */
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "bitmap.h"




/*-------------------------------------------------*/
EXTERN IF_STATE if_state;
/*-------------------------------------------------*/

#if RASTER_ORG == SIXTEEN_BIT_CHUNK
#define get_bytes(b, c)  {b[0]=(UB8)(c&0xFF); b[1]=(UB8)(c>>8);}
#define put_bytes(b, c)  c = (((CHUNK)b[1])<<8) + ((CHUNK)b[0])
#elif RASTER_ORG == THIRTYTWO_BIT_CHUNK
#define get_bytes(b, c)  {b[0]=(UB8)(c&0xFF); c>>=8; \
                          b[1]=(UB8)(c&0xFF); c>>=8; \
                          b[2]=(UB8)(c&0xFF); b[3]=(UB8)(c>>8);}
#define put_bytes(b, c)  c = (((CHUNK)b[3] )<<24) + (((CHUNK)b[2] )<<16) + \
                             (((CHUNK)b[1] )<< 8) + ((CHUNK)b[0])
#endif

#if LEFT_TO_RIGHT_BIT_ORDER
#define set_first_byte(p,b)   p=&(b[CHUNK_COUNT-1])
#define next_byte(p)          p--
#else
#define set_first_byte(p,b)   p=b
#define next_byte(p)          p++
#endif




/*--------------------*/
/*    fill            */
/*--------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID
cgfill (LPUB8 srcptr, LPUB8 dstptr, int width, int depth,
        LPUB8 or_buffer)
#else
GLOBAL VOID
cgfill (srcptr, dstptr, width, depth, or_buffer)
    LPUB8  srcptr;
    LPUB8  dstptr;
    int    width;   /* width of bitmap in bytes   */
    int    depth;   /* depth of bitmap in rasters */
    LPUB8  or_buffer;
#endif
{
    UB8  p;

    SB8   mode;          /* writing beam mode.  Off = 0,  on = 1. */
    int    iw,id;
    LPCHUNK chunkdstptr;
    LPCHUNK chunksrcptr;


    DBG("cgfill()\n");

    /* Convert pointers to CHUNK-specific pointer variables */

    chunkdstptr = (LPCHUNK)dstptr;
    chunksrcptr = (LPCHUNK)srcptr;

#if (RASTER_ORG == EIGHT_BIT_CHUNK)
    {
        for (id=0; id<depth; id++)    /* for each horizontal raster       */
        {
            mode = 0;                   /* beam off at start of each raster */
            for(iw=0; iw < width; iw++) /* loop for each "chunk" of the raster */
            {
                p = *chunksrcptr++;  /* grab next byte */
                if(mode == 0)
                {
                    mode           = off_nxt[p];
                    *chunkdstptr++ = off_tab[p];
                }
                else
                {
                    mode           = (UB8)1 - off_nxt[p];
                    *chunkdstptr++ = ~off_tab[p];
                }
            }
        }
    }
#else   /* RASTER_ORG != EIGHT_BIT_CHUNK  */
    {
        int bct, num_chunks;
        CHUNK   chunk;
        UB8  b[CHUNK_COUNT];
        LPUB8 pb;

        num_chunks = width >> (CHUNK_SHIFT - 3);
        for (id=0; id<depth; id++)    /* for each horizontal raster       */
        {
            mode = 0;                   /* beam off at start of each raster */
            for(iw=0; iw < num_chunks; iw++)
            {
             /* Grab next byte of chunk */

                chunk = *chunksrcptr++;  /* grab chunk of bytes */
                get_bytes(b, chunk);
                set_first_byte(pb, b);
                for(bct=0; bct<CHUNK_COUNT; bct++)
                {
                    p = *pb;
                    if(mode ==0)
                    {
                        mode = off_nxt[p];
                        *pb  = off_tab[p];
                    }
                    else
                    {
                        mode = (UB8)1 - off_nxt[p];
                        *pb  = ~off_tab[p];
                    }
                    next_byte(pb);
                }
                put_bytes(b, chunk);
                *chunkdstptr++ = chunk;
            }
        }
    }
#endif  /* (RASTER_ORG != EIGHT_BIT_CHUNK) */

    if(if_state.or_on)
    {
        LPSB8      pbSrc;
        LPSB8      pbDes;
        SL32       tran_size, lw;
        LPCHUNK    chunkdptr;
        LPCHUNK    chunkorptr;

        /* Step 1, squip the or_buffer:
         *         "or" into the active bitmap area any
         *         pixels that have been set in the fluff portion
         *         of the or_buffer.
         */
        /* set pointers to top; src pointer to fluff and
                                des pointer to or_buf */
        pbDes = (LPSB8)or_buffer;
        pbSrc = (LPSB8)or_buffer - width;

        for(iw=0;iw<width;iw++)
            *pbDes++ |= *pbSrc++;

        /* set pointers to bottom; src pointer to fluff and des pointer to or_buf */

        tran_size = (SL32)width * (SL32)depth;
        pbSrc = (LPSB8)or_buffer + tran_size;
        pbDes = pbSrc - width;

        for(iw=0;iw<width;iw++)
            *pbDes++ |= *pbSrc++;

        /* Step 2:  Merge the or buffer into the final bitmap */

        chunkorptr  = (LPCHUNK)or_buffer;
        chunkdptr = (LPCHUNK)dstptr;    /* remember start of destination */
        tran_size >>= (CHUNK_SHIFT - 3);
        for(lw=0; lw < tran_size; lw++) *chunkdptr++ |= *chunkorptr++;
    }
}
