/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/bmp/lmath.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: lmath.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.11   04 Aug 1995 17:28:42   JOE
 * Fixed carry bit logic in routine Ladd().
 * 
 * 
 *    Rev 1.10   06 Apr 1995 15:08:26   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.9   27 Sep 1994 13:27:22   MIKE
 * Change TT_RDR conditional code to (TT_RDR || FCO_RDR)
 * 
 *    Rev 1.8   22 Apr 1994 09:20:42   LISA
 * 
 * Modified copyright/disclaimer notice.
 * 
 *    Rev 1.7   03 Sep 1993 11:11:38   JOE
 * 
 * Changed the conditional compile statement for the entire module
 * from DRAS_QUAD.
 * 
 *    Rev 1.6   01 Jul 1993 14:19:10   MAIB
 * fixed prototype
 * 
 *    Rev 1.5   06 May 1993 17:53:04   ROB
 * Added global 'int iLMATH=0' for use w/ANSI C.
 * 
 *    Rev 1.4   05 May 1993 09:28:46   JOE
 * Included "cgconfig.h".
 * 
 *    Rev 1.3   05 May 1993 08:23:30   JOE
 * Conditionally compiled the entire module based on DRAS_QUAD.
 * 
 *    Rev 1.2   29 Mar 1993 13:35:28   JOE
 * Added function prototypes for Lneg(), Ladd() and Lmul(). Got rid of
 * compiler warnings by enclosing comment delimiters after #endif directives.
 * 
 *    Rev 1.1   22 Jan 1993 08:23:40   JOE
 * Ifdef'd out the parts not needed by MagicChef to save space
 * (done by Fred).
 * 
 *    Rev 1.0   20 Jan 1993 10:23:48   LISA
 * Initial revision.
 * 
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* lmath.c */
/* Copyright (C) Agfa Compugraphic, 1990. All rights reserved. */
/*
 *
 *  28-Jul-90 awr  created
 *  21-Jan-93 fa   ifdef out the parts not needed by Magic Chef to save space
 *  29-Mar-93 jfd  Added function prototypes for Lneg(), Ladd() and Lmul().
 *                 Got rid of compiler warnings by enclosing comment
 *                 delimiters after #endif directives.
 *  05-May-93 jfd  Conditionally compiling entire module based on DRAS_QUAD.
 *                 Including "cgconfig.h".
 *  06-May-93 rs   Add global 'int iLMATH = 0' if nothing else is declared.
 *                 Otherwise, will not compile w/ANSI C.
 *  01-Jul-93 maib Put ANSIDEFS check around Lneg(), Ladd() and Lmul()
 *  31-Aug-93 jfd  Conditionally compiling entire module based on
 *                 (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR)).
 *  27-Sep-94 mby  Change "TT_RDR" conditional code to (TT_RDR || FCO_RDR).
 *  04-Aug-95 mac  Fixed carry bit logic in routine Ladd().
 */

#include "cgconfig.h"

#if (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR))

#define JUSTMAGCHEF 1	/*don't compile parts not needed by Magic Chef*/


#define GLOBAL /**/
typedef unsigned short UWORD;
typedef long LONG;
typedef unsigned long ULONG;

#define LMATH_DIV0   1
#define LMATH_DIV_OV 2

GLOBAL UWORD Lmath_code;



#define HIBIT 0x80000000

/* LT() and LE() only work for positive x and y */
#define LT(x, y) ((x.hi<y.hi) || ( x.hi == y.hi && x.lo <  y.lo))
#define LE(x, y) ((x.hi<y.hi) || ( x.hi == y.hi && x.lo <= y.lo))

#define LEFTSHIFT(x)  x.hi<<=1; if(x.lo&HIBIT) x.hi|=1; x.lo<<=1
#define RIGHTSHIFT(x) x.lo>>=1; if(x.hi&1) x.lo|=HIBIT; x.hi>>=1
#define FLO(x)  (x & 0xffff)
#define FHI(x)  (x >> 16)


typedef struct
        {
            ULONG lo;
            ULONG hi;
        } DLONG;


#if defined (ANSI_DEFS)
GLOBAL DLONG Lneg(DLONG);
GLOBAL DLONG Ladd(DLONG, DLONG);
GLOBAL DLONG Lmul(LONG , LONG);
#else
GLOBAL DLONG Lneg();
GLOBAL DLONG Ladd();
GLOBAL DLONG Lmul();
#endif

#ifndef JUSTMAGCHEF

#define DLONG_2_LONG(x)   (x & 0xffffffff)
/*------------------*/
/*   LONG_2_DLONG   */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL DLONG LONG_2_DLONG(LONG x)
#else
GLOBAL DLONG
LONG_2_DLONG(x)
    LONG x;
#endif
{
    DLONG r;

    r.lo = x;

    if(x<0)
        r.hi = -1;
    else
        r.hi = 0;

    return r;
}

#endif /* JUSTMAGCHEF */


/*------------------*/
/*       Lneg       */
/*------------------*/
/* return -x */
#if defined (ANSI_DEFS)
GLOBAL DLONG Lneg(DLONG x)
#else
GLOBAL DLONG
Lneg(x)
    DLONG x;
#endif
{
    DLONG r;

    x.lo = ~x.lo;
    x.hi = ~x.hi;
    r.lo = x.lo + 1;
    r.hi = x.hi;
    if(!(r.lo & HIBIT) && (x.lo & HIBIT))
        r.hi++;

    return r;
}




/*------------------*/
/*       Ladd       */
/*------------------*/
/* return x + y */
#if defined (ANSI_DEFS)
GLOBAL DLONG Ladd(DLONG x, DLONG y)
#else
GLOBAL DLONG
Ladd(x, y)
    DLONG x, y;
#endif
{
    DLONG r;

    r.lo = x.lo + y.lo;
    r.hi = x.hi + y.hi;

  /*  If hi bit of either x.lo or y.lo is on and the hi bit of r.lo
   *  isn't on, then there is a carry to r.hi
   */
    if( ( (!(r.lo & HIBIT)) && ((x.lo & HIBIT) || (y.lo & HIBIT)) ) || ((x.lo & HIBIT) && (y.lo & HIBIT)) )
        r.hi++;

    return r;
}


#ifndef JUSTMAGCHEF

/*------------------*/
/*       Lsub       */
/*------------------*/
/* return x - y */

#if defined (ANSI_DEFS)
GLOBAL DLONG Lsub(DLONG x, DLONG y)
#else
GLOBAL DLONG
Lsub(x, y)
    DLONG x, y;
#endif
{
    return Ladd(x, Lneg(y));
}

#endif /* JUSTMAGCHEF */


/*------------------*/
/*       Lmul       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL DLONG Lmul(LONG x, LONG y)
#else
GLOBAL DLONG
Lmul(x, y)
    LONG x, y;
#endif
{
    int sign;
    ULONG a1, a2, a3, a4;   /* Partial products */
    DLONG p;                /* Product          */

  /*  We'll work with positive numbers so remember sign of product */

    sign = 1;
    if(x < 0)
    {
        x = -x;
        sign = -sign;
    }
    if(y < 0)
    {
        y = -y;
        sign = -sign;
    }
  /* compute partial products */
 
    a1 = FLO(x) * FLO(y);
    a2 = FHI(x) * FLO(y);
    a3 = FLO(x) * FHI(y);
    a4 = FHI(x) * FHI(y);

  /* Add partial products */

    a4 += FHI(a2) + FHI(a3);
    a2 =  FLO(a2) + FLO(a3) + FHI(a1);
    a4 += FHI(a2);
    a1 =  FLO(a1) + (a2<<16);

    p.hi = a4;
    p.lo = a1;

    if(sign < 0) p = Lneg(p);
    return p;
}



#ifndef JUSTMAGCHEF

/*------------------*/
/*       Ldiv       */
/*------------------*/
/*  Divide a DLONG by a long and return a LONG */
#if defined (ANSI_DEFS)
GLOBAL LONG Lidv(DLONG x, LONG y)
#else
GLOBAL LONG
Ldiv(x, y)
    DLONG x;
    LONG  y;
#endif
{
    LONG  q;      /* quotient */
    DLONG d;      /* divisor  */
    int  sign;
    int  qct;	/*quotient shift count*/

  /* Check for divide by 0 */

    if(!y)
    {
        Lmath_code  = LMATH_DIV0;
        return 0L;
    }

    if(!x.lo && !x.hi) return 0L;

  /*  We'll work with positive numbers so remember sign of quotient */

    sign = 1;
    if(x.hi && HIBIT)
    {
        x = Lneg(x);
        sign = -sign;
    }
    if(y < 0)
    {
        y = -y;
        sign = -sign;
    }

  /* if x < y the quotient is 0 */

    if(!x.hi && (x.lo < y)) return 0L;

  /* Load the divisor */

    d.hi = 0;
    d.lo = y;

  /*  x >= d so shift d to the left as far as possible so that x >= d  */

    qct = 1;
    while(LE(d, x))
    {
        LEFTSHIFT(d);
        qct++;
    }
    RIGHTSHIFT(d);
    qct--;
 
    if(qct > 31)
    {
        Lmath_code  = LMATH_DIV_OV;
        return 0L;
    }

    q = 0;
    while(qct)
    {
        q <<=1;
        if(LE(d,x))
        {
            if(d.lo > x.lo)
                x.hi -= 1;
            x.lo -= d.lo;
            x.hi -= d.hi;
            q |= 1;
        }
        LEFTSHIFT(x);
        qct--;
    }
 
    if(sign < 0) q = -q;
 
    return q;
}

#endif /* JUSTMAGCHEF */
#else  /* !(CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR)) */
int iLMATH = 0;     /* need at least 1 external declaration for ANSI C */
#endif /*  (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR)) */
