/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/bmp/raster.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: raster.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.40   02 Aug 1995 18:08:06   JOE
 * Removed faulty test in quad_direct() to compute ddd.
 * 
 *    Rev 1.39   25 Jul 1995 16:42:48   JOE
 * In bmras_quad_flat(), shift "if_state.p0.x" and "if_state.p0.y" when
 * done (by dbk).
 * (Above statement should say "bmras_quad_direct()", not "bmras_quad_flat()")
 * In bmras_quad_flat(), change TOL_QUAD_FLAT from 4 to 2 for better
 * performance without appreciable loss of quality (by mac).
 * 
 *    Rev 1.38   06 Apr 1995 15:08:18   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.37   14 Feb 1995 20:48:50   MIKE
 * 
 * In NZW routines changed COUNTER types to NZCOUNTER.
 * 
 *    Rev 1.36   01 Feb 1995 16:47:52   JOE
 * Fixed bug in quad_direct() when there is not enough_xres (by mac).
 * 
 *    Rev 1.35   18 Jan 1995 15:53:14   JOE
 * Defined missing ANSI function definitions (by mac).
 * 
 *    Rev 1.34   18 Nov 1994 14:52:28   JOE
 * Fixed SPARC compiler warning messages (by mac).
 * 
 *    Rev 1.32   27 Sep 1994 13:38:20   MIKE
 * 
 * Compile to work with FCO_RDR only.
 * 
 *    Rev 1.31   03 Aug 1994 15:00:16   MIKE
 * Added FCO changes from 1.26.1.1
 * 
 *    Rev 1.30   13 Jul 1994 15:51:20   JOE
 * In bmras_quad_direct(), replaced call to macro rev_x() if "xdir<0"
 * with in-line code because "testA" and "testB" are already set
 * correctly. This resolves the horizontal scan line problem.
 * 
 *    Rev 1.29   03 Jun 1994 09:33:54   JOE
 * 
 * Changed function type of bmras_quad_inactive() from GLOBAL to
 * MLOCAL to resolve compiler error.
 * 
 *    Rev 1.28   22 Apr 1994 09:20:46   LISA
 * 
 * Modified copyright/disclaimer notice.
 * 
 *    Rev 1.27   28 Mar 1994 10:06:42   JOE
 * Modified macro rev_x() and function bmras_quad_direct() to fix Lucida
 * rasterization bug (writing outside memory).
 * 
 *    Rev 1.26   16 Dec 1993 10:46:06   JOE
 * 
 * In nz_init() and nz_close_run(), changed all references of 
 * "if_state.cs.tran_run_ct" to "ras.tran_run_ct".
 * 
 *    Rev 1.25   24 Sep 1993 08:23:38   JOE
 * In bmras_quad_direct(), when calculating START.y, cast "y" as a SL32
 * to prevent truncation of expression "(y << log_ypix)" to an "int",
 * which causes integer overflow when dealing with large point sizes.
 * 
 *    Rev 1.24   15 Sep 1993 13:13:44   JOE
 * In bmras_quad_direct(), clip any control points which lie outside the
 * bounding box. This resolves the banding problem which occurs when
 * rotating bitmaps with MagicChef enabled.
 * 
 *    Rev 1.23   09 Sep 1993 11:51:48   JOE
 * Added dummy routine "bmras_quad_inactive()" to satisfy compiler when
 * neither "bmras_quad_flat()" nor "bmras_quad_direct()" is active.
 * Changed conditional compile statements inside "bmras_tbl[]" for
 * "bmras_quad_direct" and "bmras_quad_flat".
 * 
 *    Rev 1.22   03 Sep 1993 11:36:30   JOE
 * 
 * Changed the bmras_tbl[] entry for "bmras_quadto" to either
 * "bmras_quad_direct" or "bmras_quad_flat".
 * Changed the name of the DRAS_QUAD version of bmras_quadto() to
 * bmras_quad_direct() and conditionally compile based on (CGBITMAP ||
 * DRAS_QUAD && (IF_RDR || TT_RDR)).
 * Changed the name of the !DRAS_QUAD version of bmras_quadto() to
 * bmras_quad_flat() and conditionally compile based on ((DRAS_QUAD &&
 * LINEAR && (IF_RDR || TT_RDR)) || (!DRAS_QUAD && TT_RDR)).
 * Conditionally compile raster() based on CGBITMAP.
 * 
 *    Rev 1.21   02 Sep 1993 13:06:00   JOE
 * Corrected typo in bit[] table for SIXTYFOUR_BIT_CHUNK and
 * LEFT_TO_RIGHT_BIT_ORDER.
 * 
 *    Rev 1.20   10 Aug 1993 15:25:38   JOE
 * 
 * In raster(), conditionally compiled call to ifrender() based on
 * IF_RDR.
 * 
 *    Rev 1.19   04 Aug 1993 16:59:14   JOE
 * Added missing ';' to function prototype for "nz_init()".
 * In nz_close_run(), changed line "pnew->onoff = +1" to "pnew->onoff = 1"
 * to resolve compiler error.
 * 
 *    Rev 1.18   02 Aug 1993 13:06:22   AL
 * Conditioned nzw code in bmras_moveto() on if_state.non_z_wind
 * 
 *    Rev 1.17   29 Jul 1993 12:36:40   AL
 * 
 * More nzw changes
 * 
 *    Rev 1.16   27 Jul 1993 12:27:34   AL
 * Non-zero winding changes
 * 
 *    Rev 1.15   01 Jul 1993 14:17:24   MAIB
 * See comment below for description of changes made
 * 
 *    Rev 1.14   12 May 1993 15:57:26   ROB
 * Clean up compiler warnings - nested comments.
 * 
 *    Rev 1.13   04 May 1993 16:43:02   ROB
 * Add 'DRAS_QUAD' for direct rasterization of quadratic beziers.
 * 
 *    Rev 1.12   21 Apr 1993 08:32:34   JOE
 * In bmras_lineto() and bmras_quadto(), added casts when calculating "x" and
 * "START.x" so that all operands are of the same type. (Fixes MagicChef
 * banding problem.)
 * 
 *    Rev 1.11   13 Apr 1993 13:16:06   JOE
 * In raster(), conditionally compiled calls to psrender() and ttrender()
 * if !USE_JUMP_TABLES.
 * 
 *    Rev 1.10   13 Apr 1993 08:49:34   JOE
 * Moved "bit[]" table from BITMAP.H .
 * 
 *    Rev 1.9   12 Apr 1993 10:48:00   JOE
 * In set_bold(), cast "x>>CHUNK_SHIFT" as CHUNK to get rid of compiler warning.
 * 
 *    Rev 1.8   07 Apr 1993 11:33:26   JOE
 * Added raster line organization support.
 * 
 *    Rev 1.7   29 Mar 1993 13:28:28   JOE
 * MagicChef changes: Added function prototypes for Lneg() and Ladd().
 * 
 * In bmras_quadto(), cast "(xdir^ras.ydir)^alpha" as SL32 to resolve
 * mixed mode problem.
 * 
 *    Rev 1.6   12 Feb 1993 10:58:38   JOE
 * VXWorks support.
 * 
 *    Rev 1.5   22 Jan 1993 13:27:20   JOE
 * 
 * Fixed up comments following #endif directives for TILE.
 * 
 *    Rev 1.4   22 Jan 1993 08:41:46   JOE
 * 
 * More MagicChef changes (by Fred).
 * 
 *    Rev 1.3   20 Jan 1993 09:34:42   JOE
 * Magic Chef modifications (by Fred) - fixed overflows, skinny parabolas,
 * added missing pixel recovery and tiling.
 * 
 *    Rev 1.2   05 Jan 1993 15:29:02   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:29:08   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:32:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* raster.c */



/*------------------------------------------------------------------------
   25-Nov-90  awr  Changed d.y.margin to plus half pixel round. Removed
                   tty. Removed hiyrnd.
   23-Oct-90  dET  Added function prototyping for MSC
   22-Dec-90  dET  Forced "or_on" to be in the data segment by
                   initialization.  This allows fill.asm to be slighly
                   optimized.  This is a MSC qwirk.
   10-Jan-91  jfd  Added awr's enhancements.
   31_jan-91  dET  Force variables "x_tran, y_tran" (by initalization) to be
                   located in DATA segment of 80X86 compilers.  Refer to
                   optimized "imath.asm". May be ignored for other processors.
    3-Feb-91  awr  removed imath function declarations and
                   include imath.h, updated copyright.
   10-Feb-91  awr  Moved making_bold and or_on to SCALE structure.
   08-Mar-91  jfd  For MULTI-MODEL, change references to LOOP* to PLOOP.
   19-May-91  awr  Change in LOOP structure, nxt_pt() coded in line.
                   Double rounding corrected.
    2-Jun-91  awr  HQ4 changes
    9-Jun-91  awr  added bitmap dimension parameter to raster
   17-Jun-91  jfd  Moved "debug.h" after "port.h".
                   Moved "profile.h" after "port.h".
   21 Aug 91  ss   Changed defines for local vars from PBYTE to PUBYTE in
                   raster() to match the usage.
   24-Aug-91  awr  Moved function decls to include files
    1-Sep-91  awr  Included "bitmap.h"
   14-Sep-91  awr  Changed use of cp
   12-Oct-91  awr  Missing pixel recovery and pseudo bold are no 
                   longer mutually exclusive.
   14-Oct-91  awr  Ported 2.3J missing pixel recovery
   18-Oct-91  jfd  Declare "scan_convert" conditionally based on
                   TILE.
   10-Nov-91  awr  Correct rounding when xpixel = 1.
   12-Nov-91  jfd  In raster(), changed line "xdir = +1;" to "xdir = 1;"
                   for SUN/SPARC compatability.
   22-Nov-91  awr  Turned inside out- one function call entry for each
                   element to be scan converted.
   23-Nov-91  awr  Replaced one if(direction...) in each missing pixel
                   macro with an else.
   26-Nov-91  awr  In raster(), when calculating "toff", cast operands
                   of multiplication as LONGs. Changed line "if (dx<0)"
                   to "if (dx>0)" when calculating x-direction.
   22-Jan-92  rs   Change names of UFST bitmap funcs to 'bmras_xxxx()'.
                   Call raster functions via ptr 'pras->'.
   24-Jan-92  awr  Add EXTERN for 'psrender()'.
   28-Jan-92  rs   Add PBUCKET to xxrender() calling args.
   05-Feb-92  mby  Fix ras.fhalf_xpix calculation in bmras_start_char().
                   (FOR THE MOMENT, WE CONDITIONALLY COMPILED!!!!!)
                   Added #if DIRECT_RASTERIZATION in bmras_quadto().
                   Added flatten_quad() routine, called from quadto().
   24-Feb-92  jfd  Added function prototype for offsetcheck().
    4 Mar 92  ss   Added !LINT_ARGS prototypes for curve(), vertline(),
                   vlineto(), and ifrender().
                   Deleted VOID arguments to function declarations of
                   bmras_end_char() and bmras_end_loop() which caused a
                   problem on SUN.
   22-Mar-92  awr  Straightened up interfaces for test scan converters.
                   Moved clip_fops_top and clip_fops_bot to ras structure
                   from scan_convert structure
                   Moved computation of "clip_fops" to start char from
                   bitmap.c and maker.c
   03-Apr-92  rs   Portability cleanup (see port.h).
   21-May-92  jfd  Changed argument list for bmras_start_char() from
                   VOID to PVOID so as to agree in number with arg
                   list for _olstartchar().
                   In ifrender(), when calling "ras_start_char()", 
                   pass PVOID argument.
   29-May-92  jfd  Changed type "OLSTATS" to "CHAR_STATS" due to change 
                   in "ix.h", both in external declaration for "olstats"
                   and in structure RASTER.
    4-Jun-92  jfd  In ifrender(), when calling "start_char()" pass 
                   "&olstats".
    8-Jun-92  jfd  Removed all refernces to "olstats".
                   In ifrender(), pass "&if_state.cs" to start_char() 
                   instead of "&olstats".
   23-Jun-92  jfd  In flatten_quad(), added declaration for "status".
   28-Jun-92  awr  Changed call to render for 16bit scan conversion
   10-Jul-92  jfd  In offsetcheck(), replaced "printf"'s with "DBG"'s.
   21-Jul-92  awr  Conditional compile changes
   23-Jul-92  awr  Removed DBG printing of tbound at start of raster
   31-Jul-92  rs   Changed TOL_QUAD and TOL_CUBE from 1 to 4 for better
                   quality.
   04-Aug-92  jfd  In ifrender(), store global function pointer "lineto"
                   with pointer to lineto() function for optimization.
   14-Sep-92  jfd  Conditionally compiled function prototype for ifrender()
                   based on IF_RDR.
   21-Sep-92  jfd  Changed "ras" declaration from MLOCAL to GLOBAL (needs
                   to be accessed by QUADRA.C)
                   Moved typedef for RASTER to BITMAP.H.
   10-Oct-92  rs   Implement USE_JUMP_TABLES feature for overlays.
   23-Oct-92  rs   Conditionally compiled function prototype for set_bold()
                   based on BOLD
   24-Oct-92  awr  Added MAKE_BITMAP define for timing
   15-Nov-92  rs   Port to Mac - conditionalize bmras_cubeto() for PST1_RDR.
   05-Jan-93  jfd  ANSI C function declaration changes.
   18-Jan-93  fa   Modified Magic Chef, fixed overflows, skinny parabolas
                   added missing pixel recovery and tiling
                   Made it work for both 16 & 32 INTR_SIZE.
   22-Jan-93  fa   More MagicChef changes.
   22-Jan-93  jfd  Fixed up comments following #endif directives for TILE.
   08-Feb-93  jfd  VXWorks support.
   29-Mar-93  jfd  In bmras_quadto(), cast "(xdir^ras.ydir)^alpha" as SL32 
                   to resolve mixed mode problem.
                   Added function prototypes for Lneg() and Ladd().
   07-Apr-93  jfd  Added support for raster line organizations.
                   Removed MAKE_BITMAP #define (Always assume TRUE)
   12-Apr-93  jfd  In set_bold(), cast "x>>CHUNK_SHIFT" as CHUNK to get rid
                   of compiler warning.
   13-Apr-93  jfd  Moved "bit[]" table from BITMAP.H.
   13-Apr-93  jfd  In raster(), conditionally compiled calls to psrender()
                   and ttrender() if !USE_JUMP_TABLES.
   21-Apr-93  jfd  In bmras_lineto() and bmras_quadto(), added casts
                   when calculating "x" and "START.x" so that all operands
                   are of the same type.
   04-May-93  rs   Utilize new define 'DRAS_QUAD' from cgconfig.h for
                   direct rasterization of quadratic beziers.
   12-May-93  rs   Code cleanup - remove nested comments in bmras_quadto().
   01-Jul-93 maib  Moved ifrender() to quadra.c, removed quadra() 
                   declarations, changed making_bold to non_z_wind.
                   Changed conditional compilation of non_z_wind code to be
                   based on new define NON_Z_WIND rather than BOLD
   02-Aug-93 awr   Conditioned nzw code in bmras_moveto() on
                   if_state.non_z_wind.
   04-Aug-93 jfd   Corrected function prototype for "nz_init()". (Added
                   missing ';')
                   In nz_cose_run(), changed line "pnew->onoff = +1;" to
                   "pnew->onoff = 1" to resolve compiler error.
   10-Aug-93 jfd   In raster(), conditionally compile call to ifrender()
                   based on IF_RDR.
   02-Sep-93  jfd  Corrected typo in bit[] table for SIXTYFOUR_BIT_CHUNK
                   and LEFT_TO_RIGHT_BIT_ORDER.
   03-Sep-93  jfd  Changed the bmras_tbl[] entry replacing "bmras_quadto"
                   with either "bmras_quad_direct" or bmras_quad_flat".
                   Changed the name of the DRAS_QUAD version of
                   bmras_quadto() to bmras_quad_direct() and conditionally
                   compile basd on (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR))
                   Changed the name of the !DRAS_QUAD version of
                   bmras_quadto() to bmras_quad_flat() and conditionally
                   compile based on ((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR))
                   || (!DRAS_QUAD && TT_RDR))
                   Conditionally compiling raster() based on CGBITMAP.
   09-Sep-93  jfd  Added dummy routine "bmras_quad_inactive()" to satisfy
                   compiler when neither "bmras_quad_flat()" or 
                   "bmras_quad_direct()" is active.
                   Changed conditional compile statements inside bmras_tbl[]
                   for "bmras_quad_direct" and "bmras_quad_flat".
   15-Sep-93  jfd  In bmras_quad_direct(), clip any contrl points which
                   lie outside bounding box. This resolves the banding
                   problem which occurs when rotating bitmaps with
                   DRAS_QUAD enabled.
   24-Sep-93  jfd  In bmras_quad_direct(), when calculating START.y,
                   cast "y" as a SL32 to prevent truncation of expression
                   "(y << log_ypix)" to an "int", which causes integer
                   overflow when dealing with large point sizes.
   16-Dec-93  jfd/jc In nz_init() and nz_close_run(), changed all references
                   of "if_state.cs.tran_run_ct" to "ras.tran_run_ct".
   28-Mar-94  awr  Modifed macro rev_x() and function bmras_quad_direct()
                   to fix Lucida rasterization bug (writing outside memory).
   03-Jun-94  jfd  Changed function type of bmras_quad_inactive() from
                   GLOBAL to MLOCAL to resolve compiler error.
   13-Jul-94  awr  In bmras_quad_direct(), replaced call to macro rev_x()
                   if "xdir < 0" with in-line code because "testA" and
                   "testB" are already set correctly. This resolves the
                   horizontal scan line problem.
   14-Nov-94  mac  Revised and Enhanced Missing Pixel Recovery Heuristics.
                   The rasterizer now has more "intelligence" like a true
                   TrueType rasterizer by incorporating the pseudo stroke
                   concept for dropout control. 
   16-Nov-94  mac  Merged the patch to avoid overflow in lineto with long
                   diagonal lines when TILE is on. Work done by mby.
   18-Nov-94  mac  Fixed SPARC compiler warning messages.
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 FCO Changes from 1.26.1.1:
   14-Mar-94  mby  If FCO enabled, raster() calls fco_render().
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   27-Sep-94  mby  Make provision for FCO_RDR only. Wherever there is
                   conditional code "TT_RDR", change it to (TT_RDR || FCO_RDR).
   18-Jan-95  mac  Defined missing ANSI function definitions.
   01-Feb-95  mac  Fixed bug in quad_direct() when there is not enough_xres.
   14-Feb-95  mby  In nz_ routines (nonzero winding) changed COUNTER types
                   to NZCOUNTER to save space on 32-bit CPUs.
   25-Jul-95  dbk  In bmras_quad_direct(), shift "if_state.p0.x" and
                   "if_state.p0.y" when done.
   25-Jul-95  mac  Change TOL_QUAD_FLAT in bmras_quad_flat() from 4 down to 2
                   for better performance without loss of appreciable quality.

   02-Aug-95  mac  Removed faulty test in quad_direct() to compute ddd.
                   Added DBG's statements to quad_direct().

------------------------------------------------------------------------*/

#define AGFA_CUBE 1


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <string.h>
#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "cgif.h"
#include "q3.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "bitmap.h"


#ifdef LINT_ARGS
MLOCAL UW16   bmras_start_char(PVOID);
MLOCAL UW16   bmras_end_char(VOID);
MLOCAL UW16   bmras_start_loop(UW16);
MLOCAL UW16   bmras_end_loop(VOID);
MLOCAL UW16   bmras_moveto(INTR, INTR);
MLOCAL UW16   bmras_lineto(INTR, INTR);
#if (!(CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR)))
#if (!((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR))))
MLOCAL UW16   bmras_quad_inactive(INTR, INTR, INTR, INTR);
#endif
#endif
#if (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR))
GLOBAL UW16   bmras_quad_direct(INTR, INTR, INTR, INTR);
#endif
#if ((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR)))
GLOBAL UW16   bmras_quad_flat(INTR, INTR, INTR, INTR);
#endif
#if PST1_RDR
GLOBAL UW16   bmras_cubeto (INTR, INTR, INTR, INTR, INTR, INTR);
#endif

#ifdef DEBUG
MLOCAL VOID    offsetcheck(VOID);
#endif  /* DEBUG */

#else

MLOCAL UW16   bmras_start_char();
MLOCAL UW16   bmras_end_char();
MLOCAL UW16   bmras_start_loop();
MLOCAL UW16   bmras_end_loop();
MLOCAL UW16   bmras_moveto();
MLOCAL UW16   bmras_lineto();
#if (!(CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR)))
#if (!((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR))))
MLOCAL UW16   bmras_quad_inactive();
#endif
#endif
#if (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR))
GLOBAL UW16   bmras_quad_direct();
#endif
#if ((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR)))
GLOBAL UW16   bmras_quad_flat();
#endif
#if PST1_RDR
GLOBAL UW16   bmras_cubeto ();
#endif

#ifdef DEBUG
MLOCAL VOID    offsetcheck();
#endif  /* DEBUG */

#endif  /* LINT_ARGS */




/*  Output function interface structure for bitmaps... */
#if ((TT_RDR || FCO_RDR) && !PST1_RDR)  /* Add FCO_RDR, 09-26-94 */
GLOBAL OUT_TBL bmras_tbl = {
    bmras_start_char,
    bmras_end_char,
    bmras_start_loop,
    bmras_end_loop,
    bmras_moveto,
    bmras_lineto,
#if (CGBITMAP && DRAS_QUAD)
    bmras_quad_direct
#else
#if ((DRAS_QUAD && LINEAR) || !DRAS_QUAD)
    bmras_quad_flat
#endif
#endif
};
#else
GLOBAL OUT_TBL  bmras_tbl = {
    bmras_start_char,
    bmras_end_char,
    bmras_start_loop,
    bmras_end_loop,
    bmras_moveto,
    bmras_lineto,
#if (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR))  /* Add FCO_RDR, 09-26-94 */
    bmras_quad_direct
#else
#if ((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR)))
    bmras_quad_flat             /* Add FCO_RDR, 09-26-94 */
#else
    bmras_quad_inactive
#endif
#endif
#if PST1_RDR   
    ,bmras_cubeto
#endif  /* PST1_RDR */
};
#endif  /* !((TT_RDR || FCO_RDR) && !PST1_RDR) */

/*****************************************/
/*                                       */
/*      Raster Line Organizations        */
/*                                       */
/*****************************************/
#if (RASTER_ORG == EIGHT_BIT_CHUNK)

#if LEFT_TO_RIGHT_BIT_ORDER
GLOBAL  CHUNK bit[8] = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
#else
GLOBAL  CHUNK bit[8] = { 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
#endif

#elif (RASTER_ORG == SIXTEEN_BIT_CHUNK)

#if LEFT_TO_RIGHT_BIT_ORDER
GLOBAL  CHUNK bit[16] = { 0x8000, 0x4000, 0x2000, 0x1000,
                          0x0800, 0x0400, 0x0200, 0x0100,
                          0x0080, 0x0040, 0x0020, 0x0010,
                          0x0008, 0x0004, 0x0002, 0x0001};
#else
GLOBAL  CHUNK bit[16] = { 0x0001, 0x0002, 0x0004, 0x0008, 
                          0x0010, 0x0020, 0x0040, 0x0080,
                          0x0100, 0x0200, 0x0400, 0x0800,
                          0x1000, 0x2000, 0x4000, 0x8000};
#endif

#elif (RASTER_ORG == THIRTYTWO_BIT_CHUNK)

#if LEFT_TO_RIGHT_BIT_ORDER
GLOBAL  CHUNK bit[32] = { 0x80000000, 0x40000000, 0x20000000, 0x10000000,
                          0x08000000, 0x04000000, 0x02000000, 0x01000000,
                          0x00800000, 0x00400000, 0x00200000, 0x00100000,
                          0x00080000, 0x00040000, 0x00020000, 0x00010000,
                          0x00008000, 0x00004000, 0x00002000, 0x00001000,
                          0x00000800, 0x00000400, 0x00000200, 0x00000100,
                          0x00000080, 0x00000040, 0x00000020, 0x00000010, 
                          0x00000008, 0x00000004, 0x00000002, 0x00000001};
#else
GLOBAL  CHUNK bit[32] = { 0x00000001, 0x00000002, 0x00000004, 0x00000008, 
                          0x00000010, 0x00000020, 0x00000040, 0x00000080,
                          0x00000100, 0x00000200, 0x00000400, 0x00000800,
                          0x00001000, 0x00002000, 0x00004000, 0x00008000,
                          0x00010000, 0x00020000, 0x00040000, 0x00080000,
                          0x00100000, 0x00200000, 0x00400000, 0x00800000,
                          0x01000000, 0x02000000, 0x04000000, 0x08000000,
                          0x10000000, 0x20000000, 0x40000000, 0x80000000};
#endif

#elif (RASTER_ORG == SIXTYFOUR_BIT_CHUNK)

#if LEFT_TO_RIGHT_BIT_ORDER
GLOBAL  CHUNK bit[64] = {     0x8000000000000000,     0x4000000000000000,
                              0x2000000000000000,     0x1000000000000000,
                              0x0800000000000000,     0x0400000000000000,
                              0x0200000000000000,     0x0100000000000000,
                              0x0080000000000000,     0x0040000000000000,
                              0x0020000000000000,     0x0010000000000000,
                              0x0008000000000000,     0x0004000000000000,
                              0x0002000000000000,     0x0001000000000000,
                              0x0000800000000000,     0x0000400000000000,
                              0x0000200000000000,     0x0000100000000000,
                              0x0000080000000000,     0x0000040000000000,
                              0x0000020000000000,     0x0000010000000000,
                              0x0000008000000000,     0x0000004000000000,
                              0x0000002000000000,     0x0000001000000000,
                              0x0000000800000000,     0x0000000400000000,
                              0x0000000200000000,     0x0000000100000000,
                          0x80000000, 0x40000000, 0x20000000, 0x10000000,
                          0x08000000, 0x04000000, 0x02000000, 0x01000000,
                          0x00800000, 0x00400000, 0x00200000, 0x00100000,
                          0x00080000, 0x00040000, 0x00020000, 0x00010000,
                          0x00008000, 0x00004000, 0x00002000, 0x00001000,
                          0x00000800, 0x00000400, 0x00000200, 0x00000100,
                          0x00000080, 0x00000040, 0x00000020, 0x00000010, 
                          0x00000008, 0x00000004, 0x00000002, 0x00000001};
#else
GLOBAL  CHUNK bit[64] = { 0x00000001, 0x00000002, 0x00000004, 0x00000008,
                          0x00000010, 0x00000020, 0x00000040, 0x00000080,
                          0x00000100, 0x00000200, 0x00000400, 0x00000800,
                          0x00001000, 0x00002000, 0x00004000, 0x00008000,
                          0x00010000, 0x00020000, 0x00040000, 0x00080000,
                          0x00100000, 0x00200000, 0x00400000, 0x00800000,
                          0x01000000, 0x02000000, 0x04000000, 0x08000000,
                          0x10000000, 0x20000000, 0x40000000, 0x80000000,
                              0x0000000100000000,     0x0000000200000000,
                              0x0000000400000000,     0x0000000800000000,
                              0x0000001000000000,     0x0000002000000000,
                              0x0000004000000000,     0x0000008000000000,
                              0x0000010000000000,     0x0000020000000000,
                              0x0000040000000000,     0x0000080000000000,
                              0x0000100000000000,     0x0000200000000000,
                              0x0000400000000000,     0x0000800000000000,
                              0x0001000000000000,     0x0002000000000000,
                              0x0004000000000000,     0x0008000000000000,
                              0x0010000000000000,     0x0020000000000000,
                              0x0040000000000000,     0x0080000000000000,
                              0x0100000000000000,     0x0200000000000000,
                              0x0400000000000000,     0x0800000000000000,
                              0x1000000000000000,     0x2000000000000000,
                              0x4000000000000000,     0x8000000000000000};
#endif


#endif  /* RASTER_ORG == EIGHT_BIT_CHUNK */



/*================================================================*/
/*    Macros                                                      */


#define SETON { DBG("SETON\n"); \
    *((CHUNK *)((CHUNK *)(ras.or_buffer + ras.toff) + (ras.xx >> CHUNK_SHIFT))) \
           |= bit[ras.xx & CHUNK_MASK]; }

#define SETPH { DBG("SETPH\n"); \
    if ( ras.ptran == ras.xx ) { \
        *((CHUNK *)((CHUNK *)(ras.or_buffer + ras.toff) + (ras.xx >> CHUNK_SHIFT))) \
           ^= bit[ras.xx & CHUNK_MASK]; \
    }}

#define SET_A { DBG("SET_A\n"); \
    if ( ras.ydir < 0) { \
        for ( zz = ras.ptran; zz < ras.xx; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff-ras.dytran) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    } else { \
        for ( zz = ras.xx; zz < ras.ptran; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    }}

#define SET_B {DBG("SET_B\n"); \
    if (ras.ydir < 0) { \
        for ( zz = ras.ptran; zz < ras.xx; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff-ras.dytran) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    } else { \
        for ( zz = ras.xx; zz < ras.ptran; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    }}

#define SET_C {DBG("SET_C\n"); \
    if (ras.ydir < 0) { \
        for ( zz = ras.xx; zz < ras.ptran; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff-ras.dytran) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    } else { \
        for ( zz = ras.ptran; zz < ras.xx; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    }}

#define SET_D {DBG("SET_B\n"); \
    if (ras.ydir < 0) { \
        for ( zz = ras.xx; zz < ras.ptran; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff-ras.dytran) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    } else { \
        for ( zz = ras.ptran; zz < ras.xx; zz++ ) { \
            *((CHUNK *)((CHUNK *)(ras.or_buffer+ras.toff) + (zz >> CHUNK_SHIFT))) \
                |= bit[zz & CHUNK_MASK]; \
        } \
    }}


/*    Macros                                                      */
/*================================================================*/


EXTERN IF_STATE if_state;

GLOBAL RASTER ras;

#if TILE
EXTERN SCAN_CONVERT scan_convert;
#endif



#if TILE
#define HOR_TILE_CLIP if(scan_convert.tile_on)\
{   if(ras.xx < scan_convert.tb.ll.x) ras.xx = scan_convert.tb.ll.x;\
    if(ras.xx > scan_convert.tb.ur.x) ras.xx = scan_convert.tb.ur.x;\
    ras.xx -= scan_convert.tb.ll.x; }
#define VERT_TILE_CLIP if(!scan_convert.tile_on || \
    ((y>scan_convert.tb.ll.y) && (y<=scan_convert.tb.ur.y)))
#else
#define HOR_TILE_CLIP /**/
#define VERT_TILE_CLIP /**/
#endif

#if NON_Z_WIND
#define chng_tran_dir() \
 {ras.ydir     = -ras.ydir;    \
  ras.beam     =  !ras.beam;   \
  ras.yraster +=   ras.ydir;   \
  ras.dytran   = - ras.dytran; \
  ras.toff    +=   ras.dytran; \
  if ( if_state.non_z_wind && !pseudo_state ) nz_close_run(); }
#else
#define chng_tran_dir() \
 {ras.ydir     = -ras.ydir;    \
  ras.beam     =  !ras.beam;   \
  ras.yraster +=   ras.ydir;   \
  ras.dytran   = - ras.dytran; \
  ras.toff    +=   ras.dytran;}
#endif

#define wrRasterPixel(xx) {DBG1("                        xx %d\n",xx); \
                       *((CHUNK *)((CHUNK *)(ras.tran_buffer+ras.toff) + \
                             (xx >> CHUNK_SHIFT))) ^= bit[xx & CHUNK_MASK];}

#if NON_Z_WIND
#define writepixel(xx) {if(if_state.non_z_wind) \
                         {DBG1("nz_write_tran(%d)\n", xx); \
    if(ras.nz_done) ras.nz_overflow = 1;  else \
    {ras.nz_valCount ++;   *ras.nz_pval = xx;   ras.nz_pval += ras.ydir;}}\
  else wrRasterPixel(xx)}
#else
#define writepixel(xx) wrRasterPixel(xx)
#endif




#ifdef DEBUG
/*-------------------*/
/*  offsetcheck      */
/*-------------------*/
/*  If DEBUG, check that ras.toff, offset into bitmap, is synchronized
 *  with ras.yraster.
 */

#if defined (ANSI_DEFS)
MLOCAL VOID  offsetcheck()
#else
MLOCAL VOID
offsetcheck()    /* is not coded for handling tiling yet */
#endif
{
    if(ras.toff != ras.tsize - ((SL32)ras.yraster * (SL32)ras.bmdim.x))
    {
        DBG1("toff is out of sync at element %d\n", ras.elem_num-1);
        DBG1("   it is %ld rasters too big\n",
          (ras.toff- (ras.tsize - ((SL32)ras.yraster * (SL32)ras.bmdim.x))
          )/(SL32)ras.bmdim.x);
    }
}
#else
#define offsetcheck()  /**/
#endif

/*==================================================================*/
/*                     Non zero winding                             */
#if NON_Z_WIND

#define NZ_DUMP 0    /*  set to one will dump lists if DEBUG is set */


#define    nz_raster_bot_row()    ras.toff =  ras.tsize - (SL32)ras.bmdim.x;
                                   /* bottom row in bitmap */
#define    nz_raster_next_row()   ras.toff -= ras.bmdim.x;

#ifdef LINT_ARGS
#if NZ_DUMP
MLOCAL VOID nz_dump_list(PNZ_NODE);
#endif

MLOCAL VOID nz_init(LPUB8);
MLOCAL VOID nz_close_run(VOID);
MLOCAL VOID nz_insert_pending(PNZ_NODE);
MLOCAL VOID nz_insert_active(PNZ_NODE);
MLOCAL VOID nz_sort(VOID);
MLOCAL UW16 nz_set_trans(VOID);
#else
#if NZ_DUMP
MLOCAL VOID nz_dump();
#endif
MLOCAL VOID nz_init();
MLOCAL VOID nz_close_run();
MLOCAL VOID nz_insert_active();
MLOCAL VOID nz_sort();
MLOCAL UW16 nz_set_trans();
#endif


#if NZ_DUMP
#if defined (ANSI_DEFS)
MLOCAL VOID nz_dump_list( PNZ_NODE list )
#else
MLOCAL VOID nz_dump_list( list )
PNZ_NODE list;
#endif
{
    PNZ_NODE  p;
    PNZCOUNTER  pv;
    NZCOUNTER   i;

    DBG("nz_dump_list()\n");

    p = list->link;
    while(p)
    {
        DBG("-------next NZ_NODE--------\n");
        DBG1("lowRow    %d\n", p->lowRow);
        DBG1("onoff     %d\n", p->onoff);
        DBG1("valCount  %d\n", p->valCount);
        pv = p->pval;
        for(i=0; i<p->valCount; i++)
        {
            DBG1("    %d\n", *pv++);
        }
        p = p->link;
    }
}
#endif
/*-------------------*/
/*      nz_init      */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID nz_init( LPUB8 nzw_buf )
#else
MLOCAL VOID nz_init( nzw_buf )
LPUB8 nzw_buf;
#endif
{
    PNZCOUNTER p;
    NZCOUNTER i;

    DBG("nz_init()\n");

    ras.nz_buffer = nzw_buf;
    ras.nz_nodes = (PNZ_NODE)nzw_buf;
    p = (PNZCOUNTER)(&ras.nz_nodes[ras.tran_run_ct]);
    for(i=0; i<ras.tran_run_ct; i++)
    {
        ras.nz_nodes[i].pval = p;
        p += ras.bmdim.y;
    }
    ras.nz_cur_node = 0;
    ras.nz_valCount = 0;

    ras.nz_pend_list.link = NULL;
    ras.nz_overflow = 0;
    ras.nz_done = 0;
}
/*-------------------*/
/* nz_insert_pending */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID nz_insert_pending( PNZ_NODE p )
#else
MLOCAL VOID nz_insert_pending( p )
PNZ_NODE p;
#endif
{
    PNZ_NODE pprev, pnext;
    NZCOUNTER  lowRow;

    DBG("nz_insert_pending()\n");

    lowRow = p->lowRow;
    pprev = &ras.nz_pend_list;
    pnext = pprev->link;

    while(pnext)
    {
        if(lowRow <= pnext->lowRow) break;
        pprev = pnext;
        pnext = pprev->link;
    }

    p->link     = pnext;    /* link p after pprev */
    pprev->link = p;
}
/*-------------------*/
/*    nz_close_run   */
/*-------------------*/
/*  Scan conversion has changed y direction.
 *
 *  Close out current run of transitions (if any) by creating an NZ_NODE
 *  to hold the just written transitions and link this new NZ_NODE into
 *  the list of pending transition lists.
 */
#if defined (ANSI_DEFS)
MLOCAL VOID nz_close_run( VOID )
#else
MLOCAL VOID nz_close_run()
#endif
{
    PNZ_NODE  pnew;

    DBG("nz_close_run()\n");

    if(ras.nz_overflow)
    {
        DBG("  nz_overflow is set\n");
        return;
    }
    if(!ras.nz_valCount)      /* haven't written any transitions yet */
    {
        DBG("   no transitions written-  no node created\n");

        /*  We changed direction without writing any transitions.
         *  We need to move nz_start_row back in the other direction
         *  just like yraster and toff.
         */
        ras.nz_start_row += ras.ydir;
        ras.nz_pval -= ras.ydir * (ras.bmdim.y - 1); /* pt to other end */
        return;
    }


    /*  Close off current NZ_NODE  */

    pnew = &ras.nz_nodes[ras.nz_cur_node];
    pnew->valCount = ras.nz_valCount;

    if(ras.beam)   pnew->onoff = -1;   /* we were making OFF trans */
    else           pnew->onoff = 1;   /* we were making ON trans */

    if(ras.ydir == 1)  /* already changed- we were going down */
    {
        ras.nz_start_row -= ras.nz_valCount - 1;
        pnew->lowRow = ras.nz_start_row;
        pnew->pval = ras.nz_pval + 1;
    }
    else   /* We were going up */
    {
        pnew->lowRow = ras.nz_start_row;
        ras.nz_start_row += ras.nz_valCount - 1;
        pnew->pval = ras.nz_pval - ras.nz_valCount;
    }
    /*  Link new node into the list; list is sorted by nz_start_row */
    nz_insert_pending(pnew);


    /*  Reset all transition run counters for the next run */
    ras.nz_valCount = 0;

    ras.nz_cur_node++;   /* set up for next node */
    /* error check */
    if(ras.nz_cur_node >= ras.tran_run_ct)
        ras.nz_done = 1;

    ras.nz_pval = ras.nz_nodes[ras.nz_cur_node].pval;
    if(ras.ydir == -1)  /* going down; point at end of array */
        ras.nz_pval += ras.bmdim.y - 1;
}
/*-------------------*/
/* nz_insert_active  */
/*-------------------*/
/*  Insert node p into list maintining sort from low to high
 *  of *pval
 */
#if defined (ANSI_DEFS)
MLOCAL VOID nz_insert_active( PNZ_NODE p )
#else
MLOCAL VOID nz_insert_active( p )
PNZ_NODE p;
#endif
{
    PNZ_NODE pprev, pnext;
    NZCOUNTER val;

    DBG("nz_insert_active()\n");

    val = *(p->pval);
    pprev = &ras.nz_active_list;
    pnext = pprev->link;

    while(pnext)
    {
        if(val <= *(pnext->pval)) break;
        pprev = pnext;
        pnext = pprev->link;
    }

    p->link     = pnext;    /* link p after pprev */
    pprev->link = p;
}
/*-------------------*/
/*     nz_sort       */
/*-------------------*/
/*  Sort list on *pval fields low to high */
#if defined (ANSI_DEFS)
MLOCAL VOID nz_sort( VOID )
#else
MLOCAL VOID nz_sort()
#endif
{
    PNZ_NODE pcur, pnext;

    DBG("nz_sort()\n");

    pcur = ras.nz_active_list.link;
    ras.nz_active_list.link = NULL;

    while(pcur)
    {
        pnext = pcur->link;
        nz_insert_active(pcur);
        pcur = pnext;
    }    
}
/*-------------------*/
/*   nz_set_trans    */
/*-------------------*/
/*  Set simple, even-odd transitions in the transition array according
 *  to the transition list.
 */
#if defined (ANSI_DEFS)
MLOCAL UW16 nz_set_trans( VOID )
#else
MLOCAL UW16 nz_set_trans()
#endif
{
    PNZ_NODE   pprev, pnext;
    NZCOUNTER  row, pendRow, onCount, val, prevVal, beamIsOn;

    DBG("nz_set_trans()\n");
#if NZ_DUMP
    nz_dump_list(&ras.nz_pend_list);
#endif
    if(ras.nz_overflow) return ERRnzw_mem_overflow;
    ras.nz_active_list.link = NULL;
    nz_raster_bot_row();                 /* bottom row in bitmap */
    pnext = ras.nz_pend_list.link;
    if(!pnext) return SUCCESS;   /* no transitions produced */
    pendRow = pnext->lowRow;
    if_state.non_z_wind = FALSE;

    for(row = 0; row < ras.bmdim.y ; row++)
    {
        /*  Add any pending nodes */
        if(pendRow <= row)
        {
            pprev = &ras.nz_pend_list;
            pnext = ras.nz_pend_list.link;
            while(pnext)
            {
                pendRow = pnext->lowRow;
                if(pendRow <= row)
                {
                    pprev->link = pnext->link;     /* remove from pending list */
                    nz_insert_active(pnext);  /* insert in active list    */
                    pnext = pprev->link;
                }
                else
                    break;
            }
            if(!pnext) pendRow = 32767;
        }
        /*  Set transitions */
settrans:
        beamIsOn = 0;
        pnext = ras.nz_active_list.link;
        if(pnext)
        {
            prevVal = *(pnext->pval);
            onCount = pnext->onoff;
            pnext   = pnext->link;
            while(pnext)
            {
                val = *(pnext->pval);
                if(val < prevVal)
                {
                    /* Outlines have crossed, re-sort, and clear bitmap row */
                    nz_sort();
                    MEMSET(ras.tran_buffer+ras.toff, (int)0, (int)ras.bmdim.x);
                    goto settrans;   /* try again */
                }
                else if(val > prevVal)
                {
#if 0
                    /* positive winding number */
                    if((beamIsOn && onCount <= 0) || (!beamIsOn && onCount >  0))
#endif
                    if((beamIsOn && onCount == 0) || (!beamIsOn && onCount !=  0))
                    {
                        writepixel(prevVal);
                        beamIsOn = 1 - beamIsOn;
                    }
    
                    prevVal = val;
                }
                onCount += pnext->onoff;
                pnext = pnext->link;
            }  /*  for each NZ_NODE in the active list  */
            if((beamIsOn && onCount <= 0) || (!beamIsOn && onCount >  0))
                writepixel(prevVal);
        }

        /*  Bump list to next row */
        pprev = &ras.nz_active_list;
        pnext = pprev->link;
        while(pnext)
        {
            if(--(pnext->valCount))   /* if any transitions left  */
            {
                pnext->pval++;   /* bump to next transition value */
                pprev = pnext;
            }
            else
                pprev->link = pnext->link;   /*  remove from active list */

            pnext = pprev->link;
        }
        /*  move to next raster line in transition buffer  */
        nz_raster_next_row();
    }   /* for(each raster row of the bitmap */
    if_state.non_z_wind = TRUE;   /* restore */
    return SUCCESS;
}
#endif  /* NON_Z_WIND */

/*                     Non zero winding                             */
/*==================================================================*/

/***********************************************************************/
/*                                                                     */
/* Use a tab setting of three spaces to view this section of the file. */
/*                                                                     */
/***********************************************************************/

MLOCAL	int	pseudo_state;
MLOCAL	int	first_pseudo_tran;

typedef struct tran_struct {
	BOOLEAN		seton;
	int			ydir;
	int			xx;
	int			dytran;
	SL32			toff;
} Tran;

MLOCAL Tran		pseudo_tran;

typedef struct state_struct {
	int			xx;
	int			ydir;
	BOOLEAN		beam;
	BOOLEAN		seton;
	BOOLEAN		wason;
	int			ptran;
	int			yraster;
	int			dytran;
	SL32			toff;
} State;

MLOCAL State	state;

/*-------------------*/
/*	  record_state    */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL	VOID	record_state( VOID )
#else
MLOCAL	VOID	record_state( )
#endif
{
	state.xx = ras.xx;
	state.ydir = ras.ydir;
	state.beam = ras.beam;
	state.seton = ras.seton;
	state.wason = ras.wason;
	state.ptran = ras.ptran;
	state.yraster = ras.yraster;
	state.dytran = ras.dytran;
	state.toff = ras.toff;
}

/*-------------------*/
/*	  recall_state    */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL	VOID	recall_state( VOID )
#else
MLOCAL	VOID	recall_state( )
#endif
{
	ras.xx = state.xx;
	ras.ydir = state.ydir;
	ras.beam = state.beam;
	ras.seton = state.seton;
	ras.wason = state.wason;
	ras.ptran = state.ptran;
	ras.yraster = state.yraster;
	ras.dytran = state.dytran;
	ras.toff = state.toff;
}

/*-------------------*/
/*	  put_tran        */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL	VOID	put_tran( Tran *tran )
#else
MLOCAL	VOID	put_tran( tran )
Tran *tran;
#endif
{
	tran->seton = ras.seton;
	tran->ydir = ras.ydir;
	tran->xx = ras.xx;
	tran->dytran = ras.dytran;
	tran->toff = ras.toff;
}

/*-------------------*/
/*	  set_tran        */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL	VOID	set_tran( Tran *tran )
#else
MLOCAL	VOID	set_tran( tran )
Tran *tran;
#endif
{
	ras.seton = tran->seton;
	ras.ydir = tran->ydir;
	ras.xx = tran->xx;
	ras.dytran = tran->dytran;
	ras.toff = tran->toff;
}

#define	PUT_TRAN()			 {	\
	ras.seton1 = ras.seton;		\
	ras.ydir1 = ras.ydir;		\
	ras.xx1 = ras.xx;				\
	ras.dytran1 = ras.dytran;	\
	ras.toff1 = ras.toff;		\
}

#define	SET_TRAN()			 {	\
	ras.seton = ras.seton1;		\
	ras.ydir = ras.ydir1;		\
	ras.xx = ras.xx1;				\
	ras.dytran = ras.dytran1;	\
	ras.toff = ras.toff1;		\
}

/*-------------------*/
/*	  wraper				*/
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID wraper( int pseudo_state )
#else
MLOCAL VOID wraper( pseudo_state )
int pseudo_state;
#endif
{
	SW16		zz;

	if (ras.seton) {
		if ( !pseudo_state ) {
			SETON;
		}
		if (ras.wason) {
			SET_A;
		} else {
			if ( !pseudo_state ) {
				SETPH;
			}
			SET_B;
		}
	} else {
		if (ras.wason) {
			if ( !pseudo_state ) {
				SETPH;
			}
			SET_C;
		} else {
			SET_D;
		}
	}
}

/*-------------------*/
/*	 bmras_start_char */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_start_char(PVOID pstats)
#else
MLOCAL UW16 bmras_start_char(pstats)
PVOID pstats;
#endif
{
#if TILE
	/* Set y fop clipping in raster(). */

	ras.clip_fops_bot = (INTR) ypix *(INTR) (scan_convert.tb.ll.y + 1);
	ras.clip_fops_top = (INTR) ypix *(INTR) (scan_convert.tb.ur.y);

#endif
	return SUCCESS;
}

/*-------------------*/
/*	 bmras_end_char   */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_end_char()
#else
MLOCAL UW16 bmras_end_char()
#endif
{
#if NON_Z_WIND
	if (if_state.non_z_wind)
		return nz_set_trans();
#endif
	return SUCCESS;
}

/*-------------------*/
/*	 bmras_start_loop */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_start_loop(UW16 polarity)
#else
MLOCAL UW16 bmras_start_loop(polarity)
UW16 polarity;
#endif
{
	ras.polarity = polarity;
	pseudo_state = FALSE;
	first_pseudo_tran = TRUE;
	return SUCCESS;
}

/*-------------------*/
/*	  bmras_end_loop	*/
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_end_loop()
#else
MLOCAL UW16 bmras_end_loop()
#endif
{
	Tran		temp_tran;

	/*
		Connect last line segment to first line segment in the or_on buffer. 
		(Only if transitions were produced)
	*/
	if ( if_state.or_on ) {
		if ( pseudo_state ) {
			if ( !first_pseudo_tran ) {
				set_tran( &pseudo_tran );
				wraper( pseudo_state );
				recall_state();
				pseudo_state = FALSE;
				if ( !ras.first_tran ) {
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
					SET_TRAN();
					wraper( pseudo_state );
				} else { /* ras.first_tran */
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
				}
			} else { /* first_pseudo_tran */
				SET_TRAN();
				wraper( pseudo_state );
				recall_state();
				pseudo_state = FALSE;
				if ( !ras.first_tran ) {
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
					SET_TRAN();
					wraper( pseudo_state );
				} else { /* ras.first_tran */
					/* if pseudo_state && first_pseudo_tran => !ras.first_tran */
					return( (UW16)FAILURE );
				}
			}
		} else { /* !pseudo_state */
			if ( !first_pseudo_tran ) {
				put_tran( &temp_tran );
				set_tran( &pseudo_tran );
				wraper( !pseudo_state );
				set_tran( &temp_tran );
				if ( !ras.first_tran ) {
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
					SET_TRAN();
					wraper( pseudo_state );
				} else { /* ras.first_tran */
					/* if !pseudo_state && !first_pseudo_tran => !ras.first_tran */
					return( (UW16)FAILURE );
				}
			} else { /* first_pseudo_tran */
				if ( !ras.first_tran ) {
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
					SET_TRAN();
					wraper( pseudo_state );
				} else { /* ras.first_tran */
#if NON_Z_WIND
					chng_tran_dir();			/* to create last NZ_NODE */
#endif
				}
			}
		}
	} else { /* !if_state.or_on */
#if NON_Z_WIND
		chng_tran_dir();						/* to create last NZ_NODE */
#endif
	}
	return( SUCCESS );
}


/*-------------------*/
/*	  bmras_moveto		*/
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_moveto(INTR px, INTR py)
#else
MLOCAL UW16 bmras_moveto( px, py )
INTR px, py;
#endif
{
	int		end_yraster;

/*------------------------------------------------------------------*/
    DBG("\n\nbmras_moveto()\n");
#if INTR_SIZE == 16
    DBG2("  if_state.p0    = (%d, %d)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  px,py = (%d, %d)\n", px, py);
#else
    DBG2("  if_state.p0    = (%ld, %ld)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  px,py = (%ld, %ld)\n", px, py);
#endif
    DBG2("  log_xpix = %d   log_ypix = %d\n\n", log_xpix, log_ypix);
/*------------------------------------------------------------------*/

	if_state.p0.x = px;
	if_state.p0.y = py;

#ifdef DEBUG
	ras.elem_num = 0;
#endif
	ras.first_tran = TRUE;
first_pseudo_tran = TRUE;

#if TILE
	ras.above = ras.below = 0;
	if (if_state.p0.y > ras.clip_fops_top && scan_convert.tile_on) {
		ras.above = 1;
		ras.ydir = -1;							/* we only get back in going down */
		ras.beam = (ras.polarity == 1);
		ras.dytran = ras.bmdim.x;
		ras.yraster = scan_convert.tb.ur.y;			/* tile box in pixels */
	} else if (if_state.p0.y < ras.clip_fops_bot && scan_convert.tile_on) {
		ras.below = 1;
		ras.ydir = 1;							/* we only get back in going up */
		ras.beam = (ras.polarity != 1);
		ras.dytran = -ras.bmdim.x;
		ras.yraster = scan_convert.tb.ll.y + 1;
	} else
#endif
	{
		/* Set ydir	 and initialize transition_producer */

		ras.ydir = -1;							/* assume going down */
		ras.beam = (ras.polarity == 1);
		ras.dytran = ras.bmdim.x;
		ras.yraster = (int) YFLOOR(if_state.p0.y);
	}

	if (if_state.wrong_read)				/* polarity is reversed for wrong reading */
		ras.beam = !ras.beam;

	/*
      Set pointer to transition array to correspond to yraster.  Actually
      yraster is always greater than or equal to 1.  The offset into the
      bitmap, toff, is set to the raster row yraster-1 so that we don't
      have a blank raster at the bottem of the bitmap.  This offset moves
      along with yraster but is never calculated again from yraster. 
	
      In the case of tiling, yraster and the curve data remain in the
      coordinate space of the overall large bitmap.  So we subtract off the
      bottom pixel value of the tile to get to the bottom of the bit map. 
	*/

#if TILE
	if (scan_convert.tile_on)
		end_yraster = ras.yraster - scan_convert.tb.ll.y;
	else
#endif
		end_yraster = ras.yraster;
	ras.toff = ras.tsize - ((SL32) end_yraster * (SL32) ras.bmdim.x);
	offsetcheck();

#if NON_Z_WIND
	if (if_state.non_z_wind) {
		ras.nz_start_row = (int) (end_yraster - 1);
		/* same as code in nz_init() */
		ras.nz_pval = ras.nz_nodes[ras.nz_cur_node].pval;
		if (ras.ydir == -1)					/* going down; point at end of array */
			ras.nz_pval += ras.bmdim.y - 1;
	}
#endif

	return SUCCESS;
}

/*===================================================================*/

#define IABS(a)	 ( ((a) < (INTR)0) ? -(a) : (a) )

/*-------------------*/
/*	  bmras_lineto		*/
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_lineto(INTR p1x, INTR p1y)
#else
MLOCAL UW16 bmras_lineto( p1x, p1y )
INTR p1x, p1y;
#endif
{
	int		tran;
	int		end_yraster;
	int		tran_ct;
	INTR		dx, dy;
	INTR		x, y;								/* Intersection of current y rastor and current current segment. */
	INTR		absdy;

	INTR		deltax;
	INTR		dxdeltay;
	INTR		deltax1;							/* if(deltax>0) deltax+1 else deltax-1	 */
	INTR		rem;
	INTR		r;
	INTR		t;
	INTR		xdir;
	INTR		q;

#if TILE
	SL32		l_dxdeltay;
#endif

	int		zz;								/* Missing pixel recovery */

/*------------------------------------------------------------------*/
    DBG("\n\nbmras_lineto()\n");
#if INTR_SIZE == 16
    DBG2("  if_state.p0    = (%d, %d)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  p1x,p1y = (%d, %d)\n", p1x, p1y);
#else
    DBG2("  if_state.p0    = (%ld, %ld)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  p1x,p1y = (%ld, %ld)\n", p1x, p1y);
#endif
    DBG2("  log_xpix = %d   log_ypix = %d\n\n", log_xpix, log_ypix);
/*------------------------------------------------------------------*/

#if TILE
	if (ras.above) {
		if (p1y > ras.clip_fops_top)
			goto done;
		else
			ras.above = 0;
	}
	if (ras.below) {
		if (p1y < ras.clip_fops_bot)
			goto done;
		else
			ras.below = 0;
	}
#endif

	dy = p1y - if_state.p0.y;
	if (!dy) {
		goto done;								/* skip horizontal elements */
	}
	/* see if we changed ydir- up or down */

	if ( (dy ^ (INTR) ras.ydir) < 0 ) {
		chng_tran_dir();
	}
	/* Compute last stroke. Continue on to next vector	 */
	/* if this segment isn't stroked.						 */

	if ( ras.ydir > 0 ) {
#if TILE
		if (p1y > ras.clip_fops_top && scan_convert.tile_on) {
			ras.above = 1;
			end_yraster = scan_convert.tb.ur.y;
		} else
#endif
			end_yraster = (int)YFLOOR(p1y);
		tran_ct = end_yraster - ras.yraster + 1;
	} else {
#if TILE
		if (p1y < ras.clip_fops_bot && scan_convert.tile_on) {
			ras.below = 1;
			end_yraster = scan_convert.tb.ll.y + 1;
		} else
#endif
			end_yraster = (int)YCEILING(p1y + 1);
		tran_ct = ras.yraster - end_yraster + 1;
	}

	if ( tran_ct == 0 && !if_state.or_on ) { /* scan_convert.tile_on ==> !if_state.or_on */
		goto done;
	}

	if ( tran_ct == 0 ) { /* and if_state.or_on is also TRUE */
		if ( pseudo_state ) {
		} else {
			record_state();
			pseudo_state = TRUE;
		}
		dx = p1x - if_state.p0.x;
		ras.yraster = end_yraster + ras.ydir;
		ras.seton = ras.beam;
		ras.xx = (int) ((( if_state.p0.x + (dx/2) ) + (INTR) half_xpix ) >> log_xpix );
		if ( first_pseudo_tran && ras.first_tran ) {
			first_pseudo_tran = FALSE;
			put_tran( &pseudo_tran );
		} else {
			if (ras.seton) {
				if (ras.wason) {
					SET_A;
				} else {
					SET_B;
				}
			} else {
				if (ras.wason) {
					SET_C;
				} else {
					SET_D;
				}
			}
		}
		ras.wason = ras.seton;
		ras.ptran = ras.xx;						/* last x transition */
		goto done;
	}

	/* P R O D U C E	  T R A N S I T I O N S */

restart:
	dx = p1x - if_state.p0.x;

	y = (INTR) ypix *(INTR) (ras.yraster);

	ras.yraster = end_yraster + ras.ydir;

	ras.seton = if_state.or_on && ras.beam;

	if (dx == 0) {

		ras.xx = (int) ((if_state.p0.x + (INTR) half_xpix) >> log_xpix);
		if ( !pseudo_state ) {
			HOR_TILE_CLIP;
			writepixel(ras.xx);
		}
		if (if_state.or_on) {
			if ( ras.first_tran && !pseudo_state ) {
				ras.first_tran = FALSE;
				ras.ydir1 = ras.ydir;
				ras.xx1 = ras.xx;
				ras.seton1 = ras.seton;
				ras.dytran1 = ras.dytran;
				ras.toff1 = ras.toff;
			} else {
				if (ras.seton) {
					if ( !pseudo_state ) {
						SETON;
					}
					if (ras.wason) {
						SET_A;
					} else {
						if ( !pseudo_state ) {
							SETPH;
						}
						SET_B;
					}
				} else {
					if (ras.wason) {
						if ( !pseudo_state ) {
							SETPH;
						}
						SET_C;
					} else {
						SET_D;
					}
				}
			}
		}
		if ( pseudo_state ) {
			recall_state();
			pseudo_state = FALSE;
			if ((dy ^ (INTR) ras.ydir) < 0)
				chng_tran_dir();
			goto restart;
		}
		ras.toff += ras.dytran;
		for (tran = 1; tran < tran_ct; tran++) {
			writepixel(ras.xx);
			if (ras.seton)
				SETON;
			ras.toff += ras.dytran;
		}
	} else {										/* character contour is diagonal */
		/* Compute first transition point */

		absdy = IABS(dy);

#if TILE
{   /* 10/28 - 11/02/94 */
        SL32 num = (SL32)(IABS(y-if_state.p0.y));
        SL32 dx1 = (SL32)dx;
        int flagn=0;
        int flagd=0;

        if(num>46340L)  /* to avoid overflow; product must not exceed 2**31 */
        {
            num >>= 4;
            flagn++;
        }
        if( IABS(dx1) > 46340L)
        {
            dx1 >>= 4;
            flagd++;
        }

        l_dxdeltay = num * dx1;
        deltax = (INTR)(l_dxdeltay/(SL32)absdy);
        rem = ((INTR)(l_dxdeltay - deltax*absdy)) << 1;

        if (flagn)
        {
            deltax <<= 4;   /* reconstitute quotient and remainder */
            rem <<= 4;
        }
        if (flagd)
        {
            deltax <<= 4;
            rem <<= 4;
        }
        if (flagd || flagn)  /* 11-02-94 */
        {                    /* inaccuracy in deltax caused "jaggies"! */
            rem += absdy;
            rem >>= 1;
            deltax += rem/absdy;
            rem = 0;
        }
}
#else
		dxdeltay = IABS(y - if_state.p0.y) * dx;
		deltax = dxdeltay / absdy;
		rem = (dxdeltay - deltax * absdy) << 1;
#endif

		q = (absdy << 1);

		x = if_state.p0.x + (INTR) half_xpix + deltax;

		if (dx > 0) {
			xdir = 1;							/* 11-12-91 jfd */
			r = q - 1 - rem;
		} else {
			xdir = -1;
			r = rem;
		}
		if (!half_xpix)
			r -= xdir * absdy;
		if (r < 0) {
			x += xdir;
			r += q;
		}
		ras.xx = (int) (x >> log_xpix);
		if ( !pseudo_state ) {
			HOR_TILE_CLIP;
			writepixel(ras.xx);
		}
		if (if_state.or_on) {
			if ( ras.first_tran && !pseudo_state ) {
				ras.first_tran = FALSE;
				ras.ydir1 = ras.ydir;
				ras.xx1 = ras.xx;
				ras.seton1 = ras.seton;
				ras.dytran1 = ras.dytran;
				ras.toff1 = ras.toff;
			} else {
				if (ras.seton) {
					if ( !pseudo_state ) {
						SETON;
					}
					if (ras.wason) {
						SET_A;
					} else {
						if ( !pseudo_state ) {
							SETPH;
						}
						SET_B;
					}
				} else {
					if (ras.wason) {
						if ( !pseudo_state ) {
							SETPH;
						}
						SET_C;
					} else {
						SET_D;
					}
				}
			}
			ras.ptran = ras.xx;
		}
		if ( pseudo_state ) {
			recall_state();
			pseudo_state = FALSE;
			if ((dy ^ (INTR) ras.ydir) < 0)
				chng_tran_dir();
			goto restart;
		}
		ras.toff += ras.dytran;
		if (tran_ct > 1) {
			dxdeltay = (INTR) ypix *dx;

			deltax = dxdeltay / absdy;
			rem = (dxdeltay - deltax * absdy) << 1;

			/* make rem negative and set deltax1 */

			if (rem > 0)
				rem = -rem;
			deltax1 = deltax + xdir;

			/*
            Calculate "t" to be used when r goes negative.  First add absdy
            to account for the extra 1 we moved x and to reset r.  Then
            subtract remainder to set r for the next x value. 
			*/

			t = rem + q;

			r += rem;							/* set r for next y raster */

			for (tran = 1; tran < tran_ct; tran++) {
				if (r < 0) {
					x += deltax1;
					r += t;						/* set r for next x */
				} else {
					x += deltax;
					r += rem;					/* set r for next x */
				}

				ras.xx = (int) (x >> log_xpix);

				HOR_TILE_CLIP;
				writepixel(ras.xx);
				if (if_state.or_on) {
					if (ras.seton) {
						SETON;
						SET_A;
					} else {
						SET_D;
					}
					ras.ptran = ras.xx;
				}
				ras.toff += ras.dytran;
			}										/* for loop */
		}											/* if tran_ct > 1 */
	}												/* else character contour is diagonal */

	ras.wason = ras.seton;
	ras.ptran = ras.xx;						/* last x transition */

 done:
	offsetcheck();
	if_state.p0.x = p1x;
	if_state.p0.y = p1y;
	return SUCCESS;
}
/*===================================================================*/
/*===================================================================*/

/*-------------------*/
/*	 length_2			*/
/*-------------------*/
/*	 Return approximation of 2 times the length of the vector (dx, dy).
 *	 Return value approximates 2 * (dx**2 + dy**2)**1/2;
 *	 Approximation is generally too large (except if one delta is 0).
 *	 It is too large by 2 * (1.5 - sqrt(2))largest delta
 *								 = 0.1716 largest delta.
 */
#if defined (ANSI_DEFS)
MLOCAL SL32 length_2(SL32 dx, SL32 dy)
#else
MLOCAL SL32 length_2( dx, dy )
SL32 dx, dy;
#endif
{
	if (dx < 0L)
		dx = -dx;
	if (dy < 0L)
		dy = -dy;
	return (dx < dy) ? dx + (dy << 1) : (dx << 1) + dy;
}

#if (!(CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR)))
#if (!((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR))))
#if defined (ANSI_DEFS)
MLOCAL UW16 bmras_quad_inactive(INTR cx, INTR cy, INTR px, INTR py)
#else
MLOCAL UW16 bmras_quad_inactive( cx, cy, px, py )
INTR cx, cy, px, py;
#endif
{
   return SUCCESS;
}
#endif
#endif

/*===================================================================*/

#if (CGBITMAP && DRAS_QUAD && (IF_RDR || TT_RDR || FCO_RDR))

/*-------- #define's and macros specific to this function -------- */

#define ERR_straight_line 99

#define CRS(A, B)	  (A.x*B.y - A.y*B.x)

#define adv_x() {dd += dx;	 dx += dxx;	 dy += dxy;	 x+= xdir;}
#define adv_y() {dd += dy;	 dx += dxy;	 dy += dyy;	 y+= ras.ydir; }
 /* AWR */
#define rev_x() {dxy=-dxy; dx=-dx+dxx; testA = 1-testA; testB = 1-testB;}
#define rev_y() {dxy=-dxy; dy=-dy+dyy;}
/*#define rev_d() {dd=-dd; dx=-dx; dy=-dy; dxx=-dxx; dyy=-dyy; dxy=-dxy;}*/

typedef struct {								/* integer double precision format */
	UL32		lo;
	UL32		hi;
} DLONG;

#ifdef LINT_ARGS
EXTERN DLONG Ladd(DLONG, DLONG);
EXTERN DLONG Lmul(SL32, SL32);
#else
EXTERN DLONG Ladd();
EXTERN DLONG Lmul();
#endif

/*-------------------*/
/*	 pseudo_scan      */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID pseudo_scan(
	int		xdir,
	int		x,
	int		y,
	int		tran_ct,
	int		tran_ct2,

	SL32VECTOR A,
	SL32VECTOR B,
	SL32VECTOR K,
	SL32		alpha,
	SL32		beta,
	SL32		dd,
	SL32		dx,
	SL32		dy,

	SL32		testA,
	SL32		testB,
	SL32		dxx,
	SL32		dyy,
	SL32		dxy,
	SL32		ky2p2,
	SL32		kx2q2 )
#else
MLOCAL VOID pseudo_scan( xdir, x, y, tran_ct, tran_ct2, A, B, K, alpha, beta, 
				dd, dx, dy, testA, testB, dxx, dyy, dxy, ky2p2, kx2q2 )
int		xdir;
int		x;
int		y;
int		tran_ct;
int		tran_ct2;

SL32VECTOR A;
SL32VECTOR B;
SL32VECTOR K;
SL32		alpha;
SL32		beta;
SL32		dd;
SL32		dx;
SL32		dy;

SL32		testA;
SL32		testB;
SL32		dxx;
SL32		dyy;
SL32		dxy;
SL32		ky2p2;
SL32		kx2q2;
#endif
{
	int		zz;								/* missing pixel recovery */


 loop:
	{
		/* this version of the loops includes tiling and missing pixel code */
		ras.seton = if_state.or_on && ras.beam;
		/* start in A mode (x steps into parabola) or B mode (x steps out) */
		if ((SL32) (((SL32) (xdir ^ ras.ydir)) ^ (SL32) alpha) >= 0) {
			/* B loop: x steps out of parabola */
			for (; tran_ct > 0; --tran_ct) {
				/* see if it is time to reverse x direction */
				if ((dx > ky2p2) && (dd >= 0) && (dy > kx2q2)) {
					rev_x();
					x += xdir;
					xdir = -xdir;
					break;						/* switch to A loop */
				}
				/* move at least to center of skinny parabolas */
				while (dx <= ky2p2) {
					adv_x();
					/* DBG("adv_x\n"); */
				}
				/* move to outside of parabola */
				/* AWR */
				while (dd < testB) {
					adv_x();
					/* DBG("adv_x\n"); */
				}
				/* VERT_TILE_CLIP */
				{
					/* save raster intersection */
					ras.xx = x;
					/* HOR_TILE_CLIP */
					/*	writepixel(ras.xx); */
					/* missing pixel recovery */
					if (if_state.or_on) {
						if ( ras.first_tran && !pseudo_state ) {
							ras.first_tran = FALSE;
							ras.ydir1 = ras.ydir;
							ras.xx1 = ras.xx;
							ras.seton1 = ras.seton;
							ras.dytran1 = ras.dytran;
							ras.toff1 = ras.toff;
							ras.wason = ras.seton;
						} else {
							if (ras.seton) {
								/* SETON; */
								if (ras.wason) {
									SET_A;
								} else {
									/* SETPH; */
									SET_B;
								}
							} else {
								if (ras.wason) {
									/* SETPH; */
									SET_C;
								} else {
									SET_D;
								}
							}
							ras.wason = ras.seton;
						}
						goto quit;
						/* ras.ptran = ras.xx; */
					}
					/* advance y raster line */
					ras.toff += ras.dytran;
				}
				/* advance y on parabola */
				adv_y();
				/* DBG("adv_y\n"); */
			}
			/* make sure we have proper x direction at end of B loop */
			/* skinny parabolas may not have switched */
			if (xdir * B.x < 0) {
				rev_x();
				x += xdir;
				xdir = -xdir;
			}
			/* B loop may fall into A loop at X extreme */
		}
		/* A loop: x steps into parabola */
		while (--tran_ct >= 0) {
			/* move into parabola */
			/* AWR */
			while ((dd >= testA) && (dx <= ky2p2)) {
				adv_x();
				/* DBG("adv_x\n"); */
			}
			/* VERT_TILE_CLIP */
			{
				/* save raster intersection */
				ras.xx = x;
				/* HOR_TILE_CLIP */
				/* writepixel(ras.xx); */
				/* missing pixel recovery */
				if (if_state.or_on) {
					if ( ras.first_tran && !pseudo_state ) {
						ras.first_tran = FALSE;
						ras.ydir1 = ras.ydir;
						ras.xx1 = ras.xx;
						ras.seton1 = ras.seton;
						ras.dytran1 = ras.dytran;
						ras.toff1 = ras.toff;
						ras.wason = ras.seton;
					} else {
						if (ras.seton) {
							/* SETON; */
							if (ras.wason) {
								SET_A;
							} else {
								/* SETPH; */
								SET_B;
							}
						} else {
							if (ras.wason) {
								/* SETPH; */
								SET_C;
							} else {
								SET_D;
							}
						}
						ras.wason = ras.seton;
					}
					goto quit;
					/* ras.ptran = ras.xx; */
				}
				/* advance y raster line */
				ras.toff += ras.dytran;
			}
			/* advance y on parabola */
			adv_y();
			/* DBG("adv_y\n"); */
		}
		/* A loop ends at Y extreme */
	}
	if (tran_ct2) {							/* concave up or down, second part of curve */
		rev_y();

		/*
         Almost chng_tran_dir() but we don't need to change yraster, it's
         already been set to be at end of 2nd part of curve
		*/
		ras.ydir = -ras.ydir;
		ras.beam = !ras.beam;
		ras.dytran = -ras.dytran;
		ras.toff += ras.dytran;

		adv_y();
		tran_ct = tran_ct2;
		tran_ct2 = 0;
		goto loop;
	}
 quit:
	if ( pseudo_state ) {
		recall_state();
		pseudo_state = FALSE;
/*
		if ((dy ^ (INTR) ras.ydir) < 0)
			chng_tran_dir();
		goto restart;
*/
	}
	return;
}

/*-------------------*/
/*	 bmras_quad_direct*/
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 bmras_quad_direct(INTR cx, INTR cy, INTR px, INTR py)
#else
GLOBAL UW16 bmras_quad_direct( cx, cy, px, py )
INTR cx, cy, px, py;
#endif
{
	INTRVECTOR cntrl, p1;
	INTRVECTOR p0;								/* Local copy of starting point			           */
	UW16		status = SUCCESS;
	int		enough_xres = 1;				/* 0 means temporarily increase x res by one bit  */
	int		xdir;								/* current direction							           */
	int		x, y;								/* Current grid point						           */
	int		end_yraster;
	int		yextreme;						/* y extreme breaks concave up/down curve in two  */
	int		tran_ct;							/* Number of transitions curve produces           */
	int		tran_ct2;						/* ditto for 2nd part of curve if concave up/down */

	SL32VECTOR A, B, START, K;
	SL32		alpha, beta, gamma;
	SL32		abs_alpha;
	SL32		dd, dx, dy;

	/* AWR */
	SL32		testA, testB;
	SL32		dxx, dyy, dxy;
	SL32		ky2p2, kx2q2;					/* K.y*K.y*p*p and K.x*K.x*q*q */
	DLONG		ddd;								/* double precision value */
	SL32		len2a;							/* 2* length(A) */
	SL32		len2b;							/* 2* length(B) */
	SL32		len2k;							/* 2* length(K) */
	SL32		mx2len;							/* max of above 3 lengths */
	int		shiftbits;						/* number of bits that inner loop d?? values shifted */
	int		zz;								/* missing pixel recovery */

/*-------------------------------------------------------------------*/
/*	 Process the input data which defines a quadratic bezier:
 *
 *			 start point	  p0
 *			 control point	  cntrl
 *			 end point		  p1
 *
 *	 as follows:
 *
 *		  1. Make sure x pixel sixe is greater than 1.
 *			  Multiply x coordinates by 2 if not.
 *
 *		  2. Verify that we do indeed have a curve. If p0, cntrl, and p1 are
 *			  co-linear, return an error or call bmras_lineto() for scan
 *			  conversion.
 *
 *		  3. Translate the curve by -p0 so that the starting point of the
 *			  curve is (0,0).	 Compute the parameters of a parametric
 *			  equation of the curve.
 *
 *						 (x(t), y(t)) = 2At + (B-A)t**2	 (0 <= t <=1)
 *										  = 2At + K	t**2	 define K = B-A
 */

	p0.x = if_state.p0.x;
	p0.y = if_state.p0.y;
	cntrl.x = cx;
	cntrl.y = cy;
	p1.x = px;
	p1.y = py;

#if IF_RDR

	/*
      Clip any control points which are outside bounding box to resolve
      banding problem - 9/15/93 jfd
	*/

	if (if_state.pbucket->fst_type == FC_IF_TYPE) {
		if (cntrl.x < if_state.tbound.ll.x)
			cntrl.x = if_state.tbound.ll.x;
		if (cntrl.y < if_state.tbound.ll.y)
			cntrl.y = if_state.tbound.ll.y;
		if (cntrl.x > if_state.tbound.ur.x)
			cntrl.x = if_state.tbound.ur.x;
		if (cntrl.y > if_state.tbound.ur.y)
			cntrl.y = if_state.tbound.ur.y;
	}
#endif

    DBG("\n\nbmras_quad_direct()\n");
    DBG5("--next element  (%ld %ld)  (%ld %ld)-----------------------%d\n",
(SL32)if_state.p0.x, (SL32)if_state.p0.y, (SL32)px, (SL32)py, ras.elem_num++);
    DBG4("                %.1f %.1f   %.1f %.1f\n",
     (double)if_state.p0.x/(double)xpix, (double)if_state.p0.y/(double)ypix,
     (double)px/(double)xpix, (double)py/(double)ypix);
    DBG2("  p0    = (%ld, %ld)\n", (SL32)p0.x, (SL32)p0.y);
    DBG2("  p1    = (%ld, %ld)\n", (SL32)p1.x, (SL32)p1.y);
    DBG2("  cntrl = (%ld, %ld)\n", (SL32)cntrl.x, (SL32)cntrl.y);
    DBG2("  log_xpix = %d   log_ypix = %d\n", log_xpix, log_ypix);

#if TILE
	/*
		check for entirely above or below tile region
	*/
	if (ras.above && (p1.y > ras.clip_fops_top) && (cntrl.y > ras.clip_fops_top))
		goto done;
	if (ras.below && (p1.y < ras.clip_fops_bot) && (cntrl.y < ras.clip_fops_bot))
		goto done;
#endif											/* TILE */

	/*
      Make sure x pixel size is greater than 1 (we need to deal with a half
      pixel).  If not, increase x & y resolution and restore at end. 
	*/

	enough_xres = log_xpix;
	if (!enough_xres) {
		p0.x <<= 1;
		p0.y <<= 1;
		cntrl.x <<= 1;
		cntrl.y <<= 1;
		p1.x <<= 1;
		p1.y <<= 1;

		log_xpix++;								/* must restore these at end */
		log_ypix++;
		xpix <<= 1;
		ypix <<= 1;
		half_xpix = 1;
		half_ypix = 1;							/* assuming xpix == ypix */
		if_state.p0.x <<= 1;
		if_state.p0.y <<= 1;
#if TILE
		ras.clip_fops_top <<= 1;
		ras.clip_fops_bot <<= 1;
#endif											/* TILE */
	}
/*
	calculate first and second relative vectors and k, the diagonal
*/
	A.x = (SL32) (cntrl.x - p0.x);		/* (0, 0) start point	  */
	A.y = (SL32) (cntrl.y - p0.y);		/* A		 control point	 */
	B.x = (SL32) (p1.x - cntrl.x);		/* A + B	  end point		 */
	B.y = (SL32) (p1.y - cntrl.y);
	K.x = B.x - A.x;
	K.y = B.y - A.y;

    DBG2("  A = (%ld, %ld)\n", A.x, A.y);
    DBG2("  B = (%ld, %ld)\n", B.x, B.y);
    DBG2("  K = (%ld, %ld)\n", K.x, K.y);

/*
   See if this curve will cause overflow in iterative calculations; if it
   does, we will have to divide it into 2 curves. 
   Numbers the size of -4 * A X B * K * xpix must fit in 31+shiftbits bits;
   that leaves 10 bits each for A, B and K. 
   Calculate number of fraction bits for shifted calculations. 
*/

#define MAXVEC	 2047							/* 2 * largest vectors that won't overflow */

	len2a = length_2(A.x, A.y);
	len2b = length_2(B.x, B.y);
	if ((mx2len = len2a) < len2b)
		mx2len = len2b;
	len2k = length_2(K.x, K.y);
	if (mx2len < len2k)
		mx2len = len2k;
	if (mx2len > MAXVEC) {
		INTRVECTOR lC, rC, pCrv;

		/* subdivide and try again on each half */

        DBG("   subdivide and try again on each half\n");
		lC.x = (p0.x + cntrl.x) >> 1;		/* next control point on left	 */
		lC.y = (p0.y + cntrl.y) >> 1;
		rC.x = (cntrl.x + p1.x) >> 1;		/* next control point on right */
		rC.y = (cntrl.y + p1.y) >> 1;
		pCrv.x = (lC.x + rC.x) >> 1;		/* curve point */
		pCrv.y = (lC.y + rC.y) >> 1;

		bmras_quad_direct(lC.x, lC.y, pCrv.x, pCrv.y);
		bmras_quad_direct(rC.x, rC.y, p1.x, p1.y);
		goto done;
	}
/*see if I can approximate with straight line, small altitude or small A X B */

/* max error will be 1/(1<<TOL_QUAD) pixels */
#define TOL_QUAD	 4							/* 1/16 pixel error */

	alpha = CRS(A, B);
    DBG1("    alpha = %ld\n", alpha);
	abs_alpha = alpha;
	if (abs_alpha < 0)
		abs_alpha = -abs_alpha;
	if (((abs_alpha << 4) < (SL32) (xpix << log_ypix)) ||
		 ((abs_alpha << (TOL_QUAD + 1)) < (length_2(A.x + B.x, A.y + B.y) << log_xpix))) {
        DBG("   approximating by straight line\n");
		status = ERR_straight_line;
		goto done;
	}
/*-------------------------------------------------------------------*/
/*				  Starting x and y values and transition counts.			*/
restart:
	tran_ct2 = 0;								/* set for single piece curve */

	if ((p0.y < cntrl.y) || ((p0.y == cntrl.y) && (cntrl.y < p1.y))) { /* Going Up */
		if (ras.ydir < 0)
			chng_tran_dir();
		y = ras.yraster;
#if TILE
		if (scan_convert.tile_on && (ras.above || ras.below))
			y = (int) YFLOOR(p0.y) + ((ras.ydir + 1) >> 1);
#endif											/* TILE */
		if (cntrl.y <= p1.y) {				/* completely up */
			end_yraster = YFLOOR(p1.y);
			tran_ct = end_yraster - y + 1;
            DBG3("Start yraster = %d    end_yraster = %d    tran_ct = %d\n",
                                          ras.yraster, end_yraster, tran_ct);
			if (tran_ct)
				ras.yraster = end_yraster + ras.ydir;
		} else {									/* changes direction, ends up going down- break in two */
			yextreme = YFLOOR( (INTR)((SL32)p0.y - (A.y * A.y - 1) / K.y) );
			end_yraster = YCEILING(p1.y + 1);
			tran_ct = MAX(yextreme - y + 1, 0);
			tran_ct2 = MAX(yextreme - end_yraster + 1, 0);
            DBG3(" Concave down: yextreme= %d, tran_ct= %d, tran_ct2= %d\n",
                                     yextreme, tran_ct, tran_ct2);
            DBG2("Start yraster = %d    end_yraster = %d\n",
                                                 ras.yraster, end_yraster);
			if (tran_ct2)
				ras.yraster = end_yraster - ras.ydir;
			else if (tran_ct)
				ras.yraster = yextreme + ras.ydir;
		}
	} else {										/* starts out going down or horizontal but then goes down */
		if (ras.ydir > 0)
			chng_tran_dir();
		y = ras.yraster;
#if TILE
		if (scan_convert.tile_on && (ras.above || ras.below))
			y = (int) YFLOOR(p0.y) + ((ras.ydir + 1) >> 1);
#endif											/* TILE */
		if (cntrl.y >= p1.y) {				/* completely down */
/*				  end_yraster = YCEILING(p1.y); */
			end_yraster = YCEILING(p1.y + 1);
			tran_ct = y - end_yraster + 1;
            DBG3("Start yraster = %d    end_yraster = %d    tran_ct = %d\n",
                                          ras.yraster, end_yraster, tran_ct);
			if (tran_ct)
				ras.yraster = end_yraster + ras.ydir;
		} else {									/* changes direction, ends up going up- break in two */
			yextreme = YCEILING( (INTR)((SL32)p0.y - (A.y * A.y - 1) / K.y) );
/*				  end_yraster = YFLOOR(p1.y-1); */
			end_yraster = YFLOOR(p1.y);
			tran_ct = MAX(0, y - yextreme + 1);
			tran_ct2 = MAX(0, end_yraster - yextreme + 1);
            DBG3(" Concave up: yextreme = %d, tran_ct = %d, tran_ct2 = %d\n",
                                     yextreme, tran_ct, tran_ct2);
            DBG2("Start yraster = %d    end_yraster = %d\n",
                                                 ras.yraster, end_yraster);
			if (tran_ct2)
				ras.yraster = end_yraster - ras.ydir;
			else if (tran_ct)
				ras.yraster = yextreme + ras.ydir;
		}
	}

	if ( !( tran_ct | tran_ct2 ) ) {
		if ( if_state.or_on ) {
			goto pseudo;
		} else {
			goto done;
		}
	}

	START.y = (((SL32) y << log_ypix) - p0.y); /* 9-24-93 jfd */

	/* Starting	 x values */

	if ((p0.x < cntrl.x) || ((p0.x == cntrl.x) && (cntrl.x < p1.x))) {
		/* AWR */
		testA = 0;
		testB = 1;
		xdir = 1;								/* advancing right */
		x = XCEILING(p0.x - (INTR) half_xpix);
		START.x = ((SL32) x << log_xpix) + (SL32) half_xpix;
	} else {
		/* AWR */
		testA = 1;
		testB = 0;
		xdir = -1;								/* advancing left */
		x = (int) XFLOOR(p0.x + (INTR) half_xpix);
		START.x = ((SL32) x << log_xpix) - (SL32) half_xpix;
	}
	START.x -= p0.x;

    DBG2("  START = (%ld, %ld)\n", START.x, START.y);
    DBG2("  xdir = %d   x = %d\n", xdir, x);
    DBG2("  ydir = %d   y = %d\n", ras.ydir, y);

/*-------------------------------------------------------------------*/
/*					  Compute dd, dx, dy, dxx, dyy, dxy							*/

	beta = CRS(K, START);
	gamma = CRS(A, START);
	/* dd	  = -4*alpha * gamma + beta*beta; */
	/* dx	  = ( 4*alpha*A.y + K.y*(-2*beta + (K.y<<log_xpix) ) )<<log_xpix; */
	/* dy	  = (-4*alpha*A.x + K.x*( 2*beta + (K.x<<log_ypix) ) )<<log_ypix; */
	/* dxx  = ( K.y*K.y)<<(2*log_xpix+1); */
	/* ky2p2= dxx>>1; */
	/* dyy  = ( K.x*K.x)<<(2*log_ypix+1); */
	/* kx2q2= dyy>>1; */
	/* dxy  = (-K.x*K.y)<<(log_xpix+log_ypix+1); *//* dxy = dyx */
/*
	This test fails to detect overflow of ddd.lo for high resolution outlines.

	if (mx2len > MAXVEC / 4)
		ddd = Ladd(Lmul(-4 * gamma, alpha), Lmul(beta, beta));
	else {
		ddd.lo = -4 * alpha * gamma + beta * beta;
		ddd.hi = (ddd.lo & 0x80000000 ? 0xFFFFFFFF : 0);
	}
*/
	ddd = Ladd(Lmul(-4 * gamma, alpha), Lmul(beta, beta));
	shiftbits = log_xpix + 1;
	/* ddlow=ddd.lo&((1<<shiftbits)-1); don't need ddlow */
	dd = (ddd.hi << (32 - shiftbits)) | (ddd.lo >> shiftbits);
	dx = (2 * alpha * A.y + K.y * (-beta + (K.y << (log_xpix - 1))));
	dy = (-2 * alpha * A.x + K.x * (beta + (K.x << (log_ypix - 1))));
	dxx = (K.y * K.y) << (log_xpix);
	ky2p2 = dxx >> 1;
	dyy = (K.x * K.x) << (log_ypix);
	kx2q2 = dyy >> 1;
	dxy = (-K.x * K.y) << (log_ypix); /* dxy = dyx */

    DBG3("  alpha %ld    beta %ld   gamma %ld\n", alpha, beta, gamma);
    DBG1("  dd = %ld    \n", dd);
    DBG3("  dx = %ld    dxx = %ld    ky2p2 = %ld\n", dx, dxx, ky2p2);
    DBG3("  dy = %ld    dyy = %ld    kx2q2 = %ld\n", dy, dyy, kx2q2);
    DBG1("  dxy = %ld\n", dxy);

	/*
      Reverse if needed.  The values were computed assuming we are moving
      up and to the right and that START is (nominally) outside of the
      curve. 
	*/
	if (xdir < 0) {
		dxy = -dxy;
		dx = -dx + dxx;
		/*
         was rev_x(); this switched testA and testB backwards because they
         were already set correctly. 
		*/
	}
	if (ras.ydir < 0)
		rev_y();

    DBG("After reversing:\n");
    DBG1("  dd = %ld\n", dd);
    DBG2("  dx = %ld    dxx = %ld\n", dx, dxx);
    DBG2("  dy = %ld    dyy = %ld\n", dy, dyy);
    DBG1("  dxy = %ld\n", dxy);

/*
	Check for pseudo_stroke mode
*/
	if ( pseudo_state ) {
		pseudo_scan( xdir, x, y, tran_ct, tran_ct2, A, B, K, alpha, beta, 
						dd, dx, dy, testA, testB, dxx, dyy, dxy, ky2p2, kx2q2 );
		goto restart;
	}

/*-------------------------------------------------------------------*/
/* Scan convert loop
 */

    DBG("x\ty\td\tdx\tdy\n");
    DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);

 loop:
/*see if tiling and missing pixel recovery are needed*/
	{
		/* this version of the loops includes tiling and missing pixel code */
		ras.seton = if_state.or_on && ras.beam;
		/* start in A mode (x steps into parabola) or B mode (x steps out) */
		if ((SL32) (((SL32) (xdir ^ ras.ydir)) ^ (SL32) alpha) >= 0) {
			/* B loop: x steps out of parabola */
	    DBG("starting B loop\n");
			for (; tran_ct > 0; --tran_ct) {
				/* see if it is time to reverse x direction */
				if ((dx > ky2p2) && (dd >= 0) && (dy > kx2q2)) {
		    DBG("Changing left or right\n");
					rev_x();
					x += xdir;
					xdir = -xdir;
		    DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
					break;						/* switch to A loop */
				}
				/* move at least to center of skinny parabolas */
				while (dx <= ky2p2) {
					adv_x();
		    DBG("adv_x\n");
		    DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
				}
				/* move to outside of parabola */
				/* AWR */
				while (dd < testB) {
					adv_x();
		    DBG("adv_x\n");
		    DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
				}
				VERT_TILE_CLIP
				{
					/* save raster intersection */
					ras.xx = x;
					HOR_TILE_CLIP
					writepixel(ras.xx);
					/* missing pixel recovery */
					if (if_state.or_on) {
						if (ras.first_tran) {
							ras.first_tran = FALSE;
							ras.ydir1 = ras.ydir;
							ras.xx1 = ras.xx;
							ras.seton1 = ras.seton;
							ras.dytran1 = ras.dytran;
							ras.toff1 = ras.toff;
							ras.wason = ras.seton;
						} else {
							if (ras.seton) {
								SETON;
								if (ras.wason) {
									SET_A;
								} else {
									SETPH;
									SET_B;
								}
							} else {
								if (ras.wason) {
									SETPH;
									SET_C;
								} else {
									SET_D;
								}
							}
							ras.wason = ras.seton;
						}
						ras.ptran = ras.xx;
					}
					/* advance y raster line */
					ras.toff += ras.dytran;
				}
				/* advance y on parabola */
				adv_y();
		DBG("adv_y\n");
		DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
			}
			/* make sure we have proper x direction at end of B loop */
			/* skinny parabolas may not have switched */
			if (xdir * B.x < 0) {
		DBG("Changing left or right\n");
				rev_x();
				x += xdir;
				xdir = -xdir;
		DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
			}
			/* B loop may fall into A loop at X extreme */
		}
		/* A loop: x steps into parabola */
	DBG("starting A loop\n");
		while (--tran_ct >= 0) {
			/* move into parabola */
			/* AWR */
			while ((dd >= testA) && (dx <= ky2p2)) {
				adv_x();
		DBG("adv_x\n");
		DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
			}
			VERT_TILE_CLIP
			{
				/* save raster intersection */
				ras.xx = x;
				HOR_TILE_CLIP
				writepixel(ras.xx);
				/* missing pixel recovery */
				if (if_state.or_on) {
					if (ras.first_tran) {
						ras.first_tran = FALSE;
						ras.ydir1 = ras.ydir;
						ras.xx1 = ras.xx;
						ras.seton1 = ras.seton;
						ras.dytran1 = ras.dytran;
						ras.toff1 = ras.toff;
						ras.wason = ras.seton;
					} else {
						if (ras.seton) {
							SETON;
							if (ras.wason) {
								SET_A;
							} else {
								SETPH;
								SET_B;
							}
						} else {
							if (ras.wason) {
								SETPH;
								SET_C;
							} else {
								SET_D;
							}
						}
						ras.wason = ras.seton;
					}
					ras.ptran = ras.xx;
				}
				/* advance y raster line */
				ras.toff += ras.dytran;
			}
			/* advance y on parabola */
			adv_y();
	    DBG("adv_y\n");
	    DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
		}
		/* A loop ends at Y extreme */
	}

	if (tran_ct2) {							/* concave up or down, second part of curve */
        DBG("Changing up or down\n");
		rev_y();

		/*
         Almost chng_tran_dir() but we don't need to change yraster, it's
         already been set to be at end of 2nd part of curve
		*/
		ras.ydir = -ras.ydir;
		ras.beam = !ras.beam;
		ras.dytran = -ras.dytran;
		ras.toff += ras.dytran;
#if NON_Z_WIND
		if (if_state.non_z_wind)
			nz_close_run();
#endif
		adv_y();
		tran_ct = tran_ct2;
		tran_ct2 = 0;
        DBG5("%d\t%d\t%ld\t%ld\t%ld\n", x, y, dd, dx, dy);
		goto loop;
	}

#if TILE
	if (scan_convert.tile_on) {
		ras.above = ras.below = 0;
		if (p1.y > ras.clip_fops_top) {
			ras.above = 1;
			ras.yraster = scan_convert.tb.ur.y + ((ras.ydir + 1) >> 1);
#if 0
			ras.ydir = -1;						/* we only get back in going down */
			ras.beam = (ras.polarity == 1);
			ras.dytran = ras.bmdim.x;
			ras.yraster = scan_convert.tb.ur.y;		/* tile box in pixels */
#endif											/* 0 cleanup - 5/12/93 - rs */
		} else if (p1.y < ras.clip_fops_bot) {
			ras.below = 1;
			ras.yraster = scan_convert.tb.ll.y + ((ras.ydir + 1) >> 1);
#if 0
			ras.ydir = 1;						/* we only get back in going up */
			ras.beam = (ras.polarity != 1);
			ras.dytran = -ras.bmdim.x;
			ras.yraster = scan_convert.tb.ll.y + 1;
#endif											/* 0 cleanup - 5/12/93 - rs */
		}
#if 0
		if (if_state.wrong_read)			/* polarity is reversed for wrong reading */
			ras.beam = !ras.beam;
		end_yraster = ras.yraster - scan_convert.tb.ll.y;
		ras.toff = ras.tsize - ((SL32) end_yraster * (SL32) ras.bmdim.x);
#endif											/* 0 cleanup - 5/12/93 - rs */
		offsetcheck();
	}
#endif											/* TILE */

	goto done;

 pseudo:
	if ( tran_ct == 0 ) { /* and if_state.or_on is also TRUE */
		INTR	delta_x;
		if ( pseudo_state ) {
		} else {
			record_state();
			pseudo_state = TRUE;
		}
		delta_x = p1.x - if_state.p0.x;
/*		ras.yraster = end_yraster + ras.ydir; *//* already computed */
		ras.seton = ras.beam;
		ras.xx = (int) ((( if_state.p0.x + (delta_x/2) ) + (INTR) half_xpix ) >> log_xpix );
		if ( first_pseudo_tran && ras.first_tran ) {
			first_pseudo_tran = FALSE;
			put_tran( &pseudo_tran );
		} else {
			if (ras.seton) {
				if (ras.wason) {
					SET_A;
				} else {
					SET_B;
				}
			} else {
				if (ras.wason) {
					SET_C;
				} else {
					SET_D;
				}
			}
		}
		ras.wason = ras.seton;
		ras.ptran = ras.xx;						/* last x transition */
		goto done;
	}

 done:
	if (!enough_xres) {
		log_xpix--;
		log_ypix--;
		xpix >>= 1;
		ypix >>= 1;
		half_xpix >>= 1;
		half_ypix >>= 1;
      if_state.p0.x >>= 1;
      if_state.p0.y >>= 1;
#if TILE
		ras.clip_fops_top >>= 1;
		ras.clip_fops_bot >>= 1;
#endif
	}
	if (status == ERR_straight_line)
		return (if_state.out.lineto(px, py));

	if_state.p0.x = px;						/* new current point */
	if_state.p0.y = py;
	return status;
}

#endif											/* DRAS_QUAD Quadratic: Direct Scan */


/*===================================================================*/

/*===================================================================*/
/*-------------------*/
/*  bmras_quad_flat  */
/*-------------------*/
/*===================================================================*/
#if ((DRAS_QUAD && LINEAR && (IF_RDR || TT_RDR || FCO_RDR)) || (!DRAS_QUAD && (TT_RDR || FCO_RDR)))

#ifdef LINT_ARGS
MLOCAL UW16   flatten_quad ( INTRVECTOR, INTRVECTOR, INTRVECTOR, int );
#else
MLOCAL UW16   flatten_quad();
#endif

/* max error will be 1/(1<<TOL_QUAD_FLAT) pixels */
#define TOL_QUAD_FLAT   2      /* 1/4 pixel error */

/*-------------------*/
/*  bmras_quad_flat  */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  bmras_quad_flat(INTR cx, INTR cy, INTR px, INTR py)
#else
GLOBAL UW16
bmras_quad_flat(cx, cy, px, py)
    INTR cx, cy, px, py; 
#endif
{
    UW16 status;
    INTRVECTOR cntrl, p1;
    SL32  dx, dy;
    SL32  err, tol;
    int   levels;

    cntrl.x = cx;
    cntrl.y = cy;
    p1.x    = px;
    p1.y    = py;
/*------------------------------------------------------------------*/
    DBG("\n\nbmras_quad_flat()   level\n");
#if INTR_SIZE == 16
    DBG5("--next element  (%d %d)    (%d %d)-----------------------%d\n",
                      if_state.p0.x, if_state.p0.y, p1.x, p1.y, ras.elem_num++);
    DBG4("                %.1f %.1f   %.1f %.1f\n\n\n",
     (double)if_state.p0.x/(double)xpix, (double)if_state.p0.y/(double)ypix,
     (double)p1.x/(double)xpix, (double)p1.y/(double)ypix);
    DBG2("  if_state.p0    = (%d, %d)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  cntrl = (%d, %d)\n", cntrl.x, cntrl.y);
    DBG2("  p1    = (%d, %d)\n", p1.x, p1.y);
#else
    DBG5("--next element  (%ld %ld)    (%ld %ld)-----------------------%d\n",
                      if_state.p0.x, if_state.p0.y, p1.x, p1.y, ras.elem_num++);
    DBG4("                %.1f %.1f   %.1f %.1f\n\n\n",
     (double)if_state.p0.x/(double)xpix, (double)if_state.p0.y/(double)ypix,
     (double)p1.x/(double)xpix, (double)p1.y/(double)ypix);
    DBG2("  if_state.p0    = (%ld, %ld)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  cntrl = (%ld, %ld)\n", cntrl.x, cntrl.y);
    DBG2("  p1    = (%ld, %ld)\n", p1.x, p1.y);
#endif
    DBG2("  log_xpix = %d   log_ypix = %d\n\n", log_xpix, log_ypix);
/*------------------------------------------------------------------*/

  /* Calculate 8*err */


  /* diagonal of parallelogram */
    dx = (SL32)if_state.p0.x - ((SL32)cntrl.x<<1) + (SL32)p1.x;
    dy = (SL32)if_state.p0.y - ((SL32)cntrl.y<<1) + (SL32)p1.y;
    DBG2("    (dx, dy) = (%ld, %ld)\n", dx, dy);

  /*  length_2() returns 2 times |(dx, dy)| = 8 times actual error.
   *  xpix>>TOL_QUAD_FLAT is specified error.  (Shift err rather than
   *  tol so that tol doesn't go to 0.
   */
    err = length_2(dx, dy) << TOL_QUAD_FLAT;
    tol = (SL32)xpix<<3;

    DBG2("    err = %ld       tol = %ld\n", err, tol);

    for(levels =0; err > tol; levels++)
        err >>= 2;
    DBG1("    levels = %d\n", levels);

#if LINEAR
    if(if_state.est_outline)
    {
        if_state.cs.ct_quadto--;
        if_state.cs.ct_lineto += (1<<levels);
        if_state.p0.x = px;
        if_state.p0.y = py;
        return SUCCESS;
    }
    else
#endif
    {
        if(levels)
        {
            status = flatten_quad(if_state.p0, cntrl, p1, levels);
            if(status)
                return status;
        }
        return (if_state.out.lineto (p1.x, p1.y));
    }
}

/*-------------------*/
/*  flatten_quad     */
/*-------------------*/
/* Routine to recursively subdivide quadratic Beziers.   */

#if defined (ANSI_DEFS)
MLOCAL UW16  flatten_quad(INTRVECTOR p0, INTRVECTOR pC, INTRVECTOR p1, int nn)
#else
MLOCAL UW16
flatten_quad( p0, pC, p1, nn )
  INTRVECTOR  p0, pC, p1;      /* start, control, end */
  int         nn;              /* number of levels of subdivision */
#endif
{
    INTRVECTOR lC, rC, pCrv;
    UW16 status = SUCCESS;


    DBG1("    flatten_quad()  levels = %d\n", nn);

    lC.x   = (p0.x + pC.x) >> 1;   /* next control point on left  */
    lC.y   = (p0.y + pC.y) >> 1;
    rC.x   = (pC.x + p1.x) >> 1;   /* next control point on right */
    rC.y   = (pC.y + p1.y) >> 1;
    pCrv.x = (lC.x + rC.x) >> 1;   /* curve point */
    pCrv.y = (lC.y + rC.y) >> 1;

#if IF_RDR
    if (if_state.pbucket->fst_type == FC_IF_TYPE)
    {
        if(pCrv.x < if_state.tbound.ll.x)
           pCrv.x = if_state.tbound.ll.x;
        if(pCrv.y < if_state.tbound.ll.y)
           pCrv.y = if_state.tbound.ll.y;
        if(pCrv.x > if_state.tbound.ur.x)
           pCrv.x = if_state.tbound.ur.x;
        if(pCrv.y > if_state.tbound.ur.y)
           pCrv.y = if_state.tbound.ur.y;
    }
#endif

    nn--;
    if(nn)
    {
        status = flatten_quad(p0, lC, pCrv, nn);
        if(status)
            return status;
    }
    status = if_state.out.lineto (pCrv.x, pCrv.y);
    if(status)
        return status;

    if(nn)
        return flatten_quad(pCrv, rC, p1, nn);
    return SUCCESS;
}
#endif /* Quadratic: Subdivide to levels                  */
/*===================================================================*/
#if AGFA_CUBE

#ifdef LINTARGS
MLOCAL  UW16 flatten_cube(INTR, INTR, INTR, INTR, INTR, INTR, INTR, INTR, int);
#else
MLOCAL  UW16 flatten_cube();
#endif

/* pixel/(1<<TOL_CUBE) is allowable error */
#define  TOL_CUBE   4      /* 1/16 pixel error */

#if PST1_RDR
/*-------------------*/
/*  bmras_cubeto     */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 bmras_cubeto (INTR  p1x, INTR p1y, INTR p2x, INTR p2y, INTR p3x, INTR p3y)
#else
GLOBAL UW16 bmras_cubeto (p1x, p1y, p2x, p2y, p3x, p3y)
INTR  p1x, p1y, p2x, p2y, p3x, p3y;
#endif
{
    UW16 status;
    SL32 Lx, Ly, Rx, Ry;
    SL32 lenl, lenr, err, tol;
    int  levels;

/*------------------------------------------------------------------*/
     DBG ("\nbmras_cubeto()    AGFA\n");
#if INTR_SIZE == 16
    DBG5("--next element  (%d %d)    (%d %d)-----------------------%d\n",
                      if_state.p0.x, if_state.p0.y, p3x, p3y, ras.elem_num++);
    DBG4("                %.1f %.1f   %.1f %.1f\n\n\n",
     (double)if_state.p0.x/(double)xpix, (double)if_state.p0.y/(double)ypix,
     (double)p3x/(double)xpix, (double)p3y/(double)ypix);
    DBG2("  p0  = (%d, %d)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  p1  = (%d, %d)\n", p1x, p1y);
    DBG2("  p2  = (%d, %d)\n", p2x, p2y);
    DBG2("  p3  = (%d, %d)\n", p3x, p3y);
#else
    DBG5("--next element  (%ld %ld)    (%ld %ld)-----------------------%d\n",
                      if_state.p0.x, if_state.p0.y, p3x, p3y, ras.elem_num++);
    DBG4("                %.1f %.1f   %.1f %.1f\n\n\n",
     (double)if_state.p0.x/(double)xpix, (double)if_state.p0.y/(double)ypix,
     (double)p3x/(double)xpix, (double)p3y/(double)ypix);
    DBG2("  p0  = (%ld, %ld)\n", if_state.p0.x, if_state.p0.y);
    DBG2("  p1  = (%ld, %ld)\n", p1x, p1y);
    DBG2("  p2  = (%ld, %ld)\n", p2x, p2y);
    DBG2("  p3  = (%ld, %ld)\n", p3x, p3y);
#endif
    DBG2("  log_xpix = %d   log_ypix = %d\n\n", log_xpix, log_ypix);
/*------------------------------------------------------------------*/

    Lx = ((SL32)p1x<<1) - (SL32)if_state.p0.x - (SL32)p2x;
    Ly = ((SL32)p1y<<1) - (SL32)if_state.p0.y - (SL32)p2y;
    Rx = ((SL32)p2x<<1) - (SL32)p1x - (SL32)p3x;
    Ry = ((SL32)p2y<<1) - (SL32)p1y - (SL32)p3y;
    DBG2("    Lx, Ly    %ld, %ld\n", Lx, Ly);
    DBG2("    Rx, Ry    %ld, %ld\n", Rx, Ry);

    lenl = length_2(Lx, Ly);      lenr = length_2(Rx, Ry);   /* 2*len */
    err = lenl>lenr ? lenl : lenr;
    err = (3*err) << TOL_CUBE;   /* 3*err = 8 times dist from curve to base */
    tol= ((SL32)xpix << 3);      /* to match the 8 times above */
    DBG2("    lenl, lenr  %ld, %ld\n", lenl, lenr);
    DBG2("    err, tol    %ld  %ld\n", err, tol);

    for(levels=0; err > tol; levels++)
        err >>= 2;
    DBG1("    levels = %d\n", levels);

#if LINEAR
    if(if_state.est_outline)
    {
        if_state.cs.ct_cubeto--;
        if_state.cs.ct_lineto += (1<<levels);
        if_state.p0.x = p3x;
        if_state.p0.y = p3y;
        return SUCCESS;
    }
    else
#endif
    {
        if(levels)
        {
            status = flatten_cube(if_state.p0.x, if_state.p0.y, p1x, p1y,
                                                       p2x, p2y, p3x, p3y, levels);
            if(status)
                return status;
        }
        return if_state.out.lineto(p3x, p3y);
    }
}
#endif /* PST1_RDR */


/*-------------------*/
/*  flatten_cube     */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  flatten_cube(INTR p0x, INTR p0y, INTR p1x, INTR p1y, INTR p2x,
   INTR p2y, INTR p3x, INTR p3y, int levels)
#else
MLOCAL UW16
flatten_cube(p0x, p0y, p1x, p1y, p2x, p2y, p3x, p3y, levels)
    INTR  p0x, p0y, p1x, p1y, p2x, p2y, p3x, p3y;
    int   levels;
#endif
{
    UW16 status;
    INTR lcx, lcy, rcx, rcy, px, py;

/*------------------------------------------------------------------*/
     DBG1("\nflatten_cube()    levels = %d\n", levels);
#if INTR_SIZE == 16
    DBG2("  p0  = (%d, %d)\n", p0x, p0y);
    DBG2("  p1  = (%d, %d)\n", p1x, p1y);
    DBG2("  p2  = (%d, %d)\n", p2x, p2y);
    DBG2("  p3  = (%d, %d)\n", p3x, p3y);
#else
    DBG2("  p0  = (%ld, %ld)\n", p0x, p0y);
    DBG2("  p1  = (%ld, %ld)\n", p1x, p1y);
    DBG2("  p2  = (%ld, %ld)\n", p2x, p2y);
    DBG2("  p3  = (%ld, %ld)\n", p3x, p3y);
#endif
/*------------------------------------------------------------------*/

    px  = (p0x + 3*p1x + 3*p2x + p3x + 4) >>3;
    py  = (p0y + 3*p1y + 3*p2y + p3y + 4) >>3;
    levels--;
    if(levels)
    {
        lcx = (p0x + p1x) >>1;
        lcy = (p0y + p1y) >>1;
        rcx = (p0x + p1x + p1x + p2x + 2) >>2;
        rcy = (p0y + p1y + p1y + p2y + 2) >>2;
        status = flatten_cube(p0x, p0y, lcx, lcy, rcx, rcy, px, py, levels);
        if(status)
            return status;
    }
    status = if_state.out.lineto(px, py);
    if(status)
        return status;
    if(levels)
    {
        lcx = (p1x + p2x + p2x + p3x + 2) >>2;
        lcy = (p1y + p2y + p2y + p3y + 2) >>2;
        rcx = (p2x + p3x) >>1;
        rcy = (p2y + p3y) >>1;
        return flatten_cube(px, py, lcx, lcy, rcx, rcy, p3x, p3y, levels);
    }
    return SUCCESS;
}
#endif
/*===================================================================*/
/*-------------------*/
/*  raster           */
/*-------------------*/
#if CGBITMAP

#if defined (ANSI_DEFS)
GLOBAL UW16  raster(LPUB8 tran_buffer, LPUB8 or_buffer, LPUB8 nzw_buf,
                                                       SW16VECTOR bmdim)
#else
GLOBAL UW16
raster(tran_buffer, or_buffer, nzw_buf, bmdim)
    LPUB8     tran_buffer;

    LPUB8     or_buffer;
    LPUB8     nzw_buf;
    SW16VECTOR bmdim;     /* bitmap dimensions */
#endif
{
    DBG("\nraster()\n");
    DBG1(" log_xpix %d\n", log_xpix);
    DBG2("  bmdim %d  %d\n", bmdim.x, bmdim.y);



    if_state.out = bmras_tbl;   /* set up for bitmaps */

    ras.tran_buffer = tran_buffer;
    ras.or_buffer   = or_buffer;
    ras.bmdim       = bmdim;

    ras.tsize = (SL32)ras.bmdim.x * (SL32)ras.bmdim.y;

#if NON_Z_WIND
    if(if_state.non_z_wind)
        nz_init(nzw_buf);
#endif

#if USE_JUMP_TABLES
    return (*((PIF_FUNC_TBL)if_state.pbucket->pft)->render)
                 (if_state.pbucket, if_state.xlate.x,
                                    if_state.xlate.y
                                      + (half_ypix<<if_state.right_shift));
#else
   switch (if_state.pbucket->fst_type)
   {
#if IF_RDR
      case FC_IF_TYPE:
         return (ifrender (if_state.pbucket, if_state.xlate.x,
                                            if_state.xlate.y
                                      + (half_ypix<<if_state.right_shift)));
         break;
#endif
#if PST1_RDR
      case FC_PST1_TYPE:
         return (psrender (if_state.pbucket, if_state.xlate.x,
                                            if_state.xlate.y
                                      + (half_ypix<<if_state.right_shift)));
         break;
#endif
#if TT_RDR
      case FC_TT_TYPE:
          return (ttrender (if_state.pbucket, if_state.xlate.x,
                                            if_state.xlate.y
                                      + (half_ypix<<if_state.right_shift)));
         break;
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
          return (fco_render (if_state.pbucket, if_state.xlate.x,
                                            if_state.xlate.y
                                      + (half_ypix<<if_state.right_shift)));
         break;
#endif
      default:
         return (ERR_fst_type);
     }
#endif /* USE_JUMP_TABLES */

}
#endif  /* CGBITMAP */

