/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/bold.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: bold.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   06 Apr 1995 15:10:50   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   22 Apr 1994 09:27:54   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.4   08 Dec 1993 18:59:42   ROB
 * No change.
 * 
 *    Rev 1.3   12 Feb 1993 11:28:10   JOE
 * 
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 10:47:36   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:37:06   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:14   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* bold.c */
/*
 *
 *
 * History
 *
 *  28-Jul-90 awr  created
 *  12-Oct-90 tbh  In bold(), computing point of intersection "dp->x",
 *                 "dp->y" differently in the event that both X and Y
 *                 skeletal data do not exist for a duplicate point.
 *  15-Oct-90 awr  In intersect(), check that intersection point does
 *                 not exceed bounding box
 *  30-Jan-91 dET  added function prototyping for MSC.
 *  31-Jan-91 dET  Modify for MSC multi-model compilation.
 *   3-Feb-91 awr  Removed nx(), ny() function declarations,
 *                 updated copyright.
 *                 Changed initialization call from np_init_char() to
 *                 init_xy_tran().
 *   5-Feb-91 awr  Conditionally compiled whole module on BOLD.
 *                 Added #include "cgconfig.h"
 *   8-Feb-91 awr  Removed EXTERN x_skel[] and y_skel[] and made
 *                 parameters of bold().
 *   6-Apr-91 awr  Changed intersect calculations to floating point
 *                 Removed long math code to lmath.c.
 *   8-Apr-91 jfd  In intersect(), call printf() only if MSC.
 *   1-Jun-91 awr  HQ4 changes
 *  17-Jun-91 jfd  Moved "debug.h" after "port.h".
 *                 Moved "profile.h" after "port.h".
 *  24-Aug-91 awr  Moved function decls to include file
 *  19 Sep 91 ss   Added casts for compare to -1 to eliminate warnings on SUN.
 *  03-Apr-92 rs   Portability cleanup (see port.h).
 *  16-Aug-92 rs   Change define from MSC to MSDOS.
 *                       Fix use of '-1' for UB8 & UW16.
 *  15-Sep-92 jfd  Conditionally entire module based on IF_RDR.
 *  14-Nov-92 rs   Port to Mac - ANSI function definitions using ANSI_DEFS,
 *                 rename bold() to cgbold().
 *  07-Jan-93 jfd  ANSI C function declaration changes.
 *  08-Feb-93 jfd  VXWorks support.
 */
/*-------------------------------------------------------------*/
/*                  b o l d     i n t e r s e c t              */



#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "profile.h"
#include "imath.h"
#include "fpmath.h"
#include "ifmem.h"
#include "cgif.h"
#include "ix.h"
#include "if_type.h"
#include "segments.h"
#include "adj_skel.h"
#include "tr_type.h"

#if IF_RDR

#if BOLD   /* whole module is conditionally compiled on BOLD */


#define TEST_INTERSECT 0   /* test against library floating point math */

/* move typedef's here to support function prototyping dET */

typedef struct
{
    UW16 loop;
    UW16 coord_index;   /* coordinate index within loop */
    UW16 x;
    UW16 y;
    UB8 xsk0, xsk1, ysk0, ysk1;
} DUP_POINTS;
typedef DUP_POINTS * PDUP_POINTS;


#ifdef LINT_ARGS
MLOCAL BOOLEAN no_intersect(PDUP_POINTS);
MLOCAL BOOLEAN intersect(SW16,SW16,SW16,SW16,SW16,SW16,SW16,SW16,PDUP_POINTS);
MLOCAL VOID set_tran(PTRAN, UW16, UW16);
MLOCAL VOID find_in_scale_seg(UW16, LPUW16, PTRAN, LPUB8, LPUB8);
MLOCAL VOID find_out_scale_seg(UW16,LPUW16, PTRAN, LPUB8, LPUB8);
#endif /* LINT_ARGS */







/*------------------------------------------------------------*/
#define MAX_DUP_POINTS 48
EXTERN DUP_POINTS dup_points[];
EXTERN  IF_STATE if_state;
EXTERN TRAN x_tran, y_tran;
/*------------------------------------------------------------*/



#if TEST_INTERSECT
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN test_intersect(SW16 xi0, SW16 yi0, SW16 xi1, SW16 yi1, 
    SW16 xo0, SW16 yo0, SW16 xo1, SW16 yo1, LPSW16 xx, LPSW16 yy)
#else
MLOCAL BOOLEAN
test_intersect(xi0, yi0, xi1, yi1, xo0, yo0, xo1, yo1, xx, yy)
    SW16 xi0, yi0, xi1, yi1, xo0, yo0, xo1, yo1;
    LPSW16 xx, yy;
#endif
{
    double a0, b0, a1, b1;
    double c0, c1;
    double det, half_det;
    double x_det, y_det;

    DBG("test_intersect()\n");
    DBG4("    (%d, %d)  (%d, %d)\n", xi0, yi0, xi1, yi1);
    DBG4("    (%d, %d)  (%d, %d)\n", xo0, yo0, xo1, yo1);

  /*  For the two lines, determine equations of the form:
   *
   *        a0*x + b0*y = c0
   *        a1*x + b1*y = c1
   */

    a0 = (double)(yi1 - yi0);
    b0 = (double)(xi0 - xi1);
    c0 = (double)((SL32)xi0*(SL32)yi1 - (SL32)yi0*(SL32)xi1);

    a1 = (double)(yo1 - yo0);
    b1 = (double)(xo0 - xo1);
    c1 = (double)((SL32)xo0*(SL32)yo1 - (SL32)yo0*(SL32)xo1);

    DBG3("    a0 b0 c0    %f  %f  %f\n", a0, b0, c0);
    DBG3("    a1 b1 c1    %f  %f  %f\n", a1, b1, c1);

    /*  Solve equations using determinants */

    det = a0*b1 - a1*b0;
    half_det = (det+1)/2;

    DBG1("    det  %f\n", det);

    if(!det)
    {
        DBG("    lines do not intersect\n");
        return FALSE;    /* lines don't intersect */
    }


    x_det = c0*b1 - c1*b0;
    y_det = a0*c1 - a1*c0;

    DBG1("    x_det %f\n", x_det);
    DBG1("    y_det %f\n", y_det);

    *xx = (SW16)((x_det + half_det) / det);
    *yy = (SW16)((y_det + half_det) / det);

    DBG2("    intersection (%d, %d)\n", *xx, *yy);

    return TRUE;
}
#endif




#if defined (ANSI_DEFS)
MLOCAL BOOLEAN no_intersect(PDUP_POINTS dp)
#else
MLOCAL BOOLEAN
no_intersect(dp)
    PDUP_POINTS  dp;
#endif
{
    DBG("    lines do not intersect\n");

    dp->xsk0 = 255;
    dp->xsk1 = 255;
    dp->ysk0 = 255;
    dp->ysk1 = 255;

    return FALSE;    /* lines don't intersect */
}

#if defined (ANSI_DEFS)
MLOCAL BOOLEAN intersect(SW16 xi0, SW16 yi0, SW16 xi1, SW16 yi1, 
        SW16 xo0, SW16 yo0, SW16 xo1, SW16 yo1, PDUP_POINTS dp)
#else
MLOCAL BOOLEAN
intersect(xi0, yi0, xi1, yi1, xo0, yo0, xo1, yo1, dp)
    SW16 xi0, yi0, xi1, yi1, xo0, yo0, xo1, yo1;
    PDUP_POINTS  dp;
#endif /* ANSI_DEFS */
{
    FPNUM a0, b0, c0, a1, b1, c1;
    FPNUM det;

    FPNUM x_det, y_det;
    SW16  x, y;
#if TEST_INTERSECT
    SW16 xx, yy;

    test_intersect(xi0, yi0, xi1, yi1, xo0, yo0, xo1, yo1, &xx, &yy);
#endif

    DBG("intersect()\n");
    DBG4("    (%d, %d)  (%d, %d)\n", xi0, yi0, xi1, yi1);
    DBG4("    (%d, %d)  (%d, %d)\n", xo0, yo0, xo1, yo1);

  /*  For the two lines, determine equations of the form:
   *
   *        a0*x + b0*y = c0
   *        a1*x + b1*y = c1
   */
    fpmath_error = 0;

    a0 = fpint2fp((SL32)(yi1 - yi0));
    b0 = fpint2fp((SL32)(xi0 - xi1));
    c0 = fpint2fp((SL32)xi0*(SL32)yi1 - (SL32)yi0*(SL32)xi1);

    a1 = fpint2fp((SL32)(yo1 - yo0));
    b1 = fpint2fp((SL32)(xo0 - xo1));
    c1 = fpint2fp((SL32)xo0*(SL32)yo1 - (SL32)yo0*(SL32)xo1);

    /*  Solve equations using determinants */

    det = fpsub(fpmul(a0, b1), fpmul(a1, b0));

    if(fpiszero(det))
        return no_intersect(dp);

    x_det = fpsub(fpmul(c0, b1), fpmul(c1, b0));    /* c0*b1 - c1*b0 */
    y_det = fpsub(fpmul(a0, c1), fpmul(a1, c0));    /* a0*c1 - a1*c0 */

    x = fp2word(fpdiv(x_det, det));
    y = fp2word(fpdiv(y_det, det));

    /* Check that we do not exceed bounding box   (10-15-90 awr) */

    if(fpmath_error || (x < if_state.bound_box.ll.x)
                    || (if_state.bound_box.ur.x < x)
                    || (y < if_state.bound_box.ll.y)
                    || (if_state.bound_box.ur.y < y))
        return no_intersect(dp);

    dp->x = x;
    dp->y = y;

    DBG2("    intersection (%d, %d)\n", dp->x, dp->y);
#if TEST_INTERSECT && defined(MSDOS)
    if((dp->x != xx) || (dp->y != yy))
    {
        printf("***difference in intersections:\n");
        printf("    float: (xx, yy) = (%d, %d)\n", xx, yy);
        printf("    int:   (x, y)   = (%d, %d)\n", dp->x, dp->y);

    }
#endif

    return TRUE;
}



#if defined (ANSI_DEFS)
MLOCAL VOID set_tran (PTRAN td, UW16 first_skel_ind, UW16 last_skel_ind)
#else
MLOCAL VOID
set_tran(td, first_skel_ind, last_skel_ind)
    PTRAN td;
    UW16  first_skel_ind, last_skel_ind;
#endif /* ANSI_DEFS */
{
    PADJUSTED_SKEL skel0, skel1;

    skel0 = td->skel + td->sct + first_skel_ind;
    skel1 = td->skel + td->sct + last_skel_ind;

    td->new0 = skel0->adjusted;
    td->new1 = skel1->adjusted;
    td->num  = td->new1 - td->new0;

    td->old0 = skel0->original;
    td->old1 = skel1->original;
    td->den  =  td->old1 - td->old0;
    if(!td->den) td->num = td->den = 1;
    td->half_den = td->den / 2;

    DBG2("new0  %d   new1  %d\n", td->new0, td->new1);
    DBG2("old0  %d   old1  %d\n", td->old0, td->old1);
    DBG2("num %d  den %d\n\n\n",td->num,td->den);
}

/* 10-12-90 tbh  Added argument "pskelMinus1" to find_in_scale_seg() */

#if defined (ANSI_DEFS)
MLOCAL VOID find_in_scale_seg(UW16 coord_index, LPUW16 s2c_base, PTRAN td, 
                   LPUB8 pskel, LPUB8 pskelMinus1)
#else
MLOCAL VOID
find_in_scale_seg(coord_index, s2c_base, td, pskel, pskelMinus1)
    UW16   coord_index;
    LPUW16  s2c_base;
    PTRAN   td;                       /* ptr to x or y transform data  */
    LPUB8  pskel, pskelMinus1;       /* 10-12-90 tbh */
#endif /* ANSI_DEFS */
{
    UW16 i;
    LPUW16 p;
    UW16  first_skel_ind, last_skel_ind;

    DBG1("find_in_scale_seg(%u)\n", coord_index);
    DBG1("    nsk = %u\n", td->nsk);

    for(i=0, p=s2c_base + td->sct; i<td->nsk; i++, p++)
    {
        DBG1("    %u\n", *p);
        if(*p >= coord_index)
        {
            DBG("      found it\n");
            break;
        }
    }
    if(i==0 || i==td->nsk)  /* scale seg = last skel to first skel */
    {
        first_skel_ind = td->nsk - 1;
        last_skel_ind  = 0;
    }
    else
    {
        first_skel_ind = i - 1;
        last_skel_ind = i;
    }
    DBG2("    first_skel_ind %u    last_skel_ind %u\n",
                                 first_skel_ind, last_skel_ind);

    *pskel = 0xff; /* -1 */    /* 255 */
    *pskelMinus1 = (UB8)(td->sct + first_skel_ind);  /* 10-12-90 tbh */
    if(i<td->nsk)
        if(*p == coord_index)
            *pskel = (UB8)(td->sct + last_skel_ind);

    set_tran(td, first_skel_ind, last_skel_ind);
}

/* 10-12-90 tbh  Added argument "pskelPlus1" to find_out_scale_seg() */

#if defined (ANSI_DEFS)
MLOCAL VOID find_out_scale_seg(UW16 coord_index, LPUW16 s2c_base, PTRAN td, 
            LPUB8 pskel, LPUB8 pskelPlus1)
#else
MLOCAL VOID
find_out_scale_seg(coord_index, s2c_base, td, pskel, pskelPlus1)
    UW16   coord_index;
    LPUW16  s2c_base;
    PTRAN   td;                       /* ptr to x or y transform data  */
    LPUB8  pskel, pskelPlus1;        /* 10-12-90 tbh */
#endif /* ANSI_DEFS */
{
    UW16  i;
    LPUW16 p;
    UW16  first_skel_ind, last_skel_ind;

    DBG1("find_out_scale_seg(%u)\n", coord_index);
    DBG1("    nsk = %u\n", td->nsk);

    i=td->nsk-1;
    for(p=s2c_base + td->sct + i; i>0; i--, p--)
    {
        DBG1("    %u\n", *p);
        if(*p <= coord_index)
        {
            DBG("      found it\n");
            break;
        }
    }
    if(i==(UW16)-1 || i==td->nsk-1)  /* scale seg = last skel to first skel */
    {
        first_skel_ind = td->nsk - 1;
        last_skel_ind  = 0;
    }
    else
    {
        first_skel_ind = i;
        last_skel_ind = i + 1;
    }
    DBG2("    first_skel_ind %u    last_skel_ind %u\n",
                                 first_skel_ind, last_skel_ind);

    *pskel = 0xff; /* -1 */   /* 255 */
    *pskelPlus1 = (UB8)(td->sct + last_skel_ind);  /* 10-12-90 tbh */
    if(i != (UW16)(-1)) /* should this be '!= (UW16)(-1)' ?? was '>=0' */
        if(*p == coord_index)
            *pskel = (UB8)(td->sct + first_skel_ind);

    set_tran(td, first_skel_ind, last_skel_ind);
}



#if defined (ANSI_DEFS)
GLOBAL VOID cgbold(PADJUSTED_SKEL x_skel, PADJUSTED_SKEL y_skel)
#else
GLOBAL VOID
cgbold(x_skel, y_skel)
    PADJUSTED_SKEL x_skel, y_skel;
#endif /* ANSI_DEFS */
{
    PDUP_POINTS dp;
    LOOP    loop;         /* current loop */
    UW16   loopct;
    UW16   id;           /* coordinate index of duplicate point in loop */
    UW16   ncoords;
    LPUW16  x_s2c_base;
    LPUW16  y_s2c_base;
    UW16   k;
    UB8   xskPlus1, yskPlus1, xskMinus1, yskMinus1;  /* 10-12-90 tbh */

    SW16VECTOR i0, i1, o0, o1;


    DBG("bold()\n");

  /* Initialize */

    dp = dup_points;
    init_xy_tran(x_skel, y_skel); /* initialize for skeletal interpolation */
    x_tran.sct = 0;
    y_tran.sct = 0;

    x_s2c_base = if_state.xskel.skel_to_contr;
    y_s2c_base = if_state.yskel.skel_to_contr;

    DBG1("    number of loops = %d\n", if_state.num_loops);

    first_loop();
    for(loopct = 0; loopct < if_state.num_loops; loopct++)
    {
        if(dp->loop == (UW16)-1) break;

        DBG("\n\n\nN e x t    L o o p\n");

        x_tran.nsk = *(x_tran.num_skel_loop++);
        y_tran.nsk = *(y_tran.num_skel_loop++);

        next_loop(&loop);
        ncoords = loop.ncoords;

        while(dp->loop == loopct)
        {
          /* set id = index of first duplicate point */

            id = dp->coord_index;      /* index of second duplicate point */
            if(id == 0)
                id =  ncoords - 1;  /* index of point just before */
            else
                id--;

          /* find incoming scaling segment */

            find_in_scale_seg(id, x_s2c_base, &x_tran, &dp->xsk0, &xskMinus1);  /* 10-12-90 tbh */
            find_in_scale_seg(id, y_s2c_base, &y_tran, &dp->ysk0, &yskMinus1);  /* 10-12-90 tbh */

          /* compute incoming line segment */

            if(id == 0)
                k = ncoords - 1;
            else
                k = id - 1;

            i0  = *(loop.cv + k);         /* coordinate points */
            i1  = *(loop.cv + id);

            DBG4("    in  old: (%d, %d) (%d, %d)\n", i0.x, i0.y, i1.x, i1.y);

            i0  = nxy(i0);
            i1  = nxy(i1);

            DBG4("    in  new: (%d, %d) (%d, %d)\n", i0.x, i0.y, i1.x, i1.y);

          /* find outgoing scaling segment */

            id = dp->coord_index;     /* index of second duplicate point */

            find_out_scale_seg(id, x_s2c_base, &x_tran, &dp->xsk1, &xskPlus1); /* 10-12-90 tbh */
            find_out_scale_seg(id, y_s2c_base, &y_tran, &dp->ysk1, &yskPlus1); /* 10-12-90 tbh */

          /* 10-12-90 tbh  The following code was added */
        
            if ( ( (dp->xsk0 == 255)  /* if no x-skel at this duplicate . .   */
                        && 
                   (dp->xsk1 == 255) 
                 )                    /* and contour is not horizontal . .    */
                 &&                
                 ( ((y_skel+dp->ysk1)->original != (y_skel+yskPlus1)->original) 
                        || 
                   ((y_skel+dp->ysk1)->original != (y_skel+yskMinus1)->original) 
                 )
               )
            {
                if      (dp->ysk0 == 255) dp->y = (y_skel+dp->ysk1)->adjusted;
                else if (dp->ysk1 == 255) dp->y = (y_skel+dp->ysk0)->adjusted;
                else    dp->y = ((y_skel+dp->ysk1)->adjusted + (y_skel+dp->ysk0)->adjusted + 1) >> 1;
            }

            else if
               ( ( (dp->ysk0 == 255)  /* if no y-skel at this duplicate . .   */
                        && 
                   (dp->ysk1 == 255) 
                 )                    /* and contour is not vertical . .      */
                 && 
                 ( ((x_skel+dp->xsk1)->original != (x_skel+xskPlus1)->original) 
                        || 
                   ((x_skel+dp->xsk1)->original != (x_skel+xskMinus1)->original) 
                 )
               )
            {
                if      (dp->xsk0 == 255) dp->x = (x_skel+dp->xsk1)->adjusted;
                else if (dp->xsk1 == 255) dp->x = (x_skel+dp->xsk0)->adjusted;
                else    dp->x = ((x_skel+dp->xsk1)->adjusted + (x_skel+dp->xsk0)->adjusted + 1) >> 1;
            }

            else
            {
                /* compute outgoing line segment */
     
                k = id + 1;
                if(k == ncoords)
                    k = 0;
     
                o0  = *(loop.cv + k);         /* coordinate points */
                o1  = *(loop.cv + id);
     
                 DBG4("    out old: (%d, %d) (%d, %d)\n",
                                                o0.x, o0.y, o1.x, o1.y);
     
                o0  = nxy(o0);
                o1  = nxy(o1);
     
                DBG4("    out new: (%d, %d) (%d, %d)\n",
                                                o0.x, o0.y, o1.x, o1.y);
      
                /* compute intersection of incomming and outgoing line segments */
     
                intersect(i0.x, i0.y, i1.x, i1.y, o0.x, o0.y, o1.x, o1.y, dp);
            }
     
          /* move to next duplicate point */

            dp++;

        } /*  while(dp->loop == loopct) */

        x_tran.sct += x_tran.nsk;
        y_tran.sct += y_tran.nsk;

    } /* end of character */

  /*  Change skeletal points  */

    for(dp = dup_points; dp->loop != (UW16)-1; dp++)
    {
        if(dp->xsk0 != 255) (x_skel+dp->xsk0)->adjusted = dp->x;
        if(dp->xsk1 != 255) (x_skel+dp->xsk1)->adjusted = dp->x;
        if(dp->ysk0 != 255) (y_skel+dp->ysk0)->adjusted = dp->y;
        if(dp->ysk1 != 255) (y_skel+dp->ysk1)->adjusted = dp->y;
    }
}
#endif  /* BOLD */
#endif  /* IF_RDR */
