/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/comp_pix.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: comp_pix.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.35   22 Sep 1995 10:50:30   JOE
 * In comp_pix(), changed conditional compile directive surrounding
 * loading of tt fontcontext to resolve compiler error.
 * 
 *    Rev 1.34   08 Aug 1995 15:47:26   JOE
 * Return no more than 4 frac_bits to prevent overflow in DRAS.
 * 
 *    Rev 1.33   06 Jul 1995 08:20:04   JOE
 * 
 * Basic 1200 dpi support.
 * 
 *    Rev 1.32   06 Apr 1995 15:10:52   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.31   27 Feb 1995 17:52:24   JOE
 * In matrix_em_world(), code changed from 2-22-95 must be conditional
 * on FCO_RDR (by mby).
 * 
 *    Rev 1.30   25 Feb 1995 13:20:36   MIKE
 * MAT0 scaling, nonsquare resolutions; see comments 2-24, 2-25-95
 * 
 *    Rev 1.29   22 Feb 1995 18:33:32   MIKE
 * For matrix input, change "inches_per_point" in matrix_em_world().
 * 
 *    Rev 1.28   14 Feb 1995 20:46:56   MIKE
 * 
 * For FCO_RDR removed "ERRmatrix_range", changed "max_design".
 * 
 *    Rev 1.27   25 Jan 1995 16:56:18   JOE
 * 
 * In matrix_to_scale(), changed the conditional compile statement which
 * surrounds the setting of the threshold value to include FCO_RDR.
 * 
 *    Rev 1.26   16 Jan 1995 15:38:44   MARTIN
 * 
 * Added FCO_RDR around fractional_output routine and in matrix_to_scale, arou
 * 
 *    Rev 1.25   11 Jan 1995 09:45:24   JOE
 * 
 * In matrix_to_scale(), added code to calculate "frac_places" for
 * FCO input.
 * 
 *    Rev 1.24   30 Nov 1994 18:34:36   MIKE
 * In matrix_to_scale(), use fpsqrt() to calculate pixel_size.
 * 
 *    Rev 1.23   21 Nov 1994 10:28:46   JOE
 * Added support for 1200 DPI output.
 * 
 *    Rev 1.22   16 Nov 1994 13:40:04   MIKE
 * Pass transformation matrix to fco code. Handle both 72 pt/in & 72.307 pt/in
 * 
 *    Rev 1.21   19 Oct 1994 16:47:54   MIKE
 * 
 * pixel_size for FCOs can be either IF or TT compatible.
 * 
 *    Rev 1.20   14 Oct 1994 14:48:44   MIKE
 * Added "orThreshold" to comp_pix_context for FCO processing.
 * 
 *    Rev 1.19   10 Oct 1994 12:34:44   MIKE
 * In comp_pix() resolved fontcontext matching problem.
 * 
 *    Rev 1.18   21 Sep 1994 18:28:42   MIKE
 * 
 * Add code to the beginning of comp_pix() to support FCO plugins.
 * 
 *    Rev 1.17   09 Sep 1994 17:13:00   JOE
 * In comp_pix(), moved "else" statement to line following "#if FCO_RDR"
 * block so that "comp_pix_context" settings are not overwritten for
 * PS or TT (if !FCO_RDR).
 * 
 *    Rev 1.16   11 Aug 1994 09:58:50   JOE
 * In matrix_to_scale(), corrected calculations for xpixel_size,
 * ypixel_size, if_state.x.orig_Pixel and if_state.y.orig_pixel to
 * resolve compiler error which occurs if INT_FP is enabled.
 * 
 *    Rev 1.15   10 Aug 1994 13:25:44   MIKE
 * 
 * Fix bug; "else if (FCO_ISFCO(fc))..." has to be conditionalized.
 * 
 *    Rev 1.14   05 Aug 1994 21:09:50   MIKE
 * Added FCO changes from 1.9.1.3
 * 
 *    Rev 1.13   27 Apr 1994 11:30:28   MIKE
 * 
 * Set if_state.shear in matrix_to_scale().
 * 
 *    Rev 1.12   22 Apr 1994 09:28:22   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.11   06 Mar 1994 14:12:18   MIKE
 * 
 * Do pseudo obliquing for Convergent Fonts, only if CONVERGENT_FONTS == 1
 * 
 *    Rev 1.10   03 Feb 1994 14:53:06   MIKE
 * 
 * Put Convergent Font italic angle into transformation matrix.
 * 
 *    Rev 1.9   14 Jan 1994 08:43:46   JOE
 * In matrix_to_scale(), added missing ";" to resolve compiler error.
 * 
 *    Rev 1.8   13 Jan 1994 17:10:38   JOE
 * In matrix_to_scale(), when calculating "if_state.or_on", do not set
 * based on "if_state.non_z_wind" because it is not needed.
 * 
 *    Rev 1.7   24 Aug 1993 15:31:16   LISA
 * Added line for truetype spotsize.
 * 
 *    Rev 1.6   09 Jul 1993 10:57:50   MAIB
 * set making_bold and non_z_wind independently
 * 
 *    Rev 1.5   01 Jul 1993 14:26:04   MAIB
 * changed making_bold to non_z_wind
 * 
 *    Rev 1.4   12 Feb 1993 11:41:14   JOE
 * VXWorks support.
 * 
 *    Rev 1.3   07 Jan 1993 11:19:00   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.2   15 Dec 1992 18:23:12   MIKE
 * Fixed bug in comp_pix() when switching between Intellifont and TrueType
 * 
 *    Rev 1.1   14 Dec 1992 09:34:24   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:22   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* to do
    - take care of NOTAN
    - adjusted baseline
    - fix comp_pix_context checking for quick exit
    - fill_in_design_data()
        error if s<0 || s>14
    - matrix_to_scale()
        disabled "can only scale down" check since PS and TT need to
        scale up. Must fix.
    - we are returning fp_math_error. This is not a valid cgif.h error code
    - move PS and TT values for "frac_places" to UFST-specific routines 
*/

/*  comp_pix.c  */



/*-----------------------------------------------------------------
  20-Mar-90  jfd  Added check for tangent already computed
                  in routine COMP_PIX()
  05-May-90  awr  Added landscape. Set new variable d.quadrant to indicate
                  rotation type. Eliminated rotate_on. Swap x and y
                  resolution and spot size for 90 and 270 degree rotation.
  07-Jul-90  awr  removed above swapping.
  10-Sep-90  awr  changed computations for arbitrary rotation and shear to
                  produce a rotated pixel size and spot size.
  25-Sep-90  dET  made 'fpix' and 'fnew_pix' MLOCAL to prevent protection
                  violations under windows 3.0. This is an obscure bug!
  11-Nov-90  dET  Added check in comp_pix to limit  ( -45 < shear < 45 )
                  as does IF 2.2.
  10-Dec-90  awr  Changed to compute output pixel sizes same as IF2.
  03-Jan-91  jfd  Including file "cgconfig.h".
  28-Jan-91  jfd  Handling point sizes in 16ths of a point if specified
                  in pix_calc() and comp_pix().
                  
                  Performing error checking on returns from pix_calc() in
                  comp_pix().

                  Calculating point size units flag in comp_pix() and
                  checking it for 16ths. Also, added it as an argument
                  to pix_calc() where it is checked.
  30-Jan-91  dET  Modify for MSC multi-model compilation.
   3-Feb-91  awr  added error return codes for comp_pix()
                  Removed include imath.h- not needed,
                  updated copyright.
  23-Feb-91  awr  Changed bucket sub-segment handles to offsets.
  13-May-91  jfd  Changed routine "comp_pix_change()" to "comp_pix_changed()"
  19-May-91  awr  corrected compiler warnings
  05-Jun-91  jfd  In typographer(), when calling pix_calc(), check first if
                  rotating 90 or 270 degrees. If so, pass point_size
                  when calculating "xmax" and set_size when calculating
                  "ymax". (FIX FROM EARLIER VERSION)
   9-Jun-91  awr  renamed and moved function is_qual() to maker.c
  17-Jun-91  jfd  Moved "debug.h" after "port.h".
  21 Jun 91  ss   Added prototypes for fpabs().
                  Moved prototype for fgseg() from ix.h.
   4-Jul-91  awr  Moved ERRdu_pix_range to cgif.h
                  Removed xy->max_des. No longer used
                  Removed translation from matrix
                  Added Wrong reading.
                  All now goes through matrix_to_scale().
   8-Jul-91  tbh  Added elasticity.
   1-Aug-91  tbh  Removed unreferenced variables.
                  Coerced face.orThreshold to WORD for pixel size comparison
  11-Aug-91  awr  Changed quadrant testing code in matrix_to_scale() to 
                  set pseudo bold as arbitrary rotation (d.quadrant=0).
  15 Aug 91  ss   Added mirror_matrix() & related code to support mirrored
                  characters.
  16-Aug-91  jfd  Removed function prototype for "fpabs" since it is done
                  in FPMATH.H .
  22-Aug-91  jfd  Conditionally compiling comb_des_world() based on
                  (SCALE_MATRIX & (MAT1_SCALE_MATRIX | MAT2_SCALE_MATRIX))
  28-Aug-91  jfd  Changed 3rd parameter in function prototype for
                  matrix_pt_world() from WORD to FPNUM to resolve a
                  compiler warning.
  29-Aug-91  jfd  In comp_pix(), replaced call to structs_are_equal() with
                  call to FCis_equal().
   1-Sep-91  awr  Removed extra fpmath_error resets and corrected
                  comp_pix_changed() switch statement.
   3-Sep-91  awr  removed scale.tt0 code and references to scale.m[4..5]
   12-Oct-91 awr  Missing pixel recovery and pseudo bold are no 
                  longer mutually exclusive.
    4 Dec 91 ss   Added more things to test for comp_pix() context changed.
                  Inspired by problem with plugin character requested as
                  a proofer pcleo.  Running thru comp_pix() makes sure that
                  all scaling and resolution info set correctly in d.
   11-Jan-92 awr  Fixed bug in comp_pix_changed().
   23-Jan-92 awr  removed unused constant eight_k in matrix_to_scale()
   26-Jan-92 awr  Added call to ttset_trans()
   29-Jan-92 jfd  In matrix_to_scale(), now declaring "fst_frac_bits"
                  conditionally based on (PST1I || TT_RDR).
                  Changed "FC_TT_RDR" to "FC_ISTT".
   07-Feb-92 jfd  In matrix_to_scale(), hard-wiring "if_state.or_on" to
                  TRUE for IF, PS and TT (for now!)
   24-Feb-92 jfd  In matrix_em_world(), changed EXTERN to EXTERN_FONT and
                  corrected typo "com_pix_context" to "comp_pix_context".
    4 Mar 92 ss   In comp_pix(), put back in test for COMP_PIX_CONTEXT_CHGD
                  to make sure comp_pix() is executed when changing to/from
                  mirrored characters.
    7-Mar-92 awr  matrix_to_scale(): Corrected dbg statement for ypixel_size.
   03-Apr-92 rs   Portability cleanup (see port.h).
   08-Apr-92 jfd  In matrix_to_scale(), only hard-wiring "if_state.or_on"
                  TRUE (for missing pixel recovery) for PST1I and TT_RDR.
   08-Apr-92 rs   Add conditionals for some declarations:
                  'mirror_matrix()', 'matrix_pt_world()', 'matrix_em_world()',
                  'comb_des_world()', 'matrix_design()'.
   12 May 92 ss   Changed conditional compiles from EXTERN_FONT to NON_IF_FONT
                  since EXTERN_FONT is used elsewhere to mean PCLEO.
                  NON_IF_FONT signifies that one or more PS/TT options are
                  enabled.
    2 Jun 92 jfd  In matrix_to_scale(), setting "if_state.quality" if
                  PS or TT for PS and TT outlines (I'm not sure if this is
                  really needed!!)
   17-Jun-92 awr  Changed if_state.?.grid_align to INTR
    3-Jul-92 awr  Moved structs_are_equal() from bmputl.c
   21-Jul-92 awr  Conditional compile changes
   05-Aug-92 det  Included "mixmodel.h" and "string.h".
                  Replaced calls to FCis_equal() and structs_are_equal()
                  with MEMCMP for optimation.
                  Disabled structs_are_equal().
                  Added missing pixel recovery cut-in check for PS and TT.
   06-Aug-92 jfd  In matrix_to_scale(), store original matrix elements
                  in m0, m1, m2 and m3 for PS. When calculating "orig_pixel",
                  scale result to make it bigger so that missing pixel
                  recovery cut-in check will work.
   07-Aug-92 jfd  Compatability w/WINDOWS 3.1 (FIXED-->CGFIXED,
                  POINTFX-->CGPOINTFX)
   10-Aug-92 jfd  Changed missing pixel recovery cut-in threshold for PS and
                  TT from 18pt @ 96dpi to 18pt @ 300dpi.
   16-Sep-92 jfd  Changed declaration for "gaso_pn" from EXTERN to GLOBAL.
                  It is now declared EXTERN in bmputl.c
                  Changed declaration for "if_state" from EXTERN to GLOBAL.
                  Conditionally compiled routines fractional_output() and 
                  fill_in_design_data() based on IF_RDR.
   15-Oct-92 mby  Added yet another test in comp_pix() for fontcontext change
                  -- for TrueType fonts if TT_TTPLUGIN is on.
   02-Dec-92 mby  Fixed bug introduced by the 10/15 change - when switching
                  between Intellifont and TrueType.
   07-Jan-93 jfd  ANSI C function declaration changes.
   08-Feb-93 jfd  VXWorks support.
   01-Jul-93 maib  Changed making_bold to non_z_wind
   09-Jul-93 maib Added making_bold back, and set independently from
                  non_z_wind
   13-Jan-94 jfd  In matrix_to_scale(), when calculating "if_state.or_on",
                  do not set based on "if_state.non_z_wind" because it
                  is not needed.
   02-Feb-94 mby  Incorporate Convergent Font oblique angle into transformation
                  matrix in matrix_to_scale() and modify comp_pix() logic so
                  this code is executed when necessary.
   06-Mar-94 mby  Execute above change only if CONVERGENT_FONTS == 1.
   26-Apr-94 mby  Set if_state.shear in matrix_to_scale() based on orthogonal
                  rotation and nonzero shear.
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 FCO Changes from 1.9.1.3:
   14-Mar-94 mby  For FCO reader, matrix_to_scale() sets up if_state and
                  calls fco_set_trans(). In typographer() hard-coded master
                  point size and resolution to 250, 2540.
   28-Mar-94 mby  Defined FCO_THRESHOLD for drop control, 18 Pt @ 300 dpi.
   20-Jun-94 mby  Added 'unitsPerEm' to comp_pix_context. Used in
                  matrix_to_scale() to compute pixel_size.
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   10-Aug-94 mby  In comp_pix(), conditionalize "else if (FC_ISFCO(fc)) ..."
                  for comp_pix_context structure.
   11-Aug-94 jfd  In matrix_to_scale(), corrected calculations for
                  xpixel_size, ypixel_size, if_state.x.orig_pixel and
                  if_state.y.orig_pixel to resolve compiler error which
                  occurs if INT_FP is enabled.
   09-Sep-94 jfd  In comp_pix(), moved "else" statement to line following
                  "#if FCO_RDR" block so that "comp_pix_context" settings
                  are not overwritten for PS or TT (if !FCO_RDR).
   21-Sep-94 mby  In comp_pix() for FCO plugin support, added code to compare
                  current fc to fc stored in BUCKET.p.fco.
   06-Oct-94 mby/jfd
                  In comp_pix(), set "if_state.cur_loc_fc.font_hdr = 0" to
                  resolve fontcontext switching problem.
   13-Oct-94 mby  Added "comp_pix_context.orThreshold", used to set
                  value of "if_state.orThreshold".
   19-Oct-94 mby  Added "comp_pix_context.compositionFlag", 1 for TT,
                  0 for IF. Pixel_size computation depends on this in
                  matrix_to_scale() and comp_pix().
   16-Nov-94 mby  For FCO_RDR, changed comp_pix_context parameters in
                  comp_pix() and matrix_to_scale() to handle 72 pt/in scaling
                  for TT compatible faces and 72.307 pt/in scaling for IF
                  compatible faces.
                  Added transformation matrix args to fco_set_trans() call.
                  Removed 'unitsPerEm' from comp_pix_context.
   21-Nov-94 jfd  Added support for 1200 DPI output.
   28-Nov-94 mby  In matrix_to_scale changed calculation of [xy]pixel_size
                  to use fpsqrt().
   09-Jan-95 jfd/mby  In matrix_to_scale(), added code to calculate 
                  "frac_places" for FCO input.
   16-Jan-95 SBM  In matrix_to_scale(), added | FCO_RDR around definition
                  of frac_places and fo_pix.Added |FCO_RDR around routine
                  fractional_output.
   23-Jan-95 jfd  In matrix_to_scale(), changed the conditional compile
                  statement which surrounds the setting of the threshold
                  value to include FCO_RDR.
   14-Feb-95 mby  For FCO_RDR in matrix_to_scale() removed 'ERRmatrix_range',
                  Changed calculation of "max_design".
                  Made fill_in_design_data() conditional only on IF_RDR.
   22-Feb-95 mby  In matrix_em_world(), fix "inches_per_point" computation
                  for FCO Intellifont-derived faces.
   24-Feb-95 mby  Added conditional pseudobold code in matrix_to_scale() for
                  FCO_RDR; compile with PSEUDO_BOLD_FCO. Not enabled for 3.0 release!
   25-Feb-95 mby  Need to preserve compatibility at the user interface for
                  MAT0 scaling between TrueType PCLETTO's and TT-derived FCO
                  fonts. In matrix_scale(), scale the matrix by the design
                  resolution to accomplish this.
   25-Feb-95 mby  Fixed scaling problem for nonsquare resolutions. In
                  matrix_to_scale() fixed typo that set an incorrect value for
                  "if_state.y.p_pixel".
   27-Feb-95 mby  In matrix_em_world(), code change from 2/22/95 must be
						conditional on FCO_RDR.
   06-Jul-95 mac  Basic 1200 dpi support.
   06-Aug-95 mac  Return no more than 4 frac_bits to prevent overflow in DRAS.
   22-Sep-95 jfd  In comp_pix(), changed conditional compile directive
                  surrounding loading of TT fontcontext from "#if TT_TTPLUG"
                  to "#if TT_TTPLUG && TT_RDR" to resolve compiler error.
---------------------------------------------------------------------------*/

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <string.h>

#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "ifmem.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "fmath.h"
#include "fpmath.h"
#include "mixmodel.h"
#if !INT_FP
#include <math.h>
#endif


#define CON_SIZE 2

#ifdef LINT_ARGS
GLOBAL UW16   comp_pix(PFONTCONTEXT, PBUCKET);
GLOBAL UW16   comp_pix_changed(PFONTCONTEXT, PBUCKET);

GLOBAL SW16    frac_bits(SL32);
#if IF_RDR
MLOCAL UW16   fill_in_design_data(PCOORD_DATA, FPNUM, FPNUM);
#endif
#if IF_RDR|FCO_RDR
MLOCAL SW16    fractional_output(SW16);
#endif
MLOCAL UW16   typographer(PFONTCONTEXT, FPNUM);
MLOCAL UW16   matrix_to_scale(PFPNUM, PFONTCONTEXT);
#if SCALE_MATRIX
#if (FCO_RDR && (SCALE_MATRIX & MAT0_SCALE_MATRIX))
MLOCAL VOID   matrix_scale(PFPNUM, LPSL32, SW16, SW16);
#else
MLOCAL VOID   matrix_scale(PFPNUM, LPSL32, SW16);
#endif
#endif  /* SCALE_MATRIX */
#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
MLOCAL UW16   matrix_design(PFONTCONTEXT);
#endif
#if (SCALE_MATRIX & (MAT1_SCALE_MATRIX | MAT2_SCALE_MATRIX))
MLOCAL UW16   comb_des_world(FPNUM, FPNUM, LPSL32, SW16, PFONTCONTEXT);
#endif
#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
MLOCAL UW16   matrix_em_world(PFONTCONTEXT);
#endif
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
MLOCAL UW16   matrix_pt_world(PFONTCONTEXT, FPNUM);
#endif
#if 0
MLOCAL BOOLEAN structs_are_equal(LPSB8, LPSB8, int);
EXTERN BOOLEAN FCis_equal(LPSB8, LPSB8);
#endif
#if SLIM_FONTS /* add 4/8/92 - rs */
MLOCAL SW16    mirror_matrix( PFPNUM );
#endif

/*  fm.c  */
EXTERN LPSB8         fgseg(PBUCKET);

#else     /*  else !LINT_ARGS  */
/*  fm.c  */
EXTERN LPSB8    fgseg();

#if SLIM_FONTS /* add 4/8/92 - rs */
MLOCAL SW16    mirror_matrix();
#endif

#endif       /* LINT_ARGS  */


/*------------------------------------------------------------*/
GLOBAL IF_STATE if_state;
#if 0 /* looks like these are not used - 4/8/92 - rs */
MLOCAL  CGFIXED fpix;
MLOCAL  CGFIXED fnew_pix;
#endif /* 0 */

/* Save a comp_pix context to see what changes to next time.   -ss 12/4/91 */
MLOCAL struct {
#if SLIM_FONTS
   UB8        mirflags;            /* mirror_flags   */
#endif
   UW16       masterPt;            /* master point size    */
   UW16       xRes;
   UW16       yRes;
#if FCO_RDR
   UW16       orThreshold;         /* 10-13-94, mby */
   SB8        compositionFlag;     /* 0=IF compatible; 1=TT compatible */ 
#endif  /* FCO_RDR */
} comp_pix_context;

#if SLIM_FONTS
#define COMP_PIX_CONTEXT_CHGD()   \
   ( (display->masterPointSize     != comp_pix_context.masterPt) \
     || (display->scanResolutionX  != comp_pix_context.xRes)     \
     || (display->scanResolutionX  != comp_pix_context.yRes)     \
     || (comp_pix_context.mirflags != chr_def_hdr.mirror_flags) )
#else
#define COMP_PIX_CONTEXT_CHGD()   \
   ( (display->masterPointSize    != comp_pix_context.masterPt) \
     || (display->scanResolutionX != comp_pix_context.xRes)     \
     || (display->scanResolutionX != comp_pix_context.yRes) )
#endif

GLOBAL int gaso_pn;


#if SLIM_FONTS
EXTERN CHR_DEF_HDR chr_def_hdr;
#endif

#if (CONVERGENT_FONTS == 1)
EXTERN AWT_TABLE awtData;
#endif

#if PST1_RDR
#define    PS_THRESHOLD    13     /* PS pix size for 18pt @ 300dpi */
#endif

#if TT_RDR
#define    TT_THRESHOLD    13     /* TT pix size for 18pt @ 300dpi */
#endif

/*------------------------------------------------------------*/


#if 0
/*--------------------*/
/*  structs_are_equal */
/*--------------------*/
/*  Return TRUE if the structures pointed at by p and q of size s bytes
 *  are identical. Return FALSE otherwise.
 */
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN structs_are_equal(LPSB8 p, LPSB8 q, int s)
#else
MLOCAL BOOLEAN
structs_are_equal(p, q, s)
    LPSB8 p, q;
    int   s;
#endif
{
    return !MEMCMP(p,q,s);
}
#endif /* 0 */


/*--------------------*/
/*     frac_bits      */
/*--------------------*/
/*  Returns the number of fractional bits allowed for representing output
 *  pixels. The parameter v is the largest pixel value we will ever have.
 *  The number of fractional bits allowed is half the number of remaining
 *  bits in a 14 bit "word" after accounting for v itself. The reason for
 *  the half is that we multiply fractional pixel size by a fractional
 *  pixel coordiate in raster and want the result to fit into 14 bits.
 *  The reason for 14 bits and not 15 is because that's the way if2
 *  does it.
 */
#if defined (ANSI_DEFS)
GLOBAL SW16  frac_bits(SL32 v)
#else
GLOBAL SW16
frac_bits(v)
    SL32 v;
#endif
{
    int c, r;

  /* Count the number of bits in v */

    c=0;
    while(v>0)
    {
        v >>= 1;
        c++;
    }

  /*  return half of the bits v doesn't use in a 14 bit "word" */
#ifdef NOT1200DPI
    return (SW16)((14-c)>>1);
#else
/*
	For the time being this turned out to be the best solution for a Q&D
	version of UFST for 1200 dpi that does not require extensive revision
	of the code to avoid overflow.
*/
	if ( c > 14 ) {
		r = 0;
	} else if ( c > 4 ) {
		r = ( 14 - c )/2;
	} else {
		r = 4;
	}
   return( (SW16)r );
#endif  /* NOT1200DPI */
}


#if IF_RDR|FCO_RDR
/*--------------------*/
/*  fractional_output */
/*--------------------*/
/*  Compute the sizes of fractional output pixels. The parameters
 *  xmax and ymax are largest output xoordinates in pixels that will
 *  ever be used. We see how many bits xmax and ymax don't use in a SW16
 *  and then make the fractional size as large as possible. Both x and y
 *  fractional pixel sizes are made the same.
 *
 *  We also calculate a shift value used in transforming from design units
 *  to fractional output units. These values are used by tx() and ty()
 *  in imath.c.
 *
 *  This functions fills in the sc.x and sc.y fields:
 *
 *      pixel_size    output fractional pixel size, power of 2
 *      half_pixel    pixel_size / 2
 *      grid_shift    ammount to shift x to obtain x/pixel_size
 *      grid_align    x & grid_align is a whole number of pixels
 *
 *      shift
 *      shift_rnd
 *
 *  Returns the output pixel size.
 */
#if defined (ANSI_DEFS)
MLOCAL SW16  fractional_output(SW16 frac_places)
#else
MLOCAL SW16
fractional_output(frac_places)
    SW16 frac_places;
#endif
{
    SW16 frac_pixel;

    DBG1("fractional_output(frac_places=%d\n", frac_places);

    frac_pixel = 1<<frac_places;

    if_state.x.pixel_size = if_state.y.pixel_size = frac_pixel;
    if_state.x.half_pixel = if_state.y.half_pixel = frac_pixel >> 1;
    if_state.x.grid_shift = if_state.y.grid_shift = frac_places;
    if_state.x.grid_align = if_state.y.grid_align = ~((INTR)frac_pixel
                                                                 -(INTR)1);

    if_state.x.shift = 16 - if_state.x.bin_places - log_xpix;
    if_state.x.shift_rnd = 1<<(if_state.x.shift-1);

    if_state.y.shift = 16 - if_state.y.bin_places - log_ypix;
    if_state.y.shift_rnd = 1<<(if_state.y.shift-1);


    DBG2("    pixel_size = %d  half_pixel = %d\n", if_state.x.pixel_size,
                                                   if_state.x.half_pixel);
#if INTR_SIZE == 16
    DBG2("    grid_align = %x  grid_shift = %d\n", if_state.x.grid_align,
                                                   if_state.x.grid_shift);
#else
    DBG2("    grid_align = %lx  grid_shift = %d\n", if_state.x.grid_align,
                                                   if_state.x.grid_shift);
#endif
    DBG2("    x.shift = %d, x.shift_rnd = %d\n",   if_state.x.shift,
                                                   if_state.x.shift_rnd);
    DBG2("    y.shift = %d, y.shift_rnd = %d\n",   if_state.y.shift,
                                                   if_state.y.shift_rnd);

    return frac_pixel;
}
#endif  /* IF_RDR|FCO_RDR */


#if IF_RDR
/*---------------------*/
/* fill_in_design_data */
/*---------------------*/
/*  Fill in the design unit pixel data used for grid aligning. */
#if defined (ANSI_DEFS)
MLOCAL UW16  fill_in_design_data(PCOORD_DATA xy, FPNUM pixel_size, FPNUM bias)
#else
MLOCAL UW16
fill_in_design_data(xy, pixel_size, bias)
    PCOORD_DATA xy;
    FPNUM       pixel_size;
    FPNUM       bias;
#endif
{
    UL32       t;          /* precise pixel size = t >> s */
    SW16        s;
    SL32        phpix;
    SL32        tbias;

  /*  Original pixel size with no fractional precision. Used to
   *  compare with typeface or-on threshold.
   */

    xy->orig_pixel = fp2word(pixel_size);

  /*  Constrained dimension limit = pixel_size * CON_SIZE.
   *  (CON_SIZE = 2)
   */

    xy->con_size = fp2word(fpmul(pixel_size, fpint2fp((SL32)CON_SIZE)));

  /* Fractional pixel values used in skeletal processing */

    t = (UL32)fp2intel(pixel_size, (LPSW16)&s);
#ifdef NOT1200DPI
    if(s<0 || s>14)	/* Minimum pixel size is 1.058333 = 0.529167*2^1 */
#else
    if(s<0 || s>15)	/* Minimum pixel size is 0.529167 = 0.529167*2^0 */
#endif  /* NOT1200DPI */
        return ERRdu_pix_range;

    tbias = fp2long(fpmul(bias,fplongexp(1L, -s)));

    xy->p_pixel    = (SW16)t;
    phpix          = t >> 1;      /* precise half pixel */
    xy->p_half_pix = (SW16)phpix;
    xy->bin_places = s;

    xy->round[0] = phpix - tbias;
    xy->round[1] = phpix + tbias;
    xy->round[2] = phpix;
    xy->round[3] = phpix;

    DBG2("    p_pixel = %d  bin_places = %d\n", xy->p_pixel, xy->bin_places);
    DBG1("    bias = %ld\n", bias);
    DBG1("    con_size = %d\n", xy->con_size);
    DBG4("    round  %ld  %ld  %ld  %ld\n", xy->round[0], xy->round[1],
                                            xy->round[2], xy->round[3]);

  /* Standard dimension */

    xy->stand_value = 0;   /* to indicate that it must be recomputed */

    return SUCCESS;
}
#endif  /* IF_RDR */

#if SLIM_FONTS
#if defined (ANSI_DEFS)
MLOCAL SW16  mirror_matrix( PFPNUM m )
#else
MLOCAL SW16
mirror_matrix( m )
    PFPNUM m;
#endif
{
    FPNUM  m0, m1, m2, m3;
    FPNUM  n0, n1, n2, n3;
    
    m0 = *m;
    m1 = *(m+1);
    m2 = *(m+2);
    m3 = *(m+3);

    switch( chr_def_hdr.mirror_flags )
    {
      case MIRROR_ROT0:  /*  Identity - NOP                             */
                         /*   | 1  0 |  *  | m0 m1 |  =  | m0  m1 |     */
                         /*   | 0  1 |     | m2 m3 |     | m2  m3 |     */
          n0 =  m0;
          n1 =  m1;
          n2 =  m2;
          n3 =  m3;
          break;
      case MIRROR_ROT90: /*  rotate 90                                 */
                         /*   |  0  1 |  *  | m0 m1 |  =  |  m2  m3 |   */
                         /*   | -1  0 |     | m2 m3 |     | -m0 -m1 |   */
          n0 =  m2;
          n1 =  m3;
          n2 = fpneg(m0);
          n3 = fpneg(m1);
          break;
      case MIRROR_ROT180:/*  rotate 180, mirror in X and Y             */
                         /*   | -1   0 |  *  | m0 m1 |  =  | -m0 -m1 |  */
                         /*   |  0  -1 |     | m2 m3 |     | -m2 -m3 |  */
          n0 = fpneg(m0);
          n1 = fpneg(m1);
          n2 = fpneg(m2);
          n3 = fpneg(m3);
          break;
      case MIRROR_ROT270:/*  rotate 270                                */
                         /*   | 0  -1 |  *  | m0 m1 |  =  | -m2 -m3 |   */
                         /*   | 1   0 |     | m2 m3 |     |  m0  m1 |   */
          n0 = fpneg(m2);
          n1 = fpneg(m3);
          n2 =  m0;
          n3 =  m1;
          break;

      case MIRROR_NEGROT0:/*  mirror in X direction                     */
                         /*   | -1  0 |  *  | m0 m1 |  =  | -m0 -m1 |   */
                         /*   |  0  1 |     | m2 m3 |     |  m2  m3 |   */
          n0 = fpneg(m0);
          n1 = fpneg(m1);
          n2 =  m2;
          n3 =  m3;
          break;
      case MIRROR_NEGROT90:/*  mirror across the line y = -x            */
                         /*   |  0 -1 |  *  | m0 m1 |  =  | -m2 -m3 |   */
                         /*   | -1  0 |     | m2 m3 |     | -m0 -m1 |   */
          n0 = fpneg(m2);
          n1 = fpneg(m3);
          n2 = fpneg(m0);
          n3 = fpneg(m1);
          break;
      case MIRROR_NEGROT180: /*  mirror in Y direction                  */
                         /*   |  1   0 |  *  | m0 m1 |  =  |  m0  m1 |  */
                         /*   |  0  -1 |     | m2 m3 |     | -m2 -m3 |  */
          n0 =  m0;
          n1 =  m1;
          n2 = fpneg(m2);
          n3 = fpneg(m3);
          break;
      case MIRROR_NEGROT270: /*  mirror across the line y = x           */
                         /*   | 0   1 |  *  | m0 m1 |  =  |  m2  m3 |   */
                         /*   | 1   0 |     | m2 m3 |     |  m0  m1 |   */
          n0 = m2;
          n1 = m3;
          n2 = m0;
          n3 = m1;
          break;
      default:
          break;
   }  /* end - switch */
   /* copy changes for return  */
   *m     = n0;
   *(m+1) = n1;
   *(m+2) = n2;
   *(m+3) = n3;

   return SUCCESS;
}   /*  end - mirror_matrix  */
#endif  /*  SLIM_FONTS  */


/*--------------------*/
/*   matrix_to_scale  */
/*--------------------*/
/*
Computes the grid alignment and scaling transformations from a matrix
that represents the transformation from design units to output pixels.
*/

#if defined (ANSI_DEFS)
MLOCAL UW16  matrix_to_scale(PFPNUM m, PFONTCONTEXT fc)
#else
MLOCAL UW16
matrix_to_scale(m, fc)
    PFPNUM m;             /*  matrix */
    PFONTCONTEXT fc;
#endif
{
    FPNUM one;
#if (NON_IF_FONT)
    FPNUM fst_frac_bits;
#endif
    FPNUM m0, m1, m2, m3;       /* Matrix */
    FPNUM am0, am1, am2, am3;   /* Absolute values of matrix elements */
    FPNUM det;                  /* determinate */
    UW16 status;
#if IF_RDR | FCO_RDR
    FPNUM fo_pix;               /* fractional output pixel size */
    SW16  frac_places;
    int   i;
#endif

   /* Removed the following 2 lines from the IF-specific section of code
    */

    FPNUM tmp;
    FPNUM xpixel_size, ypixel_size;

    DBG("matrix_to_scale()\n");

    one        = fpint2fp(1L);



#if (CONVERGENT_FONTS == 1)     /* mby, 3-06-94 */
    /* Check for CVF oblique angle and merge it into the     */
    /* transformation matrix - unless PROHIBIT_ITALIC is set */
    if (if_state.awtsub_on && awtData.italTan && !awtData.charProhbItal)
    {
        *(m+2) = fpadd(*(m+2), fpmul(fpfixed2fp(awtData.italTan),*(m)));
        *(m+3) = fpadd(*(m+3), fpmul(fpfixed2fp(awtData.italTan),*(m+1)));
    }
#endif  /* CONVERGENT_FONTS */

#if SLIM_FONTS
    /* check for mirror flags and mirror matrix if necessary */
    if( chr_def_hdr.mirror_flags )
       mirror_matrix( m );
#endif  /* SLIM_FONTS  */

  /* Values and absolute values of matrix elements */

#if PST1_RDR
    if(FC_ISPST1(fc))     /* if PostScript font */
    {
        /* concatenate with the fontmatrix (nominally scale by .001) */

        m0 = fpadd(fpmul(if_state.pbucket->p.ps.fontmatrix[0], *(m  )),
                   fpmul(if_state.pbucket->p.ps.fontmatrix[1], *(m+2)));
        m1 = fpadd(fpmul(if_state.pbucket->p.ps.fontmatrix[0], *(m+1)),
                   fpmul(if_state.pbucket->p.ps.fontmatrix[1], *(m+3)));
        m2 = fpadd(fpmul(if_state.pbucket->p.ps.fontmatrix[2], *(m+0)),
                   fpmul(if_state.pbucket->p.ps.fontmatrix[3], *(m+2)));
        m3 = fpadd(fpmul(if_state.pbucket->p.ps.fontmatrix[2], *(m+1)),
                   fpmul(if_state.pbucket->p.ps.fontmatrix[3], *(m+3)));

      /*  Pipeline seems to want matrix operating on left of vector so
       *  send transpose of concatenated matrix.
       */
        fst_frac_bits = fpint2fp(32768L);   /* scale by 2**15 */
        if(status = psset_trans(if_state.pbucket,
                               fp2long(fpmul(m0, fst_frac_bits)),
                               fp2long(fpmul(m2, fst_frac_bits)),
                               fp2long(fpmul(m1, fst_frac_bits)),
                               fp2long(fpmul(m3, fst_frac_bits)))
          ) return status;
    }
#endif

    m0 = *m;
    m1 = *(m+1);
    m2 = *(m+2);
    m3 = *(m+3);

#if TT_RDR
    if(FC_ISTT(fc))     /* if TrueType font */
    {
        fst_frac_bits = fpint2fp(65536L);
        if_state.pbucket->p.tt.spotsize = fc->xspot;
        if ((status = ttset_trans(if_state.pbucket,
                               fp2long(fpmul(m0, fst_frac_bits)),
                               fp2long(fpmul(m1, fst_frac_bits)),
                               fp2long(fpmul(m2, fst_frac_bits)),
                               fp2long(fpmul(m3, fst_frac_bits)) ) )
                      != SUCCESS)
            return status;
    }
#endif /* TT_RDR */

#ifdef DEBUG
    DBG("    m[] = ");   fpprint(m0);   fpprint(m1);  DBG("\n");
    DBG("          ");   fpprint(m2);   fpprint(m3);  DBG("\n");
#endif

    am0 = fpabs(m0);
    am1 = fpabs(m1);
    am2 = fpabs(m2);
    am3 = fpabs(m3);

  /*  Determinant */

    det = fpsub(fpmul(m0, m3), fpmul(m1, m2));
    if(fpiszero(det))
        return ERRsingular_matrix;

    if_state.wrong_read = fpisneg(det);

  /*  Determine quadrant rotation
   *  This is only currently used by Intellifont
   */

    det = fpabs(det);        /* we only need absolute value from here on */
    if_state.quadrant = 0; /* assume arbitrary rotation or pseudo-italic */
    if(fpiszero(m1) && fpiszero(m2))
    {
        if(fpisneg(m3))
            if_state.quadrant = ROT180;
        else
            if_state.quadrant = ROT0;
    }
    else if(fpiszero(m0) && fpiszero(m3))
    {
        if(fpisneg(m2))
            if_state.quadrant = ROT90;
        else
            if_state.quadrant = ROT270;
    }

  /* if_state.shear = ROT0 for 0 or 180 rotation + nonzero shear
   *                = ROT90 for 90 or 270 rotation + nonzero shear
   *                = 0 otherwise (if .quadrant is 1, then .shear is 0)
   *
   * M = a 0  for 0/180 rotation      M = 0 b  for 90/270 rotation
   *     c d  and shear != 0              c d  and shear != 0
   */
    if_state.shear = 0;
    if (!if_state.quadrant)
    {
        if (fpiszero(m1))
            if_state.shear = ROT0;
        if (fpiszero(m0))
            if_state.shear = ROT90;
    }

    if(if_state.wrong_read)
        if_state.quadrant = - if_state.quadrant;

#ifdef DEBUG
    DBG("   am[] = ");   fpprint(am0);   fpprint(am1);  DBG("\n");
    DBG("          ");   fpprint(am2);   fpprint(am3);  DBG("\n");
    DBG("    det = ");   fpprint(det);   DBG("\n");
#endif

  /*  Determine design unit pixel sizes.
   *    xpixel size = 1/sqrt(am0*am0 + am1*am1)
   *    ypixel size = 1/(xpixel_size * det)
   */

    if (fpiszero(am1))
        tmp = am0;
    else if (fpiszero(am0))
        tmp = am1;
    else                /* mby, 11-28-94 */
        tmp = fpsqrt(fpadd(fpmul(am0,am0), fpmul(am1,am1)));
    xpixel_size = fpdiv(one, tmp);
    ypixel_size = fpdiv(tmp, det);

#if FCO_RDR
    if(FC_ISFCO(fc))
    {
        int emres;
        if_state.x.orig_pixel = fp2word(xpixel_size);
        if_state.y.orig_pixel = fp2word(ypixel_size);
        if_state.x.p_pixel = fp2intel(xpixel_size, &(if_state.x.bin_places));
        if_state.x.p_half_pix = if_state.x.p_pixel >> 1;
        if_state.y.p_pixel = fp2intel(ypixel_size, &(if_state.y.bin_places));
        if_state.y.p_half_pix = if_state.y.p_pixel >> 1;
        fst_frac_bits = fpint2fp(65536L);
        m0 = fpmul(m0, fst_frac_bits);
        m1 = fpmul(m1, fst_frac_bits);
        m2 = fpmul(m2, fst_frac_bits);
        m3 = fpmul(m3, fst_frac_bits);

  /*________________fop stuff__________________________*/

      /*  Determine xmax and ymax in output space. A one x one box when
       *  transformed by m[] has a bounding box of r x s.
       */
        {
        FPNUM max_design;
        FPNUM r, s;
        FPNUM xmax, ymax;

#ifdef NOT1200DPI
        r = fpadd(am0, am2);
        s = fpadd(am1, am3);

        if ((emres = if_state.pbucket->p.fco.design_EmRes) == 8782)
           max_design = fpint2fp((SL32)MAX_DESIGN);
        else        /* frac_places must never be < 0; must work for 1000 point, 600 dpi, mby 02-14-95 */
           max_design = fpint2fp((SL32)(emres + (emres>>1) - (emres>>3)));

        xmax = fpmul(r, max_design);
        ymax = fpmul(s, max_design);
#else
        r = one;
        s = one;
        emres = if_state.pbucket->p.fco.design_EmRes;
        max_design = fpint2fp((SL32)emres);

        xmax = fpdiv( max_design, xpixel_size );
        ymax = fpdiv( max_design, ypixel_size );
#endif  /* NOT1200DPI */

        frac_places = MIN(frac_bits(fp2long(xmax)),
                          frac_bits(fp2long(ymax)));
        if (frac_places < 0)
           return ERR_ov_16_bit_value;

        fo_pix = fpint2fp((SL32)fractional_output(frac_places));
        }

      /*  Scale all elements of matrix by output pixel size. */

        for(i=0; i<4; i++, m++)       
            *m = fpmul(fo_pix, *m);

#ifdef PSEUDO_BOLD_FCO
        if_state.pbucket->p.fco.xbold = fc->xbold;
        if_state.pbucket->p.fco.ybold = fc->ybold;
#endif
      /* Divide out the x and y scaling from the transformation matrix. */
        if ((status = fco_set_trans(if_state.pbucket,
                                    fp2long(fpmul(m0, xpixel_size)),
                                    fp2long(fpmul(m1, xpixel_size)),
                                    fp2long(fpmul(m2, ypixel_size)),
                                    fp2long(fpmul(m3, ypixel_size)) ) )
                      != SUCCESS)
            return status;
    }
#endif  /* FCO_RDR */

#if (PST1_RDR || TT_RDR || FCO_RDR)
    if(FC_ISPST1(fc) || FC_ISTT(fc))
    {
       if_state.x.orig_pixel = fp2word(fpmul(fpint2fp(1000L),xpixel_size));
       if_state.y.orig_pixel = fp2word(fpmul(fpint2fp(1000L),ypixel_size));
    }
#if PST1_RDR
    if(FC_ISPST1(fc))
       if_state.orThreshold = PS_THRESHOLD;  /* PS pix size for 18pt @ 300dpi */
#endif
#if TT_RDR
    if(FC_ISTT(fc))
       if_state.orThreshold = TT_THRESHOLD;  /* TT pix size for 18pt @ 300dpi */
#endif
#if FCO_RDR
    if(FC_ISFCO(fc))
       if_state.orThreshold = comp_pix_context.orThreshold;
#endif

#endif /* PST1_RDR || TT_RDR || FCO_RDR */

#if IF_RDR
#if NON_IF_FONT
    if(FC_ISIF(fc))     /* Intellifont specific scaling data */
#endif
    {
    FPNUM xover, yover;             /* overhang in pixels: spot size - 1 */
    FPNUM xoverhang, yoverhang;     /* overhang in design units          */
    FPNUM xbias, ybias;
    SW16  min_pix;

#ifdef DEBUG
    DBG("    pixel_size: "); fpprint(xpixel_size); fpprint(ypixel_size);
    DBG("\n");
#endif

  /*  Determine spot size overhang in design space
   *      xoverhang = (yover*am0 + xover*am1)/det;
   *      yoverhang = (yover*am2 + xover*am3)/det;
   */

    xover = fpfixed2fp(fc->xspot - F_ONE);  /* overhang in output space */
    yover = fpfixed2fp(fc->yspot - F_ONE);
    xoverhang = fpdiv(fpadd(fpmul(yover, am2), fpmul(xover, am3)), det);
    yoverhang = fpdiv(fpadd(fpmul(yover, am0), fpmul(xover, am1)), det);

  /*  Determine bias:     bias = overhang - bold
   */

    xbias = fpsub(xoverhang, fpint2fp((SL32)fc->xbold));
    ybias = fpsub(yoverhang, fpint2fp((SL32)fc->ybold));

    DBG("x design data\n");
    if((status = fill_in_design_data(&if_state.x, xpixel_size, xbias)) != SUCCESS)
        return status;

    DBG("y design data\n");
    if((status = fill_in_design_data(&if_state.y, ypixel_size, ybias)) != SUCCESS)
        return status;

  /* compute baseline */

  /* Grid aligned baseline in design space */
#if ((ELASTIC_Y) | (ELASTIC_X))
        pixel_align(if_state.origBaseline, &if_state.y, 2, 0);
#else
        pixel_align(if_state.origBaseline, &if_state.y, 2);
#endif
    if_state.aBaselnVal  = if_state.value;

    DBG1("\n    orig baseline = %d\n", if_state.origBaseline);
    DBG1("    grid aligned in design space: %d \n", if_state.aBaselnVal);

  /* Set quality level */

    if_state.quality = fc->format >> 14;
    if(!if_state.quality)
    {
        min_pix = MIN(if_state.x.orig_pixel, if_state.y.orig_pixel);
        if(min_pix < 66)       if_state.quality = 3; /*  > 30 pt at 300dpi */
        else if(min_pix < 211) if_state.quality = 2; /* between 10 and 30  */
        else                   if_state.quality = 1; /*  < 10 pt           */
    }

    DBG1("    quality = %d\n", if_state.quality);

  /*________________fop stuff__________________________*/

      /*  Determine xmax and ymax in output space. A one x one box when
       *  transformed by m[] has a bounding box of r x s.
       */
        {
        FPNUM max_design;
        FPNUM r, s;
        FPNUM xmax, ymax;

#ifdef NOT1200DPI
        r = fpadd(am0, am2);
        s = fpadd(am1, am3);
        if(fplt(one, r) || fplt(one, s))   /* Can only scale down */
            return ERRmatrix_range;
        max_design = fpint2fp((SL32)MAX_DESIGN);
        xmax = fpmul(r, max_design);
        ymax = fpmul(s, max_design);
#else
        r = one;
        s = one;
        max_design = fpint2fp((SL32)8782); /* Q&D hardcoded upem value */
        xmax = fpdiv( max_design, xpixel_size );
        ymax = fpdiv( max_design, ypixel_size );
#endif  /* NOT1200DPI */

        frac_places = MIN(frac_bits(fp2long(xmax)),
                          frac_bits(fp2long(ymax)));

#ifdef NOT1200DPI
        if (frac_places < 0)
           return ERR_ov_16_bit_value;
#else
        if (frac_places < 0)
           return ERR_ov_16_bit_value;
#endif  /* NOT1200DPI */

        fo_pix = fpint2fp((SL32)fractional_output(frac_places));

        }

      /*  Scale all elements of matrix by output pixel size. */

        for(i=0; i<4; i++, m++)       
            *m = fpmul(fo_pix, *m);

    }  /* Intellifont specific scaling data */


#endif /* IF_RDR */

  /* Set bold and or on flags */

/*
 * 7/1/93 maib
 * new method for setting non-zero winding method required. can be
 * set when bold if off, but must be set when bold is on. this value
 * is true when fontcontext format field specifies non-zero winding, 
 * or when bold is specified
 */
    if_state.making_bold =  ((fc->xbold | fc->ybold) != 0L);
    if_state.non_z_wind  = (if_state.making_bold || (FC_ISNONZWIND(fc) ));

    if_state.or_on = (((if_state.x.orig_pixel > (SW16)if_state.orThreshold)
                   ||  (if_state.y.orig_pixel > (SW16)if_state.orThreshold)) );

    DBG4("orThreshold %d  orig pixel  %d,%d    or_on = %d\n",
            if_state.orThreshold, if_state.x.orig_pixel,
                              if_state.y.orig_pixel, if_state.or_on);

    return fpmath_error;
} /* matrix_to_scale */



#if SCALE_MATRIX

#if (FCO_RDR && (SCALE_MATRIX & MAT0_SCALE_MATRIX))
#if defined (ANSI_DEFS)
MLOCAL VOID  matrix_scale(PFPNUM mdst, LPSL32 msrc, SW16 numbits, SW16 moreScale)
#else
MLOCAL VOID
matrix_scale(mdst, msrc, numbits, moreScale)
    PFPNUM mdst;          /* destination matrix                 */
    LPSL32 msrc;          /* source matrix of fixed point SL32s */
    SW16   numbits;       /* number of bits after binary point  */
    SW16   moreScale;
#endif
{
    int    i;

    for(i=0; i<4; i++)
        mdst[i] = fplongexp(*msrc++, numbits);

    if (moreScale)
    {
        FPNUM scale = fplongexp((long)moreScale, (SW16)0);
        for(i=0; i<4; i++)
            mdst[i] = fpdiv(mdst[i], scale);
    }
}
#else  /* !(FCO_RDR && (SCALE_MATRIX & MAT0_SCALE_MATRIX)) */

/*--------------------*/
/*  matrix_scale      */
/*--------------------*/
/*  Convert a matrix from fixed point to floating point */
#if defined (ANSI_DEFS)
MLOCAL VOID  matrix_scale(PFPNUM mdst, LPSL32 msrc, SW16 numbits)
#else
MLOCAL VOID
matrix_scale(mdst, msrc, numbits)
    PFPNUM mdst;          /* destination matrix                 */
    LPSL32  msrc;          /* source matrix of fixed point SL32s */
    SW16   numbits;       /* number of bits after binary point  */
#endif
{
    int    i;

    for(i=0; i<4; i++)
        *mdst++ = fplongexp(*msrc++, numbits);
}
#endif

#endif  /* SCALE_MATRIX */



#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
/*--------------------*/
/*  matrix_design     */
/*--------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  matrix_design(PFONTCONTEXT fc)
#else
MLOCAL UW16
matrix_design(fc)
    PFONTCONTEXT  fc;
#endif
{
#if FCO_RDR
    SW16 emres;
    if (FC_ISFCO(fc) && comp_pix_context.compositionFlag)
        emres = comp_pix_context.masterPt;
    else
        emres = 0;
    matrix_scale(if_state.m, fc->s.m0.m, fc->s.m0.matrix_scale, emres);
#else
    matrix_scale(if_state.m, fc->s.m0.m, fc->s.m0.matrix_scale);
#endif
    return matrix_to_scale(if_state.m, fc);
}
#endif

#if (SCALE_MATRIX & (MAT1_SCALE_MATRIX | MAT2_SCALE_MATRIX))
/*--------------------*/
/*  comb_des_world    */
/*--------------------*/
/*  Combine desgin to world transform and world to output transforms
 *  and then compute the SCALE parameters
 */
#if defined (ANSI_DEFS)
MLOCAL UW16  comb_des_world(FPNUM xscale, FPNUM yscale, LPSL32 w, 
    SW16 w_scale, PFONTCONTEXT fc)
#else
MLOCAL UW16
comb_des_world(xscale, yscale, w, w_scale, fc)
    FPNUM  xscale, yscale;     /* scale:  design to world */
    LPSL32  w;                  /* matrix: world to output */
    SW16   w_scale;
    PFONTCONTEXT  fc;
#endif
{
  /* Convert fixed point matrix to floating point */

#if (FCO_RDR && (SCALE_MATRIX & MAT0_SCALE_MATRIX))
    matrix_scale(if_state.m, w, w_scale, (SW16)0 );
#else
    matrix_scale(if_state.m, w, w_scale);
#endif

  /* Build matrix from design space to output space */

    if_state.m[0] = fpmul(xscale, if_state.m[0]);
    if_state.m[1] = fpmul(xscale, if_state.m[1]);
    if_state.m[2] = fpmul(yscale, if_state.m[2]);
    if_state.m[3] = fpmul(yscale, if_state.m[3]);

  /* Compute the SCALE parameters */

    return matrix_to_scale(if_state.m, fc);
}
#endif




#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
/*--------------------*/
/*  matrix_em_world   */
/*--------------------*/
/*  Computes the scaling paramters */
#if defined (ANSI_DEFS)
MLOCAL UW16  matrix_em_world(PFONTCONTEXT fc)
#else
MLOCAL UW16
matrix_em_world(fc)
    PFONTCONTEXT  fc;
#endif
{
    FPNUM inches_per_point;         /* a CG point is 0.01383 inches    */
    FPNUM masterpt;                 /* master point size in CG points  */
    FPNUM inches_per_dem;           /* inches per design em            */
    FPNUM dem_width, dem_depth;
    FPNUM wem_width, wem_depth;
    FPNUM xscale, yscale;

  /* Compute design unit em box */

#if FCO_RDR
#if NON_IF_FONT
    if (FC_ISIF(fc) || (FC_ISFCO(fc) && !comp_pix_context.compositionFlag))
        inches_per_point = fpdiv(fpint2fp(1383L), fpint2fp(100000L));
    else
        inches_per_point = fpdiv(fpint2fp(1L), fpint2fp(72L));
#else
    inches_per_point = fpdiv(fpint2fp(1383L), fpint2fp(100000L));
#endif
#else  /* !FCO_RDR */
#if NON_IF_FONT
    if(!FC_ISIF(fc))   /* PostScript and TrueType use 1/72 inch = point */
        inches_per_point = fpdiv(fpint2fp(1L), fpint2fp(72L));
    else
#endif
    inches_per_point = fpdiv(fpint2fp(1383L), fpint2fp(100000L));
#endif
    masterpt = fpdiv(fpint2fp((SL32)comp_pix_context.masterPt), fpint2fp(8L));
    inches_per_dem = fpmul(masterpt, inches_per_point);
    dem_width=fpmul(inches_per_dem, fpint2fp((SL32)comp_pix_context.xRes));
    dem_depth=fpmul(inches_per_dem, fpint2fp((SL32)comp_pix_context.yRes));

  /* Compute scale factors from design space to world space */

    wem_width = fplongexp(fc->s.m1.em_width, fc->s.m1.em_scale);
    wem_depth = fplongexp(fc->s.m1.em_depth, fc->s.m1.em_scale);
    xscale = fpdiv(wem_width, dem_width);
    yscale = fpdiv(wem_depth, dem_depth);

  /*  Combine the design to world transform and the world to output
   *  transform and compute the SCALE parameters.
   */

    return comb_des_world(xscale, yscale, fc->s.m1.m,
                                          fc->s.m1.matrix_scale, fc);
}
#endif




#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
/*--------------------*/
/*  matrix_pt_world   */
/*--------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  matrix_pt_world(PFONTCONTEXT fc, FPNUM masterpt)
#else
MLOCAL UW16
matrix_pt_world(fc, masterpt)
    PFONTCONTEXT  fc;
    FPNUM masterpt;
#endif
{
    FPNUM set, pnt;

    FPNUM meters_per_inch;
    FPNUM xworld_res, yworld_res;   /*  world resolution in pixels/inch */
    FPNUM xscale, yscale;           /*  scale: design to world          */

  /*  Compute first tranform matrix:
   *  scale outline by point and set size.
   *
   *    ( set   0  )
   *    (  0   pnt )
   *
   */
    set = fpdiv( fpint2fp((SL32)fc->s.m2.set_size),    masterpt);
    pnt = fpdiv( fpint2fp((SL32)fc->s.m2.point_size),  masterpt);

#ifdef DEBUG
    DBG("\n    masterpt ");  fpprint(masterpt);
    DBG("\n    set   pnt  ");  fpprint(set); fpprint(pnt);
#endif


  /* world space resolution in pixels per inch */

    xworld_res = fplongexp(fc->s.m2.xworld_res, fc->s.m2.world_scale);
    yworld_res = fplongexp(fc->s.m2.yworld_res, fc->s.m2.world_scale);

    if(!(fc->format & FC_INCHES_TYPE))
    {
      /* Convert pixels/meter to pixels/inch */
        meters_per_inch = fpdiv(fpint2fp((SL32)254), fpint2fp((SL32)10000));
        xworld_res = fpmul(xworld_res, meters_per_inch);
        yworld_res = fpmul(yworld_res, meters_per_inch);
    }

  /* Compute scale transform from design space to world space */

    xscale = fpdiv(fpmul(set, xworld_res),
                               fpint2fp((SL32)comp_pix_context.xRes));
    yscale = fpdiv(fpmul(pnt, yworld_res),
                               fpint2fp((SL32)comp_pix_context.yRes));

  /*  Combine the design to world transform and the world to output
   *  transform and compute the SCALE parameters.
   */

    return comb_des_world(xscale, yscale, fc->s.m2.m,
                                          fc->s.m2.matrix_scale, fc);
}
#endif




#if (!SCALE_MATRIX || (SCALE_MATRIX & TYPO_SCALE_MATRIX))
/*--------------------*/
/*    typographer     */
/*--------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  typographer(PFONTCONTEXT fc, FPNUM masterpt)
#else
MLOCAL UW16
typographer(fc, masterpt)
    PFONTCONTEXT  fc;
    FPNUM         masterpt;
#endif
{
  /* Rotate and Shear */
    CGFIXED fcos, fsin, ftan;
    CGFIXED fscos, fssin;

    FPNUM one;
    FPNUM meters_per_inch;

    FPNUM xscanres, yscanres;   /* Design space resolution in pixels/inch */
    FPNUM xoutres, youtres;     /* Output space resolution in pixels/inch */
    FPNUM set_size, point_size;

    FPNUM set, pnt;
    FPNUM cos, sin, tan;
    FPNUM xout, yout;



  /* Design space resolution in pixels / inch */

    xscanres = fpint2fp((SL32)comp_pix_context.xRes);
    yscanres = fpint2fp((SL32)comp_pix_context.yRes);

  /* Point and set_size and output space resolution in pixels / inch */

#if (!SCALE_MATRIX)
    if_state.wrong_read = (fc->set_size < 0);
    set_size   = fpint2fp((SL32)fc->set_size);
    point_size = fpint2fp((SL32)fc->point_size);
    xoutres = fpint2fp(fc->xres);
    youtres = fpint2fp(fc->yres);
#else
    if_state.wrong_read = (fc->s.t.set_size < 0);
    set_size   = fpint2fp((SL32)fc->s.t.set_size);
    point_size = fpint2fp((SL32)fc->s.t.point_size);
    xoutres = fpint2fp(fc->s.t.xres);
    youtres = fpint2fp(fc->s.t.yres);
#endif

    if(!(fc->format & FC_INCHES_TYPE))
    {
      /* Convert pixels/meter to pixels/inch */
        meters_per_inch = fpdiv(fpint2fp((SL32)254), fpint2fp((SL32)10000));
        xoutres = fpmul(xoutres, meters_per_inch);
        youtres = fpmul(youtres, meters_per_inch);
    }

#ifdef DEBUG
    DBG("\n    masterpt ");  fpprint(masterpt);
    DBG("\n    xscanres yscanres    ");  fpprint(xscanres); fpprint(yscanres);
    DBG("\n    xoutres  youtres     ");  fpprint(xoutres); fpprint(youtres);
    DBG("\n    set_size point_size  "); fpprint(set_size);
                                        fpprint(point_size);
    DBG("\n");
#endif

  /*  Rotation and shear  */

#if (!SCALE_MATRIX)
    fcos  = fc->rotate.x;        /*  rotation */
    fsin  = fc->rotate.y;
    fscos = fc->shear.y;         /*  shear    */
    fssin = fc->shear.x;
#else
    fcos  = fc->s.t.rotate.x;        /*  rotation */
    fsin  = fc->s.t.rotate.y;
    fscos = fc->s.t.shear.y;         /*  shear    */
    fssin = fc->s.t.shear.x;
#endif
    ftan  = if_state.glob_ital_tan;

    if(fpmath_error)
        return ERR_comp_pix;


  /*  Compute first tranform matrix:
   *  scale outline by point and set size.
   *
   *    ( set   0  )
   *    (  0   pnt )
   *
   */

    set = fpdiv(set_size,   masterpt);
    pnt = fpdiv(point_size, masterpt);

#ifdef DEBUG
    DBG("\n    set   pnt  ");  fpprint(set); fpprint(pnt);
#endif

  /*  Compute the second transform matrix: shear.
   *
   *      (  1   0  )
   *      ( tan  1  )
   *
   *  Compute the shear tangent and verify shear angle is between
   *  -45 to 45. If generic screen fonts are being used for an italic
   *  face, then the sine and cosine of the global
   *  italic angle are not available; only the tangent is available
   *  which is all you really need anyway. This little hack is to tell
   *  us whether the italic tangent has been passed in or we have to
   *  compute it.
   */

    if (ftan == NO_TANGENT)   /* 20-Mar-90 jfd */
       tan = fpdiv(fpfixed2fp(fssin), fpfixed2fp(fscos));
    else
       tan = fpfixed2fp(ftan);
#ifdef DEBUG
    DBG("\n   tan");   fpprint(tan);
#endif

    one = fpint2fp((SL32)1);
    if(fplt(tan, fpneg(one)) || fplt(one, tan))  /* 11-19-90 dET */
       return ERR_comp_pix;


    if(fpmath_error)
    {
        DBG("***** fmath_error ***** tan, set, pnt compute\n");
        return fpmath_error;
    }

  /*  Next transform is rotation.
   *
   *      (  cos   sin  )
   *      ( -sin   cos  )
   *
   */

    cos = fpfixed2fp(fcos);
    sin = fpfixed2fp(fsin);
#ifdef DEBUG
    DBG("\n    cos  sin");  fpprint(cos);  fpprint(sin);
#endif

  /*  Last transform is from design unit to output pixels.
   *
   *      ( xout   0   )
   *      (  0    yout )
   *
   *  xout = xoutres / xscanres
   *  yout = youtres / yscanres
   */

    xout = fpdiv(xoutres, xscanres);
    yout = fpdiv(youtres, yscanres);
#ifdef DEBUG
    DBG("\n    xout yout  ");  fpprint(xout);  fpprint(yout);
    DBG("\n");
#endif

  /*  Combine the above four transforms in the order given to get:
   *
   *    ( set*cos*xout                 set*sin*yout              )
   *    ( pnt*(tan*cos - sin)*xout     pnt*(tan*sin + cos)*yout  )
   *
   */

    if_state.m[0] = fpmul(fpmul(set, cos), xout);
    if_state.m[1] = fpmul(fpmul(set, sin), yout);
    if_state.m[2] = fpmul(fpmul(pnt, fpsub(fpmul(tan, cos), sin)), xout);
    if_state.m[3] = fpmul(fpmul(pnt, fpadd(fpmul(tan, sin), cos)), yout);
#ifdef DEBUG
    DBG("\n    m0 m1  ");  fpprint(if_state.m[0]);  fpprint(if_state.m[1]);
    DBG("\n    m2 m3  ");  fpprint(if_state.m[2]);  fpprint(if_state.m[3]);
    DBG("\n");
#endif
    if(fpmath_error)
    {
        DBG("***** fmath_error ***** mi compute\n");
        return fpmath_error;
    }

    return matrix_to_scale(if_state.m, fc);
}
#endif    /* (!SCALE_MATRIX || (SCALE_MATRIX & TYPO_SCALE_MATRIX)) */




/*  Computes the scaling paramters */
#if defined (ANSI_DEFS)
GLOBAL UW16  comp_pix(PFONTCONTEXT fc, PBUCKET bucket)
#else
GLOBAL UW16
comp_pix(fc, bucket)
    PFONTCONTEXT  fc;
    PBUCKET       bucket;
#endif
{
    UW16     fstType;
    UW16     status;
    int      temp;
#if IF_RDR
    PDISPLAY display;
#endif
#if ((!SCALE_MATRIX)||(SCALE_MATRIX&(TYPO_SCALE_MATRIX|MAT2_SCALE_MATRIX)))
    FPNUM    masterpt;
#endif

    DBG("\n\n\ncomp_pix()\n");

    /*  Don't do anything unless the FONTCONTEXT has changed  */

    temp = MEMCMP((LPSB8)fc, (LPSB8)&if_state.cur_loc_fc, sizeof(FONTCONTEXT));
    fstType = fc->format & FC_FONTTYPE_MASK;
    switch( fstType )
    {
#if IF_RDR
        case FC_IF_TYPE:
        {
            display = (PDISPLAY)(fgseg(bucket) + bucket->p.in.odisplay);

#if (CONVERGENT_FONTS == 1)     /* mby, 3-06-94 */
          /* If using convergent font + italic angle && prohibit flag */
          /* has changed, then we have to recalculate comp_pix().     */
            if (!if_state.awtsub_on || !awtData.italTan ||
                (awtData.charProhbItal == awtData.charProhbItalLast))
#endif
          /* Need to check more than just fontcontext for Intellifont type */
          /* data. Especially for SLIMs, need to check mirror_flags.       */
            { 
                if( !temp && !COMP_PIX_CONTEXT_CHGD() ) 
                    return SUCCESS;  /* FONTCONTEXT is unchanged. Collect $200. */
            }
            break;
        }
#endif  /* IF_RDR */

#if FCO_RDR
        case FC_FCO_TYPE:
      /* Must also compare fc to the one stored in the FCO bucket. */
        {
            if ( !temp && (!MEMCMP((LPSB8)fc, (LPSB8)&(bucket->p.fco.fcoFC),
                                   sizeof(FONTCONTEXT))) )
                return SUCCESS;
            break;
        }
#endif  /* FCO_RDR */

#if TT_RDR
        case FC_TT_TYPE:
        {
#if TT_TTPLUG   /* TT_PLUGINS == 2 (TrueType format) */
        /* Must also compare fc to the one stored in the TT bucket. */
            if ( !temp && (!MEMCMP((LPSB8)fc, (LPSB8)&(bucket->p.tt.TTfc),
                                   sizeof(FONTCONTEXT))) )
                return SUCCESS;
#else   /* For all other plugins */
            if (!temp)
                return SUCCESS;
#endif
            break;
        }
#endif  /* TT_RDR */

#if PST1_RDR
        case FC_PST1_TYPE:
        {
            if (!temp)
                return SUCCESS;
            break;
        }
#endif  /* PST1_RDR */
    }       /* switch( fstType ) */

#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
     /*
      * force FCis_equal() to fail so that
      * comp_pix() is called for first characters
      * of PostScript and TrueType fonts
      */

    if_state.cur_loc_fc.font_hdr =  (LPUB8)0;  /* 10-6-94 */
#endif
    if_state.cur_loc_fc.font_id = 0;  /* make invalid FONTCONTEXT */
#if SLIM_FONTS
  /* make invalid mirror flags copy -ss */
    comp_pix_context.mirflags = (UB8)0;
#endif

/* save current context */
    switch( fstType )
    {
#if IF_RDR
        case FC_IF_TYPE:
        {
        /* Intellifont setup */
            if_state.origBaseline     = display->baselinePosition;
            comp_pix_context.masterPt = display->masterPointSize;
            comp_pix_context.xRes     = display->scanResolutionX;
            comp_pix_context.yRes     = display->scanResolutionY;
            break;
        }
#endif  /* IF_RDR */
#if FCO_RDR
        case FC_FCO_TYPE:
        {
            bucket->p.fco.fcoFC.format = FC_IF_TYPE;  /* invalid setting */
            comp_pix_context.orThreshold = bucket->p.fco.orThreshold;
            comp_pix_context.compositionFlag = bucket->p.fco.compositionFlag;
            if (!comp_pix_context.compositionFlag)
            {
                comp_pix_context.masterPt = 2000;  /* for IF scaling */
                comp_pix_context.xRes     = 2540;
                comp_pix_context.yRes     = 2540;
            }
            else /* For non-IF scaling, mby 11-16-94 */
            {    /* Don't multiply masterPt by 8 in case of 16-bit overflow.
                  * Instead, multiply xRes, yRes by 8.
                  */
                comp_pix_context.masterPt = bucket->p.fco.design_EmRes;
                comp_pix_context.xRes     = 576;  /*  (8)(72)  */
                comp_pix_context.yRes     = 576;
            }
            break;
        }
#endif  /* FCO_RDR */
#if TT_RDR
        case FC_TT_TYPE:
        {
#if TT_TTPLUG
            bucket->p.tt.TTfc.format  = FC_IF_TYPE;  /* invalid setting */
#endif
            comp_pix_context.masterPt = 8;   /* 1 point in eighths */
            comp_pix_context.xRes     = 72;
            comp_pix_context.yRes     = 72;
            break;
        }
#endif  /* TT_RDR */
#if PST1_RDR
        case FC_PST1_TYPE:
        {
      /*  We assume that after the fontmatrix has been concatenated, an
       *  original PS design unit maps to 1 unit in "user space".
       *  A "user space" pixel is defined to be 1 point square.
       */
            comp_pix_context.masterPt = 8;   /* 1 point in eighths */
            comp_pix_context.xRes     = 72;  /* 1 user space pixel = 1 point */
            comp_pix_context.yRes     = 72;
            break;
        }
#endif  /* PST1_RDR */
    }       /* switch( fstType ) */

    gaso_pn = -1;
    fpmath_error = 0;  /*  fpmath error flag. Floating point operations
                        *  set to nonzero error code on error. */

#if ((!SCALE_MATRIX)||(SCALE_MATRIX&(TYPO_SCALE_MATRIX|MAT2_SCALE_MATRIX)))
  /*  Compute Design space master point size. Is in eighth points. Adjust
   *  in input point size is in sixteenth points.
   */
    masterpt = fpint2fp((SL32)comp_pix_context.masterPt);
    if (((fc->format) & FC_PSUNITS_MASK) == (SW16)FC_16THS_TYPE)
        masterpt = fpmul(masterpt, fpint2fp((SL32)2));
    if(fpmath_error) return fpmath_error;
#endif

#if (!SCALE_MATRIX)
    if((status = typographer(fc, masterpt)) != SUCCESS)
        return status;
#else
    switch(fc->fc_type)
    {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
        case FC_TYPO_TYPE: status = typographer(fc, masterpt);
                           break;
#endif
#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
        case FC_MAT0_TYPE: status = matrix_design(fc);
                           break;
#endif
#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
        case FC_MAT1_TYPE: status = matrix_em_world(fc);
                           break;
#endif
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
        case FC_MAT2_TYPE: status = matrix_pt_world(fc, masterpt);
                           break;
#endif
        default: return ERR_comp_pix;
    }
    if(status)
        return status;
#endif

    if_state.cur_loc_fc = *fc;
#if TT_TTPLUG && TT_RDR
    if (FC_ISTT(fc))
        bucket->p.tt.TTfc = *fc;        /* -mby 10/15/92 */
#endif
#if FCO_RDR
    if (FC_ISFCO(fc))
        bucket->p.fco.fcoFC = *fc;      /* mby, 09-21-94 */
#endif

#if SLIM_FONTS
    comp_pix_context.mirflags = chr_def_hdr.mirror_flags;
#endif

    return SUCCESS;
}




#if SCREEN_FONTS
/*--------------------*/
/* comp_pix_changed   */
/*--------------------*/
/*  If any FONTCONTEXT field has changed so as to make the design
 *  unit pixel size change, then recompute. This is used to determine
 *  whether or not generic screen fonts should be substituted. In general,
 *  the external fontcontext may be different than the one actually in
 *  effect due to prohibit flags or pseudos for the screen fonts. Thus
 *  we can't just check if any field in the FONTCONTEXT has changed.
 *  If we don't do this checking, the fontcontext will get recomputed
 *  twice for each character we generate.
 *  This procedure can be improved.
 */

#if defined (ANSI_DEFS)
GLOBAL UW16  comp_pix_changed(PFONTCONTEXT fc, PBUCKET bucket)
#else
GLOBAL UW16
comp_pix_changed(fc, bucket)
    PFONTCONTEXT fc;
    PBUCKET      bucket;
#endif
{
    BOOLEAN recompute = FALSE;

    if((fc->format ^ if_state.cur_loc_fc.format) & FC_CHANGESCALE)
        recompute = TRUE;  /* if certain bits in format field change */
    else
#if (!SCALE_MATRIX)
    if((fc->point_size != if_state.cur_loc_fc.point_size) ||
       (fc->set_size   != if_state.cur_loc_fc.set_size  ) ||
       (fc->xres       != if_state.cur_loc_fc.xres      ) ||  
       (fc->yres       != if_state.cur_loc_fc.yres      ))

        recompute = TRUE;
#else
    if(fc->fc_type != if_state.cur_loc_fc.fc_type)
        recompute = TRUE;
    else
    {
        switch(fc->fc_type)
        {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
        case FC_TYPO_TYPE:
            if((fc->s.t.point_size != if_state.cur_loc_fc.s.t.point_size) ||
               (fc->s.t.set_size   != if_state.cur_loc_fc.s.t.set_size  ) ||
               (fc->s.t.xres       != if_state.cur_loc_fc.s.t.xres      ) ||  
               (fc->s.t.yres       != if_state.cur_loc_fc.s.t.yres      ))

                recompute = TRUE;
            break;
#endif

#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
        case FC_MAT0_TYPE:
            recompute = MEMCMP((LPSB8)&(fc->s.m0),
                            (LPSB8)&if_state.cur_loc_fc.s.m0, sizeof(MAT0));
            break;
#endif
#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
        case FC_MAT1_TYPE:
            recompute = MEMCMP((LPSB8)&(fc->s.m1),
                            (LPSB8)&if_state.cur_loc_fc.s.m1, sizeof(MAT1));
            break;
#endif
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
        case FC_MAT2_TYPE:
            recompute = MEMCMP((LPSB8)&(fc->s.m2),
                            (LPSB8)&if_state.cur_loc_fc.s.m2, sizeof(MAT2));
            break;
#endif
        default: return ERR_comp_pix;
        }
    }

#endif  /*  SCALE_MATRIX  */

    if(recompute)
        return comp_pix(fc, bucket);
    else
        return SUCCESS;
}
#endif  /* SCREEN_FONTS */
