/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/if.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: if.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   06 Apr 1995 15:10:50   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   08 Jun 1994 13:47:56   JOE
 * In intel_char(), if character is unhinted, reset skeletal arrays
 * x_skel[] and y_skel[]. This fixes a bug which was occurring when
 * switching between hinted and unhinted characters.
 * Including "mixmodel.h".
 * 
 *    Rev 1.6   22 Apr 1994 09:28:24   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.5   09 Jul 1993 10:58:16   MAIB
 * examine making_bold to determine embolding, not non_z_wind
 * 
 *    Rev 1.4   01 Jul 1993 14:26:30   MAIB
 * changed making_bold to non_z_wind
 * 
 *    Rev 1.3   12 Feb 1993 11:36:06   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 10:23:08   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:36:38   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:18   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* if.c */


/*  07-Jul-90  awr  switch pixel size data for quadrant rotation
    25-Sep-90  jfd  Uncommented call to bold() at end of routine
    05-Oct-90  awr  added root adjust parameter to skel_proc() for
                    connecting characters
    14-Jan-91  jfd  Replaced "//" comments.
    29-Jan-91  jfd  Added cgconfig.h.
    30-Jan-91  dET  added function prototyping for MSC
    31-Jan-91  dET  Modify for MSC multi-model compilation.
     5-Feb-91  awr  Conditionally compiled out call to bold()
                    Moved manipulate() here.
     8-Feb-91 awr  Moved skel_init(), y_skel[] and x_skel[] from yclass.c
                   to if.c.
                   Renamed yclass_proc() to yclass().
                   Made x_skel[] and y_skel[] MLOCAL and passed as params
                   to yclass(), ital(), skel_proc(), bold(),
                   and manipulate().
                   Moved GLOBAL WORD work_buffer[WORK_BUFFER_SIZE]
                   from manilua.c and passed as parameter to manpulate().
    10-Feb-91 awr  Made global flag char_is_if part of IF_CHAR structure.
                   Moved making_bold to SCALE structure.
    08-Mar-91 jfd  For MULTI-MODEL, change references to LOOP* to PLOOP.
    01-Jun-91 awr  HQ4 changes
    17-Jun-91 jfd  Moved "debug.h" after "port.h".
                   Moved "profile.h" after "port.h".
                   Moved "cgconfig.h" before "port.h".
    24 Jun 91 ss   Changed prototypes for manipulate() to match the actual
                   definition in manipula.c.
     4-Jul-91 awr  Removed SCALE fields "px" and "py".
     8-Jul-91 tbh  Added elasticity.
     1-Aug-91 tbh  Changed COUNTER to UCOUNTER
                   Made declaration of result conditional with ELASTICITY.
                   Cleaned up line lengths.
     6-Aug-91 jfd  In intel_char(), "root_adjust" is never initialized if
                   (!ELASTIC_Y) so am setting it to "0" at top.
    24-Aug-91 awr  Moved function decls to include file
    23-Aug-91 jfd  In skleletal_init(), if ELASTICITY is enabled but no
                   elastic data exists (pex, pey == 0), check for pex and
                   pey == NULL before trying to read *pex and *pey in order
                   to get rid of a WINDOWS general protection fault error.
    11-Dec-91 tbh  Corrected placement of italic() call relative to
                   skeletal_init().
    04-Mar-92  tbh  Added .baseproj to support standard STANDARD dimensions
    03-Apr-92 rs   Portability cleanup (see port.h).
    15-Sep-92 jfd  Conditionally compiling entire module based on IF_RDR.
    17-Sep-92 jfd  Changed "if_state" from GLOBAL to EXTERN. It is declared
                   GLOBAL in COMP_PIX.C
    05-Oct-92 jfd  In intel_char(), added extra set of parentheses to two
                   "while" statements to get rid of compiler warnings.
    15-Nov-92 rs   Port to Mac - italic() -> cgitalic(), bold() -> cgbold().
    07-Jan-93 jfd  ANSI C function declaration changes.
    08-Feb-93 jfd  VXWorks support.
    01-Jul-93 maib  Changed making_bold to non_z_wind
    09-Jul-93 maib  Checked for using bold code by examining making_bold
                    field not non_z_wind
    08-Jun-94 jfd  In intel_char(), if character is unhinted, reset
                   skeletal arrays x_skel[] and y_skel[]. This fixes
                   a problem which was occurring when switching
                   between hinted and unhinted characters.
                   Including "mixmodel.h".

 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "ix.h"
#include "if_type.h"
#include "segments.h"
#include "adj_skel.h"

#include "mixmodel.h"

EXTERN IF_STATE if_state;

#if IF_RDR

#ifdef ELASTEST
GLOBAL SW16 testElasticInput;
#endif

#ifdef LINT_ARGS
MLOCAL BOOLEAN    skeletal_init (UW16);
#if ((ELASTIC_Y) | (ELASTIC_X))
MLOCAL SW16       bounds_compute (PADJUSTED_SKEL, PSKEL);
#endif

#else

#if ((ELASTIC_Y) | (ELASTIC_X))
MLOCAL SW16       bounds_compute ();
#else
#endif

#endif


/*--------------------------------------------------------------------*/
MLOCAL ADJUSTED_SKEL     x_skel[MAX_SKEL];
MLOCAL ADJUSTED_SKEL     y_skel[MAX_SKEL];
/*--------------------------------------------------------------------*/


/**********************************************************************/
/*                                                                    */
/*      skeletal_init ()                                              */
/*              sets the adjusted skeletal data arrays to their       */
/*              initial values                                        */
/*                                                                    */
/**********************************************************************/


#if defined (ANSI_DEFS)
MLOCAL BOOLEAN skeletal_init (UW16 process)
#else
MLOCAL BOOLEAN
skeletal_init (process)
UW16 process;
#endif

{

    UCOUNTER i, j, ky, kx, total_y, total_x;
    LOOP  loop;       /* pointer to current loop structure */
    PSW16VECTOR cv;   /* pointer to coordinate vectors */
    PADJUSTED_SKEL xs, ys;
    SW16  index;
    SW16  val;

#if ((ELASTIC_Y) | (ELASTIC_X))
    LPUB8 pex;       /* pointer to elasticityData in SKEL structure */
    LPUB8 pey;       /* pointer to elasticityData in SKEL structure */
#endif

    ky=0;
    kx=0;
    xs = x_skel;
    ys = y_skel;
    total_y = 0;
    total_x = 0;

   DBG ("skeletal_init()  orig  new\n");

#if ((ELASTIC_Y) | (ELASTIC_X))
    pex = if_state.xskel.elasticityData;
    pey = if_state.yskel.elasticityData;
#endif

   /* for each contour loop */

    first_loop();

    for (i=0; i<if_state.num_loops; i++)
        {
        DBG1("    loop %d\n", i);
        DBG2("    if_state.yskel.num_skel_loop[%d] = %d\n",
                                        i, if_state.yskel.num_skel_loop[i]);
        DBG2("    if_state.xskel.num_skel_loop[%d] = %d\n",
                                        i, if_state.xskel.num_skel_loop[i]);

        next_loop(&loop);
        cv = loop.cv;

        /* if skel array exceeded, return error */
        total_y += if_state.yskel.num_skel_loop[i];
        total_x += if_state.xskel.num_skel_loop[i];
        if ((total_y > MAX_SKEL) || (total_x > MAX_SKEL))
            return FALSE;
        if (process == YPROC)
          {
          for (j=0; j < if_state.yskel.num_skel_loop[i]; j++)
            {
            index = if_state.yskel.skel_to_contr[ky];
            val   = (cv+index)->y;

            ys->original          = val;
            ys->intermed          = val;
            ys->adjusted          = val;
            ys->baseproj          = val;

#if ((ELASTIC_Y) | (ELASTIC_X))
            if (pey && (*pey == (SB8)ky))
                 {
                 ys->num_breaks = *(pey+1);
                 pey +=2;
                 }
            else ys->num_breaks = 0;
#endif

            DBG2("    yskel[%d]   %d\n", index, val);

            ys++;
            ky++;
            }
          }

        else
          {
          for (j=0; j < if_state.xskel.num_skel_loop[i]; j++)
            {
            index = if_state.xskel.skel_to_contr[kx];
            val    = (cv+index)->x;

            xs->original          = val;
            xs->intermed          = val;
            xs->adjusted          = val;
            xs->baseproj          = val;

#if ((ELASTIC_Y) | (ELASTIC_X))
            if (pex && (*pex == (SB8)kx))
              {
              xs->num_breaks = *(pex+1);
              pex +=2;
              }
            else xs->num_breaks = 0;
#endif

            DBG2("    xskel[%d]   %d\n", index, val);

            xs++;
            kx++;
            }
          }
        }


  /* check data integrity */
#if 0
    if ((ky != if_state.yskel.num_skel) || (kx != if_state.xskel.num_skel))
    {
        DBG("BAD SKELETAL DATA\n");
        DBG2("    total number of y,x skels = %d, %d\n",
                                     if_state.yskel.num_skel, if_state.xskel.num_skel);
        DBG2("    number processed = %d, %d\n", ky, kx);
        return FALSE;
    }
#endif

    return TRUE;
}

#if ((ELASTIC_Y) | (ELASTIC_X))

/**********************************************************************/
/*                                                                    */
/*      bounds_compute ()                                             */
/*              calulates the black width and black heigth            */
/*              for elasticity                                        */
/*                                                                    */
/**********************************************************************/



#if defined (ANSI_DEFS)
MLOCAL SW16  bounds_compute (PADJUSTED_SKEL adj, PSKEL skel_ptr)
#else
MLOCAL SW16
bounds_compute (adj, skel_ptr)

PADJUSTED_SKEL      adj;
PSKEL               skel_ptr;
#endif

{
SW16  min, max;
UCOUNTER j;

max = MIN_WORD;
min = MAX_WORD;

for (j=0; j<skel_ptr->num_skel; j++)
  {
  if (adj->adjusted > max) max = adj->adjusted;
  if (adj->adjusted < min) min = adj->adjusted;
  adj++;
  }

return (max - min);
}

#endif



/**********************************************************************/
/*                                                                    */
/*      intel_char ()                                                 */
/*              drives the Intellifont process                        */
/*                                                                    */
/**********************************************************************/

#if defined (ANSI_DEFS)
GLOBAL UW16  intel_char()
#else
GLOBAL UW16
intel_char()
#endif

    {

/*  UW16 jj;  */

#if ((ELASTIC_Y) | (ELASTIC_X))
    MLOCAL SW16    elastic_input;
    MLOCAL COUNTER count;
    SW16           result;
#endif

    PADJUSTED_SKEL xskel, yskel;

    SW16           root_adjust;


#ifdef ELASTEST
    if (testElasticInput != 0) if_state.alt_black_width = testElasticInput;
#endif

    DBG("\n\nintel_char()\n");

    if(if_state.char_is_if)
        {
        xskel = (PADJUSTED_SKEL) & x_skel[0];
        yskel = (PADJUSTED_SKEL) & y_skel[0];
        root_adjust = 0;

#if ELASTIC_Y

       /*        
        *  y elasticity loop: if char has elasticity data and if we are 
        *  requesting an alternate black height, try no more than twice 
        *  (count=2) to alter char to be +/- half pixel within
        *  requested black height ! 
        */        

        elastic_input = 0;                  /* init for elasticity */
        result = (SW16)0x7fff;
        count = 0;
        if_state.y.elastic_input = 0;
        
        while ((ABS (if_state.alt_black_height - result) > 
                       (if_state.y.p_pixel>>(if_state.y.bin_places+1))) && count < 2)
          {    
#endif
          if(!skeletal_init (YPROC)) return ERR_skeletal_init;

          yclass (yskel);
    
          if(!skel_proc (&if_state.yskel, &if_state.glob_y_dim,
                         &if_state.y, yskel, root_adjust))
            return ERR_y_skel_proc;
   
#if ELASTIC_Y

          if (if_state.alt_black_height && if_state.yskel.num_breaks_per_char)
            {
            result = bounds_compute (yskel, &if_state.yskel);
            elastic_input += (if_state.alt_black_height - result);
            if_state.y.elastic_input = 
                          (elastic_input + (if_state.yskel.num_breaks_per_char >> 1)) 
                          / if_state.yskel.num_breaks_per_char;
            count++;
            }
          else count = 2;
    
          }
#endif

#if ((ELASTIC_Y) | (ELASTIC_X))
        pixel_align (if_state.escape_box.ll.x, &if_state.x, R_TWO_I ,0);
#else
        pixel_align (if_state.escape_box.ll.x, &if_state.x, R_TWO_I);
#endif
    
        root_adjust = if_state.value - if_state.escape_box.ll.x;
    
#if ELASTIC_X

       /*
        *  x elasticity loop: if char has elasticity data and if we are 
        *  requesting an alternate black width, try no more than twice 
        *  (count=2) to alter char to be +/- half pixel within
        *  requested black width !  
        */

        elastic_input = 0;                  /* init for elasticity */
        result = (SW16)0x7fff;
        count = 0;
        if_state.x.elastic_input = 0;
        
        while ((ABS (if_state.alt_black_width - result) > 
          (if_state.x.p_pixel>>(if_state.x.bin_places+1))) && count < 2)
          {    
#endif

          if(!skeletal_init (XPROC)) return ERR_skeletal_init;

          DBG1("    if_state.loc_ital_ang = %d\n", if_state.loc_ital_ang);
          if(if_state.loc_ital_ang) cgitalic(xskel, yskel);   /* process italic  */

          if(!skel_proc (&if_state.xskel, &if_state.glob_x_dim,
                         &if_state.x, xskel, root_adjust))
            return ERR_x_skel_proc;


#if ELASTIC_X

          if (if_state.alt_black_width && if_state.xskel.num_breaks_per_char)
            {
            result = bounds_compute (xskel, (PSKEL) &if_state.xskel);
            elastic_input += (if_state.alt_black_width - result);
            if_state.x.elastic_input = 
                          (elastic_input + (if_state.xskel.num_breaks_per_char >> 1)) 
                          / if_state.xskel.num_breaks_per_char;
            count++;
            }
          else count = 2;
          }
#endif


#if BOLD
        if(if_state.making_bold)   cgbold(x_skel, y_skel);
#endif
        }

        /* If character is unhinted, reset skeletal arrays (6-8-94 jfd) */

        else
        {
           MEMSET (x_skel, '\0', sizeof (x_skel));
           MEMSET (y_skel, '\0', sizeof (y_skel));
        }
         

/*  Manipulate and scale outline into work buffer */


#if ((ELASTIC_Y) | (ELASTIC_X))
    result = bounds_compute (xskel, (PSKEL) &if_state.xskel);
#endif

    return manipulate (x_skel, y_skel);
    }
#endif  /* IF_RDR */


