/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/if_init.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: if_init.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   06 Apr 1995 15:11:04   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 09:28:18   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.6   18 Oct 1993 15:57:28   JOE
 * In slimrecon(), additional support for processing early MOTOROLA fonts
 * which contain a pad byte in various places.
 * 
 *    Rev 1.5   23 Sep 1993 10:49:00   JOE
 * In slimrecon(), added support for processing early MOTOROLA fonts
 * which contain a pad byte in various places.
 * 
 *    Rev 1.4   12 Feb 1993 11:58:48   JOE
 * VXWorks support.
 * 
 *    Rev 1.3   07 Jan 1993 15:27:12   JOE
 * Corrected ANSI function declaration for slimsetup_intell().
 * 
 *    Rev 1.2   07 Jan 1993 14:03:42   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:34:42   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:36   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* if_init.c */
/*
 *
 *
 * HISTORY
 *
 * 03-Jan-91  jfd  IFB on a Printer changes:
 *                 1.) Including file "cgconfig.h".
 *                 2.) Adding ROM support.
 *
 * 15-Jan-91  jfd  Due to change in if_type.h ("baseline_offset" is now a
 *                 WORD), in routine if_data(), cast value stored in
 *                 "c.baseline_offset" as  *(WORD*) instead of *(UWORD*). 
 * 30-Jan-91  dET added function prototyping for MSC
 * 31-Jan-91  dET Modify for MSC multi-model compilation.
 * 31-Jan-91  dET Initalize structure SCALE d = {0,0};  This forces "d" 
 *                to be in the DATA segment rather than BSS segment.  This 
 *                modification enhances performance on 80x86 processors and
 *                can be removed if modifications to "imath.asm" are made.
 *  5-Feb-91  awr Conditionally compiled BOLD.
 * 10-Feb-91  awr Made global flag char_is_if part of IF_CHAR structure.
 * 23-Feb-91  awr Changed bucket sub-segment handles to offsets.

 *  31-Jan-91 bjg Added slimsetup_intell and slimrecon for slim format
 *  01-May-91 bjg Removed pad byte in HQ4 format.
 *  01-May-91 bjg Initialize intel data for contourless char in slimrecon
 *  24-Apr-91 bjg Reset ptr after reading expand buffer in setup_face().
 *  15-Apr-91 bjg Treat HQ4 data as Intell ordered bytes regardless of platform.
 *  01-Apr-91 tbh Added STANDARD standard dimension setup to setup_intell and setup_face
 *  02-Jun-91 awr HQ4 changes
 *  17-Jun-91 jfd Moved "debug.h" after "port.h".
 *  21 Jun 91 ss  Moved prototype for fgseg() from ix.h.
 *  25 Jun 91 ss  Cleaned up warnings by adding casts.
 *   8 Jul 91 bjg Added elasticity.
 *   1-Aug-91 tbh Removed unreferenced variables.
                  Redeclared loop counters as COUNTER or UWORD where appropriate.
                  Coerced (pub - c.expand_buf) to UWORD.
 *  22-Aug-91 jfd Conditionally compiled slimrecon() and slimsetup_intell()
 *                based on SLIM_FONTS.
 *                In if_init_char(), conditionally compiling call to
 *                slimrecon() based on SLIM_FONTS.
 *  02-Oct-91 jfd In if_init_char(), always resetting isElastic at start
 *                in case we're processing a SLIM FONT which returns
 *                without setting these variables properly.
 *  04-Oct-91 jfd In slimrecon(), initialize xmin, xmax, ymin and ymax
 *                to values of first point because first point was not
 *                being considered as an extreme, causing an incorrect
 *                x-bounding box value.
 *   4 Oct 91 ss  Fixed casts in expand_hq3().
 *   9 Oct 91 jfd In if_init_char(), conditionally compiling statement
 *                which resets isElastic to get rid of compiler error.
 *   9 Oct 91 ss  Changed set of "done" in slimrecon() to get better results.
 *  11 Oct 91 jfd Added code to produce skeletal statistics.
 *  23-Oct-91 rs  Modify 'next_loop()' for PS type 1 bezier data.
 *  28-Oct-91 jfd In slimrecon(), made changes to get rid of compiler
 *                warnings caused when building medium model as follows:
 *                   (UBYTE *)         --> (PUBYTE)
 *                   (slimfont_type *) --> (Pslimfont_type)
 *                Made similar change to MAKEWORD macro
 *                   (UBYTE *)         --> (PUBYTE)
 *  04-Nov-91 jfd In if_init_char(), removed call to print_xy() if processing
 *                slim fonts.
 *  05-Nov-91 jfd Moved declaration for "isElastic" to outside LINT_ARGS
 *                conditional compile block.
 *  16-Jan-92 rs  Fix 'next_loop()' for PS type 1 bezier data.
 *  22-Jan-92 bjg Fixed slimrecon for proofer fonts.
 *                also fixed escapement on 68000.
 *  27-Jan-92 jfd In slimrecon(), corrected misspelling for "xescapement".
 *   5-Feb-92 bg  The dup_points array is now conditionally declared based
 *                on BOLD.
 *  25 Feb 92 ss  Fixed problems in if_init_char() caused when running on
 *                SPARC.  Also changed use of pointer in slimrecon() to
 *                slimfont_type struc to allocated struc to eliminate
 *                alignment problems.
 *  04-Mar-92 jfd In if_init_char(), changed reference to "c.char_buf" to
 *                "if_state.char_buf".
 *   7-Mar-92 awr Changed next_loop() PS to not need extern_font flag
 *  19 Mar 92 ss  Fix for swapped local_italic_angle bytes in slimrecon().
 *  30-Mar-92 rs  Changed "#if DEBUG" to "#ifdef DEBUG".
 *  02-Apr-92 jfd Added STAN_STAN_MASK parameter.
 *                In glob_dims(), added code for standard standards.
 *                In if_init_glob(), added code for standard standards.
 *  03-Apr-92 rs  Portability cleanup (see port.h).
 *  08-Jul-92 rs  Code cleanup.
 *  21-Jul-92 rs  Removed unused PS code in next_loop().
 *  13 Aug 92 ss  In slimrecon(), don't swap bytes of sf.size.
 *  10-Aug-92 jfd In if_init_char(), if contour tree is missing, do not
 *                return with ERR_no_contour. Proceed with processing the
 *                character. This is being done for the case of a compound
 *                character with one of its parts being the space character.
 *  15-Sep-92 jfd Conditionally compile entire module based on IF_RDR.
 *  03-Oct-92 rs  Changes toward ANSI C - declaration of slimsetup_intell().
 *  09-Oct-92 rs  Make prototypes of slimsetup_intell() and slimrecon
 *                conditional on SLIM_FONTS.
 *  20-Oct-92 awr In build_skel_tables(), removed local variable ncoords.
 *  27-Oct-92 jfd In slimrecon(), if processing a contour-less character,
 *                instead of returning immediately with ERR_no_contour,
 *                continue processing. (This will resolve the bolle compound
 *                character problem (2 parts, 1st is space character).
 *  15-Nov-92 rs  Port to Mac -> casts in calls to build_skel_tables().
 *  07-Jan-93 jfd ANSI C function declaration changes.
 *                Corrected ANSI function declaration for slimsetup_intell().
 *  08-Feb-93 jfd VXWorks support.
 *  23-Sep-93 jfd In slimrecon(), added support for processing early MOTOROLA
 *                fonts which contain a pad byte in various places.
 *  18-Oct-93 jfd In slimrecon(), additional support for processing early 
 *                MOTOROLA fonts which contain a pad byte in various places.
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"


#if IF_RDR

#if BOLD
typedef struct
{
    UW16 loop;
    UW16 coord_index;   /* coordinate index within loop */
    UW16 x;
    UW16 y;
    UB8 xsk0, xsk1, ysk0, ysk1;
} DUP_POINTS;
typedef DUP_POINTS * PDUP_POINTS;

#define MAX_DUP_POINTS 48
GLOBAL DUP_POINTS dup_points[MAX_DUP_POINTS];
#endif  

#define STAN_STAN_MASK 0x04

#ifdef LINT_ARGS
MLOCAL UW16   expand_hq3(LPLPSB8);
MLOCAL LPSB8   glob_dims(PDIMENSION, LPSB8);
MLOCAL LPSB8   skel_data(LPSB8, PSKEL);
MLOCAL UW16   build_skel_tables(LPSB8);
MLOCAL UW16   if_data(UW16, LPSB8);
#if SLIM_FONTS
MLOCAL UW16  slimrecon (VOID);
MLOCAL LPUB8 slimsetup_intell (PSKEL, LPUB8, UB8, UB8, UB8);
#endif /* SLIM_FONTS */
#ifdef STATS
GLOBAL VOID    load_char_stats(LPUW16);
#endif
#ifdef DEBUG
MLOCAL BOOLEAN print_contour(VOID);
MLOCAL VOID print_metric(VOID);
MLOCAL VOID print_xy(VOID);
MLOCAL VOID print_points(VOID);
MLOCAL VOID print_skel(PSKEL);
MLOCAL VOID print_if(VOID);
#endif

/*  fm.c  */
EXTERN LPSB8         fgseg(PBUCKET);

#else
#if SLIM_FONTS
MLOCAL UW16  slimrecon ();
MLOCAL LPUB8 slimsetup_intell ();
#endif /* SLIM_FONTS */
/*  fm.c  */
EXTERN LPSB8    fgseg();
#ifdef STATS
GLOBAL VOID    load_char_stats();
#endif

#endif /* LINT_ARGS */

#if ((ELASTIC_Y) | (ELASTIC_X))
GLOBAL UW16 isElastic;  /* this variable is used to indicate the presence of */
                         /* elascticity data, and is used in conjunction with */
                         /* c.alt_black_width to determine need to adjust     */
                         /* char metrics in metrics(). It is finally used to  */
                         /* communicate "secretly" to ifdos.c                */
#endif


/*-----------------------------*/

EXTERN IF_STATE if_state;

#ifdef STATS
MLOCAL UW16  combined_size;  /* size of character data plus expansion data */
MLOCAL UW16  exp_size;       /* size of character data plus expansion data */
#endif

#if defined(PAD_BYTE)
#if BYTEORDER == HILO
EXTERN int process_pad_byte;
#endif
#endif

/*---------------*/
/*  next_loop    */
/*---------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  next_loop(PLOOP lp)
#else
GLOBAL VOID
next_loop(lp)
    PLOOP lp;
#endif
{
    LPSB8 p;
    UW16 npnt, ncontact;

    p = if_state.next_coord_data;
    npnt     = *(LPSW16)p;  p +=2;
    ncontact = *(LPSW16)p;  p +=2;

    lp->npnt = npnt;
    lp->ncontact = ncontact & 0x7fff;
    lp->polarity = (SB8)((ncontact&0x8000) ? 1:0);
    lp->v = p;    p += (npnt+1)&0xfffe;
    lp->cv = (PSW16VECTOR)p;
    if(if_state.quality > 1) npnt += lp->ncontact;
    lp->ncoords = npnt;

    if_state.next_coord_data = p + sizeof(SW16VECTOR)*(npnt + 1);
}





/*---------------*/
/*  first_loop   */
/*---------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  first_loop()
#else
GLOBAL VOID
first_loop()
#endif
{
    if_state.next_coord_data = if_state.expand_buf;
}






/*---------------*/
/*  glob_dims    */
/*---------------*/
#if defined (ANSI_DEFS)
MLOCAL LPSB8 glob_dims(PDIMENSION d, LPSB8 p)
#else
MLOCAL LPSB8
glob_dims(d,p)
    PDIMENSION d;
    LPSB8 p;
#endif
{
    UW16 uw;
    LPSB8 pubSTAN;

    uw = *(LPUW16)p;
    d->num_dim = (UB8)uw;
        p += 2;         /* step to array of global dimension values */
    d->value = (LPUW16)p;
        p += uw<<1;     /* step to array of global dimension flags  */
    d->attrib = (LPUB8)p;
    pubSTAN   = (LPSB8)p; /* cast correctly to prevent warnings -ss 3/19/92 */
        p += uw;        /* step to Global dimension data            */
    if(((UW16)p&1) != 0) p++;

#ifdef DEBUG
    DBG("\n\nGlobal Dimensions\n");
    DBG1("    number of dimensions  %u\n",d->num_dim);
    for(uw = 0; uw < d->num_dim; uw++)
        DBG2("    %u    %x\n", d->value[uw], d->attrib[uw]);
#endif

    /*
    setup index to standard STANDARD dimension ! */
    d->stan_STAN_i = 0xff;
    for (uw=0; uw<d->num_dim; uw++)
      {
      if (*pubSTAN & STAN_STAN_MASK)  /* 0x04 */
        {
        d->stan_STAN_i = (UB8)uw;
        break;
        }
      pubSTAN++;
      }

    return p;
}


/*---------------*/
/*  if_init_glob */
/*---------------*/
#if defined (ANSI_DEFS)
GLOBAL BOOLEAN if_init_glob(PBUCKET bucket)
#else
GLOBAL BOOLEAN
if_init_glob(bucket)
    PBUCKET  bucket;
#endif
{
  SW16   temp_glob_ital_ang;
  UW16  uw;
  LPSB8  p;
#ifdef DEBUG
  UCOUNTER   i;
  PDISPLAY  display;
  PFACE_ATT attribute;
#endif

    if(if_state.if_init_face == bucket->tfnum)
        return TRUE;

    if_state.if_init_face = 0; /* set current init'd face to invalid incase failure */



  /* raster parameter */

    if (bucket->p.in.orast != MAX_UWORD)  /* jfd */
    {
        p = fgseg(bucket) + bucket->p.in.orast;  /* jfd */
        if_state.orThreshold = *(LPUW16)(p);
        temp_glob_ital_ang = *(LPSW16)(p+2);
        DBG("Raster parameter\n");
        DBG1("  orThreshhold        %u\n",if_state.orThreshold);
        DBG1("  temp_glob_ital_ang  %d\n",temp_glob_ital_ang);
    }
    else
    {
        if_state.orThreshold = 0;
        temp_glob_ital_ang = 0;
    }




  /* display header */

    if (bucket->p.in.odisplay != MAX_UWORD)  /* jfd */
    {
#ifdef DEBUG
        display = (PDISPLAY)(fgseg(bucket) + bucket->p.in.odisplay);  /* jfd */
#endif
        DBG("Display header segment\n");
        DBG1("  NCHAR             %u\n",display->NCHAR);
        DBG1("  leftReference     %u\n",display->leftReference);
        DBG1("  baselinePosition  %u\n",display->baselinePosition);
        DBG1("  minimumPointSize  %u\n",display->minimumPointSize);
        DBG1("  maximumPointSize  %u\n",display->maximumPointSize);
        DBG1("  minimumSetSize    %u\n",display->minimumSetSize);
        DBG1("  maximumSetSize    %u\n",display->maximumSetSize);
        DBG1("  masterPointSize   %u\n",display->masterPointSize);
        DBG1("  scanDirection     %u\n",display->scanDirection);
        DBG1("  italicAngle       %d\n",display->italicAngle);
        DBG1("  xHeight           %d\n",display->xHeight);
        DBG1("  scanResolutionY   %u\n",display->scanResolutionY);
        DBG1("  scanResolutionX   %u\n",display->scanResolutionX);
        DBG1("  outputEnable      %u\n",display->outputEnable);
    }
    else
        return FALSE;



  /* attribute header */

    if (bucket->p.in.oattribute != MAX_UWORD)  /* jfd */
    {
#ifdef DEBUG
        attribute = (PFACE_ATT)(fgseg(bucket) + bucket->p.in.oattribute); /* jfd */
#endif
        DBG("Face attribute segment\n");
        DBG1("  languageType     %u\n", attribute->languageType);
        DBG1("  fontUsage        %u\n", attribute->fontUsage);
        DBG1("  isFixedPitch     %u\n", attribute->isFixedPitch);
        DBG1("  escapeUnit       %u\n", attribute->escapeUnit);
        DBG1("  scaleFactor      %u\n", attribute->scaleFactor);
        DBG1("  leftReference    %u\n", attribute->leftReference);
        DBG1("  baselinePosition %u\n", attribute->baselinePosition);
        DBG1("  windowTop        %d\n", attribute->windowTop);
        DBG1("  windowBottom     %d\n", attribute->windowBottom);
        DBG1("  ascender         %d\n", attribute->ascender);
        DBG1("  descender        %d\n", attribute->descender);
        DBG1("  capHeight        %d\n", attribute->capHeight);
        DBG1("  xHeight          %d\n", attribute->xHeight);
        DBG1("  lcAccenHeight    %d\n", attribute->lcAccenHeight);
        DBG1("  ucAccentHeight   %d\n", attribute->ucAccentHeight);
        DBG1("  charPica         %u\n", attribute->charPica);
        DBG1("  leftAlign        %d\n", attribute->leftAlign);
        DBG1("  rightAlign       %d\n", attribute->rightAlign);
        DBG1("  uscoreDepth      %d\n", attribute->uscoreDepth);
        DBG1("  uscoreThickness  %u\n", attribute->uscoreThickness);
        DBG1("  windowLeft       %d\n", attribute->windowLeft);
        DBG1("  windowRight      %d\n", attribute->windowRight);
        DBG1("  spaceBand        %u\n", attribute->spaceBand);
    }
   else
      return FALSE;




/*
 *  Locate Global Intellifont Data
 */
  if ((bucket->p.in.ogif != MAX_UWORD) && bucket->p.in.gifct)  /* jfd */
  {
    if_state.if_flag = TRUE;
  }
  else
  {
    if_state.if_flag = FALSE;
    if ( if_state.orThreshold == 0 ) if_state.orThreshold = 210;
  }




    if ((bucket->p.in.ogif != MAX_UWORD) && bucket->p.in.gifct)  /* jfd */
    {
       DBG("Global Intellifont Data\n");
       p = fgseg(bucket) + bucket->p.in.ogif;  /* jfd */

      /*  Y Class Data  */

        uw = if_state.num_gylines = *(LPUW16)p;
            p += 2;
        if_state.gylines = (LPUW16)p;
            p += uw<<1;      /* step to global Y-class defin data */
        uw = *(LPUW16)p;
        if_state.glob_yclass.num_yclass_def = (UB8)uw;
            p += 2;          /* step to high Y-line index array   */
        if_state.glob_yclass.yline_high_i = (LPUB8)p;
            p += uw;         /* step to low Y-line index array    */
        if_state.glob_yclass.yline_low_i = (LPUB8)p;
            p += uw;         /* step to Global Dimension Data     */

#ifdef DEBUG
        DBG1("  number of gylines %u\n", if_state.num_gylines);
        for (i = 0; i < if_state.num_gylines; i++)
            DBG1("    %u\n", if_state.gylines[i]);

        DBG1("    number of yclass definitions  %u\n",
                                           if_state.glob_yclass.num_yclass_def);
        for (i = 0; i < if_state.glob_yclass.num_yclass_def; i++)
            DBG2("    %u  %u\n", if_state.glob_yclass.yline_high_i[i],
                                if_state.glob_yclass.yline_low_i[i]);
#endif


      /*  Global Y Dimension Data  */

        p = glob_dims(&if_state.glob_y_dim, p);

      /*  Global X Dimension Data  */

        p = glob_dims(&if_state.glob_x_dim, p);

      /*  orThreshold value  */

        if ( if_state.orThreshold == 0 )
        {
            if ( *(LPUW16)p == 0 )
                if_state.orThreshold = 210;
            else
                if_state.orThreshold = *(LPUW16)p;
        }
            p += 2;         /* step to std dim cut-in limit               */
        if_state.stan_dim_lim = *(LPUW16)p;
            p += 2;         /* step to screen face substitution width fact*/
        if_state.subst_wdth_fac = *(LPUW16)p;
            p += 2;         /* step to screen face substitution cut-in    */
        if_state.subst_cutin = *(LPUW16)p;
            p += 10;         /* step past detail face descriptor to possible STANDARD standard dim cutin */
        if_state.stan_STAN_dim_lim = *(LPUW16)p;

        if_state.glob_ital_ang = temp_glob_ital_ang;
        if ( (if_state.stan_dim_lim == 0) || (if_state.subst_cutin == 0) )
        {
           if_state.stan_dim_lim = MAX_WORD;
           if_state.subst_cutin  = MAX_WORD;
        }
    }


    if_state.if_init_face = bucket->tfnum;  /* current init'd face */

    return TRUE;
}



/*===============================================================*/
/*            I n i t i a l i z e    C h a r a c t e r           */


#ifdef DEBUG
/*----------------*/
/* print_contour  */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN  print_contour()
#else
MLOCAL BOOLEAN
print_contour()
#endif
{
    PCTREE tnode;
    UCOUNTER i;

    DBG("Contour Tree\n");
    DBG2("    num loops, flag  %d  %d\n",if_state.num_loops, if_state.contour_flag);

    tnode = if_state.ctree;
    for(i=0; i< if_state.num_loops; i++, tnode++)
    {
        DBG4("    offset/pol/child/sib   %d  %d  %d  %d\n",
                  tnode->xyoff, tnode->polarity,
                  tnode->child, tnode->sibling);
    }
    return TRUE;
}


/*----------------*/
/* print_metric   */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID  print_metric()
#else
MLOCAL VOID
print_metric()
#endif
{
    DBG("    metric data\n");
    DBG4("    bounding box %d,%d   %d,%d\n", if_state.bound_box.ll.x,
                                             if_state.bound_box.ll.y,
                                             if_state.bound_box.ur.x,
                                             if_state.bound_box.ur.y);
    DBG4("    escape box   %d,%d   %d,%d\n", if_state.escape_box.ll.x,
                                             if_state.escape_box.ll.y,
                                             if_state.escape_box.ur.x,
                                             if_state.escape_box.ur.y);
}




/*----------------*/
/* print_xy       */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID print_xy()
#else
MLOCAL VOID
print_xy()
#endif
{
    PCTREE ctree;
    LPSW16 xptr, yptr;
    LPSB8 xauxptr, yauxptr;
    UCOUNTER  i;
    COUNTER   j;
    LPSB8 p;
    SW16 npnt, nauxpt;

    ctree = if_state.ctree;

    for (i=0; i< if_state.num_loops; i++)
    {
        DBG("    --------next loop-------\n");

        p = if_state.char_buf + ctree->xyoff;
        ctree++;

        npnt    = *(LPSW16)p;   p += 2;
        nauxpt  = *(LPSW16)p;   p += 2;
        xptr    = (LPSW16)p;    p += 2*npnt;
        yptr    = (LPSW16)p;    p += 2*npnt;
        xauxptr = p;           p += nauxpt;
        yauxptr = p;           p += nauxpt;


        DBG2("    npt = %d   nauxpt = %d\n", npnt, nauxpt);
        for(j=0; j < npnt; j++)
        {
            DBG4("        %x  %d      %x  %d\n",
                 ((UW16)*xptr) >> 14, *xptr&0x3fff,
                 ((UW16)*yptr) >> 14, *yptr&0x3fff);

            xptr++;
            yptr++;
        }
        DBG("\n    auxilary points\n");
        for(j=0; j < nauxpt; j++)
            DBG2("        %d  %d\n",*xauxptr++, *yauxptr++);


    }
}


/*----------------*/
/* print_points   */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID print_points()
#else
MLOCAL VOID
print_points()
#endif
{
    PSW16VECTOR cv;
    LPSB8 v;
    UCOUNTER  i,j;
    LOOP loop;

    DBG("\n\nCoordinate and contact points\n");
    first_loop();
    for (i=0; i< if_state.num_loops; i++)
    {
        DBG("    --------next loop-------\n");
        next_loop(&loop);

        DBG3("    npnt = %d   ncontact = %d     polarity = %d\n",
                   loop.npnt, loop.ncontact, loop.polarity);
        cv = loop.cv;
        v  = loop.v;

        for(j=0; j < loop.npnt; j++)
        {
            if(V_XSKEL(*v)) {DBG("  x ");}
                       else {DBG("    ");}
            if(V_YSKEL(*v)) {DBG("y ");}
                       else {DBG("  ");}
            if(V_CONTACT(*v)) {DBG("c ");}
                         else {DBG("  ");}

            DBG3("    %d      %d    %x\n", cv->x, cv->y, *v);
            cv++;
            if(V_CONTACT(*v) && if_state.quality > 1)
            {
                DBG2("            %d      %d\n", cv->x, cv->y);
                cv++;
            }
            v++;
        }
        DBG2("            %d      %d\n", cv->x, cv->y);
    }
}



/*----------------*/
/* print_skel     */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID  print_skel(PSKEL sp)
#else
MLOCAL VOID
print_skel(sp)
    PSKEL sp;
#endif
{
    UCOUNTER i,j;
    LPUB8 skloop;
    LPUW16 skcntr;

    /* tree_attrib bits */
    SW16   attrib;
    SW16   num_assoc;
    SW16   constr_dim;
    SW16   grid_align;
    SW16   rtz;
    SW16   rtype;


    DBG3("    num_skel / num_trees / num_nodes %d  %d  %d\n",
                         sp->num_skel, sp->num_trees, sp->num_nodes);


  /* build loop order list of skeletal points */

    skloop = sp->num_skel_loop;
    skcntr = sp->skel_to_contr;

    for ( i=0; i<if_state.num_loops; i++, skloop++)
    {
        DBG2("        loop %d has %u skel points\n\n\n",i,*skloop);
        DBG("                      skel_to_contr\n");
        for ( j=0; j<*skloop; j++)
            DBG2("            %d            %u\n", j, *skcntr++);
    }

    DBG("\n        tree_attrib        tree_skel_i\n");
    DBG("        N C G Z R\n");
    for(i=0; i < sp->num_nodes ; i++)
    {
        attrib = *(sp->tree_attrib+i);
        num_assoc = attrib >> 5;
        constr_dim = (attrib>>4) & 1;
        grid_align = (attrib>>3) & 1;
        rtz        = (attrib>>2) & 1;
        rtype      = attrib & 3;

        DBG6("        %d %d %d %d %d            %d\n",
           num_assoc,constr_dim,grid_align,rtz,rtype,*(sp->tree_skel_i+i));
    }

    DBG1("    num_intrp %d\n", sp->num_intrp);
    for(i=0; i < sp->num_intrp ; i++)
        DBG3("        %d %d %d\n", *(sp->intrp1_skel_i+i),
                                   *(sp->intrp2_skel_i+i),
                                   *(sp->num_intrp_assoc+i));
    DBG1("    tot_num_intrp_assoc %d\n", sp->tot_num_intrp_assoc);
    for(i=0; i < sp->tot_num_intrp_assoc ; i++)
        DBG1("        %d\n",*(sp->intrp_assoc_skel_i+i));
}



/*----------------*/
/* print_if       */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID print_if()
#else
MLOCAL VOID
print_if()
#endif
{
    UCOUNTER i;

  /* y skel data */

    DBG("y skeletal data\n");
    print_skel(&if_state.yskel);

  /* baseline */

    DBG1("baseline_offset %d\n",if_state.baseline_offset);

  /* y classes */

    DBG("y classes\n");
    DBG1("    num_yclass_ass %d\n",if_state.num_yclass_ass);
    DBG("        num_root_p_ass\n");
    for(i=0; i< if_state.num_yclass_ass; i++)
        DBG1("        %d\n", *(if_state.num_root_p_ass+i));
    DBG("        root_skel_i\n");
    for(i=0; i< if_state.yskel.num_trees; i++)
        DBG1("        %d\n", *(if_state.root_skel_i+i));
    DBG("        yclass_i\n");
    for(i=0; i< if_state.num_yclass_ass; i++)
        DBG1("        %d\n", *(if_state.yclass_i+i));

    DBG1("    num_yclass_def  (high/low) %d\n",if_state.num_yclass_def);
    for(i=0; i<if_state.num_yclass_def; i++)
        DBG2("        %d %d\n",*(if_state.yline_high_i+i), *(if_state.yline_low_i+i));

    DBG1("    num_ylines %d\n",if_state.num_ylines);
    for(i=0; i< if_state.num_ylines; i++)
        DBG1("        %d\n",*(if_state.ylines + i));

  /* x data */

    DBG("x skeletal data\n");
    print_skel(&if_state.xskel);

  /* local italic angle */

    DBG2("italic angle/flag  %d %d\n",if_state.loc_ital_ang, if_state.italic_flag);

  /* standard dimension data */

    DBG2("standard dims %d %d\n",if_state.xskel.stan_dim_i,if_state.yskel.stan_dim_i);
}
#endif



/*----------------*/
/*   expand_hq3   */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 expand_hq3(LPLPSB8 ppub)
#else
MLOCAL UW16
expand_hq3(ppub)
    LPLPSB8  ppub;       /* pointer to unused bytes of expansion buffer */
#endif
{
    LPSB8 pub;
    PCTREE ctree;
    LPSB8 p;
    UW16 i, j;
    UW16 npnt, ncontact, nvertex;
    LPSW16 x, y;
    LPSB8 xa, ya;
    LPSB8 v;          /* vertex codes */
    PSW16VECTOR cv;   /* coordinates and contact points */
    SW16 xs, ys;      /* first coordinate (needed to build last contact) */
    SW16 xc, yc;      /* current coordinate */
    SB8 vc;          /* current vertex code */


    pub = *ppub;

    ctree = if_state.ctree;
    for(i=0; i<if_state.num_loops; i++)
    {
      /*  Setup input pointers  */

        p = if_state.char_buf + ctree->xyoff;
          /* deleted (incorrect) cast of int to npnt,ncontact -ss 10/3/91 */
        npnt     = (*(LPSW16)p);       p += 2;         /* num coordinates  */
        ncontact = (*(LPSW16)p);       p += 2;         /* num aux pts      */
        x        = (LPSW16)p;          p += 2*npnt;    /* coordinates      */
        y        = (LPSW16)p;          p += 2*npnt;
        xa       = p;                 p += ncontact;  /* auxillary points */
        ya       = p;

      /*  setup output pointers in expansion buffer. Layout for each loop
       *  is:
       *        UW16      npnt
       *        UW16      ncontact  bit 15 is set to polarity
       *        SB8       v[npnt]   vertex codes
       *        SB8       pad if needed to align to SW16 boundary
       *        SW16VECTOR cv[nvertex] 
       */
        nvertex = npnt + 1;                    /* the loop is closed */
        if(if_state.quality > 1) nvertex += ncontact; /* interleave contact points */
        if(ctree->polarity == 1) ncontact |= 0x8000;

        /*  Leave room for 2 UW16S plus npnt bytes of vertex codes
         *  plus pad byte if needed.
         */
        v  = pub; pub += ((5 + npnt) & 0xfffe);
        cv = (PSW16VECTOR)pub; pub += 4*(nvertex);      /* coordinates */

        if((UW16)(pub - if_state.expand_buf) > if_state.expand_size)
            return ERR_ov_char_buf;


        *(LPSW16)v = npnt;     v += 2;
        *(LPSW16)v = ncontact; v += 2;

        xs = (*x & (SW16)0x3fff);    /* remember first coordinate */
        ys = (*y & (SW16)0x3fff);

      /*  Unpack input data into output arrays */

        for(j=0; j<npnt-1; j++)
        {
          /* vertex code        */

            *v++ = vc = (UB8) (((UW16)*x >> 14 )
                                | (((UW16)*y >> 12)&(UW16)0xfffc));

            xc = cv->x = *x++ & (SW16)0x3fff;
            yc = cv->y = *y++ & (SW16)0x3fff;
            cv++;
            if(if_state.quality > 1)
            {
                if(V_CONTACT(vc))
                {
                    cv->x = ((xc+(*x & (SW16)0x3fff)) >> 1) + (SW16)(*xa++);
                    cv->y = ((yc+(*y & (SW16)0x3fff)) >> 1) + (SW16)(*ya++);
                    cv++;
                }
            }
        }
        *v++ = vc = (UB8) (((UW16)*x >> 14 )
                            | (((UW16)*y >> 12)&(UW16)0xfffc));

        xc = cv->x = *x & (SW16)0x3fff;
        yc = cv->y = *y & (SW16)0x3fff;
        cv++;
        if(if_state.quality > 1)
        {
            if (V_CONTACT(vc))
            {
                cv->x = ((xc + xs) >> 1 ) + (SW16)(*xa);
                cv->y = ((yc + ys) >> 1 ) + (SW16)(*ya);
                cv++;
            }
        }
        cv->x = xs;    /* close the loop */
        cv->y = ys;

        ctree++;
    }

    *ppub = pub;
    return SUCCESS;
}




/*----------------*/
/* skel_data      */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL LPSB8 skel_data(LPSB8 pp, PSKEL sp)
#else
MLOCAL LPSB8
skel_data(pp, sp)
    LPSB8 pp;
    PSKEL sp;
#endif
{
    LPSB8 p;

    p = pp;

    sp->num_skel    = *(p++);
    sp->num_trees   = *(p++);
    sp->num_nodes   = *(p++);
    sp->tree_skel_i = (LPUB8)p;     /*  added cast -ss 6/25/91  */
       p += sp->num_nodes;
    sp->tree_attrib = (LPUB8)p;     /*  added cast -ss 6/25/91  */
       p += sp->num_nodes;


  /* Interpolated association data */

    sp->num_intrp           = *(p++);
    sp->intrp1_skel_i       = (LPUB8)p;     /*  added cast -ss 6/25/91  */
        p += sp->num_intrp;
    sp->intrp2_skel_i       = (LPUB8)p;     /*  added cast -ss 6/25/91  */
        p += sp->num_intrp;
    sp->num_intrp_assoc     = (LPUB8)p;     /*  added cast -ss 6/25/91  */
        p += sp->num_intrp;
    sp->tot_num_intrp_assoc = *(p++);
    sp->intrp_assoc_skel_i  = (LPUB8)p;     /*  added cast -ss 6/25/91  */
        p += sp->tot_num_intrp_assoc;

    if((p - pp) & 1) p++;
    return p;
}



/*---------------------*/
/*  build_skel_tables  */
/*---------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 build_skel_tables(LPSB8 pub)
#else
MLOCAL UW16
build_skel_tables(pub)
    LPSB8 pub;
#endif
{
    UCOUNTER     i;
    COUNTER      j;

    LPUB8   xskloop, yskloop;
    LPUW16   xskcntr, yskcntr;
    LOOP     loop;
    SB8     vertex_code;

#if BOLD
    UCOUNTER    k;
    PSW16VECTOR cv;
    PDUP_POINTS dp     = dup_points;
    UW16       dup_ct = 0;
    SW16VECTOR  last_coord;
#endif

  /*  Build loop order list of skeletal points. If pseudo bold is in
   *  enabled, find duplicate points.
   */

    if_state.yskel.num_skel_loop = yskloop = (LPUB8)pub; pub += if_state.num_loops;
    if_state.xskel.num_skel_loop = xskloop = (LPUB8)pub; pub += if_state.num_loops;
    if_state.yskel.skel_to_contr = yskcntr = (LPUW16)pub; pub += 2*if_state.yskel.num_skel;
    if_state.xskel.skel_to_contr = xskcntr = (LPUW16)pub; pub += 2*if_state.xskel.num_skel;

    if((UW16)(pub - if_state.expand_buf) > if_state.expand_size)
       return ERR_ov_char_buf;


    first_loop();
    for ( i=0; i<if_state.num_loops; i++, yskloop++, xskloop++)
    {
        next_loop(&loop);

        *yskloop = 0;
        *xskloop = 0;

        j = 0;

        while(j<loop.ncoords)
        {
            vertex_code = *loop.v++;

            if (V_XSKEL(vertex_code))  /* test for x skel pt */
            {
                (*xskloop)++;
                *xskcntr++ = j;
            }
            if(V_YSKEL(vertex_code))  /* test for y skel pt */
            {
                (*yskloop)++;
                *yskcntr++ = j;
            }
            if(if_state.quality>1 && V_CONTACT(vertex_code))
                j++;     /* skip contact point  */
            j++;
        }      



    }
#ifdef DEBUG
    print_if();
#endif





#if BOLD
    first_loop();
    for (i=0; i<if_state.num_loops; i++)
    {
        next_loop(&loop);

        cv = loop.cv;

        last_coord = *(cv + loop.ncoords - 1);
        k=0;
        while(k < loop.ncoords)
        {
            if(last_coord.x == cv->x && last_coord.y == cv->y)
            {
                DBG4("    dup pt: (%d, %d)  loop = %u   index = %u\n",
                               last_coord.x, last_coord.y, i, k);
                dp->loop  = i;
                dp->coord_index = k;
                dup_ct++;
                if(dup_ct == MAX_DUP_POINTS) return ERRtoo_many_dup_skel;
                dp++;
            }
            last_coord = *cv++;
            k++;
        }      
    }
    dp->loop = -1;
#endif /* BOLD */

#ifdef STATS
     combined_size = (UW16)(pub - if_state.char_buf);  /* size of charbuf + expbuf*/
     exp_size      = (UW16)(pub - if_state.expand_buf);/* size of expansion buffer*/
#endif  /* STATS */
    return SUCCESS;
}

/*----------------*/
/* if_data        */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  if_data(UW16 ifoff, LPSB8 pub)
#else
MLOCAL UW16
if_data(ifoff, pub)
    UW16  ifoff;
    LPSB8  pub;
#endif
{
    LPSB8    ifp;
    LPSB8    p;

    if(ifoff == MAX_UWORD)
    {
        if_state.char_is_if     = FALSE;
        if_state.yskel.num_skel = 0;
        if_state.xskel.num_skel = 0;
        if_state.loc_ital_ang   = 0;
    }
    else
    {
        if_state.char_is_if = TRUE;

        ifp = p = if_state.char_buf + ifoff;

      /* y skel data */

        p = skel_data(p, &if_state.yskel);

      /* baseline */

        if_state.baseline_offset = *(LPSW16)p;  p += 2;

      /* y classes */

        if_state.num_yclass_ass = *(p++);
        if_state.num_root_p_ass = (LPUB8)p;     /*  added cast -ss 6/25/91  */
                      p += if_state.num_yclass_ass;
        if_state.root_skel_i    = (LPUB8)p;     /*  added cast -ss 6/25/91  */
                      p += if_state.yskel.num_trees;
        if_state.yclass_i       = (LPUB8)p;     /*  added cast -ss 6/25/91  */
                      p += if_state.num_yclass_ass;

        /* local y class definitions */

        if_state.num_yclass_def = *(p++);
        if_state.yline_high_i   = (LPUB8)p;     /*  added cast -ss 6/25/91  */
                      p += if_state.num_yclass_def;
        if_state.yline_low_i    = (LPUB8)p;     /*  added cast -ss 6/25/91  */
                      p += if_state.num_yclass_def;

        if((p - ifp) & 1) p++;      /* pad to even byte */


        if_state.num_ylines = *(LPUW16)p;    p += 2;
        if_state.ylines     =  (LPUW16)p;    p += 2*if_state.num_ylines;

      /* x data */

        p = skel_data(p, &if_state.xskel);

      /* local italic angle */

        if_state.loc_ital_ang = *(LPSW16)p;   p += 2;
        if_state.italic_flag  = *(LPUW16)p;  p += 2;;

      /* standard dimension data */

        if_state.xskel.stan_dim_i = *(LPUB8)p++;
        if_state.yskel.stan_dim_i = *(LPUB8)p++;
    }


    return build_skel_tables((LPSB8)pub);
}



/*  build words from Intel ordered bytes in slim char recon */
/*  What do we do about non-Intel ?????? */

                                                      /* 10-28 91 jfd */
#define MAKEWORD(p)  ( (UW16)(*(LPUB8)(p)) + ((UW16)*((LPUB8)(p)+1)<<8) )

/* no swap, needed for words not aligned on word boundry  -ss 2/25/92 */
#if BYTEORDER == LOHI
#define MAKEWORD_NS(p)  ( *(LPUW16)p )
#else
#define MAKEWORD_NS(p) ( ((UW16)*(LPUB8)(p) << 8) + (UW16)(*((LPUB8)(p)+1)))
#endif



/*---------------*/
/*  if_init_char */
/*---------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 if_init_char()
#else
GLOBAL UW16
if_init_char()
#endif
{
    UW16 len, metoff, ifoff, conoff, xyoff;
    LPUW16 wp;
    LPSB8  p;
    SW16   i;
    UW16  status;
    LPSB8 pub;
#if ((ELASTIC_Y) | (ELASTIC_X))
    UW16 elasoff;
    UW16 num;
    LPSB8 ptr;
#endif
    PBOX  pbox;

   /* Reset elasticitity flag here in case slim fonts returns prematurely */

#if ((ELASTIC_Y) | (ELASTIC_X))
    isElastic = NO;
#endif

#if SLIM_FONTS
    status = MAKEWORD_NS( if_state.char_buf ); /* use status cuz its there -ss 2/21/92 */
    if(status & 0x8000) 
       return slimrecon();
#endif  /* SLIM_FONTS */

  /*  Offsets to sections of character */

    wp     = (LPUW16)if_state.char_buf;
    len    = MAKEWORD_NS( wp );   wp++;   /* total length     */
    metoff = MAKEWORD_NS( wp );   wp++;   /* metric data      */
    ifoff  = MAKEWORD_NS( wp );   wp++;   /* Intellifont data */
    conoff = MAKEWORD_NS( wp );   wp++;   /* Contour tree     */
    xyoff  = MAKEWORD_NS( wp );   wp++;   /* XY data          */
#if ((ELASTIC_Y) | (ELASTIC_X))
    elasoff = MAKEWORD_NS( wp );   wp++;   /* Elasticity data */
#endif

    pub = if_state.expand_buf;

  /*-------------Contour Data---------------------------------*/

    if ( conoff == MAX_UWORD )  /* !!!!!!!!!!!!!!!!!! */
    {
        if_state.num_loops = 0;
        if_state.contour_flag = 0;
        if_state.PreBrokenContrs = 0;
        if_state.HqFormat = 0;
        if_state.ConnectingChar = 0;
#if 0
        DBG("No contour tree\n");
        return ERR_no_contour;
#endif
    }
    else
    {

    p = (LPSB8)(if_state.char_buf+conoff);
    if_state.num_loops        = MAKEWORD_NS( p );   p += 2;
    i = if_state.contour_flag = MAKEWORD_NS( p );   p += 2;
        if_state.PreBrokenContrs = i & 0x0001;
        if_state.HqFormat = ((i & 0x0006) >> 1) + 1;
        if_state.ConnectingChar = (i & 0x0100) >> 8;
#if ((ELASTIC_Y) | (ELASTIC_X))
        isElastic = ((i & (UW16)0x0008) >> 3);
#endif
    if (if_state.HqFormat != 3)
    {
        DBG("----------not HQ3\n");

        return ERR_not_hq3;
    }
    if_state.ctree        = (PCTREE)p;

    }  /* !!!!!!!!!!!!!!!!!!!!!!!! */


#ifdef DEBUG
    print_contour();
    print_xy();
#endif

    status = expand_hq3(&pub);
    if (status)
        return status;
#ifdef DEBUG
    print_points();
#endif

  /*-------------Metric Data----------------------------------*/

    pbox = (PBOX)(if_state.char_buf+metoff);
    if_state.bound_box  = *pbox++;
    if_state.escape_box = *pbox;
#ifdef DEBUG
    print_metric();
#endif

  /*-------------XY Data--------------------------------------*/

    if_state.contour_data = (LPSB8)(if_state.char_buf + xyoff);

#if ((ELASTIC_Y) | (ELASTIC_X))

/*
** Read elastic data if any
*/
  if(isElastic){
    ptr = if_state.char_buf + elasoff;
    num = *ptr++;
    if_state.xskel.num_breaks_per_char = *ptr++;
    if_state.xskel.elasticityData = (LPUB8)ptr;
    ptr += 2 * num;
    num = *ptr++;
    if_state.yskel.num_breaks_per_char = *ptr++;
    if_state.yskel.elasticityData = (LPUB8)ptr;
  }
  else {
   if_state.xskel.elasticityData = if_state.yskel.elasticityData = NULL;
  }
#endif

  /*-------------Intellifont Data-----------------------------*/

     return if_data(ifoff, pub);
}





#if SLIM_FONTS

typedef struct {
      UW16  size;
      UW16  xescapement;
      UB8  NYTR;
      UB8  NYND;
      UB8  NXYPR;
      UB8  NYCA;
      UB8  NXND;
      UB8  baseline_offset;
      SW16   local_italic_angle;
      LPUB8 data;
} slimfont_type;

typedef slimfont_type FARPTR * Pslimfont_type;





/**********************************************************************/

/*
**  Sets up X or Y Intellifont Data for slim fonts
*/

/**********************************************************************/
#if ((defined (__STDC__) && (__STDC__  > 0) && !defined(__i960)) || \
     (defined(__i960) && defined(ANSI_960))) && !defined(VXWORKS)
MLOCAL LPUB8 slimsetup_intell (PSKEL sp, LPUB8 p, UB8 NTR, UB8 NND, UB8 NPR)
#else
MLOCAL LPUB8
slimsetup_intell (sp, p, NTR, NND, NPR)
    PSKEL   sp;
    LPUB8  p;
    UB8   NTR;
    UB8   NND;
    UB8   NPR;
#endif
{
    UCOUNTER i;
    SW16     tot;
    LPUB8   ni;

/*... Skeletal Array  I6.2.{1|2}.1 */
/*  num_skel will be counted from xy data */

  sp->num_skel = 0;

/*... Tree Data       I6.2.{1|2}.2 */

  sp->num_trees   = NTR;
  sp->num_nodes   = NND;
  sp->tree_skel_i = p;           p += sp->num_nodes;
  sp->tree_attrib = p;           p += sp->num_nodes;

/*... Interpolated Association Data  I6.2.{1|2}.3 */

  sp->num_intrp   = NPR;
  sp->intrp1_skel_i = p;         p += sp->num_intrp;
  sp->intrp2_skel_i = p;         p += sp->num_intrp;
  sp->num_intrp_assoc = p;       p += sp->num_intrp;

  ni = sp->num_intrp_assoc;
  tot = 0;
  for(i=0; i<sp->num_intrp; i++) 
    tot += (int)(*ni++);
  sp->tot_num_intrp_assoc = (UB8)tot;

  sp->intrp_assoc_skel_i = p;    p += sp->tot_num_intrp_assoc;

  return(p);
}


/**********************************************************************/
/*  uncompresses data for slim fonts                                  */
/**********************************************************************/

#if defined (ANSI_DEFS)
MLOCAL UW16 slimrecon ()
#else
MLOCAL UW16
slimrecon ()
#endif
{
  LPSB8  dxptr, dyptr;
  LPUB8 CharBuffPntr, ptr, pub, vptr, startvptr;
  UW16  j;
  SW16  xmin,xmax,ymin,ymax;
  UW16  expand_size,done;
  slimfont_type sf;
  UB8 vcmask,f1mask,f2mask,vcshift,f2shift,flag;
  SL32  ord;
  UW16  temp,temp2;

  UW16 npnt, ncontact;
  UW16 polarity;
  PSW16VECTOR cv, startcv;
  SW16VECTOR vec, prev_vec;

/*
** Set Input Character Data Pointer
*/
  CharBuffPntr = (LPUB8)if_state.char_buf;   /* 10-28-91 jfd */

  /* Changed following to use allocated struct vs. pointer.             */
  /* Makes life easier when worrying about alignment of elements within */
  /* the structure.                                       -ss 2/21/92   */

  /*  read char data as sequence of bytes */
                          /* don't swap -ss 8/13/92 */
  sf.size               = MAKEWORD_NS(CharBuffPntr);
     CharBuffPntr += sizeof( SW16 );
#if defined(PAD_BYTE)
#if BYTEORDER == HILO
  if (process_pad_byte)
     sf.xescapement        = MAKEWORD_NS(CharBuffPntr);
  else
#endif
#endif
  sf.xescapement        = MAKEWORD(CharBuffPntr);
     CharBuffPntr += sizeof( SW16 );

  sf.NYTR               = *CharBuffPntr++;
  sf.NYND               = *CharBuffPntr++;
  sf.NXYPR              = *CharBuffPntr++;
  sf.NYCA               = *CharBuffPntr++;
  sf.NXND               = *CharBuffPntr++;
  sf.baseline_offset    = *CharBuffPntr++;
                 /* loc_ital_ang swapped later, don't swap now -ss 3/19/92 */
  sf.local_italic_angle = MAKEWORD_NS( CharBuffPntr );   
     CharBuffPntr += sizeof( SW16 );
  sf.data               = CharBuffPntr;
  
/*
** Setup Character Contour Data  I6.1
*/
  /*  contourless character */
  if ( sf.NYTR == 0 &&
       sf.NYND == 0 &&
       sf.NXYPR == 0 &&
       sf.NYCA == 0x80  )
  {
     DBG("No contour tree\n");
#if 0
     return ERR_no_contour;
#endif  /* 10-27-92 */
  }
  else
  {
     if_state.HqFormat = 3;
     if_state.ConnectingChar = (sf.size&0x2000) ? 1 : 0;
  }
   /*
** Setup Intellifont Portion of character
*/
  if ( sf.NYTR == 0 && sf.NYND == 0 )
  {
    if_state.char_is_if     = FALSE;
    if_state.yskel.num_skel = 0;
    if_state.xskel.num_skel = 0;
    if_state.loc_ital_ang   = 0;
    ptr = sf.data;

/*??????????????*/

    if(sf.NXYPR == 0 &&
       sf.NYCA == 0x80  ) 
    {
        DBG("No contour tree\n");
#if 0
        return ERR_no_contour;
#endif  /* 10-27-92 */
    }

  } else {
    if_state.char_is_if     = TRUE;

  /*
  ** Setup y_intell  I6.2.1.1 thru I6.2.1.4
  */
  /*
  ** Setup Relative Baseline Offset  I6.2.1.5
  */
    if_state.baseline_offset = if_state.gylines[sf.baseline_offset];
  /*
  ** Setup Local Italic Angle Data  I6.2.3
  */

#if defined(PAD_BYTE)
#if BYTEORDER == HILO
    if (process_pad_byte)
       if_state.loc_ital_ang = MAKEWORD_NS(&sf.local_italic_angle);
    else
#endif
#endif
    if_state.loc_ital_ang = MAKEWORD(&sf.local_italic_angle);
    if_state.italic_flag = (sf.size & 0x4000) ? 1 : 0;

  /*
  ** Setup Y Preset (Vertical Channelization)  I6.2.1.6 
  */

    ptr = slimsetup_intell(&if_state.yskel, sf.data, sf.NYTR,
                                          sf.NYND, (sf.NXYPR&0xf));

  /*
  **  Setup Y-class Character (local) Data  I6.2.1.7
  */
    if_state.num_yclass_ass = sf.NYCA;
    if_state.num_root_p_ass = ptr;              ptr += if_state.num_yclass_ass;
    if_state.root_skel_i    = ptr;              ptr += if_state.yskel.num_trees;
    if_state.yclass_i       = ptr;              ptr += if_state.num_yclass_ass;

  /*  local intellifont data - not used in slim fonts */

    if_state.num_yclass_def = 0;
    if_state.yline_high_i   = ptr;
    if_state.yline_low_i    = ptr;
   
    if_state.num_ylines = 0;
    if_state.ylines = (LPUW16)ptr;  /* 10-28-91 jfd */

  /*
  ** Setup x_intell  I6.2.2.1 thru I6.2.2.4
  */
    ptr = slimsetup_intell(&if_state.xskel, ptr, 1, sf.NXND, (sf.NXYPR>>4));
  /*
  **  Setup Character Standard Dimension Data  I6.2.4
  */
    if_state.xskel.stan_dim_i = *ptr++;
    if_state.yskel.stan_dim_i = *ptr++;
  }

#if defined(PAD_BYTE)
#if BYTEORDER == HILO
     if (process_pad_byte)
        if((sf.data - ptr)&1) ptr++;
#endif
#endif

  /*  Expand coordinate data */

    pub = (LPUB8)if_state.expand_buf; /* Expanded data goes here. Added cast -ss  */
    done = 0;
    if_state.num_loops = 0;
    expand_size = 0;

  /* Trying to process a space character - 10/27/92 jfd*/
    if ( sf.NYTR == 0 &&
       sf.NYND == 0 &&
       sf.NXYPR == 0 &&
       sf.NYCA == 0x80  )
    {
       xmin = 0;
       ymin = 0;
       xmax = 0;
       ymax = 0;
    }
    else
    {

    xmax = ymax = 0;         /* character bounding box in design units */
    xmin = ymin = 0x4000;    /* gets calculated on the fly             */

  while(!done)
  {
#if defined(PAD_BYTE)
#if BYTEORDER == HILO
     if (process_pad_byte)
        temp = MAKEWORD_NS(ptr);    /* set temp first and use it  -ss 10/9/91 */
     else
#endif
#endif
     temp = MAKEWORD(ptr);    /* set temp first and use it  -ss 10/9/91 */
     done = temp & 0x8000;    /* last loop if bit 15 is set */
     npnt = temp&0x3ff;

    /*  Update expand_size for npnt vertex code bytes plus pad plus
     *  npnt+1 vectors (loop is closed). In our overflow check, make sure
     *  there's room for the worst case of npnt contact points. We won't
     *  know how many contact points there are until after we expand
     *  the coordinates. Then we'll update expand_size.
     */

     expand_size += ((npnt+1)*4 + npnt + 1)&0xfffe;
     if(expand_size + npnt > if_state.expand_size)
         return ERR_ov_char_buf;

     polarity = (temp&0x4000)<<1;    /* sit bit 15 to polarity */
     ptr+=2;

     *(LPUW16)pub = npnt;                     pub += 4;
     vptr = startvptr = pub;                  pub += (npnt+1) & 0xfffe;
     cv   = startcv   = (PSW16VECTOR)pub;     pub += 4*(npnt+1);
                                              /* add contact points later */
     ncontact = 0;

     ord = 0;
     vcmask = 0xe0;
     f1mask = 0x10;
     f2mask = 0xc;
     vcshift = 4;
     f2shift = 2;
 
  /*  process 1st coordinate separately */

#if defined(PAD_BYTE)
#if BYTEORDER == HILO
     if (process_pad_byte)
     {
        temp = MAKEWORD_NS(ptr);
        temp2 = MAKEWORD_NS(ptr+2);        ptr += 4;
     }
     else
#endif
#endif
    {
    temp = MAKEWORD(ptr);
    temp2 = MAKEWORD(ptr+2);        ptr += 4;
    }

    *vptr = (UB8)(( temp>>14) | (( temp2>>12)&(UW16)0xfffc) );

    if(!(*vptr & 0x2))
        ncontact++;
    if(*vptr & 0x8)
        if_state.yskel.num_skel++;
    if(*vptr & 0x4)
        if_state.xskel.num_skel++;
    vptr++;

    prev_vec.x = temp&0x3fff;
    prev_vec.y = temp2&0x3fff;

    /* Initialize xmin, xmax, ymin and ymax here because
       first point was not being considered as an extreme
     */

    if(prev_vec.x < xmin) xmin = prev_vec.x;
    if(prev_vec.x > xmax) xmax = prev_vec.x;
    if(prev_vec.y < ymin) ymin = prev_vec.y;
    if(prev_vec.y > ymax) ymax = prev_vec.y;

    *cv++ = prev_vec;


    for(j=1; j<npnt; j++, vptr++)
    {
        *vptr = (*ptr&vcmask)>>vcshift;

        if(!(*vptr & 0x2)) 
        {   /* previous point was start of bi-arc */
            ncontact++;
            if(if_state.quality>1) cv++;        /* leave room for contact point */
        }
        else
            *(vptr-1) |= 0x1;
        if(*vptr & 0x8)
            if_state.yskel.num_skel++;
        if(*vptr & 0x4)
            if_state.xskel.num_skel++;

        flag = *ptr&f1mask;
        if(ord) 
            ptr++;
        if(flag) 
            flag = (SB8)1 + ((*ptr&f2mask)>>f2shift);

        switch (flag) {

            case 0:  /*  bits 4-13 deltax, bits 14-23 deltay */
                if(ord) {
                    vec.x  = ((SW16)*ptr)<<2;             ptr++;
                    vec.x |= ((SW16)(*ptr&0xc0))>>6;
                    vec.y  = ((SW16)(*ptr&0x3f))<<4;      ptr++;
                    vec.y |= ((SW16)(*ptr&0xf0))>>4;
                }
                else {
                    vec.x  = ((SW16)(*ptr&0xf))<<6;       ptr++;
                    vec.x |= ((SW16)(*ptr&0xfc))>>2;
                    vec.y  = ((SW16)(*ptr&0x3))<<8;       ptr++;
                    vec.y |= (SW16)*ptr;                  ptr++;
                }
                /*  set high bits for negative numbers */
                if(vec.x & 0x200) vec.x |= 0xfc00;
                if(vec.y & 0x200) vec.y |= 0xfc00;
                vec.x += prev_vec.x;
                vec.y += prev_vec.y;
                break;

            case 1:  /*  deltay = 0, bits 6-19 x value (14bits) */
                if(ord) {
                    vec.x  = ((SW16)(*ptr&0x3f))<<8;      ptr++;
                    vec.x |= (SW16)*ptr;                  ptr++;
                }
                else {
                    vec.x  = ((SW16)(*ptr&0x3))<<12;      ptr++;
                    vec.x |= ((SW16)*ptr)<<4;             ptr++;
                    vec.x |= ((SW16)(*ptr&0xf0))>>4;
                }
                vec.y = prev_vec.y;
                break;

            case 2:  /*  deltax = 0, bits 6-19 y value (14bits) */
                if(ord) {
                    vec.y = ((SW16)(*ptr&0x3f))<<8;       ptr++;
                    vec.y |= (SW16)*ptr;                  ptr++;
                }
                else {
                    vec.y = ((SW16)(*ptr&0x3))<<12;       ptr++;
                    vec.y |= ((SW16)*ptr)<<4;             ptr++;
                    vec.y |= ((SW16)(*ptr&0xf0))>>4;
                }
                vec.x  = prev_vec.x;
                break;

            case 3:  /*  bits 6-16 deltax, bits 17-27 deltay */
                if(ord) {
                    vec.x = ((SW16)(*ptr&0x3f))<<5;       ptr++;
                    vec.x |= ((SW16)(*ptr&0xf8))>>3;
                    vec.y = ((SW16)(*ptr&0x7))<<8;        ptr++;
                    vec.y |= (SW16)*ptr;                  ptr++;
                }
                else {
                    vec.x = ((SW16)(*ptr&0x3))<<9;        ptr++;
                    vec.x |= ((SW16)*ptr)<<1;             ptr++;
                    vec.x |= ((SW16)(*ptr&0x80))>>7;
                    vec.y = ((SW16)(*ptr&0x7f))<<4;       ptr++;
                    vec.y |= ((SW16)(*ptr&0xf0))>>4;
                }
                if(vec.x & 0x400) vec.x |= 0xf800;
                if(vec.y & 0x400) vec.y |= 0xf800;
                vec.x += prev_vec.x;
                vec.y += prev_vec.y;
                break;

            case 4:  /*  bits 6-19 x value, bits 22-35 y value */
                if(ord) {
                    vec.x = ((SW16)(*ptr&0x3f))<<8;       ptr++;
                    vec.x |= ((SW16)*ptr);                ptr++;
                    vec.y = ((SW16)(*ptr&0x3f))<<8;       ptr++;
                    vec.y |= (SW16)*ptr;                  ptr++;
                }
                else {
                    vec.x = ((SW16)(*ptr&3))<<12;         ptr++;
                    vec.x |= ((SW16)(*ptr&0xff))<<4;      ptr++;
                    vec.x |= ((SW16)(*ptr&0xf0))>>4;
                    vec.y = ((SW16)(*ptr&0x3))<<12;       ptr++;
                    vec.y |= ((SW16)*ptr)<<4;             ptr++;
                    vec.y |= ((SW16)(*ptr&0xf0))>>4;
                }
                break;
        }

      /* Update character bounding box */

        if(vec.x < xmin) xmin = vec.x;
        if(vec.x > xmax) xmax = vec.x;
        if(vec.y < ymin) ymin = vec.y;
        if(vec.y > ymax) ymax = vec.y;

        *cv++ = prev_vec = vec;

      /* Set shifts and mask for next coordinate to be expanded */

        if(flag) {
            if(ord) {
                ord = 0;
                vcmask = 0xe0;
                f1mask = 0x10;
                f2mask = 0xc;
                vcshift = 4;
                f2shift = 2;
            }
            else {
                ord = 4;
                vcmask = 0xe;
                f1mask = 0x1;
                f2mask = 0xc0;
                vcshift = 0;
                f2shift = 6;
            }
        }

    }
    if(ord)
        ptr++;

    if(*startvptr & 0x2)
    {
        *(vptr-1) |= 0x1;
    }
    else
        if(if_state.quality>1) cv++;        /* leave room for contact point */

    *cv = *startcv;     /* close the loop */

    *(LPUW16)(startvptr-2) = ncontact | polarity;

    dxptr = (LPSB8)ptr;                /*  added cast -ss 6/25/91  */
    dyptr = (LPSB8)ptr + ncontact;     /*  added cast -ss 6/25/91  */
    ptr += 2*ncontact;          /* set for next loop */

  /* expand contact points if there are any and quality > 1  */

    if(ncontact && (if_state.quality>1))
    {
        pub += 4*ncontact;         /* Update expansion buffer pointer      */
        expand_size += 4*ncontact; /* and total size to relect contact pts */

        vptr = startvptr;
        cv   = startcv;
        for(j=0; j<npnt; j++, cv++)
            if(V_CONTACT(*vptr++))
            {
                vec = *cv++;
                cv->x = ((vec.x + (cv+1)->x) >> 1 ) + (SW16)(*dxptr++);
                cv->y = ((vec.y + (cv+1)->y) >> 1 ) + (SW16)(*dyptr++);
            }
    }

    if_state.num_loops++;
    if(if_state.num_loops > MAX_LOOPS)
        return ERRtoo_many_loops;

  }
#ifdef DEBUG
    print_points();
#endif

  }  /* end of test for space character 10/27/82 jfd */


  /*  Character bounding box and escapement box */

    if_state.bound_box.ll.x  = xmin;
    if_state.bound_box.ll.y  = ymin;
    if_state.bound_box.ur.x  = xmax;
    if_state.bound_box.ur.y  = ymax;

    if_state.escape_box.ll.x = 2980;
    if_state.escape_box.ll.y = 5380;
    if_state.escape_box.ur.x = 2980 + sf.xescapement;
    if_state.escape_box.ur.y = 5380;

#ifdef DEBUG
    print_metric();
#endif
/*
**  Expand Skeletal Data arrays I6.2.2.1
*/
  return build_skel_tables((LPSB8)pub);
}
#endif  /* SLIM_FONTS */

#endif  /* IF_RDR */

#ifdef STATS
#if defined (ANSI_DEFS)
GLOBAL VOID load_char_stats(LPUW16 p_stats)
#else
GLOBAL VOID
load_char_stats(p_stats)
      LPUW16 p_stats;
#endif
{
   PCTREE ctree;
   LPSB8  p;
   UW16  i;
   UW16  ncntr_pts;
   UW16  naux_pts;

   ncntr_pts = 0;
   naux_pts = 0;

   ctree = if_state.ctree;
   if (!ctree)
   {
      ncntr_pts = 0;  /* no tree segment exists (must be US font) */
      naux_pts  = 0;  /* no tree segment exists (must be US font) */
   }
   else
   {
      for (i=0; i<if_state.num_loops; i++)
      {
         p = if_state.char_buf + ctree->xyoff;
         ctree++;
         ncntr_pts += *(LPSW16)p;   p += 2;
         naux_pts  += *(LPSW16)p;   p += 2;
      }
   }

   p_stats[0] = (UW16)ncntr_pts;     /* number of contour points */
   p_stats[1] = (UW16)naux_pts;      /* number of auxiliary points */
   p_stats[2] = (UW16)if_state.num_loops;   /* number of loops */
   p_stats[3] = (UW16)combined_size; /* character buff + expand buff */

   /* local data */

   p_stats[4] = (UW16)if_state.num_yclass_ass;
   p_stats[5] = (UW16)if_state.num_yclass_def;

   /* global data */

   p_stats[6] = (UW16)if_state.num_gylines;
   p_stats[7] = (UW16)if_state.glob_yclass.num_yclass_def;
   p_stats[8] = (UW16)if_state.glob_x_dim.num_dim;
   p_stats[9] = (UW16)if_state.glob_y_dim.num_dim;

   /* XY skeletal data */

   p_stats[10] = (UW16)if_state.xskel.num_skel;
   p_stats[11] = (UW16)if_state.xskel.num_trees;
   p_stats[12] = (UW16)if_state.xskel.num_nodes;
   p_stats[13] = (UW16)if_state.xskel.tot_num_intrp_assoc;

   p_stats[14] = (UW16)if_state.yskel.num_skel;
   p_stats[15] = (UW16)if_state.yskel.num_trees;
   p_stats[16] = (UW16)if_state.yskel.num_nodes;
   p_stats[17] = (UW16)if_state.yskel.tot_num_intrp_assoc;

   p_stats[18] = (UW16)exp_size;
   return;

}
#endif
