; /* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
; * by Bayer Corp., Agfa Division, Wilmington, MA.
; *
; * This software is furnished under a license and may be used and
; * copied only in accordance with the terms of such license and with
; * the inclusion of the above copyright notice. This software or any
; * other copies thereof may not be provided or otherwise made
; * available to any other person except as allowed under license. No
; * title to and ownership of the software is hereby transferred.
; *
; * This information in this software is subject to change without notice
; */
; /* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/imath.asm,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
; /* $Log: imath.asm,v $
; /* Revision 1.2  2003/05/07 23:02:25  Lann
; /* Revision V1_00_02
; /*
; /* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
; /* First Release Version
; /* 
;  
;     Rev 1.4   06 Apr 1995 15:12:08   LISA
;  
;  Changed copyright from Miles Inc. to Bayer Corp.
;  
;     Rev 1.3   22 Apr 1994 09:32:36   LISA
;  
;  Made modifications to copyright/disclaimer notice for 1994.
;  
;     Rev 1.2   15 Jan 1993 09:27:26   LISA
;  Removed CtrlZ character from end of file
;  
;     Rev 1.1   14 Dec 1992 09:35:48   LISA
;  Made change to Log keyword
;  
;     Rev 1.0   10 Dec 1992 09:07:30   LISA
;  Initial revision.
; */
; /* $Date: 2003/05/07 23:02:25 $ */
	page	,132
	title	imath.asm  - math routines in assembly 
;*************************************************************************
; imath.asm                                                         
;
; 
; 
;*************************************************************************
;
; This module is an optimized assembly language version of imath.c.
;
; This module must be assembled with Microsoft masm 5.1.  The C structures
; and code are included in comments to aid porting to other assemblers.
; The starting file was obtained by compiling the c file with the Microsoft
; c compiler 6.00A using the following switches:
;
;     cl -c -W4 -Faimath.asm -AL -G2 -Oxarz /DMSC imath.c
;
; The resulting code was then highly optimized.
;
;*************************************************************************
; REVISION HISTORY
; ----------------
; 11/08/91  rs	Original file created from 'c' version and optimized.
;		Certain constructs & help obtained from version 1.4 imath.asm.
; 11/11/91  rs	Broke 'cg_scale()' off from des2bm() and included here.
; 03/05/92  jfd Fix for nxy() so that it produces same bitmap as IMATH.C.
; 03/09/92  dET reverse order in cg_scale, scale 1st, rotate 2nd.
;*************************************************************************
;
;	Static Name Aliases
;
	.xlist
	include model.inc
	include	cmacros.inc
	include cgconfig.inc
        include if_type.inc
	.list
	.286p
	.287
INCLUDELIB	LLIBCE
IMATH_TEXT	SEGMENT  WORD PUBLIC 'CODE'
IMATH_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT  WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST, _BSS, _DATA
	ASSUME DS: DGROUP, SS: DGROUP
EXTRN	__aFldiv:FAR
EXTRN	_if_state:BYTE
EXTRN	_x_tran:BYTE
EXTRN	_y_tran:BYTE
IMATH_TEXT      SEGMENT
	ASSUME	CS: IMATH_TEXT
IMATH_TEXT      ENDS
CONST      SEGMENT
$T20002	DW SEG _y_tran 
$T20004	DW SEG _x_tran 
CONST      ENDS
IMATH_TEXT      SEGMENT
	ASSUME	CS: IMATH_TEXT


IFDEF SMALL
vx	equ	bp+4
vy	equ	bp+6
ELSE
vx	equ	bp+6
vy	equ	bp+8
ENDIF

	PUBLIC	_nxy
IFDEF SMALL
_nxy	PROC NEAR
ELSE
_nxy	PROC FAR
ENDIF
	push	bp		; save bp
	mov	bp,sp		; point to caller's params
;
;	v = 6 : bp+6 -> v.x, bp+8 -> v.y
;

; GLOBAL WORDVECTOR nxy (WORDVECTOR v)
;
; {
;    WORDVECTOR new;
;    LONG       x, y;
;
;
; new.x = v.x - x_tran.old0;
;
	mov	ax,WORD PTR [vx]	; v.x
	mov	es,WORD PTR $T20004	; seg x_tran
	sub	ax,WORD PTR es:_x_tran.old0; v.x - x_tran.old0  +4
;
; if (new.x == 0)
;
	jne	$I340			; .ne. -> new.x != 0
;
;   new.x = x_tran.new0;
;
	mov	ax,WORD PTR es:_x_tran.new0; x_tran.new0 +6
	jmp	SHORT $I341		;
$I340:
;
; new.x != 0
;
;else
;{
;    x = (LONG)(new.x) * (LONG)x_tran.num;
;    if (x > 0)
;        new.x = (WORD)((x + x_tran.half_den) / x_tran.den) + x_tran.new0;
;    else
;        new.x = (WORD)((x - x_tran.half_den) / x_tran.den) + x_tran.new0;
;}
;
	imul	WORD PTR es:_x_tran.num ; new.x * x_tran.num  +0
	or	dx,dx			; is x > 0?
	jl	$I342			; .l. -> no
	jg	$L20003			; .g. -> yes
	or	ax,ax			; maybe
	je	$I342			; .e. -> no
;
; x > 0
;    new.x = (WORD)((x + x_tran.half_den) / x_tran.den) + x_tran.new0;
;
$L20003:
;;	add	ax,WORD PTR es:_x_tran.half_den; x + x_tran.half_den (lsw) +8
;;	adc	dx,0			;                     (msw)
        mov     bx,dx
        mov     cx,ax
        mov     ax,WORD PTR es:_x_tran.half_den
        cwd
        add     ax,cx
        adc     dx,bx
	jmp	SHORT $L20007		; continue
;
; x <= 0
;    new.x = (WORD)((x - x_tran.half_den) / x_tran.den) + x_tran.new0;
;
$I342:
;;	sub	ax,WORD PTR es:_x_tran.half_den; x - x_tran.half_den (lsw) +8
;;	sbb	dx,0			;                     (msw)
        mov     bx,dx
        mov     cx,ax
        mov     ax,WORD PTR es:_x_tran.half_den
        cwd
        xchg    bx,dx
        xchg    cx,ax
        sub     ax,cx
        sbb     dx,bx
;
$L20007:
	idiv	WORD PTR es:_x_tran.den	; / x_tran.den   +2
	add	ax,WORD PTR es:_x_tran.new0; + x_tran.new0  +6
$I341:
;;	mov	cx,ax			; save result new.x
        push    si
        mov     si,ax                   ; save result new.x
;
; Perform the 'y' side of the computations...
;
; new.y = v.y - y_tran.old0;
;
	mov	ax,WORD PTR [vy]	; v.y
	mov	es,WORD PTR $T20002	; seg y_tran
	sub	ax,WORD PTR es:_y_tran.old0; v.y - y_tran.old0 +4
;
; if (new.y == 0)
;
	jne	$I344			; .ne. -> new.y != 0
;
; new.y == 0
;   new.y = y_tran.new0
;
	mov	dx,WORD PTR es:_y_tran.new0; y_tran.new0 +6
	jmp	short _nxy_xx2		; clean up and exit
;
; new.y != 0
;else
;{
;    y = (LONG)(new.y) * (LONG)y_tran.num;
;    if (y > 0)
;        new.y = (WORD)((y + y_tran.half_den) / y_tran.den) + y_tran.new0;
;    else
;        new.y = (WORD)((y - y_tran.half_den) / y_tran.den) + y_tran.new0;
;}
$I344:
	imul	WORD PTR es:_y_tran.num	; new.y * y_tran.num +0
	or	dx,dx			; is y > 0?
	jl	$I346			; .l. -> no
	jg	$L20006			; .g. -> yes
	or	ax,ax			; maybe?
	je	$I346			; .e. -> no
;
; y > 0
;  new.y = (WORD)((y + y_tran.half_den) / y_tran.den) + y_tran.new0;
;
$L20006:
;;	add	ax,WORD PTR es:_y_tran.half_den; y + y_tran.half_den (lsw) +8
;;	adc	dx,0			;                            (msw)
        mov     bx,dx
        mov     cx,ax
        mov     ax,WORD PTR es:_y_tran.half_den
        cwd
        add     ax,cx
        adc     dx,bx
	jmp	SHORT $L20008		; continue
;
; y <= 0
;  new.y = (WORD)((y - y_tran.half_den) / y_tran.den) + y_tran.new0;
;
$I346:
;;	sub	ax,WORD PTR es:_y_tran.half_den; y - y_tran.half_den (lsw) +8
;;	sbb	dx,0			;                            (msw)
        mov     bx,dx
        mov     cx,ax
        mov     ax,WORD PTR es:_y_tran.half_den
        cwd
        xchg    bx,dx
        xchg    cx,ax
        sub     ax,cx
        sbb     dx,bx
;
$L20008:
	idiv	WORD PTR es:_y_tran.den	; / y_tran.den +2
	add	ax,WORD PTR es:_y_tran.new0; + y_tran.new0 +6
;
; Prepare new.y for return
;
	mov	dx,ax			; new.y for return value
;
; get new.x return value and exit (dx contains nx.y)
;
_nxy_xx2:
;;	mov	ax,cx			; get result new.x
        mov     ax,si                   ; get result new.x
        pop     si
	pop	bp			; restore caller's bp
	ret				; return (new) : end of nxy()

_nxy	ENDP
;


IFDEF SMALL
Axx	equ	bp+4
Ayy	equ	bp+6
Azz	equ	bp+8
ELSE
Axx	equ	bp+6
Ayy	equ	bp+8
Azz	equ	bp+10
ENDIF

PUBLIC	_scale_iii
IFDEF SMALL
_scale_iii	PROC NEAR
ELSE
_scale_iii	PROC FAR
ENDIF
	push	bp			; save caller's bp
	mov	bp,sp			; get ptr to caller's params
;
;	x = 6
;	y = 8
;	z = 10
;
	mov	ax,WORD PTR [Ayy]	;y
	imul	WORD PTR [Axx]		;x
	idiv	WORD PTR [Azz]		;z
;
; sp was not changed in this function, just pop the 'bp' and go
;
	pop	bp			; restore caller's bp
	ret	

_scale_iii	ENDP


;
; This function 'cg_scale()' was broken off from 'des2bm()' and included
; here in order to optimize for speed.
;
; Uses stack argument defines from above for '_nxy()'.
;
; WORDVECTOR cg_scale (v)
; WORDVECTOR v;
; {
;  WORD        xx, yy;
;  WORDVECTOR  new;
;
	PUBLIC	_cg_scale
IFDEF SMALL
_cg_scale	PROC NEAR
ELSE
_cg_scale	PROC FAR
ENDIF

	push	bp			; save caller's bp (faster then enter)
	mov	bp,sp			; get ptr to caller's params

	mov	ax,SEG _if_state       ; get seg of 'if_state'
	mov	es,ax			;  "

	mov	dx,WORD PTR [vy]	; dx = v.x
	sub	ax,ax                   ; (ULONG)v.y << 16) in dx:ax 

; NOTICE that the 'yy' is calculated first so that when the 'xx' is
; calculated it will already be in the proper register
;
; if (v.y < 0)
;       yy = -((  (UWORD)(  ((ULONG)-v.y << 16)  / if_state.y.p_pixel
;                      ) + if_state.y.shift_rnd
;             ) >> if_state.y.shift);
;
	or	dx,dx			; v.y < 0?
        jge	$I536

	neg	dx                      ; (ULONG)-v.y << 16) in dx:ax
	div	WORD PTR es:_if_state.y.p_pixel; / if_state.y.p_pixel +72
	add	ax,WORD PTR es:_if_state.y.shift_rnd	; + if_state.y.shift_rnd +136
	mov	cl,BYTE PTR es:_if_state.y.shift	; >> if_state.y.shift +134
	shr	ax,cl			;   "
	neg	ax
	jmp	SHORT $L20010
$I536:
; else
;  yy = (  (UWORD)(  ((ULONG)v.y << 16)  / if_state.y.p_pixel
;                 ) + if_state.y.shift_rnd
;        ) >> if_state.y.shift;
                                        ;(ULONG)v.y << 16) in dx:ax
	div	WORD PTR es:_if_state.y.p_pixel; / if_state.y.p_pixel +72
	add	ax,WORD PTR es:_if_state.y.shift_rnd	; + if_state.y.shift_rnd +136
	mov	cl,BYTE PTR es:_if_state.y.shift	; >> if_state.y.shift +134
	shr	ax,cl			;   "

$L20010:


        mov     bx,ax                   ; bx = yy   save for later
        mov     dx,WORD PTR [vx]        ; load up xx
        sub     ax,ax                   ;(ULONG)v.x << 16) in dx:ax

; if (v.x < 0)
;   xx = -((  (UWORD)(  ((ULONG)-v.x << 16)  / if_state.x.p_pixel
;                    ) + if_state.x.shift_rnd
;             ) >> if_state.x.shift);
;
; 
	or	dx,dx			; v.x < 0?
	jge	$I372			; .ge. -> no
;
	neg	dx                      ; -v.x
	div	WORD PTR es:_if_state.x.p_pixel	; / if_state.x.p_pixel +2
	add	ax,WORD PTR es:_if_state.x.shift_rnd	; + if_state.x.shift_rnd +66
	mov	cl,BYTE PTR es:_if_state.x.shift	; >> if_state.x.shift +64
	shr	ax,cl			;    "
	neg	ax			;  -
	jmp	SHORT $L20009
;
$I372:
;
;   else /* xx >= 0 */
;       xx = (  (UWORD)(  ((ULONG)v.x << 16)  / if_state.x.p_pixel
;                      ) + if_state.x.shift_rnd
;             ) >> if_state.x.shift;

	div	WORD PTR es:_if_state.x.p_pixel	; / if_state.x.p_pixel +2
	add	ax,WORD PTR es:_if_state.x.shift_rnd	; + if_state.x.shift_rnd +66
	mov	cl,BYTE PTR es:_if_state.x.shift	; >> if_state.x.shift +64
	shr	ax,cl			;    "
$L20009:
;

;  ax = xx   and bx = yy  and we want dx:ax to be yy:xx

        mov     dx,bx
        
	mov	bx,WORD PTR es:_if_state.quadrant ; if_state.quadrant +178
        
;    else if(if_state.quadrant == ROT0)
;       new.x = xx;
;       new.y = yy;
;
        cmp	bx, ROT0
        jne	$I538

;       dx:ax   all ready set up

        jmp	SHORT $L20011

$I538:
;    else if(if_state.quadrant == ROT90)
;       new.x = -yy;
;       new.y =  xx;
;
	cmp	bx, ROT90
	jne	$I540

        xchg    dx,ax
        neg     ax

	jmp	SHORT $L20011

$I540:
;    else if(if_state.quadrant == ROT180)
;       new.x =  -xx;
;       new.y =  -yy;
;
	cmp	bx, ROT180
	jne	$I542

	neg	ax
	neg	dx
	jmp	SHORT $L20011

$I542:
;    else if(if_state.quadrant == ROT270)
;       new.x =  yy;
;       new.y = -xx;
;
	cmp	bx, ROT270
        jne	$I544

        xchg    dx,ax
        neg     dx
	jmp	SHORT $L20011

$I544:
;    if(if_state.quadrant == -ROT0)    /* Next 4: mirror about y axis first */
;       new.x = -xx;
;       new.y =  yy;
	cmp	bx, -ROT0
        jne	$I545

        neg     ax
	jmp	SHORT $L20011

$I545:
;    else if(if_state.quadrant == -ROT90)
;       new.x = -yy;
;       new.y = -xx;
;
	cmp	bx, -ROT90
        jne	$I547

        xchg    dx,ax
        neg     dx
        neg	ax
	jmp	SHORT $L20011

$I547:
;
;    else if(if_state.quadrant == -ROT180)
;       new.x =  xx;
;       new.y = -yy;
;
        cmp     bx, -ROT180
	jne	$I549

        neg     dx
	jmp	SHORT $L20011

$I549:
;
;    else if(if_state.quadrant == -ROT270)
;       new.x = yy;
;       new.y = xx;
;
        cmp     bx, -ROT270
	jne	$I551
        xchg    dx,ax
$I551:
$L20011:



; 
;    new.x += if_state.tt.x;
;    new.y += if_state.tt.y;

        add     ax, WORD PTR es:_if_state.tt.xx
        add     dx, WORD PTR es:_if_state.tt.yy

; We did not change 'sp' so no need to fix it. just restore caller's 'bp'
; This is faster than using 'leave'!
;
	pop	bp			; restore caller's bp
	ret				; return (new)

_cg_scale	ENDP

IMATH_TEXT	ENDS
END

