/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/ital.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: ital.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   06 Apr 1995 15:10:58   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 09:28:20   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.3   12 Feb 1993 11:38:06   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 11:04:56   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:35:14   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:44   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* ital.c */
/*
 *
 *
 *
 * HISTORY:
 * 
 *  30-Jan-91  dET  Added function prototyping for MSC.
 *  31-Jan-91  dET  multi-model compilation for MSC.
 *   8_Feb-91  awr  Made x_skel[] and y_skel[] parameters instead of
 *                  EXTERNs
 *   2-Jun-91  awr  HQ4 changes
 *  17-Jun-91  jfd  Moved "debug.h" after "port.h".
 *                  Added "cgconfig.h" before "port.h".
 *  24-Aug-91  awr  Moved function decls to include file
 *  04-Mar-92  tbh  Added .baseproj to support standard STANDARD dimensions
 *  03-Apr-92  rs   Portability cleanup (see port.h).
 *   6 May 92  ss   Added casts in italic() to help porting.
 *  15-Sep-92 jfd  Conditionally compile entire module based on IF_RDR.
 *  17-Nov-92 rs    Mac port -> rename italic() -> cgitalic().
 *  07-Jan-93 jfd   ANSI C function declaration changes.
 *  08-Feb-93 jfd   VXWorks support.
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include "cgconfig.h"
#include "port.h"

#if IF_RDR

#include "debug.h"
#include "ifmem.h"
#include "cgif.h"
#include "ix.h"
#include "if_type.h"
#include "segments.h"
#include "adj_skel.h"

EXTERN  IF_STATE if_state;

#if defined (ANSI_DEFS)
GLOBAL VOID  cgitalic(PADJUSTED_SKEL x_skel, PADJUSTED_SKEL y_skel)
#else
GLOBAL VOID
cgitalic(x_skel, y_skel)
    PADJUSTED_SKEL  x_skel;
    PADJUSTED_SKEL  y_skel;
#endif
{
    PADJUSTED_SKEL xskel;
    PADJUSTED_SKEL yskel;

    LPUB8 x_num_skel_loop;
    LPUB8 y_num_skel_loop;

    LPUW16 x_skel_to_contr;
    LPUW16 y_skel_to_contr;

    UW16  loopct;
    LOOP   loop;

    UW16  x_vecnum;
    UW16  y_vecnum;

    SW16  x_nsk;      /*  Number of skeletal points in loop */
    SW16  y_nsk;
    SW16  xnum;       /*  Number of skel pts processed so far */
    SW16  ynum;

    SW16  yold,  ynew;
    SW16  yold0, yold1, yold_first;
    SW16  ynew0, ynew1, ynew_first;
    SW16  num, den;
    SW16  xadj;


    DBG("cgitalic()\n");

    xskel = x_skel;
    yskel = y_skel;

         /* added casts, seems to help with assignment on SPARC -ss 5/6/92 */
    x_num_skel_loop = (LPUB8)if_state.xskel.num_skel_loop;
    y_num_skel_loop = (LPUB8)if_state.yskel.num_skel_loop;

    x_skel_to_contr = if_state.xskel.skel_to_contr;
    y_skel_to_contr = if_state.yskel.skel_to_contr;

    x_vecnum = *x_skel_to_contr++;

    /*  For each loop in the character */
    first_loop();
    for(loopct = 0; loopct < if_state.num_loops; loopct++)
    {
        next_loop(&loop);

        x_nsk = *(x_num_skel_loop++);
        y_nsk = *(y_num_skel_loop++);
        DBG3("loop %d has %d xskels and %d yskels\n", loopct, x_nsk, y_nsk);

        xnum  = 0;
        
        yold_first = yskel->original;
        ynew_first = yskel->adjusted;

        yold1 = (yskel + y_nsk - 1)->original;
        ynew1 = (yskel + y_nsk - 1)->adjusted;

        DBG1("\n    0th yskel pair has start index y_vecnum = %d\n",
                                           *(y_skel_to_contr + y_nsk - 1));

      /*  For each y skel scaling segment in this loop  */

        for(ynum=0; ynum<=y_nsk; ynum++)
        {
          /*  Next pair of y skeletal points along loop  */

            yold0 = yold1;
            ynew0 = ynew1;

          /*  If at end of loop, the last y skeletal is the first  */

            if(ynum == y_nsk)
            {
                y_vecnum = loop.ncoords; /* To stop x at the end of loop */
                yold1 = yold_first;
                ynew1 = ynew_first;
            }
            else
            {
                y_vecnum = *y_skel_to_contr++;
                yold1 = yskel->original;
                ynew1 = yskel->adjusted;
                yskel++;
            }
            DBG2("\n    %dth yskel pair has ending index y_vecnum = %d\n",
                                                            ynum, y_vecnum);
            DBG2("    yold0, yold1 %d %d\n", yold0, yold1);
            DBG2("    ynew0, ynew1 %d %d\n", ynew0, ynew1);

            num = ynew1 - ynew0;
            den = yold1 - yold0;
            DBG2("    num, den%d %d\n", num, den);

            while((x_vecnum < y_vecnum) && (xnum<x_nsk))
            {
                DBG2("\n        %dth xskel has index x_vecnum = %d\n",
                                                         xnum, x_vecnum);

                yold = (loop.cv + x_vecnum)->y;

              /*  Scale y coordinate of this x skeletal */
                if(den)
                    ynew = (SW16)(((SL32)(yold - yold0)*(SL32)num)
                                                           /den) + ynew0;
                else
                    ynew = yold - yold0 + ynew0;
                DBG2("        yold, ynew   %d %d\n", yold, ynew);

              /*  Adjust x coordinate based on angle */
                if(if_state.glob_ital_ang && !if_state.italic_flag)
                {
                    DBG1("        Adjust by global %d\n", if_state.glob_ital_ang);
                    xadj = (SW16)
                         (
                           (
                               ( (SL32)if_state.glob_ital_ang * (SL32)ynew ) -
                                 ( (SL32)yold * (SL32)if_state.loc_ital_ang )
                           ) >> 15
                         );
                }
                else
                {
                    DBG1("        Adjust by local %d\n", if_state.loc_ital_ang);
                    xadj = (SW16)
                         (
                           ((SL32)if_state.loc_ital_ang * (SL32)(ynew - yold)) >> 15
                         );
                }
                DBG1("        xadj = %d\n", xadj);
                xskel->intermed += xadj;
                xskel->adjusted = xskel->intermed;
              /* project coord to baseline ! */
                xskel->baseproj -= (SW16)(((SL32)yold * (SL32)if_state.loc_ital_ang) >> 15);

              /*  Bump to next x skeletal */

                xnum++;
                x_vecnum = *x_skel_to_contr++;
                xskel++;
            }
        }
    }
}
#endif  /* IF_RDR */
