; /* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
; * by Bayer Corp., Agfa Division, Wilmington, MA.
; *
; * This software is furnished under a license and may be used and
; * copied only in accordance with the terms of such license and with
; * the inclusion of the above copyright notice. This software or any
; * other copies thereof may not be provided or otherwise made
; * available to any other person except as allowed under license. No
; * title to and ownership of the software is hereby transferred.
; *
; * This information in this software is subject to change without notice
; */
; /* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/pixel_al.asm,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
; /* $Log: pixel_al.asm,v $
; /* Revision 1.2  2003/05/07 23:02:25  Lann
; /* Revision V1_00_02
; /*
; /* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
; /* First Release Version
; /* 
;  
;     Rev 1.4   06 Apr 1995 15:12:26   LISA
;  
;  Changed copyright from Miles Inc. to Bayer Corp.
;  
;     Rev 1.3   22 Apr 1994 09:33:06   LISA
;  
;  Made modifications to copyright/disclaimer notice for 1994.
;  
;     Rev 1.2   15 Jan 1993 09:27:52   LISA
;  Removed CtrlZ character from end of file
;  
;     Rev 1.1   14 Dec 1992 09:35:26   LISA
;  Made change to Log keyword
;  
;     Rev 1.0   10 Dec 1992 09:07:28   LISA
;  Initial revision.
; */
; /* $Date: 2003/05/07 23:02:25 $ */
	page	,132
	title	pixel_al.asm -  align pixels
;**********************************************************************
;    pixel_al.asm                                                   
;    -------------------------------------------------------------    
; 
; 
;*********************************************************************
;
;  This module recodes pixel_al.c routines in assembly
;  language.
;
;  This module must be assebled with Microsoft masm 5.1.  The C structures
;  and code are included in comments to aid porting to other assemblers.
;  history :
; 
;  AR, SS, dET
;
; 11-20-90  dET - modify for minor optimization
;           tbh - fix for missing pixels
; 11-21-90  dET - added conditional compiler for multi-model
; 17-Feb91  dET - added include "if_type.inc" and modified corresponding code.
;

        include model.inc

	.xlist
	include	cmacros.inc
        include if_type.inc
	.list

.286

sBegin	data

externW pixel_aligned

sEnd

;-----------------------------------------------------------------
;  This routine is very dependent on the COORD_DATA structure
;   defined in if_type.h
;

sBegin	code
	assumes	cs,code
	assumes	ds,data


;------------------
;  pixel_align
;
;------------------
;/*----------------------*/
;/*   pixel_align        */
;/*----------------------*/
;GLOBAL VOID
;pixel_align(val, xy, round_i)
;    WORD val;
;    PCOORD_DATA xy;
;    WORD  round_i;
;{
;    WORD value;
;    WORD grid;
;
;    value = ABS(val);
;
;    grid = (WORD)((((LONG)value <<xy->bin_places) + xy->round[round_i])
;                          / xy->p_pixel);
;
;    if(val < 0)
;        grid = - grid;
;
;    pixel_aligned.value =
;                (WORD)(((LONG)grid * (LONG)xy->p_pixel) >> xy->bin_places);
;    pixel_aligned.grid_line = grid;
;}
;

cProc  	pixel_align,<PUBLIC>,<si>

        parmW   val
        parmD   pcxy
        parmW   round_i

cBegin
        mov     AX, val         ; get val
        cmp     AX, 0           ; ? zero 
        jge     pa1
        neg     AX              ; value = ABS(val)
pa1:
        cwd                     ; dx:ax = (LONG) ABS(val)
        les     BX, pcxy        ; ES:BX points to xy
        mov     CL, BYTE PTR ES:[BX+bin_places]
        or      CL, CL          ; zero ?
        je      pa3
pa2:
        shl     AX, 1           ; value << xy->bin_places
        rcl     DX, 1
        dec     CL
        jne     pa2
pa3:
        mov     SI, round_i     ; round[round_i]
        shl     SI, 2
        add     AX, WORD PTR ES:[BX + round][SI]         ; add low word
        adc     DX, WORD PTR ES:[BX + round + 2][SI]     ; add high word
pa5:
	mov	CX,  WORD PTR ES:[BX+p_pixel]	; xy->p_pixel
	cmp	CX, 0
	je	pa6

        idiv    CX	        ; divide by xy->p_pixel
pa6:
pa7:    cmp     val, 0          ; if(val < 0)
        jge     pa8             ; no!
        neg     AX              ;    grid = - grid;
pa8:
	push	AX              ;  save grid
        imul    WORD PTR ES:[BX+p_pixel]        ; grid * (LONG)xy->p_pixel)
        mov     CL, BYTE PTR ES:[BX+bin_places]
        or      CL, CL
        je      pa10
pa9:
        sar     DX, 1           ; >> xy->bin_places
        rcr     AX, 1
        dec     CL
        jne     pa9
pa10:

if (sizeD OR (?WIN eq 1))
	mov	BX, SEG pixel_aligned
	mov	ES, BX
        mov     WORD PTR ES:pixel_aligned, AX
	pop	AX                              ; pop grid
        mov     WORD PTR ES:pixel_aligned+2, AX ;pixel_aligned.grid_line = grid
else
	lea	BX, pixel_aligned
        mov     WORD PTR [BX], AX
	pop	AX                      ; pop grid
        mov     WORD PTR [BX+2], AX     ;pixel_aligned.grid_line = grid
endif

cEnd
sEnd
        END


