/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/pixel_al.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pixel_al.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   06 Apr 1995 15:10:58   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   22 Apr 1994 09:28:18   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.4   02 Feb 1994 09:14:32   JOE
 * 
 * Conditionally compiled function prototype for sign_l_l() based on
 * (ELASTIC_Y | ELASTIC_X).
 * 
 *    Rev 1.3   12 Feb 1993 11:43:36   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 11:34:10   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:33:58   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pixel_al.c */
/*
 *
 *
 *
 *  History:
 *
 *   11-29-90  tbh   Bug fix for missing pixels in pixel_align()
 *  30-Jan-91  dET   Add function prototyping for MSC Compiler
 *  31-Jan-91  dET   Modify for MSC multi-model compilation.
 *  17-Jun-91  jfd   Moved "debug.h" after "port.h".
 *                   Added "cgconfig.h" before "port.h".
 *   8-Jul-91  tbh   Added elasticity.
 *  24-Aug-91  awr   Moved function decls to if_type.h
 *  03-Apr-92  rs    Portability cleanup (see port.h).
 *  15-Sep-92  jfd   Conditionally compile entire module based on IF_RDR.
 *  07-Jan-93  jfd   ANSI C function declaration changes.
 *  08-Feb-93  jfd   VXWorks support.
 *  27-Jan-94  jfd   Conditionally compiled function prototype for 
 *                   sign_l_l() based on ((ELASTIC_Y) | (ELASTIC_X))
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include  <stdio.h>
#include  "cgconfig.h"
#include  "port.h"

#if IF_RDR

#include  "debug.h"
#include  "ifmem.h"
#include  "cgif.h"
#include "ix.h"
#include  "if_type.h"

#ifdef LINT_ARGS
#if ((ELASTIC_Y) | (ELASTIC_X))
MLOCAL SL32  sign_l_l (SL32, SL32);
#endif
#endif




#if ((ELASTIC_Y) | (ELASTIC_X))
MLOCAL
SL32  sign_l_l (longVal, longSign)

SL32 longVal;
SL32 longSign;

{
if (longSign >= 0L) return (  longVal);
else               return (- longVal);
}
#endif


EXTERN IF_STATE if_state;


/**********************************************************************/
/*                                                                    */
/*      pixel_align ()                                                */
/*              returns pixel aligned value for input ('val').        */
/*              The alignment process rounds input via the round      */
/*              value indexed by 'round_i' and the pixel size         */
/*              (p_pixel) pointed to by '*xy'.  Remember:             */
/*                                                                    */
/*                pixel size = p_pixel  *  ( 2 ** (-bin_places))      */
/*                                                                    */
/*              Note:  'val' may be negative !                        */
/*                                                                    */
/**********************************************************************/


#if defined (ANSI_DEFS)
GLOBAL VOID  pixel_align (SW16 val, PCOORD_DATA xy, UW16 round_i
#if ((ELASTIC_Y) | (ELASTIC_X))
    , UW16 num_elast
#endif
    )
#else
GLOBAL VOID
#if ((ELASTIC_Y) | (ELASTIC_X))
pixel_align (val, xy, round_i, num_elast)
#else
pixel_align (val, xy, round_i)
#endif

    SW16        val;
    PCOORD_DATA xy;
    UW16       round_i;

#if ((ELASTIC_Y) | (ELASTIC_X))
    UW16       num_elast;     /* numb of elastic segmnts crossed by assoc */
#endif
#endif

{
    SW16    value;
    SL32    result;

#if ((ELASTIC_Y) | (ELASTIC_X))
    SW16    pa_valu;
    SL32    limit;
#endif

    value = ABS(val);

    result = (((SL32)value <<xy->bin_places) + xy->round[round_i]) / xy->p_pixel;
    if (val < 0) result = - result;

    if_state.value = (SW16)((result * (SL32)xy->p_pixel) >> xy->bin_places);
    if_state.grid_line = (SW16)result;

    DBG4("pixel_align: val = %d  round_i = %d  new val = %d   grid = %d\n",
               val, round_i, if_state.value, if_state.grid_line);


#if ((ELASTIC_Y) | (ELASTIC_X))
/*      
if elastic seg, add elastic input + remndr from previous elastic seg */
if (xy->elastic_input && num_elast) 
    {

    DBG1("pixel_align: remainder = %d\n\r",if_state.remainder);

    result =  sign_l_l ((SL32)if_state.value, (SL32)val); 

    if (result < (SL32)0) limit = -((-result) << xy->bin_places);
    else             limit = (SL32)0;



    result += (SL32)( ((SW16)num_elast * xy->elastic_input) + if_state.remainder) ;
    if (result < 0) result = -((-result) << xy->bin_places);
    else            result <<= xy->bin_places;
    if (result < limit) result = limit;

    result += sign_l_l (xy->round[R_TWO_I], result);

    if_state.grid_line = (SW16)(result / xy->p_pixel);
    pa_valu = (SW16)(((SL32)if_state.grid_line * (SL32)xy->p_pixel) >> xy->bin_places);

    if_state.remainder = 
         - (pa_valu 
         - (SW16)((result - sign_l_l(xy->round[R_TWO_I],result)) >> xy->bin_places));
    if_state.value = pa_valu;

    if (val < 0)
      {
      if_state.value =     - if_state.value;
      if_state.grid_line = - if_state.grid_line;
      }

    DBG4("pixel_align: num_elast = %d, elastic_input = %d, value = %d, remainder = %d\n\r",
             num_elast,xy->elastic_input,pa_valu,if_state.remainder);

    }
#endif

}




#if defined (ANSI_DEFS)
GLOBAL VOID  sd_pixel_align(SW16 val, PCOORD_DATA xy, UW16 round_i
#if ((ELASTIC_Y) | (ELASTIC_X))
    , UW16 num_elast
#endif
    )
#else
GLOBAL VOID
#if ((ELASTIC_Y) | (ELASTIC_X))
sd_pixel_align(val, xy, round_i, num_elast)
#else
sd_pixel_align(val, xy, round_i)
#endif

    SW16        val;
    PCOORD_DATA xy;
    UW16       round_i;

#if ((ELASTIC_Y) | (ELASTIC_X))
    UW16       num_elast;     /* numb of elastic segmnts crossed by assoc */
#endif
#endif

{
    SW16    value;
    SW16    half_pix;

    value = ABS(val);
    half_pix  = xy->p_half_pix >> xy->bin_places;

/*
if this is standard dim process, (and val is significantly non-zero) ..   */
#if ((ELASTIC_Y) | (ELASTIC_X))
if ((value > half_pix) && ! num_elast)
#else
if (value > half_pix)
#endif

    {

/*  value is difference between input val and standard dimension          */
    value = ABS(value - xy->stand_value);

/*  if value is within one half pixel of standard dimension . . .         */
    if (value <= half_pix)
        {
/*      . . aligned value is equal to aligned standard dimension !        */
            if_state.value     =  xy->st_value[round_i];
            if_state.grid_line =  xy->st_pixels[round_i];
    
/*          aligned data must have same sign as val                       */
            if(val < 0)
            {
                if_state.value     = -if_state.value;
                if_state.grid_line = -if_state.grid_line;
            }

            DBG4("sd_pixel_align: val = %d  round_i = %d  new val = %d   grid = %d\n",
               val, round_i, if_state.value, if_state.grid_line);
        }

/*  otherwise, do normal grid alignment */
    else   pixel_align (
                       val, 
                       xy, 
                       round_i

#if ((ELASTIC_Y) | (ELASTIC_X))
                       , num_elast
#endif
                       );
    }

/*
otherwise, do normal grid alignment */
else   pixel_align (
                   val, 
                   xy, 
                   round_i

#if ((ELASTIC_Y) | (ELASTIC_X))
                   , num_elast
#endif
                   );

}
#endif  /* IF_RDR */


