/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/skeletal.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: skeletal.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   06 Apr 1995 15:10:54   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 09:28:14   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.6   02 Feb 1994 09:07:42   JOE
 * 
 * In skel_proc(), check for if_state.stan_dim_lim != 0 before processing
 * with standard dimensions.
 * 
 *    Rev 1.5   12 Feb 1993 11:31:24   JOE
 * VXWorks support.
 * 
 *    Rev 1.4   14 Jan 1993 11:28:56   MIKE
 * Corrected non-ANSI function declaration for hq3_assoc_proc
 * 
 *    Rev 1.3   07 Jan 1993 15:29:14   JOE
 * Corrected ANSI function declaration for hq3_assoc_proc().
 * 
 *    Rev 1.2   07 Jan 1993 10:54:04   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:36:02   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:32   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* skeletal.c */


/*  17-May-89  awr  Cloned from if 2.11 skeletal.c
    05-Oct-90  awr  added root adjust parameter to skel_proc() for
                    connecting characters
    29-Nov-90  tbh  Missing pixel fix in skel_proc()
    31-Jan-91  dET  Modify for MSC multi-model compilation.
    17-Jun-91  jfd  Moved "debug.h" after "port.h".
                    Added "cgconfig.h" before "port.h".
     8-Jul-91  tbh  Added elasticity.
     1-Aug-91  tbh  changed COUNTER to UCOUNTER
                    Made *pix_al_ptr declaration consistent regardless 
                    of ELASTICITY definition.
                    Made pix UWORD.
    24-Aug-91  awr  Moved function decls to include file
     1 Nov 91  ss   Changed declarations of pix_al_ptr from WORD to VOID
                    to match the declares of the functions assigned to it.
    11-Dec-91  tbh  In skel_proc(), removed the effect of st_variation.
    09-Jan-92  tbh  In skel_proc(), removed lines of code which test if
                    skeletal point is not yet aligned, not terminal,
                    but processed (because condition was never true).
                    In hq3_assoc_proc(), when collapsing association to
                    zero, added calculation for "skel[assoc_i].pixel_grid_line".
    12-mar-92  tbh  removed *ps_proc and *grid and updated diagonal control and standard
                    STANDARD dimension processing.
                    Reorganized tree process so tree_proc aligns roots and 
                    distributes to assocs, while hq3_assoc_proc does all alignment and assoc
                    manipulation.
    17-Aug-92  jfd  In hq3_assoc_proc(), initialized result to 0.
    15-Sep-92  jfd  Conditionally compile enture module based on IF_RDR.
    03-Oct-92  rs   Changes toward ANSI C - declaration of hq3_assoc_proc().
    03-Nov-92  tbh  In skel_proc(), reset "xy->stand_value" to 
                    "curr_stan_value" when done.
    07-Jan-93  jfd  ANSI C function declaration changes.
                    Corrected ANSI function declaration for hq3_assoc_proc().
    08-Feb-93  jfd  VXWorks support.
    28-Jan-94  jfd  In skel_proc(), check for if_state.stan_dim_lim != 0
                    before processing with standard dimensions.


----------------------------------------------------------------------*/

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include  <stdio.h>
#include  "cgconfig.h"
#include  "port.h"

#if IF_RDR

#include  "debug.h"
#include  "ifmem.h"
#include  "cgif.h"
#include "ix.h"
#include  "if_type.h"
#include  "segments.h"
#include  "adj_skel.h"


#define ALIGN_MASK      0x08    /*  alignment attribute mask: bit 3   */
#define R_TYPE_MASK     0x03    /*  value to mask for "R" types       */
#define HQ3_RTZ_MASK  0x04    /*  round-to-zero attrib mask: bit 2  */
#define HQ3_CON_MASK    0x10    /*  constrained dimension mask (HQ3)  */
#define STAN_DIM_OFF    0x00    /* 11-29-90 tbh                       */
#define STAN_DIM_ON     0x01    /* 11-29-90 tbh                       */


#if 0
#define NO_STANDARD_DIM 0xffff  /*  id for none .standard_value       */
#define DIM_NOT_PROC    -2      /*  status: dimension not processed   */
#define HQ2             2       /*  HQ2 data format                   */
#define HQ3             3       /*  HQ3 data format                   */
#endif

MLOCAL UW16    pix;            /*  pixel size in design units        */


#ifdef LINT_ARGS
#if ((ELASTIC_Y) | (ELASTIC_X))
MLOCAL VOID       (*pix_al_ptr)(SW16, PCOORD_DATA, UW16, UW16); /* ptr to pixel_align()*/
#else
MLOCAL VOID       (*pix_al_ptr)(SW16, PCOORD_DATA, UW16); /* ptr to pixel_align()*/
#endif
MLOCAL VOID       hq3_assoc_proc(UB8, UB8, UB8, PADJUSTED_SKEL, PCOORD_DATA);
MLOCAL BOOLEAN    interp_assoc_proc (PSKEL, PADJUSTED_SKEL);

#else
MLOCAL VOID       (*pix_al_ptr)();   /* ptr to pixel_align() function      */

#endif
EXTERN IF_STATE if_state;
MLOCAL UB8 stan_dim_option;  /* *** */
MLOCAL SW16  curr_stan_value;  /* *** */



/**********************************************************************/
/*                                                                    */
/*      hq3_assoc_proc ( assoc_i, skel_i, attribute )                 */
/*              adjusts associated point "assoc_i" by an amount equal */
/*              to that used to adjust its skeletal point "skel_i".   */
/*                                                                    */
/**********************************************************************/

#if ((defined (__STDC__) && (__STDC__  > 0) && !defined(__i960)) || \
    (defined(__i960) && defined(ANSI_960))) || defined (VXWORKS)
MLOCAL VOID  hq3_assoc_proc (UB8 assoc_i, UB8 skel_i, UB8 attribute,
               PADJUSTED_SKEL skel, PCOORD_DATA xy)
#else
MLOCAL VOID  hq3_assoc_proc ( assoc_i, skel_i, attribute, skel, xy)
    UB8   assoc_i;
    UB8   skel_i;
    UB8   attribute;
    PADJUSTED_SKEL skel;
    PCOORD_DATA    xy;
#endif /* __STDC__ */
{
    SW16 adjustment;              /*  11-29-90 tbh              */
    SW16  temp;

#if ((ELASTIC_Y) | (ELASTIC_X))
    SW16   result=0, limit;
#endif

    DBG2("       hq3_assoc_proc: start assoc skel [%d] = %d\n",
                        assoc_i,
                        skel[assoc_i].adjusted);

/*  Assume r types enabled- awr */
    skel[assoc_i].round_i = attribute & R_TYPE_MASK;


/*  if this skeletal node is NOT to be ALIGNED . . */
    if (!(attribute & ALIGN_MASK))
    {

        skel [assoc_i].adjusted +=
                        skel [skel_i].adjusted - skel [skel_i].intermed;

        DBG ("      as a non-aligned assoc skel\n");
        adjustment = 0;

/*      if this assoc is within diag_control_tol of 2*standard dim, bias it to help diags ! */
        if (stan_dim_option)
          {
          temp =   skel[assoc_i].baseproj - skel[skel_i].baseproj;
          if (ABS(temp) < ((curr_stan_value << 1) + xy->diag_control_tol))
            {

            adjustment = xy->st_variation[ skel[assoc_i].round_i ];
/*          if adjustment reverses sign . .                       */
            if (temp >= 0)
              {
              if ((temp + adjustment) < 0) adjustment = -temp;
              }
            else
              {
              if ((temp - adjustment) > 0) adjustment =  temp;
              }
            }
          }

/*      rounding adjustment                                       */
        adjustment += (SW16)((xy->round[ skel[assoc_i].round_i ]
                           - (SL32)xy->p_half_pix) >> xy->bin_places);
 
#if ((ELASTIC_Y) | (ELASTIC_X))
/*      if this is an elastic assoc, incorporate elasticity !      */
        if (skel [assoc_i].num_breaks)
        {
          if (adjustment < 0) limit = adjustment;
          else                limit = 0;
          result += ((SW16)skel [assoc_i].num_breaks * xy->elastic_input)
                                       + skel[skel_i].remainder;
          if (result < limit) adjustment += limit;
          else                adjustment += result;
        }
#endif

/*      if non_aligned is to right, then add rounding bias  */
        if ( skel [assoc_i].intermed >= skel [skel_i].intermed )
        {
            skel[assoc_i].adjusted += adjustment;  
        }

/*      else, non-aligned to left, so subtract rounding bias */
        else
        {
            skel[assoc_i].adjusted -= adjustment;  
        }

#if ((ELASTIC_Y) | (ELASTIC_X))
                skel [assoc_i].remainder = 0;
#endif

    }
/*  else, this association will be ALIGNED and checked for constraint and RTZ ! */
    else
    {

#if ((ELASTIC_Y) | (ELASTIC_X))
        if_state.remainder = skel[skel_i].remainder;
#endif

        (*pix_al_ptr) (
                      skel[assoc_i].intermed - skel[skel_i].intermed,
                      xy, 
                      skel[assoc_i].round_i

#if ((ELASTIC_Y) | (ELASTIC_X))
                      ,skel[assoc_i].num_breaks
#endif
                      );

/*      if this association is "small" and "constrained"  */
        if ((ABS (if_state.value) < xy->con_size)
                && (attribute & HQ3_CON_MASK))
        {
            /* collapse it to zero */
            skel[assoc_i].adjusted = skel[skel_i].adjusted;

#if ((ELASTIC_Y) | (ELASTIC_X))
            if (skel[assoc_i].num_breaks) skel [assoc_i].remainder =
                                if_state.remainder + if_state.value;
            else skel[assoc_i].remainder = if_state.remainder;
#endif
        }

/*      else if the association rounds to zero, BUT shouldn't . .  */
        else if ((if_state.value == 0) && !(attribute & HQ3_RTZ_MASK))
        {
            DBG ("       hq3_assoc_proc: this association allowed to RTZ !\n");
/*          set the association to of one pixel */
/*          if assoc is right of skel, add      */
            if (skel[assoc_i].intermed >= skel[skel_i].intermed)
            {
                skel[assoc_i].adjusted =
                            skel[skel_i].adjusted + pix;

#if ((ELASTIC_Y) | (ELASTIC_X))
                if (skel[assoc_i].num_breaks) skel [assoc_i].remainder =
                            if_state.remainder - pix;
                else skel[assoc_i].remainder = if_state.remainder;
#endif
            }
/*          else, is left of skel, so subtract */
            else
            {
                skel[assoc_i].adjusted =
                            skel[skel_i].adjusted
                                      - pix;

#if ((ELASTIC_Y) | (ELASTIC_X))
                if (skel[assoc_i].num_breaks) skel [assoc_i].remainder =
                            if_state.remainder + pix;
                else skel[assoc_i].remainder = if_state.remainder;
#endif
            }
        }
/*      else use value returned from pixel_align () */
        else
        {
                skel[assoc_i].adjusted =
                    skel[skel_i].adjusted + if_state.value;

#if ((ELASTIC_Y) | (ELASTIC_X))
                skel[assoc_i].remainder = if_state.remainder;
#endif
        }
    }

    DBG2("       hq3_assoc_proc: end   assoc skel [%d] = %d\n",
                            assoc_i,
                            skel[assoc_i].adjusted);
}





/**********************************************************************/
/*                                                                    */
/*      interp_assoc_proc ()                                          */
/*              makes interpolated adjustments to specified skeletal  */
/*              points based on parent skeletals (previously pos-     */
/*              itioned by the tree process).                         */
/*                                                                    */
/**********************************************************************/


#if defined (ANSI_DEFS)
MLOCAL BOOLEAN interp_assoc_proc (PSKEL skel_ptr, PADJUSTED_SKEL skel)
#else
MLOCAL BOOLEAN
interp_assoc_proc (skel_ptr, skel)
    PSKEL          skel_ptr;
    PADJUSTED_SKEL skel;
#endif
{
    UCOUNTER i,j,k;
    SL32    numerator, denominator;

    k = 0;

/*  for each set of interpolated associations  */
    for (i = 0; i < skel_ptr->num_intrp; i++)
    {

/*      calculate a scale factor, and  */
        numerator =   (SL32)(skel[skel_ptr->intrp2_skel_i[i]].adjusted -
                             skel[skel_ptr->intrp1_skel_i[i]].adjusted);
        denominator = (SL32)(skel[skel_ptr->intrp2_skel_i[i]].intermed -
                             skel[skel_ptr->intrp1_skel_i[i]].intermed);
/*      if denominator is not zero  */
        if (denominator)
        {

/*          for each interp assoc in this set, scale it */
            for (j = 0; j < skel_ptr->num_intrp_assoc[i]; j++)
            {
                if (k >= skel_ptr->tot_num_intrp_assoc) return FALSE;
                skel[skel_ptr->intrp_assoc_skel_i[k]].adjusted =
                    (SW16)
                    (((SL32)(skel[skel_ptr->intrp_assoc_skel_i[k]].intermed -
                              skel[skel_ptr->intrp1_skel_i[i]].intermed)
                    * numerator) / denominator)
                    + skel[skel_ptr->intrp1_skel_i[i]].adjusted;
                k++;
            }
        }
/*      else we can not divide by zero  */
        else
        {

/*          for each interp assoc in this set, set equal to base.  */
            for (j = 0; j < skel_ptr->num_intrp_assoc[i]; j++)
            {
                if (k >= skel_ptr->tot_num_intrp_assoc) return FALSE;

                skel[skel_ptr->intrp_assoc_skel_i[k]].adjusted =
                              skel[skel_ptr->intrp1_skel_i[i]].adjusted;
                k++;
            }
        }
    }
    return TRUE;
}



/**********************************************************************/
/*                                                                    */
/*      skel_proc (option)                                            */
/*              sets up the required control parameters for the tree  */
/*              and interp assoc processes based on option (X orY).   */
/*                                                                    */
/**********************************************************************/


#if defined (ANSI_DEFS)
GLOBAL BOOLEAN skel_proc (PSKEL skel_ptr, PDIMENSION glob_dim_ptr,
    PCOORD_DATA xy, PADJUSTED_SKEL skel, SW16 root_adjust)
#else
GLOBAL BOOLEAN
skel_proc (skel_ptr, glob_dim_ptr, xy, skel, root_adjust)
    PSKEL          skel_ptr;
    PDIMENSION     glob_dim_ptr;
    PCOORD_DATA    xy;
    PADJUSTED_SKEL skel;
    SW16           root_adjust;   /* adjustment to x-values to align left ref */
#endif
{
    UW16   sk_indx;              /*  skeletal point index      */
    UW16   as_indx;              /*  associated point index    */
    COUNTER i, j;
    SW16 num_assoc;

/*  efficiency */

    UB8  skel_i;
    LPSW16  adj_skel;

#if ((ELASTIC_Y) | (ELASTIC_X))
    LPSW16  remainder;
#endif


    DBG("\n\n\n-----------------------skel_proc()------------------\n");


/**********************************************************************/
/*                                                                    */
/*      tree_proc ()                                                  */
/*              traverses the skeletal tree and processes each        */
/*              skeletal point according to its alignment attribute,  */
/*              association with other skeletal points, and           */
/*              dimensions.                                           */
/*                                                                    */
/**********************************************************************/

/*  set pointer to pixel alignment function NOT using standard dims   */

    pix_al_ptr = pixel_align;
    stan_dim_option = STAN_DIM_OFF;  /* 11-29-90 tbh */
    pix = (xy->p_pixel >> xy->bin_places);

/*  if we need to process with standard dimensions because pixel size
    size is greater than font wide cutin limit                        */

    if (pix >= if_state.stan_dim_lim && if_state.stan_dim_lim != 0) /* 1-28-94 JPK */
    {

        curr_stan_value  = glob_dim_ptr->value[skel_ptr->stan_dim_i];
 
        DBG1("Using standard dimenstions,  stan_dim_i = %d\n", skel_ptr->stan_dim_i);
        DBG1("    curr_stan_value  = %d\n", curr_stan_value);

/*      if we need to calculate the aligned standard dimension */
        if ( xy->stand_value != curr_stan_value)
        {
            xy->stand_value = curr_stan_value; /* so we don't recalc for next character */

            DBG1("    Calculating st dims. curr_stan_value = %d\n",curr_stan_value);

            for (i=0; i < 4; i++)
            {
                if ((glob_dim_ptr->stan_STAN_i != 0xff) && (pix >= if_state.stan_STAN_dim_lim))
                  {
                  pixel_align (
                              glob_dim_ptr->value[glob_dim_ptr->stan_STAN_i],
                              xy, 
                              i
#if ((ELASTIC_Y) | (ELASTIC_X))
                              ,0
#endif
                              );
                  xy->st_value[i]  = if_state.value;
                  xy->st_pixels[i] = if_state.grid_line;
                  xy->stand_value  = glob_dim_ptr->value[glob_dim_ptr->stan_STAN_i];
                  pix_al_ptr       = sd_pixel_align;
                  }

                (*pix_al_ptr) (
                            curr_stan_value, 
                            xy, 
                            i

#if ((ELASTIC_Y) | (ELASTIC_X))
                            ,0
#endif
                            );

                xy->st_value[i]  = if_state.value;
                xy->st_pixels[i] = if_state.grid_line;

                DBG3("    %d:  value %d    grid %d\n", i, xy->st_value[i],
                                                          xy->st_pixels[i]);

            }

            xy->stand_value = curr_stan_value;  /* 11-03-92 */

            xy->st_variation[0] = xy->st_value[0] - (curr_stan_value
                       + (SW16)(xy->round[0] >> xy->bin_places) - (pix >> 1));
            xy->st_variation[1] = - (xy->st_variation[0]);
            xy->st_variation[2] = 0;
            xy->st_variation[3] = 0;

        }

/*      set pointer to pixel alignment function which uses standard dims  */
        pix_al_ptr = sd_pixel_align;
        stan_dim_option = STAN_DIM_ON;  /* 11-29-90 tbh */

    }
    else
    {
    xy->st_variation[0] = 0;
    xy->st_variation[1] = 0;
    xy->st_variation[2] = 0;
    xy->st_variation[3] = 0;
    }

    as_indx = 0;

/*  for each skeletal point in the tree   */
    for (sk_indx = 0; sk_indx < skel_ptr->num_nodes; sk_indx++)
    {
        skel_i = skel_ptr->tree_skel_i[sk_indx];
        adj_skel = &skel [skel_i].adjusted;

#if ((ELASTIC_Y) | (ELASTIC_X))
        remainder = &skel[skel_i].remainder;
#endif

        DBG1("\n\n\n\nskel_i =%u\n", skel_i);

        num_assoc = skel_ptr->tree_attrib[sk_indx] >> 5;
        DBG1("number of associates = %d\n", num_assoc);
        DBG2("\ntree: processing skel [%d] = %d\n",
                         skel_i, skel [ skel_i ].adjusted);
 
/*      if assoc equals skel, we're at a root point; therefore, */
        if (as_indx == sk_indx)
        {
            DBG("      as a root skel\n");
            as_indx++;                /* increment assoc index */

/*          pixel align the root skeletal point */
            pixel_align (
                        *adj_skel + root_adjust, 
                        xy, 
                        R_TWO_I

#if ((ELASTIC_Y) | (ELASTIC_X))
                        ,0
#endif
                        );

            *adj_skel = if_state.value;

#if ((ELASTIC_Y) | (ELASTIC_X))
            *remainder = 0;
#endif

        }

        DBG1("      after grid alignment:    .adjusted = %d\n", *adj_skel);
        DBG1("                               .round_i = %d\n",
                                                 skel [skel_i].round_i);
#if ((ELASTIC_Y) | (ELASTIC_X))
        DBG1("                               .remainder = %d\n",
                                                 skel [skel_i].remainder);
#endif

/*      and, finally . . . .                                    */
/*      for each of this skel's assocs, pass on the adjustment  */
        for (j = 0; j < num_assoc; j++)
        {
            DBG1("       passing adjustment to assoc [%d]\n",j);
            hq3_assoc_proc
                         (
                             skel_ptr->tree_skel_i[as_indx],
                             skel_i,
                             skel_ptr->tree_attrib[as_indx],
                             skel, xy
                         );
            as_indx++;
        }


    }   /* for each skeletal point in tree */

    if (skel_ptr->num_intrp)
        if(!interp_assoc_proc (skel_ptr, skel)) return FALSE;

    return TRUE;
}
#endif  /* IF_RDR */


