/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/cor/yclass.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: yclass.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   06 Apr 1995 15:10:56   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 09:28:26   LISA
 * 
 * Modified copyright/disclaimer notice for 1994.
 * 
 *    Rev 1.3   12 Feb 1993 11:45:48   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 11:37:00   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:35:36   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:37:46   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/*  yclass.c */


/*  16-May-89 awr  Cloned from if 2.11 yclass.c
    07-Jul-90 awr  added xy COORD_DATA parameter for quadrant rotation
                   removed skeletal_scale()
    31-Jan-91 dET  Modify for MSC multi-model compilation.
     3-Feb-91 awr  removed scale_iii() declaration- it's in imath.h,
                   removed obsolete skeletal_scale(),
                   updated copyright.
     8-Feb-91 awr  Moved skel_init(), y_skel[] and x_skel[] from yclass.c
                   to if.c. Made yskel a parameter instead of an extern,
                   renamed yclass_proc() to yclass().
    17-Jun-91 jfd  Moved "debug.h" after "port.h".
                   Moved "profile.h" after "port.h".
                   Added "cgconfig.h" before "port.h".
     8-Jul-91 tbh  Added elasticity.
     1-Aug-91 tbh  changed COUNTER to UCOUNTER
    24-Aug-91 awr  Moved function decls to include file
    03-Apr-92 rs   Portability cleanup (see port.h).
    15-Sep-92 jfd  Conditionally compile entire module based on IF_RDR.
    07-Jan-93 jfd  ANSI C function declaration changes.
    08-Feb-93 jfd  VXWorks support.
---------------------------------------------------------------------*/


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include  <stdio.h>
#include  "cgconfig.h"
#include  "port.h"

#if IF_RDR

#include  "debug.h"
#include  "profile.h"
#include  "imath.h"
#include  "segments.h"
#include  "ifmem.h"
#include  "cgif.h"
#include "ix.h"
#include  "if_type.h"
#include  "adj_skel.h"

#ifdef LINT_ARGS
MLOCAL SW16  pix_align(SW16);
#endif

EXTERN IF_STATE if_state;

/*----------------------*/
/*  pix_align           */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16  pix_align(SW16 val)
#else
MLOCAL SW16
pix_align(val)
    SW16 val;
#endif
{
#if ((ELASTIC_Y) | (ELASTIC_X))
    pixel_align (val, &if_state.y, 2, 0);
#else
    pixel_align (val, &if_state.y, 2);
#endif
    return if_state.value;
}


/**********************************************************************/
/*                                                                    */
/*      yclass()                                                      */
/*              completes the entire Y Class manipulation process by  */
/*              appropriately adjusting all Y skeletal root point     */
/*              values in y_skel.adjusted                             */
/*                                                                    */
/**********************************************************************/

#if defined (ANSI_DEFS)
GLOBAL VOID  yclass(PADJUSTED_SKEL y_skel)
#else
GLOBAL VOID
yclass(y_skel)
    PADJUSTED_SKEL  y_skel;
#endif
{
    SW16    baseline_adj;   /*  implement baseline offset concept */
    UCOUNTER i,j,k;

    SW16   class_i;
    SW16   ihigh, ilow;
    SW16   orig_low, orig_high;
    SW16   adj_low,  adj_high;
    SW16   root_i;
    LPSW16  adj_skel_ptr;

    DBG ("\n\n-------------------yclass()--------------------\n");

    if (if_state.baseline_offset != 0)
      {
      baseline_adj = pix_align(if_state.baseline_offset) - if_state.baseline_offset;
      DBG1("    baseline_adj based on baseline offset = %d\n", baseline_adj);
      }
    else
      {
      baseline_adj = 0;
      DBG1("    baseline_adj = %d\n",baseline_adj);
      }

    k = 0;
    DBG1("%d yclass assignment(s) in character\n", if_state.num_yclass_ass);
    for (i=0; i < if_state.num_yclass_ass; i++)  /* for each yclass assignment */
    {
        class_i = if_state.yclass_i[i];

        DBG2("\nyclass assignment %d  definition index %d\n",i, class_i);

        if (if_state.num_yclass_def)   /* if character has local yclass defs */
        {
            ilow  = if_state.yline_low_i [class_i];
            ihigh = if_state.yline_high_i[class_i];
            DBG2("    local yclass indices low = %d  high = %d\n",
                                                         ilow, ihigh);

            /* Note: local yclass def can use either loc or glob ylines. */
            if (if_state.num_ylines)      /* i.e. local ylines available */
            {
                DBG("        local ylines\n");
                orig_low  = if_state.ylines[ilow];
                orig_high = if_state.ylines[ihigh];
            }
            else
            {
                DBG("        global ylines\n");
                orig_low  = if_state.gylines[ilow];
                orig_high = if_state.gylines[ihigh];
            }
        }
        else
        {
           /*  Note: global yclass defs must use global ylines  */

            orig_low  = if_state.gylines[if_state.glob_yclass.yline_low_i[class_i]];
            orig_high = if_state.gylines[if_state.glob_yclass.yline_high_i[class_i]];

            DBG2("    Global yclass indices low = %d  high = %d\n",
                                   if_state.glob_yclass.yline_low_i[class_i],
                                   if_state.glob_yclass.yline_high_i[class_i]);
        }

        adj_high = pix_align(orig_high - if_state.origBaseline)
                                       + if_state.aBaselnVal;
        adj_low  = pix_align(orig_low  - if_state.origBaseline)
                                       + if_state.aBaselnVal;

        DBG2 ("        original hi,lo %d %d\n", orig_high, orig_low);
        DBG2 ("        aligned  hi,lo %d %d\n", adj_high,  adj_low);




        DBG1("\n\n    %d roots in this assignment:\n", if_state.num_root_p_ass[i]);
        for (j=0; j < if_state.num_root_p_ass[i]; j++)  /* each root in assnmt */
        {
            root_i = if_state.root_skel_i[k];
            /* was: adj_skel_ptr = &y_skel[root_i].adjusted;      awr */
            adj_skel_ptr = &((y_skel+root_i)->adjusted);

            DBG2("        y_skel[%d] before yclass adjustment    = %d\n",
                           root_i, *adj_skel_ptr);

            /* if root skel is above yclass, then shift */
            if (*adj_skel_ptr - if_state.baseline_offset >= orig_high)
            {

                *adj_skel_ptr += adj_high - orig_high + baseline_adj;

        DBG2("            y_skel[%d] is above yclass, adj y_skel = %d\n",
                            root_i, *adj_skel_ptr);

            }

            /*  else if root skel's below yclass, then shift */
            else if (*adj_skel_ptr - if_state.baseline_offset <= orig_low)
            {
                *adj_skel_ptr += adj_low - orig_low + baseline_adj;

     DBG2("            y_skel[%d] is below yclass, adj y_skel = %d\n",
                            root_i, *adj_skel_ptr);

            }

            /* else, root skel is within, so scale */
            else
            {
                *adj_skel_ptr =
                    scale_iii(*adj_skel_ptr - if_state.baseline_offset - orig_low,
                                  adj_high - adj_low,
                                  orig_high - orig_low
                              )
                            + adj_low + baseline_adj + if_state.baseline_offset;

       DBG2("            y_skel[%d] is within yclass, adj y_skel = %d\n",
                          root_i, *adj_skel_ptr);

            }

            k++;    /* NO CHECK FOR OVERRUNNING ROOT ARRAY*/

        }  /* for ( j = ...  */
    }  /* for ( i = ... */
}
#endif  /* IF_RDR */

