/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/bucket.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: bucket.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.46   19 Jun 1995 15:33:52   MIKE
 * BUCKfind() should call SYMnoMap() for PCLEO with !b->usePlugins
 * 
 *    Rev 1.45   06 Apr 1995 15:14:14   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.44   17 Dec 1994 17:56:24   JOE
 * In BUCKfind(), if TFS was a pcleo, need to load symbolset first
 * and last character in order to locate the character in the
 * FCO plugins.
 * 
 *    Rev 1.43   15 Dec 1994 16:53:46   MIKE
 * Return error if "buck_search_lvl" too large (BUCKfind)
 * 
 *    Rev 1.42   02 Dec 1994 21:26:02   MIKE
 * 
 * KSC (YAN).
 * 
 *    Rev 1.41   30 Nov 1994 11:02:52   JOE
 * 
 * In BUCKfind(), if FCO_RDR is enabled, always set up FCO plugins
 * regardless of fst type.
 * 
 *    Rev 1.40   09 Nov 1994 16:21:22   JOE
 * In BUCKfind(), added braces following "if" statement to correct
 * improper bucket searching algorithm (by bg/dbk ).
 * 
 *    Rev 1.39   15 Sep 1994 20:44:24   MIKE
 * In BUCKfind() for FCO plugins, set font_type.
 * 
 *    Rev 1.38   08 Sep 1994 20:10:38   MIKE
 * 
 * 
 *    Rev 1.37   02 Sep 1994 12:58:34   MIKE
 * 
 * In BUCKfind() set up plugin faces for FCO_RDR.
 * 
 *    Rev 1.36   05 Aug 1994 13:39:32   MIKE
 * Added FCO changes from 1.25.1.2
 * 
 *    Rev 1.35   29 Apr 1994 16:10:36   JOE
 * In BUCKfind(), only call IXopen_file() for TT data for which we
 * have a path.
 * 
 *    Rev 1.34   22 Apr 1994 15:39:02   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.33   22 Apr 1994 15:12:00   JOE
 * 
 * In BUCKfind(), when calling xxload_font(), cast first arg as LPSB8.
 * 
 *    Rev 1.32   22 Apr 1994 13:54:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.31   30 Mar 1994 11:45:54   JOE
 * In BUCKfind(), if processing TT, after finding bucket, call IXopen_file()
 * in the event that the TT file was closed due to num_open_files exceeding
 * max_open_files.
 * 
 *    Rev 1.30   29 Mar 1994 10:08:02   JOE
 * 
 * Changed conditional compile for IXopen_file() and IXclose_file()
 * to include TT_RDR too. 
 * Modified IXopen_file() for TT support.
 * 
 *    Rev 1.29   09 Feb 1994 12:07:14   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.28   03 Feb 1994 15:30:20   MIKE
 * 
 * Change fontindex.awtsub_on to if_state.awtsub_on.
 * 
 *    Rev 1.27   02 Feb 1994 09:05:18   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.26   19 Jan 1994 08:57:48   JOE
 * In BUCKfind(), conditionally compiled code which stores platform and
 * specific IDs based on TT_RDR to resolve compiler error.
 * 
 *    Rev 1.25   05 Jan 1994 18:12:18   ROB
 * Add support for "GB" encoding.
 * 
 *    Rev 1.24   08 Dec 1993 19:00:00   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.23   07 Dec 1993 15:20:08   JOE
 * 
 * In BUCKfind(), for KANJI TT fonts, set platform ID and specific ID
 * from "symbolset" data (loaded by cgif_Font() ).
 * Changed conditional compile statement for OS2 support.
 * 
 *    Rev 1.22   01 Dec 1993 08:52:38   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.21   30 Nov 1993 14:48:56   ROB
 * Add BIG5 support and TCA hooks.
 * 
 *    Rev 1.20   18 Nov 1993 13:34:34   MIKE
 * 
 * In BUCKfind() set platId & specId to 0 in the TT bucket, if plugins disable
 * 
 *    Rev 1.19   11 Nov 1993 16:32:16   JOE
 * 
 * In BUCKfind(), added UNICODE changes for KANJI support (platformID
 * set to 3 instead of 1).
 * 
 *    Rev 1.18   23 Sep 1993 20:26:28   MIKE
 * 
 * Before setting up plugin search path, test pbucket->usePlugins
 * 
 *    Rev 1.17   23 Sep 1993 19:29:32   MIKE
 * 
 * BUCKfind() changes.
 * 
 *    Rev 1.16   12 Aug 1993 11:08:18   MIKE
 * 
 * For CONVERGENT_FONTS: change IF plugin search path setup in BUCKfind().
 * 
 *    Rev 1.15   10 Aug 1993 15:33:54   JOE
 * 
 * In BUCKfind(), conditionally compiled call to ifload_font() based on
 * IF_RDR. 
 * In BUCKfree(), conditionally compiled call to ifunload_font() based on
 * IF_RDR.
 * In BUCKfree(), changed statement "return (fst_type)" to "return"
 * because BUCKfree() returns VOID.
 * 
 *    Rev 1.14   15 Jul 1993 11:55:46   MIKE
 * Convergent font changes -- see comments.
 * 
 *    Rev 1.13   01 Jul 1993 15:21:40   JOE
 * 
 * EUC KANJI support.
 * 
 *    Rev 1.12   30 Jun 1993 08:54:56   JOE
 * In BUCKfind(), conditionally compiling test for JIS or SJIS encoding
 * based on KANJI_ENCODING.
 * 
 *    Rev 1.11   29 Jun 1993 14:49:52   JOE
 * In BUCKfind(), storing 1 for platformID and specificID if using JIS or
 * SJIS encoding.
 * 
 *    Rev 1.10   28 Jun 1993 14:08:32   JOE
 * 
 * In BUCKfind(), when searching for bucket, generalized code which
 * determines whether TFS font has changed.
 * 
 *    Rev 1.9   24 Jun 1993 14:21:00   JOE
 * 
 * In BUCKfind(), if processing KANJI fonts, check encoding value in
 * addition to pathname before determining that TFS font has not changed.
 * This fixes a bug when switching from JIS to SJIS encoding and vice versa.
 * 
 *    Rev 1.8   03 May 1993 17:07:16   MIKE
 * Fix ROM problem in bucket search algorithm in BUCKfind().
 * 
 *    Rev 1.7   22 Apr 1993 11:18:04   MIKE
 * BUCKfind - support IF dynamic fonts (has_path, etc.).
 * IXopen_file() - dynamic font support (don't call buildpath()).
 * 
 *    Rev 1.6   13 Apr 1993 13:26:14   JOE
 * In BUCKfree(), conditionally compiled calls to psunload_font() and
 * ttunload_font() if !USE_JUMP_TABLES. In BUCKfind(), conditionally compiled
 * calls to psload_font() and ttload_font() if !USE_JUMP_TABLES.
 * 
 *    Rev 1.5   29 Mar 1993 10:50:00   ROB
 * Kanji cleanup.
 * 
 *    Rev 1.4   11 Mar 1993 15:06:08   MAIB
 * Initial changes to support Asian character encoding (TrueType 1st pass)
 * 
 *    Rev 1.3   12 Feb 1993 13:36:58   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 16:05:36   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:47:30   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* bucket.c */
/*
 *
 *
 * History
 *
 *    24-Aug-90  awr   Initialize BUCKET's "my_handle" field in BUCKnew()
 *    03-Dec-90  awr   In BUCKfree(), reset if_init_face (last face processed
 *                     by if_init())
 *     7 Jan 91  ss    Added PCLEO_RDR support
 * 
 *    24-Jan-91  jfd   As a result of removing the "name_off" field from
 *                     the INDEX_ENTRY structure (#if ROM), conditionally
 *                     compile the DBG5 statement in IXfind_bucket().
 *
 *      28-Jan-91  tnc   Window-ized file "close" and "read".
 *
 *    28-Jan-91  jfd   Made size arg of MEMalloc() LONG
 *    30-Jan-91  dET   Added function prototyping for MSC
 *    31-Jan-91  dET   Modify for MSC multi-model compilation.
 *     4-Feb-91  awr   Split off from ix.c
 *     8-Feb-91  awr   Added dll.h to declare functions.
 *    15-Feb-91  awr   changed IXfind_bucket() name to BUCKfind()
 *    23-Feb-91  awr   removed reference to hfi by adding calls to
 *                     FIpath() and FIentry().
 *    23-Feb-91  awr   Moved BUCKET defund logic from mem.c
 *    04-Mar-91  jfd   Conditionally declared FIpath (#if !ROM).
 *    06-Mar-91  jfd   Removed BUCKdefund().
 *    09-Apr-91  dET   Added BUFdump routines for aid in debugging. 
 *    17-Jun-91  jfd   Moved "debug.h" after "port.h".
 *                     Moved "cgconfig.h" before "port.h".
 *    24 Jun 91  ss    Conditionally compile io.h based on system type.
 *                     Added prototypes for BUCK,BUF...() when not LINT_ARGS.
 *     3-Jan-92  awr   Removed font_open field from BUCKET
 *                     Removed BUCKnew(); coded inline.
 *    15-Jan-92  jfd   Added functofin prototype for IXset_search_path().
 *    17 Jan 92  ss    In BUCKfind() made test for matching to an existing
 *                     bucket more strict.
 *    29-Jan-92  rs    Move IF_FUNC_TBL from cgif.c for URIP ptrs.
 *    07-Mar-92  rs    Remove duplicate global 'pras' (in cgif.c).
 *     8-Mar-92  awr   Added core font substitution for PS and TT
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    23 Apr 92  ss    In BUCKfind(), reordered initial setup code based
 *                     on buck_search_lvl which wraps in the PS,TT specific
 *                     code instead of duplicating it.
 *                     - Improved test for matching typeface in bucket search
 *                     to the one requested in fontindex.
 *                     - Changed test for buck_search_lvl==MAX_UWORD to ==0.
 *                     No longer using MAX_UWORD to determine a non-IF type.
 *                     Added items set when have a TFS round (buck_search_lvl
 *                     == 0).
 *                     - Changed name fontindex.num_levels to .num_searches.
 *     6-Jul-92  jfd   Added "ifget_width" to iffunc_tbl structure.
 *                     Added "psget_width" to psfunc_tbl structure.
 *                     Added "ttget_width" to ttfunc_tbl structure.
 *     9-Jul-92  jfd   Conditionally compiled "ifget_width", "psget_width"
 *                     and "ttget_width" based on WIDTHS.
 *    21-Jul-92  awr   Conditional compile changes.
 *    28-Jul-92  ss    In BUCKfind(), initialize tfnum to 0; if not IF font
 *                     and ROM is true, has_path = FALSE.
 *    05-Aug-92  jfd   Replaced calls to "clear_mem()" with MEMSET for
 *                     optimization.
 *                     Included "mixmodel.h" and "string.h".
 *    16-Aug-92  rs    #defined 'MEM_DUMP' = 0 if not already defined.
 *    14-Sep-92  jfd   Conditionally compiled table iffunc_tbl{} based on
 *                     IF_RDR.
 *                     In BUCKfind(), conditionally compiled case clause
 *                     which stores pointer to IF function table based on
 *                     IF_RDR.
 *    16-Sep-92  jfd   Conditionally compile routines IXopen_file() and
 *                     IXclose_file() based on IF_RDR.
 *    28-Sep-92  awr   Changed BUCKfind() parameters.
 *                     Changed FIentry() parameter.
 *    10-Oct-92  rs    Implement USE_JUMP_TABLES feature for overlays.
 *    13-Oct-92  mby   Changed BUCKfind() for TT: platformID & specificID.
 *                     Set has_path = TRUE, if TT_TTPLUGIN && not ROM font
 *    26-Oct-92  jfd   In BUCKfind(), before storing "platId" and "specId"
 *                     into TT bucket, check if bucket is a TT bucket.
 *                     In same routine, storing "cur_ssnum" into bucket
 *                     structure at same time that other fields are loaded.
 *    06-Nov-92  jfd   In BUCKfind(), moved closing brace to line following
 *                     #endif for (IF_RDR || PS_IFPLUG || TT_IFPLUG). This
 *                     fixes a compiler error if compiling for TT only.\
 *    15-Nov-92  rs    Port to Macintosh - #include <unix.h>, casting in call
 *                     to load_font().
 *    22-Nov-92  rs    Port to Macintosh - prototype for set_tt_universal().
 *    06-Jan-93  jfd   ANSI C function declaration changes.
 *    08-Feb-93  jfd   VXWorks support.
 *    11-Mar-93  maib  began support for jis and shift jis character encoding.
 *    27-Mar-93  rs    Add defines for KANJI_ENCODING, JIS_ENCODING &
 *                     SJIS_ENCODING per cgconfig.h.
 *    13-Apr-93  jfd   In BUCKfree(), conditionally compiled calls to
 *                     psunload_font() and ttunload_font() if !USE_JUMP_TABLES.
 *                     in BUCKfind(), conditionally compiled calls to
 *                     psload_font() and ttload_font() if !USE_JUMP_TABLES.
 *    10-Apr-93  mby   DYNAMIC_FONTS: IXopen_file() builds pathname differently.
 *                     In BUCKfind(), has_path can be true for IF; BUCKET->dynIFActive.
 *    30-Apr-93  mby   Fix ROM problem in BUCKfind() bucket search algorithm.
 *    24-Jun-93  jfd   In BUCKfind(), if processing KANJI fonts, check 
 *                     encoding value in addition to pathname before
 *                     determining that TFS font has not changed. This
 *                     fixes a bug when switching from JIS to SJIS encoding 
 *                     and vice versa.
 *    28-Jun-93  jfd   In BUCKfind(), when searching for bucket, generalize
 *                     the code. For PS, TT, KANJI, or IF using dynamic
 *                     fonts, the symbolset is checked in addition to the
 *                     pathname before determining that TFS font has not 
 *                     changed.
 *    29-Jun-93  jfd   In BUCKfind(), storing 1 for platformID and specificID
 *                     if using JIS or SJIS encoding.
 *    30-Jun-93  jfd   In BUCKfind(), conditionally compiling test for
 *                     JIS or SJIS encoding based on KANJI_ENCODING.
 *    30-Jun93 jfd/gy  EUC KANJI support.
 *    13-Jul-93  mby   Conditionally compiled set_tt_universal() based on
 *                     TT_TTPLUG and TT_TTPLUG_IF.
 *                     Modified TT plugin font selection for TT_TTPLUG_IF.
 *                     Added debug routine print_buckets().
 *    10-Aug-93  jfd   In BUCKfind(), conditionally compile call to
 *                     ifload_font() based on IF_RDR. 
 *                     In BUCKfree(), conditionally compile call to 
 *                     ifunload_font() based on IF_RDR.
 *                     In BUCKfree(), changed "return (ERR_fst_type);"
 *                     to "return" because BUCKfree() returns VOID.
 *    12-Aug-93  mby   For CONVERGENT_FONTS: change plugin search path setup
 *                     in BUCKfind().
 *    22-Sep-93  mby   Add default case to switch(fontindex.plug_type)
 *                     Set usePlugins boolean in bucket. ROM1 support.
 *    11-Nov-93  gy    In BUCKfind(), added UNICODE changes for KANJI
 *                     support (platformID set to 3 instead of 1).
 *    18-Nov-93  mby   In BUCKfind() set platId and specId to 0 in the TrueType
 *                     bucket if if_state.usePlugins is 0.
 *    23-Nov-93  rs    Add BIG5 & TCA to KANJI_ENCODING support.
 *    01-Dec-93  jfd   Changed KANJI_ENCODING to ASIAN_ENCODING.
 *    03-Dec-93  jfd   In BUCKfind(), for KANJI fonts, set platform ID and
 *                     and specificID from "symbolset" data (loaded by
 *                     cgif_Font() ).
 *    07-Dec-93  rs    Changed conditional compile statement for OS2.
 *    08-Dec-93  rs    General cleanup - MSDOS & OS2.
 *    05-Jan-94  rs    Add support for "GB" encoding.
 *    19-Jan-94  jfd   In BUCKfind(), conditionally compiled block of code
 *                     which stores platform ID and specific ID based on
 *                     TT_RDR.
 *    27-Jan-94  jfd   Conditionally compiled #include for fcntl.h
 *                     (if !(_AM29K && UNIX) ).
 *    02-Feb-94  mby   Change fontindex.awtsub_on to if_state.awtsub_on.
 *    09-Feb-94  jfd   Including "hif.h" if _AM29K.
 *    28-Mar-94  jfd   Change conditional compile for IXopen_file() and
 *                     IXclose_file() to include TT_RDR too.
 *                     Modified  IXopen_file() for TT support.
 *    30-Mar-94  jfd   In BUCKfind(), if processing TT, after finding 
 *                     bucket, call IXopen_file() in the event that
 *                     the TT file was closed due to num_open_files
 *                     exceeding max_open_files.
 *    22-Apr-94  dbk   In BUCKfind(), when calling xxload_font(), cast
 *                     first arg as LPSB8.
 *               jfd   Changed conditional compile statement prior to
 *                     including <hif.h> to #if (_AM29K && !UNIX) to
 *                     resolve UNIX Metaware compiler error.
 *    29-Apr-94  jfd   In BUCKfind(), only call IXopen_file() for TT data
 *                     for which we have a path .
 *    09-Nov-94  bg/dbk In BUCKfind(), added braces following "if" statement
 *                     to correct improper bucket searching algorithm.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  FCO Changes from 1.25.1.2:
 *    15-Mar-94  mby   Added fco_func_tbl structure for FCO function calls.
 *                     In BUCKfind(), cur_font_hdr = fontindex.FCObject for
 *                     FCO font type.
 *    26-May-94  mby   Change fontindex.FCObject to if_state.FCObject.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *    02-Sep-94  mby   In BUCKfind() set up plugin faces for FCO_RDR.
 *    08-Sep-94  mby   Add missing break statement.
 *    15-Sep-94  mby   In BUCKfind() for FCO plugins, set font_type.
 *    28-Nov-94  jfd   In BUCKfind(), if FCO_RDR is enabled, always set
 *                     up FCO plugins regardless of fst type.
 *    15-Dec-94  mby   In BUCKfind() for FCO_RDR, if "buck_search_lvl"
 *                     argument too large, return ERR_no_cgnum.
 *    17-Dec-94  jfd   In BUCKfind(), if TFS was a pcleo, need to load 
 *                     symbolset first and last character in order to 
 *                     locate the character in the FCO plugins.
 *    06-Jun-95  mby   In BUCKfind() for plugin search path, if TFS is PCLEO
 *                     or PCLETTO and !(b->usePlugins), call SYMnoMap(),
 *                     not SYMnew().
 */



#include <string.h>
#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>
#endif

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined (MSDOS) || defined (__OS2__)
#include <io.h>
#endif

#if defined (MACINTOSH)
#include <unix.h>
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "sym.h"
#include "dll.h"
#include "if_type.h"

#if PCLEO_RDR
#include "pcleo.h"
#endif

#if TT_ROM1
#include "ttroment.h"
#endif

#if ASIAN_ENCODING     /* 3/11/93 maib */
#include "kanji.h"
#endif


#define MAXNAME  80    /* max size name includes drive, path and file */


#ifdef LINT_ARGS
GLOBAL UW16       BUCKinit(VOID);
GLOBAL VOID        BUCKexit(VOID);
GLOBAL VOID        BUCKfree(HBUCKET);
GLOBAL UW16       BUCKfind(int, int, PPBUCKET);
GLOBAL MEM_HANDLE  BUFalloc(SL32);
GLOBAL VOID        BUFfree(MEM_HANDLE);

#if TT_TTPLUG
GLOBAL UW16        set_tt_universal(LPUB8 ptr, int rom_font);
#endif
#if TT_TTPLUG_IF
GLOBAL VOID        set_tt_universal(SL32 tfnum);
#endif

#if IF_RDR || TT_RDR
#if !ROM                /* added conditional compile  -ss 6/21/91  */
GLOBAL VOID        IXclose_file(PBUCKET);
GLOBAL UW16       IXopen_file(PINDEX_ENTRY, PBUCKET);
#endif
#endif  /* IF_RDR || TT_RDR */
EXTERN VOID        buildpath(LPSB8, LPSB8, LPSB8);
EXTERN PINDEX_ENTRY FIentry(int);
#if !ROM
EXTERN LPSB8      FIpath(PINDEX_ENTRY);
#endif 

EXTERN UW16       IXset_search_path(SW16);
#if FCO_RDR
EXTERN VOID       fco_pluginSearchPath( PBUCKET, PMEM_HANDLE, LPUB8, int* );
#endif

#else    /*  NOT LINT_ARGS  */
GLOBAL UW16       BUCKinit();
GLOBAL VOID        BUCKfree();
GLOBAL UW16       BUCKfind();
GLOBAL MEM_HANDLE  BUFalloc();
GLOBAL VOID        BUFfree();
EXTERN VOID        buildpath();
EXTERN PINDEX_ENTRY FIentry();

#if TT_TTPLUG
GLOBAL UW16        set_tt_universal();
#endif
#if TT_TTPLUG_IF
GLOBAL VOID        set_tt_universal();
#endif

#if !ROM
EXTERN LPSB8       FIpath();
#if IF_RDR || TT_RDR
GLOBAL VOID        IXclose_file();
GLOBAL UW16       IXopen_file();
#endif  /* IF_RDR || TT_RDR */
#endif

EXTERN UW16       IXset_search_path();
#if FCO_RDR
EXTERN VOID       fco_pluginSearchPath();
#endif
#endif

/*-------------------------------------------------------------*/
EXTERN IF_STATE  if_state;
EXTERN FONTINDEX fontindex;
EXTERN SYMBOLSET symbolset;
#if CONVERGENT_FONTS
EXTERN AWT_TABLE awtData;
#endif
/*-------------------------------------------------------------*/

/* Open files */
MLOCAL UW16 num_open_files;      /* current number of open library files */
GLOBAL UW16 max_open_files;      /* maximum   "     "   "     "      "   */

EXTERN SB8  typePath[];

/* Buckets */
GLOBAL MEM_HANDLE hBUCKlru;       /*  Least recently used list for BUCKETs */

#if (USE_JUMP_TABLES)
/*
URIP function interface tables - 1 for each font type
*/
#if IF_RDR
MLOCAL IF_FUNC_TBL iffunc_tbl = {
    ifload_font,
    ifunload_font,
    ifset_trans,
    ifset_char,
    ifmake_gaso_and_stats,
    ifrender
#if WIDTHS
   ,ifget_width
#endif /* WIDTHS */
};
#endif /* IF_RDR */

#if PST1_RDR
MLOCAL IF_FUNC_TBL psfunc_tbl = {
    psload_font,
    psunload_font,
    psset_trans,
    psset_char,

    psmake_gaso_and_stats,
    psrender
#if WIDTHS
   ,psget_width
#endif /* WIDTHS */
};
#endif /* PST1_RDR */

#if TT_RDR
MLOCAL IF_FUNC_TBL ttfunc_tbl = {
    ttload_font,
    ttunload_font,
    ttset_trans,
    ttset_char,
    ttmake_gaso_and_stats,
    ttrender
#if WIDTHS
   ,ttget_width
#endif /* WIDTHS */
};
#endif /* TT_RDR */

#if FCO_RDR
MLOCAL IF_FUNC_TBL fco_func_tbl = {
    fco_load_font,
    fco_unload_font,
    fco_set_trans,
    fco_set_char,
    fco_make_gaso_and_stats,
    fco_render
#if WIDTHS
   ,fco_get_width
#endif /* WIDTHS */
};
#endif /* FCO_RDR */

#endif /* USE_JUMP_TABLES */

#if FCO_RDR && PCLEO_RDR && PLUGINS
EXTERN  FONTCONTEXT fcCur;      /* current FONTCONTEXT */
#endif

/*-------------------------------------------------------------*/

#if IF_RDR || TT_RDR   /* JFD */
#if !ROM

/*-------------------*/
/*   IXclose_file    */
/*-------------------*/
/*  Close buckets file if it's open and decrement
 *  global count of open files.
 */
#if defined (ANSI_DEFS)
GLOBAL VOID  IXclose_file(PBUCKET b)
#else
GLOBAL VOID
IXclose_file(b)
    PBUCKET   b;
#endif
{
    if(b->fh != -1)
    {
        CLOSE(b->fh);
        b->fh = -1;
        num_open_files--;
    }
}




/*-------------------*/
/*   IXopen_file     */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  IXopen_file(PINDEX_ENTRY ix, PBUCKET bucket)
#else
GLOBAL UW16
IXopen_file(ix, bucket)
    PINDEX_ENTRY ix;
    PBUCKET      bucket;
#endif
{
    HBUCKET      hb;
    PBUCKET      b;
    SB8        pathname[MAXNAME];

    if(bucket->fh != -1) return SUCCESS;   /* file is already open */

  /*  Make sure too many files aren't open  */

		memset(pathname, '\0', MAXNAME);
    while(num_open_files >= max_open_files)
    {
        hb = ((PDLL)MEMptr(hBUCKlru))->b;       /* lru BUCKET in lru list */
        while(hb != hBUCKlru)
        {
            b  = (PBUCKET)MEMptr(hb);
            if(b->fh != -1)
            {
                IXclose_file(b);
                break;
            }
            hb = b->link.b;                /* previous BUCKET in the list */
        }
        if(hb == hBUCKlru)
        {
            DBG("    couldn't close file\n");
            return ERR_IXopen_file;
        }
    }

  /*  Open the file  */

#if IF_RDR
    if (bucket->fst_type == FC_IF_TYPE)  /* 3-28-94 jfd */
    {
#if DYNAMIC_FONTS
    if (bucket->dynIFActive)
      STRCPY(pathname, bucket->pathname);
    else
#endif
      buildpath (pathname, typePath, FIpath(ix));
    }                                    /* 3-28-94 jfd*/
#endif

#if TT_RDR
    if (bucket->fst_type == FC_TT_TYPE)  /* 3-28-94 jfd */
       STRCPY(pathname, bucket->pathname);
#endif

    if((bucket->fh = OPEN(pathname, O_READFLAGS)) == -1)
    {
        DBG1("        Open lib file failed. pathname = %s\n", pathname);
        return ERR_open_lib;
    }
    num_open_files++;
    return SUCCESS;
}

#endif  /*  !ROM  */
#endif  /*  IF_RDR || TT_RDR */



/*-------------------*/
/*     BUCKinit      */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  BUCKinit()
#else
GLOBAL UW16
BUCKinit()
#endif
{
    num_open_files = 0;               /* number of open library files     */
    if_state.if_init_face   = 0;               /* Last face processed by if_init() */

	hBUCKlru = MEMalloc(BUFFER_POOL, (SL32)sizeof(DLL));
    if(!hBUCKlru)
        return ERRmem;

/*    if(!(hBUCKlru = MEMalloc(BUFFER_POOL, (SL32)sizeof(DLL))))	***KMR***
         return ERRmem; 
*/

    dll_null(hBUCKlru);               /*  Set BUCKET lru to empty.        */

    return SUCCESS;
}


/*-------------------*/
/*     BUCKexit      */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  BUCKexit()
#else
GLOBAL VOID
BUCKexit()
#endif
{
    while(!dll_empty(hBUCKlru))
        BUCKfree(((PDLL)MEMptr(hBUCKlru))->b);
    MEMfree(BUFFER_POOL, hBUCKlru);
}


/*-------------------*/
/*    BUCKfree       */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  BUCKfree(HBUCKET hb)
#else
GLOBAL VOID
BUCKfree(hb)
    HBUCKET hb;
#endif
{
    PBUCKET      b;

    b = ((PBUCKET)MEMptr(hb));
#if USE_JUMP_TABLES
    (*((PIF_FUNC_TBL)b->pft)->unload_font) (b);
#else
   switch (b->fst_type)
   {
#if IF_RDR
      case FC_IF_TYPE:
         ifunload_font (b);
         break;
#endif
#if PST1_RDR
      case FC_PST1_TYPE:
         psunload_font (b);
         break;
#endif
#if TT_RDR
      case FC_TT_TYPE:
         ttunload_font (b);
         break;
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
         fco_unload_font (b);
         break;
#endif
      default:
/*         return (ERR_fst_type); */
         return;
     }
#endif /* USE_JUMP_TABLES */

    dll_remove(hb);                        /* remove from active lru list */
    BUFfree(hb);
}



#if TT_TTPLUG

/* TT Plugins are in TrueType format. */
MLOCAL  int         ttplug_font_type;
MLOCAL  PATHNAME    tt_universal;
MLOCAL  LPUB8       tt_fnt_hdr;

/*-------------------*/
/*  set_tt_universal */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  set_tt_universal(LPUB8 ptr, int rom_font)
#else
GLOBAL UW16
set_tt_universal(ptr, rom_font)
    LPUB8  ptr;
    int    rom_font;
#endif
{
    ttplug_font_type = FC_TT_TYPE;
    if(rom_font)
    {
        ttplug_font_type |= FC_ROM_TYPE;
        tt_fnt_hdr = ptr;
    }
    else
    {
        if(STRLEN((LPSB8)ptr) >= PATHNAMELEN)
            return ERRlong_font_name;
        STRCPY(tt_universal, (LPSB8)ptr);
        tt_fnt_hdr = (LPUB8)tt_universal;
    }

    return SUCCESS;
}

#endif  /*  TT_TTPLUG  */


#if TT_TTPLUG_IF

/* TT Plugins are in Intellifont format. */
MLOCAL  int    ttplug_font_type;
MLOCAL  SL32   ttplug_tfnum;

/*-------------------*/
/*  set_tt_universal */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  set_tt_universal( SL32 tfnum )
#else
GLOBAL VOID  set_tt_universal( tfnum )
  SL32 tfnum;
#endif
{
    ttplug_tfnum = tfnum;
    ttplug_font_type = FC_IF_TYPE;
#if ROM    /* if ROM is enabled, assume ROM plugins for IF */
    ttplug_font_type |= FC_ROM_TYPE;
#endif
    return;
}

#endif  /* TT_TTPLUG_IF */



/*-------------------*/
/*     BUCKfind      */
/*-------------------*/
/* Inputs: buck_search_level == 0       buck_search_level > 0
 *    fontindex.cur_tf_num		***KMR (used to have a nested comment)
 *              cur_ssnum
 *              font_type
 *              has_path
 *              cur_pix
 *              cur_font_hdr
 *              pathname
 *              symbolset.tt_platID
 *              symbolset.tt_specID
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  BUCKfind(int buck_search_lvl, int purge_bucket, PPBUCKET p_bucket)
#else
GLOBAL UW16
BUCKfind(buck_search_lvl, purge_bucket, p_bucket)
    int buck_search_lvl;
    int purge_bucket;
    PPBUCKET p_bucket;
#endif
{
    SL32         tfnum;
    UW16         cur_ssnum;
    HBUCKET      hb, hb0;
    PBUCKET      b;
    UW16         status;
    int          has_path;

    LPUB8        cur_font_hdr;

    int          font_type;
    int          rom_font;
    BOOLEAN      extern_font;
    UW16         fst_type;
#if TT_RDR
    UW16         platformID;    /* These are needed for */
    UW16         specificID;    /* TrueType BUCKET */
#endif

    DBG1("BUCKfind(%d)\n", buck_search_lvl);

    if( buck_search_lvl == 0 )      /* Typeface Sensitive level */
    {
        tfnum        = fontindex.cur_tf_num;
        cur_ssnum    = fontindex.cur_ssnum;
        font_type    = fontindex.font_type;
        has_path     = fontindex.has_path;

        rom_font     = (int)(font_type & FC_ROM_TYPE);
        extern_font  = ((font_type & FC_EXTERN_TYPE) == FC_EXTERN_TYPE);
        fst_type     = font_type & FC_FONTTYPE_MASK;

        switch (fst_type)
        {
#if IF_RDR
            case FC_IF_TYPE:
                fontindex.pix = fontindex.cur_pix;   /* IF disk or ROM */
#if DYNAMIC_FONTS
                if (fontindex.cur_pix)  /* If cur_pix is valid, then the TFS */
                    has_path = FALSE;   /* is in if.fnt. Even if there if a */
#endif                                  /* pathname, ignore it. */
                break;
#endif  /* IF_RDR */
#if TT_RDR
            case FC_TT_TYPE:
                if (fst_type == FC_TT_TYPE)
                {
#if ASIAN_ENCODING

                 /* Load "platformID" and "specificID" from "symbolset".
                  * No longer hard-wiring values.
                  *   12-06-93 jfd
                  */

                   if (cur_ssnum == JIS || cur_ssnum == SHIFT_JIS
                    || cur_ssnum == EUC || cur_ssnum == UNICODE
                    || cur_ssnum == BIG5 || cur_ssnum == TCA
                    || cur_ssnum == GB  || cur_ssnum == KSC
                  )
                   {
                        platformID = symbolset.tt_platID; /* 12-06-93 jfd */
                        specificID = symbolset.tt_specID; /* 12-06-93 jfd */
                   }

                   else
#endif /* ASIAN_ENCODING */
                   {
                      if (if_state.usePlugins)
                      {
                         platformID = symbolset.tt_platID; /* At TFS level these   */
                         specificID = symbolset.tt_specID; /* come from symbol set */
                      }
                      else      /* set to 0, if plugins are disabled because */
                      {         /* no symbol set has been loaded  mby, 11/18/93 */
                         platformID = 0;
                         specificID = 0;
                      }
                   }
                }
                break;
#endif  /* TT_RDR */
            default:  break;
        } /* switch (fst_type) */

        if (has_path)
            cur_font_hdr = (LPUB8)fontindex.pathname;
        else
            cur_font_hdr = fontindex.cur_font_hdr;
#if FCO_RDR
        if (fst_type == FC_FCO_TYPE)
            cur_font_hdr = (LPUB8)MEMptr(if_state.FCObject);
#endif
    } /* if( buck_search_lvl == 0 ) */


#if PLUGINS
    else  /* loading a plugin, buck_search_level > 0 */
    {
        has_path = FALSE;
        switch( fontindex.plug_type )
        {
#if (IF_RDR || PS_IFPLUG || TT_IFPLUG)   /*  Intellifont plugins  */
            case FC_IF_TYPE:
            {
               /*  Intellifont plugin  disk based */

                fontindex.pix = FIentry( buck_search_lvl - 1 );
                tfnum         = fontindex.pix->tfnum;
                font_type     = FC_IF_TYPE;   /* disk based */
                cur_font_hdr  = (LPUB8)NULL;
#if ROM
                /* if ROM is enabled, we assume ROM plugins for IF */
                font_type    |= FC_ROM_TYPE;
#endif
                break;
            }
#endif  /*  Intellifont Plugins  */
#if TT_RDR
#if TT_TTPLUG_ANY     /* TrueType plugins */
            case FC_TT_TYPE:
            {
                font_type = ttplug_font_type;
#if TT_TTPLUG
                tfnum = 0;
                cur_font_hdr = tt_fnt_hdr;
                platformID = TT_PLUGPLID;   /* Microsoft Unicode UGL, ix.h */
                specificID = TT_PLUGSPID;
                if ( !(font_type & FC_ROM_TYPE) )
                    has_path = TRUE;
#else
                tfnum         = ttplug_tfnum;
                fontindex.pix = fontindex.plugintt_pix;
                cur_font_hdr  = (LPUB8)NULL;
#endif
                break;
            }
#endif  /* TrueType plugins */
#endif  /* TT_RDR */

#if FCO_RDR
            case FC_FCO_TYPE:   /* 09-02-94, mby */
            {
                font_type = FC_FCO_TYPE;
                cur_font_hdr = (LPUB8)MEMptr(fontindex.fcoPlugHndl);
                if (buck_search_lvl >= fontindex.num_searches) /* level too large */
                    return ERR_no_cgnum;
                tfnum = fontindex.fcoSearchPath[buck_search_lvl-1];
                break;
            }
#endif  /* FCO_RDR */

            default:
                return ERR_no_cgnum;

        }  /*  switch  */

      /*  For any type of plugins, break out details of plugin font.
       */
        cur_ssnum     = 0;
        rom_font      = (int)(font_type & FC_ROM_TYPE);
        extern_font   = ((font_type & FC_EXTERN_TYPE) == FC_EXTERN_TYPE);
        fst_type      = font_type & FC_FONTTYPE_MASK;
    }
#endif  /*  PLUGINS  */





  /* Search for BUCKET  */

    hb0 = hb = ((PDLL)MEMptr(hBUCKlru))->f;   /* first BUCKET in lru list */
    while(hb != hBUCKlru)
    {
        b = (PBUCKET)MEMptr(hb);

    /* Search algorithm: (1) If there's a pathname, see if it matches with
         b->pathname.  (2) If ROM + dynamic font, compare cur_font_hdr to
         b->cur_font_hdr. We need to do this because b->tfnum is set inside
         ifload_font(), so the final comparison will always fail.
         (3) compare tfnum, symbol set, font_hdr, and font_type.
     */
#if TT_RDR
    /* For TT fonts we have to match on platform id and specific id. */
        if (fst_type == FC_TT_TYPE)
        {
            if (b->p.tt.platId != platformID  ||  b->p.tt.specId != specificID)
                goto Bf1;
        }
#endif  /* TT_RDR */

#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
        if (has_path)
        {
            if(b->has_path)
            {
                if(STRNCMP((LPSB8)cur_font_hdr,
                              b->pathname, PATHNAMELEN) == 0)
                {
                       b->cur_ssnum = cur_ssnum;
                       break;
                }
            }
        }
        else
#endif  /* (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)) */

#if (DYNAMIC_FONTS && ROM)
        if (rom_font && !tfnum)
        {
            if (b->cur_font_hdr == cur_font_hdr)
                break;
        }
        else
#endif  /* (DYNAMIC_FONTS && ROM) */

        if( (b->tfnum        == tfnum       )   && 
            (b->cur_ssnum    == cur_ssnum   )   &&
            (b->cur_font_hdr == cur_font_hdr)   &&
            (b->font_type    == font_type))
           break;
Bf1:
        if(hb == hb0)              /*  if first bucket in lru list, */
            b->locked = FALSE;     /*  unlock                       */

        hb = b->link.f;            /* next BUCKET in the list */
    } /* bucket search loop */




    if(purge_bucket)
    {
        if(hb != hBUCKlru)    /* found it */
            BUCKfree(hb);
        return SUCCESS;
    }

    if(hb != hBUCKlru)
    {                                                    /* found it */
      /*  Make BUCKET most recently used */
        DBG("    search succeeded\n");
#if TT_DISK
        if (fst_type == FC_TT_TYPE)
        {
           if(b->has_path)    /* 4-29-94 jfd */
           {
              status = IXopen_file((PINDEX_ENTRY)NULL, b);
              if (status)
                 return status;
           }
        }
#endif
        if(hb != hb0)              /* if not already first in list... */
        {
            b->locked =TRUE;
            dll_remove(hb);
            dll_after(hBUCKlru, hb);
        }
    }
    else  /* not found */
    {
        DBG("    search failed- making new BUCKET\n");

		hb = (HBUCKET)BUFalloc((SL32)sizeof(BUCKET));
		if (!hb)
			return ERR_no_buck_mem;

/*        if(!(hb = (HBUCKET)BUFalloc((SL32)sizeof(BUCKET))))		***KMR
            return ERR_no_buck_mem;
*/
        b = (PBUCKET)MEMptr(hb);
        MEMSET((LPUB8)b, (int)0, (int)sizeof(BUCKET) );

        b->my_handle   = hb;      /* remember who I am for freeing */
        b->fh          = -1;          /* no open file -ss 11/25/91 */
        b->tfnum       = tfnum;
        b->bucket_num  = 0;                     /* set to default  */
        b->font_type   = font_type;
        b->rom_font    = rom_font;
        b->fst_type    = fst_type;
        b->extern_font = extern_font;
        b->cur_font_hdr = cur_font_hdr;
        b->cur_ssnum   = cur_ssnum;  /* 10-26-92 jfd */
        b->usePlugins  = if_state.usePlugins;
#if TT_RDR
        if (fst_type == FC_TT_TYPE)
        {
           b->p.tt.platId = platformID;   /* needed by ttload_font() */
           b->p.tt.specId = specificID;
        }
#if TT_ROM1
        b->p.tt.entity1 = (if_state.rom_thing == ENTITY1) ? 1 : 0;
#endif
#endif  /* TT_RDR */

#if (PST1_DISK || TT_DISK || DYNAMIC_FONTS)
#if DYNAMIC_FONTS
#if ROM
        b->dynIFActive = (fst_type == FC_IF_TYPE) && !extern_font && cur_font_hdr;
        /* If dynamic, cur_font_hdr points to a font in ROM. */
#else
        b->dynIFActive = (fst_type == FC_IF_TYPE) && has_path;
#endif
#endif  /* DYNAMIC_FONTS */
        b->has_path = has_path;
        if(has_path)
            STRCPY(b->pathname, (LPSB8)cur_font_hdr);  /* mby 10/13/92 */
#endif  /* PST1_DISK || TT_DISK || DYNAMIC_FONTS */

#if USE_JUMP_TABLES
        switch (b->fst_type)
        {
        case FC_IF_TYPE:
#if IF_RDR
         DBG("    fst_type = Intellifont\n");
         b->pft = &iffunc_tbl;
         break;
#endif
#if PST1_RDR
        case FC_PST1_TYPE:
         DBG("    fst_type = PostScript\n");
         b->pft = &psfunc_tbl;
         break;
#endif
#if TT_RDR
        case FC_TT_TYPE:
         DBG("    fst_type = TrueType\n");
         b->pft = &ttfunc_tbl;
         break;
#endif /* TT_RDR */
#if FCO_RDR
        case FC_FCO_TYPE:
         DBG("    fst_type = Font Collection Object\n");
         b->pft = &fco_func_tbl;
         break;
#endif /* FCO_RDR */
        default:
         BUFfree(hb);
         return ERR_fst_type;
        }
#endif /* USE_JUMP_TABLES */

#if ASIAN_ENCODING && TT_RDR    /* 3/11/93 maib */ /* 1/18/94 jfd  */
      /*
       * 3/11/93 maib, hard-code id's needed for now, symbol set not read
       *               therfore these values not set.
       * 7/1/93  jfd   Only hard-code them if fst_type is TT.
       *12/06/93 jfd   Don't hard-code id's anymore.
       */
      if (b->fst_type == FC_TT_TYPE)
      {
    /* Correct platform and specific IDs should be available in "symbolset".

     *    12-06-93 jfd
     */
        if ((fontindex.cur_ssnum == JIS) || (fontindex.cur_ssnum == SHIFT_JIS)
          || (fontindex.cur_ssnum == EUC) || (fontindex.cur_ssnum == UNICODE)
          || (fontindex.cur_ssnum == BIG5) || (fontindex.cur_ssnum == TCA)
          || (fontindex.cur_ssnum == GB)  || (fontindex.cur_ssnum == KSC)
           )
        {
          b->p.tt.platId = platformID;
          b->p.tt.specId = specificID;
        }

      }
#endif /* ASIAN_ENCODING && TT_RDR */


#if USE_JUMP_TABLES
        status =
          ((*((PIF_FUNC_TBL)b->pft)->load_font)((PFONT_DES)cur_font_hdr, b));
#else
         switch (b->fst_type)
         {
#if IF_RDR
            case FC_IF_TYPE:
               status = ifload_font ((LPSB8)cur_font_hdr, b);
               break;
#endif
#if PST1_RDR
            case FC_PST1_TYPE:
               status = psload_font ((LPSB8)cur_font_hdr, b);
               break;
#endif
#if TT_RDR
            case FC_TT_TYPE:
               status = ttload_font ((LPSB8)cur_font_hdr, b);
               break;
#endif
#if FCO_RDR
            case FC_FCO_TYPE:
               status = fco_load_font ((LPSB8)cur_font_hdr, b);
               break;
#endif
            default:
               return (ERR_fst_type);
         }
#endif /* USE_JUMP_TABLES */

        if (status)
        {
            DBG("    load_font() failed in BUCKfind()\n");
            BUFfree(hb);
            return status;
        }
        else
            dll_after(hBUCKlru, hb);      /* link at start of BUCKET lru list */
    }  /* bucket not found; made a new bucket. */

#if PLUGINS
    /*  If have only determined up to TFS level, now determine plugins.  */

#if FCO_RDR

    /* If FCO_RDR is enabled, always use FCO plugins regardless of
     * fst type.
     */
    if (!fontindex.fcoSearchPath_on)
    {
        fontindex.plug_type = FC_FCO_TYPE;
        fontindex.fcoSearchPath_on = 1;
        fco_pluginSearchPath(b, &fontindex.fcoPlugHndl,
                fontindex.fcoSearchPath, &fontindex.num_searches);
#if PCLEO_RDR

    /* If TFS was a pcleo, need to load symbolset first and last character 
     * in order to locate the character in the FCO plugins */

        if (fcCur.format & FC_EXTERN_TYPE)
        {
           if (!b->usePlugins)  /* mby, 6-06-95 */
           {
              if (!SYMnoMap(fcCur.font_hdr, fcCur.format))
                 return ERR_IXnew_ss;
           }
           else
           {
              if (!SYMnew(fcCur.ssnum, fcCur.format))
                 return ERR_IXnew_ss;
           }
        }
#endif        
    }
#else

    if(fontindex.num_searches <= 1  &&  b->usePlugins) /* setup plugin search path */
    {
        fontindex.plug_type = 0xFFFF;   /* Invalid type */
#if TT_TTPLUG_ANY
        if(fst_type == FC_TT_TYPE)
        {
            fontindex.plug_type = FC_TT_TYPE;
            fontindex.num_searches++;    /* added another search level */
        }
#endif

#if (IF_RDR || PS_IFPLUG || TT_IFPLUG)   /* Intellifont plugins  */
        if( ( fst_type == FC_IF_TYPE                ) ||
            ((fst_type == FC_PST1_TYPE) && PS_IFPLUG) ||
            ((fst_type == FC_TT_TYPE  ) && TT_IFPLUG))
        {
/* A quick rundown:
    if AWT font substitution is on, then pass bits in awt header to
        IXset_search_path().
    else pass bits in b->bucket_num to IXset_search_path().
        if B_PLUGIN_TYPE_TT is set, then use the TT plugin
*/
#if CONVERGENT_FONTS
            if (if_state.awtsub_on)
            {
                if (awtData.useIFplugins)
                {
                    fontindex.plug_type = FC_IF_TYPE;
                    status = IXset_search_path((SW16)awtData.IFpluginDesc);
                    if (status)
                       return status;
                }
                else
                    fontindex.plug_type = FC_TT_TYPE;
            }
            else
#endif
            {
#if MULTIFORMAT
                if (b->bucket_num & B_PLUGIN_TYPE_TT)
                {
                    fontindex.plug_type = FC_TT_TYPE;
                    fontindex.num_searches++;
                }
                else
#endif
                {
                    fontindex.plug_type = FC_IF_TYPE;
                    status = IXset_search_path(b->bucket_num);
                    if (status)
                       return status;
                }
            }
        }
#endif  /* (IF_RDR || PS_IFPLUG || TT_IFPLUG)   Intellifont plugins  */
    }  /* if (fontindex.num_searches <= 1) */

#endif  /*  FCO_RDR  */
#endif  /*  PLUGINS  */

    b->locked = TRUE;
    if_state.pbucket = b;
    *p_bucket = b;
    return SUCCESS;
}


/*------------------------------------------------------------------*/
/*         B u f f e r    M e m o r y    M a n a g e m e n t        */



/*------------------*/
/*     BUFalloc    */
/*------------------*/
/* Acquire size SB8s. Free lru BUCKETs if need be   */
#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE BUFalloc(SL32 size)
#else
GLOBAL MEM_HANDLE
BUFalloc(size)
    SL32 size;
#endif
{
    MEM_HANDLE hbuf;
    HBUCKET hb;

	hbuf = MEMalloc(BUFFER_POOL, size);
	while (!hbuf)
/*    while (!(hbuf=MEMalloc(BUFFER_POOL, size)))	***KMR */
    {
       if(dll_empty(hBUCKlru)) return NIL_MH;
       hb = ((PDLL)MEMptr(hBUCKlru))->b;
       if(((PBUCKET)MEMptr(hb))->locked) return NIL_MH;
              /* Only the most recently used BUCKET can be locked. */
       BUCKfree(hb);     /* free lru BUCKET */
	   hbuf = MEMalloc(BUFFER_POOL, size);	/* ***KMR */
    }
    return hbuf;
}




/*------------------*/
/*     BUFfree      */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  BUFfree(MEM_HANDLE h)
#else
GLOBAL VOID
BUFfree(h)
    MEM_HANDLE h;
#endif
{
    MEMfree(BUFFER_POOL, h);
}

#if !defined(MEM_DUMP)
#define MEM_DUMP 0
#endif
#if MEM_DUMP
/*-------------------*/
/*     BUFdump       */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL SL32  BUFdump(UW16 print)
#else
GLOBAL SL32
BUFdump(print)
    UW16 print;
#endif
{
    HBUCKET      hb;
    PBUCKET      b;
    SL32 size;
    SL32 total = 0L;

    if(print) printf("BUFFERS\n");

    hb = ((PDLL)MEMptr(hBUCKlru))->f;     /* first BUCKET in lru list */
    while(hb != hBUCKlru)
    {
        b = (PBUCKET)MEMptr(hb);
        size = *((LPSL32)((LPSB8)b - 4));
        total += size;
        
        size = *((LPSL32)(MEMptr(b->hfgseg)-4));
        total += size;
        
        size = *((LPSL32)(MEMptr(b->hface_header_seg)-4));
        total += size;
        
        if(print) printf("Handle %6lx  Pointer %Fp size %5ld\n",hb, b, size);
        hb = b->link.f;                    /* next BUCKET in the list */


    }
    if(print) printf("BUFFER totals %ld\n", total);

    return total;
}

#endif /* MEM_DUMP */


#ifdef PRINT_BUCKETS
print_buckets()
{
    HBUCKET      hb;
    PBUCKET      b;
    hb = ((PDLL)MEMptr(hBUCKlru))->f;   /* first BUCKET in lru list */
    while(hb != hBUCKlru)
    {
        b = (PBUCKET)MEMptr(hb);
        hb = b->link.f;            /* next BUCKET in the list */
        printf("bucket %lx:  tfnum = %ld  bucket_num = %04X\n", b, b->tfnum, b->bucket_num);
        printf("  font_type = %04X, extern_font = %d, cur_ssnum = %04X\n", b->font_type, b->extern_font, b->cur_ssnum);
        printf("  has_path = %d", b->has_path);
        if (b->has_path)
           printf("  pathname = %s", b->pathname);
        printf("\n");
    }
}
#endif
