/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/chr_def.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: chr_def.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.39   18 Sep 1995 16:25:30   JOE
 * In IXsetup_chr_def(), changed conditional compile directive to
 * resolve compiler error when FCO is disabled.
 * 
 *    Rev 1.38   18 Sep 1995 13:34:40   JOE
 * In IXsetup_chr_def(), added code to support case where there is not
 * plugin augmentation for TT or PS.
 * 
 *    Rev 1.37   18 Sep 1995 11:20:18   MIKE
 * Fixed problems with fixed space processing
 * 
 *    Rev 1.36   11 Sep 1995 15:35:04   JOE
 * In above comment, replaced the comment delimiters with the words
 * "comment delimiters" to resolve compiler error.
 * 
 *    Rev 1.35   11 Sep 1995 08:14:12   JOE
 * In IXsetup_chr_def(), added comment delimiters around comment following
 * "#endif" directive.
 * 
 *    Rev 1.34   08 Sep 1995 08:23:40   JOE
 * In IXsetup_chr_def(), modified test which checks for potential
 * external compound character so that it is done only once.
 * 
 *    Rev 1.33   07 Sep 1995 18:12:04   JOE
 * Added declarations for externals "fcCur" and "missing_ccparts".
 * In IXsetup_Chr_def(), added test for external compound character
 * and calls to BUCKfind() and DAmake_cd() to map the cg# to the
 * appropriate FCO unicode #.
 * In same routine, if TFS search fails, set "plug_type" to IF in
 * case character is an external compound character.
 * ALso in same routine, added code to retrieve space character
 * escapement if processing FCO plugins.
 * 
 *    Rev 1.32   25 Aug 1995 16:48:30   JOE
 * Removed "22-Aug-95" change (PS space support).
 * 
 *    Rev 1.31   22 Aug 1995 16:01:58   JOE
 * In IXsetup_chr_def(), added support for space character when
 * FCO_RDR is enabled.
 * 
 *    Rev 1.30   18 Apr 1995 16:47:10   JOE
 * In IXsetup_chr_def(), added support for the removal of symbol
 * set mapping.
 * 
 *    Rev 1.29   06 Apr 1995 15:14:46   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.28   10 Feb 1995 11:28:48   JOE
 * 
 * In IXsetup_chr_def(), added checks for This, EN and EM spaces
 * when processing FCO's.
 * 
 *    Rev 1.27   16 Jan 1995 14:04:28   JOE
 * 
 * In IXsetup_chr_def(), conditionally compiled check for status ==
 * ERR_no_ccpart if (SLIM_FONTS && !FCO_RDR) because we must search FCO
 * plugins if FCO_RDR is enabled.
 * 
 *    Rev 1.26   02 Dec 1994 21:04:50   MIKE
 * 
 * KSC (YAN).
 * 
 *    Rev 1.25   31 Aug 1994 17:50:38   MIKE
 * 
 * Process FCO space char (32) if not found in TFS.
 * 
 *    Rev 1.24   22 Apr 1994 13:55:16   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.23   03 Feb 1994 15:45:18   MIKE
 * Change fontindex.awtsub_on to if_state.awtsub_on.
 * 
 *    Rev 1.22   02 Feb 1994 09:01:22   JOE
 * 
 * Removed #include for "fcntl.h" .
 * 
 *    Rev 1.21   05 Jan 1994 18:12:24   ROB
 * Add support for "GB" encoding.
 * 
 *    Rev 1.20   08 Dec 1993 18:59:54   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.19   01 Dec 1993 08:39:52   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.18   30 Nov 1993 14:49:00   ROB
 * Add BIG5 support and TCA hooks.
 * 
 *    Rev 1.17   11 Nov 1993 16:28:18   JOE
 * In IXsetup_chr_def(), added UNICODE changes for KANJI.
 * 
 *    Rev 1.16   27 Oct 1993 09:52:14   MIKE
 * Fix convergent font bug in IXsetup_chr_def().
 * 
 *    Rev 1.15   23 Sep 1993 20:03:44   MIKE
 * 
 * In IXsetup_chr_def() bypass plugins if PBUCKET->usePlugins is set.
 * 
 *    Rev 1.14   12 Aug 1993 10:43:02   MIKE
 * 
 * CONVERGENT_FONTS tune-up in IXsetup_chr_def().
 * 
 *    Rev 1.13   21 Jul 1993 14:36:26   MAIB
 * Included forgotten #if convergent_fonts check
 * 
 *    Rev 1.12   15 Jul 1993 12:04:44   MIKE
 * Convergent font support.
 * 
 *    Rev 1.11   01 Jul 1993 15:13:12   JOE
 * EUC KANJI support.
 * 
 *    Rev 1.10   14 Jun 1993 17:17:28   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.9   29 Mar 1993 11:08:00   ROB
 * Changes for Kanji - cleanup, do not augment symbol sets on Kanji fonts.
 * 
 *    Rev 1.8   03 Mar 1993 08:14:26   JOE
 * For previous fix in IXsetup_chr_def(), when masking out font type bits,
 * use FC_FONTTYPE_MASK instead of FC_TT_TYPE.
 * 
 *    Rev 1.7   01 Mar 1993 16:13:22   JOE
 * In IXsetup_chr_def(), when checking for TT font type, mask out all other
 * 
 * 
 * bits of font_type field.
 * 
 *    Rev 1.6   01 Mar 1993 12:07:42   JOE
 * In IXsetup_chr_def(), if cgnum == 812, use spaceband value instead of
 * thinspacereverse value for escapement.
 * 
 *    Rev 1.5   12 Feb 1993 13:17:54   JOE
 * VXWorks support.
 * 
 *    Rev 1.4   29 Jan 1993 16:32:20   JOE
 * In IXsetup_chr_def(), adjust escapements if native design units are
 * not 8782's.
 * 
 *    Rev 1.3   29 Jan 1993 09:08:16   JOE
 * In IXsetup_chr_def(), saved em box size under various conditions.
 * 
 *    Rev 1.2   06 Jan 1993 15:02:34   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:57:56   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:50   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* chr_def.c */
/*
 *
 *
 * History
 *
 *    04-Sep-90  awr   Removed find_compound()- no longer referenced.
 *    19-Dec-90  jfd   IFB on a Printer changes:
 *                     2.) Changed first argument of IXsetup_chr_def() from
 *                         "cgnum" to "chId".
 *    30-Jan-91  dET   Added function prototyping for MSC
 *    31-Jan-91  dET   Modify for MSC multi-model compilation.
 *     4-Feb-91  awr   Split off from ix.c
 *     9-Feb-91  awr   Added #include "sym.h" to declare symbol set fncts.
 *    04-Mar-91  jfd   Added function prototype for DAmake_cd().
 *    30 May 91  ss    Changed for limit to NBUCKET_LEVELS in
 *                     IXsetup_chr_def()
 *     5 Jun 91  ss    Added support for FIXED_PITCH.
 *                     Added a fix for SLIM_FONTS bug.
 *    17-Jun-91  jfd   Moved "debug.h" after "port.h".
 *                     Moved "cgconfig.h" before "port.h".
 *    24 Jun 91  ss    Conditionally compile io.h based on system type.
 *     2 Oct 91  ss    Deleted lines in IXsetup_chr_def() for FIXED_PITCH 
 *                     causing error.
 *    05 Feb 92  rs    Clean up compiler warnings.
 *     8-Mar-92  awr   Added core font substitution for PS and TT
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    09-Apr-92  rs    Disable unconditional return for space (812) char in
 *                     IXsetup_chr_def(). Only return error if char not found.
 *    23 Apr 92  ss    Reordered loop over BUCKfind()/DAmake_cd().
 *                     Changed name, fontindex.num_levels to .num_searches.
 *    22-May-92  rs    Remove conditioned out code from 'IXsetup_chr_def()'
 *                     for fixed space support (cleanup purposes). Add other
 *                     space chars (thinspace, enspace, emspace & reverses).
 *    18-Jun-92  jfd   In IXsetup_chr_def(), if have a fixed space character
 *                     not in the font, store the metrics for the character
 *                     in the CHAR_STATS structure.
 *                     Added EXTERN for if_state.
 *    31 Jul 92  ss    Special case handling of ss_num == 0 for PCLEOs with
 *                     symbol sets not know to us, (not in IF.SS.)
 *    10-Sep-92  jfd   In IXsetup_chr_def(), reload typeface-sensitive 
 *                     bucket before attempting to retrieve fixed space
 *                     relative width value.
 *    14-Sep-92  jfd   In IXsetup_chr_def(), added code to retrieve space
 *                     character width from IF PCLEO. If processing PS or TT
 *                     and space character was not found, reload core 
 *                     plugin rather than TFS bucket.
 *    28-Sep-92  awr   Changed parameters of BUCKfind(), DAmake_cd()
 *    12-Oct-92  mby   For TT, skip special code for space char handling.
 *                 @@@ What should we do about fixed spaces for PST1 fonts?
 *    06-Jan-93  jfd   ANSI C function declaration changes.
 *    27-Jan-93  jfd   In IXsetup_chr_def(), if processing a space character,
 *                     storing em box size values into "if_state.cs".
 *    29-Jan-93  jfd   Adjust escapement if native design units are not in
 *                     8782's.
 *                     Included "fpmath.h".
 *    08-Feb-93  jfd   VXWorks support.
 *    01-Mar-93  jfd   In IXsetup_chr_def(), for cgnum == 812, use spaceband
 *                     value instead of thinspacereverse value for escapement.
 *    01-Mar-93  ss/jfd/dbk
 *                     In IXsetup_chr_def(), when checking for TT font type,
 *                     mask out all other bits of font_type field.
 *    03-Mar-93  awr   For previous fix, when masking out font type bits,
 *                     use FC_FONTTYPE_MASK instead of FC_TT_TYPE.
 *    27-Mar-93  rs    Support for Kanji - do not augment symbols sets
 *                     for JIS or SHIFT-JIS mapping.
 *    04-Jun-93  jfd   Support for Type 1 encoding - do not augment symbol
 *                     sets for Type 1 encoding mapping.
 *                     Including "t1itype1.h".
 *    30-Jun93 jfd/gy  EUC KANJI support.
 *    13-Jul-93  mby   Convergent Fonts: in IXsetup_chr_def() handle no TFS case.
 *    21-Jul-93  maib  Checked to make sure convergent fonts was defined befor
 *                     declaring awtData
 *    12-Aug-93  mby   CONVERGENT_FONTS tune-up in IXsetup_chr_def().
 *    22-Sep-93  mby   Look at PBUCKET->usePlugins flag to bypass plugins.
 *                     Some cleanup in IXsetup_chr_def().
 *    26-Oct-93  mby   Fix bug in IXsetup_chr_def() for convergent fonts when
 *                     there is no supersensitive face. Only set the plugin
 *                     search path if num_searches is 1.
 *    11-Nov-93  gy    In IXsetup_chr_def(), added UNICODE changes for
 *                     KANJI.
 *    23-Nov-93  rs    Add BIG5 & TCA to KANJI_ENCODING support.
 *    01-Dec-93  jfd   Changed KANJI_ENCODING to ASIAN_ENCODING.
 *    08-Dec-93  rs    General cleanup - MSDOS & OS2.
 *    05-Jan-94  rs    Add support for "GB" encoding.
 *    26-Jan-94  jfd   Removed #include for fcntl.h .
 *    02-Feb-94  mby   Change fontindex.awtsub_on to if_state.awtsub_on.
 *    31-Aug-94  mby   Added FCO space character processing, if unicode 32
 *                     is not found in the TFS. Use the spaceband width from
 *                     the FCO bucket.
 *    16-Jan-95  jfd   In IXsetup_chr_def(), conditionally compiled check for 
 *                     status = ERR_no_cc_part if (SLIM_FONTS && !FCO_RDR)
 *                     because we must search FCO plugins if FCO_RDR is
 *                     enabled.
 *    09-Feb-95  jfd   In IXsetup_chr_def(), added checks for Thin, EN and
 *                     EM spaces when processing FCO's.
 *    18-Apr-95  jfd   In IXsetup_chr_def(), added support for the
 *                     removal of symbol set mapping.
 *    22-Aug-95  jfd   In IXsetup_chr_def(), added support for space
 *                     character processing when FCO_RDR is enabled.
 *                     (This fixes the PS space character escapement bug.)
 *    25-Aug-95  jfd   Removed "22-Aug-95" change above.
 *    07-Sep-95  jfd   Added declarations for externals "fcCur" and 
 *                     "missing_ccparts".
 *                     In IXsetup_Chr_def(), added test for external
 *                     compond character and calls to BUCKfind() and
 *                     and DAmake_cd() to map the cg# to the appropriate
 *                     FCO unicode #.
 *                     In same routine, if TFS search fails, set "plug_type" 
 *                     to IF in case character is an external compound character.
 *                     In same routine, added code to retrieve space
 *                     character escapement if processing FCO plugins.
 *    08-Sep-95  jfd   In IXsetup_chr_def(), modified test which checks
 *                     for potential external compound character so that
 *                     it is only done once.
 *    11-Sep-95  jfd   In IXsetup_chr_def(), added comment delimiters around
 *                     comment following "#endif" directive.
 *    15-Sep-95  mby   Fixed problems with fixed space processing.
 *    18-Sep-95  jfd   In IXsetup_chr_def(), added code to support case
 *                     where there is no plugin augmentation for
 *                     TT or PS.
 *                     In IXsetup_chr_def(), changed conditional compile
 *                     directive to resolve compiler error when FCO is
 *                     disabled.
 */


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>


#include "cgconfig.h"
#include "port.h"

#if defined (MSDOS) || defined (__OS2__)
#include <io.h>
#endif

#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "segments.h"
#include "cgif.h"
#include "ix.h"
#include "sym.h"
#include "if_type.h"

#if PCLEO_RDR
#include "pcleo.h"
#endif

#include "fpmath.h"

#if ASIAN_ENCODING /* 3/27/93 - rs */
#include "kanji.h"
#endif


/* Character specific data (# parts, escape, is_compound, etc.) */

GLOBAL CHR_DEF chr_def[MAX_CC_PARTS];
GLOBAL CHR_DEF_HDR chr_def_hdr;


#ifdef LINT_ARGS
GLOBAL UW16 IXsetup_chr_def(UW16, PCHR_DEF, PPBUCKET);
EXTERN UW16 IXset_search_path(SW16);
EXTERN UW16 BUCKfind(int, int, PPBUCKET);
EXTERN UW16 DAmake_cd(PBUCKET, UW16, PCHR_DEF, int);
EXTERN LPSB8 fgseg(PBUCKET);
#if IF_RDR
EXTERN UW16  fco_map_cgnum_to_unicode( UW16 );
#endif
#else
GLOBAL UW16 IXsetup_chr_def();
EXTERN UW16 IXset_search_path();
EXTERN UW16 BUCKfind();
EXTERN UW16 DAmake_cd();
EXTERN LPSB8 fgseg();
#if IF_RDR
GLOBAL UW16  fco_map_cgnum_to_unicode();
#endif
#endif

EXTERN IF_STATE if_state;
EXTERN FONTINDEX fontindex;
#if CONVERGENT_FONTS
EXTERN AWT_TABLE awtData;
#endif
#if PCLEO_RDR
EXTERN SYMBOLSET symbolset;
#endif

#if FCO_RDR && (PST1_RDR || TT_RDR) && (TT_IFPLUG || PS_IFPLUG)
EXTERN FONTCONTEXT fcCur;
EXTERN SW16      missing_ccparts;
#endif

/*-------------------*/
/* IXsetup_chr_def   */
/*-------------------*/
/*  Setup chr_def, the character definition structure for chId.
 *  Returns a pointer to the BUCKET in which chId was found.
 *  If chId references a compound character, then all parts of
 *  the compound character must be in the same bucket that listed
 *  chId in its compound character segment.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  IXsetup_chr_def(UW16 chId, PCHR_DEF chr_def, PPBUCKET p_bucket)
#else
GLOBAL UW16
IXsetup_chr_def(chId, chr_def, p_bucket)
    UW16     chId;
    PCHR_DEF chr_def;
    PPBUCKET p_bucket;
#endif
{
    UW16   status;
    int    buck_search_lvl;
#if (IF_RDR || PST1_RDR)
    int    reload_buck_search_lvl=0;
#endif
#if !DU_ESCAPEMENT
    FPNUM  tmp_fp,
           factor;
#endif

    DBG1("IXsetup_chr_def(chId = %d)\n", chId);

  /*  Search each BUCKET for cgnum. The order of the search is
   *  typeface sensitive, limited sensitive, universal.
   */
    buck_search_lvl = 0;

#if NO_SYMSET_MAPPING
#if PCLEO_RDR
    if ( !((fontindex.font_type & FC_EXTERN_TYPE) == FC_EXTERN_TYPE) )
#endif  /* PCLEO_RDR */
       chId = *(UW16 *)if_state.chIdptr;
#endif  /* NO_SYMSET_MAPPING */


#if CONVERGENT_FONTS
    if (if_state.awtsub_on && fontindex.noTFS)
    {                     /* SYMmap(chId) not in AWT && awtData.no_sstfs */
        buck_search_lvl++;
        if (fontindex.num_searches == 1)    /* mby, 10/26/93 */
        {
            if (awtData.useIFplugins)
            {
                fontindex.plug_type = FC_IF_TYPE;
                status = IXset_search_path((SW16)awtData.IFpluginDesc);
                if (status)
                    return status;
            }
            else
            {
                fontindex.plug_type = FC_TT_TYPE;
                fontindex.num_searches++;
            }
        }
    }
#endif

#ifdef PRINT_BUCKETS
  print_buckets();
#endif
    do      /* while (buck_search_lvl < fontindex.num_searches) */
    {
        status = BUCKfind(buck_search_lvl, CREATE_BUCKET, p_bucket);
        if (status)
            return status;

        if(SUCCESS ==
            (status = DAmake_cd(*p_bucket, chId, chr_def, buck_search_lvl)) )
            return SUCCESS;

#if FCO_RDR && (PST1_RDR || TT_RDR) && (TT_IFPLUG || PS_IFPLUG)
        /* If using FCO plugins with PS or TT and encounter an external 
         * compound  character, the cg # is stored in "cd->cgnum". Set the
         * plugin type to FCO and call BUCKfind() and DAmake_cd() 
         * again to map the cg # to the corresponding unicode number.
         */
        if ( (FC_ISPST1(&fcCur) || FC_ISTT(&fcCur)) && missing_ccparts
                && (fontindex.plug_type != FC_FCO_TYPE) )
        {
           fontindex.plug_type = FC_FCO_TYPE;

           status = BUCKfind(buck_search_lvl, CREATE_BUCKET, p_bucket);
           if (status)
               return status;

           if(SUCCESS ==
            (status = DAmake_cd(*p_bucket, chId, chr_def, buck_search_lvl)) )
            return SUCCESS;
        }
        else if ( buck_search_lvl )
           fontindex.plug_type = FC_FCO_TYPE;
#endif /* FCO_RDR && (PST1_RDR || TT_RDR) && (TT_IFPLUG || PS_IFPLUG) */

#if FCO_RDR
      /* if TFS && unicode space character, go to fixed space processing */
        if (buck_search_lvl == 0  &&
             (fontindex.font_type & FC_FONTTYPE_MASK) == FC_FCO_TYPE  &&
             ( ((*p_bucket)->p.fco.unicode == 32)     ||
               ((*p_bucket)->p.fco.unicode == 0x2002) ||
               ((*p_bucket)->p.fco.unicode == 0x2003) ||
               ((*p_bucket)->p.fco.unicode == 0x2009)) )
            break;
#endif

#if !NO_SYMSET_MAPPING
        if ( !((*p_bucket)->usePlugins) )
            return status;
#endif  /* !NO_SYMSET_MAPPING */

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
         /*    add 6/04/93 - jfd
            Ifthis is a Type 1 encoding mapping - do not augment symbol set
         */
         if ((*p_bucket)->cur_ssnum == T1ENCODING)
            return (status);
#endif

#if ASIAN_ENCODING
         /*    add 3/27/93 - rs
            Ifthis is a Kanji mapping - do not augment symbol set
         */
         if ((*p_bucket)->cur_ssnum == JIS
            || (*p_bucket)->cur_ssnum == SHIFT_JIS
            || (*p_bucket)->cur_ssnum == EUC
            || (*p_bucket)->cur_ssnum == UNICODE
            || (*p_bucket)->cur_ssnum == BIG5
            || (*p_bucket)->cur_ssnum == TCA
            || (*p_bucket)->cur_ssnum == GB
            || (*p_bucket)->cur_ssnum == KSC
            )
            return (status);
#endif /* ASIAN_ENCODING */

#if SLIM_FONTS && !FCO_RDR
        /*  DAmake_cd => LIBmake_cd already checked for external parts  */
        /*  if a part is missing, return an error.          -ss 6/11/91 */
        if( status == ERR_no_cc_part )
            return ERR_no_cc_part;
#endif

#if PST1_RDR
        if (!buck_search_lvl && ((*p_bucket)->fst_type == FC_PST1_TYPE))
           reload_buck_search_lvl++;    /* if PST1, load core plugin */
#endif /* PST1_RDR */

#if FCO_RDR && (PST1_RDR || TT_RDR) && (TT_IFPLUG || PS_IFPLUG)
        /* If processing PS or TT with FCO plugins and TFS search fails, 
         * set up next bucket search for possible external compound 
         * character by setting "plug_type" to "FC_IF_TYPE".
         *   8-25-95 jfd
         */
        if ( !buck_search_lvl && 
             ( ((*p_bucket)->fst_type == FC_PST1_TYPE) ||
               ((*p_bucket)->fst_type == FC_TT_TYPE)) )
        {                                                               /* 8-25-95 */
           /* Set up for core font processing   9-6-95 jfd */
           fontindex.plug_type = FC_IF_TYPE;                            /* 8-25-95 */
        }                                                               /* 8-25-95 */
#endif /* FCO_RDR && (PST1_RDR || TT_RDR) && (TT_IFPLUG || PS_IFPLUG) */

#if FCO_RDR && (IF_RDR || PST1_RDR) && NO_SYMSET_MAPPING

        /* If not using symbol set mapping and character was not
         * found in IF or PS TFS, map cgnum to unicode before searching
         * FCO plugins
         */
        if ( ((*p_bucket)->fst_type == FC_IF_TYPE) ||
             ((*p_bucket)->fst_type == FC_PST1_TYPE) )
        {
           if ( (chId = fco_map_cgnum_to_unicode(*(UW16 *)if_state.chIdptr)) == FAILURE)
              chId = *(UW16 *)if_state.chIdptr;  /* restore chId in case char is ext cc */
        }
#endif /* FCO_RDR && IF_RDR && NO_SYMSET_MAPPING */

#if TT_RDR && PCLEO_RDR && NO_SYMSET_MAPPING

        /* If not using symbol set mapping and character was not
         * found in TT TFS, substitute unicode for before searching
         * FCO plugins
         */
        if ( ((fontindex.font_type & FC_EXTERN_TYPE) == FC_EXTERN_TYPE) &&
             ((*p_bucket)->fst_type == FC_TT_TYPE) )
           chId = *(UW16 *)if_state.chIdptr;

#endif /* FCO_RDR && IF_RDR && NO_SYMSET_MAPPING */
        buck_search_lvl++;
    } while( buck_search_lvl < fontindex.num_searches );

/* - - - - - - - - - - - - */

#if FCO_RDR && IF_RDR && NO_SYMSET_MAPPING
    chId = *(UW16 *)if_state.chIdptr;  /* restore original chId */  /* ? PS ? */
#endif  /* FCO_RDR && IF_RDR && NO_SYMSET_MAPPING */

#if (TT_RDR && (TT_NOPLUG || TT_TTPLUG))
    if ( (fontindex.font_type & FC_FONTTYPE_MASK) == FC_TT_TYPE)
    {
       if_state.cs.du_emx = if_state.cs.du_emy = 0;
       if_state.cs.escapement = 0;
       return (ERR_find_cgnum);
    }
#endif  /* 9-13-95 jfd */
#if (PST1_RDR && PS_NOPLUG)
    if ( (fontindex.font_type & FC_FONTTYPE_MASK) == FC_PST1_TYPE)
    {
       if_state.cs.du_emx = if_state.cs.du_emy = 0;
       if_state.cs.escapement = 0;
       return (ERR_find_cgnum);
    }
#endif  /* 9-13-95 jfd */
#if FCO_RDR
    if ( ((fontindex.font_type & FC_FONTTYPE_MASK) == FC_FCO_TYPE) || /* 08-31-94, mby */
         ((fontindex.font_type & FC_FONTTYPE_MASK) == FC_TT_TYPE))    /* 09-13-95, jfd */
    {
#define  IFDESIGNUNITS       8782
#if DU_ESCAPEMENT
       if_state.cs.du_emx = if_state.cs.du_emy = (*p_bucket)->p.fco.design_EmRes;
#else
       SL32  nn, esk;
       if_state.cs.du_emx = if_state.cs.du_emy = IFDESIGNUNITS;
#endif
       if_state.cs.escapement = 0;

       if ((*p_bucket)->p.fco.unicode == 32)
          if_state.cs.escapement = (*p_bucket)->p.fco.spaceBand;
       else if ((*p_bucket)->p.fco.unicode == 0x2002)
          if_state.cs.escapement = (*p_bucket)->p.fco.ENSpace;
       else if ((*p_bucket)->p.fco.unicode == 0x2003)
          if_state.cs.escapement = (*p_bucket)->p.fco.EMSpace;
       else if ((*p_bucket)->p.fco.unicode == 0x2009)
          if_state.cs.escapement = (*p_bucket)->p.fco.ThinSpace;

       if ( ((*p_bucket)->p.fco.unicode == 32) ||
              ((*p_bucket)->p.fco.unicode == 0x2002) ||
              ((*p_bucket)->p.fco.unicode == 0x2003) ||
              ((*p_bucket)->p.fco.unicode == 0x2009) )
       {
#if !DU_ESCAPEMENT
          nn = (SL32)(*p_bucket)->p.fco.design_EmRes;
          esk = ((SL32)if_state.cs.escapement * (SL32)IFDESIGNUNITS + (nn >> 1)) / nn;
          if ((*p_bucket)->p.fco.compositionFlag)
          {
/* Compensate for rounding when FCO is converted to 8782-based
   Multiply by FCO|TT|PS point size / Inteliifont point size: 12500/12447 */
              esk = (esk * 12500L + 6223L) / 12447L;
          }
          if_state.cs.escapement = (UW16)esk;
#endif
          return (ERR_fixed_space);
       }
       else
          return (ERR_find_cgnum);
    }
#endif  /* FCO_RDR */

#if FCO_RDR && (IF_RDR || PST1_RDR)
    else
#endif

#if (IF_RDR || PST1_RDR)
  /*
     Handle fonts with various space chars.
     Do this only for Intellifont and Type 1.
  */
  /* Map the symbol set code into a cg # for libraries & plugins for PCLEOs */

    {
    UW16      cgnum;
    SL32      des_em_width;
    PDISPLAY  display;
    SW16      em_box;
    LPSB8     pfgseg;
    FPNUM     tmp_fp_em;
    UW16      width_pos;

#if NO_SYMSET_MAPPING
        cgnum = *(UW16 *)if_state.chIdptr;
#else
#if PCLEO_RDR
        if (symbolset.curssnum != 0)
#endif
          if( !(cgnum = SYMmap(chId, FC_IF_TYPE)) )
          {
            if_state.cs.escapement = 0;
            if_state.cs.du_emx = 0;
            if_state.cs.du_emy = 0;
            return ERR_no_cgnum;
          }
#endif  /* NO_SYMSET_MAPPING */

        switch (cgnum)
        {
          case 812:  /* thinspacereverse */
             break;

          case 1751: /* thinspace */
             width_pos = 0;
             break;

          case 813:  /* enspacereverse */
          case 1752: /* enspace */
             width_pos = 1;
             break;

          case 814:  /* emspacereverse */
          case 1753: /* emspace */
             width_pos = 2;
             break;

          default:
             return (ERR_find_cgnum);
        }


        /*
          Reload typeface-sensitive bucket      - 9/10/92 - jfd
        */

        status = BUCKfind(reload_buck_search_lvl, CREATE_BUCKET, p_bucket);
        if (status)
            return status;

#if FCO_RDR    /* 8-24-95 */

        /* If using FCO plugins, get proper space character escapement
         * from "fco" part of the BUCKET data structure.
         *   8-24-95 jfd
         */

    if ( (fontindex.font_type & FC_FONTTYPE_MASK) == FC_FCO_TYPE)
    {
#if DU_ESCAPEMENT
        if_state.cs.du_emx = if_state.cs.du_emy = (*p_bucket)->p.fco.design_EmRes;
#else
        if_state.cs.du_emx = if_state.cs.du_emy = IFDESIGNUNITS;
#endif

#if (PCLEO_RDR)
        if (B_ISEXTERN( *p_bucket ))
           if_state.cs.escapement = (*p_bucket)->p.fco.spaceBand;
        else
#endif /* PCLEO_RDR */
        {
           if (cgnum == 812)
              if_state.cs.escapement = (*p_bucket)->p.fco.spaceBand;
           else
              switch (width_pos)
              {
                 case 0:
                    if_state.cs.escapement = (*p_bucket)->p.fco.ThinSpace;
                    break;

                 case 1:
                    if_state.cs.escapement = (*p_bucket)->p.fco.ENSpace;
                    break;

                 case 2:
                    if_state.cs.escapement = (*p_bucket)->p.fco.EMSpace;
                    break;
               }
        }
        return (ERR_fixed_space);
    }  /* endif ( (fontindex.font_type & FC_FONTTYPE_MASK) == FC_FCO_TYPE) */
#endif  /* !FCO_RDR  8-24-95, 9-15-95 */


        pfgseg = fgseg(*p_bucket);
        if ((*p_bucket)->p.in.oattribute != MAX_UWORD)
        {
#if (PCLEO_RDR)
           if (B_ISEXTERN( *p_bucket ))
              if_state.cs.escapement = ((PFACE_ATT)(pfgseg + 
                    (*p_bucket)->p.in.oattribute))->spaceBand;
           else
#endif /* PCLEO_RDR */
              if (cgnum == 812)
                 if_state.cs.escapement = ((PFACE_ATT)(pfgseg +
                    (*p_bucket)->p.in.oattribute))->spaceBand;
              else
                 if_state.cs.escapement = ((PFACE_ATT)(pfgseg + 
                    (*p_bucket)->p.in.oattribute))->fixedSpaceRelWidths[width_pos];

        /* Adjust escapement if native design units are not in 8782's */

#define IF_MASTERPT_SIZE 2000L  /* IF 250pts * 8 for eigths of a point */
#define XSCAN_RES        2540L  /* IF design window units              */
#define IF_EM_WIDTH    ( IF_MASTERPT_SIZE * XSCAN_RES )

           display        = (PDISPLAY)(pfgseg + (*p_bucket)->p.in.odisplay);

           des_em_width   = (SL32)display->masterPointSize
                          * (SL32)display->scanResolutionX;

           tmp_fp_em      = fpmul( fplongexp(des_em_width, 0),
                                   fplongexp(1383L, 0) );
           tmp_fp_em      = fpdiv( tmp_fp_em, fplongexp(100000L, 0));
           tmp_fp_em      = fpdiv( tmp_fp_em, fplongexp(8L, 0));
           em_box         = fp2word( tmp_fp_em );

           if_state.cs.du_emx = em_box;
           if_state.cs.du_emy = em_box;

#if !DU_ESCAPEMENT
           if(des_em_width != IF_EM_WIDTH )
           {
             /** new dst.esc = (old esc * IF_EM_WIDTH ) / des_em_width  **/
             factor      = fpdiv( fplongexp(IF_EM_WIDTH, 0),
                                  fplongexp(des_em_width, 0) );
             tmp_fp      = fpmul( fplongexp( (SL32)if_state.cs.escapement, 0 ),
                                         factor );
             if_state.cs.escapement  = fp2word( tmp_fp );   /* save it */
             if_state.cs.du_emx = (SW16)8782;
             if_state.cs.du_emy = (SW16)8782;
           }
#endif
           return (ERR_fixed_space);
        } /* endif ((*p_bucket)->p.in.oattribute != MAX_UWORD) */
        else
           return (ERR_find_cgnum);

    }
#endif  /* (IF_RDR || PST1_RDR) */

}

