/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/da.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: da.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.12   18 Apr 1995 16:48:14   JOE
 * 
 * In DAmake_cd(), added support for the removal of symbol set mapping.
 * 
 *    Rev 1.11   06 Apr 1995 15:14:56   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.10   08 Sep 1994 16:50:30   MIKE
 * Fixed typo: fcoset_char -> fco_set_char
 * 
 *    Rev 1.9   03 Aug 1994 16:00:36   MIKE
 * 
 * Added FCO changes from 1.6.1.1
 * 
 *    Rev 1.8   22 Apr 1994 13:55:18   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   02 Feb 1994 08:57:14   JOE
 * 
 * Removed #include for "fcntl.h" .
 * 
 *    Rev 1.6   08 Dec 1993 18:59:50   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.5   10 Aug 1993 15:30:36   JOE
 * 
 * In DAmake_cd(), conditionally compiled call to ifset_char() based
 * on IF_RDR.
 * 
 *    Rev 1.4   13 Apr 1993 13:21:56   JOE
 * In DAmake_cd(), conditionally compiled calls to psrender() and ttrender()
 * if !USE_JUMP_TABLES.
 * 
 *    Rev 1.3   12 Feb 1993 13:19:58   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 15:05:20   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:58:20   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:56   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* da.c */
/*
 *
 *
 * History
 *
 *    19-Dec-90  jfd   IFB on a Printer changes:
 *                     2.) Replace CC elements with fields from CHR_DEF_HDR
 *                         structure.
 *     7 Jan 91  ss    Added PCLEO_RDR support
 *    30-Jan-91  dET   Added function prototyping for MSC
 *    31-Jan-91  dET   Modify for MSC multi-model compilation.
 *     7-Feb-91  jfd   Make sure that PCLascii2ptr() is declared correctly
 *     9-Feb-91  awr   Added #include "sym.h" to declare symbol set fncts.
 *    23-Feb-91  awr   Changed bucket sub-segment handles to offsets.
 *                     Split off as new module.
 *    04-Mar-91  jfd   Added function prototype for BUFfree() and
 *                     PCLload_font().
 *                     In DAmake_cd(), added missing ";" after call to
 *                     PCLEOmake_cd().
 *                     In DAload_font(), if PCLEO, store "b->tfnum" and
 *                     "b->bucket_num" from "ix".
 *    17-Jun-91  jfd   Moved "debug.h" after "port.h".
 *                     Moved "cgconfig.h" before "port.h".
 *    19 Jun 91  ss    Changed DAmak_cd() argument "i" to "buck_search_lvl".
 *    24 Jun 91  ss    Conditionally compile io.h based on system type.
 *    24-Aug-91  awr   IXclose_file() function prototype
 *    27-Aug-91  jfd   When calling PCLEOmake_cd(), no longer passing 
 *                     PBUCKET as first argument because it was never
 *                     getting referenced.
 *    17 Sep 91  ss    Added !ROM call to PCLload_font() in DAload_font() to 
 *                     support PCLEO_RDR w/ disk-based plugins.
 *    25 Nov 91  ss    In DAload_font(), set file_open to FALSE for PCLEOs.
 *     3-Jan-92  awr   Removed font_open field from BUCKET
 *    22-Jan-92  rs    Incorporate ptrs to external font functions.
 *    28-Jan-92  rs    Move external font func ptr to bucket.
 *     7-Mar-92  awr   cleaned up test ps stubs.
 *    30 Mar 92  ss    In DAmake_cd, reset chr_def_hdr.mirror_flags.
 *                     For IF data, it gets reset OK, but for PS & TT data
 *                     it was not resulting in non-mirrored characters being
 *                     mirrored if requested after a mirrored character.
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    23 Apr 92  ss    In DAmake_cd(), restored test for only calling
 *                     PCLEOmake_cd() when typeface sensitive.
 *    21-Jul-92  awr   Conditional compile changes.
 *    31 Jul 92  ss    Special handling of ss_num == 0 for PCLEOs with symbol
 *                     sets not know to us, (not in IF.SS) in DAmake_cd().
 *    15-Sep-92  jfd   In DAmake_cd(), conditionally compiled test for IF
 *                     bucket type based on IF_RDR.
 *                     Conditionally compile function prototype for
 *                     LIBmake_cd().
 *    28-Sep-92  awr   Removed DAload_font() and DAunload_font().
 *                     Coded in line.  Changed parameter of DAmake_cd().
 *    10-Oct-92  rs    Implement USE_JUMP_TABLES feature for overlays.
 *    06-Jan-93  jfd   ANSI C function declaration changes.
 *    08-Feb-93  jfd   VXWorks support.
 *    13-Apr-93  jfd   In DAmake_cd(), conditionally compiled calls to 
 *                     psrender() and ttrender() if !USE_JUMP_TABLES.
 *    10-Aug-93  jfd   In DAmake_cd(), conditionally compile call to
 *                     ifset_char() based on IF_RDR.
 *    08-Dec-93  rs    General cleanup - MSDOS & OS2.
 *    26-Jan-94  jfd   Removed #include for fcntl.h .
 *  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  FCO Changes from 1.6.1.1:
 *    15-Mar-94  mby   Added fco_set_char() call from DAmake_cd().
 *  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *    08-Sep-94  mby   Fixed typo: fcoset_char -> fco_set_char
 *    18-Apr-95  jfd   In DAmake_cd(), added support for the removal of
 *                     symbol set mapping.
 */


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"

#if defined (MSDOS) || defined (__OS2__) /* needs port.h 4/3/92 - rs */
#include <io.h>
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "sym.h"
#include "if_type.h"

#if PCLEO_RDR
#include "pcleo.h"
#endif




#ifdef LINT_ARGS
GLOBAL UW16       DAmake_cd(PBUCKET, UW16, PCHR_DEF, int);
#if IF_RDR
EXTERN UW16       LIBmake_cd(PBUCKET, UW16, PCHR_DEF, UW16);
#endif  /* IF_RDR */
#if PCLEO_RDR
EXTERN             PCLEOmake_cd(UW16, PCHR_DEF, int);
#endif  /* PCLEO_RDR */

#else /* not LINTARGS */
#if IF_RDR
EXTERN UW16       LIBmake_cd();
#endif  /* IF_RDR */

#if PCLEO_RDR
EXTERN             PCLEOmake_cd();
#endif  /* PCLEO_RDR */

#endif    /* LINT_ARGS  */


#if SLIM_FONTS
EXTERN CHR_DEF_HDR chr_def_hdr;
#endif

#if PCLEO_RDR
EXTERN SYMBOLSET symbolset;
#endif

/*-------------------*/
/*    DAmake_cd      */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  DAmake_cd(PBUCKET bucket, UW16 chId, PCHR_DEF chr_def,
    int buck_search_lvl)
#else
GLOBAL UW16
DAmake_cd(bucket, chId, chr_def, buck_search_lvl)
    PBUCKET  bucket;
    UW16    chId;
    PCHR_DEF chr_def;
    int      buck_search_lvl;
#endif
{
#if SLIM_FONTS  /** Is this the best place for this?? -ss 3/30/92 */
   chr_def_hdr.mirror_flags = (UB8)0;
#endif

#if IF_RDR
    if(bucket->fst_type == FC_IF_TYPE)
    {
#if PCLEO_RDR
        /* Only have IF pcleos at TFS level */
        if(bucket->extern_font && buck_search_lvl == TF_SENSITIVE)
            return PCLEOmake_cd(chId, chr_def, buck_search_lvl);
#if !NO_SYMSET_MAPPING
        else
           if( symbolset.curssnum == 0 ) /* must have valid ssnum to map */
               return ERR_no_cgnum;      /* to cgnum.        -ss 7/31/92 */
#endif  /* !NO_SYMSET_MAPPING */
        else
#endif /* PCLEO_RDR */
            return LIBmake_cd(bucket, chId, chr_def, buck_search_lvl);
    }
    else
#endif /* IF_RDR */
    {
#if (NON_IF_FONT)
#if (USE_JUMP_TABLES)
        return ((*((PIF_FUNC_TBL)bucket->pft)->set_char) (bucket, chId));
#else
   switch (bucket->fst_type)
   {
#if IF_RDR
      case FC_IF_TYPE:
         return ifset_char (bucket, chId);
         break;
#endif
#if PST1_RDR
      case FC_PST1_TYPE:
         return psset_char (bucket, chId);
         break;
#endif
#if TT_RDR
      case FC_TT_TYPE:
         return ttset_char (bucket, chId);
         break;
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
         return fco_set_char (bucket, chId);
         break;
#endif
      default:
         return (ERR_fst_type);
     }
#endif /* USE_JUMP_TABLES */

#endif /* NON_IF_FONT */
    }
}

