/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/dll.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: dll.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.4   06 Apr 1995 15:14:56   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 13:55:12   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   06 Jan 1993 15:50:44   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:58:40   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:30   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/*   dll.c     doubly linked list
 *
 *
 *  HISTORY:
 *
 *  29-Jan-91  jfd  Added cgconfig.h
 *  30-Jan-91  dET  Added function prototyping for MSC
 *  31-Jan-91  dET  Modify for MSC multi-model compilation.
 *   8-Feb-91  awr  Added dll.h to declare functions.
 *                  Removed #include "cache.h"- not needed.
 *  17-Jun-91  jfd  Moved "cgconfig.h" before "port.h".
 *  06-Jan-93  jfd  ANSI C function declaration changes.
 */

#include  "cgconfig.h"
#include  "port.h"
#include  "ifmem.h"                     /* 17-Feb-91 awr */
#include  "cgif.h"
#include  "dll.h"

/* Returns TRUE if hp is empty list */
#if defined (ANSI_DEFS)
BOOLEAN dll_empty (MEM_HANDLE hp)
#else
BOOLEAN
dll_empty (hp)
    MEM_HANDLE hp;
#endif
{
    PDLL p;

    p = (PDLL)MEMptr(hp);
    return hp == p->f;
}




/* Makes hp an empty list */
#if defined (ANSI_DEFS)
VOID dll_null(MEM_HANDLE hp)
#else
VOID
dll_null(hp)
    MEM_HANDLE hp;
#endif
{
    PDLL p;

    p = (PDLL)MEMptr(hp);
    p->b  = hp;
    p->f  = hp;
}




/* Removes p from a list */
#if defined (ANSI_DEFS)
VOID dll_remove (MEM_HANDLE hp)
#else
VOID
dll_remove (hp)
    MEM_HANDLE hp;
#endif
{
    PDLL p, prev, next;
    
    p = (PDLL)MEMptr(hp);
    prev = (PDLL)MEMptr(p->b);
    next = (PDLL)MEMptr(p->f);

    prev->f = p->f;
    next->b = p->b;
    dll_null(hp);
}




/* Links q into p's list after p */
#if defined (ANSI_DEFS)
VOID dll_after (MEM_HANDLE hp, MEM_HANDLE hq)
#else
VOID
dll_after (hp, hq)
    MEM_HANDLE hp, hq;
#endif
{
    PDLL p, q, next;
    MEM_HANDLE hnext;

    p = (PDLL)MEMptr(hp);
    q = (PDLL)MEMptr(hq);

    q->b  = hp;
    hnext = p->f;
    q->f  = hnext;

    p->f = hq;
    next = (PDLL)MEMptr(hnext);
    next->b = hq;
}


