/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/fm.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: fm.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/*
 * 
 *    Rev 1.32   13 Jul 1995 14:12:22   MIKE
 * Conditionally compile char_dir() and fgseg() for IF_RDR=1
 * 
 *    Rev 1.31   18 Apr 1995 16:50:32   JOE
 * In LIBmake_cd() and DArd_char(), added support for the removal of
 * symbol set mapping.
 * 
 *    Rev 1.30   06 Apr 1995 15:14:48   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.29   19 Jan 1995 11:30:22   JOE
 * In LIBmake_cd(), conditionally compiled check of "missing_ccparts"
 * based on FCO_RDR && SLIM_FONTS.
 * 
 *    Rev 1.28   18 Jan 1995 13:27:02   JOE
 * In LIBmake_cd(), if character processed was not an external compound
 * character, reset "cgnum" and "index" fields of CHR_DEF data so that
 * fco_set_char() check for external compound character will work.
 * 
 *    Rev 1.27   16 Jan 1995 14:07:00   JOE
 * In LIBmake_cd(), if processing external compound character, return
 * ERR_no_cc_part if FCO_RDR so as to bypass the code which searches
 * IF plugins for missing character.
 * 
 *    Rev 1.26   22 Apr 1994 16:07:52   JOE
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.25   22 Apr 1994 13:55:10   LISA
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.24   09 Feb 1994 11:53:12   JOE
 * More _AM29K changes.
 * 
 *    Rev 1.23   02 Feb 1994 08:52:50   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.22   15 Dec 1993 08:43:34   JOE
 * 
 * Fixed prohibit flag problem for external compouond characters.
 * 
 *    Rev 1.21   08 Dec 1993 18:59:06   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.20   12 Oct 1993 09:47:18   MAIB
 * Added ansi defs checks to allow compilation on sparc
 * 
 *    Rev 1.19   11 Oct 1993 12:26:24   MIKE
 * chr_def_hdr.mirror_flags in LIBmake_cd().
 * 
 *    Rev 1.18   20 Aug 1993 17:29:48   JOE
 * 
 * If MIPS, do not include "stdlib.h" or "io.h" to resolve compiler
 * errors.
 * 
 *    Rev 1.17   15 Jun 1993 17:23:20   MIKE
 * In ifunload_font(), move "if (b->tfnum == if_state.if_init_face) ... ;"
 * to top of function.
 * 
 *    Rev 1.16   15 Jun 1993 10:35:34   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.15   12 May 1993 15:58:38   ROB
 * Clean up compiler warnings - nested comments.
 * 
 *    Rev 1.14   06 May 1993 15:12:12   JOE
 * In DArd_char(), do not save and restore font index. Restoring the font
 * index inside DArd_char() causes a core dump when processing an HQ2 pcleo
 * compound character. Instead, save and restore font index in calling routine
 * (ifmake_gaso_and_stats()).
 * 
 *    Rev 1.13   30 Apr 1993 10:10:34   MIKE
 * Fixed problems in DYNAMIC_FONTS/ROM (ifload_font, find_bucket_type, SEEKREAD)
 * 
 *    Rev 1.12   22 Apr 1993 11:15:48   MIKE
 * Debugged and optimized ROM code in FMprocess_face().
 * Moved ifget_FontBBox() from cgif.c. This module is a more logical place.
 * 
 *    Rev 1.11   20 Apr 1993 10:56:42   MIKE
 * Added new function FMprocess_face(), called from ifload_font(), to read IF
 * face in library file format. This mimics ixmak for font that are not part
 * of the if.fnt block. Conditionally compiled with DYNAMIC_FONTS.
 * 
 *    Rev 1.10   15 Mar 1993 09:52:12   JOE
 * In DArd_char(), if call to LIBmake_cd() fails, restore "fontindex" before
 * returning error.
 * 
 *    Rev 1.9   15 Mar 1993 09:00:30   JOE
 * 
 * 
 * In DArd_char(), added HQ2 optimization for IF_PCLEOI && IF_ROM.
 * 
 *    Rev 1.8   02 Mar 1993 14:34:18   LISA
 * Put Log information back into header.
 *
 *    Rev 1.7   15 Feb 1993 12:19:42   JOE
 * In rd_char(), restructured conditional compile block because of MIPS
 * compiler bug.
 *
 *    Rev 1.6   12 Feb 1993 13:44:00   JOE
 * VXWorks support.
 *
 *    Rev 1.5   07 Jan 1993 15:31:50   JOE
 * Corrected ANSI function declaration for LIBmake_cd().
 *
 *    Rev 1.4   06 Jan 1993 16:18:00   JOE
 * ANSI C function declaration changes.
 *
 *    Rev 1.3   05 Jan 1993 08:38:58   JOE
 * 960 changes (multiple "READ"s if reading more than 996 bytes due to 
 * limitation of INTEL library routine, conditional calls to routine
 * FMalloc_rd() due to difference in argument list).
 *
 *    Rev 1.2   14 Dec 1992 15:58:52   LISA
 * Removed CntrlZ character from end of file.
 * 
 *    Rev 1.0   09 Dec 1992 15:38:22   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* fm.c */
/*
 *
 *
 *  HISTORY:
 *
 *  12-Mar-90   jfd     Storing the pointers to the Typeface Header
 *                      and Font Alias Segments in this routine now
 *                      (keys 107 and 110)
 *  05-May-90   awr     Character buffer is fixed size- allocated once
 *  07-Jun-90   dah     Modified FMalloc_rd() and FMseek_read(); added
 *                      parameters for font library compression.
 *  08-Jun-90   dET     Close files at end of functions because Windows
 *                      is brain dead.
 *  29-Jul-90   awr     Fixed FMrd_char. Was clobbering cd->index with
 *                      with index into update library. Later, old library
 *                      becomes active- meaningless index.
 *  12-Oct-90   dET     Close files at end of functions if running either
 *                      WINDOWS or BOW
 *  04-Dec-90  jfd      Moved "include" statement for  "cgconfig.h" to line
 *                      following "port.h"
 *  19-Dec-90  jfd      IFB on a Printer changes:
 *                      1.) In FMrd_char(), when calling IXget_fnt_index(),
 *                          pass (FONTCONTEXT *) instead of (LONG).
 *                      2.) Add ROM support.
 *  08-Jan-91  jfd      IFB on a Printer changes:
 *                      1.) Added PCLEO support.
 *  13-Jan-91  awr      Changed FMalloc_rd() to call BUFalloc()
 *  28-Jan-91  jfd      Made size arg of MEMalloc() LONG
 *  30-Jan-91  dET      Made modifications to FMseek_read and function
 *                      prototyping for multi-model compilation.  Added new
 *                      include for mixmodel.h and memory.h
 *   4-Feb-91  awr      Changed symbol set mapping to use SYMmap()
 *   9-Feb-91  awr      Added #include "sym.h" to declare symbol set fncts.
 *  15-Feb-91  awr      changed IXfind_bucket() name to BUCKfind()
 *  23-Feb-91  awr      Changed bucket sub-segment handles to offsets.
 *  04-Mar-91  jfd      In LIBload_font(), changed field name pfont_block to
 *                      pfnt_index.
 *  15 May 91  ss       Deleted all references to COMPRESS.  This includes
 *                        deleting last 2 parameters to FMalloc_rd() &
 *                        FMseek_read() which are no longer needed.
 *                      Added support for SLIM_FONTS (external compound chars).
 *                      Changes to support up to 5 level, 15 plugin scheme.
 *   3 Jun 91  ss       Save mirror flags for SLIM_FONT compound chars.
 *  05-Jun-91  jfd      Changed FMrd_char to use a temp FONTINDEX for HQ3
 *                      and ROM processing.
 *                      (FIX FROM EARLIER VERSION)
 * 
 *                      SUN support
 *                      (FIX FROM EARLIER VERSION)
 *
 *                      Moved debug.h after port.h
 *                      (FIX FROM EARLIER VERSION)
 *   9-Jun-91  awr      Changed chr_def_hdr structure
 *  18 Jun 91  ss       Fixed bug in LIBmake_cd for SLIM_FONTS, not finding
 *                      all the pieces of an external compound char.
 *                      And bug searching too many buckets of a compound
 *                      character - was searching buckets the TF didn't "own".
 *  19 Jun 91  ss       Changed CHR_DEF.bucknum to CHR_DEF.buck_search_lvl.
 *                      Changed mirror code to use defines for masks.
 *  26 Jun 91  ss       Added casts for b->plibfont usage.
 *   1 Jun 91  ss       Added prototpye for fgseg() in not LINT_ARGS.
 *  07-Aug-91  jfd      Changed "MSWINDOWS" to "_WINDOWS".
 *                      In function prototype for "clear_mem()", changed
 *                      type of first argument from "UBYTE *" to "PUBYTE"
 *  17 Jul 91  ss       Updated code for SLIM_FONTS mirroring to work with
 *                      code added elsewhere.
 *  24-Aug-91  awr      Moved function decls to include file
 *  17 Sep 91  ss       Added line in rd_char() to test if OK to call IXopen()
 *                      based on !ROM and PCLEO_RDR for reading a disk based
 *                      library (like plugins) and PCLEO_RDR is enabled.
 *                      Also in rd_char(), added set of expand_buf for !ROM
 *                      and PCLEO_RDR case.
 *   2 Oct 91  ss       Changed PCLEO_RDR code in rd_char() to use only the
 *                      EXPBUFSIZE # of bytes now that it is larger.
 *   4 Oct 91  ss       Added SPARC support.
 *  18 Oct 91  jfd      Changed "char_dir" from MLOCAL to GLOBAL.
 *  25 Oct 91  ss       Added return lines in LIBmake_cd().
 *   3-Jan-92  awr      Removed font_open field from BUCKET
 *   7-Jan-92  jfd      In rd_char(), conditionally compiled line which
 *                      references "cd->pgif" based on PCLEO_RDR.
 *   5-Feb-92  rs       Cleanup of compiler warnings.
 *  21 Feb 92  ss       In LIBload_font(), make sure setting of globoff
 *                      avoids alignment problems.
 *   4 Mar 92  ss       Updated references to entries in new bucket structure
 *                      in ROM code.
 *   7-Mar-92  awr      Changed for UFST
 *  10 mar 92  ss       Added prototypes for PCLload_font().
 *                      Fixed tests for PCLEO_RDR in ifload_font().
 *  24 Mar 92  ss       Fixed set of charcount and charoff in rd_char() for
 *                      SPARC specific code.
 *  30 Mar 92  ss       Fixed set of charcount and charoff for SPARC and SLIM.
 *  31 Mar 92  ss       Added line needed for last fix which got lost somehow.
 *  03-Apr-92  rs       Portability cleanup (port.h).
 *  23 Apr 92  ss       In LIBmake_cd(), changed limit of test for searching
 *                      bucket tree for missing cc chars fro NBUCKET_LEVELS
 *                      to fontindex.num_searches. This is works with the
 *                      new plugin scheme of not referencing TFS face via
 *                      fontindex.icur_index[0].
 *   7 May 92  ss       Changed arg to IXopen_file() in rd_char().
 *  16-Jun-92  ss       In DArd_char(), if not HQ3, when checking if pcleo,
 *                      check "fi_sav.extern_font", rather than calling
 *                      "B_ISEXTERN(b)", because BUCKfind() changes value
 *                      of "b->bucket_num".
 *   1 Jul 92  ss       Moved port.h to top to access defines earlier.
 *                      Changed conditional on SUN to UNIX to be more general.
 *   9-Jul-92  jfd      In DArd_char(), if not HQ3, load "tmp_fc.font_id" 
 *                      with "-(fontindex.cur_tf_num)" if at TFS level, and
 *                      with "-(fontindex.pix->tfnum)" if at plugin level.
 *   5-Aug-92  jfd      Removed function prototypes for "clear_mem()".
 *                      Never references here.
 *  09-Aug-92  rs       Changes for Watcom C386 (string.h).
 *                      Change args in FMseek_read() & FMalloc_read
 *                      from SW16 to int, SL32 to long for 32 bit platforms.
 *  21-Aug-92  rs       Fix for case where we have a non-Intellifont primary
 *                      font which does not contain the desired character and
 *                      the character ends up being a compound char with a part in the
 *                      universals (ie PB symbol set, chId 82 - Rx prescription).
 *  15-Sep-92  jfd      Conditionally compiled the following routines:
 *                      ifload_font(), ifunload_font(), ifset_char(),
 *                      LIBmake_cd(), DArd_char(), rd_char(), FMchar_index().
 *  23-Sep-92  jfd      INTEL960 conditional compile changes.
 *  25-Sep-92  jfd      Replaced CGSPARC.H with CGMACROS.H.
 *  28-Sep-92  awr      Changed parameters of BUCKfind()
 *  30-Sep-92  jfd      Removed conditional compiles based on SPARC and
 *                      replaced with conditional compiles based on
 *                      (NAT_ALIGN == 4) and/or (BYTEORDER == HILO) wherever 
 *                      possible.
 *  09-Oct-92  mby      SYMmap() calls take second argument (int fst_type).
 *  15-Oct-92  jfd      In rd_char(), added special block of code to get
 *                      offset to character and size of character for
 *                      INTEL 960.
 *  15-Nov-92  rs       Port to Macintosh - no io.h, include unix.h.
 *  05-Jan-93  jfd      Conditionally compiled calls to Fmalloc_rd()
 *                      based on platform due to different arguments.
 *                      In FMseek_read(), if INTEL960, if reading more 
 *                      than 996 bytes, use multiple READs due to
 *                      problem with 960 read() function.
 *  06-Jan-93  jfd      ANSI C function declaration changes.
 *  07-Jan-93  jfd      Corrected ANSI function declaration for LIBmake_cd().
 *  08-Feb-93  jfd      VXWorks support.
 *                      Changed all READ's to READF's due to conflict with
 *                      VXWorks.
 *  15-Feb-93  jfd      In rd_char(), changed "#if ...#elif ...#else" block to
 *                      "if ... #else ... #if ... #else" because of MIPS
 *                      compiler bug.
 *  10-Mar-93  jfd      In DArd_char(), added support for HQ2 processing
 *                      optimization for (IF_PCLEOI && IF_ROM).
 *  15-Mar-93  jfd      In DArd_char(), if call to LIBmake_cd() fails,
 *                      restore "fontindex" before returning error.
 *  14-Apr-93  mby      Changed ifload_font() to handle dynamic fonts.
 *                      Added function FMprocess_face(), called from
 *                      ifload_font(), to read IF face in library file format.
 *                      Conditionally compiled based on DYNAMIC_FONTS.
 *  19-Apr-93  mby      Added macros to FMprocess_face() to handle SPARC-like
 *                      platforms that require special byte alignment.
 *  21-Apr-93  mby      Moved ifget_FontBBox() from cgif.c. Optimized ROM code.
 *  29-Apr-93  mby      Fixed problems in DYNAMIC_FONTS/ROM in ifload_font()
 *                      & find_bucket_type(). Fixed SEEKREAD macro.
 *  06-May-93  jfd/ss   In DArd_char(), do not restore font index until we
 *                      are completely done with the character. Restoring
 *                      the font index inside DArd_char() causes a core
 *                      dump when processing an HQ2 pcleo compound character.
 *                      Save and restore font index in calling routine
 *                      (ifmake_gaso_and_stats()).
 * 12-May-93  rs        Remove nested comment in 'find_bucket_type()'.
 * 14-Jun-93  mby       In ifunload_font() move 'if (b->tfnum == ...
 *                      if_state.if_init_face = 0;' to top of function.
 * 15-Jun-93  jfd       Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 20-Aug-93  jfd       If MIPS, do not include "stdlib.h" or "io.h" to
 *                      resolve MIPS compiler error.
 * 08-Oct-93  mby       Set chr_def_hdr.mirror_flags to 0 at the end of
 *                      LIBmake_cd(), if the function fails.
 * 10-Oct-93  maib      Added ansi def checks around ifget_FontBBox
 * 08-Dec-93  rs        General cleanup - MSDOS & CGFLAT32.
 * 15-Dec-93  jfd       In LIBmake_cd(), save prohibit flag and width when
 *                      processing an external compound character.
 * 26-Jan-94  jfd       Removed #include for fcntl.h.
 *                      Conditionally compiled out #include for "unistd.h"
 *                      (if !_AM29K).
 * 04-Feb-94  jfd       Conditionally compiled #include for io.h based on
 *                      !_AM29K.
 *                      Including hif.f if _AM29K.
 * 22-Apr-94  jfd       Changed conditional compile statement prior to
 *                      including <hif.h> to #if (_AM29K && !UNIX) to
 *                      resolve UNIX Metaware compiler error.
 * 13-Jan-95  jfd       In LIBmake_cd(), if processing external compound
 *                      character, return ERR_no_cc_part error if FCO_RDR
 *                      so as to bypass the code which searches
 *                      IF plugins for missing character.
 * 18-Jan-95  jfd       In LIBmake_cd(), if character processed was not an
 *                      external compound character, reset "cgnum" and
 *                      "index" fields of CHR_DEF data so that fco_set_char()
 *                      check for external compound character will work.
 * 19-Jan-95  jfd       In LIBmake_cd(), conditionally compiled check of
 *                      "missing_ccparts" based on FCO_RDR && SLIM_FONTS. 
 * 18-Apr-95  jfd       In LIBmake_cd() and DArd_char(), added support 
 *                      for the removal of symbol set mapping.
 * 13-Jul-95  mby       Conditionally compile char_dir() and fgseg() for
 *                      IF_RDR=1. "b->p.in" is not defined otherwise.
 */

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#ifdef LAMIGA
#include <exec/types.h>
#include <exec/nodes.h>
#include <dos/dos.h>
#include <clib/dos_protos.h>
#include <pragmas/dos_pragmas.h>
#define SEEK_SET 0
#endif


#include <stdio.h>
#include <errno.h>

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#ifndef __i960
#if defined (UNIX)
#if !defined(_AM29K)
#include <unistd.h>
#endif
#elif defined (MACINTOSH)
#include <unix.h>
#else
#ifndef MIPS
#include <stdlib.h>
#if !defined(_AM29K)
//#include <io.h>
#endif
#endif
#endif /* UNIX */
#endif  /* !__i960 */

#if defined (__WATCOMC__) || defined(__i960) || defined(VXWORKS)
#include <string.h>
#else
#include <string.h>
#include <memory.h>
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "sym.h"
#include "mixmodel.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"

#include "cgmacros.h"
#if PCLEO_RDR
#include "pcleo.h"
#endif

#ifdef LINT_ARGS  /* function prototypes 30-Jan-91 dET */
EXTERN VOID       BUFfree(MEM_HANDLE);

EXTERN UW16      IXmak_font_index(LPSB8);
EXTERN UW16      BUCKfind(int, int, PPBUCKET);
#if !ROM                /* added conditional compile  -ss 6/21/91  */
EXTERN UW16      IXopen_file(PINDEX_ENTRY, PBUCKET);
EXTERN UW16      IXclose_file(PBUCKET);
#endif
EXTERN MEM_HANDLE BUFalloc(SL32);

/* pcleoutl.c */
#if PCLEO_RDR
EXTERN UW16      PCLload_font(LPUB8, PBUCKET);
EXTERN UW16      PCLmakeGlobalSeg();
#endif

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
GLOBAL BOOLEAN    FMseek_read(int, long, UW16, LPSB8);
GLOBAL MEM_HANDLE FMalloc_rd(int, UW16, long);
#else /* 32 bit platform */
GLOBAL BOOLEAN    FMseek_read(int, long, int, LPSB8);
GLOBAL MEM_HANDLE FMalloc_rd(int, int, long);
#endif
#if IF_RDR
GLOBAL LPSB8      char_dir(PBUCKET);
GLOBAL LPSB8      fgseg(PBUCKET);
GLOBAL UW16       LIBmake_cd(PBUCKET, UW16, PCHR_DEF, int);
MLOCAL UW16       rd_char(PCHR_DEF);
MLOCAL SW16       FMchar_index(PBUCKET, UW16);
#endif  /* IF_RDR */
GLOBAL UW16      DArd_char(PCHR_DEF);


#if FONTBBOX
GLOBAL UW16       ifget_FontBBox( PBUCKET, BBoxRes* );
#endif  /* FONTBBOX */

#if DYNAMIC_FONTS
MLOCAL UW16       FMprocess_face(LPUB8, PBUCKET);
MLOCAL BOOLEAN    find_bucket_type(PBUCKET, LPUB8, UL32, SL32, SW16*);
#endif

#else             /* NOT LINT_ARGS */
/* fm.c */
#if IF_RDR
GLOBAL LPSB8      fgseg();
GLOBAL LPSB8      char_dir();
GLOBAL UW16       LIBmake_cd();
MLOCAL UW16       rd_char();
MLOCAL SW16       FMchar_index();
#endif  /* IF_RDR */

/* mem.c */
EXTERN VOID       BUFfree();

EXTERN UW16      IXmak_font_index();
EXTERN UW16      BUCKfind();
#if !ROM                /* added conditional compile  -ss 6/21/91  */
EXTERN UW16      IXopen_file();
EXTERN UW16      IXclose_file();
#endif
EXTERN MEM_HANDLE BUFalloc();
MLOCAL SW16       FMchar_index();

/* pcleoutl.c */
#if PCLEO_RDR
EXTERN UW16      PCLload_font();
EXTERN UW16      PCLmakeGlobalSeg();
#endif

#if FONTBBOX
GLOBAL UW16       ifget_FontBBox();
#endif  /* FONTBBOX */

#if DYNAMIC_FONTS
MLOCAL UW16       FMprocess_face();
MLOCAL BOOLEAN    find_bucket_type();
#endif

#endif


EXTERN FONTINDEX fontindex;


/* character buffer */

GLOBAL MEM_HANDLE  hchar_buf =  NIL_MH;
EXTERN IF_STATE if_state;


/* Character specific data (# parts, escape, is_compound, etc.) */

EXTERN CHR_DEF chr_def[];
EXTERN CHR_DEF_HDR chr_def_hdr;

#if SLIM_FONTS
GLOBAL CHARWIDTH missing_ccpart_widthinfo;
GLOBAL SW16      missing_ccparts;
#endif

#if !ROM

/*------------------*/
/*  FMseek_read     */
/*------------------*/
/*  In file "f", do an lseek to "offset" an then read "count" bytes
 *  into "buffer". Return TRUE if success.
 */
#if defined (ANSI_DEFS)
GLOBAL BOOLEAN FMseek_read(int f, long offset,
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16 count,
#elif defined(__i960)
    unsigned int count,
#else /* 32 bit platform */
    int count,
#endif
    LPSB8 buffer)
#else
GLOBAL BOOLEAN
FMseek_read(f, offset, count, buffer)
    int   f;       /* file handle - SW16 to int - 8/10/92 - rs  */
    long   offset; /* offset within file - SL32 to long - 8/10/92  */
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16  count;   /* number of SB8s to read */
#elif defined(__i960)
    unsigned int count;
#else /* 32 bit platform */
    int   count;   /* number of SB8s to read - SW16 to int 8/10/92 */
#endif
    LPSB8  buffer; /* buffer to read data into */
#endif
{
#if defined (__i960)
    unsigned int num_read;
    unsigned int maxcount;
    unsigned int loops;
    unsigned int left;
    LPSB8  buffer2;
    unsigned int i;
#endif

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    DBG2("                FMseek_read()   offset: %ld   count: %u\n",
                                                          offset, count);
#else /* 32 bit platform */
    DBG2("                FMseek_read()   offset: %ld   count: %d\n",
                                                          offset, count);
#endif
    if(LSEEK(f, offset, SEEK_SET) != offset)
    {
        DBG("                    lseek() failed\n");
        return FALSE;
    }
#if !defined(__i960)
    if((UW16)READF(f, buffer, count) != count)
    {
        DBG("                    read() failed\n");
        return FALSE;
    }
#else
    /* For INTEL960, can't read more than 996 bytes at a time,
       so break up read() call into multiple reads if necessary
     */

    if (count <= 996)
    {
       num_read = READF(f, buffer, count);
       if (num_read != count)
       {
          DBG("                    read() failed\n");
          return FALSE;
       }
    }
    else
    {
       maxcount = 996;
       loops = count / maxcount;
       left  = count - (loops * maxcount);

       buffer2 = buffer;
       for (i=0; i<loops; i++)
       {
          num_read = READF(f, buffer2, maxcount);
          if (num_read != maxcount)
          {
            DBG("                    read() failed\n");
            return FALSE;
          }
          buffer2 += maxcount;
       }
       num_read = READF(f, buffer2, left);
       if (num_read != left)
       {
         DBG("                    read() failed\n");
         return FALSE;
       }
    }
#endif  /* !defined(__i960) */
    return TRUE;
}



/*------------------*/
/*  FMalloc_rd      */
/*------------------*/
/*  MEMalloc "size" SB8s and then do an lseek() to "offset" in file "f" and
 *  read "size" SB8s into the allocated buffer. Return the buffer pointer
 *  or null on failure.
 */
#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE FMalloc_rd(int f, 
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16 size,
#else /* 32 bit platform */
    int size,
#endif
    long offset)
#else
GLOBAL MEM_HANDLE
FMalloc_rd(f, size, offset)
    int    f;      /* SW16 to int - 8/10/92 - rs */
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16   size;   /* Size of buffer to allocated */
#else /* 32 bit platform */
    int    size;   /* Size of buffer to allocated - SW16 to int - 8/10/92 */
#endif
    long   offset; /* SL32 to long - 8/10/92 */
#endif
{
    MEM_HANDLE hbuf;
    LPSB8      buf;

  /*  Acquire size SB8S  */

	hbuf = BUFalloc((SL32)size);
	if (!hbuf) return NIL_MH;
/*    if(!(hbuf = BUFalloc((SL32)size))) return NIL_MH;		***KMR */
    buf = MEMptr(hbuf);

  /*  Read data into new buffer.  If error, free buffer  */

    if(!FMseek_read(f, offset, size, buf))
    {
        BUFfree(hbuf);
        return NIL_MH;
    }

    return hbuf;
}

#endif  /* !ROM */



#if IF_RDR

/*------------------*/
/*    char_dir      */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL LPSB8 char_dir(PBUCKET b)
#else
GLOBAL LPSB8
char_dir(b)
    PBUCKET b;
#endif
{
#if ROM
    return b->p.in.pface_header_seg + 6;
#else
    return MEMptr(b->p.in.hface_header_seg) + 6;
#endif
}




/*------------------*/
/*     fgseg        */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL LPSB8 fgseg(PBUCKET b)
#else
GLOBAL LPSB8
fgseg(b)
    PBUCKET b;
#endif
{
#if ROM
    return b->p.in.pfgseg;
#else
    return MEMptr(b->p.in.hfgseg);
#endif
}



/*-------------------*/
/*   ifunload_font   */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 ifunload_font (PBUCKET  b)
#else
GLOBAL UW16 ifunload_font (b)
    PBUCKET  b;
#endif
{
    DBG ("\nifunload_font()\n");

    if (b->tfnum == if_state.if_init_face)
       if_state.if_init_face = 0;

#if PCLEO_RDR
    if(b->extern_font)
        BUFfree(b->p.in.hfgseg);   /* all we need to do for PCLEOs */
    else
#endif
    {
      /*  Either disk or ROM library file */

#if !ROM
        IXclose_file(b);
#endif  /*  !ROM  */

        if(!B_ISROM(b))
        {
            BUFfree(b->p.in.hface_header_seg);
            BUFfree(b->p.in.hfgseg);
        }
    }
    return SUCCESS;
} 




/*-------------------*/
/*    ifload_font    */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  ifload_font(PFONT_DES pfd, PBUCKET b)
#else
GLOBAL UW16
ifload_font(pfd, b)
    PFONT_DES    pfd;
    PBUCKET      b;
#endif
{
    UW16    status;
    LPSB8   face_header_seg;   /* Face header seqment (char dir)   */
    LPSB8   chptr;             /* Standard character directory     */
    UW16    dir_entry_size;    /* size of char directory entry     */
    UW16    ch_count;          /* number of character in directory */

    SL32     globoff;           /* offset to face global segment    */
    UW16    globcount;         /* size of face global segment      */
    LPSB8    p;

#ifdef DEBUG
    UW16    type;
    UL32    size;
#endif

    UW16    key;
    UL32    off;
    UW16    count;
    UW16    oseg;

    DBG("    ifload_font()\n");

#if PCLEO_RDR
    if( b->extern_font)               /* Is this a PCLEO ? */
       return PCLload_font((LPUB8)pfd, b);
#endif  /* PCLEO_RDR  */
#if DYNAMIC_FONTS
    if (b->dynIFActive)
    {
        status = FMprocess_face((LPUB8)pfd, b);
        if (status)  return status;
        b->tfnum = fontindex.dynix.tfnum;
        b->bucket_num = fontindex.dynix.bucket_num;
    }
    else
#endif  /* DYNAMIC_FONTS */

    {
      b->tfnum      = fontindex.pix->tfnum;
      b->bucket_num = fontindex.pix->bucket_num;
    }

#if ROM
#if DYNAMIC_FONTS
    if (b->dynIFActive)
    {
      b->p.in.plibfont = b->cur_font_hdr;
      face_header_seg = b->p.in.pface_header_seg 
                      = (LPSB8)b->p.in.plibfont + fontindex.dynix.fhoff;
    }
    else
#endif  /* DYNAMIC_FONTS */
    {
      b->p.in.plibfont = fontindex.pfnt_index + fontindex.pix->p_r.lib_offset;
      face_header_seg = b->p.in.pface_header_seg 
                      = (LPSB8)b->p.in.plibfont + fontindex.pix->fhoff;
    }
#else   /* !ROM */
   {
    MEM_HANDLE  hfhseg;

  /* Open library file */

    status = IXopen_file(fontindex.pix, b);
    if (status)
        return status;

  /* Read face header (= character directory) */

    DBG("        face_header (=character directory)\n");

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
#if DYNAMIC_FONTS
    if (b->dynIFActive)
        hfhseg = FMalloc_rd(b->fh, fontindex.dynix.fhcount,
                                   fontindex.dynix.fhoff);
    else
#endif  /* DYNAMIC_FONTS */
        hfhseg = FMalloc_rd(b->fh, fontindex.pix->fhcount,
                                   fontindex.pix->fhoff);
#else
#if DYNAMIC_FONTS
    if (b->dynIFActive)
        hfhseg = FMalloc_rd(b->fh, 
             (int)fontindex.dynix.fhcount, fontindex.dynix.fhoff);
    else
#endif  /* DYNAMIC_FONTS */
        hfhseg = FMalloc_rd(b->fh, 
             (int)fontindex.pix->fhcount, fontindex.pix->fhoff);
#endif
    if ((b->p.in.hface_header_seg = hfhseg) == NIL_MH)
    {
        IXclose_file(b);
        return ERR_mem_face_hdr;
    }
    face_header_seg = MEMptr(b->p.in.hface_header_seg);

   }
#endif  /* !ROM */

  /*  Set up character directory   (skip segment link)  and count characters
   */

  /* Count number of characters in directory */

    ch_count = 0;

    /* use defines set in segments.h for correct size on SPARC -ss 8/28/91 */
    if(B_U_LIB(b))
       dir_entry_size = US_CH_DIR_ENTRY_SIZE;
    else 
       dir_entry_size = CH_DIR_ENTRY_SIZE;

    chptr = char_dir(b);
    while(*(LPUW16)chptr != MAX_UWORD)
    {
        ch_count++;
        chptr += dir_entry_size;
    }

    b->p.in.ch_count = ch_count;

  /* Type face global segment */

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)   /* compensate for potential alignment problems -ss 2/21/92 */
                       /* changed from "ifdef SPARC" - jfd 9/30/92 */
    MAKELONG( globoff, face_header_seg);        /* file offset    */
#else
    globoff = *(LPSL32)(face_header_seg);        /* file offset    */
#endif  /* (NAT_ALIGN == 4 && BYTEORDER == HILO) */
    globcount = *(LPUW16)(face_header_seg + 4); /* segment length */


    DBG2("\n        face_global()  offset: %ld   count: %d\n",
                           globoff, globcount);

  /* get face global buffer */

#if ROM
    b->p.in.pfgseg = (LPSB8)b->p.in.plibfont + globoff;
#else
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
/*    if(!(b->p.in.hfgseg = FMalloc_rd(b->fh, globcount, globoff)))		***KMR */
	b->p.in.hfgseg = FMalloc_rd(b->fh, globcount, globoff);
	if (!(b->p.in.hfgseg))
#else
	b->p.in.hfgseg = FMalloc_rd(b->fh, (int)globcount, globoff);
	if (!(b->p.in.hfgseg))
/*    if(!(b->p.in.hfgseg = FMalloc_rd(b->fh, (int)globcount, globoff))) ***KMR - 12-17-92 */
#endif
    {
        IXclose_file(b);
        BUFfree(b->p.in.hface_header_seg);
        return ERR_face_abort;
    }
#endif
    b->p.in.sfgseg = globcount;

  /*  Fill in sub-segment offsets and sizes. First set all offsets to
   *  MAX_UWORD which means the sub-segment is not present.
   */

    b->p.in.ogif             = MAX_UWORD;
    b->p.in.otrack_kern_seg  = MAX_UWORD;
    b->p.in.otext_kern_seg   = MAX_UWORD;
    b->p.in.odesign_kern_seg = MAX_UWORD;
    b->p.in.owidth_seg       = MAX_UWORD;
    b->p.in.oattribute       = MAX_UWORD;
    b->p.in.orast            = MAX_UWORD;
    b->p.in.otf_header_seg   = MAX_UWORD;
    b->p.in.ocompound_seg    = MAX_UWORD;
    b->p.in.odisplay         = MAX_UWORD;
    b->p.in.ofont_alias_seg  = MAX_UWORD;
    b->p.in.ocopy            = MAX_UWORD;

  /*  Read segment directory and set sub-segment offsets and sizes */

    p = fgseg(b);

#ifdef DEBUG
    type = *((LPUW16)p);
#endif
    p += sizeof( UW16 );
#ifdef DEBUG
#if (NAT_ALIGN == 4 && BYTEORDER == HILO)   /* changed from "ifdef SPARC" - jfd 9/30/92 */
    MAKELONG(size, p);
#else
    size = *((LPUL32)p);
#endif  /* (NAT_ALIGN == 4 && BYTEORDER == HILO) */
#endif  /* DEBUG */
    p += sizeof( UL32 );

    DBG2("            type = %d    size = %ld\n",type, size);

    DBG("\n            directory\n");
    do
    {
        key =   *((LPUW16)p);     p += sizeof( UW16 );

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)   /* changed from "ifdef SPARC" - jfd 9/30/92 */
        MAKELONG( off, p );       p += sizeof( UL32 );
#else
        off =   *((LPUL32)p);     p += sizeof( UL32 );
#endif  /* (NAT_ALIGN == 4 && BYTEORDER == HILO) */

        count = *((LPUW16)p);     p += sizeof( UW16 );
        DBG3("            key / offset / count  %d   %ld   %d\n",
                                              key,off,count);

        oseg   = (UW16)(off + 6);
        count -= 6;
        switch (key)
        {
            case 100:  b->p.in.ogif = oseg - 6;          /* Intellifont        */
                       b->p.in.gifct = count + 6;
                       break;
            case 101:  b->p.in.otrack_kern_seg = oseg;   /* track kerning      */
                       b->p.in.strack_kern_seg = count;
                       break;
            case 102:  b->p.in.otext_kern_seg = oseg;    /* text kerning       */
                       b->p.in.stext_kern_seg = count;
                       break;
            case 103:  b->p.in.odesign_kern_seg = oseg;  /* designer kerning   */
                       b->p.in.sdesign_kern_seg = count;
                       break;
            case 104:  b->p.in.owidth_seg = oseg;        /* character widths   */
                       b->p.in.swidth_seg = count;
                       break;
            case 105:  b->p.in.oattribute = oseg;        /* attribute hdr      */
                       b->p.in.sattribute = count;
                       break;
            case 106:  b->p.in.orast = oseg;             /* raster parameter    */
                       b->p.in.srast = count;
                       break;
            case 107:  b->p.in.otf_header_seg = oseg;    /* typeface header     */
                       b->p.in.stf_header_seg = count;
                       break;
            case 108:  b->p.in.ocompound_seg = oseg;     /* compound characters */
                       b->p.in.scompound_seg = count;
                       break;
            case 109:  b->p.in.odisplay = oseg;          /* display header      */
                       b->p.in.sdisplay = count;
                       break;
            case 110:  b->p.in.ofont_alias_seg = oseg;   /* font alias          */
                       b->p.in.sfont_alias_seg = count;
                       break;
            case 111:  b->p.in.ocopy = oseg - 6;         /* Copyright segment   */
                       b->p.in.scopy = count + 6;
                       break;
            default:   break;
        }
    }
    while (key != (UW16)-1);              /* added cast  -ss 6/21/91  */

#if (defined(_WINDOWS) | defined(BOW))   /* 10-12-90 dET */
    IXclose_file(b);   /* brain dead Windows does not allow open files */
#endif

    return SUCCESS;
}



/*-------------------*/
/*  ifset_char       */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  ifset_char (PBUCKET pb, UW16 chId)
#else
GLOBAL UW16
ifset_char (pb, chId)
    PBUCKET  pb;
    UW16    chId;
#endif
{
   DBG ("\nifset_char()\n");
   return SUCCESS;
}




/*-------------------*/
/*     LIBmake_cd    */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  LIBmake_cd(PBUCKET bucket, UW16 chId, PCHR_DEF chr_def,
    int buck_search_lvl)
#else
GLOBAL UW16
LIBmake_cd(bucket, chId, chr_def, buck_search_lvl)
    PBUCKET  bucket;
    UW16    chId;
    PCHR_DEF chr_def;
    int      buck_search_lvl;
#endif
{
    SW16         m;
    UW16        j;  /* change SW16 to UW16 - 2/5/92 - rs */
    LPSB8        p;
    UW16        num_cc;    /* number of cc defs */
    UW16        cc_cgnum;
    UW16        cgnum;
    PCHR_DEF     cd;
#if SLIM_FONTS
    PCHARWIDTH   widthPtr;
#endif

    DBG1("LIBmake_cd(chId = %d)\n", chId);

#if SLIM_FONTS
    missing_ccpart_widthinfo.flags = 0;
    missing_ccpart_widthinfo.width = 0;
    missing_ccparts = 0;
#endif

#if NO_SYMSET_MAPPING
    cgnum = chId;
#else
    cgnum = SYMmap(chId, FC_IF_TYPE);
#endif

    if((chr_def->index = FMchar_index(bucket, cgnum)) >= 0)
    {
        DBG("    found as primary\n");
        chr_def_hdr.is_compound = FALSE;
        chr_def_hdr.num_parts   = 1;
#if SLIM_FONTS
        chr_def_hdr.mirror_flags = (UB8)0;
#endif
        chr_def->cgnum    = cgnum;
        chr_def->buck_search_lvl = buck_search_lvl;
        chr_def->offset.x = 0;
        chr_def->offset.y = 0;
        return SUCCESS;
    }
    /*  Assume have a compound char  */
        DBG("    searching compound\n");

        chr_def_hdr.is_compound = TRUE;
        if(bucket->p.in.ocompound_seg == MAX_UWORD)
           return ERR_find_cgnum;
        p = fgseg(bucket) + bucket->p.in.ocompound_seg;

        num_cc = *(LPUW16)p;    p += sizeof( UW16 );
        DBG1("    num_cc %d\n", num_cc);

        for(j=0; j<num_cc; j++)    /* search thru cchar segment  */
        {
            cc_cgnum              = *(LPUW16)p;    p += sizeof( UW16 );
            chr_def_hdr.escape.x  = *(LPSW16)p;     p += sizeof( SW16 );

            if(!B_U_LIB(bucket))      /* v_esc not in U libraries  */
            {
               chr_def_hdr.escape.y = *(LPSW16)p;
               p += sizeof( SW16 );
            }
            else
               chr_def_hdr.escape.y = 0;

                                      /* mirror flags in num_parts */
            chr_def_hdr.num_parts = *(LPSW16)p;
            p += sizeof( SW16 );

#if SLIM_FONTS
                             /*  Have mirror flags        -ss 6/4/91     */
            if( chr_def_hdr.num_parts & MIRROR_MASK )
            {
               chr_def_hdr.mirror_flags
                           = (UB8)MIRROR_FLAGS(chr_def_hdr.num_parts);
               chr_def_hdr.num_parts   &= NPARTS_MASK;
            }
            else chr_def_hdr.mirror_flags = (UB8)0;
#endif  /*  SLIM_FONTS  */


            if(cc_cgnum != cgnum)
            {  /* skip over 3 words for each part: cgnum, offset.x, .y */
               p += chr_def_hdr.num_parts * 3 * sizeof( SW16 );
               continue;     /* go to examine next cchar in segment */
            }

          /*  Protect against over-running chr_def array. This means
           *  we won't process characters in a font that contains
           *  compound characters with too many parts even if these
           *  complex compound characters are never used.
           */

           if(chr_def_hdr.num_parts > MAX_CC_PARTS)
               return ERR_cc_complex;

            /*  Have the compound character. */

            DBG4("    cgnum %d  escape (%d, %d)    num_parts %d\n",
                              cgnum, chr_def_hdr.escape.x, 
                              chr_def_hdr.escape.y, chr_def_hdr.num_parts);

           /*  For each compound character part, fill in its
            *  cgnum, offsets, bucket number and character index.
            */

            cd = chr_def;

            for(m=0; m<chr_def_hdr.num_parts; m++)
            {
                    DBG3("        cgnum%d   xoffset %d yoffset %d\n",
                                  cd->cgnum, cd->offset.x, cd->offset.y);

                    cd->cgnum     = *(LPUW16)p;
                    p += sizeof( UW16 );

                    cd->offset.x  = *(LPSW16)p;
                    p += sizeof( SW16 );

                    cd->offset.y  = *(LPSW16)p;
                    p += sizeof( SW16 );
                    
#if SLIM_FONTS
                   /* compensate for positive offset expected to be negative*/
                    if( chr_def_hdr.mirror_flags )
                    {
                       if( chr_def_hdr.mirror_flags & MIRROR_X_MASK )
                          cd->offset.x = -cd->offset.x;
                       if( chr_def_hdr.mirror_flags & MIRROR_Y_MASK )
                          cd->offset.y = -cd->offset.y;
                       /*** fill this in when have data to test ***
                       if( chr_def_hdr.mirror_flags & MIRROR_ROT90_MASK )
                         ???;
                       ********************************************/
                    }
#endif  /*  SLIM_FONTS  */

                    cd->buck_search_lvl = buck_search_lvl;
                    if((cd->index = FMchar_index(bucket, cd->cgnum)) < 0)
#if SLIM_FONTS
                    {
                        missing_ccparts = 1;
                                         /* setup to search at next level */
                        cd->buck_search_lvl++;
                    }
#else
                        return ERR_no_cc_part;
#endif
                    cd++;
            }

#if SLIM_FONTS
          if( missing_ccparts )
            break;
          else
#endif
            return SUCCESS;

        }   /* for each entry in cc segment */

#if FCO_RDR && SLIM_FONTS
       if (missing_ccparts)
          return ERR_no_cc_part;
       else
       {
          chr_def[0].cgnum = 0xFFFF; /* flags indicating this is not an ext cc */
          chr_def[0].index = -1; 
       }
#endif

#if SLIM_FONTS
        /*  Special processing for External Compound Characters  */
        if( missing_ccparts )
        {
           cd = chr_def;
           /* Bump cd - fix for not finding all correct parts -ss 6/18/91 */
           for( m = 0; m < chr_def_hdr.num_parts; m++, cd++ )
           {
              if( cd->index >= 0 )    /* have a part all filled in  */
                continue;

              /* search down bucket tree til find the character     */
              while( cd->buck_search_lvl < fontindex.num_searches )   
              {
                 if( fontindex.icur_index[cd->buck_search_lvl-1] == MAX_UWORD)
                    return ERR_no_cc_part; /* no more valid buckets */

                 if( BUCKfind( cd->buck_search_lvl, CREATE_BUCKET, &bucket )
                                                                 != SUCCESS )
                    return ERR_no_cc_part;       /* no more buckets */
   
                 if((cd->index = FMchar_index(bucket, cd->cgnum)) >= 0)
                 {
                    if (bucket->p.in.owidth_seg != MAX_UWORD)
                    {
                        widthPtr = ((PCHARWIDTH)(fgseg(bucket) + 
                           bucket->p.in.owidth_seg) + cd->index);
                        missing_ccpart_widthinfo.flags = widthPtr->flags;
                        missing_ccpart_widthinfo.width = widthPtr->width;
                    }
                    break;                          /*  found it   */
                 }

                 cd->buck_search_lvl++;    /* setup to search at next level */
              }  /*  end - while  */
#if 0
              if( cd->buck_search_lvl >= NBUCKET_LEVELS )
#endif
              /* 21-Aug-92 - rs
                 add fix for case where we have a non-Intellifont primary
                 font which does not contain the desired character and the
                 character ends up being a compound char with a part in the
                 universals (ie PB symbol set, chId 82 - Rx prescription).
             */
              if(cd->buck_search_lvl >= fontindex.num_searches)
                return ERR_no_cc_part;
                
           }  /*  end - m loop  */
  
           /* restore current bucket context  */
           BUCKfind( buck_search_lvl, CREATE_BUCKET, &bucket );
           return SUCCESS;                     /* added  -ss 10/25/91 */
        }  /*  fill in missing cc parts  */
#endif  /*  SLIM_FONTS  */

#if SLIM_FONTS
   chr_def_hdr.mirror_flags = (UB8)0;   /* 10-08-93 - mby */
#endif
   return FAILURE;            /* added  -ss 10/25/91 */
}  /*  end - LIBmake_cd  */
#endif /* IF_RDR */

#if IF_RDR
/*-------------------*/
/*  FMchar_index    */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16  FMchar_index(PBUCKET b, UW16 cgnum)
#else
MLOCAL SW16
FMchar_index(b, cgnum)
    PBUCKET  b;
    UW16    cgnum;
#endif
{
    LPSB8    chptr;
    UW16    dir_entry_size;
    SW16     i,lo,hi;
    UW16    charnum;

  /* find entry in character directory */

    DBG1("        FMchar_index(%d)\n", cgnum);

    /* use defines set in segments.h for correct size on SPARC -ss 8/28/91 */
    if(B_U_LIB(b))
       dir_entry_size = US_CH_DIR_ENTRY_SIZE;
    else 
       dir_entry_size = CH_DIR_ENTRY_SIZE;

    chptr = char_dir(b);
    lo = 0;
    hi = (SW16)b->p.in.ch_count - 1;
    while(lo <= hi)
    {
        i = (lo + hi)/2;
        charnum = *(LPUW16)(chptr + i*dir_entry_size);
        if(charnum  == cgnum)
        {
            DBG1("            index = %d\n", i);
            return i;
        }
        else if(charnum < cgnum) lo = i+1;
        else hi = i-1;
    }
    DBG("            character not found\n");
    return -1;
}



/*-------------------*/
/*    rd_char        */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  rd_char(PCHR_DEF cd)
#else
MLOCAL UW16
rd_char(cd)
    PCHR_DEF cd;
#endif
{
    UW16             status;
    PBUCKET           b;
    PCH_DIR_ENTRY     chptr;
    PUS_CH_DIR_ENTRY  uschptr;
    UL32             charoff;
    UW16             charcount;   /*  size of character in bytes  */
#if (NAT_ALIGN == 4)  /* changed from "ifdef SPARC" - jfd 9/30/92 */
    LPSB8             p;
    int               tmpi;
#endif  /* (NAT_ALIGN == 4) */

    DBG2("        rd_char(buck_search_lvl = %d, index = index = %d)\n",
                                      cd->buck_search_lvl, cd->index);

  /* Find and open typeface file */

    status = BUCKfind(cd->buck_search_lvl, CREATE_BUCKET, &b);
    if (status)
        return status;
#if !ROM
#if PCLEO_RDR
    if( !B_ISEXTERN(b) )  /* don't open a pcleo file        -ss 9/16/91 */
#endif
    /* just called BUCKfind() to fill in fontindex, use it -ss 5/7/92 */
    status = IXopen_file(fontindex.pix, b);
    if (status)
        return status;
#endif  /* !ROM */

  /* Initialize typeface global data if need be */

    if(!if_init_glob(b))
    {
#if (defined(_WINDOWS) | defined(BOW))   /* 10-12-90 dET */
      /* brain dead Windows does not allow open files */
        IXclose_file(b);
#endif
        return ERR_if_init_glob;  
    }


#if ROM
    if_state.expand_buf  = (LPSB8)MEMptr( hchar_buf );
    if_state.expand_size = EXPBUFSIZE;
#endif
#if PCLEO_RDR
    /* ??don't need to worry about PS,TT Pcleo's, this code is not accessed */
    /* by the PS,TT typeface sensitive requests.  Even if it was, the only  */
    /* harm is pointing at these buffers that may never get used-ss 4/23/92 */
    if( b->extern_font )
    {
#if !ROM                          /* already set if have ROM  -ss 9/16/91 */
       if_state.expand_buf  = (LPSB8)MEMptr( hchar_buf );
       if_state.expand_size = CHARBUFSIZE;     /* have the whole thing, use it   */
#endif

#if (NAT_ALIGN == 4)
    /* changed from "ifdef SPARC" - jfd 9/30/92 */
    /* make sure expand_buf is long aligned before starting -ss 10/9/91 */
    if( tmpi = ((int)if_state.expand_buf & MEM_ALIGN) )
    {
       if_state.expand_buf  += (MEM_ALIGN+1) - tmpi;
       if_state.expand_size -= (MEM_ALIGN+1) - tmpi;
    }
#endif  /* (NAT_ALIGN == 4) */

       if_state.char_buf    = (LPSB8)cd->pgif;       /*  added cast  -ss 6/24/91 */
       return if_init_char();
    }
#endif /* PCLEO_RDR */

/*  ASSERT: at this point we have a ROM or DISK Library File */


  /* Get offset to character and size of character */

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)   /* changed from "ifdef SPARC" - jfd 9/30/92 */

    if(B_U_LIB(b))    /* Ultra-slim fonts have a different char directory */
    {
       p  = char_dir(b)                       /* beginning of entries     */
         + (cd->index * US_CH_DIR_ENTRY_SIZE) /* our entry                */
         + sizeof( UW16) ;                   /* skip charnum to charoff  */
       MAKELONG( charoff, p );              /* added line -ss 3/31/92 */
       p += US_CH_DIR_ENTRY_SIZE;             /* charoff in next entry     */
       MAKELONG( tmpi, p );                   /* grab charoff              */
       charcount = tmpi - charoff;   /* diff from next char offset to orig */
    }
    else
   {   /* changed to rely on charcount directly out of struct -ss 3/24/92 */
       p  = char_dir(b)                      /* beginning of entries      */
         + (cd->index * CH_DIR_ENTRY_SIZE)   /* our entry                 */
         + sizeof( UW16) ;                  /* skip charnum to charoff   */
       MAKELONG( charoff, p );               /* grab charoff              */
       charcount = *(LPUW16)(p + sizeof(UL32) );
    }

#else
#if (NAT_ALIGN == 4 && BYTEORDER == LOHI)   /* changed from "ifdef SPARC" - jfd 9/30/92 */
    if(B_U_LIB(b))    /* Ultra-slim fonts have a different char directory */
    {
       p  = char_dir(b)                       /* beginning of entries     */
         + (cd->index * US_CH_DIR_ENTRY_SIZE) /* our entry                */
         + sizeof( UW16) ;                   /* skip charnum to charoff  */
       charoff = *(LPUL32)p;
       DBG1(" charoff = %ld", charoff);
       p += US_CH_DIR_ENTRY_SIZE;             /* charoff in next entry     */
       tmpi = *(LPUL32)p;
       DBG1(" tmpi = %ld", tmpi);
       charcount = tmpi - charoff;   /* diff from next char offset to orig */
       DBG1(" charcount = %d", charcount);
    }
    else
   {   /* changed to rely on charcount directly out of struct -ss 3/24/92 */
       p  = char_dir(b)                      /* beginning of entries      */
         + (cd->index * CH_DIR_ENTRY_SIZE)   /* our entry                 */
         + sizeof( UW16) ;                  /* skip charnum to charoff   */
       charoff = *(LPUL32)p;
       DBG1(" charoff = %ld", charoff);
       charcount = *(LPUW16)(p + sizeof(UL32) );
       DBG1(" charcount = %d", charcount);
    }
#else

    if(B_U_LIB(b))  /* Ultra-slim fonts have a different char directory */
    {
        uschptr   = (PUS_CH_DIR_ENTRY)char_dir(b) + cd->index;
        charoff   = uschptr->charoff;
        charcount = (UW16)((uschptr+1)->charoff - uschptr->charoff);
    }
    else            /* normal character directory structure */
    {
        chptr     = (PCH_DIR_ENTRY)char_dir(b) + cd->index;
        charoff   = chptr->charoff;
        charcount = chptr->charcount;
    }
#endif
#endif  /* (NAT_ALIGN == 4 && BYTEORDER == HILO) */

  /*  Get pointer to character */

#if ROM
    if_state.char_buf    = (LPSB8)b->p.in.plibfont + charoff;
#else
    if_state.char_buf = MEMptr(hchar_buf);
    if_state.expand_buf = if_state.char_buf + charcount; /* unused char buffer after data */
    if_state.expand_size = CHARBUFSIZE - charcount;
#if (NAT_ALIGN == 4)
    /* changed from "ifdef SPARC" - jfd 9/30/92 */
    /* make sure expand_buf is long aligned before starting -ss 10/9/91 */
	tmpi = (int)if_state.expand_buf & 0x03;
	if (tmpi)
/*    if( tmpi = ((int)if_state.expand_buf & 0x03) )	***KMR */
    {
       if_state.expand_buf  += 4 - tmpi;
       if_state.expand_size -= 4 - tmpi;
    }
#endif  /* (NAT_ALIGN == 4) */


    if(charcount > CHARBUFSIZE)
    {
#if (defined(_WINDOWS) | defined(BOW))   /* 10-12-90 dET */
      /* brain dead Windows does not allow open files */
        IXclose_file(b);
#endif
        return ERR_ov_char_buf;
    }

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    if(!FMseek_read(b->fh, (long)charoff, (UW16)charcount, if_state.char_buf))
#else /* 32 bit platform */
    if(!FMseek_read(b->fh, (long)charoff, (int)charcount, if_state.char_buf))
#endif
    {

#if (defined(_WINDOWS) | defined(BOW))   /* 10-12-90 dET */
      /* brain dead Windows does not allow open files */
        IXclose_file(b);
#endif
        return ERR_rd_char_data;
    }


#if (defined(_WINDOWS) | defined(BOW))   /* 10-12-90 dET */
  /* brain dead Windows does not allow open files */
    IXclose_file(b);
#endif

#endif  /* ROM */

  /*  Initialize character data structures  */


    return if_init_char();
}



/*-------------------*/
/*  DArd_char        */
/*-------------------*/
/*  Find character with cgnum = n, allocate a character buffer, read the
 *  character data into the buffer, and initialize character data structures.
 *  The function rd_char() above does all of the work. This function
 *  tries to substitute characters from an auxilary library if the character
 *  being processed is in hq2 format.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  DArd_char(PCHR_DEF cd)
#else
GLOBAL UW16
DArd_char(cd)
    PCHR_DEF cd;
#endif
{
    UW16       status;
    FONTINDEX  fi_sav;

    FONTCONTEXT tmp_fc;
    PBUCKET     b;
    CHR_DEF     tmpcd;

#if (IF_PCLEOI && IF_ROM)
    int i;
#endif  /* (IF_PCLEOI && IF_ROM) */

    DBG1("        DArd_char(cgnum = %d)\n", cd->cgnum);

    status = rd_char(cd);
    if (status)
    {
      /* If we failed because the character was not hq3 format, then try
       * to find the character in the substitute hq3 libraries.
       */

                                                 /* added cast  -ss 10/17/91 */
        if(status != (UW16)ERR_not_hq3) return status;  /* some other error */


      /*  Set the three bucket index entries, the primary TF_SENSITIVE
       *  bucket entry will contain our typeface. The update typeface
       *  number is negative so that FMfont_change() won't get confused
       *  when we go back to processing normal typefaces. This way he
       *  won't think that a BUCKET already has normal typeface header
       *  info loaded when in fact it has update typeface header info.
       */

        if (!cd->buck_search_lvl)
           tmp_fc.font_id = - (fontindex.cur_tf_num); /* at TFS level */
        else
           tmp_fc.font_id = - (fontindex.pix->tfnum); /* at plugin level */

        DBG1("    update_tfnum = %ld\n", tmp_fc.font_id);
        fi_sav = fontindex;    /* save old font index */

#if !ROM
      /* Read in the font index for the substitute libraries */
        status = IXmak_font_index("hq3.fnt");
        if (status)
            return ERR_not_hq3;
        tmp_fc.format = 0;
#else
        tmp_fc.format = FC_ROM_TYPE;
#endif  /* !ROM */

#if (IF_PCLEOI && IF_ROM)

      /* Special HQ2 processing optimization used for rom pcleos:
       *
       * (1) Search HQ3 substitute library
       * (2) Search resident fonts
       *
       */

     for (i=0; i<2; i++)
     {
#endif  /* (IF_PCLEOI && IF_ROM) */

        if(!(status = IXget_fnt_index(&tmp_fc)))
        {

            if(!(status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &b)))
            {
#if PCLEO_RDR
                tmpcd.pgif = (LPUB8)NULL;

                /*  For pcleo, the cd->cgnum is really the ascii code */
              /*  Convert to cgnum for use with HQ2->HQ3 libs       */

#if (IF_PCLEOI && IF_ROM)

              /*  NOTE: If we are processing one part of a compound 
               *        character, there is no need to call SYMmap().
               */

              if ( (fi_sav.font_type & FC_EXTERN_TYPE) && !chr_def_hdr.is_compound)
#else
              if( fi_sav.font_type & FC_EXTERN_TYPE)
#endif  /* (IF_PCLEOI && IF_ROM) */
              {
#if NO_SYMSET_MAPPING
                 tmpcd.cgnum = cd->cgnum;  /* 3-21-95 jfd */
#else
                 tmpcd.cgnum = SYMmap(cd->cgnum, FC_IF_TYPE);
#endif
                 if (!tmpcd.cgnum)
                 {
                    fontindex = fi_sav;    /* restore font index    */
                    return ERR_no_cgnum;
                 }
              }
              else
#endif  /* PCLEO_RDR */
                tmpcd.cgnum = cd->cgnum;

                if((tmpcd.index = FMchar_index(b, tmpcd.cgnum)) >= 0)
                {
                    tmpcd.buck_search_lvl = TF_SENSITIVE;
                    status = rd_char(&tmpcd);
                }
#if (IF_PCLEOI && IF_ROM)
                else if (fi_sav.font_type & FC_EXTERN_TYPE)
                {

                /* Might be compound character. Have to check for
                 * possibility.
                 */

                   if ((status = LIBmake_cd(b, cd->cgnum, chr_def, 
                          (int)TF_SENSITIVE)) != 0)
                   {
                      fontindex = fi_sav;    /* restore font index    */
                      return status;
                   }

                   tmpcd.cgnum = cd->cgnum;
                   tmpcd.index = cd->index;
                   tmpcd.buck_search_lvl = TF_SENSITIVE;
                   status = rd_char(&tmpcd);

                }  /* end else */
#endif  /* (IF_PCLEOI && IF_ROM) */
                else
                    status = ERR_not_hq3;
            }
        }

#if !ROM
        BUFfree(fontindex.hfnt_index);   /* free temp. font index */
#endif

#if (IF_PCLEOI && IF_ROM)

       /* If character was not found in HQ3 substitute libraries,
        * restore typeface number and search resident fonts
        * if TFS is pcleo and ROM is enabled.
        */

        if(!status)
           break;

        else if (fontindex.font_type & FC_EXTERN_TYPE)
           tmp_fc.font_id = fi_sav.cur_tf_num; /* at TFS level */

     }  /* end for */

#endif  /* (IF_PCLEOI && IF_ROM) */
        if(status) return ERR_not_hq3;
    }

    return SUCCESS;
}
#endif  /* IF_RDR */





#if IF_RDR
#if DYNAMIC_FONTS

#define  FONTALIASNAME "HP                  "
#define  FAT_NFATS     6
#define  FAT_FIRSTTAB  8
#define  FAT_TFNUM     100
#define  FAT_XREFSIZE  104
#define  FAT_SIMPLESERIF 31
#define  FAT_WEIGHT    19
#define  FAT_POSTURE   17
#define  FAC_FIXEDPITCH 8
#define  FAC_SPACEBAND 64

#if ROM
#define SEEKREAD(fh, off, ct, buf)  (1, buf = fontPtr + off)
#else
#define SEEKREAD(fh, off, ct, buf)  FMseek_read(fh, off, ct, (LPSB8)buf)
#endif

#ifndef FM_PF_OPTIMIZE
#if (BYTEORDER == HILO) /* Motorola format, don't swap bytes. */
#define GETWORD_NS(p)  \
           ( ( ((UW16) *((LPUB8)(p))) << 8 ) | (UW16) *((LPUB8)(p)+1) )
#define GETLONG_NS(p)  \
           ( ( ((UL32) *((LPUB8)(p))) << 24)   |  \
             ( ((UL32) *((LPUB8)(p)+1)) << 16) |  \
             ( ((UL32) *((LPUB8)(p)+2)) << 8)  |  \
               (UL32) *((LPUB8)(p)+3)             \
           )

#else                   /* Intel format, do swap bytes. */
#define GETWORD_NS(p) \
           ( (UW16) *((LPUB8)(p)) | ( ((UW16) *((LPUB8)(p)+1)) << 8 ) )
#define GETLONG_NS(p)  \
           ( ( ((UL32) *((LPUB8)(p)+3)) << 24)   |  \
             ( ((UL32) *((LPUB8)(p)+2)) << 16) |    \
             ( ((UL32) *((LPUB8)(p)+1)) << 8)  |    \
               (UL32) *((LPUB8)(p))                 \
           )
#endif

#else
#define GETWORD_NS(p) ( *((LPUW16)(p)) )   /* most efficient - if CPU can */
#define GETLONG_NS(p) ( *((LPUL32)(p)) )   /* tolerate any byte alignment */
#endif

#if defined (ANSI_DEFS)
MLOCAL UW16 FMprocess_face( LPUB8 fontPtr, PBUCKET pBk )

#else
MLOCAL UW16 FMprocess_face( fontPtr, pBk )
   LPUB8 fontPtr;
   PBUCKET pBk;
#endif  /* !defined (ANSI_DEFS) */

{
#if !ROM
    UB8   buffer[10];
#endif
    LPUB8 pbuf;
    SW16  bucket_num;
    UW16  lib_type;
    UW16  fcount;
    UL32  offset;
    UW16  key;

#ifdef FMDEBUG
    printf("FMprocess_face()\n");
#endif
#if !ROM
    if (pBk->has_path)
    {
        UW16 status =
               IXopen_file((PINDEX_ENTRY)0, pBk); /* pathname is in bucket */
        if (status) return status;
    }
    fontindex.dynix.bucket_num = 0;
    pbuf = buffer;
#else
    fontindex.dynix.bucket_num = ROM_TYPE;
#endif
    /* First word must be 'D', 'S', or 'U' */
    if (!SEEKREAD(pBk->fh, 0L, 2, pbuf))
        goto IXerror1;
    lib_type = GETWORD_NS(pbuf);
    switch (lib_type)
    {
        case 0x0044: fontindex.dynix.bucket_num |= D_LIB; break;
        case 0x0053: fontindex.dynix.bucket_num |= S_LIB; break;
        case 0x0055: fontindex.dynix.bucket_num |= U_LIB; break;
        default:     goto IXerror2;
    }

    /* Read file segment directory until find File Directory Segment,
       keyword = 2. */
    fcount = 0; offset = 2;
    do
    {
        if (!SEEKREAD(pBk->fh, offset, 8, pbuf))
            goto IXerror1;
        key = GETWORD_NS(pbuf);
        if(key == 2)
        {
            offset = GETLONG_NS(pbuf + 2);
            fcount = GETWORD_NS(pbuf + 6);
            break;
        }
        offset += 8;
    } while (key != (UW16)-1);

    if (!fcount)
        goto IXerror2;

    /* Grab first entry in file directory (there should only be one, anyway).
     * Get typeface number, face header offset, face header byte count. */
    if (!SEEKREAD(pBk->fh, offset, 10, pbuf))
        goto IXerror1;
    if ( (fontindex.dynix.tfnum = GETLONG_NS(pbuf)) == -1)
        goto IXerror2;
    fontindex.dynix.fhoff = GETLONG_NS(pbuf + 4);
    fontindex.dynix.fhcount = GETWORD_NS(pbuf + 8);

    if ( !find_bucket_type( pBk, fontPtr,
                            fontindex.dynix.fhoff, fontindex.dynix.tfnum,
                            &bucket_num ))
        goto IXerror1;
    fontindex.dynix.bucket_num |= bucket_num;
#if !ROM
    if (pBk->has_path)
        IXclose_file(pBk);
#endif
    
#ifdef FMDEBUG
    printf("    tfnum, bucketnum, off, ct = %ld, %04x, %ld, %u\n",
           fontindex.dynix.tfnum, fontindex.dynix.bucket_num,
           fontindex.dynix.fhoff, fontindex.dynix.fhcount);
#endif

    return SUCCESS;

IXerror1:
#if !ROM
    if (pBk->has_path)
        IXclose_file(pBk);
#endif
    return ERR_if_read_libfile;

IXerror2:
#if !ROM
    if (pBk->has_path)
        IXclose_file(pBk);
#endif
    return ERR_if_process_face;
}




/************************
 *   find_bucket_type   *
 ************************
 *
 * Returns bucket bits 0-5 (typeface characteristics and fixed pitch plugin
 *   description) as described in ix.h in bucket_num.
 *   bucket_num defaults to 0 (normal-serif-upright, no FP) if global data is
 *   missing from the library file.
 * Returns error (FALSE) if unable to read the library file.
 * bucket->fh is the file handle (disk fonts)
 * fontPtr is the font pointer (ROM fonts)
 * fhoffset is the face header offset in the libr file.
 * tfnum is the Agfa typeface number.
 */
#if defined (ANSI_DEFS)
MLOCAL BOOLEAN   find_bucket_type( PBUCKET bucket, LPUB8 fontPtr,
                                   UL32 fhoffset, SL32 tfnum,
                                   SW16* bucket_num)
#else
MLOCAL BOOLEAN   find_bucket_type( bucket, fontPtr, fhoffset, tfnum, bucket_num )
  PBUCKET bucket;
  LPUB8   fontPtr;
  UL32    fhoffset;
  SL32    tfnum;
  SW16*   bucket_num;
#endif  /* !defined (ANSI_DEFS) */
{
#if !ROM
    UB8   buffer[8];
    LPUB8 pbuf = buffer;
#else
    LPUB8 pbuf;
#endif
    UW16  key;
    LPSB8 pSegData, pFAT;
    int   nfats, nxref, found_table_name;
    int   fat_flag=0;
    UL32  gsegOff;
    int   ii, iii;
    UL32  offset;
    UL32  seg_off;
#if !ROM
    MEM_HANDLE  hSeg;
    UW16  seg_size;
#endif
#if CGFIXED_PITCH
    int   attr_flag=0;
#endif

    *bucket_num = 0;

    if (!SEEKREAD(bucket->fh, fhoffset, 4, pbuf))
        return FALSE;
    gsegOff = GETLONG_NS(pbuf);    /* offset to TF Global Segment */

    /* loop through each segment of the face header. Look for the
       Attribute Header (fixed pitch only), the Font Alias Table, and
       the Typeface Header.
       -- Apparently the Font Alias table is always present, so for
          more efficiency, let's not look for or process the TF Header.
     */
    offset = gsegOff + 6;
    while (TRUE)
    {
        if (!SEEKREAD(bucket->fh, offset, 8, pbuf))
            return FALSE;
        if ( (key = GETWORD_NS(pbuf)) == 0xFFFF)
            break;      /* there is no more */
        switch (key)
        {
#if CGFIXED_PITCH
            case ATTRIBUTE_KEY:
                attr_flag = 1;
                seg_off = GETLONG_NS(pbuf+2);
#if !ROM
                seg_size = GETWORD_NS(pbuf+6);
                hSeg = FMalloc_rd(bucket->fh, seg_size, (gsegOff + seg_off));
                if (hSeg == NIL_MH)
                    break;
                pSegData = MEMptr(hSeg);
#else
                pSegData = (LPSB8)fontPtr + (gsegOff + seg_off);
#endif
                if (pSegData[FAC_FIXEDPITCH])
                {
                    switch ( GETWORD_NS(pSegData + FAC_SPACEBAND) )
                    {
                      case COURIER_WIDTH:
                        *bucket_num |= B_COURIER;
                        break;
                      case LETTER_GOTHIC_WIDTH:
                        *bucket_num |= B_LETTER_GOTHIC;
                        break;
                      default:    /* fixed pitch, no plugins */
                        *bucket_num |= B_FIXED_PITCH;
                        break;
                    }
                }
#if !ROM
                BUFfree(hSeg);
#endif
                break;
#endif  /* CGFIXED_PITCH */

            case FONT_ALIAS_KEY:    /* the preferred table */
                seg_off = GETLONG_NS(pbuf+2);
#if !ROM
                seg_size = GETWORD_NS(pbuf+6);
                hSeg = FMalloc_rd(bucket->fh, seg_size, (gsegOff + seg_off));
                if (hSeg == NIL_MH)
                  break;
                pSegData = MEMptr(hSeg);
#else
                pSegData = (LPSB8)fontPtr + (gsegOff + seg_off);
#endif
                nfats = GETWORD_NS(pSegData + FAT_NFATS);
                pFAT = pSegData + FAT_FIRSTTAB;
                for (ii=0; ii < nfats; ii++)
                {
                    found_table_name = (STRNCMP(FONTALIASNAME, pFAT, 20) == 0);
                    pFAT += 20;
                    nxref = GETWORD_NS(pFAT);
                    pFAT += 2;
                    for (iii=0; iii < nxref; iii++)
                    {
                        if (found_table_name  &&
                            tfnum == GETLONG_NS(pFAT + FAT_TFNUM) )
                        {
                            fat_flag = 1;
                            break;
                        }
                        pFAT += FAT_XREFSIZE;
                    }
                    if (fat_flag)
                        break;
                }
                if (!(pFAT[FAT_SIMPLESERIF] - '0'))
                    *bucket_num |= B_SANS_SERIF;
                if (atoi(pFAT + FAT_WEIGHT) >= 10)
                    *bucket_num |= B_BOLD;
                if (pFAT[FAT_POSTURE] - '0')
                    *bucket_num |= B_ITALIC;
#if !ROM
                BUFfree(hSeg);
#endif
                break;

#if 0   /* don't think we need this */
**            case TF_HEADER_KEY:     /* do this later if FAT not found */
**                seg_off = GETLONG_NS(pbuf+2);
**#if !ROM
**                seg_size = GETWORD_NS(pbuf+6);
**                hSeg = FMalloc_rd(bucket->fh, seg_size, (gsegOff + seg_off));
**                if (hSeg == NIL_MH)
**                    break;
**                pSegData = MEMptr(hSeg);
**#else
**                pSegData = fontPtr + seg_off;
**#endif
**                if (tfnum == GETLONG_NS(pSegData + TFH_TFNUM) )
**                {
**                    if (pSegData[TFH_DESC_OFF + TFH_DSTEM_STY] == 10)
**                       *bucket_num |= B_SANS_SERIF;
**                    if (pSegData[TFH_DESC_OFF + TFH_DSTEM_WT] > 30)
**                       *bucket_num |= B_BOLD;
**                    if (pSegData[TFH_DESC_OFF + TFH_DSLANT_STY] != 10)
**                       *bucket_num |= B_ITALIC;
**                }
**#if !ROM
**                BUFfree(hSeg);
**#endif
**                break;
#endif  /* 0 */

            default:   break;

        }   /* switch (key) */

#if CGFIXED_PITCH
        if (fat_flag && attr_flag)
#else
        if (fat_flag)
#endif
            break;              /* exit loop once we've found our tables */
        offset += 8;
    } /* loop through segments in typeface global data */

    return TRUE;
}

#endif  /* DYNAMIC_FONTS */




#if FONTBBOX

/* ifget_FontBBox
 *
 * Returns font bbox and design resolution. Offsets bbox coordinates by
 * the left reference and baseline position.
 */

#define DISPLAY_FONTLIM  14
#define DISPLAY_LEFTREF  30
#define FACEATT_SCALEFC  4

#if defined (ANSI_DEFS)
GLOBAL UW16 ifget_FontBBox( PBUCKET pBucket, BBoxRes* basefont )
#else
GLOBAL UW16 ifget_FontBBox(pBucket, basefont)
  PBUCKET pBucket;
  BBoxRes* basefont;
#endif /* ANSI_DEFS */
{
    LPSB8    gsegptr;       /* pointer to IF segment data */
    LPSB8    segptr;
    LPUW16   limits;        /* font limits, L R T B       */
    LPUW16   pRef;          /* pointer to IF composition origin coords. */
#if IF_PCLEOI
    PHPFH pcleoHdr;
#endif

    switch (pBucket->extern_font)
    {
#if (IF_DISK || IF_ROM)
        case 0:
            if (pBucket->p.in.sdisplay  &&  pBucket->p.in.sattribute)
            {
                gsegptr = fgseg(pBucket);
                segptr = gsegptr + pBucket->p.in.odisplay;
                limits = (LPUW16)(segptr + DISPLAY_FONTLIM);
                pRef = (LPUW16)(segptr + DISPLAY_LEFTREF);
                basefont->BBox[0] = limits[1] - *pRef;      /* xmin */
                basefont->BBox[2] = limits[0] - *pRef++;    /* xmax */
                basefont->BBox[1] = limits[3] - *pRef;      /* ymin */
                basefont->BBox[3] = limits[2] - *pRef;      /* ymax */
                segptr = gsegptr + pBucket->p.in.oattribute;
                pRef = (LPUW16)(segptr + FACEATT_SCALEFC);
                basefont->emRes = *pRef;
            }
            else
                return ERRfont_bbox;
            break;
#endif  /* (IF_DISK || IF_ROM) */
#if IF_PCLEOI
        case 1:
            pcleoHdr = (PHPFH)pBucket->cur_font_hdr;
            basefont->BBox[2] = (int)pcleoHdr->cellWidth;   /* xmax */
            basefont->BBox[3] = (int)pcleoHdr->cellHeight;  /* ymax */
            basefont->BBox[0] = (int)pcleoHdr->textWidth;   /* xmin */
            basefont->BBox[1] = (int)pcleoHdr->textHeight;  /* ymin */
            basefont->emRes = (int)pcleoHdr->scaleFactor;
            break;
#endif  /* IF_PCLEOI */
        default:
            return ERRfont_bbox;
    }
    return SUCCESS;
}
#undef DISPLAY_FONTLIM
#undef DISPLAY_LEFTREF
#undef FACEATT_SCALEFC

#endif  /* FONTBBOX */
#endif  /* IF_RDR */

