/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/ix.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: ix.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.38   06 Apr 1995 15:14:38   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.37   26 Jan 1995 16:41:40   JOE
 * 
 * Moved declaration of "if_state" outside of conditional compile
 * for CONVERGENT_FONTS.
 * 
 *    Rev 1.36   23 Jan 1995 08:07:18   JOE
 * In IXinit(), corrected earlier change regarding setting of "entry_ct".
 * 
 *    Rev 1.35   11 Jan 1995 11:02:02   JOE
 * In IXinit(), changed conditional compile statement so that "entry_ct"
 * is set to 0 if FCO_RDR.
 * 
 *    Rev 1.34   30 Nov 1994 11:09:12   JOE
 * 
 * In init_font_index(), if FCO_RDR is enabled, add case check for
 * plug count = 0 since it is now valid to build font index file
 * without IF plugins.
 * 
 *    Rev 1.33   26 Sep 1994 09:40:50   JOE
 * 
 * In IXget_fnt_index(), when checking if IF ROM or DISK, also check
 * that it is not a foreign bitmap.
 * 
 *    Rev 1.32   02 Sep 1994 12:57:02   MIKE
 * 
 * In IXget_fnt_index() set fontindex.fcoSearchPath_on = 0.
 * 
 *    Rev 1.31   05 Aug 1994 16:02:38   MIKE
 * 
 * Added FCO changes from 1.22.1.2
 * 
 *    Rev 1.30   25 Apr 1994 13:50:12   MIKE
 * No change.
 * 
 *    Rev 1.29   22 Apr 1994 15:45:30   JOE
 * 
 * 
 * Changed conditional compile statement prior to including <hif.h> to
 * #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.28   22 Apr 1994 13:55:18   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.27   06 Mar 1994 15:19:46   MIKE
 * 
 * Changes to support AWT4 format in Convergent Fonts.
 * 
 *    Rev 1.26   09 Feb 1994 15:04:54   JOE
 * 
 * Did not fully implement bug fix for IXset_search_path() mentioned
 * above. In addition to returning SUCCESS, no longer setting "fontindex.
 * cur_tf_num" to 0 before returning SUCCESS.
 * 
 *    Rev 1.25   09 Feb 1994 11:59:12   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.24   03 Feb 1994 19:44:18   MIKE
 * Convergent Fonts II. Reads AWT4 header, which holds italic angle and
 * horizontal offset information.
 * 
 *    Rev 1.23   02 Feb 1994 08:48:14   JOE
 * 
 * AM29K changes.
 * In IXset_search_path(), fixed problem with fixed-pitch plugin processing
 * (return SUCCESS if the 2 weight-sensitive plugins are neither LETTER_GOTHIC
 * nor COURIER).
 * 
 *    Rev 1.22   10 Jan 1994 15:36:10   MIKE
 * Added constants AWT_ITAL & AWT_NHOC for AWT3 table.
 * 
 *    Rev 1.21   08 Dec 1993 18:58:58   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.20   06 Dec 1993 12:07:06   MIKE
 * Change awt code to read em resolution from bytes 22-23.
 * 
 *    Rev 1.19   01 Dec 1993 08:35:22   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.18   28 Oct 1993 16:29:48   JOE
 * In !LINT_ARGS function prototype for set_tt_universal(), removed argument
 * type to resolve compiler error.
 * 
 *    Rev 1.17   27 Oct 1993 09:59:46   MIKE
 * 
 * Fix convergent font bug with chars missing from AWT. fsearch_awt()
 * 
 *    Rev 1.16   11 Oct 1993 13:28:18   MIKE
 * 
 * Added CVFget_fnt_index(). Restructured CVFsearch_awt().
 * 
 *    Rev 1.15   10 Sep 1993 16:04:04   MIKE
 * CONVERGENT_FONTS: Optimize fsearch_awt() for linear search on Intel machine
 * 
 *    Rev 1.14   30 Aug 1993 10:51:00   MIKE
 * 
 * Changed convergent fonts to use AWT2 format (Motorola).
 * 
 *    Rev 1.13   16 Aug 1993 13:38:50   JOE
 * In ROM version of IXinit(), set "fontindex.entry_ct" to 0 if IF is
 * disabled. This is done to avoid using a null pointer "fontindex.pfnt_index"
 * to calculate this value.
 * 
 *    Rev 1.12   12 Aug 1993 10:26:08   MIKE
 * 
 * Modified CVsearch_awt() (used to be CVread_awt_header).
 * 
 *    Rev 1.11   02 Aug 1993 09:27:42   JOE
 * 
 * Support for PS ROM - In ROM version of IXinit(), if processing PS ROM,
 * BUFFalloc 'CHARBUFSIZE' bytes instead of 'EXPBUFSIZE' bytes.
 * 
 *    Rev 1.10   15 Jul 1993 11:37:44   MIKE
 * Put code in init_font_index() to init TT plugin in IF format.
 * CONVERGENT_FONTS: Added CVread_awt_header().
 * 
 *    Rev 1.9   28 Jun 1993 14:04:12   JOE
 * In IXget_fnt_index(), generalized the code which tests if the font index
 * entry has changed. Replaced "0x3c00" with "FC..." definitions.
 * 
 *    Rev 1.8   24 Jun 1993 14:17:22   JOE
 * In IXget_fnt_index(), if processing KANJI fonts, check encoding value in
 * addition to pathname before determining that TFS font has not changed.
 * This fixes a bug when switching from JIS to SJIS encoding and vice versa.
 * Included "kanji.h".
 * 
 *    Rev 1.7   15 Jun 1993 10:34:04   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.6   12 May 1993 15:59:14   ROB
 * Conditionalize 'core_list[]', save 32 bytes.
 * 
 *    Rev 1.5   06 May 1993 16:50:38   JOE
 * In !DYNAMIC_FONTS version of IXget_fnt_index(), conditionally compiled
 * references to font_hdr field of font context to resolve compiler error.
 * 
 *    Rev 1.4   22 Apr 1993 11:15:04   MIKE
 * Rewrite IXget_fnt_index() to support IF dynamic fonts.
 * 
 *    Rev 1.3   12 Feb 1993 13:25:30   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 15:34:52   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:56:50   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:46   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* ix.c */
/*
 *
 *  HISTORY:
 *
 *   12-Apr-90   jfd   In routine IXget_fnt_index, filter out bit 2
 *                     (italic/nonitalic flag) of "bucket_num" because
 *                     it is being used as an index into "hplugin"
 *    05-May-90  awr   Character buffer is fixed size- allocated once
 *    28-May-90  awr   if.fnt and if.ss are in directory ufstPath[].
 *    01-Jul-90  awr   Add "screen_fnt_ct" to determine if generic
 *                     screen fonts were installed.
 *    22-Jul-90  awr   Initialized ufstPath = "" for multicaller.
 *    23-Jul-90  awr   Merged Blake's default typeface path code in
 *    29-Jul-90  awr   changed conditional compile on MEMstat() from DEBUG
 *                     to MEM_TRACE
 *    18-Aug-90  awr   Correct buildpath() to not insert a "\" at the
 *                     beginning if source1 is null.
 *    04-Sep-90  awr   Removed find_compound()- no longer referenced.
 *    04-Dec-90  jfd   Moved "include" statement for  "cgconfig.h" to line
 *                     following "port.h"
 *    19-Dec-90  jfd   IFB on a Printer changes:
 *                     1.) In IXget_fnt_index(), change argument from
 *                         (LONG) to (FONTCONTEXT *).
 *                         Changed references of "hp" to "hix".
 *                         Changed references of "p" to "ix".
 *                     2.) Replace CC elements with fields from CHR_DEF_HDR
 *                         structure.
 *     7 Jan 91  ss    Added PCLEO_RDR support
 *    28-Jan-91  tnc   Window-ized file "close" and "read".
 *
 *    28-Jan-91  jfd   Made size arg of MEMalloc() LONG
 *    30-Jan-91  dET   Added function prototyping for MSC
 *    31-Jan-91  dET   Modify for MSC multi-model compilation.
 *     4-Feb-91  awr   Split off symbolset code to symmap.c.
 *    04-Mar-91  jfd   Conditionally declared FIpath (#if !ROM).
 *                     In FIentry(), fixed bug when comparing "j" to
 *                     MAX_UWORD.
 *    15 May 91  ss    Deleted references to COMPRESS.  This includes updating
 *                     references to FMalloc_rd() for 2 less parameters.
 *                     Added support for SLIM_FONTS and 15 plugins.
 *    06-Jun-91  jfd   SUN support.
 *                     (FIX FROM EARLIER VERSION)
 *
 *                     Moved debug.h after port.h
 *                     (FIX FROM EARLIER VERSION)
 *     5 Jun 91  ss    Added FIXED_PITCH support.
 *                     Deleted defines ZERO and NO_CMP, no longer needed.
 *    26-Aug-91  jfd   In IXget_fnt_index(), declaring "w" conditionally
 *                     based on FIXED_PITCH | SLIM_FONTS to get rid of
 *                     compiler warning.
 *    17 Sep 91  ss    Added line to set chr_def_hdr.font_hdr vs ix_extra->p_r
 *                     in IXget_fnt_index() for PCLEO_RDR and disk (!ROM).
 *    20 Sep 91  ss    Reordered plugin_list[] SLIM top level typeface
 *                     numbers to correctly match bucket_num settings.
 *    29-Sep-91  awr   IXinit() and IXexit() use CGIFinitstatus
 *     3 Oct 91  ss    Put is_fpitch back into IXget_fnt_index() since it
 *                     was incorrectly "cleaned up."
 *     4 Oct 91  ss    Added SPARC support.
 *    14-Oct-91  jfd   In IXinit() (ROM version), changed "got" to "goto"
 *                     to correct a compiler error. In same routine, 
 *                     removed call to BUFfree() with argument
 *                     "fontindex.hfnt_index" because it was unnecessary.
 *                     In same routine, changed "goto err3" to "goto err2"
 *                     because label "err3" was removed.
 *    28-Oct-91  jfd   Changed argument of function prototype for PCLmapLS()
 *                     from (HPFH *) to (PHPFH) to get rid of compiler
 *                     warning when building medium model.
 *     6-Jan-92  awr   UFST support added to IXgetfnt_index()
 *    15-Jan-92  jfd   Added functofin prototype for IXset_search_path().
 *    24-Feb-92  jfd   In IXget_fnt_index(), conditionally compiled
 *                     setting of "fontindex.cur_font_hdr" based on
 *                     EXTERN_FONT.
 *     8-Mar-92  awr   Added core font substitution for PS and TT
 *    13-Mar-92  jfd   In init_font_index(), add check for compatability
 *                     between plugin and fonts.
 *    19-Mar-92  jfd   Changed list of "core_list" fonts to agree with top
 *                     level of slim fonts
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    06-Apr-92  rs    Change 'FIXED_PITCH' to 'CGFIXED_PITCH' (portability).
 *    23 Apr 92  ss    In IXset_search_path(), now initialize elements of
 *                     fontindex.icur_index array before filling it in.
 *                     - Added code to fontindex.num_searches field based
 *                     on new scheme which doesn't set icur_index[0] to
 *                     typeface sensitive but does use it for the core
 *                     typeface needed for PS & TT.
 *                     Added set of new field fontindex.media.
 *    11 May 92  ss    In IXset_search_path(), only set icur_index entries
 *                     which are relevant.  Moved set of num_searches to
 *                     only set when actually add to a search level.
 *    21 May 92  ss    Cleaned up code for FIXED_PITCH including code for
 *                     Letter Gothic plugins now available.
 *    19-Jun-92  ss    In init_font_index(), if don't have Letter Gothic or
 *                     Courier plugins, set plugin values to MAX_UWORD.
 *   1 Jul 92  ss       Moved port.h to top to access defines earlier.
 *                      Changed conditional on SUN to UNIX to be more general.
 *  08-Jul-92  rs       Code cleanup.
 *  21-Jul-92  awr      Conditional compile changes.
 *   5-Aug-92  jfd      Removed function prototypes for "clear_mem()".
 *                      Never references here.
 *  10-Aug-92  rs       Change args in IXmak_font_index() from SW16 to int,
 *                      SL32 to long for 32 bit systems (Watcom C386).
 *  23-Sep-92  jfd      INTEL960 conditional compile changes.
 *  28-Sep-92  awr      Removed fontindex.media.
 *                      Changed FIentry() parameter to int.
 *  30-Sep-92  jfd      Removed conditional compiles based on SPARC and
 *                      replaced with conditional compiles based on
 *                      (NAT_ALIGN == 4) wherever possible.
 *  08-Oct-92  jfd      In IXget_fnt_index(), conditionally compiled line
 *                      which retrieved font_hdr from font context.
 *  10-Oct-92  rs       Add #include <string.h>.
 *  12-Oct-92  mby     In IXget_fnt_index() fix bug with fontindex.pathname
 *  12-Oct-92  awr      Added not_intellifont bit to CGIFinitstate
 *  14-Oct-92  awr      Added cur_ssnum to font matching list
 *                      Conditionally compiled out Intellifont
 *  16-Oct-92  jfd      In init_font_index(), resetting the 'not_intellifont'
 *                      bit if ROM.
 *  02-Nov-92  jfd      Changed conditional compiled from IF_RDR to
 *                      (IF_RDR || PS_IFPLUG || TT_IFPLUG).
 *  15-Nov-92  rs       Port to Mac -> include <unix.h> instead of <io.h>.
 *  06-Jan-93  jfd      ANSI C function declaration changes.
 *  08-Feb-93  jfd      VXWorks support.
 *  01-Apr-93  mby      Rewrite IXget_fnt_index() for dynamic fonts support.
 *  06-May-93  jfd      In !DYNAMIC_FONTS version of IXget_fnt_index(),
 *                      conditionally compiled references to font_hdr field
 *                      of font context to resolve compiler error.
 *  12-May-93  rs       Save 32 bytes by conditionalizing 'core_list[]' on
 *                      (NON_IF_FONT && (PS_IFPLUG || TT_IFPLUG)).
 *  15-Jun-93  jfd      Moved "vxWorks.h" before "port.h" to resolve conflicts.
 *  24-Jun-93  jfd      In IXget_fnt_index(), if processing KANJI fonts,
 *                      check encoding value in addition to pathname before
 *                      determining that TFS font has not changed. This fixes
 *                      a bug when switching from JIS to SJIS encoding and 
 *                      vice versa.
 *                      Included "kanji.h".
 *  28-Jun-93  jfd      In IXget_fnt_index() (both versions), generalized the
 *                      code which tests if the font index entry has changed.
 *                      For PS, TT or KANJI fonts, the symbolset is checked 
 *                      in addition to the pathname before determine that 
 *                      the font index has not changed.
 *                      In IXget_fnt_index() (both versions), replaced 
 *                      "0x3c00" with "(FC_FONTTYPE_MASK | FC_EXTERN_TYPE | 
 *                      FC_ROM_TYPE)".
 *  12-Jul-93  mby      In init_font_index(), code to initialize TT plugin in IF format.
 *  15-Jul-93  mby      CONVERGENT_FONTS: Moved CVread_awt_header() to this module.
 *  29-Jul-93  jfd      Support for PS ROM font - In ROM version of IXinit(),
 *                      if processing PS ROM font, BUFalloc 'CHARBUFSIZE' 
 *                      bytes instead of 'EXPBUFSIZE' bytes.
 *  12-Aug-93  mby      Modified CVsearch_awt() (used to be CVread_awt_header).
 *  16-Aug-93  jfd      In ROM version of IXinit(), set "fontindex.entry_ct"
 *                      to 0 if IF is disabled. This is done to avoid
 *                      using a null pointer "fontindex.pfnt_index" to
 *                      calculate this value.
 *  24-Aug-93  mby      Made changes in CVsearch_awt() & fsearch_awt() to read
 *                      AWT data in Motorola-only format, so code can be platform
 *                      independent. Added improved SWAPW and SWAPL macros.
 *  09-Sep-93  mby      Optimize fsearch_awt() for linear search on INTEL platforms.
 *  06-Oct-93  mby      CVsearch_awt -> CVFsearch_awt(). Restructured.
 *                      Added CVFget_fnt_index().
 *                  **  awtData.scaleFactor is hard-coded to 8782. In the
 *                      future it should be read from the awt file.
 *                      In IXset_search_path(), put fst_type code inside
 *                      NON_IF_FONT && (PS_IFPLUG || TT_IFPLUG).
 *  25-Oct-93  mby      fsearch_awt() to return a width of 0 if charnum isn't
 *                      found in the AWT table.
 *  28-Oct-93  jfd      In !LINT_ARGS function prototype for set_tt_universal(),
 *                      removed argument type to resolve compiler error.
 *  01-Dec-93  jfd      Changed KANJI_ENCODING to ASIAN_ENCODING.
 *  02-Dec-93  mby      Change awt code to read em resolution from bytes 22-23.
 *  08-Dec-93  rs       General cleanup - DOS & FLAT -> CGFLAT32.
 *  06-Jan-94  mby      Added constants AWT_ITAL & AWT_NHOC for AWT3 table. Not implemented yet.
 *  26-Jan-94  jfd      Conditionally compiled out #include for unistd.h .
 *                      Conditionally compiled #include for fcntl.h (if 
 *                      !defined(_AM29K) || (defined(_AM29K) && defined(UNIX) ).
 *                      In IXset_search_path(), fixed problem with fixed
 *                      pitch plugin processing (return SUCCESS if the 2
 *                      weight sensitive plugins are neither B_LETTER_GOTHIC
 *                      nor B_COURIER ).
 *  02-Feb-94  mby      AWT table header extended to 48 bytes (AWT4).
 *                      Read italic angle and horizontal offsets from AWT
 *                      table to support Convergent Fonts II (obliqued).
 *                      Added binary search routine CVF_bsearch().
 *                      Renamed fsearch_awt() => CVF_lsearch() [linear].
 *  04-Feb-94  jfd      Conditionally compiled #include for io.h (if !_AM29K).
 *                      Including "hif.h" if _AM29K.
 *  09-Feb-94  jfd      Did not fully implement bug fix for IXset_search_path()
 *                      which was mentioned above. In addition to returning
 *                      SUCCESS, no longer setting "fontindex.cur_tf_num" to
 *                      0.
 *  06-Mar-94  mby      Changes to support AWT4 format. Got rid of
 *                      CVF_lsearch(), replaced by CVF_bsearch().
 *  22-Apr-94  jfd      Changed conditional compile statement prior to
 *                      including <hif.h> to #if (_AM29K && !UNIX) to
 *                      resolve UNIX Metaware compiler error.
 *  23-Sep-94  jfd      In IXget_fnt_index(), when checking if IF ROM or
 *                      disk, also check that it is not a foreign bitmap.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  FCO Changes from 1.25.1.2:
 *  15-Mar-94  mby      In IXget_fnt_index(), has_path should make itself 0
 *                      for FCO font type.
 *  18-Jul-94  mby     In IXget_fnt_index (DYNAMIC_FONTS) add FCO test
 *                     in ROM code.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  02-Sep-94  mby     In IXget_fnt_index() set fontindex.fcoSearchPath_on=0.
 *  29-Nov-94  jfd     In init_font_index(), if FCO_RDR is enabled, add case
 *                     check for plug count = 0 since it is now valid to
 *                     build font index file without plugins.
 *  11-Jan-95  jfd/dbk In IXinit(), changed conditional compile statement
 *                     so that "entry_ct" is set to 0 if FCO_RDR.
 *  23-Jan-95  jfd/dah In IXinit(), corrected earlier change regarding
 *                     setting of "entry_ct".
 *  26-Jan-95  jfd     Moved declaration of "if_state" outside of
 *                     conditional compile for CONVERGENT_FONTS.
 *
 *  TO DO: CVFget_fnt_index() cleanup for CGIFwidth()
 *         Combine CVFget_fnt_index() & CVFsearch_awt() - save beaucoup code.
 */

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>
#endif

#include <string.h>

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#ifndef __i960
#if defined (MACINTOSH)
#include <unix.h>
#elif defined UNIX
#if !defined(_AM29K)
#include <unistd.h>
#endif
#else
#if !defined(_AM29K)
//#include <io.h>
#endif  /* !_AM29K */
#endif  /*  UNIX  */
#endif  /* !__i960 */

#ifdef LAMIGA
#define SEEK_END 2    
#endif


#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "segments.h"
#include "cgif.h"
#include "ix.h"
#include "sym.h"
#include "if_type.h"

#if ASIAN_ENCODING
#include "kanji.h"
#endif

#define MEM_TRACE 0    /* set to 1 to trace memory */

#define MAXNAME  80    /* max size name includes drive, path and file */

/* Character specific data (# parts, h_esc, v_esc, is_compound, etc.) */
EXTERN CHR_DEF_HDR chr_def_hdr;


#ifdef LINT_ARGS
GLOBAL PINDEX_ENTRY FIentry(int);
#if !ROM
GLOBAL LPSB8        FIpath(PINDEX_ENTRY);
#endif
GLOBAL UW16        IXmak_font_index(LPSB8);
MLOCAL UW16        init_font_index(VOID);
GLOBAL UW16        IXinit(VOID);
GLOBAL UW16        IXget_fnt_index(PFONTCONTEXT);
GLOBAL VOID         IXexit(VOID);
GLOBAL UW16         IXset_search_path(SW16);

#if CONVERGENT_FONTS
GLOBAL UW16         CVFsearch_awt(PFONTCONTEXT, UW16, LPSW16);
GLOBAL UW16         CVFget_fnt_index( PFONTCONTEXT, UW16, int, LPSW16);
MLOCAL UW16         CVF_bsearch( UW16, LPUW16, register int, LPSW16 );
#endif

EXTERN MEM_HANDLE   BUFalloc(SL32);
EXTERN VOID         BUFfree(MEM_HANDLE);
EXTERN UW16         BUCKinit(VOID);
EXTERN VOID         BUCKexit(VOID);
#if TT_TTPLUG_IF
EXTERN VOID         set_tt_universal(SL32);
#endif

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
EXTERN MEM_HANDLE   FMalloc_rd(int, UW16, long);
#else /* 32 bit platform */
EXTERN MEM_HANDLE   FMalloc_rd(int, int, long);
#endif

EXTERN VOID         buildpath(LPSB8, LPSB8, LPSB8);

#else  /*  not LINTARGS  */

EXTERN MEM_HANDLE   BUFalloc();
EXTERN VOID         BUFfree();
EXTERN UW16         BUCKinit();
EXTERN  VOID        BUCKexit();
#if TT_TTPLUG_IF
EXTERN VOID         set_tt_universal();
#endif
#if CONVERGENT_FONTS
GLOBAL UW16         CVFsearch_awt();
GLOBAL UW16         CVFget_fnt_index();
MLOCAL UW16         CVF_bsearch();
#endif

EXTERN MEM_HANDLE   FMalloc_rd();

EXTERN VOID         buildpath();

#endif    /* LINT_ARGS  */



EXTERN UW16 CGIFinitstate;

/* Character buffer */

EXTERN MEM_HANDLE hchar_buf;

/* Open files */

EXTERN SB8  ufstPath[];

/*----------------------------------------------------------------------*/
GLOBAL FONTINDEX fontindex;

#if CONVERGENT_FONTS
GLOBAL AWT_TABLE awtData;

/*
 *  SWAPW and SWAPL macros.
 */
#if  BYTEORDER == HILO
#define SWAPL(a)        (a)
#define SWAPW(a)        (a)

#else   /* BYTEORDER == LOHI */
#define SWAP2BYTE(p)  ( ((unsigned short)((p)[0]) << 8) |  (p)[1])
#define SWAP4BYTE(p)  ( ((SWAP2BYTE(p)+0L) << 16) | SWAP2BYTE((p)+2) )
#define SWAPW(a)      ((short) SWAP2BYTE( (unsigned char*)(&a) ))
#define SWAPL(a)      ((long)  SWAP4BYTE( (unsigned char*)(&a) ))
#endif

#endif  /* CONVERGENT_FONTS */

EXTERN IF_STATE if_state;
/*----------------------------------------------------------------------*/


#if (IF_RDR || PS_IFPLUG || TT_IFPLUG)   /*  Intellifont plugins  */

/*------------------*/
/*     FIBUF       */
/*------------------*/
/*  Macro to return a LPSB8 to the fontindex buffer. This
 *  pointer is obtained differently for ROM and disk based systems.
 */
#if (NAT_ALIGN == 4)  /* changed from "ifdef SPARC" -jfd 9/30/92 */  
#define ENTRY_CT_SIZE sizeof(SL32)
#else
#define ENTRY_CT_SIZE sizeof(SW16)
#endif

#if ROM
#define FIBUF (fontindex.pfnt_index + ENTRY_CT_SIZE)
#else
#define FIBUF (MEMptr(fontindex.hfnt_index) + ENTRY_CT_SIZE)
#endif  /* ROM */

/*------------------*/
/*     FIentry      */
/*------------------*/
/*  Return a pointer to a font index entry corresponding to the "i th"
 *  search level.
 *  NOTE: The array icur_index[] contains the index numbers into the
 *        array FIBUF of library font files.
 */
#if defined (ANSI_DEFS)
GLOBAL PINDEX_ENTRY FIentry(int buck_search_lvl)
#else
GLOBAL PINDEX_ENTRY
FIentry(buck_search_lvl)
    int buck_search_lvl;
#endif
{
        return (PINDEX_ENTRY)FIBUF + fontindex.icur_index[buck_search_lvl];
}



#if !ROM
/*------------------*/
/*     FIpath       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL LPSB8 FIpath(PINDEX_ENTRY ix)
#else
GLOBAL LPSB8
FIpath(ix)
    PINDEX_ENTRY ix;
#endif
{
    return FIBUF + fontindex.olibnames + ix->name_off;
}
#endif  /* !ROM */



#if !ROM
/*------------------*/
/* IXmak_font_index */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  IXmak_font_index(LPSB8 fname)
#else
GLOBAL UW16
IXmak_font_index(fname)
    LPSB8 fname;        /*  file name of font index file     */
#endif
{
    int        f; /* SW16 to int - 8/10/92 - rs */
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16      index_size;
#else /* 32 bit platform */
    int       index_size; /* UW16 to int - 8/10/92 */
#endif
    MEM_HANDLE  hbuf;
    SB8        pathname[MAXNAME];
#ifdef DEBUG
    SW16           i;
    PINDEX_ENTRY   p;
#endif

    DBG1("IXmak_font_index(%s)\n", fname);

  /* Build full pathname */
  	memset(pathname, '\0', sizeof(pathname));
    buildpath (pathname, ufstPath, fname);
    
  /* Read font index table */
    if ((f = OPEN(pathname, O_READFLAGS)) == -1)
    {
        DBG1("Font index file %s not found\n", pathname);
        return ERR_no_font_index;
    }

#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    index_size = (UW16)LSEEK(f, 0L, SEEK_END);
#else /* 32 bit platform */
    index_size = (int)LSEEK(f, 0L, SEEK_END);
#endif
    DBG1("index_size = %d\n", index_size);

    hbuf = FMalloc_rd(f, index_size, 0L);
    CLOSE(f);
    if(!hbuf)
    {
        DBG("read font index failed\n");
        return ERR_rd_font_index;
    }

/* Initialize fontindex */
    fontindex.hfnt_index = hbuf;
#if (NAT_ALIGN == 4)  /* changed from "ifdef SPARC" -jfd 9/30/92 */  
                      /* wrote out as long, but only need word  -ss 8/27/91 */
    fontindex.entry_ct = (SW16)*((LPSL32)MEMptr(hbuf));
#else
    fontindex.entry_ct = *((LPSW16)MEMptr(hbuf));
#endif
    fontindex.olibnames  = fontindex.entry_ct * sizeof(INDEX_ENTRY);
    fontindex.cur_tf_num = 0;
    fontindex.cur_font_hdr = (LPUB8)NULL;
    fontindex.font_type    = 0;
    fontindex.cur_ssnum    = (UW16)0;
#if (PST1_DISK || TT_DISK || DYNAMIC_FONTS)
    fontindex.has_path     = FALSE;
#endif

#ifdef DEBUG
    if(trace_sw)
    {
        printf("\n\nF o n t    I n d e x\n");
        printf("entry_ct = %d\n", fontindex.entry_ct);
        printf("    size of entry = %d\n", sizeof(INDEX_ENTRY));
        for(i = 0, p = (PINDEX_ENTRY)FIBUF; i<fontindex.entry_ct;  i++, p++)
#if (defined(M_I86SM) || defined(M_I86MM) || defined (M_I86TM))
            printf("%ld %Fs %lu %u %d\n", p->tfnum,
                                    FIpath(p),
                                    p->fhoff, p->fhcount, p->bucket_num);
#else
            printf("%ld %s %lu %u %d\n", p->tfnum,
                                     FIpath(p),
                                     p->fhoff, p->fhcount, p->bucket_num);
#endif

    }
#endif  /* DEBUG */

    return SUCCESS;
}

#endif  /*  !ROM  */

#if (NON_IF_FONT && (PS_IFPLUG || TT_IFPLUG))
static SL32 core_list[8]={
                 92500L, 92504L, 94021L, 94023L, 92501L, 92505L,
                 94022L, 94024L};
#endif

static plugin_list[ NMAX_PLUGINS ] = {
#if SLIM_FONTS       /*  reordered PSW #'s to match bucket_num -ss 9/30/91 */
  6305, 6309, 6307, 6311,  /* Top level - posture, weight, serif sensitive */
  6306, 6310, 6308, 6312,
#endif
  5720, 5721, 5723, 5724,  /* Originals - weight & serif sensitive         */
#if SLIM_FONTS
  5717, 5718,              /* Weight sensitive                             */
#endif
  5719                 };  /* Universals                                   */

#if TT_TTPLUG_IF
static SL32 plugin_TT = 94464L;
#endif


/*  masks for checking if all correct typefaces are loaded.  The values   */
/* vary depending on how plugin_list is compiled.                         */
#if SLIM_FONTS
#define FULL_PLUGIN_SET   0x7FFF      /* all 15 buckets  */
#define MED_PLUGIN_SET    0x7F00      /* missing top level - 7 buckets    */
#define ORIG_PLUGIN_SET   0x4F00      /* original 2 level, 5 buckets      */
#define SMALL_PLUGIN_SET  0x4300      /* original small_plugins, 3 buckets*/
#else
#define ORIG_PLUGIN_SET   0x001F      /* original 2 level, 5 buckets      */
#define SMALL_PLUGIN_SET  0x0013      /* original small_plugins, 3 buckets*/
#endif

/*------------------*/
/*  init_font_index */
/*------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 init_font_index()
#else
MLOCAL UW16
init_font_index()
#endif
{
#if !ROM
    UW16         status;
#endif
    SW16          i, j;
    PINDEX_ENTRY  ix;
    UW16         plug_ct;
    UL32         plugin_mask = 0L;
#if CGFIXED_PITCH
    UW16         courier_mask = 0,
                  lgothic_mask = 0;
#endif
    BOOLEAN       have_fat_plugins = TRUE;  /* 3-13-92 */
    BOOLEAN       have_slim_fonts = FALSE;  /* 3-13-92 */
#if TT_TTPLUG_IF
    SL32          tt_plugin_num = 0L;
#endif

    DBG("init_font_index\n");


  /* Allocate and read font index table */
#if !ROM            /*  already set this up for ROM        */
    status = IXmak_font_index((LPSB8)"if.fnt");
    if (status)
    {
        if(status != ERR_no_font_index)
            return status;
    }
    else
        CGIFinitstate &= ~not_intellifont;
#else
        CGIFinitstate &= ~not_intellifont;
#endif

  /* Find plugins and generic screen fonts */

#if SCREEN_FONTS
    fontindex.screen_fnt_ct = 0;
#endif
    plug_ct = 0;
    fontindex.plugin_set = 0;     /* initialize -ss 5/11/92 */
    ix      = (PINDEX_ENTRY)FIBUF;
    
    for( i = 0; i < fontindex.entry_ct; i++, ix++ )
    {
#if SCREEN_FONTS
        if( ix->tfnum == FACE_S_SCR  ||  ix->tfnum == FACE_SS_SCR )
        {
          fontindex.screen_fnt_ct++;
          continue;
        }
#endif

#if CGFIXED_PITCH
        if( B_ISFPITCH(ix) )
        {
           if( (ix->bucket_num & B_COURIER) == B_COURIER )
           {
              j = -1;
              if( ix->tfnum == 4415 )       /* Courier roman     */
                j = 0;
              else if( ix->tfnum == 4416 )  /* Courier bold      */


                j = 1;
              else if( ix->tfnum == 4414 )  /* Courier universal */
                j = 2;
              else continue;

              if( j >= 0 )     /* found a plugin, log it -ss 5/19/92 */
              {
                 fontindex.courier_iplugin[ j ] = i;
                 courier_mask |= 1 << j;
              }
              continue;
           }
           if( (ix->bucket_num & B_LETTER_GOTHIC) == B_LETTER_GOTHIC )
           {
              j = -1;
              if( ix->tfnum == 4938 )   /* Letter Gothic roman     */
                j = 0;
              if( ix->tfnum == 4939 )   /* Letter Gothic bold      */
                j = 1;
              if( ix->tfnum == 4941 )   /* Letter Gothic universal */
                j = 2;

              if( j >= 0 )     /* found a plugin, log it -ss 5/19/92 */
              {
                 fontindex.lgothic_iplugin[ j ] = i;
                 lgothic_mask |= 1 << j;
              }
              continue;
           }
        }
#endif  /*  CGFIXED_PITCH  */

#if TT_TTPLUG_IF
      if (ix->tfnum == plugin_TT)
      {
         tt_plugin_num = plugin_TT;
         fontindex.plugintt_pix = ix;
         continue;
      }
#endif

      /* search for tfnum in list of plugins to order iplugin */
      for( j = 0; j < NMAX_PLUGINS; j++ )
      {
         if( ix->tfnum == plugin_list[j] )
         {
            fontindex.iplugin[j] = i;
            plug_ct++;

            have_fat_plugins = ((ix->bucket_num & FILEORG_MASK) == D_LIB);  /* 3-13-92 */

            plugin_mask |= 1 << j;   /* turn on bit representing this tfnum */
            break;
         }
         else
            if ((ix->bucket_num & FILEORG_MASK) != D_LIB)
               have_slim_fonts = TRUE; /* 3-13-92 */
      }  /*  end - for j  */

/* If using IF core to augment TT or PS */
#if (NON_IF_FONT && (PS_IFPLUG || TT_IFPLUG))
    /* Set up icore[], the font index entries for the core 8. This array
     * is parallel to the static array core_list[8] defined above. The
     * low three bits of bucket_num can be used to index directly into
     * these arrays to find the matching Intellifont face to augment
     * PostScript and TrueType character sets.
     */
        for(j=0; j<8; j++)
            if(ix->tfnum == core_list[j])
                fontindex.icore[j] = i;
#endif

    }  /*  end - for i  */

#if TT_TTPLUG_IF
    set_tt_universal(tt_plugin_num);

#endif

    /* check for incompatability between plugins and fonts  3-13-92 */
#if !FCO_RDR
    if (have_fat_plugins && have_slim_fonts)
    {
       DBG("    plugins incompatable with fonts\n");
       return ERR_incompatable_plugin;
    }
#endif

    /* match exactly the tfnums required for a particular plugin scheme */
    switch( plug_ct )
    {
#if SLIM_FONTS
      case 15: if( plugin_mask != FULL_PLUGIN_SET )  /* all 15 typefaces  */
               {
                  DBG("    missing plugin\n");
                  return ERR_missing_plugin;

               }
               fontindex.plugin_set = FULL_PLUGIN_SET;
               break;
      case  7: if( plugin_mask != MED_PLUGIN_SET )      /* 7 typefaces    */
               {
                  DBG("    missing plugin\n");
                  return ERR_missing_plugin;
               }
               fontindex.plugin_set = MED_PLUGIN_SET;
               break;
#endif  /*  SLIM_FONTS  */
      case  5: if( plugin_mask != ORIG_PLUGIN_SET )     /*  5 typefaces   */
               {
                  DBG("    missing plugin\n");
                  return ERR_missing_plugin;
               }
               fontindex.plugin_set = ORIG_PLUGIN_SET;
               break;
      case  3: if( plugin_mask != SMALL_PLUGIN_SET )    /* 3 typefaces    */
               {
                  DBG("    missing plugin\n");
                  return ERR_missing_plugin;
               }
               fontindex.plugin_set = SMALL_PLUGIN_SET;
               break;
#if FCO_RDR
      case  0: break;
#endif
      default: DBG("    plugins incompatable with fonts\n");  /* 3-13-92 */
               return ERR_incompatable_plugin;
    }   /*  end - switch plug_ct */

#if CGFIXED_PITCH
    /* check that have 3 plugins for each typeface   */
    /*  Can have zero plugins or exactly 3 plugins   */
    if( courier_mask != 0x07 && courier_mask != 0 )
    {
         DBG("    missing fixed pitch plugin (courier)\n");
         return ERR_missing_plugin;
    }
    /*  Can have zero plugins or exactly 3 plugins   */
    if( lgothic_mask != 0x07 && lgothic_mask != 0 )
    {
         DBG("    missing fixed pitch plugin (lgothic)\n");
         return ERR_missing_plugin;
    }
    if( courier_mask == 0 )
       fontindex.courier_iplugin[0] = 
       fontindex.courier_iplugin[1] = 
       fontindex.courier_iplugin[2] = MAX_UWORD; 
    if( lgothic_mask == 0 )
       fontindex.lgothic_iplugin[0] = 
       fontindex.lgothic_iplugin[1] = 
       fontindex.lgothic_iplugin[2] = MAX_UWORD; 
#endif  /*  CGFIXED_PITCH  */

    return SUCCESS;
}



/*---------------------*/
/*  IXset_search_path  */
/*---------------------*/
/*  Set up the plugin search path for the current TFS typeface.
 *  It is only called to set up the search path when using Intellifont
 *  plugins.
 *
 *  The search path is a list of typeface library files that are to
 *  be searched in order to find any particular character in the font
 *  defined by the FONTCONTEXT. The current search path is an array in
 *  the FONTINDEX called fontindex.icur_index[].  Each element in the
 *  array is the index number of an INDEX_ENTRY in the font index
 *  file (if.fnt or ROM equivalent).
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  IXset_search_path(SW16 bucket_num)
#else
GLOBAL UW16
IXset_search_path(bucket_num)
    SW16 bucket_num;
#endif
{
    LPUW16         ci;                   /* pointer to icur_index   */
    int            i;
    LPUW16         sw,
                   u;
#if (CGFIXED_PITCH | SLIM_FONTS)

    LPUW16         w;
#endif
#if SLIM_FONTS
    LPUW16         psw;
#endif

    if(CGIFinitstate & not_intellifont)   /* Intellifont not active */
        return SUCCESS;


     /* clear indexes to plugin path */
     ci  = fontindex.icur_index;   /* list of current indexes to build  */
     for( i = 0; i < NBUCKET_LEVELS; i++ )
       *ci++ = MAX_UWORD;          /* initialize to an invalid value    */
     ci  = fontindex.icur_index;   /* rewind for next use               */

#if (NON_IF_FONT && (PS_IFPLUG || TT_IFPLUG))
     /* If not IF type, have want to reference a core typeface for missing */
     /*  characters before checking the plugins. Set the first level in    */
     /*  the plugin array to one of the 8 core typefaces that matches.     */
    {
     int fst_type = fontindex.font_type & FC_FONTTYPE_MASK;  /* mby 10-06-93 */
     if( (fst_type == FC_TT_TYPE   && TT_IFPLUG) ||
        (fst_type == FC_PST1_TYPE && PS_IFPLUG) )

     {
        *ci++ = fontindex.icore[bucket_num & 7];

        fontindex.num_searches++;            /* added another search level */
     }
    }
#endif


#if CGFIXED_PITCH
     if(bucket_num & B_FP_PLUGIN_MASK)
     {
       /* next are the 2 weight sensitive plugins                */
       if( (bucket_num & B_LETTER_GOTHIC) == B_LETTER_GOTHIC )
          w = fontindex.lgothic_iplugin;
       else if( (bucket_num & B_COURIER) == B_COURIER )
          w = fontindex.courier_iplugin;
       else
       {
       /*   fontindex.cur_tf_num = 0;   invalid font */
          return SUCCESS;  /* JPK */
       }

       /*  universal is 3rd  */
       u = w + 2;

       *ci++ = w[ bucket_num & 0x01 ];  /* use only low 1 bit   */
       *ci   = *u;
       fontindex.num_searches += 2;
       return SUCCESS;
     }
#endif  /*  CGFIXED_PITCH  */

    /*  If(small_plugins) the bolds aren't loaded so use normals
     *  instead.
     */
     if(fontindex.plugin_set == SMALL_PLUGIN_SET)
       bucket_num &= 2;

#if SLIM_FONTS
    psw = fontindex.iplugin;      /* posture/serif/weight at beginning */
    sw  = psw + NPSW_FACES;       /* serif/weight faces after PSW      */
    w   = sw  + NSW_FACES;        /* weight faces after SW faces       */
    u   = w   + NW_FACES;         /* Universal after W faces           */
#else
    sw  = fontindex.iplugin;      /* serif/weight                      */
    u   = sw  + NSW_FACES;        /* Universal                         */
#endif


#if SLIM_FONTS
    if(fontindex.plugin_set == FULL_PLUGIN_SET)
    {
       *ci++ = psw[ bucket_num & 0x07 ];  /* Lim Sensitive:       */
        fontindex.num_searches++;
    }
#endif
    *ci++ = sw[ bucket_num & 0x03 ];   /*    low 2 bits only   */
#if SLIM_FONTS
    if(fontindex.plugin_set == FULL_PLUGIN_SET 
                   || fontindex.plugin_set == MED_PLUGIN_SET )
    {
       *ci++ = w[ bucket_num & 0x01  ];   /*    low 1 bit only    */
        fontindex.num_searches++;
    }
#endif
    *ci   = *u;                        /* universal            */
    fontindex.num_searches += 2;       /* add 2 for sw & u     */

    return SUCCESS;
}
#endif /* (IF_RDR || PS_IFPLUG || TT_IFPLUG) */




#if ROM
/*------------------*/
/*  IXinit          */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  IXinit()
#else
GLOBAL UW16
IXinit()
#endif
{
    UW16         status;

    if(!(CGIFinitstate & not_buf))
        return ERR_IXinit;                  /* already initialized */

    /* Initialize font buckets */
    if ((status = BUCKinit()) != 0)
        return status;

    /* Allocate character buffer */
    /* Printer will not need the full character buffer since the char     */
    /*  data will already be in ROM or RAM (PCLEO) so only allocate       */
    /*  enuf for the expansion buffer.                                    */
#if PST1_ROM
    if(!(hchar_buf = BUFalloc((SL32)CHARBUFSIZE)))   /* 7-29-93 jfd */
#else
    if(!(hchar_buf = BUFalloc((SL32)EXPBUFSIZE)))
#endif
    {
       status = ERR_mem_char_buf;
       goto err1;
    }

#if (IF_RDR || PS_IFPLUG || TT_IFPLUG)  /*  Intellifont plugins  */
#if (NAT_ALIGN == 4)   /* wrote out as long, but only need word -ss 8/27/91 */
                       /* changed from "ifdef SPARC" -jfd 9/30/92 */
   if (FC_ISEXTERN(&if_state.cur_loc_fc) || FC_ISFCO(&if_state.cur_loc_fc))
      fontindex.entry_ct     = 0;
   else
      fontindex.entry_ct     = (SW16)*((LPSL32)(fontindex.pfnt_index));
#else
   if (FC_ISEXTERN(&if_state.cur_loc_fc) || FC_ISFCO(&if_state.cur_loc_fc))
      fontindex.entry_ct     = 0;
   else 
      fontindex.entry_ct     = *((LPSW16)(fontindex.pfnt_index));
#endif

#else
   fontindex.entry_ct     = 0;
#endif  /* (IF_RDR || PS_IFPLUG || TT_IFPLUG)  */
   fontindex.cur_tf_num   = 0;
   fontindex.cur_font_hdr = (LPUB8)NULL;
   fontindex.font_type    = 0;
   fontindex.cur_ssnum    = (UW16)0;
#if (PST1_DISK || TT_DISK || DYNAMIC_FONTS)
   fontindex.has_path     = FALSE;
#endif

#if IF_RDR
    if ((status = init_font_index()) != 0)  goto err2;  /* set up FONTINDEX */
#endif
    if ((status = SYMinit()) != 0)  goto err2; /* Load symbol set directory */

    CGIFinitstate &= ~not_buf;        /* turn off not initialized bit */
    goto noerr;
err2:  BUFfree(hchar_buf);
err1:  BUCKexit();
noerr: return status;
}  /*  end - IXinit  */


#else       /* !ROM */

/*------------------*/
/*  IXinit          */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 IXinit()
#else
GLOBAL UW16
IXinit()
#endif
{
    UW16 status;

    if(!(CGIFinitstate&not_buf)) return ERR_IXinit; /* already initialized */
    status = BUCKinit();               /* BUCKET lru list */
    if (status)
       return status;

	hchar_buf = BUFalloc((SL32)CHARBUFSIZE);
	if (!hchar_buf)
/*    if(!(hchar_buf = BUFalloc((SL32)CHARBUFSIZE))) ***KMR */    /* character buffer */
    {
        status = ERR_mem_char_buf;
        goto err1;
    }

#if IF_RDR
    status = init_font_index();           /* Set up FONTINDEX */
#endif

    if (status)
        goto err2;

    status = SYMinit();          /* Load symbol set directory */
    if(status)
        goto err3;
    CGIFinitstate &= ~not_buf;             /* turn off not initialized bit */
    goto noerr;

err3:
      BUFfree(fontindex.hfnt_index);
err2:
      BUFfree(hchar_buf);
err1:
      BUCKexit();
noerr:
      return status;
}
#endif  /*  !ROM  */




/*------------------*/
/*  IXexit          */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  IXexit()
#else
GLOBAL VOID
IXexit()
#endif
{
    DBG("\n\nIXexit()\n");

    if(CGIFinitstate & not_buf) return;   /* not initialized */

    BUFfree(hchar_buf);    /* free the character buffer      */
    BUCKexit();            /* close down the bucket lru list */
#if (!ROM && IF_RDR)
    if(!(CGIFinitstate & not_intellifont))
    {
        BUFfree(fontindex.hfnt_index);     /* free the FONTINDEX */
        CGIFinitstate |= not_intellifont;
    }
#endif  /*  ROM  */

    SYMexit();              /* free the symbol set directory */

    CGIFinitstate |= not_buf;    /* set not initialized bit */

#if MEM_TRACE
    MEMstat(BUFFER_POOL);
#endif
}


/*------------------*/
/*  IXget_fnt_index */
/*------------------*/
/*  Set current TypeFace Sensitive (TFS) font. */
/*
 *  There are 2 versions, compiled with DYNAMIC_FONTS = 0 or 1.
 *  If DYNAMIC_FONTS is 0, these are the possibilities:
 *   (1) For Intellifont ROM or disk, if the typeface number (fc->font_id)
 *       or the symbol set from the fontcontext has changed, then we
 *       search if.fnt until we find a matching TF number.
 *   (2) For a TT or PS font or IF PCLEO, fc->font_hdr is a pointer either
 *       to a pathname or to a PCLEO header or to the font in ROM. This
 *       is stored in fontindex along with the symbol set and TF number.
 *       We do not search if.fnt.
 *
 *  If DYNAMIC_FONT is 1, these are the possibilities:
 *   (1) and (2) behave exactly as described above.
 *   (3) The Intellifont face is specified by a pathname in fc->font_hdr.
 *       fc->font_id must be 0.
 *       First, test to see if nothing has changed.
 *       Next, try to match the path to one of the fonts in if.fnt.
 *       If this works, set the INDEX_ENTRY pointer in fontindex.
 *       Otherwise the pathname is passed along in fontindex.cur_font_hdr.
 *   (4) The IF face is specified by a pointer to ROM in fc->font_hdr.
 *       Same as (3) but with pointer instead of pathname.
 *   We can tell the difference betw. (3) and (4) by looking at fc->format.
 */

#if !DYNAMIC_FONTS


/*------------------*/
/*  IXget_fnt_index */
/*------------------*/
/*  Set current TypeFace Sensitive (TFS) font. */
/*  !DYNAMIC_FONTS                             */

#if defined (ANSI_DEFS)
GLOBAL UW16  IXget_fnt_index(PFONTCONTEXT fc)
#else
GLOBAL UW16
IXget_fnt_index(fc)
    PFONTCONTEXT fc;
#endif
{
    SL32           cur_tf_num;
    UW16           cur_ssnum;
    int            font_type;
    LPUB8          cur_font_hdr;
    int            has_path=0;
#if (PST1_DISK || TT_DISK)
    int            rom_font;
    BOOLEAN        extern_font;
#endif
#if IF_RDR
    int            i;
    PINDEX_ENTRY   ix;
#endif


    DBG("\nIXget_fnt_index()\n");

/*  If we've changed type faces, then find the font index entry
 *  for the new face.
 */
    font_type    = (int)(fc->format & (FC_FONTTYPE_MASK | FC_EXTERN_TYPE | 
                                          FC_ROM_TYPE));
    cur_ssnum    = fc->ssnum;
    cur_tf_num   = fc->font_id;
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
    cur_font_hdr = fc->font_hdr;
#endif

#if (PST1_DISK || TT_DISK)
    rom_font     = (int)(font_type & FC_ROM_TYPE);
    extern_font  = ((font_type & FC_EXTERN_TYPE) == FC_EXTERN_TYPE);
    has_path = !extern_font && !rom_font && (FC_ISPST1(fc) || FC_ISTT(fc));
                                /* disk-based: PS or TT */
    if(has_path)
    {
        if(fontindex.has_path)
        {
            if( (STRNCMP((LPSB8)fontindex.pathname,
                          (LPSB8)cur_font_hdr, PATHNAMELEN) == 0) &&
                   (cur_ssnum == fontindex.cur_ssnum))  /* 6-28-93 */
                    return SUCCESS;
        }
        STRCPY(fontindex.pathname, (LPSB8)cur_font_hdr);
    }
    else
#endif  /* (PST1_DISK || TT_DISK) */
      if ( (fontindex.font_type    == font_type   )  &&
             (fontindex.cur_ssnum    == cur_ssnum   )  &&
             (fontindex.cur_tf_num   == cur_tf_num  )  &&
             (fontindex.cur_font_hdr == cur_font_hdr))
          return SUCCESS;    /* haven't changed */

#if IF_RDR
    if ( !FC_ISEXTERN(fc) && FC_ISIF(fc) && !FC_ISAPPGEN(fc) ) /* IF ROM or disk, not ALIEN */
    {
        /*  Search if.fnt for INDEX_ENTRY  */
        fontindex.cur_pix = 0;          /* initialize to 0 */
        for (i=0, ix=(PINDEX_ENTRY)FIBUF;  i<fontindex.entry_ct;  i++, ix++)
            if (cur_tf_num == ix->tfnum) break;

        if (i >= fontindex.entry_ct)
        {
            DBG("    ERR_no_fi_entry\n");
            fontindex.cur_tf_num = 0;   /* To avoid a false match later. */
            return ERR_no_fi_entry;
        }
        fontindex.cur_pix = ix;     /* TFS INDEX_ENTRY pointer */
    } /* if ( !FC_ISEXTERN(fc) && FC_ISIF(fc) && !FC_ISAPPGEN(fc) ) */

#endif  /* IF_RDR */

  /*  Current TFS font has changed  */

    fontindex.font_type    = font_type;
    fontindex.cur_tf_num   = cur_tf_num;
    fontindex.cur_font_hdr = cur_font_hdr;
    fontindex.cur_ssnum    = cur_ssnum;
    fontindex.has_path     = has_path;
    fontindex.num_searches = 1;   /* only 1 level valid so far */
#if FCO_RDR
    fontindex.fcoSearchPath_on = 0;
#endif

    return SUCCESS;
}

#else   /* DYNAMIC_FONTS */

/*------------------*/
/*  IXget_fnt_index */
/*------------------*/
/*  Set current TypeFace Sensitive (TFS) font. */
/*  DYNAMIC_FONTS                              */

#if defined (ANSI_DEFS)
GLOBAL UW16  IXget_fnt_index(PFONTCONTEXT fc)
#else
GLOBAL UW16
IXget_fnt_index(fc)
    PFONTCONTEXT fc;
#endif
{
    SL32           cur_tf_num;
    UW16           cur_ssnum;
    int            font_type;
    LPUB8          cur_font_hdr;
    int            has_path=0;
    int            rom_font;
    int            extern_font;
#if IF_RDR
    int            i;
    PINDEX_ENTRY   ix;
#endif

    DBG("\nIXget_fnt_index()\n");

    font_type    = (int)(fc->format & (FC_FONTTYPE_MASK | FC_EXTERN_TYPE | 
                                          FC_ROM_TYPE));
    cur_ssnum    = fc->ssnum;
    cur_tf_num   = fc->font_id;
    cur_font_hdr = fc->font_hdr;

    rom_font     = (int)(font_type & FC_ROM_TYPE);
    extern_font  = (int)(font_type & FC_EXTERN_TYPE);
    has_path = !extern_font && !rom_font && !cur_tf_num
#if FCO_RDR
               && !FC_ISFCO(fc)
#endif
               ;  /* disk-based: PS, TT, or IF/dynamic; not FCO */

/* First, see if nothing has changed */
#if DISK_FONTS
    if (has_path)
    {                           /* TT/PST1 disk, IF disk (dynamic) */
        if(fontindex.has_path)
        {
            if( (STRNCMP((LPSB8)fontindex.pathname,
                          (LPSB8)cur_font_hdr, PATHNAMELEN) == 0) &&
                   (cur_ssnum == fontindex.cur_ssnum))  /* 6-28-93 */
            {
                    DBG("    disk: has_path OK\n");
                    return SUCCESS;     /* pathnames match */
            }
        }
        STRCPY(fontindex.pathname, (LPSB8)cur_font_hdr);
        goto IXgfi1;
    }
#endif /* DISK_FONTS */

#if ROM
    if (rom_font && !cur_tf_num
#if FCO_RDR
                                && !FC_ISFCO(fc)    /* 07-18-94, mby */
#endif
       )
    {                           /* TT ROM, IF ROM (dynamic) */
        if (fontindex.cur_font_hdr == cur_font_hdr)
        {
            DBG("    ROM: cur_font_hdr OK\n");
            return SUCCESS;     /* ROM pointers match */
        }
        goto IXgfi1;
    }
#endif  /* (ROM) */

    if ( (fontindex.font_type    == font_type   )  &&
             (fontindex.cur_ssnum    == cur_ssnum   )  &&
             (fontindex.cur_tf_num   == cur_tf_num  )  &&
             (fontindex.cur_font_hdr == cur_font_hdr))
        return SUCCESS;         /* IF disk/ROM, any PCLExO */

IXgfi1:

#if IF_RDR
    if ( !extern_font && FC_ISIF(fc) && !FC_ISAPPGEN(fc) ) /* IF rom or disk, not ALIEN */
    {
#if ROM
        LPUB8 romBlkPtr = fontindex.pfnt_index;
#endif
        fontindex.cur_pix = 0;          /* initialize to 0 */
        for (i=0, ix=(PINDEX_ENTRY)FIBUF;  i<fontindex.entry_ct;  i++, ix++)
        {
/* The following code may be unnecessary. The idea is that a dynamic font
   could also be registered in "if.fnt", so we should first search there
   for a pathname or rom pointer. This will save a call to FMprocess_face()
   later. If if.fnt only contains plugins, then we don't need
   "if (!cur_tf_num) { ... }".
*/
            if (!cur_tf_num)    /* dynamic font or not? */
            {
            /* Need to set cur_tf_num to avoid duplicate buckets. */
            /* Assumes ROM & disk mutually exclusive */
#if !ROM    /* disk-based */
                if (STRCMP( (LPSB8)fontindex.pathname, FIpath(ix) ) == 0)
                {
                    cur_tf_num = ix->tfnum;
                    break;
                }
#else   /* ROM */
                if ((romBlkPtr + ix->p_r.lib_offset) == cur_font_hdr)
                {
                    cur_tf_num = ix->tfnum;
                    break;
                }
#endif
            }
            else    /* IF font, not dynamic. Search if.fnt for INDEX_ENTRY  */
                if (cur_tf_num == ix->tfnum) break;
        }  /* for (... ) */

        if (cur_tf_num)
        {                                   /* not dynamic */
            if (i >= fontindex.entry_ct)
            {
                DBG("    ERR_no_fi_entry\n");
                fontindex.cur_tf_num = 0;   /* avoids a false match later. */
                return ERR_no_fi_entry;
            }
            fontindex.cur_pix = ix;         /* TFS INDEX_ENTRY pointer */
            cur_font_hdr = (LPUB8)NULL;     /* always */
        }

    } /* if ( !FC_ISEXTERN(fc) && FC_ISIF(fc) && !FC_ISAPPGEN(fc) ) */

#endif  /* IF_RDR */

  /*  Current TFS font has changed  */

    fontindex.font_type    = font_type;

    fontindex.cur_tf_num   = cur_tf_num;
    fontindex.cur_font_hdr = cur_font_hdr;
    fontindex.cur_ssnum    = cur_ssnum;
    fontindex.has_path     = has_path;
    fontindex.num_searches = 1;   /* only 1 level valid so far */
#if FCO_RDR
    fontindex.fcoSearchPath_on = 0;
#endif

    DBG1("    fontindex.font_type = %04x\n", fontindex.font_type);
    DBG1("    fontindex.cur_tf_num = %ld\n", fontindex.cur_tf_num);
    DBG1("    fontindex.cur_font_hdr = %lx\n", fontindex.cur_font_hdr);
    DBG1("    fontindex.cur_ssnum = %04x\n", fontindex.cur_ssnum);
    DBG1("    fontindex.pathname = %s\n", (fontindex.has_path ? fontindex.pathname : "") );

    return SUCCESS;
}

#endif  /* DYNAMIC_FONTS */





#if CONVERGENT_FONTS
#if (CONVERGENT_FONTS != 1 && CONVERGENT_FONTS != 3)
@@@@@       /* WARNING! CONVERGENT_FONTS must be 1 or 3 in cgconfig.h
               Force a compilation error */
#endif

/* Offsets to information in AWT table */
#define  AWT_FISZ    4      /* file size            */
#define  AWT_HDSZ    6      /* header size          */
#define  AWT_SFLG    8      /* substitute font bits */
#define  AWT_RFLG    10     /* request font bits    */
#define  AWT_SNUM    12     /* substitute tf number */
#define  AWT_RNUM    16     /* request tf number    */
#define  AWT_NCHS    20     /* number of characters */
#define  AWT_SCAL    22     /* Resolution per em; scale factor */
#if (CONVERGENT_FONTS == 1)
#define  AWT_ITAL    24     /* Italic Angle (tangent * 64K) */
#define  AWT_ITALX   28     /* Italic Angle (cosine * 64K) */
#define  AWT_ITALY   32     /* Italic Angle (sine * 64K)   */
#define  AWT_GHAJ    36     /* Global Horizontal AdJustment */
#define  AWT_NHOC    38     /* Number of Horizontal Offset Corrections */
#define  AWT_XMIN    40     /* Font bounding box -- combination of       */
#define  AWT_YMIN    42     /*   substitute typeface, supersensitive     */
#define  AWT_XMAX    44     /*   typeface, global horizontal adjustment, */
#define  AWT_YMAX    46     /*   and HOC table.                          */
#endif

#if defined (ANSI_DEFS)
GLOBAL UW16 CVFsearch_awt( PFONTCONTEXT fc, UW16 chId, LPSW16 altwidth )
#else

GLOBAL UW16 CVFsearch_awt( fc, chId, altwidth )
   PFONTCONTEXT fc;
   UW16  chId;
   LPSW16 altwidth;
#endif
{
#if IF_RDR
    LPUB8  awt = fc->p_AltWidTab;
    SL32   cur_tf_num;
    int    font_type;

    /* Sets up global awtData structure.
     * The Substitute and Supersensitive fonts must both be in IF format.
     * The typeface number bit must be cleared for both fonts.
     * No support for TT, PST1, or dynamic fonts.
     */
    if (awt != awtData.awtPtr)
    {
        UW16  word1, word2;
#if (CONVERGENT_FONTS == 1)
        if (!awt || *((LPUL32)awt) != AWT_ID4)  /* Data file integrity */
#endif
#if (CONVERGENT_FONTS == 3)
        if (!awt || *((LPUL32)awt) != AWT_ID3)
#endif
            return ERR_bad_awt;
        word1 = (UW16)(SWAPW(*((LPUW16)(awt + AWT_SFLG))));
        word2 = (UW16)(SWAPW(*((LPUW16)(awt + AWT_RFLG))));
        if ((word1 | word2) & AW_TFN_BIT)
            return ERR_bad_awt;
        awtData.awtPtr = awt;
        if ((awtData.subst_fType = (word1 & AW_FONTTYPE_MASK)) != AW_IF_TYPE)
            return ERR_bad_awt;
        if ((awtData.no_sstfs = (word2 & AW_SSTFS_BIT)) == 0)
        {
            if ((awtData.sstfs_fType = (word2 & AW_FONTTYPE_MASK)) != AW_IF_TYPE)
                return ERR_bad_awt;
        }
        awtData.useIFplugins = !(word2 & AW_PLUGIN_TYPE_BIT);
        awtData.IFpluginDesc = word2 & AW_IFPLUGIN_MASK;
        awtData.subst_tfnum = (UL32)(SWAPL(*((LPUL32)(awt + AWT_SNUM))));
        awtData.sstfs_tfnum = (UL32)(SWAPL(*((LPUL32)(awt + AWT_RNUM))));
        awtData.nchIDs = (UW16)(SWAPW(*((LPUW16)(awt + AWT_NCHS))));
        awtData.scaleFactor = (UW16)(SWAPW(*((LPUW16)(awt + AWT_SCAL))));
        if (!awtData.scaleFactor)
            awtData.scaleFactor = 8782;     /* default value */
#if (CONVERGENT_FONTS == 1)
        awtData.italTan = (SL32)(SWAPL(*((LPSL32)(awt + AWT_ITAL))));
        awtData.globalHorAdj = (SW16)(SWAPW(*((LPSW16)(awt + AWT_GHAJ))));
        awtData.nHorAdj = (SW16)(SWAPW(*((LPSW16)(awt + AWT_NHOC))));
        awtData.charProhbItal = 0;
#endif
    }

    {
      UW16  cgnum = SYMmap(chId, FC_IF_TYPE);
      SW16  widthListOffset;
#if (CONVERGENT_FONTS == 1)
      SW16  offsetListOffset;
#endif
      widthListOffset = SWAPW(*((LPUW16)(awt + AWT_HDSZ)));
      fontindex.noTFS = 0;
      cur_tf_num = awtData.subst_tfnum;

/*    font_type  = awtData.subst_fType; */
/*    if (CVF_lsearch((LPUW16)(awt + widthListOffset), cgnum, altwidth) != SUCCESS) */

      if (CVF_bsearch( cgnum, (LPUW16)(awt + widthListOffset),
                                (int)awtData.nchIDs, altwidth) != SUCCESS )
      {         /* did not find cgnum in AWT */
        if (awtData.no_sstfs)
        {
            fontindex.noTFS = 1;
        }
        else
        {
            cur_tf_num = awtData.sstfs_tfnum;
/***        font_type  = awtData.sstfs_fType; ***/
        }
      }
#if (CONVERGENT_FONTS == 1)
      offsetListOffset = widthListOffset + (awtData.nchIDs << 2);
      if_state.lsb_adj = 0;   /* remains 0, if bsearch fails */
      if (awtData.nHorAdj)
      {
          CVF_bsearch(cgnum, (LPUW16)(awt + offsetListOffset),
                          (int)awtData.nHorAdj, &if_state.lsb_adj);
      }
      if_state.lsb_adj += awtData.globalHorAdj;
      awtData.charProhbItalLast = awtData.charProhbItal;
      awtData.charProhbItal = 0;
#endif
    }

    font_type = FC_IF_TYPE;
#if IF_ROM
    font_type |= FC_ROM_TYPE;
#endif

    if ( ( fontindex.font_type == font_type )  &&
           ( fontindex.cur_ssnum == fc->ssnum )  &&
             ( fontindex.cur_tf_num == cur_tf_num )  &&
               ( fontindex.cur_font_hdr == 0 ) )
        return SUCCESS;    /* haven't changed */

    fontindex.font_type    = font_type;
    fontindex.cur_tf_num   = cur_tf_num;
    fontindex.cur_ssnum    = fc->ssnum;
    fontindex.cur_font_hdr = 0;
    fontindex.has_path     = 0;
    fontindex.num_searches = 1;   /* only 1 level valid so far */

    {
        /*  Search if.fnt for INDEX_ENTRY  */
        PINDEX_ENTRY   ix;
        int ii;
        for (ii=0, ix=(PINDEX_ENTRY)FIBUF;  ii<fontindex.entry_ct;  ii++, ix++)
            if (fontindex.cur_tf_num == ix->tfnum) break;


        if (ii >= fontindex.entry_ct)
        {

            fontindex.cur_tf_num = 0;
            fontindex.cur_pix = 0;
            return ERR_no_fi_entry;
        }
        fontindex.cur_pix = ix;     /* TFS INDEX_ENTRY pointer */
    }
    
    return SUCCESS;

#else   /* not IF_RDR! */
    return ERR_bad_awt;
#endif  /* IF_RDR */
}




#if defined (ANSI_DEFS)
GLOBAL UW16 CVFget_fnt_index( PFONTCONTEXT fc, UW16 chId, int control, LPSW16 altwidth )
#else

GLOBAL UW16 CVFget_fnt_index( fc, chId, control, altwidth )
   PFONTCONTEXT fc;
   UW16   chId;
   int    control;
   LPSW16 altwidth;
#endif
{
#if IF_RDR
    LPUB8  awt = fc->p_AltWidTab;
    SL32   cur_tf_num;
    int    font_type;

    /* Sets up global awtData structure.
     * The Substitute and Supersensitive fonts must both be in IF format.
     * The typeface number bit must be cleared for both fonts.

     * No support for TT, PST1, or dynamic fonts.
     */
    if (awt != awtData.awtPtr)
    {
        UW16  word1, word2;
#if (CONVERGENT_FONTS == 1)
        if (!awt || *((LPUL32)awt) != AWT_ID4)  /* Data file integrity */
#endif
#if (CONVERGENT_FONTS == 3)
        if (!awt || *((LPUL32)awt) != AWT_ID3)
#endif
            return ERR_bad_awt;
        word1 = (UW16)(SWAPW(*((LPUW16)(awt + AWT_SFLG))));
        word2 = (UW16)(SWAPW(*((LPUW16)(awt + AWT_RFLG))));
        if ((word1 | word2) & AW_TFN_BIT)
            return ERR_bad_awt;
        awtData.awtPtr = awt;
        if ((awtData.subst_fType = (word1 & AW_FONTTYPE_MASK)) != AW_IF_TYPE)
            return ERR_bad_awt;
        if ((awtData.no_sstfs = (word2 & AW_SSTFS_BIT)) == 0)
        {
            if ((awtData.sstfs_fType = (word2 & AW_FONTTYPE_MASK)) != AW_IF_TYPE)
                return ERR_bad_awt;
        }
        awtData.useIFplugins = !(word2 & AW_PLUGIN_TYPE_BIT);
        awtData.IFpluginDesc = word2 & AW_IFPLUGIN_MASK;
        awtData.subst_tfnum = (UL32)(SWAPL(*((LPUL32)(awt + AWT_SNUM))));
        awtData.sstfs_tfnum = (UL32)(SWAPL(*((LPUL32)(awt + AWT_RNUM))));
        awtData.nchIDs = (UW16)(SWAPW(*((LPUW16)(awt + AWT_NCHS))));
        awtData.scaleFactor = (UW16)(SWAPW(*((LPUW16)(awt + AWT_SCAL))));
        if (!awtData.scaleFactor)
            awtData.scaleFactor = 8782;     /* default value */
#if (CONVERGENT_FONTS == 1)
        awtData.italTan = (SL32)(SWAPL(*((LPSL32)(awt + AWT_ITAL))));
        awtData.globalHorAdj = (SW16)(SWAPW(*((LPSW16)(awt + AWT_GHAJ))));
        awtData.nHorAdj = (SW16)(SWAPW(*((LPSW16)(awt + AWT_NHOC))));
        awtData.charProhbItal = 0;
#endif
    }

    fontindex.noTFS = 0;
    cur_tf_num = awtData.subst_tfnum;
    font_type  = awtData.subst_fType;
    if (!chId)  /* if chId is 0, don't do the character mapping & lookup */
    {
        if (control == CVF_NO_INDEX)
            return SUCCESS;
        else if (control == CVF_REQU_FNT)
        {
            if (!(fontindex.noTFS = awtData.no_sstfs))
            {
                cur_tf_num = awtData.sstfs_tfnum;
                font_type  = awtData.sstfs_fType;
            }
        }
    }
    else        /* map chId; look up in table */
    {

        UW16  cgnum = SYMmap(chId, FC_IF_TYPE);
        SW16  widthListOffset;
#if (CONVERGENT_FONTS == 1)
        SW16  offsetListOffset;
#endif
        widthListOffset = SWAPW(*((LPUW16)(awt + AWT_HDSZ)));
/*      if (CVF_lsearch((LPUW16)(awt + widthListOffset), cgnum, altwidth) != SUCCESS) */
        if (CVF_bsearch( cgnum, (LPUW16)(awt + widthListOffset),
                         (int)awtData.nchIDs, altwidth) != SUCCESS )
        {       /* did not find cgnum in AWT */
            if (!(fontindex.noTFS = awtData.no_sstfs))
            {
                cur_tf_num = awtData.sstfs_tfnum;
                font_type  = awtData.sstfs_fType;
            }
        }
#if (CONVERGENT_FONTS == 1)
      /*** This code isn't used by CGIFwidth().      */
      /*** Figure out some way to branch around it.  */
        offsetListOffset = widthListOffset + (awtData.nchIDs << 2);
        if_state.lsb_adj = 0;   /* remains 0, if bsearch fails */
        if (awtData.nHorAdj)
        {
            CVF_bsearch(cgnum, (LPUW16)(awt + offsetListOffset),
                            (int)awtData.nHorAdj, &if_state.lsb_adj);
        }
        if_state.lsb_adj += awtData.globalHorAdj;
        awtData.charProhbItalLast = awtData.charProhbItal;
        awtData.charProhbItal = 0;
#endif
    }
#if IF_ROM
    font_type |= FC_ROM_TYPE;
#endif

    if ( ( fontindex.font_type == font_type )  &&
           ( fontindex.cur_ssnum == fc->ssnum )  &&
             ( fontindex.cur_tf_num == cur_tf_num )  &&
               ( fontindex.cur_font_hdr == 0 ) )
        return SUCCESS;    /* haven't changed */

    fontindex.font_type    = font_type;
    fontindex.cur_tf_num   = cur_tf_num;
    fontindex.cur_ssnum    = fc->ssnum;
    fontindex.cur_font_hdr = 0;
    fontindex.has_path     = 0;
    fontindex.num_searches = 1;   /* only 1 level valid so far */

    {
        /*  Search if.fnt for INDEX_ENTRY  */
        PINDEX_ENTRY   ix;
        int ii;
        for (ii=0, ix=(PINDEX_ENTRY)FIBUF;  ii<fontindex.entry_ct;  ii++, ix++)
            if (fontindex.cur_tf_num == ix->tfnum) break;

        if (ii >= fontindex.entry_ct)
        {
            fontindex.cur_tf_num = 0;
            fontindex.cur_pix = 0;
            return ERR_no_fi_entry;
        }
        fontindex.cur_pix = ix;     /* TFS INDEX_ENTRY pointer */
    }
    
    return SUCCESS;

#else   /* not IF_RDR! */
    return ERR_bad_awt;
#endif  /* IF_RDR */
}



#if defined (ANSI_DEFS)
MLOCAL UW16 CVF_bsearch( UW16 key, LPUW16 array_, register int high, LPSW16 value )
#else
MLOCAL UW16 CVF_bsearch( key, array_, high, value )
  UW16 key;             /* binary search wants to match 'key' */
  LPUW16 array_;        /* list of {charnum, value} */
  register int high;    /* number of elements in list */
  LPSW16 value;         /* returned value; width or offset; is left unchanged
                           on FAILURE */
#endif
/* Returns FAILURE if there is no match for 'key' */
{

/*  Binary search routine. */

    register int  ii;
    register int  low, new;

    low = 0; high--;
    while (low <= high)
    {
        new = (low + high) >> 1;
        ii = (SW16)(key - SWAPW(array_[new<<1]));
        if (ii > 0)
            low = new + 1;
        else if (ii < 0)
            high = new - 1;
        else
        {
            *value = (SW16)(SWAPW(array_[(new<<1)+1]));
            return SUCCESS;
        }
    }
    return FAILURE;
}



#if 0                      /* No longer needed  3/6/94,mby */
#if defined (ANSI_DEFS)
MLOCAL UW16 CVF_lsearch( LPUW16 charlist, UW16 charnum, LPSW16 width )

#else
MLOCAL UW16 CVF_lsearch( charlist, charnum, width )
   LPUW16  charlist;
   UW16    charnum;
   LPSW16  width;
#endif
{
/*  Searches for charnum in the array charlist. charlist is organized as
 *  { cgnum1, width1, cgnum2, width2, ... }. The data in charlist is in
 *  HI-LO byte order with cgnums in ascending order.
 */
    UW16 cnum = SWAPW(charnum);
    int ii;
    int nch = awtData.nchIDs << 1;
    for (ii=0; ii < nch; ii++,ii++)
    {
        if (cnum == charlist[ii])
        {
            *width = SWAPW(charlist[ii+1]);
            return SUCCESS;

        }
    }
    *width = 0;       /* Returns width = 0, if no entry in table */
                      /* This insures that if_state.alt_width will be zero */
    return FAILURE;
}
#endif

#endif  /* CONVERGENT_FONTS */

