/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/mapfont.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: mapfont.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.13   06 Apr 1995 15:14:44   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   22 Apr 1994 13:55:08   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.11   06 Mar 1994 14:34:26   MIKE
 * 
 * Check PROHIBIT_ITALIC flag for CONVERGENT_FONTS == 1.
 * 
 *    Rev 1.10   03 Feb 1994 16:20:44   MIKE
 * Check PROHIBIT_ITALIC flag for Convergent Fonts.
 * 
 *    Rev 1.9   15 Dec 1993 08:39:28   JOE
 * Fixed prohibit flag problem for external compound characters.
 * 
 *    Rev 1.8   11 Oct 1993 13:26:58   MIKE
 * In map_and_set_scale(), moved "buck_bits" inside SCREEN_FONTS. Changed
 * CVsearch_awt() prototype to CVFsearch_awt().
 * 
 *    Rev 1.7   12 Aug 1993 10:43:42   MIKE
 * 
 * In get_face_and_char(), set 'fontindex.awtsub_on'.
 * 
 *    Rev 1.6   15 Jul 1993 12:17:30   MIKE
 * Convergent Font support.
 * 
 *    Rev 1.5   09 Jul 1993 11:00:26   MAIB
 * get embolding values if making_bold set
 * 
 *    Rev 1.4   01 Jul 1993 14:27:08   MAIB
 * changed making_bold to non_z_wind
 * 
 *    Rev 1.3   12 Feb 1993 13:27:40   JOE
 * 
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 15:39:20   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:58:08   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:40   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* To do:
    - screen fonts substitution needs work for TT and PS. Must at least
      make sure the local fc is set to the right font type
*/
/* mapfont.c */

/*---------------------------------------------------------------------
     02-26-90   jfd   Changed "MAKfontSize()" to implement screen font
     05-02-90   jfd   Removed calls to routines
                         GETcharWidth()
                         GETprohibitFlags()
                         MAKEscreenFontBold()
                         MAKEscreenFontNonBold()
                         MAKEscreenFontItalic()
                         MAKEscreenFontNonItalic()
                         CHANGEfontID()
                      and replaced them with in-line code
     05-03-90   jfd   If explicitly requesting a screen font, variable
                      "face.glob_ital_tan" never gets set to "NO_TANGENT";
                      Added pointer "widthPtr" to shorten long expressions.
     05-04-90   jfd   Save/restore user's font context
     06-25-90   jfd   Added conditional compile for screen fonts
     07-01-90   awr   Reorganized screen font code. Won't try to sub screen
                      fonts is screen fonts not installed or if char is
                      not typeface sensitive.
     08-05-90   awr   Prohibit flags checked in MAKfontSize()
     08-29-90   det   In "MAKfontSize()", when calling get_face_and_char(),
                      pass "local_fc.font_id" as first argument.
     09-01-90   awr   Corrected the recently added conditional in
                      bitmap_size() from just checking bold to also check
                      spotsize.
     11-29-90   jfd   At start of MAKfontSize(), check if font id is 0
                      and return an error if it is.
                      Later, if comp_pix() returns an error, set current
                      local font_id to 0 so that when processing next
                      character, comp_pix() will be called again.
     12-19-90  jfd    IFB on a Printer changes:
                      1.) Changed first argument of get_face_and_char() from
                      (LONG) to (FONTCONTEXT *).
                      2.) Changed second argument of get_face_and_char() 
                          and made appropriate changes to routine.
                      3.) In MAKfontSize(), disabled symbol set mapping to
                          cg number and changed call to get_face_and_char().
                      5.) In set_kern(), disabled symbol set mapping to cg
                          number and changed call to IXsetup_chr_def().

     01-22-91   jfd   At start of MAKfontSize(), checking for space
                      character (812) and returning ERR_fixed_space.

     01-23-91   awr   Moved MAX_BM to "cgconfig.h".

     01-28-91   tnc   In outline_metrics(), if compound character, store
                      "h_esc" as escapement instead of calculating it 
                      from bounding box.

                     Made size arg of MAKfontSize() a PLONG

                     Made max size and size args of bitmap_size() and
                     outline_size() args LONG and PLONG

     01-30-91   dET  Forced "or_on" to be in the data segment by
                     initialization.  This allows fill.asm to be slighly
                     optimized.  This is a MSC qwirk.

                     function prototypes and modification to support 
                     MSC multi-model compilation.
     4-Feb-91   awr  Changed symbol set mapping to use SYMmap()
     5-Feb-91   awr  Put in FC_IS...() macros for testing format field
                     of FONTCONTEXT for output type.
     4-Feb-91   awr  Split off from maker.c. A lot of MAKfontSize()
                     is now map_and_set_scale()
     8-Feb-91   awr  Removed FCcopy_fc(), coded in line.
    10-Feb-91   awr  Moved or_on to SCALE structure. Added making_bold
                     to SCALE structure.
    23-Feb-91   awr  Changed bucket sub-segment handles to offsets.
    13-Apr-91   awr  Pseudo bold disable only done in typographer mode.
    17-Jun-91   jfd  Moved "debug.h" after "port.h".
                     Moved "profile.h" after "port.h".
    19 Jun 91   ss   Changed CHR_DEF.bucknum to CHR_DEF.buck_search_lvl.
     1 Jul 91   ss   Added prototypes for fgseg().
     8 Jul 91   bjg  Added Elasticity.
     5 AUG 91   tbh  Removed isElastic flag.
    13-Aug-91   jfd  In map_and_set_scale(), before setting shear values
                     if prohibit-italic is enabled (for TYPO_SCALE_MATRIX),
                     check that TYPO_SCALE_MATRIX has been selected (in
                     event of multiple scaling matrices selected)
    24-Aug-91   awr  Moved function decls to include file
    03-Oct-91   jfd  In map_and_set_scale(), if width segment does not
                     exist in the requested font, do not substitute
                     screen font.
    09-Oct-91   jfd  If not substituting screen font, reset alternate
                     black height instead of alternate width.

    25-Oct-91   jfd  In map_and_set_scale(), when checking if screen fonts
                     are supposed to cut-in, no longer casting subst_cutin
                     as (WORD) because if value is 65535, cast converts
                     it to -1 and substitution always takes place.
    03-Apr-92   rs   Portability cleanup (see port.h).
    04-Apr-92   rs   Edit 'map_and_set_scale()' to not kick out fixed space.
                     We need for PST1 & TT.
    22-May-92   rs   Remove conditioned out code from 'map_and_set_scale()'
                     for fixed space (cleanup).
    05-Aug-92   jfd  Disabled clear_mem(), replaced by direct call to
                     MEMSET.
    07-Aug-92   jfd  Compatability w/WINDOWS 3.1 (FIXED-->CGFIXED,
                     POINTFX-->CGPOINTFX)
    10-Aug-92   jfd  In map_and_set_scale(), do not want to check for
                     screen font substitution if PS or TT.
    15-Sep-92   jfd  In get_face_and_char(), conditionally compiled test
                     for IF bucket type based on IF_RDR. Did same in
                     map_and_set_scale().
    06-Jan-93   jfd  ANSI C function declaration changes.
    08-Feb-93   jfd  VXWorks support.
    01-Jul-93   maib Changed making_bold to non_z_wind
    09-Jul-93   maib Get embolding values if making_bold set
    12-Jul-93   mby  Do not call IXget_fnt_index() for Convergent Fonts.
    12-Aug-93   mby  In get_face_and_char(), set 'fontindex.awtsub_on'.
    05-Oct-93   mby  CVsearch_awt() -> CVFsearch_awt().
                     Moved "buck_bits" inside SCREEN_FONTS in map_and_set_scale().
    15-Dec-93   jfd  In map_and_set_scale(), check "missing_ccparts" flag
                     so that correct prohibit flags are used if processing
                     an external compound character.
    03-Feb-94   mby  In map_and_set_scale(), cancel the global horiz. shift
                     from the AWT file if the PROHIBIT_ITALIC flag is set.
    06-Mar-94   mby  Do above change only if CONVERGENT_FONTS == 1.
-----------------------------------------------------------------------*/


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "sym.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "fmath.h"
#include "if_type.h"


#ifdef LINT_ARGS
#if 0
GLOBAL VOID    clear_mem(LPUB8, UL32);
#endif
GLOBAL UW16   map_and_set_scale(PFONTCONTEXT, SW16);
MLOCAL UW16   get_face_and_char(PFONTCONTEXT, UW16, PPBUCKET);
/* fm.c */
EXTERN LPSB8   fgseg(PBUCKET);

EXTERN UW16   comp_pix(PFONTCONTEXT, PBUCKET);
EXTERN UW16   comp_pix_changed(PFONTCONTEXT, PBUCKET);
EXTERN UW16   IXsetup_chr_def(UW16, PCHR_DEF, PPBUCKET);
EXTERN UW16   CVFsearch_awt(PFONTCONTEXT, UW16, LPSW16);
#else         /* NOT LINT_ARGS */
/* fm.c */
EXTERN LPSB8   fgseg();

EXTERN UW16   comp_pix();
EXTERN UW16   comp_pix_changed();
EXTERN UW16   IXsetup_chr_def();
EXTERN UW16   CVFsearch_awt();
#endif        /* LINT_ARGS  */



EXTERN FONTINDEX fontindex;

EXTERN IF_STATE if_state;

#if CONVERGENT_FONTS
EXTERN AWT_TABLE awtData;
#endif

/*............Data from compound character segment.........................*/

EXTERN CHR_DEF chr_def[];
EXTERN CHR_DEF_HDR chr_def_hdr;

#if SLIM_FONTS
EXTERN CHARWIDTH missing_ccpart_widthinfo;
EXTERN SW16      missing_ccparts;
#endif

#if 0
/*----------------------*/
/*    clear_mem         */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  clear_mem(LPUB8 p, UL32 size)
#else
GLOBAL VOID
clear_mem(p, size)
    LPUB8 p;
    UL32  size;
#endif
{
    UL32 i;

    for(i=0; i<size; i++)
        *p++ = 0;
}
#endif /* 0 */



/*----------------------*/
/*  get_face_and_char   */
/*----------------------*/
/*  Set BUCKETs and chr_def  */
#if defined (ANSI_DEFS)
MLOCAL UW16  get_face_and_char(PFONTCONTEXT fc, UW16 chId, PPBUCKET pp_bucket)
#else
MLOCAL UW16
get_face_and_char(fc, chId, pp_bucket)
    PFONTCONTEXT fc;
    UW16        chId;
    PPBUCKET     pp_bucket;
#endif
{
    UW16     status;
    PBUCKET   bucket;

#if CONVERGENT_FONTS
#if (CONVERGENT_FONTS == 1)
    if_state.lsb_adj = 0;
#endif
    if (fc->p_AltWidTab)
    {
        if_state.awtsub_on = 1;
        status = CVFsearch_awt(fc, chId, &if_state.alt_width);
    }
    else
    {
        if_state.awtsub_on = 0;
        status = IXget_fnt_index(fc);
    }
#else
    status = IXget_fnt_index(fc);
#endif

    if (status)
        return status;
    status = IXsetup_chr_def(chId, chr_def, &bucket);
    if (status)
        return status;

  /*  If the library file has changed,
   *  initialize the global Intellifont data.
   */
#if IF_RDR
    if (bucket->fst_type == FC_IF_TYPE)
    if(!if_init_glob(bucket))
        return ERR_if_init_glob;  /*???? what about Windows and open files*/
#endif
    *pp_bucket = bucket;
    return SUCCESS;
}

/*----------------------*/
/*  map_and_set_scale   */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  map_and_set_scale(PFONTCONTEXT fc, SW16 chId)
#else
GLOBAL UW16
map_and_set_scale(fc, chId)
    PFONTCONTEXT  fc;
    SW16          chId;
#endif
{
    UW16   status;
    PBUCKET bucket;
    PCHARWIDTH   widthPtr;                   /* 05-03-90   jfd */
    FONTCONTEXT  local_fc;
#if ((ELASTIC_Y) | (ELASTIC_X))
    SL32 pixelwidth;
    UW16 frac;
#endif

#define PROHIBIT_BOLD     0x0040
#define PROHIBIT_ITALIC   0x0080

    DBG1("map_and_set_scale(%d)\n", chId);

#if 0   /* 14-Jan-92 jfd */
  /*  If font id is 0, return an error */

    if (!fc->font_id) return ERR_no_font; /* 11-29-90 jfd */
#endif

  /*  Load the font and set up to access the character */
 
    status = get_face_and_char(fc, chId, &bucket);
    if (status)
        return status;

    local_fc = *fc;   /* Local copy of FONTCONTEXT */
    local_fc.format = (local_fc.format & ~FC_FONTTYPE_MASK)
                              | bucket->fst_type;
  /* Point to character width and prohibit flags
     (if width segment exists!)
   */

    widthPtr = (PCHARWIDTH)NULL;
#if IF_RDR
    if(bucket->fst_type == FC_IF_TYPE)
    {
#if SLIM_FONTS
        if (missing_ccparts)
        {
           widthPtr = &missing_ccpart_widthinfo;
        }
        else
#endif
        {
           if (bucket->p.in.owidth_seg != MAX_UWORD)
              widthPtr = ((PCHARWIDTH)(fgseg(bucket) + bucket->p.in.owidth_seg)
                                                         + chr_def->index);
        }        
    }
#endif  /* IF_RDR */

    if (widthPtr)
    {

     /*  Don't pseudo-embolden this character if not allowed  */

       if (widthPtr->flags & PROHIBIT_BOLD)
       {
           local_fc.xbold = 0;
           local_fc.ybold = 0;
       }

/*  Don't pseudo-italicize this character if not allowed  */
        if (widthPtr->flags & PROHIBIT_ITALIC)
        {
#if (!SCALE_MATRIX)
            local_fc.shear.x = 0;
            local_fc.shear.y = 0x10000L;
#endif
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
            if (local_fc.fc_type == FC_TYPO_TYPE)  /* 08-13-91 jfd */
            {
                local_fc.s.t.shear.x      = 0;
                local_fc.s.t.shear.y      = 0x10000L;
            }
#endif
#if (CONVERGENT_FONTS == 1)
/*  If AWT4 convergent font, cancel global shift for ~Italic chars, 2-03-94 mby */
            if (if_state.awtsub_on)
            {
                if_state.lsb_adj -= awtData.globalHorAdj;
                awtData.charProhbItal = 1;
            }
#endif  /* CONVERGENT_FONTS */
        }

    }   /* widthPtr */

 
    if_state.glob_ital_tan = NO_TANGENT;

#if IF_RDR
/*================================================================*/
/*             G e n e r i c    S c r e e n    F o n t s          */
#if SCREEN_FONTS

      /* 
       * Check for screen font substitution (only for IF)
       */

   if (FC_ISIF(fc))
   {
      /*
       *
       *  If pixel size exceeds screen face substitution cut-in limit,
       *  we want to substitute the appropriate screen font.
       *  Screen fonts only contain type face sensitive characters, so
       *  don't bother trying to substitute if we're building a LS or U.
       *  Also, don't substitue if we're already a screen font.
       *  First check that the screen fonts are installed. Init_font_index()
       *  in ix.c sets screen_fnt_ct to 2 if they are.
       */

  /*  If the pt/set size or output resolution changed, then
   *  recompute the pixel size.
   */


  /* Bits indicate if base font is bold, serifed, and italic */
    SW16   buck_bits = bucket->bucket_num;

    status = comp_pix_changed(&local_fc, bucket);
    if (status)
        return status;


    DBG2("if_state.subst_wdth_fac = %u    if_state.subst_cutin = %u\n",
                                   if_state.subst_wdth_fac, if_state.subst_cutin);

    if((fontindex.screen_fnt_ct == 2)       /* Screen fonts are installed  */
           &&
                                            /* Only tfs have screen fonts  */
       (chr_def->buck_search_lvl == TF_SENSITIVE)/* changed name -ss 6/19/91 */
           &&
       (fc->font_id != FACE_S_SCR)          /* don't sub screen for screen */
           &&
       (fc->font_id != FACE_SS_SCR)
           &&
       (        if_state.x.orig_pixel > if_state.subst_cutin
                                 ||
                if_state.y.orig_pixel > if_state.subst_cutin     )

           &&
       if_state.subst_wdth_fac
           &&
       if_state.subst_cutin
           &&
       widthPtr)
    {
      /* Select serif or sans-serif generic screen font */

        if (buck_bits & B_SANS_SERIF)
            local_fc.font_id = FACE_SS_SCR;
        else
            local_fc.font_id = FACE_S_SCR;

      /*  Pseudo-embolden this character if base font is bold
       *  and character is allowed to be emboldened.
       */

        if ((buck_bits & B_BOLD)
                           && !(BOOLEAN)(widthPtr->flags & PROHIBIT_BOLD))
        {
          /*  If application is using pseudo bold, then go with
           *  application's bold values.
           */
            if(!if_state.making_bold)
            {
                local_fc.xbold = 496;
                local_fc.ybold = 330;
            }
        }

      /*  Pseudo-italicize this character if base font is italic
       *  and character is allowed to be italicized.
       */
 
        if((buck_bits & B_ITALIC)
                            && !(BOOLEAN)(widthPtr->flags & PROHIBIT_ITALIC))
        {
          /*  Calculate tangent of italic angle for later use
           *  and sign-extend if the value is negative.
           */

            if_state.glob_ital_tan = (if_state.glob_ital_ang && !if_state.italic_flag)
               ?    (CGFIXED)if_state.glob_ital_ang << 1
               :    (CGFIXED)if_state.loc_ital_ang << 1;
            if (if_state.glob_ital_tan >= 0x10000L)
                if_state.glob_ital_tan |= 0xFFFF0000L;
        }

      /*  Override screen character width with requested character's
       *  width unless application has already given an alternate width.
       */

        if (if_state.alt_width == 0)
            if_state.alt_width = (SW16)widthPtr->width;

#if ((ELASTIC_Y) | (ELASTIC_X))
        /*  Set alt_black_width for elasticity with screen fonts */
        pixelwidth = ((SL32)widthPtr->width<<4)/(SL32)if_state.x.orig_pixel;

        frac = (UW16)(pixelwidth & 0xf);
        pixelwidth >>= 4;
        if(frac < 8)
                pixelwidth--;
        if(pixelwidth <= 0)
            pixelwidth = 1;

        /*  compensate for serifs by adding an extra pixel 
            when serifs don't drop out */
        if (!(buck_bits & B_SANS_SERIF) && if_state.x.orig_pixel < 735)
          pixelwidth++;

        if_state.alt_black_width = (UW16)(pixelwidth * if_state.x.orig_pixel);
#endif

      /*  Load the generic screen font and set up to access the character */

        status = get_face_and_char(&local_fc, chId, &bucket);
        if (status)
            return status;
    }
    else
    {

    /* Not elastic font so reset alternate black width and alternate height */

       if_state.alt_black_width = 0;  /* 10-03-91 jfd */
       if_state.alt_black_height = 0;  /* 10-03-91 jfd */
    }

   }
#endif /* SCREEN_FONTS */
/*             G e n e r i c    S c r e e n    F o n t s          */
/*================================================================*/
#endif /* IF_RDR */

    return comp_pix(&local_fc, bucket);
}

