/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved,
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/path.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: path.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   06 Apr 1995 15:14:42   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 13:55:08   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   12 Feb 1993 13:15:22   JOE
 * 
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 14:59:28   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:57:46   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:36   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* path.c */
/*
 *
 *
 *  HISTORY:
 *
 *    22-Jul-90  awr   Initialized ufstPath = "" for multicaller.
 *    23-Jul-90  awr   Merged Blake's default typeface path code in
 *    18-Aug-90  awr   Correct buildpath() to not insert a "\" at the
 *                     beginning if source1 is null.
 *     4-Feb-91  awr   Split off from ix.c
 *    17-Jun-91   jfd  Moved "debug.h" after "port.h".
 *                     Moved "cgconfig.h" before "port.h".
 *    03-Apr-92   rs   Portability cleanup (see port.h).
 *    20-May-92   jfd  Changed buildpath() by adding a second delimiter
 *                     (":" if LAMIGA) to prevent an invalid path from being
 *                     returned.
 *   1 Jul 92  ss      Changed conditional on SUN to UNIX to be more general.
 *                     Changed conditional order of PATH_DELIM to resolve
 *                     problem on MIPS which is confused by #elif.
 *                     (? Bug in the preprocessor? )
 *  08-Jul-92  rs      Code cleanup.
 *  19-Nov-92  rs      Port to Macintosh -> path delimiters ":".
 *  06-Jan-93  jfd     ANSI C function declaration changes.
 *  08-Feb-93  jfd     VXWorks support.
 */


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "mixmodel.h"

#ifdef LINT_ARGS
GLOBAL VOID  buildpath(LPSB8, LPSB8, LPSB8);
#endif


GLOBAL SB8  ufstPath[PATHNAMELEN] = "";
GLOBAL SB8  typePath[PATHNAMELEN] = "";


#ifdef UNIX
#define PATH_DELIM      '/'
#define PATH_DELIM2     '\0'
#elif defined (MACINTOSH)
#define PATH_DELIM      ':'
#define PATH_DELIM2     ':'
#elif defined LAMIGA
#define PATH_DELIM      '/'
#define PATH_DELIM2     ':'
#elif defined __linux__
#define PATH_DELIM      '/'
#define PATH_DELIM2     '\0'
#else
#define PATH_DELIM      '\\'
#define PATH_DELIM2     '\0'
#endif

/*------------------*/
/*  buildpath       */
/*------------------*/
/*  Build the a full pathname in dest.  Assume source2 is either a simple
 *  filename or already the full pathname. Use the presence of a "\" to
 *  determine. source1 if the default directory path.
 *  If source1 is null or source2 contains a slash, copy source2 to dest.
 *  Otherwise, concatinate source1 and source2 in dest making sure that
 *  there is a "\" between them.
 */
#if defined (ANSI_DEFS)
GLOBAL VOID  buildpath(LPSB8 dest, LPSB8 source1, LPSB8 source2)
#else
GLOBAL VOID
buildpath(dest, source1, source2)
   LPSB8  dest, source1, source2;
#endif
{
    LPSB8 p, q;

  /* See if source2 contains "\" */
    q = source2;
    while ((*q) && ((*q) != PATH_DELIM) && ((*q) != PATH_DELIM2) )
       ++q;

    p = dest;
    if(! *q)              /* It doesn't, so assume source2 filename only */
    {
        if(*source1)        /* copy default directory path */
        {
            while(*source1)
                *p++ = *source1++;

            --p;              /* make sure a '\' seperates */
            if(*p != PATH_DELIM && (*p != PATH_DELIM2) ) {
                p++;
                *p++ = PATH_DELIM;
            }
            else ++p;
       }
     }

/*    while(*p++ = *source2++) 	***KMR */
	while (*source2) *p++ = *source2++;
	*p = '\0';
/*        ;						***KMR */
}

