/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/pcl_swap.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pcl_swap.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   06 Apr 1995 15:14:52   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 13:55:14   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.6   15 Jun 1993 10:38:24   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.5   01 Mar 1993 19:26:14   ROB
 * Fixed definition of 'compound_char() when ANSI_DEFS is set. Line 538,
 * changed 'PUB8' to 'LPUB8'.
 * 
 *    Rev 1.4   12 Feb 1993 13:47:38   JOE
 * 
 * VXWorks support.
 * 
 *    Rev 1.3   06 Jan 1993 14:56:46   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.2   14 Dec 1992 15:56:38   LISA
 * No change.
 * 
 *    Rev 1.1   14 Dec 1992 08:50:48   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:26   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pcl_swap.c */
/*
 *
 *
 *  HISTORY:
 *
 * Functions here provide the functionality to swap PCLEO data
 * from Motorola 680x0 format to Intel 80x86 format.          
 * History:
 *
 *    06 Nov 90 ss   Created from pcleo.c
 *    11 Jan 91 ss   Cleaned up misc junk
 *    04 Jan 91 dET  Added MSC multi model compilation support
 *    05-Mar-91 jfd  In structure HPFH, field "UWORD typeface" has been
 *                   changed to "UBYTE lsb_typeface" and "UBYTE msb_typeface"
 *                   so no need to SWAP "typeface" in font_hdr().
 *                   Changed copyright statement at top.
 *    13 Nov 91 ss   Test for existance of GIF segment before swapping.
 *    17 Jan 92 ss   Conditionaly compile ext_font_hdr(), not needed.
 *    03-Apr-92 rs   Portability cleanup (see port.h).
 *    16-Aug-92 rs	#define 'PCL_EFH = 0' if not defined already.
 *    20-Aug-92 jfd,ss
 *                   In simple_char(), check if contour tree exists before
 *                   using contour tree offset to test for HQ2 character.
 *    06-Jan-93 jfd  ANSI C function declaration changes.
 *    08-Feb-93 jfd  VXWorks support.
 *    15-Jun-93 jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
 */

#include "cgconfig.h" 

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#if PCLEO_RDR  &&  BYTEORDER == LOHI



#include <stdio.h>

#include "pcleo.h"


MLOCAL  union {
              SW16 w;
              struct{
                        SB8 b0;
                        SB8 b1;
                    }b;
           } tmp;


#define SWAPSAV( y )   SWAP; (y) = *(LPUW16)(p-2);
#define SWAP     tmp.w = *(LPUW16)p; *p++ = tmp.b.b1; *p++ = tmp.b.b0;
#define SWAPL    tmp.w = *((LPUW16)p); *((LPUW16)p) = *((LPUW16)(p+2));   \
                 *((LPUW16)(p+2)) = tmp.w; SWAP SWAP

MLOCAL UB8  even_odd = 0;
#define PAD   if(((UB8)p + even_odd) & 1) p++;


#define WORD_LEN  sizeof( SW16 )
#define LONG_LEN  sizeof( SL32 )
#define HQ2_MASK  0x02

#if !defined(PCL_EFH)
#define PCL_EFH	0
#endif

#ifdef LINT_ARGS
GLOBAL UW16  PCLswapHdr(LPUB8 );
GLOBAL UW16  PCLswapChar(LPUB8);

MLOCAL UW16  font_hdr(LPUB8);
#if PCL_EFH
MLOCAL UW16  ext_font_hdr(LPUB8);
#endif
MLOCAL UW16  gif(LPUB8);
MLOCAL LPUB8 skeletal( LPUB8, UW16, UW16);
MLOCAL UW16  simple_char( LPUB8 );
MLOCAL UW16  compound_char( LPUB8 );
#else
GLOBAL UW16  PCLswapHdr();
GLOBAL UW16  PCLswapChar();

MLOCAL UW16  font_hdr();
#if PCL_EFH
MLOCAL UW16  ext_font_hdr();
#endif
MLOCAL UW16  gif();
MLOCAL LPUB8 skeletal();
MLOCAL UW16  simple_char();
MLOCAL UW16  compound_char();
#endif


/*----------------*/
/*    font_hdr    */
/*----------------*/
/*  swap PCLEO header (HPFH) in place  */
#if defined (ANSI_DEFS)
MLOCAL UW16  font_hdr( LPUB8 p )
#else
MLOCAL UW16
font_hdr( p )
  LPUB8 p;
#endif
{

    SWAP;              /*    fontDescriptorSize                           */
    p += 4;            /*  UB8    descriptorFormat,                     */
                       /*     symbolSetOrganization, style_msb, Reserved1 */
    SWAP;              /*    baselinePosition                             */
    SWAP;              /*    cellWidth                                    */
    SWAP;              /*    cellHeight                                   */
    p += 2;            /*  UB8    orientation, spacing                  */
    SWAP;              /*    symSetCode                                   */
    SWAP;              /*    pitch                                        */
    SWAP;              /*    height                                       */
    SWAP;              /*    xHeight                                      */
    p += 3;            /*  SB8     appearanceWidth, strokeWeight,        */
                       /*    UB8 style_lsb                              */
    p += 2;            /*  UB8    lsb_typeface, msb_typeface (03-05-91) */
    p += 5;            /*  UB8 serifStyle, quality, placement,          */
                       /*   was_underlineHeight, SB8 was_underlinePosition */
    SWAP;              /*    textHeight                                   */
    SWAP;              /*    textWidth                                    */
    SWAP;              /*    firstCode                                    */
    SWAP;              /*    lastCode                                     */
    p += 2;            /*  UB8    pitch_ext, height_ext                 */
    SWAP;              /*    capHeight                                    */
    SWAPL;             /*  UL32    fontNumber                            */
    p += 16;           /*  UB8    fontName[16]                          */
    SWAP;              /*    scaleFactor                                  */
    SWAP;              /*    xRes                                         */
    SWAP;              /*    yRes                                         */
    SWAP;              /*    underlinePosition                            */
    SWAP;              /*    underlineHeight                              */
    SWAP;              /*    orThreshold                                  */
    SWAP;              /*    globItalAng                                  */
    SWAP;              /*    gifct                                        */

    return SUCCESS;
}  /*  end - font_hdr  */


#if PCL_EFH
/** conditionally compile out since not calling it any more.  Leave the   */
/*  code in for reference and future used.  Currently have no way to      */
/*  exactly determine if an extended header exists, and if it does exist, */
/*  is if of the Type Director type.                 -ss 1/17/92          */

/*----------------*/
/*  ext_font_hdr  */
/*----------------*/
/*  swap PCLEO extended header (HPEFH) in place  */
#if defined (ANSI_DEFS)
MLOCAL UW16  ext_font_hdr( LPUB8 p )
#else
MLOCAL UW16
ext_font_hdr( p )
  LPUB8 p;
#endif
{

    SWAP;              /*   ehHSize                                       */
    p += 2;            /*  UB8   ehHType, ehTreatment                   */
    SWAP;              /*   ehFamilynumb                                  */
    p += 2;            /*  UB8   ehFamilydes[2]                         */
    SWAP;              /*   ehStyle                                       */
    SWAP;              /*   ehClassIndex                                  */
    SWAP;              /*   ehExtleading                                  */
    SWAP;              /*   ehIntleading                                  */
    p += 4;            /*  UB8   ehStemStyle, ehStemMod, ehSymdes[2]    */
    SWAP;              /*   ehSymclass                                    */
    p += 2;            /*  UB8   ehType, ehClass                        */
    SWAP;              /*   ehXres                                        */
    SWAP;              /*   ehYres                                        */
    SWAP;              /*   ehXdot                                        */
    SWAP;              /*   ehYdot                                        */
    SWAP;              /*   ehGrays                                       */
    p += 2;            /*  UB8   pad, check                             */

    return SUCCESS;
                      
}  /*  end - font_hdr  */

#endif /* PCL_EFH */



/*----------------*/
/*     gif        */
/*----------------*/
/*  swap Global Intellifont Segment  */
#if defined (ANSI_DEFS)
MLOCAL UW16  gif( LPUB8 p )
#else
MLOCAL UW16
gif( p )
     LPUB8 p;
#endif
{
  SW16      i,
            m;

   /* Y-line */
   SWAPSAV( i )      /*  NYLN  */

   for( m = 1; m <= i; m++ )     /*  Y-line values  */
   {
     SWAP
   }	    

   /* Y-class */
   SWAPSAV( i )      /*  NGCD  */
   p  += i*2;  /* 2-byte arrays of Y line indices of size NGCD */

   /* Y-Dim */
   SWAPSAV( i )   /*  NGYD  */

   for( m = 1; m <= i; m++ )     /*  Global Y dim values       */
   {
     SWAP
   }	    

   p += i;                     /* byte array of pf flags     */

   /* check for odd boundary */
   PAD

   /* X-Dim */
   SWAPSAV( i )      /*  NGXD  */
 
   for( m = 1; m <= i; m++ )
   {
     SWAP
   }	    

   p += i;                       /*  byte array of flags       */

   /* check for odd boundary */
   PAD

   /* ultra low res */
   SWAP
   SWAP

   /*  face substitution */
   SWAP
   SWAP
   p += 8;

   return SUCCESS;
} /*  end - gif  */




MLOCAL UB8 N_TR;

/*----------------*/
/*    skeletal    */
/*----------------*/
/*  swap skeletal data  */
#if defined (ANSI_DEFS)
MLOCAL LPUB8 skeletal( LPUB8 p, UW16 NLOP, UW16 hq2)
#else
MLOCAL LPUB8
skeletal( p, NLOP, hq2 )
    LPUB8 p;
    UW16  NLOP;
    UW16  hq2;
#endif
{
    UB8 numof,
          N_SK;
    UW16 i;

    N_SK = *p++;                 /* Skip N_SK */

    if( hq2 )
    {
       p += NLOP;
       PAD
       for( i = 0; i < N_SK; i++ )
       {
          SWAP
       }
    }  /*  hq2  */

    N_TR = *p++;                 /* save y version for y line processing */
    numof = *p++;                /* N_ND */
    p += (UB8)2 * numof;
    if( hq2 )
    {
       p += numof;   /*  another byte array of N_ND  */
       numof = *p++;               /*  N_DM  */
       p += numof;
    }

    numof = (UB8)3 * *p++;     /* N_PR */
    p += numof;
    numof = *p++;                /* N_IN */
    p += numof;

    /*  Local Dimension Data  */
    if( hq2 )
    {
       numof = *p++;            /* N_LC */
       PAD
       for(i = 0; i < numof; i++ )
       {
          SWAP
       }
       p += numof;
    }
    PAD

    return( p );
}  /* end - skeletal  */





/*------------------*/
/*    simple_char   */
/*------------------*/
/*  Swap character data  */
#if defined (ANSI_DEFS)
MLOCAL UW16  simple_char( LPUB8 p )
#else
MLOCAL UW16
simple_char( p )
     LPUB8 p;
#endif
{
    UW16 metoff,     /* metric data      */
          ifoff,      /* Intellifont data */
          conoff,     /* Contour tree     */
          xyoff,      /* XY data          */
          tanoff;     /* Tangent data     */ /* 10-08-90 jfd */
    
    UW16 i, j;
    UW16 numof,
          NLOP   = 0,
          NPNT,
          NAUXPT,
          hq2    = 0;
   LPUB8 p_sav,
          p_beg;
    UW16 contour_flag;


    p_beg = p;

    SWAP                                    /* total length           */
    SWAPSAV( metoff )                       /* metric data            */
    SWAPSAV( ifoff )                        /* Intellifont data       */
    SWAPSAV( conoff )                       /* Contour tree           */
    SWAPSAV( xyoff )                        /* XY data                */


    /*  test for HQ2 character (if contour tree exists) */

    if(conoff != MAX_UWORD)
    {
       p_sav = p;
       p     = p_beg + conoff + WORD_LEN;      /* SWAP macros require p  */
       SWAPSAV( contour_flag )
       hq2   = (contour_flag & HQ2_MASK ) ? 1 : 0;
       if( hq2 )
       {
          p  = p_beg + conoff;                 /* backup to where NLOP is */
          SWAPSAV( NLOP )
       }
       p     = p_sav;                          /* restore p and continue */
    }


  /* Character may have an additional segment: Tangent Data.
     If so store it and SWAP. (10-08-90 jfd)
   */
  
    if( metoff == 12  ||  hq2 )  /* ?? is this really a duplicate test?? */
    { 
       SWAPSAV( tanoff )
    }

    /* Metric data           */
    for( i = 0; i < 10; i++ )
    {
      SWAP
    }


    /*  Intellifont Data     */
    if(ifoff != MAX_UWORD)
    {
        p = skeletal( p, hq2 ? NLOP : 0, hq2 );    /* Y-skeletal      */
        SWAP                                 /* y baseline            */

        if( hq2 )
        {
           numof = *p++;                    /*  NYCH  */
           p += numof;
           PAD
           for( i = 0; i < numof; i++ )
           {
              SWAP
           }
        }

        numof = *p++;                        /* NYCA ylines           */
        p += 2*numof + N_TR;
        numof = 2 * *p++;                    /* 2 * NLYCD             */
        p += numof;
        PAD
        SWAPSAV( numof )                     /* NLYLN                 */
        for( i = 0; i < numof; i++ )
        {        
           SWAP
        }

        p = skeletal( p, hq2 ? NLOP : 0, hq2 );    /* X-skeletal      */
        SWAP                                 /* Italic angle          */
        SWAP
        p += 2;                              /* Standard dimensions   */
    }

    if(conoff != MAX_UWORD)
    {
       if( hq2 )
       {
          p += sizeof( SW16 );    /* already swapped NLOP and have it */
       }
       else
       {
          SWAPSAV( NLOP )                    /* Contour Tree NLOP     */
       }
       /* contour_flag: already swapped to test for HQ2, so just skip */
       p += sizeof( SW16 );

       for(i=0; i<NLOP; i++)
       {
          SWAP
          p += 2;
          SWAP
          SWAP
       }
    }

    if(xyoff != MAX_UWORD)
    {
       if( hq2 )
       {
          for(i=0; i<NLOP; i++)
          {
             SWAPSAV( NPNT )                   /* XY coordinate Data    */
             SWAP
             SWAP
             for( j = 0; j < (UB8)2 * NPNT; j++ )
             {
               SWAP
             }
             p += NPNT;
             PAD
          }

       }
       else
       {
          for(i=0; i<NLOP; i++)
          {
             SWAPSAV( numof )                   /* XY coordinate Data    */
             numof *= 2;
             SWAPSAV( NAUXPT )
             NAUXPT *= 2;
             for(j=0; j<numof; j++)
             {
               SWAP
             }
             p += NAUXPT;

          }  /*  end - else  */

       }  /*  hq2  */
    }   /*  end - xyoff  */

    p += 2;                                 /*  pad, checksum          */

    return SUCCESS;

}  /*  end - simple_char  */



/*-------------------*/
/*   compound_char   */
/*-------------------*/
/*  Swap data for compound character specification   */
#if defined (ANSI_DEFS)
MLOCAL UW16  compound_char( LPUB8 p )
#else
MLOCAL UW16
compound_char( p )
    LPUB8 p;
#endif
{
    UW16     i,
              num_parts;

    /*  Build compound character class 4 entity.     */
    SWAP                     /*  escapement          */
    num_parts = *p++;        /* ?? only one byte ??  */
    p++;                     /*  ?? skip byte        */

    for( i = 0; i <  num_parts; i++ )
    {
       SWAP                  /* character code       */
       SWAP                  /* X offset             */
       SWAP                  /* Y offset             */
    }

    p += 2;                  /*  pad, checksum       */

    return SUCCESS;
}  /*  end - compound_char  */



/*----------------*/
/*   PCLswapHdr   */
/*----------------*/
/*  Call routines to swap sections of the whole header  */
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLswapHdr( LPUB8 p )
#else
GLOBAL UW16
PCLswapHdr( p )
  LPUB8 p;
#endif
{
  UW16    i;
  PHPFH    fh;
  /**  HPEFH   *efh;  **/

   font_hdr( p );
   fh  = (PHPFH)p;
   p  += sizeof( HPFH );

   /* get a fudge factor if GIF starts on odd boundry   */
   even_odd = (UB8)p & 1;

   /* swap gif only if segment is avaliable    -ss 11/13/91 */
   if( fh->gifct )
   {
      gif( p );
      p  += fh->gifct;
   }

   SWAPSAV( i )              /* copyright length     */
                         /* only need to save if using PCL_EFH -ss 1/17/92 */
  
#if PCL_EFH                  /* compiled out, not needed.  -ss 1/1792 */
   p  += i;                  /* bump past copyright  */

   /**  efh = (PHPEFH)p;    **  Don't need to save this      **/
   ext_font_hdr( p );
   /** p  += sizeof( HPEFH );**  All done so don't waste time  **/
#endif

   return SUCCESS;
} /*  end - PCLswapHdr  */



/*----------------*/
/*  PCLswapChar   */
/*----------------*/
/*  Determine if character is simple or compound and call routines  */
/*  to swap data as appropriate.                                    */
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLswapChar( LPUB8 p )
#else
GLOBAL UW16
PCLswapChar( p )
  LPUB8 p;
#endif
{
     PPCL_CHR_HDR   ch;

     /*  map beginning of buffer into header struct  */
     ch = (PPCL_CHR_HDR)p;
     p += sizeof(PCL_CHR_HDR);

     even_odd = (UB8)p & 1;
     if( ch->class == PCL_SIMPLE_CHR )
       simple_char( p );
     else if( ch->class == PCL_COMPOUND_CHR )
       compound_char( p );
     else
     {
        return FAILURE;
     }

    return SUCCESS;

} /*  end - PCLswapChar  */

#endif  /*  PCLEO_RDR && BYTEORDER == LOHI */

