/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/pcleoutl.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pcleoutl.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.14   18 Apr 1995 16:49:16   JOE
 * 
 * Conditionally compiled PCLeo2IF_ssnum() based on !NO_SYMSET_MAPPING.
 * 
 *    Rev 1.13   06 Apr 1995 15:14:42   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   25 Jul 1994 11:48:44   JOE
 * Changed last arg of PCLeo2IF_ssnum() (if !ANSI_DEFS) from "fc_ssnum"
 * to "fc_ssn" to resolve compiler error.
 * 
 *    Rev 1.11   05 Jul 1994 08:21:36   MIKE
 * 
 * Add 3rd argument to PCLeo2IF_ssnum(); don't change fontcontext->ssnum.
 * 
 *    Rev 1.10   22 Apr 1994 13:55:10   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.9   02 Feb 1994 09:09:50   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.8   08 Dec 1993 18:59:46   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.7   27 Oct 1993 19:47:14   MIKE
 * 
 * if MULTICALLER, call PCLchId2ptr() with callerID argument.
 * 
 *    Rev 1.6   21 Sep 1993 14:44:44   JOE
 * 
 * Added function prototype for getHPFH() to resolve compiler error
 * on SPARC.
 * 
 *    Rev 1.5   25 Aug 1993 14:21:22   JOE
 * Moved getHPFH() and GET_TOK macro from within IF_RDR block and
 * conditionally compiled it based on PCLEO_RDR to resolve linker
 * error on SPARC when building for TT only.
 * 
 *    Rev 1.4   15 Jun 1993 10:37:02   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.3   12 Feb 1993 13:23:14   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 15:13:16   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 15:57:34   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:32   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pcleoutl.c */
/*
 *
 *
 *  HISTORY:
 *
 *  original  ss
 *  15-Dec-90 awr  Reworked.
 *  04-Jan-91 dET  Add support for MSC multi model compilation.
 *  23-Feb-91 awr  Changed bucket sub-segment handles to offsets.
 *  04-Mar-91 jfd  In PCLload_font(), when loading "b->hfgseg", change
 *                 "hseg" to "hfgseg".
 *                 In PCLload_font():
 *                 1.) When calculating pointer for raster parameter,
 *                     change "fgseg" to "pfgseg".
 *                 2.) When calculating display segment pointer, change
 *                     "b->hdisplay" to b->odisplay.
 *                 3.) Store "pfgseg" into "b->pfgseg".
 *                 In PCLEOmake_cd(), removed cc_cgnum, i, j, m, num_cc,
 *                 status, cgnum.
 *                 Added declaration for structure chr_def_hdr.
 *                 Included "debug.h".
 *                 Corrected function prototype for PCLEOmake_cd().
 *                 Added function prototype for PCLascii2ptr(), PCLmapLS()
 *                 and PCLload_font().
 *  08-Apr-91 jfd  In PCLload_font(), changed the names of references
 *                 to two fields in the BUCKET structure so that they agree
 *                 with the names in file IX.H: "ocopyright" becomes "ocopy"
 *                 and "scopyright" becomes "scopy". Also, when storing
 *                 "copyright_len", use "*PWORD" instead of "PWORD".
 *  05-Jun-91 jfd  Changed name of PCLascii2ptr() to PCLchId2ptr()
 *                 (FIX FROM EARLIER VERSION)
 *
 *                 In IXsetup_chr_def(), added cast for "cc->nparts".
 *                 (FIX FROM EARLIER VERSION)
 *
 *                 In PCLmapLS(), when testing for italic, use
 *                 face_classification[2] instead of face_classification[3]
 *                 (FIX FROM EARLIER VERSION)                 
 *
 *                 In PCLEOmake_cd(), when processing compound characters
 *                 from PCLEOs, was forgetting to store values in
 *                 "cd->bucknum" and "cd->index" which was causing incorrect
 *                 bitmaps to be produced.
 *                 (FIX FROM EARLIER VERSION)                 
 *
 *                 Added getHPFH routine
 *                 (FIX FROM EARLIER VERSION)
 *   9-Jun-91 awr  Changed chr_def_hdr structure
 *   6 Jun 91 ss   Added support for FIXED_PITCH.
 *  19 Jun 91 ss   - Changed CHR_DEF.bucknum to CHR_DEF.buck_search_lvl.
 *                 - Changed bucket_descriptors[] to include only the items
 *                 actually needed. (Copied from IXMAK.C.)
 *                 - In PCLmapLS changed references to face_classification[]
 *                 to more descriptive variable names.
 *  26 Jun 91 ss   Changed "BYTE*" to PBYTE.
 *  27-Aug-91 jfd  Removed first argument (PBUCKET) from PCLEOmake_cd()
 *                 because it was never referenced. This resolves a compiler
 *                 warning.
 *   4 Oct 91 ss   Added SPARC support.
 *   9 Nov 91 ss   Clear out chr_def_hdr.mirror_flags just to be safe.
 *  13 Nov 91 ss   Test for existance of GIF segment before referencing it.
 *   8 Jan 92 awr  Moved call to PCLmapLS() to PCLload_font() per UFST.
 *  03-Apr-92 rs   Portability cleanup (see port.h).
 *  06-Apr-92 rs   Change 'FIXED_PITCH' to 'CGFIXED_PITCH' (portability).
 *  23 Apr 92 ss   Deleted stub for PCLchId2ptr() since supporting code
 *                 is now functional.
 *   1 Jul 92  ss  Moved port.h to top to access defines earlier.
 *                 Changed conditional on SUN to UNIX to be more general.
 *                 Eliminated cast of buf in macro GET_TOK which caused a
 *                 problem on the MIPS.
 *  08-Jul-92  rs  Code cleanup.
 *  31 Jul 92  ss  Added PCLeo2IF_ssnum() to convert the ss_code in a pcleo
 *                 header to the IF ssnum.
 *  05-Aug-92  jfd Replaced calls to "clear_mem()" with MEMSET for
 *                 optimization.
 *                 Included "mixmodel.h" and "string.h".
 *  14-Aug-92  rs  Fix conditional problem to not include 'memory.h' if
 *                 using Watcom C386 compiler.
 *  16-Sep-92  jfd Conditionally compiled PCLEOmake_cd(), PCLload_font(),
 *                 PCLmapLS() and getHPFH() based on IF_RDR.
 *  28-Sep-92  awr Changed parameter of PCLEOmake_cd()
 *  30-Sep-92  jfd Removed conditional compiles based on SPARC and replaced 
 *                 with conditional compiles based on (NAT_ALIGN == 4 &&
 *                 BYTEORDER == HILO) .
 *  09-Oct-92 mby  Change first arg of PCLeo2IF_ssnum() to PFONTCONTEXT,
 *                 because we need to use FC_ISxx(fc) macros. Code looks at
 *                 different symbolset pointers, depending on FST type.
 *  21-Oct-92 mby  Include "cgmacros.h" for GET_x...() macros.
 *  30-Oct-92 jd   In PCLeo2IF_ssnum(), conditionally compiled sections of
 *                 code which test if processing TT based on TT_RDR.
 *  23-Nov-92 mby  In PCLeo2IF_ssnum(), change conditional code to work with
 *                 TrueType only.
 *  06-Jan-93 jfd  ANSI C function declaration changes.
 *  08-Feb-93 jfd  VXWorks support.
 *  15-Jun-93 jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
 *  25-Aug-93 jfd  Moved getHPFH() and GET_TOK macro from within IF_RDR block
 *                 and conditionally compiling it based on PCLEO_RDR to
 *                 resolve linker error on SPARC when building for TT only.
 *  21-Sep-93 jfd  Added function prototype for getHPFH() to resolve
 *                 compiler error on SPARC.
 *  27-Oct-93 mby  if MULTICALLER enabled, call PCLchId2ptr() with callerID
 *                 argument. Declare uLastCallerId EXTERNAL.
 *  08-Dec-93 rs   General cleanup - MSDOS & OS2.
 *  27-Jan-94 jfd  Further conditionally compiled #include for "memory.h"
 *                 based on !defined (_AM29K).
 *  01-Jul-94 mby  Add 3rd argument to PCLeo2IF_ssnum(). This function should
 *                 not change 'ssnum' in application's copy of fontcontext.
 *  25-Jul-94 jfd  Changed last arg of PCLeo2IF_ssnum() (if !ANSI_DEFS)
 *                 from "fc_ssnum" to "fc_ssn" to resolve compiler error.
 *  18-Apr-95 jfd  Conditionally compiled PCLeo2IF_ssnum() based on
 *                 !NO_SYMSET_MAPPING.
 */

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#if PCLEO_RDR

#include <stdio.h>
 /* Watcom and INTEL960 need string.h instead of memory.h */
#if !defined (__WATCOMC__) && !defined(__i960) && !defined(VXWORKS) && !defined(_AM29K)
#include <memory.h>
#endif

#include <string.h> /* needed by Watcom and everyone else */


#ifndef UNIX
#include <stdlib.h>
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "pcleo.h"
#include "cgif.h"
#include "ix.h"
#include "segments.h"
#include "sym.h"
#include "cgmacros.h"

#if !NO_SYMSET_MAPPING
#ifdef LINT_ARGS
GLOBAL UW16       PCLeo2IF_ssnum( PFONTCONTEXT, UW16, LPUW16 );
#else
GLOBAL UW16       PCLeo2IF_ssnum();
#endif
#endif  /* !NO_SYMSET_MAPPING */

#if IF_RDR

#ifdef LINT_ARGS
GLOBAL UW16       PCLEOmake_cd(UW16, PCHR_DEF, int);
GLOBAL UW16       PCLload_font(LPUB8, PBUCKET);
MLOCAL SW16        PCLmapLS(PHPFH);
EXTERN MEM_HANDLE  BUFalloc( SL32 );
GLOBAL VOID       getHPFH(PHPFH, LPUB8);
#if !MULTICALLER
EXTERN LPUB8      PCLchId2ptr(UW16);
#else   /* Multicaller enabled */
EXTERN LPUB8      PCLchId2ptr(UW16, UW16);
#endif  /* MULTICALLER */
#else
GLOBAL UW16       PCLEOmake_cd();
GLOBAL UW16       PCLload_font();
MLOCAL SW16        PCLmapLS();
EXTERN MEM_HANDLE  BUFalloc();
EXTERN LPUB8      PCLchId2ptr();
GLOBAL VOID       getHPFH();
#endif


MLOCAL SB8
       faisweights[15] = {0x01, 0x01, 0x01, 0x01, 0x02, 0x02, 0x03, 0x03,
                          0x03, 0x04, 0x04, 0x05, 0x05, 0x05, 0x05};

#define NLS_FACES         4
#define NBUCK_DESCRIPTORS 3

MLOCAL SB8 bucket_descriptors[NLS_FACES * NBUCK_DESCRIPTORS] =
{
  /* stem style,      stem weight, slant style   */
  /* 10 = sans serif, 30 = medium, 10 = upright  */
  /* 20 = serif,      40 = bold,   20 = italic   */

        20,            30,         10,         /* Type Face 5720  */
        20,            40,         10,         /* Type Face 5721  */
        10,            30,         10,         /* Type Face 5723  */
        10,            40,         10,         /* Type Face 5724  */
};


/* Character specific data (# parts, escape, is_compound, etc.) */
EXTERN CHR_DEF_HDR chr_def_hdr;

#if MULTICALLER         /* mby, 10/27/93 */
EXTERN  UW16  uLastCallerId;
#endif



/*--------------*/
/*   PCLmapLS   */
/*--------------*/
/*  determine limited sensitive bucket number based on data available in  */
/*  the PCLEO font header.                                                */

#if defined (ANSI_DEFS)
MLOCAL SW16  PCLmapLS( PHPFH fh )
#else
MLOCAL SW16
PCLmapLS( fh )
     PHPFH    fh;
#endif
{
   UW16      w;
   LPSB8      b;
   SW16       ls_bucket;
   SW16       stem_wt,
              stem_style,
              slant_style;
   SW16       tf_stem_wt,
              tf_stem_style,
              tf_slant_style;
   UW16      current, 
              closest;

   /* Stem style */
   tf_stem_style = (SB8)(10 * (fh->serifStyle >> 6) );

   /* stem weight */
   /*  strokeWeight = stemWeight - 8  */
   /*  want stemWeight... stemWeight = strokeWeight + 8 */
   tf_stem_wt = (SB8)(10 * faisweights[ fh->strokeWeight + 8 - 1] );

   /* slant style */
   /*  posture is 2 low bits of style_lsb, use low 1 bit here */
   tf_slant_style = (SB8)(10 * ( (fh->style_lsb & 1) + 1) );

   /*  Compute limited sensitive bucket */
   /*  code stolen from ixmak.c  */

   closest = 0xffff;
   b       = bucket_descriptors;
   for( w = 0; w < NLS_FACES; w++)
   {
      stem_wt     = (tf_stem_wt     - b[1])/10;
      slant_style = (tf_slant_style - b[2])/10;
      stem_style  = (tf_stem_style  - b[0])/10;

      current = (((UW16)stem_wt & 0x8000)    >> 7) +
                 ((UW16)((ABS(stem_wt))    << 9)) +
                 (((UW16)slant_style & 0x8000)  >> 11) +
                 ((UW16)((ABS(slant_style)) << 5)) +
                 (((UW16)stem_style & 0x8000) >> 15) +
                 (UW16)((ABS(stem_style)) << 1);
               
      if (closest > current)
      {
         closest   = current;
         ls_bucket = w;      /*  bucket_num  */
       }
       b += NBUCK_DESCRIPTORS;

    }   /*  end - for  */

    if (tf_slant_style > (SB8)10)
        ls_bucket |= B_ITALIC;                 /* if italic, set bit 2 */

#if CGFIXED_PITCH
    if( fh->spacing == 0 )            /* have a fixed pitch typeface      */
    {
        /*  The width of a typeface must exactly match one we have or we  */
        /* cannot provide the plugins.                                    */
        switch( fh->pitch )
        {
           case COURIER_WIDTH:
                    ls_bucket |= B_COURIER;
                    break;
           case LETTER_GOTHIC_WIDTH:
                    ls_bucket |= B_LETTER_GOTHIC;
                    break;
           default:                         /* fixed pitch, no plugins    */
                    ls_bucket |= B_FIXED_PITCH;
                    break;
        }

    }  /* end - fixed_pitch  */
#endif  /*  CGFIXED_PITCH  */

    return ls_bucket;
} /*  end - PCLmapLS  */


#define RASTER_SIZE    4


/*----------------------*/
/*     PCLload_font     */
/*----------------------*/
/*  Convert PCLEO font header into segment data.                          */
/*  1. Compute size of the BUFFER_POOL memory block needed & allocate it. */
/*  2. Copy or convert the PCLEO font header into the segments.           */
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLload_font( LPUB8 fh_buf, PBUCKET b )
#else
GLOBAL UW16
PCLload_font( fh_buf, b )
  LPUB8  fh_buf;
  PBUCKET b;
#endif
{
  PHPFH      fh;
  PDISPLAY   d;
  PFACE_ATT  a;
  UW16      size;
  MEM_HANDLE hfgseg;
  LPSB8      pfgseg;
  UW16      offset;
  LPUB8     p;
#if SEGACCESS
  SW16       copyright_len;
#endif

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)     /* added   -ss 9/23/91 */
                         /* changed from "ifdef SPARC" - jfd 9/30/92 */
   HPFH       tmp_fh;

   getHPFH( &tmp_fh, (LPUB8)fh_buf );
   fh = &tmp_fh;
#else
   fh   = (PHPFH)fh_buf;         /* map to font header struct  */
#endif

    b->bucket_num = PCLmapLS(fh) | FC_EXTERN_TYPE;

  /*  BUFFER_POOL memory block is needed to contain:
   *    raster parameter segment = 4 bytes
   *    display segment          = sizeof( DISPLAY )
   *    face attribute segment   = sizeof( FACE_ATT )
   *    global intellifont       = size from PCLEO header (gifct)
   *    copyright segment        = size from PCLEO header
   *
   * Other segments not currently needed by ufst:
   *    fontalias segment
   */

   size = RASTER_SIZE + sizeof( DISPLAY) + sizeof( FACE_ATT) + fh->gifct;

#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from "ifdef SPARC" -jfd 9/30/92 */  
   /*** Check this ref to fh_buf  ****/
#endif
   
#if SEGACCESS
   copyright_len = *(LPSW16)(fh_buf + sizeof( HPFH ) + fh->gifct);
   size += copyright_len;
#endif  /*  SEGACCESS  */

   /*  Allocate BUFFER_POOL memory, free BUCKETS if needed.      */
   if( !(hfgseg = BUFalloc((SL32)size)) )
     return FAILURE;
   pfgseg = MEMptr(hfgseg);

   MEMSET( (LPUB8)pfgseg, (int)0, (int)size );

   /*  set pointers and sizes in Bucket  */

   b->p.in.hfgseg = hfgseg;                      /*  face global segment */
   b->p.in.pfgseg = pfgseg;
   b->p.in.sfgseg = size;

   offset = 0;

   b->p.in.gifct  = fh->gifct;
   /*  global IF segment   */
   if( b->p.in.gifct )                  /* no offset if no gif -ss 11/13/91*/
   {
      b->p.in.ogif   = offset;
      offset   += fh->gifct;
   }
   else b->p.in.ogif = MAX_UWORD;  /* make it consistent with refs to it */

   b->p.in.oattribute = offset;                  /*  attribute header    */
   b->p.in.sattribute = sizeof( FACE_ATT );
   offset       += sizeof( FACE_ATT );

   b->p.in.orast      = offset;                  /*  raster parameter    */
   b->p.in.srast      = RASTER_SIZE;
   offset       += RASTER_SIZE;

   b->p.in.odisplay   = offset;                  /*  display header      */
   b->p.in.sdisplay   = sizeof( DISPLAY );


   /***  Fill in segments  ***/
   
   /*  Global IF Data  */
   fh_buf       += sizeof( HPFH );    /* point to global if */
   if( b->p.in.gifct )      /* don't copy if seg not available   -ss 11/13/91 */
   {
      MEMCPY( pfgseg + b->p.in.ogif, fh_buf, b->p.in.gifct );
      fh_buf += fh->gifct;
   }

#if SEGACCESS
   /*  Copyright string  */
   b->p.in.ocopy = offset + sizeof(DISPLAY);
   b->p.in.scopy = copyright_len;

   fh_buf       += sizeof( SW16 );    /* skip over length we alredy have */
   MEMCPY( pfgseg + b->p.in.ocopy, fh_buf, copyright_len);
#endif  /*  SEGACCESS  */

   /*  Attribute segment.  Only spaceBand is actually used by ufst,
    *  but fill in these for reference.
    */
   a = (PFACE_ATT)(pfgseg + b->p.in.oattribute);
   a->baselinePosition       = fh->baselinePosition;
   a->uscoreDepth            = fh->underlinePosition;
   a->uscoreThickness        = fh->underlineHeight;
   a->capHeight              = fh->capHeight;
   a->xHeight                = fh->xHeight;
   a->spaceBand              = fh->pitch;
   a->scaleFactor            = fh->scaleFactor;  /*  should be 8782 */
   a->fixedSpaceRelWidths[1] = fh->textWidth;

   /*  raster parameter  */
   p = (LPUB8)(pfgseg + b->p.in.orast);  /* !!! */
   *(LPUW16)(p)   = fh->orThreshold;
   *(LPUW16)(p+2) = fh->globItalAng;

  /*  Display segment. The baselinePosition got into the pcleo from
   *  the attribute segment. I restore it here because comp_pix()
   *  uses it from the display segment
   */

   d = (PDISPLAY)(pfgseg + b->p.in.odisplay);
   d->masterPointSize       = fh->height;
   d->scanResolutionY       = fh->yRes;       /*  ?== 2540              */
   d->scanResolutionX       = fh->xRes;       /*  ?== 2540              */
   d->baselinePosition      = fh->baselinePosition;

   return SUCCESS;
}  /*  end - PCLmakeGlobalSeg  */




/*----------------------*/
/*     PCLEOmake_cd     */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLEOmake_cd(UW16 chId, PCHR_DEF chr_def, int buck_search_lvl)
#else
GLOBAL UW16
PCLEOmake_cd(chId, chr_def, buck_search_lvl)
    UW16    chId;
    PCHR_DEF chr_def;
    int      buck_search_lvl;
#endif
{
    SW16         k;
    PCHR_DEF     cd;
    PPCL_CHR_HDR      chr_hdr;
    PPCL_CC_DESC      cc;
    PPCL_CC_COMPONENT cc_comp;

#if !MULTICALLER        /* mby, 10/27/93 */
    if((chr_hdr = (PPCL_CHR_HDR)PCLchId2ptr(chId)) == (PPCL_CHR_HDR)NULL)
#else   /* Multicaller is enabled */
    if((chr_hdr = (PPCL_CHR_HDR)PCLchId2ptr(uLastCallerId, chId)) == (PPCL_CHR_HDR)NULL)
#endif  /* MULTICALLER */
        return ERR_find_cgnum;

#if SLIM_FONTS
    /* just to be sure its clear. No slim/mirrored PCLEOs! -ss 11/9/91 */
    chr_def_hdr.mirror_flags = (UB8)0;
#endif

  /*  Do COMPOUND CHARS  */
    if (chr_hdr->class == PCL_COMPOUND_CHR)
    {
        cc = (PPCL_CC_DESC)chr_hdr;  /* recast to ref full cc hdr */

        chr_def_hdr.is_compound = TRUE;
        chr_def_hdr.escape.x    = cc->cc_esc;
        chr_def_hdr.escape.y    = 0;
        chr_def_hdr.num_parts   = (SW16)cc->nparts;

        cd      = chr_def;
        cc_comp = (PPCL_CC_COMPONENT)&(cc->cc_list);
        for( k = 0; k < chr_def_hdr.num_parts; k++ )
        {
            cd->cgnum     = cc_comp->chId;
            cd->offset.x  = cc_comp->xoffset;
            cd->offset.y  = cc_comp->yoffset;
            cd->index     = 0;
            cd->buck_search_lvl = buck_search_lvl;
#if !MULTICALLER        /* mby, 10/27/93 */
            if( (cd->pgif = PCLchId2ptr( cc_comp->chId )) == (LPUB8)NULL )
#else   /* Multicaller is enabled */
            if( (cd->pgif = PCLchId2ptr( uLastCallerId, cc_comp->chId )) == (LPUB8)NULL )
#endif  /* MULTICALLER */
                return ERR_no_cc_part;

          /* bump past hdr to IF data  */
            cd->pgif     += sizeof( PCL_CHR_HDR );
            cd++;
            cc_comp++;
        }
               
        return SUCCESS;
    }    /*  end - compound chars  */

    DBG("    found as primary\n");
    chr_def_hdr.is_compound = FALSE;
    chr_def_hdr.num_parts   = 1;
    chr_def->pgif           = (LPUB8)chr_hdr + sizeof(PCL_CHR_HDR);
    chr_def->cgnum          = chId;
    chr_def->offset.x       = 0;     /***  check these  ***/
    chr_def->offset.y       = 0;
    chr_def->index          = 0;
    chr_def->buck_search_lvl = buck_search_lvl;
    return SUCCESS;

}  /* end - PCLEOmake_cd */
#endif  /* IF_RDR */

#if !defined (MSDOS ) && !defined (__OS2__)

#define GET_TOK( i, type ) \
    memcpy( (LPSB8)(&font_hdr->i), (LPSB8)buf, sizeof(type) ); \
    buf += sizeof( type );


/*-------------*/
/*   getHPFH   */
/*-------------*/
/* this routine assumes the data in buf is "packed" as described in */
/* the LJIII manual. Also assume that mem is allocated for font_hdr.*/
#if defined (ANSI_DEFS)
GLOBAL VOID  getHPFH( PHPFH font_hdr, LPUB8 buf)
#else
GLOBAL VOID
getHPFH( font_hdr, buf )
   PHPFH       font_hdr;
   LPUB8      buf;
#endif
{
    memset( (LPSB8)font_hdr, 0, sizeof( HPFH ) );

    GET_TOK( fontDescriptorSize,    UW16 );
    GET_TOK( descriptorFormat,      UB8 );
    GET_TOK( symbolSetOrganization, UB8 );
    GET_TOK( style_msb,             UB8 );
    GET_TOK( Reserved1,             UB8 );
    GET_TOK( baselinePosition,      UW16 );
    GET_TOK( cellWidth,             UW16 );
    GET_TOK( cellHeight,            UW16 );
    GET_TOK( orientation,           UB8 );
    GET_TOK( spacing,               UB8 );
    GET_TOK( symSetCode,            UW16 );
    GET_TOK( pitch,                 UW16 );
    GET_TOK( height,                UW16 );
    GET_TOK( xHeight,               UW16 );
    GET_TOK( appearanceWidth,       SB8  );
    GET_TOK( style_lsb,             UB8 );
    GET_TOK( strokeWeight,          SB8  );
    GET_TOK( lsb_typeface,          UB8 ); /* 02-20-91 jfd */
    GET_TOK( msb_typeface,          UB8 ); /* 02-20-91 jfd */
    GET_TOK( serifStyle,            UB8 );
    GET_TOK( quality,               UB8 );
    GET_TOK( placement,             UB8 );
    GET_TOK( was_underlinePosition, SB8  );
    GET_TOK( was_underlineHeight,   UB8 );
    GET_TOK( textHeight,            UW16 );
    GET_TOK( textWidth,             UW16 );
    GET_TOK( firstCode,             UW16 );
    GET_TOK( lastCode,              UW16 );
    GET_TOK( pitch_ext,             UB8 );
    GET_TOK( height_ext,            UB8 );
    GET_TOK( capHeight,             UW16 );
    GET_TOK( fontNumber,            UL32 );
    memcpy( (LPSB8)(font_hdr->fontName), (LPSB8)buf, 16 ); buf += 16;
    GET_TOK( scaleFactor,           UW16 );
    GET_TOK( xRes,                  UW16 );
    GET_TOK( yRes,                  UW16 );
    GET_TOK( underlinePosition,     SW16  );
    GET_TOK( underlineHeight,       UW16 );
    GET_TOK( orThreshold,           UW16 );
    GET_TOK( globItalAng,           UW16 );
    GET_TOK( gifct,                 UW16 );

}  /*  end - getHPFH  */

#endif  /* !MSDOS && !OS2 */


EXTERN SYMBOLSET symbolset;

#if !NO_SYMSET_MAPPING
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLeo2IF_ssnum( PFONTCONTEXT fc, UW16 pcleo_ssnum, LPUW16 fc_ssn )
#else
GLOBAL UW16
PCLeo2IF_ssnum( fc, pcleo_ssnum, fc_ssn )
   PFONTCONTEXT  fc;
   UW16   pcleo_ssnum;
   LPUW16 fc_ssn;       /* mby, 07-01-94 */
#endif
{
    int            dir_size;
    int            ii;
    int            num_symsets;
    LPUB8          ss;
   
#if (!TT_RDR)
#if ROM
    ss = symbolset.pss_directory[SYMBOLSET_IF];
#else
    ss = (LPUB8) MEMptr(symbolset.hss_directory[SYMBOLSET_IF]);
#endif  /* !ROM */
#endif  /* no TrueType */

#if !(IF_RDR || PST1_RDR)
#if ROM
    ss = symbolset.pss_directory[SYMBOLSET_TT];
#else
    ss = (LPUB8) MEMptr(symbolset.hss_directory[SYMBOLSET_TT]);
#endif  /* !ROM */
#endif  /* TrueType only */

#if ((IF_RDR || PST1_RDR) && TT_RDR)
#if ROM
    if ( FC_ISIF(fc) || FC_ISPST1(fc) )
        ss = symbolset.pss_directory[SYMBOLSET_IF];
    else if (FC_ISTT(fc))
        ss = symbolset.pss_directory[SYMBOLSET_TT];
#else
    if ( FC_ISIF(fc) || FC_ISPST1(fc) )
        ss = (LPUB8) MEMptr(symbolset.hss_directory[SYMBOLSET_IF]);
    else if (FC_ISTT(fc))
        ss = (LPUB8) MEMptr(symbolset.hss_directory[SYMBOLSET_TT]);
#endif  /* !ROM */
#endif  /* Intellifont OR PostScript AND TrueType */

    dir_size = GET_xWORD_OFF(ss, SSD_DIRSIZE);
    num_symsets = GET_xWORD_OFF(ss, SSD_NSS);
    ss += SSD_DOFF;
    for(ii=0; ii<num_symsets;  ii++, ss += dir_size)
    {
        if(pcleo_ssnum == GET_xWORD_OFF(ss, SSD_SYMCODE) )  /* ->symSetCode */
            break;
    }
    if(ii == num_symsets)
    {
        DBG("    symbol set not found\n");
        /* Could have a pcleo with a symbol set we don't know about.  */
        /* This is not a failure.                                     */
        *fc_ssn = 0;     /* make sure there is a value, not garbage */
        symbolset.curssnum = 0; /* reset in case its referenced later */
    }
    else
        *fc_ssn = GET_xWORD_OFF(ss, SSD_CODE);    /* ->ss_code */

    return( SUCCESS );

}  /* end - PCLeo2IF_ssnum */
#endif  /* !NO_SYMSET_MAPPING */
#endif  /*  PCLEO_RDR -- whole module is conditionally compiled */
