/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/da/symmap.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: symmap.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.33   18 Apr 1995 16:51:44   JOE
 * 
 * Changes to support the removal of symbol set mapping.
 * 
 *    Rev 1.32   06 Apr 1995 15:14:50   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.31   19 Jan 1995 16:20:16   MARTIN
 * Added SYMmapTT.
 * 
 *    Rev 1.30   16 Jan 1995 14:13:42   JOE
 * 
 * Added support for MicroType symbol sets.
 * 
 *    Rev 1.29   16 Dec 1994 14:23:24   MARTIN
 * Added FCO_TT conditional around SYMmapReverse.
 * 
 *    Rev 1.28   15 Dec 1994 20:02:32   MARTIN
 * 
 * Added SYMmapReverse.
 * 
 *    Rev 1.27   02 Dec 1994 21:25:38   MIKE
 * 
 * KSC (YAN).
 * 
 *    Rev 1.26   08 Sep 1994 19:06:54   MIKE
 * 
 * Use symbol_setTT and SYMBOLSET_TT for either FCO or TT.
 * 
 *    Rev 1.25   03 Aug 1994 19:46:26   MIKE
 * Added FCO changes from 1.18.1.1
 * 
 *    Rev 1.24   13 Jun 1994 12:55:36   MIKE
 * Made some code in SYMnoMap() conditional on PCLEO_RDR.
 * 
 *    Rev 1.23   08 Jun 1994 12:05:40   MIKE
 * 
 * Added SYMnoMap() to take care of downloaded symbol sets.
 * 
 *    Rev 1.22   22 Apr 1994 15:50:38   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.21   22 Apr 1994 13:55:06   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.20   09 Feb 1994 12:02:42   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.19   02 Feb 1994 10:14:10   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.18   05 Jan 1994 18:12:30   ROB
 * Add support for "GB" encoding.
 * 
 *    Rev 1.17   08 Dec 1993 18:59:12   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.16   01 Dec 1993 08:40:52   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.15   30 Nov 1993 14:48:36   ROB
 * Add BIG5 support and TCA hooks.
 * 
 *    Rev 1.14   11 Nov 1993 16:30:04   JOE
 * 
 * In SYMnew(), added UNICODE changes for KANJI support.
 * 
 *    Rev 1.13   17 Aug 1993 14:50:06   JOE
 * In !ROM version of SYMinit(), corrected syntax error - changed line
 * "#ifdef DEBUG && !ROM" to #ifdef DEBUG".
 * 
 *    Rev 1.12   13 Aug 1993 14:53:54   MIKE
 * In SYMinit(), fix DEBUG compilation error.
 * 
 *    Rev 1.11   27 Jul 1993 11:41:50   JOE
 * Removed external declaration for "fontcontext".
 * In SYMnew(), replaced call to macro FC_ISEXTERN with in-line code
 * so as not to require "fontcontext" to be declared in this module.
 * 
 *    Rev 1.10   01 Jul 1993 15:15:12   JOE
 * 
 * EUC KANJI support.
 * 
 *    Rev 1.9   15 Jun 1993 10:39:46   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.8   14 Jun 1993 17:18:34   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.7   29 Mar 1993 10:55:46   ROB
 * Kanji cleanup.
 * 
 *    Rev 1.6   11 Mar 1993 15:07:28   MAIB
 * Initial changes to support Asian character encoding (TrueType 1st pass)
 * 
 *    Rev 1.5   15 Feb 1993 09:10:24   JOE
 * Changed all occurrences of READ to READF due to conflict with VXWorks.
 * 
 *    Rev 1.4   12 Feb 1993 13:31:32   JOE
 * VXWorks support.
 * 
 *    Rev 1.3   06 Jan 1993 15:46:34   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.2   14 Dec 1992 15:56:26   LISA
 * No change.
 * 
 *    Rev 1.1   14 Dec 1992 08:51:06   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:38:18   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* symmap.c */
/*
 *
 *
 * History
 *
 *   4-Feb-91  awr  Split off from ix.c.
 *                  Renamed init_symbol_set() to SYMinit() for new module.
 *                  Changed symbol set mapping to use SYMmap()
 *   5-Feb-91  jfd  In ROM version of SYMinit(), always return SUCCESS
 *                  or else return value is ambiguous.
 *  20 May 91  ss   Updated references to FMalloc_rd() & FMseek_rd() to
 *                  deleted last 2 parameters no longer needed.  Cleaned up
 *                  defines for these no longer used.
 *  17-Jun-91  jfd  Moved "debug.h" after "port.h".
 *                  Moved "cgconfig.h" before "port.h".
 *  24 Jun 91  ss   Conditionally compile io.h based on system type.
 *  27-Jun-91  rs   Add 'SYMmapR()' for reverse lookup of cgnum to chId.
 *  22-Aug-91  jfd  Conditionally compile SYMmapR based on PST1.
 *  25 Oct 91  ss   Added use of SS_COUNT_SIZE and SS_COUNT_TYPE to help 
 *                  with SPARC port.
 *  22 Nov 91  ss   Changed call to FMalloc_rd() in SYMinit() to use define
 *                  SS_COUNT_SIZE set in sym.h based on -DSPARC.
 *  03-Apr-92  rs   Portability cleanup (see port.h).
 *  08-Jul-92  rs   Code cleanup.
 *  10-Aug-92  rs   Change args in FMseek_read() from SW16 to int,
 *                  SL32 to long for 32 bit systems (Watcom C386).
 *  29-Sep-92  mby  Use GET_xWORD() and GET_xLONG() macros to extract 2- and
 *                  4-byte data from file (byte order is *always* HI-LO).
 *                  In SYMnew(), dumping file data into a structure pointer
 *                  is unsafe practice. Use GET_... macros to read data.
 *  30-Sep-92  mby  Call new function SYMinit_ReadDir(), from SYMinit().
 *                  SYMinit_ReadDir(fst_type) loads symbol set file
 *                  differently depending if fst_type is TrueType or not.
 *                  In SYMmap() symbolset.pss_entry is now a UW16 array. Ditto for SYMmapR().
 *                  SYMexit() frees symbolset.hufss_directory.
 *                  SYMnew() takes fst type as 2nd argument.
 *  08-Oct-92  mby  symbol_setIF[256] and symbol_setTT[256] so SYMnew() can
 *                  load both kinds of symbol sets. SYMBOLSET structure
 *                  (sym.h) was modified ==> changes to SYMmap(), SYMinit(),
 *                  SYMexit(), SYMnew(), SYMmapR().
 *  09-Oct-92  mby  SYMnew() returns error if can't load SS for req'd FST.
 *  20-Oct-92  jfd  In SYMinit(), corrected syntax error in "for" statement
 *                  ("," instead of ";"). Disabled code which references
 *                  "symbolset.hufss_directory". (No such structure member). 
 *  21-Oct-92  mby  Fixed bug in SYMnew() - returned bogus error.
 *                  #include "cgmacros.h" for GET_x...() macros.
 *  26-Oct-92  jfd  In SYMnew(), if processing a pcleo, do not swap bytes
 *                  when retrieving new symbol set number "new_ss_num".
 *                  Declared "fontcontext" as EXTERNAL.
 *  29-Oct-92  jfd  Moved declaration of "fontcontext" to outside "#if !ROM"
 *                  block.
 *                  Moved function prototype for SYMinit_ReadDir() to within
 *                  "#if !ROM" block to remove compiler warning.
 *  02-Nov-92  jfd  In SYMnew(), conditionally compiled code which checks 
 *                  the type of symbol set (IF or TT).
 *  15-Nov-92  rs   Port to Mac -> move "cgconfig.h" & "port.h" to start of
 *                  includes, include <unix.h>.
 *  23-Nov-92  mby  Clean up TT-only, IF-only code in SYMnew()
 *  06-Jan-93  jfd  ANSI C function declaration changes.
 *  08-Feb-93  jfd  VXWorks support.
 *  15-Feb-93  jfd  Changed READ to READF due to conflict with VXWorks.
 *  11-Mar-93  maib added code to begin to support JIS and SHIFT_JIS
 *                  character encoding
 *  27-Mar-93  rs   Add defines for KANJI_ENCODING, JIS_ENCODING &
 *                  SJIS_ENCODING per cgconfig.h.
 *  04-Jun-93  jfd  Add defines for USE_UFST_MAPPING per cgconfig.h.
 *  15-Jun-93  jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
 *  30-Jun93 jfd/gy EUC KANJI support.
 *  27-Jul-93  jfd  Removed external declaration for "fontcontext".
 *                  In SYMnew(), replaced call to macro FC_ISEXTERN with
 *                  in-line code so as not to require "fontcontext" in
 *                  this module.
 *  12-Aug-93  mby  In SYMinit() fix DEBUG code - make symbolset.hss_directory
 *                  an array (see Oct '92 changes).
 *  17-Aug-93  jfd  In !ROM version of SYMinit(), corrected syntax error
 *                  - changed line "ifdef DEBUG && !ROM" to "#ifdef DEBUG".
 *  11-Nov-93  gy   In SYMnew(), added UNICODE changes for KANJI support.
 *  23-Nov-93  rs   Add BIG5 & TCA to KANJI_ENCODING support.
 *  01-Dec-93 jfd   Changed KANJI_ENCODING to ASIAN_ENCODING.

 *  08-Dec-93 rs    General cleanup - MSDOS & CGFLAT32.
 *  05-Jan-94 rs    Add support for "GB" encoding.
 *  27-Jan-94 jfd   Conditionally compiled #include for fcntl.h based
 *                  on (!defined(_AM29K) || (defined(_AM29K) && 
 *                  !defined(UNIX))).
 *  09-Feb-94 jfd   Including "hif.h" if _AM29K.
 *  22-Apr-94 jfd   Changed conditional compile statement prior to
 *                  including <hif.h> to #if (_AM29K && !UNIX) to
 *                  resolve UNIX Metaware compiler error.
 *  06-Jun-94 mby  Added SYMnoMap() to take care of downloaded symbol sets.
 *  13-Jun-94 mby  Made block of code in SYMnoMap() conditional on PCLEO_RDR.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.18.1.1:
 *  15-Mar-94 mby  Added SYMmap() support for FCO_RDR for Unicode mapping.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  08-Sep-94 mby  symbol_setTT/SYMBOLSET_TT must be used for FCO font types
 *                 as well as TrueType.
 *  15-Dec-94 SBM  Added  SYMmapReverse.
 *  16-Dec-94 SBM  Added FCO_TT conditional around SYMmapReverse. Only the
 *                 TrueType generator uses this code for now.
 *  05-Jan-95 jfd  Added support for MicroType symbol sets.
 *  19-Jan-95 SBM  Added SYMmapTT.
 *  18-Apr-95 jfd  In SYMnoMap(), added support for the removal of symbol
 *                 set mapping.
 *                 Changed GET_WORD macro to version used in CGIF.C .
 *                 Conditifonally compiled SYMinit(), SYMexit(), SYMnew(),
 *                 SYMmap() and SYMmapR() based on NO_SYMSET_MAPPING.
 */


#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>

#if defined (MACINTOSH)
#include <unix.h> /* open() */
#endif

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>
#endif

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined (MSDOS) || defined (__OS2__)
#include <io.h>
#endif

#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "sym.h"
#include "segments.h"
#include "cgif.h"
#include "ix.h"
#include "if_type.h"   /* 1-6-95 jfd */
#include "cgmacros.h"

#if PCLEO_RDR
#include "pcleo.h"
#endif

#if ASIAN_ENCODING     /* 3/11/93 maib */
#include "kanji.h"
#endif

#if TT_ROM1
#include "ttroment.h"
#endif 

#define MAXNAME  80    /* max size name includes drive, path and file */


#ifdef LINT_ARGS
EXTERN VOID        BUFfree(MEM_HANDLE);
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
EXTERN BOOLEAN     FMseek_read(int, long, UW16, LPSB8);
EXTERN MEM_HANDLE  FMalloc_rd(int, UW16, long);
#else /* 32 bit platform */
EXTERN BOOLEAN     FMseek_read(int, long, int, LPSB8);
EXTERN MEM_HANDLE  FMalloc_rd(int, int, long);
#endif
EXTERN VOID        buildpath(LPSB8, LPSB8, LPSB8);

#else
EXTERN VOID        BUFfree();
EXTERN BOOLEAN     FMseek_read();
EXTERN MEM_HANDLE  FMalloc_rd();
EXTERN VOID        buildpath();
#endif

EXTERN SB8  ufstPath[];

EXTERN IF_STATE if_state;  /* 1-6-95 jfd */

GLOBAL SYMBOLSET symbolset;

/* Symbol sets */


#if !ROM && !NO_SYMSET_MAPPING

#if (IF_RDR  ||  PST1_RDR)
GLOBAL UW16        symbol_setIF[256];     /* current IF symbol set */
MLOCAL LPSB8       pathIF = "uif.ss";
#endif
#if (TT_RDR || FCO_RDR)
GLOBAL UW16        symbol_setTT[256];     /* current TT symbol set */
MLOCAL LPSB8       pathTT = "utt.ss";
#endif
#if FCO_RDR
GLOBAL UW16        symbol_setMT[256];     /* current MT symbol set */
MLOCAL LPSB8       pathMT = "umt.ss";
#endif

MLOCAL LPSB8       shortPath[NSS_FILES];
MLOCAL LPUW16      symbol_set[NSS_FILES];

#ifdef LINT_ARGS
MLOCAL UW16        SYMinit_ReadDir(int);
#else
MLOCAL UW16        SYMinit_ReadDir();
#endif

#endif  /* !ROM && !NO_SYMSET_MAPPING */

#if !NO_SYMSET_MAPPING

#if ((IF_RDR || PST1_RDR)  &&  (TT_RDR || FCO_RDR))

/*------------------*/
/*     SYMmap       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  SYMmap (SW16 chId, int fst_type)
#else
GLOBAL UW16
SYMmap (chId, fst_type)
    SW16 chId;
    int  fst_type;
#endif
{
/* Remember that data in pss_entry arrays is in Hi-Lo byte order!! */
    register LPUB8  ptr;
    if (fst_type != FC_TT_TYPE
#if FCO_RDR
           && fst_type != FC_FCO_TYPE
#endif
       )
        {
        if((chId < symbolset.ss_first_code[SYMBOLSET_IF]) ||
              (symbolset.ss_last_code[SYMBOLSET_IF] < chId))
            return 0;
        ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_IF] +
                       (chId - symbolset.ss_first_code[SYMBOLSET_IF]) );
        return (GET_xWORD(ptr));
        }
    else
        {
#if FCO_RDR

           /* If IF font in MIcroType, 
            * use MicroType symbolset for mapping.
            */

           if (fst_type == FC_FCO_TYPE && 
               if_state.pbucket->p.fco.design_EmRes == 8782) /* map to MT ss */
           {
              if((chId < symbolset.ss_first_code[SYMBOLSET_MT]) ||
                     (symbolset.ss_last_code[SYMBOLSET_MT] < chId))
                  return 0;
              ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_MT] +
                       (chId - symbolset.ss_first_code[SYMBOLSET_MT]) );
              return (GET_xWORD(ptr));
           }
           else
#endif
           {
              if((chId < symbolset.ss_first_code[SYMBOLSET_TT]) ||
                     (symbolset.ss_last_code[SYMBOLSET_TT] < chId))
                  return 0;
              ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                       (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
              return (GET_xWORD(ptr));
           }
        }

}


#else   /* either (IF_RDR || PST1_RDR) or (TT_RDR || FCO_RDR) but not both. */

/*------------------*/
/*     SYMmap       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  SYMmap (SW16 chId, int fst_type)
#else
GLOBAL UW16
SYMmap (chId, fst_type)
    SW16 chId;
    int  fst_type;
#endif
{
    register LPUB8  ptr;
#if (IF_RDR  ||  PST1_RDR)
    if((chId < symbolset.ss_first_code[SYMBOLSET_IF]) ||
          (symbolset.ss_last_code[SYMBOLSET_IF] < chId))
        return 0;
    ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_IF] +
                   (chId - symbolset.ss_first_code[SYMBOLSET_IF]) );
    return (GET_xWORD(ptr));
#endif
#if FCO_RDR

           /* If IF font in MIcroType, 
            * use MicroType symbolset for mapping.
            */

    if (fst_type == FC_FCO_TYPE && 
        if_state.pbucket->p.fco.design_EmRes == 8782) /* map to MT ss */
    {
       if((chId < symbolset.ss_first_code[SYMBOLSET_MT]) ||
                 (symbolset.ss_last_code[SYMBOLSET_MT] < chId))
           return 0;
       ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_MT] +
                      (chId - symbolset.ss_first_code[SYMBOLSET_MT]) );
       return (GET_xWORD(ptr));
    }
    else
#endif
#if (TT_RDR || FCO_RDR)
    {
    if((chId < symbolset.ss_first_code[SYMBOLSET_TT]) ||
              (symbolset.ss_last_code[SYMBOLSET_TT] < chId))
        return 0;
    ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                   (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
    return (GET_xWORD(ptr));
    }
#endif
}

#endif

#endif /* !NO_SYMSET_MAPPING */


#if !NO_SYMSET_MAPPING

/*------------------*/
/*     SYMinit      */
/*------------------*/
#if ROM

#if defined (ANSI_DEFS)
GLOBAL UW16  SYMinit ()
#else
GLOBAL UW16
SYMinit ()
#endif
{
    symbolset.curssnum = 0;     /* no symbol set is loaded  */
    return SUCCESS;
}

#else     /*  Disk based version */

#if defined (ANSI_DEFS)
GLOBAL UW16  SYMinit ()
#else
GLOBAL UW16
SYMinit ()
#endif
{
    SW16         ii;
    UW16 status;
#ifdef DEBUG
    LPUB8        ss;
    int          dir_size, num_symsets;
#endif

    DBG("init_symbol_set()\n");

    symbolset.curssnum = 0;               /* no symbol set is loaded  */
    for (ii=0; ii<NSS_FILES; ii++)
        symbolset.hss_directory[ii] = 0;

#if (IF_RDR | PST1_RDR)
    shortPath[SYMBOLSET_IF] = pathIF;
    status = SYMinit_ReadDir(FC_IF_TYPE);
    symbol_set[SYMBOLSET_IF] = symbol_setIF;
    if (status)  return status;
#endif

#if (TT_RDR || FCO_RDR)
    shortPath[SYMBOLSET_TT] = pathTT;
    status = SYMinit_ReadDir(FC_TT_TYPE);
    symbol_set[SYMBOLSET_TT] = symbol_setTT;
    if (status)  return status;
#endif

#if FCO_RDR
    shortPath[SYMBOLSET_MT] = pathMT;
    status = SYMinit_ReadDir(FC_FCO_TYPE);
    symbol_set[SYMBOLSET_MT] = symbol_setMT;
    if (status)  return status;
#endif



#ifdef DEBUG
    if(trace_sw)
        {
        int jj;
        for (jj=0; jj<NSS_FILES; jj++)
          {
            if (symbolset.hss_directory[jj])
            {
                ss = (LPUB8)MEMptr(symbolset.hss_directory[jj]);
                num_symsets = GET_xWORD_OFF(ss, SSD_NSS);
                dir_size = GET_xWORD_OFF(ss, SSD_DIRSIZE);
                ss += SSD_DOFF;
                for(ii=0; ii<num_symsets; ii++, ss += dir_size)
                    printf("    %c%c:  first= %u   num= %u   offset= %lu\n",
                            ss[SSD_CODE], ss[SSD_CODE+1],
                            GET_xWORD_OFF(ss, SSD_FIRSTC),
                            GET_xWORD_OFF(ss, SSD_NUMC),
                            GET_xLONG_OFF(ss, SSD_OFF) );
            }
          }
        }
#endif  /* DEBUG */

    return status;
}


#if defined (ANSI_DEFS)
MLOCAL UW16  SYMinit_ReadDir (int fst_type)
#else
MLOCAL UW16
SYMinit_ReadDir (fst_type)
  int  fst_type;    /* FC_IF_TYPE, FC_PST1_TYPE, FC_TT_TYPE, or FC_FCO_TYPE */
#endif
{
    UB8          buffer[SSD_DOFF];
    int          dir_size;
    int          fd;        /* symbol set file */
    MEM_HANDLE  *hndl;
    int          num_symsets;
#if defined (MSDOS) && !defined (CGFLAT32) /* 16 bit platform */
    UW16         ssdir_size;
#else /* 32 bit platform */
    int          ssdir_size;
#endif
    SB8          pathname[MAXNAME];

#if (IF_RDR || PST1_RDR)
    if (fst_type == FC_IF_TYPE)
        {           /* build full pathname; get pointer to IF symbol sets */
        buildpath (pathname, ufstPath, shortPath[SYMBOLSET_IF]);
        hndl = &symbolset.hss_directory[SYMBOLSET_IF];
        }
#endif

#if (TT_RDR || FCO_RDR)
    if (fst_type == FC_TT_TYPE)
        {           /* build full pathname; get pointer to TT symbol sets */
        buildpath (pathname, ufstPath, shortPath[SYMBOLSET_TT]);
        hndl = &symbolset.hss_directory[SYMBOLSET_TT];
        }
#endif

#if FCO_RDR
    if (fst_type == FC_FCO_TYPE)
        {           /* build full pathname; get pointer to MT symbol sets */
        buildpath (pathname, ufstPath, shortPath[SYMBOLSET_MT]);
        hndl = &symbolset.hss_directory[SYMBOLSET_MT];
        }
#endif


  /* Open symbol set file and read number of entries */
    if ((fd = OPEN(pathname, O_READFLAGS)) == -1)
    {
        DBG("Symbol set file uif.ss, utt.ss ur umt.ss not found\n");
        return ERR_no_symbol_set;
    }

    if(READF(fd, (LPSB8)buffer, SSD_DOFF) != SSD_DOFF)
    {
        DBG("    read error\n");
        CLOSE(fd);
        return ERR_rd_symbol_set;
    }

  /*  Get symbol set directory memory; read directory. There's one more
   *  because of the dummy entry at the end.
   */
    num_symsets = GET_xWORD_OFF(buffer, SSD_NSS);
    dir_size = GET_xWORD_OFF(buffer, SSD_DIRSIZE);
    ssdir_size = (num_symsets + 1) * dir_size + SSD_DOFF;
    *hndl = FMalloc_rd(fd, ssdir_size, 0L);
    CLOSE(fd);
    if(!(*hndl))
    {
        DBG("    loading symbol set directory failed\n");
        return ERR_rd_symbol_set;
    }

    return SUCCESS;
}

#endif  /*  !ROM  */

#endif /* !NO_SYMSET_MAPPING */


#if !NO_SYMSET_MAPPING

/*------------------*/
/*     SYMexit      */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  SYMexit()
#else
GLOBAL VOID
SYMexit()
#endif
{
#if !ROM
#if (IF_RDR | PST1_RDR)
    BUFfree(symbolset.hss_directory[SYMBOLSET_IF]);
#endif
#if (TT_RDR || FCO_RDR)
    BUFfree(symbolset.hss_directory[SYMBOLSET_TT]);
#endif
#if FCO_RDR
    BUFfree(symbolset.hss_directory[SYMBOLSET_MT]);
#endif
#endif
}



/*------------------*/
/*    SYMnew        */
/*------------------*/
/*  If font f's symbol set is different than the current symbol set,
 *  then read in the new symbol set and set f's first_code and
 *  last_code fields.
 *  Errors:
 *       Can't find symbol set referenced by f->ss_code
 *       Can't open symbol set file if.ss
 *       Can't seek to new symbol set in if.ss
 *       Can't read new symbol set from if.ss
 */

#if defined (ANSI_DEFS)
GLOBAL BOOLEAN SYMnew(UW16 new_ss_num, UW16 fstType)
#else
GLOBAL BOOLEAN
SYMnew(new_ss_num, fstType)
  UW16  new_ss_num;
  UW16  fstType;    /* FC_IF_TYPE, FC_PST1_TYPE, FC_TT_TYPE, or FC_FCO_TYPE */
#endif
{
    int           i, jj;
    register int  nsn;
    int           num_symsets;
    int           dir_size;
    LPUB8         pss;
#if !ROM
    SB8           pathname[MAXNAME];
    LPSB8         fname;
    UL32          ss_offset;      /* offset to new symbol set */
    int           ss_size;        /* size of new symbol set   */
    int           ssf;            /* symbol set file handle   */
    BOOLEAN       ok;
#endif

  /* Change symbol set if necessary */

    if (new_ss_num != symbolset.curssnum)
        {
        /* set to invalid symbolset in case we fail */
        symbolset.curssnum = 0;

        DBG1("New symbol set %u\n", new_ss_num);

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
        /*
         * don't bother trying to find the matching symbol set for
         * Type 1 encoding, characters determined differently 
         * than codes found in the symbol set...
         */
        if (new_ss_num == T1ENCODING)
          return TRUE;
#endif  /* (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2) */

#if ASIAN_ENCODING     /* 3/11/93 maib */
        /*
         * don't bother trying to find the matching symbol set for
         * JIS or Shift-JIS encoding, characters determined differently 
         * than codes found in the symbol set...
         */
        if ((new_ss_num == JIS) || (new_ss_num == SHIFT_JIS)  
             || (new_ss_num == EUC ) || (new_ss_num == UNICODE)
             || (new_ss_num == BIG5) || (new_ss_num == TCA)
             || (new_ss_num == GB)   || (new_ss_num == KSC)
           )
          return TRUE;
#endif /* ASIAN_ENCODING */

/**************************************************/
/* Search symbol set directory for new symbol set */
/* This loop loads both IF and TT symbol sets if both FSTs are enabled.
 * What we really want to do is
 *   1) if FST = IF, load only the IF symbol set.
 *   2) if FST = TT, and TT_PLUGINS == 2 or 0, load only the TT symbol set.
 *   3) if FST = TT, and TT_PLUGINS == 1, load both symbol sets.
 * By the way, whatever goes for IF goes for PST1 too.
 */
        for (jj=0; jj<NSS_FILES; jj++)
            {
            symbolset.ss_first_code[jj] = 0;
            symbolset.ss_last_code[jj]  = 0;
#if ROM
            pss = symbolset.pss_directory[jj];
#else   /*  !ROM  */
            pss = (LPUB8)MEMptr(symbolset.hss_directory[jj]);
            fname = shortPath[jj];
#endif /* ROM */
            num_symsets = GET_xWORD_OFF(pss, SSD_NSS);
            dir_size = GET_xWORD_OFF(pss, SSD_DIRSIZE);
            pss += SSD_DOFF;

/* new_ss_num is the representation of a two-byte string such as "DT"
 * or "VI". Therefore its value as a 16-bit word is PLATFORM-DEPENDENT.
 * "nsn" is platform-independent. */

            nsn = GET_xWORD(&new_ss_num);
#if PCLEO_RDR
            if (fstType & FC_EXTERN_TYPE)
               nsn = new_ss_num;  /* don't swap if pcleo */
#endif  /* PCLEO_RDR */

            for (i=0; i<num_symsets;  i++, pss += dir_size)
                {
                if (nsn == (GET_xWORD_OFF(pss, SSD_CODE)) )
                    break;
                }

            if (i == num_symsets)    /* if the function argument does not */
                {                    /* match any of the symbol set codes */
                DBG("    symbol set not found\n");
#if !((IF_RDR || PST1_RDR) && (TT_RDR || FCO_RDR))   /* IF-only or TT-only, but not both */
                return FALSE;        /* required symbol set not found */
#else
                if ( (fstType & FC_FONTTYPE_MASK) == FC_TT_TYPE  ||
                       (fstType & FC_FONTTYPE_MASK) == FC_FCO_TYPE )
                    {
                    if (jj == SYMBOLSET_TT)
                        return FALSE;   /* required symbol set not found */
                    }
                else
                    {
                    if (jj == SYMBOLSET_IF)
                        return FALSE;   /* required symbol set not found */
                    }
                continue;   /* ==> for (jj=0; jj<NSS_FILES; jj++) */
#endif
                }

#if ROM
            symbolset.pss_entry[jj] = (LPUW16)(symbolset.pss_directory[jj] +
                            GET_xLONG_OFF(pss, SSD_OFF));

#else /* !ROM */
            symbolset.pss_entry[jj] = (LPUW16)(symbol_set[jj]);   /* @@@ This can be optimized -- mby 10/08/92 */
            ss_offset = GET_xLONG_OFF(pss, SSD_OFF);
            ss_size = (int)(GET_xLONG_OFF(pss, (dir_size + SSD_OFF)) - ss_offset);
            DBG1("    symbol set size %u\n", ss_size);

          /* Build full pathname; read in new symbol set.  */
   			memset(pathname, '\0', sizeof(pathname));       
            buildpath (pathname, ufstPath, fname);
            if ((ssf = OPEN(pathname, O_READFLAGS)) == -1)
                {
                DBG("Symbol set file ss.s not found\n");
                return FALSE;
                }
            ok = FMseek_read(ssf, ss_offset, ss_size, (LPSB8)symbol_set[jj]);
            CLOSE(ssf);
            if (!ok)
                {
                DBG("    symbol set read failed\n");
                return FALSE;
                }

#endif  /*  ROM  */

            symbolset.curssnum = new_ss_num;   /*  Success- a new symbol set */
            symbolset.ss_first_code[jj] = GET_xWORD_OFF(pss, SSD_FIRSTC);
            symbolset.ss_last_code[jj]  = symbolset.ss_first_code[jj] +
                                          GET_xWORD_OFF(pss, SSD_NUMC) - 1;
            symbolset.ss_symSetCode[jj] = GET_xWORD_OFF(pss, SSD_SYMCODE);
            symbolset.ss_type[jj]       = GET_xWORD_OFF(pss, SSD_TYPE);
            symbolset.ss_class[jj]      = GET_xWORD_OFF(pss, SSD_CLASS);


#if TT_RDR
            if (jj == SYMBOLSET_TT)
                {
                symbolset.tt_platID     = GET_xWORD_OFF(pss, SSD_PLID);
                symbolset.tt_specID     = GET_xWORD_OFF(pss, SSD_SPID);
                }
#endif
            }       /* for (jj=0; jj<NSS_FILES; jj++)    */

        }       /* if(new_ss_num != symbolset.curssnum)  */
    return TRUE;
}

#endif /* !NO_SYMSET_MAPPING */

#if (PCLEO_RDR || TT_ROM1 || NO_SYMSET_MAPPING)
/*------------------*/
/*    SYMnoMap      */  /* mby, 06-06-94 */
/*------------------*/
/*  If symbol set word in fontcontext is 0x8000, it means the PCLExO has a
 *  downloaded symbol set. CGIFfont calls this function instead of SYMnew.
 *  Fills in symbolset.curssnum, symbolset.ss_{first|last}_code[]
 */
#if 0
#define GET_WORD( destp, srcp )   \
               *destp = *srcp;   *(destp+1) = *(srcp+1);
#endif
#define GET_WORD( destp, srcp )   memcpy( (SB8 *)(destp), (SB8 *)(srcp), 2 );

#if defined (ANSI_DEFS)
GLOBAL BOOLEAN SYMnoMap( LPUB8 font_hdr, UW16 fstType )
#else
GLOBAL BOOLEAN SYMnoMap( font_hdr, fstType )
    LPUB8 font_hdr;
    UW16  fstType;
#endif
{
    int     q;

#if ((IF_RDR || PST1_RDR) &&  TT_RDR)
    if ( (fstType & FC_FONTTYPE_MASK) == FC_TT_TYPE )
        q = SYMBOLSET_TT;
    else
        q = SYMBOLSET_IF;
#endif
#if !TT_RDR
    q = SYMBOLSET_IF;
#endif
#if (TT_RDR  &&  !(IF_RDR || PST1_RDR) )
    q = SYMBOLSET_TT;
#endif

    symbolset.curssnum = 0;
#if PCLEO_RDR     /* 06-13-94 */
    if (fstType & FC_EXTERN_TYPE)
    {
        if ( (fstType & FC_FONTTYPE_MASK) == FC_IF_TYPE )
        {
            GET_WORD(&symbolset.ss_first_code[q], font_hdr + FIRST_CODE);
            GET_WORD(&symbolset.ss_last_code[q], font_hdr + LAST_CODE);
        }
        else
        {
            symbolset.ss_first_code[q] = GET_xWORD_OFF(font_hdr, FIRST_CODE);
            symbolset.ss_last_code[q] = GET_xWORD_OFF(font_hdr,LAST_CODE);
        }
        return TRUE;
    }
#endif  /* PCLEO_RDR */
#if TT_ROM1
      if (tr1_FirstLast(font_hdr, &symbolset.ss_first_code[q],
                                  &symbolset.ss_last_code[q]))
    {
    }
    return TRUE;
#endif
/*        return FALSE; */

    return TRUE;
}
#endif  /* (PCLEO_RDR || TT_ROM1 || NO_SYMSET_MAPPING) */


#if !NO_SYMSET_MAPPING

#if PST1  &&  IF_RDR        /* Won't work without IF_RDR enabled?? -- mby 10/08/92 */
/*------------------*/
/*    SYMmapR       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL SW16  SYMmapR(UW16 cgnum)
#else
GLOBAL SW16
SYMmapR(cgnum)
    UW16 cgnum;
#endif
/*
return chId for cgnum if in current symbol set, else return MAX_UWORD
*/
{
SW16  k;
register LPUB8  ptr;

/* Remember that data in pss_entry arrays is in Hi-Lo byte order!! */

for (k = symbolset.ss_first_code[SYMBOLSET_IF]; k <= symbolset.ss_last_code[SYMBOLSET_IF]; k++)
    {
    ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_IF] + (k - symbolset.ss_first_code[SYMBOLSET_IF]));
    if (GET_xWORD(ptr))
        return (k);
    }
return MAX_UWORD;
}
#endif /* PST1 */

#endif /* !NO_SYMSET_MAPPING */

#if FCO_TT    /* the code below is only for the TrueType generator */
#if ((IF_RDR || PST1_RDR)  &&  (TT_RDR || FCO_RDR))

/*-----------------------*/
/*     SYMmapReverse     */
/*-----------------------*/
#if defined (ANSI_DEFS)
GLOBAL SW16  SYMmapReverse (UW16 number, int fst_type)
#else
GLOBAL SW16
SYMmapReverse (number, fst_type)
    UW16 number;
    int  fst_type;
#endif
{
/* Remember that data in pss_entry arrays is in Hi-Lo byte order!! */
    SW16 chId;
    register LPUB8  ptr;
    if (fst_type != FC_TT_TYPE
#if FCO_RDR
           && fst_type != FC_FCO_TYPE
#endif
       )
    {
        for (chId =symbolset.ss_first_code[SYMBOLSET_IF];
             chId<=symbolset.ss_last_code[SYMBOLSET_IF]; chId++){
             ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_IF] +
                    (chId - symbolset.ss_first_code[SYMBOLSET_IF]) );
             if (number == GET_xWORD(ptr))
                return(chId);  /* number was found, return */
        }
        return(0); /* number was not found */
    }
    else
    {
#if FCO_RDR

           /* If IF font in MIcroType, 
            * use MicroType symbolset for mapping.
            */

       if (fst_type == FC_FCO_TYPE && 
           if_state.pbucket->p.fco.design_EmRes == 8782) /* map to MT ss */
       {
          for (chId =symbolset.ss_first_code[SYMBOLSET_MT];
               chId<=symbolset.ss_last_code[SYMBOLSET_MT]; chId++){
               ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_MT] +
                      (chId - symbolset.ss_first_code[SYMBOLSET_MT]) );
               if (number == GET_xWORD(ptr))
                  return(chId);  /* number was found, return */
          }
          return(0); /* number was not found */
       }
       else
#endif
        {
           for (chId =symbolset.ss_first_code[SYMBOLSET_TT];
                chId<=symbolset.ss_last_code[SYMBOLSET_TT]; chId++){
                ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                       (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
                if (number == GET_xWORD(ptr))
                   return(chId);  /* number was found, return */
           }
           return(0); /* number was not found */
        }
    }
}


#else   /* either (IF_RDR || PST1_RDR) or (TT_RDR || FCO_RDR) but not both. */

/*-----------------------*/
/*     SYMmapReverse     */
/*-----------------------*/
#if defined (ANSI_DEFS)
GLOBAL SW16  SYMmapReverse (UW16 number, int fst_type)
#else
GLOBAL SW16
SYMmapReverse (number, fst_type)
    UW16 number;
    int  fst_type;
#endif
{
/* Remember that data in pss_entry arrays is in Hi-Lo byte order!! */
    SW16 chId;
    register LPUB8  ptr;
#if (IF_RDR  ||  PST1_RDR)
    for (chId =symbolset.ss_first_code[SYMBOLSET_IF];
         chId<=symbolset.ss_last_code[SYMBOLSET_IF]; chId++){
         ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_IF] +
                (chId - symbolset.ss_first_code[SYMBOLSET_IF]) );
         if (number == GET_xWORD(ptr))
             return(chId);  /* number was found, return */
    }
    return(0); /* number was not found */
#endif
#if FCO_RDR

    /* If IF font in MIcroType, 
     * use MicroType symbolset for mapping.
     */

    if (fst_type == FC_FCO_TYPE && 
        if_state.pbucket->p.fco.design_EmRes == 8782) /* map to MT ss */
    {
       for (chId =symbolset.ss_first_code[SYMBOLSET_MT];
            chId<=symbolset.ss_last_code[SYMBOLSET_MT]; chId++){
            ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_MT] +
                   (chId - symbolset.ss_first_code[SYMBOLSET_MT]) );
            if (number == GET_xWORD(ptr))
                return(chId);  /* number was found, return */
       }
       return(0); /* number was not found */
    }
#endif
#if (TT_RDR || FCO_RDR)
    for (chId =symbolset.ss_first_code[SYMBOLSET_TT];
         chId<=symbolset.ss_last_code[SYMBOLSET_TT]; chId++){
         ptr  = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
         if (number == GET_xWORD(ptr))
             return(chId);  /* number was found, return */
    }
    return(0); /* number was not found */
#endif
}

#endif
#if ((IF_RDR || PST1_RDR)  &&  (TT_RDR || FCO_RDR))

/*------------------*/
/*     SYMmapTT       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  SYMmapTT (SW16 chId, int fst_type)
#else
GLOBAL UW16
SYMmapTT (chId, fst_type)
    SW16 chId;
    int  fst_type;
#endif
{
/* Remember that data in pss_entry arrays is in Hi-Lo byte order!! */
    register LPUB8  ptr;

              if((chId < symbolset.ss_first_code[SYMBOLSET_TT]) ||
                     (symbolset.ss_last_code[SYMBOLSET_TT] < chId))
                  return 0;
              ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                       (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
              return (GET_xWORD(ptr));
}


#else   /* either (IF_RDR || PST1_RDR) or (TT_RDR || FCO_RDR) but not both. */

/*------------------*/
/*     SYMmapTT       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  SYMmapTT (SW16 chId, int fst_type)
#else
GLOBAL UW16
SYMmapTT (chId, fst_type)
    SW16 chId;
    int  fst_type;
#endif
{
    register LPUB8  ptr;
    if((chId < symbolset.ss_first_code[SYMBOLSET_TT]) ||
              (symbolset.ss_last_code[SYMBOLSET_TT] < chId))
        return 0;
    ptr = (LPUB8)(symbolset.pss_entry[SYMBOLSET_TT] +
                   (chId - symbolset.ss_first_code[SYMBOLSET_TT]) );
    return (GET_xWORD(ptr));
}

#endif

#endif  /* FCO_TT */


