/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/dep/cache.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cache.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.17   07 Apr 1995 08:36:32   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.16   13 Feb 1995 15:10:08   JOE
 * In FNTfree(), when freeing the hash table, removed call to dll_remove()
 * 
 * because it is unnecessary and was causing an infinite loop.
 * 
 *    Rev 1.15   26 Jan 1995 16:22:44   JOE
 * ASIAN cache manager changes:
 * In CACinsert(), check if MEMalloc() call failed before inserting
 * character in hash list.
 * In CACfont() and CAChdr_font(), return error if not enough cache
 * memory for hash list.
 * In FNTfree(), free hash table.
 * 
 *    Rev 1.14   26 Sep 1994 09:37:44   JOE
 * 
 * In CAChdr_purge(), reset similar_fonts_purged flag before
 * looping thru every font.
 * 
 *    Rev 1.13   20 Sep 1994 11:50:06   JOE
 * 
 * In CAChdr_font(), conditionally compiled statements which reference
 * "font_hdr" field of fontcontext to resolve compiler error.
 * In same function, returning ERRfont_hdr_purge error if this function
 * iis not supported.
 * 
 *    Rev 1.12   11 Sep 1994 09:02:48   JOE
 * 
 * Added new functions CAChdr_purge() and CAChdr_font().
 * 
 *    Rev 1.11   05 Aug 1994 20:17:52   MIKE
 * 
 * Added FCO changes from 1.8.1.1
 * 
 *    Rev 1.10   21 Apr 1994 15:43:10   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.9   25 Jan 1994 10:45:08   MAIB
 * Created a two-byte character code caching scheme, conditionally compiled
 * on ASIAN_ENCODING
 * 
 *    Rev 1.8   01 Nov 1993 13:09:56   MAIB
 * Additional check for current font added
 * 
 *    Rev 1.7   29 Oct 1993 17:27:58   MAIB
 * Fixed condition missed in CACfont() optimization
 * 
 *    Rev 1.6   25 Oct 1993 10:58:52   MAIB
 * Optimizations for cache access and font access in place
 * 
 *    Rev 1.5   06 May 1993 16:09:36   MIKE
 * In CACfont() change "has_path" condition from NON_IF_FONT to
 *   PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK).
 *   has_path is true for IF disk + dynamic font.
 * 
 *    Rev 1.4   12 Feb 1993 19:38:28   MIKE
 * Application Generated Bitmap support: in BMfree() call
 * app_free_character() to clear char from cache.
 * 
 *    Rev 1.3   12 Feb 1993 13:55:46   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   14 Jan 1993 13:55:32   LISA
 * Removeed CtrlZ character from end of file
 * 
 *    Rev 1.1   11 Dec 1992 15:31:42   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:25:46   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* cache.c */
/*
 *
 * History
 *
 *    29-Jul-90  awr   changed conditional compile on MEMstat() from DEBUG
 *                     to MEM_TRACE
 *    05-Aug-90  awr   added bitMapCount in FONTCONTEXT to improve cache
 *                     performance. If last bitmap is freed from a font
 *                     and it's not the current font, then the font is freed.
 *    20-Nov-90  jfd   Compiling all routines conditionally based on CACHE;
 *                     Added  #include "cgconfig.h".
 *    04-Dec-90  jfd   Moved "include" statement for  "cgconfig.h" to line
 *                     following "port.h"
 *    28-Jan-91  jfd   Made size arg of BMnew() LONG
 *                     Made size arg of MEMalloc() LONG
 *    30-Jan-91  dET   Added function prototyping for MSC.
 *    31-Jan-91  dET   Modify for MSC multi-model compilation.
 *     3-Feb-90  awr   Split BMnew() into CACalloc() and CACinsert()
 *                     changed make_char() for memory callbacks
 *                     changed mem_avail[] to a LONG.
 *     8-Feb-91  awr   Added dll.h to declare functions.
 *                     Moved FNTfree() call in CGIFfont() to start of
 *                     FNTfind().
 *                     Renamed FNTfind() to CACfont().
 *                     Removed BMnew()- no longer used.
 *    05-Mar-91  jfd   Added new routine CACpurge().
 *    06-Mar-91  jfd   In CACexit(), free list headers.
 *                     Changed CACdefund() to BOOLEAN and am calling
 *                     CACExit() if necessary.
 *    09-Apr-91  dET   Added print_fnt_lru() and cac_dump routines for aid
 *                     in debugging. 
 *    17-Jun-91  jfd   Moved "debug.h" after "port.h".
 *                     Moved "cgconfig.h" before "port.h".
 *    26 Jun 91  ss    Added not LINT_ARGS prototype for FNTfree().
 *    18-Aug-91  awr   Added htileBM to keep track of tile bm memory
 *    28-Aug-91  jfd   Added function prototype for purge_page() and
 *                     (*free)() to resolve compiler warnings.
 *    29-Aug-91  jfd   In CACfont(), replaced call to structs_are_equal()
 *                     with call to FCis_equal().
 *    25-Sep-91  jfd   In CACpurge(), changed type of argument from
 *                     "FONTCONTEXT *" to "PFONTCONTEXT" to get rid of
 *                     compiler warning.
 *    28-Seo-91  awr   Use CGIFinitstate to signal whether cache is
 *                     initialized and protect against out of sequence
 *                     calls to CACinit() or CACexit()
 *    14-Feb-92  jfd   Included "mixmodel.h".
 *    26-Feb-92  jfd   In CACfont(), conditionally compiled all references
 *                     to "fc->font_hdr" based on EXTERN_FONT.
 *                     Included <string.h> dur to STRNCMP call.
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    05-Apr-92  rs	  Fix CACfont - always said font was found after call
 *							  to 'FCis_equal()'.
 *    12 May 92  ss    Changed conditional compiles based on EXTERN_FONT
 *                     to (PST1I || TT_RDR) since EXTERN_FONT is used
 *                     elsewhere to mean PCLEO.
 *    08-Jul-92  rs    Code cleanup.
 *   21-Jul-92   awr   Conditional compile changes.
 *   05-Aug-92   jfd   Replaced calls to FCis_equal() with MEMCMP for
 *                     optimization.
 *   04-Sep-92   jfd   In CACfont(), moved setting of "has_path" outside
 *                     of "for" loop to ensure thatit is set properly.
 *   17-Nov-92   rs    Add ANSI function definitions base on ANSI_DEFS.
 *   08-Feb-93   jfd   VXWorks support.
 *   09-Feb-93   mby   Application Generated Bitmap support: in BMfree() call
 *                     app_free_character() to clear character from cache.
 *   05-May-93   mby   In CACfont() change has_path condition from NON_IF_FONT
 *                     to PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)
 *                     Set has_path if dynamic font and IF disk.
 *   25-Oct-93   maib  Conditionally left out CACaccess, now inline in CGIFchar.
 *                     Optimized CACfont for multi-threading
 *   29-Oct-93   maib  Fixed optimization when same fontcontext passed
 *   01-Nov-93   maib  Made sure to check for valid pfontCur before comparing
 *                     fontcontexts
 *   25-Jan-94   maib  Included new cache accessing scheme for ASIAN_ENCODING
 *   30-Aug-94   jfd   Added new functions CAChdr_purge() and
 *                     CAChdr_font().
 *   20-Sep-94   jfd   In CAChdr_font(), conditionally compiled statement
 *                     which references "font_hdr" field of fontcontext
 *                     to resolve compiler error.
 *                     In same function, returning ERRhdr_font_purge error
 *                     if this function is not supported.
 *   23-Sep-94   jfd   In CAChdr_purge(), reset similar_fonts_purged
 *                     before looping thru every font.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.8.1.1:
 *   15-Jun-94   mby   In CACfont() has_path = 0 if fst type is FCO.
 *   26-Jan-95   jfd   Made the following changes to ASIAN_ENCODING
 *                     version of cache manager:
 *                     In CACinsert(), check if MEMalloc() call failed
 *                     before inserting character in hash list.
 *                     In CACfont() and CAChdr_font(), return error if
 *                     there is not enough cache memory for hash list.
 *                     In FNTfree(), free hash table.
 *   13-Feb-95   jfd   In FNTtree(), when freeing the hash table, removed
 *                     call to dll_remove() because it is unnecessary.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 */
#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <string.h>

#include "cgconfig.h"                  /* 11-20-90 jfd */
#include "port.h"
#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "cgif.h"
#include "cache.h"               /* Declares GLOBAL cache functions */
#include "dll.h"
#include "sym.h" /*keb*/

#define MEM_TRACE  0        /* set to 1 to trace memory */

#if CACHE                              /* 11-20-90 jfd */

#ifdef LINT_ARGS
MLOCAL VOID        BMfree(HIFBITMAP);
MLOCAL VOID        FNTfree(HIFFONT);
#if DEFUND
MLOCAL VOID        purge_page(UW16, MEM_HANDLE, VOID (*)(MEM_HANDLE));
#endif /* DEFUND */
EXTERN VOID        app_free_character( HIFBITMAP hbm );
GLOBAL UW16        CAChdr_purge(PFONTCONTEXT);
GLOBAL UW16        CAChdr_font (PFONTCONTEXT);
#else /* not LINT_ARGS */
MLOCAL VOID        FNTfree();           /*  added -ss 6/26/91  */
#if DEFUND
MLOCAL VOID        purge_page();
#endif /* DEFUND */
EXTERN VOID        app_free_character();
GLOBAL UW16        CAChdr_purge();
GLOBAL UW16        CAChdr_font ();
#endif /* LINT_ARGS */


/* cgif.c */
MLOCAL  FONTCONTEXT fcCur;              /* current FONTCONTEXT            */
GLOBAL  HIFFONT     hfontCur;           /* handle of current FONT         */
GLOBAL  PFONT       pfontCur;           /* ptr to current FONT            */
EXTERN  UW16       CGIFinitstate;

#if CACHE
GLOBAL   UW16        similar_fonts_purged = 0;   /* 8-30-94 jfd */
#endif
/*------------------------------------------------------------------------*/
MLOCAL MEM_HANDLE  hFNTlru;            /* Least recently used fonts       */
GLOBAL MEM_HANDLE  hBMlru;             /* LRU character IFBITMAPs         */
GLOBAL UW16       max_char_size;      /* max cached bitmap size          */
MLOCAL HIFBITMAP   hBigBM;             /* buffer handle of big character  */
#if TILE
GLOBAL HIFBITMAP htileBM;         /* Handle of last made tile part   */
#endif
/*------------------------------------------------------------------------*/



#if 0    /* 10/25/93 maib */
/*----------------------*/
/*       CACaccess      */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL PIFBITMAP CACaccess(UW16 chId)
#else
GLOBAL PIFBITMAP
CACaccess(chId)
    UW16 chId;
#endif
{
    UW16      status;
    PIFBITMAP  pbm;              /* pointer to the new character IFBITMAP */
    PHIFBITMAP phbm;

  /*  Make sure we're set for the current FONT. CGIFdefund() could have
   *  freed it on us. The app could also be calling us without a
   *  preceeding valid call to CGIFfont().
   */

    if(!pfontCur)                /* Is pointer to FONT set ? */
    {
        if(!hfontCur)            /* No. How about the handle to the FONT? */
        {
            if(!fcCur.font_id) /* Still no. Do we even have a FONTCONTEXT? */
                return (PIFBITMAP)0;
            else
            {
                status = CACfont(&fcCur);
                if (status)
                    return (PIFBITMAP)0;
            }
        }
        else
        {
            pfontCur = (PFONT)MEMptr(hfontCur);
        }
    }

 /* point to handle of character's IFBITMAP in current FONT */

    phbm = pfontCur->hbuf + chId;

    if(! *phbm)                            /* Is character in the cache ? */
        return (PIFBITMAP)0;               /* No. */

    pbm = (PIFBITMAP)MEMptr(*phbm);

  /*  Make buffer most recently used if it hasn't
   *  already been made so during this current font's reign.
   */

    if( pbm->notmru )
    {
        pbm->notmru = 0;               /* Keep from doing this again       */
        dll_remove(*phbm);             /* Remove from lru list             */
        dll_after(hBMlru, *phbm);      /* Link at the head of the lru list */
    }

  /*  Return character bitmap pointer */

    return pbm;
}
#endif /* 0, 10/25/93 maib */

/*
 * 1/25/94 maib
 * return a MEM_HANDLE to the hash list item for a particular
 * character ID, look in the font passed
 */
#if ASIAN_ENCODING
#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE CAChashLookup(PFONT pf, UW16 chId)
#else
GLOBAL MEM_HANDLE 
CAChashLookup(pf, chId)
  PFONT pf;
  UW16 chId;
#endif
{
  UB8 row = ((chId & 0xff00) >> 8);
  MEM_HANDLE hItem, hrowDLL = pf->hash_table[row];
  PHASH_ITEM phi;

  /*
   * hrowDLL is a handle to the DLL which contains hash list items
   * for the particular row. traverse each hash list item to determine
   * if the character has been previously cached. if found, return the
   * handle to the hash list item. if not found, return null...
   */
  for (hItem = ((PDLL)MEMptr(hrowDLL))->f; hItem != hrowDLL; hItem = phi->link.f)
  {
    phi = (PHASH_ITEM)MEMptr(hItem);
    if (phi->chId == chId)
      return hItem;
  }

  return (MEM_HANDLE)0L;
}
#endif /* ASIAN_ENCODING */


/*----------------------*/
/*       BMfree         */
/*----------------------*/
/*  Free an IFBITMAP. Remove all references to this bitmap. References can
 *  be from FONTs or from hBigBM.
 */
#if defined (ANSI_DEFS)
MLOCAL VOID BMfree(HIFBITMAP hbm)
#else
MLOCAL VOID
BMfree(hbm)
    HIFBITMAP hbm;              /* handle of IFBITMAP that is to be freed */
#endif
{
    PIFBITMAP bm;
    HIFFONT   hf;
    PFONT     f;


    if(hbm == hBigBM)
        hBigBM = (HIFBITMAP)0L;

    bm = (PIFBITMAP)MEMptr(hbm);       /* Recover pointer to the IFBITMAP */

  /*  Remove the reference to the IFBITMAP from the font. If there are
   *  no more bitmaps in the font and the font is not the current font
   *  then free up the font also.
   */

    hf = bm->hiffont;                          /* handle to my FONT owner */
    f = (PFONT)MEMptr(hf);
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    /*
     * get a handle to the hash list item for this particular bitmap
     * and remove the item from the hash list
     */
    {
      MEM_HANDLE hItem;

      hItem = CAChashLookup(f, bm->index);
      dll_remove(hItem);
      MEMfree(CACHE_POOL, hItem);
    }
#else
    *(f->hbuf+bm->index) = (HIFBITMAP)0L;      /* forget about me         */
#endif /* ASIAN_ENCODING */
    if(!(--f->bitmapCount) && (hf != hfontCur))
        FNTfree(hf);

    dll_remove(hbm);                    /*  Remove IFBITMAP from lru list */

#if ALIEN_BITS
    if (FC_ISAPPGEN( &(f->fc) ))
    {
        app_free_character(hbm);
        return;
    }
#endif  /* ALIEN_BITS */

    MEMfree(CACHE_POOL, hbm);           /*  Free the IFBITMAP memory      */
}







/*----------------------*/
/*     CACinsert        */
/*----------------------*/
/*  Insert the character whose handle is hbm into the current font
 *  at index chId.
 *  ASSUMES that hfontCur and pfontCur are valid.
 */
#if defined (ANSI_DEFS)
GLOBAL VOID CACinsert(HIFBITMAP hbm, UW16 chId)
#else
GLOBAL VOID
CACinsert(hbm, chId)
    HIFBITMAP hbm;
    UW16     chId;
#endif
{
    PIFBITMAP bm;

    bm = (PIFBITMAP)MEMptr(hbm);                       /* Recover pointer */

  /*  If memory block is too big to cache, remember it in hBigBM.
   *  It will be freed on the next call to CHARalloc().
   */

    if((SL32)bm->width * (SL32)bm->depth > (SL32)max_char_size)
        hBigBM = hbm;

  /*  make least recently used */

    bm->notmru = 0;             /* Keep CACaccess() from calling me again */
    dll_after(hBMlru, hbm);     /* link at start of IFBITMAP lru list     */

  /*  Remember my new owner so that I can remove all references to
   *  myself if I have to be reclaimed. Tell new owner there's one more
   *  of us bitmaps.
   */

    bm->index = chId;
    bm->hiffont = hfontCur;
    pfontCur->bitmapCount++;

  /* Insert bitmap handle in current FONT table */

/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    {
      MEM_HANDLE hItem, hrowDLL;
      PHASH_ITEM phi;

      /*
       * create and initialize a new hash list item, insert it as 
       * the first item in the row's DLL hash list...
       */
      hItem = MEMalloc(CACHE_POOL, sizeof(HASH_ITEM));

     /*
      * If MEMalloc() failed, remember memory block in hBigBM.
      * It will be freed on the next call to CHARalloc().
      */

      if (!hItem)
         hBigBM = hbm;
      else
      {
      phi = (PHASH_ITEM)MEMptr(hItem);
      phi->chId = chId;  phi->hbm = hbm;
      hrowDLL = pfontCur->hash_table[((chId & 0xff00) >> 8)];
      dll_after(hrowDLL, hItem);
      }
    }
#else
    *(pfontCur->hbuf + chId) = hbm;
#endif /* ASIAN_ENCODING */
}



/*                              I F B I T M A P                           */
/*========================================================================*/
/*                                 F O N T                                */




/*----------------------*/
/*    FNTfree           */
/*----------------------*/
/*  Free a currently active FONT and associated IFBITMAPs */

#if defined (ANSI_DEFS)
MLOCAL VOID FNTfree(HIFFONT hf)
#else
MLOCAL VOID
FNTfree(hf)
    HIFFONT hf;                             /* Handle of FONT to be freed */
#endif
{
    PFONT      f;                           /* Pointer to FONT to be freed */
    PHIFBITMAP phbm;
    SW16       i;

  /*  Clear cache state pointers if this is the current font. Leave
   *  the current FONTCONTEXT
   */

    if(hf == hfontCur)
    {
        hfontCur = (HIFFONT)0;
        pfontCur = (PFONT)0;
    }

    f = (PFONT)MEMptr(hf);                             /* Recover pointer */

  /*  Free each IFBITMAP in the font. Bump the font's bitmapCount by 1 so
   *  that it won't go to 0 when the last bitmap is freed. Otherwise,
   *  BMfree() will try to free me.
   */

    f->bitmapCount++;                 /* One more than I really have      */
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    /*
     * just make sure all cached bitmaps are accessed here, the
     * actual cleanup, for both the bitmap and hash list item,
     * is done within BMfree...
     * traverse each row, and each column w/in each row...
     */
    {
      MEM_HANDLE hItem, hrowDLL;
      HASH_ITEM *phi;

      for (i = 0; i < HASHMAX; i++)
      {
        /*
         * since this is a DLL, the entire list has been traversed when
         * a forward link points to the row's DLL handle.
         * remember, the hash table contains handles to DLLs which then
         * point to hash list items...
         */
        hrowDLL = f->hash_table[i];
        hItem = ((PDLL)MEMptr(hrowDLL))->f;
        while (hItem != hrowDLL)
        {
          /* get the next item in the list before it is freed */
          phi = (PHASH_ITEM)MEMptr(hItem);
          hItem = phi->link.f;
          BMfree(phi->hbm);
        }
      }
      /* Free hash table too      1-26-95 jfd */

      for (i = 0; i < HASHMAX; i++)
         MEMfree(CACHE_POOL, f->hash_table[i]);
    }
#else
    phbm = f->hbuf;                   /* start of array of bitmap handles */
    for(i = 0; i<SSMAX; i++)
    {
        if (*phbm) BMfree(*phbm);
        phbm++;
    }
#endif /* ASIAN_ENCODING */

    dll_remove(hf);                         /*  Remove FONT from lru list */
    MEMfree(CACHE_POOL, hf);                /*  Free the FONT memory      */
}








/*-------------------*/
/*    CACfont        */
/*-------------------*/
/*  Find the active FONT that matches the given FONTCONTEXT. If no
 *  match, then create a new FONT.
 */
EXTERN UW16 Meto_encodearray; /*keb*/
EXTERN UW16 cache_Meto_font;
#if defined (ANSI_DEFS)
GLOBAL UW16 CACfont(PFONTCONTEXT fc)
#else
GLOBAL UW16
CACfont(fc)
    PFONTCONTEXT fc;
#endif
{
    HIFFONT   hf;
    PFONT     f;
    HIFBITMAP hbm;
    PIFBITMAP bm;
#if ASIAN_ENCODING
    MEM_HANDLE htmp;
#endif /* ASIAN_ENCODING */
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
    int       has_path=0;

#if ROM
    has_path = 0;
#else
    has_path = (!FC_ISEXTERN(fc) && !fc->font_id); /* PS, TT disk, IF dynamic */
    if (FC_ISFCO(fc))
        has_path = 0;
#endif /* ROM */
#endif

    /*
     * 10/25/93 maib
     * in an attempt to optimize CACfont, do not perform any changes if
     * the fontcontext passed is identical to what the cache believes is
     * the current font's fontcontext. ie. there is no need to make the
     * font the most current if this already is true...
     */
    if (pfontCur &&
        !MEMCMP((LPSB8)fc, (LPSB8)&pfontCur->fc, sizeof(FONTCONTEXT)))
    {
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
       if (has_path)
       {
         if (STRNCMP((LPSB8)fc->font_hdr, pfontCur->pathname, PATHNAMELEN) == 0)
           return SUCCESS;
       }
       else
#endif
       return SUCCESS;
    }

  /*  Free old FONT if it has no bitmaps */
    if(pfontCur)
        if(!pfontCur->bitmapCount) FNTfree(hfontCur);

  /* Set cache state to no valid FONT in case we fail */
    pfontCur = (PFONT)0;
    hfontCur = (HIFFONT)0;
    fcCur.font_id = 0;

  /*  Search active fonts for a match with
   *  the user's device font context
   */
/*keb*/
	cache_Meto_font = 0;
    for(hf = ((PDLL)MEMptr(hFNTlru))->f; hf != hFNTlru; hf = f->link.f)
    {
        f = (PFONT)MEMptr(hf);
#if (PST1_DISK)
		if (fc->font_hdr && f->pathname)
		if(STRNCMP((LPSB8)fc->font_hdr, f->pathname, PATHNAMELEN) == 0)
		{
			    cache_Meto_font = 1;
				if(f->fc.ssnum == T1ENCODING)
					Meto_encodearray = 1;
				else
					Meto_encodearray = 0;
        }
#endif
        if (!MEMCMP((LPSB8)fc, (LPSB8)&f->fc, sizeof(FONTCONTEXT)))
		  {
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
            if (has_path)
            {
                if(STRNCMP((LPSB8)fc->font_hdr, f->pathname, PATHNAMELEN) == 0)
				        break;
			}
            else
#endif
            
            break;
			
		  }
    }

    if(hf != hFNTlru)
    {
      /*  Make FONT most recently used */
		/* keb */
		cache_Meto_font = 1;
        dll_remove(hf);
        dll_after(hFNTlru, hf);
    }
    else
    {
      /*  No active FONT matches the app's FONTCONTEXT. Make a new FONT */

        SW16       i;
        PHIFBITMAP phbm;

      /*  Allocate a new FONT */

        if(!(hf = (HIFFONT)CHARalloc((SL32)sizeof(FONT))))
            return ERR_no_font;

#if ASIAN_ENCODING

      /* Check for enough cache memory for hash list 
       * which will be allocated later
       */

        if(!(htmp = CHARalloc((SL32)(sizeof(DLL) * HASHMAX))))
            return ERR_no_font;
        CHARfree(htmp);

#endif /* ASIAN_ENCODING */

        /*  Make new FONT most recently used */

        dll_after(hFNTlru, hf);

      /* Initialize font data. */

        f = (PFONT)MEMptr(hf);                       /* Recover pointer */
        f->fc = *fc;                          /* Copy FONTCONTEXT to new FONT */    
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
        if(has_path)
            STRCPY(f->pathname, (LPSB8)fc->font_hdr);
#endif

        f->bitmapCount = 0;          /* No character IFBITMAPs are cached yet */
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
        for (i = 0; i < HASHMAX; i++)
        {
          /*
           * each row initially contains a empty DLL of hash list items
           */
          f->hash_table[i] = MEMalloc(CACHE_POOL, sizeof(DLL));
          dll_null(f->hash_table[i]);
        }
#else
        phbm = f->hbuf;                  /* point to list of IFBITMAP handles */
        for(i=0; i < SSMAX; i++)
            *phbm++ = (HIFBITMAP)0L;
#endif /* ASIAN_ENCODING */
    }  /* end make a new FONT */

  /*  Set all IFBITMAPs' notmru flags to 1 indicating that they have not
   *  been moved to the front of the lru list during calls to CGIFchar() for
   *  the current FONT. CGIFchar() checks the notmru flag for the IFBITMAP
   *  it is about to return. If it is 1, then a call is made to BMmru()
   *  above to move the IFBITMAP to the head of the lru list making it
   *  "most recently used". At that time the notmru flag is cleared so that
   *  it will be moved to the head of the list only once during a sequence
   *  of calls to CGIFchar() for a given FONT. This is to keep CGIFchar()'s
   *  performance up. All IFBITMAPs that need to have their
   *  notmru flags set are at the beginning of the lru list.
   */
    hbm = ((PDLL)MEMptr(hBMlru))->f;        /* first IFBITMAP in lru list */
    while(hbm != hBMlru)
    {
        bm = (PIFBITMAP)MEMptr(hbm);
        if(bm->notmru) break;
        bm->notmru = 1;
        hbm = bm->link.f;                    /* next IFBITMAP in the list */
    }

  /* Set cache state for current font */

    pfontCur = f;
    hfontCur = hf;
    fcCur = *fc;

    return SUCCESS;
}

/*--------------------*/
/*    CAChdr_font     */
/*--------------------*/
/*  Find the active FONT that matches the given FONTCONTEXT. If no
 *  match, then create a new FONT.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16 CAChdr_font(PFONTCONTEXT fc)
#else
GLOBAL UW16
CAChdr_font(fc)
    PFONTCONTEXT fc;
#endif
{
    HIFFONT   hf;
    PFONT     f;
    HIFBITMAP hbm;
    PIFBITMAP bm;
#if ASIAN_ENCODING
    MEM_HANDLE htmp;
#endif /* ASIAN_ENCODING */
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
    int       has_path=0;

#if ROM
    has_path = 0;
#else
    has_path = (!FC_ISEXTERN(fc) && !fc->font_id); /* PS, TT disk, IF dynamic */
#endif /* ROM */
#endif

    /*
     * 10/25/93 maib
     * in an attempt to optimize CACfont, do not perform any changes if
     * the fontcontext's font_hdr passed is identical to what the cache believes is
     * the current font's fontcontext's font_hdr. ie. there is no need to make the
     * font the most current if this already is true...
     */
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
    if (pfontCur &&
        ((LPSB8)fc->font_hdr == (LPSB8)pfontCur->fc.font_hdr))
    {
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
       if (has_path)
       {
         if (STRNCMP((LPSB8)fc->font_hdr, pfontCur->pathname, PATHNAMELEN) == 0)
         {
           similar_fonts_purged = FALSE;
           return SUCCESS;
         }
       }
       else
#endif /* (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)) */
       {
       similar_fonts_purged = FALSE;
       return SUCCESS;
       }
    }
#else
    return ERRhdr_font_purge;
#endif /* (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS) */

  /*  Free old FONT if it has no bitmaps */
    if(pfontCur)
        if(!pfontCur->bitmapCount) FNTfree(hfontCur);

  /* Set cache state to no valid FONT in case we fail */
    pfontCur = (PFONT)0;
    hfontCur = (HIFFONT)0;
    fcCur.font_id = 0;

  /*  Search active fonts for a match with
   *  the user's device font context's font_hdr
   */

    for(hf = ((PDLL)MEMptr(hFNTlru))->f; hf != hFNTlru; hf = f->link.f)
    {
        f = (PFONT)MEMptr(hf);
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
        if ((LPSB8)fc->font_hdr == (LPSB8)f->fc.font_hdr)
		  {
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
            if (has_path)
            {
                if(STRNCMP((LPSB8)fc->font_hdr, f->pathname, PATHNAMELEN) == 0)
                    break;
            }
            else
#endif
            break;
		  }
#endif /* (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS) */
    }

    if(hf != hFNTlru)
    {
      /*  Make FONT most recently used */
        dll_remove(hf);
        dll_after(hFNTlru, hf);
        similar_fonts_purged = FALSE;
    }
    else
    {
      /*  No active FONT matches the app's FONTCONTEXT's font_hdr. Make a new FONT */

        SW16       i;
        PHIFBITMAP phbm;

        similar_fonts_purged = TRUE;

      /*  Allocate a new FONT */

        if(!(hf = (HIFFONT)CHARalloc((SL32)sizeof(FONT))))
            return ERR_no_font;

#if ASIAN_ENCODING

      /* Check for enough cache memory for hash list 
       * which will be allocated later
       */

        if(!(htmp = CHARalloc((SL32)(sizeof(DLL) * HASHMAX))))
            return ERR_no_font;
        CHARfree(htmp);

#endif /* ASIAN_ENCODING */

        /*  Make new FONT most recently used */

        dll_after(hFNTlru, hf);

      /* Initialize font data. */

        f = (PFONT)MEMptr(hf);                       /* Recover pointer */
        f->fc = *fc;                          /* Copy FONTCONTEXT to new FONT */    
#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
        if(has_path)
            STRCPY(f->pathname, (LPSB8)fc->font_hdr);
#endif

        f->bitmapCount = 0;          /* No character IFBITMAPs are cached yet */
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
        for (i = 0; i < HASHMAX; i++)
        {
          /*
           * each row initially contains a empty DLL of hash list items
           */
          f->hash_table[i] = MEMalloc(CACHE_POOL, sizeof(DLL));
          dll_null(f->hash_table[i]);
        }
#else
        phbm = f->hbuf;                  /* point to list of IFBITMAP handles */
        for(i=0; i < SSMAX; i++)
            *phbm++ = (HIFBITMAP)0L;
#endif /* ASIAN_ENCODING */
    }  /* end make a new FONT */

  /*  Set all IFBITMAPs' notmru flags to 1 indicating that they have not
   *  been moved to the front of the lru list during calls to CGIFchar() for
   *  the current FONT. CGIFchar() checks the notmru flag for the IFBITMAP
   *  it is about to return. If it is 1, then a call is made to BMmru()
   *  above to move the IFBITMAP to the head of the lru list making it
   *  "most recently used". At that time the notmru flag is cleared so that
   *  it will be moved to the head of the list only once during a sequence
   *  of calls to CGIFchar() for a given FONT. This is to keep CGIFchar()'s
   *  performance up. All IFBITMAPs that need to have their
   *  notmru flags set are at the beginning of the lru list.
   */
    hbm = ((PDLL)MEMptr(hBMlru))->f;        /* first IFBITMAP in lru list */
    while(hbm != hBMlru)
    {
        bm = (PIFBITMAP)MEMptr(hbm);
        if(bm->notmru) break;
        bm->notmru = 1;
        hbm = bm->link.f;                    /* next IFBITMAP in the list */
    }

  /* Set cache state for current font */

    pfontCur = f;
    hfontCur = hf;
    fcCur = *fc;

    return SUCCESS;
}


#if MEM_TRACE
#if defined (ANSI_DEFS)
MLOCAL VOID print_fnt_lru()
#else
MLOCAL VOID
print_fnt_lru()
#endif
{
    HIFFONT   hf;
    PFONT     f;

  /*  Search active fonts and print
   */

    for(hf = ((PDLL)MEMptr(hFNTlru))->f; hf != hFNTlru; hf = f->link.f)
    {
        f = (PFONT)MEMptr(hf);
    
        DBG3("%ld: %d %d\n", f->fc.font_id,f->fc.point_size, f->bitmapCount);
    }                
}
#endif


/*----------------------*/
/*       CACinit        */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 CACinit()
#else
GLOBAL UW16
CACinit()
#endif
{
    if(!(CGIFinitstate & not_cac))
        return ERR_CACinit; /* already initialized */

  /* Set cache state to no valid FONT */

    pfontCur = (PFONT)0;
    hfontCur = (HIFFONT)0;
    fcCur.font_id = 0;

#if TILE
    htileBM = NIL_MH;     /* Handle of last made tile part   */
#endif

  /* Get doubly linked list headers. These must be handles */

    if(!(hBMlru = MEMalloc(CACHE_POOL, (SL32)sizeof(DLL))))
        return ERR_CACinit;
    if(!(hFNTlru = MEMalloc(CACHE_POOL, (SL32)sizeof(DLL))))
    {
        MEMfree(CACHE_POOL, hBMlru);
        return ERR_CACinit;
    }

    dll_null(hFNTlru);                    /*  Set FONT lru list to empty. */
    dll_null(hBMlru);                     /*  Set IFBITMAP lru to empty.  */
    hBigBM = (HIFBITMAP)0L;               /*  No big character yet        */

    CGIFinitstate &= ~not_cac;            /* turn off not initialized bit */
    return SUCCESS;
}




/*----------------------*/
/*       CACexit        */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID CACexit()
#else
GLOBAL VOID
CACexit()
#endif
{
    DBG("\n\nCACexit()\n");

    if(CGIFinitstate & not_cac) return;   /* cache not initialized */

  /* Free all FONTs */

    while(!dll_empty(hFNTlru))
        FNTfree(((PDLL)MEMptr(hFNTlru))->b);


  /* free list headers */

    MEMfree(CACHE_POOL, hFNTlru);
    MEMfree(CACHE_POOL, hBMlru);

#if TILE
    if(htileBM)
    {
        MEMfree(CACHE_POOL, htileBM);
        htileBM = NIL_MH;
    }
#endif

    CGIFinitstate |= not_cac;           /* set not initialized bit */

#if MEM_TRACE
    MEMstat(CACHE_POOL);
#endif
}


/*------------------*/
/*   CACpurge       */
/*------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 CACpurge(PFONTCONTEXT fc)
#else
GLOBAL UW16
CACpurge(fc)
    PFONTCONTEXT fc;
#endif
{
    UW16 status;
    status = CACfont(fc);
    if (status)
        return status;
    FNTfree(hfontCur);
    return SUCCESS;
}


/*-----------------------*/
/*   CAChdr_purge        */
/*-----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 CAChdr_purge(PFONTCONTEXT fc)
#else
GLOBAL UW16
CAChdr_purge(fc)
    PFONTCONTEXT fc;
#endif
{
    UW16 status;

    similar_fonts_purged = 0;

    while (!similar_fonts_purged)
    {
       status = CAChdr_font(fc);
       if (status)
           return status;
       FNTfree(hfontCur);
    }
    return SUCCESS;
}

/*------------------------------------------------------------------*/
/*         C a c h e    M e m o r y    M a n a g e m e n t          */


#if DEFUND
/*  If DEFUND is enabled, we may get called via the CGIFdefund()
 *  function to relinquish all use of a particlular ufst memory
 *  page. CACdefund() is called in this case. If the linked list
 *  headers need to be freed, we just call CACexit() to clear out the
 *  whole cache and return TRUE so that CGIFdefund() will call CACinit()
 *  once it has disposed of the page.
 */


/*----------------*/
/*  purge_page    */
/*----------------*/
/*  Search all entries in the least recently used list whose handle is
 *  "lru". If any entry has been allocated from the memory block "page",
 *  then free it using the function "free".
 */
#if defined (ANSI_DEFS)
MLOCAL VOID purge_page (UW16 page, MEM_HANDLE lru, VOID (*free)(MEM_HANDLE))
#else
MLOCAL VOID
purge_page(page, lru, free)
    UW16      page;
    MEM_HANDLE lru;            /* handle of lru list */
#ifdef LINT_ARGS
    VOID       (*free)(MEM_HANDLE);
#else
    VOID       (*free)();      /* function that frees members of lru list */
#endif
#endif /* (ANSI_DEFS) */
{
    MEM_HANDLE    hp, hnext;

    hp = ((PDLL)MEMptr(lru))->f;
    while(hp != lru)
    {
        hnext = ((PDLL)MEMptr(hp))->f;
        if(PAGE(hp) == page)
            (*free)(hp);
        hp = hnext;
    }
}




/*----------------------*/
/*       CACdefund      */
/*----------------------*/
/*  Free all BITMAPs and FONTs that are part of memory page "page". */
#if defined (ANSI_DEFS)
GLOBAL BOOLEAN CACdefund (UW16 page)
#else
GLOBAL BOOLEAN
CACdefund(page)
    UW16 page;
#endif
{
    purge_page(page, hFNTlru, FNTfree);  /* Free FONTs using this page */
    purge_page(page, hBMlru,  BMfree);   /* Free BITMAPs using this page */
    if((PAGE(hFNTlru) == page) || (PAGE(hBMlru) == page))
    {
        CACexit();
        return TRUE;
    }
    else
        return FALSE;
}
#endif  /*  DEFUND  */




/*----------------------*/
/*       CHARalloc      */
/*----------------------*/
/*  Acquire cache memory, freeing character bitmaps if need be.
 *  Return a handle to the memory.
 */
#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE CHARalloc (SL32 size)
#else
GLOBAL MEM_HANDLE
CHARalloc(size)
    SL32 size;
#endif
{
    MEM_HANDLE h;

  /*  Free up big character IFBITMAP if any */

    if (hBigBM)
        BMfree(hBigBM);

#if TILE
    if(htileBM)
    {
        MEMfree(CACHE_POOL, htileBM);
        htileBM = NIL_MH;
    }
#endif

    while(!(h = MEMalloc(CACHE_POOL, (SL32)size)))
    {
#if MEM_TRACE
        MEMstat(CACHE_POOL);
#endif
        if(dll_empty(hBMlru))

        {
#if MEM_TRACE
            print_fnt_lru();
#endif
            return (MEM_HANDLE)0;
        }
        else
            BMfree( ((PDLL)MEMptr(hBMlru))->b );     /* free lru IFBITMAP */
    }
    return h;
}




/*----------------------*/
/*       CHARfree       */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID CHARfree (MEM_HANDLE h)
#else
GLOBAL VOID
CHARfree(h)
    MEM_HANDLE h;
#endif
{
    MEMfree(CACHE_POOL, h);
}

#if MEM_TRACE
/*----------------*/
/*  MEMstat       */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL SL32 CACdump (UW16 print)
#else
GLOBAL SL32
CACdump(print)
    UW16 print;
#endif
{

    HIFFONT   hf;
    PFONT     f;
    HIFBITMAP hbm;
    PIFBITMAP bm;

    SL32 size;
    SL32 total = 0L;
    SL32 bmTotal = 0L;
    SL32 ftTotal = 0L;

    if(print) DBG("FONTS\n");

    for(hf = ((PDLL)MEMptr(hFNTlru))->f; hf != hFNTlru; hf = f->link.f)
    {
        f = (PFONT)MEMptr(hf);
        size = *((LPSL32)((LPSB8)f - 4));
        total += size;
        ftTotal += size;

        if(print) DBG4("Handle %6lx  Pointer %Fp  Bitmapcount %3d Size %5ld\n",
                        hf, f, f->bitmapCount, size);
    }
    if(print) DBG1("FONT totals = %ld\n", ftTotal);

    if(print) DBG("BITMAPS\n");
    
    hbm = ((PDLL)MEMptr(hBMlru))->f;        /* first IFBITMAP in lru list */
    while(hbm != hBMlru)
    {
        bm = (PIFBITMAP)MEMptr(hbm);

        size = *((LPSL32)((LPSB8)bm - 4));
        total += size;
        bmTotal += size;
        
        if(print) DBG4("Handle %6lx  Pointer %Fp size %5ld charcode %d\n",
        hbm, bm, size, bm->index);
        
        hbm = bm->link.f;                    /* next IFBITMAP in the list */
    }
    if(print) DBG1("BITMAP totals %ld\n", bmTotal);

    return total;

}
#endif  /* MEM_TRACE */

#endif  /* CACHE  */


