/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/dep/cgif.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cgif.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.99   04 Aug 1995 16:21:10   JOE
 * Changed fco y fluff from 2 to 5 because of perthousand character (by jc).
 * 
 *    Rev 1.98   04 Aug 1995 15:13:24   JOE
 * In CGIFfco_access(), corrected args - psize and pbuffer (misspelling)
 * (by jc).
 * 
 *    Rev 1.97   03 Aug 1995 11:48:26   MIKE
 * In CGIFbound_box() increased FCO fluff to 4 in X, 2 in Y
 * 
 *    Rev 1.96   28 Jul 1995 16:57:28   JOE
 * Added release_semaphor() call to CGIFtt_Free() before exit (by jwd).
 * 
 *    Rev 1.95   28 Jul 1995 10:22:40   MIKE
 * Initialized lsize[] array in routine CGIFchar_size(). [ by JWD]
 * 
 *    Rev 1.94   18 Jul 1995 13:29:16   MIKE
 * CGIFfont_purge(), CGIFhdr_font_purge().
 * 
 *    Rev 1.93   13 Jul 1995 14:15:00   MIKE
 * Conditionally compile CGIFsegments() if IF_RDR=1
 * 
 *    Rev 1.92   28 Jun 1995 16:13:28   MIKE
 * CGIFbound_box()
 * 
 *    Rev 1.91   24 May 1995 19:55:06   MIKE
 * CGIFbound_box, CGIFwidth, CGIFfco_Close, CGIFfco_Plugin.
 * 
 *    Rev 1.90   18 Apr 1995 16:53:10   JOE
 * Changes to support the removal of symbol set mapping.
 * 
 *    Rev 1.89   10 Apr 1995 16:20:06   MIKE
 * Conditionally compiled CGIFfco_Access()
 * 
 *    Rev 1.88   07 Apr 1995 08:37:00   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.87   31 Mar 1995 11:12:52   JOE
 * Added support for CGIFfco_Access() (by jwd).
 * 
 *    Rev 1.86   27 Mar 1995 10:40:52   MARTIN
 * Modified CGIFtt_Free to use a pointer instead of a handle.
 * 
 *    Rev 1.85   16 Feb 1995 16:46:46   JOE
 * Corrected prototype for CGIFtt_Generate() based on HUGE_PTR_SUPPORT.
 * 
 *    Rev 1.84   13 Jan 1995 18:05:08   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.83   09 Jan 1995 10:33:12   MARTIN
 * Added new arg to CGIFtt_Generate.
 * 
 *    Rev 1.82   17 Dec 1994 09:42:12   MIKE
 * Fixed CGIFbound_box() for FC_FCO_TYPE
 * 
 *    Rev 1.81   14 Dec 1994 15:46:56   JOE
 * Added support for MULTICALLER in FCO-related functions.
 * Removed MULTICALLER dependency from CAChdr_purge() prototype (by jwd).
 * 
 *    Rev 1.80   14 Dec 1994 08:20:54   JOE
 * Changed arg 2 of CGIFtt_Generate() from LPLPUB8 to LPHPUB8 (by rs).
 * 
 *    Rev 1.79   02 Dec 1994 21:13:22   MIKE
 * KSC (YAN).
 * 
 *    Rev 1.78   24 Oct 1994 09:57:12   JOE
 * In CGIFexit(), changed the way "CGIFinitstate" is tested based on IF_RDR
 * to resolve memory leakage problem.
 * 
 *    Rev 1.77   20 Oct 1994 14:09:50   MIKE
 * Changed argument of CGIFtt_Free() to SW16.
 * 
 *    Rev 1.76   19 Oct 1994 17:21:48   MIKE
 * Fixed CGIFbound_box() problem for mirrored matrix states.
 * Changed args of CGIFfco_Close and CGIFfco_Plugin from "int" to "SW16".
 * 
 *    Rev 1.75   11 Oct 1994 16:16:16   MARTIN
 * 
 * Modified CGIFexit, added &&!FCO_RDR to logical so that we clean up properly
 * 
 *    Rev 1.74   10 Oct 1994 12:20:40   MIKE
 * In cgif_Font(), resolve fontcontext matching problem by always setting
 * if_state.cur_loc_fc.font_hdr to 0.
 * 
 *    Rev 1.73   26 Sep 1994 11:03:50   MIKE
 * Changed CGIFfco_Open to pass int* argument to fco_InitFCO instead of UW16*
 * 
 *    Rev 1.72   20 Sep 1994 16:17:06   ROB
 * Modified CGIFinit() so that when running Windows DLL, 'CGIFinitstate'
 * will be initialized each time (instead of by compiler).
 * 
 *    Rev 1.71   15 Sep 1994 11:46:06   JOE
 * 
 * Moved prototype for CGIFhdr_font_purge() so that it is not
 * conditionally compiled based on CACHE.
 * 
 *    Rev 1.70   15 Sep 1994 08:27:46   JOE
 * Corrected function prototype declaration for CGIFhdr_font_purge()
 * (ENTRY --> CGENTRY).
 * Corrected prototype for CAChdr_purge() ("UW16 CGENTRY" --> "EXTERN UW16").
 * Removed prototype for CAChdr_font().
 * 
 *    Rev 1.69   11 Sep 1994 09:07:48   JOE
 * Added new functifon CGIFhdr_font_purge().
 * 
 *    Rev 1.68   08 Sep 1994 20:10:08   MIKE
 * Cleanup in CGIFwidth(), -kern() to support FCO only.
 * 
 *    Rev 1.67   02 Sep 1994 12:45:24   MIKE
 * Added CGIFfco_Plugin().
 * 
 *    Rev 1.66   26 Aug 1994 08:57:18   JOE
 * Changed arg 2 of CGIFffco_Open() from 'int *' to 'LPSW16' for WINDOWS.
 * Changed args 1 and 2 of CGIFtt_Generate() ('int *' to 'LPSW16', 'LPUB8 *'
 * to 'LPLPUB8') for WINDOWS.
 * 
 *    Rev 1.65   04 Aug 1994 14:14:56   MIKE
 * Added FCO changes 1.48.1.2
 * 
 *    Rev 1.64   14 Jul 1994 10:24:44   MIKE
 * Fixed bug in CGIFfont() that was returning error 54 for PCLETTOs.
 * 
 *    Rev 1.63   13 Jul 1994 14:02:00   JOE
 * In CGIFwidth(), set if_state.awtsub_on based on fcCur.p_AltWidTab to
 * avoid potential problem that could be caused when switching between
 * conv. and non-conv. fonts for multiple threads.
 * 
 *    Rev 1.62   13 Jul 1994 09:49:06   JOE
 * In CGIFbound_box(), was not setting if_state.awtsub_on based on
 * fcCur.p_AltWidTab. This was causing a problem if switching between
 * convergent and non-convergent fonts using multiple threads.
 * 
 *    Rev 1.61   05 Jul 1994 08:16:46   MIKE
 * Add 3rd argument to PCLeo2IF_ssnum(), called from cgif_Font().
 * 
 *    Rev 1.60   15 Jun 1994 10:22:24   MIKE
 * In CGIFfont() for Foreign Bitmaps 'has_path'=0; don't call SYMnew.
 * 
 *    Rev 1.59   08 Jun 1994 13:10:58   MIKE
 * 
 * CGIFfont calls SYMnoMap for PCLEOs with downloaded symbol set.
 * 
 *    Rev 1.58   03 Jun 1994 10:04:02   JOE
 * 
 * Changed all occurrences of ENTRY to CGENTRY to resolve conflict on
 * some compilers.
 * 
 *    Rev 1.57   05 May 1994 14:20:32   MIKE
 * Fixed bug involving "if_state.awtsub_on" and font bounding box.
 * 
 *    Rev 1.56   25 Apr 1994 13:56:06   MIKE
 * For FONTBBOX: changed structure IFplugin->xmax because of new "plugin.cfp"
 * 
 *    Rev 1.55   21 Apr 1994 16:48:58   JOE
 * 
 * Changed the way CGIFsegments() interprets the "tfnum" argument.
 * Instead of basing it on DYNAMIC_FONTS, it now checks for SEGACCESS
 * = 1 or 2 as well as DYNAMIC_FONTS.
 * 
 *    Rev 1.54   21 Apr 1994 15:43:04   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.53   25 Mar 1994 11:47:54   JOE
 * In CGIFwidth(), if processing CONVERGENT_FONTS, set "if_state.alt_width"
 * to 0 before calling CVFget_fnt_index() so that chwidth() will get called
 * if there is no entry in the alternate width table.
 * 
 *    Rev 1.52   06 Mar 1994 15:30:06   MIKE
 * 
 * Made changes to CGIFbound_box() to support Convergent Fonts/AWT4.
 * 
 *    Rev 1.51   10 Feb 1994 12:12:30   JOE
 * 
 * In CGIFsegments(), if DYNAMIC_FONTS is enabled, treat "tfnum" arg as a
 * pathname rather than a typeface number. This will all CGIFsegments() to
 * return segment data without having to call CGIFfont() first.
 * 
 *    Rev 1.50   03 Feb 1994 13:56:04   MIKE
 * 
 * For Convergent Fonts, made minor changes in CGIFwidth(). 
 * 
 *    Rev 1.49   25 Jan 1994 10:44:24   MAIB
 * Created a two-byte character code caching scheme, conditionally compiled
 * on ASIAN_ENCODING
 * 
 *    Rev 1.48   06 Jan 1994 09:42:28   JOE
 * Modified CGIFchar_size() to return the size of the largest compound
 * character part, for the cc_buf_size in the IFCONFIG structuure. Will
 * be returned in size[3].
 * 
 *    Rev 1.47   06 Jan 1994 08:32:08   MAIB
 * 
 * Fixed bug in handling alien bitmaps
 * 
 *    Rev 1.46   05 Jan 1994 18:12:56   ROB
 * Add support for "GB" encoding.
 * 
 *    Rev 1.45   05 Jan 1994 14:59:38   MAIB
 * Modified handling of alien bitmaps
 * 
 *    Rev 1.44   05 Jan 1994 09:37:40   JOE
 * In cgif_Config(), added check for bitmap width compatability with setting
 * of RASTER_ORG.
 * 
 *    Rev 1.43   14 Dec 1993 12:57:28   MIKE
 * Set xx_FLUFF constants to 1 for CGIFbound_box() function.
 * 
 *    Rev 1.42   07 Dec 1993 15:15:40   JOE
 * In cgif_Font(), added calls to get_ttDISK_ids() and get_ttROM_ids()
 * to retrieve platform and specific IDs from KANJI TT fonts.
 * Including "kanji.h".
 * 
 *    Rev 1.41   21 Nov 1993 07:59:16   MAIB
 * 
 * Added prototypes missing in multi-caller configuration
 * 
 *    Rev 1.40   11 Nov 1993 18:26:56   MIKE
 * When get_awt_bbox() is called, check status for error.
 * 
 *    Rev 1.39   01 Nov 1993 13:10:18   MAIB
 * Additional data required when switching instances
 * 
 *    Rev 1.38   27 Oct 1993 16:49:10   MIKE
 * 
 * Removed redundant code CGIFwidth().
 * 
 *    Rev 1.37   25 Oct 1993 10:57:50   MAIB
 * 
 * Optimized cache access in CGIFchar()
 * 
 *    Rev 1.36   12 Oct 1993 09:56:48   MAIB
 * 
 * put in ansi defs to allow sparc compilation
 * 
 *    Rev 1.35   11 Oct 1993 13:56:30   MIKE
 * 
 * Changes to CGIFwidth(), bound_box(), font(). See comments 9/30, 10/5.
 * 
 *    Rev 1.34   08 Oct 1993 15:04:02   JOE
 * In CGIFchar(), if requesting a fixed space character which has already
 * been cached, "status" is not being set to ERR_fixed_space. Check for
 * fixed space character and set "status" to ERR_fixed_space if necessary.
 * 
 *    Rev 1.33   29 Sep 1993 12:01:50   JOE
 * 
 * Added support for PS bounding box.
 * 
 *    Rev 1.32   29 Sep 1993 08:37:54   MAIB
 * Fixed bug of not releasing semaphore for all cases in CGIFinitRomInfo
 * 
 *    Rev 1.31   24 Sep 1993 09:19:34   JOE
 * 
 * In CGIFenter(), if MULTICALLER && !SEM_ACCESS, if "uEnterFirstTime"
 * is FALSE, "status" is returned as an ambiguous value. Initialized
 * "status" to SUCCESS at start of routine.
 * 
 *    Rev 1.30   23 Sep 1993 18:53:34   MIKE
 * 
 * Changes to CGIFfont(), CGIFbound_box().
 * 
 *    Rev 1.29   16 Sep 1993 11:27:30   MAIB
 * Changed CGIFchar() to allow banding of alien bitmaps 
 * 
 *    Rev 1.28   03 Sep 1993 13:26:52   JOE
 * Changed function declaration for psget_FontBBox() to include both
 * ANSI and non-ANSI formats to resolve compiler error.
 * 
 *    Rev 1.27   24 Aug 1993 15:27:40   JOE
 * 
 * In cgif_Font(), if symbol set is set to special encoding array value,
 * do not call PCLeo2IF_ssnum() or SYMnew().
 * 
 *    Rev 1.26   13 Aug 1993 19:35:02   MIKE
 * Replaced 2 printf's in CGIFchar() with DBG1's.
 * 
 *    Rev 1.25   03 Aug 1993 14:43:58   MAIB
 * Changed interface to resolve naming conflicts
 * 
 *    Rev 1.24   02 Aug 1993 14:20:16   MAIB
 * Changes to support multi-tasking
 * 
 *    Rev 1.23   29 Jul 1993 12:21:24   AL
 * Non-zero winding change for CGIFchar_size()
 * 
 *    Rev 1.22   15 Jul 1993 17:31:44   ROB
 * Make CGIFfont_purge() not be conditional on CACHE. Fix problem of purging
 * a PSEO and not working properly due to copy of fontcontext in if_state by
 * zeroing out this copy in font purge function.
 * 
 *    Rev 1.21   15 Jul 1993 11:59:08   MIKE
 * Changes for CGIFbbox_IFPCLEOchar(), convergent fonts; see comments.
 * 
 *    Rev 1.20   15 Jun 1993 18:32:10   MIKE
 * Added IF PCLEO support for font bbox. New routine CGIFbbox_IFPCLEOchar().
 * Added xx_FLUFF constants for CGIFbound_box(). Did some reorganization of
 * CGIFbound_box().
 * 
 *    Rev 1.19   09 Jun 1993 16:50:54   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.18   14 May 1993 16:08:02   JOE
 * Conditionally compiled "pathname" based on (PST1_DISK || TT_DISK ||
 * (DYNAMIC_FONTS && IF_DISK)) to resolve compiler error.
 * 
 *    Rev 1.17   06 May 1993 16:43:40   MIKE
 * In CGIFfont_purge() put conditional code around fc->font_hdr=0;
 * 
 *    Rev 1.16   06 May 1993 16:06:04   MIKE
 * Replace CGIFcache_purge() with CGIFfont_purge(). cache_purge is now a macro.
 * In CGIFfont() change "has_path" condition from NON_IF_FONT to
 *   PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK).
 *   has_path is also true for IF disk + dynamic font.
 * 
 *    Rev 1.15   22 Apr 1993 12:20:50   MIKE
 * Moved ifget_FontBBox() => fm.c.  Conditionally compile TTplugin structure.
 * 
 *    Rev 1.14   05 Apr 1993 13:27:38   MIKE
 * Fix MSC 6.0 compilation problem with ifget_FontBBox() prototype.
 * 
 *    Rev 1.13   17 Mar 1993 09:29:46   JOE
 * 
 * In CGIFchar(), if banding a PS or TT space character which exists in the
 * font or pcleo, CGIFbmheader() will not return "ERR_fixed_space", so to
 * check for space character, test for "if_state.num_loops == 0" to avoid
 * calling CGIFtile().
 * 
 * In ifget_FontBBox(), conditionally compiled declaration for "pcleoHdr"
 * based on IF_PCLEOI to resolve compiler error if !PCLEO_RDR.
 * 
 *    Rev 1.12   16 Mar 1993 10:08:40   JOE
 * Corrected function prototype for CGIFcache_purge() if !LINT_ARGS.
 * 
 *    Rev 1.11   12 Mar 1993 10:41:30   JOE
 * In CGIFchar(), if banding a fixed space character, do not tile bitmap.
 * Create bitmap untiled and cache it normally so that metric information
 * is saved.
 * 
 *    Rev 1.10   08 Mar 1993 10:19:26   JOE
 * Do not or "not_init" bit when initializing CGIFinitstate because it is
 * never utilized.
 * 
 *    Rev 1.9   03 Mar 1993 20:01:22   MIKE
 * Made code updates to CGIFbound_box().
 * 
 *    Rev 1.8   26 Feb 1993 13:05:16   JOE
 * In CGIFchar(), if character processed is a fixed space character,
 * cache it instead of returning prematurely.
 * 
 *    Rev 1.7   24 Feb 1993 16:31:04   JOE
 * In CGIFchar(), if BANDING is enabled but not selected, and if rotation is
 * desired, was returning an erroneous error.
 * 
 *    Rev 1.6   12 Feb 1993 13:53:32   JOE
 * VXWorks support.
 * 
 *    Rev 1.5   05 Feb 1993 13:31:56   MIKE
 * Added CGIFbound_bbox(). Also ifget_FontBBox(), psget_FontBBox(); should move
 * these two somewhere else
 * 
 *    Rev 1.4   02 Feb 1993 17:12:34   JOE
 * In CGIFchar(), added support for horizontal banding of tiles.
 * 
 *    Rev 1.3   29 Jan 1993 09:48:36   JOE
 * In CGIFwidth(), saved corresponding em box size for each width in buffer.
 * 
 *    Rev 1.2   21 Dec 1992 15:18:14   ROB
 * Added ANSI function declarations based upon ANSI_DEFS. General cleanup.
 * 
 *    Rev 1.1   11 Dec 1992 15:30:24   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:25:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* cgif.c */
/*
 *
 *  History:
 *  original  awr 
 *  18-May-90 dET add instance handling for MS-WINDOWS
 *  23-Jul-90 awr added Blake's typePath in CGIFconfig()
 *  07-Aug-90 awr in CGIFfont(), free previous FONT if no bitmaps
 *  13-Aug-90 awr added return SUCCESS in CGIFexit to match MULTICALLER
 *                version.
 *  18-Aug-90 awr added making_bold parameter in call to MAKfontSize()
 *                in CGIFchar_size()
 *  24-Aug-90 jfd in CGIFpcleo(), changed "ENTRY UWORD" to "UWORD ENTRY";
 *                in CGIFpcleo(), changed argument to INSTsetState()
 *                from "CallerId" to "uCallerId"
 *  28-Aug-90 dET moved uInitFirstTime and uEnterFirstTime declarations
 *                and reset these upon CGIFexit().
 *  20-Nov-90 dET In CGIFchar_size(), added "UWORD status" for MULTICALLER
 *  03-Dec-90 dET Moved "cgconfig.h" to after "port.h" and before "cgif.h"
 *  19-Dec-90 jfd IFB on a Printer changes:
 *                1.) Keep local copy of font context regardless of CACHE.
 *                2.) In CGIFfont(), store local copy of font context
 *                    regardless of CACHE.
 *                3.) In CGIFwidth(), call IXget_fnt_index() with an
 *                    argument of type (FONTCONTEXT *) regardless of CACHE.
 *                4.) In CGIFkern(), call IXget_fnt_index() with an
 *                    argument of type (FONTCONTEXT *) regardless of CACHE.
 *                5.) In CGIFpcleo(), call IXget_fnt_index() with an
 *                    argument of type (FONTCONTEXT *) regardless of CACHE.
 *                    (double-check this!!!)
 *                6.) Added routine CGIFsegments() after removing it from
 *                    file "segments.c". Had to include "segments.h" and
 *                    "ix.h". In call to IXget_fnt_index(), changed 
 *                    argument from (LONG) to (FONTCONTEXT *).
 *                7.) In CGIFchar() and CGIFchar_size(), commented out
 *                    line "chId -= ss_first_code;"
 *   3 Jan 91 ss  Added ROM support 
 *
 *  16-Jan-91 jfd In CGIFwidth(), when calling MAKchar_width(), pass
 *                "chId" instead of "chId - ss_first_code"
 *  17-Jan-91 awr Removed ERRinvalid_seg_key and moved it into cgif.h
 *  28-Jan-91 jfd Made size args of CGIFchar_size() call
 *                conditional based on (MAX_BM_BITS > 16).
 *                Declared "ccBufferSize" and "cfg->cc_buf_size"
 *                conditionally based on MAX_BM_BITS > 16.
 *  30-Jan-91 dET added prototype function definitions for MSC.
 *  31-Jan-91 dET Modify for MSC multi-model compilation.
 *   3-Feb-91 awr Made size arg to MAKfontSize() a PLONG
 *                changed mem_fund[] to a LONG.
 *                changed cc_size to LONG
 *                Renamed IXnew_ss() to SYMnew() for new module.
 *   5-Feb-91 awr Renamed MAKkern() to kern() for new module.
 *                Renamed MAKchar_width to chwidth for new module.
 *   8-Feb-91 awr Removed FCcopy_fc(), coded in line.
 *                Added dll.h to declare functions.
 *                Moved FNTfree() call in CGIFfont() to start of FNTfind().
 *                Renamed FNTfind() to CACfont().
 *                Added #include "instance.h" to declare multicaller fncts.
 *   9-Feb-91 awr Added #include "sym.h" to declare symbol set fncts.
 *  10-Feb-91 awr Moved making_bold to SCALE structure- removed parameter
 *                in MAKfontSize().
 *  15-Feb-91 awr changed IXfind_bucket() name to BUCKfind()
 *  23-Feb-91 awr Changed bucket sub-segment handles to offsets.
 *  04-Mar-91 jfd In CGIFinitRomInfo(), changed field name pfont_block to
 *                pfnt_index and removed declaration for "status".
 *                Returning SUCCESS in CGIFinitRomInfo() .
 *                Added correct function prototype for CGIFinitRomInfo().
 *  05-Jun-91 jfd Added routine CGIFcache_purge() which will call
 *                CACpurge() to purge the font in the current font 
 *                context and all its associated bitmaps.
 *                (FIX FROM EARLIER VERSION)
 *  10-Jun-91 jfd Added module CGIFps() for PostScript Type 1 output
 *                Made declaration of routine MAKifbmheader() conditional
 *                based on TILE
 *  11-Jun-91 jfd Added declaration for ps_write().
 *  17-Jun-91 jfd Moved "debug.h" after "port.h".
 *                Moved "cgconfig.h" before "port.h".
 *  19-Jun-91 jfd In CGIFps(), changed arguments.
 *                In ps_write(), changed arguments.
 *  21 Jun 91 ss  Moved prototype for fgseg() from ix.h.
 *  02-Jul-91 rs  Modified CGIFkern() to NOT subtract 'first_code' before
 *                calling kern().
 *  02-Jul-91 jfd In CGIFps(), removed "pssize" argument from CGIFps() and
 *                ps_write() functions, and am calling ps_write() conditionally
 *                based on MULTICALLER.
 *  25-Jul-91 jfd Added argument PPARAMSTR to CGIFps() because of unresolved
 *                external when attempting to build DLL.
 *  07-Aug-91 jfd Including "ps_type1.h".
 *                Added GLOBAL declaration for "PSparam_str".
 *                Changed CGIFps() function declaration from GLOBAL UWORD
 *                to UWORD ENTRY
 *  14-Aug-91 jfd Added CGIFtile().
 *  18-Aug-91 awr Added htileBM to keep track of tile bm memory
 *  25-Sep-91 jfd In CGIFcache_purge(), changed argument type from
 *                (FONTCONTEXT *) to PFONTCONTEXT to get rid of compiler 
 *                warning.
 *                Added function prototype for pcleo() to get rid of
 *                compiler warning.
 *  29-Sep-91 awr Added CGIFinitstatus
 *  14-Oct-91 jfd Added function prototype for BUCKfind() if LINT_ARGS to
 *                get rid of compiler warning.
 *   9 Dec 91 ss  Changed function prototype and call to pcleo() to PCLeo()
 *                to match name in pcleo.c.
 *  22-Jan-92 rs  Add support for URIP pointer callable functions. This
 *                includes IF_FUNC_TBL & IF_RAS_TBL structs as well as
 *                changes to CGIFfont().
 *  28-Jan-92 rs  Move font function setup to bucket.c.
 *  04-Feb-92 jfd Conditionally compiled IF_RAS_TBL for PST1I and TT_RDR..
 *  12-Feb-92 jfd In CGIFfont(), if processing a TT or PS font, reset
 *                the pointer to the font header in the current local
 *                font context to force comp_pix() to be called before
 *                processsing the first TT or PS character.
 *  24-Feb-92 jfd In CGIFfont(), conditionally compiled block of code
 *                which calculates "has_path" based on  EXTERN_FONT.
 *                Conditionally compiled declaration for "pathname" based
 *                on EXTERN_FONT.
 *                Conditionally compiled declaration for "bmras_cubeto"
 *                based on EXTERN_FONT.
 *                In CGIFsegments(), changed all occurrences of "b->" to
 *                "b->p.in." due to changes in BUCKET structure.


 *   7-Mar-92 awr Change CGIFfont() to not expect FC_EXTERN_TYPE     
 *  24 Mar 92 ss  Fixed casts in CGIFfont() to eliminate warnings.
 *  03-Apr-92 rs  Portability cleanup (see port.h).
 *  12 May 92 ss  Changed conditional compiles based on EXTERN_FONT to
 *                (PST1I || TT_RDR) since EXTERN_FONT is used
 *                elsewhere to mean PCLEO.
 *  21-May-92 jfd Added outline function table "olras_tbl".
 *                In CGIFfont(), if generating an outline, set "pras" to
 *                outline function table.
 *                Including "outline.h" for outline function prototypes.
 *  21-May-92 rs  Add call to 'cm_load_psname()' to CGIFenter() to load
 *                PostScript name table if enabled.
 *  27 May 92 ss  Changed hard-coded path of psname.cfg to use typePath
 *                given to us via config.c (the application.)
 *  10-Jun-92 jfd In CGIFinit(), changed "MAX_UW16" to "MAX_UWORD".
 *  14-Jun-92 rs  Add error check when calling 'cm_load_psname()'. Add
 *                call to 'cm_free_psname()' in CGIFexit().
 *   4-Jul-92 awr cc_buf_size unconditionally SL32
 *                Conditional fields on IFCONFIG
 *   8 Jul 92 ss  Added code in CGIFfont() to set font_id from pcleo font
 *                header into fontcontext so application doesn't have to.
 *  08-Jul-92 rs  Code cleanup.
 *  13-Jul-92 mby Added conditional code (TT_PCLEOI) to read font number
 *                from TrueType PCLEO. Always read in hi-lo (Motorola) order.
 *  14-Jul-92 rs  Fix CGIFfont() to work w/all PCLEXO's.
 *  21-Jul-92 awr Conditional compile changes.
 *  28-Jul-92 ss  In CGIFfont(), set if_state.has_path = 0
 *                if NON_IF_FONT && ROM are set.
 *  31 Jul 92 ss  Added code in CGIFfont() to map ss_code in PCLEO header to
 *                CG ss_num.
 *  05-Aug-92 jfd In CGIFfont(), copy *fc into fcCur via FCcopy(), which
 *                will zero out destination prior to copying. In addition,
 *                perform this operation prior to CACfont() call. In call
 *                to CACfont(), pass zero-initialized "fcCur" rather than
 *                non-initialized "fc".
 *  14-Aug-92 jfd In CGIFfont(), added check for emboldening when emboldening
 *                is disabled.
 *                In CGIFfont(), if PS pcleo or TT pcleo, when calculating
 *                "pcleo_ssnum", was calling GET_xLONG_OFF instead of
 *                GET_xWORD_OFF.
 *                Added macro GET_xWORD_OFF.
 *  02-Sep-92 jfd No longer calling cm_load_psname() and cm_free_psname().
 *                Replaced by PSdata table in "t1iscan.c".
 *                Removed define for PATH_DELIM.
 *  04-Sep-92 jfd In CGIFkern(), returning error if requesting kern data for
 *                PS or TT input.
 *  11-Sep-92 jfd In CGIFfont(), reset the font id of the fontcontext to
 *                prevent potential problems when switching between FST's.
 *  16-Sep-92 jfd In CGIFkern(), conditionally compiled code following
 *                PS/TT check based on IF_RDR.
 *                Conditionally compiled CGIFpcleo() based on IF_RDR.
 *  30-Sep-92 awr Added CGIFtt_universal()
 *  30-Sep-92 mby CGIFfont() calls SYMnew() with 2nd argument, fc->format.
 *  05-Oct-92 mby Removed GET_xWORD and GET_xLONG macro definitions. They
 *                are already defined in sym.h.
 *  13-Oct-92 mby Fixed incorrect parameter in CGIFtt_universal()
 *  19-Oct-92 mby Changed CGIFinitRomInfo() -- symbol set pointer (2nd
 *                argument) is an array, may point to IF symbol set block,
 *                TT symbol set block, or both.
 *  21-Oct-92 mby Include "cgmacros.h" for GET_x...() macros.
 *  21-Oct-92 rs  Fix CGIFtt_universal declarations for Windows.
 *  26-Oct-92 jfd Changed first arg of call to PCLeo2IF() from LPUW16
 *                tp PFONTCONTEXT to match actual function.
 *  21-Dec-92 rs  Add ANSI function declarations based on ANSI_DEFS.
 *  28-Jan-93 jfd In CGIFwidth(), store em box size after each width in
 *                buffer.
 *  01-Feb-93 jfd In CGIFchar(), added support for caching of horizontal
 *                bands.
 *  04-Feb-93 mby Added CGIFbound_box(), ifget_FontBBox(), psget_FontBBox()
 *                 -- should move the last two somewhere else.
 *  08-Feb-93 jfd VXWorks support.
 *  24-Feb-93 jfd In CGIFchar(), if BANDING is enabled but not requested,
 *                and if rotation is requested, was incorrectly returning
 *                "ERR_invalid_band" error.
 *  26-Feb-93 jfd In CGIFchar(), if character processed was a fixed space
 *                character, cache it to save metrics information. (Had
 *                been returning ERR_fixed space without caching.)
 *  03-Mar-93 mby Removed PFONTCONTEXT argument from CGIFbound_box().
 *                Instead of passing font context, use fcCur.
 *                Conditionally compile ps- and ifget_FontBBox().
 *                For IF PCLEO, grab bbox from header.
 *  08-Mar-93 jfd When initializing CGIFinitstate, no longer or'ing 
 *                "not_init" because it is not utilized.
 *  12-Mar-93 jfd In CGIFchar(), if banding a fixed space character,
 *                do not return prematurely after call to CGIFbmheader().
 *                Instead, give up attempt to tile character and create
 *                bitmap normally. Then cache it so that metric information
 *                is returned.
 *  16-Mar-93 jfd Corrected function prototype for CGIFcache_purge() if
 *                !LINT_ARGS.
 *  17-Mar-93 jfd In CGIFchar(), if banding a PS or TT space character which
 *                exists in the font or pcleo, CGIFbmheader() will not
 *                return "ERR_fixed_space". So to check for space, test
 *                for "if_state.num_loops == 0" to avoid calling CGIFtile().
 *                In ifget_FontBBox(), conditionally compiled declaration 
 *                for "pcleoHdr" based on IF_PCLEOI to resolve compiler
 *                error if !PCLEO_RDR
 *  01-Apr-93 mby/jwd Revised calling sequence of CGIFbound_box, to alleviate
 *                compilation anomalies generated with MS-C 6.0.
 *  21-Apr-93 mby Moved ifget_FontBBox() => fm.c. Conditionally compile
 *                TTplugin structure.
 *  05-May-93 mby Replace CGIFcache_purge() with CGIFfont_purge().
 *                CGIFcache_purge() is a macro.
 *                In CGIFfont() change has_path condition from NON_IF_FONT to
 *                PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)
 *                Set has_path if dynamic font and IF disk.
 *  06-May-93 mby In CGIFfont_purge() put conditional around fc->font_hdr=0;
 *  14-May-93 jd  Conditionally compiled "pathname" based on
 *                (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)) to
 *                resolve compiler error.
 *  09-Jun-93 jfd Changed all references to "char" to "SB8" for
 *                transportability.
 *  14-Jun-93 mby Added IF PCLEO support for font bounding box. New interface
 *                routine CGIFbbox_IFPCLEOchar().
 *                Added xx_FLUFF constants for CGIFbound_box().
 *                Did some reorganization of CGIFbound_box().
 *  13-Jul-93 mby Added badCharList argument to CGIFbbox_IFPCLEOchar().
 *  15-Jul-93 mby Disabled CGIFkern(), width, bound_box, font_purge,
 *                segments, pcleo, & CGIFps() with Convergent Fonts.
 *  15-Jul-93 rs  Make externs for CGIFfont_purge() not be conditionalized
 *                for CACHE. Fix problem when PSEO is purged but next time
 *                through, comp_pix does not process properly by zeroing
 *                the if_state copy of the fontcontext.
 *  28-Jul-93 awr Changed CGIFchar_size() for non-zero winding
 *  02-Aug-93 maib Changed interface to prevent CGIFxxx() routines from calling
 *                other CGIFxxx() routines, required for multi-tasking. also
 *                added multicaller support code to CGIFxxx() routines
 *  03-Aug-93 maib changed definitions for cgifXXXX() routines to resolve
 *                naming conflicts
 *  13-Aug-93 mby Replaced 2 printfs in CGIFchar() with DBG1's.
 *  24-Aug-93 jfd In cgif_Font(), if symbol set is set to special encoding
 *                array value, do not call PCLeo2IF_ssnum() or SYMnew().
 *  02-Sep-93 jfd Changed function declaration for psget_FontBBox() to
 *                include both ANSI and non-ANSI formats to resolve
 *                compiler error.
 *  16-Sep-93 maib Changed CGIFchar() to support banding of alien bitmaps
 *  22-Sep-93 mby Changed cgif_Font(): to handle ROM1; do better error
 *                checking for PCLEOs. Clean up bbox code; start implementation
 *                for convergent fonts (doesn't work yet!).
 *  24-Sep-93 jfd In MULTICALLER version of CGIFenter(), if !SEM_ACCESS,
 *                if "uEnterFirstTime" is FALSE, "status" is returned as
 *                an ambiguous value. Initializing "status" to SUCCESS at 
 *                start of routine.
 *  29-Sep-93 maib Semaphore was not being released for all cases, fixed it
 *  29-Sep-93 jfd Added support for PS bounding box.
 *  30-Sep-93 mby Optimize cgif_Font() by branching around ROM1 code if font
 *                type is external.
 *                Implement CGIFwidth() for CONVERGENT_FONTS.
 *  05-Oct-93 mby Implement CGIFbound_box() for CONVERGENT_FONTS. Update
 *                IFplugin and TTplugin statics for various plugin options.
 *  08-Oct-93 jfd In CGIFchar(), if requesting a fixed space character which
 *                has already been cached, "status" is not being set to
 *                ERR_fixed_space. Check for fixed space character and
 *                set "status" to ERR_fixed_space if necessary.
 *  12-Oct-93 maib Put ansi defs around bbox_union
 *  25-Oct-93 maib Optimized cache access by placing all required CACaccess 
 *                code inline in CGIFchar
 *  26-Oct-93 mby Removed redundant code in CGIFwidth().
 *  01-Nov-93 maib Declared fcCur global for reference in instance.c
 *  05-Nov-93 mby/rk  Check get_awt_bbox() for status value.
 *  23-Nov-93 maib Added prototypes missing in multi-caller section for
 *                 fontbbox enabled functions
 *  06-Dec-93 jfd  In cgif_Font(), added calls to get_ttDISK_ids() and
 *                 get_ttROM_ids() to retrieve platform and specific IDs 
 *                 from KANJI TT font.
 *                 Including "kanji.h".
 *  14-Dec-93 mby  Set IF_FLUFF, TT_FLUFF, PS_FLUFF constants to 1 for
 *                 CGIFbound_box().
 *  04-Jan-94 jwd Modified CGIFchar_size() to return the size of the largest 
 *                compound character part, for the cc_buf_size in the IFCONFIG
 *                structure. Will be returned in size[3].
 *  05-Jan-94 jfd  In cgif_Config(), added check for bitmap width compatability
 *                 with setting of RASTER_ORG.
 *  05-Jan-94 maib Modified handling of alien bitmaps, allowing alien bitmaps
 *                 and UFST generated bitmaps to be produced at application's
 *                 discression
 *  05-Jan-94 rs   Add support for "GB" encoding.
 *  06-Jan-94 maib Fixed bug in banding alien bitmaps
 *  25-Jan-94 maib Included new cache accessing scheme for ASIAN_ENCODING
 *  27-Jan-94 mby  Minor changes in CGIFwidth() for Convergent Fonts.
 *  03-Feb-94 jfd  In CGIFsegments(), if DYNAMIC_FONTS is enabled, treat
 *                 "tfnum" argument as a pathname rather than a typeface 
 *                 number. This will allow CGIFsegments() to return segment
 *                 data without CGIFfont() having to be called.
 *  06-Mar-94 mby  Changes to CGIFbound_box() for Convergent Fonts for AWT4
 *                 format support.
 *  25-Mar-94 jfd  In CGIFwidth(), if processing CONVERGENT_FONTS, set 
 *                 "if_state.alt_width" = 0 before calling CVFget_fnt_index()
 *                 so that chwidth() will get called if there is no entry in 
 *                 the alternate width table.
 *  20-Apr-94 jfd  Changed the way CGIFsegments() interprets the "tfnum"
 *                 argument. Instead of basing it on DYNAMIC_FONTS, it now
 *                 checks for SEGACCESS = 1 or 2 as well as DYNAMIC_FONTS.
 *  25-Apr-94 mby  For font bounding bbox, changed IFplugin structure->xmax
 *                 from 8782 to 9631 to reflect new "plugin.cfp" plugin file.
 *  05-May-94 mby  In cgif_Font(), set "if_state.awtsub_on" if the awt pointer
 *                 for Convergent Fonts is set. This fixes a bug in CGIFbound_box()
 *                 where awtsub_on was not getting set, affecting the computation
 *                 of the font matrix in comp_pix() for obliqued conv. fonts.
 *                 Also fixed code in CGIFwidth() that uses awtsub_on.
 *  03-Jun-94 jfd  Changed all occurrences of ENTRY to CGENTRY to resolve
 *                 conflict on some compilers.
 *  06-Jun-94 mby  In cgif_Font() 'useMapping' = false if sym set = 0x8000.
 *                 Affects PCLETTOs with downloaded symbol set.
 *                 If useMapping is 0 call SYMnoMap().
 *  14-Jun-94 mby  For foreign bitmaps (CGIFfont) - set 'has_path' to 0;
 *                 do not call SYMnew or SYMnoMap.
 *  01-Jul-94 mby  In cgif_Font(), change call to PCLeo2IF_ssnum to use
 *                 additional argument - to fix fc->ssnum bug.
 *  12-Jul-94 jfd  In CGIFbound_box(), was not setting if_state.awtsub_on 
 *                 based on fcCur.p_AltWidTab. This was causing a problem
 *                 if switching between convergent and non-convergent fonts
 *                 for multiple threads.
 *  13-Jul-94 jfd  In CGIFwidth(), set if_state.awtsub_on based on
 *                 fcCur.p_AltWidTab to avoid potential problem that could
 *                 be caused when switching between conv. and non-conv.
 *                 fonts for multiple threads.
 *  14-Jul-94 mby  Corrections to 7-01-94 change: fcCur.ssnum = pcleo_ssnum
 *                 only if external font and useMapping are true. Also when
 *                 cgif_Font() calls SYMnew() and SYMnoMap(), the arguments
 *                 should use fcCur, not fc.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.48.1.2:
 *  14-Mar-94 mby  Added FCO option to CGIFbound_box().  Added CGIFfco_Init().
 *                 In cgif_Font(), replace nonIF font test with TT || PST1;
 *                 set if_state.has_path to 0 for FCO_RDR.
 *  26-May-94 mby  Changed CGIFfco_Init() to CGIFfco_Open().
 *                 Added CGIFfco_Close(), CGIFtt_Generate(), CGIFtt_Free().
 *                 Modified CGIFenter(), CGIFexit(), CGIFbound_box().
 *                 CGIFfont() stores FCO handle in if_state.FCObject.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  18-Aug-94 jfd  Changed arg 2 of CGIFfco_Open() from 'int *' to
 *                 'LPSW16' due to WINDOWS.
 *  22-Aug-94 jfd  Changed args 1 and 2 of CGIFtt_Generate() ('int *'
 *                 --> 'LPSW16', 'LPUB8 *' --> 'LPLPUB8' for WINDOWS.
 *  02-Sep-94 mby  Added CGIFfco_Plugin().
 *  08-Sep-94 mby  Cleanup in CGIFwidth(), -kern() to support FCO only.
 *  11-Sep-94 jfd  Added new function CGIFhdr_font_purge().
 *  15-Sep-94 jfd  In function prototypes and function declarations for
 *                 CGIFhdr_font_purge(), changed ENTRY to CGENTRY.
 *                 Changed function prototypes for CAChdr_purge() from 
 *                 "UW16 CGENTRY" to "EXTERN UW16".
 *                 Removed function prototype for CAChdr_font().
 *                 Moved prototype for CGIFhdr_font_purge() so that it is
 *                 not conditionally compiled based on CACHE.
 *  20-Sep-94 rs   Modified CGIFinit() so that when running Windows DLL,
 *                 'CGIFinitstate' will be initialized each time (instead
 *                 of by compiler).
 *  26-Sep-94 mby  Changed CGIFfco_Open to copy int* pointer to LPSW16 pointer
 *                 before returning. Valid handles are in the range 0 - 7FFF.
 *                 If CGIFfco_Open returns an error, handle is set to 0xFFFF.
 *  06-Oct-94 mby/jfd
 *                 In cgif_Font(), set "if_state.cur_loc_fc.font_hdr = 0"
 *                 always to resolve fontcontext matching problem.
 *  11-Oct-94 SBM  In CGIFexit, added check for !FCO_RDR.
 *  18-Oct-94 mby  In CGIFbound_box() clear "chr_def_hdr.mirror_flags" to avoid
 *                 mirroring the matrix. Set "if_state.cur_loc_fc.font_id"
 *                 and ".font_hdr" to 0 to disable fontcontext matching.
 *                 Changed argument of CGIFfco_Close(), CGIFfco_Plugin()
 *                 from "int" to "SW16" for compatibility with CGIFfco_Open().
 *  20-Oct-94 mby  Changed argument of CGIFtt_Free() from "int" to "SW16".
 *  21-Oct-94 jfd  In CGIFexit(), changed the way "CGIFinitstate" is tested
 *                 based on IF_RDR to resolve memory leakage problem.
 *  14-Dec-94 rs   Changed arg 2 of CGIFtt_Generate() from LPLPUB8
 *                 to LPHPUB8.
 *  14-Dec-94 jwd  Added support for MULTICALLER in FCO related functions; 
 *                 Removed MULTICALLER dependency from CAChdr_purge 
 *                 prototype.
 *  17-Dec-94 mby/jc Fixed scale factor in CGIFbound_box() for FC_FCO_TYPE.
 *  06-Jan-95 SBM  Added new arg ttgenFlg, to CGIFtt_Generate.
 *  16-Feb-95 jfd  Corrected prototype for CGIFtt_Generate() based on
 *                 HUGE_PTR_SUPPORT.
 *  24-Mar-95 SBM  Modified CGIFtt_free to use a Ptr instead of a MEM_HANDLE.
 *  31-Mar-95 jwd  Added support for CGIFfco_Access(). Interface routine will
 *                 extract specific FCO related information based on application
 *                 needs.
 *  10-Apr-95 mby  Conditionally compiled CGIFfco_Access().
 *  18-Apr-95 jfd  In cgif_Font(), added support for the removal of
 *                 symbol set mapping.
 *                 Added new function CGIFchIdptr().
 *                 In cgif_Font(), conditionally compiled calls to SYMnew() 
 *                 and PCLeo2IF_ssnum() based on !NO_SYMSET_MAPPING.
 *  24-May-95 mby  Changed CGIFbound_box() to search FCO plugins through a
 *                 call to fco_get_FontBBox() if FCO_RDR is enabled. Fixed
 *                 division by wrong 'fScale' value.
 *                 In CGIFfco_Plugin() and CGIFfco_Close() added release_semaphor()
 *                 call before exiting.
 *                 From rk - in CGIFwidth() return width of 0x7FFF if charcode
 *                 is out of range (first_chid loop).
 *  27-Jun-95 mby  Fixed bug - CGIFbound_box(): "if_state.x.pixel_size" was
 *                 being used before call to comp_pix().
 *  13-Jul-95 mby  Conditionally compile CGIFsegments() only if IF_RDR=1.
 *  18-Jul-95 mby  In CGIFfont_purge(), CGIFhdr_font_purge(), remove code
 *                 that changes the app's fc->font_id and fc->font_hdr.
 *                 Instead, clear the fcCur copy of the fontcontext.
 *  28-Jul-95 jwd  Initialized the local sizing value lsize[3] in the 
 *                 routine CGIFchar_size(), in order to correct improper
 *                 size values being placed into members not specifically
 *                 filled by UFST/MicroType. Also added release_semaphore call
 *                 to CGIFtt_Free() before exit.
 *  02-Aug-95 mby  In CGIFbound_box(), increased FCO fluff factor to 4 in X;
 *                 to 2 in Y.
 *  04-Aug-95 jc   In CGIFfco_access(), corrected args - psize and pbuffer
 *                 (misspelling).
 *                 Changed fco y fluff from 2 to 5, because of the perthousand
 *                 character.
 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <stdlib.h>/* JJG for _for _MAX_PATH*/
#include <string.h>
#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#if PST1
#include "ps_type1.h"
#endif
#include "cgif.h"
#include "cache.h"
#include "sym.h"
#include "segments.h"
#include "ix.h"
#include "dll.h"
#if MULTICALLER
#include "instance.h"
#endif
#include "if_type.h"
#include "cgmacros.h"
#if defined( LAMIGA ) || defined (__i960) || defined(VXWORKS)
#include <stdlib.h>
#include <sys/types.h>
#elif defined (MACINTOSH)
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#if FONTBBOX
#include "fpmath.h"
#endif  /* FONTBBOX */

#if PCLEO_RDR
#include "pcleo.h"

#define GET_LONG( destp, srcp )   memcpy( (SB8 *)(destp), (SB8 *)(srcp), 4 );
#define GET_WORD( destp, srcp )   memcpy( (SB8 *)(destp), (SB8 *)(srcp), 2 );
#endif /* PCLEO_RDR */

#if TT_ROM1
#include "ttroment.h"
#endif 

#if ASIAN_ENCODING
#include "kanji.h"
#endif

#ifdef LINT_ARGS
#if !MULTICALLER
UW16 CGENTRY CGIFinit(VOID);
GLOBAL UW16 cgif_Config (PIFCONFIG);
UW16 CGENTRY CGIFconfig (PIFCONFIG);
UW16  CGENTRY CGIFenter (VOID);
UW16  CGENTRY CGIFexit (VOID);
GLOBAL UW16 cgif_Font (PFONTCONTEXT);
UW16 CGENTRY CGIFfont (PFONTCONTEXT);
UW16 CGENTRY Meto_CGIFfont (PFONTCONTEXT); /* for Meot use 6-24-97 jqz */ 
#if CHAR_HANDLE
GLOBAL UW16 cgif_Char_Handle (UW16, PHIFBITMAP, SW16);
UW16 CGENTRY CGIFchar_handle (UW16, PHIFBITMAP, SW16);
#endif
#if CACHE
UW16 CGENTRY CGIFchar (UW16, PPIFBITMAP, SW16);
#endif
#if TILE
GLOBAL UW16 cgif_BMHeader (UW16, PIFBITMAP, SW16);
UW16 CGENTRY CGIFbmheader (UW16, PIFBITMAP, SW16);
#if CHAR_HANDLE
UW16 CGENTRY CGIFtile_handle (PIFTILE, PHIFBITMAP);
#endif
#if CACHE
GLOBAL UW16 cgif_Tile (PIFTILE, PPIFBITMAP);
UW16 CGENTRY CGIFtile (PIFTILE, PPIFBITMAP);
#endif
#endif /* TILE */
#if WIDTHS
UW16 CGENTRY CGIFwidth (UW16, UW16, UW16, LPUW16);
#endif  /* WIDTHS */
#if KERN
GLOBAL UW16 cgif_Kern (UW16, UW16, PKERN_PAIR);
UW16 CGENTRY CGIFkern (UW16, UW16, PKERN_PAIR);
#endif
#if PCLEO && IF_RDR
UW16 CGENTRY CGIFpcleo (LPSB8, LPUL32);
#endif
#if PST1
UW16 CGENTRY CGIFps (PPSPARAMSTR);
EXTERN UW16    ps_write(VOID);
#endif /* PST1 */
#if FONTBBOX
UW16 CGENTRY CGIFbound_box( int* );
#if IF_PCLEOI
UW16 CGENTRY CGIFbbox_IFPCLEOchar( LPUB8, LPUB8, LPUW16 );
MLOCAL VOID bbox_SimpleChar( LPUB8, LPSW16, LPSW16, LPSW16, LPSW16 );
EXTERN LPUB8 PCLEO_charptr( LPUB8, UW16 );
#endif  /* IF_PCLEOI */
#endif  /* FONTBBOX */
#if SEGACCESS
UW16 CGENTRY CGIFsegments (SL32, UW16, LPUW16, LPSB8);
#endif
#if ROM
GLOBAL SW16     CGIFinitRomInfo(LPUB8, LPUB8[]);
#endif  /* ROM */
UW16 CGENTRY CGIFfont_purge (PFONTCONTEXT);
#if TT_TTPLUG
GLOBAL UW16 CGENTRY CGIFtt_universal(LPUB8, int);
#endif  /* TT_TTPLUG */
#if FCO_RDR
GLOBAL UW16 CGENTRY CGIFfco_Open( LPUB8, LPSW16 );
GLOBAL UW16 CGENTRY CGIFfco_Close( SW16 );
GLOBAL UW16 CGENTRY CGIFfco_Plugin( SW16 );
#if FCOACCESS
GLOBAL UW16 CGENTRY CGIFfco_Access( LPUB8, UW16, UW16, LPUW16, LPSB8 );
#endif /* FCOACCESS */
#if HUGE_PTR_SUPPORT
GLOBAL UW16 CGENTRY CGIFtt_Generate( UW16, LPSW16, LPHPUB8, LPUL32 );
#else
GLOBAL UW16 CGENTRY CGIFtt_Generate( UW16, LPSW16, LPLPUB8, LPUL32 );
#endif
GLOBAL UW16 CGENTRY CGIFtt_Free( LPSB8 );
#endif

UW16 CGENTRY CGIFhdr_font_purge (PFONTCONTEXT);
#if CACHE
EXTERN UW16  CAChdr_purge (PFONTCONTEXT);
#endif

#if NO_SYMSET_MAPPING
GLOBAL UW16 CGENTRY CGIFchIdptr( VOID *, VOID * );
#endif /* NO_SYMSET_MAPPING */
#else /* MULTICALLER */
UW16 CGENTRY CGIFinit (LPUW16, LPUL32, LPUL32);
GLOBAL UW16 cgif_Config (PIFCONFIG);
UW16 CGENTRY CGIFconfig (UW16, PIFCONFIG);
UW16  CGENTRY CGIFenter (UW16);
UW16 CGENTRY CGIFexit (UW16);
GLOBAL UW16 cgif_Font (PFONTCONTEXT);
UW16 CGENTRY CGIFfont (UW16, PFONTCONTEXT);
UW16 CGENTRY Meto_CGIFfont (UW16, PFONTCONTEXT); /* for Meot use 6-24-97 jqz */ 

#if CHAR_HANDLE
GLOBAL UW16 cgif_Char_Handle (UW16, PHIFBITMAP, SW16);
UW16 CGENTRY CGIFchar_handle (UW16, UW16, PHIFBITMAP, SW16);
#endif
#if CACHE
UW16 CGENTRY CGIFchar (UW16, UW16, PPIFBITMAP, SW16);
#endif
#if CHAR_SIZE
#if (MAX_BM_BITS > 16)
UW16  CGENTRY CGIFchar_size (UW16, UW16, LPSL32, SW16);
#else
UW16  CGENTRY CGIFchar_size (UW16, UW16, LPUW16, SW16);
#endif
#endif /* CHAR_SIZE */
#if TILE
GLOBAL UW16 cgif_BMHeader (UW16, PIFBITMAP, SW16);
UW16 CGENTRY CGIFbmheader (UW16, UW16, PIFBITMAP, SW16);
#if CHAR_HANDLE
UW16 CGENTRY CGIFtile_handle (UW16, PIFTILE, PHIFBITMAP);

#endif
#if CACHE
GLOBAL UW16 cgif_Tile (PIFTILE, PPIFBITMAP);
UW16 CGENTRY CGIFtile (UW16, PIFTILE, PPIFBITMAP);
#endif
#endif /* TILE */
#if WIDTHS
UW16 CGENTRY CGIFwidth (UW16, UW16, UW16, UW16, LPUW16);
#endif
#if KERN
GLOBAL UW16 cgif_Kern (UW16, UW16, PKERN_PAIR);
UW16 CGENTRY CGIFkern (UW16, UW16, UW16, PKERN_PAIR);
#endif
#if PCLEO && IF_RDR
UW16 CGENTRY CGIFpcleo (UW16, LPSB8, LPUL32);
#endif
#if PST1
UW16 CGENTRY CGIFps (UW16, PPSPARAMSTR);
EXTERN UW16    ps_write(UW16);
#endif /* PST1 */
#if FONTBBOX
UW16 CGENTRY CGIFbound_box( UW16, int* );
#if IF_PCLEOI
UW16 CGENTRY CGIFbbox_IFPCLEOchar( UW16, LPUB8, LPUB8, LPUW16 );
MLOCAL VOID bbox_SimpleChar( LPUB8, LPSW16, LPSW16, LPSW16, LPSW16 );
EXTERN LPUB8 PCLEO_charptr( LPUB8, UW16 );
#endif /* IF_PCLEOI */
#endif /* FONTBBOX */
#if SEGACCESS
UW16 CGENTRY CGIFsegments (UW16, SL32, UW16, LPUW16, LPSB8);
#endif
#if ROM
GLOBAL SW16 CGIFinitRomInfo(UW16, LPUB8, LPUB8[]);
#endif  /* ROM */
UW16 CGENTRY CGIFfont_purge (UW16, PFONTCONTEXT);
#if TT_TTPLUG
GLOBAL UW16 CGENTRY CGIFtt_universal(UW16, LPUB8, int);
#endif  /* TT_TTPLUG */
#if FCO_RDR
GLOBAL UW16 CGENTRY CGIFfco_Open(UW16, LPUB8, LPSW16);
GLOBAL UW16 CGENTRY CGIFfco_Close(UW16, SW16);
GLOBAL UW16 CGENTRY CGIFfco_Plugin(UW16, SW16);
#if FCOACCESS
GLOBAL UW16 CGENTRY CGIFfco_Access( UW16, LPUB8, UW16, UW16, LPUW16, LPSB8);
#endif /* FCOACCESS */
#if HUGE_PTR_SUPPORT
GLOBAL UW16 CGENTRY CGIFtt_Generate( UW16, UW16, LPSW16, LPHPUB8, LPUL32 );
#else
GLOBAL UW16 CGENTRY CGIFtt_Generate( UW16, UW16, LPSW16, LPLPUB8, LPUL32 );
#endif
GLOBAL UW16 CGENTRY CGIFtt_Free(UW16, LPSB8);
#endif

UW16 CGENTRY CGIFhdr_font_purge (UW16, PFONTCONTEXT);
#if CACHE
EXTERN UW16  CAChdr_purge (PFONTCONTEXT);
#endif

#if NO_SYMSET_MAPPING
GLOBAL UW16 CGENTRY CGIFchIdptr( UW16, VOID *, VOID * );
#endif /* NO_SYMSET_MAPPING */
#endif /* MULTICALLER */

#if PCLEO && IF_RDR
EXTERN UW16 PCLeo(LPSB8, LPUL32, SL32);
#endif

EXTERN UW16    makechar(PFONTCONTEXT, SW16, PHIFBITMAP);
EXTERN UW16    BUCKfind(int, int, PPBUCKET);
EXTERN UW16    MAKfontSize(PFONTCONTEXT, SW16, LPSL32);
/*  fm.c  */
EXTERN LPSB8         fgseg(PBUCKET);

#if PCLEO_RDR && !NO_SYMSET_MAPPING
/* pcleoutl.c */
EXTERN UW16    PCLeo2IF_ssnum( PFONTCONTEXT, UW16, LPUW16 );
#endif /* PCLEO_RDR && !NO_SYMSET_MAPPING */

#if TILE  
EXTERN UW16    MAKifbmheader(PFONTCONTEXT, SW16, PIFBITMAP);
EXTERN UW16    bitmap_tile(PIFTILE, PHIFBITMAP);
#endif  /* 06-10-91 jfd */
EXTERN UW16    chwidth(UW16);

EXTERN SW16     kern(UW16,UW16,UW16);

/* fc.c */
EXTERN VOID  FCcopy(PFONTCONTEXT, PFONTCONTEXT);
/* bucket.c */
#if TT_TTPLUG              /*  Using TrueType Universal plugin  */
EXTERN UW16  set_tt_universal (LPUB8, int);
#endif

#if (PST1_RDR && FONTBBOX)
GLOBAL UW16  psget_FontBBox( PBUCKET, BBoxRes* );
#endif

#if CONVERGENT_FONTS
EXTERN UW16 CVFget_fnt_index( PFONTCONTEXT fc, UW16 chId, int b, LPSW16 width);
#endif

#if ASIAN_ENCODING
#if TT_DISK
EXTERN UW16       get_ttDISK_ids(LPUW16, LPUW16, LPSB8);
#endif
#if TT_ROM
EXTERN UW16       get_ttROM_ids(LPUW16, LPUW16, LPUB8);
#endif
#endif /* ASIAN_ENCODING */

#if FCO_RDR
EXTERN UW16  FCOinit( VOID );
EXTERN UW16  FCOexit( VOID );
EXTERN UW16  fco_InitFCO( int*, LPUB8 );
EXTERN UW16  fco_DeleteFCO( int );
EXTERN UW16  fco_saveHndl( int );
EXTERN UW16  fco_ttCreate( UW16, PBUCKET, int*, LPUB8*, LPUL32 );
EXTERN UW16  fco_ttDestroy( int );
EXTERN UW16  fco_GetMemHandle( int, PMEM_HANDLE );
#if FCOACCESS
EXTERN UW16  fco_Access( LPUB8, UW16, UW16, LPUW16, LPSB8 );
#endif /* FCOACCESS */
#endif

#else   /*  not LINTARGS  */
UW16 CGENTRY CGIFinit();
GLOBAL UW16 cgif_Config ();
UW16 CGENTRY CGIFconfig ();
UW16  CGENTRY CGIFenter ();
UW16  CGENTRY CGIFexit ();
GLOBAL UW16 cgif_Font();
UW16 CGENTRY CGIFfont();
#if CHAR_HANDLE
GLOBAL UW16 cgif_Char_Handle ();
UW16 CGENTRY CGIFchar_handle ();
#endif
#if CACHE
UW16 CGENTRY CGIFchar ();
#endif
#if CHAR_SIZE
UW16  CGENTRY CGIFchar_size ();
#endif
#if TILE
GLOBAL UW16 cgif_BMHeader ();
UW16 CGENTRY CGIFbmheader ();
#if CHAR_HANDLE
UW16 CGENTRY CGIFtile_handle ();
#endif
#if CACHE
GLOBAL UW16 cgif_Tile ();
UW16 CGENTRY CGIFtile ();
#endif
#endif /* TILE */
#if WIDTHS
UW16 CGENTRY CGIFwidth ();
#endif
#if KERN
GLOBAL UW16 cgif_Kern ();
UW16 CGENTRY CGIFkern ();
#endif
#if FONTBBOX
UW16 CGENTRY CGIFbound_box();
#if IF_PCLEOI
UW16 CGENTRY CGIFbbox_IFPCLEOchar();
MLOCAL VOID bbox_SimpleChar();
EXTERN LPUB8 PCLEO_charptr();
#endif  /* IF_PCLEOI */
#endif  /* FONTBBOX  */

#if SEGACCESS
UW16 CGENTRY CGIFsegments ();
#endif
#if PCLEO && IF_RDR
UW16 CGENTRY CGIFpcleo ();
#endif /* PCLEO && IF_RDR */
UW16 CGENTRY CGIFfont_purge ();

EXTERN UW16    makechar();                  /* make a chracter IFBITMAP */
EXTERN UW16    BUCKfind();
EXTERN UW16    MAKfontSize();
/*  fm.c  */
EXTERN LPSB8    fgseg();

#if PCLEO_RDR && !NO_SYMSET_MAPPING
/* pcleoutl.c */
EXTERN UW16    PCLeo2IF_ssnum();
#endif /* PCLEO_RDR && !NO_SYMSET_MAPPING */

#if TILE
EXTERN UW16    MAKifbmheader();
EXTERN UW16    bitmap_tile();
#endif
EXTERN UW16    chwidth();
EXTERN SW16     kern();
#if ROM
GLOBAL SW16     CGIFinitRomInfo ();
#endif  /* ROM */
#if TT_TTPLUG
GLOBAL UW16     CGIFtt_universal();
#endif  /* TT_TTPLUG */
#if FCO_RDR
UW16 CGENTRY CGIFfco_Open();
UW16 CGENTRY CGIFfco_Close();
UW16 CGENTRY CGIFfco_Plugin();
#if FCOACCESS
UW16 CGENTRY CGIFfco_Access();
#endif /* FCOACCESS */
UW16 CGENTRY CGIFtt_Generate();
UW16 CGENTRY CGIFtt_Free();
EXTERN UW16  FCOinit();
EXTERN UW16  FCOexit();
EXTERN UW16  fco_InitFCO();
EXTERN UW16  fco_DeleteFCO();
EXTERN UW16  fco_ttCreate();
EXTERN UW16  fco_ttDestroy();
EXTERN UW16  fco_GetMemHandle();
EXTERN UW16  fco_saveHndl();
#if FCOACCESS
EXTERN UW16  fco_Access();
#endif /* FCOACCESS */
#endif /* FCO_RDR   */
#if PST1
UW16 CGENTRY CGIFps ();
EXTERN UW16    ps_write();
#endif /* PST1 */

EXTERN VOID    FCcopy();
#if PCLEO && IF_RDR
EXTERN UW16 PCLeo(LPSB8, LPUL32, SL32);
#endif
#if TT_TTPLUG              /*  Using TrueType Universal plugin  */
EXTERN UW16    set_tt_universal();
#endif

#if (PST1_RDR && FONTBBOX)
GLOBAL UW16  psget_FontBBox();
#endif

#if CONVERGENT_FONTS
EXTERN UW16 CVFget_fnt_index();
#endif

#if ASIAN_ENCODING
#if TT_DISK
EXTERN UW16       get_ttDISK_ids();
#endif
#if TT_ROM
EXTERN UW16       get_ttROM_ids();
#endif
#endif /* ASIAN_ENCODING */

UW16 CGENTRY CGIFhdr_font_purge ();
#if CACHE
EXTERN UW16  CAChdr_purge ();
#endif

#if NO_SYMSET_MAPPING
GLOBAL UW16 CGENTRY CGIFchIdptr();
#endif /* NO_SYMSET_MAPPING */
#endif /* LINT_ARGS */


/*------------- E x t e r n a l   G l o b a l s---------------*/
EXTERN SYMBOLSET symbolset;
#if SLIM_FONTS
EXTERN CHR_DEF_HDR chr_def_hdr;   /* flags used to describe mirroring */
#endif
#if CONVERGENT_FONTS
EXTERN AWT_TABLE awtData;
#endif

/* mem.c    */
EXTERN SL32    mem_fund[];            /* Total memory managed by mem.c  */
/* cache.c   */
EXTERN UW16    max_char_size;   /* max cached character bitmap size */
/* ix.c     */
EXTERN FONTINDEX fontindex;
EXTERN UW16    max_open_files;
EXTERN SB8     libPath[];
EXTERN SB8     ufstPath[];
EXTERN SB8     typePath[];


#if CHAR_SIZE
GLOBAL LPUB8    cc_buf;          /* compound character buffer        */
GLOBAL SL32     cc_size;         /* size of comp. char. buffer       */
#endif

EXTERN IF_STATE if_state;



#if PST1
GLOBAL  PSPARAMSTR  PSparam_str;
#endif

#if PST1_RDR
GLOBAL UW16 Meto_encodearray ;  /* for Meot use 6-24-97 jqz */ 
GLOBAL UW16 cache_Meto_font; /*keb*/
MLOCAL UW16 Meto_get_status(UW16, PPIFBITMAP,  PHIFBITMAP); /* for Meot use 6-24-97 jqz */ 
MLOCAL SB8 Meto_last_font[PATHNAMELEN];
#endif

/*-----------------------------------------*/
/*
 * 11/1/93 maib
 * this file's copy of fontcontext must be updated when an
 * instance is switched in
 */
GLOBAL  FONTCONTEXT fcCur;      /* current FONTCONTEXT */

#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
MLOCAL  PATHNAME    pathname;
#endif



#if CACHE
GLOBAL  UW16  CGIFinitstate = not_buf | not_cac | not_intellifont;
#else
GLOBAL  UW16  CGIFinitstate = not_buf | not_intellifont;
#endif


/*-----------------------------------------*/

/*-----------------------------------------*/
#if MULTICALLER
EXTERN  SB8  *ccBuffer;           /* buffer pointer for comp-char buffer */
EXTERN  UW16  uLastCallerId;              /* an initial value */
MLOCAL  BOOLEAN uInitFirstTime  = TRUE;    /* TRUE == need to init system */
MLOCAL  BOOLEAN uEnterFirstTime = TRUE;    /* TRUE == need to init cache  */
#endif  
   

/*----------------*/
/*  CGIFinit      */
/*----------------*/
/*
This function initializes the memory manager.
*/


#if !MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFinit()
#else
UW16 CGENTRY
CGIFinit()
#endif /* ANSI_DEFS */
{
/*  9/12/94 - rob
    Add this next block to fix a problem in Windows DLL where system
    is not completely exited properly (IXexit) and then we try
    to run again. The DLL is not necessarily reloaded by Windows.
*/
#if defined (_WINDLL)
#if CACHE
    CGIFinitstate = not_buf | not_cac | not_intellifont;
#else
    CGIFinitstate = not_buf | not_intellifont;
#endif
#endif /* _WINDLL */
/* end of block - 9/12/94 - rob */

    MEMinit();                /* Initialize memory manager   */
    return SUCCESS;
}

#else /* MULTICALLER */

/*  Multicaller is enabled. We also initialize the multicaller instance
 *  manager. We wish to initialize via MEMinit() and INSTinit() only the
 *  first time this function is called. This version of the function
 *  also returns the current memory pool sizes.
 */

#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFinit (LPUW16 pCallerId, LPUL32 pCacheSize, LPUL32 pBufferSize)
#else
UW16 CGENTRY
CGIFinit(pCallerId, pCacheSize, pBufferSize)
    LPUW16 pCallerId;
    LPUL32 pCacheSize;
    LPUL32 pBufferSize;
#endif /* ANSI_DEFS */
{
  UW16 status;

#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;

#endif /* SEM_ACCESS */

  /* First time initialization */
    if(uInitFirstTime)
    {
        uInitFirstTime = FALSE;
        MEMinit();                /* Initialize memory manager   */
        INSTinit();               /* Initialize instance manager */
    }

  /* Return current memory pool sizes */

    *pCacheSize  = (UL32)mem_fund[CACHE_POOL ];
    *pBufferSize = (UL32)mem_fund[BUFFER_POOL];

  /* Return the caller's unique caller id */

    if((*pCallerId = INSTfree()) == MAX_UWORD)
    {
#if SEM_ACCESS
      release_semaphore();
#endif /* SEM_ACCESS */
      return ERR_max_callers;
    }

#if SEM_ACCESS
    release_semaphore();
#endif /* SEM_ACCESS */
    return SUCCESS;
}
#endif



/*----------------*/
/*  cgif_Config    */
/*----------------*/
/*  The application calls this function to set or change the
 *  configuration parameters.
*/
#if !MULTICALLER

#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Config (PIFCONFIG cfg)
#else
GLOBAL UW16 
cgif_Config(cfg)
    PIFCONFIG cfg;
#endif /* ANSI_DEFS */
{
  /*  Set configuration values  */

    max_open_files = cfg->num_files;  /* max number of open library files */
    if_state.bit_map_width = cfg->bit_map_width;  /* bmap alignmnt bytes */

    if(if_state.bit_map_width < (UW16)RASTER_ORG)
        return ERR_incomp_bitmap_width;  /* conflict with RASTER_ORG */

    if(if_state.bit_map_width > 4)
        return ERR_bad_bitmap_width;
    if_state.bit_map_width <<= 3;                             /* Convert to pixels */


    if(STRLEN(ufstPath) <= 1)               /* cannot change ufstPath */
        STRCPY(ufstPath, cfg->ufstPath);
    STRCPY(typePath, cfg->typePath);

#if CACHE
    max_char_size = cfg->max_char_size; /* max cached character IFBITMAP size */
#endif

#if CHAR_SIZE
    cc_buf  = cfg->cc_buf_ptr;                /* compund character buffer */
    cc_size = cfg->cc_buf_size;
#endif
    return SUCCESS;
}

#else  /* Multicaller is enabled */

#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Config (PIFCONFIG cfg)
#else
GLOBAL UW16 
cgif_Config(cfg)
    PIFCONFIG cfg;
#endif /* ANSI_DEFS */
{
  /*  Set configuration values  */

    max_open_files = cfg->num_files;  /* max number of open library files */
    if_state.bit_map_width = cfg->bit_map_width; /* bmap align bytes */

    if(if_state.bit_map_width < (UW16)RASTER_ORG)
        return ERR_incomp_bitmap_width;  /* conflict with RASTER_ORG */

    if(if_state.bit_map_width > 4)
        return ERR_bad_bitmap_width;
    if_state.bit_map_width <<= 3;                           /* Convert to pixels */


    if(STRLEN(ufstPath) <= 1)               /* cannot change ufstPath */
        STRCPY(ufstPath, cfg->ufstPath);
    STRCPY(typePath, cfg->typePath);

#if CACHE
    max_char_size = cfg->max_char_size; /* max cached character IFBITMAP size */
#endif

#if CHAR_SIZE
/* set cc_buf to point to valid buffer, cfg->cc_buf_ptr may point to NULL */

    cc_buf  = (cfg->cc_buf_ptr) ? cfg->cc_buf_ptr : (LPUB8)ccBuffer;
    cc_size = cfg->cc_buf_size;
#endif
    return SUCCESS;
}

#endif

/*----------------*/
/*  CGIFconfig    */
/*----------------*/
/*  The application calls this function to set or change the
 *  configuration parameters.
*/
#if !MULTICALLER

#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFconfig (PIFCONFIG cfg)
#else
UW16 CGENTRY
CGIFconfig(cfg)
    PIFCONFIG cfg;
#endif /* ANSI_DEFS */
{
  return cgif_Config(cfg);
}

#else   /* Multicaller is enabled */

#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFconfig (UW16 uCallerId, PIFCONFIG cfg)
#else
UW16 CGENTRY
CGIFconfig(uCallerId, cfg)
    UW16     uCallerId;
    PIFCONFIG cfg;
#endif /* ANSI_DEFS */
{
    UW16 status;

#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    status = INSTsaveConfig(uCallerId, cfg);
    if (status)
    {
#if SEM_ACCESS
      release_semaphore();
#endif /* SEM_ACCESS */
      return status;
    }

    status = cgif_Config(cfg);
#if SEM_ACCESS
    release_semaphore();
#endif /* SEM_ACCESS */
    return status;
}

#endif


/*----------------------*/
/*    CGIFenter         */
/*----------------------*/
/*  This function is called once after the memory pools have been funded
 *  to initialize the cache and the font management subsystem.

 * Read PostScript mapping table into memory if PS is enabled. - 5/21/92 - rs
 */

#if !MULTICALLER

#if defined (ANSI_DEFS)
UW16  CGENTRY CGIFenter ()
#else
UW16  CGENTRY
CGIFenter()
#endif /* ANSI_DEFS */
{
    UW16 status;

    status = IXinit();         /* buffers, font index, and symbol set */
    if (status)
       return status;

#if CACHE
    status = CACinit();       /* Initialize the cache */
    if (status) {
      IXexit();
      return (status);
    }
#endif

#if FCO_RDR                   /* 5-26-94 mby */
    status = FCOinit();       /* Initialize handles for FCO_RDR */
    if (status)
    {
#if CACHE
      CACexit();
#endif
      IXexit();
    }
#endif

    return (status);
}


#else

/*  Multicaller is enabled.
 */

#if defined (ANSI_DEFS)
UW16  CGENTRY CGIFenter (UW16 uCallerId)
#else
UW16  CGENTRY
CGIFenter(uCallerId)
    UW16 uCallerId;
#endif /* ANSI_DEFS */
{
    UW16 status;

    status = SUCCESS;  /* 9-24-93 jfd */
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uEnterFirstTime)  /* if the very first time called */
    {
        uEnterFirstTime = FALSE;

        status = IXinit();      /* buffers, font index, and symbol set */
        if(status)
        {
#if SEM_ACCESS
          release_semaphore();
#endif /* SEM_ACCESS */
          return status;
        }

#if CACHE
        status = CACinit();     /* Initialize the cache */
        if (status)
        {
          IXexit();
#if SEM_ACCESS
          release_semaphore();
#endif /* SEM_ACCESS */
          return status;
        }
#endif /* CACHE */

#if FCO_RDR
        status = FCOinit();     /* Initialize handles for FCO_RDR */
        if (status)
        {
#if CACHE
          CACexit();
#endif
          IXexit();
#if SEM_ACCESS
          release_semaphore();
#endif /* SEM_ACCESS */
          return status;
        }
#endif  /* FCO_RDR */
    }

#if SEM_ACCESS
    release_semaphore();
#endif /* SEM_ACCESS */
    return (status);
}
#endif





/*----------------------*/

/*    CGIFexit          */
/*----------------------*/
#if !MULTICALLER

#if defined (ANSI_DEFS)
UW16  CGENTRY CGIFexit ()
#else
UW16  CGENTRY
CGIFexit()
#endif /* ANSI_DEFS */
{
    DBG("CGIFexit()\n");

#if 0
    if(!CGIFinitstate) return SUCCESS;      /* not initialized */
#endif
#if IF_RDR
    if(CGIFinitstate) return SUCCESS;      /* not initialized */
#else
    if(CGIFinitstate & ~not_intellifont) return SUCCESS;      /* not initialized */
#endif

#if FCO_RDR     /* 5-26-94 mby */
    FCOexit();
#endif
#if CACHE
    CACexit();
#endif
    IXexit();

    return SUCCESS;
}

#else

/*  Multicaller is enabled.
 *  Call INSTexit() to tell the instance handler we're leaving. He'll
 *  defund all of our funded memory. If we're the last instance to
 *  leave, call CACexit() and IXexit(), then reset the first time
 *  initialize variables.
 *
 */

#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFexit (UW16 uCallerId)
#else
UW16 CGENTRY
CGIFexit(uCallerId)
    UW16 uCallerId;
#endif /* ANSI_DEFS */
{
    UW16 status;

#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    DBG1("CGIFexit(%u)\n", uCallerId);

    status = INSTexit(uCallerId);
    if (status)
    {
#if SEM_ACCESS
      release_semaphore();
#endif /* SEM_ACCESS */
      return status;
    }

    if(!INSTactive())    /* any active instances ? */
    {
#if FCO_RDR
        FCOexit();
#endif
#if CACHE
        CACexit();
#endif
        IXexit();
        uInitFirstTime = TRUE;    /* reset instance system init */
        uEnterFirstTime = TRUE;   /* reset cache init */

    }
#if SEM_ACCESS
    release_semaphore();
#endif /* SEM_ACCESS */
    return (SUCCESS);
}
#endif



/*-----------------------*/
/*    cgif_Font          */
/*-----------------------*/
/*  The application calls this function to change the current font.
 *  A new symbol set is loaded if it changed.
 */
#define DL_SYMSET  0x8000

#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Font (PFONTCONTEXT fc)
#else
GLOBAL UW16 cgif_Font (fc)
    PFONTCONTEXT  fc;
#endif /* ANSI_DEFS */
{
#if CACHE | MULTICALLER | PCLEO_RDR | ASIAN_ENCODING
    UW16 status;
#endif
    BOOLEAN useMapping;     /* if high bit set or if ENTITY1 type (mby 9-93) */
#if PCLEO_RDR
    UW16 pcleo_sscode;      /* mby, 07-01-94 */
#endif

    if( FC_ISIF( fc ) && (CGIFinitstate & not_intellifont) )
        return ERR_no_font_index;

#if !BOLD
    if(fc->xbold || fc->ybold)
       return ERR_bold_not_enabled;
#endif /* !BOLD */

    useMapping = ( (fc->ssnum != DL_SYMSET) && !NO_SYMSET_MAPPING);
                                                 /* changed: mby, 06-06-94 */
                                                 /* changed: jfd, 03-29-95 */

#if TT_RDR && NO_SYMSET_MAPPING
    if ( FC_ISTT( fc ) )
    {
       symbolset.tt_platID = (UW16)(fc->dl_ssnum & 0x000F);
       symbolset.tt_specID = (UW16)(fc->dl_ssnum & 0x00F0) >> 4;
    }
#endif  /* TT_RDR && NO_SYMSET_MAPPING */

#if PCLEO_RDR
    /* have font_id in pcleo font header, so set it in fontcontext for */
    /* later use.                                           -ss 6/2/92 */
    if( FC_ISEXTERN( fc ) )
    {
       UW16 pcleo_ssnum;
       
       if( FC_ISIF( fc ) )
       {
#if IF_PCLEOI
          GET_LONG(&fc->font_id, fc->font_hdr + FONT_NUMBER);
          GET_WORD(&pcleo_ssnum, fc->font_hdr + SS_CODE );
#else
          return ERR_fst_type;
#endif
       }

     /* TrueType & PostScript PCLExO header data is always in Motorola
      * byte order (hi-lo). Use GET_xLONG(), GET_xWORD() macros.
      */
       else
       {
#if (!TT_PCLEOI || !(PST1_PCLEOI || PST1_SFNTI))  /* check for bad fst type */
#if !(PST1_PCLEOI || PST1_SFNTI)
          if (FC_ISPST1(fc))
              return ERR_fst_type;
#endif
#if !TT_PCLEOI
          if (FC_ISTT(fc))
              return ERR_fst_type;
#endif
#endif
#if (TT_PCLEOI || PST1_PCLEOI || PST1_SFNTI)
          fc->font_id = GET_xLONG_OFF(fc->font_hdr, FONT_NUMBER);
          pcleo_ssnum = GET_xWORD_OFF(fc->font_hdr, SS_CODE );
#endif
       }

       fc->font_id &= PCLFONT_NUMBER_MASK;  /* grab only significant bytes */
#if !NO_SYMSET_MAPPING
       if (useMapping)
       {        /* convert to IF ssnum and save in fontcontext -ss 7/29/92 */
          status = PCLeo2IF_ssnum( fc, pcleo_ssnum, &pcleo_sscode );
          if (status)
             return status;
       }
#endif  /* !NO_SYMSET_MAPPING */
    }       /* if ( FC_ISEXTERN(fc) ) */
    else
#endif  /* PCLEO_RDR */

    {
#if TT_ROM1
        if_state.rom_thing = 0;
        if ( FC_ISTT(fc) && (fc->format & FC_ROM_TYPE) )
        {
            if (GET_xLONG(fc->font_hdr) == ENTITY1)
            {
                useMapping = FALSE;
                if_state.rom_thing = ENTITY1;
            }
        }
#endif  /* TT_ROM1 */
    }

    if_state.usePlugins = (useMapping ? TRUE : FALSE);

#if (PST1_RDR || TT_RDR)
    /* for PS and TT fonts, reset the font id of the fontcontext to
     * prevent problems which may occur when switching between FST's
     */
    if ( (FC_ISTT( fc ) || FC_ISPST1( fc )) && !FC_ISEXTERN( fc ))
       fc->font_id = 0;

#endif  /* (PST1_RDR || TT_RDR) */

    FCcopy(&fcCur, fc); /* Local copy of the FONTCONTEXT */
#if PCLEO_RDR
    if( FC_ISEXTERN( fc ) && useMapping )   /* mby 07-14-94 */
    {
        fcCur.ssnum = pcleo_sscode;
    }
#endif

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)      /* mby, 5-5-94 */
        if_state.awtsub_on = 1;
    else
        if_state.awtsub_on = 0;
#endif  /* CONVERGENT_FONTS */

#if CACHE
    status = CACfont(&fcCur);   /* Inform cache of new font */
    if (status)
       return status;
#endif

#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
#if ROM
    if_state.has_path = 0;
#else
    if_state.has_path = (!FC_ISEXTERN(fc) && !fc->font_id);
                                /* PS, TT disk, IF dynamic */
#if FCO_RDR
    if (FC_ISFCO(fc))
        if_state.has_path = 0;
#endif
#if ALIEN_BITS
    if (FC_ISAPPGEN(fc))
        if_state.has_path = 0;
#endif
#endif  /* !ROM */

    if (if_state.has_path)
    {
        if(STRLEN((LPSB8)fcCur.font_hdr) >= PATHNAMELEN)
            return ERRlong_font_name;
        STRCPY(pathname, (LPSB8)fcCur.font_hdr);
        fcCur.font_hdr = (LPUB8)pathname;
    }
#endif  /* (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)) */

#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
     /* 
      * force FCis_equal() to fail so that
      * comp_pix() is called for first characters
      * of PostScript and TrueType fonts
      */

    if_state.cur_loc_fc.font_hdr =  (LPUB8)0;  /* 10-6-94 */
#endif

#if FCO_RDR     /* Save the UFST FCO handle in if_state.FCObject. 05-26-94, mby */
                /* The application handle is in the high 16 bits of fc->font_id */
    if (FC_ISFCO(fc))
    {
        MEM_HANDLE mh;
        UW16 status = fco_GetMemHandle((int)(fc->font_id >> 16), &mh);
        if (status)
        {
            if_state.FCObject = 0;
            return status;
        }
        if_state.FCObject = mh;
    }
#endif  

#if ASIAN_ENCODING && TT_RDR
    if ( FC_ISTT(fc) && 
         ((fcCur.ssnum == JIS)  || (fcCur.ssnum == SHIFT_JIS)  
       || (fcCur.ssnum == EUC ) || (fcCur.ssnum == UNICODE)
       || (fcCur.ssnum == BIG5) || (fcCur.ssnum == TCA)
       || (fcCur.ssnum == GB)    || (fcCur.ssnum == KSC )
         )
       && (symbolset.curssnum != fcCur.ssnum) )
    {
       if ( !(fc->format & FC_ROM_TYPE) )
       {
#if TT_DISK
          status = get_ttDISK_ids(&symbolset.tt_platID, &symbolset.tt_specID,
             fcCur.font_hdr);
#endif
       }
       else
       {
#if TT_ROM
          status = get_ttROM_ids(&symbolset.tt_platID, &symbolset.tt_specID,
             fcCur.font_hdr);
#endif  /* TT_ROM */
       }
    symbolset.curssnum = fcCur.ssnum;
    }
#endif  /* ASIAN_ENCODING */

  /*  Read in new symbol if necessary and set up
   *  ss_first_code and ss_last_code.
   */
   /* For a PCLEO, if ssnum is not in our available list, fc->ssnum == 0 */
   /* an symbolset.current_ssnum reinitialized to 0 so SYMnew() should   */
   /* return success.                                        -ss 7/31/92 */

#if ALIEN_BITS
   /* For Application Generated Bitmaps, DO NOT call SYMnew or SYMnoMap */
    if (FC_ISAPPGEN(fc))      /* 06-14-94 */
        return SUCCESS;
#endif

#if (PCLEO_RDR || TT_ROM1 || NO_SYMSET_MAPPING)  /* 3-29-95 jfd */
    if (!useMapping)            /* pass fcCur in arguments, mby 07-14-94 */
    {
        if (!SYMnoMap(fcCur.font_hdr, fcCur.format))
            return ERR_IXnew_ss;
    }
    else
#endif
    {
#if !NO_SYMSET_MAPPING
        if (!SYMnew(fcCur.ssnum, fcCur.format))
            return ERR_IXnew_ss;
#endif  /* !NO_SYMSET_MAPPING */
    }

    return SUCCESS;

}       /* cgif_Font() */



/*----------------------*/
/*    CGIFfont          */
/*----------------------*/
/*  The application calls this function to change the current font.
 *  A new symbol set is loaded if it changed.
 *  This function is dynamically deciding the mapping scheme for a Type1 font.
 */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfont (UW16 uCallerId, PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFfont (uCallerId, fc)
    UW16 uCallerId;
    PFONTCONTEXT  fc;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfont (PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFfont (fc)
    PFONTCONTEXT  fc;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{

#if PST1_RDR
	UW16 status, chId = 32;
	HIFBITMAP hbm;
	IFBITMAP bm;
	PIFBITMAP pbm;
	
	pbm=&bm;
    /*keb*/
	if(!FC_ISPST1(fc)) 
		Meto_encodearray=0;
	if(FC_ISPST1(fc))
	{	
		if(STRNCMP((LPSB8) Meto_last_font, fc->font_hdr, PATHNAMELEN)) 
	{
		   status = Meto_CGIFfont(fc);
		   if (cache_Meto_font == 0)
		       status = Meto_get_status(chId, &pbm, &hbm);
	}
	if (Meto_encodearray == 1 ) 
	    fc->ssnum = T1ENCODING;  
	}
	if(fc->font_hdr)
		STRCPY(Meto_last_font, fc->font_hdr);
#endif

#if MULTICALLER
   status = Meto_CGIFfont(uCallerId, fc) ;
#else
   status = Meto_CGIFfont(fc) ;
#endif
   return status ;
}


/*----------------------*/
/*    Meto_CGIFfont     */
/*----------------------*/
/* This function is the same as the previous version of CGIFfont().
 * The rename is for Meto use only.                     6-24-97 jqz  
 */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY Meto_CGIFfont (UW16 uCallerId, PFONTCONTEXT fc)
#else
UW16 CGENTRY Meto_CGIFfont (uCallerId, fc)
    UW16 uCallerId;
    PFONTCONTEXT  fc;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY Meto_CGIFfont (PFONTCONTEXT fc)
#else
UW16 CGENTRY Meto_CGIFfont (fc)
    PFONTCONTEXT  fc;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
   UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    status = INSTsaveState(uCallerId, fc);
    if (status)
    {
#if SEM_ACCESS
      release_semaphore();
#endif /* SEM_ACCESS */
      return status;
    }
#endif /* MULTICALLER */

    status = cgif_Font(fc);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}

/*--------------------------------------------------------------------*/
/*  All entries below are conditionally compiled depending on which
 *  options have been set in cgconfig.h
 */

#if CHAR_HANDLE
/*----------------------*/
/*    cgif_Char_Handle   */
/*----------------------*/
/*  Return a handle  to the requested character IFBITMAP.  */
#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Char_Handle (UW16 chId, PHIFBITMAP phbm, SW16 alt_width)
#else
GLOBAL UW16 cgif_Char_Handle(chId, phbm, alt_width)
    UW16       chId;
    PHIFBITMAP phbm;
    SW16       alt_width;
#endif /* ANSI_DEFS */
{
    if_state.alt_width = alt_width;
    return makechar((PFONTCONTEXT)&fcCur, chId, phbm);
}

/*----------------------*/
/*    CGIFchar_handle   */
/*----------------------*/
/*  Return a handle  to the requested character IFBITMAP.  */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchar_handle (UW16 uCallerId, UW16 chId, PHIFBITMAP phbm,
                              SW16 alt_width)
#else
UW16 CGENTRY CGIFchar_handle(uCallerId, chId, phbm, alt_width)
    UW16       uCallerId;
    UW16       chId;
    PHIFBITMAP phbm;
    SW16       alt_width;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchar_handle (UW16 chId, PHIFBITMAP phbm, SW16 alt_width)
#else
UW16 CGENTRY CGIFchar_handle(chId, phbm, alt_width)
    UW16       chId;
    PHIFBITMAP phbm;
    SW16       alt_width;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16      status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)   /* use correct font context */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    DBG1("CGIFchar_handle(%u)\n", chId);

    status = cgif_Char_Handle(chId, phbm, alt_width);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /*  CHAR_HANDLE  */

#if CACHE

  /* Moved the following EXTERN from before CGIFtile()  02-01-93 */

#if TILE
EXTERN HIFBITMAP htileBM;     /* Handle of last made tile part   */
#endif

/*----------------------*/
/*    CGIFchar          */
/*----------------------*/
/*  Character generation used with AGFA supplied character cache.
 *  May be used with internal or external memory manager.
 *  Return a pointer to the requested character IFBITMAP.
 *  Return nil if the character is not in the cache and cannot be
 *  made or if bad input data.
 *  If caller ID has changed since the last call to this function, then the 
 *  saved state (from CGIFconfig, CGIFfont) of the caller must be restored.
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchar (UW16 uCallerId, UW16 chId, PPIFBITMAP ppbm,
                     SW16 alt_width)
#else
UW16 CGENTRY
CGIFchar(uCallerId, chId, ppbm, alt_width)
    UW16 uCallerId;
    UW16      chId;
    PPIFBITMAP ppbm;
    SW16       alt_width;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchar (UW16 chId, PPIFBITMAP ppbm, SW16 alt_width)
#else
UW16 CGENTRY
CGIFchar(chId, ppbm, alt_width)
    UW16      chId;
    PPIFBITMAP ppbm;
    SW16       alt_width;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    EXTERN MEM_HANDLE  hBMlru;
    EXTERN PFONT pfontCur;
    PHIFBITMAP phbm;
    HIFBITMAP  hbm;
    UW16      status;
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    MEM_HANDLE hItem;
    PHASH_ITEM phi;
#endif /* ASIAN_ENCODING */

/*
 * 9/16/93 maib
 * this code only required if UFST creating the bitmap
 */
#if BANDING
    IFBITMAP bm;
    PIFBITMAP pbm;
    IFTILE   iftile;

#define     F_ONE     0x10000L

#endif /* BANDING */

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)   /* use correct font context */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    DBG1("CGIFchar(%u)\n", chId);

    status = SUCCESS;  /* initialize in case bitmap is already cached */

    /*
     * 10/25/93 maib
     * check for the necessary data to find the bitmap
     */
    if (!pfontCur)
    {
      *ppbm = (PIFBITMAP)0;
      return ERR_no_font;
    }

/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    /*
     * not found in cache case handled below (same as for 

     * non-Asian Encoding...
     */
    if (hItem = CAChashLookup(pfontCur, chId))
    {
      phi = (PHASH_ITEM)MEMptr(hItem);
      *ppbm = (PIFBITMAP)MEMptr(phi->hbm);
#else
    /*
     * 10/25/93 maib
     * if a handle to the bitmap is found, set the pointer and update
     * the LRU list. otherwise start the process of creating it...
     */
    if (*(phbm = pfontCur->hbuf + chId))
    {
      *ppbm = (PIFBITMAP)MEMptr(*phbm);
#endif /* ASIAN_ENCODING */

      /*
       *  Make buffer most recently used if not already done
       */
      if (((PIFBITMAP)*ppbm)->notmru)
      {
        ((PIFBITMAP)*ppbm)->notmru = 0;  /* Keep from doing this again       */
#if ASIAN_ENCODING
        dll_remove(phi->hbm);            /* Remove from lru list             */
        dll_after(hBMlru, phi->hbm);    /* Link at the head of the lru list */
#else
        dll_remove(*phbm);             /* Remove from lru list             */
        dll_after(hBMlru, *phbm);      /* Link at the head of the lru list */
#endif /* ASIAN_ENCODING */
      }

      /* If this is a space character and it has already been cached,
       * "status" will not be set to ERR_fixed_space. Check if this
       * character is a fixed space and set status appropriately.
       *  10-08-93 jfd
       */
       if (!((PIFBITMAP)(*ppbm)->width) && !((PIFBITMAP)(*ppbm)->depth))
          status = ERR_fixed_space;
    }
    else       /* not found in the cache */
    {
        if_state.alt_width = alt_width;

#if BANDING
        if ( (fcCur.band_top || fcCur.band_bot) &&
             !((fcCur.rotate.x == F_ONE && fcCur.rotate.y == 0)     /* 0 deg */
             ||(fcCur.rotate.x == -F_ONE && fcCur.rotate.y == 0)) ) /* 180 deg */
        {
#if (MULTICALLER && SEM_ACCESS)
          release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
          return ERR_invalid_band;
        }

        /*
         * 1/6/94 maib
         * determine who is responsible for creating the bitmap, UFST
         * or the calling application, by examining the fontcontext to
         * see if the FC_APPGEN_TYPE bit is set...
         */
        if ((fcCur.band_top || fcCur.band_bot) && !FC_ISAPPGEN(&fcCur))
        {
           status = cgif_BMHeader(chId, &bm, 0);
           if (status && (status != ERR_fixed_space))
           {
             DBG1("cgif_BMHeader() failed: %d\n", status);
#if (MULTICALLER && SEM_ACCESS)
             release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
             return status;
           }
           else if (!status && if_state.num_loops)
           {
              iftile.x = 0;
              iftile.width = bm.black_width;
              iftile.depth = fcCur.band_top;

              if (fcCur.rotate.x == F_ONE)  /* 0 deg rotation */
                 iftile.y = (bm.black_depth - (SW16)(bm.yorigin >> 4L)) + fcCur.band_bot;
              else                          /* 1800 deg rotation */
                 iftile.y = ((bm.black_depth - (SW16)(bm.yorigin >> 4L)) - fcCur.band_bot)
                               - fcCur.band_top;

              status = cgif_Tile(&iftile, &pbm);
              if (status)
              {
                DBG1("cgif_Tile() failed: %d\n", status);
#if (MULTICALLER && SEM_ACCESS)
                release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
                return status;
              }
              hbm = htileBM;  /* from cgif_Tile() ???? */
              htileBM = NIL_MH;     /* Handle of last made tile part   */
              goto insert;
           }
        }
#endif  /* BANDING */

        status = makechar((PFONTCONTEXT)&fcCur, chId, (PHIFBITMAP)&hbm);

        /* If character is fixed space, cache it anyway to save
         * the metrics information
         */

        if (status && (status != ERR_fixed_space))
        {
          DBG("    makechar() failed\n");
#if (MULTICALLER && SEM_ACCESS)
          release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
          return status;
        }

insert:
        CACinsert(hbm, chId);      /* Insert in cache  */
        *ppbm = (PIFBITMAP)MEMptr(hbm);
    }

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /* CACHE */


#if CHAR_SIZE
/*----------------------*/
/*    CGIFchar_size     */
/*----------------------*/
/* Character generator for application managed bitmap buffers */

#if MULTICALLER
#if defined (ANSI_DEFS)
#if (MAX_BM_BITS > 16)
UW16  CGENTRY CGIFchar_size (UW16 uCallerId, UW16 chId, LPSL32 size,
                           SW16 alt_width)
#else
UW16  CGENTRY CGIFchar_size (UW16 uCallerId, UW16 chId, LPUW16 size,
                           SW16 alt_width)
#endif /* MAX_BM_BITS */
#else /* !ANSI_DEFS */
UW16  CGENTRY CGIFchar_size (uCallerId, chId, size, alt_width)
    UW16    uCallerId;
    UW16    chId;
#if (MAX_BM_BITS > 16)
    LPSL32    size;
#else
    LPUW16   size;
#endif
    SW16     alt_width;

#endif /* ANSI_DEFS */
#else /* !MULTICALLER */

#if defined (ANSI_DEFS)
#if (MAX_BM_BITS > 16)
UW16  CGENTRY CGIFchar_size (UW16 chId, LPSL32 size, SW16 alt_width)
#else
UW16  CGENTRY CGIFchar_size (UW16 chId, LPUW16 size, SW16 alt_width)
#endif /* MAX_BM_BITS */
#else /* !ANSI_DEFS */
UW16  CGENTRY CGIFchar_size (chId, size, alt_width)
    UW16    chId;
#if (MAX_BM_BITS > 16)
    LPSL32    size;
#else
    LPUW16   size;
#endif
    SW16     alt_width;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;
    SL32  lsize[3];

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    DBG1("CGIFchar_size(%u)\n", chId);

    if_state.alt_width = alt_width;        /* Alternate width */

    /*    First, let's initialize the values of lsize. If the application is */
    /* not processing a compound character,  or does not have NZW turned on, */
    /* this step will avoid garbage being placed in those size fields.       */
    
    lsize[0] = 0;
    lsize[1] = 0;
    lsize[2] = 0;

    status = MAKfontSize(&fcCur, chId, lsize);


#if (MAX_BM_BITS > 16)
    size[0] = lsize[0];
    size[1] = lsize[1];
    size[2] = lsize[2];
#else
    size[0] = (UW16)lsize[0];
    size[1] = (UW16)lsize[1];
    size[2] = (UW16)lsize[2];
#endif

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /* CHAR_SIZE */

#if TILE
/*----------------------*/
/*    cgif_BMHeader      */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_BMHeader (UW16 chId, PIFBITMAP pbm, SW16 alt_width)
#else
GLOBAL UW16 cgif_BMHeader (chId, pbm, alt_width)
    UW16     chId;
    PIFBITMAP pbm;
    SW16      alt_width;
#endif /* ANSI_DEFS */
{
    if_state.alt_width = alt_width;        /* Alternate width */

    return MAKifbmheader(&fcCur, chId, pbm);
}

/*----------------------*/
/*    CGIFbmheader      */
/*----------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbmheader (UW16 uCallerId, UW16 chId, PIFBITMAP pbm,
                        SW16 alt_width)
#else
UW16 CGENTRY CGIFbmheader (uCallerId, chId, pbm, alt_width)
    UW16    uCallerId;
    UW16     chId;
    PIFBITMAP pbm;
    SW16      alt_width;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbmheader (UW16 chId, PIFBITMAP pbm, SW16 alt_width)
#else
UW16 CGENTRY CGIFbmheader (chId, pbm, alt_width)
    UW16     chId;
    PIFBITMAP pbm;
    SW16      alt_width;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = cgif_BMHeader(chId, pbm, alt_width);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}

#if CHAR_HANDLE
/*----------------------*/
/*    CGIFtile_handle   */
/*----------------------*/

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtile_handle (UW16 uCallerId, PIFTILE piftile, PHIFBITMAP phbm)
#else
UW16 CGENTRY CGIFtile_handle (uCallerId, piftile, phbm)
    UW16 uCallerId;
    PIFTILE piftile;
    PHIFBITMAP phbm;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtile_handle (PIFTILE piftile, PHIFBITMAP phbm)
#else
UW16 CGENTRY CGIFtile_handle (piftile, phbm)
    PIFTILE piftile;
    PHIFBITMAP phbm;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
  UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = bitmap_tile(piftile, phbm);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif /* CHAR_HANDLE */

#if CACHE
/*----------------------*/
/*    cgif_Tile          */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Tile (PIFTILE piftile, PPIFBITMAP ppbm)
#else
GLOBAL UW16 cgif_Tile (piftile, ppbm)
    PIFTILE piftile;
    PPIFBITMAP ppbm;
#endif /* ANSI_DEFS */
{
    UW16     status;

    status = bitmap_tile(piftile, &htileBM);
    if (status)
        return status;

    *ppbm = (PIFBITMAP)MEMptr(htileBM);
    return SUCCESS;
}

/*----------------------*/
/*    CGIFtile          */
/*----------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtile (UW16 uCallerId, PIFTILE piftile, PPIFBITMAP ppbm)
#else
UW16 CGENTRY CGIFtile (uCallerId, piftile, ppbm)
    UW16 uCallerId;
    PIFTILE piftile;
    PPIFBITMAP ppbm;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */

#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtile (PIFTILE piftile, PPIFBITMAP ppbm)
#else
UW16 CGENTRY CGIFtile (piftile, ppbm)
    PIFTILE piftile;
    PPIFBITMAP ppbm;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16     status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = cgif_Tile(piftile, ppbm);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif /* CACHE */
#endif  /* TILE */

#if WIDTHS
/*----------------------*/
/*    CGIFwidth         */
/*----------------------*/

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFwidth (UW16 uCallerId, UW16 first_chId, UW16 num_chId,
                        UW16 buffer_size, LPUW16 buffer)
#else
UW16 CGENTRY CGIFwidth (uCallerId, first_chId, num_chId, buffer_size, buffer)
    UW16  uCallerId;
    UW16  first_chId;
    UW16  num_chId;
    UW16  buffer_size;
    LPUW16 buffer;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFwidth (UW16 first_chId, UW16 num_chId,
                        UW16 buffer_size, LPUW16 buffer)
#else
UW16 CGENTRY CGIFwidth (first_chId, num_chId, buffer_size, buffer)
    UW16  first_chId;
    UW16  num_chId;
    UW16  buffer_size;
    LPUW16 buffer;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16    status;
    LPUW16   p;
    int     q;
    UW16    chId;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
         goto WIDTH_EXIT;
    }
#endif /* MULTICALLER */

    DBG4("CGIFwidth(%u, %u, %u, %u)\n",
                    first_chId, num_chId, buffer_size, buffer);

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)      /* jfd, 7-13-94 */
        if_state.awtsub_on = 1;
    else
        if_state.awtsub_on = 0;
#endif  /* CONVERGENT_FONTS */

#if CONVERGENT_FONTS
    if (!if_state.awtsub_on)    /* mby, 5-5-94 */
    {
        status = IXget_fnt_index(&fcCur);
        if (status)
            goto WIDTH_EXIT;
    }
#else   /* !CONVERGENT_FONTS */

    status = IXget_fnt_index(&fcCur);
    if (status)
        goto WIDTH_EXIT;
#endif  /* !CONVERGENT_FONTS */

    if(buffer_size < 4*num_chId)  /* buffer must now hold em box size too */
    {
      DBG("    buffer too small\n");
      status = ERR_buffer_too_small;
      goto WIDTH_EXIT;
    }

    p = (LPUW16)buffer;

#if ((IF_RDR || PST1_RDR) && (TT_RDR || FCO_RDR))
    if (FC_ISTT(&fcCur) || FC_ISFCO(&fcCur))
        q = SYMBOLSET_TT;
    else
        q = SYMBOLSET_IF;
#endif
#if !(TT_RDR || FCO_RDR)
    q = SYMBOLSET_IF;
#endif
#if !(IF_RDR || PST1_RDR)
    q = SYMBOLSET_TT;
#endif
    for(chId=first_chId; chId<first_chId + num_chId; chId++)
    {
#if !NO_SYMSET_MAPPING
        if((chId < symbolset.ss_first_code[q])
                              || (symbolset.ss_last_code[q] < chId) )
        {
            *p++ = ERR_char_unavailable;  /* 0x7FFF, 05-24-95 */
            *p++ = 0;  /* em box size */
        }
        else
#endif  /* !NO_SYMSET_MAPPING */
        {
#if CONVERGENT_FONTS            /* 9-30-93 mby */
            if (if_state.awtsub_on)     /* mby, 5-5-94 */
            {
                if_state.alt_width = 0; /* 3-25-94 jfd */

                status = CVFget_fnt_index(&fcCur, chId, CVF_NO_INDEX, &if_state.alt_width);
                if (status)
                  goto WIDTH_EXIT;
                if (if_state.alt_width)     /* if this is zero, then there */
                                        /* is no table entry, so we should */
                {                               /* drop down to chwidth()  */
                    *p++ = if_state.alt_width;
                    *p++ = awtData.scaleFactor;
                    continue;   /* skip call to chwidth() */
                }
            }
#endif  /* CONVERGENT_FONTS */
            *p++ = chwidth(chId);
            *p++ = if_state.cs.du_emx;  /* em box size */
        }
    }
    status = SUCCESS;

WIDTH_EXIT:
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /* WIDTHS */


#if KERN
/*----------------------*/
/*    cgif_Kern          */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 cgif_Kern (UW16 code, UW16 num_pairs, PKERN_PAIR pkern_pair)
#else
GLOBAL UW16 cgif_Kern (code, num_pairs, pkern_pair)
    UW16      code;
    UW16      num_pairs;
    PKERN_PAIR pkern_pair;
#endif /* ANSI_DEFS */
{
    UW16 status;
    UW16 i;

    if(FC_ISPST1(&fcCur) || FC_ISTT(&fcCur) || FC_ISFCO(&fcCur))
        return ERR_kern_unsupported;      /* no kern support for PS, TT, FCO */
#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
        return ERR_kern_unsupported;      /* no kern support for Convergent Fonts */
#endif

#if IF_RDR
    if((code != TEXT_KERN) && (code != DESIGN_KERN))
        return ERR_bad_kern_code;
    status = IXget_fnt_index(&fcCur);
    if (status)
        return status;

    for(i=0; i<num_pairs; i++, pkern_pair++)
        /*
           Modified call to kern() to NOT subtract 'symbolset.ss_first_code'
           from each chId. - 7/2/91 - rs
        */
        pkern_pair->adj = kern(code, pkern_pair->chId0, pkern_pair->chId1);
    return SUCCESS;
#endif  /* IF_RDR */
}

/*----------------------*/
/*    CGIFkern          */
/*----------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFkern (UW16 uCallerId, UW16 code, UW16 num_pairs,
                     PKERN_PAIR pkern_pair)
#else
UW16 CGENTRY CGIFkern (uCallerId, code, num_pairs, pkern_pair)
    UW16      uCallerId;
    UW16      code;
    UW16      num_pairs;
    PKERN_PAIR pkern_pair;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFkern (UW16 code, UW16 num_pairs, PKERN_PAIR pkern_pair)
#else
UW16 CGENTRY CGIFkern (code, num_pairs, pkern_pair)
    UW16      code;

    UW16      num_pairs;
    PKERN_PAIR pkern_pair;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
  UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = cgif_Kern(code, num_pairs, pkern_pair);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /* KERN */


#if IF_RDR
#if SEGACCESS
/*------------------*/
/*   CGIFsegments   */
/*------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFsegments (UW16 uCallerId, SL32 tfnum, UW16 key, LPUW16 psize, LPSB8 pbuffer)
#else
UW16 CGENTRY CGIFsegments (uCallerId, tfnum, key, psize, pbuffer)
    UW16        uCallerId;
    SL32        tfnum;
    UW16       key;
    LPUW16      psize;
    LPSB8       pbuffer;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFsegments (SL32 tfnum, UW16 key, LPUW16 psize, LPSB8 pbuffer)
#else
UW16 CGENTRY CGIFsegments (tfnum, key, psize, pbuffer)
    SL32        tfnum;
    UW16       key;
    LPUW16      psize;
    LPSB8       pbuffer;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16       status;
    PBUCKET     b;
    UW16       m;
    UW16       c;
    UW16       i;
    LPSB8       p;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

  /*  Load typeface  */

#if (DYNAMIC_FONTS && (SEGACCESS == 2))  /* 4-20-94 jfd */
   fcCur.font_id = 0;
   fcCur.font_hdr = (LPUB8)tfnum;
   fcCur.format = 0;
#endif
  
#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return ERR_segts_unsupported; /* no segment support for Convergent Fonts */
    }
#endif
    status = IXget_fnt_index(&fcCur);
    if(status)
    {
#if (MULTICALLER && SEM_ACCESS)
        release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        DBG1("IXget_fnt_index() failed: status %d\n", status);
        return status;
    }
    status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &b);
    if(status)
    {
#if (MULTICALLER && SEM_ACCESS)
        release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        DBG1("BUCKfind() failed: status %d\n", status);
        return status;
    }

  /* Get segment memory handle and size */

    switch (key)
    {
        case FACE_GLOBAL_KEY:              /* Entire face global segment */
                m = 0;
                c = b->p.in.sfgseg;
                break;
        case GIF_KEY:                      /* Global Intellifont segment */
                m = b->p.in.ogif;
                c = b->p.in.gifct;
                break;
        case TRACK_KERN_KEY:               /* track kerning              */
                m = b->p.in.otrack_kern_seg;
                c = b->p.in.strack_kern_seg;
                break;
        case TEXT_KERN_KEY:                /* text kerning               */
                m = b->p.in.otext_kern_seg;
                c = b->p.in.stext_kern_seg;
                break;
        case DESIGN_KERN_KEY:              /* designer kerning           */
                m = b->p.in.odesign_kern_seg;
                c = b->p.in.sdesign_kern_seg;
                break;
        case WIDTH_KEY:                    /* character width segment    */
                m = b->p.in.owidth_seg;
                c = b->p.in.swidth_seg;
                break;
        case ATTRIBUTE_KEY:                /* Attribute header           */
                m = b->p.in.oattribute;
                c = b->p.in.sattribute;
                break;
        case RASTER_KEY:                   /* Raster parameter           */
                m = b->p.in.orast;
                c = b->p.in.srast;
                break;
        case TF_HEADER_KEY:                /* Typeface Header segment    */
                m = b->p.in.otf_header_seg;
                c = b->p.in.stf_header_seg;
                break;
        case COMPOUND_KEY:                 /* Compound character         */
                m = b->p.in.ocompound_seg;
                c = b->p.in.scompound_seg;
                break;
        case DISPLAY_KEY:                  /* Display header             */
                m = b->p.in.odisplay;
                c = b->p.in.sdisplay;
                break;
        case FONT_ALIAS_KEY:               /* Font Alias segment         */
                m = b->p.in.ofont_alias_seg;
                c = b->p.in.sfont_alias_seg;
                break;
        case COPYRIGHT_KEY:                /* Copyright notice           */
                m = b->p.in.ocopy;
                c = b->p.in.scopy;
                break;
        default:
                return ERRinvalid_seg_key;
                break;
    }

  /* Return required buffer size or copy the data to caller's buffer */

    if(!pbuffer)
        *psize = c;
    else
    {
        if(c)
        {
            p = fgseg(b) + m;
            for(i=0; i<c; i++)
                *pbuffer++ = *p++;
        }
    }

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return SUCCESS;
}

#endif  /* SEGACCESS */
#endif  /* IF_RDR */




#if IF_RDR
#if PCLEO

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFpcleo (UW16 uCallerId, LPSB8 fileName, LPUL32 pcount)
#else
UW16 CGENTRY CGIFpcleo (uCallerId, fileName, pcount)
    UW16      uCallerId;
    LPSB8  fileName;
    LPUL32 pcount;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFpcleo (LPSB8 fileName, LPUL32 pcount)
#else
UW16 CGENTRY CGIFpcleo (fileName, pcount)
    LPSB8  fileName;
    LPUL32 pcount;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */
    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return ERR_pcleo_unsupported;  /* no pcleo support for Convergent Fonts */
    }
#endif
    status = IXget_fnt_index(&fcCur);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }

    status = PCLeo(fileName, pcount, fcCur.font_id);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}

#endif  /* PCLEO */
#endif  /* IF_RDR */


/*------------------*/
/*  CGIFfont_purge  */
/*-----------------------------*/
/*  CGIFcache_purge (obsolete) */
/*-----------------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfont_purge (UW16 uCallerId, PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFfont_purge (uCallerId, fc)
   UW16 uCallerId;
   PFONTCONTEXT fc;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfont_purge (PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFfont_purge (fc)
   PFONTCONTEXT fc;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;
    PBUCKET p_bucket;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
     return ERR_fontpurge_unsupported; /* not supported with Convergent Fonts */
    }
#endif /* CONVERGENT_FONTS */

#if CACHE
    status = CACpurge(fc);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }
#endif /* CACHE */

    status = IXget_fnt_index(fc);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }
    status = BUCKfind(TF_SENSITIVE, PURGE_BUCKET, &p_bucket);

   /*    7/15/93 - rs
      Make sure the if_state copy of the fontcontext is also gone!
      Our own local copy is guaranteed to be reset the next time
      CGIFfont() is called - and it better be called before asking
      for any more characters.
   */
    MEMSET (&fcCur, '\0', sizeof (FONTCONTEXT));
    MEMSET (&if_state.cur_loc_fc, '\0', sizeof (FONTCONTEXT));

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}

/*--------------------------*/
/*  CGIFhdr_font_purge      */
/*--------------------------*/
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFhdr_font_purge (UW16 uCallerId, PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFhdr_font_purge (uCallerId, fc)
   UW16 uCallerId;
   PFONTCONTEXT fc;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFhdr_font_purge (PFONTCONTEXT fc)
#else
UW16 CGENTRY CGIFhdr_font_purge (fc)
   PFONTCONTEXT fc;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;
    PBUCKET p_bucket;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
     return ERR_fontpurge_unsupported; /* not supported with Convergent Fonts */
    }
#endif /* CONVERGENT_FONTS */

#if CACHE
    status = CAChdr_purge(fc);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }
#endif /* CACHE */

    status = IXget_fnt_index(fc);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }
    status = BUCKfind(TF_SENSITIVE, PURGE_BUCKET, &p_bucket);

   /*    7/15/93 - rs
      Make sure the if_state copy of the fontcontext is also gone!
      Our own local copy is guaranteed to be reset the next time
      CGIFfont() is called - and it better be called before asking
      for any more characters.
   */
    MEMSET (&fcCur, '\0', sizeof (FONTCONTEXT));
    MEMSET (&if_state.cur_loc_fc, '\0', sizeof (FONTCONTEXT));

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}


#if PST1
/*----------------*/
/*    CGIFps      */
/*----------------*/

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFps (UW16 uCallerId, PPSPARAMSTR PPSparam_str)
#else
UW16 CGENTRY CGIFps (uCallerId, PPSparam_str)
    UW16 uCallerId;
    PPSPARAMSTR PPSparam_str;     /* 07-25-91 jfd */
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFps (PPSPARAMSTR PPSparam_str)
#else
UW16 CGENTRY CGIFps (PPSparam_str)
    PPSPARAMSTR PPSparam_str;     /* 07-25-91 jfd */
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16   status;

    PSparam_str = *PPSparam_str;  /* 07-25-91 jfd */

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MUTICALLER */

#if CONVERGENT_FONTS
    if (fcCur.p_AltWidTab)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return ERR_ps_unsupported;  /* no ps support for Convergent Fonts */
    }
#endif

    status = IXget_fnt_index(&fcCur);
    if (status)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return status;
    }

#if MULTICALLER
    status = ps_write(uCallerId);
#if SEM_ACCESS
    release_semaphore();
#endif /* SEM_ACCESS */
#else
    status = ps_write();
#endif /* MULTICALLER */

    return status;
}
#endif /* PST1 */

#if ROM
/*-------------------*/
/*  CGIFinitRomInfo  */
/*-------------------*/
/*  Use this routine to get the addresses of the IF.FNT and Uxx.SS into */
/*  ufst in a ROM based system.                                      */
#if MULTICALLER
#if defined (ANSI_DEFS)
GLOBAL SW16 CGIFinitRomInfo (UW16 uCallerId, LPUB8 fblock_ptr, LPUB8 ss_ptr[])
#else
GLOBAL SW16 CGIFinitRomInfo ( uCallerId, fblock_ptr, ss_ptr )
  UW16  uCallerId;
  LPUB8 fblock_ptr;
  LPUB8 ss_ptr[];
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
GLOBAL SW16 CGIFinitRomInfo (LPUB8 fblock_ptr, LPUB8 ss_ptr[])
#else
GLOBAL SW16 CGIFinitRomInfo ( fblock_ptr, ss_ptr )
  LPUB8 fblock_ptr;
  LPUB8 ss_ptr[];
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    int ii;

#if MULTICALLER
    UW16 status;

#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    fontindex.pfnt_index    = fblock_ptr;
    for (ii=0; ii<NSS_FILES; ii++)
        symbolset.pss_directory[ii] = ss_ptr[ii];

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return SUCCESS;
}

#endif  /* ROM */


#if TT_TTPLUG              /*  Using TrueType Universal plugin  */
/*-------------------*/
/*  CGIFtt_universal */
/*-------------------*/
/*  This function defines the current font as set by the last call
 *  to CGIFfont() as a plugin font.
 */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtt_universal (UW16 uCallerId, LPUB8 ptr, int rom_font)
#else
UW16 CGENTRY CGIFtt_universal (uCallerId, ptr, rom_font)
    UW16  uCallerId;
    LPUB8 ptr;
    int   rom_font;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtt_universal (LPUB8 ptr, int rom_font)
#else
UW16 CGENTRY CGIFtt_universal (ptr, rom_font)
    LPUB8 ptr;
    int   rom_font;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = set_tt_universal(ptr, rom_font);
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /*  TT_TTPLUG  */



#if FCO_RDR
/*----------------*/
/*  CGIFfco_Open  */
/*----------------*/
/*  This function reads a new Font Collection Object.
 *  fcName is the pointer to an FCO in ROM, or its pathname.
 *  FChandle is returned to the application.
 *  If status = error, then FChandle = is 0xFFFF
 *  If status = success, then FChandle = is between 0 and 0x7FFF;
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Open( UW16 uCallerId, LPUB8 fcName, LPSW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Open( uCallerId, fcName, FChandle )
    UW16 uCallerId;
    LPUB8 fcName;
    LPSW16 FChandle;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Open( LPUB8 fcName, LPSW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Open( fcName, FChandle )
    LPUB8 fcName;
    LPSW16 FChandle;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    int  fcoHandle;
    UW16 status;
    DBG("CGIFfco_Open()\n");

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = fco_InitFCO( &fcoHandle, fcName );
    if (status == SUCCESS)
        *FChandle = (SW16)fcoHandle;
    else
        *FChandle = 0xFFFF;

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */

    return status;
}


/*-----------------*/
/*  CGIFfco_Close  */
/*-----------------*/
/*  This function closes a Font Collection Object whose handle is FChandle.
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Close( UW16 uCallerId, SW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Close( uCallerId, FChandle )
    UW16 uCallerId;
    SW16 FChandle;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Close( SW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Close( FChandle )
    SW16 FChandle;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

    DBG("CGIFfco_Close()\n");

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)

      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = fco_DeleteFCO((int)FChandle);
#if (MULTICALLER && SEM_ACCESS)     /* mby|rk, 5-24-95 */
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */

    return status;
}


/*------------------*/
/*  CGIFfco_Plugin  */
/*------------------*/
/*  This function permanently selects an FCO where the plugins are located.
 *  The handle of the FCO is 'FChandle'.
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Plugin( UW16 uCallerId, SW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Plugin( uCallerId, FChandle )
    UW16 uCallerId;
    SW16 FChandle;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Plugin( SW16 FChandle )
#else
UW16 CGENTRY CGIFfco_Plugin( FChandle )
    SW16 FChandle;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

    DBG("CGIFfco_Plugin()\n");
#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    status = fco_saveHndl((int)FChandle);
#if (MULTICALLER && SEM_ACCESS)     /* mby|rk, 5-24-95 */
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */

    return status;
}



#if FCOACCESS

/*------------------*/
/*  CGIFfco_Access  */
/*------------------*/
/*  This function is used to access the selected typeface within the selected 
 *  FCO, and returns typeface specific information to the application.
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Access( UW16 uCallerId, LPUB8 fcPathName, UW16 fco_Index, UW16 Info_Key, LPUW16 psize, LPSB8 pbuffer )
#else
UW16 CGENTRY CGIFfco_Access( uCallerId, fcPathName, fco_Index, Info_Key, psize, pbuffer )
   UW16   uCallerId;
   LPUB8  fcPathName;
   UW16   fco_Index;
   UW16   Info_Key;
   LPUW16 psize;
   LPSB8  pbuffer;

#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFfco_Access( LPUB8 fcPathName, UW16 fco_Index, UW16 Info_Key, LPUW16 psize, LPSB8 pbuffer )
#else
UW16 CGENTRY CGIFfco_Access( fcPathName, fco_Index, Info_Key, psize, pbuffer )
   LPUB8  fcPathName;
   UW16   fco_Index;
   UW16   Info_Key;
   LPUW16 psize;
   LPSB8  pbuffer;

#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
#if MULTICALLER
   UW16 status;
#endif

   DBG("CGIFfco_Access\n");

#if MULTICALLER
#if SEM_ACCESS
   if (status = acquire_semaphore())
      return status;
#endif /* SEM_ACCESS */

   if(uCallerId != uLastCallerId)          /* use correct fontcontext */
      {
      status = INSTsetState(uCallerId);
      if (status)
         {
#if SEM_ACCESS
         release_semaphore();
#endif /* SEM_ACCESS */
         return status;
         }
      }
#endif /* MULTICALLER */

   return(fco_Access(fcPathName,fco_Index,Info_Key,psize,pbuffer));
}
#endif  /* FCOACCESS */



#if FCO_TT

/*------------------*/
/*  CGIFtt_Generate */
/*------------------*/
/*  This function generates a TrueType font.
 *  'ttgenFlg' is a flag that contains the platform and language info.
 *  'ttptr' is points to a memory block which contains the font.
 *  'ttHandle' is a handle associated with ttptr.
 *  'size_tt' is the size of the font. May be > 64K.
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
#if (HUGE_PTR_SUPPORT)
UW16 CGENTRY CGIFtt_Generate( UW16 uCallerId, UW16 ttgenFlg, LPSW16 ttHandle, LPHPUB8 ttptr, LPUL32 size_tt )
#else
UW16 CGENTRY CGIFtt_Generate( UW16 uCallerId, UW16 ttgenFlg, LPSW16 ttHandle, LPLPUB8 ttptr, LPUL32 size_tt )
#endif
#else
UW16 CGENTRY CGIFtt_Generate( uCallerId, ttgenFlg, ttHandle, ttptr, size_tt )
    UW16 uCallerId;
    UW16 ttgenFlg;
    LPSW16  ttHandle;
#if (HUGE_PTR_SUPPORT)
    LPHPUB8 ttptr;
#else
    LPLPUB8 ttptr;
#endif
    LPUL32 size_tt;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
#if (HUGE_PTR_SUPPORT)
UW16 CGENTRY CGIFtt_Generate( UW16 ttgenFlg, LPSW16 ttHandle, LPHPUB8 ttptr, LPUL32 size_tt )
#else
UW16 CGENTRY CGIFtt_Generate( UW16 ttgenFlg, LPSW16 ttHandle, LPLPUB8 ttptr, LPUL32 size_tt )
#endif
#else
UW16 CGENTRY CGIFtt_Generate( ttgenFlg, ttHandle, ttptr, size_tt )
    UW16    ttgenFlg;
    LPSW16  ttHandle;
#if (HUGE_PTR_SUPPORT)
    LPHPUB8 ttptr;
#else
    LPLPUB8 ttptr;
#endif
    LPUL32 size_tt;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    PBUCKET pBucket;
    UW16    status;
    DBG("CGIFtt_Generate\n");

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    if (!FC_ISFCO(&fcCur))
       {
#if (MULTICALLER && SEM_ACCESS)
       release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        return (ERR_fco_ttgen);
       }
       
    if ((status = IXget_fnt_index(&fcCur)) != SUCCESS)
       {
#if (MULTICALLER && SEM_ACCESS)
       release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        return status;
       }

    if ((status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &pBucket)) != SUCCESS)
       {
#if (MULTICALLER && SEM_ACCESS)
       release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        return status;
       }

    if ((status = fco_ttCreate(ttgenFlg, pBucket, ttHandle, ttptr, size_tt)) != SUCCESS)
       {
#if (MULTICALLER && SEM_ACCESS)
       release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        return status;
       }

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */

    return SUCCESS;
}

/*--------------*/
/*  CGIFtt_Free */
/*--------------*/
/*  Frees UFST dynamic memory associated with 'ttHandle'
 */

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtt_Free( UW16 uCallerId, LPSB8 ttPtr )

#else
UW16 CGENTRY CGIFtt_Free( uCallerId, ttPtr )
    UW16 uCallerId;
    LPSB8  ttPtr;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFtt_Free( LPSB8 ttPtr )
#else
UW16 CGENTRY CGIFtt_Free( ttPtr )
    LPSB8  ttPtr;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16 status;

    DBG("CGIFtt_Free\n");

#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */


#if defined(MSDOS) && !defined(CGFLAT32) && !defined (__STDC__)
    hfree (ttPtr);
#else
    free (ttPtr);
#endif

#if (MULTICALLER && SEM_ACCESS)     /* mby|rk, 5-24-95 */
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */

    return (0);
}
#endif  /* FCO_TT */
#endif  /* FCO_RDR */




/*****************************************************************/
/****                                                         ****/

#if FONTBBOX
/* BBoxRes is defined in "ix.h" */

#if IF_RDR
#if CGFIXED_PITCH
  /* union of slim plugins + f.p. plugins, normalized */
MLOCAL BBoxRes IFplugin = { { -1251, -2700, 9631, 8331 }, 8782 };
#else
  /* union of slim plugins, normalized */
MLOCAL BBoxRes IFplugin = { { -1251, -2196, 9631, 8331 }, 8782 };
#endif  /* CGFIXED_PITCH */
#if (PS_IFPLUG || TT_IFPLUG)
#if CGFIXED_PITCH
  /* union of 8 core fonts, slim plugins, & f.p. plugins, normalized */
MLOCAL BBoxRes IFCOREplugin = { { -2189, -2700, 10499, 8391 }, 8782 };
#else
  /* union of 8 core fonts & slim plugins, normalized */
MLOCAL BBoxRes IFCOREplugin = { { -2189, -2196, 10499, 8391 }, 8782 };
#endif  /* CGFIXED_PITCH */
#endif  /* (PS_IFPLUG || TT_IFPLUG) */
#if (TT_RDR && TT_TTPLUG_IF)
  /* TT Universal plugins in IF format, normalized */
MLOCAL BBoxRes TTplugin = { { -100, -2968, 8479, 8033 }, 8782 };
#endif
#endif  /* IF_RDR */

#if (TT_RDR && (TT_TTPLUG || (CONVERGENT_FONTS && MULTIFORMAT)))
  /* TT Universal plugins */
MLOCAL BBoxRes TTplugin = { { -23, -628, 1968, 1864 }, 2048 };
#endif

/* This is getting ridiculous. Set up the BBoxRes structs at init time?
 * For example, the data could be pulled from if.fnt. Anyway, it's not
 * the best idea to have the plugin bboxes as constants. mby 10/1/93
 */

#ifdef LINT_ARGS
MLOCAL VOID    bbox_union( BBoxRes*, BBoxRes* );
#if CONVERGENT_FONTS
MLOCAL UW16    get_awt_bbox( BBoxRes*, BBoxRes*, int* );
#endif
#if IF_PCLEOI
MLOCAL VOID    bbox_union_1( SW16, SW16, SW16, SW16, LPSW16, LPSW16, LPSW16, LPSW16 );
#endif
EXTERN UW16    comp_pix(PFONTCONTEXT, PBUCKET);

#else
MLOCAL VOID    bbox_union();
#if CONVERGENT_FONTS
MLOCAL UW16    get_awt_bbox();
#endif
#if IF_PCLEOI
MLOCAL VOID    bbox_union_1();
#endif
EXTERN UW16    comp_pix();
#endif

#if IF_RDR
#define IF_FLUFF  1
#else
#define IF_FLUFF  0
#endif
#if TT_RDR
#define TT_FLUFF  1
#else
#define TT_FLUFF  0
#endif
#if PST1_RDR
#define PS_FLUFF  1
#else
#define PS_FLUFF  0
#endif
#if FCO_RDR
#define FCO_FLUFFX  4
#define FCO_FLUFFY  5
#else
#define FCO_FLUFFX  0
#define FCO_FLUFFY  0
#endif

/*------------------*/
/*  CGIFbound_box   */
/*------------------*/
/*  This function returns an upper bound estimate of the font bounding box
 *  in output pixels. The estimate is not 100% guaranteed.
 */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbound_box( UW16 uCallerId, int FontBBox[4] )
#else
UW16 CGENTRY CGIFbound_box( uCallerId, FontBBox )
    UW16    uCallerId;
    int    *FontBBox;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbound_box( int FontBBox[4] )
#else
UW16 CGENTRY CGIFbound_box( FontBBox )
    int         *FontBBox;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
FPNUM   bboxDU_fp[4];
SW16VECTOR  bboxpt[4];          /* the 4 corners transformed (ll, ul, ur, lr) */
FPNUM   fScale;                 /* scale factor applied to matrix[] */
int     fluffFactor, fluffFactorY;
FPNUM   matrix[4];              /* matrix trsnsform from design to output */
PBUCKET pBucket;                /* of TFS font */
UW16    status;
BBoxRes tf_bbox;                /* b-box of TFS font */
BBoxRes plugin_bbox;            /* b-box encompassing all plugin fonts */
int     yes_plugins = 0;
int     ii, jj, nn;

#if MULTICALLER
#if SEM_ACCESS
    if (status = acquire_semaphore())
      return status;
#endif /* SEM_ACCESS */
    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)   goto BBOX_EXIT;         /* release semaphore; return status */
    }
#endif /* MULTICALLER */

    /* This function finds the bounding box of the TFS font,
     * ORs it with the bounding box of the plugin set, calls comp_pix()
     * to get the transformation matrix from design units into pixels,
     * and returns the transformed bounding box (with a fudge factor included.
     * Must call BUCKfind() because comp_pix() requires pBucket as an argument.
     */

#if CONVERGENT_FONTS
    if_state.awtsub_on = 0;  /* 7-12-94 */
    if (fcCur.p_AltWidTab)
    {
        SW16  tmp;
        if_state.awtsub_on = 1;  /* 7-12-94 */
        if ((status = CVFget_fnt_index(&fcCur, 0, CVF_SUBST_FNT, &tmp)) != SUCCESS)
            return status;
    }
    else
#endif  /* CONVERGENT_FONTS */
    {
        if ((status = IXget_fnt_index(&fcCur)) != SUCCESS)
            goto BBOX_EXIT;
    }

    if ((status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &pBucket)) != SUCCESS)
        goto BBOX_EXIT;

#if CONVERGENT_FONTS    /* Intellifont Convergent Fonts */
    if (fcCur.p_AltWidTab)
    {
        fcCur.format &= ~FC_FONTTYPE_MASK;
        fcCur.format |= pBucket->fst_type;
        yes_plugins = 1;
        if ((status = get_awt_bbox(&tf_bbox, &plugin_bbox, &fluffFactor)) != SUCCESS)
            goto BBOX_EXIT;
        fluffFactorY = fluffFactor;
        DBG5("AWT BBox in design units (%d):  { %d, %d, %d, %d }\n",
             tf_bbox.emRes, tf_bbox.BBox[0], tf_bbox.BBox[1], tf_bbox.BBox[2], tf_bbox.BBox[3]);
        DBG5("Plugin BBox in design units (%d):  { %d, %d, %d, %d }\n",
             plugin_bbox.emRes, plugin_bbox.BBox[0], plugin_bbox.BBox[1], plugin_bbox.BBox[2], plugin_bbox.BBox[3]);
    }
    else
#endif  /* CONVERGENT_FONTS */

    {   /* normal font (non-convergent) */

/* xxget_FontBBox() is an FST specific function that returns the TFS font
 * bounding box and design resolution in design units, with the composition
 * origin at (0,0) (the Intellifont b-box coordinates must be normalized.)
 * bbox_union() unions the TFS b-box and the plugin b-box, when applicable.
 */
    switch (pBucket->fst_type)
    {
#if IF_RDR
        case FC_IF_TYPE:
            if ((status = ifget_FontBBox(pBucket, &tf_bbox)) != SUCCESS)
                goto BBOX_EXIT;
#if FCO_RDR
            /* IF font uses FCO plugins */
            if ((status = fco_get_FontBBox(pBucket, tf_bbox.emRes, &plugin_bbox)) != SUCCESS)
                goto BBOX_EXIT;
#else
            plugin_bbox = IFplugin;
#if MULTIFORMAT
            if (pBucket->bucket_num & B_PLUGIN_TYPE_TT)
                plugin_bbox = TTplugin;
#endif
#endif  /* !FCO_RDR */
            yes_plugins = 1;
            fluffFactorY = fluffFactor = IF_FLUFF;

            DBG5("IF BBox in design units (%d):  { %d, %d, %d, %d }\n",
                 tf_bbox.emRes, tf_bbox.BBox[0], tf_bbox.BBox[1], tf_bbox.BBox[2], tf_bbox.BBox[3]);
            break;
#endif  /**** IF_RDR ****/

#if TT_RDR
        case FC_TT_TYPE:
            if ((status = ttget_FontBBox(pBucket, &tf_bbox)) != SUCCESS)
                goto BBOX_EXIT;
#if FCO_RDR
            /* TT font uses FCO plugins */
            if ((status = fco_get_FontBBox(pBucket, tf_bbox.emRes, &plugin_bbox)) != SUCCESS)
                goto BBOX_EXIT;
            yes_plugins = 1;
#else
#if TT_TTPLUG_ANY
            plugin_bbox = TTplugin;
            yes_plugins = 1;
#endif
#if TT_IFPLUG
            plugin_bbox = IFCOREplugin;
            yes_plugins = 1;
#endif
#endif  /* !FCO_RDR */
            fluffFactorY = fluffFactor = TT_FLUFF;
            fScale = fpint2fp( ((SL32)tf_bbox.emRes) );
            break;
#endif  /**** TT_RDR ****/

#if PST1_RDR
        case FC_PST1_TYPE:
            if ((status = psget_FontBBox(pBucket, &tf_bbox)) != SUCCESS)
                goto BBOX_EXIT;
#if PS_IFPLUG
            plugin_bbox = IFCOREplugin;
            yes_plugins = 1;
#endif
            fluffFactorY = fluffFactor = PS_FLUFF;
            fScale = fpint2fp( ((SL32)tf_bbox.emRes) );
            break;
#endif  /* PST1_RDR */

#if FCO_RDR
        case FC_FCO_TYPE:
            if ((status = fco_get_FontBBox(pBucket, 0, &tf_bbox)) != SUCCESS)
                goto BBOX_EXIT;
            fluffFactor = FCO_FLUFFX;
            fluffFactorY = FCO_FLUFFY;
            yes_plugins = 0;    /* font bbox already includes plugin faces */
            break;
#endif  /* FCO_RDR */

        default:
            status = ERRfont_bbox;
            goto BBOX_EXIT;
    }   /*** end of switch (pBucket->fst_type) ***/
   }  /* not Convergent Font */

    if (yes_plugins)
        bbox_union(&tf_bbox, &plugin_bbox);

    DBG5("BBox in design units (%d):  { %d, %d, %d, %d }\n",
         tf_bbox.emRes, tf_bbox.BBox[0], tf_bbox.BBox[1], tf_bbox.BBox[2], tf_bbox.BBox[3]);

    for (ii=0; ii<4; ii++)      /* convert to floating point */
        bboxDU_fp[ii] = fpint2fp((SL32)tf_bbox.BBox[ii]);

    /* Force fontcontext matching to fail so that comp_pix() is executed in full, 10-18-94 */
    if_state.cur_loc_fc.font_id = 0;
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
    if_state.cur_loc_fc.font_hdr =  (LPUB8)0;
#endif
#if SLIM_FONTS
    chr_def_hdr.mirror_flags = 0;   /* Force comp_pix() to produce */
#endif                              /* a nonmirrored "if_state.m"  */

    if ((status = comp_pix(&fcCur, pBucket)) != SUCCESS)   /* transf matrix */
        goto BBOX_EXIT;

    /* This has to be done after comp_pix()! - 6-27-95 */
    if (pBucket->fst_type == FC_FCO_TYPE || pBucket->fst_type == FC_IF_TYPE)
        fScale = fpint2fp( ((SL32)if_state.x.pixel_size) );

    for (ii=0; ii<4; ii++)  /* matrix[] scales from design units to pixels */
        matrix[ii] = fpdiv(if_state.m[ii], fScale);

#ifdef DEBUG
    printf("Transformation Matrix:  ");
    fpprint(matrix[0]);
    fpprint(matrix[1]);
    fpprint(matrix[2]);
    fpprint(matrix[3]);
    printf("\n");
#endif  /* DEBUG */

    /* Transform the 4 corners of the font bbox. Find the
     * new min and max x, y from the 4 transformed points. */
    for (nn=0, ii=0; ii<4; ii += 2)
    {
        for (jj=1; jj<4; jj += 2, nn++)
        {
            bboxpt[nn].x = fp2word( fpadd( fpmul( bboxDU_fp[ii], matrix[0] ),
                                           fpmul( bboxDU_fp[jj], matrix[2] ) ) );
            bboxpt[nn].y = fp2word( fpadd( fpmul( bboxDU_fp[ii], matrix[1] ),
                                           fpmul( bboxDU_fp[jj], matrix[3] ) ) );
        }
    }

/* Add fudge factor to account for roundoff or truncation when
 * converting floating point to integer. The integer bounding box shall in
 * no case be smaller than the f.p. bbox.
 */
    FontBBox[0] = FontBBox[1] = MAX_WORD;
    FontBBox[2] = FontBBox[3] = MIN_WORD;
    for (ii=0; ii<4; ii++)
    {
        if (bboxpt[ii].x - (fluffFactor + 1) < FontBBox[0])
            FontBBox[0] = bboxpt[ii].x - (fluffFactor + 1);
        if (bboxpt[ii].y - (fluffFactorY + 1) < FontBBox[1])
            FontBBox[1] = bboxpt[ii].y - (fluffFactorY + 1);
        if (bboxpt[ii].x + (fluffFactor + 1) > FontBBox[2])
            FontBBox[2] = bboxpt[ii].x + (fluffFactor + 1);
        if (bboxpt[ii].y + (fluffFactorY + 1) > FontBBox[3])
            FontBBox[3] = bboxpt[ii].y + (fluffFactorY + 1);
    }

    status = SUCCESS;


BBOX_EXIT:
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}




/*
 * bbox_union
 *
 * Unions two b-box structures. If the design resolutions are
 * different, converts the plugin b-box to tfs units.
 */
#if defined (ANSI_DEFS)
MLOCAL VOID  bbox_union( BBoxRes* tfs, BBoxRes* plug )
#else
MLOCAL VOID  bbox_union(tfs, plug)
  BBoxRes *tfs, *plug;
#endif /* ANSI_DEFS */
{
int     ii;

    for (ii=0; ii<4; ii++)
    {
        if (tfs->emRes != plug->emRes)
        {
            plug->BBox[ii] = (int)((plug->BBox[ii] * (SL32)tfs->emRes) / plug->emRes);
            if (ii < 2)
                plug->BBox[ii]--;
            else
                plug->BBox[ii]++;
        }

        if (ii < 2) {
            if (plug->BBox[ii] < tfs->BBox[ii])
                tfs->BBox[ii] = plug->BBox[ii];
        }
        else {
            if (plug->BBox[ii] > tfs->BBox[ii])
                tfs->BBox[ii] = plug->BBox[ii];
        }
    }
}




#if PST1_RDR

/* psget_FontBBox
 *
 * Returns font bbox and design resolution.
 * Do full implementation later - 1/29/93.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  psget_FontBBox( PBUCKET pBucket, BBoxRes* basefont)
#else
GLOBAL UW16  psget_FontBBox( pBucket, basefont )
PBUCKET pBucket;
BBoxRes* basefont;
#endif
{
   /* If font bounding box information has not been stored,
    * initialize it to -2000,, -2000, 2000, 2000, 1000
    */

    if (!pBucket->p.ps.FontBBox[0] && !pBucket->p.ps.FontBBox[1] &&
        !pBucket->p.ps.FontBBox[2] && !pBucket->p.ps.FontBBox[3])
    {
       basefont->BBox[0] = basefont->BBox[1] = -2000;
       basefont->BBox[2] = basefont->BBox[3] = 2000;
    }
    else
    {
       basefont->BBox[0] = pBucket->p.ps.FontBBox[0];
       basefont->BBox[1] = pBucket->p.ps.FontBBox[1];
       basefont->BBox[2] = pBucket->p.ps.FontBBox[2];
       basefont->BBox[3] = pBucket->p.ps.FontBBox[3];
    }
    basefont->emRes = 1000;
    return SUCCESS;
}
#endif  /* PST1_RDR */




#if IF_PCLEOI

#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbbox_IFPCLEOchar( UW16 uCallerId, LPUB8 pchar_data,
                                 LPUB8 pfont_hdr, LPUW16 badCharList )
#else
UW16 CGENTRY CGIFbbox_IFPCLEOchar( uCallerId, pchar_data, pfont_hdr, badCharList )
   UW16    uCallerId;
   LPUB8   pchar_data;
   LPUB8   pfont_hdr;
   LPUW16  badCharList;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFbbox_IFPCLEOchar( LPUB8 pchar_data,
                                 LPUB8 pfont_hdr, LPUW16 badCharList )
#else
UW16 CGENTRY CGIFbbox_IFPCLEOchar( pchar_data, pfont_hdr, badCharList )
   LPUB8   pchar_data;
   LPUB8   pfont_hdr;
   LPUW16  badCharList;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    int  ii;
    int  numMissing = 0;
    int  numPieces;
    SW16 xmin, ymin, xmax, ymax;
    LPUW16 pchr;

#if MULTICALLER
    UW16 status;

#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)          /* use correct fontcontext */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    if (pfont_hdr[2] != CGIFP_IF_SCALABLE || pchar_data[0] != CGIFP_IF_SCALABLE)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return (UW16)0xFFFF;      /* Not Intellifont! */
    }

    switch (pchar_data[3])
    {
      case 3:         /* Intellifont Scalable Character */
        bbox_SimpleChar(pchar_data, &xmin, &ymin, &xmax, &ymax);
        break;

      case 4:         /* Intellifont Scalable Compound Character */
        numPieces = pchar_data[6];      /* only 1 byte! */
        pchr = (LPUW16)(pchar_data + 8);
        for (ii=0; ii<numPieces; ii++)  /* analyze each component */
        {
            UW16 charcode;
            LPUB8 componentPtr;
            charcode = *pchr++;
            componentPtr = PCLEO_charptr(pfont_hdr, charcode);
            if (!componentPtr)
            {
                badCharList[numMissing++] = charcode;
                if (numMissing == CGIFP_MAX_BADCHARS)
                {
#if (MULTICALLER && SEM_ACCESS)
                  release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
                  return (UW16)numMissing;
                }
                else
                    pchr += 2;
            }
            else
            {
                if (componentPtr[0] != CGIFP_IF_SCALABLE || componentPtr[3] != 3)
                {
#if (MULTICALLER && SEM_ACCESS)
                  release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
                  return 0xFFFF;      /* Components of a c.c. cannot */
                }
                                        /* themselves be compound.     */
                bbox_SimpleChar(componentPtr, &xmin, &ymin, &xmax, &ymax);
                xmin += (SW16)(*pchr); xmax += (SW16)(*pchr++); /* x-offset */
                ymin += (SW16)(*pchr); ymax += (SW16)(*pchr++); /* y-offset */
            }
        }       /* for (ii ...  */
        break;

      default:
#if (MULTICALLER && SEM_ACCESS)
        release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
        return (UW16)0xFFFF;    /* corrupt data */
    }
    if (numMissing)
    {
#if (MULTICALLER && SEM_ACCESS)
      release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
      return (UW16)numMissing;
    }

    /* Union the character's bounding box with the 4 words in the PCLEO hdr. */
    bbox_union_1( xmin, ymin, xmax, ymax,
                  (LPSW16)(pfont_hdr+TEXT_WIDTH),
                  (LPSW16)(pfont_hdr+TEXT_HEIGHT),
                  (LPSW16)(pfont_hdr+CELL_WIDTH),
                  (LPSW16)(pfont_hdr+CELL_HEIGHT) );
#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return SUCCESS;
}


#if defined (ANSI_DEFS)
MLOCAL VOID bbox_SimpleChar( LPUB8 pchar_data,
                             LPSW16 xmin, LPSW16 ymin,
                             LPSW16 xmax, LPSW16 ymax )
#else
MLOCAL VOID bbox_SimpleChar( pchar_data, xmin, ymin, xmax, ymax )
  LPUB8   pchar_data;
  LPSW16  xmin, ymin, xmax, ymax;
#endif /* ANSI_DEFS */
{
    LPSW16 pMetrics;
    SW16   origin_x, origin_y;

    pMetrics = (LPSW16)(pchar_data + 4 + *(LPUW16)(pchar_data + 6));
    origin_x = *(pMetrics + 4);
    origin_y = *(pMetrics + 5);
    *xmin = *pMetrics - origin_x;
    *ymin = *(pMetrics+1) - origin_y;
    *xmax = *(pMetrics+2) - origin_x;
    *ymax = *(pMetrics+3) - origin_y;
}


#if defined (ANSI_DEFS)
MLOCAL VOID bbox_union_1( SW16 xmin, SW16 ymin, SW16 xmax, SW16 ymax,
                          LPSW16 pxmin, LPSW16 pymin, LPSW16 pxmax, LPSW16 pymax )
#else
MLOCAL VOID bbox_union_1( xmin, ymin, xmax, ymax, pxmin, pymin, pxmax, pymax )
   SW16   xmin,  ymin,  xmax,  ymax;
   LPSW16 pxmin, pymin, pxmax, pymax;
#endif /* ANSI_DEFS */
{
if (xmin < *pxmin)  *pxmin = xmin;
if (ymin < *pymin)  *pymin = ymin;
if (xmax > *pxmax)  *pxmax = xmax;
if (ymax > *pymax)  *pymax = ymax;
}

#endif  /* IF_PCLEOI */



#if CONVERGENT_FONTS

/*
 *  SWAPW and SWAPL macros.
 */
#if  BYTEORDER == HILO
#define SWAPL(a)        (a)
#define SWAPW(a)        (a)

#else   /* BYTEORDER == LOHI */
#define SWAP2BYTE(p)  ( ((unsigned short)((p)[0]) << 8) |  (p)[1])
#define SWAP4BYTE(p)  ( ((SWAP2BYTE(p)+0L) << 16) | SWAP2BYTE((p)+2) )
#define SWAPW(a)      ((short) SWAP2BYTE( (unsigned char*)(&a) ))
#define SWAPL(a)      ((long)  SWAP4BYTE( (unsigned char*)(&a) ))
#endif

#define  AWT_XMIN    40     /* Font bounding box -- combination of       */
#define  AWT_YMIN    42     /*   substitute typeface, supersensitive     */
#define  AWT_XMAX    44     /*   typeface, global horizontal adjustment, */
#define  AWT_YMAX    46     /*   and HOC table.                          */

#if defined (ANSI_DEFS)
MLOCAL UW16  get_awt_bbox( BBoxRes* tf_bbox, BBoxRes* plugin_bbox,
                           int* fluffFactor )
#else
MLOCAL UW16  get_awt_bbox( tf_bbox, plugin_bbox, fluffFactor )
   BBoxRes  *tf_bbox;
   BBoxRes  *plugin_bbox;
   int      *fluffFactor;
#endif /* ANSI_DEFS */
{
#if IF_RDR
#if (CONVERGENT_FONTS == 1)   /* Read font bbox out of the AWT header */
    LPUB8   pAwt;

    pAwt = awtData.awtPtr;
    tf_bbox->BBox[0] = SWAPW(*((LPUW16)(pAwt + AWT_XMIN)));
    tf_bbox->BBox[1] = SWAPW(*((LPUW16)(pAwt + AWT_YMIN)));
    tf_bbox->BBox[2] = SWAPW(*((LPUW16)(pAwt + AWT_XMAX)));
    tf_bbox->BBox[3] = SWAPW(*((LPUW16)(pAwt + AWT_YMAX)));
    tf_bbox->emRes = awtData.scaleFactor;
    *fluffFactor = IF_FLUFF;
#if MULTIFORMAT
    if (!awtData.useIFplugins)
    {           /* use TT plugins in either IF or TT format */
        *plugin_bbox = TTplugin;
#if (TT_RDR && TT_TTPLUG)
        *fluffFactor = MAX(IF_FLUFF, TT_FLUFF); /* use TT plugins in TT format */
#endif
    }
    else
#endif  /* MULTIFORMAT */
        *plugin_bbox = IFplugin;

    return SUCCESS;

#else   /* CONVERGENT_FONTS == 3 */
        /* Make font bbox by combining from Substitute & Supersensitive fonts */
    BBoxRes bboxR;
    PBUCKET pBucket;
    UW16    status;
    SW16    tmp;

    /* Load AWT & setup fontindex members, but do not map any chars */
    if ((status = CVFget_fnt_index(&fcCur, 0, CVF_SUBST_FNT, &tmp)) != SUCCESS)
        return status;
    if ((status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &pBucket)) != SUCCESS)
        return status;
    switch (pBucket->fst_type)
    {
        case FC_IF_TYPE:
            if ((status = ifget_FontBBox(pBucket, tf_bbox)) != SUCCESS)
                return status;
            break;
        default:
            return ERRfont_bbox;
    }

    if ((status = CVFget_fnt_index(&fcCur, 0, CVF_REQU_FNT, &tmp)) != SUCCESS)
        return status;
    if (!fontindex.noTFS)
    {
        if ((status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &pBucket)) != SUCCESS)
            return status;
        switch (pBucket->fst_type)
        {
            case FC_IF_TYPE:
                if ((status = ifget_FontBBox(pBucket, &bboxR)) != SUCCESS)
                    return status;
                *fluffFactor = IF_FLUFF;
#if MULTIFORMAT
                if (!awtData.useIFplugins)
                {
                    *plugin_bbox = TTplugin;
                    *fluffFactor = MAX(IF_FLUFF, TT_FLUFF); /* use TT plugins in TT format */
                }
                else
#endif
                    *plugin_bbox = IFplugin;
                break;
            default:
                return ERRfont_bbox;
        }
        bbox_union(tf_bbox, &bboxR);
    }
    return SUCCESS;

#endif  /* CONVERGENT_FONTS == 3 */

#else   /* !IF_RDR */

    return ERRfont_bbox;
#endif  /* IF_RDR */

}

#endif  /* CONVERGENT_FONTS */
#endif  /* FONTBBOX */

#if NO_SYMSET_MAPPING
/*----------------------*/
/*    CGIFchIdptr       */
/*----------------------*/
/*  Store a pointer to the chId in IF_STATE. This will be used if
 *  syymbol set mapping has been removed (NO_SYMSET_MAPPING).
 */
#if MULTICALLER
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchIdptr(UW16 uCallerId, VOID *chId, VOID *PSchar_name)
#else
UW16 CGENTRY CGIFchIdptr(uCallerId, chId, PSchar_name)
    UW16       uCallerId;
    VOID      *chId;
    VOID      *PSchar_name;
#endif /* ANSI_DEFS */
#else /* !MULTICALLER */
#if defined (ANSI_DEFS)
UW16 CGENTRY CGIFchIdptr(VOID *chId, VOID *PSchar_name)
#else
UW16 CGENTRY CGIFchIdptr(chId, PSchar_name)
    VOID      *chId;
    VOID      *PSchar_name;
#endif /* ANSI_DEFS */
#endif /* MULTICALLER */
{
    UW16      status;

    status = SUCCESS;
#if MULTICALLER
#if SEM_ACCESS
  if (status = acquire_semaphore())
    return status;
#endif /* SEM_ACCESS */

    if(uCallerId != uLastCallerId)   /* use correct font context */
    {
      status = INSTsetState(uCallerId);
      if (status)
      {
#if SEM_ACCESS
        release_semaphore();
#endif /* SEM_ACCESS */
        return status;
      }
    }
#endif /* MULTICALLER */

    DBG1("CGIFchIdptr(%u)\n", chId);

    if_state.chIdptr = chId;
#if PST1_RDR
    if_state.PSchar_name = PSchar_name;
#endif  /* PST1_RDR */

#if (MULTICALLER && SEM_ACCESS)
    release_semaphore();
#endif /* (MULTICALLER && SEM_ACCESS) */
    return status;
}
#endif  /*  NO_SYMSET_MAPPING  */

#if PST1_RDR
/*----------------------------------------------------------------*/
/*  Meto_get Type1 font mapping status   jqz 6-24-97 for Meto Use */
/*----------------------------------------------------------------*/
MLOCAL UW16 Meto_get_status(chId, ppbm, phbm)

UW16       chId;
PPIFBITMAP ppbm;
PHIFBITMAP phbm;
{
	UW16 status;

	*phbm = NIL_MH;
	status = CGIFchar_handle(chId, (PHIFBITMAP)phbm, (SW16)0);
	if(*phbm)

	{
		CHARfree(*phbm);
		*phbm=NIL_MH;
	}
	return status;
}
#endif
