/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/dep/extmem.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: extmem.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.14   07 Apr 1995 08:37:06   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.13   13 Jan 1995 18:06:18   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.12   07 Nov 1994 15:41:52   ROB
 * Modifications in allocation levels for Windows.
 * 
 *    Rev 1.11   17 Sep 1994 15:37:54   JOE
 * 
 * In MEMalloc(), if BORLAND, call _fmalloc() instead of halloc().
 * 
 *    Rev 1.10   21 Apr 1994 15:43:08   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.9   22 Feb 1994 16:36:10   JOE
 * 
 * In MEMalloc() and MEMfree(), if running on _AM29K system under UNIX,
 * must 8-byte align due to Type 1 structures containing "double" fields.
 * 
 *    Rev 1.8   04 Feb 1994 17:46:34   MIKE
 * 
 * Changed buffer from 250,000 to 2,500,000 bytes - gy.
 * 
 *    Rev 1.7   02 Feb 1994 08:55:44   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.6   09 Dec 1993 12:16:04   MIKE
 * 
 * If ASIAN_ENCODING make buffer pool 250000 bytes.
 * 
 *    Rev 1.5   08 Dec 1993 18:57:36   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.4   22 Apr 1993 16:22:18   JOE
 * Changed conditional compile directive used for setting sizes to #if
 * MSDOS && !__FLAT.
 * 
 *    Rev 1.3   12 Feb 1993 14:02:20   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   17 Dec 1992 15:40:04   ROB
 * Added ANSI_DEFS, made sizes depend on (MSDOS & !__FLAT) instead of just
 * UNIX vs !UNIX - caused problems for i960, etc when no unix is involved.
 * 
 *    Rev 1.1   11 Dec 1992 15:31:08   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:25:50   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/*  extmem.c  */
/*
 * History
 *
 *    04-Sep-91  jfd   Internal memory management routines extraced from
 *                     mem.c.
 *     1 Nov 91  ss    deleted VOID arg to MEMinit().
 *                     Added include sys/types.h for UNIX, has typedef size_t
 *    27-Jan-92  rs    Modify sizes of memory pools in 'MEMinit()'.
 *    27-Feb-92  jfd   Moved "#if !INT_MEM_MGT" statement to top of file.
 *    11-Mar-92  rs    Changed conditionals 'MSC' to 'MSDOS'.
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    13 Jul 92  ss    Changed conditional compiles in MEMinit() from SPARC
 *                     to UNIX.
 *    10-Aug-92  rs    Changes for Watcom C386, don't call halloc() or hfree().
 *    14-Aug-92  jfd   In MEMinit(), changed size of BUFFER_POOL to
 *                     120K for UNIX else 60K.
 *    25-Sep-92  jfd   INTEL960 conditional compiles.
 *    03-Oct-92  rs    Changes toward ANSI C - no 'halloc()' in MEMalloc()
 *                     and MEMfree().
 *    14-Oct-92  jfd   In MEMinit(), changed conditional compile to
 *                     "#if defined(UNIX) || defined(__i960)" for INTEL960.
 *    15-Nov-92  rs    Port to Macintosh - include <stdlib.h>.
 *    17-Dec-92  rs    add function declarations based on ANSI_DEFS.
 *                     Reverse setting of sizes in MEMinit() based on
 *                     "MSDOS & !__FLAT".
 *    08-Feb-93  jfd   VXWorks support.
 *    22-Apr-93  jfd   Corrected conditional compiler directive for setting
 *                     sizes (changed it to MSDOS & !__FLAT).
 *    08-Dec-93  rs    General cleanup - MSDOS & FLAT -> CGFLAT32.
 *    08-Dec-93  gy/my If ASIAN_ENCODING increase buffer pool to 250000
 *    28-Jan-94  jfd   Conditionally compiled out #include for "sys/types.h"
 *                     based on !defined(_AM29K).
 *    17-Feb-94  jfd   In MEMalloc() and MEMfree(), if running on _AM29K
 *                     system under UNIX, must 8-byte align due to PS
 *                     structures containing "double" fields.
 *    17-Sep-94  jfd   In MEMalloc(), if BORLAND, call _fmalloc() instead
 *                     of halloc().
 *    02-Nov-94  rob   Modify allocation levels for Windows & TT generator.
 *    12-Jan-95  rob   Add support for > 64KB blocks of memory in DOS.
 */
 
#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "cgconfig.h"

#if !INT_MEM_MGT   /*  not INT_MEM_MGT  */

#include "port.h"
#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"

#ifdef UNIX
#if !defined(_AM29K)
#include <sys/types.h>   /* added, after port.h for UNIX define -ss 11/1/91 */
#endif
#endif



#define MEM_TRACE    0      /* set to 1 to trace MEMalloc() & MEMfree() */
#define MEM_DUMP     0      /* set to 1 to trace memory alloc and free  */


/*
The memory manager must handle two memory pools. The pools are referenced
by the defines in cgif.h:

        #define CACHE_POOL   0
        #define BUFFER_POOL  1

Each pool is funded with a number of bytes of memory stored in mem_fund[].
During operation, some of this memory will be given to clients via
MEMalloc() to be later returned via MEMfree(). The number of bytes that
are still availble is stored in mem_avail[]. Thus calls to MEMalloc()
decrease mem_avail[] while calls to MEMfree() increase mem_avail[].
If the number of bytes requested through MEMalloc() is more than
mem_avail[], the request fails and NIL_MH is returned.

*/

#define NP    2                /* number of memory pools      */
GLOBAL SL32   mem_fund[NP];    /* Total memory in each pool   */
MLOCAL SL32   mem_avail[NP];   /* Available memory in pool    */


/*
The memory management option supported below is compiled depending on the
setting in cgconfig.h of INT_MEM_MGT. If INT_MEM_MGT is disabled, the
external memory management option is enabled.

The external memory manager relies on external functions for dynamic
allocation.

Either the external or internal memory manager may by used. The external
memory manager may be modified to use other external allocation functions.

The two memory managers differ in the way that their pool memory is
funded. The internal manager is funded via a function CGIFfund().
The external manager's fund sizes are simply set in MEMinit().
*/



/*--------------------------------------------------------------------*/
/*          E x t e r n a l    M e m o r y    m a n a g e r           */
/*
This external memory manager uses malloc() and free() for dynamic
allocation. You may modify to use different allocation functions.
*/

/* tnc */
#if defined( LAMIGA ) || defined (__i960) || defined(VXWORKS)
#include <stdlib.h>
#include <sys/types.h>
#elif defined (MACINTOSH)
#include <stdlib.h>
#else
#include <malloc.h>
#endif



/*----------------*/
/*  MEMinit       */
/*----------------*/
/* Application should set these fund sizes */
#if defined (ANSI_DEFS)
GLOBAL VOID MEMinit()
#else
GLOBAL VOID
MEMinit()     /* deleted arg of VOID -ss 11/1/91 */
#endif
{
/* Application should set these fund sizes */

/*#if defined(_WINDOWS)
    mem_avail[CACHE_POOL]   = 35000L;
    mem_fund[CACHE_POOL]    = 35000L;
    mem_avail[BUFFER_POOL]  = 500000L;
    mem_fund[BUFFER_POOL]   = 500000L;
#elif defined(MSDOS) && !defined(CGFLAT32) && !(HUGE_PTR_SUPPORT)
    mem_avail[CACHE_POOL]   = 35000L;
    mem_fund[CACHE_POOL]    = 35000L;
    mem_avail[BUFFER_POOL]  = 60000L;
    mem_fund[BUFFER_POOL]   = 60000L;
#elif defined(MSDOS) && !defined(CGFLAT32) && (HUGE_PTR_SUPPORT)
    mem_avail[CACHE_POOL]   = 30000L;
    mem_fund[CACHE_POOL]    = 30000L;
    mem_avail[BUFFER_POOL]  = 150000L;
    mem_fund[BUFFER_POOL]   = 150000L;
#else
    mem_avail[CACHE_POOL]   = 70000L;
    mem_fund[CACHE_POOL]    = 70000L;
    mem_avail[BUFFER_POOL]  = 120000L;
    mem_fund[BUFFER_POOL]   = 120000L;
#if ASIAN_ENCODING
    mem_avail[BUFFER_POOL]  = 2500000L;
    mem_fund[BUFFER_POOL]   = 2500000L;
#endif
#endif*/

	mem_avail[CACHE_POOL]  = 0x00400000;	/* 2MB */
	mem_fund[CACHE_POOL]   = 0x00400000; 	/* 2MB */
	mem_avail[BUFFER_POOL] = 0x00800000;	/* 4MB */
	mem_fund[BUFFER_POOL]  = 0x00800000;	/* 4MB */
}



/*----------------*/
/*  MEMalloc      */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL MEM_HANDLE MEMalloc(UW16 pool, SL32 size)
#else
GLOBAL MEM_HANDLE
MEMalloc(pool, size)
    UW16  pool;
    SL32  size;
#endif
{
    LPSB8 p;

#if defined(_AM29K) && defined(UNIX)

  /*  Make room for "size" and round up for 8-byte alignment. This is
   *  necessary for _AM29K systems running under UNIX. - jfd 2-17-94
   */

    size += ( sizeof( SL32 ) + sizeof( SL32 ) + (MEM_ALIGN + 4));  /* MEMHEAD.size is long -ss */
    size &= ~(MEM_ALIGN + 4);
#else

  /*  Make room for "size" and round up for alignment */

    size += sizeof( SL32 ) + MEM_ALIGN;    /* MEMHEAD.size is long -ss */
    size &= ~MEM_ALIGN;
#endif

    if(mem_avail[pool] < size)
        return (MEM_HANDLE)0;

#if defined(MSDOS) && !defined(CGFLAT32) && !defined (__STDC__)
#if defined(__BORLANDC__)
     p = (LPSB8)_fmalloc((long)size);
#else    
     p = (LPSB8)halloc((long)size, 1);
#endif   
#else
    p = malloc((size_t)size);
#endif
    if (p)
    {
        mem_avail[pool] -= size;
        *((LPSL32)p) = size;
#if defined(_AM29K) && defined(UNIX)
        p += (sizeof(SL32) + sizeof(SL32));
#else
        p += sizeof(SL32);
#endif
    }

    return p;
}




/*----------------*/
/*  MEMfree       */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID MEMfree(UW16 pool, MEM_HANDLE hm)
#else
GLOBAL VOID
MEMfree(pool, hm)
    UW16      pool;
    MEM_HANDLE hm;
#endif
{
    if(!hm) return;

#if defined(_AM29K) && defined(UNIX)
    hm -= (sizeof(SL32) + sizeof(SL32));
#else
    hm -= sizeof(SL32);
#endif
    mem_avail[pool] += *((LPSL32)hm);
#if defined(MSDOS) && !defined(CGFLAT32) && !defined (__STDC__)
    hfree(hm);
#else
    free(hm);
#endif
}




#if MEM_TRACE
/*----------------*/
/*  MEMstat       */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID MEMstat(UW16 pool)
#else
GLOBAL VOID
MEMstat(pool)
    UW16 pool;
#endif
{
    DBG1("MEMstat pool %u\n",i);
    DBG1("             Total available     %ld\n", mem_avail[i]);
    DBG1("             Total in fund       %ld\n", mem_fund[i]);
}
#endif /* MEM_TRACE */

/*          E x t e r n a l    M e m o r y    m a n a g e r           */
/*--------------------------------------------------------------------*/
#endif   /*  not INT_MEM_MGT       type of memory manager  */
