/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/dep/fc.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: fc.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   19 Apr 1995 16:46:00   JOE
 * Modified FCcopy() for NO_SYMSET_MAPPING.
 * 
 *    Rev 1.7   07 Apr 1995 08:37:06   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.6   21 Apr 1994 15:43:12   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   13 Jul 1993 20:10:46   MIKE
 * Modified FCcopy() to do p_AltWidTab (CONVERGENT_FONTS).
 * 
 *    Rev 1.4   06 May 1993 16:42:22   MIKE
 * In FCcopy() the conditional code around ->font_hdr is replaced by
 *   #if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
 * 
 *    Rev 1.3   02 Feb 1993 17:07:34   JOE
 * In FCcopy(), copying two new fields "band_bot" and "band_top" to
 * destination font context structure.
 * 
 *    Rev 1.2   17 Dec 1992 15:50:00   ROB
 * Added function declarations based on ANSI_DEFS
 * 
 *    Rev 1.1   11 Dec 1992 15:30:56   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:25:42   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* fc.c */
/*
 *
 *  HISTORY:
 *
 *  23-OCT-90   dET added function prototyping for MSC
 *  28-Nov-90   dET Modify for MSC multi-model compilation.
 *  17-Jun-91   jfd Moved "cgconfig.h" before "port.h".
 *  29-Aug-91   jfd Since sizeof(FONTCONTEXT) always uses the size of the
 *                  largest union member, an incorrect result may be returned.
 *                  To correct this bug, the correct size of the FONTCONTEXT
 *                  is computed first, and then the byte-for-byte comparison
 *                  is done.
 *  03-Apr-92   rs  Portability cleanup (see port.h).
 *  05-Aug-92   jfd Included "mixmodel.h" and "string.h".
 *                  Added FCcopy().
 *                  Disabled FCis_equal() - calling MEMCMP directly.
 *  07-Aug-92   jfd Fixed bug in FCcopy() - if SCALE_MATRIX other than 0,
 *                  was only copying unionized fields and not entire
 *                  FONTCONTEXT.
 *  17-Dec-92   rs  Added function declarations based on ANSI_DEFS.
 *  02-Feb-93   jfd In FCcopy(), copying 2 new fields of font context -
 *                  band_top and band_bot.
 *  06-May-93  mby  In FCcopy() the ->font_hdr conditional code is replaced
 *                  by #if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS).
 *  07-Jul-93  mby  Modified FCcopy() for CONVERGENT_FONTS.
 *  19-Apr-95  jfd  Modified FCcopy() for NO_SYMSET_MAPPING.
 */

#include <string.h>

#include "cgconfig.h"
#include "port.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "mixmodel.h"

#ifdef LINT_ARGS
#if 0
GLOBAL BOOLEAN FCis_equal(PFONTCONTEXT, PFONTCONTEXT);
#endif
GLOBAL VOID    FCcopy(PFONTCONTEXT, PFONTCONTEXT);
#else /* no LINT_ARGS */
#if 0
GLOBAL BOOLEAN FCis_equal();
#endif
GLOBAL VOID    FCcopy();
#endif /* LINT_ARGS */

#if 0
/*----------------------*/
/*     FCis_equal       */
/*----------------------*/

/*  Return truth value of "FONTCONTEXT f == FONTCONTEXT g". */
#if defined (ANSI_DEFS)
GLOBAL BOOLEAN FCis_equal(PFONTCONTEXT f, PFONTCONTEXT g)
#else
GLOBAL BOOLEAN
FCis_equal(f, g)
    PFONTCONTEXT f, g;
#endif /* ANSI_DEFS */
{
    UW16 size;

#if 0
#if SCALE_MATRIX
    if (f->fc_type != g->fc_type) /* if scaling types don't match, */
       return FALSE;              /* no need to go further         */

    size = (UW16)(&fc->fc_type - fc) + (UW16)(sizeof(UW16));

    switch (f->fc_type)
    {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
       case FC_TYPO_TYPE:
          size += sizeof(TYPO);
          break;
#endif  /* SCALE_MATRIX & TYPO_SCALE_MATRIX */

#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
       case FC_MAT0_TYPE:
          size += sizeof(MAT0);
          break;
#endif  /* SCALE_MATRIX & MAT0_SCALE_MATRIX */

#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
       case FC_MAT1_TYPE:
          size += sizeof(MAT1);
          break;
#endif  /* SCALE_MATRIX & MAT1_SCALE_MATRIX */
       
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
       case FC_MAT2_TYPE:
          size += sizeof(MAT2);
          break;
#endif  /* SCALE_MATRIX & MAT2_SCALE_MATRIX */
    }

#else
    size = sizeof(FONTCONTEXT);   /* only one possible size */
#endif  /* SCALE_MATRIX */
#endif /* 0 */

#if SCALE_MATRIX
    if (f->fc_type != g->fc_type) /* if scaling types don't match, */
       return FALSE;              /* no need to go further         */
#endif
    size = sizeof(FONTCONTEXT);   /* only one possible size */
    return !MEMCMP((void*)f, (void*)g, size);
}
#endif /* 0 */

/*----------------------*/
/*     FCcopy           */
/*----------------------*/

/*  Zeroes out 'f' and copies 'g' into 'f'. */

#if defined (ANSI_DEFS)
GLOBAL VOID FCcopy(PFONTCONTEXT f, PFONTCONTEXT g)
#else
GLOBAL VOID
FCcopy(f, g)
    PFONTCONTEXT f, g;
#endif /* (ANSI_DEFS) */
{
   memset(f,0,sizeof(FONTCONTEXT));
#if !SCALE_MATRIX
   f->font_id    = g->font_id;
   f->point_size = g->point_size;
   f->set_size   = g->set_size;
   f->shear      = g->shear;
   f->rotate     = g->rotate;
   f->xres       = g->xres;
   f->yres       = g->yres;
   f->xspot      = g->xspot;
   f->yspot      = g->yspot;
   f->xbold      = g->xbold;
   f->ybold      = g->ybold;
   f->ssnum      = g->ssnum;
   f->format     = g->format;
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
   f->font_hdr   = g->font_hdr;
#endif
#if BANDING
   f->band_top   = g->band_top;
   f->band_bot   = g->band_bot;
#endif
#if CONVERGENT_FONTS
   f->p_AltWidTab = g->p_AltWidTab;
#endif
#if NO_SYMSET_MAPPING && TT_RDR
   f->dl_ssnum    = g->dl_ssnum;
#endif

#else   /* SCALE_MATRIX */
   f->font_id    = g->font_id;
   f->xspot      = g->xspot;
   f->yspot      = g->yspot;
   f->xbold      = g->xbold;
   f->ybold      = g->ybold;
   f->ssnum      = g->ssnum;
   f->format     = g->format;
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
   f->font_hdr   = g->font_hdr;
#endif
#if BANDING
   f->band_top   = g->band_top;
   f->band_bot   = g->band_bot;
#endif
#if CONVERGENT_FONTS
   f->p_AltWidTab = g->p_AltWidTab;
#endif
#if NO_SYMSET_MAPPING && TT_RDR
   f->dl_ssnum    = g->dl_ssnum;
#endif
   f->fc_type    = g->fc_type;
   switch (g->fc_type)
   {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
     case FC_TYPO_TYPE:
       f->s.t.point_size = g->s.t.point_size;
       f->s.t.set_size   = g->s.t.set_size;
       f->s.t.shear      = g->s.t.shear;
       f->s.t.rotate     = g->s.t.rotate;
       f->s.t.xres       = g->s.t.xres;
       f->s.t.yres       = g->s.t.yres;
       break;
#endif

#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
     case FC_MAT0_TYPE:
       f->s.m0.m[0]         = g->s.m0.m[0];
       f->s.m0.m[1]         = g->s.m0.m[1];
       f->s.m0.m[2]         = g->s.m0.m[2];
       f->s.m0.m[3]         = g->s.m0.m[3];
       f->s.m0.matrix_scale = g->s.m0.matrix_scale;
       break;
#endif

#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
     case FC_MAT1_TYPE:
       f->s.m1.m[0]         = g->s.m1.m[0];
       f->s.m1.m[1]         = g->s.m1.m[1];
       f->s.m1.m[2]         = g->s.m1.m[2];
       f->s.m1.m[3]         = g->s.m1.m[3];
       f->s.m1.em_width     = g->s.m1.em_width;
       f->s.m1.em_depth     = g->s.m1.em_depth;
       f->s.m1.matrix_scale = g->s.m1.matrix_scale;
       f->s.m1.em_scale     = g->s.m1.em_scale;
       break;
#endif

#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
     case FC_MAT2_TYPE:
       f->s.m2.m[0]         = g->s.m2.m[0];
       f->s.m2.m[1]         = g->s.m2.m[1];
       f->s.m2.m[2]         = g->s.m2.m[2];
       f->s.m2.m[3]         = g->s.m2.m[3];
       f->s.m2.xworld_res   = g->s.m2.xworld_res;
       f->s.m2.yworld_res   = g->s.m2.yworld_res;
       f->s.m2.matrix_scale = g->s.m2.matrix_scale;
       f->s.m2.world_scale  = g->s.m2.world_scale;
       f->s.m2.point_size   = g->s.m2.point_size;
       f->s.m2.set_size     = g->s.m2.set_size;
       break;
#endif
   }
   return;
#endif /* SCALE_MATRIX */
}
