/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/dep/mixmodel.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: mixmodel.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   07 Apr 1995 08:37:10   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   21 Apr 1994 15:42:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   02 Feb 1994 09:11:40   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.3   09 Jun 1993 16:53:30   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.2   23 Dec 1992 11:50:48   ROB
 * Added ANSI function declarations based on ANSI_DEFS.
 * 
 *    Rev 1.1   11 Dec 1992 15:31:18   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:25:40   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* mixmodel.c */
/*
 *
 *  History:
 *
 *  original  dET 
 *  17-Jun-91 jfd  Added "cgconfig.h" before "port.h".
 *  19-Jul-91 jfd  Changed "MSWINDOWS" to "_WINDOWS".
 *  26-Jul-91 dET  Added function "_fstrcat()".
 *  24-Sep-91 jfd  Added function "_fqsort()".
 *  25-Sep-91 jfd  Added function prototypes for (*comp)() amd (*compare)()
 *                 to get rid of compiler warning.
 *                 Routine _fstrcat() was pointing to byte after NULL byte
 *                 when appending string; fixed pointer so that it points
 *                 to NULL byte when appending.
 *                 Conditionally compiling _fstrlen(), _fstrcpy() and
 *                 _fstrcat() based on !_WINDOWS.
 *                 Disabled _fstrncpy() and _fstrncmp() if WINDOWS
 *                 because they already exist in <string.h>.
 *  26-Sep-91 jfd  Moved function prototype for _fqsort() here from
 *                 "mixmodel.h".
 *  03-Mar-92 rs   Added '_fqsort()' to MSC 6.0 for Windows (was 5.10).
 *                 Add '_fstrcmp()' for MSC5.X.
 *  04-Mar-92 jfd  Changed last arg of function prototype for _fqsort()
 *                 to "WORD(*)(PBYTE,PBYTE)" from "WORD(*)(PVOID,PVOID)".
 *  03-Apr-92 rs   Portability cleanup (see port.h).
 *  05-Aug-92 jfd/det Added _fmemcmp() and _fmemset().
 *  23-Dec-92 rs   Add ANSI function declarations based on ANSI_DEFS.
 *  09-Jun-93 jfd  Changed all references to "char" to "SB8" for
 *                 transportability.
 *  27-Jan-94 jfd  Conditionally compiled out #include for io.h based on
 *                 !defined(_AM29K).
 */

#if !defined(_AM29K)
//#include <io.h>
#endif

#include "cgconfig.h"
#include "port.h"
#include "mixmodel.h"



#ifdef _WINDOWS
GLOBAL VOID far pascal _fqsort(PVOID, UW16, UW16,
   int(*)(LPSB8, LPSB8));
#else
GLOBAL VOID _fqsort(PVOID, UW16, UW16, int(*)(LPSB8, LPSB8));
#endif

/***************************  MSC 5.X  ********************
*
* dET 11-14-90
*
* The arguments to strlen() and strcpy() in MSC medium, small, tiny model
* are NEAR pointers.  So we have to define our oun string functions that
* defines arguments as FAR pointers.
* MSC 6.0 has library functions for this purpose.
* BORLANDC also has these library functions.
*/

#if (defined(MSC) || defined(_WINDOWS))

#if (defined(M_I86SM)||defined(M_I86MM)||defined(M_I86TM)||defined(_WINDOWS))

#if (!(_MSC_VER >= 600))

#ifndef _WINDOWS

#if defined (ANSI_DEFS)
GLOBAL SW16 _fstrlen (LPSB8 str)
#else
GLOBAL SW16 _fstrlen (str)
    LPSB8 str;
#endif /* ANSI_DEFS */
{
    int length = 0;

	  while(*str++)
		    ++length;

    return length;
}


#if defined (ANSI_DEFS)
GLOBAL LPSB8 _fstrcpy (LPSB8 dst, LPSB8 src)
#else
GLOBAL LPSB8 _fstrcpy (dst, src)
    LPSB8 dst;
    LPSB8 src;
#endif /* ANSI_DEFS */
{
    LPSB8 cp = dst;

    while(*dst++ = *src++)
	      ;                /* Copy src over dst */
    return cp;
}

#if defined (ANSI_DEFS)
GLOBAL LPSB8 _fstrcat (LPSB8 dst, LPSB8 src)
#else
GLOBAL LPSB8 _fstrcat (dst, src)
    LPSB8 dst;
    LPSB8 src;
#endif /* ANSI_DEFS */
{
    LPSB8 cp = dst;

    while(*dst++)
      ;
    dst--;
    while(*dst++ = *src++)
	      ;                /* Copy src to end of dst */
    return cp;
}

#if defined (ANSI_DEFS)
#ifdef _WINDOWS
GLOBAL LPSB8 far pascal _fstrncpy (LPSB8 dst, LPSB8 src, SW16 count)
#else /* not WINDOWS */
GLOBAL LPSB8 _fstrncpy (LPSB8 dst, LPSB8 src, SW16 count)
#endif /* WINDOWS */
#else /* not ANSI */
GLOBAL LPSB8
#ifdef _WINDOWS
far pascal
#endif
_fstrncpy(dst, src, count)
    LPSB8 dst;
    LPSB8 src;
    SW16  count;
#endif /* ANSI_DEFS */
{
    LPSB8 cp = dst;

    while(count && (*dst++ = *src++))
	      count--;		    /* Copy src over dst */
    if (count)
        while (--count)
          *dst++ = '\0';

    return cp;
}


#if defined (ANSI_DEFS)
#ifdef _WINDOWS
GLOBAL SW16 far pascal _fstrncmp (LPSB8 dst, LPSB8 src, SW16 count)
#else /* not WINDOWS */
GLOBAL SW16 _fstrncmp (LPSB8 dst, LPSB8 src, SW16 count)
#endif /* WINDOWS */
#else /* not ANSI */
GLOBAL SW16 
#ifdef _WINDOWS
far pascal
#endif
_fstrncmp(dst, src, count)
    LPSB8 dst;
    LPSB8 src;
    SW16  count;
#endif /* ANSI_DEFS */
{
    if(!count)
       return count;

    while (--count && *src && *src == *dst)
    {
        src++;
        dst++;
    }
    return(*src - *dst);
}

#if defined (ANSI_DEFS)
#ifdef _WINDOWS
GLOBAL SW16 far pascal _fstrcmp (LPSB8 dst, LPSB8 src)
#else /* not WINDOWS */
GLOBAL SW16 _fstrcmp (LPSB8 dst, LPSB8 src)
#endif /* WINDOWS */
#else /* not ANSI */
GLOBAL SW16 
#ifdef _WINDOWS
far pascal
#endif
_fstrcmp(dst, src)
    LPSB8 dst;
    LPSB8 src;
#endif /* ANSI_DEFS */
{
    while (*src && *src == *dst)
    {
        src++;
        dst++;
    }
    return(*src - *dst);
}

#endif  /* !WINDOWS */

#endif
#endif
#endif


/***************************  MSC 5.X  and 6.X   ********************
*
* dET 11-14-90  
* jfd 08-05-92
*
* The arguments to memcpy and memcmp in MSC medium, small, tiny model
* are NEAR pointers.  So we have to define our oun memcpy function that
* defines arguments as FAR pointers.
* MSC 6.0 has a library function for this purpose.
*
* The MSC read() function has the same problem.  Here we find a big HACK.
* A small buffer is decared in the data segment.  A pointer to this buffer
* is passed to the read() function.  Then the data is copied to the
* FAR pointer passed to MSCread.
*
*
*/


#if (defined(MSDOS) && !defined(_WINDOWS))
#if (defined(M_I86SM) || defined(M_I86MM) || defined (M_I86TM))

#define TMPBUFSIZE 1000

SB8 tmpBuf[TMPBUFSIZE];

#if (_MSC_VER < 600)
#if defined (ANSI_DEFS)
GLOBAL LPSB8 _fmemcpy (LPSB8 dst, LPSB8 src, SW16 count)
#else
GLOBAL LPSB8 _fmemcpy(dst, src, count)
    LPSB8 dst;
    LPSB8 src;
    SW16 count;
#endif /* ANSI_DEFS */
{
    LPSB8 ret = dst;

	/*
	 * copy from lower addresses to higher addresses
	 */
	while (count--)
		*dst++ = *src++;

	return(ret);
}

#if defined (ANSI_DEFS)
GLOBAL SW16 _fmemcmp (LPSB8 buf1, LPSB8 buf2, UW16 count)
#else
GLOBAL SW16 _fmemcmp(buf1, buf2, count)
    LPSB8 buf1;
    LPSB8 buf2;
    UW16 count;
#endif /* ANSI_DEFS */
{
   /* Purpose: 
    *    Compares count bytes of memory starting at buf1 and but2
    *    and finds if equal or which one is first in lexical order.
    */

    if (!count)
       return(0);
    while (--count && *buf1 == *buf2)
    {
       buf1++;
       buf2++;
    }
    return(*buf1 - *buf2);
}

#if defined (ANSI_DEFS)
GLOBAL LPSB8 _fmemset (LPSB8 dst, SB8 val, unsigned int count)
#else
GLOBAL LPSB8 _fmemset(dst, val, count)
    LPSB8 dst;
    SB8  val;
    unsigned int count;
#endif /* ANSI_DEFS */
{
   /* Purpose: 
    *    Sets the first "count" bytes of the memory starting
    *    at "dst" to the character value "val".
    */

    SB8 *start = dst;

    while (count--)
       *dst++ = val;
    return(start);
}

#endif /* (_MSC_VER < 600) */

#if defined (ANSI_DEFS)
GLOBAL SW16 MMread (SW16 f, LPSB8 buffer, SW16 count)
#else
GLOBAL SW16 MMread (f, buffer, count)
    SW16  f;
    LPSB8 buffer;
    SW16  count;
#endif /* ANSI_DEFS */
{
    SW16  partCount;
    SW16  bytesRead;
    SW16  totalRead = 0;

    while(count > 0)
    {
        partCount = (count > TMPBUFSIZE) ? TMPBUFSIZE : count;
        count -= partCount;
            
        bytesRead = read(f, tmpBuf, partCount);
        totalRead += bytesRead;
        _fmemcpy(buffer, (LPSB8)tmpBuf, bytesRead);
        buffer += bytesRead;
        if(bytesRead != partCount)
            break;
    }
    return totalRead;
}

#if defined (ANSI_DEFS)
GLOBAL SW16 MMwrite (SW16 f, LPSB8 buffer, SW16 count)
#else
GLOBAL SW16 MMwrite (f, buffer, count)
    SW16  f;
    LPSB8 buffer;
    SW16  count;
#endif /* ANSI_DEFS */
{
    SW16  partCount;
    SW16  bytesWrite;
    SW16  totalWrite = 0;

    while(count > 0)
    {
        partCount = (count > TMPBUFSIZE) ? TMPBUFSIZE : count;
        count -= partCount;
            
        _fmemcpy((LPSB8)tmpBuf, buffer, partCount);
        bytesWrite = write(f, tmpBuf, partCount);
        totalWrite += bytesWrite;
        buffer += bytesWrite;
        if(bytesWrite != partCount)
            break;
    }
    return totalWrite;
}

#endif /* (defined(M_I86SM) || defined(M_I86MM) || defined (M_I86TM)) */
#endif /* (defined(MSDOS) && !defined(_WINDOWS)) */


/***************************  MSC 5.X  ********************
*
* jfd 09-24-91
*
* The arguments to qsort() in MSC medium, small, tiny model
* are NEAR pointers.  So we have to define our oun string functions that
* defines arguments as FAR pointers.
* MSC 6.0 has library functions for this purpose.
*
*/

#if defined(MSDOS)

#if (defined(M_I86SM)||defined(M_I86MM)||defined(M_I86TM)||defined(_WINDOWS))

MLOCAL UW16  width = 0;

MLOCAL SW16 (* compare)(LPSB8, LPSB8);

MLOCAL VOID
#ifdef _WINDOWS
pascal
#endif
quicksort( LPSB8, LPSB8 );


MLOCAL VOID
#ifdef _WINDOWS
pascal
#endif
swap( LPSB8, LPSB8, UW16 );

#if defined (ANSI_DEFS)
#ifdef _WINDOWS
GLOBAL VOID far pascal _fqsort (PVOID base, UW16 num, UW16 wid,
                                 SW16 (*comp)(LPSB8, LPSB8))
#else /*not _WINDOWS */
GLOBAL VOID _fqsort (PVOID base, UW16 num, UW16 wid,
                        SW16 (*comp)(LPSB8, LPSB8))
#endif /* _WINDOWS */
#else /* not ANSI */
GLOBAL VOID
#ifdef _WINDOWS
far pascal
#endif
_fqsort ( base, num, wid, comp )
PVOID base;
UW16 num;
UW16 wid;
SW16 (*comp)(LPSB8, LPSB8);
#endif /* ANSI_DEFS */
/***************************************************************************
*_fqsort(base, num, wid, comp) - quicksort function for sorting arrays
*
*Purpose:
*   quicksort the array of elements
*   side effects:  sorts in place
*
*Entry:
*   SB8 *base = pointer to base of array
*   unsigned num  = number of elements in the array
*   unsigned wid  = width in bytes of each array element
*   int (*comp)() = pointer to function returning analog of strncmp for
*           strings, but supplied by user for comparing the array elements.
*           it accepts 2 pointers to elements and returns neg if 1<2, 0 if 1=2,
*           pos if 1>2.
*
*Exit:
*   returns void
*
*Exceptions:
*
****************************************************************************/
{
    LPSB8 q = (LPSB8)base;
    LPSB8 p = (LPSB8)base + wid;
    SW16  i = num - 1;
    SW16  sort = 0;   /* set to non-zero if sort must be done */
    /* (some element is out of order) */

    if (num)
        while (i--) {
            if ((*comp)( q, p ) > 0) {
                sort++;
                break;
            }

            q = p;
            p += wid;
        }

    if (sort) {
        width = wid;
        compare = comp;
#ifdef SIZED
        quicksort( (LPSB8)base, (LPSB8)base + ((long)(num - 1)) * width );
#else
        quicksort( (LPSB8)base, (LPSB8)base + (num - 1) * width );
#endif
    }
}

#if defined (ANSI_DEFS)
#ifdef _WINDOWS
MLOCAL VOID pascal quicksort (LPSB8 lo, LPSB8 hi)
#else /* not _WINDOWS */
MLOCAL VOID quicksort (LPSB8 lo, LPSB8 hi)
#endif /* _WINDOWS */
#else /* not ANSI */
MLOCAL VOID
#ifdef _WINDOWS
pascal
#endif
quicksort ( lo, hi )
LPSB8 lo;
LPSB8 hi;
#endif /* ANSI_DEFS */
{
    LPSB8 higuy = hi + width;
    LPSB8 loguy = lo;

    while (lo < hi) {
        for (;;) {
            do  {
                loguy += width;
            }
            while (loguy < hi && (*compare)( loguy, lo ) <= 0);

            do  {
                higuy -= width;
            }
            while (higuy > lo && (*compare)( higuy, lo ) >= 0);

            if (higuy <= loguy)
                break;

            swap( loguy, higuy, width );
        }

        swap( lo, higuy, width );
        if ( higuy - lo >= hi - higuy ) {
            quicksort( higuy + width, hi );
            hi = higuy - width;
            loguy = lo;
        }
        else {
            quicksort( lo, higuy - width );
            loguy = lo = higuy + width;
            higuy = hi + width;
        }
    }
}

#if defined (ANSI_DEFS)
#ifdef _WINDOWS
MLOCAL VOID pascal swap (LPSB8 one, LPSB8 two, UW16 w)
#else /* not _WINDOWS */
MLOCAL VOID swap (LPSB8 one, LPSB8 two, UW16 w)
#endif /* _WINDOWS */
#else /* not ANSI */
MLOCAL VOID
#ifdef _WINDOWS
pascal
#endif
swap ( one, two, w )
LPSB8 one;
LPSB8 two;
UW16 w;
#endif /* ANSI_DEFS */
{
    SB8 temp;

    while (w--) {
        temp = *one;
        *one++ = *two;
        *two++ = temp;
    }
}

/* endif - remove this conditional for MSC 5.10 - 3/2/92 - rs */
#endif/*(defined(M_I86SM)||defined(M_I86MM)||defined(M_I86TM)||defined(_WINDOWS))*/
#endif /* defined(MSDOS) */

