/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/gen/maker.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: maker.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.27   07 Apr 1995 08:42:50   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.26   23 Feb 1995 08:53:56   JOE
 * In MAKfontSize(), changed "cc_size" from UW16 to UL32 to prevent
 * overflow when processing large characters.
 * 
 *    Rev 1.25   14 Feb 1995 20:48:04   MIKE
 * 
 * In MAKfontSize reduced size[1] NZW buffer.
 * 
 *    Rev 1.24   01 Feb 1995 10:32:24   JOE
 * 
 * In ifmake_gaso_and_stats(), if not quadrant rotation, set
 * "wholeOrgBox.ll" to "chr_def_hdr.origin". This variable is used later
 * in the routine if processing an outline.
 * 
 *    Rev 1.23   27 Jan 1995 16:20:06   MIKE
 * 
 * Call new function fco_CharCleanup() from MAKifbmheader().
 * 
 *    Rev 1.22   11 Jan 1995 09:36:10   JOE
 * In MAKifbmheader(), do not set "frac_places" to 4 for FCO input. This
 * value will be calculated dynamically in fco_set_trans().
 * 
 *    Rev 1.21   11 Dec 1994 17:28:30   MIKE
 * 
 * Changed if_state.cs.origin_cs to SL32VECTOR from SW16VECTOR
 * 
 *    Rev 1.20   28 Oct 1994 09:14:02   JOE
 * In ifmake_gaso_and_stats(), when processing outlines, use "wholeOrgBox.ll"
 * rather than "chr_def_hdr.origin" when calculating origin 
 * ("if_state.cs.origin").
 * 
 *    Rev 1.19   04 Aug 1994 14:55:30   MIKE
 * 
 * Added FCO changes from 1.13.1.2
 * 
 *    Rev 1.18   28 Apr 1994 14:26:22   JOE
 * Revised handling of Size[2] calculation to properly account for
 * bit_map_widths greater than 8 bits.
 * 
 *    Rev 1.17   26 Apr 1994 19:23:44   MIKE
 * Fixed y-alignment problem in ifmake_gaso_and_stats().
 * 
 *    Rev 1.16   22 Apr 1994 14:09:12   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.15   15 Apr 1994 16:18:22   JOE
 * 
 * In ifmake_gaso_and_stats(), changed call to find_part2whole() to 
 * include new 1st arg.
 * If ifmake_gaso_and_stats(), if processing compound character with space 
 * as first part, use next part's translation as translation of whole's
 * des2bm().
 * Added arg to char_left_ref() call : y offset.
 * 
 *    Rev 1.14   11 Feb 1994 12:31:38   MAIB
 * Properly initialized non-zero winding buffer size before returning
 * 
 *    Rev 1.13   17 Jan 1994 11:57:02   JOE
 * In MAKfontSize(), conditionally compiled block of code which calculates
 * "size[2]" (max compound character part size) based on IF_RDR.
 * 
 *    Rev 1.12   06 Jan 1994 09:45:44   JOE
 * 
 * Modified MAKfontSize() to return compound char buffer size, to be
 * used dynamically for filling IFCONFIG.CC_buf_size.
 * 
 *    Rev 1.11   16 Dec 1993 10:44:04   JOE
 * 
 * In MAKifbmheader(), save copy of the number of transition runs.
 * 
 *    Rev 1.10   23 Sep 1993 16:46:50   MIKE
 * 
 * Remove references to if_state.extern_font.
 * 
 *    Rev 1.9   10 Aug 1993 15:28:34   JOE
 * 
 * In MAKifbmheader(), conditionally compiled call to ifmake_gaso_and_stats()
 * based on IF_RDR.
 * 
 *    Rev 1.8   29 Jul 1993 12:23:34   AL
 * 
 * Non-zero winding changes
 * 
 *    Rev 1.7   06 May 1993 15:17:20   JOE
 * In ifmake_gaso_and_stats(), save font index at start and restore it at end
 * instead of doing it in DArd_char(). Problems arise with HQ2 pcleo compound
 * characters if DArd_char() saves and restores the font index.
 * 
 *    Rev 1.6   13 Apr 1993 13:30:52   JOE
 * In MAKifbmheader(), conditionally compiled calls to psmake_gaso_and_stats()
 * and ttmake_gaso_and_stats() if !USE_JUMP_TABLES.
 * 
 *    Rev 1.5   12 Feb 1993 14:25:10   JOE
 * VXWorks support.
 * 
 *    Rev 1.4   29 Jan 1993 09:14:06   JOE
 * In ifmake_gaso_and_stats(), save em box size.
 * In MAKifbmheader(), conditionally compile escapement adjustment code
 * based on DU_ESCAPEMENT.
 * 
 *    Rev 1.3   22 Jan 1993 09:11:06   JOE
 * Moved escapement adjustment code back to MAKifbmheader() because
 * adjustments were not being made if CHAR_SIZE were enabled.
 * 
 *    Rev 1.2   05 Jan 1993 13:57:10   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:23:08   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 16:03:14   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* maker */


/*---------------------------------------------------------------------
     05-05-90   awr   Added landscape. New function rot90(), changed
                      des2wrkbm() to rotate coords. Changed bitmpa_size()
                      to swap bmwidth and bmdepth and compute d.max_x
                      and d.max.y.
     08-03-90   awr   Bold calculations now use ABS(round[0]).
     08-05-90   awr   Prohibit flags checked in MAKfontSize()
     08-05-90   awr   Doubled x_bold and y_bold in MAKfontSize(). Bold
                      characters do not grow in all directions but may
                      grow only to the right or only down.
     09-05-90   awr   In make_char_part(), if calculation of "size" > 32K,
                      result is a negative number because "d.bmwidth" and
                      "d.bmdepth" are typed as WORDs, not LONGs. Therfore,
                      cast "d.bmwidth" and "d.bmdepth" as ULONG.
     09-11-90   bjg   Added quadratic outline support.
     09-21-90   jfd   Changed BITMAP to CGBITMAP due to conflict in "windows.h"
     26-Oct-90  jfd   Conditionally compiling declarations for routines
                      linear() and quadra().
     12-05-90   bg    In MAKfontSize(), make_char_part() and MAKbitMap(),
                      check for format<2 for bitmap output and format==2
                      for outline output.
                      If !CGBITMAP, add GLOBAL declaration for "or_on".
     01-02-91  jfd    Changes for IFB on a Printer:
                      1.) Declared chr_def_hdr as GLOBAL CHR_DEF_HDR
                      2.) Disabled CC elements which are now part of the
                          CHR_DEF_HDR structure above and made the appropriate
                          changes to all references to them in the following
                          routines:
                             MAKbitMap()
                             MAKchar_width()
                             outline_size()
                             des_bound_box()
                             MAKfontSize()
                             make_char_part()
     01-02-91   bg    In make_char_part() and MAKbitMap(), corrected
                      compound character bug for outline output.
     01-15-91   jfd   When checking for a compound character, instead of
                      testing for "num_parts > 1", test for "is_compound".
                      This change occurs in the following routines:
                      MAKbitMap(), MAKchar_width() and set_kern().

     01-22-91   jfd   At start of MAKfontSize(), checking for space
                      character (812) and returning ERR_fixed_space.

     01-23-91   awr   Moved MAX_BM to "cgconfig.h".

     01-28-91   tnc   In outline_metrics(), if compound character, store
                      "h_esc" as escapement instead of calculating it 
                      from bounding box.

                     Made size arg of MAKfontSize() a PLONG


                     "cc_size"  is LONG

     01-30-91   dET  Forced "or_on" to be in the data segment by
                     initialization.  This allows fill.asm to be slighly
                     optimized.  This is a MSC qwirk.

                     function prototypes and modification to support 
                     MSC multi-model compilation.
     3-Feb-91   awr  Split off much of MAKfontSize() to map_and_set_scale()
                     in mapfont.c
     5-Feb-91   awr  Put in FC_IS...() macros for testing format field
                     of FONTCONTEXT for output type.
     10-Feb-91  awr  Moved making_bold and or_on to SCALE structure.
     08-Mar-91  jfd  For MULTI-MODEL, change references to LOOP* to PLOOP.
    19-May-91   awr  Changed LOOP structure
     1-Jun-91   awr  HQ4 changes
    10-Jun-91   jfd  Made declaration of MAKifbmheader() conditional based on
                     TILE.
    17-Jun-91   jfd  Moved "debug.h" after "port.h".
                     Moved "profile.h" after "port.h".
                     Moved "cgconfig.h" before "port.h".
    15-Aug-91  awr   Changed name of MAKbitMap() to CGIFbitMap()
    18-Aug-91  awr   Changed *bm = entire_bm to prevent overwrite
    24-Aug-91  awr   Moved function decls to include file
    28-Aug-91  jfd   Including "mixmodel.h" to resolve a compiler warning
                     regarding MEMCPY. Including "<string.h>".
     1-Sep-91  awr   Included "bitmap.h"
     6-Sep-91  awr   Changed HEADERSIZE to BMHEADERSIZE
     9-Sep-91  jfd   Corrected function prototype for out_count() (no 
                     arguments).
                     Removed conditional compile statement for function
                     prototype of MAKifbmheader().
    13-Sep-91  jfd   Changed name of CGIFbitMap() to CGIFmakechar().
    19-Sep-91  jfd   In CGIFtilebitMap(), when calculating tile_bm.xorigin
                     and tile_bm.yorigin, cast operand as LONG due to
                     change in type to LONG for xorigin and yorigin.
    27-Sep-91  bjg   Add special case handling for mirrored chars 
    12-Oct-91  awr   Missing pixel recovery and pseudo bold are no 
                     longer mutually exclusive.
    18-Oct-91  jfd   Declare "scan_convert" conditionally based on
                     TILE.
    25-Oct-91  jfd   Changed declaration for "scan_convert" from EXTERN
                     to GLOBAL so as to resolve a linker error which
                     occurs if CHAR_SIZE is enabled.
    31 Oct 91  ss    Added test, if outline processing then never set
                     special_case (in MAKifbmheader().)
    01-Nov-91  awr   In MAKifbmheader(), corrected adjustment of
                     bounding box for outline.
    07-Nov-91  jfd   In MAKifbmheader(), changed num_bytes from a WORD
                     to a LONG so as to handle sizes greater than 64K.
    12-Nov-91  jfd   In MAKifbmheader(), repalced constants with sizeof
                     operations for SUN/SPARC compatability.
    22-Jan-92  rs    Make 'ifmake_gaso_and_stats()' global.
                     Add stubs for remainder of 'if' driver functions.
    29-Jan-92  jfd   In MAKifbmheader(), changed "ttmake_gaso_and_state()"
                     call to "ttmake_gaso_and_stats()".
    05-Feb-92  rs    In MAKifbmheader(), when calculating black_width
                     and black depth, using bounding box extremes rather
                     that char_stats extremes.
    24-Feb-92  jfd   Added function prototype for short_metrics().
                     Added function prototype for estimate_outline().
     7-Mar-92  awr   Removed last two parameters from ifmake_gaso_and_stats()
                     to make it consistant with the other FST versions.
    19-Mar-92  awr   Changed bitmap_dimensions() to take LONGs
                     Moved clip_fops_top and clip_fops_bot to ras structure
                     from scan_convert structure
                     Moved computation of "clip_fops" to start char from
                     bitmap.c and maker.c
    03-Apr-92  rs    Portability cleanup (see port.h).
    04-Apr-92  awr   Changed calling sequence of find_part2whole() in
                     if_make_gaso_and_stats()
     4 Apr 92  ss    In MAKifbmheader(), moved call to generic
                     make_gaso_and_stats() from insde PST1I || TT_RDR
                     specific code and eliminated explicit call to
                     if_make_gaso_and_stats() covered by the generic call.
                     Deleted prototypese for short_metrics() not referenced.
    12-Apr-92  awr   Moved bitmap generating code for normal and tiled
                     characters to bitmap.c
                     Cleaned up MAKifbmheader() a bit.
    20-Apr-92  awr   Filled in "pix_bound" field of CHR_DEF in
                     ifmake_gaso_and_stats()
    21-Apr-92  jfd   Temporarily removed conditional compile for scan_convert
                     until BITMAP.C is settled.
                     In MAKifbmheader(), if processing a TT font, after
                     call to make_gaso_and_stats(), store "ct_loop" into
                     "num_loops" for correct loop count.
    23-Apr-92  jfd   In ifmake_gaso_and_stats(), stored number of loops
                     in "pcs->ct_loop" for compatability with PS and TT.
    18 May 92  ss    Uncommented lines in ifmake_gaso_and_stats() to fix
                     rotated compound character problem.
    29 May 92  jfd   Changed "olstats" type from "OLSTATS" to "CHAR_STATS".
    01-Jun-92  jfd   In ifmake_gaso_and_stats(), wherever "pcs->" loads
                     something, we store the same thing in "olstats".
    02-Jun-92  jfd   In ifmake_gaso_and_stats(), use "nloop" field of
                     "olstats" for both bitmaps and outlines. Initialize
                     "nloop" to "if_state.num_loops" for first part of
                     character and increment by "if_state.num_loops" for
                     each remaining part. Disable incrementing of 
                     "olstats.nloop" in out_count() and at end of 
                     ifmake_gaso_and_stats().
    04-Jun-92  jfd   In MAKifbmheader(), changed reference to "ct_loop"
                     to "nloop" due to change in OLSTATS.
    08-Jun-92  jfd   Eliminated all references to external "olstats".
                     Using pointer to CHAR_STATS "pcs" instead to
                     load character statistics data.
                     Passing "pcs" to estimate_outline().
                     Using "if_state.cs" in MAKfontSize().
    22-Jun-92  jfd   In MAKifbmheader(), check that we do not overflow
                     16 bits for any coordinates (#if INTR_SIZE == 16).
    28-Jun-92  awr   Changed MAKifbmheader() for 16bit scan conversion
    30-Jun-92  jfd   In estimate_outline() and ttps_estimate_outline(),
                     cast all operands used in calculating "num_bytes"
                     to SL32.
               rs    In ifmake_gaso_and_stats(), moved declarations for
                     "dx" and "dy" outside of conditional compile block
                     based on OUTLINE.
     4-Jul-92  awr   Fixed conditional compile for call to
                     ttps_esimate_outline()
    10 Jul 92  ss,awr Add to estimate so can Long align beginning of
                     vectors before setting.
     14-Jul-92  awr  Changed call to make_gaso().
     28-Jul-92  awr  Removed setting of tbound in MAKifbmheader()
      5-Aug-92  jfd  Removed function prototypes for "clear_mem()".
                     Never references here.
      6-Aug-92  jfd  In MAKifbmheader(), removed setting of "or_on" if
                     !IF because it is now set based on pixel size in
                     matrix_to_scale().
     11-Aug-92  jfd  Trying macro MDES2BM for optimization.
                     Included imath.h.
     17 Aug 92  ss   In MAKifbmheader(), adjusted escapement if master point
                     size and X scan resolution are not based on 8782.
     20 Aug 92 ss,awr In MAKifbmheader(), adjusted escapement of PS & TT
                     chars to compensate for rounding to 8782 base.
     27 Aug 92  ss   Moved escapement adjustment code fro MAKifbmheader() to
                     makechar() in maker.c.
     16-Sep-92  jfd  Changed "entire_bm" and "entire_tt" from EXTERN to 
                     GLOBAL.
     10-Oct-92  rs   Implement USE_JUMP_TABLES feature for overlays.
     15-Nov-92  rs   Port to Mac -> rename outline() to cgoutline().
     05-Jan-93  jfd  ANSI C changes to function declarations.
     21-Jan-93  jfd  In MAKifbmheader(), added code to adjust escapement
                     if master point size and x scan resolution are not in IF
                     8782's. 
                     In same routine, moved block of code which stores pixel
                     and grid values into "if_state" for NON_IF_FONTS 
                     before calls to xxmake_gaso_and_stats() because
                     "pixel_size" was never getting set when routine
                     ttmake_gaso_and_stats() copied it into xscale and yscale
                     for TT outlines.
                     Added function prototype for fgseg().
     25-Jan-93  jfd  In ifmake_gaso_and_stats(), save escapement and
                     em box size based on DU_ESCAPEMENT.
                     In MAKifbmheader(), conditionally compiled escapement
                     adjustment code based on !DU_escapement because if
                     DU_ESCAPEMENT, escapement is intentionally in native 
                     design units.
     08-Feb-93  jfd  VXWorks support.
     13-Apr-93  jfd  In MAKifbmheader(), conditionally compiled calls to 
                     psmake_gaso_and_stfats() and ttmake_gaso_and_stats() 
                     if !USE_JUMP_TABLES.
     06-May-93 jfd/ss In ifmake_gaso_and_stats(), save "fontindex" at start
                     and restore it at end instead of doing it in DArd_char().
                     Problems arise with HQ2 pcleo compound characters if 
                     DArd_char() saves and restores the font index.
     27-Jul-93 awr   Changed MAKfontSize() to return nzw buffer size
     10-Aug-93 jfd   In MAKifbmheader(), conditionally compile call to
                     ifmake_gaso_and_stats() based on IF_RDR.
     10-Sep-93 mby   Do not set if_state.extern_font
     16-Dec-93 jfd/jc In MAKifbmheader(), save a copy of the number of
                     transition runs. The value "if_state.cs.tran_run_ct"
                     is later updated by manipula() causing an inaccurate
                     number of runs to be stored.
                     Added external declaration for "ras".
     04-Jan-94 jwd   Modified MAKfontSize() to return compound char buffer size,
                     to be used dynamically for filling IFCONFIG.cc_buf_size.
     17-Jan-94 jfd/jwd In MAKfontSize(), conditionally compiled block of code
                     which calculates "size[2]" (max compound character part
                     size) based on IF_RDR.
     11-Feb-94 maib  Initialize the size of the nzw buf required regardless
                     of whether NON_Z_WIND is enabled or not
     13-Apr-94 awr   In ifmake_gaso_and_stats(), changed call to
                     find_part2whole() to include new 1st arg.
     14-Apr-94 jfd   In ifmake_gaso_and_stats(), if processing compound
                     character with space as first part, use next part's
                     translation as translation of whole's des2bm().
     15-Apr-94 jfd   Added arg to char_left_ref() call - y offset.
     26-Apr-94 mby/  Problem with y-alignment of a character and its mirror
               bjg   image if the font is obliqued. In ifmake_gaso_and_stats()
                     set "special_case" true if there is a shear and an
                     orthogonal rotation.
     27-Apr-94 jwd   Revised handling of Size[2] calculation, to properly 
                     account for bit_map_widths greater than 8 bits.
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   FCO Changes from 1.13.1.2:
     14-Mar-94 mby   If FCO reader is enabled, MAKifbmheader() calls
                     fco_make_gaso_and_stats(); frac_places is set to 6.
     18-Mar-94 mby   In MAKifbmheader(), to make larger characters, hard-coded
                     "frac_places" = 4 for FCO_TYPE. Must be kept in synch
                     with fco_set_trans() in "fc_if.c"!
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     28-Oct-94 jfd   In ifmake_gaso_and_stats(), when processing outlines,
                     use "wholeOrgBox.ll" rather than "chr_def_hdr.origin"
                     when calculating origin ("if_state.cs.origin").
     11-Dec-94 mby   Changes in ifmake_gaso_and_stats(): if_state.cs.origin_cs
                     is now SL32VECTOR instead of SW16VECTOR.
     09-Jan-95 jfd/mby
                     In MAKifbmheader(), do not set "frac_places" to 4
                     for FCO input. This value will be calculated dynamically
                     later in fco_set_trans().
     27-Jan-95 mby   Call fco_CharCleanup() from MAKifbmheader(). This is
                     intended to happen at the very beginning of making a
                     new character to clean up memory left over from the
                     rasterization of the previous (FCO) character.
     01-Feb-95 jfd   In ifmake_gaso_and_stats(), if not quadrant rotation,
                     set "wholeOrgBox.ll" to "chr_def_hdr.origin". This
                     variable is used later in the routine if processing
                     an outline.
     14-Feb-95 mby   In MAKfontSize reduce size[1] NZW buffer to fit structure alignment.
     23-Feb-95 jfd   In MAKfontSize, changed "cc_size" from UW16 to UL32
                     to prevent overflow when processing large characters.

-----------------------------------------------------------------------*/


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <string.h>
#include "cgconfig.h"
#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "cgif.h"
#include "q3.h"
#include "segments.h"
#include "ix.h"
#include "fpmath.h"
#include "if_type.h"
#include "bitmap.h" 
#include "imath.h"


#ifdef LINT_ARGS
GLOBAL UW16   MAKfontSize(PFONTCONTEXT, SW16, LPSL32);
GLOBAL UW16   MAKifbmheader(PFONTCONTEXT, SW16, PIFBITMAP);

EXTERN UW16   map_and_set_scale(PFONTCONTEXT, SW16);
EXTERN VOID    out_count(PCHAR_STATS);
#ifdef DEBUG
EXTERN VOID    pr_tran(LPUB8, SW16, SW16);           /* pr_tran.c */
#endif
EXTERN SW16    frac_bits(SL32);


GLOBAL UW16   ifmake_gaso_and_stats(PBUCKET, PCHAR_STATS);
/*
Following are temporary stubs for remainder of 'if' interface functions
until the real thing arrives - 1/22/92 - rs
*/
GLOBAL UW16   ifset_trans (PBUCKET, SL32, SL32, SL32, SL32);

#if OUTLINE
MLOCAL UW16    estimate_outline(VOID);
#endif  /* OUTLINE */

EXTERN LPSB8   fgseg(PBUCKET);

#if FCO_RDR
GLOBAL VOID    fco_CharCleanup(VOID);
#endif

#else          /* NOT LINT_ARGS */
EXTERN UW16   map_and_set_scale();
EXTERN VOID    out_count();
#ifdef DEBUG
EXTERN VOID    pr_tran();           /* pr_tran.c */
#endif
GLOBAL UW16   ifmake_gaso_and_stats();
EXTERN SW16    frac_bits();

/*
Following are temporary stubs for remainder of 'if' interface functions
until the real thing arrives - 1/22/92 - rs
*/
GLOBAL UW16   ifset_trans ();

#if OUTLINE
MLOCAL UW16    estimate_outline();
#endif  /* OUTLINE */

EXTERN LPSB8   fgseg();

#if FCO_RDR
GLOBAL VOID    fco_CharCleanup();
#endif
#endif         /* LINT_ARGS  */

#if SLIM_FONTS
GLOBAL SW16 special_case=0;
#endif



/*------------------------------------------------------------*/
EXTERN IF_STATE if_state;
/* #if TILE */
GLOBAL SCAN_CONVERT scan_convert;
/* #endif  */
EXTERN CHR_DEF chr_def[];
EXTERN CHR_DEF_HDR chr_def_hdr;
#if 0
EXTERN SW16VECTOR entire_tt;     /* translation for entire bitmap      */
EXTERN IFBITMAP   entire_bm;     /* header of entire bitmap w/ metrics */
#endif
GLOBAL SW16VECTOR entire_tt;     /* translation for entire bitmap      */
GLOBAL IFBITMAP   entire_bm;     /* header of entire bitmap w/ metrics */
EXTERN int gaso_pn;
/*------------------------------------------------------------*/


#if LINEAR

/*  Define output functions that do nothing.  For counting the number of
 *  lineto()'s produced for linear outlines, we call outline with
 *  if_state.est_outline == TRUE.  The vectorizing functions check this
 *  flag and update the lineto, quadto and cubeto counts in if_state.cs
 *  without actually producing the vectors.
 */
#ifdef LINT_ARGS
EXTERN UW16     cgoutline(VOID);
MLOCAL UW16     startchar(PVOID);
MLOCAL UW16     end(VOID);
MLOCAL UW16     startloop(UW16);
MLOCAL UW16     moveto(INTR, INTR);
#else
EXTERN UW16     cgoutline();
MLOCAL UW16     startchar();
MLOCAL UW16     end();
MLOCAL UW16     startloop();
MLOCAL UW16     moveto();
#endif

MLOCAL UW16 startchar(p) PVOID p; {return SUCCESS;}
MLOCAL UW16 end() {return SUCCESS;}
MLOCAL UW16 startloop(polarity) UW16 polarity; {return SUCCESS;}
MLOCAL UW16 moveto(x, y) INTR x,y;  {if_state.p0.x = x;
                                     if_state.p0.y = y; return SUCCESS;}

MLOCAL OUT_TBL est_out_tbl = {
    startchar,        /* startchar */
    end,              /* endchar   */
    startloop,        /* startloop */
    end,              /* endloop   */
    moveto,           /* moveto    */
    moveto            /* lineto    */
};
#endif   /* LINEAR */

#if NON_Z_WIND
EXTERN RASTER ras;
#endif

#if OUTLINE
/*----------------------*/
/*   estimate_outline   */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  estimate_outline()
#else
MLOCAL UW16
estimate_outline()
#endif
{
    UW16 status;
    SW16 format;
    SL32 num_bytes;
    SW16 new_loop_space;

    format = if_state.cs.format;
    
#if LINEAR
    if(format == FC_LINEAR_TYPE)
    {
        if_state.est_outline = TRUE;
        if_state.out = est_out_tbl;
        status = cgoutline();
        if(status)
            return status;
    }
#endif
    if_state.est_outline = FALSE;

  /*  Estimate or compute upper bound of IFOUTLINE memory */

    new_loop_space = sizeof(OUTLINE_LOOP) * if_state.cs.nloop;

 /* Make sure we have enough to long align vectors later. -ss,awr 7/10/92 */
    new_loop_space += 3;

    if_state.cs.est_pnts =
    if_state.cs.est_segs = if_state.cs.nloop
                         + if_state.cs.ct_lineto
                         + if_state.cs.ct_quadto
                         + if_state.cs.ct_cubeto;

    if(format == FC_QUAD_TYPE)
        if_state.cs.est_pnts += if_state.cs.ct_quadto;
    else if(format == FC_CUBIC_TYPE)
        if_state.cs.est_pnts += (if_state.cs.ct_quadto << 1)
                                + 5*if_state.cs.ct_cubeto;

    num_bytes = (SL32)(sizeof(OUTLINE_CHAR) - sizeof(OUTLINE_LOOP))
                + (SL32)new_loop_space
                + (SL32)((SL32)sizeof(INTRVECTOR) * (SL32)if_state.cs.est_pnts)
                + (SL32)(if_state.cs.est_segs);
    if_state.cs.est_size = num_bytes;
    DBG1("num_bytes = %d\n", num_bytes);
    return SUCCESS;
}
#endif  /* OUTLINE */
#if IF_RDR
/*----------------------*/
/*       out_count      */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  out_count(PCHAR_STATS pcs)
#else
GLOBAL VOID
out_count(pcs)
    PCHAR_STATS pcs;
#endif
{
    SW16 j;
    LOOP loop;

    pcs->nloop += if_state.num_loops;
    first_loop();
    for (j=0; j< if_state.num_loops; j++)
    {
        next_loop(&loop);
        if(if_state.quality == 1)
        {
            pcs->ct_lineto += loop.npnt;
        }
        else if(if_state.quality == 2)
        {
            pcs->ct_lineto += loop.npnt + loop.ncontact;
        }
        else if(if_state.quality == 3)
        {
            pcs->ct_lineto += loop.npnt - loop.ncontact;
            pcs->ct_quadto += loop.ncontact << 1;
        }
    }
}
/*----------------------*/
/* ifmake_gaso_and_stats*/
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  ifmake_gaso_and_stats(PBUCKET pb, PCHAR_STATS pcs)
#else
GLOBAL UW16
ifmake_gaso_and_stats(pb, pcs) /* jfd */
    PBUCKET     pb;
    PCHAR_STATS pcs;
#endif
{
    UW16        status;
    SW16        pn;
    PCHR_DEF    cd;
    SW16VECTOR  off;
    SW16VECTOR  tt0;   /* Saved translation of whole's des2bm() */

    BOX des;    /* union of design space bounding boxes of parts */
    BOX pix;    /*   "    " output  "      "        "    "   "   */
    BOX gbox;   /* output space bounding box of next part        */
    BOX wholeOrgBox;
    INTR dx, dy;

    EXTERN FONTINDEX fontindex;
    FONTINDEX        fi_sav;

    BOOLEAN use_part1_trans = FALSE;

    fi_sav = fontindex;

#if NON_Z_WIND
    if_state.cs.tran_run_ct = 0;
#endif

  /* Get bounds for first part of character */

    gaso_pn = -1;       /* no valid gaso in buffer */
    cd = chr_def;
    status = make_gaso(0, cd);
    if (status)
    {
       fontindex = fi_sav;   /* restore */
       return status;
    }


    des = if_state.bound_box;    /* Design unit bounding box */

    cd->bmorigin.x =
    cd->bmorigin.y =
    pix.ll.x =
    pix.ll.y = 0;
  /* pixel width and depth */
    pix.ur.x = (SW16)((if_state.tbound.ur.x + (INTR)half_xpix) >> log_xpix);
    pix.ur.y = (SW16)(if_state.tbound.ur.y >> log_ypix);

    cd->pix_bound = pix;
    DBG4("pix_bound  (%d,%d)   (%d,%d)\n", pix.ll.x,
                                           pix.ll.y,
                                           pix.ur.x,
                                           pix.ur.y);

  /*  Declare origin of first character part translated by first part's
   *  offset to be origin of compound character.
   */
#if SLIM_FONTS
    if( (chr_def_hdr.mirror_flags&MIRROR_Y_MASK) &&
         (-cd->offset.y) <
         (if_state.bound_box.ur.y + if_state.bound_box.ll.y - 
                (if_state.escape_box.ll.y<<1)) + 25 &&
         (-cd->offset.y) >
         (if_state.bound_box.ur.y + if_state.bound_box.ll.y - 
                (if_state.escape_box.ll.y<<1)) - 25 &&
#if OUTLINE
         (!pcs->format) &&  /* if not using outlines OK to special case */
#endif /* OUTLINE */
          (if_state.quadrant || if_state.shear) )   /* 4/26/94, mby */
    {                             /* set special_case if rotation is */
         special_case = TRUE;     /* orthogonal, even if shear is nonzero */
         if (if_state.quadrant)
             cd->offset.y = 0;    /* if there's no shear, set offset to 0 */
    }
    else
         special_case = FALSE;
#endif
    off.x = cd->offset.x;
    off.y = cd->offset.y;

    /* If first part is a space character, use translation of next part */

    if (!if_state.num_loops)    /* 4-14-94 jfd */
       use_part1_trans = TRUE;  /* 4-14-94 jfd */

    chr_def_hdr.origin.x = if_state.escape_box.ll.x - off.x;
    chr_def_hdr.origin.y = if_state.escape_box.ll.y - off.y;
    DBG("PART 0:\n");
    DBG4("Design space bounding box (%d,%d)   (%d,%d)\n", des.ll.x,
                                                          des.ll.y,
                                                          des.ur.x,
                                                          des.ur.y);
    DBG2("    origin.x, origin.y: (%d,%d)\n",
                            chr_def_hdr.origin.x, chr_def_hdr.origin.y);
#if 0
    DBG("Bitmap:\n");
    print_bm(&dst);   /* jfd */
#endif

    if(!chr_def_hdr.is_compound)
    {
        chr_def_hdr.escape.x = if_state.escape_box.ur.x - if_state.escape_box.ll.x;
        chr_def_hdr.escape.y = if_state.escape_box.ur.y - if_state.escape_box.ll.y;
    } /* else escape has been previously filled in */

    out_count(pcs);

#if OUTLINE
    pcs->format = if_state.cur_loc_fc.format & FC_OUTPUT_MASK;
    if(pcs->format)   /* non-zero means outline format */
    {
        pcs->xscale = if_state.x.pixel_size << powincr;
        pcs->yscale = if_state.y.pixel_size << powincr;

        pcs->escapement = chr_def_hdr.escape.x;
        pcs->olbox = if_state.tbound;
    }
#endif

    if(if_state.quadrant)
        wholeOrgBox = char_left_ref(chr_def_hdr.origin, pix, off.y);
    else
        wholeOrgBox.ll = chr_def_hdr.origin;

    for(pn=1, cd=chr_def; pn<chr_def_hdr.num_parts; pn++)
    {
        DBG1("\nPART %d\n", pn);
        cd++;

        tt0 = if_state.tt;    /* save translation of first part */

        status = make_gaso((int)pn, cd);
        if (status)
        {
           fontindex = fi_sav;   /* restore */
            return status;
        }

        if (use_part1_trans)          /* 4-14-94 jfd */
        {                             /* 4-14-94 jfd */
           tt0 = if_state.tt;         /* 4-14-94 jfd */
           des = if_state.bound_box;  /* 4-14-94 jfd */
        }                             /* 4-14-94 jfd */

        DBG4("Design space bounding box (%d,%d)   (%d,%d)\n",
                                                    if_state.bound_box.ll.x,
                                                    if_state.bound_box.ll.y,
                                                    if_state.bound_box.ur.x,
                                                    if_state.bound_box.ur.y);
#if INTR_SIZE == 16
        DBG4("Output space bounding box (%d,%d)   (%d,%d)\n",
                                                    if_state.tbound.ll.x,
                                                    if_state.tbound.ll.y,
                                                    if_state.tbound.ur.x,
                                                    if_state.tbound.ur.y);
#else
        DBG4("Output space bounding box (%ld,%ld)   (%ld,%ld)\n",
                                                    if_state.tbound.ll.x,
                                                    if_state.tbound.ll.y,
                                                    if_state.tbound.ur.x,
                                                    if_state.tbound.ur.y);
#endif
        union_bound_boxes(&des, &if_state.bound_box, cd->offset.x - off.x,
                                              cd->offset.y - off.y);

      /*  O u t p u t    b o u n d    b o x  */
      /* gbox is cc part positioned in 1st part */

        cd->pix_bound.ll.x = 0;
        cd->pix_bound.ll.y = 0;
        cd->pix_bound.ur.x = (SW16)((if_state.tbound.ur.x + (INTR)half_xpix)
                                                              >> log_xpix);
        cd->pix_bound.ur.y = (SW16)(if_state.tbound.ur.y >> log_ypix);

        cd->bmorigin =
        gbox.ll      = find_part2whole(wholeOrgBox.ll, tt0, cd);
        gbox.ur.x    = gbox.ll.x + cd->pix_bound.ur.x;
        gbox.ur.y    = gbox.ll.y + cd->pix_bound.ur.y;
        DBG4("   src black box in dest:  (%d %d)  (%d %d)\n",
                               gbox.ll.x, gbox.ll.y, gbox.ur.x, gbox.ur.y);
        union_bound_boxes(&pix, &gbox, 0, 0);
        out_count(pcs);

#if OUTLINE
        if(pcs->format)
        {
            dx = (INTR)cd->bmorigin.x * (INTR)xpix;
            dy = (INTR)cd->bmorigin.y * (INTR)ypix;
    pcs->olbox.ll.x = MIN(pcs->olbox.ll.x, dx + if_state.tbound.ll.x);
    pcs->olbox.ll.y = MIN(pcs->olbox.ll.y, dy + if_state.tbound.ll.y);
    pcs->olbox.ur.x = MAX(pcs->olbox.ur.x, dx + if_state.tbound.ur.x);
    pcs->olbox.ur.y = MAX(pcs->olbox.ur.y, dy + if_state.tbound.ur.y);
        }
#endif

    }

  /*  If the overall bounding box grew left or down, we have to:
   *      1. adjust the bmorigin of every part
   *      2. adjust the translation
   */

    if(pix.ll.x < 0 || pix.ll.y < 0)
    {
        dx = (INTR)pix.ll.x * (INTR)xpix;
        dy = (INTR)pix.ll.y * (INTR)ypix;

        cd = chr_def;
        for(pn=0; pn<chr_def_hdr.num_parts; pn++)
        {
            cd->bmorigin.x -= pix.ll.x;
            cd->bmorigin.y -= pix.ll.y;
            cd++;
        }
        if_state.tt.x   -= (SW16)dx;
        if_state.tt.y   -= (SW16)dy;
        pix.ur.x -= pix.ll.x;
        pix.ur.y -= pix.ll.y;
#if OUTLINE
        if(pcs->format)
        {
            pcs->olbox.ll.x -= dx;
            pcs->olbox.ll.y -= dy;
            pcs->olbox.ur.x -= dx;
            pcs->olbox.ur.y -= dy;
        }
#endif
    }
#if OUTLINE
    if(pcs->format)   /* non-zero means outline format */
    {
        SW16VECTOR tempOrg;
#if defined MDES2BM
        tempOrg = MDES2BM(wholeOrgBox.ll);
#else
        tempOrg = des2bm(wholeOrgBox.ll);
#endif /* defined MDES2BM */
        if_state.cs.origin_cs.x = (SL32)tempOrg.x;
        if_state.cs.origin_cs.y = (SL32)tempOrg.y;
        if_state.cs.origin_cs.x =
              (SL32)((if_state.cs.origin_cs.x+half_xpix)&if_state.x.grid_align);
        if_state.cs.origin_cs.y =
              (SL32)((if_state.cs.origin_cs.y+half_ypix)&if_state.y.grid_align);

        if_state.cs.olbox.ll.x -= (INTR)if_state.cs.origin_cs.x;
        if_state.cs.olbox.ll.y -= (INTR)if_state.cs.origin_cs.y;
        if_state.cs.olbox.ur.x -= (INTR)if_state.cs.origin_cs.x;
        if_state.cs.olbox.ur.y -= (INTR)if_state.cs.origin_cs.y;

      /* Account for increase in final output resolution */

        if_state.cs.olbox.ll.x <<= powincr;
        if_state.cs.olbox.ll.y <<= powincr;
        if_state.cs.olbox.ur.x <<= powincr;
        if_state.cs.olbox.ur.y <<= powincr;

        DBG1("    if_state.cs.format %d\n", if_state.cs.format);
        DBG1("    if_state.cs.nloop  %d\n", if_state.cs.nloop );
#if 0
        status = estimate_outline();
        if(status)
        {
           fontindex = fi_sav;   /* restore */
           return status;
        }
#endif
    }
#endif  /* OUTLINE */

  /* Return CHAR_STATS */

/*  Pretend we didn't figure out tt yet.  We'll figure it out again when
 *  we return.
 */

    pcs->xmin = -if_state.tt.x;
    pcs->ymin = -if_state.tt.y;
    pcs->xmax = -if_state.tt.x + (INTR)pix.ur.x * (INTR)xpix;
    pcs->ymax = -if_state.tt.y + (INTR)pix.ur.y * (INTR)ypix;

  /* Store escapement in either native units or 8782/em  01-25-93 - jfd */

#if DU_ESCAPEMENT
    {
    PDISPLAY     display;

    SL32         des_em_width;

    display        = (PDISPLAY)(fgseg(if_state.pbucket)
                   + if_state.pbucket->p.in.odisplay);
    des_em_width   = (SL32)( (SL32)((SL32)(display->masterPointSize) / 8L)
                           * (SL32)((SL32)(display->scanResolutionX) * 1383L)
                           / 100000L );

    pcs->du_emx      = (SW16)des_em_width;
    pcs->du_emy      = (SW16)des_em_width;
    }
#else
    pcs->du_emx      = (SW16)8782;
    pcs->du_emy      = (SW16)8782;
#endif
    pcs->escapement = chr_def_hdr.escape.x;
    pcs->dorigin = chr_def_hdr.origin;  /* 6-1-92 */

    pcs->dxmin = des.ll.x;
    pcs->dymin = des.ll.y;
    pcs->dxmax = des.ur.x;
    pcs->dymax = des.ur.y;
#if 0
    pcs->ct_loop = if_state.num_loops;  /* 4-23-92 */
#endif
#if NON_Z_WIND
    if_state.cs.tran_run_ct <<= 1; /* Actual extremes may not be curve pts */
#endif

    DBG("\n\nFinal result\n");
    DBG4("Design space bounding box (%d,%d)   (%d,%d)\n", des.ll.x,
                                                          des.ll.y,
                                                          des.ur.x,
                                                          des.ur.y);

    fontindex = fi_sav;
    return SUCCESS;
}

/*
Temporary stub functions for remainder of 'if' interface mechanism
until the real thing becomes available - 1/22/92 - rs
*/
#if defined (ANSI_DEFS)
GLOBAL UW16   ifset_trans (PBUCKET pb, SL32 l1, SL32 l2, SL32 l3, SL32 l4)
#else
GLOBAL UW16   ifset_trans (pb, l1, l2, l3, l4)
PBUCKET  pb;
SL32     l1, l2, l3, l4;
#endif
{
   DBG ("\nifset_trans()\n");
   return (0);
}
#endif /* IF_RDR  */

/*----------------------*/
/*    MAKifbmheader     */
/*----------------------*/
/*  Fill in the header portion of the IFBMRECT structure with metric
 *  information for a bitmap. Do not actually build the bitmap.
 *  Side effects:
 *     1. Translation for entire bitmap saved in entire_tt
 *     2. Copy of bitmap header saved in entire_bm;
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  MAKifbmheader(PFONTCONTEXT fc, SW16 chId, PIFBITMAP pbm)
#else
GLOBAL UW16
MAKifbmheader(fc, chId, pbm)
    PFONTCONTEXT  fc;
    SW16          chId;
    PIFBITMAP     pbm;  /* returned bitmap header */
#endif
{
    IFBITMAP dst;
    UW16       status;
    SL32VECTOR bounds;
    SW16     frac_places, frac_pixel;
#if INTR_SIZE == 16
    SW16     right_shift;
#endif

#if !DU_ESCAPEMENT
    SW16         esc;
    int          esc_changed = 0;
#endif

DBG("\n\n\n\n MAKifbmheader()\n");

#if FCO_RDR
    if (if_state.fcoCleanup)
        fco_CharCleanup();
#endif
    if_state.est_outline = FALSE;
    status = map_and_set_scale(fc, chId);
    if (status)
      return status;

    if_state.fst_type    = if_state.cur_loc_fc.format & FC_FONTTYPE_MASK;

#if OUTLINE
    if_state.cs.format = if_state.cur_loc_fc.format & FC_OUTPUT_MASK;
    if ((if_state.pbucket->fst_type == FC_PST1_TYPE) &&
           (if_state.cs.format == FC_QUAD_TYPE))
        return ERRinvalid_outproc_type;
#endif
    if_state.cs.nloop     =
    if_state.cs.ct_lineto =
    if_state.cs.ct_quadto =
    if_state.cs.ct_cubeto = 0;

/* Moved NON_IF_FONT block from before line which sets if_state.xlate.x and 
 * if_state.xlate.y because ttmake_gaso_and_stats() needs if_state.x.pixel_size
 * and if_state.y.pixel_size.
 * 01-21-93 jfd */

#if NON_IF_FONT
    if(if_state.pbucket->fst_type != FC_IF_TYPE)
    {
        if_state.quality = 3;

        if(if_state.fst_type == FC_PST1_TYPE)   /* PostScript */
            frac_places = 4;
        else if(if_state.fst_type == FC_TT_TYPE)  /* TrueType  */
            frac_places = 6;

        if (if_state.pbucket->fst_type != FC_FCO_TYPE)
        {
           frac_pixel = 1<<frac_places;
           if_state.x.pixel_size = if_state.y.pixel_size = frac_pixel;
           if_state.x.half_pixel = if_state.y.half_pixel = frac_pixel >> 1;
           if_state.x.grid_shift = if_state.y.grid_shift = frac_places;
           if_state.x.grid_align = if_state.y.grid_align = ~((INTR)frac_pixel
                                                                     -(INTR)1);
        }
    }
#endif

#if USE_JUMP_TABLES
    status = (*((PIF_FUNC_TBL)if_state.pbucket->pft)->make_gaso_and_stats)
                               (if_state.pbucket, &if_state.cs);
#else
   switch (if_state.pbucket->fst_type)
   {
#if IF_RDR
      case FC_IF_TYPE:
         status = ifmake_gaso_and_stats (if_state.pbucket, &if_state.cs);
         break;
#endif
#if PST1_RDR
      case FC_PST1_TYPE:
         status = psmake_gaso_and_stats (if_state.pbucket, &if_state.cs);
         break;
#endif
#if TT_RDR
      case FC_TT_TYPE:
         status = ttmake_gaso_and_stats (if_state.pbucket, &if_state.cs);
         break;
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
         status = fco_make_gaso_and_stats (if_state.pbucket, &if_state.cs);
         break;
#endif
      default:
         return (ERR_fst_type);
     }
#endif /* USE_JUMP_TABLES */

    if (status)
       return status;

#if NON_Z_WIND
    /* Save copy of number of transition runs. This value is the true
     * number of runs. The value "if_state.cs.tran_run_ct" will be
     * incremented later by manipula() causing an inaccurate number
     * of runs to be stored.     12-16-93 jfd/jc
     */
    ras.tran_run_ct = (NZCOUNTER)if_state.cs.tran_run_ct;
#endif


#if !DU_ESCAPEMENT

    esc = if_state.cs.escapement;

#if IF_RDR                              
    /* Test for master point size and x scan resolution based on IF's  */
    /* base of 8782.  If different, adjust escapement.    -ss 8/17/92  */
    if(if_state.pbucket->fst_type == FC_IF_TYPE)
    {
#define IF_MASTERPT_SIZE 2000L  /* IF 250pts * 8 for eigths of a point */
#define XSCAN_RES        2540L  /* IF design window units              */
#define IF_EM_WIDTH    ( IF_MASTERPT_SIZE * XSCAN_RES )

       PDISPLAY     display;
       FPNUM        tmp_fp,
                    factor;
       SL32         des_em_width;

       display        = (PDISPLAY)(fgseg(if_state.pbucket)
                      + if_state.pbucket->p.in.odisplay);
       des_em_width   = (SL32)display->masterPointSize
                      * (SL32)display->scanResolutionX;
       if(des_em_width != IF_EM_WIDTH )
       {
          /** new dst.esc = (old esc * IF_EM_WIDTH ) / des_em_width  **/
          factor      = fpdiv( fplongexp(IF_EM_WIDTH, 0),
                               fplongexp(des_em_width, 0) );
          tmp_fp      = fpmul( fplongexp( (SL32)esc, 0 ), factor );
          esc         = fp2word( tmp_fp );   /* save it */
          esc_changed = 1;
       }
    }
#endif /* IF_RDR */

#if NON_IF_FONT
     /* Compensate for rounding when PS or TT is converted to 8782-based
        Multiply by TT or PS point size / Inteliifont point size
                = (1/72) / 0.01383 = 100,000/(72 * 1383)
                = 12500 / (9 * 1383) = 12500 / 12447     -ss,awr 8/20/92
     */
    if( if_state.pbucket->fst_type == FC_PST1_TYPE ||
        if_state.pbucket->fst_type == FC_TT_TYPE )
    {
       esc         = (UW16)( (((SL32)esc * 12500L) + 6223L) / 12447L );
       esc_changed = 1;
    }
#endif  /* NON_IF_FONT */

    /* save changed escapement. */
    if(esc_changed)
       if_state.cs.escapement = esc;

#endif  /* !DU_ESCAPEMENT */


#if TT_RDR || FCO_RDR
    if (if_state.fst_type == FC_TT_TYPE || if_state.fst_type == FC_FCO_TYPE)
       if_state.num_loops = if_state.cs.nloop;
#endif  /* TT_RDR */

    if_state.xlate.x =   -(((INTR)if_state.cs.xmin + if_state.x.half_pixel)
                                          & if_state.x.grid_align);
    if_state.xlate.y =   ((-(INTR)if_state.cs.ymin + if_state.y.half_pixel)
                                          & if_state.y.grid_align);

#if INTR_SIZE == 16
    DBG2("    if_state.xlate.x = %d   if_state.xlate.y = %d\n",
                                       if_state.xlate.x, if_state.xlate.y);
#else
    DBG2("    if_state.xlate.x = %ld   if_state.xlate.y = %ld\n",
                                       if_state.xlate.x, if_state.xlate.y);
#endif

  /*  Compute working bitmap bounding box: assumes we will
   *  translate by if_state.xlate.  Add half pixel in y direction.
   */

    bounds.x = if_state.cs.xmax + (SL32)if_state.xlate.x;
    bounds.y = if_state.cs.ymax + (SL32)if_state.xlate.y
                                             + (SL32)if_state.y.half_pixel;

  /* IF INTR_SIZE has been set to 16, compute the number of fractional
   * bits we can keep without overflowing the 16 bit scan converter.
   * We will shift all coordinates from PS and TT to the right.
   */

    if_state.right_shift = 0;

#if INTR_SIZE == 16
    if(if_state.pbucket->fst_type != FC_IF_TYPE)
    {
        frac_places = frac_bits(1 + MAX(bounds.x >> log_xpix,
                                        bounds.y >> log_ypix));

        if(frac_places < 0)
            return ERR_ov_16_bit_value;
        else
        {
            right_shift = log_xpix - frac_places;
            if(right_shift <= 0)
                right_shift = 0;
            else
            {
                log_xpix     -= right_shift;
                log_ypix     -= right_shift;
                xpix        >>= right_shift;
                ypix        >>= right_shift;
                half_xpix   >>= right_shift;
                half_ypix   >>= right_shift;
                bounds.x >>= right_shift;
                bounds.y >>= right_shift;
                if_state.cs.xscale >>= right_shift;
                if_state.cs.yscale >>= right_shift;
            }
            if_state.right_shift = right_shift;
        }
    }
#endif

#if OUTLINE
    if(if_state.cs.format)
    {
#if NON_IF_FONT
        if(if_state.pbucket->fst_type != FC_IF_TYPE)
        {
    if_state.cs.olbox.ll.x = (INTR)(if_state.cs.xmin >> if_state.right_shift);
    if_state.cs.olbox.ll.y = (INTR)(if_state.cs.ymin >> if_state.right_shift);
    if_state.cs.olbox.ur.x = (INTR)(if_state.cs.xmax >> if_state.right_shift);
    if_state.cs.olbox.ur.y = (INTR)(if_state.cs.ymax >> if_state.right_shift);
        }
#endif
        status = estimate_outline();
        if(status)
            return status;
    }
#endif

    dst.left_indent =
    dst.top_indent  = 0;
    dst.black_width = (SW16)((bounds.x + (INTR)half_xpix) >> log_xpix);
    dst.black_depth = (SW16)(bounds.y >> log_ypix);

  /* Bitmap width in bytes: we're really adding 1 to black width first
   * to account for off transition. During the ceiling op below, that
   * extra one gets cancelled out.
   */
    dst.width = (1+dst.black_width/if_state.bit_map_width)
                                * (if_state.bit_map_width >>3);
    dst.depth = dst.black_depth;

    metrics(&dst);

    DBG("Bitmap\n");
    print_bm(&dst);

    entire_bm = dst;
    entire_tt = if_state.tt;   /* save translation */
    *pbm = dst;
    return SUCCESS;

} /* MAKifbmheader() */


#if CHAR_SIZE
/*----------------------*/
/*    MAKfontSize       */
/*----------------------*/
/*  Returns number of bytes needed for cached bitmap and sets up the
 *  the character generation subsytem (the "maker") to produce a
 *  character bitmap.
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  MAKfontSize(PFONTCONTEXT fc, SW16 chId, LPSL32 size)
#else
GLOBAL UW16
MAKfontSize(fc, chId, size)
    PFONTCONTEXT  fc;
    SW16          chId;
    LPSL32         size;      /* returned bitmap size       */
#endif
{
    IFBITMAP bm;

    UW16 status;
#if IF_RDR
    UL32 cc_size = 0L;
    UW16 looper,delta_x  = 0;
    UW16 bytes_per_row,num_rows = 0;
#endif

    DBG1("MAKfontSize(%d)\n", chId);

    if(status = MAKifbmheader(fc, chId, &bm))
        return status;

#if OUTLINE
    if(if_state.cs.format)   /* non-zero means outline format */
        size[0] = (SL32)OLHEADERSIZE + (SL32)if_state.cs.est_size;
    else
#endif
    {
        size[0] = (SL32)BMHEADERSIZE + (SL32)bm.width * (SL32)bm.depth;
#if NON_Z_WIND
        if(if_state.non_z_wind)
        {
            size[1] = (SL32)if_state.cs.tran_run_ct * (
                           (SL32)((sizeof(NZ_NODE) + MEM_ALIGN) & ~MEM_ALIGN)
                         + (SL32)bm.depth * (SL32)(sizeof(NZCOUNTER))
                                                      );
           if(size[1] > (SL32)MAX_BM) return ERRnzw_mem_overflow;
           DBG1("nzw buf size %ld\n", size[1]);
        }
        else
#endif
            size[1] = 0L;     /* initialize nzw buf for application */

    /* At this point in time, the CHR_HDR_DEF structure is filled, especially */
    /* the pix_bound member (pixel bounding box, x and y).  These values will */
    /* be used to calculate the size of the compound char buffer.             */
        
#if IF_RDR
        if (if_state.fst_type == FC_IF_TYPE)
        {
           for (looper = 1; looper < chr_def_hdr.num_parts; looper++)
           {
           /* Assume base char will always be looper = 0 */

              num_rows =  chr_def[looper].pix_bound.ur.y - 
                          chr_def[looper].pix_bound.ll.y + 1;

              delta_x  = chr_def[looper].pix_bound.ur.x - 
                         chr_def[looper].pix_bound.ll.x + 1;

              bytes_per_row = (1 + (delta_x-1)/if_state.bit_map_width)
                                    * (if_state.bit_map_width >> 3);

              cc_size = MAX(num_rows*bytes_per_row,cc_size);
           }

           /* We need to add the size of the bitmap header, for the size of */
           /* compound character buffer.                                    */
              
           if (chr_def_hdr.num_parts > 1)
              cc_size += (SL32 )BMHEADERSIZE;

           size[2] = cc_size;   
        }
        else

#endif  /* IF_RDR */

           size[2] = 0;
    }
    if(size[0] > (SL32)MAX_BM) return ERR_bm_too_big;

    return SUCCESS;
}
#endif   /* CHAR_SIZE */
