/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/cache.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cache.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   07 Apr 1995 08:45:12   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   21 Apr 1994 15:48:16   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   25 Jan 1994 10:45:30   MAIB
 * Created a two-byte character code caching scheme, conditionally compiled
 * on ASIAN_ENCODING
 * 
 *    Rev 1.3   25 Oct 1993 10:53:48   MAIB
 * 
 * Conditionally removed CACaccess, this functionality now inline in CGIFchar(
 * 
 *    Rev 1.2   15 Jan 1993 09:35:24   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:42:38   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:12   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* cache.h */
/*
 *
 * History
 *
 *    05-Aug-90  awr   added bitMapCount in FONTCONTEXT to improve cache
 *                     performance. If last bitmap is freed from a font
 *                     and it's not the current font, then the font is freed.
 *    31-Jan-91  dET   add support for MSC multi-model compilation.
 *    05-Mar-91  jfd   Added funtion prototype for CACpurge().
 *    06-Mar-91  jfd   Changed CACdefund() to BOOLEAN.
 *    25-Sep-91  jfd   Changed argument of CACpurge() from "FONTCONTEXT *"
 *                     to PFONTCONTEXT to get rid of compiler warning.
 *    03-Apr-92  rs    Portability cleanup (see port.h).
 *    25-Oct-93  maib  Conditionally left out CACaccess
 *    25-Jan-94  maib  Modified FONT for new caching scheme, included prototypes
 */



#if CACHE

/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
#define HASHMAX         256   /* max rows to contain column hash lists */
typedef struct {
   DLL         link;          /* list of cached bitmaps for particular row */
   UW16        chId;          /* two-byte encoding */
   HIFBITMAP   hbm;           /* handle to cached bitmap */
} HASH_ITEM;
typedef HASH_ITEM * PHASH_ITEM;
#endif

/*----------------------*/
/*      Font            */
/*----------------------*/

#define SSMAX         256

typedef struct
{
    DLL   link;           /* doubly linked list pointers- this slot may be
                           * in an active least recently used list or it may
                           * be unused in the avail list.
                           */
    UW16 bitmapCount;    /* Number of bitmaps in this font */
    FONTCONTEXT fc;
    PATHNAME pathname;
/*
 * 1/25/94 maib
 * new caching scheme for asian encoding
 */
#if ASIAN_ENCODING
    MEM_HANDLE hash_table[HASHMAX]; /* hash table */
#else
    HIFBITMAP hbuf[SSMAX];  /* buffer handles of cached characters */
#endif
}
FONT;
typedef FONT FARPTR * PFONT;


#ifdef LINT_ARGS
#if ASIAN_ENCODING
EXTERN MEM_HANDLE CAChashLookup(PFONT, UW16);
#endif /* ASIAN_ENCODING */
EXTERN UW16       CACinit(VOID);
EXTERN VOID        CACexit(VOID);
EXTERN UW16       CACfont(PFONTCONTEXT);
#if 0  /* 10/25/93 maib */
EXTERN PIFBITMAP   CACaccess(UW16);
#endif
EXTERN VOID        CACinsert(HIFBITMAP, UW16);
EXTERN UW16       CACpurge(PFONTCONTEXT);
#if DEFUND
EXTERN BOOLEAN     CACdefund(UW16);
#endif
EXTERN MEM_HANDLE  CHARalloc(SL32);
EXTERN VOID        CHARfree(MEM_HANDLE);

#else   /*  not LINT_ARGS  */

#if ASIAN_ENCODING
EXTERN MEM_HANDLE CAChashLookup();
#endif /* ASIAN_ENCODING */
EXTERN UW16       CACinit();
EXTERN VOID        CACexit();
EXTERN UW16       CACfont();
#if 0  /* 10/25/93 maib */
EXTERN PIFBITMAP   CACaccess();
#endif
EXTERN VOID        CACinsert();
EXTERN UW16       CACpurge();
#if DEFUND
EXTERN BOOLEAN     CACdefund();
#endif
EXTERN MEM_HANDLE  CHARalloc();
EXTERN VOID        CHARfree();
#endif  /* LINTARGS */



#else  /*  not CACHE */

#define CHARalloc(size)    MEMalloc(CACHE_POOL, (size))
#define CHARfree(h)        MEMfree(CACHE_POOL, (h))

#endif /* CACHE */


