/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/cgconfig.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cgconfig.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.59   22 Sep 1995 09:54:08   JOE
 * Moved DRAS_QUAD define below the DO NOT CHANGE line.
 * Changed settings to standard settings.
 * 
 *    Rev 1.58   07 Sep 1995 18:17:40   JOE
 * 
 * Changed #defines for TT_NOPLUG, TT_IFPLUG, TT_TTPLUG, TT_TTPLUG_IF,
 * TT_TTPLUG_ANY, PS_NOPLUG and PS_IFPLUG by making them independent
 * of FCO_RDR.
 * 
 *    Rev 1.57   24 Jul 1995 18:47:18   MIKE
 * 
 * Defined NO_SYMSET_MAPPING 0, below the line.
 * 
 *    Rev 1.55   20 Jul 1995 11:37:38   MIKE
 * Removed #define and #pragmas for NO_SYMSET_MAPPING
 * 
 *    Rev 1.54   18 Apr 1995 16:54:22   JOE
 * Added define and pragmas for NO_SYMSET_MAPPING.
 * 
 *    Rev 1.53   07 Apr 1995 08:45:12   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.52   31 Mar 1995 11:06:30   JOE
 * Added new define FCOACCESS (by jwd).
 * 
 *    Rev 1.51   13 Feb 1995 16:07:56   JOE
 * If !ASIAN_ENCODING,, #define ASIAN_ENCODING as 0 to resolve compiler
 * error on some platforms.
 * 
 *    Rev 1.50   25 Jan 1995 17:05:08   JOE
 * Before redefining NON_Z_WIND (if BOLD), undefine NON_Z_WIND
 * to resolve WATCOM compiler error.
 * 
 *    Rev 1.49   13 Jan 1995 18:06:32   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.48   02 Dec 1994 21:00:16   MIKE
 * (YAN) KSC.
 * 
 *    Rev 1.47   30 Nov 1994 10:59:32   JOE
 * Changed the defines TT_NOPLUG, TT_IFPLUG, TT_TTPLUG, TT_TTPLUG_IF,
 * TT_TTPLUG_ANY, PS_NOPLUG and PS_IFPLUG based on !FCO_RDR.
 * 
 *    Rev 1.46   14 Sep 1994 10:41:44   MIKE
 * Add FCO_RDR to definition of PLUGINS.
 * 
 *    Rev 1.45   02 Aug 1994 18:11:20   MIKE
 * Added FCO changes from 1.37.1.2
 * 
 *    Rev 1.44   11 Jul 1994 14:35:04   JOE
 * Moved #define for K_ENCODING here from TTKAN.C .
 * Expanded #define for ASIAN_ENCODING.
 * 
 *    Rev 1.43   22 Apr 1994 16:42:16   JOE
 * 
 * 
 * Added pragmas for MULTIFORMAT/CONVERGENT_FONTS.
 * 
 *    Rev 1.42   21 Apr 1994 16:51:00   JOE
 * 
 * Changed comment associated with SEGACCESS switch.
 * 
 *    Rev 1.41   21 Apr 1994 15:48:42   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.40   01 Mar 1994 15:48:54   MIKE
 * For CONVERGENT_FONTS, 1 is standard (AWT4), 3 is old format (AWT3).
 * 
 *    Rev 1.39   28 Feb 1994 17:58:20   MIKE
 * CONVERGENT_FONTS must take value 0, 3, or 4. Added #pragma.
 * 
 *    Rev 1.38   15 Feb 1994 09:32:30   JOE
 * 
 * Changed default settings.
 * 
 *    Rev 1.37   05 Jan 1994 15:28:30   ROB
 * Added #define for "GB" mapping.
 * 
 *    Rev 1.36   17 Dec 1993 17:13:04   JOE
 * Changed the comment associated with MAX_BM_BITS setting for UNIX (max
 * should be 22 not 32).
 * 
 *    Rev 1.35   08 Dec 1993 12:29:22   MAIB
 * Modified Unicode mapping defines
 * 
 *    Rev 1.34   07 Dec 1993 12:51:00   MAIB
 * Added literal to allow JIS to Unicode and Unicode to Jis mappings
 * 
 *    Rev 1.33   02 Dec 1993 11:59:22   MIKE
 * Fixed syntax error in #define ASIAN_ENCODING.
 * 
 *    Rev 1.32   01 Dec 1993 08:55:28   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.31   30 Nov 1993 14:49:30   ROB
 * Add BIG5 support and TCA hooks.
 * 
 *    Rev 1.29   09 Nov 1993 10:35:34   MIKE
 * 
 * Add UNICODE_ENCODING definition; updated KANJI_ENCODING.
 * 
 *    Rev 1.28   23 Sep 1993 17:45:24   MIKE
 * 
 * 
 *    Rev 1.27   23 Sep 1993 13:41:06   MIKE
 * 
 * Changed to TT_ROM1.
 * 
 *    Rev 1.26   17 Sep 1993 10:21:58   MIKE
 * Added EXTERN_ENTITY1.
 * 
 *    Rev 1.25   02 Sep 1993 15:09:54   JOE
 * 
 * Moved the following #defines above the dotted lines:
 * USE_JUMP_TABLES, DRAS_QUAD, SJIS_ENCODING, JIS_ENCODING, EUC_ENCODING
 * and USE_UFST_MAPPING.
 * 
 *    Rev 1.24   31 Aug 1993 14:15:34   AL
 * 
 * Added BOLD == 1 forces NON_Z_WIND to 1
 * 
 *    Rev 1.23   12 Aug 1993 18:13:10   ROB
 * Add 'PST1_SFNTI' to define for 'PST1_RDR'.
 * 
 *    Rev 1.22   02 Aug 1993 14:26:36   MAIB
 * New define to configure semaphore multi-tasking
 * 
 *    Rev 1.21   26 Jul 1993 11:40:32   ROB
 * 
 * Add T1REMASTER for type 1 multimaster support.
 * 
 *    Rev 1.20   14 Jul 1993 19:17:36   MIKE
 * 
 *    Rev 1.19   14 Jul 1993 19:09:32   MIKE
 * Added #defines for CONVERGENT_FONTS and MULTIFORMAT.
 * Added #define TT_PLUGINS 3 option for LJ4 compatible, IF format.
 * 
 *    Rev 1.18   01 Jul 1993 14:23:58   MAIB
 * added new define NON_Z_WIND
 * 
 *    Rev 1.17   25 Jun 1993 14:13:46   ROB
 * Changed default options.
 * 
 *    Rev 1.16   25 Jun 1993 14:11:50   ROB
 * No change.
 * 
 *    Rev 1.15   14 Jun 1993 18:38:56   ROB
 * Change comment on 'USE_UFST_MAPPING' to support type 1 encoding arrays.
 * 
 *    Rev 1.14   10 Jun 1993 10:01:32   ROB
 * Fix typo.
 * 
 *    Rev 1.13   08 Jun 1993 15:59:00   ROB
 * Add support for type 1 multimaster 'T1IMMASTER'.
 * 
 *    Rev 1.12   05 Jun 1993 18:56:06   ROB
 * Add conditional 'PST1_SFNTI' to support generic type 1 downloaded soft fonts.
 * 
 *    Rev 1.11   06 May 1993 15:35:28   JOE
 * FIxed comment regarding IF_DISK.
 * Added pragma stating that BANDING requires CACHE as well as TILE.
 * 
 *    Rev 1.10   04 May 1993 16:42:24   ROB
 * Add define 'DRAS_QUAD' for direct rasterization of quadratic beziers.
 * 
 *    Rev 1.9   09 Apr 1993 12:43:44   MIKE
 * Added #define for DYNAMIC_FONTS.
 * 
 *    Rev 1.8   07 Apr 1993 12:05:30   JOE
 * Added new defines for raster line organization support.
 * 
 *    Rev 1.7   29 Mar 1993 10:41:18   ROB
 * Add defines to support KANJI_ENCODING.
 * 
 *    Rev 1.6   04 Feb 1993 10:25:10   MIKE
 * Set FONTBBOX and ALIEN_BITS to 0
 * 
 *    Rev 1.5   04 Feb 1993 09:34:22   MIKE
 * Added #defines for FONTBBOX & ALIEN_BITS
 * 
 *    Rev 1.4   02 Feb 1993 17:01:54   JOE
 * Added #define for BANDING.
 * 
 *    Rev 1.3   29 Jan 1993 09:28:10   JOE
 * Added #define for DU_ESCAPEMENT.
 * 
 *    Rev 1.2   15 Jan 1993 09:35:34   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:41:40   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:10   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* cgconfig.h */

/* This file should be included in all .c files of the UFST core.          */
/* The setting of defines here determines the functionality options to be  */
/* included in the resulting libraries and executables.                    */
/* These defines are used to conditionally compile code in the core.       */

/* Setting a define to 1 includes that option, 0 excludes it.              */

/* ** When altering settings, make sure to note dependencies specied. **   */

/* Change History:
 *    1-Jan-92  awr Added #define TT_RDR
 *    9-Feb-92  awr Added #define IF_RDR
 *   26-Feb-92  jfd Added comment to explain meaning of OLDATA switch.
 *   18-Mar-92  rs  Add #define PST1_PCLEOI & TT_PCLEOI for UFST pcleo's.
 *                  Add '#error' in addition to '#pragma message'
 *   03-Apr-92  rs  Portability cleanup (see port.h).
 *   06-Apr-92  rs  Change 'FIXED_PITCH' to 'CGFIXED_PITCH' (portability).
 *   06-May-92  jfd Disabled "#error" statements due to problems on SUN
 *   08-May-92  jfd Changed definition for EXTERN_FONT from
 *                  "(PCLEO_RDR || PST1I || TT_RDR)" to
 *                  "(PCLEO_RDR || PST1_PCLEOI || TT_PCLEOI)".
 *   12 May 92  ss  Added NON_IF_FONT define to signify that one or more
 *                  PS/TT options are enabled.
 *   22-May-92  rs  Add #define USE_UFST_MAPPING for all symbol sets w/PS
 *    5 Jun 92  ss  Cleanup and major reorganization of file.
 *   14-Jun-92  awr Added #define INTR_SIZE
 *    3-Jul-92  awr Changed comments and pragma for MULTI_CALLER
 *    8-Jul-92  jfd Changed comment associated with WIDTHS to indicate
 *                  widths for any type of font (IF, PS or TT).
 *   10-Jul-92  jfd Moved #define for "USE_UFST_MAPPING" to fixed defines
 *                  section because it should not be changed.
 *                  Changed MEM_ALIGN from 1 to 3 for SUN/SPARC and added
 *                  pragma warning for DOS users.
 *   20-Jul-92  rs  Create new IF, PS & TT defines for disk, PCLEO & ROM
 *                  input.
 *   30-Jul-92  jfd Removed olsolete pragmas.
 *   21 Aug 92  ss  Added comments about DISK & ROM being mutually exclusive.
 *   27-Sep-92  awr Added DISK_FONTS, a derived define.
 *   10-Oct-92  rs  Implement USE_JUMP_TABLES feature for overlays.
 *   20-Oct-92  jfd Changed "FF_NOPLUG" to "TT_NOPLUG".
 *   22-Jan-93  jfd Added #define for DU_ESCAPEMENT.
 *   01-Feb-93  jfd Added #define for BANDING.
 *   04-Feb-93  mby Added #defines for FONTBBOX & ALIEN_BITS
 *   27-Mar-93  rs  Add #defines for Kanji support - , SJIS_ENCODIING,
 *                  JIS_ENCODING, EUC_ENCODING & KANJI_ENCODING.
 *   07-Apr-93  jfd Added #defines for RASTER_ORG and LEFT_TO_RIGHT_BIT_ORDER
 *                  for raster line organization support.
 *   07-Apr-93  mby Added #define for DYNAMIC_FONTS.
 *   04-May-93  rs  Add define for 'DRAS_QUAD' - direct rasterization of
 *                  quadratic curves.
 *   06-May-93  jfd Fixed comment regarding IF_DISK.
 *                  Added pragma stating that BANDING requires CACHE.
 *   29-May-93  rs  Add conditional 'PST1_SFNTI' for generic type 1
 *                  downloaded soft font support.
 *   06-Jun-93  rs  Add type 1 MultiMaster support 'T1MMASTER'.
 *   14-Jun-93  rs  Change comment for 'USE_UFST_MAPPING'.
 *   01-Jul-93 maib Added new define NON_Z_WIND to specify non-zero
 *                  winding methods for determining transitions.
 *                  Also, disabled error message "#error Can not enable 
 *                  multiple forms of type 1 soft fonts" due to problems
 *                  on SPARC
 *   06-Jul-93 mby  Added #defines for CONVERGENT_FONTS and MULTIFORMAT.
 *   10-Jul-93 mby  Added #define TT_PLUGINS 3 option for LJ4 compatible, IF format.
 *   23-Jul-93 rs   Add 'T1REMASTER' for type 1 multimaster support.
 *   02-Aug-93 maib Added SEM_ACCESS, to configure semaphore multi-tasking
 *   12-Aug-93 rs   Add 'PST1_SFNTI' to define for 'PST1_RDR'.
 *   31-Aug-93 awr  Set NON_Z_WIND to 1 if BOLD == 1.
 *   02-Sep-93 jfd  Moved the following #defines above the dotted line:
 *                  USE_JUMP_TABLES, DRAS_QUAD, SJIS_ENCODING, JIS_ENCODING,
 *                  EUC_ENCODING, and USE_UFST_MAPPING.
 *   13-Sep-93 mby  Added EXTERN_ENTITY1
 *   17-Sep-93 mby  Changed to TT_ROM1.
 *   09-Nov-93 gy/my  Added UNICODE_ENCODING definition. Expanded definition
 *                  of KANJI_ENCODING to include UNICODE_ENCODING.
 *                  Moved JIS, SJIS, EUC, & UNICODE_ENCODING below the line.
 *   23-Nov-93 rs   Add define for "BIG5" & "TCA". Add these to KANJI_ENCODING.
 *   01-Dec-93 jfd  Changed KANJI_ENCODING to ASIAN_ENCODING.
 *   02-Dec-93 mby  Fixed syntax error in #define ASIAN_ENCODING. "\" was
 *                  not the last character in the line.
 *   07-Dec-93 maib Added UNICODE_IN and UNICODE_OUT, moved asian literals
 *                  above the do-not-change line
 *   08-Dec-93 maib Changed the way in which Unicode mappings are determined
 *   17-Dec-93 jfd  Changed the comment associated with MAX_BM_BITS setting
 *                  for UNIX (max should be 22 not 32).
 *   05-Jan-94 rs   Add #define for "GB_ENCODING".
 *   28-Feb-94 mby  Added pragma to constrain CONVERGENT_FONTS to value of
 *                  0, 3 or 4.
 *   01-Mar-94 mby  CONVERGENT_FONTS can be 0, 1, or 3.
 *   20-Apr-94 jfd  Changed comment associated with SEGACCESS switch.
 *   22-Apr-94 jc   Added pragmas for MULTIFORMAT/CONVERGENT_FONTS.
 *   11-Jul-94 jfd  Moved #define for K_ENCODING here from TTKAN.C .
 *                  Expanded #define for ASIAN_ENCODING.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.37.1.2:
 *   11-Mar-94 mby  Added FCO_DISK, FCO_ROM, & FCO_RDR configurations.
 *   26-May-94 mby  Added FCO_TT configuration to the data output types to
 *                  generate a TrueType font from an FCO.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *
 *   14-Sep-94 mby  Add FCO_RDR to definition of PLUGINS.
 *   29-Nov-94 jfd  Changed the defines TT_NOPLUG, TT_IFPLUG, TT_TTPLUG,
 *                  TT_TTPLUG_IF, TT_TTPLUG_ANY, PS_NOPLUG and PS_IFPLUG
 *                  based on !FCO_RDR.
 *   02-Dec-94 yan  Ksc.
 *   09-Jan-95 rob  Implement support for > 64KB memory blocks in DOS.
 *                  Add '#define HUGE_PTR_SUPPORT'.
 *   25-Jan-95 jfd  Before redefining NON_Z_WIND (if BOLD), undefine
 *                  NON_Z_WIND to resolve WATCOM compiler error.
 *   10-Feb-95 jfd  If !ASIAN_ENCODING, #define ASIAN_ENCODING as 0
 *                  to resolve compiler error on some platforms.
 *   31-Mar-95 jwd  Added support for FCO Access function, CGIFfco_Access().
 *                  This function is conditionally compilable based on the
 *                  switch FCOACCESS.
 *   18-Apr-95 jfd  Added #define for NO_SYMSET_MAPPING.
 *                  Added pragmas for NO_SYMSET_MAPPING.
 *   20-Jul-95 mby  Removed #define and #pragmas for NO_SYMSET_MAPPING.
 *   24-Jul-95 mby  Defined NO_SYMSET_MAPPING 0 below the line.
 *   07-Sep-95 jfd  Changed #defines for TT_NOPLUG, TT_IFPLUG, TT_TTPLUG,
 *                  TT_TTPLUG_IF, TT_TTPLUG_ANY, PS_NOPLUG and PS_IFPLUG
 *                  by making them independent of FCO_RDR.
 *   22-Sep-95 jfd  Moved DRAS_QUAD define below the DO NOT CHANGE line.
 */
 
#define __WATCOMC__ 1
#define __386__ 1


/*-------------------*/
/* Memory Management */
/*-------------------*/
#define MEM_ALIGN       3  /* 0==8 bit, 1==16 bit, 3==32 bit alignment    */

/* Non-CG (external) memory management can be provided outside of the UFST*/
/* core and referenced via extmem.c by setting INT_MEM_MGT==0. C system   */
/* calls malloc & free can be the basis for external memory management.   */
#define INT_MEM_MGT     0  /* CG (Internal) memory management scheme      */
#define HUGE_PTR_SUPPORT 1 /* support > 64 KB memory blocks in DOS        */
#define DEFUND          0  /* requires INT_MEM_MGT==1                     */

#define MULTICALLER     0  /* pseudo multitasking support for MSWindows   */
                           /* MULTICALLER == 1 and INT_MEM_MGT == 1       */
                           /* requires DEFUND == 1                        */
#define SEM_ACCESS      0  /* Semaphore control for multitasking          */
                           /* requires MULTICALLER == 1                   */

/*  At least one of CACHE, CHAR_SIZE or CHAR_HANDLE must be set to 1      */
#define CACHE           1  /* CG caching of character bitmaps             */
#define CHAR_HANDLE     1  /* Non-caching character generation            */
#define CHAR_SIZE       1  /* char size info and bitmap generation        */


/*------------------------*/
/* Floating Point Options */
/*------------------------*/
/* Non-CG (external) floating point processing can be provided outside of */
/* the UFST core by setting INT_FP==0.  C system calls to floating point  */
/* functions can provide the same functionality.                          */
#define INT_FP          1   /* CG (internal) math package                 */


/*---------------------------------*/
/* Bitmap and Outline Output Modes */
/*---------------------------------*/
#define CGBITMAP        1  /* generate bitmaps                            */
#define LINEAR          0  /* Linear outlines                             */
#define QUADRA          0  /* Quadratic outlines                          */
#define CUBIC           1  /* Cubic outlines                              */

#define OLDATA          1  /* enable CG outline functions                 */
                           /* required if LINEAR, QUADRA or CUBIC == 1    */

#define TILE            0  /* generate characters in tiles                */


   /* Bitmap size limits */
/* Maximum bitmap size specified as power of 2 (e.g., 16 == 64K-1 bytes)  */
/* For MSDOS, 16 is the recommended limit for MAX_BM_BITS.                */
/* For UNIX,  22 is the limit due the use of this define with long ints.  */
#define MAX_BM_BITS     22


/*------------------*/
/*  Plugin Options  */
/*------------------*/
#define SLIM_FONTS      1  /* Use HQ4 plugins, support HQ4 (S) libraries  */
#define CGFIXED_PITCH   1  /* Include support for Fixed Pitch plugins     */

#define TT_PLUGINS      2  /* TrueType: 0 no plugins, 1  IF plugins, 
                            * 2 TT plugins (LaserJet 4) -- TT format
                            * 3 TT plugins (LaserJet 4) -- IF format
                            */
#define PS_PLUGINS      1  /* PostScript: 0 no plugins, 1  IF plugins     */


/*------------------*/
/* Data Input Types */
/*------------------*/
/* Disk input */           /*** If any _DISK is 1, all _ROM must be 0   ***/
#define IF_DISK         1  /* Intellifont disk input                      */
#define PST1_DISK       1  /* PostScript Type 1 disk input                */
#define TT_DISK         1  /* TrueType disk input                         */
#define FCO_DISK        0  /* FCO disk input */
#define T1MMASTER       0  /* type 1 multimaster */
#define T1REMASTER      0  /* type 1 multimaster remaster font */

/* PCLEO formatted input */
#define IF_PCLEOI       1  /* Intellifont PCLEXO input                    */
/*
NOTE:
   Only 1 form of type 1 downloaded soft font may be active at a time.
   PST1_PCLEOI is for the PSEO format while PST1_SFNTI is for the generic
   downloaded soft fonts.
*/
#define PST1_PCLEOI     0  /* PostScript Type 1 PCLEXO input              */
#define PST1_SFNTI      0  /* PostScript type 1 soft font input */
#define TT_PCLEOI       1  /* TrueType PCLEXO input                       */

/* ROM input */            /*** If any _ROM is 1, all _DISK must be 0   ***/
#define IF_ROM          0  /* IF ROM input (Plugins, core fonts in ROM)   */
#define PST1_ROM        0  /* PostScript Type 1 ROM input                 */
#define TT_ROM          0  /* TrueType ROM input                          */
#define FCO_ROM         0  /* FCO ROM input */

/*-------------------*/
/* Data Output Types */
/*-------------------*/
#define PCLEO           1  /* Pcleo generator                             */
#define PST1            0  /* PostScript Type 1 generator                 */
                             /* requires CUBIC==1 and OLDATA==1           */
#define FCO_TT          0  /* TrueType generator (from FCO)               */


/*-----------------------*/
/* Miscellaneous Options */
/*-----------------------*/
#define SCREEN_FONTS    0  /* substitute of fonts below font cut in limit */

#define SEGACCESS       1  /* allow independent access to IF segment data
                            * 0 no access
                            * 1 access via font id
                            * 2 access via pathname
                            */

#define FCOACCESS       0  /* allow independent access to FCO segment data
                            * 0 no access
                            * 1 access via pathname & fco_index
                            */

#define KERN            0  /* allow independent access to IF kerning data */
#define WIDTHS          1  /* allow independent access to width data   */
#define BOLD            0  /* allow pseudo emboldening                    */

#define DYNAMIC_FONTS   0  /* can use IF fonts, that are not in IF.FNT block */
#define NON_Z_WIND      1  /* specify non-zero winding transitions */
#define CONVERGENT_FONTS 0 /* font substitution, Alternate Width Tables */
                           /* 1 for AWT4 format; 3 for AWT3 format */
#define MULTIFORMAT     1  /* {IF|TT|PS}-compatible fonts in a different format. */


/*--------------------------------*/
/* Scaling Paramater Input Format */
/*--------------------------------*/
/* Set SCALE_MATRIX to 0 for FONTCONTEXT compatible with Version 1.4
 * and earlier. Set to sum of any of the following 4
 * defines for the FONTCONTEXT types you wish to support.
 * Do Not Change the MATRIX types, only change SCALE_MATRIX.
 */
#define TYPO_SCALE_MATRIX    0x0001   /*  typographer                     */
#define MAT0_SCALE_MATRIX    0x0002   /*  matrix from design to output    */
#define MAT1_SCALE_MATRIX    0x0004   /*  matrix world->out and em box    */
#define MAT2_SCALE_MATRIX    0x0008   /*  matrix world->out and pt/size   */

#define SCALE_MATRIX    0

/*---------------------------*/
/* Raster Line Organizations */
/*---------------------------*/
/*  Character bitmaps produced by UFST are structured as a sequence of
 *  horizontal raster lines from top to bottom of the bitmap. Each raster
 *  line is structured as a sequence of bytes. Applications would like to
 *  retrieve 8, 16, 32 or 64 bit or larger portions of a raster line and 
 *  would like the bit ordering of the bits within these larger (than byte)
 *  portions to be defined by the application. RASTER_ORG controls the
 *  size of the raster "chunk". LEFT_TO_RIGHT_BIT_ORDER contrls the
 *  bit ordering within the "chunk".
 *
 *  Set RASTER_ORG to any of the 4 defines for the "chunk" size you wish to
 *  support. Do Not Change the CHUNK types, only change RASTER_ORG.
 *
 *  Set LEFT_TO_RIGHT_BIT_ORDER to 1 for left-to-right bit ordering, 0
 *  for right-to-left bit ordering.
 */

#define EIGHT_BIT_CHUNK     0x0001   /* 8-bit chunk (default) */
#define SIXTEEN_BIT_CHUNK   0x0002   /* 16-bit chunk          */
#define THIRTYTWO_BIT_CHUNK 0x0004   /* 32-bit chunk          */
#define SIXTYFOUR_BIT_CHUNK 0x0008   /* 64-bit chunk          */

#define RASTER_ORG    THIRTYTWO_BIT_CHUNK
#define LEFT_TO_RIGHT_BIT_ORDER  0   /* 1 = left-to-right bit ordering  */
                                     /* within chunk, 0 = right-to-left */

/*--------------------------------------------*/
/* Scan Conversion and Output Coordinate size */
/*--------------------------------------------*/
/*  INTR_SIZE controls the precision at which Intelifont outlines are
 *  vectorized and scan converted.  It must be set to either 16 or 32.
 *  The operational limits are 999 point at 300dpi when set to 16 and
 *  999 point at 600dpi when set to 32.  If your processor's integer
 *  length is 32, then it is best for performance to set INTR_SIZE at
 *  32 regardless of your output size requirements.
 */

#define INTR_SIZE  32

/*------------------------*/
/* Font Metrics Precision */
/*------------------------*/
/*  If DU_ESCAPEMENT is set to 1, the escapement field of the character
 *  will be in the design units specified in "du_emx" and "du_emy" of the
 *  IFBITMAP/IFOUTLINE data structures. Thus, "escapement/du_emx" is the
 *  fraction of an em to escape. If DU_ESCAPEMENT is set to 0, then the
 *  escapement will be returned in 8782 units per em as is now.
 *
 */
#define DU_ESCAPEMENT   1  /* Escapement design units:                    */
                           /*  0 == use 8782/em, 1 == use native units    */

/*------------------------*/
/* Banding                */
/*------------------------*/
/*  This option will support caching of horizontal bands of character
 *  bitmaps. By a horizontal band, we mean a tile whose width is the
 *  entire width of the character bitmap.
 */
#define BANDING  0

/*------------------------*/
/* Font Bounding Box      */
/*------------------------*/
/*  If set to 1, this option supports the CGIFbound_box() function that
 *  returns an upper bound estimate of the font bounding box in output pixels.
 */
#define FONTBBOX    0

/*------------------------------*/
/* Application Generated Output */
/*------------------------------*/
/*  If set to 1, this option lets the app integrate its own character
 *  generation into UFST.
 */
#define ALIEN_BITS  0

/*-------------------------------------------------------------------------
USE_JUMP_TABLES was implemented for systems using overlay managers which
can not properly handle indirect calls through pointers. The default is
to use the jump tables by setting this value = 1. Setting the value = 0
will cause all calls to be made directly. The code size will be slightly
larger and the performance slightly faster.
---------------------------------------------------------------------------*/
#define USE_JUMP_TABLES 1

#define USE_UFST_MAPPING 2 /* 1-PCL sym sets, 0-encoding array, 2-both */

/*
The following group of constants are used for PostScript Type 0 and
TrueType Kanji font support.
*/
#define SJIS_ENCODING   0       /* enable Kanji Shift JIS mapping */
#define JIS_ENCODING    0       /* enable Kanji JIS mapping */
#define EUC_ENCODING    0       /* enable Kanji EUC mapping */
#define UNICODE_ENCODING 0      /* enable Kanji UNICODE mapping */
#define UNICODE_MAPPING  0      /* Bits indicating appropriate mappings
                                 * 0 - No mapping
                                 * 1 - JIS To Unicode mapping
                                 * 2 - Big5 To Unicode mapping
                                 * 4 - GB To Unicode mapping
                                 * 8 - KSC To Unicode mapping
                                 */


/*
Defines for Taiwanese, Chinese & Korean fonts.
*/
#define BIG5_ENCODING   0       /* enable BIG5 mapping */
#define TCA_ENCODING    0       /* enable TCA mapping */
#define GB_ENCODING     0       /* enable GB mapping */
#define K_ENCODING      0       /* enable K mapping */


/**************************************************************************/
/**--**--**              DO NOT CHANGE below this line.          **--**--**/

/*-----------------------------*/
/* Dependent and Fixed Defines */
/*-----------------------------*/

#define NO_SYMSET_MAPPING 0     /* 0 - use UFST symbol sets for mapping */

/* Max size of bitmap in bytes. Relies on previously defined MAX_BM_BITS */
#define MAX_BM          (UL32)((1L << (UL32)MAX_BM_BITS) - 1)
#define TT_ROM1         0

#define IF_RDR          (IF_DISK || IF_PCLEOI || IF_ROM)
#define PST1_RDR        (PST1_DISK || PST1_PCLEOI || PST1_SFNTI || PST1_ROM)
#define TT_RDR          (TT_DISK || TT_PCLEOI || TT_ROM || TT_ROM1)
#define FCO_RDR         (FCO_DISK || FCO_ROM)

#if (PST1_PCLEOI && PST1_SFNTI)
/*
#error Can not enable multiple forms of type 1 soft fonts
*/
#endif

#define DISK_FONTS      (IF_DISK || PST1_DISK || TT_DISK || FCO_DISK)
#define PCLEO_RDR       (IF_PCLEOI || PST1_PCLEOI || PST1_SFNTI || TT_PCLEOI)
#define NON_IF_FONT     (PST1_RDR || TT_RDR || FCO_RDR)
#define ROM             (IF_ROM || PST1_ROM || TT_ROM || TT_ROM1 || FCO_ROM)

#define PLUGINS         (IF_RDR || TT_PLUGINS || PS_PLUGINS || FCO_RDR)
#define TT_NOPLUG       (TT_PLUGINS == 0)
#define TT_IFPLUG       (TT_PLUGINS == 1)
#define TT_TTPLUG       (TT_PLUGINS == 2)
#define TT_TTPLUG_IF    (TT_PLUGINS == 3)
#define TT_TTPLUG_ANY   ((TT_PLUGINS == 2  ||  TT_PLUGINS == 3))
#define PS_NOPLUG       (PS_PLUGINS == 0)
#define PS_IFPLUG       (PS_PLUGINS == 1)

#define ELASTIC_X       (SCREEN_FONTS)
#define ELASTIC_Y       (SCREEN_FONTS)

/* Set OUTLINE if any of the outline options have been specified.         */
#define OUTLINE         (LINEAR || QUADRA || CUBIC)

#if BOLD
#undef  NON_Z_WIND
#define NON_Z_WIND  1
#endif

/*
The following define controls the method used to rasterize quadratic
bezier curves. Setting 'DRAS_QUAD' to 1 will enable direct rasterization of
quadratic bezier curves. Setting the value to 0 will utilize the original
method of subdividing the curves into line segments.
*/
#define DRAS_QUAD       0       /* recommend always setting to 0 */

#define ASIAN_ENCODING  \
   (SJIS_ENCODING || JIS_ENCODING || EUC_ENCODING \
    || UNICODE_ENCODING || BIG5_ENCODING || TCA_ENCODING || K_ENCODING)

#if !defined(ASIAN_ENCODING)
#define ASIAN_ENCODING 0
#endif

/*
 * Unicode mapping required whenever a variety of encodings
 * are specified
 */
#define UNICODE_IN      \
   ((SJIS_ENCODING || JIS_ENCODING || EUC_ENCODING || K_ENCODING) && UNICODE_ENCODING)

/*-------------------------------------------------------------------*/
/*               Test for invalid switch settings                    */
/*-------------------------------------------------------------------*/

#ifndef SUN        /* no #pragma on standard Sun C compiler   -ss 12/4/91 */

#if (MULTICALLER && INT_MEM_MGT && !DEFUND)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   DEFUND must be 1 if INT_MEM_MGT & MULTICALLER are 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: DEFUND must be 1 if INTMEM_MGT & MULTICALLER are 1!
*/
#endif

#if (DEFUND && !INT_MEM_MGT)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   INT_MEM_MGT must be 1 if DEFUND is 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: INT_MEM_MGT must be 1 if DEFUND is 1!
*/
#endif

#if (!CACHE && !CHAR_SIZE && !CHAR_HANDLE)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   At least one of CACHE, CHAR_SIZE or CHAR_HANDLE must be 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: At least one of CACHE, CHAR_SIZE or CHAR_HANDLE must be 1!
*/
#endif

#if (!CGBITMAP && !OUTLINE)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   At least one of CGBITMAP or OUTLINE must be 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: At least one of CGBITMAP or OUTLINE must be 1!
*/
#endif

#if (MEM_ALIGN != 0 && MEM_ALIGN != 1 && MEM_ALIGN != 3)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   MEM_ALIGN must be 0, 1 or 3!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: MEM_ALIGN must be 0, 1 or 3!
*/
#endif

#if (PST1 && (!CUBIC || !CHAR_HANDLE || !(SCALE_MATRIX & MAT1_SCALE_MATRIX)))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   CUBIC and CHAR_HANDLE must be 1 and SCALE_MATRIX must")
#pragma message("   include MAT1_SCALE_MATRIX if PST1 is 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: CUBIC & CHAR_HANDLE must be 1 & MAT1_SCALE_MATRIX if PST1!
*/
#endif

#if (defined(_WINDOWS) && (!INT_MEM_MGT || !CACHE))
/*
#error CGCONFIG: WINDOWS requires INT_MEM_MGT & CACHE!
*/
#endif

#if ((INTR_SIZE != 16) && (INTR_SIZE != 32))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   INTR_SIZE must be defined as 16 or 32")
#pragma message("   ****************************************************\n")
#endif

#if (BANDING && (!TILE || !CACHE))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   TILE and CACHE must be 1 if BANDING is 1!")
#pragma message("   ****************************************************\n")
/*
#error CGCONFIG: TILE must be 1 if BANDING!
*/
#endif

#if (CONVERGENT_FONTS  &&  (CONVERGENT_FONTS != 1 && CONVERGENT_FONTS != 3))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   CONVERGENT_FONTS MUST BE 1 or 3!")
#pragma message("   ****************************************************\n")
#endif          /* 2/28/94, mby */

#if (CONVERGENT_FONTS  &&  (SLIM_FONTS != 1))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   SLIM_FONTS must be 1 if CONVERGENT_FONTS is 1 or 3!")
#pragma message("   ****************************************************\n")
#endif          /* 4/22/94 jc */

#if ((TT_PLUGINS == 1 || TT_PLUGINS == 3) && MULTIFORMAT == 0)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   MULTIFORMAT must be 1!")
#pragma message("   ****************************************************\n")
#endif          /* 4/22/94 jc */

#if (PS_PLUGINS == 1 && MULTIFORMAT == 0)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   MULTIFORMAT must be 1!")
#pragma message("   ****************************************************\n")
#endif          /* 4/22/94 jc */

#endif  /* !SUN  */


