;  /* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/cgconfig.inc,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
;  /* $Log: cgconfig.inc,v $
;  /* Revision 1.2  2003/05/07 23:02:25  Lann
;  /* Revision V1_00_02
;  /*
;  /* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
;  /* First Release Version
;  /* 
   
      Rev 1.3   02 Dec 1994 13:24:32   JOE
   
   Added missing comment delimiters ";" at start of file.
;     
;        Rev 1.2   15 Jan 1993 09:32:36   LISA
;     Removed CtrlZ character from end of file
;     
;        Rev 1.1   14 Dec 1992 09:41:00   LISA
;     Made change to Log keyword
;     
;        Rev 1.0   10 Dec 1992 09:11:22   LISA
;     Initial revision.
;  */
;  /* $Date: 2003/05/07 23:02:25 $ */
;  COMMENT $
;  /* cgconfig.inc */
;  /*
;   *
;   * Copyright (C) 1990, 1991, 1992, all rights reserved, 
;   * by Miles Inc., Agfa Division, Wilmington, MA.
;   *
;   * This software is furnished under a license and may be used and
;   * copied only in accordance with the terms of such license and with
;   * the inclusion of the above copyright notice. This software or any
;   * other copies thereof may not be provided or otherwise made
;   * available to any other person except as allowed under license. No
;   * title to and ownership of the software is hereby transferred.
;   *
;   * This information in this software is subject to change without notice
;   * and should not be construed as a commitment by Miles Inc., Agfa
;   * Division.
;   *
;   */
;  
;  
;  
;  /*   26-Jun-90  bjg Added BITMAP, OUTLINE, LINEAR and QUADRA.              */
;  /*   21-Sep-90  jfd Changed BITMAP to CGBITMAP due to conflict in          */
;  /*                  "windows.h"                                            */
;  /*   22-Oct-90  jfd Disabled OUTLINE and QUADRA as default settings        */
;  /*   05-Dec-90  bg  Instead of #defining OUTLINE separately,               */
;  /*                  #define OUTLINE QUADRA                                 */
;  /*   03-Jan-91  jfd Added ROM and PCLEO_RDR options.                       */
;  /*   13-Jan-91  awr Added MEM_ALIGN                                        */
;  /*   23-Jan-91  awr Added MAX_BM from maker.c                              */
;  /*   29-Jan-91  jfd Added MAX_BM_BITS and using it to calculate MAX_BM     */
;  /*   15 May 91  ss  Added SLIM_FONTS                                       */
;  /*    5 Jun 91  ss  Added FIXED_PITCH                                      */
;  /*   10-Jun-91  jfd Added PST1 for PostScript Type 1 output                */
;  /*   19 Jun 91  ss  Deleted COMPRESS, no longer needed.                    */
;  /*    9 Jul 91  tbh Added ELASTIC_X and ELASTIC_Y.                         */
;  /*    1-Sep-91  awr Added LINEAR                                           */
;  /*   10-Sep-91  jfd Added OLDATA.                                          */
;  /*   20-Sep-91  jfd Added #pragma's to warn of invalid config settings.    */
;  /*   23-Sep-91  jfd Corrected misspelling (MEM_ALIGN not MERM_ALIGN)       */
;  /*                  Changed PostScript config test to include SCALE_MATRIX */
;  /*                  not set for MAT1_SCALE_MATRIX.                         */
;  /*   23-Sep-91  jfd Changed PostScript config test to include SCALE_MATRIX */
;  /*                  not set for MAT1_SCALE_MATRIX.                         */
;  /*   26-Feb-92  jfd Added switches IF_RDR, TT_RDR, PS_RDR due to changes   */
;  /*                  in CGCONFIG.H.                                         */
;  /*   06-Apr-92  rs  Change 'FIXED_PITCH' to 'CGFIXED_PITCH' (portability).*/
;  /*   09-Apr-92  jfd Added switches PST1_PCLEOI and TT_PCLEOI.             */
;  /*   27-Jul-92  jfd Re-arranged order of switches to more closely resemble*/
;  /*                  order in "cgconfig.h".                                */
;  /*              rs  Create new IF, PS & TT defines for disk, PCLEO & ROM  */
;  /*                  input.                                                */
;  /*              jfd Added switch INTR_SIZE.                               */
;
;  02-Dec-94  jfd  Added missing comment delimiters ";" at start of file.
;  
;  /*  These defines control whether various sections of code are compiled.   */
;  $
          ; Memory Management
          ;
MEM_ALIGN    EQU 3 ;  /*  0=8-bit, 1=16-bit, 3=32-bit  */
; /* Non-CG (external) memory management can be provided outside of the UFST*/
; /* core and referenced via extmem.c by setting INT_MEM_MGT==0. C system   */
; /* calls malloc & free can be the basis for external memory management.   */
INT_MEM_MGT  EQU 1 ; /* Internal memory management */
DEFUND       EQU 0 ; /* requires INT_MEM_MGT */
MULTICALLER  EQU 0 ; /* pseudo multitasking support for MSWindows   */
                   ; /* MULTICALLER == 1 and INT_MEM_MGT == 1       */
                   ; /* requires DEFUND == 1                        */
; /*  At least one of CACHE, CHAR_SIZE or CHAR_HANDLE must be set to 1      */
CACHE        EQU 0 ; /* CG caching of character bitmaps             */
CHAR_HANDLE  EQU 1 ; /* Non-caching character generation            */
CHAR_SIZE    EQU 0 ; /* char size info and bitmap generation        */
; /*------------------------*/
; /* Floating Point Options */
; /*------------------------*/
; /* Non-CG (external) floating point processing can be provided outside of */
; /* the UFST core by setting INT_FP==0.  C system calls to floating point  */
; /* functions can provide the same functionality.                          */
INT_FP       EQU 1 ;  /* internal math package */
; /*---------------------------------*/
; /* Bitmap and Outline Output Modes */
; /*---------------------------------*/
CGBITMAP     EQU 1 ; /* generate bitmaps                            */
LINEAR       EQU 1 ; /* Linear outlines                             */
QUADRA       EQU 1 ; /* Quadratic outlines                          */
CUBIC        EQU 1 ; /* Cubic outlines                              */
OLDATA       EQU 1 ; /* enable CG outline functions                 */
                   ; /* required if LINEAR, QUADRA or CUBIC == 1    */
TILE         EQU 1 ; /* generate characters in tiles                */
;   /* Bitmap size limits */
; /* Maximum bitmap size specified as power of 2 (e.g., 16 == 64K-1 bytes)  */
; /* For MSDOS, 16 is the recommended limit for MAX_BM_BITS.                */
; /* For UNIX,  32 is the limit due the use of this define with long ints.  */
MAX_BM_BITS  EQU 16 ;                      /* max bitmap size as power of
; /*------------------*/
; /*  Plugin Options  */
; /*------------------*/
SLIM_FONTS   EQU 1 ; /* Use HQ4 plugins, support HQ4 (S) libraries  */
CGFIXED_PITCH  EQU 1;/* Include support for Fixed Pitch plugins     */
; /*------------------*/
; /* Data Input Types */
; /*------------------*/
; /* Disk input */
IF_DISK      EQU 1 ;  /* Intellifont disk input, Currently reqd at all times*/
PST1_DISK    EQU 1 ;  /* PostScript Type 1 disk input                */
TT_DISK      EQU 1 ;  /* TrueType disk input                         */
; /* PCLEO formatted input */
IF_PCLEOI    EQU 1 ;  /* Intellifont PCLEXO input                    */
PST1_PCLEOI  EQU 1 ;  /* PostScript Type 1 PCLEXO input              */
TT_PCLEOI    EQU 1 ;  /* TrueType PCLEXO input                       */
; /* ROM input */
IF_ROM       EQU 0 ;  /* IF ROM input (Plugins, core fonts in ROM)   */
PST1_ROM     EQU 0 ;  /* PostScript Type 1 ROM input                 */
TT_ROM       EQU 0 ;  /* TrueType ROM input                          */
; /*-------------------*/
; /* Data Output Types */
; /*-------------------*/
PCLEO        EQU 0 ; /* Pcleo generator                             */
PST1         EQU 0 ; /* PostScript Type 1 generator                 */
                   ; /* requires CUBIC==1 and OLDATA==1           */
; /*-----------------------*/
; /* Miscellaneous Options */
; /*-----------------------*/
SCREEN_FONTS EQU 1 ; /* substitute of fonts below font cut in limit */
SEGACCESS    EQU 0 ; /* allow independent access to IF segment data */
KERN         EQU 1 ; /* allow independent access to IF kerning data */
WIDTHS       EQU 1 ; /* allow independent access to width data   */
BOLD         EQU 1 ; /* allow pseudo emboldening                    */


;                                              /* max bitmap size in bytes   */

COMMENT $
/* FONTCONTEXT types. Set SCALE_MATRIX to 0 for FONTCONTEXT compatible
 * with Version 1.4 and earlier. Set to sum of any of the following 4
 * defines for the FONTCONTEXT types you wish to support
 */ $

TYPO_SCALE_MATRIX    EQU 1 ;  /*  typographer                   */
MAT0_SCALE_MATRIX    EQU 2 ;  /*  matrix from design to output  */
MAT1_SCALE_MATRIX    EQU 4 ;  /*  matrix world->out and em box  */
MAT2_SCALE_MATRIX    EQU 8 ;  /*  matrix world->out and pt/size */

SCALE_MATRIX   EQU 0

INTR_SIZE      EQU 16

;/*-------------------------------------------------------------------*/
;/*  Flags defined from user specified flags above.                   */


MAX_BM       EQU ((1 SHL MAX_BM_BITS) - 1)
IF_RDR       EQU (IF_DISK OR IF_PCLEOI OR IF_ROM)
PST1_RDR     EQU (PST1_DISK OR PST1_PCLEOI OR PST1_ROM)
TT_RDR       EQU (TT_DISK OR TT_PCLEOI OR TT_ROM)
PCLEO_RDR    EQU (IF_PCLEOI OR PST1_PCLEOI OR TT_PCLEOI) 
NON_IF_FONT  EQU (PST1_RDR OR TT_RDR)
ROM          EQU (IF_ROM OR PST1_ROM OR TT_ROM) 
ELASTIC_X    EQU (SCREEN_FONTS)
ELASTIC_Y    EQU (SCREEN_FONTS)
OUTLINE      EQU (LINEAR OR QUADRA OR CUBIC)
USE_UFST_MAPPING EQU 1 ; /* required for regular UFST PS implementation */

COMMENT $
/*-------------------------------------------------------------------*/
/*  Test for invalid switch settings                                 */

#if (MULTICALLER && !DEFUND)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   DEFUND must be 1 if MULTICALLER is 1!")
#pragma message("   ****************************************************\n")
#endif

#if (DEFUND && !INT_MEM_MGT)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   INT_MEM_MGT must be 1 if DEFUND is 1!")
#pragma message("   ****************************************************\n")
#endif

#if (!CACHE && !CHAR_SIZE && !CHAR_HANDLE)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   At least one of CACHE, CHAR_SIZE or CHAR_HANDLE must be 1!")
#pragma message("   ****************************************************\n")
#endif

#if (!CGBITMAP && !OUTLINE)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   At least one of CGBITMAP or OUTLINE must be 1!")
#pragma message("   ****************************************************\n")
#endif

#if (MEM_ALIGN != 0 && MEM_ALIGN != 1 && MEM_ALIGN != 3)
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   MEM_ALIGN must be 0, 1 or 3!")
#pragma message("   ****************************************************\n")
#endif

#if (PST1 && (!CUBIC || !CHAR_HANDLE || !(SCALE_MATRIX & MAT1_SCALE_MATRIX)))
#pragma message("\n   ****************************************************")
#pragma message("   Configuration error in CGCONFIG.H :")
#pragma message("   CUBIC and CHAR_HANDLE must be 1 and SCALE_MATRIX must")
#pragma message("   include MAT1_SCALE_MATRIX if PST1 is 1!")
#pragma message("   ****************************************************\n")
#endif
$

