/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/cgif.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cgif.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.57   01 Sep 1995 09:45:00   MERRILL
 * No change.
 * 
 *    Rev 1.56   24 May 1995 19:01:06   MIKE
 * 
 * Added new error code 'ERR_char_unavailable'
 * 
 *    Rev 1.55   01 May 1995 11:12:58   MIKE
 * Added new error code 513
 * 
 *    Rev 1.54   18 Apr 1995 16:55:22   JOE
 * 
 * Added "dl_ssnum" field to FONTCONTEXT.
 * Added function prototype for CGIFchIdptr().
 * 
 *    Rev 1.53   07 Apr 1995 08:44:50   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.52   31 Mar 1995 11:14:26   JOE
 * 
 * Added prototype for CGIFfco_access().
 * Added FCO segment keys for use in CGIFfco_Access() (by jwd).
 * 
 *    Rev 1.51   27 Mar 1995 10:41:38   MARTIN
 * 
 * Modified argument to CGIFtt_Free.
 * 
 *    Rev 1.50   27 Jan 1995 11:32:56   MIKE
 * Added new error code 512, 'ERR_fco_nzwCode'
 * 
 *    Rev 1.49   13 Jan 1995 18:06:00   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.48   09 Jan 1995 10:33:48   MARTIN
 * 
 * Added new arg to CGIFtt_Generate.
 * 
 *    Rev 1.47   14 Dec 1994 08:16:58   JOE
 * Changed arg 2 of CGIFtt_Generate() from LPLPUB8 to LPHPUB8 (by rs).
 * 
 *    Rev 1.46   20 Oct 1994 14:08:38   MIKE
 * 
 * Changed prototypes of CGIFfco_Close(), CGIFfco_Plugin(), CGIFtt_Free().
 * 
 *    Rev 1.45   30 Sep 1994 15:59:34   MIKE
 * Added new error code ERR_fco_Init
 * 
 *    Rev 1.44   20 Sep 1994 11:41:16   JOE
 * Added new error code ERRhdr_font_purge.
 * 
 *    Rev 1.43   16 Sep 1994 16:22:14   MIKE
 * Added prototypes for CGIFfco_Plugin().
 * 
 *    Rev 1.42   13 Sep 1994 19:15:50   MIKE
 * 
 * Added new error 'ERR_fco_SegmentSharing'
 * 
 *    Rev 1.41   11 Sep 1994 09:19:16   JOE
 * 
 * Added prototype for CGIFhdr_font_purge().
 * 
 *    Rev 1.40   09 Sep 1994 14:19:44   MIKE
 * 
 * Added new error 'ERR_fco_versionError'
 * 
 *    Rev 1.39   26 Aug 1994 08:49:26   JOE
 * 
 * Changed arg 2 of CGIFfco_Open() from 'int *' to 'LPSW16' for WINDOWS.
 * Changed args 1 and 2 of CGIFtt_Generate() ('int *' to 'LPSW16', 'LPUB8 *'
 * to 'LPLPUB8') for WINDOWS.
 * 
 *    Rev 1.38   03 Aug 1994 10:14:08   MIKE
 * Added FCO changes from 1.33.1.3
 * 
 *    Rev 1.37   03 Jun 1994 10:08:50   JOE
 * 
 * Changed all occurrences of ENTRY to CGENTRY to resolve conflict on
 * some compilers.
 * 
 *    Rev 1.36   21 Apr 1994 15:48:46   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.35   14 Apr 1994 14:17:50   JOE
 * 
 * Added error code ERR_psi_scan_Fulnam.
 * 
 *    Rev 1.34   02 Feb 1994 09:19:24   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.33   05 Jan 1994 09:39:22   JOE
 * 
 * Added error code "ERR_incomp_bitmap_width".
 * 
 *    Rev 1.32   21 Nov 1993 07:57:50   MAIB
 * 
 * Moved define statements outside of prototype declarations
 * 
 *    Rev 1.31   13 Oct 1993 08:16:50   JOE
 * Added error code "ERR_psi_scan_ps_font_box".
 * 
 *    Rev 1.30   23 Sep 1993 13:19:34   MIKE
 * Added ERR_TT_ENTITY1.
 * 
 *    Rev 1.29   03 Sep 1993 14:24:36   JOE
 * 
 * Added missing function prototype for CGIFbmheader() if !LINT_ARGS.
 * 
 *    Rev 1.28   02 Sep 1993 13:37:52   JOE
 * 
 * Added typedef for PPIFOUTLINE.
 * 
 *    Rev 1.27   31 Aug 1993 12:31:48   AL
 * Added CGIFtile_nzw_buf() declarations.
 * 
 *    Rev 1.26   02 Aug 1993 14:27:12   MAIB
 * Changed prototypes for multi-tasking and multicaller
 * 
 *    Rev 1.25   27 Jul 1993 13:21:46   AL
 * Improved NZW comment
 * 
 *    Rev 1.24   27 Jul 1993 12:47:16   AL
 * Non-zero winding changes
 * 
 *    Rev 1.23   26 Jul 1993 11:37:42   ROB
 * Add error code for type 1 multimaster.
 * 
 *    Rev 1.22   16 Jul 1993 14:55:30   MAIB
 * added error code ERR_TT_FSCHARBEARINGS
 * 
 *    Rev 1.21   15 Jul 1993 12:23:36   MIKE
 * New error codes for unsupported functions.
 * 
 *    Rev 1.20   13 Jul 1993 19:56:54   MIKE
 * Added p_AltWidTab to FONTCONTEXT. Changed prototype of CGIFbbox_IFPCLEOchar()
 * 
 *    Rev 1.19   01 Jul 1993 14:24:38   MAIB
 * used a bit in the fontcontext format field for specifying non-zero winding
 * 
 *    Rev 1.18   15 Jun 1993 17:53:04   MIKE
 * Added prototype for CGIFbbox_IPFCLEOchar() & #define CGIFP_IF_SCALABLE.
 * 
 *    Rev 1.17   08 Jun 1993 15:47:30   ROB
 * Add error codes for type 1 multimaster.
 * 
 *    Rev 1.16   21 May 1993 08:30:26   JOE
 * Reversed comments for band_top and band_bot in FONTCONTEXT structure.
 * 
 *    Rev 1.15   14 May 1993 15:54:44   JOE
 * In IFBITMAP structure, changed type of "bm" field from "UB8 bm[4]" to
 * "UL32 bm[1]" so that it will be long-aligned for 32-bit RASTER_ORG
 * value on SPARC.
 * 
 *    Rev 1.14   06 May 1993 16:45:00   JOE
 * In FONTCONTEXT structure, re-conditionally compiled field "font_hdr" based
 * on (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS).
 * 
 *    Rev 1.13   06 May 1993 16:05:02   MIKE
 * Add declarations for CGIFfont_purge(); replace CGIFcache_purge with a macro.
 * Remove conditional code around FONTCONTEXT.font_hdr.
 * 
 *    Rev 1.12   22 Apr 1993 10:57:26   MIKE
 * New error codes 150-151 for dynamic fonts.
 * 
 *    Rev 1.11   29 Mar 1993 10:45:26   ROB
 * Error codes for Kanji PostScript.
 * 
 *    Rev 1.10   19 Mar 1993 18:48:56   ROB
 * Modifications for support of Kanji PostScript.
 * 
 *    Rev 1.9   08 Mar 1993 10:16:30   JOE
 * Deleted #define statement for "not_init" because it is never utilized.
 * 
 *    Rev 1.8   03 Mar 1993 19:44:44   MIKE
 * Remove PFONTCONTEXT argument from CGIFbound_box() prototype.
 * 
 *    Rev 1.7   03 Mar 1993 19:35:28   ROB
 * Add error codes for PSI scanning StemSnapH & StemSnapV.
 * 
 *    Rev 1.6   08 Feb 1993 16:42:48   MIKE
 * Added CGIFbound_box() prototype. Not implemented yet for MULTICALLER.
 * 
 *    Rev 1.5   05 Feb 1993 13:40:38   MIKE
 * Added ERRfont_bbox
 * Added FC_APPGEN_TYPE and FC_ISAPPGEN() macro.
 * 
 *    Rev 1.4   02 Feb 1993 17:04:56   JOE
 * Added fields "band_top" and "band_bot" to FONTCONTEXT structure. Added
 * error code "ERR_invalid_band".
 * 
 *    Rev 1.3   29 Jan 1993 08:55:40   JOE
 * Added em box size fields to IFBITMAP and IFOUTLINE structures.
 * 
 *    Rev 1.2   15 Jan 1993 09:34:32   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:41:24   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:06   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* cgif.h */


/*
 *     21-Jul-90   awr   moved segment definitions for CGIFsegments()
 *                       from segments.h to cgif.h
 *     23-Jul-90   awr   added Blake's typePath to IF_CONFIG
 *     26-Jun-90   bjg   Added IFOUTLINE OUTLINE_LOOP and OUTLINE_CHAR.  Also
 *                       added error flags for outline or bitmap not installed.
 *     17-Aug-90   awr   corrected byte count comment for FONTCONTEXT
 *      7 Jan 91   jd,ss Added FONTCONTEXT.font_hdr field for PCLEO support
 *                       Added MASK defines and macros for FONTCONTEXT.format
 *                        bit usage
 *     13-Jan-91   awr   Added ERRhix_extra error code.
 *     17-Jan-91   awr   Added ERRinvalid_seg_key
 *     23-Jan-91   awr   Compiling Font Context masks and macros unconditionally.
 *     28-Jan-91   jfd   Declared "...cc_buf_size" conditionally based
 *                       on (MAX_BM_BITS > 16)
 *                       Declared xorigin and yorigin from structure IFBITMAP
 *                       conditionally based oon (MAX_BM_BITS > 16).
 *                       ADDed MASK defines for FONTCONTEXT.format bit usage
 *                       for point size units designation.
 *     29-Jan-91   jfd   Added description for bits 8-9 of format field.
 *     20-Dec-90   dET   Add support for multi-model MSC compilation.
 *      3-Feb-90   awr   added typedefs for HIFOUTLINE & PMEM_HANDLE.
 *      8-Feb-91   awr   added typedef for PHIFOUTLINE.
 *     17-Feb-91   awr   moved MEM_HANDLE typedefs to ifmem.h
 *     06-Mar-91   jfd   Conditionally compiling fields xscale and yscale
 *                       in structure IFOUTLINE so that IFOUTLINE remains
 *                       aligned with IFBITMAP.
 *                       Changed value of HEADERSIZE from "34" to
 *                       "sizeof(IFBITMAP)-4".
 *      28-Apr-91  awr   Matrix varients of FONTCONTEXT. Output resolution
 *                       option pixels/inch
 *     05-Jun-91   jfd   Added function declaration for CGIFcache_purge().
 *                       (FIX FROM EARLIER VERSION)
 *                       Macro FC_ROM_TYPE was missing.
 *     10-Jun-91  jfd   Added declaration for module CGIFps().
 *     19-Jun-91  jfd   Changed arguments for CGIFps() calling sequence.
 *     30-Jun-91  awr   Corrected #define FC_INCHES_TYPE
 *     02-Jul-91  jfd   Changed arguments for CGIFps() calling sequence.
 *      4-Jul-91  awr   Chg'd IFBITMAP and IFOUTLINE arrays from 4 to 1 byte
 *     05-Jul-91  rs    Add prototype for CGIFps() - LINT_ARGS && !MULTICALLER
 *                      Moved ERRdu_pix_range from comp_pix.c
 *     07-Aug-91  jfd   Added argument PPSPARAMSTR to CGIFps() function
 *                      prototype.
 *                      Added typedef for PPSPARAMSTR.
 *                      Added typedef for PSPARAMSTR (from ps_type1.h)
 *                      Added #define for MAXPATHLEN (from ps_type1.h)
 *                      Chg'd size of IFBITMAP and IFOUTLINE "bm" arrays from
 *                      1 to 4 bytes (Was affecting computation of HEADERSIZE)
 *                      Added function prototype for CGIFcache_purge() if
 *                      LINT_ARGS & (! MULTICALLER).
 *     09-Sep-91  awr   Replaced "#define HEADERSIZE..." with "define
 *                      BMHEADERSIZE..." and #define OLHEADERSIZE...".
 *                      In structure IFOUTLINE, no longer conditionally
 *                      compiling xscale and yscale based on MAX_BM_BITS.
 *     13-Sep-91  jfd   Changed CGIFbitMap() to CGIFmakechar().
 *     16-Sep-91  jfd   Added error codes ERR_ps_toomanystems and
 *                      ERR_ps_toomanystdwid.
 *     17-Sep-91  jfd   In structure IFBITMAP, changed xorigin and yorigin
 *                      to LONG instead of either LONG or WORD.
 *     30-Sep-91  awr   Added CGIFinitstate bits.
 *                det   In structure IFOUTLINE, changed size from WORD
 *                      to UWORD so as to be able to handle sizes 
 *                      greater than 32K.
 *     30-Sep-91  rs    Add 'FC_PST1_TYPE' to FONTCONTEXT 'format' field for
 *                      PostScript Type 1.
 *     02-Oct-91  rs    Added declaration for module CGIFpsi().
 *     07-Nov-91  jfd   In structure IFOUTLINE, changed size from UWORD to
 *                      LONG so as to be able to handle sizes greater than
 *                      64K.
 *                      In structure OUTLINE_CHAR, changed size from UWORD
 *                      to LONG for same reason. Added WORD field "pad" so
 *                      as to maintain long alignment.
 *     21-Nov-91  jfd   Added error code "ERR_ps_char_not_in_list".
 *     27-Nov-91  rs    Add PostScript Type 1 Input error codes
 *      1-Jan-91  awr   Added tt bit to FONTCONTEXT format field.
 *                      Conditionally compiled font_hdr field in FONTCONTEXT
 *                      if(PCLEO_RDR || PST1I || TT_RDR)
 *      7-Mar-92  awr   Removed FC_DISK_TYPE
 *     13-Mar-92  jfd   Added #define ERR_incompatable_plugin 8 macro
 *     03-Apr-92  rs    Portability cleanup (see port.h).
 *     21-Apr-92  rs    Conditionalize 'MAXPATHLEN' on _WINDOWS.
 *     20-Jun-92  awr   Changed IFOUTLINE bounds to INTRs
 *                      Modified FC_IS_OUTLINE()
 *     22-Jun-92  jfd   Added "#define ERR_ov_16_bit_value 95".
 *      4-Jul-92  awr   Conditionally compiled in IFCONFIG structure elements
 *                      only needed for CHAR_SIZE or CACHE.
 *      6-Jul-92  mby   Added TrueType error codes -- 0x7000 range.
 *     08-Jul-92  rs    Code cleanup.
 *     10-Jul-92  jfd   Added #define  ERR_cubic_not_installed.
 *     10 Jul 92  ss    Changed OUTLINE_CHAR.bm to ol.
 *                      Changed OUTLINE_CHAR.loop[4] to [1] and adjusted
 *                      OLHEADERSIZE accordingly.
 *     21-Jul-92  awr   Changed conditional compiles.
 *     07-Aug-92  rs    Compatibility w/Windows 3.1 (FIXED, POINTFX).
 *      7 Aug 92  ss    Added ERRcompact_pcleo.
 *     12-Aug-92  jfd   Added macro MDES2BM for speed.
 *     14-Aug-92  jfd   Added error code ERR_bold_not_enabled.
 *     16-Aug-92  rs    Make declaration of 'PSPARAMSTR' dependent upon
 *                      'PST1' defined as non-zero (PostScript output).
 *                      Declaration of 'CGIFps()' dependent upon 'PST1'.
 *                      Remove declaration of 'CGIFpsi()'.
 *     04-Sep-92  jfd   Added error code ERR_kern_unsupported (for PS or TT).
 *     08-Sep-92  jfd   Changed TT error codes from hex values (0x7000-0x7012)
 *                      to decimal (400-412) so that they fall within the
 *                      range of other UFST error codes.
 *     03-Sep-92  awr   Added CGIFtt_universal()
 *     12-Oct-92  awr   Added not_intellifont bit to CGIFinitstate
 *     22-Jan-93  jfd   Added fields "du_emx" and "du_emy" to IFBITMAP.
 *                      Added fields "du_emx" and "du_emy" to IFOUTLINE.
 *     28-Jan-93  mby   Added ERRfont_bbox.
 *     01-Feb-93  jfd   Added fields "band_top" and "band_bot" to
 *                      FONTCONTEXT structure.
 *                      Added error code "ERR_invalid_band".
 *     03-Feb-93  mby   Added FC_APPGEN_TYPE and FC_ISAPPGEN() macro.
 *     08-Feb-93  mby   Added CGIFbound_box() prototype [!MULTICALLER].
 *     02-Mar-93  rs    Add error codes ERR_psi_scan_StemSnapH &
 *                      ERR_psi_scan_StemSnapV.
 *     03-Mar-93  mby   Remove PFONTCONTEXT argument from CGIFbound_box() proto.
 *     08-Mar-93  jfd   Removed define for CGIFinitstate bit "not_init" 
 *                      because it is not utilized.
 *     15-Mar-93  rs    Add error codes for PostScript Type 0 input (Asian).
 *     27-Mar-93  rs    More error codes for Asian (Kanji).
 *     21-Apr-93  mby   Error codes (150-51) for dynamic fonts.
 *     05-May-93  mby   Add declarations for CGIFfont_purge();
 *                      make CGIFcache_purge() a macro.
 *                      Remove cond. code around FONTCONTEXT.font_hdr
 *     06-May-93  jfd/mby
 *                      In FONTCONTEXT structure, conditionally compiled
 *                      field "font_hdr" based on (PCLEO_RDR || NON_IF_FONT
 *                      || DYNAMIC_FONTS)
 *     14-May-93  jfd   In IFBITMAP structure, changed "bm" field from
 *                      "UB8 bm[4]" to "UL32 bm[1]" so that it will be
 *                      properlly aligned for 32-bit RASTER_ORG value.
 *     21-May-93  jfd   Reversed comments for band_top and band_bot in
 *                      FONTCONTEXT structure.
 *     06-Jun-93  rs    Add error codes for type 1 multi master.
 *     08-Jun-93  mby   Added prototype for CGIFbbox_IFPCLEOchar() &
 *                      #define CGIFP_IF_SCALABLE
 *     01-Jul-93 maib   Added FC_NON_Z_WIND bit to the fontcontext format
 *                      field, and macro FC_ISNONZWIND to determine if this
 *                      bit is set
 *     05-Jul-93  awr   Added ERRnzw_mem_overflow
 *                      Changed calls for CGIFmakechar() and CGIFtilebitMap()
 *     06-Jul-93  mby   Added p_AltWidTab to FONTCONTEXT.
 *                      #defined FC_ILLEGAL_TYPE
 *     13-Jul-93  mby   Changed function proto for CGIFbbox_IFPCLEOchar() --
 *                      added bad char list. #defined CGIFP_MAX_BADCHARS. 
 *     15-Jul-93  mby   New error codes for disabled CGIF functions.
 *     16-Jul-93  maib  Added ERR_TT_FSCHARBEARINGS error code
 *     23-Jul-93  rs    Add 'ERR_psi_badMMblendmap' error code.
 *     02-Aug-93  maib  Changed prototypes, for MULTICALLER and multi-tasking
 *     30-Aug-93  awr   Added CGIFtile_nzw_buf()
 *     02-Sep-93  jfd   Added typedef for PPIFOUTLINE.
 *     03-Sep-93  jfd   Added missing function prototype for CGIFbmheader()
 *                      if !LINT_ARGS.
 *     13-Sep-93  mby   Added ERR_TT_ENTITY1.
 *     27-Sep-93  jfd   Added error code "ERR_psi_scan_ps_font_bbox".
 *     23-Nov-93  maib  Moved defines CGIFP_IF_SCALABLE and CGIF_MAX_BADCHARS
 *                      outside of prototype declarations
 *     05-Jan-94 jfd    Added error code "ERR_incomp_bitmap_width".
 *     27-Jan-94 jfd    Conditionally compiled out MDES2BM macro based on
 *                      !defined(_AM29K).
 *     12-Apr-94 jfd    Added error code ERR_psi_scan_Fulnam.
 *     03-Jun-94 jfd    Changed all occurrences of ENTRY to CGENTRY to resolve
 *                      conflict on some compilers.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.33.1.3:
 *     11-Mar-94 mby    Changed FONTCONTEXT.format to add FCO font type.
 *                      Use bit 5 for future expansion. Added FCO errors.
 *     26-May-94 mby    Declarations for CGIFfco_Open(), CGIFfco_Close(),
 *                      CGIFtt_Generate(), CGIFtt_Free().
 *                      Added new FCO error codes.
 *     29-Jul-94 mby    Added new error 'ERR_fco_FCcompCharPiece'.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     18-Aug-94 jfd    Changed arg 2 of CGIFfco_Open() from 'int *' to
 *                      'LPSW16' for WINDOWS.
 *     22-Aug-94 jfd    Changed args 1 and 2 of CGIFtt_Generate() ('int *'
 *                      --> 'LPSW16', 'LPUB8 *' --> 'LPLPUB8' for WINDOWS.
 *     09-Sep-94 mby    Added new error 'ERR_fco_versionError'.
 *     11-Sep-94 jfd    Added prototype for CGIFhdr_font_purge().
 *     13-Sep-94 mby    Added new error 'ERR_fco_SegmentSharing'
 *     16-Sep-94 mby    Added prototypes for CGIFfco_Plugin().
 *     20-Sep-94 jfd    Added new error code ERRhdr_font_purge.
 *     30-Sep-94 mby    Added new error 'ERR_fco_Init'
 *     20-Oct-94 mby    In prototypes of CGIFfco_Close(), CGIFfco_Plugin(),
 *                      CGIFtt_Free() changed argument from "int" to "SW16"
 *                      for consistency with CGIFfco_Open().
 *     14-Dec-94 rs     Changed arg 2 of CGIFtt_Generate() from LPLPUB8
 *                      to LPHPUB8.
 *     06-Jan-95 SBM    Added new arg to CGIFtt_Generate().
 *     09-Jan-95 rob    Implement support for > 64KB memory for int mem mgr.
 *     27-Jan-95 mby    Added new error code 'ERR_fco_nzwCode'.
 *     24-Mar-95 SBM    Modified CGIFtt_Free to use a Ptr instead of a MEM_HANDLE.
 *     31-Mar-95 jwd    Added prototype for new interface function, CGIFfco_access();
 *                      Added FCO segment keys for use in CGIFfco_Access function.
 *     18-Apr-95 jfd    Added "dl_ssnum" field to FONTCONTEXT.
 *                      Added function prototype for CGIFchIdptr().
 *     01-May-95 mby    Added new error code 'ERR_fco_OutlCode', 513.
 *     23-May-95 mby    Added new error code 'ERR_char_unavailable'
 */
typedef MEM_HANDLE   HIFFONT;
typedef MEM_HANDLE   HIFBITMAP;
typedef MEM_HANDLE   HIFOUTLINE;
typedef HIFBITMAP  FARPTR * PHIFBITMAP;
typedef HIFOUTLINE FARPTR * PHIFOUTLINE;

/* Bits in CGIFinitstate indicating components not initialized */

#define not_buf   0x0002
#define not_cac   0x0004
#define not_enter 0x0008
#define not_intellifont 0x0010

/*----------------------------------*/
/*         Memory Pools             */
/*----------------------------------*/
#define CACHE_POOL   0
#define BUFFER_POOL  1

/*----------------------------------*/
/*     CGIFkern() query codes       */
/*----------------------------------*/
#define  TEXT_KERN    0
#define  DESIGN_KERN  1

/*-----------------------------------*/
/* CGIFsegments() data segment codes */
/*-----------------------------------*/
#define FACE_GLOBAL_KEY   0    /* Entire face global segment */
#define GIF_KEY         100    /* Global Intellifont segment */
#define TRACK_KERN_KEY  101    /* track kerning              */
#define TEXT_KERN_KEY   102    /* text kerning               */
#define DESIGN_KERN_KEY 103    /* designer kerning           */
#define WIDTH_KEY       104    /* character width segment    */
#define ATTRIBUTE_KEY   105    /* Attribute header           */
#define RASTER_KEY      106    /* Raster parameter           */
#define TF_HEADER_KEY   107    /* Typeface Header segment    */
#define COMPOUND_KEY    108    /* Compound character         */
#define DISPLAY_KEY     109    /* Display header             */
#define FONT_ALIAS_KEY  110    /* Font Alias segment         */
#define COPYRIGHT_KEY   111    /* Copyright notice           */

/*-------------------------------------*/
/* CGIFfco_Access() data segment codes */
/*-------------------------------------*/

#define TFATRIB_KEY     401    /* Typeface Attribute data    */

/*----------------------------------*/
/*        Error Return Codes        */
/*----------------------------------*/
#define ERR_bad_bitmap_width   1
#define ERR_no_font_index      3   /* can't open font index file */
#define ERR_rd_font_index      4   /* can't allocate or read font index */
#define ERR_missing_plugin     5   /* missing one or more plugin lib    */
#define ERR_no_symbol_set      6   /* can't open symbol set file        */
#define ERR_rd_symbol_set      7   /* can't allocate or read symbol set */
#define ERR_incompatable_plugin 8  /* plugin libs incompatable with fonts*/
#define ERR_incomp_bitmap_width 9  /* bitmap width conflict with RASTER_ORG*/

#define  ERR_bad_pool          21
#define  ERR_CACinit           32
#define  ERR_IXinit            33
#define  ERRlong_font_name     51
#define  ERR_fst_type          52  /* invalide fst type in fc->format */
#define  ERR_no_font           53
#define  ERR_IXnew_ss          54
#define  ERR_bad_chID          61
#define  ERR_bm_buff           63
#define  ERR_no_cgnum          64  /* ss id does not map to a cgnum */
#define  ERR_no_fi_entry       65  /* no font index */
#define  ERR_open_lib          66  /* Error opening library file */
#define  ERR_mem_face_hdr      67  /* Mallac failed for face header */
#define  ERR_face_abort        68
#define  ERR_find_cgnum        69  /* Can't find cgnum in char. index */
#define  ERR_rd_char_data      70  /* Can't read character data       */
#define  ERR_buffer_too_small  71
#define  ERR_invalid_tile      72  /* App spec'd inside out tile  */
#define  ERR_invalid_band      73  /* App spec'd band with invalid rotation */
#define  ERRnzw_mem_overflow   74  /* nzw buffer was too small */
#define  ERR_bad_kern_code     81
#define  ERR_segts_unsupported 90  /* CGIFsegments not supported.      */
#define  ERRinvalid_seg_key    91  /* bad key param in CGIFsegments()  */
#define  ERRmem                92  /* general memory allocation error  */
#define  ERRoutline_mem        93
#define  ERRcc_outline_mem     94
#define  ERR_ov_16_bit_value   95  /* 16-bit overflow in MAKifbmheader() */
#define  ERR_bold_not_enabled  96  /* cannot embolden with BOLD disabled */
#define  ERR_kern_unsupported  97  /* kern is not supported for PS or TT */
#define  ERR_width_unsupported 98  /* CGIFwidth not supported          */
#define  ERR_char_unavailable  0x7FFF  /* returned by CGIFwidth()      */

/* pcleo.c */
#define ERRnot_ready_lpt      100  /* printer not ready during write   */
#define ERRwrite              101  /* fwrite() error                   */
#define ERRopen_printer       102  /* LPT not ready during open_file() */
#define ERRopen_file          103  /* fopen() error   "      "    "    */
#define ERRfstat              104  /* fstat() error   "      "    "    */
#define ERRrastparam_missing  105  /* missing raster parameter segment */
#define ERRattribseg_missing  106  /*    "    font attribute      "    */
#define ERRdispheader_missing 107  /*    "    display header      "    */
#define ERRfat_missing        108  /*    "    font alias table         */
#define ERRbadchar            109  /* Inconsistent skeletal char data  */
#define ERRvertesc            110  /* Non-zero vertical escapement     */
#define ERRcompact_pcleo      111  /* No slim pcleo's                  */
#define ERR_pcleo_unsupported 112  /* CGIFpcleo not supported.         */

/* CGIFbound_box */
#define ERRfont_bbox          120  /* Error reading font bounding box  */

/* Convergent Fonts */
#define ERR_bad_awt           130  /* Bad Alternate Width Table */

/* CGIFhdr_font_purge */
#define ERRhdr_font_purge     140  /* CGIFhdr_font_purge not supported */

#if PST1
/*
PostScript Output error messages
*/
#define ERRtfheader_missing   200	/* typeface header not in library */
#define ERR_ps_pfb_open       201	/* error opening pfb file */
#define ERR_ps_afm_open       202	/* error opening afm file */
#define ERR_ps_pfm_open       203	/* error opening pfm file */
#define ERR_ps_vfm_open       204	/* error opening vfm file */
#define ERR_no_vfm_font_id    205
#define ERR_ps_toomanysegs    206   /* too many segments in type 1 outline */
#define ERR_ps_unk_seg        207   /* unknown segment outline */
#define ERR_ps_toomanystems   208   /* no room to add stem to stem str */
#define ERR_ps_toomanystdwid  209   /* no room to add std dim to array */
#define ERR_ps_char_not_in_list 210 /* char missing from master list */
#define ERR_ps_unsupported    211   /* CGIFps not supported. */
#endif /* PST1 */

#if IF_RDR
/* fm.c */
#define  ERR_if_read_libfile 150    /* dynamic fonts, read error */
#define  ERR_if_process_face 151    /* dynamic fonts, invalid libr format */
#endif  /* IF_RDR */

#if PST1_RDR
/*
PostScript Input error messages
*/
/*---------*/
#define ERR_psi_scan_file    300	/* error scanning type 1 file */
#define ERR_psi_scan_matrix  301	/* error scanning for type 1 matrix */
#define ERR_psi_rd_bhdr      302	/* error reading type 1 binary header */
#define ERR_psi_scan_private 303	/* error scanning for type 1 private */
#define ERR_psi_scan_LenIV   304	/* error scanning for type 1 LenIV */
#define ERR_psi_scan_StdVW   305	/* error scanning for type 1 StdVW */
#define ERR_psi_scan_StdHW   306	/* error scanning for type 1 StdHW */
#define ERR_psi_scan_Blues   307	/* error scanning for type 1 Blues */
#define ERR_psi_scan_OBlues  308	/* error scanning for type 1 Other Blues */
#define ERR_psi_scan_BScale  309	/* error scanning for type 1 BlueScale */
#define ERR_psi_scan_BShift  310	/* error scanning for type 1 BlueShift */
#define ERR_psi_scan_Encode  311	/* error scanning for type 1 Encoding */
#define ERR_psi_scan_Subrs   312	/* error scanning for type 1 Subrs */
#define ERR_psi_Subr_too_hi  313	/* Type 1 Subr # too high */
#define ERR_psi_scan_Charstr 314	/* error scanning for type 1 Charstrings */
#define ERR_psi_Char_too_hi  315	/* Type 1 Charstring # too high */
#define ERR_psi_SubrStr_mem  316	/* error alloc'g type 1 Subr array */
#define ERR_psi_Subrdat_mem  317	/* error alloc'g type 1 Subr data mem */
#define ERR_psi_CharStr_mem  318	/* error alloc'g type 1 Charstring array */
#define ERR_psi_Charname_mem 319	/* error alloc'g type 1 Char name mem */
#define ERR_psi_Chardat_mem  320	/* error alloc'g type 1 Char data mem */
#define ERR_psi_Encode_mem   321	/* error alloc'g type 1 Encoding array mem */
#define ERR_psi_Encodename_mem 322	/* error alloc'g type 1 Encoding name mem */
#define ERR_psi_nocharstring 323   /* name not found in charstrings */
#define ERR_psi_open_file    324	/* error opening type 1 file */
#define ERR_psi_rdfont       325	/* error reading type 1 font */
#define ERR_psi_cc_missing   326 /* piece of compound char missing */
#define ERR_psi_hint_ovflow  327 /* hint structure overflow */
#define ERR_psi_wkbuf_ovflow 328 /* working buff overflow */
#define ERR_psi_exp_ovflow   329 /* expand buff overflow */
#define ERR_psi_scale_ovflow 330 /* scale factor overflow */
#define ERR_psi_pcleo_encr   331 /* encrypted ps pcleos unsupported */
#define ERR_psi_pcleo_nodata 332 /* unable to find ps pcleo char data */
#define ERR_psi_cg2idx       333 /* unable to map cgnum to index */
#define ERR_psi_idx2psname   334 /* unable to map index to PS name */
#define ERR_psi_pcleo_not1   335 /* pcleo not type 1 */
#define ERR_psi_psname       336 /* error loading psname table */
#define ERR_psi_scan_StemSnapH 337	/* error scanning for type 1 StemSnapH */
#define ERR_psi_scan_StemSnapV 338	/* error scanning for type 1 StemSnapV */
#define ERR_psi_WeightVector 339	/* error reading type 1 WeightVector */
#define ERR_psi_MMstdvw     340	/* error reading type 1 MMstdvw */
#define ERR_psi_MMstdhw     341	/* error reading type 1 MMstdhw */
#define ERR_psi_MMblendtypes 342	/* error reading type 1 MMblendtypes */
#define ERR_psi_alloc_MMblendmap 343	/* error alloc'g type 1 MMblendmap[] */
#define ERR_psi_MMblendmap 344	/* error reading type 1 MMblendmap[] */
#define ERR_psi_alloc_MMblues 345	/* error alloc'g type 1 MMblues[] */
#define ERR_psi_alloc_MMotherblues 346	/* error alloc'g type 1 MMotherblues[] */
#define ERR_psi_badMMblendmap 347   /* bad multimaster blendmap */
#define ERR_psi_scan_ps_font_bbox 348 /* error scanning for type 1 FontBBox */
#define ERR_psi_scan_Fulnam   349	/* error scanning for type 1 fullname */

/*
Error codes 360 through 399 reserved for PostScript Type 0 errors
*/
#define ERR_psi_open_H0file  360 /* error opening top level H pgf file */
#define ERR_psi_open_R0file  361 /* error opening Romaji R pgf file */
#define ERR_psi_open_K0file  362 /* error opening Kana K pgf file */
#define ERR_psi_open_A0file  363 /* error opening Shift JIS A pgf file */
#define ERR_psi_open_B0file  364 /* error opening Shift JIS B pgf file */
#define ERR_psi_open_UG0file 365 /* error opening User Gaiji pgf file */
#define ERR_psi_type0_codarr 366 /* error allocating type 0 encode array */
#define ERR_psi_type0_PGOffset 367 /* error scanning type 0 PGOffset */
#define ERR_psi_type0_FontName 368 /* error scanning type 0 FontName */
#define ERR_psi_type0_RowMissing 369 /* error row is missing from font */
#define ERR_psi_type0_nochId  370 /* error chId does not map to char */
#define ERR_psi_open_CODfile  371 /* error opening COD file */
#define ERR_psi_access_CODfile  372 /* error seeking or reading COD file */
#define ERR_psi_open_CSAfile  373 /* error opening CSA file */
#define ERR_psi_access_CSAfile  374 /* error seeking or reading CSA file */
#define ERR_psi_type0_noSymSet  375 /* error symbol set mapping not supported */
#define ERR_psi_type0_generic 399 /* type 0 generic error */
#endif /* PST1_RDR */


#if TT_RDR
/*
 * TrueType error codes -- tt_if.c
 */
#define ERR_TT_OPENDISK      400 /* load_font: can't open disk font file. */
#define ERR_TT_DISKNOMEM     401 /* load_font: not enough memory for global TT data. */
#define ERR_TT_BADCONFIG     402 /* load_font: attempt to load font type not enabled in cgconfig.h */
#define ERR_TT_MEMFAIL       403 /* load_font: not enough buffer memory. */
#define ERR_TT_FSOPEN        404 /* load_font: fs_OpenFonts()  */
#define ERR_TT_FSINIT        405 /* load_font: fs_Initialize() */
#define ERR_TT_FSNEWSFNT     406 /* load_font: fs_NewSfnt()    */
#define ERR_TT_FSNEWTRANS    407 /* set_trans: fs_NewTransformation()  */
#define ERR_TT_FSGRIDFIT     408 /* make_gaso... : fs_ContourGridFit() */
#define ERR_TT_FSCLOSE       409 /* never used. */
#define ERR_TT_PCLEONOGT     410 /* global TT data segment not found */
#define ERR_TT_PCLEONOMEM    411 /* not enough memory to load global TT data */
#define ERR_TT_ROMPTR        412 /* ROM font pointer is NULL */
#define ERR_TT_DISKREAD      413 /* disk read or seek error */
#define ERR_TT_FSCHARBEARINGS 414 /* make_gaso... : fs_FindCharBearings() */
#define ERR_TT_ENTITY1       415
#endif  /* TT_RDR */


#if FCO_RDR
/*
 * Font Collection Object error codes
 */
#define ERR_fco_FCnew           500
#define ERR_fco_FCclose         501
#define ERR_fco_FCfontNew       502
#define ERR_fco_NoMem           503
#define ERR_fco_FCcharNew       504
#define ERR_fco_FCcompCharPiece 505
#define ERR_fco_intelliflator   506
#define ERR_fco_handle          507
#define ERR_fco_ttgen           508
#define ERR_fco_versionError    509
#define ERR_fco_SegmentSharing  510
#define ERR_fco_Init            511
#define ERR_fco_nzwCode         512
#define ERR_fco_OutlCode        513
#endif  /* FCO_RDR */

/*---------*/
#define  ERR_bm_gt_oron       599  /* Char bitmap too big for on array */
#define  ERR_bm_too_big       600  /* Char bitmap too big */
#define  ERR_mem_char_buf     602  /* Can't malloc character buffer */
#define  ERRmatrix_range      603  /* scaling outside of range */
#define  ERRdu_pix_range      604  /* scaling outside of range */
#define  ERR_if_init_glob     605  /* if_init_glob() failed */
#define  ERR_comp_pix         606  /* com_pix() failed */
#define  ERR_fixed_space      607  /* character is a fixed space */
#define  ERRsingular_matrix   608  /* scaling matrix has 0 determinate */
#define  ERR_skeletal_init    610
#define  ERR_y_skel_proc      611
#define  ERR_x_skel_proc      612
#define  ERR_bold_buf         613
#define  ERR_no_contour       701
#define  ERR_not_hq3          702
#define  ERR_ov_char_buf      703
#define  ERR_out_of_handles   800
#define  ERR_bad_handle       801
#define  ERR_lost_mem         802  /* CGIFdefund() didnot free whole block */
#define  ERR_IXopen_file      803
#define  ERR_no_buck_mem      804  /* BUCKnew couldn't get memory */
#define  ERR_cc_complex       805  /* Compound character hs too many parts */
#define  ERR_no_cc_part       806  /* Can't find compound character part */
#define  ERR_missing_block    807  /* CGIFdefund() can't find the block */
#define  ERR_max_callers      900  /* maximum number of callers         */
#define  ERR_bad_ID           901  /* Caller ID is out of range         */
#define  ERR_not_valid_ID     902  /* ID passed is not active           */
#define  ERR_ccBuff_alloc     903  /* cannot allocate comp-char buffer  */
#define  ERRtoo_many_dup_skel 904  /* too many duplicate skel points    */
#define  ERRmult_call         905
#define  ERRtoo_many_loops    906  /* too many contour loops in character */

/*  output processor installation errors */
#define  ERRinvalid_outproc_type     950
#define  ERR_bitmap_not_installed    951
#define  ERR_outline_not_installed   952
#define  ERR_quadratic_not_installed 953
#define  ERR_linear_not_installed    954
#define  ERR_cubic_not_installed     955

/* Miscellaneous error */
#define  ERR_fontpurge_unsupported   980   /* CGIFfont_purge unsupported. */

/*----------------------------------*/
/* Intellifont Configuration Block  */
/*----------------------------------*/

typedef struct
{
    UW16  bit_map_width;   /* BYTE alignment of char bitmap: 1, 2 or 4 */
    UW16  num_files;       /* max number of open library files         */
    SB8   ufstPath[PATHNAMELEN];  /* location of ufst files.       */
    SB8   typePath[PATHNAMELEN];    /* location of typeface files.     */
#if CACHE
    UW16  max_char_size;          /* max cached character bitmap size  */
#endif
#if CHAR_SIZE
#if (HUGE_PTR_SUPPORT)
    HPUB8 cc_buf_ptr;             /* compound character buffer pointer */
#else
    LPUB8 cc_buf_ptr;             /* compound character buffer pointer */
#endif
    SL32  cc_buf_size;            /*    "        "        "     size   */
#endif
} IFCONFIG;
typedef IFCONFIG FARPTR * PIFCONFIG;




/*----------------------------------*/
/*       Font Context               */
/*----------------------------------*/
/*  Masks and field values for FONTCONTEXT format field

    UW16   format;

        output format
        bit 15-14    0  Auto-quality
                     1  quality level 1
                     2  quality level 2
                     3  quality level 3

        Bits 13-12  Font Type
        Value  (in word)        If Bit 5 is 1, then ignore these bits

          0    (0x0000)  Intellifont
          1    (0x1000)  PostScript Type 1
          2    (0x2000)  TrueType
          3    (0x3000)  Font Collection Object

        Bit 11 Font Media for Internal Fonts
        Value
          0    (0x0000)  Disk
          1    (0x0800)  ROM

        Bit 10 Font Source
        Value
          0    (0x0000)  Internal Font
          1    (0x0400)  External Font

        Bits 9-8    FONTCONTEXT.format point size
                    units descriptors
        Value (in word)
          0    (0x0000)  8ths of a point
          1    (0x0100)  16ths of a point

        Bit 7  Resolution units

        Value
          0    (0x0000)  Pixels per meter
          1    (0x0080)  Pixels per inch

        Bit 6  Reserved

        Bit 5  (0x0020)  Alternate Font Type (for future expansion -
                         for now this is always 0)
          Value
            0  (0x0000)  Bits 13-12 describe the font type.
            1  (0x0020)  Font type is described in the FONTCONTEXT format2
                         field. Ignore bits 12 & 13.

        Bit 4  (0x0010)  Used to specify Non-zero winding scanning method

        Bits 3-0  Output character type
        Value  (in word)
          0    (0x0000)  Bitmap
          1    (0x0001)  Linear outline
          2    (0x0002)  Quadratic outline
          3    (0x0003)  Cubic outline
         15    (0x000f)  Application Generated Bitmap (FC_APPGEN_TYPE)
*/

#define FC_CHANGESCALE     0x3380   /* diff bits => change scale params   */

#define FC_EXTERN_TYPE     0x0400   /* PCLEO file format                  */
#define FC_ROM_TYPE        0x0800   /* ROM based file                     */

#define FC_FONTTYPE_MASK  0x3000
#define FC_IF_TYPE        0x0000   /* Intellifont                        */
#define FC_PST1_TYPE      0x1000   /* PostScript Type 1 font             */
#define FC_TT_TYPE        0x2000   /* TrueType font                      */
#define FC_FCO_TYPE       0x3000   /* Font Collection Object */

#define FC_ISEXTERN(fc) ( (fc)->format & FC_EXTERN_TYPE)
#define FC_ISIF(fc)    (( (fc)->format & FC_FONTTYPE_MASK ) == FC_IF_TYPE)
#define FC_ISPST1(fc)  (( (fc)->format & FC_FONTTYPE_MASK ) == FC_PST1_TYPE)
#define FC_ISTT(fc)    (( (fc)->format & FC_FONTTYPE_MASK ) == FC_TT_TYPE)
#define FC_ISFCO(fc)   (( (fc)->format & FC_FONTTYPE_MASK ) == FC_FCO_TYPE)

#define FC_PSUNITS_MASK   0x0300   /* Pt sz units bits w/in format fld   */
#define FC_8THS_TYPE      0x0000   /* Pt sz in 8ths (default)            */
#define FC_16THS_TYPE     0x0100   /* Pt sz in 16ths                     */

#define FC_INCHES_TYPE    0x0080   /* Output resolution is in pixels/inch */

#define FC_OUTPUT_MASK    0x000f   /* output type bits w/in format field */
#define FC_BITMAP_TYPE    0x0000   /* bitmap                             */
#define FC_LINEAR_TYPE    0x0001   /* linear outline                     */
#define FC_QUAD_TYPE      0x0002   /* quadratic outline                  */
#define FC_CUBIC_TYPE     0x0003   /* cubic outline                      */
#define FC_APPGEN_TYPE    0x000f   /* application generated              */
#define FC_NON_Z_WIND     0x0010   /* non-zero winding scanning method   */
#define FC_ISNONZWIND(fc) ( (fc)->format & FC_NON_Z_WIND )
#define FC_ISBITMAP(fc) (( (fc)->format & FC_OUTPUT_MASK ) == FC_BITMAP_TYPE)
#define FC_ISLINEAR(fc) (( (fc)->format & FC_OUTPUT_MASK ) == FC_LINEAR_TYPE)
#define FC_ISQUAD(fc)   (( (fc)->format & FC_OUTPUT_MASK ) == FC_QUAD_TYPE)
#define FC_ISCUBIC(fc)  (( (fc)->format & FC_OUTPUT_MASK ) == FC_CUBIC_TYPE)
#define FC_ISOUTLINE(fc) (( (fc)->format & 3 ) && !( (fc)->format & 0x000c ))
#define FC_ISAPPGEN(fc) (( (fc)->format & FC_OUTPUT_MASK ) == FC_APPGEN_TYPE)


#if !SCALE_MATRIX    /* typographer version only */

/*  48 bytes */
typedef struct
{
    SL32    font_id;      /* font number                                */
    SW16    point_size;   /* point size of this character in 1/8th pts  */
    SW16    set_size;     /* set   size of this character in 1/8th pts  */
    CGPOINTFX shear;        /* cosine & sine of vertical stroke angle     */
    CGPOINTFX rotate;       /* cosine & sine of baseline rotation         */
    UL32   xres;         /* output pixels per meter                    */
    UL32   yres;
    CGFIXED xspot;
    CGFIXED yspot;
    SW16    xbold;
    SW16    ybold;
    UW16   ssnum;
    UW16   format;       /* format flags                               */
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
    LPUB8  font_hdr;     /* pointer to font header */
#endif                   

#if BANDING
    SW16   band_top;     /* height of the band in pixels ( >= 0 )       */
    SW16   band_bot;     /* distance in pixels from the baseline to the */
#endif /* BANDING */

#if CONVERGENT_FONTS
    LPUB8  p_AltWidTab;
#endif
#if NO_SYMSET_MAPPING && TT_RDR
    UL32   dl_ssnum;     /* download symbol set information:
                          * Bits 0-3:    Platform ID (if TT),
                          * Bits 4-7:    Specific ID (if TT),
                          * Bits 8-31:   Reserved,
                          */
#endif  /* NO_SYMSET_MAPPING && TT_RDR */
}  FONTCONTEXT;

#else                /* typographer and all matrix versions */

/* The following 4 typedefs are different ways of specifying the scaling
   parameters. They are all combined in a union in the FONTCONTEXT
   structure defined after.
*/

#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
typedef struct
{
    SW16    point_size;   /* point size of this character in 1/8th pts  */
    SW16    set_size;     /* set   size of this character in 1/8th pts  */
    CGPOINTFX shear;        /* cosine & sine of vertical stroke angle     */
    CGPOINTFX rotate;       /* cosine & sine of baseline rotation         */
    UL32   xres;         /* output pixels per meter                    */
    UL32   yres;
}  TYPO;
#endif


#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
/*  Design space to output space */

typedef struct
{
    SL32    m[4];         /* Design space to output space               */
    SW16    matrix_scale; /* number of fractional bits in m[] values    */
} MAT0;
#endif



#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
/* world to output and em box */

typedef struct
{
    SL32    m[4];         /* matrix from world space to output space    */
    SL32    em_width;     /* size of em box in world units              */
    SL32    em_depth;
    SW16    matrix_scale; /* number of fractional bits in m[] values    */
    SW16    em_scale;     /*   "     "     "        "   " em sizes      */
} MAT1;
#endif



#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
/* world to output and world res and pt and set */

typedef struct
{
    SL32    m[4];         /* matrix from world space to output space    */
    SL32    xworld_res;   /* world space resolution */
    SL32    yworld_res;
    SW16    matrix_scale; /* number of fractional bits in m[] values    */
    SW16    world_scale;  /*   "     "     "        "   " resolution    */
    SW16    point_size;
    SW16    set_size;
} MAT2;
#endif


/* FONTCONTEXT structure */

typedef struct
{
    SL32    font_id;      /* font number                                */
    CGFIXED xspot;
    CGFIXED yspot;
    SW16    xbold;
    SW16    ybold;
    UW16   ssnum;
    UW16   format;       /* format flags                               */
#if (PCLEO_RDR || NON_IF_FONT || DYNAMIC_FONTS)
    LPUB8  font_hdr;     /* pointer to font header */
#endif

#if BANDING
    SW16   band_top;     /* height of the band in pixels ( >= 0 )       */
    SW16   band_bot;     /* distance in pixels from the baseline to the */
#endif /* BANDING */

#if CONVERGENT_FONTS
    LPUB8  p_AltWidTab;
#endif
#if NO_SYMSET_MAPPING && TT_RDR
    UL32   dl_ssnum;     /* download symbol set information:
                          * Bits 0-3:    Platform ID (if TT),
                          * Bits 4-7:    Specific ID (if TT),
                          * Bits 8-31:   Reserved,
                          */
#endif  /* NO_SYMSET_MAPPING && TT_RDR */

    UW16  fc_type;     /* selector indicates which union type */
    union
    {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
        TYPO  t;
#endif
#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
        MAT0  m0;
#endif
#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
        MAT1  m1;
#endif
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
        MAT2  m2;    
#endif
    } s;
} FONTCONTEXT;

/* values for fc_type */

#define FC_TYPO_TYPE      0   /* Typographer                        */
#define FC_MAT0_TYPE      1   /* Matrix design unit to output       */
#define FC_MAT1_TYPE      2   /*        world to output   em box    */
#define FC_MAT2_TYPE      3   /*                          pt, set   */

#endif  /*  SCALE_MATRIX not 0 */


typedef FONTCONTEXT FARPTR * PFONTCONTEXT;

#ifdef _WINDOWS
#define MAXPATHLEN		128			/* max length of pathname (incl null) */
#else
#define MAXPATHLEN		65			/* max length of pathname (incl null) */
#endif /* _WINDOWS */

#if PST1
typedef struct PSparamSTR
{
	UW16	filetypes;				/* afm, pfm, vfm requested */
	SB8	outFile[MAXPATHLEN];	/* output file base name */
#if VFM
	SL32	vfm_font_id;			/* as per Ventura spec */
#endif
} PSPARAMSTR;
typedef PSPARAMSTR  FARPTR * PPSPARAMSTR;  /* 07-25-91 jfd */
#endif /* PST1 */


/*----------------------------------*/
/*    Character Bitmap              */
/*----------------------------------*/

/*----------------------*/
/*  Doubly Linked Lists */
/*----------------------*/
typedef struct
{ 
    MEM_HANDLE  f;  /* forward pointer */
    MEM_HANDLE  b;  /* backward pointer */
} DLL;
typedef DLL FARPTR * PDLL;

typedef struct
{
    DLL     link;          /* doubly linked list pointers                  */
    UW16   notmru;        /* set to 0 if recently made most recently used */
    HIFFONT hiffont;       /* Font handle of the owner of this IFBITMAP    */
    SW16    index;         /* index to IFBITMAP in above FONT's table      */

    SW16    width;         /* bit map width (bytes)                 */
    SW16    depth;         /*  "   "  depth (pixels)                */
    SW16    left_indent;
    SW16    top_indent;
    SW16    black_width;
    SW16    black_depth;
    SL32    xorigin;       /*  (1/16th pixel)  */
    SL32    yorigin;       /*  (1/16th pixel)  */
    SW16    escapement;    /* character body width (design units)  */
                           /*  native units if DU_ESCAPEMENT == 1, */
                           /*  else 8782's                         */
    SW16    du_emx;        /* x-size of em box                     */
    SW16    du_emy;        /* y-size of em box                     */

    UL32   bm[1];            /* character bit map                     */
} IFBITMAP;
typedef IFBITMAP FARPTR * PIFBITMAP;
typedef IFBITMAP FARPTR * FARPTR * PPIFBITMAP;

#define BMHEADERSIZE   (sizeof(IFBITMAP) - 4) /* IFBITMAP header size  */


typedef struct {
    UW16 num_segmts;
    UW16 num_coords;
    UW16 polarity;
    UW16 segmt_offset;
    UW16 coord_offset;
} OUTLINE_LOOP;
typedef OUTLINE_LOOP FARPTR * POUTLINE_LOOP;

typedef struct {
  SL32  size;
  SW16  pad;
  UW16 num_loops;
  OUTLINE_LOOP loop[1];  /* actual # of loops depends on character */
  /* Actual outline data follows this array. */
} OUTLINE_CHAR;
typedef OUTLINE_CHAR FARPTR * POUTLINE_CHAR;

typedef struct
{
    DLL     link;          /* doubly linked list pointers                  */
    UW16   notmru;        /* set to 0 if recently made most recently used */
    HIFFONT hiffont;       /* Font handle of the owner of this IFBITMAP    */
    SW16    index;         /* index to IFBITMAP in above FONT's table      */

    SL32     size;         /* size of header w/out metrics */
    SW16    depth;         /*  always 1                */
    INTR    left;
    INTR    top;
    INTR    right;
    INTR    bottom;
    SW16    xscale;
    SW16    yscale;
    SW16    escapement;    /* character body width (design units)  */
                           /*  native units if DU_ESCAPEMENT == 1, */
                           /*  else 8782's                         */
    SW16    du_emx;        /* x-size of em box                     */
    SW16    du_emy;        /* y-size of em box                     */

    OUTLINE_CHAR    ol;    /* changed from 3.01 to match actual data */
} IFOUTLINE;
typedef IFOUTLINE FARPTR * PIFOUTLINE;
typedef IFOUTLINE FARPTR * FARPTR * PPIFOUTLINE;

/* IFOUTLINE header size */
#define OLHEADERSIZE   (sizeof(IFOUTLINE) - sizeof(OUTLINE_CHAR))


/*----------------------------------*/
/*    Kerning Pair                  */
/*----------------------------------*/

typedef struct
{
    UW16 chId0, chId1;
    SW16  adj;
}  KERN_PAIR;
typedef KERN_PAIR FARPTR * PKERN_PAIR;

/*----------------------------------*/
/*    Tile structures               */
/*----------------------------------*/
typedef struct
{
    SW16 x;      /* coordinate of upper left corner of tile  */
    SW16 y;
    SW16 width;  /* dimensions of tile */
    SW16 depth;

}  IFTILE;
typedef IFTILE FARPTR * PIFTILE;




#define MAKbitMap  CGIFmakechar

/**********************************************************/
/*                                                        */
/*                         CG macros                      */
/*                                                        */
/**********************************************************/

#if !defined(_AM29K)
#define MDES2BM(v) \
    ( (!if_state.quadrant) /* arbitrary rotation */  \
      ?  des2bm(v)                                   \
      :  cg_scale(v) )
#endif

#if FONTBBOX
#define CGIFP_MAX_BADCHARS    2
#define CGIFP_IF_SCALABLE    10
#endif

#ifdef LINT_ARGS
#if MULTICALLER
#if SEM_ACCESS
EXTERN  UW16  CGENTRY  acquire_semaphore(VOID);
EXTERN  UW16  CGENTRY  release_semaphore(VOID);
#endif  /* SEM_ACCESS */
EXTERN  UW16  CGENTRY  CGIFinit  (LPUW16, LPUL32, LPUL32);
EXTERN  UW16  CGENTRY  CGIFconfig(UW16, PIFCONFIG );
EXTERN  UW16  CGENTRY  CGIFenter (UW16);
EXTERN  UW16  CGENTRY  CGIFexit  (UW16);
EXTERN  UW16  CGENTRY  CGIFfont  (UW16, PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFwidth (UW16, UW16, UW16, UW16, LPUW16);
EXTERN  UW16  CGENTRY  CGIFkern  (UW16, UW16, UW16, PKERN_PAIR);
#if (HUGE_PTR_SUPPORT)
EXTERN  UW16  CGENTRY  CGIFfund  (UW16, UW16, HPSB8 , UL32, LPUW16 );
EXTERN  UW16  CGENTRY  CGIFmove_block (UW16, UW16, HPSB8);
#else
EXTERN  UW16  CGENTRY  CGIFfund  (UW16, UW16, LPSB8 , UL32, LPUW16 );
EXTERN  UW16  CGENTRY  CGIFmove_block (UW16, UW16, LPSB8);
#endif
EXTERN  UW16  CGENTRY  CGIFchar(UW16, UW16, PPIFBITMAP, SW16);
EXTERN  UW16  CGENTRY  CGIFfont_purge(UW16, PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFhdr_font_purge(UW16, PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFtile(UW16, PIFTILE, PPIFBITMAP);
EXTERN UW16   CGENTRY  CGIFchar_handle(UW16, UW16, PHIFBITMAP, SW16);
EXTERN UW16   CGENTRY  CGIFtile_handle(UW16, PIFTILE, PHIFBITMAP);
#if (MAX_BM_BITS > 16)
EXTERN  UW16  CGENTRY  CGIFchar_size(UW16, UW16, LPSL32, SW16);
#else
EXTERN  UW16  CGENTRY  CGIFchar_size(UW16, UW16, LPUW16, SW16);
#endif
EXTERN  UW16  CGENTRY  CGIFmakechar(UW16, PIFBITMAP, LPUB8);
EXTERN  UW16  CGENTRY  CGIFtile_nzw_buf(UW16, PIFTILE, LPSL32);
EXTERN  UW16  CGENTRY  CGIFtilebitMap(UW16, PIFTILE, PIFBITMAP, LPUB8);
EXTERN  UW16  CGENTRY  CGIFbmheader(UW16, UW16, PIFBITMAP, SW16);
EXTERN  UW16  CGENTRY  CGIFdefund(UW16, UW16);
EXTERN  UW16  CGENTRY  CGIFpcleo(UW16, LPSB8, LPUL32);
EXTERN  UW16  CGENTRY  CGIFsegments(UW16, SL32, UW16, LPUW16, LPSB8);
GLOBAL  SW16         CGIFinitRomInfo(UW16, LPUB8, LPUB8*);
#if TT_TTPLUG   /* TrueTupe uses TrueType Universal Plugins */
EXTERN  UW16  CGENTRY  CGIFtt_universal(UW16, LPUB8, int);
#endif
#if PST1
EXTERN  UW16  CGENTRY  CGIFps(UW16, PPSPARAMSTR);
#endif
#if FONTBBOX
EXTERN  UW16  CGENTRY  CGIFbound_box( UW16, int* );
EXTERN  UW16  CGENTRY  CGIFbbox_IFPCLEOchar( UW16, LPUB8, LPUB8, LPUW16 );
#endif /* FONTBBOX */
#if FCO_RDR
EXTERN  UW16  CGENTRY  CGIFfco_Open( UW16, LPUB8, LPSW16);
EXTERN  UW16  CGENTRY  CGIFfco_Close( UW16, SW16 );
EXTERN  UW16  CGENTRY  CGIFfco_Plugin( UW16, SW16 );
#if FCOACCESS
EXTERN  UW16  CGENTRY  CGIFfco_Access( UW16, LPUB8, UW16, UW16, LPUW16, LPSB8 );
#endif /* FCOACCESS */
#if (HUGE_PTR_SUPPORT)
EXTERN  UW16  CGENTRY  CGIFtt_Generate( UW16, UW16, LPSW16, LPHPUB8, LPUL32 );
#else
EXTERN  UW16  CGENTRY  CGIFtt_Generate( UW16, UW16, LPSW16, LPLPUB8, LPUL32 );
#endif
EXTERN  UW16  CGENTRY  CGIFtt_Free( UW16, LPSB8 );
#endif
#if NO_SYMSET_MAPPING
EXTERN  UW16  CGENTRY  CGIFchIdptr( UW16, VOID *, VOID * );
#endif
#else   /* ! MULTICALLER */
EXTERN  UW16  CGENTRY  CGIFinit  (VOID);
EXTERN  UW16  CGENTRY  CGIFconfig(PIFCONFIG);
EXTERN  UW16  CGENTRY  CGIFenter (VOID);
EXTERN  UW16  CGENTRY  CGIFexit  (VOID);
EXTERN  UW16  CGENTRY  CGIFfont  (PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFwidth (UW16, UW16, UW16, LPUW16);
EXTERN  UW16  CGENTRY  CGIFkern  (UW16, UW16, PKERN_PAIR);
#if (HUGE_PTR_SUPPORT)
EXTERN  UW16  CGENTRY  CGIFfund  (UW16, HPSB8, UL32, LPUW16);
EXTERN  UW16  CGENTRY  CGIFmove_block (UW16, HPSB8);
#else
EXTERN  UW16  CGENTRY  CGIFfund  (UW16, LPSB8, UL32, LPUW16);
EXTERN  UW16  CGENTRY  CGIFmove_block (UW16, LPSB8);
#endif
EXTERN  UW16  CGENTRY  CGIFchar  (UW16, PPIFBITMAP, SW16);
EXTERN  UW16  CGENTRY  CGIFfont_purge(PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFhdr_font_purge(PFONTCONTEXT);
EXTERN  UW16  CGENTRY  CGIFtile(PIFTILE, PPIFBITMAP);
EXTERN  UW16  CGENTRY  CGIFchar_handle(UW16, PHIFBITMAP, SW16);
EXTERN  UW16  CGENTRY  CGIFtile_handle(PIFTILE, PHIFBITMAP);
#if (MAX_BM_BITS > 16)
EXTERN  UW16  CGENTRY  CGIFchar_size(UW16, LPSL32, SW16);
#else
EXTERN  UW16  CGENTRY  CGIFchar_size(UW16, LPUW16, SW16);
#endif
EXTERN  UW16  CGENTRY  CGIFmakechar(PIFBITMAP, LPUB8);
EXTERN  UW16  CGENTRY  CGIFtile_nzw_buf(PIFTILE, LPSL32);
EXTERN  UW16  CGENTRY  CGIFtilebitMap(PIFTILE, PIFBITMAP, LPUB8);
EXTERN  UW16  CGENTRY  CGIFbmheader(UW16, PIFBITMAP, SW16);
EXTERN  UW16  CGENTRY  CGIFdefund(UW16);
EXTERN  UW16  CGENTRY  CGIFpcleo(LPSB8, LPUL32);
EXTERN  UW16  CGENTRY  CGIFsegments(SL32, UW16, LPUW16, LPSB8);
GLOBAL  SW16         CGIFinitRomInfo(LPUB8, LPUB8*);
#if TT_TTPLUG   /* TrueTupe uses TrueType Universal Plugins */
EXTERN  UW16  CGENTRY  CGIFtt_universal(LPUB8, int);
#endif
#if PST1
EXTERN  UW16  CGENTRY  CGIFps(PPSPARAMSTR);
#endif
#if FONTBBOX
EXTERN  UW16  CGENTRY  CGIFbound_box( int* );
EXTERN  UW16  CGENTRY  CGIFbbox_IFPCLEOchar( LPUB8, LPUB8, LPUW16 );
#endif
#if FCO_RDR
EXTERN  UW16  CGENTRY  CGIFfco_Open( LPUB8, LPSW16);
EXTERN  UW16  CGENTRY  CGIFfco_Close( SW16 );
EXTERN  UW16  CGENTRY  CGIFfco_Plugin( SW16 );
#if FCOACCESS
EXTERN  UW16  CGENTRY  CGIFfco_Access( LPUB8, UW16, UW16, LPUW16, LPSB8 );
#endif /* FCOACCESS */
#if (HUGE_PTR_SUPPORT)
EXTERN  UW16  CGENTRY  CGIFtt_Generate( UW16, LPSW16, LPHPUB8, LPUL32 );
#else
EXTERN  UW16  CGENTRY  CGIFtt_Generate( UW16, LPSW16, LPLPUB8, LPUL32 );
#endif
EXTERN  UW16  CGENTRY  CGIFtt_Free( LPSB8 );
#endif
#if NO_SYMSET_MAPPING
EXTERN  UW16  CGENTRY  CGIFchIdptr( VOID *, VOID * );
#endif
#endif /* MULTI_CALLER */

#else   /* ! LINT_ARGS */

#if SEM_ACCESS
EXTERN  UW16  CGENTRY  acquire_semaphore();
EXTERN  UW16  CGENTRY  release_semaphore();
#endif  /* SEM_ACCESS */
EXTERN  UW16  CGENTRY  CGIFinit();
EXTERN  UW16  CGENTRY  CGIFconfig();
EXTERN  UW16  CGENTRY  CGIFfund();
EXTERN  UW16  CGENTRY  CGIFenter();
EXTERN  UW16  CGENTRY  CGIFexit();
EXTERN  UW16  CGENTRY  CGIFfont();
EXTERN  UW16  CGENTRY  CGIFwidth();
EXTERN  UW16  CGENTRY  CGIFkern();
EXTERN  UW16  CGENTRY  CGIFmove_block();

EXTERN  UW16  CGENTRY  CGIFchar();
EXTERN  UW16  CGENTRY  CGIFfont_purge();
EXTERN  UW16  CGENTRY  CGIFhdr_font_purge();
EXTERN  UW16  CGENTRY  CGIFtile();
EXTERN  UW16  CGENTRY  CGIFchar_handle();
EXTERN  UW16  CGENTRY  CGIFtile_handle();
EXTERN  UW16  CGENTRY  CGIFchar_size();
EXTERN  UW16  CGENTRY  CGIFmakechar();
EXTERN  UW16  CGENTRY  CGIFtile_nzw_buf();
EXTERN  UW16  CGENTRY  CGIFtilebitMap();
EXTERN  UW16  CGENTRY  CGIFbmheader();
EXTERN  UW16  CGENTRY  CGIFdefund();
EXTERN  UW16  CGENTRY  CGIFpcleo();
EXTERN  UW16  CGENTRY  CGIFsegments();
GLOBAL  SW16         CGIFinitRomInfo();
#if TT_TTPLUG   /* TrueTupe uses TrueType Universal Plugins */
EXTERN  UW16  CGENTRY  CGIFtt_universal();
#endif
#if PST1
EXTERN  UW16  CGENTRY  CGIFps();
#endif
#if FONTBBOX
EXTERN  UW16  CGENTRY  CGIFbound_box();
EXTERN  UW16  CGENTRY  CGIFbbox_IFPCLEOchar();
#endif
#if FCO_RDR
EXTERN  UW16  CGENTRY  CGIFfco_Open();
EXTERN  UW16  CGENTRY  CGIFfco_Close();
EXTERN  UW16  CGENTRY  CGIFfco_Plugin();
EXTERN  UW16  CGENTRY  CGIFtt_Generate();
EXTERN  UW16  CGENTRY  CGIFtt_Free();
#if FCOACCESS
EXTERN  UW16  CGENTRY  CGIFfco_Access();
#endif /* FCOACCESS */
#endif
#if NO_SYMSET_MAPPING
EXTERN  UW16  CGENTRY  CGIFchIdptr();
#endif
#endif /* LINT_ARGS */


#define CGIFcache_purge( a )  CGIFfont_purge( (a) )

