/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/debug.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: debug.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.4   07 Apr 1995 08:45:20   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   21 Apr 1994 15:48:44   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   15 Jan 1993 09:35:16   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:40:50   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:02   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
 /*----------------------------DEBUG.H--------------------------------------
  *  DEBUG.H  This header file contains the statements necessary for the
  *           conditional compilation of debug statements
  *
  *
  *  Modification History:
  *
  *  17-Jun-91  jfd   Changed trace_sw declaration to use port.h defines
  *                   (FIX FROM EARLIER VERSION)
  *  30-Sep-91  rs    Added 'DBG8()' for PostScript Type 1 output.
  *  03-Apr-92  rs    Portability cleanup (see port.h).
  *
  *------------------------------------------------------------------------*/
  EXTERN SW16 trace_sw;   /* if 1, display debug statements */


#ifdef DEBUG
#define GENERATE_STATEMENTS(statements) statements
#else
#define GENERATE_STATEMENTS(statements)  ;   
#endif

#define DBG(user_text) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text))

#define DBG1(user_text,a1) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1))

#define DBG2(user_text,a1,a2) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2))

#define DBG3(user_text,a1,a2,a3) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2,a3))

#define DBG4(user_text,a1,a2,a3,a4) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2,a3,a4))

#define DBG5(user_text,a1,a2,a3,a4,a5) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2,a3,a4,a5))

#define DBG6(user_text,a1,a2,a3,a4,a5,a6) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2,a3,a4,a5,a6))

#define DBG8(user_text,a1,a2,a3,a4,a5,a6,a7,a8) \
    GENERATE_STATEMENTS(if (trace_sw) printf(user_text,a1,a2,a3,a4,a5,a6,a7,a8))


