/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/ifmem.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: ifmem.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.9   06 Jul 1995 08:21:16   JOE
 * 
 * Basic 1200 dpi support.
 * 
 *    Rev 1.8   07 Apr 1995 08:45:16   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   13 Jan 1995 18:06:26   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.6   21 Nov 1994 10:30:18   JOE
 * 
 * Changed OFFBITS for 1200 DPI support.
 * 
 *    Rev 1.5   21 Apr 1994 15:48:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   08 Dec 1993 18:57:58   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.3   15 Jan 1993 09:35:22   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.2   17 Dec 1992 18:12:12   ROB
 * Make OFFBITS depend only on MSDOS 16 bit else other.
 * 
 *    Rev 1.1   14 Dec 1992 09:42:04   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:00   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* ifmem.h */
/*
 *
 *
 * History
 *
 *  17-Feb-91  awr  split off from cgif.h 
 *  23-Feb-91  awr  moved MEM_HANDLE offset and page macros from mem.c
 *   6-Jun-91  jfd  Added SUN support for OFFBITS() and OFF.
 *                  (FIX FROM EARLIER VERSION)
 *  24 Mar 92  ss   Added #define MEM_HANDLE_DEFINED needed in TT input code
 *                  to avoid redefine MEM_HANDLE if its already been done.
 *  03-Apr-92  rs   Portability cleanup (see port.h).
 *  13 Jul 92  ss   Changed condition compile of OFFBITS from ROM/SUN to
 *                  UNIX.  All UNIXs will now use more OFFBITS.
 *  13-Aug-92  rs   Added support for Watcom C386 (__FLAT__) model by
 *                  making OFFBITS same as for other 32 bit platforms.
 *  17-Dec-92  rs   Make OFFBITS depend only on 16 bit DOS else other.
 *  08-Dec-93  rs   General cleanup - MSDOS & FLAT -> CGFLAT32.
 *  21-Nov-94  jfd  Changed OFFBITS for 1200 DPI support.
 *  09-Jan-95  rob  Implement > 64KB support for internal memory mgt.
 *  06-Jul-95  mac  Basic 1200 dpi support.
 */
/*
The internal functions of the Intellifont run time library require
a dynamic memory manager. This management may be supplied by the

    - c runtime library functions malloc() and free()
    - the module mem.c
    - an application specific memory manager

Source code for the first two options is supplied. Either option may be
selected by setting the define in cgconfig.h

    #define INT_MEM_MGT  0    Set to 1 for internal memory manager

The file ifmem.h then conditional defines one of the first two options.
For the last option, use the definition of external memory management at
the end of ifmem.h as a guide and replace it with your own.
 */

#if INT_MEM_MGT   /*  If CG memory manager  */

/*
        I N T E R N A L    M E M O R Y    M A N A G E R

Initial memory is funded by the application. The application may provide
more than one block of memory for each pool. Each block of memory is
internally referred to as a PAGE and is assigned a page number.

Memory pages are subdivided into smaller blocks to fullfill MEMalloc()
requests. Each of these smaller blocks is refered to be a handle of type
MEM_HANDLE.

A memory handle is a ULONG interpreted as having two fields. A PAGE field
refers to the internally assigned page number and an offset field giving
the byte offset of the memory block from the start of the page.

The macros PAGE() and OFF() extract these fields from a MEM_HANDLE.
The maximum size for a memory block returned by MEMalloc() is determined
by the size of the offset field which is defined by OFFBITS.
*/


#if (defined (MSDOS) && !defined (CGFLAT32) && !HUGE_PTR_SUPPORT)
#define OFFBITS  16                   /* bits in offset field of handle */
#define OFF(x)   (x & 0xffff)
#else
  /*  need larger offset for addressing into font block on 32 bit machine  */
#ifdef NOT1200DPI
#define OFFBITS  24
#define OFF(x)   (x & 0xffffff)
#else
#define OFFBITS  25
#define OFF(x)   (x & 0x1ffffff)
#endif  /* NOT1200DPI */
#endif  /* MSDOS & !CGFLAT32 */

#define PAGE(x)  (UW16)(x >> OFFBITS)

#define MEM_HANDLE_DEFINED
typedef UL32        MEM_HANDLE;
typedef MEM_HANDLE FARPTR * PMEM_HANDLE;
#define NIL_MH       ((MEM_HANDLE)0L)


#ifdef LINTARGS
EXTERN VOID       MEMinit(VOID);
#if (HUGE_PTR_SUPPORT)
EXTERN HPSB8      hMEMptr(MEM_HANDLE);
#define MEMptr(h)    (LPSB8)hMEMptr(h)
#else
EXTERN LPSB8     MEMptr(MEM_HANDLE);
#endif
EXTERN MEM_HANDLE MEMalloc(UW16, SL32);
EXTERN VOID       MEMfree(UW16, MEM_HANDLE);
EXTERN VOID       MEMinstFree(UW16);
EXTERN VOID       MEMstat(UW16);
#else
EXTERN VOID       MEMinit();
#if (HUGE_PTR_SUPPORT)
EXTERN HPSB8      hMEMptr();
#define MEMptr(h)    (LPSB8)hMEMptr(h)
#else
EXTERN LPSB8      MEMptr();
#endif
EXTERN MEM_HANDLE MEMalloc();
EXTERN VOID       MEMfree();
EXTERN VOID       MEMinstFree();
EXTERN VOID       MEMstat();
#endif


#else

/*   C    R U N    T I M E    M E M O R Y    M A N A G E R

We use malloc() and free() to provide the memory management.
Since handles aren't used we define a MEM_HANDLE to be a byte pointer
and the hndle to ptr conversion function is the identity macro.

*/

#define MEM_HANDLE_DEFINED
typedef LPSB8        MEM_HANDLE;
typedef MEM_HANDLE FARPTR * PMEM_HANDLE;
#define NIL_MH       ((MEM_HANDLE)0)

#if (HUGE_PTR_SUPPORT)
#define hMEMptr(h)    (h)
#endif
#define MEMptr(h)    (h)

#ifdef LINTARGS
EXTERN VOID       MEMinit(VOID);
EXTERN MEM_HANDLE MEMalloc(UW16, SL32);
EXTERN VOID       MEMfree(UW16, MEM_HANDLE);
EXTERN VOID       MEMstat(UW16);
#else
EXTERN VOID       MEMinit();
EXTERN MEM_HANDLE MEMalloc();
EXTERN VOID       MEMfree();
EXTERN VOID       MEMstat();
#endif /* LINTARGS */



#endif

