/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/instance.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: instance.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   07 Apr 1995 08:45:14   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   21 Apr 1994 15:48:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   15 Nov 1993 09:18:32   MAIB
 * 
 * Added macros for identifying cache accessing threads
 * 
 *    Rev 1.2   15 Jan 1993 09:35:32   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:40:18   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:28   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* instance.h */


/*
REVISION HISTORY
------------------------------------------------------------------
03-Apr-92  rs  Portability cleanup (see port.h).
15-Nov-93 maib Added macros to identify cache accessing threads
*/

#if SEM_ACCESS
/*
 * 11/15/93 maib
 * macros added to increase performance of multi-threading
 * by identifying, in advance, the threads which are used
 * to access the cache
 */
EXTERN UW16 InstCACAccess[];
#define SET_CAC_THREAD(id)    (InstCACAccess[id] = 1)
#define CLEAR_CAC_THREAD(id)	(InstCACAccess[id] = 0)
#define IS_CAC_THREAD(id)	   (InstCACAccess[id])
#endif  /* SEM_ACCESS */

#ifdef LINTARGS
EXTERN VOID     INSTinit(VOID);
EXTERN UW16    INSTfree(VOID);
EXTERN UW16    INSTexit(UW16);
EXTERN UW16    INSTactive(VOID);
EXTERN UW16    INSTsaveConfig(UW16, PIFCONFIG);
EXTERN UW16    INSTsaveState(UW16, PFONTCONTEXT);
EXTERN UW16    INSTsetState(UW16);
#else
EXTERN VOID     INSTinit();
EXTERN UW16    INSTfree();
EXTERN UW16    INSTexit();
EXTERN UW16    INSTactive();
EXTERN UW16    INSTsaveConfig();
EXTERN UW16    INSTsaveState();
EXTERN UW16    INSTsetState();
#endif



