/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/inc/mixmodel.h,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: mixmodel.h,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.9   07 Apr 1995 08:45:18   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.8   21 Apr 1994 15:48:44   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   09 Feb 1994 13:34:16   JOE
 * 
 * _AM29K changes.
 * 
 *    Rev 1.6   08 Dec 1993 18:58:02   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.5   09 Jun 1993 16:47:06   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.4   22 Feb 1993 11:04:52   JOE
 * Added conditional compile for O_READFLAGS define (VXWORKS) to resolve
 * compiler error for OPEN call.
 * 
 *    Rev 1.3   12 Feb 1993 14:33:30   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   15 Jan 1993 09:35:28   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:42:16   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:11:32   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/************************************************************************/
/*
 *                      Function definitions                            
 *
 *
 */
/************************************************************************/
				/* special Borland C++ version - 3-7-92 - rs */
/* 
 * History:
 *
 * 03-DEC-90  dET - original
 *
 *
 * The common problem of mapping various I/O and string functions to the
 * respective operating system/compilers is partialy addressed forthwith.
 * Three cases exist.  MSDOS, MS WINDOWS, and standard 'C'.  We map various
 * functions to other functions because of the stdio differences.  In the 
 * SMALL, MEDIUM, and TINY models of the MSC and MS WINDOWS compilation,
 * these functions take far pointers to arguments rather than near pointers. 
 * 
 * 
 *   24 Jun 91  ss    Deleted O_BINARY from default O_READFLAGS & O_WRITEFLAGS.
 *                    Changed define SEEK to LSEEK for default.
 *   19-Jul-91  jfd   Changed "MSWINDOWS" to "_WINDOWS".
 *   26-Jul-91  jfd   Added STRCAT and SPRINTF.
 *   07-Aug-91  jfd   Added function prototype for _fstrcat() and wsprintf().
 *                    Changed conditional compile statement so that the
 *                    section of code that was meant to be run only if
 *                    !MSC && !_WINDOWS does not run if MSC.
 *   24-Sep-91  jfd   Added #define for QSORT.
 *   03-Mar-92  rs    Add '_fstrcmp()'.
 *   04-Mar-92  rs    Add STRSTR = '_fstrstr()'.
 *   07-Mar-92  rs	 Add support for Borland C++ compiler. Make 'MSC'
 *                    more like 'MSDOS' where appropriate.
 *   15-Mar-92  rs    Move Borland specific things to 'port.h'.
 *   03-Apr-92  rs    Portability cleanup (see port.h).
 *   11-Jun-92  rs    wsprintf fix for Borland C++.
 *   05-Aug-92  jfd   Added MEMCMP and MEMSET.
 *   08-Aug-92  rs    Changes for Watcom C386 compiler.
 *   08-Feb-93  jfdf  Changed READ to READF and WRITE to WRITEF due to
 *                    conflict with VXWorks.
 *   17-Feb-93  jfd   Resolve VXWORKS compiler error when calling OPEN by 
 *                    changing #define for O_READFLAGS to "O_RDONLY, 0x644".
 *   09-Jun-93  jfd   Changed all references to "char" to "SB8" for
 *                    transportability.
 *   08-Dec-93  rs    General cleanup - MSDOS & WATCOMC -> CGFLAT32.
 *   09-Feb-94  jfd/dbk _AM29K changes.
 */

/*
Borland compiler decisions depend upon the following manifest constants:

	__BORLANDC__
	_Windows

if Borland C++ compiler - fake out the system to make it appear as
if we are running the Microsoft 6.0 compiler as follows:

NON-WINDOWS

MODEL	\	MSC	_WINDOWS	M_I86TM	M_I86SM	M_I86MM	M_I86CM M_I86LM	_MSC_VER
-----------------------------------------------------------------------------
SMALL		 +			 -		  -			 +			-			-			-		  600
MEDIUM	 +			 -		  -			 -			+			-			-		  600
COMPACT 	 +			 -		  -			 -			-			+			-		  600
LARGE		 +			 -		  -			 -			-			-			+		  600

WINDOWS

MODEL	\	MSC	_WINDOWS	M_I86TM	M_I86SM	M_I86MM	M_I86CM M_I86LM	_MSC_VER
-----------------------------------------------------------------------------
SMALL		 -			 +		  -			 +			-			-			-		  600
MEDIUM	 -			 +		  -			 -			+			-			-		  600
COMPACT 	 -			 +		  -			 -			-			+			-		  600
LARGE		 -			 +		  -			 -			-			-			+		  600

These definitions are taken care of in 'port.h'
*/


/* if small or medium (tiny?) MS `C' model then define pointers as far */

#if defined(MSDOS) && !defined (CGFLAT32)

#if (defined(MSDOS) && !defined(_WINDOWS))
#define O_READFLAGS   O_BINARY | O_RDONLY
#define O_WRITEFLAGS  O_BINARY | O_WRONLY| O_CREAT

#if (defined(M_I86SM) || defined(M_I86MM) || defined(M_I86TM))
#define STRLEN    _fstrlen
#define STRCPY    _fstrcpy
#define STRNCPY   _fstrncpy
#define STRNCMP   _fstrncmp
#define STRCMP    _fstrcmp
#define MEMCPY    _fmemcpy
#define STRCAT    _fstrcat
#define OPEN       open
#define READF      MMread
#define LSEEK      lseek
#define WRITEF     MMwrite
#define CLOSE      close
#define SPRINTF    sprintf
#define QSORT     _fqsort
#define STRSTR    _fstrstr
#define MEMCMP    _fmemcmp
#define MEMSET    _fmemset
#else                              /* large model (all pointers are far) */
#define STRLEN     strlen
#define STRCPY     strcpy
#define STRNCPY    strncpy
#define STRNCMP    strncmp
#define STRCMP     strcmp
#define STRCAT     strcat
#define MEMCPY     memcpy
#define OPEN       open
#define READF      read
#define LSEEK      lseek
#define WRITEF     write
#define CLOSE      close
#define SPRINTF    sprintf
#define QSORT      qsort
#define STRSTR     strstr
#define MEMCMP     memcmp
#define MEMSET     memset
#endif

#else                              /* _WINDOWS  (08-07-91 jfd) */

#define O_READFLAGS   0    /* OF_READ  as defined in windows.h */
#define O_WRITEFLAGS  1    /* OF_WRITE */

#if (defined(M_I86LM))
#define STRNCPY   strncpy
#define STRNCMP   strncmp
#define MEMCPY    memcpy
#define QSORT     qsort
#define STRSTR    strstr
#define MEMCMP    memcmp
#define MEMSET    memset
#else /* WINDOWS, not large model */
#define STRNCPY   _fstrncpy
#define STRNCMP   _fstrncmp
#define MEMCPY    _fmemcpy
#define QSORT     _fqsort
#define STRSTR    _fstrstr
#define MEMCMP    _fmemcmp
#define MEMSET    _fmemset
#endif /* WINDOWS & M_I86LM */

/*
Windows, all models
*/
#define STRLEN     lstrlen
#define STRCPY     lstrcpy
#define STRCMP     lstrcmp
#define STRCAT     lstrcat
#define OPEN      _lopen
#define READF     _lread
#define LSEEK     _llseek
#define WRITEF    _lwrite
#define CLOSE     _lclose
#if defined (__BORLANDC__) /* add 6/11/92 - rs */
#define wsprintf   WSPRINTF
#endif /* __BORLANDC__ */
#define SPRINTF    wsprintf

#endif

#else                              /* !MSDOS, !_WINDOWS and standard 'C'  */
#if defined (__WATCOMC__) /* looks like DOS, tastes like unix */
#define O_READFLAGS   /*O_BINARY |*/ O_RDONLY
#define O_WRITEFLAGS  /*O_BINARY |*/ O_WRONLY| O_CREAT
#elif defined (__i960) /* looks like DOS, tastes like unix */
#define O_READFLAGS   O_BINARY | O_RDONLY
#define O_WRITEFLAGS  O_BINARY | O_WRONLY| O_CREAT
#elif defined (VXWORKS)
#define O_READFLAGS   O_RDONLY,0x644
#define O_WRITEFLAGS  WRITE
#else
#define O_READFLAGS   O_RDONLY           /* deleted O_BINARY  -ss 6/24/91   */
#define O_WRITEFLAGS  O_WRONLY | O_CREAT /* deleted O_BINARY  -ss 6/24/91   */
#endif /* __WATCOMC__ - rest of Watcom is like unix, ie real system */

#if defined _AM29K   /* 2-7-94 jfd,dbk */
#define OPEN       _open
#define CLOSE      _close
#define LSEEK      _lseek
#define READF      _read
#else /*!AM29K*/
#define OPEN       open
#define CLOSE      close
#define LSEEK      lseek    /* correct define from SEEK to LSEEK -ss 6/24/91 */
#define READF      read
#endif  /* AM29K*/

#define STRLEN     strlen
#define STRCPY     strcpy
#define STRNCPY    strncpy
#define STRNCMP    strncmp
#define STRCMP     strcmp
#define MEMCPY     memcpy
#define STRCAT     strcat
#define WRITEF     write
#define SPRINTF    sprintf
#define QSORT      qsort
#define STRSTR     strstr
#define MEMCMP     memcmp
#define MEMSET     memset
#endif



/* function prototypes for MSC  */

#if (defined(MSDOS) && !defined(_WINDOWS) && !defined(CGFLAT32))
#if (defined(M_I86SM) || defined(M_I86MM) || defined(M_I86TM))
#if (defined(_MSC_VER) && (_MSC_VER >= 600)) /* includes Borland */
/* nothing */
#else /* MSC 5.10, etc */
EXTERN SW16  _fstrlen(LPSB8);
EXTERN LPSB8 _fstrcpy(LPSB8, LPSB8);
EXTERN LPSB8 _fstrncpy(LPSB8, LPSB8, SW16);
EXTERN SW16  _fstrncmp(LPSB8, LPSB8, SW16);
EXTERN SW16  _fstrcmp(LPSB8, LPSB8);
EXTERN LPSB8 _fmemcpy(LPSB8, LPSB8, SW16);
EXTERN LPSB8 _fstrcat(LPSB8, LPSB8);
EXTERN LPSB8 _fstrstr(LPSB8, LPSB8);
EXTERN SW16  _fmemcmp(LPSB8, LPSB8, UW16);
EXTERN LPSB8 _fmemset(LPSB8, SB8, int);
#endif
EXTERN SW16   MMread(SW16, LPSB8, SW16);
EXTERN SW16   MMwrite(SW16, LPSB8, SW16);
#endif
#endif

#ifdef _WINDOWS
EXTERN SW16  far pascal lstrlen( LPSB8 );
EXTERN LPSB8 far pascal lstrcpy( LPSB8, LPSB8);
EXTERN LPSB8 far pascal lstrcat( LPSB8, LPSB8);
/*EXTERN LPSB8 far pascal _fstrncpy(LPSB8, LPSB8, SW16);	*/
/*EXTERN SW16  far pascal _fstrncmp(LPSB8, LPSB8, SW16);	*/
EXTERN int far pascal lstrcmp(LPSB8, LPSB8);   /* add 3/4/92 rs */

int  far pascal _lopen( SB8 far *, int );
SL32 far pascal _llseek( int, long, int );
SW16 far pascal _lread( int, SB8 far *, int );
int  far pascal _lclose( int );
SW16 far pascal _lwrite( int, SB8 far *, int );
int  far cdecl wsprintf(SB8 far *, SB8 far *,...);
#endif


