/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/met/chwidth.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: chwidth.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.11   14 Jul 1995 17:33:36   MIKE
 * If error in chwidth(), return "ERR_char_unavailable".
 * 
 *    Rev 1.10   07 Apr 1995 09:12:38   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.9   03 Aug 1994 15:59:14   MIKE
 * Add FCO changes from 1.7.1.1
 * 
 *    Rev 1.8   22 Apr 1994 14:20:54   LISA
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   21 Oct 1993 08:48:30   MIKE
 * chwidth(); ifget_width()
 * 
 *    Rev 1.6   15 Jun 1993 10:47:00   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.5   12 Feb 1993 14:41:58   JOE
 * VXWorks support.
 * 
 *    Rev 1.4   29 Jan 1993 16:35:58   JOE
 * In ifget_width(), adjust escapement if native design units are not
 * in 8782's.
 * 
 *    Rev 1.3   29 Jan 1993 09:51:46   JOE
 * In ifget_width(), saved em box size and escapement in "if_state.cs".
 * 
 *    Rev 1.2   06 Jan 1993 14:22:38   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:16:52   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:59:04   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* chwidth.c */


/*---------------------------------------------------------------------
     12-05-90   dET   In MAKchar_width(), when testing for a compound
                      character, instead of testing for "num_parts > 1",
                      test for "is_compound". This bug resulted in
                      an incorrect width being returned for a compound
                      character consisting of only one part.
     12-19-90  jfd    IFB on a Printer changes:
     01-02-91  jfd    Changes for IFB on a Printer:
     01-15-91  jfd    When checking for a compound character, instead of
                      testing for "num_parts > 1", test for "is_compound".
                      This change occurs in the following routines:
                      MAKbitMap(), MAKchar_width() and set_kern().

     01-22-91   jfd   In MAKchar_width(), when checking for space character,
                      check for "cgnum == 812" instead of checking value
                      returned by IXsetup_chr_def() == ERR_fixed_space,
                      because IXsetup_chr_def() returns SUCCESS if processing
                      space character.
     01-30-91   dET   function prototypes and modification to support 
                      MSC multi-model compilation.
     4-Feb-91   awr   Split off from maker.c
     9-Feb-91   awr   Added #include "sym.h" to declare symbol set fncts.
    23-Feb-91   awr   Changed bucket sub-segment handles to offsets.
     9-Jun-91   awr   Changed chr_def_hdr structure
    17-Jun-91   jfd   Moved "debug.h" after "port.h".
                      Moved "profile.h" after "port.h".
                      Moved "cgconfig.h" before "port.h".
    24 Jun 91   ss    Added prototypes for fgseg().
    03-Apr-92   rs    Portability cleanup (see port.h).
    15-May-92   jfd   Added ability to retrieve width from a PCLEO.
    21-May-92   jfd   Conditionally compiled code to retrieve width for a
                      PCLEO baed on PCLEO_RDR.
     9 Jun 92   ss    Duplicated prototype for PCLchId2ptr() for !LINT_ARGS.
     6-Jul-92   jfd   Added "ifget_width()" routine, using code extracted
                      from "chwidth()". 
                      Calling "get_width()" from chwidth() using function 
                      table.
     7-Jul-92   mby   moved fgseg(), chr_def, chr_def_hdr
                      declarations out of #if WIDTHS ...
     8-Jul-92   rs    Make entire file dependent on WIDTHS.
    15-Sep-92   jfd   Conditionally compiled ifget_width() based on IF_RDR.
    21-Sep-92   jfd   In ifget_width(), check if width segment exists
                      before retrieving a width. If it does not exist,
                      return 0.
    12-Oct-92   rs    Implement USE_JUMP_TABLES feature for overlays.
    06-Jan-93   jfd   ANSI C function declaration changes.
    28-Jan-93   jfd   In ifget_width(), save em box size and escapement in 
                      "if_state.cs".
                      In ifget_width(), adjust escapement if native design
                      units are not 8782's.
                      Included ""fpmath.h".
    08-Feb-93   jfd   VXWorks support.
    15-Jun-93   jfd   Moved "vxWorks.h" before "port.h" to resolve conflicts.
    20-Oct-93   mby   Fixed inappropriate return code in chwidth().
                      In ifget_width(), 'factor' and 'tmp_fp' are only used
                      when DU_ESCAPEMENT == 0
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  FCO Changes from 1.7.1.1:
    14-Mar-94   mby   Added call to fco_get_width() from chwidth().
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

    13-Jul-95  rk/mby In chwidth() if can't find character and it isn't a
                      fixed space, return "ERR_char_unavailable", not 0.

-----------------------------------------------------------------------*/


#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#if WIDTHS

#include <stdio.h>
#include "debug.h"
#include "profile.h"
#include "ifmem.h"
#include "sym.h"
#include "cgif.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "pcleo.h"
#include "fpmath.h"

/*  fm.c  */
#ifdef LINT_ARGS
EXTERN LPSB8  fgseg(PBUCKET);

#else    /*  not LINT_ARGS  */
EXTERN LPSB8  fgseg();

#endif   /* LINT_ARGS */

EXTERN CHR_DEF_HDR chr_def_hdr;
EXTERN CHR_DEF chr_def[];





#ifdef LINT_ARGS
GLOBAL UW16 chwidth(UW16);

EXTERN UW16   IXsetup_chr_def(UW16, PCHR_DEF, PPBUCKET);

#else    /*  not LINT_ARGS  */
GLOBAL UW16 chwidth();
EXTERN UW16   IXsetup_chr_def();

#endif

/*............Data from compound character segment.........................*/

EXTERN IF_STATE if_state;



/*-------------------*/
/*    chwidth        */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  chwidth(UW16 chId)
#else
GLOBAL UW16
chwidth(chId)
    UW16 chId;
#endif
{
    PBUCKET   bucket;
    UW16     status;

    DBG1("chwidth(%d)\n", chId);

    status = IXsetup_chr_def(chId, chr_def, &bucket);
    if (status == ERR_fixed_space)
       return if_state.cs.escapement;
    else if (status != SUCCESS)
       return ERR_char_unavailable;     /* 0x7FFF, 7-13-95 */

#if (USE_JUMP_TABLES)
    return (*((PIF_FUNC_TBL)if_state.pbucket->pft)->get_width)(bucket);
#else
   switch (bucket->fst_type)
   {
#if IF_RDR
      case FC_IF_TYPE:
         return (ifget_width (bucket));
#endif
#if PST1_RDR
      case FC_PST1_TYPE:
         return (psget_width (bucket));
#endif
#if TT_RDR
      case FC_TT_TYPE:
         return (ttget_width (bucket));
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
         return (fco_get_width (bucket));
#endif
      default:
         return ERR_char_unavailable;
      }
#endif /* (USE_JUMP_TABLES) */
}

#if IF_RDR
/*-------------------*/
/*    ifget_width    */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  ifget_width(PBUCKET bucket)
#else
GLOBAL UW16
ifget_width(bucket)
   PBUCKET   bucket;
#endif
{
   LPSB8     pfgseg;
#if PCLEO_RDR
   LPUW16    wp;
   PBOX      pbox;
#endif

   PDISPLAY     display;
   SL32         des_em_width;
   SW16         esc;
   FPNUM        tmp_fp_em;
   SW16         em_box;
#if !DU_ESCAPEMENT      /* 10-20-93 mby */
   FPNUM        tmp_fp,
                factor;
#endif

   pfgseg = fgseg(bucket);

#define IF_MASTERPT_SIZE 2000L  /* IF 250pts * 8 for eigths of a point */
#define XSCAN_RES        2540L  /* IF design window units              */
#define IF_EM_WIDTH    ( IF_MASTERPT_SIZE * XSCAN_RES )

   display        = (PDISPLAY)(pfgseg + bucket->p.in.odisplay);

   des_em_width   = (SL32)display->masterPointSize
                  * (SL32)display->scanResolutionX;

   tmp_fp_em      = fpmul( fplongexp(des_em_width, 0),
                           fplongexp(1383L, 0) );
   tmp_fp_em      = fpdiv( tmp_fp_em, fplongexp(100000L, 0));
   tmp_fp_em      = fpdiv( tmp_fp_em, fplongexp(8L, 0));
   em_box         = fp2word( tmp_fp_em );

   if_state.cs.du_emx = em_box;
   if_state.cs.du_emy = em_box;

#if !DU_ESCAPEMENT      /* 10-20-93 mby */
   if(des_em_width != IF_EM_WIDTH )
   {
       /** new dst.esc = (old esc * IF_EM_WIDTH ) / des_em_width  **/
       factor      = fpdiv( fplongexp(IF_EM_WIDTH, 0),
                            fplongexp(des_em_width, 0) );
   }
#endif

   if(chr_def_hdr.is_compound)
   {
      DBG1("    compound character %d\n", chr_def_hdr.escape.x);
      esc = chr_def_hdr.escape.x;

#if !DU_ESCAPEMENT
      if(des_em_width != IF_EM_WIDTH )
      {
         tmp_fp      = fpmul( fplongexp( (SL32)esc, 0 ), factor );
         esc         = fp2word( tmp_fp );   /* save it */
         if_state.cs.du_emx = (SW16)8782;
         if_state.cs.du_emy = (SW16)8782;
      }
#endif
      if_state.cs.escapement = esc;
      return esc;
   }
   else
   {
#if PCLEO_RDR

      /* 5-6-92 AE:
         Since PCLEO data doesn't contain a width segment, must get
         width directly from character metric data.
      */
      if (B_ISEXTERN(bucket))
      {
         /* when the character is typeface sensitive, it will be in the
            PCLEO data, so use it.
         */
         if (chr_def[0].pgif)
         {
            /* get pointer to metric data offset */
            wp = (LPUW16)(chr_def[0].pgif + sizeof(UW16));

            /* get ptr to metric data */
            wp = (LPUW16)(chr_def[0].pgif + *wp );

            /* get pointer to bounding box member */
            pbox = (PBOX)wp;
            pbox++;  /* bump to escapement box */

            esc = pbox->ur.x - pbox->ll.x;

#if !DU_ESCAPEMENT
            if(des_em_width != IF_EM_WIDTH )
            {
               tmp_fp      = fpmul( fplongexp( (SL32)esc, 0 ), factor );
               esc         = fp2word( tmp_fp );   /* save it */
               if_state.cs.du_emx = (SW16)8782;
               if_state.cs.du_emy = (SW16)8782;
            }
#endif
            if_state.cs.escapement = esc;
            return( esc );  /* return x escapement */
         }
      }
#endif /* PCLEO_RDR */

     /* All non-PCLEO and non-typeface sensitive characters get width
        from width segment.
     */

       if (bucket->p.in.owidth_seg != MAX_UWORD)
       {
          DBG1("    %u\n", ((PCHARWIDTH)(pfgseg + bucket->p.in.owidth_seg) /* jfd */
               + chr_def[0].index)->width);


          esc = ((PCHARWIDTH)(pfgseg + bucket->p.in.owidth_seg)
               + chr_def[0].index)->width;

#if !DU_ESCAPEMENT
          if(des_em_width != IF_EM_WIDTH )
          {
             tmp_fp      = fpmul( fplongexp( (SL32)esc, 0 ), factor );
             esc         = fp2word( tmp_fp );   /* save it */
             if_state.cs.du_emx = (SW16)8782;
             if_state.cs.du_emy = (SW16)8782;
          }
#endif
          if_state.cs.escapement = esc;
          return ( esc );
       }
       else
       {
          if_state.cs.escapement = 0;
          if_state.cs.du_emx     = 0;
          if_state.cs.du_emy     = 0;
          return 0;
       }
    }
}
#endif  /* IF_RDR */

#endif  /* WIDTHS */
