/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/out/cubic.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: cubic.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.7   07 Apr 1995 09:17:10   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.6   01 Jun 1994 09:56:32   JOE
 * In get_angle(), moved code which adjust angle for polarity so that
 * it is executed only if the vector is neither horizontal nor vertical.
 * 
 *    Rev 1.5   22 Apr 1994 14:23:08   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   02 Feb 1994 08:59:26   JOE
 * 
 * Removed #include for "memory.h" .
 * 
 *    Rev 1.3   12 Feb 1993 14:47:18   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   05 Jan 1993 14:19:54   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:25:38   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:28:46   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/*
**  Process Block 1.6
**  File: cubic.c
**  ----------------------------------------------------------
*  History:
*  ---------
*             bjg Version 2.2 release
*   12-Mar-91 awr started port to ufst
*   24-Mar-91 awr modified get_angle(). "Slope" was not always initialized.
*   19-May-91 awr LOOP structure changed
*    2-Jun-91 awr HQ4 changes
*    8-Jun-91 awr fixed two bugs in if_long_mult()
*   17-Jun-91 jfd Moved "debug.h" after "port.h".
*   17-Jun-91 bjg Fixed make_bezier when den == 0.
*   18-Jun-91 jfd In check_bezier(), changed "eps1" from 20 to 40.
*   19-Jun-91 jfd Attempted fix by bjg in make_bezier()
*   26 Jun 91 ss  Fixed prototype for cubic() in not LINT_ARGS.
*                 Added casts for SegmtPtr usage.
*   27-Jun-91 bjg In make_bezier(), to get rid of crossing contours,
*                 check if both "alpha1" and "alpha2" exceed 65536.
*             jfd In check_bezier(), changed "eps1" from 40 to 60.
*   06-Aug-91 jfd In cubic(), cast argument passed to CHARfree() as
*                 (HIFOUTLINE).
*   24-Aug-91 awr Moved function decls to include file
*    6-Sep-91 awr Changed HEADERSIZE to OLHEADERSIZE
*    7-Sep-91 awr Changed cubic output from IFOUTLINE to function calls
*    9-Sep-91 jfd  Including "outline.h".
*   10-Sep-91 jfd Changed naming convention of outline functions.
*   12-Sep-91 jfd In make_bezier(), changed name of olcurveto() call to
*                 olcubeto().
*    9-Nov-91 awr Moved if_long_mult() to q3.c
*   03-Apr-92 rs  Portability cleanup (see port.h).
*   21-May-92 jfd In cubic() and make_bezier(), changed argument lists for
*                 calls to olmoveto(), ollineto() and olcubeto() so as to
*                 match corresponding bitmap function calls. Replaced
*                 all direct outline function calls with calls via the
*                 function table.
*                 Added pointer to font function table "pras".
*   08-Jul-92 rs  Code cleanup.
*   30-Jul-92 jfd Removed "#include if_def.h" statement.
*   09-Aug-92 rs  Changes for Watcom C386 compiler (string.h).
*   23-Sep-92 jfd INTEL960 conditional compile changes.
*   05-Jan-93 jfd ANSI C function declaration changes.
*   08-Feb-93 jfd VXWorks support.
*   26-Jan-94 jfd Removed #include for memory.h .
*   01-Jun-94 jfd In get_angle(), moved code which adjusts angle for
*                 polarity so that it is executed only if the vector
*                 is neither horizontal nor vertical.
*/

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#if defined (__WATCOMC__) || defined(__i960) || defined(VXWORKS)
#include <string.h>
#endif

#include "cgconfig.h"

#if IF_RDR && CUBIC        /*  Entire module is conditionally compiled  */

#include "port.h"
#include "debug.h"
#include "mixmodel.h"
#include "ifmem.h"
#include "q3.h"
#include "cgif.h"
#include "cache.h"
#include "cubic.h"
#include "ix.h"
#include "if_type.h"


#ifdef LINTARGS
GLOBAL UW16 cubic(INTR, INTR);
MLOCAL SW16  if_break(SW16, SW16, LPSW16, LPSW16);
MLOCAL UW16 make_bezier(VOID);
MLOCAL VOID  check_bezier(SW16, SW16, SW16,
                    SW16VECTOR, SW16VECTOR, SW16VECTOR, SW16VECTOR, LPSW16);
MLOCAL VOID  get_point(SW16, SW16, SW16, PSW16VECTOR);
MLOCAL SW16  get_angle(PSW16VECTOR);
EXTERN VOID  if_long_mult(SL32, SW16, LPSL32, LPSW16);


#else
GLOBAL UW16 cubic(); /* changed VOID to UW16 to match function -ss 6/26/91 */
MLOCAL SW16  if_break();
MLOCAL UW16 make_bezier();
MLOCAL VOID  check_bezier();
MLOCAL VOID  get_point();
MLOCAL SW16  get_angle();
EXTERN VOID  if_long_mult();
#endif

EXTERN IF_STATE if_state;
MLOCAL PSW16VECTOR coord;
/*--------------------------------------------------------------------*/
MLOCAL  PSW16VECTOR  wb;

MLOCAL SW16 xt,yt,finis;
MLOCAL SW16VECTOR START, CONTACT, END;

MLOCAL SW16 bzstart,bzend,k;
MLOCAL SW16 base[129], angle[129];
MLOCAL SW16VECTOR stack[64], stack1[64], stack2[64];
MLOCAL PSW16VECTOR stack_pntr, ptr1, ptr2;
MLOCAL LPSW16 bzptr, angle_pntr;

MLOCAL SL32 AcrossBprev;
MLOCAL SW16 angEprev;


/*--------------------------------------------------------------------*/

#define dot(A,B) ( ((SL32)(A.x)*(SL32)(B.x)) + ((SL32)(A.y)*(SL32)(B.y)) )
#define crs(A,B) ( ((SL32)(A.x)*(SL32)(B.y)) - ((SL32)(A.y)*(SL32)(B.x)) )
#define BYTEMASK1 ((UB8)1)
#define BYTEMASK2 ((UB8)2)



/* ----------------------------------------------------------------------- */
/* Routine: cubic                                                          */
/* Purpose: Generate a cubic outline for the output character              */
/* Input  : Grid aligned scaled outline- line and bi-arc                   */
/* Output : Function calls to start & end loop and draw lines and beziers  */
/* ----------------------------------------------------------------------- */
#if defined (ANSI_DEFS)
GLOBAL UW16  cubic(INTR xtranslate, INTR ytranslate)
#else
GLOBAL UW16
cubic(xtranslate, ytranslate)
    INTR        xtranslate;
    INTR        ytranslate;
#endif
{
   BOOLEAN  linear_op;        /* TRUE = linear, FALSE = quadratic outline  */
   UW16    bstate,set_state = 1,i;
   BOOLEAN  vs,ve;       /*  TRUE if curve point */
   LPSB8    vptr;        /* vertex codes */
   LOOP     loop;        /* current loop */
   UW16    status;

   xt = (SW16)(-xtranslate);
   yt = (SW16)(-ytranslate);

   linear_op = (if_state.quality < 3);
   vs = ve = FALSE;     /* set for quality < 3 */

   first_loop();
   for ( k = 0; k < if_state.num_loops; k++ ) {
      DBG("\n\n\nN e x t    L o o p\n");

      next_loop(&loop);
      vptr  = loop.v;                           /* vertex codes */
      finis = loop.ncoords;
      coord = wb = loop.cv;    /* start of loop in workbuffer */
#if OBSOLETE
      status = olstartloop(loop.polarity);
#endif
      status = if_state.out.start_loop(loop.polarity);
      if (status)
         return status;

     /* Traverse contour foward (CCW direction) by outline segments */ 

      START.x = wb->x - xt;
      START.y = wb->y - yt;
      wb++;
      if(!linear_op)
          vs = V_CONTACT(*vptr++);
      bzstart = 0;

      stack_pntr = stack;
      angle_pntr = angle;
      bstate = set_state;
      status = if_state.out.moveto(incr(START.x), incr(START.y));
      if (status)
         return status;

      for ( i = 1; i <= finis; i++ ) {
         if ( linear_op || (!vs) ) {
            END.x = wb->x - xt;
            END.y = wb->y - yt;
            wb++;
            if(!linear_op)
                ve = V_CONTACT(*vptr++);
            bzstart = i;
            angle_pntr = angle;
            bstate = set_state = 1;
            status = if_state.out.lineto(incr(END.x), incr(END.y));
            if (status)
               return status;
         } else {
            CONTACT.x = wb->x - xt;
            CONTACT.y = wb->y - yt;
            wb++;

            i++;
            END.x = wb->x - xt;
            END.y = wb->y - yt;
            wb++;
            ve = V_CONTACT(*vptr++);

            if( if_break(bzstart,i,(LPSW16)&bstate,(LPSW16)&set_state) ) {

               bzend = i - 2;

               status = make_bezier();
               if (status)
                   return status;

               bzstart = bzend;
               *(angle+1) = *(--angle_pntr);
               *(angle) = *(--angle_pntr);
               angle_pntr = angle + 2;
               bstate = set_state;

           }  /* end if for discontinuity, inflection, extrema check */


            if(!ve || (i == finis)) {

               bzend = i;

               status = make_bezier();
               if (status)
                   return status;

               bzstart = bzend;
               angle_pntr = angle;
               bstate = set_state;

           }  /* end if next seg is line or end  */
            
       } /*  end else clause for curve segment */
      START = END; 
      vs = ve;
      } /* end for each segment */ 
#if OBSOLETE
      status = olendloop();
#endif
      status = if_state.out.end_loop();
      if (status)
         return status;
   } /* end for each contour */ 
   return SUCCESS;  
}




/*-------------------*/
/*   make_bezier     */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  make_bezier()
#else
MLOCAL UW16
make_bezier()
#endif
{
   UW16 status;
   UW16 is,ie,u1,fit;
   SW16VECTOR B,C,D,E,Dnext,Enext;
   SW16VECTOR  P0 ,P1, P2, P3;
   SW16VECTOR chord;
   SL32 m1,m2,b1,b2,bx,by;
   SL32 mult,mult2,fac,den;
   SL32 alpha1,alpha2;
   SW16 shift,shift2;   
   SW16 u,tempang,chordang,minn;
   LPSW16 tempptr;

   SW16VECTOR CONTROL, V;

   bzptr = base;
   *bzptr++ = bzstart;             
   *bzptr++ = bzend;

   get_point(bzstart, bzstart+1, bzstart+2, &P1);
   get_point(bzend,   bzend-1,   bzend-2,   &P2);

   D.x = (P1.x>>1) - coord[bzstart].x+xt;
   D.y = (P1.y>>1) - coord[bzstart].y+yt;
   E.x = (P2.x>>1) - coord[bzend].x+xt;
   E.y = (P2.y>>1) - coord[bzend].y+yt;
   
   *stack_pntr++ = D;
   *stack_pntr++ = E;

   while ( bzptr != base ) {
     ie = *(--bzptr);
     is = *(--bzptr);

     fit = TRUE;
     P0.x = coord[is].x-xt;
     P0.y = coord[is].y-yt;
     P3.x = coord[ie].x-xt;
     P3.y = coord[ie].y-yt;

     C = E = *(--stack_pntr);
     B = D = *(--stack_pntr);

     den = crs(D,E);
     if(den == 0) {
       fit = 2;
         status = if_state.out.lineto(incr(P3.x), incr(P3.y));
         if (status)
            return status;
         continue;
     }


     if(D.x == 0) {
        m2 = ((SL32)E.y << 16)/E.x;
        b2 = P3.y - (SW16)((m2 * P3.x)>>16);
        P1.x = P0.x;
        P1.y = (SW16)(b2 + ((m2 * P1.x)>>16));
     }
     else if (E.x == 0) {
        m1 = ((SL32)D.y << 16)/D.x;
        b1 = P0.y - (SW16)((m1 * P0.x)>>16);
        P1.x = P3.x;
        P1.y = (SW16)(b1 + ((m1 * P1.x)>>16));
     }
     else {
        m1 = ((SL32)D.y << 16)/D.x;
        m2 = ((SL32)E.y << 16)/E.x;
        if_long_mult(m1, P0.x, &mult, &shift);
           fac = mult>>(16-shift);
           b1 = P0.y - fac;
        if_long_mult(m2, P3.x, &mult, &shift);
           b2 = P3.y - (mult>>(16-shift));
        if_long_mult((b2-b1),0x4000,&mult,&shift);
        P1.x = (SW16)(mult/((m1-m2)>>(3+shift)));
        P1.x = (P1.x+1)>>1;

        if(D.y == 0)
          P1.y = P0.y;
        else if (E.y == 0)
          P1.y = P3.y;
        else {
          if_long_mult(m1, P1.x, &mult, &shift);
             fac = mult>>(16-shift);
             P1.y = (SW16)(b1 + fac);
        }
     }


     D.x = P1.x - P0.x;
     D.y = P1.y - P0.y;
     E.x = P1.x - P3.x;
     E.y = P1.y - P3.y;

     den = crs(D,E);
     if(den == 0) {
       fit = 2;
         status = if_state.out.lineto(incr(P3.x), incr(P3.y));
         if (status)
            return status;
         continue;
     }


     minn = 0x7fff;
     u1 = is;

     chord.x = P3.x - P0.x;
     chord.y = P3.y - P0.y;
     chordang = get_angle(&chord);

     tempptr = angle + 2 + (is-bzstart);
     for (u=is+2; u<ie; u++) {
      tempang = *tempptr++;

       if(ABS(tempang-chordang) < minn) {
         minn = ABS(tempang-chordang);
         u1 = u;
       }
     }
     if(u1 == is)
       u1 = (is + ie)>>1;

     P1.x = coord[u1].x-xt;
     P1.y = coord[u1].y-yt;


     bx = ( ( ((SL32)P1.x<<3) - ((SL32)P0.x<<2)  
            - ((SL32)P3.x<<2))<<16)/3L;
     by = ( ( ((SL32)P1.y<<3) - ((SL32)P0.y<<2)
            - ((SL32)P3.y<<2))<<16)/3L;

     if_long_mult(bx,E.y,&mult,&shift);
     if_long_mult(by,E.x,&mult2,&shift2);
     if(shift > shift2) {
       mult2 = mult2>>(shift-shift2);
       fac = den >> shift;
     }
     else {
       mult = mult >>(shift2-shift);
       fac = den >> shift2;
       shift = shift2;
     }

     if( ((mult^mult2)&0x80000000L) &&
         ( (LABS(mult)&0x40000000L) || (LABS(mult2)&0x40000000L)) ) {
        shift += 1;
        mult = mult>>1;
        mult2 = mult2>>1;
     }
     alpha1 = (mult - mult2)/den;
     alpha1 = alpha1 << shift;


     if_long_mult(by,D.x,&mult,&shift);
     if_long_mult(bx,D.y,&mult2,&shift2);
     if(shift > shift2) {
       mult2 = mult2>>(shift-shift2);
       fac = den >> shift;
     }
     else {
       mult = mult >>(shift2-shift);
       fac = den >> shift2;
       shift = shift2;
     }
     if( ((mult^mult2)&0x80000000L) &&
         ( (LABS(mult)&0x40000000L) || (LABS(mult2)&0x40000000L)) ) {
        shift += 1;
        mult = mult>>1;
        mult2 = mult2>>1;
     }
     alpha2 = (mult - mult2)/den;
     alpha2 = alpha2 << shift;

     if((alpha1 < 0 || alpha2 < 0)) 
         fit = FALSE;
     if((alpha1 > 65536L && alpha2 > 65536L))
         fit = FALSE;
     P1.x = P0.x + (SW16)((alpha1 * D.x) >> 16);
     P1.y = P0.y + (SW16)((alpha1 * D.y) >> 16);
     P2.x = P3.x + (SW16)((alpha2 * E.x) >> 16);
     P2.y = P3.y + (SW16)((alpha2 * E.y) >> 16);
     if (fit == TRUE)
         check_bezier(is, u1, ie, P0, P1, P2, P3, (LPSW16)&fit);
     if( fit == 2) {
        /************WRITE DATA************/
         status = if_state.out.lineto(incr(P3.x), incr(P3.y));
         if (status)
            return status;
        /************WRITE DATA************/
     }

     else if ((fit != TRUE) && ((ie-is) > 2) ) {
        u1 = (is&1) ? u1|1 : u1&0xfffe;
        if(u1 == ie) u1 -= 2;
        *bzptr++ = u1;
        *bzptr++ = ie;
        *bzptr++ = is;
        *bzptr++ = u1;
        get_point(u1, u1+1, u1+2, &P1);
        get_point(u1, u1-1, u1-2, &P2);

        
        Dnext.x = (P1.x>>1) - coord[u1].x+xt;
        Dnext.y = (P1.y>>1) - coord[u1].y+yt;
        Enext.x = (P2.x>>1) - coord[u1].x+xt;
        Enext.y = (P2.y>>1) - coord[u1].y+yt;
        *stack_pntr++ = Dnext;
        *stack_pntr++ = C;
        *stack_pntr++ = B;
        *stack_pntr++ = Enext;
     }
     else if (fit != TRUE) {
        /************WRITE DATA************/
        CONTROL.x = P0.x+B.x;
        CONTROL.y = P0.y+B.y;
        V.x = coord[u1].x - xt;
        V.y = coord[u1].y - yt;
        status = if_state.out.cubeto(incr(CONTROL.x), incr(CONTROL.y), 
                          incr(CONTROL.x), incr(CONTROL.y),
                          incr(V.x), incr(V.y));
        if (status)
           return status;
        /************WRITE DATA************/
        CONTROL.x = P3.x+C.x;
        CONTROL.y = P3.y+C.y;
        status = if_state.out.cubeto(incr(CONTROL.x), incr(CONTROL.y),
                          incr(CONTROL.x), incr(CONTROL.y),
                          incr(P3.x), incr(P3.y));
        if (status)
           return status;
        /************WRITE DATA************/
     }
     else {
        /************WRITE DATA************/
        status = if_state.out.cubeto(incr(P1.x), incr(P1.y), incr(P2.x),
                          incr(P2.y), incr(P3.x), incr(P3.y));
        if (status)
           return status;
        /************WRITE DATA************/
     }
   }  /*  end while(bzptr != base) */
   return SUCCESS;
}




/*-------------------*/
/*     get_angle     */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16  get_angle (PSW16VECTOR A)
#else
MLOCAL SW16
get_angle (A)
   PSW16VECTOR A;
#endif
{
   SW16 index,angA;
   SL32 slope;

   if (A->x == 0)
     angA = 180;
   else if (A->y == 0)
     angA = 0;
   else
   {
      if ( ABS(A->y) > ABS(A->x)) 
         slope = LABS(((SL32)A->y<<16)/A->x);
      else
         slope = LABS(((SL32)A->x<<16)/A->y);

      index = (SW16)((slope-63488L)>>12);
      if(index < 229)
        angA = atanlist[index];
      else if (index < 508) {
        if (index < 318) {
           if(index < 266)   angA = 173;
           else              angA = 174;
        }
        else if(index < 392) angA = 175;
        else                 angA = 176;
      }
      else if (index < 1207) {
        if(index < 718)      angA = 177;
        else                 angA = 178;
      }
      else if (index < 3651) angA = 179;
      else                   angA = 180;

      /* The following code was moved from outside the
       * if-else if -else loop
       *    5-31-94 jfd
       */

      if ( ABS(A->y) <= ABS(A->x)) 
        angA = 180 - angA;
      if(A->x < 0)
        angA = 360 - angA;
      if(A->y < 0) 
        angA = -angA;
   }
   return(angA);
}




/*-------------------*/
/*     if_break      */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16  if_break(SW16 bzstart, SW16 i, LPSW16 bstate, LPSW16 set_state)
#else
MLOCAL SW16
if_break(bzstart,i,bstate,set_state)
   SW16 bzstart;
   SW16 i;
   LPSW16 bstate;
   LPSW16 set_state;
#endif
{
#define angtol 10
   SW16VECTOR A,B,C;
   SW16 angA,angB,angC,angD,angE;
   SL32 AcrossB;

/*  this is the only other use of START, CONTACT, END 
 *  which are global variables other than in main. Think about passing
 *  as parameters.
 */

   A.x = END.x - START.x;
   A.y = END.y - START.y;
   B.x = CONTACT.x - START.x;
   B.y = CONTACT.y - START.y;
   C.x = END.x - CONTACT.x;
   C.y = END.y - CONTACT.y;

   angA = get_angle(&A);
   angB = get_angle(&B);
   angC = get_angle(&C);
 
   angD = angB + angB - angA;
   angE = angC + angC - angA;
   *angle_pntr++ = angD;
   *angle_pntr++ = angA;

   *set_state = 1;

   AcrossB = crs(A,B);

   if ( (i - bzstart) > 22) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(1);
   }

   if ( bzstart >= (i-2) ) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(0);
   }
   if(   /* inflection */
        (((AcrossB^AcrossBprev)&0x80000000L) != 0)  ||
      /* discontinuity */
         ( ABS(angD-angEprev) > angtol)  ) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(1);
    }

   *set_state = 0;

   if (  ( ABS(angD) >= 3 ) &&
         ( ABS(180 - ABS(angD)) >= 3 ) &&
         ( ABS(360 - ABS(angD)) >= 3 ) )  {
      *bstate = 1;
   }

   if( *bstate == 0) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(0);
   }

   if ( ABS(angE) < 3 || ABS(180 - ABS(angE)) < 3 ||
         ABS(360 - ABS(angE)) < 3) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(0);
   }
      /*  extrema  */
   if (  ( ABS(angD) < 3 ) ||
         ( ABS(180 - ABS(angD)) < 3 ) ||
         ( ABS(360 - ABS(angD)) < 3 ) ||
         ( ABS(angEprev) < 3 ) ||
         ( ABS(180 - ABS(angEprev)) < 3 ) ||
         ( ABS(360 - ABS(angEprev)) < 3 ) ) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(1);
     }

     if (( ((angD^angE)&0x8000) != 0 ) ||
         ( (((180-ABS(angD))^(180-ABS(angE)))&0x8000) != 0 ) ) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(1);
     }
     if (( ((angD^angEprev)&0x8000) != 0 ) ||
         ( (((180-ABS(angD))^(180-ABS(angEprev)))&0x8000) != 0 ) ) {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(1);
     }



     else {
         AcrossBprev = AcrossB;
         angEprev = angE;
         return(0);
     }
}




/*-------------------*/
/*    get_point      */
/*-------------------*/
/*  is, ic, ie are input indices of curve points. */
#if defined (ANSI_DEFS)
MLOCAL VOID  get_point(SW16 is, SW16 ic, SW16 ie, PSW16VECTOR P)
#else
MLOCAL VOID
get_point(is, ic, ie, P)
  SW16 is,ic,ie;
  PSW16VECTOR P;
#endif
{
   SW16VECTOR A,B;
   SW16VECTOR P0;
   SL32 fac,den,mult;
   SW16 shift;

   A.x = coord[ie].x - coord[is].x;
   A.y = coord[ie].y - coord[is].y;
   B.x = coord[ic].x - coord[is].x;
   B.y = coord[ic].y - coord[is].y;
   P0.x = coord[ic].x - xt;
   P0.y = coord[ic].y - yt;
   fac = dot(B,B);
   den = dot(A,B);
   if ( den == 0 ) {
      P->x = ( P0.x << 1 );
      P->y = ( P0.y << 1 );
   } else {
      if_long_mult ( fac, A.x, &mult, &shift );
      den = den >> shift;
      P->x = ( P0.x << 1 ) - ( (SW16)(mult/den) );
      if_long_mult ( fac, A.y, &mult, &shift );
      den = den >> shift;
      P->y = ( P0.y << 1 ) - ( (SW16)(mult/den) );
   }

}




/*-------------------*/
/*    check_bezier   */
/*-------------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID  check_bezier(SW16 is, SW16 u1, SW16 ie, SW16VECTOR P0,
   SW16VECTOR P1, SW16VECTOR P2, SW16VECTOR P3, LPSW16 fit)
#else
MLOCAL VOID
check_bezier(is, u1, ie, P0, P1, P2, P3, fit)
   SW16 is;
   SW16 u1;
   SW16 ie;
   SW16VECTOR P0, P1, P2, P3;
   LPSW16 fit;
#endif
{

#define MAYBE 23
#define LONGMASK1 ((UL32)1)
#define bitpattern 0x00001327


   SW16 u,iz;
   SW16VECTOR F;
   SW16 dx, dy, dx1, dy1, dx2, dy2;
   SW16VECTOR v0, v1, v2, v3;
   SW16 shift;
   SL32 m1,m2,mult,b1,b2,fac,bitpatt;
   SW16 first,last,ang1,ang2;
   LPSW16 tempptr;
   SW16 flip,eps1;
   PSW16VECTOR ptr;

   eps1 = 60;    /* controls curve fitting tolerance (was 20, then 40) 06-27-91 jfd */
 
   for (iz=0; iz<4; iz += 2) {


      if( iz == 0) {
         F.x = (SW16)((((SL32)P0.x<<5) - ((SL32)P0.x<<2) - (SL32)P0.x
                     + ((SL32)P1.x<<5) - ((SL32)P1.x<<2) - (SL32)P1.x
                     + ((SL32)P2.x<<3) + (SL32)P2.x + (SL32)P3.x)>>6);
         F.y = (SW16)((((SL32)P0.y<<5) - ((SL32)P0.y<<2) - (SL32)P0.y
                     + ((SL32)P1.y<<5) - ((SL32)P1.y<<2) - (SL32)P1.y
                     + ((SL32)P2.y<<3) + (SL32)P2.y + (SL32)P3.y)>>6);
         first = is+1;
         last = u1;
      }
      else {
         F.x = (SW16)((((SL32)P3.x<<5) - ((SL32)P3.x<<2) - (SL32)P3.x
                     + ((SL32)P2.x<<5) - ((SL32)P2.x<<2) - (SL32)P2.x
                     + ((SL32)P1.x<<3) + (SL32)P1.x + (SL32)P0.x)>>6);
         F.y = (SW16)((((SL32)P3.y<<5) - ((SL32)P3.y<<2) - (SL32)P3.y
                     + ((SL32)P2.y<<5) - ((SL32)P2.y<<2) - (SL32)P2.y
                     + ((SL32)P1.y<<3) + (SL32)P1.y + (SL32)P0.y)>>6);
         first = u1+1;
         last = ie;
      }
      ptr = &coord[first-1];
      if ( ABS(F.x - ptr->x + xt) < eps1 &&
           ABS(F.y - ptr->y + yt) < eps1) {
           *fit = TRUE;
           continue;
      }
      *fit = FALSE;
      for(u = first; u <= last; u++) {
        v0.x = ptr->x - xt;
        v0.y = ptr->y - yt;
        ptr++;
        dx = ptr->x - v0.x - xt;
        dy = ptr->y - v0.y - yt;

        if( ABS(F.x-v0.x-dx) < eps1 &&
            ABS(F.y-v0.y-dy) < eps1) {
           *fit = TRUE;
           break;
        }
        if (dx > 0 ) {
           dx1 = 0;
           dx2 = dx;
        }
        else {
           dx1 = dx;
           dx2 = 0;
        }
        if (dy > 0 ) {
           dy1 = 0;
           dy2 = dy;
        }
        else {
           dy1 = dy;
           dy2 = 0;
        }
        if (F.x < v0.x + dx1 - eps1 ||
            F.y < v0.y + dy1 - eps1 ||
            F.x > v0.x + dx2 + eps1 ||
            F.y > v0.y + dy2 + eps1 ) {
                *fit = FALSE;
                continue;
        }
        *fit = MAYBE;
        break;
     }  /*  end for (u= ... */



     if(*fit == FALSE)
       break;
     if(*fit == TRUE)
       continue;
     
     tempptr = angle + u - 1 - bzstart;
     ang1 = *tempptr++;
     ang2 = *tempptr;

     flip = 1;
     if(ang1 < 0) {
        ang1 = -ang1;
        flip = -1;
     }
     if(ang1 > 180) {
        ang1 = 360 - ang1;
        flip *= -1;
     }
     m1 = tanlist[ang1]*flip;
     flip = 1;
     if(ang2 < 0) {
        ang2 = -ang2;
        flip = -1;
     }
     if(ang2 > 180) {
        ang2 = 360 - ang2;
        flip *= -1;
     }
     m2 = tanlist[ang2]*flip;

     v1.x = v0.x + dx;
     v1.y = v0.y + dy;

     if(m1 == m2) {
       v2.x = (v0.x + v1.x)>>1;
       v2.y = (v0.y + v1.y)>>1;
     }
     else {
       if_long_mult(m1, v0.x, &mult, &shift);
            fac = mult>>(16-shift);
          b1 = v0.y - fac;
       if_long_mult(m2, v1.x, &mult, &shift);
          b2 = v1.y - (mult>>(16-shift));
       if_long_mult((b2-b1),0x4000,&mult,&shift);
       v2.x = (SW16)(mult/((m1-m2)>>(3+shift)));
       v2.x = (v2.x+1)>>1;
       if(m1 == MAX_LONG)
         v2.y = v0.y;
       else if (m2 == MAX_LONG)
         v2.y = v1.y;
       else {
         if_long_mult(m1, v2.x, &mult, &shift);
            fac = mult>>(16-shift);
            v2.y = (SW16)(b1 + fac);
       }
     }
     ptr2 = stack2 + 8;
     *ptr2++ = v0;
     v0.x = v0.x<<1;
     v0.y = v0.y<<1;
     v3.x = v1.x<<1;
     v3.y = v1.y<<1;
     v1.x = v2.x<<1;
     v1.y = v2.y<<1;

    


    bitpatt = bitpattern;
    ptr1 = stack1;
    ptr2 = stack2;
    while ( TRUE ) {
       if ( bitpatt & LONGMASK1 ) {
          bitpatt = bitpatt >> 1;
          v2.x = (SW16)(( (SL32)v0.x + (SL32)v1.x )>>1);
          v2.y = (SW16)(( (SL32)v0.y + (SL32)v1.y )>>1);
          v1.x = (SW16)(( (SL32)v1.x + (SL32)v3.x )>>1);
          v1.y = (SW16)(( (SL32)v1.y + (SL32)v3.y )>>1);
          *++ptr1 = v2;
          *++ptr1 = v0;
          v0.x = (SW16)(( (SL32)v1.x + (SL32)v2.x )>>1);
          v0.y = (SW16)(( (SL32)v1.y + (SL32)v2.y )>>1);
       } else {
          bitpatt = bitpatt >> 1;
          v3.x >>= 1;
          v3.y >>= 1;
          *ptr2++ = v3;
          v3 = v0;
          if ( ptr1 == stack1 ) break;
          v0 = *ptr1--;
          v1 = *ptr1--;
       }
    }  

      *fit = FALSE;
      ptr2 = stack2;
      v1 = *ptr2++;
      for(u = 1; u <= 8; u++) {
        v0 = v1;
        v1 = *ptr2++;
        dx = v1.x - v0.x;
        dy = v1.y - v0.y;

        if( ABS(F.x-v0.x-dx) < eps1 &&
            ABS(F.y-v0.y-dy) < eps1) {
           *fit = TRUE;
           break;
        }
        if (dx > 0 ) {
           dx1 = 0;
           dx2 = dx;
        }
        else {
           dx1 = dx;
           dx2 = 0;
        }
        if (dy > 0 ) {
           dy1 = 0;
           dy2 = dy;
        }
        else {
           dy1 = dy;
           dy2 = 0;
        }
        if (F.x < v0.x + dx1 - eps1 ||
            F.y < v0.y + dy1 - eps1 ||
            F.x > v0.x + dx2 + eps1 ||
            F.y > v0.y + dy2 + eps1 ) {
                *fit = FALSE;
                continue;
        }

        if (dx == 0) {
          if(ABS(F.x-v0.x)<eps1) {
            *fit = TRUE;
            break;
          }
          else
            continue;
        }
        if (dy == 0) {
          if(ABS(F.y-v0.y)<eps1) {
            *fit = TRUE;
            break;
          }
          else
            continue;
        }

        else {
          m1 = ((SL32)dy<<16)/dx;
          if_long_mult (m1,(F.x-v0.x),&mult,&shift);
          v2.y = v0.y + (SW16)(mult>>(16-shift));
          if(ABS(F.y-v2.y)<eps1) {
            *fit = TRUE;
            break;
          }
          m1 = ((SL32)dx<<16)/dy;
          if_long_mult (m1,(F.y-v0.y),&mult,&shift);
          v2.x = v0.x + (SW16)(mult>>(16-shift));
          if(ABS(F.x-v2.x)<eps1) {
            *fit = TRUE;
            break;
          }
        }
      }  /*  end for (u= ... */
      if(*fit == FALSE) break;

  }   /*  end for(iz = ...  */
}

#endif   /*  CUBIC  */

