/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/out/outdata.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: outdata.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   07 Apr 1995 09:17:36   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   15 Feb 1995 16:36:00   JOE
 * Fixed printf's format specifiers in print_outline_data() (by mac).
 * 
 *    Rev 1.6   22 Apr 1994 14:23:32   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   02 Feb 1994 08:43:14   JOE
 * 
 * Removed #include statement for "memory.h".
 * 
 *    Rev 1.4   12 Feb 1993 14:44:54   JOE
 * VXWorks support.
 * 
 *    Rev 1.3   29 Jan 1993 09:20:24   JOE
 * In olstartchar(), saved em box size in "odata.pol".
 * 
 *    Rev 1.2   05 Jan 1993 15:03:58   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:25:24   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:28:36   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* outdata.c */


/*---------------------------------------------------------------------
     09-11-90   bjg   Added quadratic outline support.
     12-01-90   awr   split off from maker.c. Removed unused parameters
                      from linear() and quadra().
     02-04-91   awr   Changed name des2wrkbm() to des2bm()
     02-04-91   tnc   In outline_metrics(), if compound character, store
                      "h_esc" as escapement instead of calculating it 
                      from bounding box.

                dET   In outline_metrics(), "is_compound" and "h_esc"
                      are part of structure "chr_def_hdr".
     03-06-91   jfd   In make_char_part(), corrected typeo in conditional
                      compile (#if QUADRA  was  #if QUADdRA)
                      In outline(), loaded "*phol" prior to calling
                      outline_metrics().
     03-10-91   awr   Corrected size calculations for outline memory
     19-May-91  awr   LOOP structure changed
      1-Jun-91  awr   HQ4 changes
      9-Jun-91  awr   added more output to print_outline_data()
                      changed chr_def_hdr structure
     17-Jun-91  jfd   Moved "debug.h" after "port.h".
                      Moved "profile.h" after "port.h".
                      Moved "cgconfig.h" before "port.h".
     29-Jun-91  awr   Removed d.tt- not needed.
     23-Aug-91  rs    make_char_part() & outline_metrics() -> GLOBAL
     24-Aug-91  awr   Moved function decls to include file
      6-Sep-91  awr   Changed HEADERSIZE to OLHEADERSIZE
      9-Sep-91  jfd   Changed routine names as follows:
                         OUTstartchar() --> odstartchar()
                         OUTendchar()--> odendchar()
                         OUTstartloop() --> odstartloop()
                         OUTendloop() --> odendloop()
                         OUTmoveto() --> odmoveto()
                         OUTlineto() --> odlineto()
                         OUTquadto() --> odquadto()
                         OUTcurveto() --> odcurveto()
                      In odstartloop(), was not declaring argument
                      "polarity".
                      Added function prototype for outdata().
     10-Sep-91  jfd   Changed naming convention of outline functions:
                         odstartchar() --> _olstartchar()
                         odendchar()   --> _olendchar()
                         odstartloop() --> _olstartloop()
                         odendloop()   --> _olendloop()
                         odmoveto()    --> _olmoveto()
                         odlineto()    --> _ollineto()
                         odquadto()    --> _olquadto()
                         odcurveto()   --> _olcurveto()
                      Added PWORDVECTOR argument to _olifbb.
     11-Sep-91  jfd   In _olendchar(), reduce size of outline by removing
                      unused space and update appropriate offsets and sizes.
                      Including "mixmodel.h" and <memory.h>.
      12-Sep-91 jfd   In _olendchar(), check if unused space exists before
                      trying to reclaim it.
                      Changed name of _olcurveto() to _olcubeto().
       8 Oct 91 ss    Added prototype for cpymem() in !LINT_ARGS case.
     12-Oct-91  awr   Removed unused #include "bitmap.h"
     07-Nov-91  jfd   In _olstartchar(), when calculating "odata.pntptr",
                      add 8 instead of 4 to accomodate changes in
                      OUTLINE_CHAR structure.
     12-Nov-91  jfd   In _olstartchar(), replaced constants with sizeof
                      operations for SUN/SPARC compatability.
                      In _olendchar(), did the same thing.
      22-Nov-91  rs    Modify odifbb() to not add translation to get bbox.
                       This bbox is NOT same as from CGIFCHAR_handle() - error
                      equals 1/2 of translation vector.
     03-Apr-92  rs    Portability cleanup (see port.h).
                      #ifdef'd out 'OLrealloc()', not used?
     10-Apr-92  jfd   In _olendchar(), applying translation to coordinates.
     21-May-92  jfd   In order to use the function table, the following
                      outline functions' argument lists were changed to
                      match those of the corresponding bitmap functions:
                        olmoveto: (SW16VECTOR) --> (SL32, SL32)
                        ollineto: (SW16VECTOR) --> (SL32, SL32)
                        olquadto: (SW16VECTOR, SW16VECTOR) -->
                                  (SL32, SL32, SL32, SL32)
                        olcubeto: (SW16VECTOR, SW16VECTOR, SW16VECTOR) -->
                                  (SL32, SL32, SL32, SL32, SL32, SL32)

                      The argument for olstartchar() was changed from
                      OLSTATS to PVOID.
     22-May-92  jfd   In _olendchar(), removed code which applied translation
                      to coordinates. Will do it in make_char_part().
     29-May-92  jfd   In "odata" structure and in _olstartchar(), changed 
                      type "OLSTATS" to "CHAR_STATS" due to change in
                      "ix.h".
     19-Jun-92  jfd   In outdata(), if processing space character, set
                      "est_size" to 0.
                      If outline() returns ERR_fixed_space, save handle
                      to outline and return.
                      In _olstartchar(), if processing a space character,
                      return ERR_fixed_space.
      1 Jul 92  ss    Added !LINT_ARGS prototypes.
      2-Jul-92  jfd   Added olcubequadto() for generating TT cubic outlines
                      from quadratic outlines.
      7-Jul-92  jfd   Re-enabled POSTSCRIPCONTOUR so that fix_cubic_ol()
                      is called to reverse contours if necessary.
     10 Jul 92 ss,awr Changed refs from OUTLINE_CHAR.bm to new item ol.
                      Long align beginning of vectors before setting.
     14-Jul-92  awr   Changed call to make_gaso().
     16-Jul-92 rs/jfd Fixed "fix_cubic_ol()" bug by making "temppnt"
                      (data at beginning of coordinate data section)
                      an MLOCAL instead of frame variable due to potential 
                      compiler bug in MSC.
     09-Aug-92 rs     Changes for Watcom C386 (string.h).
     15-Sep-92 jfd    COnditionally compiled odifbb() based on IF_RDR &&
                      PST1.
     23-Sep-92 jfd    INTEL960 conditional compile changes.
     15-Nov-92 rs     Port to Mac - rename outline() to cgoutline().
     05-Jan-93 jfd    ANSI C function declaration changes.
     27-Jan-93 jfd    In olstartchar(), store em box size in "odata.pol".
     08-Feb-93 jfd    VXWorks support.
     26-Jan-94 jfd    Removed #include statement for "memory.h".
     15-Feb-95 mac    Fixed printf's format specifiers in print_outline_data()
-----------------------------------------------------------------------*/


#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#if defined (__WATCOMC__) || defined(__i960) || defined(VXWORKS)
#include <string.h>
#endif

#include "cgconfig.h"

#if OUTLINE && OLDATA     /* Entire module is conditionally compiled */

#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "cache.h"
#include "segments.h"
#include "ix.h"
#include "if_type.h"
#include "fmath.h"
#include "mixmodel.h"


#ifdef LINT_ARGS
EXTERN UW16      cgoutline(VOID);
GLOBAL UW16      outdata(PHIFOUTLINE);
GLOBAL UW16      outbuffer(PIFOUTLINE);
GLOBAL UW16      odifbb(PCHR_DEF, PINTRBOX, PINTRVECTOR);
MLOCAL VOID      cpymem(LPSB8, LPSB8, UW16);
MLOCAL VOID      fix_cubic_ol(POUTLINE_CHAR);
#ifdef DEBUG
MLOCAL VOID      print_outline_data(PIFOUTLINE);
#endif
EXTERN UW16      make_gaso(int,PCHR_DEF);

MLOCAL UW16     olstartchar(PVOID);  /* 5-21-92 !!! */
MLOCAL UW16     olendchar(VOID);
MLOCAL UW16     olstartloop(UW16);
MLOCAL UW16     olendloop(VOID);
MLOCAL UW16     olmoveto(INTR, INTR);
MLOCAL UW16     ollineto(INTR, INTR);
MLOCAL UW16     olquadto(INTR, INTR, INTR, INTR);
MLOCAL UW16     olcubeto(INTR, INTR, INTR, INTR, INTR, INTR);
GLOBAL UW16     olcubequadto(INTR, INTR, INTR, INTR);

#else  /* !LINT_ARGS */

EXTERN UW16      cgoutline();
GLOBAL UW16      outdata();
GLOBAL UW16      outbuffer();
GLOBAL UW16      odifbb();
MLOCAL VOID      cpymem();
MLOCAL VOID      fix_cubic_ol();
#ifdef DEBUG
MLOCAL VOID      print_outline_data();
#endif
EXTERN UW16      make_gaso();

MLOCAL UW16     olstartchar();  /* 5-21-92 !!! */
MLOCAL UW16     olendchar();
MLOCAL UW16     olstartloop();
MLOCAL UW16     olendloop();
MLOCAL UW16     olmoveto();
MLOCAL UW16     ollineto();
MLOCAL UW16     olquadto();
MLOCAL UW16     olcubeto();
GLOBAL UW16     olcubequadto();

#endif  /* LINT_ARGS */

#define LONGALIGN( v )  (((SL32)(v)+3)&0xFFFFFFFC)


EXTERN IF_STATE if_state;
EXTERN CHR_DEF_HDR chr_def_hdr;
EXTERN CHR_DEF chr_def[];

GLOBAL OUT_TBL olout_tbl = {
    olstartchar,
    olendchar,
    olstartloop,
    olendloop,
    olmoveto,
    ollineto,
    olquadto
#if CUBIC
    ,olcubeto
#endif  /* CUBIC */
};


#define POSTSCRIPTCONTOUR 1 /* use to reverse cubic outlines for PST1 */
#if POSTSCRIPTCONTOUR
/*
Try making this variable an MLOCAL instead of frame variable in 
'fix_cubic_ol()' due to potential compiler bug in MSC. - rs - 7/16/92
*/
MLOCAL INTRVECTOR temppnt;
#endif /* POSTSCRIPTCONTOUR */

#ifdef DEBUG
#if defined (ANSI_DEFS)
MLOCAL VOID  print_outline_data(PIFOUTLINE pol)
#else
MLOCAL VOID
print_outline_data(pol)
    PIFOUTLINE pol;
#endif
{
    POUTLINE_CHAR outchar;
    INTR x0,y0,x1,y1,x2,y2,x3,y3;
    SW16 num_contrs,num_segmts;
    LPSB8 segment;
    PINTRVECTOR points;
    SW16  i,j;

    DBG("\n\nprint_outline_data()\n");
    DBG1("    size\t%d\n", pol->size);    /* size of header w/out metrics */
    DBG1("    depth\t%d\n", pol->depth);  /*  always 1                */
#if INTR_SIZE == 16
    DBG1("    left\t%d\n", pol->left);
    DBG1("    top\t\t%d\n", pol->top);
    DBG1("    right\t%d\n", pol->right);
    DBG1("    bottom\t%d\n", pol->bottom);
#else
    DBG1("    left\t%ld\n", pol->left);
    DBG1("    top\t\t%ld\n", pol->top);
    DBG1("    right\t%ld\n", pol->right);
    DBG1("    bottom\t%ld\n", pol->bottom);
#endif
    DBG1("    xscale\t%d\n", pol->xscale);
    DBG1("    yscale\t%d\n", pol->yscale);
    DBG1("    escapement\t%d\n", pol->escapement);
                      
    outchar = &pol->ol;
    num_contrs = outchar->num_loops;

    DBG1("\nNumber of loops %d\n", num_contrs);

    for(i=0; i<num_contrs; i++)
    {
        num_segmts = outchar->loop[i].num_segmts;
     
        segment = (LPSB8)((LPSB8)(outchar->loop)
                                         + outchar->loop[i].segmt_offset);
        points = (PINTRVECTOR)((LPSB8)(outchar->loop)
                                        + outchar->loop[i].coord_offset);

        DBG1("Next Contour  num_segmts = %d\n", num_segmts);
        DBG1("    polarity = %d\n", outchar->loop[i].polarity);
        for(j=0; j<num_segmts; j++)
        {
   
            if(*segment == 0x00)
            {
                x0 = points->x;
                y0 = points->y;    points++;

#if INTR_SIZE == 16
                DBG2("    MoveTo %6d %6d\n", x0, y0);
#else
                DBG2("    MoveTo %6ld %6ld\n", x0, y0);
#endif
            }
            else if (*segment == 0x01)
            {
                x1 = points->x;
                y1 = points->y;    points++;

#if INTR_SIZE == 16
                DBG2("    LineTo %6d %6d\n", x1, y1);
#else
                DBG2("    LineTo %6ld %6ld\n", x1, y1);
#endif
            }
            else if (*segment == 0x02)
            {
                x1 = points->x;
                y1 = points->y;    points++;

                x2 = points->x;
                y2 = points->y;    points++;

#if INTR_SIZE == 16
                DBG4("    QuadTo %6d %6d %6d %6d\n", x1, y1, x2, y2);
#else
                DBG4("    QuadTo %6ld %6ld %6ld %6ld\n", x1, y1, x2, y2);
#endif
            }
            else if (*segment == 0x03)
            {
                x1 = points->x;
                y1 = points->y;    points++;

                x2 = points->x;
                y2 = points->y;    points++;

                x3 = points->x;
                y3 = points->y;    points++;

#if INTR_SIZE == 16
                DBG6("    CurvTo %6d %6d %6d %6d %6d %6d\n",
                         x1, y1, x2, y2, x3, y3);
#else
                DBG6("    CurvTo %6ld %6ld %6ld %6ld %6ld %6ld\n",
                         x1, y1, x2, y2, x3, y3);
#endif
            }
            else
                DBG1("    INVALID SEGMENT CODE %d\n", *segment);

            segment++;
        }
    }
}
#endif


MLOCAL struct
{
    SW16 tot_pnts;    /* total number of points generated   */
    SW16 tot_segs;    /* total number of segments generated */

    HIFOUTLINE hol;   /* Handle of outline being constructed */
    PIFOUTLINE pol;   /* pointer "   "       "        "      */

    POUTLINE_CHAR outcharptr;
    POUTLINE_LOOP oloop;      /* current loop under construction */
    LPSB8 segptr;             /* next segment in outline data structure */
    PINTRVECTOR pntptr;       /*  "   point   "     "      "      "     */

    CHAR_STATS s;             /* copy of outline stats */
} odata;


#define MOVETO  0
#define LINETO  1
#define QUADTO  2
#define CURVETO 3

#if (IF_RDR && PST1)
/*----------------------*/
/*     odifbb           */
/*----------------------*/
/*  This is a special purpose function used in producing PostScript
 *  hints from Intellifont scaling intelligence. It returns the bounding
 *  box of the character part specified by cd as it will be in the final
 *  cubic outline. It also has gone through intel_char() and so has left
 *  all of the processed scaling intelligence for the hint producing
 *  algorithm to exaimine. This function can only be called after the
 *  outline has been produced.
 */
EXTERN int gaso_pn;
#if defined (ANSI_DEFS)
GLOBAL UW16  odifbb(PCHR_DEF cd, PINTRBOX pb, PINTRVECTOR pt)
#else
GLOBAL UW16
odifbb(cd, pb, pt)
    PCHR_DEF    cd;
    PINTRBOX    pb;
    PINTRVECTOR pt;
#endif
{
    UW16 status;
    INTR xt, yt;


  /* Grid aligned scaled outline */
    gaso_pn = -1;
    status = make_gaso(0,cd);
    if (status)
       return status;

  /* Translation of character part so that composition origin is (0,0) */

    xt = (INTR)cd->bmorigin.x * (INTR)xpix - (INTR)odata.s.origin.x;
    yt = (INTR)cd->bmorigin.y * (INTR)ypix - (INTR)odata.s.origin.y;

    pt->x = xt + if_state.xlate.x;
    pt->y = yt + if_state.xlate.y;

    /*
       Modify bbox to not add translation factor - caused error equal to
         1/2 of translation when compared to CGIFCHAR_handle() bbox
             11/22/91 - rs
    */
#if 0
    pb->ll.x = (INTR)if_state.cs.olbox.ll.x;
    pb->ll.y = (INTR)if_state.cs.olbox.ll.y;
    pb->ur.x = (INTR)if_state.cs.olbox.ur.x;
    pb->ur.y = (INTR)if_state.cs.olbox.ur.y;
#endif
    /*
     * 7-6-92 These numbers seem to be closer to what we want!
     */
    pb->ll.x = (INTR)if_state.cs.xmin + pt->x;
    pb->ll.y = (INTR)if_state.cs.ymin + pt->y;
    pb->ur.x = (INTR)if_state.cs.xmax + pt->x;
    pb->ur.y = (INTR)if_state.cs.ymax + pt->y;


    return SUCCESS;
}
#endif  /* (IF_RDR && PST1) */

#if POSTSCRIPTCONTOUR
/*----------------------*/
/*     fix_cubic_ol     */
/*----------------------*/
/*  reverse outline depending on fill rule and polarity */
/*
    Reverse outline depending on fill rule and polarity. PostScript
    follows a "fill to the left" rule. Outside contours are counter-clockwise
    and inside contours are clockwise.

    NOTE: This algorithm will only work if there are NO open paths within
            contours. The final point must end up at the start point.
          Only newly made loops in case of a compound character are reversed.
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  fix_cubic_ol(POUTLINE_CHAR outcharptr)
#else
MLOCAL VOID
fix_cubic_ol(outcharptr)
    POUTLINE_CHAR outcharptr;
#endif
{
    POUTLINE_LOOP oloop;
    LPSB8 segptr, bsegptr;
    PINTRVECTOR pntptr, bpntptr;
    SW16 k, i;
    SB8 tempseg;
#if 0 /* try making this an MLOCAL to track potential compiler bug - rs 7/16/92 */
    INTRVECTOR temppnt;
#endif /* 0 */

    oloop = outcharptr->loop;
    for (k = 0; k<outcharptr->num_loops; k++, oloop++ )
    {
        /* Only reverse the points for polarity == 0 */
        if(!oloop->polarity)
        {
            oloop->polarity = 1;

          /*  Reverse order of segments. Leave 1st moveto where it is.
           *  Point segptr just after the MOVETO segment. Point bsegptr
           *  to the bottom segment
           */

            segptr = (LPSB8)(outcharptr->loop) + oloop->segmt_offset + 1;
            bsegptr = (LPSB8)segptr + oloop->num_segmts - 2;

            for (i = 0; i < ((oloop->num_segmts - 1) >> 1); i++)
            {
                tempseg    = *segptr;
                *segptr++  = *bsegptr;
                *bsegptr-- = tempseg;
            }

          /* Reverse order of points using the same idea. */

            pntptr = (PINTRVECTOR)((LPSB8)(outcharptr->loop)
                                              + oloop->coord_offset);
            bpntptr = pntptr + oloop->num_coords - 1;

            for (i = 0; i < (oloop->num_coords >> 1); i++)
            {
                
                temppnt    = *pntptr;
                *pntptr++  = *bpntptr;
                *bpntptr-- = temppnt;
            }
        } /* if (polarity == 0) */
    }
}
#endif /* POSTSCRIPTCONTOUR */


/*----------------------*/
/*     olstartchar      */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olstartchar(PVOID pstats)
#else
MLOCAL UW16
olstartchar(pstats)
    PVOID pstats;  /* 5-21-92 !!! */
#endif
{
    odata.s = *(PCHAR_STATS)pstats;

    DBG("olstartchar()\n");
    DBG1("    odata.s.format   %d\n", odata.s.format  );
    DBG1("           .nloop    %d\n", odata.s.nloop   );
    DBG1("           .est_pnts %d\n", odata.s.est_pnts);
    DBG1("           .est_segs %d\n", odata.s.est_segs);
    DBG1("           .est_size %ld\n", odata.s.est_size);


  /*  Get memory for IFOUTLINE */

    if(odata.pol)                       /* If using apps buffer           */
        odata.hol = (HIFOUTLINE)NIL_MH; /* set to nil so we don't realloc */
    else                                /* else alloc and realloc at end  */
    {
        odata.hol = CHARalloc((SL32)(OLHEADERSIZE+odata.s.est_size));
        if(odata.hol == (HIFOUTLINE)NIL_MH)
            return ERRoutline_mem;
        odata.pol = (PIFOUTLINE)MEMptr(odata.hol);
    }

  /* Special case:
   *      if space character, return ERR_fixed_space
   */
    if (!if_state.num_loops)  /* 6-19-92 */
       return ERR_fixed_space;

  /* Fill in IFOUTLINE header */

    odata.pol->size             = odata.s.est_size;
    odata.pol->depth            = 1;

    odata.pol->left             =  odata.s.olbox.ll.x;
    odata.pol->bottom           =  odata.s.olbox.ll.y;
    odata.pol->right            =  odata.s.olbox.ur.x;
    odata.pol->top              =  odata.s.olbox.ur.y;

    odata.pol->xscale           = odata.s.xscale;
    odata.pol->yscale           = odata.s.yscale;
    odata.pol->escapement       = odata.s.escapement;

    /* Store em box size   - 01/27/93 jfd */
    odata.pol->du_emx           = odata.s.du_emx;
    odata.pol->du_emy           = odata.s.du_emy;

    odata.outcharptr            = &odata.pol->ol;
    odata.outcharptr->size      = odata.s.est_size;
    odata.outcharptr->num_loops = odata.s.nloop;

  /* point to first loop and start of data area */

    odata.oloop = odata.outcharptr->loop;
    odata.pntptr = (PINTRVECTOR)
         ((LPSB8)odata.outcharptr
                                              /*  VVV only have one now */
                    + (sizeof(OUTLINE_CHAR) - sizeof(OUTLINE_LOOP))
                    + sizeof(OUTLINE_LOOP) * odata.s.nloop);

     /* make sure vectors start on long aligned address -ss,awr 7/10/92 */
    odata.pntptr = (PINTRVECTOR)LONGALIGN( odata.pntptr );

    odata.segptr = (LPSB8)(odata.pntptr + odata.s.est_pnts);
    odata.tot_segs = 0;
    odata.tot_pnts = 0;

    return SUCCESS;
}


/*----------------------*/
/*      olendchar       */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olendchar()
#else
MLOCAL UW16
olendchar()
#endif
{
    PIFOUTLINE pol;
    POUTLINE_CHAR outchar;
    SW16 i;
    SW16 wasted_point_space;
    SW16 wasted_segmt_space;
    SW16 wasted_total_space;
    LPSB8 segment;
    LPSB8 src;
    LPSB8 dst;
    MEM_HANDLE nh;
    SW16 new_size;
    PIFOUTLINE dol;


#ifdef DEBUG
    print_outline_data(odata.pol);
#endif

    DBG2("est_segs = %d   actual segs = %d\n",
                                  odata.s.est_segs, odata.tot_segs);
    DBG2("est_pnts = %d   actual pnts = %d\n",
                                  odata.s.est_pnts, odata.tot_pnts);
    DBG1("   wasted space = %d\n",  4*(odata.s.est_pnts-odata.tot_pnts)
                                     + odata.s.est_segs-odata.tot_segs);

#if POSTSCRIPTCONTOUR
    /*
        changed from '=' to '==' - 4/3/92 - rs
    */
    if(odata.s.format == FC_CUBIC_TYPE)
        fix_cubic_ol(odata.outcharptr);
#endif /* POSTSCRIPTCONTOUR */

    if(odata.hol != (HIFOUTLINE)NIL_MH)
    {
        /* if linear or cubic,  quality level == 3 and */
        /* unused space exists, remove unused space    */

        wasted_point_space = sizeof(INTRVECTOR) *
            (odata.s.est_pnts - odata.tot_pnts);  /* 11-12-91 jfd */
        wasted_segmt_space = odata.s.est_segs - odata.tot_segs;
        wasted_total_space = wasted_point_space + wasted_segmt_space;

        if ((if_state.quality == 3)
                       && (odata.s.format == (SW16)FC_LINEAR_TYPE ||
          odata.s.format == (SW16)FC_CUBIC_TYPE) && (wasted_total_space > 0))
        {
           pol = odata.pol;
           outchar = &pol->ol;
           new_size = OLHEADERSIZE + (SW16)(pol->size - (SL32)wasted_total_space);
              /* 11-07-91 jfd */

           /* try to allocate new smaller block */

           nh = CHARalloc((SL32)new_size); /* else leave big one */
           if (nh != NIL_MH)
           {       
              src = MEMptr(odata.hol); /* de-reference source outline */
              dst = MEMptr(nh);        /* de-reference reduced outline */
              dol = (PIFOUTLINE)dst;

              /* get rid of unused space in source outline */

              segment = (LPSB8)((LPSB8)(outchar->loop) + 
                    outchar->loop[0].segmt_offset);
              cpymem(segment - wasted_point_space, segment, odata.tot_segs);

              for (i=0; i<outchar->num_loops; i++)
                 outchar->loop[i].segmt_offset -= wasted_point_space;

              /* copy into smaller outline */

              cpymem(dst, src, new_size);

              /* update appropiate sizes */

              dol->size -= wasted_total_space;
              outchar = &dol->ol;
              outchar->size -= wasted_total_space;

              /* free old outline */

              CHARfree(odata.hol);  /* free old outline */

              /* update odata pointers */

              odata.hol = nh;
              odata.pol = (PIFOUTLINE)MEMptr(odata.hol);

           }
        }

    }
    return SUCCESS;
}
/*----------------------*/
/*     olstartloop      */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olstartloop(UW16 polarity)
#else
MLOCAL UW16
olstartloop(polarity)
    UW16 polarity;
#endif
{
    odata.oloop->num_segmts = 0;
    odata.oloop->num_coords = 0;

    odata.oloop->segmt_offset =
         (LPSB8)odata.segptr - (LPSB8)odata.outcharptr->loop;
    odata.oloop->coord_offset =
         (LPSB8)odata.pntptr - (LPSB8)odata.outcharptr->loop;
    odata.oloop->polarity = polarity;
    return SUCCESS;
}
/*----------------------*/
/*     olendloop        */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olendloop()
#else
MLOCAL UW16
olendloop()
#endif
{
    odata.oloop++;
    return SUCCESS;
}
/*----------------------*/
/*     olmoveto         */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olmoveto(INTR vx, INTR vy)
#else
MLOCAL UW16
olmoveto(vx, vy)
    INTR vx;
    INTR vy;
#endif
{

    odata.oloop->num_segmts++;
    odata.oloop->num_coords++;

    odata.tot_segs++;
    odata.tot_pnts++;
    if((odata.tot_segs > odata.s.est_segs)
                                || (odata.tot_pnts > odata.s.est_pnts))
        return ERRoutline_mem;

    *odata.segptr++ = MOVETO;
    odata.pntptr->x = vx;
    odata.pntptr->y = vy;
    odata.pntptr++;
    if_state.p0.x = vx;
    if_state.p0.y = vy;
    return SUCCESS;
}
/*----------------------*/
/*     ollineto         */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  ollineto(INTR vx, INTR vy)
#else
MLOCAL UW16
ollineto(vx, vy)
    INTR vx;
    INTR vy;
#endif
{
    odata.oloop->num_segmts++;
    odata.oloop->num_coords++;

    odata.tot_segs++;
    odata.tot_pnts++;
    if((odata.tot_segs > odata.s.est_segs)
                                || (odata.tot_pnts > odata.s.est_pnts))
        return ERRoutline_mem;

    *odata.segptr++ = LINETO;
    odata.pntptr->x = vx;
    odata.pntptr->y = vy;
    odata.pntptr++;  /* 5-21-92 !!! */
    if_state.p0.x = vx;
    if_state.p0.y = vy;
    return SUCCESS;
}
/*----------------------*/
/*     olquadto         */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olquadto(INTR cx, INTR cy, INTR vx, INTR vy)
#else
MLOCAL UW16
olquadto(cx, cy, vx, vy)
    INTR cx, cy, vx, vy;
#endif
{
    odata.oloop->num_segmts++;
    odata.oloop->num_coords += 2;

    odata.tot_segs++;
    odata.tot_pnts += 2;
    if((odata.tot_segs > odata.s.est_segs)
                                || (odata.tot_pnts > odata.s.est_pnts))
        return ERRoutline_mem;

    *odata.segptr++ = QUADTO;
    odata.pntptr->x = cx;
    odata.pntptr->y = cy;
    odata.pntptr++;
    odata.pntptr->x = vx;
    odata.pntptr->y = vy;
    odata.pntptr++;

    if_state.p0.x = vx;
    if_state.p0.y = vy;
    return SUCCESS;
}
/*----------------------*/
/*     olcubeto         */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  olcubeto(INTR c0x, INTR c0y, INTR c1x, INTR c1y, INTR vx, INTR vy)
#else
MLOCAL UW16
olcubeto(c0x, c0y, c1x, c1y, vx, vy)
    INTR c0x, c0y, c1x, c1y, vx, vy;
#endif
{
    odata.oloop->num_segmts++;
    odata.oloop->num_coords += 3;

    odata.tot_segs++;
    odata.tot_pnts +=3;
    if((odata.tot_segs > odata.s.est_segs)
                                || (odata.tot_pnts > odata.s.est_pnts))
        return ERRoutline_mem;

    *odata.segptr++ = CURVETO;
    odata.pntptr->x = c0x;
    odata.pntptr->y = c0y;
    odata.pntptr++;
    odata.pntptr->x = c1x;
    odata.pntptr->y = c1y;
    odata.pntptr++;
    odata.pntptr->x = vx;
    odata.pntptr->y = vy;
    odata.pntptr++;

    if_state.p0.x = vx;
    if_state.p0.y = vy;
    return SUCCESS;
}
/*----------------------*/
/*     olcubequadto     */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  olcubequadto(INTR cx, INTR cy, INTR vx, INTR vy)
#else
GLOBAL UW16
olcubequadto(cx, cy, vx, vy)
    INTR cx, cy, vx, vy;
#endif
{
    INTR cx0, cy0, cx1, cy1;
    UW16 status;

    cx0 = (INTR)(((SL32)if_state.p0.x + ((SL32)cx << 1)) / 3L);
    cy0 = (INTR)(((SL32)if_state.p0.y + ((SL32)cy << 1)) / 3L);

    cx1 = (INTR)((((SL32)cx << 1) + (SL32)vx) / 3L);
    cy1 = (INTR)((((SL32)cy << 1) + (SL32)vy) / 3L);

    status = if_state.out.cubeto(cx0, cy0, cx1, cy1, vx, vy);
    return status;
}

/*----------------------*/
/*    cpymem            */
/*----------------------*/
/*  Like memcpy() only copies from front to back (for sure). It's here so we
 *  don't have to use memmove()
 */
#if defined (ANSI_DEFS)
MLOCAL VOID  cpymem(LPSB8 dest, LPSB8 src, UW16 count)
#else
MLOCAL VOID
cpymem(dest, src, count)
    LPSB8 dest;
    LPSB8 src;
    UW16 count;
#endif
{
    while(count--)
        *dest++ = *src++;
}




/*----------------------*/
/*      outdata         */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  outdata(PHIFOUTLINE phol)
#else
GLOBAL UW16
outdata(phol)
    PHIFOUTLINE phol;         /* Final result goes here */
#endif
{
    UW16 status;

    DBG("\n\n\n\no u t d a t a()\n");

    odata.pol = (PIFOUTLINE)0;   /* to signal no outline memory buffer */

    /* Special case:
     *   if space character, set "est_size" to 0 because 
     *   "make_gaso_and_stats()" has not been called to
     *   calculate this value
     */
    if (!if_state.num_loops)  /* 6-19-92 */
       odata.s.est_size = 0L;

    if_state.out = olout_tbl;
    status = cgoutline();

    /* Special case:
     *   if space character, store handle before returning
     */

    if (status == ERR_fixed_space)  /* 6-19-92 */
       *phol = odata.hol;

    if (status)
       return status;
    *phol = odata.hol;
    return SUCCESS;
}
/*----------------------*/
/*      outbuffer       */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  outbuffer(PIFOUTLINE pol)
#else
GLOBAL UW16
outbuffer(pol)
    PIFOUTLINE pol;         /* Final result goes here */
#endif
{
    odata.pol = pol;
    if_state.out = olout_tbl;
    return cgoutline();
}

#endif  /* OUTLINE && OLDATA */
