/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/out/outline.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: outline.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.14   25 Aug 1995 11:18:04   MIKE
 * Changed last 2 args of ttrender() call (can be nonzero).
 * 
 *    Rev 1.13   07 Apr 1995 09:17:34   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   02 Feb 1995 13:36:32   JOE
 * In make_char_part(), fixed computation of "half pixel" sizes (by mac).
 * 
 *    Rev 1.11   12 Dec 1994 08:12:58   JOE
 * Conditionally compiled prototype for bmras_quad_flat() based on FCO_RDR.
 * In outline(), corrected typo in conditional compile statement
 * (FC_RDR is changed to FCO_RDR) (by dbk)
 * 
 *    Rev 1.10   11 Dec 1994 17:24:18   MIKE
 * Replace "cs.origin" with "cs.origin_cs".
 * 
 *    Rev 1.9   17 Nov 1994 13:38:52   JOE
 * More FCO outline changes (by bjg).
 * 
 *    Rev 1.8   15 Nov 1994 14:19:48   JOE
 * In outline(), added FCO support (by bjg).
 * 
 *    Rev 1.7   03 Aug 1994 16:01:42   MIKE
 * Added FCO changes for 1.5.1.1
 * 
 *    Rev 1.6   22 Apr 1994 14:23:30   LISA
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   03 Sep 1993 11:06:28   JOE
 * In cgoutline(), substitute proper "...quadto()" function in
 * "if_state.out" table.
 * Added function prototype for "bmras_quad_flat()".
 * 
 *    Rev 1.4   13 Apr 1993 13:19:16   JOE
 * In cgoutline(), conditionally compiled calls to psrender() and ttrender()
 * if !USE_JUMP_TABLES.
 * 
 *    Rev 1.3   12 Feb 1993 14:57:24   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   05 Jan 1993 14:23:58   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:24:48   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:28:40   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* outline.c */


/*---------------------------------------------------------------------
     09-11-90   bjg   Added quadratic outline support.
     12-01-90   awr   split off from maker.c. Removed unused parameters
                      from linear() and quadra().
     02-04-91   awr   Changed name des2wrkbm() to des2bm()
     02-04-91   tnc   In outline_metrics(), if compound character, store
                      "h_esc" as escapement instead of calculating it 
                      from bounding box.

                dET   In outline_metrics(), "is_compound" and "h_esc"
                      are part of structure "chr_def_hdr".
     03-06-91   jfd   In make_char_part(), corrected typeo in conditional
                      compile (#if QUADRA  was  #if QUADdRA)
                      In outline(), loaded "*phol" prior to calling
                      outline_metrics().
     03-10-91   awr   Corrected size calculations for outline memory
     19-May-91  awr   LOOP structure changed
      1-Jun-91  awr   HQ4 changes
      9-Jun-91  awr   added more output to print_outline_data()
                      changed chr_def_hdr structure
     17-Jun-91  jfd   Moved "debug.h" after "port.h".
                      Moved "profile.h" after "port.h".
                      Moved "cgconfig.h" before "port.h".
     29-Jun-91  awr   Removed d.tt- not needed.
     24-Aug-91  awr   Moved function decls to include file
      6-Sep-91  awr   Changed HEADERSIZE to OLHEADERSIZE
     10-Sep-91  jfd   Changed naming convention of outline functions.
     12-Oct-91  awr   Removed unused #include "bitmap.h"
     03-Apr-92  rs    Portability cleanup (see port.h).
     13-Apr-92  awr   In outline(), added braces inside "for" loop.
     21-May-92  jfd   In outline(), replaced direct outline function calls
                      with calls via the function table. Cast argument
                      for ras_start_char() to PVOID.
                      Added pointer to font function table "pras".
     27-May-92  jfd   In make_char_part(), when passing translations "xt" 
                      and "yt" to quadra() and cubic(), add additional
                      translation "if_state.xlate.x" and "if_state.xlate.y".
     29-May-92  jfd   Changed type "OLSTATS" to "CHAR_STATS" due to change 
                      in "ix.h".
      4 Jun 92  jfd   In outline(), if PS or TT, call "render()" with
                      zero translation.
      8-Jun-92  jfd   Replaced all references to "olstats" with
                     "if_state.cs".
      9-Jun-92  jfd   In outline(), call "render()" if requested character
                      is in PS or TT bucket (i.e., check "pbucket->fst_type"
                      rather than "format").
     23-Jun-92  jfd   In outline(), moved statement which copied "olout_tbl"
                      into "if_state.out" from beginning of routine to
                      two different places: after check for linear and
                      at end of routine.
     24-Jun-92  jfd   In make_char_part(), restore "if_state.tbound" 
                      before returning.
      6-Jul-92  jfd   In outline(), if generating a TT cubic outline,
                      substitute "olcubequadto()" function for "olquadto()".
     14-Jul-92  awr   Changed call to make_gaso().
     21-Jul-92  awr   Conditional compile changes.
     14-Sep-92  jfd   In outline(), moved braces outside of #if IF_RDR 
                      conditional compile.
     10-Oct-92  rs    Implement USE_JUMP_TABLES feature for overlays.
     15-Nov-92  rs    Port to Mac -> rename outline() to cgoutline().
     05-Jan-93  jfd   ANSI C function declaration changes.
     08-Feb-93  jfd   VXWorks support.
     13-Apr-93  jfd   In cgoutline(), conditionally compiled calls to 
                      psrender() and ttrender() if !USE_JUMP_TABLES.
     31-Aug-93  jfd   In cgoutline(), substitute proper "...quadto()"
                      function in if_state.out table.
                      Added function prototypes for "bmras_quad_flat()".
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  FCO Changes from 1.5.1.1:
     14-Mar-94  mby   If FCO is enabled, cgoutline() calls fco_render().
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     15-Nov-94  bjg   In outline(), added FCO support.
     11-Dec-94  mby   Replace "cs.origin" with "cs.origin_cs".
     12-Dec-94  dbk   Conditionally compiled prototype for bmras_quad_flat()
                      based on FCO_RDR.
                      In outline(), corrected typo in conditional compile
                      statement (FC_RDR is changed to FCO_RDR).
     02-Feb-95  mac   In make_char_part(), fixed computation of "half pixel"
                      sizes.
     24-Aug-95  mby   In cgoutline, last two args to ttrender() are nonzero if
                      the character's LSB != xmin. This caused the outline to
                      lie in the wrong position. Disabled USE_JUMP_TABLES.


-----------------------------------------------------------------------*/

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include "cgconfig.h"

#if OUTLINE     /* Entire module is conditionally compiled */

#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"
#include "cgif.h"
#include "q3.h"
#include "cache.h"
#include "ix.h"
#include "if_type.h"
#include "segments.h"

#ifdef LINT_ARGS
GLOBAL UW16      cgoutline(VOID);
MLOCAL UW16      make_char_part(UW16, PCHR_DEF);
EXTERN UW16      quadra(UW16, INTR, INTR);
EXTERN UW16      cubic(INTR, INTR);
EXTERN UW16      make_gaso(int,PCHR_DEF);
#if OLDATA
EXTERN UW16      olcubequadto(INTR, INTR, INTR, INTR);
#endif
#if ((DRAS_QUAD && IF_RDR) || TT_RDR || FCO_RDR)
EXTERN UW16   bmras_quad_flat(INTR, INTR, INTR, INTR);
#endif
#else
EXTERN UW16      quadra();
EXTERN UW16      cubic();
EXTERN UW16      make_gaso();
#if OLDATA
EXTERN UW16      olcubequadto();
#endif
#if ((DRAS_QUAD && IF_RDR) || TT_RDR || FCO_RDR)
EXTERN UW16   bmras_quad_flat();
#endif
#endif

EXTERN IF_STATE if_state;
EXTERN CHR_DEF_HDR chr_def_hdr;
EXTERN CHR_DEF chr_def[];


EXTERN OUT_TBL olout_tbl;
EXTERN OUT_TBL bmras_tbl;


#if IF_RDR
/*----------------------*/
/*   make_char_part     */
/*----------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  make_char_part(UW16 pn, PCHR_DEF cd)
#else
MLOCAL UW16
make_char_part(pn, cd)
    UW16 pn;
    PCHR_DEF cd;
#endif
{
    UW16    status;
    INTR    xt, yt;

    DBG("make_char_part()\n");

  /* Grid aligned scaled outline */

    status = make_gaso((int)pn, cd);
    if (status)
        return status;

  /*  Translate outline: 1. to postion this part within the whole
   *                     2. Position the whole so origin is at (0,0)
   */

    xt = (INTR)cd->bmorigin.x * (INTR)xpix - (INTR)if_state.cs.origin_cs.x;
    yt = (INTR)cd->bmorigin.y * (INTR)ypix - (INTR)if_state.cs.origin_cs.y;

    if_state.tbound.ll.x += xt;
    if_state.tbound.ll.y += yt - half_ypix;
    if_state.tbound.ur.x += xt;
    if_state.tbound.ur.y += yt - half_ypix;

    /*  Increase the fractional output pixel by powincr bits.  These values
     *  will be restored at the end of this function.  All coordinates
     *  will be multiplied by 2**powincr.
     */
    log_xpix   += powincr;
    log_ypix   += powincr;
    xpix      <<= powincr;
    ypix      <<= powincr;
    half_xpix = xpix >> 1;
    half_ypix = ypix >> 1;
    if_state.tbound.ll.x <<= powincr;
    if_state.tbound.ll.y <<= powincr;
    if_state.tbound.ur.x <<= powincr;
    if_state.tbound.ur.y <<= powincr;

  /* draw the character outline */

    switch(if_state.cs.format)
    {
#if LINEAR 
        case FC_LINEAR_TYPE:    /* quadra() also makes linear outlines */
#endif
#if QUADRA
        case FC_QUAD_TYPE:
#endif
#if (LINEAR || QUADRA)
                              status = quadra(if_state.cs.format, 
                                              xt + if_state.xlate.x, 
                                              yt + if_state.xlate.y);
                              break;
#endif
#if CUBIC
        case FC_CUBIC_TYPE:   status = cubic(xt + if_state.xlate.x,
                                             yt + if_state.xlate.y);
                              break;
#endif
        default:              status = ERRinvalid_outproc_type;
    }

    /*  Restore original fractional output pixel size  */
    log_xpix   -= powincr;
    log_ypix   -= powincr;
    xpix      >>= powincr;
    ypix      >>= powincr;
    half_xpix = xpix >> 1;
    half_ypix = ypix >> 1;
    if_state.tbound.ll.x >>= powincr;
    if_state.tbound.ll.y >>= powincr;
    if_state.tbound.ur.x >>= powincr;
    if_state.tbound.ur.y >>= powincr;

    if_state.tbound.ll.x -= xt;
    if_state.tbound.ll.y -= yt - half_ypix;
    if_state.tbound.ur.x -= xt;
    if_state.tbound.ur.y -= yt - half_ypix;

    return status;
}
#endif  /* IF_RDR  */

/*----------------------*/
/*      cgoutline       */
/*----------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  cgoutline()
#else
GLOBAL UW16
cgoutline()
#endif
{
#if IF_RDR
    UW16     status, pn;
    PCHR_DEF cd;
#endif

    DBG("\n\n\n\no u t l i n e()\n");

#if LINEAR 
  /* Substitute vectorizing functions for cubeto() and quadto() */
    if(if_state.cs.format == FC_LINEAR_TYPE)
    {
#if ((DRAS_QUAD && IF_RDR) || TT_RDR || FCO_RDR)

    /* 8-30-93 jfd
     *
     * Substitute correct 'quadto()' function.
     */
        if_state.out.quadto = bmras_quad_flat;
#endif
        if_state.out.cubeto = bmras_tbl.cubeto;
    }
#endif

#if (TT_RDR || FCO_RDR)
  /* Substitute TT cubequadto() function for cubeto() */
    if ((if_state.pbucket->fst_type == FC_TT_TYPE ||
         if_state.pbucket->fst_type == FC_FCO_TYPE) &&
        (if_state.cs.format == FC_CUBIC_TYPE))
    {
#if OLDATA
        if_state.out.quadto = olcubequadto;
#endif
    }
#endif /* TT_RDR || FCO_RDR */


#if (NON_IF_FONT)
  if (if_state.pbucket->fst_type == FC_PST1_TYPE ||
      if_state.pbucket->fst_type == FC_TT_TYPE ||
      if_state.pbucket->fst_type == FC_FCO_TYPE)

#if 0   /* Do not use this anymore because changed call to ttrender()! */
 /*#if USE_JUMP_TABLES
       return (*((PIF_FUNC_TBL)if_state.pbucket->pft)->render)
                 (if_state.pbucket, 0L, 0L);
   #else */
#endif

  {
   switch (if_state.pbucket->fst_type)
   {
#if PST1_RDR
      case FC_PST1_TYPE:
       return (psrender (if_state.pbucket, 0L, 0L));
       break;
#endif
#if TT_RDR
      case FC_TT_TYPE:
       return (ttrender (if_state.pbucket,
                -if_state.cs.origin_cs.x, -if_state.cs.origin_cs.y));
       break;     /* last two args can be nonzero! mby, 8-24-95 */
#endif
#if FCO_RDR
      case FC_FCO_TYPE:
       return (fco_render (if_state.pbucket, 0L, 0L));
       break;
#endif
      default:
         return (ERR_fst_type);
   }
  }
/* #endif  // USE_JUMP_TABLES */

    else
#endif  /* NON_IF_FONT */
    {
#if IF_RDR
        status = if_state.out.start_char((PVOID)&if_state.cs);
        if (status)
           return status;

        for(pn=0, cd=chr_def; pn<chr_def_hdr.num_parts; pn++, cd++)
        {
            status = make_char_part(pn, cd);
            if (status)
               return status;
        }
        return if_state.out.end_char();
#endif
    }
    return SUCCESS;
}
#endif  /* OUTLINE */
