/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/out/quadra.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: quadra.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.11   07 Apr 1995 09:17:34   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.10   02 Feb 1995 13:34:54   JOE
 * 
 * In ifrender(), fixed computation of "half pixel" sizes (by mac).
 * 
 *    Rev 1.9   22 Apr 1994 14:23:32   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.8   02 Feb 1994 08:40:24   JOE
 * Removed function prototype for "nxt_coord()".
 * 
 *    Rev 1.7   01 Jul 1993 14:20:28   MAIB
 * moved function ifrender() here
 * 
 *    Rev 1.6   09 May 1993 12:03:40   ROB
 * Move 'DRAS_QUAD' & 'COMPAT23' references to after include files.
 * 
 *    Rev 1.5   04 May 1993 16:43:46   ROB
 * add 'DRAS_QUAD' for direct rasterization of quadratic beziers.
 * 
 *    Rev 1.4   28 Apr 1993 09:54:34   ROB
 * Added 'iQUADRA' to satisfy ANSI C requirements if outlines not enabled.
 * 
 *    Rev 1.3   12 Feb 1993 14:53:18   JOE
 * 
 * VXWorks support
 * 
 *    Rev 1.2   05 Jan 1993 15:07:06   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:25:12   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 08:28:44   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
#define ROB_OPTIMIZATION 0 /* fast calling for lineto() */
/* quadra.c */


/*---------------------------------------------------------------------
    26-Jun-90  bjg Created to handle quadratic outlines.
    26-Oct-90  jfd Conditionally compiling routines quadra() and
                   compute_boundbox().
                   Including file "cgconfig.h".
    25-Jan-91  jfd In quadra(), check for "quality< 3" when checking
                   first_vertex_code and current_vertex_code
                   Removed unused parameters from quadra().
    04-Feb-91  dET Added external declaration for "quality"
    11-Feb-91  jfd Loop was not being closed if "first_vertex_code == 0 ||
                   "quality < 3"
    06-Mar-91  jfd Changed first_vertex_code and current_vertex_code
                   to BOOLEAN.
    10-Mar-91  awr changed to work with workbuffer. Added #include q3.h
    19-May-91  awr LOOP structure changed
	 06-Jun-91  jfd Moved cgconfig.h to top.
                   Added SUN support.
                   (FIXES FROM EARLIER VERSIONS)
    17-Jun-91 jfd  Moved "debug.h" after "port.h".
                   Moved "profile.h" after "port.h".
    16-Aug-91 awr  added quality level check
    24-Aug-91 awr  Moved function decls to include file
     7-Sep-91 awr  Added linear
     9-Sep-91 jfd  Including "outline.h".
    10-Sep-91 jfd  Changed naming convention of outline functions.
    03-Apr-92 rs   Portability cleanup (see port.h).
    21-May-92 jfd  In quadra(), changed argument lists for calls to 
                   olmoveto(), ollineto() and olquadto() so as to
                   match corresponding bitmap function calls.
                   Replaced all direct outline function calls with calls
                   via the function table.
                   Added pointer to font function table "pras".
    27-May-92 jfd  In quadra(), if doing linear outline, after call to
                   q3(), removed loop which called lineto() repeatedly.
    04-Aug-92 jfd  Performance enhancements - call lineto() through global
                   pointer instead of data structure function pointer.
    04-Aug-92 awr  Coded next_coord() in line.
    16-Aug-92 awr  Added mac's change to not increase resolution in 16
                   bit mode for lineto()
   21-Sep-92  jfd  Added EXTERN declaration for "ras".
                   Included BITMAP.H.
                   In quadra(), shift "ras.clip_fops_top" and 
                   "ras.clip_fops_bot" whenever xpix and ypix are shifted.
                   Also in quadra(), corrected typo "half_xpix = half_xpix =
                   ypix >> 1;" to half_xpix = half_ypix = ypix >> 1;".
   23-Oct-92  awr  Corrected outline output coordinate cals for INTR_SIZE 16
   05-Jan-93  jfd  ANSI C functifon declaration changes.
   08-Feb-93  jfd  VXWorks support.
   27-Apr-93  rs   Need to define something in file for ANSI C 'iQUADRA'.
   04-May-93  rs   Utilize 'DRAS_QUAD' for direct rasterization of quadratic
                   bezier curves (if enabled, set COMPAT23 == 0).
   08-May-93  rs   Move 'DRAS_QUAD' to after include files.
   01-Jul-93 maib  Moved ifrender() from raster.c to here, added non-lint
		   function declarations
   26-Jan-94  jfd  Removed function prototype for "nxt_coord()" because
                   it is obsolete.
   02-Feb-95  mac  In ifrender(), fixed computation of "half pixel" sizes.
---------------------------------------------------------------------*/

#include "cgconfig.h"  /* 10-29-90 jfd */

#if IF_RDR && (CGBITMAP || LINEAR || QUADRA) /* module conditionally compiled */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#include "port.h"
#include "debug.h"
#include "profile.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "cgif.h"
#include "ix.h"
#include "if_type.h"
#include "q3.h"
#include "bitmap.h"


#if DRAS_QUAD
#define COMPAT23    0 /* direct rasterization of bezier curves */
#else
#define COMPAT23    1 /* subdivide bezier curves into line segments */
#endif




#ifdef  LINT_ARGS
GLOBAL UW16 quadra(UW16, INTR, INTR);
#else
GLOBAL UW16 quadra();
#endif

EXTERN IF_STATE if_state;


#if ROB_OPTIMIZATION
#ifdef LINT_ARGS
EXTERN UW16 (*lineto) (INTR, INTR);
#else
EXTERN UW16 (*lineto) ();
#endif
#endif /* ROB_OPTIMIZATION */


EXTERN RASTER ras;


#if IF_RDR
/*-------------------*/
/*     ifrender      */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  ifrender(PBUCKET pb, INTR xt, INTR yt)
#else
GLOBAL UW16
ifrender(pb, xt, yt)
    PBUCKET pb;
    INTR xt, yt;
#endif
{
    UW16         status;

    DBG("\n\n\n\nifrender()\n\n");

    /*  Increase the fractional output pixel by powincr bits.  These values
     *  will be restored at the end of this function.  All coordinates
     *  will be multiplied by 2**powincr.
     */
    log_xpix   += powincr;
    log_ypix   += powincr;
    xpix      <<= powincr;
    ypix      <<= powincr;
    half_xpix = xpix >> 1;
    half_ypix = ypix >> 1;
    if_state.tbound.ll.x <<= powincr;
    if_state.tbound.ll.y <<= powincr;
    if_state.tbound.ur.x <<= powincr;
    if_state.tbound.ur.y <<= powincr;

    status = if_state.out.start_char((PVOID)&if_state.cs);  /* 6-8-92 */
    if (status)
      goto done;

    status = quadra(if_state.cs.format, xt, yt);
    if (status)
      goto done;

    status = if_state.out.end_char ();

done:
    /*  Restore original fractional output pixel size  */
    log_xpix   -= powincr;
    log_ypix   -= powincr;
    xpix      >>= powincr;
    ypix      >>= powincr;
    half_xpix = xpix >> 1;
    half_ypix = ypix >> 1;
    if_state.tbound.ll.x >>= powincr;
    if_state.tbound.ll.y >>= powincr;
    if_state.tbound.ur.x >>= powincr;
    if_state.tbound.ur.y >>= powincr;

    return status;
}
#endif  /* IF_RDR */

/*-------------------*/
/*  quadra           */
/*-------------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  quadra(UW16 format, INTR xtranslate, INTR ytranslate)
#else
GLOBAL UW16
quadra(format, xtranslate, ytranslate)
    UW16 format;
    INTR  xtranslate, ytranslate;
#endif
{
    UW16         status;
    LOOP          loop;     /* current loop */
    UW16         loopct;
    LPSB8         v;           /* vertex code array */
    BOOLEAN       current_vertex_code; /* current point is start of bi-arc */
    INTRVECTOR    START, CONTACT, END;
    PSW16VECTOR   wb;
    int           num_left;
    SW16          xt, yt;
#if QUADRA || !COMPAT23
    INTRVECTOR    control0, control1;
#endif
#if INTR_SIZE == 16
    int           linear_on = 1;
#endif

    DBG("\n\n\n\nQ U A D R A ( )\n\n");
    DBG1("number of loops = %d\n", if_state.num_loops);

    xt = (SW16)xtranslate;
    yt = (SW16)ytranslate;

    first_loop();

    for(loopct = 0; loopct < if_state.num_loops; loopct++)
    {
        DBG("\n\n\nN e x t    L o o p\n");
        next_loop(&loop);
        wb = loop.cv;                        /* coordinate points */
        v  = loop.v;                         /* vertex codes */
        num_left = (int)loop.ncoords;        /* num coordinate points */
        current_vertex_code = FALSE;         /* set for quality < 3  */

        DBG1("ncoords %d\n", num_left);

        if_state.out.start_loop(loop.polarity);

        END.x = xcrd(wb->x);
        END.y = ycrd(wb->y);
        wb++;
        num_left--;

        status = if_state.out.moveto(END.x, END.y);
        if (status)
           return status;

        while(num_left >= 0)
        {
            if(if_state.quality == 3)
            {
                DBG1("vertex code  %d\n", *v);
                current_vertex_code = V_CONTACT(*v++);
            }
            if(!current_vertex_code)
            {
#if INTR_SIZE == 16
                if(linear_on && (format == FC_BITMAP_TYPE))
                {
                    if_state.p0.x >>= 1;
                    if_state.p0.y >>= 1;
                    log_xpix = log_ypix = log_ypix - 1;
                    xpix = ypix = ypix >> 1;
                    half_xpix = half_ypix = ypix >> 1;
#if TILE
                    ras.clip_fops_bot >>= 1;
                    ras.clip_fops_top >>= 1;
#endif
                    linear_on = 0;
                }
                if (format == FC_BITMAP_TYPE)
                {
                   END.x = wb->x + xt;
                   END.y = wb->y + yt;
                }
                else
                {
                   END.x = xcrd(wb->x);
                   END.y = ycrd(wb->y);
                }
#else  /* 32 */
                END.x = xcrd(wb->x);
                END.y = ycrd(wb->y);
#endif
                wb++;
                num_left--;

#if ROB_OPTIMIZATION
                status = ((*lineto) (END.x, END.y));
#else
                status = if_state.out.lineto(END.x, END.y);
#endif
                if (status)
                   return status;
            }
            else
            {
#if INTR_SIZE == 16
                if(!linear_on)
                {
                    if_state.p0.x <<= 1;
                    if_state.p0.y <<= 1;
                    END.x <<=1;
                    END.y <<=1;
                    log_xpix = log_ypix = log_ypix + 1;
                    xpix = ypix = ypix << 1;
                    half_xpix = half_ypix = ypix >> 1;
#if TILE
                    ras.clip_fops_bot <<= 1;
                    ras.clip_fops_top <<= 1;
#endif
                    linear_on = 1;
                }
#endif
                START   = END;
                CONTACT.x = xcrd(wb->x);
                CONTACT.y = ycrd(wb->y);
                wb++;
                num_left--;

                END.x = xcrd(wb->x);
                END.y = ycrd(wb->y);
                wb++;
                num_left--;
#if COMPAT23
                if(format != FC_QUAD_TYPE)
                {
                    status = q3(START, CONTACT, END);
                    if(status)
                        return status;
                    continue;
                }
#endif
#if !COMPAT23 || QUADRA
                control_points(START, CONTACT, END, &control0, &control1);
                status = if_state.out.quadto(control0.x, control0.y,
                                              CONTACT.x, CONTACT.y);
                if (status)
                   return status;
                status = if_state.out.quadto(control1.x, control1.y,
                                              END.x, END.y);
                if (status)
                   return status;
#endif
            }
        }  /* end of loop */
#if INTR_SIZE == 16
        if(!linear_on)
        {
            log_xpix = log_ypix = log_ypix + 1;
            xpix = ypix = ypix << 1;
            half_xpix = half_ypix = ypix >> 1;
#if TILE
            ras.clip_fops_bot <<= 1;
            ras.clip_fops_top <<= 1;
#endif
            linear_on = 1;
        }
#endif
        if_state.out.end_loop();
    } /* end of character */
    return SUCCESS;
}
#else /* need to define something in file for ANSI C */
int iQUADRA = 0;
#endif /* IF_RDR && (CGBITMAP || LINEAR || QUADRA) */
