/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/pcl/pcldospr.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pcldospr.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   07 Apr 1995 09:26:22   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 14:24:58   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.6   08 Dec 1993 19:01:14   ROB
 * General cleanup for MSDOS, FLAT & OS2.
 * 
 *    Rev 1.5   15 Jun 1993 10:43:20   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.4   12 May 1993 15:59:46   ROB
 * Clean up compiler warnings, change #if to #if defined for DOS & _WINDOWS.
 * 
 *    Rev 1.3   12 Feb 1993 15:05:14   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   05 Jan 1993 16:26:36   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:12:26   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:51:48   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pcldospr.c */
/* PCLeo msDOS PRinter routines */

/*
 *
 *
 * History:
 *
 *  22 Jan 92  ss   Original. Printer specific routines were extracted from
 *                  pcleo.c
 *                  Changed names of routines to make interface more general.
 *                  New routine printer_avail().
 *  25-Jun-92  jfd  Moved "cgconfig.h" before "port.h".
 *  17-Sep-92  jfd  Changed conditional compile for entire module to include
 *                  IF_RDR.
 *  05-Jan-93  jfd  ANSI C function declaration changes.
 *  08-Feb-93  jfd  VXWorks support.
 *  12-May-93  rs   Change from '#if MSDOS' to '#if defined MSDOS'.
 *                  Change from '#if _WINDOWS' to '#if defined _WINDOWS'.
 *  15-Jun-93  jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
 *  08-Dec-93  rs   General cleanup - MSDOS & OS2.
 */

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h" 

#if PCLEO && IF_RDR && (defined (MSDOS) || defined (__OS2__) || defined (_WINDOWS))

#include <dos.h>
#ifndef SIMULATE
#include <bios.h>
#endif
#include <stdlib.h>
#include <io.h>

#include <stdio.h>
#include <fcntl.h>

#include <sys\types.h>
#include <sys\stat.h>

#include "ifmem.h" 
#include "cgif.h"



#ifdef LINT_ARGS
GLOBAL VOID   Delay(SW16);
GLOBAL VOID   init_printer(int);
GLOBAL VOID   reset_printer(int);
GLOBAL UW16   printer_status(unsigned);
GLOBAL UW16   printer_avail(unsigned);

#else    /*  not LINT_ARGS  */

GLOBAL VOID   Delay();
GLOBAL VOID   init_printer();
GLOBAL VOID   reset_printer();
GLOBAL UW16   printer_status();
GLOBAL UW16   printer_avail();

#endif  /* LINT_ARGS */



/*--------------------*/
/*   Delay()          */
/*--------------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  Delay(SW16 n)
#else
GLOBAL VOID
Delay(n)
    SW16 n;
#endif
{
/*  This is MS-DOS specific, please substitute an appropriate routine.
 *  On a fast system (25MHz 486) two ticks are necessary.
 *  dET - Windows Delay is supported.
 */

#ifndef SIMULATE
#ifdef _WINDOWS
    unsigned long start, finish;

    UL32 far pascal GetCurrentTime(void);

    start = GetCurrentTime() + (UL32)(55 * n);
    while(1)
    {
       finish = GetCurrentTime();
       if(finish > start)
          break;
    }

#else
    SL32 start, finish;

    _bios_timeofday(_TIME_GETCLOCK, &start);

    start += n;  /* two ticks is a very long time but ... */

    while(1)
    {
       _bios_timeofday(_TIME_GETCLOCK, &finish);
       if(finish > start)
          break;
    }
#endif
#endif
}

#ifdef _WINDOWS    /* routines not needed (or wanted) in windows  */
    /* make dummy routines to preserve interface      -ss 6/22/92 */

/*----------------*/
/*  init_printer  */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL VOID  init_printer(int fp)
#else
GLOBAL VOID
init_printer(fp)
    int fp;
#endif
{
}

#if defined (ANSI_DEFS)
GLOBAL VOID  reset_printer(int fp)
#else
GLOBAL VOID
reset_printer(fp)
    int fp;
#endif
{
}
#else
/*----------------*/
/*  init_printer  */
/*----------------*/
/*
 *    set the printer to binary mode
 *    Formerly named set_ioctl().             -ss 6/22/92 
 */
#if defined (ANSI_DEFS)
GLOBAL VOID  init_printer(int fp)
#else
GLOBAL VOID
init_printer(fp)
    int fp;
#endif
{
#ifndef SIMULATE
    union REGS r;

    r.x.ax = 0x4400;
    r.x.bx = (unsigned)(fp);
    intdos(&r, &r);
    if (r.h.dl & 0x20)               /* already in binary mode? */
        return;                      /* yes - do nothing        */
    r.x.ax = 0x4401;
    r.x.bx = (unsigned)(fp);
    r.x.dx = 0x0020;
    intdos(&r, &r);
#endif
}



/*--------------------*/
/*   reset_printer    */
/*--------------------*/
/*
 *    reset the printer mode
 *    Formerly named reset_ioctl().           -ss 1/22/92 
 */
#if defined (ANSI_DEFS)
GLOBAL VOID  reset_printer(int fp)
#else
GLOBAL VOID
reset_printer(fp)
    int fp;
#endif
{
#ifndef SIMULATE
    union REGS r;

    r.x.ax = 0x4400;
    r.x.bx = (unsigned)(fp);
    intdos(&r, &r);
    r.h.dh = 0x0;
    r.h.dl &= 0xdf;                   /* clear binary bit without */
    r.x.ax = 0x4401;                  /* changing others          */
    r.x.bx = (unsigned)(fp);
    intdos(&r, &r);
#endif
}  /* end - reset_printer */

#endif  /* !MSWINDOWS */


/*--------------------*/
/*    printer_status  */
/*--------------------*/
/*  
 *    Check the parallel printer status.  If it is on line,
 *    and ready to go, return 0. 
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  printer_status(unsigned port_num)
#else
GLOBAL UW16
printer_status( port_num )
   unsigned port_num;
#endif
{
#define PR_TIMEOUT   0x0001
#define PR_IO_ERROR  0x0008
#define PR_SELECTED  0x0010
#define PR_PAPER_OUT 0x0020
#define PR_ACK       0x0040
#define PR_NOT_BUSY  0x0080

#ifndef SIMULATE
#ifndef _WINDOWS     /* 08-10-90  jfd  No support for downloading yet! */
    UW16 status;

    status = _bios_printer(_PRINTER_STATUS, port_num, 0);
    if ((status & PR_SELECTED) && (status & PR_NOT_BUSY)
                       && !(status & PR_TIMEOUT) && !(status & PR_IO_ERROR) 
                       && !(status & PR_PAPER_OUT))
        return SUCCESS;

    else
#endif
#endif
        return FAILURE;
}


/*--------------------*/
/*    printer_avail   */
/*--------------------*/
/* test for printer available: online/selected */

#if defined (ANSI_DEFS)
GLOBAL UW16  printer_avail(unsigned port_num)
#else
GLOBAL UW16
printer_avail( port_num )
   unsigned port_num;
#endif
{
   int status;

#ifndef SIMULATE
   status = _bios_printer(_PRINTER_STATUS, port_num, 0);
   if ((status & 0x0008)                 /* if IO error */
          || !(status & 0x0010))        /* or NOT printer selected */
      return ERRopen_printer;           /* error */
#endif
   return SUCCESS;

}  /* end - printer_avail */

#endif /* PCLEO && IF_RDR */
