/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/pcl/pcleo.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pcleo.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.10   07 Apr 1995 09:26:44   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.9   22 Apr 1994 15:48:10   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * Conditionally compiled include statement for <fcntl.h> based on
 * ((!_AM29K) || (_AM29K && !UNIX)).
 * 
 *    Rev 1.8   22 Apr 1994 14:26:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   09 Feb 1994 13:08:06   JOE
 * 
 * _AM29K changes.
 * 
 *    Rev 1.6   08 Dec 1993 19:00:06   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.5   15 Jun 1993 10:44:54   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.4   09 Jun 1993 16:40:32   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.3   12 Feb 1993 15:02:42   JOE
 * VXWorks suupport.
 * 
 *    Rev 1.2   05 Jan 1993 16:41:56   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:11:54   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:51:52   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pcleo.c */
/*
 *
 *
 * History:
 *
 *    xx-Apr-90 awr  Created using HP's March 1990 Marie as a guide and
 *                   incorporating much of Intellimetrics' downld.c from
 *                   Type Director for printer I/O.
 *    05-May-90 awr  moved char_buf into IF_CHAR structure
 *    10-Aug-90 jfd  Windowized the following IO calls:
 *                      fopen / OpenFile
 *                      close / _lclose
 *                      fwrite/ _lwrite
 *                      sscanf/ atoi,...
 *                   and as a result, declared "fout" conditionally
 *                   (WORD if running WINDOWS, FILE* if running DOS)
 *
 *                   Currently there is no support for downloading to
 *                   a printer under WINDOWS.
 *
 *                   Additional restrictions:
 *                      _bios_printer() is not allowed #if MSWINDOWS
 *                      sscanf() is not alloced #if WINDLL
 *    15-Aug-90 awr  Free BUCKET at end of PCLEOheader() because we
 *                   trashed it by swapping bytes.
 *    04-Oct-90 jfd  Corrected differences in hpCopyrightStatement:
 *                       a.) Changed year - 1990 from 1988
 *                       b.) Added one space after "All Rights Reserved."
 *                       c.) Changed "(C)" to "(c)"
 *
 *                   Corrected differences in HP font header structure
 *                   in routine PCLheader():
 *                       a.) ".quality" : storing 0 instead of 2;
 *                       b.) ".textWidth" : storing value of Fixed space 
 *                                          relative width for EN space;
 *                       c.) ".firstCode" : storing value of ss_first_code
 *                       d.) ".fontName" : padding with NULLS instead of
 *                                         spaces;
 *                       e.) ".fontNumber" : Calculating differently by using
 *                                           vendor ID rather than hard-wiring
 *                                           "C". This difference occurred
 *                                           while processing a proofer font!
 *
 *                    Performing the necessary SWAPs on data which we are
 *                    now storing (described above);
 *
 *                    In PCLheader(), check if Global Intellifont Data
 *                    exists before writing it out. (Proofer font I
 *                    tested did not have any.)
 *
 *                    Changed "sscanf" format list so that "class_index"
 *                    would get loaded with a value from the font alias table
 *                    (for DOS version);
 * 
 *                    For DINGBATS, MARIE's pcleo was roughly twice the
 *                    size of WINDOWS pcleo due to the fact that in routine
 *                    simple_character(), if call to FMrd_char() returns
 *                    an error, we stop writing the pcleo. In routine
 *                    simple_character(), check for thin, en or em space
 *                    while processing.
 *
 *    30-Nov-90 dET   Added code for routine Delay(), which had been a
 *                    dummy routine previouly. In addition, when calling
 *                    Delay(), pass an argument of "2".
 *
 *    14-Jan-91 jfd   Replaced "//" comments.
 *
 *    22-Jan-91 jfd   Declare "symbol_set" conditionally based on ROM.
 *    23-Jan-91 jfd   Increased value of MAXCHR_DEF from 300 to 400.
 *
 *                    In build_char_lists(), when calling IXsetup_chr_def(),
 *                    use "chId + ss_first_code" instead of "cgnum" as first
 *                    argument.
 *
 *    29-Jan-91 jfd   Added cgconfig.h.
 *    30-Jan-91 dET   Modify for MSC multi-model compilation.  Add WINDOWS
 *                    Delay() support. Changed redundant #ifdef's for
 *                    MSWINDOWS to _WINDOWS
 *    15-Feb-91  awr  changed IXfind_bucket() name to BUCKfind()
 *    23-Feb-91  awr  Changed bucket sub-segment handles to offsets.
 *    05-Mar-91  jfd  In structure HPFH, field "UWORD typeface" has been
 *                    changed to "UBYTE lsb_typeface" and "UBYTE msb_typeface".
 *                    As a result, the following changes were made in routine
 *                    PCLheader():
 *                    1.) Define macros PACK, UNPACK_LSB and UNPACK_MSB.
 *                    2.) Change line which saves "hpfat.family".
 *                    3.) Change line which calculates "vendorID".
 *                    4.) Change DBG1 statement.
 *                    Changed copyright statement at top.
 *
 *    06-Jun-91  jfd  Added SUN support
 *                    (FIX FROM EARLIER VERSION)
 *     9-Jun-91  awr  changed chr_def_hdr structure
 *    19 Jun 91  ss   Changed cd->bucknum to cd->buck_search_lvl in 
 *                     build_char_lists().
 *     1 Jul 91  ss   Added prototype for fgseg().
 *    31-Jul-91  jfd  Conditionally compile if PCLEO
 *    27-Aug-91  jfd  In compound_character(), rewrote the way checksum
 *                    was stored to resolve a compiler warning.
 *    23-Sep-91  jfd  In open_out(), conditionally declared "status" and
 *                    "port_status" to get rid of compiler warnings.
 *                    In printer_status(), conditionally declared "status"
 *                    to get rid of compiler warning.
 *    27-Sep-91  jfd  In open_out(), calling _fstrstr() instead of strstr
 *                    under WINDOWS for model independence.
 *    30-Sep-91  jfd  Added typedef for PSYMLIST.
 *                    In open_out(), added pmode arg "S_IREAD | S_IWRITE".
 *                    Changed "qsort" to "QSORT".
 *    28-Oct-91  jfd  In add_part(), changed "ss" from "SS_ENTRY *" to
 *                    PSS_ENTRY to get rid of compiler warning when
 *                    building medium model.
 *    24-Feb-92  jfd  In PCLheader(), changed all occurrences of "bucket->"
 *                    to "bucket->p.in." due to change to BUCKET structure.
 *    03-Apr-92  rs   Portability cleanup (see port.h).
 *    17-Jun-92  jfd  Due to status being returned by IXsetup_chr_def()
 *                    for fixed space characters (ERR_fixed_space), in
 *                    build_char_lists() process ERR_fixed_space status 
 *                    first before returning on any other error.
 *    24 Jun 92  ss   Moved printer specific functions to separate module.
 *                    For MSDOS the new module is pcldospr.c.
 *                    ** Currently only directly download to printer in DOS **
 *                    To support other printers/systems, the routines:
 *                    init_printer(), reset_printer(), printer_status(),
 *                    printer_avail() and Delay() should be provided in a
 *                    separate module and linked in place of pcldospr.c.
 *    05-Aug-92  jfd  Replaced calls to "clear_mem()" with MEMSET for
 *                    optimization.
 *     7 Aug 92  ss   Added test in PCLheader() to return error if trying
 *                    to use slim fonts to create a pcleo - not allowed.
 *                    In PCLeo(), make sure to close output file before
 *                    returning error.
 *    17-Sep-92  jfd  Changed conditional compile for entire module to include
 *                    IF_RDR.
 *    25-Sep-92  jfd  Replaced CGSPARC.H with CGMACROS.H.
 *    28-Sep-92  awr  Changed parameters of BUCKfind()
 *    30-Sep-92  jfd  Removed conditional compiles based on SPARC and
 *                    replaced with conditional compiles based on
 *                    (NAT_ALIGN == 4 && BYTEORDER == HILO) wherever possible.
 *    14-Oct-92  mby  Modify code to conform to new SYMBOLSET structure.
 *    05-Jan-93  jfd  ANSI C function declaration changes.
 *    08-Feb-93  jfd  VXWorks support.
 *                    Change all WRITE's to WRITEF's due to conflict with
 *                    VXWorks.
 *    09-Jun-93  jfd  Changed all references to "char" to "SB8" for transport-
 *                    ability.
 *    15-Jun-93  jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
 *    08-Dec-93  rs   General cleanup - MSDOS & OS2.
 *    09-Feb-94  jfd  Including "hif.h" if _AM29K.
 *    22-Apr-94  jfd  Changed conditional compile statement prior to
 *                    including <hif.h> to #if (_AM29K && !UNIX) to
 *                    resolve UNIX Metaware compiler error.
 *                    Conditionally compiled include statement for <fcntl.h>
 *                    based on ((!_AM29K) || (_AM29K && !UNIX)).
 */

#define MARIETEST 1   /*  Set to 1 to sort "extra" symbol codes so as to
                       *  to create pcleos identical to Marie's. Set to
                       *  0 for production version.
                       */
#ifdef _WINDOWS      /* remember to use include files from WIN 3 SDK */
#define _MT
#define _DLL
#endif

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"/* moved to top to get UNIX defines before system includes */

#if PCLEO && IF_RDR

#include <stdio.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>
#endif

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined (MSDOS) || defined (__OS2__)
#include <stdlib.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#else  /* !MSDOS && !OS2 */

#include "cgmacros.h"

#include <sys/types.h>
#include <sys/stat.h>
#endif  /*  MSDOS || OS2 */

#include <string.h>
#include <ctype.h>

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "segments.h"
#include "pcleo.h"
#include "cgif.h"
#include "ix.h"
#include "if_type.h"
#include "sym.h"

/* Printer name key word.  Since LPT is the DOS convention, could change */
/* to something else for other systems.                      -ss 1/22/92 */
#define PR_NAME_KEY  "LPT"

#if defined(MSC)  /* this is here because near/far scanf argument */
#if (defined(M_I86SM) || defined(M_I86MM) || defined (M_I86TM))
#define _WINDLL 1
#endif
#endif


#if BYTEORDER == LOHI
#define SWAP  tmp.w = *(UW16*)p;  *p++ = tmp.b.b1; *p++ = tmp.b.b0;
#define PSWAP tmp.w = *(LPUW16)pp; *pp++ = tmp.b.b1; *pp++ = tmp.b.b0;
#else
/* don't swap in this case, just bump pointer to keep up w/code -ss 10/24/91 */
#define SWAP   p += 2;
#define PSWAP pp += 2;
#endif

#define PAD   if((UB8)p&1) p++;
#define PPAD  if((UB8)pp&1) pp++;

#define PACK(lsb, msb, val)      val = ((UW16)msb << 8) + lsb; /* 02-20-91 jfd */
#define UNPACK_LSB(val, lsb)     lsb = (UB8)(val % 256);      /* 02-20-91 jfd */
#define UNPACK_MSB(val, msb)     msb = (UB8)(val >> 8);       /* 02-20-91 jfd */

#ifdef _WINDOWS                          /* 08-10-90  jfd */

typedef struct tagOFSTRUCT
  {
    SB8    cBytes;
    SB8    fFixedDisk;
    SW16    nErrCode;
    SB8    reserved[4];
    SB8    szPathName[128];
  } OFSTRUCT;

typedef OFSTRUCT far   *LPOFSTRUCT;

#define OF_CREATE	          0x1000  /* Flags for OpenFile */
#define OF_SHARE_COMPAT     0x0000

typedef SB8 far	    *LPSTR;
int         far pascal _lclose( int );
SW16        far pascal _lwrite( int, LPSTR, int );
int  far pascal OpenFile(SB8 far *, LPOFSTRUCT, int);

MLOCAL  OFSTRUCT ofFile;
#endif

/* Symbol list */

typedef struct
{
    UW16 symCode;      /* Symbol set code                         */
    UW16 num_parts;    /* 0 for simple char, >0 for compound char */
    UW16 icd;          /* index into chr_def[]                    */
}  SYMLIST;
typedef SYMLIST FARPTR * PSYMLIST;  /* 09-30-91 jfd */



#ifdef LINT_ARGS

/* ix.c */
EXTERN  UW16 BUCKfind(int, int, PPBUCKET);
EXTERN  UW16 IXsetup_chr_def(UW16, PCHR_DEF, PPBUCKET);
EXTERN  VOID  BUCKfree(HBUCKET);
/* fm.c  */
EXTERN LPSB8  fgseg(PBUCKET);
/* maker.c */
EXTERN UW16  DArd_char(PCHR_DEF);

GLOBAL UW16  PCLeo(LPSB8, LPUL32, SL32);

MLOCAL UB8  check_sum(LPUB8, UL32);

#if defined (MSDOS) || defined (__OS2__)
EXTERN VOID   Delay(SW16);
EXTERN VOID   init_printer(int);
EXTERN VOID   reset_printer(int);
EXTERN UW16   printer_status(unsigned);
EXTERN UW16   printer_avail(unsigned);
#endif  /* MSDOS || OS2 */

MLOCAL UW16   open_out(LPSB8);
MLOCAL VOID   close_out(VOID);
MLOCAL UW16   out(LPUB8, UW16);
MLOCAL UW16   out_byte(UB8);
MLOCAL LPUB8  myitoa(LPUB8, UW16);
MLOCAL UW16   esc_out(UW16, SW16);
MLOCAL UW16   PCLheader(SL32);
MLOCAL LPUB8  skeletal(LPUB8);
MLOCAL UW16   simple_character(SYMLIST *);
MLOCAL UW16   compound_character(SYMLIST *);
MLOCAL UW16   PCLchars(VOID);
MLOCAL UW16   add_part(PCHR_DEF, UW16);
MLOCAL UW16   build_char_lists(VOID);

MLOCAL SW16   fatoi(LPSB8);

#if MARIETEST
#ifdef _WINDOWS
MLOCAL SW16 _cdecl test_compare(PSYMLIST, PSYMLIST);
EXTERN VOID far pascal _fqsort(LPSB8, UW16, UW16,
  SW16(*)(PSYMLIST, PSYMLIST));
#else
MLOCAL SW16 test_compare(PSYMLIST, PSYMLIST);
EXTERN VOID _fqsort(LPSB8, UW16, UW16, SW16(*)(PSYMLIST, PSYMLIST));
#endif
#endif /* MARIETEST */

#else    /*  not LINT_ARGS  */

MLOCAL SW16 fatoi();

/* ix.c */
EXTERN  UW16 BUCKfind();
EXTERN  UW16 IXsetup_chr_def();
EXTERN  VOID  BUCKfree();
/* fm.c  */
EXTERN LPSB8  fgseg();
/* maker.c */
/* fm.c */
EXTERN UW16   DArd_char();

#endif  /* LINT_ARGS */

/* Symbol sets */

EXTERN SYMBOLSET symbolset;


#if ROM  /* 01-22-91 jfd */
EXTERN SS_ENTRY      *symbol_set;         /* current symbol set            */
#else
EXTERN SS_ENTRY      symbol_set[];        /* current symbol set            */
#endif

               /* changed to int to match use in system calls -ss 6/22/92  */
MLOCAL int    fout;           /* Handle for write IO calls                 */

                           /* make port_num type same as usage -ss 6/22/92 */
MLOCAL unsigned port_num;     /* printer port number                       */
MLOCAL BOOLEAN  printer_out;  /* TRUE if printer output                    */
MLOCAL BOOLEAN  parallel_out; /* TRUE if parallel printer output           */
MLOCAL UL32    pcleo_count;


#define MAXSYMLIST 300
MLOCAL SYMLIST     symlist[MAXSYMLIST];
#define EXTRABASE  256
MLOCAL SYMLIST    *symExt;
MLOCAL UW16       numSymCodes;
MLOCAL UW16       numExtraSymCodes;

/* character setup info */

#define MAXCHR_DEF 400
MLOCAL  CHR_DEF    chr_def[MAXCHR_DEF];
MLOCAL  UW16      num_chr_defs;

/* Compound Character Data */

/* Character specific data (# parts, escape, is_compound, etc.) */
EXTERN CHR_DEF_HDR chr_def_hdr;

EXTERN IF_STATE if_state;
/*
SB8 hpCopyrightStatement[] = "(C) Copyright Hewlett-Packard Company, 1988. \
 All rights reserved. Reproduction, adaptation or distribution of copies\
 of this font is prohibited, except as allowed under the copyright laws.";
*/
SB8 hpCopyrightStatement[] = "(c) Copyright Hewlett-Packard Company, 1990. \
 All rights reserved.  Reproduction, adaptation or distribution of copies\
 of this font is prohibited, except as allowed under the copyright laws.";

MLOCAL HPFH  hpfh;    /* HP font header */
MLOCAL HPEFH hpefh;   /* HP Extended font header */
MLOCAL HPFAT hpfat;   /* HP Font Alias Table */

/*
  This file contains the definition of the HP/PCL font alias segment
  as an offset into the 100 byte structure
  (added by jfd 08-10-90 because sscanf() is not allowed if DLL)
 */

#define FATYPEABBREV	(0)	/* two character typeface abbrev (char)	*/
#define FATREATMENT	(3)	/* one character treatment code	(char)	*/
				/* fixed / prop			(char)	*/
#define FAFIXPITCH   (5)   /* 07-19-90 jfd */
#define FAPCLWIDTH	(7)	/* width type + 5		(int)	*/
				/* reserved			(int)	*/
#define FASTRUCTURE	(12)	/* style structure		(int)	*/
#define FAWIDTH		(15)	/* style width			(int)	*/
#define FAPOSTURE	(17)	/* style posture		(int)	*/
#define FAWEIGHT	(19)	/* weight + 8			(int)	*/
#define FATYPEFAMILY	(22)	/* typeface family		(int)	*/
#define FASERIF		(28)	/* serif style			(int)	*/
#define FASIMPLESERIF	(31)	/* simple serif flag		(int)	*/
#define FACOMPRESSFLG	(33)	/* compressed flag		(int)	*/
#define FASHORTNAME	(35)	/* short typeface name		(char)	*/
#define FASHORTNAMESIZE	(16)
#define FACGNUMBER	(52)	/* CG typeface number		(long)	*/
#define FACLASSINDEX	(59)	/* family class index		(int)	*/

#define FONTALIASNAME "HP                  "

/*  PCLEO Compound Character Template- Each PCLEO compound character is
 *  constructed here.
 */
typedef struct
{
    UW16 symCode;
    SW16  xoffset;
    SW16  yoffset;
} CCPART;

typedef struct
{
  /* character header */

    UB8 h0;    /* 10 */
    UB8 h1;    /*  0 */
    UB8 h2;    /*  2 */
    UB8 h3;    /*  4 */

    SW16 escapement;
    UB8 num_parts;
    UB8 pad0;

    CCPART ccpart[MAX_CC_PARTS];

    UB8 pad1;
    UB8 check;
} CC;

MLOCAL CC cc;

/* typeface vendors.  This comes from MARIE, file wt-pcl.c
   (10-09-90 jfd)
*/
SB8 vendorInitial[ ] = {' ',' ','C',' ','B'};


/*                Data                                           */
/*---------------------------------------------------------------*/
/*                I/O and Miscellaneous                          */

#if 0
MLOCAL VOID
fontId (p, n)
    FILE *p;
    SW16  n;
{
    fprintf (p, "\033*c%dD", n);
}

MLOCAL VOID
fontControl (p, n)
    FILE *p;
    SW16  n;
{
    fprintf (p, "\033*c%dF", n);
}
#endif



/*----------------*/
/*  check_sum     */
/*----------------*/
/*  Return the (UB8) checksum of a memory block */
#if defined (ANSI_DEFS)
MLOCAL UB8   check_sum(LPUB8 memptr, UL32 size)
#else
MLOCAL UB8
check_sum(memptr, size)
    LPUB8  memptr;
    UL32   size;
#endif
{
    UB8 check;

    check = 0;
    while(size--)
        check += *memptr++;
    return check;
}



/*----------------*/
/*  open_out      */
/*----------------*/
/* dET - 30-Jan-91
 *
 * If using MSC with compiler options other than LARGE then there exists a
 * problem of passing a far pointer to filename to routine (OPEN) that
 * expects a near pointer.  So, we copy far pointer to near pointer.
 */
#if defined (ANSI_DEFS)
MLOCAL UW16  open_out(LPSB8 ffileName)
#else
MLOCAL UW16
open_out(ffileName)
    LPSB8 ffileName;
#endif
{
#if defined (MSDOS) || defined (__OS2__)
    UW16 status;
    struct stat port_status;
#endif
    SB8   fileName[FILENAMELEN + PATHNAMELEN]; /* dET */

    parallel_out = printer_out = FALSE;          /* default -ss 3/6/92 */
    fout = NULL;

    if(ffileName)
    {
        STRCPY(fileName, ffileName);   /* copy far string to near string */

      /* If a parallel printer port is specified, check the status. */
      /* Need better checking- could be file LBTFOO.sfs */

#ifdef _WINDOWS
        if (_fstrstr(ffileName, (LPUB8)PR_NAME_KEY) != (LPSB8)NULL)
#else
        if (strstr(fileName, PR_NAME_KEY) != (SB8 *)NULL)
#endif
        {
#if defined (MSDOS) || defined (__OS2__)
            parallel_out = TRUE;
            port_num = (unsigned)atoi(fileName+3) - 1;
            if( (status = printer_avail( port_num )) != SUCCESS )
               return status;
#else               
            /* 08-10-90  jfd  No support for downloading other than DOS */
            return ERRopen_printer;           /* error */
#endif
        }


      /* Open output file */

#ifdef _WINDOWS                              /* 08-10-90  jfd */
        if ((fout = OpenFile(ffileName, &ofFile, OF_CREATE | OF_SHARE_COMPAT)) == -1)
#else
        if ((fout = OPEN(fileName, O_WRITEFLAGS, S_IREAD | S_IWRITE)) == -1)
#endif
            return ERRopen_file;

      /*  Get the file status. See if this is a regular file
       *  or a device.
       */

/* Currently, can only download directly to printer in DOS.  -ss 1/22/92 */

#if defined (MSDOS) || defined (__OS2__)
        if (fstat (fout, &port_status))    /* get file status */
        {
            CLOSE(fout);                          /* fstat() error   */
            return ERRfstat;
        }  
                         /* regular file? */
        else if (((unsigned int)port_status.st_mode) & S_IFREG)
            printer_out = FALSE;
        else
            printer_out = TRUE;

        if(printer_out)
            init_printer(fout);    /* force to binary output */
#endif  /* MSDOS || OS2 */

    }  /* end - if ffileName */

    return SUCCESS;
}




/*----------------*/
/*  close_out     */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL VOID  close_out()
#else
MLOCAL VOID
close_out()
#endif
{
    if(fout != NULL)
    {
#if defined (MSDOS) || defined (__OS2__)
        if(printer_out)
            reset_printer(fout); /* printer specific, whatever is lined in */
#endif
        CLOSE(fout);
    }
}



/*----------------*/
/*       out      */
/*----------------*/
/*  Output buffer to file or device fout */
#if defined (ANSI_DEFS)
MLOCAL UW16  out(LPUB8 memptr, UW16 size)
#else
MLOCAL UW16
out(memptr, size)
    LPUB8  memptr;
    UW16   size;
#endif
{
#define STATUS_RETRY 7

    SW16 not_ready;
    SW16 tries;

    pcleo_count += (UL32)size;

    if(fout != NULL)
    {
      /* Write to printer or output file */

/* currently only download directly to printer in DOS -ss 3/6/92 */
#if defined (MSDOS) || defined (__OS2__)
        if(parallel_out)
        {
          /*  Check the printer status. */

            tries = 0;
            not_ready = printer_status( port_num );
            while (not_ready && (tries < STATUS_RETRY))
            {
                Delay(2);   /* wait 2/18th of a second (11-30-90 dET) */
                not_ready = printer_status( port_num );
                tries += 1;
            }
            if(not_ready)
                return ERRnot_ready_lpt;
        }
#endif /* MSDOS || OS2 */

        if(size != WRITEF(fout, memptr, size))
        {
            DBG("fwrite() failed\n");
            return ERRwrite;
        }
    }  /* end - if(fout != NULL)  */

    return SUCCESS;
}




/*----------------*/
/*   out_byte     */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  out_byte(UB8 b)
#else
MLOCAL UW16
out_byte(b)
    UB8  b;
#endif
{
    return out((LPUB8)&b, 1);
}





/*----------------*/
/*    myitoa      */
/*----------------*/
/*  Converts integer to ASCII. Writes ASCII string starting at the
 *  passed in UB8 pointer and returns a pointer to the UB8 after
 *  the just written ASCII string.
 */
#if defined (ANSI_DEFS)
MLOCAL LPUB8 myitoa(LPUB8 p, UW16 count)
#else
MLOCAL LPUB8
myitoa(p, count)
    LPUB8 p;
    UW16  count;
#endif
{
    UB8  n[16];
    LPUB8 np;

    np = n;
    while(count)
    {
        *np++ = (UB8)((count % 10) + '0');
        count = count / 10;
    }

    while(np > n)
        *p++ = *--np;

    return p;
}




/*----------------*/
/*    esc_out     */
/*----------------*/
/*  Write PCL escape sequence */

#define CHARCODE 0     /* "\27*c%hdE", count" */
#define CHARDOWN 1     /* "\27(s%hdW", count" */
#define CREATFNT 2     /* "\27)s%hdW", count" */

#if defined (ANSI_DEFS)
MLOCAL UW16  esc_out(UW16 type, SW16 count)
#else
MLOCAL UW16
esc_out(type, count)
    UW16  type;
    SW16   count;
#endif
{
    UB8  esc[16];
    LPUB8 p;

    p = esc;
    *p++ = 27;
    if(type == CHARCODE)
    {
        *p++ = '*';
        *p++ = 'c';
        p = myitoa(p, count);
        *p++ = 'E';
    }
    else
    {
        if(type == CHARDOWN)
            *p++ = '(';
        else
            *p++ = ')';

        *p++ = 's';
        p = myitoa(p, count);
        *p++ = 'W';
    }

    return out((LPUB8)esc, p - (LPUB8)esc);
}


/*                I/O and Miscellaneous                          */
/*---------------------------------------------------------------*/
/*                PCLheader()                                    */


#define CGCOPYLEN 62

/*----------------*/
/*    PCLheader   */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  PCLheader(SL32 fontid)
#else
MLOCAL UW16
PCLheader(fontid)
    SL32  fontid;
#endif
{
    UW16      status;
    PBUCKET   bucket;
    LPSB8     pfgseg;           /* pointer to face global segment */
    UB8      *p;                /* model dependent pointer dET */
    LPSB8     pp;               /* changed to signed   -ss 6/22/92 */
    PFACE_ATT attribute;        /* attribute segment */
    PDISPLAY  display;          /* display segment */
    UW16      i, j;
    LPSB8     gif;              /* global Intellifont segment */
    LPSB8     cgcopy;           /* copyright segment- CGCOPYLEN (=62) bytes */
    UW16      hpLength;         /* Length of HP Copyright */
    UW16      copyrightLength;  /* total copyright length */

  /* font alias */

    UW16     NFATS;
    UW16     NXREF;
    UL32     FACENUM;
    BOOLEAN  found_table_name;
    LPSB8    fa_table;
    SW16     face_style;

    union {
              SW16 w;
              struct{
                        SB8 b0;
                        SB8 b1;
                    }b;
           } tmp;

    UW16 numof;
    UW16 fontDescriptorSize;

    SB8  vendorID;  /* 10-09-90 jfd  This comes from MARIE, file wt-pcl.c */

    UW16 packed_typeface;  /* 02-20-91 jfd */

    status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &bucket);
    if (status)
        return status;
#if SLIM_FONTS
    if( (bucket->bucket_num & FILEORG_MASK) != D_LIB )
        return ERRcompact_pcleo;
#endif
    pfgseg = fgseg(bucket);

  /* Zero out font header and extended font header */

    MEMSET((LPUB8)&hpfh, (int)0, (int)sizeof(HPFH));
    MEMSET((LPUB8)&hpefh, (int)0, (int)sizeof(HPEFH));

  /* Global Intellifont Data */

    hpfh.gifct = bucket->p.in.gifct;     /* global Intellifont size */

    if ((bucket->p.in.ogif != MAX_UWORD) && bucket->p.in.gifct)
    {
        pp = gif = pfgseg + bucket->p.in.ogif;

        numof = *((LPUW16)pp);    PSWAP           /* NYLN */
        for(i=0; i<numof; i++)  { PSWAP }
        numof = *((LPUW16)pp);    PSWAP           /* NGCD */
        pp += 2 * numof;
        for(j=0; j<2; j++)
        {
            numof = *((LPUW16)pp);    PSWAP       /* NG_D */
            for(i=0; i<numof; i++)  { PSWAP }
            pp += numof;
            PPAD
        }
        PSWAP
        PSWAP
        PSWAP
        PSWAP
        hpefh.ehStemStyle = *pp++;
        hpefh.ehStemMod     = *pp;
    }

  /* Raster Parameters */

    if (bucket->p.in.orast == MAX_UWORD) return ERRrastparam_missing;
    pp = pfgseg + bucket->p.in.orast;
    hpfh.orThreshold = *(LPUW16)(pp);
    hpfh.globItalAng = *(LPSW16)(pp+2);

  /* Font Attribute Header */

    if (bucket->p.in.oattribute == MAX_UWORD) return ERRattribseg_missing;
    attribute = (PFACE_ATT)(pfgseg + bucket->p.in.oattribute);

    hpfh.baselinePosition  = attribute->baselinePosition;
    hpfh.underlinePosition = attribute->uscoreDepth;
    hpfh.underlineHeight   = attribute->uscoreThickness;
    hpfh.xHeight           = (UW16)attribute->xHeight;
    hpfh.capHeight         = attribute->capHeight;
    hpfh.pitch             = attribute->spaceBand;
    hpfh.scaleFactor       = attribute->scaleFactor;
    hpfh.textWidth         = attribute->fixedSpaceRelWidths[1]; /* En-space */
                                                                /* 10-09-90 jfd */

  /* display header */

    if (bucket->p.in.odisplay == MAX_UWORD) return ERRdispheader_missing;
    display = (PDISPLAY)(pfgseg + bucket->p.in.odisplay);

    hpfh.height = display->masterPointSize;
    hpfh.xRes   = display->scanResolutionX;
    hpfh.yRes   = display->scanResolutionY;

  /* Font Alias Table */

    if(bucket->p.in.ofont_alias_seg == MAX_UWORD)  return ERRfat_missing;
    DBG("\n\n    F o n t a l i a s    S e g m e n t\n\n");

    pp = pfgseg + bucket->p.in.ofont_alias_seg;
    fa_table = (LPSB8)0;

    NFATS = *(LPUW16)pp;    pp += 2;
    DBG1("    NFATS = %d\n", NFATS);
    for(i=0; i<NFATS; i++)
    {
        DBG1("    Alias table name: --%20.20s--\n", pp);

        found_table_name = (STRNCMP(FONTALIASNAME, pp, 20) == 0);
        pp += 20;

        NXREF = *(LPUW16)pp;  pp += 2;
        DBG1("        NXREF = %d\n", NXREF);
        for(j=0; j<NXREF; j++)
        {
#if (NAT_ALIGN == 4 && BYTEORDER == HILO)  /* changed from "ifdef SPARC" -jfd 9/30/92 */
            MAKELONG( FACENUM, (pp+100) );
#else
            FACENUM = *(LPUL32)(pp+100);
#endif
            DBG1("            %lu\n", FACENUM);
            DBG1("            %25.25s\n", pp);
            DBG1("            %25.25s\n", pp+25);
            DBG1("            %25.25s\n", pp+50);
            DBG1("            %25.25s\n", pp+75);

            if(found_table_name && (FACENUM == bucket->tfnum))
            {
                fa_table = pp;
                break;
            }
            pp += 104;
        }
        if(fa_table) break;
    }
    if(i == NFATS)
        return ERRfat_missing;

#if (defined(_WINDLL)  ||  (NAT_ALIGN == 4 && BYTEORDER == HILO))
         /* changed from "ifdef SPARC" -jfd 9/30/92 */
      hpfat.PCLalfa[0] = fa_table[FATYPEABBREV];
      hpfat.PCLalfa[1] = fa_table[FATYPEABBREV+1];
      hpfat.treatment = fa_table[FATREATMENT];  
      hpfat.fixPitch = fa_table[FAFIXPITCH];
      hpfat.PCLwidth = fatoi(&fa_table[FAPCLWIDTH]);
      hpfat.structure = fatoi(&fa_table[FASTRUCTURE]);
      hpfat.face_width = fatoi(&fa_table[FAWIDTH]);
      hpfat.posture = fatoi(&fa_table[FAPOSTURE]);
      hpfat.stem_wt = fatoi(&fa_table[FAWEIGHT]);
      hpfat.family = fatoi(&fa_table[FATYPEFAMILY]);
      hpfat.serif_style = fatoi(&fa_table[FASERIF]);
      hpfat.serif_flag = fatoi(&fa_table[FASIMPLESERIF]);
      hpfat.compress = fa_table[FACOMPRESSFLG];
      STRNCPY(&hpfat.font_name[0], &fa_table[FASHORTNAME], 16);
      hpfat.FAIS_file_num = fatoi(&fa_table[FACGNUMBER]);
      hpfat.class_index = fatoi(&fa_table[FACLASSINDEX]);
#else
    sscanf(fa_table,
      "%2s-%c-%c-%hd%*4c%hd-%hd-%hd-%hd-%hd-%hd-%hd-%c-%16c-%ld-%hd",
      hpfat.PCLalfa,&hpfat.treatment,&hpfat.fixPitch,&hpfat.PCLwidth,
      &hpfat.structure,&hpfat.face_width,&hpfat.posture,&hpfat.stem_wt,
      &hpfat.family,&hpfat.serif_style,&hpfat.serif_flag,&hpfat.compress,
      hpfat.font_name,&hpfat.FAIS_file_num,&hpfat.class_index);  /* 10-09-90 jfd */
#endif

    hpfat.font_name[16] = '\0';

    DBG("\n\nhpfat:\n");
    DBG1("  PCLalfa[2]     %2.2s\n", hpfat.PCLalfa);
    DBG1("  treatment      %c\n", hpfat.treatment);
    DBG1("  fixPitch       %c\n", hpfat.fixPitch);
    DBG1("  PCLwidth       %d\n", hpfat.PCLwidth);
    DBG1("  structure      %d\n", hpfat.structure);
    DBG1("  face_width     %d\n", hpfat.face_width);
    DBG1("  posture        %d\n", hpfat.posture);
    DBG1("  stem_wt        %d\n", hpfat.stem_wt);
    DBG1("  family         %d\n", hpfat.family);
    DBG1("  serif_style    %d\n", hpfat.serif_style);
    DBG1("  serif_flag     %d\n", hpfat.serif_flag);
    DBG1("  compress       %c\n", hpfat.compress);
    DBG1("  font_name[17]  %17.17s\n", hpfat.font_name);
    DBG1("  FAIS_file_num  %d\n", hpfat.FAIS_file_num);
    DBG1("  class_index    %d\n", hpfat.class_index);


  /** Set PCL Font Header values */
    face_style  = 32*hpfat.structure + 4*hpfat.face_width
                                                  + hpfat.posture;

    hpfh.serifStyle = (UB8)(((hpfat.serif_flag+1)<<6)
                                                     + hpfat.serif_style);
    /*spacing=1 for proportional*/
    hpfh.spacing = (UB8)((hpfat.fixPitch=='F')? 0:1);
    hpfh.strokeWeight  = (SB8)(hpfat.stem_wt - 8);
    hpfh.style_lsb = (SB8)face_style;
    hpfh.style_msb = (SB8)(face_style>>8);
    hpfh.appearanceWidth = (SB8)(hpfat.PCLwidth - 5);

    UNPACK_LSB(hpfat.family, hpfh.lsb_typeface); /* 02-20-91 jfd */
    UNPACK_MSB(hpfat.family, hpfh.msb_typeface); /* 02-20-91 jfd */

    STRNCPY(hpfh.fontName,hpfat.font_name,16);
    j = 15;                                         /* 10-09-90 jfd */
    while ((hpfh.fontName[j] <= 0x20) && (j > 0))   /* 10-09-90 jfd */
    {                                               /* 10-09-90 jfd */
       hpfh.fontName[j] = '\000';                   /* 10-09-90 jfd */
       j--;                                         /* 10-09-90 jfd */
    }                                               /* 10-09-90 jfd */

    hpfh.firstCode = symbolset.ss_first_code[SYMBOLSET_IF];
  
    hpefh.ehTreatment = hpfat.treatment;
    hpefh.ehFamilydes[0] = hpfat.PCLalfa[0];
    hpefh.ehFamilydes[1] = hpfat.PCLalfa[1];
    hpefh.ehStyle = face_style;
    hpefh.ehFamilynumb = hpfat.family;
    hpefh.ehClassIndex = hpfat.class_index;

  /*---------------------------------------------------------*/
  /*           Finish HP Font Header                         */


/*    hpfh.fontNumber = ((long)'C' << 24) | fontid; */

    /* The following comes from MARIE, file wt-pcl.c.
       It assumes 'native' mode typefaces, none 'converted'
       (10-09-90 jfd)
     */

    PACK(hpfh.lsb_typeface, hpfh.msb_typeface, packed_typeface); /* 02-20-91 jfd */
    vendorID = vendorInitial[ (packed_typeface >> 11) & 0x000F]; /* 02-20-91 jfd */
    hpfh.fontNumber = ((long)vendorID << 24) | fontid;          /* 10-09-90 jfd */

    hpfh.fontDescriptorSize = 80;            /* Size of this header */
    hpfh.descriptorFormat = (UB8)10;         /* 10-Intellifont */
    hpfh.quality = (UB8)0;                   /* 0, ignored */ /* 10-09-90 jfd */


  /*  NOTE: this is meant to duplicate an anomaly in marie so the
   *  we make the same pcleos as marie. The first branch gives us
   *  one more than the real last code.
   */

    if(numExtraSymCodes)
        hpfh.lastCode = MAX(symbolset.ss_last_code[SYMBOLSET_IF],
                                   EXTRABASE + numExtraSymCodes);
    else
        hpfh.lastCode = symbolset.ss_last_code[SYMBOLSET_IF];

  /* Values from symbol set */

    hpfh.symbolSetOrganization = (UB8)symbolset.ss_type[SYMBOLSET_IF];
    hpfh.symSetCode = symbolset.ss_symSetCode[SYMBOLSET_IF];

  /* Final font header- let's take a look */

    DBG("\n\nhpfh:\n");
    DBG1("  fontDescriptorSize     %u\n", hpfh.fontDescriptorSize);
    DBG1("  descriptorFormat       %u\n", hpfh.descriptorFormat);
    DBG1("  symbolSetOrganization  %u\n", hpfh.symbolSetOrganization);
    DBG1("  style_msb              %u\n", hpfh.style_msb);
    DBG1("  Reserved1              %u\n", hpfh.Reserved1);
    DBG1("  baselinePosition       %u\n", hpfh.baselinePosition);
    DBG1("  cellWidth              %u\n", hpfh.cellWidth);
    DBG1("  cellHeight             %u\n", hpfh.cellHeight);
    DBG1("  orientation            %u\n", hpfh.orientation);
    DBG1("  spacing                %u\n", hpfh.spacing);
    DBG1("  symSetCode             %u\n", hpfh.symSetCode);
    DBG1("  pitch                  %u\n", hpfh.pitch);
    DBG1("  height                 %u\n", hpfh.height);
    DBG1("  xHeight                %u\n", hpfh.xHeight);
    DBG1("  appearanceWidth        %d\n", hpfh.appearanceWidth);
    DBG1("  style_lsb              %u\n", hpfh.style_lsb);
    DBG1("  strokeWeight           %d\n", hpfh.strokeWeight);
    DBG1("  typeface               %u\n", packed_typeface); /* 02-20-91 jfd */
    DBG1("  serifStyle             %u\n", hpfh.serifStyle);
    DBG1("  quality                %u\n", hpfh.quality);
    DBG1("  placement              %u\n", hpfh.placement);
    DBG1("  was_underlinePosition  %d\n", hpfh.was_underlinePosition);
    DBG1("  was_underlineHeight    %u\n", hpfh.was_underlineHeight);
    DBG1("  textHeight             %u\n", hpfh.textHeight);
    DBG1("  textWidth              %u\n", hpfh.textWidth);
    DBG1("  firstCode              %u\n", hpfh.firstCode);
    DBG1("  lastCode               %u\n", hpfh.lastCode);
    DBG1("  pitch_ext              %u\n", hpfh.pitch_ext);
    DBG1("  height_ext             %u\n", hpfh.height_ext);
    DBG1("  capHeight              %u\n", hpfh.capHeight);
    DBG1("  fontNumber             %lu\n", hpfh.fontNumber);
    DBG1("  fontName               %16.16s\n", hpfh.fontName);
    DBG1("  scaleFactor            %u\n", hpfh.scaleFactor);
    DBG1("  xRes                   %u\n", hpfh.xRes);
    DBG1("  yRes                   %u\n", hpfh.yRes);
    DBG1("  underlinePosition      %d\n", hpfh.underlinePosition);
    DBG1("  underlineHeight        %u\n", hpfh.underlineHeight);
    DBG1("  orThreshold            %u\n", hpfh.orThreshold);
    DBG1("  globItalAng            %u\n", hpfh.globItalAng);

  /*  Swap bytes- Don't swap on words we filled in with 0's */

#if BYTEORDER == LOHI
    p = (UB8*)&hpfh;
    SWAP       p+= 4;    /* fontDescriptorSize */
    SWAP       p+= 6;    /* baselinePosition */
    SWAP                 /* symSetCode */
    SWAP                 /* pitch */
    SWAP                 /* height */
/*    SWAP       p+= 16;*/   /* xHeight */    /* 10-09-90 jfd */
    SWAP       p+= 12;   /* xHeight */      /* 10-09-90 jfd */
    SWAP                 /* textWidth */    /* 10-09-90 jfd */
    SWAP                 /* firstCode */    /* 10-09-90 jfd */
    SWAP       p+= 2;    /* lastCode */
    SWAP                 /* capHeight */

    i = *((UW16*)p);                /* swap a long */
    *((UW16*)p) = *((UW16*)(p+2));
    *((UW16*)(p+2)) = i;
    SWAP
    SWAP       p+= 16;    /* fontNumber */

    for(i=0; i<8; i++) { SWAP }

#endif /* LOHI */


  /*---------------------------------------------------------*/
  /*           Finish HP Extended Font Header                */

    hpefh.ehHSize      = sizeof(HPEFH) - 2;  /* my version includes check */
    hpefh.ehHType      = HPFONTHDR_EXT_HEADER_TYPE;
    hpefh.ehExtleading = 1755;
    hpefh.ehType       = 1;
    hpefh.ehClass      = 'O';
    hpefh.ehXres       = 300;
    hpefh.ehYres       = 300;
    hpefh.ehXdot       = 0x2000;
    hpefh.ehYdot       = 0x2000;
    hpefh.ehGrays      = 1;

  /* From symbol set */

#if BYTEORDER == LOHI
    /* original for PC                    -ss 6/22/92 */
    hpefh.ehSymdes[0] = (UB8)(symbolset.curssnum & 0xff);
    hpefh.ehSymdes[1] = (UB8)(symbolset.curssnum >> 8);
#else
    /* for some reason these bytes are swapped, make it OK  -ss 6/22/92 */
    hpefh.ehSymdes[1] = (UB8)(symbolset.curssnum & 0xff);
    hpefh.ehSymdes[0] = (UB8)(symbolset.curssnum >> 8);
#endif
    hpefh.ehSymclass  = symbolset.ss_class[SYMBOLSET_IF];

    DBG("\n\nhpefh:\n");
    DBG1("  ehHSize         %u\n", hpefh.ehHSize);
    DBG1("  ehHType         %u\n", hpefh.ehHType);
    DBG1("  ehTreatment     %u\n", hpefh.ehTreatment);
    DBG1("  ehFamilynumb    %u\n", hpefh.ehFamilynumb);
    DBG1("  ehFamilydes[2]  %2.2s\n", hpefh.ehFamilydes);
    DBG1("  ehStyle         %u\n", hpefh.ehStyle);
    DBG1("  ehClassIndex    %u\n", hpefh.ehClassIndex);
    DBG1("  ehExtleading    %x\n", hpefh.ehExtleading);
    DBG1("  ehIntleading    %u\n", hpefh.ehIntleading);
    DBG1("  ehStemStyle     %u\n", hpefh.ehStemStyle);
    DBG1("  ehStemMod       %u\n", hpefh.ehStemMod);
    DBG1("  ehSymdes[2]     %2.2su\n", hpefh.ehSymdes);
    DBG1("  ehSymclass      %u\n", hpefh.ehSymclass);
    DBG1("  ehType          %u\n", hpefh.ehType);
    DBG1("  ehClass         %u\n", hpefh.ehClass);
    DBG1("  ehXres          %x\n", hpefh.ehXres);
    DBG1("  ehYres          %x\n", hpefh.ehYres);
    DBG1("  ehXdot          %x\n", hpefh.ehXdot);
    DBG1("  ehYdot          %x\n", hpefh.ehYdot);
    DBG1("  ehGrays         %x\n", hpefh.ehGrays);

  /*  Swap bytes in HP Extended Font Header. Warning: didn't swap
   *  UW16S that were hard coded to 0.
   */

#if BYTEORDER == LOHI
    p = (UB8*)&hpefh;
    SWAP    p += 2;      /* ehHSize      */
    SWAP    p += 2;      /* ehFamilynumb */
    SWAP                 /* ehStyle      */
    SWAP                 /* ehClassIndex */
    SWAP    p += 6;      /* ehExtleading */
    SWAP    p += 2;      /* ehSymclass   */
    SWAP                 /* ehXres       */
    SWAP                 /* ehYres       */
    SWAP                 /* ehXdot       */
    SWAP                 /* ehYdot       */
    SWAP                 /* ehGrays      */

#endif /* LOHI */



    hpLength = STRLEN(hpCopyrightStatement);
    copyrightLength = 2 + 1     /* length, type code ???????? */
                   + CGCOPYLEN    /* = 62, copyright segment */
                   + hpLength
                   + 1;           /* Terminating null */

    fontDescriptorSize = 
        PCLFONTHEADERSIZE      /* 80 */
        + bucket->p.in.gifct
        + copyrightLength
        + sizeof(hpefh);                  /* check sum is in hpefh */

    DBG1("  font descriptor size %u\n", fontDescriptorSize);


  /* Write escape sequence */

    status = esc_out(CREATFNT, fontDescriptorSize);
    if (status)
        return status;

  /* Compute check */

    cgcopy = pfgseg + bucket->p.in.ocopy;
    DBG1("CG Copyright -%62.62s-\n", cgcopy);

    hpefh.pad   =   0;
    hpefh.check =   (UB8)256 -
                   (check_sum((LPUB8)&hpfh.scaleFactor, (UL32)16)
                  + check_sum(gif, (UL32)bucket->p.in.gifct)
                  + (UB8)(copyrightLength >> 8)
                  + (UB8)(copyrightLength & 0xff)
                  + (UB8)(COPYRIGHTCODE)
                  + check_sum(hpCopyrightStatement, (UL32)hpLength)
                  + check_sum(cgcopy, (UL32)CGCOPYLEN)
                  + check_sum((LPUB8)&hpefh, (UL32)sizeof(HPEFH) - 1)); 

  /* Write font header */

    status = out((LPUB8)&hpfh, sizeof(HPFH));
    if (status)
        return status;

  /* Write Global Intellifont data */
  /* (if any exists - proofer font had none!!! 10-10-90 jfd */

    if (bucket->p.in.gifct)     /* 10-10-90 jfd */
       status = out(gif, bucket->p.in.gifct);
       if (status)
           return status;

  /* Write Copyright */

    /* Length */
    status = out_byte((UB8) (copyrightLength >> 8));
    if (status)
        return status;
    status = out_byte((UB8) (copyrightLength & 0xff));
    if (status)
        return status;
    status = out_byte(COPYRIGHTCODE);
    if (status)
        return status;

    status = out((LPUB8)hpCopyrightStatement, hpLength);
    if (status)
       return status;
    status = out(cgcopy,               CGCOPYLEN);
    if (status)
       return status;
    status = out_byte(0);
    if (status)
       return status;

  /* Write extended font header */

    status = out((LPUB8)&hpefh, sizeof(HPEFH));
    if (status)
        return status;

  /* free the BUCKET we just trashed */

    BUCKfree(bucket->my_handle);

    return SUCCESS;
}

/*                PCLheader()                                    */
/*---------------------------------------------------------------*/
/*                PCLchars()                                     */


MLOCAL UB8 N_TR;

#if defined (ANSI_DEFS)
MLOCAL LPUB8 skeletal(LPUB8 pp)
#else
MLOCAL LPUB8
skeletal(pp)
    LPUB8 pp;
#endif
{
    UB8 numof;

    pp++;                         /* Skip N_SK */
    N_TR = *pp++;                 /* save y version for y line processing */
    numof = (UB8)2 * *pp++;       /* N_ND */
    pp += numof;
    numof = (UB8)3 * *pp++;       /* N_PR */
    pp += numof;
    numof = *pp++;                /* N_IN */
    pp += numof;
    PPAD

    return pp;
}


/*------------------*/
/* simple_character */
/*------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  simple_character(SYMLIST *sl)
#else
MLOCAL UW16
simple_character(sl)
    SYMLIST  *sl;
#endif
{
    UW16 status;
    UW16 char_space; /* total length     */
    UW16 metoff;     /* metric data      */
    UW16 ifoff;      /* Intellifont data */
    UW16 conoff;     /* Contour tree     */
    UW16 xyoff;      /* XY data          */

    UW16 tanoff;     /* Tangent data     */ /* 10-08-90 jfd */
    
    UW16 i, j;
    UW16 numof;
    UW16 NLOP;
    UW16 NAUXPT;

    LPUB8 pp;
    LPUB8 header;

    union {
              SW16 w;
              struct{
                        SB8 b0;
                        SB8 b1;
                    }b;
           } tmp;

    /* If the call to DArd_char returns an ERR_no_contour error,
       instead of aborting the writing of the PCLEO, continue.
       (10-08-90 jfd)
     */

    status = DArd_char(chr_def + sl->icd);   /* 10-08-90 jfd */
    if (status && status != ERR_no_contour)  /* 10-08-90 jfd */
        return status;                       /* 10-08-90 jfd */

  /* Swap bytes for all SW16s */

    pp = (LPUB8)if_state.char_buf;
    char_space = *(LPUW16)pp;   PSWAP    /* total length     */
    metoff     = *(LPUW16)pp;   PSWAP    /* metric data      */
    ifoff      = *(LPUW16)pp;   PSWAP    /* Intellifont data */
    conoff     = *(LPUW16)pp;   PSWAP    /* Contour tree     */
    xyoff      = *(LPUW16)pp;   PSWAP    /* XY data          */

  /* Character may have an additional segment: Tangent Data.
     If so store it and SWAP. (10-08-90 jfd)
   */
  
    if (metoff == 12)                        /* 10-08-90 jfd */
    {                                        /* 10-08-90 jfd */
       tanoff  = *(LPUW16)pp;   PSWAP        /* 10-08-90 jfd */
    }                                        /* 10-08-90 jfd */

    for(i=0; i<10; i++) { PSWAP }            /* Metric data           */

    if(ifoff != MAX_UWORD)
    {
        pp = skeletal(pp);                   /* Y-skeletal            */
        PSWAP                                /* y baseline            */
        numof = *pp++;                       /* ylines                */
        pp += 2*numof + N_TR;
        numof = 2 * *pp++;                   /* 2 * NLYCD             */
        pp += numof;
        PPAD
        numof = *(LPUW16)pp;  PSWAP          /* NLYLN                 */
        for(i=0; i<numof; i++) { PSWAP }
        pp = skeletal(pp);                   /* x skelatal            */
        PSWAP                                /* Italic angle          */
        PSWAP
        pp += 2;                             /* Standard dimensions   */
    }

    if(conoff != MAX_UWORD)                  /* 10-08-90 jfd */   
    {                                        /* 10-08-90 jfd */
       NLOP = *(LPUW16)pp;     PSWAP         /* Contour Tree NLOP     */
       PSWAP                                 /* Contour flag          */
       for(i=0; i<NLOP; i++)
       {
          PSWAP
          pp += 2;
          PSWAP
          PSWAP
       }
    }                                        /* 10-08-90 jfd */

    if(xyoff != MAX_UWORD)                   /* 10-08-90 jfd */   
    {                                        /* 10-08-90 jfd */
       for(i=0; i<NLOP; i++)
       {
          numof = 2 * (*(LPUW16)pp);    PSWAP  /* XY coordinate Data    */
          NAUXPT = 2 * (*(LPUW16)pp);   PSWAP
          for(j=0; j<numof; j++)  { PSWAP }
          pp += NAUXPT;
       }
    }                                        /* 10-08-90 jfd */

  /* Just to make sure we didn't get lost */

    if((pp - (LPUB8)if_state.char_buf) != char_space)
        return ERRbadchar;

  /* Checksum */

    *pp++ = 0;
    *pp++ = (UB8)256 - check_sum(if_state.char_buf, (UL32)char_space);

  /* write character */
  /* Write 'Download Character' escape sequence */

    status = esc_out(CHARDOWN, char_space + 2 + CHARHEADERSIZE);
    if (status)
        return status;

  /* Write character header- use end of character buffer to construct */

    header = pp;
    *pp++ = 10;
    *pp++ = 0;
    *pp++ = CHARDESCRIPTORSIZE;
    *pp++ = 3;                        /* Normal character */

    status = out(header, 4);
    if (status)
        return status;
    status = out(if_state.char_buf, char_space+2);
    if (status)
        return status;
}



/*---------------------*/
/* compound_character  */
/*---------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  compound_character(SYMLIST *sl)
#else
MLOCAL UW16
compound_character(sl)
    SYMLIST  *sl;
#endif
{
    UW16     status;
    UW16     i;
    UW16     char_space;
    CCPART   *q;
    CHR_DEF  *cd;

    UB8 *p;          /* For SWAP and PAD macros.  Model dependent dET */
    union {
              SW16 w;
              struct{
                        SB8 b0;
                        SB8 b1;
                    }b;
           } tmp;

  /*  Build compound character class 4 entity. */

    char_space = 4 + 6*sl->num_parts;
    cd = chr_def + sl->icd;

    cc.h0 = 10;
    cc.h1 =  0;
    cc.h2 =  2;
    cc.h3 =  4;
                                            p = (UB8*)&cc.escapement;
    cc.escapement = cd->bmorigin.x;         SWAP    p += 2;
    cc.num_parts = (UB8)sl->num_parts;
    cc.pad0      = 0;

    q = cc.ccpart;
    for(i=0; i<sl->num_parts; i++, cd++, q++)
    {
        q->symCode = cd->bmorigin.y;        SWAP
        q->xoffset = cd->offset.x;          SWAP
        q->yoffset = cd->offset.y;          SWAP
    }

  /* Checksum */

    p = (UB8*)q;
    *p++ = 0;
    *p   = (UB8)256 - 
                      check_sum((LPUB8)&cc.escapement, (UL32)char_space);
#if 0
    *(((UB8*)q)++) = 0;
    *((UB8*)q) = (UB8)256 - 
                      check_sum((LPUB8)&cc.escapement, (UL32)char_space);
#endif

  /* Write character */
  /* Write 'Download Character' escape sequence */

    status = esc_out(CHARDOWN, char_space + 2 + CHARHEADERSIZE);
    if (status)
        return status;

    status = out((LPUB8)&cc, char_space + 2 + CHARHEADERSIZE);
    if (status)
        return status;

    return SUCCESS;
}




/*----------------*/
/*    PCLchars    */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 PCLchars()
#else
MLOCAL UW16
PCLchars()
#endif
{
    UW16    status;
    UW16    i;
    SYMLIST *sl;

  /*  Go through symbol list writing a simple character (class3) or
   *  a compound character discription (class4).
   */

    sl = symlist;
    for(i=0; i<numSymCodes; i++)
    {
      /* Write 'Character Code' escape sequence */

        if(status = esc_out(CHARCODE, sl->symCode))   return status;

        if(sl->num_parts)
        {
            status = compound_character(sl);
            if (status)
                return status;
        }
        else
        {
            status = simple_character(sl);
            if (status)
                return status;
        }
        sl++;
    }
    return SUCCESS;
}



/*                PCLchars()                                     */
/*---------------------------------------------------------------*/
/*                build_char_lists()                             */


/*---------------------*/
/*      add_part       */
/*---------------------*/
/*  Returns the symCode corresponding to the cgnum in the passed
 *  in CHR_DEF. If the cgnum was not in the base symbol set, a new
 *  entry is added to the symlist[].
 */
#if defined (ANSI_DEFS)
MLOCAL UW16  add_part(PCHR_DEF cd, UW16 icd)
#else
MLOCAL UW16
add_part(cd, icd)
    PCHR_DEF  cd;
    UW16     icd;
#endif
{
    UW16    numSyms;
    UW16    chId;
    LPUW16  ss;     /* changed to LPUW16* -- mby, 10-14-92 */
    UW16    i;
    UW16    cgnum;
    SYMLIST *sl;
    UW16    nextExtraCode;

  /* Search symbol set for cgnum- return symbol code if found */

    numSyms = symbolset.ss_last_code[SYMBOLSET_IF] - symbolset.ss_first_code[SYMBOLSET_IF] + 1;
    cgnum = cd->cgnum;
    ss = symbolset.pss_entry[SYMBOLSET_IF];
    for(chId=0; chId<numSyms; chId++)
    {
        if(cgnum == *ss)
            return chId + symbolset.ss_first_code[SYMBOLSET_IF]; /* return symCode */
        ss++;
    }

  /*  Not found in symbol set. See if we've already added it
   *  to the extra symbols
   */

    sl = symExt;
    for(i=0; i<numExtraSymCodes; i++)
    {
        if(cgnum == (chr_def + sl->icd)->cgnum)
            return sl->symCode;
        sl++;
    }

  /* Add to extended symbol set if there's room */

    if(numSymCodes >= MAXSYMLIST)
        return 99;

    numSymCodes++;

    nextExtraCode = EXTRABASE + numExtraSymCodes;

    sl->symCode   = nextExtraCode;
    sl->num_parts = 0;
    sl->icd       = icd;

    numExtraSymCodes++;

    return nextExtraCode;
}


#if MARIETEST
MLOCAL SW16
#ifdef _WINDOWS
_cdecl
#endif
#if defined (ANSI_DEFS)
test_compare(PSYMLIST a, PSYMLIST b)
#else
test_compare(a, b)
    PSYMLIST a;
    PSYMLIST b;
#endif
{
    UW16 acode, bcode;

    acode = (chr_def + a->icd)->cgnum;
    bcode = (chr_def + b->icd)->cgnum;
    if(acode > bcode)
        return 1;
    else if(acode < bcode)
        return -1;
    else
        return 0;
}

#endif  /* MARIETEST */

/*--------------------*/
/*  build_char_lists  */
/*--------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  build_char_lists()
#else
MLOCAL UW16
build_char_lists()
#endif
{
    UW16     status;
    UW16     numChIds;     /* Number of entries in symbol_set[]       */
    UW16     chId;         /* Index into symbol_set[]                 */
    UW16     cgnum;        /* CG number from symbol_set[]             */
    SYMLIST  *sl;           /* Next available entry in symlist[]       */
    PCHR_DEF  cd;           /*  "      "        "    " chr_def[]       */
    UW16     numBaseCodes;
    UW16     i,j;
    UW16     icd;
    PBUCKET   bucket;       /* Not used- returned by IXsetup_chr_def() */


  /*  FIRST PASS: cruise through symbol_set[] making an entry in symlist[]
   *  for each chId. Each such symlist[] entry points to one (or more if
   *  compound character) CHR_DEFs in chr_def[].
   */
    numChIds = symbolset.ss_last_code[SYMBOLSET_IF] - symbolset.ss_first_code[SYMBOLSET_IF] + 1;

    numSymCodes  = 0;           /* Number of entries in symlist[] */
    num_chr_defs = 0;           /*    "    "    "     " chr_def[] */

    sl = symlist;
    cd = chr_def;

    for(chId=0; chId<numChIds; chId++)
    {
        if( !(cgnum = *(symbolset.pss_entry[SYMBOLSET_IF] + chId)) )
            continue;    /* symbol code doesn't map to a character */

      /* fill one or more CHR_DEFs */

/*        if(status = IXsetup_chr_def(cgnum, cd, &bucket))*/
        status = IXsetup_chr_def(chId + symbolset.ss_first_code[SYMBOLSET_IF],
                                   cd, &bucket); /* 01-23-91 jfd */

        if (status == ERR_fixed_space)
            continue;
        else if (status)
            return status;

        if(cd->buck_search_lvl != 0)
            continue;                /* skip the plugins */

      /*  Found a new character to add to our lists. Make sure
       *  there's enough room and then add it.
       */

        if((numSymCodes >= MAXSYMLIST)
                            || (num_chr_defs > MAXCHR_DEF - MAX_CC_PARTS))
            return 99;

        sl->symCode = chId + symbolset.ss_first_code[SYMBOLSET_IF];
        sl->icd     = num_chr_defs;
        if(chr_def_hdr.is_compound)  /* 01-16-91 jfd */
        {
            /* can't handle vert esc */ /* 01-16-91 jfd */
            if(chr_def_hdr.escape.y) return ERRvertesc;
            cd->bmorigin.x = chr_def_hdr.escape.x; /* 01-16-91 jfd */
            sl->num_parts = chr_def_hdr.num_parts; /* 01-16-91 jfd */
        }
        else
            sl->num_parts = 0;

      /* Bump list pointers and counts */

        sl++;
        numSymCodes++;

        cd += chr_def_hdr.num_parts; /* 01-16-91 jfd */
        num_chr_defs += chr_def_hdr.num_parts; /* 01-16-91 jfd */
    }


  /*  PASS TWO:  cruise through symlist[] looking for compound characters
   *  For each such compound character, use fields that are unused for
   *  pcleo support in each CHR_DEF to record the component symCode. The
   *  first CHR_DEF also gets the escapement.  New symCodes are added at
   *  the end of the smlist[] if needed.
   */

    symExt = sl;        /* start of extra symCodes- just after base codes */
    numBaseCodes = numSymCodes;
    numExtraSymCodes = 0;

    sl = symlist;
    for(i=0; i<numBaseCodes; i++)
    {
        if(sl->num_parts)     /* if it's a compound character */
        {
            icd = sl->icd;         /* index of first CHR_DEF */
            cd = chr_def + icd;    /* first of num_parts CHR_DEFs */
            for(j=0; j<sl->num_parts; j++)
            {
                cd->bmorigin.y = add_part(cd, icd);  /* symCode */
                icd++;
                cd++;
            }
        }    
        sl++;
    }

#if MARIETEST
    QSORT((LPSB8)symExt, numExtraSymCodes, sizeof(SYMLIST),
#ifdef LINT_ARGS
    (int (*)(const void *, const void *))test_compare);
#else
    (int *)test_compare);
#endif /* LINT_ARGS */
#endif

    return SUCCESS;
}

#if defined (ANSI_DEFS)
MLOCAL SW16 fatoi(register LPSB8 p)
#else
MLOCAL SW16 fatoi(p)
register LPSB8 p;
#endif
{
    short n, i;

    for (i = n = 0;; n *= 10)
    {
        n += (*p - '0');
        if (!isdigit(*(++p)))
           break;
    }
    return n;
}


/*                build_char_lists()                             */
/*---------------------------------------------------------------*/
/*                PCLeo()                                        */




/*----------------*/
/*    PCLeo       */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16  PCLeo(LPSB8 fileName, LPUL32 pcount, SL32 fontid)
#else
GLOBAL UW16
PCLeo(fileName, pcount, fontid)
    LPSB8  fileName;
    LPUL32 pcount;
    SL32   fontid;
#endif
{
    UW16  status;

    pcleo_count = 0;                 /* Byte count of PCLEO           */
    status = build_char_lists();  /* Build lists of character data */
    if (status)
        return status;
    status = open_out(fileName);  /* Open output file or device    */
    if (status)
    {
        close_out(); 
        return status;
    }
    status = PCLheader(fontid);   /* Write pcl font header         */
    if (status)
    {
        close_out(); 
        return status;
    }
    status = PCLchars();          /* Write characters              */
    close_out();                  /* Close output file or device   */
    if (status)
        return status;
    *pcount = pcleo_count;
    return SUCCESS;
}
#endif /* PCLEO && IF_RDR */
