/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/ps/iftops1.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: iftops1.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.13   07 Apr 1995 10:16:02   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   06 May 1994 14:10:08   JOE
 * Free memory call added to ps_write() in the case of no additional
 * (optional) files requested to be generated, to alleviate memory limit
 * failures. Also, call to CHARfree() added in the case of contourless
 * character, as some memory is stil required to be freed at that point.
 * 
 *    Rev 1.11   22 Apr 1994 15:41:56   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * Conditionally compiled include statement for <fcntl.h> based on
 * ((!_AM29K) || (_AM29K && !SUN)) for same reason.
 * 
 *    Rev 1.10   22 Apr 1994 14:35:04   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.9   09 Feb 1994 13:22:42   JOE
 * 
 * _AM29K changes.
 * 
 *    Rev 1.8   08 Dec 1993 19:00:12   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.7   21 Sep 1993 08:32:32   JOE
 * In function declaration for PScharEncrypt(), reversed the order of
 * "encryptVec" and "nEncode" (2nd and 3rd arguments).
 * In function declaration for encPScurveto(), changed type of
 * argument 4 from "SWS16" to "SW16".
 * 
 *    Rev 1.6   03 Aug 1993 14:46:56   MAIB
 * Changed interface to resolve naming conflicts
 * 
 *    Rev 1.5   02 Aug 1993 14:23:58   MAIB
 * Changes to support multi-tasking
 * 
 *    Rev 1.4   09 Jun 1993 16:43:46   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.3   12 Feb 1993 15:27:34   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   06 Jan 1993 10:03:26   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:14:06   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:54:24   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* iftops1.c
 *
 *
 *


This file was created by modifying 'ff1tops.c' by ATECH Corporation.
This is used with Intellifont for the PostScript Type 1 writer (output).

NOTE:
	In order to use the PS Type 1 writer, The 'cgconfig.h' file must have
	CHAR_HANDLE defined and SCALE_MATRIX must be set to MAT1_SCALE_MATRIX.
	No PS Type 1 code will be compiled unless PST1 is defined in cgconfig.h.


Revision History
----------------
05/20/91  rs	Create original file by modifying 'ff1tops.c' from ATECH
					Corporation.
05/30/91  rs	Move userdict stuff to Private dict - problem w/pipeline.
					Init 'eexecR' to 55665 before call to writePrivate() in
					write_t1_pfb_file().
05/31/91  rs	Go back to userdict for RD, ND & NP. Use closepath at end
					of each outline loop. Create #defines for all CharString
					commands. Do not take negative of Y values in outline.
06/03/91  rs	Scale all points by proper scale factor in fpsToPs().
					Add 'bld_encode()' function to build character encoding
					array. Look at return status from fpsToPs() in
					write_t1_pfb_file().
06/04/91  rs	Temp change to bld_widTab() to not exit if chars are missing
					from PS1Codes master list (debug only).
06/04/91  jfd  In write_t1_afm_file(), scaled capHeight, xHeight, ascender
               and descender to proper units. Also, checking widTab[].ps1_off
               for number of characters rather than calling SYMmap().
06/05/91  rs	Filter out duplicate points for 'lineto' in fpsToPs().
06/07/91  jfd  Added code for writing PFM file.
               Modified initPS1() to allocate buffer holData for PFM data.
               Freeing holData when other buffers are freed.
06/10/91  jfd  Added code for writing VFM file.
06/10/91  rs	Modify fpsToPs() to add fixed space character.
06/11/91  rs	Change protototype of write_t1_vfm_file() from WORD to VOID.
					Modify write_pfb() to copy global library data to our local
					storage (mytf, fspacewidth). Fix other handling of library
					data strings.
06/11/91  jfd	Fix compiler warnings - casting WORD to BYTE, etc.
06/13/91  jfd	Make local copies of library globals. Run 'spaceToDash()' on
			 &		all name like strings in font. Add /UnderlineThickness,
			 rs	/UnderlinePosition & italicAngle to FontInfo. Add
					UnderlinePosition & UnderlineThickness to AFM. Change
					dfAscent from 100 to bboxury.
06/14/91  rs	Add 'def' after 'PaintType' in font dict. Clean up pfb
					header info - FontType, CreationDate.
06/17/91  jfd  Passing argument "fontid" to write_t1_vfm_file() and
               using it when writing FACEID, UFACEID and SFACEID.
               In addition, changed format specifier for these fields
               from "%d" to "%ld".
               In SetDf(), calculating dfItalic, dfWeight, winType and
               dfPitchAndFamily rather than hard-wiring values.
               In AfmToEtm(), calculating etmSlant and etmUpperCaseDecent
               rather than hard-wiring values.
               Added the following fields: "ULONG typeFaceSet" and 
               "BYTE descriptorSet[DESCR_SET_LEN]" to TF structure in order
               to access font characteristics.
               In ps_write(), copying descriptorSet to mytf, and storing
               "cg_isFixedPitch".
06/18/91  jfd  In write_t1_vfm_file(), made changes for SIZE, ATTRTYPE,
               USTYLE, SSTYLE, FACEID, SFACEID, UFACEID and TYPEFACE 
               according to Ventura Publisher Technical Notes.
               In AfmToEtm(), changed the following values: 
               etmUnderlineOffset, etmUnderlineWidth,
               etmDoubleUpperUnderlineOffset, etmDoubleLowerUnderlineOffset,
               etmDoubleUpperUnderlineWidth, etmDoubleLowerUnderlineWidth,
               etmStrikeOutOffset and etmStrikeOutWidth.
               In SetDf(), set dfPixHeight = 1116.
06/19/91  jfd  In ps_write(), added arguments:
                 "outFile" - name of PostScript output file (no extension)
                 "vfm_font_id" - font id (written to VFM file)
               Removed argument "fontid".
               In write_t1_afm(), write_t1_pfm() and write_t1_pfb() and
               write_t1_vfm(), changed first argument from "fontid" (LONG)
               to "outFile" (PBYTE).
               In write_t1_vfm(), added argument "vfm_font_id" (PBYTE).
06/20/91  rs	Change 'fpsToPs()' to 'writeCharStrings()' for clarity.
					Change 'holData' to 'hpfmData' for pfm files. Only allocate
					if making a pfm.
06/21/91  jfd  In write_t1_afm_file(), replaced "\n" with "\r\n" and added
               "StartFontMetrics 2.0\r\n" af top.
               In write_t1_vfm_file(), replaced "\n" with "\r\n" and hard-
               wired the following values (based on Ventura's AFMTOVFM.EXE
               program):
                  TOP 940
                  BOT 220
                  YMPY 12
                  YDIV 720
                  XMPY 12
                  XDIV 720
               In addition, using 'j' to keep track of widths output per line.
06-25-91  rs	Clean up use of automatic arrays - use CHARalloc() instead due
					to stack overflow problems. Remove 'error_msg()', use DBG.
					Change 'bld_encode()' from VOID to WORD.
06-26-91  jfd  Moved "debug.h" after "port.h".
06-27-91  rs	Add text kerning pair support including pfm file.
07-01-91  rs	Add text kerning pair support to afm file. Add creation date
					to afm file. Move call to 'time()' from write_t1_pfb_file()
					to ps_write() and save in 'ltime' as MLOCAL. Change afm file
					from binary to text mode. Add bounding box info to WIDTABSTR
					for AFM file. Make 'nChars' a static variable equal to the
					number of chars in our symbol set to be in font. Move
					declaration of struct TF to ps_type1.h. Wherever "fullname"
					is used - use non "space-to-dash" name from mytf struct.
07/01/91  jfd  In write_t1_vfm_file(),
               (1) after copying typeface name into short_typeFaceName, add
               NULL terminator to be sure.
               (2) store TOP and BOTTOM using bounding box data rather then
               hard-wiring values.
               (3) write text kerning data to file.
               (4) removed "\r" from writes because file is now opened as an
               ASCII file
               In write_t1_vfm(), opening file as an ASCII file.
07/02/91  jfd  Added EXTERN variable "uCallerID" in case of MULTICALLER.
               Removed argument "size" from routines "write_t1_afm()",
               "write_t1_pfm()", "write_t1_vfm()", "write_t1_pfb()"
               and "ps_write(). Declared "ps_write()" conditionally based
               on MULTICALLER.
               In bld_kpTab(), calling CGIFkern() conditionally based on
               MULTICALLER.
               In write_t1_pfb_file(), am no longer calling writeCharStrings()
               conditionally because "uCallerId" is an EXTERN which does not
               have to be passed through.
               Am no longer declaraing writeCharStrings() conditionally based
               on MULTICALLER because "uCallerId" is an EXTERN.
07-03-91  rs	Change etmUpperCaseDecent to negative of bboxlly as per
					Adobe pfm file in PutEtm().
07/05/91  rs	Add 'EXTERN PBYTE fgseg (PBUCKET);' to fix make warnings.
					Clean up error return codes. Clean up opening/closing of
					files only from 'write_t1_xxx()' level.
07/09/91  rs	Fix pfm file -> lastchar should be relative to dfFirstChar,
					extent table must be inclusive from dfFirstChar to dfLastChar.
					Change dfFirstChar/dfLastChar/dfDefaultChar/dfBreakChar from
					BYTE to UBYTE.
07/10/91  rs	Add error check for too many kern pairs in bld_kpTab.
					Replace hardwired Adobe value for 'dfPixHeight' with value
					calculated from Intellifont constants in SetDf().
07/16/91  jfd  Added timing tests for each PostScript file created.
07/17/91  jfd  Disabled code to write PostScript VFM file.
07/19/91  rs	Write 'ForceBold' in Private Dictionary. Move call to
					SetDf() from write_t1_pfb_file() to ps_write ().
07/22/91  rs	Add more global hinting - StdHW,StdVW,StemSnapH,StemSnapV.
					Break out new funtion 'calcDfWidths()' from SetDf. Need all
					outlines (char widths) before calculating max & avg widths.
07/23/91  jfd  Windowize the file as follows:
                  fopen   --> OPEN (OpenFile)
                  fclose  --> CLOSE
                  fprintf --> STRCPY, strcat, WRITE
                  sprintf --> SPRINTF
                  memcpy  --> MEMCPY
                  strcpy  --> STRCPY
                  fseek   --> LSEEK
                  fputc   --> WRITE
                  ftell   --> tell
                  strcat  --> STRCAT
                  "outFp" is changed from FILE* to WORD
               Added include file mixmodel.h .
               Added include file io.h .
               Could not perform WINDOWS OpenFile() for AFM file in TEXT mode,
               so I reinserted "\r" after all WRITEs.
08/01/91  jfd  In writeCharStrings(), when resetting "hol", set it to NIL_MH
               instead of "0".
08/05/91  rs	Restored 'dfAscent' to old value - font did not align with
					Adobe fonts (bboxury). Move into function 'calcDfWidths()'.
08/06/91  jfd  In ps_write(), whenever "hpfmData" is CHARfree()'d, set it to
               0 so it won't be freed the next time if it hasn't been
               CHARalloc()'d.
08/07/91  jfd  Included "stat.h".
               On all calls to OPEN, added 3rd argument "S_IWRITE" so that
               files created will be read-write.
08/09/91  jfd  In writePfbData(), when writing type of data (ASCII or BINARY),
               use value passed ("type") instead of hard-wiring "2".
08/20/91  rs	Access global intellifont segment for stem width info.
					Add function 'freePS1mem()' to deallocate 'widely' used
					memory handles in one place. Includeds hencodeVec, hencryptVec,
					hwidTab, hsbuff and hpfmData.
					Change writePrivate() from VOID to UWORD.
					Remove various local CHARalloc calls for text buffers & use
					'sbuff' instead.
08/23/91  rs   Begin adding phase 1 hinting code for stems (lite hints).
08/29/91  rs	Make StdHW & StdVW globals.
09/03/91  rs	Add 'BlueScale' to private dict.
					Remove last segment if LINETO (closepath handles this).
09/04/91  rs	Begin 2nd level of hints (lite+) using multiple dimensions.
					Add global arrays 'StemSnapH' & 'StemSnapV'.
09/09/91  rs	Add ghost stem support (HSTEM).
09-25-91  jfd  In write_t1_afm_file() and write_t1_vfm_file(), using buffer
               "sbuff" instead of "temp_buf".

               In bld_encode(), using buffer "sbuff" instead of "buff"
               so no longer freeing hbuff.

               In initPS1(), no longer dynamically allocating buffer
               "hsbuff". Making "sbuff" static so as to be able to
               build medium memory model successfully.

               In freePS1mem(), no longer freeing "hsbuff".

               In ps_write(), no longer de-referencing hsbuff.

               In write_t1_pfb(), write_t1_pfm() and write_t1_afm(),
               using "sbuff" instead of "outFileName" and "hofn".

               Added PBYTE casts to pointer arguments passed to SPRINTF
               if necessary so as to be able to build under WINDOWS.

               When calling psWrite(), casting sbuff argument as PUBYTE
               so as to agree with function prototype for psWrite().

09/26/91  jfd  Conditionally compiling "sbuff" and "PsFontName" for WINDOWS.
11/21/91  jfd  In ps_write(), when calling bld_widTab(), was not storing
               return status.
               In bld_widTab(), changed error code returned from -1 to
               ERR_ps_char_not_in_list.
               In writeCharStrings(), changed olDataSz from WORD to LONG
               because of similar change to "outchar->size".
11/22/91  ss   Added define OPEN_MODE conditionally compiled for SUN. Added
               it to each call to OPEN() to get correct modes for each system.
               Added casts to eliminate warnings on SUN in bld_kpTab ().
25 Nov 91 ss   Make defines for file extension strings.  They are
               conditionally compiled for case sensitivity based on system
               type.
06 Jan 92 jfd  Included "if_type.h" for IF_STATE structure definition.
24-Feb-92 jfd  In writePrivate(), changed occurrence of "bucket->" to
               "bucket->p.in." due to change to BUCKET structure.
               Made same changes to ps_write().
02 Mar 92 jfd  Added #defines for file extensions if building under
               type.
               In encPut(), changed local variable "c2" from WORD to UBYTE
               to agree with function prototype for eexecEncrypt().
31 Mar 92 tnc  Added dummy write for Amiga lseek problem--could not lseek 
               past the end-of-file, so we write 6 bytes before the lseek to increase the file size.
               Also, added Dave T's code in writePfbData() to write 
               the 6 bytes with using a single WRITE.
03-Apr-92 rs   Portability cleanup (see port.h).
07-Jul-92 jfd  In "encPSputCoord()", changed mast from "0xf" to "0xff".
               In writeCharStrings(), changed "points" to PINTRVECTOR and
               casting coordinates as SW16 regardless of INTR_SIZE because 
               can never write a value > 32000.
10 Jul 92 ss   Changed refs from OUTLINE_CHAR.bm to new item ol.
16-Aug-92 rs	Fix nested comment in 'bld_kpTab()'
17-Sep-92 jfd  Changed conditional compile of entire module to include
               IF_RDR.
28-Sep-92 jfd  In writePfbData() and write_t1_pfb_file(), replaced tell() 
               call with lseek() call (Intel960 does not have "tell()" 
               function).
28-Sep-92 awr  Changed parameters of BUCKfind()
03-Oct-92 rs   Changes toward ANSI C - if file not compiled, must
               declared  at least 1 external - int iIFTOPS1 = 0.
15-Oct-92 mby  Changes to SYMBOLSET structure from sym.h. SYMmap() called
               with two arguments.
06-Jan-93 jfd  ANSI C function declaration changes.
08-Feb-93 jfd  VXWorks support.
               Changed all WRITE's to WRITEF's due to conflict with
               VXWorks.
09-Jun-93 jfd  Changed all references to "char" to "SB8" for transportability.
02-Aug-93 maib Changed calls to CGIFxxx() routines to cgifXXX() routines,
	       required for multi-tasking
03-Aug-93 maib changed definitions for cgifXXXX() routines to resolve
               naming conflicts
21-Sep-93 jfd  In function declaration for encPScurveto(), changed type of
               argument 4 from "SWS16" to "SW16".
               In function declaration for PScharEncrypt(), reversed the
               order of "encryptVec" and "nEncode" (2nd and 3rd args).
08-Dec-93 rs   General cleanup - MSDOS & OS2.
09-Feb-94 jfd  Including "hif.h" if _AM29K.
22-Apr-94 jfd  Changed conditional compile statement prior to
               including <hif.h> to #if (_AM29K && !UNIX) to
               resolve UNIX Metaware compiler error.
               Conditionally compiled include statement for <fcntl.h>
               based on ((!_AM29K) || (_AM29K && !SUN)).
05-May-94 jwd  Free memory call added to ps_write(),  in the case of no
               addtional (optional) files requested to be generated, to
               alleviate memory limit failures. Also,  call to CHARfree
               added in the case of contourless character, as some mem-
               ory is still required to be freed at that point.
*/

#include	"cgconfig.h"
#if PST1 && IF_RDR			/* enable PostScript Type 1 writer */

#define PSFONTNAME	0 /* 1 = use names w/o spaces - 7/2/91 - rs */

/*
Move this error message to cgif.h at earliest opportunity
*/
#define ERR_ps_TooManyKernPairs	208	/* too many kern pairs for type 1 */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(SUN)))
#include <fcntl.h>
#endif

#include <ctype.h>
#include <string.h>
#include "port.h"


#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined (MSDOS) || defined (__OS2__) /* needs port.h */
#include <stdlib.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <sys\timeb.h>
#include <io.h>

#elif defined LAMIGA
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <devices/timer.h>
#include <proto/dos.h>
#include <io.h>
#define SEEK_SET 0


#else
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/timeb.h>
#endif

#include <time.h>

#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"  /* 07-23-91 jfd */
#include "segments.h"
#include "cgif.h"
#include "cache.h"
#include "ix.h"
#include "sym.h"
#if MULTICALLER
#include "instance.h"
#endif
#include "ps_type1.h"

#if T1HINTS
#include "if_type.h"	/* for hinting - 8/23/91 - rs */
#endif /* T1HINTS */

/*
External function references
*/
#ifdef LINT_ARGS
EXTERN UW16      writeBlueValues(VOID);
EXTERN UW16      BUCKfind(int, int, PPBUCKET);
EXTERN BOOLEAN		if_init_glob(PBUCKET);	/* add 8/21/91 - rs */
EXTERN UW16      SYMmap(SW16, int);
EXTERN SW16 		SYMmapR (UW16);
EXTERN LPSB8		fgseg (PBUCKET);	/* add 7/5/91 - rs */

#if T1HINTS
EXTERN UW16		StemGen (VOID);	/* add 8/23/91 - rs */
EXTERN UW16		writeStdWidths (VOID);	/* add 9/4/91 - rs */
EXTERN UW16		ghost_stems (VOID);
#endif /* T1HINTS */

#else	/* not LINT_ARGS */
EXTERN UW16      writeBlueValues();
EXTERN UW16      BUCKfind();
EXTERN BOOLEAN		if_init_glob();	/* add 8/21/91 - rs */
EXTERN UW16		SYMmap ();
EXTERN SW16 		SYMmapR ();
EXTERN LPSB8		fgseg ();	/* add 7/5/91 - rs */

#if T1HINTS
EXTERN UW16		StemGen ();	/* add 8/23/91 - rs */
EXTERN UW16		ghost_stems ();
EXTERN UW16		writeStdWidths ();	/* add 9/4/91 - rs */
#endif /* T1HINTS */

#endif	/* LINT_ARGS */

/*
Function prototypes for this module
*/
#ifdef LINT_ARGS
MLOCAL UW16      write_t1_pfb(VOID);
MLOCAL SW16			writeCharStrings(VOID);
#if MULTICALLER
GLOBAL UW16      ps_write(UW16);
#else
GLOBAL UW16      ps_write(VOID);
#endif /* MULTICALLER */
MLOCAL SW16      write_t1_pfb_file(VOID);
MLOCAL UW16      write_t1_afm_file(VOID);
MLOCAL UW16      write_t1_pfm_file(SW16);
#if VFM
MLOCAL UW16      write_t1_vfm_file(VOID);
#endif
MLOCAL UW16      write_t1_pfm(VOID);
MLOCAL UW16      write_t1_afm(VOID);
#if VFM
MLOCAL UW16      write_t1_vfm(VOID);
#endif
MLOCAL UW16		initPS1(VOID);
MLOCAL VOID			freePS1mem (VOID);
MLOCAL VOID			encPSputCoord(SW16 d);
MLOCAL VOID			encPSmoveto(SW16 x0, SW16 y0, SW16 x1, SW16 y1);
MLOCAL VOID			encPSlineto(SW16 x0, SW16 y0, SW16 x1, SW16 y1);
MLOCAL VOID			encPScurveto(SW16 x0, SW16 y0, SW16 x1, SW16 y1, 
							SW16 x2, SW16 y2, SW16 x3, SW16 y3);
MLOCAL UB8		CharEncrypt(UB8 plain);
MLOCAL VOID       psWrite(LPUB8);
GLOBAL VOID       encWrite(LPUB8);
MLOCAL VOID			encEnd(VOID);
MLOCAL VOID			PScharEncrypt(LPUB8, SW16, LPUB8);
MLOCAL VOID       writePfbData(SW16);
MLOCAL VOID       spaceToDash(LPSB8, LPSB8);
MLOCAL UB8      eexecEncrypt(UB8);
MLOCAL VOID       encPut(LPUB8, SW16);
MLOCAL UW16      writePrivate(VOID);
GLOBAL UW16		PS1map (UW16);
MLOCAL SW16			bld_widTab (VOID);
MLOCAL SW16			bld_encode (VOID);
MLOCAL UW16		bld_kpTab (VOID);
MLOCAL VOID       szMove(LPSB8, LPSB8, SW16);
MLOCAL VOID       ResetBuffer(VOID);
MLOCAL VOID       SetDf(VOID);
MLOCAL VOID       PutByte(SW16);
MLOCAL VOID       PutWord(SW16);
MLOCAL VOID       PutLong(SL32);
MLOCAL VOID       PutRgb(LPSB8, SW16);
MLOCAL VOID       AfmToEtm(SW16);
MLOCAL VOID       PutEtm(SW16);
MLOCAL VOID       PutDeviceName(LPSB8);
MLOCAL VOID       PutFaceName(VOID);
MLOCAL VOID       PutFontName(LPSB8);
MLOCAL VOID       PutExtentTable(VOID);
MLOCAL VOID       PutPairKernTable(SW16);
MLOCAL VOID       PutTrackKernTable(VOID);
MLOCAL VOID       PutString(LPSB8);
MLOCAL VOID       PutOriginTable(VOID);
MLOCAL VOID			calcDfWidths (VOID);

#else	/* not LINT_ARGS */

GLOBAL UW16      ps_write();
MLOCAL SW16      write_t1_pfb_file();
MLOCAL UW16      write_t1_afm_file();
MLOCAL UW16      write_t1_pfm_file();
#if VFM
MLOCAL UW16      write_t1_vfm_file();
#endif
MLOCAL UW16      write_t1_pfb();
MLOCAL UW16      write_t1_pfm();
MLOCAL UW16      write_t1_afm();
#if VFM
MLOCAL UW16      write_t1_vfm();
#endif
MLOCAL VOID       psWrite();
MLOCAL UW16		initPS1();
MLOCAL VOID			freePS1mem ();
MLOCAL SW16			writeCharStrings();
MLOCAL VOID			encPSputCoord();
MLOCAL VOID			encPSmoveto();
MLOCAL VOID			encPSlineto();
MLOCAL VOID			encPScurveto();
MLOCAL UB8		CharEncrypt();
GLOBAL VOID       encWrite();
MLOCAL VOID			encEnd();
MLOCAL VOID			PScharEncrypt();
MLOCAL VOID       writePfbData();
MLOCAL VOID       spaceToDash();
MLOCAL UB8      eexecEncrypt();
MLOCAL VOID       encPut();
MLOCAL UW16      writePrivate();
GLOBAL UW16		PS1map ();
MLOCAL SW16			bld_widTab ();
MLOCAL SW16			bld_encode ();
MLOCAL UW16 		bld_kpTab ();
MLOCAL VOID       szMove();
MLOCAL VOID       ResetBuffer();
MLOCAL VOID       SetDf();
MLOCAL VOID       PutByte();
MLOCAL VOID       PutWord();
MLOCAL VOID       PutLong();
MLOCAL VOID       PutRgb();
MLOCAL VOID       AfmToEtm();
MLOCAL VOID       PutEtm();
MLOCAL VOID       PutDeviceName();
MLOCAL VOID       PutFaceName();
MLOCAL VOID       PutFontName();
MLOCAL VOID       PutExtentTable();
MLOCAL VOID       PutPairKernTable();
MLOCAL VOID       PutTrackKernTable();
MLOCAL VOID       PutString();
MLOCAL VOID       PutOriginTable();
MLOCAL VOID			calcDfWidths ();

#endif /* LINT_ARGS */

EXTERN PS1CODESTR PS1Codes[];
EXTERN SW16 nPS1Codes;
EXTERN PSPARAMSTR	PSparam_str;

#if T1HINTS
EXTERN STEMSTRUC	XStemStr, YStemStr;
#endif /* T1HINTS */

EXTERN IF_STATE     if_state;	/* add 8/21/91 - rs */

/*
MULTICALLER related variables 
*/
#if MULTICALLER
GLOBAL UW16 uCallerId;
#endif /* MULTICALLER */

/* Encryption variables for CharStrings */
GLOBAL UW16 CharStringR;
GLOBAL UW16 eexecR;
GLOBAL UW16 CharStringC1 = (UW16)52845;
GLOBAL UW16 CharStringC2 = 22719;

GLOBAL MEM_HANDLE hencodeVec = NULL;
GLOBAL MEM_HANDLE hencryptVec = NULL;
GLOBAL MEM_HANDLE hwidTab = NULL;

GLOBAL MEM_HANDLE hpfmData = NULL; /* 6/7/91 JFD */
GLOBAL LPUB8 encodeVec;
GLOBAL LPUB8 encryptVec;
GLOBAL PWIDTABSTR	widTab = NULL;

#ifdef _WINDOWS
GLOBAL UB8 far sbuff[132];   /* must be far for WINDOWS 09-26-91 jfd */
MLOCAL SB8 far PsFontName[TF_NAME_LEN];/* ' ' -> '-' fontname */

#define OPEN_MODE         S_IWRITE
#define PFB_EXTENSION     ".PFB"
#define PFM_EXTENSION     ".PFM"
#define AFM_EXTENSION     ".AFM"
#define VFM_EXTENSION     ".VFM"

#else
GLOBAL UB8 sbuff[132];   /* 09-25-91 jfd */
MLOCAL SB8 PsFontName[TF_NAME_LEN];/* ' ' -> '-' fontname */

#if defined (MSDOS) || defined (__OS2__)   /* added -ss 11/22/91 */
#define OPEN_MODE         S_IWRITE
#define PFB_EXTENSION     ".PFB"
#define PFM_EXTENSION     ".PFM"
#define AFM_EXTENSION     ".AFM"
#define VFM_EXTENSION     ".VFM"

#else  /* !MSDOS */

#define OPEN_MODE         0644
#define PFB_EXTENSION     ".pfb"
#define PFM_EXTENSION     ".pfm"
#define AFM_EXTENSION     ".afm"
#define VFM_EXTENSION     ".vfm"
#endif

#endif  /* !_WINDOWS */


MLOCAL TF			mytf;						/* our copy of typeface header */
MLOCAL PTF        ptf;                 /* TYPEFACEHEADER  (103)      */
MLOCAL PDISPLAY   pdh;                 /* DISPLAYHEADER   (301)      */
MLOCAL PFACE_ATT  pat;                 /* ATTRIBUTEHEADER (105)      */
MLOCAL UW16      tks_off;             /* TEXT KERN SEG offset (102)      */
MLOCAL UW16		fspacewidth;			/* fixed space char width (pixels) */
MLOCAL SW16       cg_capHeight;        /* Cap height (pixels)        */
MLOCAL SW16       cg_xHeight;          /* X-Height (pixels)          */
MLOCAL SW16       cg_ascender;         /* Maximum ascender (pixels)  */
MLOCAL SW16       cg_descender;        /* Maximum descender (pixels) */
MLOCAL SW16			cg_uscoreDepth;		/* underline position (pixels) */
MLOCAL UW16		cg_uscoreThickness;	/* underline thickness (pixels) */
GLOBAL SW16			cg_italicAngle;		/* italic angle (degrees) */
MLOCAL UB8		cg_isFixedPitch;		/* fixed pitch flag (0 = variable*/
                                       /* pitch, 1 = fixed pitch)       */

GLOBAL SW16 nEncode = 0;
GLOBAL SW16 prPScount = 0;
GLOBAL SL32	pfbOffset;
GLOBAL SW16 outFp;                     /* handle for file IO */
MLOCAL time_t ltime;							/* used for creation date of font */
#if TIMING
struct timeb timebuffer;               /* used for timing tests */
#endif

MLOCAL SW16	nChars;							/* # of chars in symbol set for font */

GLOBAL SW16	bboxllx;
GLOBAL SW16	bboxlly;
GLOBAL SW16	bboxurx;
GLOBAL SW16	bboxury;
GLOBAL SW16	StdHW, StdVW, StemSnapH[MAXSTDWIDTHS+1], StemSnapV[MAXSTDWIDTHS+1];
GLOBAL SW16 glob_x_dim, glob_y_dim;

/* ATECH variables for writing PFM file */

MLOCAL SW16 dfVersion = 0x0100;	/* Version 1.00 */
MLOCAL SL32 dfSize;
MLOCAL SB8 dfCopyright[60];
MLOCAL SW16 dfType;
MLOCAL SW16 dfPoints;
MLOCAL SW16 dfVertRes;
MLOCAL SW16 dfHorizRes;
MLOCAL SW16 dfAscent;
MLOCAL SW16 dfInternalLeading;
MLOCAL SW16 dfExternalLeading;
MLOCAL SB8 dfItalic;
MLOCAL SB8 dfUnderline;
MLOCAL SB8 dfStrikeOut;
MLOCAL SW16 dfWeight;
MLOCAL SB8 dfCharSet;
MLOCAL SW16 dfPixWidth;
MLOCAL SW16 dfPixHeight;
MLOCAL SW16 dfPitchAndFamily;
MLOCAL SW16 dfAvgWidth;
MLOCAL SW16 dfMaxWidth;
MLOCAL UB8 dfFirstChar;	/* change from SB8 to UB8 - 7/9/81 - rs */
MLOCAL UB8 dfLastChar;	/* change from SB8 to UB8 - 7/9/81 - rs */
MLOCAL UB8 dfDefaultChar;/* change from SB8 to UB8 - 7/9/81 - rs */
MLOCAL UB8 dfBreakChar;	/* change from SB8 to UB8 - 7/9/81 - rs */
MLOCAL SW16 dfWidthBytes;
MLOCAL SL32 dfDevice;
MLOCAL SL32 dfFace;
MLOCAL SL32 dfBitsPointer;
MLOCAL SL32 dfBitsOffset;
MLOCAL SW16 dfSizeFields;
MLOCAL SL32 dfExtMetricsOffset;
MLOCAL SL32 dfExtentTable;
MLOCAL SL32 dfOriginTable;
MLOCAL SL32 dfPairKernTable;
MLOCAL SL32 dfTrackKernTable;
MLOCAL SL32 dfDriverInfo;
MLOCAL SL32 dfReserved;

MLOCAL SW16 etmSize;
MLOCAL SW16 etmPointSize;
MLOCAL SW16 etmOrientation;
MLOCAL SW16 etmMasterHeight;
MLOCAL SW16 etmMinScale;
MLOCAL SW16 etmMaxScale;
MLOCAL SW16 etmMasterUnits;
MLOCAL SW16 etmCapHeight;
MLOCAL SW16 etmXHeight;
MLOCAL SW16 etmLowerCaseAscent;
MLOCAL SW16 etmUpperCaseDecent;
MLOCAL SW16 etmSlant;
MLOCAL SW16 etmSuperScript;
MLOCAL SW16 etmSubScript;
MLOCAL SW16 etmSuperScriptSize;
MLOCAL SW16 etmSubScriptSize;
MLOCAL SW16 etmUnderlineOffset;
MLOCAL SW16 etmUnderlineWidth;
MLOCAL SW16 etmDoubleUpperUnderlineOffset;
MLOCAL SW16 etmDoubleLowerUnderlineOffset;
MLOCAL SW16 etmDoubleUpperUnderlineWidth;
MLOCAL SW16 etmDoubleLowerUnderlineWidth;
MLOCAL SW16 etmStrikeOutOffset;
MLOCAL SW16 etmStrikeOutWidth;
MLOCAL SW16 etmNKernPairs;
MLOCAL SW16 etmNKernTracks;

/* Symbol set info */
EXTERN SYMBOLSET symbolset;

GLOBAL SW16       cbBuffer;
GLOBAL LPSB8      pbBuffer;
MLOCAL LPSB8      pfmData; /* dereferenced from hpfmData */
#if VFM
MLOCAL SB8 str0to6[] = "0123456"; 	/* for vfm file by write_t1_vfm_file() */
#endif

/*
Kerning related variables
*/
EXTERN CG_KERN_TBL  cg_kern_tbl[];
EXTERN SW16	nmKrnPrs;		/* total possible # of kern pairs in master list */
EXTERN KERN_PAIR kp_tbl[];	/* actual kern pair table for font */
MLOCAL SW16	naKrnPrs;		/* total actual # of kern pairs in font */


/* The following code added to support WINDOWS 07-26-91 jfd */
#ifdef _WINDOWS

typedef struct tagOFSTRUCT
  {
    SB8    cBytes;
    SB8    fFixedDisk;
    SW16    nErrCode;
    SB8    reserved[4];
    SB8    szPathName[128];
  } OFSTRUCT;

typedef OFSTRUCT far   *LPOFSTRUCT;

#define OF_CREATE	          0x1000  /* Flags for OpenFile */
#define OF_SHARE_COMPAT     0x0000

typedef SB8 far	    *LPSTR;
int  far pascal OpenFile(LPSTR, LPOFSTRUCT, SW16);

MLOCAL  OFSTRUCT ofFile;
#endif



/* Try using a static.s buffer for handling IO rather than
   alocating it from CACHE
 */


#if defined (ANSI_DEFS)
MLOCAL UW16 initPS1()
#else
MLOCAL UW16 initPS1()
#endif
/*
Initialization function for IF to PS1 conversion ->

	Allocate buffers for conversion, set global handles:
		hencodeVec	-	handle to buffer to encode vectors
		hencryptVec	-	handle to buffer to encrypt vectors
		hwidTab		-	handle to buffer for width table
      hpfmData    -  handle to PFM data buf (6/7/91 JFD) - if pfm requested

	return (SUCCESS) if no error, else (error code)
*/
{
	if (!(hencodeVec = CHARalloc((SL32)ENCVECSIZE)))
	{
		DBG("initPS1() - nomem - encodeVec\n");
		return(ERRmem);
	}

	if (!(hencryptVec = CHARalloc((SL32)ENCVECSIZE)))
	{
		DBG("initPS1() - nomem - encryptVec\n");
		freePS1mem ();
		return(ERRmem);
	}
	if (!(hwidTab = CHARalloc((SL32)(MAXPS_SYMBOLS * sizeof(WIDTABSTR)))))
	{
		DBG("initPS1() - nomem - widTab\n");
		freePS1mem ();
		return(ERRmem);
	}

	if (PSparam_str.filetypes & PS_PFM_FILE)
		if (!(hpfmData = CHARalloc((SL32)(MAXPFMDATA))))  /* 6/7/91 JFD */
		{
			DBG("initPS1() - nomem - pfmData\n");
			freePS1mem ();
			return(ERRmem);
		}

	return(SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL VOID freePS1mem ()
#else
MLOCAL VOID freePS1mem ()
#endif
/*
This function will free all 'widely' used memory handles for the PS1 system.

These include:
	hencodeVec, hencryptVec, hwidTab, hsbuff and hpfmData
		
Each of these handles should be NULL if not allocated. They will
be freed via CHARFree if allocated.

Returns (nothing)
*/
{
	if (hencodeVec)
	{
		CHARfree (hencodeVec);
		hencodeVec = NIL_MH;
	}
	if (hencryptVec)
	{
		CHARfree (hencryptVec);
		hencryptVec = NIL_MH;
	}
	if (hwidTab)
	{
		CHARfree (hwidTab);
		hwidTab = NIL_MH;
	}
	if (hpfmData)
   {
	   CHARfree(hpfmData);  /* 6/7/91 JFD */
      hpfmData = NIL_MH;   /* 8/6/91 jfd */
   }
	return ;
}

#if defined (ANSI_DEFS)
MLOCAL SW16 writeCharStrings()
#else
MLOCAL SW16 writeCharStrings()
#endif
/*
This is the main worker function for IF to PS Type 1 conversion.

Each character in the current symbol set will have an Intellifont cubic
Bezier outline created (a la PostScript style). This outline will then
be converted to a PS Type 1 outline and output to the current PFB output
file. All other requested output file will also be processed.

All 'global' PS information/headers should have previously been processed
and output to the PFB file. The current file position should be ready to
receive the global bounding box data.

NOTE: uses global string buffer 'sbuff'.

We will return (SUCCESS) if no errors, else (error code)
*/
{
SL32 tmpl;
SL32 olDataSz;
SW16 tmpw;
SW16 x0,y0,x1,y1,x2,y2,x3,y3;
UW16 chId;
UW16 ures, num_loops, num_segs, num_coords;
UW16 loop_ctr, seg_ctr, total_segs;
HIFOUTLINE hol;
PIFOUTLINE	pol;
POUTLINE_CHAR outchar;
PINTRVECTOR points;
LPSB8 segment;
SW16 xscale, yscale;
SW16	hnum;

#ifdef HINTS
struct olCharStr olChar;
struct ruleHdrStr ruleHdr;
#endif /* HINTS */

/*
Start the CharStrings dictionary
*/
	encWrite((LPUB8)"dup/CharStrings 260 dict dup begin\r\n");

	/*
	 * build and output character data
	 */
	for (chId = 0; chId < MAXPS_SYMBOLS; chId++)
	{
		if (widTab[chId].ps1_off == -1)
			continue;

		/*
		 * Create the character outline
		 */
		hol = NIL_MH;
		ures = cgif_Char_Handle(chId, (PHIFBITMAP)&hol, 0);

		/*
			Process the fixed space character in a special way. We will not
			generate an outline but we do need the character & it's metrics.
		*/
		if (ures == ERR_fixed_space)	/* hol should == 0, not processed by IF */
		{
		/*
			Use four zeros as the random 4 bits at the start of the vector
		*/
			encodeVec[0] = encodeVec[1] = encodeVec[2] = encodeVec[3] = 0;
			nEncode = 4;
		/*
			Update bounding box info in WIDTABSTR for afm file.
		*/
		widTab[chId].bboxllx = widTab[chId].bboxlly
		= widTab[chId].bboxurx = widTab[chId].bboxury = 0;

		/*
			Start with sidebearing point and character width
		*/
			encPSputCoord(0);	/* xmin */
			widTab[chId].cg_width = fspacewidth;
			encPSputCoord(fspacewidth);
			encodeVec[nEncode++] = c_HSBW;

			encodeVec[nEncode++] = c_ENDCHAR;
			PScharEncrypt((LPUB8)encodeVec,nEncode,(LPUB8)encryptVec);

			SPRINTF(sbuff,"/%s %d RD ",
#ifdef _WINDOWS
				(LPSB8)(PS1Codes[widTab[chId].ps1_off].adobeName),
#else
				PS1Codes[widTab[chId].ps1_off].adobeName,
#endif
            nEncode);
			encWrite((LPUB8)sbuff);
			encPut((LPUB8)encryptVec,nEncode);
			encWrite((LPUB8)" ND\r\n");

         CHARfree (hol);  /* Added 5/5/94, jwd. Cures memory limit failures. */
			continue;
		}

		if (ures)
		{
			if (hol)
				CHARfree (hol);
			DBG1("writeCharStrings() - Error creating character outline %d\n",
				ures);
			return(ures);
		}

#if T1HINTS	/* add 8/23/91 - rs */
		/*
			Generate hints for this character
		*/
		ures = StemGen ();
        if (ures)
		{
			CHARfree (hol);
			DBG1("writeCharStrings() - Error creating character stem hints %d\n",
				ures);
			return (ures);
		}

	/*
		We must generate 'ghost' stems if there are no HSTEMS at the top
		and bottom of the character or no VSTEMS at the left and right.
	*/
		ures = ghost_stems ();
        if (ures)
		{
			CHARfree (hol);
			DBG1("writeCharStrings() - Error creating ghost stems %d\n",
				ures);
			return (ures);
		}

#endif /* T1HINTS */

		/*
		 * Process outline data
		 */
		pol = (PIFOUTLINE)MEMptr (hol);	/* deref outline handle */
		outchar = &pol->ol;

		olDataSz = outchar->size;
        if (olDataSz)
		{
			if (olDataSz > (SL32)MAXOLDATA)
			{
				if (hol)
					CHARfree (hol);
				DBG1("writeCharStrings() - Outline data too large %ld\n",
					olDataSz);
				return(ERR_bm_too_big);
			}
		}

	/*
		For our purposes, xscale & yscale will always fit into 16 bits.
		In order to optimize, we will convert these values into a shift
		factor. They are guaranteed to be a power of 2.
	*/

	xscale = yscale = 0;
	tmpl = pol->xscale;
	while (tmpl >>= 1)
		xscale++;
	tmpl = pol->yscale;
	while (tmpl >>= 1)
		yscale++;

#ifdef HINTS
		ruleHdr.xRules = 0;
		ruleHdr.yRules = 0;
#endif /* HINTS */

		/*
		 * Output PS char header
		 */

		/* Use four zeros as the random 4 bits at the start of the vector */
		encodeVec[0] = encodeVec[1] = encodeVec[2] = encodeVec[3] = 0;
		nEncode = 4;

		/*
			Add character bounding box info to WIDTABSTR. This is used
			for afm file. - 7/1/91 - rs
		*/
		widTab[chId].bboxllx = (pol->left >> xscale);
		widTab[chId].bboxlly = (pol->bottom >> yscale);
		widTab[chId].bboxurx = (pol->right >> xscale);
		widTab[chId].bboxury = (pol->top >> yscale);

		/*
			Update global bounding box info, do xmin here, finish below
			NOTE: PS may want origin at 0
		*/
		tmpw = (pol->left >> xscale);
		if (bboxllx > tmpw)
			bboxllx = tmpw;

		/* Start with sidebearing point and character width */
		encPSputCoord(tmpw);	/* xmin */
		/*
			we must convert escapement from our designer units (8782 to the em
			to PS designer units (1000 to the em)
		*/
		tmpl = (((SL32)(pol->escapement) * 1000L) + 4391L) / 8782L;
		widTab[chId].cg_width = (SW16)tmpl;	/* save char width */
		encPSputCoord((SW16)tmpl);	/* widTabl[i] */
		encodeVec[nEncode++] = c_HSBW;

#if T1HINTS	/* add 8/26/91 - rs */
		/*
			Write the stem hints if any are available
		*/
		if (XStemStr.numStems)
			for (hnum = 0; hnum < XStemStr.numStems; hnum++)
			{
				encPSputCoord(XStemStr.a[hnum].loc);
				encPSputCoord(XStemStr.a[hnum].width);
				encodeVec[nEncode++] = c_VSTEM;
				prPScount++;
			}
		if (YStemStr.numStems)
			for (hnum = 0; hnum < YStemStr.numStems; hnum++)
			{
				encPSputCoord(YStemStr.a[hnum].loc);
				encPSputCoord(YStemStr.a[hnum].width);
				encodeVec[nEncode++] = c_HSTEM;
				prPScount++;
			}
#endif /* T1HINTS */

		/* The current point is set to the sidebearing */
		x0 = tmpw;	/* xmin */
		y0 = 0;

		/*
			Finish updating bounding box
		*/
		tmpw = (pol->right >> xscale);
		if (bboxurx < tmpw)
			bboxurx = tmpw;
		tmpw = (pol->top >> yscale);
		if (bboxury < tmpw)
			bboxury = tmpw;
		tmpw = (pol->bottom >> yscale);
		if (bboxlly > tmpw)
			bboxlly = tmpw;

		/*
		 * Output outline data
		 */
		if (!olDataSz)	/* do we need this? */
		{
			CHARfree (hol);
			hol = NIL_MH;
			continue;
		}

		num_loops = outchar->num_loops;
		total_segs = 0;
		for (loop_ctr = 0; loop_ctr < num_loops; loop_ctr++)
		{
			num_segs = outchar->loop[loop_ctr].num_segmts;
			total_segs += num_segs;
/*
NOTE:	There may be a limit of 500 "elements" as per the type 3
		writer. Something to do with LaserJet PostScript?
*/
			if (total_segs > LIMITCHECK)
			{	/* PS allows 1500 "flattened paths" per char - B&W:27 */
				if (hol)
					CHARfree (hol);
				DBG1("writeCharStrings() - Too many segments in char %d\n",
					total_segs);
				return(ERR_ps_toomanysegs);
			}
			segment = (LPSB8)((LPSB8)(outchar->loop)
				+ outchar->loop[loop_ctr].segmt_offset);
			num_coords = outchar->loop[loop_ctr].num_coords;
			points = (PINTRVECTOR)((LPSB8)(outchar->loop)
				+ outchar->loop[loop_ctr].coord_offset);

			/*
				If the last segment is a LINETO, remove it. CLOSEPATH will
				handle this. - 9/3/91 - rs
			*/
			if (*(segment + num_segs - 1) == IFLINETO)
				num_segs--;

			for (seg_ctr = 1; seg_ctr <= num_segs; seg_ctr++)
			{
				switch (*segment++)
				{
				case IFMOVETO:
				/*	MOVETO segment - extract one point */
					x1 = (SW16)(points->x >> (INTR)xscale);
					y1 = (SW16)(points->y >> (INTR)yscale);
					points++;

					encPSmoveto(x0, y0, x1, y1);
					x0 = x1;
					y0 = y1;
					break;

				case IFLINETO:
				/* LINETO segment - extract 1 point */
					x1 = (SW16)(points->x >> (INTR)xscale);
					y1 = (SW16)(points->y >> (INTR)yscale);
					points++;

				/*
					If duplicate point (lineto where we already are), discard
					Intellifont sometimes needs these points but we don't
				*/
					if ((x0 == x1) && (y0 == y1))
						break;

					encPSlineto(x0, y0, x1, y1);
					x0 = x1;
					y0 = y1;
					break;

				case IFBEZIERTO:
				/* cubic bezier curve to - extract 3 points */
					x1 = (SW16)(points->x >> (INTR)xscale);
					y1 = (SW16)(points->y >> (INTR)yscale);
					points++;

					x2 = (SW16)(points->x >> (INTR)xscale);
					y2 = (SW16)(points->y >> (INTR)yscale);
					points++;

					x3 = (SW16)(points->x >> (INTR)xscale);
					y3 = (SW16)(points->y >> (INTR)yscale);
					points++;

					encPScurveto(x0, y0, x1, y1, x2, y2, x3, y3);
					x0 = x3;
					y0 = y3;
					break;

				default:
					if (hol)
						CHARfree (hol);
					DBG1("writeCharStrings() - Invalid outline data %d\n",
						(SW16)(*(segment-1)));
					return(ERR_ps_unk_seg);
				} /* switch (*segment++) */
			} /* for (seg_ctr... ) */
			/*
				End of this loop, let's close it
			*/
			encodeVec[nEncode] = c_CLOSEPATH;
			nEncode++;
			prPScount++;
		} /* for (loop_ctr... ) */

		CHARfree (hol);
		hol = NIL_MH;
		encodeVec[nEncode++] = c_ENDCHAR;

		PScharEncrypt((LPUB8)encodeVec,nEncode,(LPUB8)encryptVec);

		SPRINTF(sbuff,"/%s %d RD ",
#ifdef _WINDOWS
			(LPSB8)(PS1Codes[widTab[chId].ps1_off].adobeName),
#else
			PS1Codes[widTab[chId].ps1_off].adobeName,
#endif         
         nEncode);

		encWrite((LPUB8)sbuff);
		encPut((LPUB8)encryptVec,nEncode);
		encWrite((LPUB8)" ND\r\n");
	} /* for (chId = 0; chId < MAXPS_SYMBOLS; chId++) - all chars in sym set */

	/* Add the .notdef character */
	encodeVec[0] = encodeVec[1] = encodeVec[2] = encodeVec[3] = 0;
	nEncode = 4;
	encPSputCoord(0);
	encPSputCoord(0);
	encodeVec[nEncode++] = c_HSBW;
	encodeVec[nEncode++] = c_ENDCHAR;
	PScharEncrypt((LPUB8)encodeVec,nEncode,(LPUB8)encryptVec);

	SPRINTF(sbuff,"/.notdef %d RD ", nEncode);
	encWrite((LPUB8)sbuff);
	encPut((LPUB8)encryptVec,nEncode);
	encWrite((LPUB8)" ND\r\n");

	encWrite((LPUB8)"end\r\n");
	encWrite((LPUB8)"readonly put\r\n");
	encWrite((LPUB8)"dup /FontName get exch definefont pop\r\n");
	encWrite((LPUB8)"mark currentfile closefile ");

	/* Write Binary text header data */
	writePfbData(PFB_BINARY);

	encEnd();

	if (hol)
		CHARfree (hol);
	return(SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL UW16 writePrivate()
#else
MLOCAL UW16 writePrivate()
#endif
/*
Write userdict entries for RD, ND & NP. Also write Private dict and start
CharStrings.
*/
{
UW16    status;
PBUCKET  bucket;
LPSB8    pfgseg;           /* pointer to face global segment */

	encWrite((LPUB8)"%%%%%% Four discardable bytes needed for encryption\r\n");
	encWrite((LPUB8)"\r\n");

#define USERDICT	1		/* Atech's method */
#ifdef USERDICT			/* Atech's method */
/*
We had a problem getting pipeline 't1' to eat fonts w/userdict before Private
try another approach - 5/30/91 - rs
This got us past this point but 't1' still didn't like the entire file. It
apparently wants ascii hex files instead of binary because it searches for
ascii string 'Private' in unencrypted form. We'll stick w/Atech's method.
*/
	encWrite((LPUB8)"userdict/RD{string currentfile exch readstring pop}executeonly put\r\n");
	encWrite((LPUB8)"userdict/ND{noaccess def}executeonly put\r\n");
	encWrite((LPUB8)"userdict/NP{noaccess put}executeonly put\r\n");
#endif /* USERDICT */
	encWrite((LPUB8)"dup/Private 10 dict dup begin\r\n");

#ifndef USERDICT			/* Adobe's method */
	encWrite((LPUB8)"/RD {string currentfile exch readstring pop} executeonly def\r\n");
	encWrite((LPUB8)"/ND {noaccess def} executeonly def\r\n");
	encWrite((LPUB8)"/NP {noaccess put} executeonly def\r\n");
#endif /* USERDICT */
	writeBlueValues();
	/*
		BlueScale = [(ptsize-0.49) / 240] for 300 dpi
		should be between 9 and 10 pt (re CG designers)
	*/
#if 0
	encWrite ((LPUB8)"/BlueScale 0.039625 def\r\n");	/* add 9/3/91 - rs */
#else	/* try this value - 9/11/91 - rs */
	encWrite ((LPUB8)"/BlueScale 0.045455 def\r\n");	/* add 9/11/91 - rs */
#endif

   /*
		Get Global Intellifont Segment - 8/20/91 - rs
	*/
    status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &bucket);
    if (status)
	{
		freePS1mem ();
		return (status);
	}
    pfgseg = fgseg (bucket);
	if (bucket->p.in.ogif != MAX_UWORD)
	{
	/*
		Make sure the global data is resident
	*/
		if (!if_init_glob (bucket))
		{
			freePS1mem ();
			return (ERR_if_init_glob);
		}
		/*
			Get the standard temp widths while we have the right bucket
			- use Global Intellifont data - 8/20/91 - rs
		*/
		if (if_state.if_flag && if_state.glob_y_dim.num_dim)
			glob_y_dim = (SW16) ((((SL32)if_state.glob_y_dim.value[0] * 1000L)
				+ 4391L) / 8782L);
		else glob_y_dim = 0;
		if (if_state.if_flag && if_state.glob_x_dim.num_dim)
			glob_x_dim = (SW16) ((((SL32)if_state.glob_x_dim.value[0] * 1000L)
				+ 4391L) / 8782L);
		else glob_x_dim = 0;
	} /* if (bucket->ogif != MAX_UWORD) */
	else /* no global data available */
	{
		glob_x_dim =  glob_y_dim = 0;
	}

#if T1HINTS
	status = writeStdWidths();
    if (status)
	{
		freePS1mem ();
		return (status);
	}
#endif /* T1HINTS */

	(dfWeight >= FW_MEDIUM) ? /* add ForceBold - 7/19/91 - rs */
		encWrite((LPUB8)"/ForceBold true def\r\n") :
		encWrite((LPUB8)"/ForceBold false def\r\n");
	encWrite((LPUB8)"/MinFeature{16 16} def\r\n"); /* change 'ND' to 'def' - 7/19/91 -rs */
	encWrite((LPUB8)"/password 5839 def\r\n");
	encWrite((LPUB8)"end NP\r\n");
	encWrite((LPUB8)"\r\n");
	return (SUCCESS);
}

/*-------------------------------------------------------------------------*
 *
 *  Name:
 *      encPSputCoord
 *
 *  Description:
 *      Ouputs the specified coordinate value in compressed form as follows:
 *
 *          -107 <= d <=  107  -> output: (d + 139)
 *           108 <= d <= 1131  -> output: (d % 256) + 247 and 108 + (d / 256)
 *         -1131 <= d <= -108  -> output: (d % 256) + 251 and 108 + (d / 256)
 *               otherwise     -> 255 + 4 2's complement bytes
 *
 *  Input:
 *      d       - Coord value to output
 *
 *  Output:
 *      NONE
 *
 *-------------------------------------------------------------------------*/

#if defined (ANSI_DEFS)
MLOCAL VOID encPSputCoord(SW16 d)
#else
MLOCAL VOID encPSputCoord(d)
SW16 d;
#endif
{
SW16 n;

	if (d >= -107 && d <= 107)
		encodeVec[nEncode++] = (UB8)(d + 139);
	else
	if (d >= 108 && d <= 1131)
	{
		d -= 108;
		n = d/256;
		encodeVec[nEncode++] = (UB8)(247 + n);
		encodeVec[nEncode++] = (UB8)(d - (n*256));
	}
	else
	if (d >= -1131 && d <= -108)
	{
		d += 108;
		n = -d/256;
		encodeVec[nEncode++] = (UB8)(251 + n);
		encodeVec[nEncode++] = (UB8)(-d - (n*256));
	}
	else
	{
		encodeVec[nEncode++] = 255;

		if (d < 0)
		{
			encodeVec[nEncode++] = 255;
			encodeVec[nEncode++] = 255;
		}
		else
		{
			encodeVec[nEncode++] = 0;
			encodeVec[nEncode++] = 0;
		}
		encodeVec[nEncode++] = (UB8)(d>>8);
		encodeVec[nEncode++] = (UB8)(d & 0xff);
	}
}

/*-------------------------------------------------------------------------*
 *
 *  Name:
 *      encPSmoveto
 *
 *  Description:
 *      Output a moveto command (use rmoveto command)
 *
 *  Input
 *      x0,y0   - Coord of current point
 *      x1,y1   - Coord of point to move to
 *
 *  Output:
 *      NONE
 *
 *-------------------------------------------------------------------------*/

#if defined (ANSI_DEFS)
MLOCAL VOID encPSmoveto(SW16 x0, SW16 y0, SW16 x1, SW16 y1)
#else
MLOCAL VOID encPSmoveto(x0, y0, x1, y1)
SW16 x0, y0;
SW16 x1, y1;
#endif
{
SW16 dx,dy;

	dx = x1 - x0;
	dy = y1 - y0;

	if (dx == 0)
	{
		encPSputCoord(dy);
		encodeVec[nEncode] = c_VMOVETO;
		nEncode++;
		prPScount++;
	}
	else
	if (dy == 0)
	{
		encPSputCoord(dx);
		encodeVec[nEncode] = c_HMOVETO;
		nEncode++;
		prPScount++;
	}
	else
	{
		encPSputCoord(dx);
		encPSputCoord(dy);
		encodeVec[nEncode] = c_RMOVETO;
		nEncode++;
		prPScount++;
	}
}

/*-------------------------------------------------------------------------*
 *
 *  Name:
 *      encPSlineto
 *
 *  Description:
 *      Output a lineto command (use rlineto command)
 *
 *  Input
 *      x0,y0   - Coord of current point
 *      x1,y1   - Coord of point to draw line to
 *
 *  Output:
 *      NONE
 *
 *-------------------------------------------------------------------------*/

#if defined (ANSI_DEFS)
MLOCAL VOID encPSlineto(SW16 x0, SW16 y0, SW16 x1, SW16 y1)
#else
MLOCAL VOID encPSlineto(x0, y0, x1, y1)
SW16 x0, y0;
SW16 x1, y1;
#endif
{
SW16 dx,dy;

	dx = x1 - x0;
	dy = y1 - y0;

	if (dx == 0)
	{
		encPSputCoord(dy);
		encodeVec[nEncode] = c_VLINETO;
		nEncode++;
		prPScount++;
	}
	else
	if (dy == 0)
	{
		encPSputCoord(dx);
		encodeVec[nEncode] = c_HLINETO;
		nEncode++;
		prPScount++;
	}
	else
	{
		encPSputCoord(dx);
		encPSputCoord(dy);
		encodeVec[nEncode] = c_RLINETO;
		nEncode++;
		prPScount++;
	}
}

/*-------------------------------------------------------------------------*
 *
 *  Name:
 *      encPScurveto
 *
 *  Description:
 *      Output a curveto command (use rrcurveto command)
 *
 *  Input
 *      x0,y0   - Coord of current point
 *      x1,y1   - First Bezier control point
 *      x2,y2   - Second Bezier control point
 *      x3,y3   - Curve endpoint
 *
 *  Output:
 *      NONE
 *
 *-------------------------------------------------------------------------*/

#if defined (ANSI_DEFS)
MLOCAL VOID encPScurveto(SW16 x0, SW16 y0, SW16 x1, SW16 y1, 
    SW16 x2, SW16 y2, SW16 x3, SW16 y3)
#else
MLOCAL VOID encPScurveto(x0, y0, x1, y1, x2, y2, x3, y3)
SW16 x0, y0;
SW16 x1, y1;
SW16 x2, y2;
SW16 x3, y3;
#endif
{
SW16 dx1,dy1,dx2,dy2,dx3,dy3;

	dx1 = x1 - x0;
	dy1 = y1 - y0;

	dx2 = x2 - x1;
	dy2 = y2 - y1;

	dx3 = x3 - x2;
	dy3 = y3 - y2;

	/* Arguments are relative to each other 
	*  rrcurveto is equivalent to 
	*  dx1 dy1 (dx1+dx2) (dy1+dy2) (dx1+dx2+dx3) (dy1+dy2+dy3) rcurveto
	*/

	if (dy1 == 0 && dx3 == 0)
	{
		encPSputCoord(dx1);
		encPSputCoord(dx2);
		encPSputCoord(dy2);
		encPSputCoord(dy3);
		encodeVec[nEncode] = c_HCURVETO;
		nEncode++;
		prPScount++;
	}
	else
	if (dx1 == 0 && dy3 == 0)
	{
		encPSputCoord(dy1);
		encPSputCoord(dx2);
		encPSputCoord(dy2);
		encPSputCoord(dx3);
		encodeVec[nEncode] = c_VHCURVETO;
		nEncode++;
		prPScount++;
	}
	else
	{
		encPSputCoord(dx1);
		encPSputCoord(dy1);
		encPSputCoord(dx2);
		encPSputCoord(dy2);
		encPSputCoord(dx3);
		encPSputCoord(dy3);
		encodeVec[nEncode] = c_RRCURVETO;
		nEncode++;
		prPScount++;
	}
}

#if defined (ANSI_DEFS)
MLOCAL VOID psWrite(LPUB8 s)
#else
MLOCAL VOID psWrite(s)
LPUB8 s;
#endif
{
	WRITEF(outFp, (LPSB8)s, STRLEN(s));
}


#if defined (ANSI_DEFS)
GLOBAL VOID encWrite(LPUB8 s)
#else
GLOBAL VOID encWrite(s)
LPUB8 s;
#endif
{
	encPut((LPUB8)s,STRLEN(s));
}

#if defined (ANSI_DEFS)
MLOCAL VOID encPut(LPUB8 s, SW16 n)
#else
MLOCAL VOID encPut(s,n)
LPUB8 s;
SW16 n;
#endif
{
SW16 i;
UB8 c2;

	for (i = 0; i < n; i++)
	{
		c2 = eexecEncrypt(s[i]);
		WRITEF (outFp, (LPSB8)&c2, (SW16)1);
	}
}

#if defined (ANSI_DEFS)
MLOCAL VOID encEnd()
#else
MLOCAL VOID encEnd()
#endif
{
SW16 i,j;
	WRITEF(outFp,(LPSB8)"\r\n", 2);
	for (i = 0; i < 8; i++)
	{
		for (j = 0; j < 64; j++)
			WRITEF(outFp, (LPSB8)"0", (SW16)1);
		WRITEF(outFp,(LPSB8)"\r\n", (SW16)2);
	}
	WRITEF(outFp,(LPSB8)"\r\n", 2);
	WRITEF(outFp,(LPSB8)"cleartomark \r\n", (SW16)14);
}

#if defined (ANSI_DEFS)
MLOCAL VOID PScharEncrypt(LPUB8 encodeVec, SW16 nEncode, LPUB8 encryptVec)
#else
MLOCAL VOID PScharEncrypt(encodeVec,nEncode,encryptVec)
LPUB8 encodeVec, encryptVec;
SW16 nEncode;
#endif
{
SW16 i;

	CharStringR = 4330;
	for (i=0;i<nEncode;i++)
		encryptVec[i] = CharEncrypt(encodeVec[i]);
}

#if defined (ANSI_DEFS)
MLOCAL UB8 CharEncrypt(UB8 plain)
#else
MLOCAL UB8 CharEncrypt(plain)
UB8 plain;
#endif
{
UB8 cipher;

	cipher = (plain ^ (CharStringR >> 8));
	CharStringR = (cipher + CharStringR) * CharStringC1 + CharStringC2;

	return cipher;
}

#if defined (ANSI_DEFS)
MLOCAL UB8 eexecEncrypt(UB8 plain)
#else
MLOCAL UB8 eexecEncrypt(plain)
UB8 plain;
#endif
{
UB8 cipher;

	cipher = (plain ^ (eexecR >> 8));
	eexecR = (cipher + eexecR) * CharStringC1 + CharStringC2;

	return cipher;
}

#if defined (ANSI_DEFS)
MLOCAL VOID writePfbData(SW16 type)
#else
MLOCAL VOID writePfbData(type)
SW16 type;
#endif
{
SL32 curOffset;
UL32 nBytes;
UB8 c [7];
#ifdef LAMIGA
   UB8 dummy [] ={0,0,0,0,0,0};  /* for expanding file size before lseek past end-of-file */
#endif   

#if 0
	curOffset = tell(outFp);
#endif
   curOffset = lseek(outFp, 0L, SEEK_CUR);


#ifdef LAMIGA
   WRITEF (outFp,(LPSB8)dummy, 6); 
#endif

	LSEEK(outFp,pfbOffset,SEEK_SET);

   c[0] = 128;                          /* Binary Postscript */
   c[1] = (UB8)type;                  /* ASCII or Binary data */
	nBytes = curOffset - pfbOffset - 6;
	c[2] = (UB8)(nBytes & 0xff);
	c[3] = (UB8)((nBytes >> 8) & 0xff);
	c[4] = (UB8)((nBytes >> 16) & 0xff);
	c[5] = (UB8)((nBytes >> 24) & 0xff);
	WRITEF(outFp, (LPSB8)c, (SW16)6);

	pfbOffset = curOffset;
	LSEEK(outFp, (SL32)(curOffset + 6), SEEK_SET);
}

#if defined (ANSI_DEFS)
MLOCAL VOID spaceToDash(LPSB8 in, LPSB8 out)
#else
MLOCAL VOID spaceToDash(in, out)
LPSB8 in, out;
#endif
{
SW16 i;

	if (in != out)	/* added this line only - 6/13/91 - rs */
		STRCPY(out,in);
	for (i = 0; i < STRLEN(out); i++)
		if (out[i] == ' ')
			out[i] = '-';
}

/**************************************************************************/
/* start of Joe's code */


/*-----------------------------*/
/*      write_t1_pfb_file      */
/*-----------------------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16  write_t1_pfb_file()
#else
MLOCAL SW16
write_t1_pfb_file()
#endif
{

  /* We need the following data:
   *
   *     KEYWORD            DATA
   *     -------            ----
   *     FontName           PsFontName
   *
   *     FullName           PsFontName
   *
   *     Weight             mytf.weight
   *
   *     ItalicAngle        cg_italicAngle (Jim always includes this!)
   *
   *     FontMatrix         NOTE: Jim is hard-wiring to ".001 0 0 .001 0 0"
   *
	* Uses global 'PsFontName[] for '-' instead of ' ' name
	* uses static 'ltime' for creation date.
	*
	* NOTE: uses global string buffer 'sbuff'.
   */

   SW16    status;
	SL32 BB_bookmark, tmp_bookmark;
   SW16    c;           /* 07-26-91 jfd */

#ifdef LAMIGA
   UB8 dummy [] ={0,0,0,0,0,0};  /* for expanding file size before lseek past end-of-file */
#endif   

	/* Set up eexec encryption key */
	eexecR = (UW16)55665;

	/* Skip past encoding data */

	pfbOffset = 0L;

#ifdef LAMIGA
   WRITEF (outFp,(LPSB8)dummy, 6); 
#endif

	LSEEK(outFp, 6L, SEEK_SET);

#ifdef GERNERICTYPE1	/* generic form doesn't work w/ATM & ami-pro */
	/* Change to "proper" 1st line - 6/14/91 - rs */

	SPRINTF(sbuff,"%%!FontType1-1.0: %s\r\n", PsFontName);

#else /* ADOBETYPE1 */ /* This form works w/ATM & ami-pro */

	SPRINTF(sbuff,"%%!PS-AdobeFont-1.0: %s\r\n", PsFontName);

#endif /* GENERICTYPE1 */
	psWrite((LPUB8)sbuff);

	/* add CreationDate - 6/14/91 - rsbuff */

#ifdef _WINDOWS
	SPRINTF(sbuff,"%%%%CreationDate: %s\r\n", (LPSB8)ctime(&ltime));
#else
	SPRINTF(sbuff,"%%%%CreationDate: %s\r\n", ctime(&ltime));
#endif
   psWrite((LPUB8)sbuff);

	/* Add Agfa copyright comment - 6/14/91 - rs */

	SPRINTF (sbuff,"%% Copyright (c) 1991 Agfa Corporation. All rights reserved\r\n");
	psWrite ((LPUB8)sbuff);

	psWrite("11 dict begin\r\n");
	psWrite("/FontInfo 8 dict dup begin\r\n");
	psWrite("/Notice (Copyright (c) Agfa Corp. 1991. All rights reserved.) readonly def\r\n");
	psWrite("/version (1.0) readonly def\r\n");
	/*
		Substitute mytf.typeFaceName for PsFontName - 7/1/91 - rs
	*/
#if PSFONTNAME
	SPRINTF(sbuff,"/FullName (%s) readonly def\r\n", PsFontName);
#else /* name with spaces */
#ifdef _WINDOWS
	SPRINTF(sbuff,"/FullName (%s) readonly def\r\n", (LPSB8)mytf.typeFaceName);
#else
	SPRINTF(sbuff,"/FullName (%s) readonly def\r\n", mytf.typeFaceName);
#endif
#endif /* PSFONTNAME */
	psWrite((LPUB8)sbuff);

#ifdef _WINDOWS
	SPRINTF(sbuff,"/FamilyName (%s) readonly def\r\n", (LPSB8)mytf.familyName);
#else
	SPRINTF(sbuff,"/FamilyName (%s) readonly def\r\n", mytf.familyName);
#endif
	psWrite((LPUB8)sbuff);

#ifdef _WINDOWS
   SPRINTF(sbuff,"/Weight (%s) def\r\n", (LPSB8)mytf.weight);
#else
   SPRINTF(sbuff,"/Weight (%s) def\r\n", mytf.weight);
#endif
   psWrite((LPUB8)sbuff);

   SPRINTF(sbuff,"/ItalicAngle %d def\r\n",cg_italicAngle);
   psWrite((LPUB8)sbuff);

	/*
		Add UnderlinePosition & UnderlineThickness - 6/13/91 - rs
	*/

	SPRINTF (sbuff, "/UnderlinePosition %d def\r\n", cg_uscoreDepth);
	psWrite ((LPUB8)sbuff);

	SPRINTF (sbuff, "/UnderlineThickness %d def\r\n", cg_uscoreThickness);
	psWrite ((LPUB8)sbuff);

	psWrite("end readonly def\r\n");

	SPRINTF(sbuff,"/FontName /%s def\r\n", PsFontName);
	psWrite((LPUB8)sbuff);

	/* PaintType 0 is Filled font, PaintType 2 is outline */
   psWrite("/PaintType 0 def\r\n");

/*
Initialize bounding box info. Since we do not know the min/max for the
entire character set, this will be updated dynamically as we process each
character. For now, we will output the known info and leave a bookmark.
Later we will come back and update the file. Leave space for up to 4 digits
with an optional minus sign and trailing space (-xxxx -xxxx -xxxx -xxxx ).
*/
	bboxllx = bboxlly = bboxurx = bboxury = 0;

	SPRINTF(sbuff,"/FontBBox { ");
	psWrite((LPUB8)sbuff);
#if 0
	BB_bookmark = tell (outFp);
#endif
   BB_bookmark = lseek(outFp, 0L, SEEK_CUR);

	SPRINTF(sbuff,"                        } readonly def\r\n");
	psWrite((LPUB8)sbuff);

	/* Write Encoding data */
	psWrite("/FontType 1 def\n");

   SPRINTF(sbuff,"/FontMatrix [.001 0 0 .001 0 0] readonly def\r\n");
	psWrite((LPUB8)sbuff);

	/*
		Build the encoding array
	*/
	status = bld_encode ();
    if (status)
	{
		return (status);
	}

	psWrite("currentdict end\n");
	psWrite("currentfile eexec\n");

	/* Write ASCII text header data */
	writePfbData(PFB_ASCII);

	/* Write the Private Dictionary */
	status = writePrivate();
    if (status)
	{
		freePS1mem ();
		return  (status);
	}

	/*
	 * Output character data
	 */
	status = writeCharStrings();
    if (status)
	{
		return (status);
	}

	/*
		Go back and fix up the global bounding box info
		are the signs correct????
		should we change them permanently????
	*/
#if 0
	tmp_bookmark = tell (outFp);
#endif
   tmp_bookmark = lseek(outFp, 0L, SEEK_CUR);

	LSEEK(outFp, BB_bookmark, SEEK_SET);

	SPRINTF(sbuff,"%d %d %d %d", bboxllx, bboxlly, bboxurx, bboxury);
	psWrite((LPUB8)sbuff);
	LSEEK(outFp, tmp_bookmark, SEEK_SET);

	/* Write ASCII text header data */
	writePfbData(PFB_ASCII);

	/* Write PFB end of file */
	LSEEK(outFp,pfbOffset,SEEK_SET);
   c = 128;
	WRITEF(outFp, (LPSB8)&c, (SW16)1);
   c = PFB_END;
	WRITEF(outFp, (LPSB8)&c, (SW16)1);
	return(SUCCESS);

}

/*--------------------------*/
/*      write_t1_pfb        */
/*--------------------------*/

#if defined (ANSI_DEFS)
MLOCAL UW16 write_t1_pfb()
#else
MLOCAL UW16 write_t1_pfb()
#endif
{
   UW16 status;

   /*
		Create pfb output file name
	*/

   STRCPY((LPSB8)sbuff, PSparam_str.outFile);
   STRCAT((LPSB8)sbuff, PFB_EXTENSION);

	/*
		Open pfb output file
	*/
#ifdef _WINDOWS
   if ((outFp = OpenFile(sbuff, &ofFile, OF_CREATE | OF_SHARE_COMPAT)) == -1)
#else                                 /* changed to OPEN_MODE -ss 11/22/91 */
   if ((outFp = OPEN(sbuff, O_WRITEFLAGS, OPEN_MODE)) == -1)
#endif
	{
		return (ERR_ps_pfb_open);
	}

   /*
		Write PFB file
	*/
   status = write_t1_pfb_file();

   /*
		Close pfb output file
	*/
   CLOSE(outFp);
   return (status);
}


/*--------------------------*/
/*      write_t1_pfm        */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_pfm()
#else
MLOCAL UW16
write_t1_pfm()
#endif
{
   UW16 status;

   /*
		Create pfm output file name
	*/

   STRCPY((LPSB8)sbuff, PSparam_str.outFile);
   STRCAT((LPSB8)sbuff, PFM_EXTENSION);

	/*
		Open pfm output file
	*/
#ifdef _WINDOWS
   if ((outFp = OpenFile(sbuff, &ofFile, OF_CREATE | OF_SHARE_COMPAT)) == -1)
#else                                 /* changed to OPEN_MODE -ss 11/22/91 */
   if ((outFp = OPEN(sbuff, O_WRITEFLAGS, OPEN_MODE)) == -1)
#endif
	{
		return (ERR_ps_pfm_open);
	}

   /*
		Write PFM file
	*/
   status = write_t1_pfm_file((SW16)FALSE);

   /*
		Close pfm output file
	*/
   CLOSE(outFp);
   return (status);
}

/*--------------------------*/
/*      write_t1_afm_file   */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_afm_file()
#else
MLOCAL UW16
write_t1_afm_file()
#endif
{
  /* We need the following data:
   *
   *     KEYWORD            DATA
   *     -------            ----
   *     FontName           PsFontName
   *
   *     FullName           PsFontName
   *
   *     FamilyName         mytf.familyName
   *
   *     CapHeight          cg_capHeight
   *     XHeight            cg_xHeight
   *     Ascender           cg_ascender
   *     Descender          cg_descender
	*		UnderlineThickness cg_uscoreThickness
	*		UnderlinePosition  cg_uscoreDepth
   */

#if PITCH
   SW16  pitch;
#endif
   UW16  chId;
   SW16   k;
#if PITCH
   pitch = 100; /* WE MAY NEVER HAVE TO CHANGE THIS VALUE */
#endif

	/* Write Character Header */

   SPRINTF (sbuff, "StartFontMetrics 2.0\r\n");
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff, 
      "Comment Copyright (c) 1991 Agfa Corp. All rights reserved.\r\n");
	psWrite ((LPUB8)sbuff);

#ifdef _WINDOWS
	SPRINTF (sbuff, "Comment Creation Date:%s\r\n", (LPSB8)ctime(&ltime));
#else
	SPRINTF (sbuff, "Comment Creation Date:%s\r\n", ctime(&ltime));
#endif
	psWrite ((LPUB8)sbuff);

	SPRINTF (sbuff,"FontName %s\r\n", PsFontName);
	psWrite ((LPUB8)sbuff);

	/*
		Substitute mytf.typeFaceName for PsFontName - 7/1/91 - rs
	*/

#if PSFONTNAME
	SPRINTF(sbuff,"FullName %s\r\n", PsFontName);
#else /* name with spaces */
#ifdef _WINDOWS
	SPRINTF(sbuff,"FullName %s\r\n", (LPSB8)mytf.typeFaceName);
#else
	SPRINTF(sbuff,"FullName %s\r\n", mytf.typeFaceName);
#endif
#endif /* PSFONTNAME */
	psWrite ((LPUB8)sbuff);

#ifdef _WINDOWS
	SPRINTF (sbuff,"FamilyName %s\r\n", (LPSB8)mytf.familyName);
#else
	SPRINTF (sbuff,"FamilyName %s\r\n", mytf.familyName);
#endif
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"FontBBox %d %d %d %d\r\n",bboxllx,bboxlly,bboxurx,bboxury);
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff, "ItalicAngle %d\r\n", cg_italicAngle); /* add 6/13/91 - rs */
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff, "UnderlinePosition %d\r\n", cg_uscoreDepth); /* 6/13/91 rs */
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"UnderlineThickness %d\r\n", cg_uscoreThickness); /* 6/13/91 rs */
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"Notice Copyright (c) 1991 Agfa Corp. All rights reserved.\r\n");
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"EncodingScheme AdobeStandardEncoding\r\n");
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"Characters %d\r\n", nChars);
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"CapHeight %d\r\n", cg_capHeight);
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"XHeight %d\r\n", cg_xHeight);
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"Ascender %d\r\n", cg_ascender);
	psWrite ((LPUB8)sbuff);
	SPRINTF (sbuff,"Descender %d\r\n", cg_descender);
	psWrite ((LPUB8)sbuff);

 	/* Write Character Widths */
   SPRINTF (sbuff,"\r\nStartCharMetrics %d\r\n", nChars);
	psWrite ((LPUB8)sbuff);

   for (chId = 0; chId < MAXPS_SYMBOLS; chId++)
   {
      if (widTab[chId].ps1_off >= 0)
      {
		   SPRINTF (sbuff,"C %d ; WX %u ; N %s ; B %d %d %d %d ;\r\n", chId,
			/*
			NOTE: since pitch is always 100 and 100/100 is always 1 ...
					we will comment out this part of the equation.
					If your situation differs, put this code back
			*/
            (UW16)(widTab[chId].cg_width /* * (float)pitch/100. */),
#ifdef _WINDOWS
            (LPSB8)PS1Codes[widTab[chId].ps1_off].adobeName,
#else
            PS1Codes[widTab[chId].ps1_off].adobeName,
#endif
				widTab[chId].bboxllx, widTab[chId].bboxlly,
				widTab[chId].bboxurx, widTab[chId].bboxury);
        	psWrite ((LPUB8)sbuff);

      }
   }
	SPRINTF (sbuff,"EndCharMetrics\r\n");
	psWrite ((LPUB8)sbuff);

	/* Write Kerning Data */
	if (naKrnPrs)
	{
		SPRINTF (sbuff,"\r\nStartKernData\r\n");
    	psWrite ((LPUB8)sbuff);
		SPRINTF (sbuff,"StartKernPairs %d\r\n",naKrnPrs);
    	psWrite ((LPUB8)sbuff);

      for (k = 0; k < nmKrnPrs; k++)
		{
			if (!kp_tbl[k].adj)
				continue;
			SPRINTF (sbuff,"KPX %s %s %d\r\n",
#ifdef _WINDOWS
				(LPSB8)(PS1Codes[PS1map (SYMmap (kp_tbl[k].chId0, FC_IF_TYPE))].adobeName),
				(LPSB8)(PS1Codes[PS1map (SYMmap (kp_tbl[k].chId1, FC_IF_TYPE))].adobeName),
#else
				PS1Codes[PS1map (SYMmap (kp_tbl[k].chId0, FC_IF_TYPE))].adobeName,
				PS1Codes[PS1map (SYMmap (kp_tbl[k].chId1, FC_IF_TYPE))].adobeName,
#endif
				(int)(kp_tbl[k].adj /* * (float)pitch / 100.*/));/* pitch = 100 */
        	psWrite ((LPUB8)sbuff);
        
		}
		SPRINTF (sbuff,"EndKernPairs\r\n");
     	psWrite ((LPUB8)sbuff);
		SPRINTF (sbuff,"EndKernData\r\n");
     	psWrite ((LPUB8)sbuff);

	}
	SPRINTF (sbuff,"\r\nEndFontMetrics\r\n");
  	psWrite ((LPUB8)sbuff);

   return(SUCCESS);
}

/*--------------------------*/
/*      write_t1_afm        */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_afm()
#else
MLOCAL UW16
write_t1_afm()
#endif
{
   UW16 status;

   /*
		Create afm output file name
	*/

   STRCPY((LPSB8)sbuff, PSparam_str.outFile);
   STRCAT((LPSB8)sbuff, AFM_EXTENSION);

	/*
		Open afm output file
		Change from binary to text mode - 7/1/91 - rs
	*/
#ifdef _WINDOWS                              /* 08-10-90  jfd */
   if ((outFp = OpenFile(sbuff, &ofFile, OF_CREATE | OF_SHARE_COMPAT)) == -1)
#else                                 /* changed to OPEN_MODE -ss 11/22/91 */
   if ((outFp = OPEN(sbuff, O_WRITEFLAGS, OPEN_MODE)) == -1)
#endif
	{
		return (ERR_ps_afm_open);
	}

   /*
		Write AFM file
	*/
   status = write_t1_afm_file();

   /*
		Close afm output file
	*/
   CLOSE(outFp);
   return (status);
}
#if VFM
/*--------------------------*/
/*      write_t1_vfm_file   */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_vfm_file()
#else
MLOCAL UW16
write_t1_vfm_file()
#endif
{
#if KERNING
   SW16 i;
	UW16 wid;
	SL32 num;
   SL32 denom;
#endif
   SW16 chId;
   SW16 size;
#if PITCH
   UW16 pitch;
#endif
   UW16 style;
   SL32  id;
#if PITCH
   pitch = 100; /* WE MAY NEVER HAVE TO CHANGE THIS VALUE */
#endif

#ifdef _WINDOWS
   SB8  far short_typeFaceName[MAXVFMTFNAME];  /* 9-26-91 jfd */
#else
   SB8  short_typeFaceName[MAXVFMTFNAME];  /* max len of VFM typeface name */
#endif
   SW16  k;

   MEMCPY(short_typeFaceName, PsFontName, MAXVFMTFNAME);
   short_typeFaceName[MAXVFMTFNAME-1] = '\0';  /* make sure of NULL term. */

   size = 255;          /* MUST BE 255 FOR POSTSCRIPT */

        /* ATTRTYPE: 1=Medium, 2=Bold, 5=Medium Italic, 6=Bold Italic*/
        /* USTYLE:   0=Medium, 1=Bold, 4=Medium Italic, 5=Bold Italic*/
        /* SSTYLE:   (same as USTYLE)                                */

   if (mytf.descriptorSet[STEMWEIGHT_OFF] <= 30)
      style = 1;
   else
      style = 2;

   if (mytf.descriptorSet[SLANTSTYLE_OFF] > 10) 
      style |= 4;

   SPRINTF(sbuff, "DEVICE POSTSCRIPT\n");
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "TYPEFACE %s\n", short_typeFaceName);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "FACEID %ld\n", PSparam_str.vfm_font_id);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "SIZES %d\n", size);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "ATTRTYPE %c\n", str0to6[style]);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "UFACEID %ld\n", PSparam_str.vfm_font_id);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "USTYLE %c\n", str0to6[style-1]);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "SFACEID %ld\n", PSparam_str.vfm_font_id);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "SSTYLE %c\n", str0to6[style-1]);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "TOP %d\n", bboxury);
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "BOT %d\n", ABS(bboxlly));
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "YMPY 12\n");
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "YDIV 720\n");
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "XMPY 12\n");
	psWrite ((LPUB8)sbuff);
   SPRINTF(sbuff, "XDIV 720\n");
	psWrite ((LPUB8)sbuff);

/*
   SPRINTF(sbuff, "DEVSPEC JUNK/%s/%s\n", PsFontName,
		PsFontName);
*/
   SPRINTF(sbuff, "DEVSPEC %s/%s\n", PsFontName,
		PsFontName);
	psWrite ((LPUB8)sbuff);

   SPRINTF(sbuff, "WIDTHS %d\n", nChars);
	psWrite ((LPUB8)sbuff);
   for (chId = k = 0; chId < MAXPS_SYMBOLS; chId++) {
      if (widTab[chId].ps1_off != -1) {
 	      SPRINTF(sbuff, "%2d", (SW16)(widTab[chId].cg_width /* *pitch/100. */ ));
         psWrite ((LPUB8)sbuff);
         SPRINTF(sbuff, ((k & 15) == 15) ? "\n" : " ");
	      psWrite ((LPUB8)sbuff);
         k++;
      }
	}
   if (naKrnPrs)
	{
      SPRINTF(sbuff,"\nKERN %d\n", naKrnPrs);
   	psWrite ((LPUB8)sbuff);

		for (k = 0; k < nmKrnPrs; k++) /* must process largest possible table */
		{
		   if (!kp_tbl[k].adj)
				continue;	/* don't output 0 kerning amounts */

			SPRINTF(sbuff,"%d %d %d\n", 
				(UB8)kp_tbl[k].chId0, (UB8)kp_tbl[k].chId1, kp_tbl[k].adj);
      	psWrite ((LPUB8)sbuff);
		}
	}

	return(SUCCESS);
}

/*--------------------------*/
/*      write_t1_vfm        */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_vfm()
#else
MLOCAL UW16
write_t1_vfm()
#endif
{
   UW16 status;

   /*
		Create vfm output file name
	*/

   STRCPY((LPSB8)sbuff, PSparam_str.outFile);
   STRCAT((LPSB8)sbuff, VFM_EXTENSION);

	/*
		Open vfm output file
	*/
#ifdef _WINDOWS                              /* 08-10-90  jfd */
   if ((outFp = OpenFile(sbuff, &ofFile, OF_CREATE | OF_SHARE_COMPAT)) == -1)
#else                                 /* changed to OPEN_MODE -ss 11/22/91 */
   if ((outFp = OPEN(sbuff, O_WRITEFLAGS,  OPEN_MODE)) == -1)
#endif
	{
		return (ERR_ps_vfm_open);
	}

   /*
		Write VFM file
	*/
   status = write_t1_vfm_file();

   /*
		Close vfm output file
	*/
   CLOSE(outFp);
   return (status);
}
#endif

/*----------------*/
/*    ps_write    */
/*----------------*/
GLOBAL UW16
#if MULTICALLER
#if defined (ANSI_DEFS)
ps_write(UW16 uCallID)
#else
ps_write(uCallID)
    UW16  uCallID;
#endif
#else
#if defined (ANSI_DEFS)
ps_write()
#else
ps_write()
#endif
#endif /* MULTICALLER */
/*
main entry point to PostScript Type 1 output subsystem.
Initializes system, allocates memory, get current time
*/
{
    UW16    status;
    PBUCKET  bucket;
    LPSB8    pfgseg;           /* pointer to face global segment */
    SW16     j;
#if TIMING
    LPSB8    timeline;
#endif

#if MULTICALLER
    uCallerId = uCallID;       /* store ID in GLOBAL variable */
#endif

#if TIMING
   ftime(&timebuffer);
   timeline = ctime(&(timebuffer.time));
   printf("\n\nStart of setup is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif

	/***********************************/
	/* Allocate buffers for conversion */
	/***********************************/
	status = initPS1();
    if (status)
		return(status);

	/*
		dereference our handles into global pointers
		NOTE: This may not be good enough for Windows, Mac, unix, etc
				may have to dereference on the fly...
	*/
	encodeVec = (LPUB8)MEMptr (hencodeVec);
	encryptVec = (LPUB8)MEMptr (hencryptVec);
	widTab = (PWIDTABSTR)MEMptr (hwidTab);

	/*
		Get the current time as the creation date of the font and associated
		metrics files.
	*/

   time(&ltime);	/* get current time */

	/*
		Build the width/x-ref table between cg-nums & ps-nums
	*/
	status = bld_widTab ();
    if (status)
		return (status);

   /* Find Typeface-sensitive bucket */

    status = BUCKfind(TF_SENSITIVE, CREATE_BUCKET, &bucket);
    if (status)
	{
		freePS1mem ();
		return (status);
	}
   pfgseg = fgseg(bucket);

   /* Get pointer to typeface header */

   if (bucket->p.in.otf_header_seg == MAX_UWORD)
	{
		freePS1mem ();
		return (ERRtfheader_missing);
	}
   ptf = (PTF)(pfgseg + bucket->p.in.otf_header_seg);

	/* Get offset to text kerning segment (use as flag to indicate presence */
		tks_off = bucket->p.in.otext_kern_seg;

   /* Get pointer to display header */

   if (bucket->p.in.odisplay == MAX_UWORD)
	{
		freePS1mem ();
		return (ERRdispheader_missing);
	}
   pdh = (PDISPLAY)(pfgseg + bucket->p.in.odisplay);

   /* Get pointer to attribute header */

   if (bucket->p.in.oattribute == MAX_UWORD)
	{
		freePS1mem ();
		return (ERRattribseg_missing);
	}

   pat = (PFACE_ATT)(pfgseg + bucket->p.in.oattribute);
	/*
		Copy any variables which we'll need later. They may not be around
		forever... Get capHeight, xHeight, ascender and descender
	*/
   cg_capHeight = (SW16)(((SL32)(pat->capHeight * 1000L) + 4391L) / 8782L);
   cg_xHeight   = (SW16)(((SL32)(pat->xHeight * 1000L) + 4391L) / 8782L);
   cg_ascender  = (SW16)(((SL32)(pat->ascender * 1000L) + 4391L) / 8782L);
   cg_descender = (SW16)(((SL32)(pat->descender * 1000L) + 4391L) / 8782L);
	cg_uscoreThickness =
			(UW16)(((SL32)(pat->uscoreThickness * 1000L) + 4391L) / 8782L);
	cg_uscoreDepth = (SW16)(((SL32)(pat->uscoreDepth * 1000L) + 4391L) / 8782L);
	cg_italicAngle = pdh->italicAngle / 100;
   cg_isFixedPitch = (UB8)(pat->isFixedPitch);	/* add 6/17/91 - jfd */

	/*
		Get width of fixed space character - use 'Thin Space'
	*/
	fspacewidth =
		(UW16)((((SL32)pat->fixedSpaceRelWidths[0] * 1000L) + 4391L) / 8782L);

	/*
		Copy typeface header from library to our own structure. These fields
		are assumed to be padded with spaces to the full size. We will null
		terminate them at either 1 past the last non-space or the end of field.
		Convert any embedded spaces to dashes in name fields - 6/13/91 - rs
	*/
	STRNCPY (mytf.typeFaceName, ptf->typeFaceName, TF_NAME_LEN);
	for (j = TF_NAME_LEN - 2; j > 0; j--)
		if (mytf.typeFaceName[j] != ' ')
			break;

#define TESTINGPS	0	/* don't change names for releases */
#if T1HINTS && TESTINGPS
/*
DEBUG ONLY - if testing hints - add an 'H' to end of name - 8/28/91 - rs
*/
	mytf.typeFaceName[++j] = 'H';
#endif /* T1HINTS && TESTINGPS */

	mytf.typeFaceName[j+1] = '\0';

	/*
		PostScript doesn't like spaces in some of its names
	*/
	spaceToDash (mytf.typeFaceName, PsFontName);

	STRNCPY (mytf.familyName, ptf->familyName, FAM_NAME_LEN);
	for (j = FAM_NAME_LEN - 2; j > 0; j--)
		if (mytf.familyName[j] != ' ')
			break;
	mytf.familyName[j+1] = '\0';
	spaceToDash (mytf.familyName, mytf.familyName);

	STRNCPY (mytf.weight, ptf->weight, WEIGHT_DSC_LEN);
	for (j = WEIGHT_DSC_LEN - 2; j > 0; j--)
		if (mytf.weight[j] != ' ')
			break;
	mytf.weight[j+1] = '\0';
	spaceToDash (mytf.weight, mytf.weight);

   MEMCPY (mytf.descriptorSet, ptf->descriptorSet, DESCR_SET_LEN);


	/* build the kern pair table */
	status = bld_kpTab ();
    if (status)
	{
		freePS1mem ();
		return (status);
	}

#if TIMING
   ftime(&timebuffer);
   timeline = ctime(&(timebuffer.time));
   printf("\n  End of setup is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif

    SetDf();	/* set up df values for type 1 font */

/* Create the pfb file (always required) */
#if TIMING
   ftime(&timebuffer);
   timeline = ctime(&(timebuffer.time));
   printf("\n\nStart of PFB file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif

    status = write_t1_pfb();
    if (status)
	{
		freePS1mem ();
		return (status);
	}

#if TIMING
   ftime(&timebuffer);
   timeline = ctime(&(timebuffer.time));
   printf("\n  End of PFB file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif

   /* If no other files were requested, return */
   if (!(PSparam_str.filetypes & OPTIONALFILES))
      {
      /* First, let's clean up before we leave!!! */ /* jwd, 05-05-94 */

      freePS1mem ();
      return (status);
      }

   /* Create requested PostScript Type 1 output files */

   if (PSparam_str.filetypes & PS_AFM_FILE)
   {
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n\nStart of AFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
      status = write_t1_afm();
      if (status)
	  {
		  freePS1mem ();
		  return (status);
	  }
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n  End of AFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
   }

	/*
		Calculate the maximum & average char widths & set dfAscent.
	*/
	calcDfWidths ();

   if (PSparam_str.filetypes & PS_PFM_FILE)
   {
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n\nStart of PFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
      status = write_t1_pfm();
      if (status)
	  {
	      freePS1mem ();
		  return (status);
	  }
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n  End of PFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
   }
#if VFM
   if (PSparam_str.filetypes & PS_VFM_FILE)
   {
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n\nStart of VFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
      if(status = write_t1_vfm())
		{
			freePS1mem ();
			return (status);
		}
#if TIMING
      ftime(&timebuffer);
      timeline = ctime(&(timebuffer.time));
      printf("\n  End of VFM file is %.8s.%hu",&timeline[11],timebuffer.millitm);
#endif
   }
#endif

/*
Don't forget to free our memory before leaving
*/
	freePS1mem ();
   return (SUCCESS);
}

/*----------------*/
/*    PS1map      */
/*----------------*/
#if defined (ANSI_DEFS)
GLOBAL UW16 PS1map (UW16 cgnum)
#else
GLOBAL UW16 PS1map (cgnum)
UW16 cgnum;
#endif
/*
Lookup the index into PS1Codes structure for a given cgnum

return (MAX_UWORD) if not found
*/
{
UW16	index;

	for (index = 0; index < nPS1Codes; index++)
	{
		if (PS1Codes[index].cgCode != cgnum)
			continue;
		return (index);
	}
	return (MAX_UWORD);
}


/*----------------*/
/*    bld_widTab  */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL SW16 bld_widTab ()
#else
MLOCAL SW16 bld_widTab ()
#endif
/*
Build the width table/xref structure widTab
calculate nChars = # of chars in symbol set

return (0) if no error, else (ERR_ps_char_not_in_list)
*/
{
UW16	chId, cgnum, ps1_idx;

	nChars = 0;
	for (chId = 0; chId < MAXPS_SYMBOLS; chId++)
	{
		/*
			Determine the index into PS1Codes struct based upon chId and
			the number of chars in our symbol set.
		*/

		if (!(cgnum = SYMmap ((SW16)chId, FC_IF_TYPE)))
			widTab[chId].ps1_off = -1;
		else if ((ps1_idx = PS1map (cgnum)) != MAX_UWORD)
		{
			nChars++;
			widTab[chId].ps1_off = ps1_idx;
		}
		else
		{
			DBG1 ("bld_widTab() - Symbol missing from master PS1 list %d\n",
				chId);
			widTab[chId].ps1_off = -1;
#ifndef DEVELOPMENT
			return (ERR_ps_char_not_in_list);	/* must be in PS1 table or else - fatal! */
#endif /* DEVELOPMENT */
		}
	}
	return (0);
}

#if defined (ANSI_DEFS)
MLOCAL SW16 bld_encode ()
#else
MLOCAL SW16 bld_encode ()
#endif
/*
Build the encoding array here. The width table structure has
already been built. It will tell us if a character is in the
current symbol set. If a character is not in the symbol set,
we'll just use the .notdef, else we'll use the real character. The Adobe
name will come from the PS1Codes structure.

return SUCCESS or error code
*/
{
SW16		chId;

#ifdef STANDARDENCODING
	psWrite("/Encoding StandardEncoding def\n");

#else /* not STANDARDENCODING */
	psWrite("/Encoding 256 array\n");
	psWrite("0 1 255 {1 index exch /.notdef put } for\n");

	for (chId = 0; chId < MAXPS_SYMBOLS; chId++)
	{
		if (widTab[chId].ps1_off == -1)
			continue;

		SPRINTF (sbuff, "dup %d /%s put\n", chId,
#ifdef _WINDOWS
			(LPSB8)(PS1Codes[widTab[chId].ps1_off].adobeName));
#else
			PS1Codes[widTab[chId].ps1_off].adobeName);
#endif

		psWrite ((LPUB8)sbuff);
	}
	psWrite ("readonly def\n");
#endif /* STANDARDENCODING */

	return (SUCCESS);
}

/*----------------*/
/*    bld_kpTab  */
/*----------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16 bld_kpTab ()
#else
MLOCAL UW16 bld_kpTab ()
#endif
/*
This function will contruct the pair kerning table. The contents of this
table are based upon the available kerning pairs in our master kern pair
array 'cg_kern_tbl[]' and the current symbol set.
'nmKrnPrs' is the total possible # of kern pairs in our master table.
'naKrnPrs' is the actual # of kern pairs we will include in the font.

We will fill out the kp_tbl[] structure with all valid pairs in the current
symbol set. 'naKrnPrs' will be set to the number of entries in kp_tbl[]
which contain valid data.
*/
{
#if KERN
SW16	j, k, tmpKrnPrs;
UW16	status, thisKey, nextKey;
KERN_PAIR	kp_tmp;	/* use for sorting kern pair structure */

	if (tks_off == MAX_UWORD)
	{
		naKrnPrs = 0;		/* no text kerning in library */
		return (SUCCESS);
	}

	for (k = naKrnPrs = 0; k < nmKrnPrs; k++)
	{
		if ((kp_tbl[naKrnPrs].chId0 = SYMmapR (cg_kern_tbl[k].cgnuml)) 
                  == (UW16)-1)                /* added cast -ss 11/22/91 */
			continue;
		if ((kp_tbl[naKrnPrs].chId1 = SYMmapR (cg_kern_tbl[k].cgnumr)) 
                  == (UW16)-1)                /* added cast -ss 11/22/91 */
			continue;
		naKrnPrs++;
	}

	status = cgif_Kern (TEXT_KERN, naKrnPrs, kp_tbl);
    if (status)
		return (status);
	/*
		Scale kerning data from 1/8782 em to 1/1000 em
		and
		Filter out all 0 kerning pairs
		* note this will cause the	kp_tbl[] to become sparsely populated
	*/
	tmpKrnPrs = naKrnPrs;	/* # of populated KP's including 0's */
	for (k = 0; k < tmpKrnPrs; k++)
	{
		if (!(j = kp_tbl[k].adj))
		{
			naKrnPrs--;
			continue;
		}
		kp_tbl[k].adj = -( (SW16)((((SL32)j * 1000L) + 4391L) / 8782L));
	}

/*
Make sure that we have not included too many kern pairs - 7/10/91 - rs
*/
	if (naKrnPrs > MAXKERNPAIRS)
		return (ERR_ps_TooManyKernPairs);

	/*
		Sort the kern pair structure in order of increasing "right" char
	*/
	for (k = 0; k < tmpKrnPrs-1; k++)	/* look at all populated KP's */
	{
		thisKey = (((UW16)kp_tbl[0].chId1 << 8) | ((UW16)kp_tbl[0].chId0));
		for (j  = 0; j < tmpKrnPrs-1-k; j++)/* look at all populated KP's */
		{
			nextKey = (((UW16)kp_tbl[j+1].chId1 << 8) | ((UW16)kp_tbl[j+1].chId0));
			if (nextKey < thisKey)
			{
				kp_tmp.chId0 = kp_tbl[j+1].chId0;
				kp_tmp.chId1 = kp_tbl[j+1].chId1;
				kp_tmp.adj = kp_tbl[j+1].adj;
				kp_tbl[j+1].chId0 = kp_tbl[j].chId0;
				kp_tbl[j+1].chId1 = kp_tbl[j].chId1;
				kp_tbl[j+1].adj = kp_tbl[j].adj;
				kp_tbl[j].chId0 = kp_tmp.chId0;
				kp_tbl[j].chId1 = kp_tmp.chId1;
				kp_tbl[j].adj = kp_tmp.adj;
				/*
					Since we swapped, there is not need to use the following
					two lines, just imagine that they exist...
					thisKey = nextKey;
					thisKey = nextKey;   this would be outside loop w/o "else"
				*/
			}
			else thisKey = nextKey;
		}
	}

	return (SUCCESS);
#else /* no kern enabled in build */
	naKrnPrs = 0;
	return (SUCCESS);
#endif /* KERN */
}

/*************************************************************
* Name: szMove()
*
* Action: Copy a string.  This function will copy at most the
*	  number of bytes in the destination area - 1.
*
**************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  szMove(LPSB8 szDst, LPSB8 szSrc, SW16 cbDst)
#else
MLOCAL VOID
szMove(szDst, szSrc, cbDst)
   LPSB8 szDst;		/* Ptr to the destination area */
   LPSB8 szSrc;		/* Ptr to the source area */
   SW16  cbDst;		/* The size of the destination area */
#endif
{
    while ((*szDst++ = *szSrc++)!=NULL)
	if (--cbDst <= 0)
	    {
	    *(szDst-1) = 0;
	    break;
	    }
}

/******************************************************************
* Name: ResetBuffer()
*
* Action: This function resets the output buffer.
*
*******************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  ResetBuffer()
#else
MLOCAL VOID
ResetBuffer()
#endif
{
    pfmData = MEMptr(hpfmData);  /* 6/7/91 JFD */
    pbBuffer = pfmData;
    cbBuffer = 0;
}

/**************************************************************
* Name: SetDf()
*
* Action: This function sets the values in the device font structure
*	  from the values in the afm structure.
*
****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  SetDf()
#else
MLOCAL VOID
SetDf()
#endif
{
#ifdef PITCH /* add 6/17/91 - jfd */
    SW16  pitch;
#endif /* PITCH */
    SW16  winType;

#if PITCH /* add 6/17/91 - jfd */
    pitch = 100; /* WE MAY NEVER HAVE TO CHANGE THIS VALUE */

    winType = 0;
#endif /* PITCH */

/*
Following block added 6/17/91 - jfd
*/
	switch (mytf.descriptorSet[STEMSTYLE_OFF])
	{
		case cg_SS_SSERIF:		/* sans serif */
	      winType = (SW16)FF_SWISS;
			break;

		case cg_SS_SERIF:		/* serif */
		   winType = (SW16)FF_ROMAN;
			break;

		case cg_SS_SCRIPT:
	      winType = (SW16)FF_SCRIPT;
			break;

		case cg_SS_NOVELTY:
         winType = (SW16)FF_DECORATIVE;
			break;

		default:
	   	if (cg_isFixedPitch == (UB8)1)    /* Modern */
	      	winType = (SW16)FF_MODERN;
			else winType = (SW16)FF_DONTCARE;	/* don't care or don't know */
	}
/*
End of block 6/17/91 - jfd */

    szMove(dfCopyright, "Copyright (c) 1991 Agfa Corp. All rights reserved.\n",
       sizeof(dfCopyright));
    /* A device realized vector font */
    dfType = 0x081;
    dfCharSet = ANSI_CHARSET;
    dfDefaultChar = ' ';
    dfBreakChar = 0;

    dfInternalLeading=0;


	/*
		Move setting of dfAscent from here to 'calcDfWidths' because we
		must have all outlines created before obtaining this value. - 8/5/91 rs
	*/

    dfPoints = 10;	/* Default to 80 column text */
    dfVertRes = 300;
    dfHorizRes = 300;

    dfExternalLeading = 0;

    dfItalic = (mytf.descriptorSet[SLANTSTYLE_OFF] == cg_SLANTNORMAL) ?
		(SB8)0 : (SB8)1;

	switch (mytf.descriptorSet[STEMWEIGHT_OFF])
	{
		case cg_EXTRALIGHT:
      	dfWeight = (SW16)FW_EXTRALIGHT;
			break;

		case cg_LIGHT:
			dfWeight = (SW16)FW_LIGHT;
			break;

		case cg_NORMAL:
	      dfWeight = (SW16)FW_NORMAL;
			break;

		case cg_BOLD:
	      dfWeight = (SW16)FW_BOLD;
			break;

		case cg_EXTRABOLD:
			dfWeight = (SW16)FW_EXTRABOLD;
			break;

		default:
			dfWeight = (SW16)FW_NORMAL;
			break;
	}

    dfPitchAndFamily = winType;	/* winType already shifted to <7:4> */

    dfFirstChar = (SB8)symbolset.ss_first_code[SYMBOLSET_IF];  /* 06-11-91 jfd */
    dfLastChar  = (SB8)symbolset.ss_last_code[SYMBOLSET_IF];   /* 06-11-91 jfd */

    if (!cg_isFixedPitch)
       dfPitchAndFamily |= 1; /* Variable Pitch */

	/*
		Changed 'dfPixHeight' from hardwired Adobe value of 1116 to value
		calculated from Intellifont constants. At some point, a more accurate
		value may be able to be calculated from library data.
		(((TOP_OF_WINDOW - BOTTOM_OF_WINDOW) * 1000) / 8782) - 7/10/91 - rs
	*/
    dfPixHeight = (SW16)((((13718L - 2663L) * 1000L) + 4391) / 8782L);
}

/**********************************************************
* Name: PutString()
*
* Action: This function writes a null terminated string
*	  to the output file.
*
**********************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutString(LPSB8 sz)
#else
MLOCAL VOID
PutString(sz)
    LPSB8 sz;
#endif
{
    SW16 bCh;

    do
	{
		bCh = *pbBuffer++ = *sz++;
		++cbBuffer;
	} while (bCh);
}

/****************************************************************
* Name: PutByte()
*
* Action: This function writes a byte to the output buffer.
*
*****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutByte(SW16 iByte)
#else
MLOCAL VOID
PutByte(iByte)
   SW16 iByte;
#endif
{
    *pbBuffer++ = (SB8)(iByte & 0x0ff);  /* 06-11-91 jfd */
    ++cbBuffer;
}


/****************************************************************
* Name: PutWord()
*
* Action: This function writes a word to the output buffer.
*
*****************************************************************
*/

#if defined (ANSI_DEFS)
MLOCAL VOID  PutWord(SW16 iWord)
#else
MLOCAL VOID
PutWord(iWord)
   SW16 iWord;
#endif
{
    *pbBuffer++ = (SB8)(iWord & 0x0ff);         /* 06-11-91 jfd */
    *pbBuffer++ = (SB8)((iWord >> 8) & 0x0ff);  /* 06-11-91 jfd */
    cbBuffer += 2;
}

/****************************************************************
* Name: PutLong()
*
* Action: This function writes a long word to the output buffer.
*
*****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutLong(SL32 lWord)
#else
MLOCAL VOID
PutLong(lWord)
   SL32 lWord;
#endif
{
    PutWord((SW16) (lWord & 0x0ffffL));
    lWord >>= 16;
    PutWord((SW16) (lWord & 0x0ffffL));
}

/****************************************************************
* Name: PutRgb()
*
* Action: This function writes an array of bytes to the output buffer.
*
*****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutRgb(LPSB8 pb, SW16 cb)
#else
MLOCAL VOID
PutRgb(pb, cb)
   LPSB8 pb;
   SW16 cb;
#endif
{
    while (--cb>=0)
	PutByte(*pb++);
}

/****************************************************************
* Name: AfmToEtm()
*
* Action: Convert from PostScript to extended text metrics
*
*****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  AfmToEtm(SW16 nPairs)
#else
MLOCAL VOID
AfmToEtm(nPairs)
   SW16 nPairs;	/* actual # of kerning pairs (sparsely populated table) */
#endif
{
	SW16 ulOffset = 15;
	SW16 ulThickness = 10;

    etmPointSize = 12 * 20;	/* Nominal point size = 12 */
    etmOrientation = 0;
    etmMasterHeight = 1000;
    etmMinScale = 3;
    etmMaxScale = 1000;
    etmMasterUnits = 1000;
    etmCapHeight = cg_capHeight;
    etmXHeight = cg_xHeight;
    etmLowerCaseAscent =  cg_capHeight;
	/*
		Change etmUpperCaseDecent to negative of bboxlly - 7/3/91 - rs
	*/
    etmUpperCaseDecent = -bboxlly;	/* was hard-wired to 100 by atech */
    etmSlant = -(cg_italicAngle * 10);	/* was hard-wired to 0 by atech */
    etmSuperScript = -500;
    etmSubScript = 250;
    etmSuperScriptSize = 500;
    etmSubScriptSize = 500;

    etmUnderlineOffset = 100;                /* 06-18-91 from ADOBE -jfd */
    etmUnderlineWidth = 50;                  /* 06-18-91 from ADOBE -jfd */
    etmDoubleUpperUnderlineOffset = 50;      /* 06-18-91 from ADOBE -jfd */
    etmDoubleLowerUnderlineOffset = 100;     /* 06-18-91 from ADOBE -jfd */
    etmDoubleUpperUnderlineWidth = 25;       /* 06-18-91 from ADOBE -jfd */
    etmDoubleLowerUnderlineWidth = 25;       /* 06-18-91 from ADOBE -jfd */
    etmStrikeOutOffset = 300;                /* 06-18-91            -jfd */
    etmStrikeOutWidth = 50;                  /* 06-18-91 from ADOBE -jfd */

	 etmNKernPairs = nPairs;
    etmNKernTracks = 0;
}


#if defined (ANSI_DEFS)
MLOCAL VOID  PutEtm(SW16 nPairs)
#else
MLOCAL VOID
PutEtm(nPairs)
   SW16 nPairs;
#endif
{
    SW16 iMarker;

    AfmToEtm(nPairs);


    iMarker = cbBuffer;

    PutWord(etmSize);
    PutWord(etmPointSize);
    PutWord(etmOrientation);
    PutWord(etmMasterHeight);
    PutWord(etmMinScale);
    PutWord(etmMaxScale);
    PutWord(etmMasterUnits);
    PutWord(etmCapHeight);
    PutWord(etmXHeight);
    PutWord(etmLowerCaseAscent);
    PutWord(etmUpperCaseDecent);
    PutWord(etmSlant);
    PutWord(etmSuperScript);
    PutWord(etmSubScript);
    PutWord(etmSuperScriptSize);
    PutWord(etmSubScriptSize);
    PutWord(etmUnderlineOffset);
    PutWord(etmUnderlineWidth);
    PutWord(etmDoubleUpperUnderlineOffset);
    PutWord(etmDoubleLowerUnderlineOffset);
    PutWord(etmDoubleUpperUnderlineWidth);
    PutWord(etmDoubleLowerUnderlineWidth);
    PutWord(etmStrikeOutOffset);
    PutWord(etmStrikeOutWidth);
    PutWord(etmNKernPairs);
    PutWord(etmNKernTracks);

	etmSize = cbBuffer - iMarker;
}

/***************************************************************
* Name: PutdeviceName()
*
* Action: This function writes the device name to the output file.
*
*************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutDeviceName(LPSB8 szDevice)
#else
MLOCAL VOID
PutDeviceName(szDevice)
   LPSB8 szDevice;
#endif
{
    dfDevice = cbBuffer;
    PutString(szDevice);
}

/***************************************************************
* Name: PutFaceName()
*
* Action: This function writes the font's face name to the output file.
*
*************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutFaceName()
#else
MLOCAL VOID
PutFaceName()
#endif
{
    dfFace = cbBuffer;
	/*
		Substitute mytf.typeFaceName for PsFontName - 7/1/91 - rs
	*/
#if PSFONTNAME
    PutString(PsFontName);
#else /* use name w/spaces */
    PutString(mytf.typeFaceName);
#endif /* PSFONTNAME */
}


/***************************************************************
* Name: PutFontName()
*
* Action: This function writes the font name to the output file.
*
*************************************************************
*/

#if defined (ANSI_DEFS)
MLOCAL VOID  PutFontName(LPSB8 fontName)
#else
MLOCAL VOID
PutFontName(fontName)
   LPSB8 fontName;
#endif
{
    dfDriverInfo = cbBuffer;
    PutString(fontName);
}

/***************************************************************
* Name: PutExtentTable()
*
* Action: Send the character extent information to the output file.
*
****************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutExtentTable()
#else
MLOCAL VOID
PutExtentTable()
#endif
{
	SW16	NotDefWidth;
   UW16 chId;

	/*
		Change extent table to output all widths from dfFirstChar to dfLastChar
		using 'dfDefaultChar' width if not defined. - 7/9/91 - rs
	*/
   if (dfPitchAndFamily & 1)
	{
		NotDefWidth = widTab[dfDefaultChar].cg_width;
		dfExtentTable = cbBuffer;
      for (chId = (UW16)dfFirstChar; chId <= (UW16)dfLastChar; chId++)
      {
         if (widTab[chId].ps1_off != -1)
			/*
			NOTE: since pitch is always 100 and 100/100 is always 1 ...
					we will comment out this part of the equation.
					If your situation differs, put this code back
			*/
	    	   PutWord((SW16)(widTab[chId].cg_width  /* * pitch/100.  */));
			else /* use the notdef char width */
	    	   PutWord(NotDefWidth);
      }
   }           
   else
   	dfExtentTable = (long) NULL;
}

/*******************************************************************
* Name: PutPairKernTable()
*
* Action: Send the pairwise kerning table to the output file.
*         (CONDITIONALLY COMPILED BY JFD 06-07-91)
*
********************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutPairKernTable(SW16 nPairs)
#else
MLOCAL VOID
PutPairKernTable(nPairs)
SW16	nPairs; /* actual # of kern pairs in sparsely populated table */
#endif
{
   SW16 k, key;

   if (nPairs)
	{
		dfPairKernTable = cbBuffer;
		DBG1("Pair Kern Table:# pairs=%d\n", nPairs);
		PutWord(nPairs);
		for (k = 0; k < nmKrnPrs; k++) /* must process largest possible table */
		{
		   if (!kp_tbl[k].adj)
				continue;	/* don't output 0 kerning amounts */

			key = ((kp_tbl[k].chId1 << 8) | (kp_tbl[k].chId0));
		   PutWord(key);
		   PutWord(kp_tbl[k].adj);
    	   DBG2("key=%02X, kern amount=%d\n", key, kp_tbl[k].adj);
		}
	}
	else 
		dfPairKernTable = NULL;
}

#if defined (ANSI_DEFS)
MLOCAL VOID  PutOriginTable()
#else
MLOCAL VOID
PutOriginTable()
#endif
{
    dfOriginTable = 0L;
}

/******************************************************************
* Name: PutTrackKernTable()
*
* Action: Send the track kerning table to the output file.
*
*******************************************************************
*/
#if defined (ANSI_DEFS)
MLOCAL VOID  PutTrackKernTable()
#else
MLOCAL VOID
PutTrackKernTable()
#endif
{
	dfTrackKernTable = NULL;
}




/*--------------------------*/
/*      write_t1_pfm_file   */
/*--------------------------*/
#if defined (ANSI_DEFS)
MLOCAL UW16  write_t1_pfm_file(SW16 fPass2)
#else
MLOCAL UW16
write_t1_pfm_file(fPass2)
   SW16 fPass2;		/* TRUE if this is the second pass */
#endif
{

/* Method: This function makes two passes over the data. On the
 *	  first pass it collects offset data as it places data
 *	  in the output buffer. On the second pass, it first
 *	  resets the output buffer and then writes the data
 *	  to the output buffer again with the offsets computed
 *	  from pass 1.
 */


  /* We need the following data:
   *
   *     KEYWORD            DATA
   *     -------            ----
   *     FontName           PsFontName
   *
   *     FullName           PsFontName
   *
   *     FamilyName         mytf.familyName
   *
   *     CapHeight          cg_capHeight
   *     XHeight            cg_xHeight
   *     Ascender           cg_ascender
   *     Descender          cg_descender
   */

   SW16 iMarker;

    ResetBuffer();

    PutWord(dfVersion);
    PutLong(dfSize);
    PutRgb(dfCopyright, 60);
    PutWord(dfType);
    PutWord(dfPoints);
    PutWord(dfVertRes);
    PutWord(dfHorizRes);
    PutWord(dfAscent);
    PutWord(dfInternalLeading);
    PutWord(dfExternalLeading);
    PutByte(dfItalic);
    PutByte(dfUnderline);
    PutByte(dfStrikeOut);
    PutWord(dfWeight);
    PutByte(dfCharSet);
    PutWord(dfPixWidth);
    PutWord(dfPixHeight);
    PutByte(dfPitchAndFamily);
    PutWord(dfAvgWidth);
    PutWord(dfMaxWidth);
    PutByte(dfFirstChar);
    PutByte(dfLastChar);
	/*
		Change default char from 'dfDefaultChar' to
		'(dfDefaultChar - dfFirstChar)' on 7/9/91 - rs
	*/
    PutByte(dfDefaultChar - dfFirstChar);	/* 7/9/91 - rs */
    PutByte(dfBreakChar);
    PutWord(dfWidthBytes);
    PutLong(dfDevice);
    PutLong(dfFace);
    PutLong(dfBitsPointer);
    PutLong(dfBitsOffset);

    iMarker = cbBuffer;

    PutWord(dfSizeFields);
    PutLong(dfExtMetricsOffset);
    PutLong(dfExtentTable);
    PutLong(dfOriginTable);
    PutLong(dfPairKernTable);
    PutLong(dfTrackKernTable);
    PutLong(dfDriverInfo);
    PutLong(dfReserved);

    dfSizeFields = cbBuffer - iMarker;

    /* Put the extended text metrics table */
    dfExtMetricsOffset = cbBuffer;

    PutEtm(naKrnPrs);

    PutDeviceName("PostScript");
    PutFaceName();
    PutFontName(PsFontName);

    /* Put the extent table */
    dfExtentTable = cbBuffer;
    PutExtentTable();

    /* Put the origin table */
    dfOriginTable = cbBuffer;
    PutOriginTable();

    /* Put the pair kerning table */
  	PutPairKernTable(naKrnPrs);

    /* Put the track kerning table */
    PutTrackKernTable();

    dfOriginTable = NULL;

    if (!fPass2)
	{
		dfSize = cbBuffer;
      write_t1_pfm_file((SW16)TRUE);
	}
    else
		WRITEF (outFp, (LPSB8)pfmData , cbBuffer);
	return(SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL VOID calcDfWidths ()
#else
MLOCAL VOID calcDfWidths ()
#endif
/*
Calculate the average and maximum character widths for all characters
in our symbol set.
Store dfAscent - add 8/5/91 - rs

This cannot be done until all outlines have been created (i.e. after pfb)
*/
{
UL32 avgWidth=0;
UW16 chId;

    dfMaxWidth = widTab[0].cg_width;
	 for (chId = 0; chId < MAXPS_SYMBOLS; chId++)
	 {
	  	if (widTab[chId].ps1_off != -1)
       {
          avgWidth += widTab[chId].cg_width;
          if (widTab[chId].cg_width > dfMaxWidth)
             dfMaxWidth = widTab[chId].cg_width;
       }
    }

    dfAvgWidth = (SW16)(avgWidth/nChars);  /* 06-11-91 jfd */

	/*
		Change dfAscent - was originally hardwired to 100 (Atech),
		then changed to bboxury, finally changed to ->
		'((((TOPOFWINDOW - BASELINE) * 1000) + 4391) / 8782)' - 7/19/91 - rs
    dfAscent = (SW16)(((((13718L - 5380L) * 1000L) + 4391L) / 8782L));
	change back to bboxury - causes font to not align w/Adobe fonts -rs 8/5/91
	*/
    dfAscent = bboxury;	/* put back to old value - 8/5/91 - rs */

	return ;
}
#else
#if ((defined (__STDC__) && (__STDC__  > 0) && !defined(__i960)) || \
    (defined(__i960) && defined(ANSI_960))) || \
    ((defined (__STDC__) && (__STDC__  > 0) && !defined(VXWORKS)) || \
      (defined(VXWORKS) && defined(ANSI_960)))
int iIFTOPS1 = 0;
#endif /* __STDC__ */
#endif /* PST1 && IF_RDR */

