/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/ps/ps1codes.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: ps1codes.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   04 Aug 1995 10:58:52   JOE
 * Cleanup.
 * 
 *    Rev 1.4   07 Apr 1995 10:16:00   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 14:35:08   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   06 Jan 1993 10:11:18   JOE
 * Removed CTRL-Z at end of file.
 * 
 *    Rev 1.1   14 Dec 1992 09:15:04   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:54:16   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* ps1codes.c
 *
 *


This file contains tables which are used to convert between CG character
codes and PostScript character names/numbers.

Revision History
----------------
05/20/91  rs	Created original file by modifying 'ff1codes.c' from
					ATECH Corporation. Deleted array 'spdIds[]' which was used
					only for SPEEDO. Renamed original structure 'FF1CODESTR'
					to 'PS1CODESTR'. Removed fields unicode, nqCode, cgIndex
					and 'spdIndex'. Renamed 'nFf1Codes' to 'nPS1Codes'.
06/11/91  rs	Add some missing codes to end of PS1Codes[].
07/01/91  rs	Comment out 'pfmCode' from PS1Codes[].
08/06/91  lk   Corrections.
08/23/91  jfd  Changed "#ifdef PST1" to "#if PST1".
11/21/91  jfd  Added entry for CG number 7438 (Embulletsolid1).
11/27/91  lk	Added plugin chars.
04/03/92  rs   Portability cleanup (see port.h).
17-Sep-92 jfd  Changed conditional compile of entire module to include
               IF_RDR.
03-Oct-92 rs   Changes toward ANSI C - if file not compiled, must
               declared  at least 1 external - int iPS1CODES = 0.
06-Jan-93 jfd  Removed CTRL-Z at end of files.
04-Aug-95 jfd/jc Cleanup.
*/

#include "cgconfig.h"

#if PST1 && IF_RDR
#include "port.h"
#include "ps_type1.h"

PS1CODESTR PS1Codes[] = {
/*   PS name 				CG num pfmcode		  */
/*   -------            ------ -------      */
	{"thinspacereverse",    812 /*,  32*/ }, /* 32 */
	{"exclam",               85 /*,  33*/ }, /* 33 */
	{"quotedbl",           7256 /*,  34*/ }, /* 34 */
	{"numbersign",         1719 /*,  35*/ }, /* 35 */
	{"dollar",             1602 /*,  36*/ }, /* 36 */
	{"percent",            1702 /*,  37*/ }, /* 37 */
	{"ampersand",            53 /*,  38*/ }, /* 38 */
	{"quoteright",           88 /*,  39*/ }, /* 39 */
	{"parenleft",          1569 /*,  40*/ }, /* 40 */
	{"parenright",         1570 /*,  41*/ }, /* 41 */
	{"asterisk",           1718 /*,  42*/ }, /* 42 */
	{"plus",               1704 /*,  43*/ }, /* 43 */
	{"comma",              1566 /*,  44*/ }, /* 44 */
	{"hyphen",             1573 /*,  45*/ }, /* 45 */
	{"period",             1565 /*,  46*/ }, /* 46 */
	{"slash",              1576 /*,  47*/ }, /* 47 */
	{"zero",               1601 /*,  48*/ }, /* 48 */
	{"one",                1592 /*,  49*/ }, /* 49 */
	{"two",                1593 /*,  50*/ }, /* 50 */
	{"three",              1594 /*,  51*/ }, /* 51 */
	{"four",               1595 /*,  52*/ }, /* 52 */
	{"five",               1596 /*,  53*/ }, /* 53 */
	{"six",                1597 /*,  54*/ }, /* 54 */
	{"seven",              1598 /*,  55*/ }, /* 55 */
	{"eight",              1599 /*,  56*/ }, /* 56 */
	{"nine",               1600 /*,  57*/ }, /* 57 */
	{"colon",              1567 /*,  58*/ }, /* 58 */
	{"semicolon",          1568 /*,  59*/ }, /* 59 */
	{"less",               7279 /*,  60*/ }, /* 60 */
	{"equal",              1707 /*,  61*/ }, /* 61 */
	{"greater",            7278 /*,  62*/ }, /* 62 */
	{"question",             86 /*,  63*/ }, /* 63 */
	{"at",                 7249 /*,  64*/ }, /* 64 */
	{"A",                    47 /*,  65*/ }, /* 65 */
	{"B",                    42 /*,  66*/ }, /* 66 */
	{"C",                    37 /*,  67*/ }, /* 67 */
	{"D",                    41 /*,  68*/ }, /* 68 */
	{"E",                    39 /*,  69*/ }, /* 69 */
	{"F",                    45 /*,  70*/ }, /* 70 */
	{"G",                    34 /*,  71*/ }, /* 71 */
	{"H",                    29 /*,  72*/ }, /* 72 */
	{"I",                    35 /*,  73*/ }, /* 73 */
	{"J",                    49 /*,  74*/ }, /* 74 */
	{"K",                    52 /*,  75*/ }, /* 75 */
	{"L",                    32 /*,  76*/ }, /* 76 */
	{"M",                    31 /*,  77*/ }, /* 77 */
	{"N",                    30 /*,  78*/ }, /* 78 */
	{"O",                    28 /*,  79*/ }, /* 79 */
	{"P",                    36 /*,  80*/ }, /* 80 */
	{"Q",                    51 /*,  81*/ }, /* 81 */
	{"R",                    33 /*,  82*/ }, /* 82 */
	{"S",                    43 /*,  83*/ }, /* 83 */
	{"T",                    27 /*,  84*/ }, /* 84 */
	{"U",                    50 /*,  85*/ }, /* 85 */
	{"V",                    38 /*,  86*/ }, /* 86 */
	{"W",                    48 /*,  87*/ }, /* 87 */
	{"X",                    46 /*,  88*/ }, /* 88 */
	{"Y",                    44 /*,  89*/ }, /* 89 */
	{"Z",                    40 /*,  90*/ }, /* 90 */
	{"bracketleft",        1571 /*,  91*/ }, /* 91 */
	{"backslash",          1827 /*,  92*/ }, /* 92 */
	{"bracketright",       1572 /*,  93*/ }, /* 93 */
	{"circumflex1",        7280 /*,  94*/ }, /* 94 */
	{"ruleunderline",      7282 /*,  95*/ }, /* 95 */
	{"quoteleft",            87 /*,  96*/ }, /* 96 */
	{"a",                    21 /*,  97*/ }, /* 97 */
	{"b",                    16 /*,  98*/ }, /* 98 */
	{"c",                    11 /*,  99*/ }, /* 99 */
	{"d",                    15 /*, 100*/ }, /* 100 */
	{"e",                    13 /*, 101*/ }, /* 101 */
	{"f",                    19 /*, 102*/ }, /* 102 */
	{"g",                     8 /*, 103*/ }, /* 103 */
	{"h",                     3 /*, 104*/ }, /* 104 */
	{"i",                     9 /*, 105*/ }, /* 105 */
	{"j",                    23 /*, 106*/ }, /* 106 */
	{"k",                    26 /*, 107*/ }, /* 107 */
	{"l",                     6 /*, 108*/ }, /* 108 */
	{"m",                     5 /*, 109*/ }, /* 109 */
	{"n",                     4 /*, 110*/ }, /* 110 */
	{"o",                     2 /*, 111*/ }, /* 111 */
	{"p",                    10 /*, 112*/ }, /* 112 */
	{"q",                    25 /*, 113*/ }, /* 113 */
	{"r",                     7 /*, 114*/ }, /* 114 */
	{"s",                    17 /*, 115*/ }, /* 115 */
	{"t",                     1 /*, 116*/ }, /* 116 */
	{"u",                    24 /*, 117*/ }, /* 117 */
	{"v",                    12 /*, 118*/ }, /* 118 */
	{"w",                    22 /*, 119*/ }, /* 119 */
	{"x",                    20 /*, 120*/ }, /* 120 */
	{"y",                    18 /*, 121*/ }, /* 121 */
	{"z",                    14 /*, 122*/ }, /* 122 */
	{"braceleft",          7250 /*, 123*/ }, /* 123 */
	{"arrowvertex1",       7281 /*, 124*/ }, /* 124 */
	{"braceright",         7251 /*, 125*/ }, /* 125 */
	{"asciitilde",         7283 /*, 126*/ }, /* 126 */
	{"bullet",             1408 /*, 149*/ }, /* 127 */
	{"fraction",           1656 /*, 188*/ }, /* 128 */
	{"fi",                 4757 /*, 174*/ }, /* 129 */
	{"fl",                 4758 /*, 175*/ }, /* 130 */
	{"Lslash",              392 /*, 232*/ }, /* 131 */
	{"lslash",              386 /*, 248*/ }, /* 132 */
	{"Eth",                 363 /*, 208*/ }, /* 133 */
	{"eth",                 365 /*, 240*/ }, /* 134 */
	{"Thorn",               364 /*, 222*/ }, /* 135 */
	{"thorn",               366 /*, 254*/ }, /* 136 */
	{"mu",                 7496 /*, 181*/ }, /* 137 */
	{"plusminus",          1706 /*, 177*/ }, /* 138 */
	{"onehalf",            1673 /*, 189*/ }, /* 139 */
	{"Dieresis",           1881 /*, 168*/ }, /* 140 */
	{"grave",              1853 /*, 146*/ }, /* 141 */
	{"periodcentered",     1737 /*, 183*/ }, /* 142 */
	{"tilde",              1856 /*,   0*/ }, /* 143 */
	{"circumflex",         1855 /*,   0*/ }, /* 144 */
	{"endash",             1574 /*, 150*/ }, /* 145 */
	{"acute",              1852 /*,   0*/ }, /* 146 */
	{"macron",             1859 /*,   0*/ }, /* 147 */
	{"catalan",            1904 /*, 145*/ }, /* 148 */
	{"Catalan",            1905 /*, 145*/ }, /* 149 */
	{"ring",               1857 /*,   0*/ }, /* 150 */
	{"dotaccent",          1861 /*,   0*/ }, /* 151 */
	{"hungarumlaut",       1847 /*,   0*/ }, /* 152 */
	{"cedilla",            1851 /*,   0*/ }, /* 153 */
	{"ogonek",             1846 /*,   0*/ }, /* 154 */
	{"Caron",              1885 /*,   0*/ }, /* 155 */
	{"breve",              1860 /*,   0*/ }, /* 156 */
	{"dotlessi",            243 /*,   0*/ }, /* 157 */
	{".notdef",               0 /*, 106*/ }, /* 158 */
	{"quotedblbase",       1094 /*,   0*/ }, /* 159 */
	{"Agrave",              566 /*, 192*/ }, /* 160 */
	{"Acircumflex",         567 /*, 194*/ }, /* 161 */
	{"Egrave",              551 /*, 200*/ }, /* 162 */
	{"Ecircumflex",         571 /*, 202*/ }, /* 163 */
	{"Edieresis",           572 /*, 203*/ }, /* 164 */
	{"Icircumflex",         575 /*, 206*/ }, /* 165 */
	{"Idieresis",           576 /*, 207*/ }, /* 166 */
	{"copyright",          4768 /*, 169*/ }, /* 167 */
	{"registered",         4767 /*, 174*/ }, /* 168 */
	{"trademark",          4770 /*,   0*/ }, /* 169 */
	{"guilsinglleft",       424 /*, 176*/ }, /* 170 */
	{"guilsinglright",      423 /*, 180*/ }, /* 171 */
	{"Ugrave",              583 /*, 217*/ }, /* 172 */
	{"Ucircumflex",         584 /*, 219*/ }, /* 173 */
	{"carriagereturn",     4662 /*,   0*/ }, /* 174 */
	{"perthousand",         839 /*,   0*/ }, /* 175 */
	{"quotedblleft1",       444 /*, 147*/ }, /* 176 */
	{"quotedblright",       445 /*, 148*/ }, /* 177 */
	{"Ccedilla",            276 /*, 199*/ }, /* 178 */
	{"ccedilla",            238 /*, 184*/ }, /* 179 */
	{"Ntilde",              577 /*, 209*/ }, /* 180 */
	{"ntilde",              248 /*, 241*/ }, /* 181 */
	{"exclamdown",           98 /*, 161*/ }, /* 182 */
	{"questiondown",         99 /*, 191*/ }, /* 183 */
	{"currency",           1825 /*, 164*/ }, /* 184 */
	{"sterling",           1700 /*, 163*/ }, /* 185 */
	{"yen",                1725 /*, 165*/ }, /* 186 */
	{"section",            1716 /*, 167*/ }, /* 187 */
	{"florin",             1703 /*,   0*/ }, /* 188 */
	{"cent",               1603 /*, 162*/ }, /* 189 */
	{"acircumflex",         234 /*, 226*/ }, /* 190 */
	{"ecircumflex",         242 /*, 234*/ }, /* 191 */
	{"ocircumflex",         252 /*, 244*/ }, /* 192 */
	{"ucircumflex",         257 /*, 251*/ }, /* 193 */
	{"aacute",              232 /*, 225*/ }, /* 194 */
	{"eacute",              240 /*, 233*/ }, /* 195 */
	{"oacute",              249 /*, 243*/ }, /* 196 */
	{"uacute",              254 /*, 250*/ }, /* 197 */
	{"agrave",              231 /*, 224*/ }, /* 198 */
	{"egrave",              239 /*, 232*/ }, /* 199 */
	{"ograve",              250 /*, 242*/ }, /* 200 */
	{"ugrave",              255 /*, 249*/ }, /* 201 */
	{"adieresis",           233 /*, 228*/ }, /* 202 */
	{"edieresis",           241 /*, 235*/ }, /* 203 */
	{"odieresis",           251 /*, 246*/ }, /* 204 */
	{"udieresis",           256 /*, 252*/ }, /* 205 */
	{"Aring",               564 /*, 197*/ }, /* 206 */
	{"icircumflex",         247 /*, 238*/ }, /* 207 */
	{"Oslash",              291 /*, 216*/ }, /* 208 */
	{"AE",                  172 /*, 198*/ }, /* 209 */
	{"aring",               236 /*, 229*/ }, /* 210 */
	{"iacute",              244 /*, 237*/ }, /* 211 */
	{"oslash",              253 /*, 248*/ }, /* 212 */
	{"ae",                  174 /*, 230*/ }, /* 213 */
	{"Adieresis",           563 /*, 196*/ }, /* 214 */
	{"igrave",              245 /*, 236*/ }, /* 215 */
	{"Odieresis",           558 /*, 214*/ }, /* 216 */
	{"Udieresis",           585 /*, 220*/ }, /* 217 */
	{"Eacute",              570 /*, 201*/ }, /* 218 */
	{"idieresis",           246 /*, 239*/ }, /* 219 */
	{"germandbls",          177 /*, 223*/ }, /* 220 */
	{"Ocircumflex",         569 /*, 212*/ }, /* 221 */
	{"Aacute",              565 /*, 193*/ }, /* 222 */
	{"Atilde",              568 /*, 195*/ }, /* 223 */
	{"atilde",              235 /*, 227*/ }, /* 224 */
	{"arrowright",         7449 /*,   0*/ }, /* 225 */
	{"homeplate",          7622 /*,   0*/ }, /* 226 */
	{"Iacute",              574 /*, 205*/ }, /* 227 */
	{"Igrave",              573 /*, 204*/ }, /* 228 */
	{"Oacute",              579 /*, 211*/ }, /* 229 */
	{"Ograve",              578 /*, 210*/ }, /* 230 */
	{"Otilde",              581 /*, 213*/ }, /* 231 */
	{"otilde",              258 /*, 245*/ }, /* 232 */
	{"Scaron",              542 /*,   0*/ }, /* 233 */
	{"scaron",              597 /*,   0*/ }, /* 234 */
	{"Uacute",              582 /*, 218*/ }, /* 235 */
	{"Ydieresis",           721 /*,   0*/ }, /* 236 */
	{"ydieresis",           720 /*,   0*/ }, /* 237 */
	{"OE",                  173 /*,   0*/ }, /* 238 */
	{"oe",                  175 /*,   0*/ }, /* 239 */
	{"paragraph",          1717 /*,   0*/ }, /* 240 */
	{"dagger",             1714 /*, 175*/ }, /* 241 */
	{"daggerdbl",          1715 /*,   0*/ }, /* 242 */
	{"emdash",             1575 /*, 151*/ }, /* 243 */
	{"hyphensoft",         7257 /*,   0*/ }, /* 244 */
	{"embox",              7258 /*,   0*/ }, /* 245 */
	{"ordfeminine",        1711 /*,   0*/ }, /* 246 */
	{"ordmasculine",       1712 /*,   0*/ }, /* 247 */
	{"guillemotleft",        96 /*, 171*/ }, /* 248 */
	{"guillemotright",       97 /*, 187*/ }, /* 249 */
	{"ellipsis",           1722 /*,   0*/ }, /* 250 */

	/* The following codes are not used by Powerpak but are for
	*  font conversions requiring character sets beyond 256
	*  characters */
	{"brokenbar",          7286 /*, 166*/ }, /* 251 */
	{"logicalnot",         7018 /*,   0*/ }, /* 252 */
	{"minus",              1705 /*, 173*/ }, /* 253 */
	{"Macron",             1886 /*,   0*/ }, /* 254 */
	{"degree",             1713 /*, 176*/ }, /* 255 */
	{"twosuperior",        1620 /*,   0*/ }, /* 256 */
	{"threesuperior",      1621 /*,   0*/ }, /* 257 */
	{"dotaccentspacing",   7348 /*,   0*/ }, /* 258 */
	{"onesuperior",        1619 /*,   0*/ }, /* 259 */
	{"onequarter",         1674 /*,   0*/ }, /* 260 */
	{"threequarters",      1675 /*,   0*/ }, /* 261 */
	{"multiply",           1708 /*, 215*/ }, /* 262 */
	{"Yacute",              367 /*,   0*/ }, /* 263 */
	{"yacute",              368 /*,   0*/ }, /* 264 */
	{"divide",             1709 /*, 247*/ }, /* 265 */
	{"radical1",           1286 /*,   0*/ }, /* 266 */
	{"greaterequal",       1323 /*,   0*/ }, /* 267 */
	{"lessequal",          1324 /*,   0*/ }, /* 268 */
	{"notequal",           7483 /*,   0*/ }, /* 269 */
	{"infinity",           7548 /*,   0*/ }, /* 270 */
	{"partialdiff",        7481 /*,   0*/ }, /* 271 */
	{"Sigma",              1228 /*,   0*/ }, /* 272 */
	{"lozenge",            7607 /*,   0*/ }, /* 273 */
	{"Delta",              1219 /*,   0*/ }, /* 274 */
	{"approxequal",        1267 /*,   0*/ }, /* 275 */
	{"Omega",              1237 /*,   0*/ }, /* 276 */
	{"product",            4669 /*,   0*/ }, /* 277 */
	{"pi",                 1248 /*,   0*/ }, /* 278 */
	{"integral",           7544 /*,   0*/ }, /* 279 */
	{"apple",              7679 /*,   0*/ }, /* 280 */
	{"hardspace",          7260 /*,   0*/ }, /* 281 */
	{"Zcaron",              541 /*,   0*/ }, /* 282 */
	{"zcaron",              599 /*,   0*/ }, /* 283 */
	{"underscoredbl",      2589 /*,   0*/ }, /* 284 */
	{"quotesinglbase",      790 /*,   0*/ }, /* 285 */
	{"dbleexclam",          106 /*,   0*/ }, /* 286 */
	{"nsuperior",          1591 /*,   0*/ }, /* 287 */
	{"franc",               749 /*,   0*/ }, /* 288 */
	{"peseta",             1807 /*,   0*/ }, /* 289 */
	{"Gamma",              1215 /*,   0*/ }, /* 290 */
	{"Theta",              1231 /*,   0*/ }, /* 291 */
	{"Phi",                1234 /*,   0*/ }, /* 292 */
	{"alpha",              1240 /*,   0*/ }, /* 293 */
	{"delta",              1242 /*,   0*/ }, /* 294 */
	{"epsilon",            1254 /*,   0*/ }, /* 295 */
	{"sigma",              1250 /*,   0*/ }, /* 296 */
	{"tau",                1261 /*,   0*/ }, /* 297 */
	{"phi1",               1374 /*,   0*/ }, /* 298 */
	{"arrowleft",          7448 /*,   0*/ }, /* 299 */
	{"arrowup",            7447 /*,   0*/ }, /* 300 */
	{"arrowdown",          7446 /*,   0*/ }, /* 301 */
	{"arrowboth",          7452 /*,   0*/ }, /* 302 */
	{"northsoutharrow",    7450 /*,   0*/ }, /* 303 */
	{"nrthstharrowperp",   7451 /*,   0*/ }, /* 304 */
	{"orthogonal",            0 /*,   0*/ }, /* 305 */
	{"intersection",       1335 /*,   0*/ }, /* 306 */
	{"equivalence",        1273 /*,   0*/ }, /* 307 */
	{"logicalnotreverse",  7276 /*,   0*/ }, /* 308 */
	{"integraltp",         7444 /*,   0*/ }, /* 309 */
	{"integralbt",         7445 /*,   0*/ }, /* 310 */
	{"closedbox",          1404 /*,   0*/ }, /* 311 */
	{"emcircleopen",       7439 /*,   0*/ }, /* 312 */
	{"trianglesolidup",    7004 /*,   0*/ }, /* 313 */
	{"trianglesolidright", 7006 /*,   0*/ }, /* 314 */
	{"trianglesoliddown",  7002 /*,   0*/ }, /* 315 */
	{"trianglesolidleft",  7005 /*,   0*/ }, /* 316 */
	{"inversecenterbullet",7440 /*,   0*/ }, /* 317 */
	{"inverselargecircle", 7441 /*,   0*/ }, /* 318 */
	{"Rcaron",              777 /*,   0*/ }, /* 319 */
	{"solidfilltophalf",   7420 /*,   0*/ }, /* 320 */
	{"solidfillbottomhalf",7419 /*,   0*/ }, /* 321 */
	{"solidfillcharacter", 7418 /*,   0*/ }, /* 322 */
	{"solidfilllefthalf",  7421 /*,   0*/ }, /* 323 */
	{"solidfillrighthalf", 7422 /*,   0*/ }, /* 324 */
	{"thickunderliningrule",7423 /*,  0*/ }, /* 325 */
	{"seventyfivegraytint",7424 /*,   0*/ }, /* 326 */
	{"twentyfivegraytint", 7425 /*,   0*/ }, /* 327 */
	{"smileface",          7431 /*,   0*/ }, /* 328 */
	{"darksmile",          7432 /*,   0*/ }, /* 329 */
	{"sun",                7533 /*,   0*/ }, /* 330 */
	{"female",             7435 /*,   0*/ }, /* 331 */
	{"male",               7436 /*,   0*/ }, /* 332 */
	{"spade",              7430 /*,   0*/ }, /* 333 */
	{"club",               7429 /*,   0*/ }, /* 334 */
	{"heart",              7427 /*,   0*/ }, /* 335 */
	{"diamond1",           7428 /*,   0*/ }, /* 336 */
	{"eighthnote",         7433 /*,   0*/ }, /* 337 */
	{"doublesixteenthnote",7434 /*,   0*/ }, /* 338 */
	{"Abreve",              733 /*,   0*/ }, /* 339 */
	{"abreve",              259 /*,   0*/ }, /* 340 */
	{"Aogonek",             375 /*,   0*/ }, /* 341 */
	{"aogonek",             383 /*,   0*/ }, /* 342 */
	{"Cacute",              376 /*,   0*/ }, /* 343 */
	{"cacute",              384 /*,   0*/ }, /* 344 */
	{"Ccaron",              540 /*,   0*/ }, /* 345 */
	{"ccaron",              593 /*,   0*/ }, /* 346 */
	{"Dcaron",              587 /*,   0*/ }, /* 347 */
	{"dcaron",                0 /*,   0*/ }, /* 348 */
	{"Dslash",              363 /*,   0*/ }, /* 349 */
	{"dslash",              308 /*,   0*/ }, /* 350 */
	{"Eogonek",             377 /*,   0*/ }, /* 351 */
	{"eogonek",             385 /*,   0*/ }, /* 352 */
	{"Ecaron",              719 /*,   0*/ }, /* 353 */
	{"ecaron",              260 /*,   0*/ }, /* 354 */
	{"Gbreve",              369 /*,   0*/ }, /* 355 */
	{"gbreve",              343 /*,   0*/ }, /* 356 */
	{"Idot",                371 /*,   0*/ }, /* 357 */
	{"Lacute",              757 /*,   0*/ }, /* 358 */
	{"lacute",              758 /*,   0*/ }, /* 359 */
	{"Lcaron",              588 /*,   0*/ }, /* 360 */
	{"lcaron",              265 /*,   0*/ }, /* 361 */
	{"Nacute",              378 /*,   0*/ }, /* 362 */
	{"nacute",              387 /*,   0*/ }, /* 363 */
	{"Ncaron",              589 /*,   0*/ }, /* 364 */
	{"ncaron",              596 /*,   0*/ }, /* 365 */
	{"Odblacute",           411 /*,   0*/ }, /* 366 */
	{"odblacute",           306 /*,   0*/ }, /* 367 */
	{"Racute",              759 /*,   0*/ }, /* 368 */
	{"racute",              268 /*,   0*/ }, /* 369 */
	{"rcaron",              269 /*,   0*/ }, /* 370 */
	{"Sacute",              380 /*,   0*/ }, /* 371 */
	{"sacute",              389 /*,   0*/ }, /* 372 */
	{"Scedilla",            370 /*,   0*/ }, /* 373 */
	{"scedilla",            844 /*,   0*/ }, /* 374 */
	{"Tcedilla",            562 /*,   0*/ }, /* 375 */
	{"tcedilla",            298 /*,   0*/ }, /* 376 */
	{"Tcaron",              591 /*,   0*/ }, /* 377 */
	{"tcaron",              598 /*,   0*/ }, /* 378 */
	{"Uring",               448 /*,   0*/ }, /* 379 */
	{"uring",               447 /*,   0*/ }, /* 380 */
	{"Udblacute",           412 /*,   0*/ }, /* 381 */
	{"udblacute",           307 /*,   0*/ }, /* 382 */
	{"Zacute",              381 /*,   0*/ }, /* 383 */
	{"zacute",              390 /*,   0*/ }, /* 384 */
	{"Zdot",                382 /*,   0*/ }, /* 385 */
	{"zdot",                391 /*,   0*/ }, /* 386 */
	{"foursuperior",       1622 /*,   0*/ }, /* 387 */
	{"Pt",                 1807 /*,   0*/ }, /* 388 */
	{"logicalnotflopped",  7277 /*,   0*/ }, /* 389 */
	{"Dotaccentspacing",   7347 /*,   0*/ }, /* 390 */
	{"Lcatalan",           7291 /*,   0*/ }, /* 391 */
	{"lcatalan",           7295 /*,   0*/ }, /* 392 */
	{"IJ",                  349 /*,   0*/ }, /* 393 */
	{"ij",                  176 /*,   0*/ }, /* 394 */
	{"ff",                 4759 /*,   0*/ }, /* 395 */
	{"ffi",                4760 /*,   0*/ }, /* 396 */
	{"ffl",                4761 /*,   0*/ }, /* 397 */
	{"fivesuperior",       1623 /*,   0*/ }, /* 398 */
	{"sixsuperior",        1624 /*,   0*/ }, /* 399 */
	{"sevensuperior",      1625 /*,   0*/ }, /* 400 */
	{"eightsuperior",      1626 /*,   0*/ }, /* 401 */
	{"ninesuperior",       1627 /*,   0*/ }, /* 402 */
	{"zerosuperior",       1628 /*,   0*/ }, /* 403 */
	{"apostrophen",        7287 /*,   0*/ }, /* 404 */
	{"liter",              7248 /*,   0*/ }, /* 405 */
	{"slogan",             4771 /*,   0*/ }, /* 406 */
	{"prescription",        480 /*,   0*/ }, /* 407 */
	{"careofscript",       3171 /*,   0*/ }, /* 408 */
/*
Following codes added 6/11/91 for chars in symbol set but missing
from master list - rs
*/
	{"quotesingle",        7255 /*,   0*/ }, /* 409 */
	{"centerperiod",       1684 /*,   0*/ }, /* 410 */
	{"gravespacing",       7313 /*,   0*/ }, /* 411 */
	{"acutespacing",       7314 /*,   0*/ }, /* 412 */
	{"circumflexspacing",  7316 /*,   0*/ }, /* 413 */
	{"tildespacing",       7317 /*,   0*/ }, /* 414 */
	{"macronspacing",      7318 /*,   0*/ }, /* 415 */
	{"brevespacing",       7345 /*,   0*/ }, /* 416 */
	{"dieresisspacing",    7315 /*,   0*/ }, /* 417 */
/*
The following information added 6/24/91 to include the remaining
characters found in the Type Director Glyph List - Tina
*/
   {"copyrightlarge",     493 /*,   0*/ }, /* 418 */
   {"trademarksans",      497 /*,   0*/ }, /* 419 */
   {"registersans",       791 /*,   0*/ }, /* 420 */
   {"enspacereverse",     813 /*,   0*/ }, /* 421 */
   {"emspacereverse",     814 /*,   0*/ }, /* 422 */
   {"beta",              1241 /*,   0*/ }, /* 423 */
   {"eta",               1243 /*,   0*/ }, /* 424 */
   {"mu",                1246 /*,   0*/ }, /* 425 */
   {"register2",         1282 /*,   0*/ }, /* 426 */
   {"opensquare",        1303 /*,   0*/ }, /* 427 */
   {"encirclemedium",    1307 /*,   0*/ }, /* 428 */
   {"embulletsolid",     1406 /*,   0*/ }, /* 429 */
   {"encircleopen",      1407 /*,   0*/ }, /* 430 */
   {"emboxopen1",        1451 /*,   0*/ }, /* 431 */
   {"minute",            1727 /*,   0*/ }, /* 432 */
   {"second",            1728 /*,   0*/ }, /* 433 */
   {"thinspace",         1751 /*,   0*/ }, /* 434 */
   {"enspace",           1752 /*,   0*/ }, /* 435 */
   {"emspace",           1753 /*,   0*/ }, /* 436 */
   {"grave",             1853 /*,   0*/ }, /* 437 */
   {"dieresis",          1854 /*,   0*/ }, /* 438 */
   {"caron",             1858 /*,   0*/ }, /* 439 */
   {"Ogonek",            1873 /*,   0*/ }, /* 440 */
   {"Hungarumlaut",      1874 /*,   0*/ }, /* 441 */
   {"Cedilla",           1878 /*,   0*/ }, /* 442 */
   {"Acute",             1879 /*,   0*/ }, /* 443 */
   {"Grave",             1880 /*,   0*/ }, /* 444 */
   {"Circumflex",        1882 /*,   0*/ }, /* 445 */
   {"Tilde",             1883 /*,   0*/ }, /* 446 */
   {"Ring",              1884 /*,   0*/ }, /* 447 */
   {"Breve",             1887 /*,   0*/ }, /* 448 */
   {"Dotaccent",         1888 /*,   0*/ }, /* 449 */
   {"carriagereturn1",   4793 /*,   0*/ }, /* 450 */
   {"emboxsolid",        7009 /*,   0*/ }, /* 451 */
   {"enboxsolid",        7252 /*,   0*/ }, /* 452 */
   {"enboxopen",         7253 /*,   0*/ }, /* 453 */
   {"trademark",         7254 /*,   0*/ }, /* 454 */
   {"embox",             7258 /*,   0*/ }, /* 455 */
   {"arrowtab",          7259 /*,   0*/ }, /* 456 */
   {"connector",         7274 /*,   0*/ }, /* 457 */
   {"connectordouble",   7275 /*,   0*/ }, /* 458 */
   {"asciigrave",        7284 /*,   0*/ }, /* 459 */
   {"lira",              7297 /*,   0*/ }, /* 460 */
   {"Caronspacing",      7304 /*,   0*/ }, /* 461 */
   {"Cedillaspacing",    7305 /*,   0*/ }, /* 462 */
   {"Gravespacing",      7306 /*,   0*/ }, /* 463 */
   {"Acutespacing",      7307 /*,   0*/ }, /* 464 */
   {"Dieresisspacing",   7308 /*,   0*/ }, /* 465 */
   {"Circumflexspacing", 7309 /*,   0*/ }, /* 466 */
   {"Tildespacing",      7310 /*,   0*/ }, /* 467 */
   {"Macronspacing",     7311 /*,   0*/ }, /* 468 */
   {"Ringspacing",       7312 /*,   0*/ }, /* 469 */
   {"ringspacing",       7319 /*,   0*/ }, /* 470 */
   {"cedillaspacing",    7320 /*,   0*/ }, /* 471 */
   {"caronspacing",      7321 /*,   0*/ }, /* 472 */
   {"hungarumlautspacing",7322 /*,  0*/ }, /* 473 */
   {"Hungarumlautspacing",7323 /*,  0*/ }, /* 474 */
   {"Brevespacing",      7346 /*,   0*/ }, /* 475 */
   {"ogonekspacing",     7349 /*,   0*/ }, /* 476 */
   {"Ogonekspacing",     7350 /*,   0*/ }, /* 477 */
   {"thinintersctinglines",7378 /*, 0*/ }, /* 478 */
   {"thinverticalline",  7379 /*,   0*/ }, /* 479 */
   {"rightmiddleboxside",7380 /*,   0*/ }, /* 480 */
   {"middleboxbottom",   7381 /*,   0*/ }, /* 481 */
   {"middleboxtop",      7382 /*,   0*/ }, /* 482 */
   {"leftmiddleboxside", 7383 /*,   0*/ }, /* 483 */
   {"centerboxbarhoriz", 7384 /*,   0*/ }, /* 484 */
   {"upperrightboxcorner",7385 /*,  0*/ }, /* 485 */
   {"lowerrightboxcorner",7386 /*,  0*/ }, /* 486 */
   {"lowerleftboxcorner",7387 /*,   0*/ }, /* 487 */
   {"upperleftboxcorner",7388 /*,   0*/ }, /* 488 */
   {"boxinterdbletosngle",7389 /*,  0*/ }, /* 489 */
   {"midbotsngletodble", 7390 /*,   0*/ }, /* 490 */
   {"midtopdbletosngle", 7391 /*,   0*/ }, /* 491 */
   {"rightboxsiddblesingl",7392 /*, 0*/ }, /* 492 */
   {"leftboxsidesngltodbl",7393 /*, 0*/ }, /* 493 */
   {"lwrrightboxdbltosngl",7394 /*, 0*/ }, /* 494 */
   {"lwrleftsngletodble",7395 /*,   0*/ }, /* 495 */
   {"uprlftsingletodble",7396 /*,   0*/ }, /* 496 */
   {"uprrightboxdbltosngl",7397 /*, 0*/ }, /* 497 */
   {"boxintersectiondble",7398 /*,  0*/ }, /* 498 */
   {"lowerleftbxcrnrdble",7399 /*,  0*/ }, /* 499 */
   {"uprleftboxcrnrdble", 7400 /*,  0*/ }, /* 500 */
   {"uprrghtboxcrndble",  7401 /*,  0*/ }, /* 501 */
   {"lowerrghtbxcrnrdbl", 7402 /*,  0*/ }, /* 502 */
   {"rightboxsidedouble", 7403 /*,  0*/ }, /* 503 */
   {"middleboxbottomdble",7404 /*,  0*/ }, /* 504 */
   {"middleboxtopdouble", 7405 /*,  0*/ }, /* 505 */
   {"leftboxsidedouble",  7406 /*,  0*/ }, /* 506 */
   {"cntrboxbarhorizdble",7407 /*,  0*/ }, /* 507 */
   {"boxintersngltodble", 7408 /*,  0*/ }, /* 508 */
   {"lftboxsiddbltosngl", 7409 /*,  0*/ }, /* 509 */
   {"centerboxbarvertdbl",7410 /*,  0*/ }, /* 510 */
   {"rightboxsidesngdbl", 7411 /*,  0*/ }, /* 511 */
   {"midtopsingletodble", 7412 /*,  0*/ }, /* 512 */
   {"midbotdbletosingle", 7413 /*,  0*/ }, /* 513 */
   {"lwrleftcrnrdbltosngl",7414 /*, 0*/ }, /* 514 */
   {"upprlftdbletosngl",  7415 /*,  0*/ }, /* 515 */
   {"upprrghtboxcrner",   7416 /*,  0*/ }, /* 516 */
   {"lwrrghtbxsngltodble",7417 /*,  0*/ }, /* 517 */
   {"error",              7426 /*,  0*/ }, /* 518 */
   {"infinityserif",      7442 /*,  0*/ }, /* 519 */
   {"northwestarrow",     7453 /*,  0*/ }, /* 520 */
   {"northeastarrow",     7454 /*,  0*/ }, /* 521 */
   {"southeastarrow",     7455 /*,  0*/ }, /* 522 */
   {"southwestarrow",     7456 /*,  0*/ }, /* 523 */
   {"arrowdblleft",       7457 /*,  0*/ }, /* 524 */
   {"arrowdblright",      7458 /*,  0*/ }, /* 525 */
   {"arrowdblup",         7459 /*,  0*/ }, /* 526 */
   {"arrowdbldown",       7460 /*,  0*/ }, /* 527 */
   {"arrowdblboth",       7461 /*,  0*/ }, /* 528 */
   {"doublearrowupdown",  7462 /*,  0*/ }, /* 529 */
   {"radical",            7463 /*,  0*/ }, /* 530 */
   {"isproportionalserif",7464 /*,  0*/ }, /* 531 */
   {"baseofnaturallog",   7466 /*,  0*/ }, /* 532 */
   {"Epsilon",            7467 /*,  0*/ }, /* 533 */
   {"therefore",          7468 /*,  0*/ }, /* 534 */
   {"Gamma",              7469 /*,  0*/ }, /* 535 */
   {"Delta",              7470 /*,  0*/ }, /* 536 */
   {"Theta",              7471 /*,  0*/ }, /* 537 */
   {"Lambda",             7472 /*,  0*/ }, /* 538 */
   {"Xi",                 7473 /*,  0*/ }, /* 539 */
   {"Sigma",              7475 /*,  0*/ }, /* 540 */
   {"Upsilon",            7476 /*,  0*/ }, /* 541 */
   {"Phi",                7477 /*,  0*/ }, /* 542 */
   {"Psi",                7478 /*,  0*/ }, /* 543 */
   {"Omega",              7479 /*,  0*/ }, /* 544 */
   {"gradient",           7480 /*,  0*/ }, /* 545 */
   {"sigma1",             7482 /*,  0*/ }, /* 546 */
   {"summationbottomrule",7484 /*,  0*/ }, /* 547 */
   {"alpha",              7485 /*,  0*/ }, /* 548 */
   {"beta",               7486 /*,  0*/ }, /* 549 */
   {"gamma",              7487 /*,  0*/ }, /* 550 */
   {"delta",              7488 /*,  0*/ }, /* 551 */
   {"epsilon",            7489 /*,  0*/ }, /* 552 */
   {"zeta",               7490 /*,  0*/ }, /* 553 */
   {"eta",                7491 /*,  0*/ }, /* 554 */
   {"theta",              7492 /*,  0*/ }, /* 555 */
   {"iota",               7493 /*,  0*/ }, /* 556 */
   {"kappa",              7494 /*,  0*/ }, /* 557 */
   {"lambda",             7495 /*,  0*/ }, /* 558 */
   {"nu",                 7497 /*,  0*/ }, /* 559 */
   {"xi",                 7498 /*,  0*/ }, /* 560 */
   {"omicron",            7499 /*,  0*/ }, /* 561 */
   {"pi",                 7500 /*,  0*/ }, /* 562 */
   {"rho",                7501 /*,  0*/ }, /* 563 */
   {"sigma",              7502 /*,  0*/ }, /* 564 */
   {"tau",                7503 /*,  0*/ }, /* 565 */
   {"upsilon",            7504 /*,  0*/ }, /* 566 */
   {"phi",                7505 /*,  0*/ }, /* 567 */
   {"chi",                7506 /*,  0*/ }, /* 568 */
   {"psi",                7507 /*,  0*/ }, /* 569 */
   {"omega",              7508 /*,  0*/ }, /* 570 */
   {"theta1",             7509 /*,  0*/ }, /* 571 */
   {"phiopenalternate",   7510 /*,  0*/ }, /* 572 */
   {"pialternate",        7511 /*,  0*/ }, /* 573 */
   {"approximatelyequal", 7512 /*,  0*/ }, /* 574 */
   {"notidenticalwith",   7513 /*,  0*/ }, /* 575 */
   {"rghtarrwoverleftarrw",7514 /*, 0*/ }, /* 576 */
   {"reversiblereaction", 7515 /*,  0*/ }, /* 577 */
   {"vectorsymbol",       7516 /*,  0*/ }, /* 578 */
   {"summationtoprule",   7517 /*,  0*/ }, /* 579 */
   {"universal",          7518 /*,  0*/ }, /* 580 */
   {"existential",        7519 /*,  0*/ }, /* 581 */
   {"perpndiclarupsidedwn",7520 /*, 0*/ }, /* 582 */
   {"perpendicular",      7521 /*,  0*/ }, /* 583 */
   {"union",              7522 /*,  0*/ }, /* 584 */
   {"element",            7523 /*,  0*/ }, /* 585 */
   {"suchthat",           7524 /*,  0*/ }, /* 586 */
   {"notelement",         7525 /*,  0*/ }, /* 587 */
   {"propersubset",       7526 /*,  0*/ }, /* 588 */
   {"propersuperset",     7527 /*,  0*/ }, /* 589 */
   {"notsubset",          7528 /*,  0*/ }, /* 590 */
   {"doesnotcontain",     7529 /*,  0*/ }, /* 591 */
   {"reflexsubset",       7530 /*,  0*/ }, /* 592 */
   {"reflexsuperset",     7531 /*,  0*/ }, /* 593 */
   {"circleplus",         7532 /*,  0*/ }, /* 594 */
   {"circlemultiply",     7534 /*,  0*/ }, /* 595 */
   {"abstractminus",      7535 /*,  0*/ }, /* 596 */
   {"abstractdivide",     7536 /*,  0*/ }, /* 597 */
   {"logicaland",         7537 /*,  0*/ }, /* 598 */
   {"logicalor",          7538 /*,  0*/ }, /* 599 */
   {"exclusiveor",        7539 /*,  0*/ }, /* 600 */
   {"functionalcomposite",7540 /*,  0*/ }, /* 601 */
   {"circlelarge",        7541 /*,  0*/ }, /* 602 */
   {"perpendicularleft",  7542 /*,  0*/ }, /* 603 */
   {"perpendicularright", 7543 /*,  0*/ }, /* 604 */
   {"contourintegral",    7545 /*,  0*/ }, /* 605 */
   {"angle",              7546 /*,  0*/ }, /* 606 */
   {"emptyset",           7547 /*,  0*/ }, /* 607 */
   {"Beth",               7549 /*,  0*/ }, /* 608 */
   {"Gimel",              7550 /*,  0*/ }, /* 609 */
   {"cblackletter",       7551 /*,  0*/ }, /* 610 */
   {"iblackletter",       7552 /*,  0*/ }, /* 611 */
   {"Rfraktur",           7553 /*,  0*/ }, /* 612 */
   {"zblackletter",       7554 /*,  0*/ }, /* 613 */
   {"bracketlefttp",      7555 /*,  0*/ }, /* 614 */
   {"bracketleftbt",      7556 /*,  0*/ }, /* 615 */
   {"bracelefttp",        7557 /*,  0*/ }, /* 616 */
   {"braceleftmid",       7558 /*,  0*/ }, /* 617 */
   {"braceleftbt",        7559 /*,  0*/ }, /* 618 */
   {"contourintegcenter", 7560 /*,  0*/ }, /* 619 */
   {"summationtoplftcrnr",7561 /*,  0*/ }, /* 620 */
   {"centerlinedbl",      7562 /*,  0*/ }, /* 621 */
   {"summationbotomlftcrnr",7563 /*,0*/ }, /* 622 */
   {"summationlowerdiag", 7564 /*,  0*/ }, /* 623 */
   {"bracketrighttp",     7565 /*,  0*/ }, /* 624 */
   {"bracketrightbt",     7566 /*,  0*/ }, /* 625 */
   {"bracerighttp",       7567 /*,  0*/ }, /* 626 */
   {"bracerightmid",      7568 /*,  0*/ }, /* 627 */
   {"bracerightbt",       7569 /*,  0*/ }, /* 628 */
   {"braceverticalpiece", 7570 /*,  0*/ }, /* 629 */
   {"histogram",          7571 /*,  0*/ }, /* 630 */
   {"radicalcomposite",   7572 /*,  0*/ }, /* 631 */
   {"summationtopright",  7573 /*,  0*/ }, /* 632 */
   {"summationcenterpiece",7574 /*, 0*/ }, /* 633 */
   {"summationbottomright",7575 /*, 0*/ }, /* 634 */
   {"summationupperdiag", 7576 /*,  0*/ }, /* 635 */
   {"minusplus",          7577 /*,  0*/ }, /* 636 */
   {"obtuselessthan",     7578 /*,  0*/ }, /* 637 */
   {"obtusegreaterthan",  7579 /*,  0*/ }, /* 638 */
   {"masksymbol",         7580 /*,  0*/ }, /* 639 */
   {"congruent",          7581 /*,  0*/ }, /* 640 */
   {"triangleup",         7582 /*,  0*/ }, /* 641 */
   {"triangleright",      7583 /*,  0*/ }, /* 642 */
   {"triangledown",       7584 /*,  0*/ }, /* 643 */
   {"triangleleft",       7585 /*,  0*/ }, /* 644 */
   {"muchlessthan",       7586 /*,  0*/ }, /* 645 */
   {"muchgreaterthan",    7587 /*,  0*/ }, /* 646 */
   {"identical",          7588 /*,  0*/ }, /* 647 */
   {"definedas",          7589 /*,  0*/ }, /* 648 */
   {"Digamma",            7590 /*,  0*/ }, /* 649 */
   {"plancksconstant",    7591 /*,  0*/ }, /* 650 */
   {"lagrangian",         7592 /*,  0*/ }, /* 651 */
   {"powerset",           7593 /*,  0*/ }, /* 652 */
   {"weierstrass",        7594 /*,  0*/ }, /* 653 */
   {"summation",          7595 /*,  0*/ }, /* 654 */
   {"bracketleftdouble",  7596 /*,  0*/ }, /* 655 */
   {"bracketdoublemiddle",7597 /*,  0*/ }, /* 656 */
   {"bracketrightdouble", 7598 /*,  0*/ }, /* 657 */
   {"quartercircletopleft",7599 /*, 0*/ }, /* 658 */
   {"qrtrcrclbottomleft", 7600 /*,  0*/ }, /* 659 */
   {"unioncompositemiddle",7601 /*, 0*/ }, /* 660 */
   {"intersection",       7602 /*,  0*/ }, /* 661 */
   {"union",              7603 /*,  0*/ }, /* 662 */
   {"brackleftdbltp",     7604 /*,  0*/ }, /* 663 */
   {"brackleftdblebottom",7605 /*,  0*/ }, /* 664 */
   {"quartrcircletopright",7608 /*, 0*/ }, /* 665 */
   {"qrtrcirclbottomright",7609 /*, 0*/ }, /* 666 */
   {"productbottom",      7610 /*,  0*/ }, /* 667 */
   {"producttop",         7611 /*,  0*/ }, /* 668 */
   {"brackrghtdbltop",    7612 /*,  0*/ }, /* 669 */
   {"brackleftdblbottom", 7613 /*,  0*/ }, /* 670 */
   {"diamond",            7615 /*,  0*/ }, /* 671 */
   {"suchthatrotated",    7616 /*,  0*/ }, /* 672 */
   {"asterisk",           7617 /*,  0*/ }, /* 673 */
   {"arrowextndrsnglhoriz",7618 /*, 0*/ }, /* 674 */
   {"arrowextndrdblehoriz",7619 /*, 0*/ }, /* 675 */
   {"revsummationcenter", 7620 /*,  0*/ }, /* 676 */
   {"because",            7621 /*,  0*/ }, /* 677 */
   {"rightanglesymbol",   7623 /*,  0*/ }, /* 678 */
/*
The following information added 11/21/91 to include 
CG number 7438 , missing when trying to process the
DT symbol set - jfd
*/
   {"Embulletsolid1",     7438 /*,  0*/ }, /* 679 */
/*
Added missing plugin chars. 11/27/91
*/

   {"plus",   				   184 /*,  0*/ }, /* 680 */
   {"minus",   				185 /*,  0*/ }, /* 681 */
   {"plusminus",   			186 /*,  0*/ }, /* 682 */
   {"equal",   				187 /*,  0*/ }, /* 683 */
   {"multiply",   			188 /*,  0*/ }, /* 684 */
   {"divide",   				189 /*,  0*/ }, /* 685 */
   {"degree",   				195 /*,  0*/ }, /* 686 */
   {"numbersign",    	   201 /*,  0*/ }, /* 687 */
   {"suchthat",   	     7325 /*,  0*/ }, /* 688 */
   {"nabla",   	        7326 /*,  0*/ }, /* 689 */
   {"lcitalice",   	     7327 /*,  0*/ }, /* 690 */
   {"currencysymbol",     7338 /*,  0*/ }, /* 691 */
   {"litre",   	        7339 /*,  0*/ }, /* 692 */
   {"not",   	   		  7341 /*,  0*/ }, /* 693 */
   {"tickdownleft",   	  7342 /*,  0*/ }, /* 694 */
   {"tickupleft",   	     7343 /*,  0*/ }, /* 695 */
   {"percent",   	     		182 /*,  0*/ }, /* 696 */
   {"copyright2",   	     1283 /*,  0*/ }, /* 697 */
   {"prescriptionsign",   7336 /*,  0*/ }, /* 698 */
   {"pilcrow",    	     7337 /*,  0*/ }, /* 699 */
   {"compass",    	     7437 /*,  0*/ }, /* 700 */
   {"plus",    	  	     8009 /*,  0*/ }, /* 701 */
   {"minus",   		     8010 /*,  0*/ }, /* 702 */
   {"plusorminus",  	     8011 /*,  0*/ }, /* 703 */
   {"equal",   	  	     8012 /*,  0*/ }, /* 704 */
   {"multiply",   	     8013 /*,  0*/ }, /* 705 */
   {"divide",   	     	  8014 /*,  0*/ }, /* 706 */
   {"logicalnot",   	     8015 /*,  0*/ }, /* 707 */
   {"logicalnotreverse",  8016 /*,  0*/ }, /* 708 */
   {"logicalnotflopped",  8017 /*,  0*/ }, /* 709 */
   {"degree",   	     	  8018 /*,  0*/ }, /* 710 */
   {"righthandindex",     8102 /*,  0*/ }, /* 711 */
   {"scissors1",   	     8103 /*,  0*/ }, /* 712 */
   {"scissors2",   	     8105 /*,  0*/ }, /* 713 */
   {"dingbats",   	     8107 /*,  0*/ }, /* 714 */
   {"sansserifcopyright", 8118 /*,  0*/ }, /* 715 */
   {"mediumopenstar",     8137 /*,  0*/ }, /* 716 */
   {"sixpointedjackstar", 8138 /*,  0*/ }, /* 717 */
   {"sixpointedjackstar1",8139 /*,  0*/ }, /* 718 */
   {"dingbats",   	     8140 /*,  0*/ }, /* 719 */
   {"dingbats",   	     8142 /*,  0*/ }, /* 720 */
   {"dingbats",   	     8144 /*,  0*/ }, /* 721 */
   {"dingbats",   	     8145 /*,  0*/ }, /* 722 */
   {"star1",   	   	  8148 /*,  0*/ }, /* 723 */
   {"twoopensansserif",   8152 /*,  0*/ }, /* 724 */
   {"threeopensansserif", 8153 /*,  0*/ }, /* 725 */
   {"fiveopensansserif",  8155 /*,  0*/ }, /* 726 */
   {"eightopensansserif", 8158 /*,  0*/ }, /* 727 */
   {"tenopensansserif",   8160 /*,  0*/ }, /* 728 */
   {"dingbats",   	     8163 /*,  0*/ }, /* 729 */
   {"dingbats",   	     8166 /*,  0*/ }, /* 730 */
   {"eightsolidsansserif",8168 /*,  0*/ }, /* 731 */
   {"tensolidsansserif",  8170 /*,  0*/ }, /* 732 */
   {"rtopncuffdhandindex",8202 /*,  0*/ }, /* 733 */
   {"dingbats",   	     8203 /*,  0*/ }, /* 734 */
   {"solidbottomscissors",8206 /*,  0*/ }, /* 735 */
   {"telephone1",   	     8207 /*,  0*/ }, /* 736 */
   {"circledphonehandset",8208 /*,  0*/ }, /* 737 */
   {"solidfinial",   	  8211 /*,  0*/ }, /* 738 */
   {"solidstemfinial",    8212 /*,  0*/ }, /* 739 */
   {"altrntenegativestem",8244 /*,  0*/ }, /* 740 */
   {"engravedflowerstar", 8245 /*,  0*/ }, /* 741 */
   {"crossflowerstar",    8246 /*,  0*/ }, /* 742 */
   {"boldcrossflowerstar",8247 /*,  0*/ }, /* 743 */
   {"eightpointwheelstar",8248 /*,  0*/ }, /* 744 */
   {"twoserifopen",   	  8252 /*,  0*/ }, /* 745 */
   {"threeserifopen",     8253 /*,  0*/ }, /* 746 */
   {"fiveserifopen",   	  8255 /*,  0*/ }, /* 747 */
   {"sixserifopen",   	  8256 /*,  0*/ }, /* 748 */
   {"eightserifopen",     8258 /*,  0*/ }, /* 749 */
   {"nineserifopen",   	  8259 /*,  0*/ }, /* 750 */
   {"tenserifopen",   	  8260 /*,  0*/ }, /* 751 */
   {"threeserifsolid",    8263 /*,  0*/ }, /* 752 */
   {"sixserifsolid",   	  8266 /*,  0*/ }, /* 753 */
   {"eightserifsolid",    8268 /*,  0*/ }, /* 754 */
   {"tenserifsolid",   	  8270 /*,  0*/ }, /* 755 */
   {"dottedarrow",   	  8287 /*,  0*/ }, /* 756 */
   {"bolddottedarow",     8288 /*,  0*/ }, /* 757 */
   {"rghtcasualhandindex",8302 /*,  0*/ }, /* 758 */
   {"solidtelephone",     8307 /*,  0*/ }, /* 759 */
   {"opentelephone",   	  8308 /*,  0*/ }, /* 760 */
   {"pencilinhand",   	  8309 /*,  0*/ }, /* 761 */
   {"atsymbol",   	     8317 /*,  0*/ }, /* 762 */
   {"atsymbol1",   	     8318 /*,  0*/ }, /* 763 */
   {"opncntrsixpointstar",8333 /*,  0*/ }, /* 764 */
   {"centeredjackstar",   8339 /*,  0*/ }, /* 765 */
   {"sunflowerinacircle", 8345 /*,  0*/ }, /* 766 */
   {"engravedflower",     8346 /*,  0*/ }, /* 767 */
   {"star3",   	        8347 /*,  0*/ }, /* 768 */
   {"rghtopndblstemarrow",8379 /*,  0*/ }, /* 769 */
   {"boldcasualx",   	  8411 /*,  0*/ }, /* 770 */
   {"c0038480412",   	  8412 /*,  0*/ }, /* 771 */
   {"airplane",   	     8419 /*,  0*/ }, /* 772 */
   {"bdfourpointjackstar",8433 /*,  0*/ }, /* 773 */
   {"peacesign",   	     8438 /*,  0*/ }, /* 774 */
   {"fourclvrpointngstar",8452 /*,  0*/ }, /* 775 */
   {"madeinusapart1",     8600 /*,  0*/ }, /* 776 */
   {"printedinusapar1",   8604 /*,  0*/ }, /* 777 */
   {"c0038487624",   	  8624 /*,  0*/ }, /* 778 */
   {"c0038487627",   	  8627 /*,  0*/ }, /* 779 */
   {"c0038487642",   	  8642 /*,  0*/ }, /* 780 */
   {"rtchalkmarkarrowpt1",8700 /*,  0*/ }, /* 781 */
   {"rtchalkmarkarrowpt1",8701 /*,  0*/ }, /* 782 */
   {"chlkmarkcrossoutpt1",8704 /*,  0*/ }, /* 783 */
   {"chlkmarkcrossoutpt2",8706 /*,  0*/ }, /* 784 */
   {"dblbrchlkmrkcrsspt1",8708 /*,  0*/ }, /* 785 */
   {"dblbrchlkmrkcrsspt3",8710 /*,  0*/ }, /* 786 */
   {"dblbrchlkmrkcrsspt4",8711 /*,  0*/ }, /* 787 */
   {"chlkmrkcheckmarkpt1",8713 /*,  0*/ }, /* 788 */
   {"chlkmrkcheckmarkpt2",8714 /*,  0*/ }, /* 789 */
   {"rightindexpart1",    8717 /*,  0*/ }, /* 790 */
   {"rightindexpart4",    8720 /*,  0*/ }, /* 791 */
   {"oldfshndtlphnpt2",   8725 /*,  0*/ }, /* 792 */
   {"rtchalkmarkarrowpt5",8738 /*,  0*/ }, /* 793 */
   {"rtopnhndindx2pt1",   8739 /*,  0*/ }, /* 794 */
   {"rtopnhndindx1pt1",   8740 /*,  0*/ }, /* 795 */
   {"rtsldhndindx1pt1",   8741 /*,  0*/ }, /* 796 */
   {"chldsscissorspt1",   8743 /*,  0*/ }, /* 797 */
   {"chkmrkpt1",   	     8744 /*,  0*/ }, /* 798 */
   {"oldfshndtlphnpt1",   8745 /*,  0*/ }, /* 799 */
   {"dagger",   	         196 /*,  0*/ }, /* 800 */
   {"daggerdbl",   	      197 /*,  0*/ }, /* 801 */
   {"section",   	         198 /*,  0*/ }, /* 802 */
   {"asterisk",   	      200 /*,  0*/ }, /* 803 */
   {"superiorregistered", 7331 /*,  0*/ }, /* 804 */
   {"superiorcopyright",  7332 /*,  0*/ }, /* 805 */
   {"superiortrademark",  7333 /*,  0*/ }, /* 806 */
   {"superiorsignature",  7334 /*,  0*/ }, /* 807 */
   {"superiormask",   	  7335 /*,  0*/ }, /* 808 */
   {"commercialat",   	  7340 /*,  0*/ }, /* 809 */
   {"Pi",   	     		  7474 /*,  0*/ }, /* 810 */
   {"percent",   	     	  7980 /*,  0*/ }, /* 811 */
   {"perthousand",   	  7981 /*,  0*/ }, /* 812 */
   {"careofscript",   	  7982 /*,  0*/ }, /* 813 */
   {"dagger",   	     	  8006 /*,  0*/ }, /* 814 */
   {"daggerdbl",   	     8007 /*,  0*/ }, /* 815 */
   {"dollar",   	         118 /*,  0*/ }, /* 816 */
   {"cent",   	     			119 /*,  0*/ }, /* 817 */
   {"sterling",   	      180 /*,  0*/ }, /* 818 */
   {"rightbraceupright",  7329 /*,  0*/ }, /* 819 */
   {"leftbraceupright",   7344 /*,  0*/ }, /* 820 */
   {"guilsingleright",    7983 /*,  0*/ }, /* 821 */
   {"guilsingleleft",     7984 /*,  0*/ }, /* 822 */
   {"guillemotleft",   	  7985 /*,  0*/ }, /* 823 */
   {"guillemotright",     7986 /*,  0*/ }, /* 824 */
   {"bracketleft",   	  7989 /*,  0*/ }, /* 825 */
   {"bracketright",   	  7990 /*,  0*/ }, /* 826 */
   {"yen",   	           8008 /*,  0*/ }  /* 827 */


};

GLOBAL SW16 nPS1Codes = (sizeof(PS1Codes)/sizeof(PS1CODESTR));

#else
#if (defined (__STDC__) && (__STDC__  > 0) && !defined(__i960)) || \
    (defined(__i960) && defined(ANSI_960))
int iPS1CODES = 0;
#endif /* __STDC__ */
#endif /* PST1 && IF_RDR */

