/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/ps/pskp.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: pskp.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.4   07 Apr 1995 10:15:58   LISA
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 14:35:10   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   06 Jan 1993 09:47:08   JOE
 * Removed CTRL-Z at end of file.
 * 
 *    Rev 1.1   14 Dec 1992 09:14:48   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 15:54:20   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* pskp.c - PostScript kern pair structure
 *
 *

This file contains a kern pair structure for the Intellifont PostScript
type 1 writer. It was semi-automatically produced by running 'krnstru.exe'
with an input file of 'isoadobe.kp'.

	c:\> krnstru isoadobe.kp pskp.tmp

You must then edit pskp.tmp to add necessary additional information and
eventually rename it to 'pskp.c'.

REVISION HISTORY
----------------
06/27/91  rs	Original file created.
07/10/91  rs	Add comment about maximum # of kern pairs allowed in font.
04/03/92  rs   Portability cleanup (see port.h).
17-Sep-92 jfd  Changed conditional compile of entire module to include
               IF_RDR.
03-Oct-92 rs   Changes toward ANSI C - if file not compiled, must
               declared  at least 1 external - int iPSKP = 0.
06-Jan-93 jfd  Removed CTRL-Z at end of file.
*/

#include "cgconfig.h"
#if PST1 && IF_RDR	/* only compile for PostScript output */
#include "port.h"
#include "ifmem.h"	/* need for cgif.h */
#include "cgif.h"
#include "ps_type1.h"

/*
WARNING: There is a rule which specifies that the maximum number of
			kern pairs allowed in a font is 512. This apperas in the Microsoft
			DDK "Printers and Fonts" manual on page 2-10 for etmKernPairs.
			The define for this value is 'MAXKERNPAIRS'.
*/

GLOBAL CG_KERN_TBL  cg_kern_tbl[] = {
{  88,   88},    /*  '' quoteright,quoteright */
{  88, 1565},    /*  '. quoteright,period */
{  88,   47},    /*  'A quoteright,uppercase A */
{  88,   37},    /*  'C quoteright,uppercase C */
{  88,   34},    /*  'G quoteright,uppercase G */
{  88,   28},    /*  'O quoteright,uppercase O */
{  88,   43},    /*  'S quoteright,uppercase S */
{  88,   17},    /*  's quoteright,lowercase s */
{  87, 1565},    /*  `. quoteleft,period */
{  87,   47},    /*  `A quoteleft,uppercase A */
{  87,   37},    /*  `C quoteleft,uppercase C */
{  87,   34},    /*  `G quoteleft,uppercase G */
{  87,   28},    /*  `O quoteleft,uppercase O */
{ 546, 1565},    /*  ". quotedblleft,period  */
{ 546,   47},    /*  "A quotedblleft,uppercase A */
{ 546,   37},    /*  "C quotedblleft,uppercase C */
{ 546,   34},    /*  "G quotedblleft,uppercase G */
{ 546,   28},    /*  "O quotedblleft,uppercase O */
{ 546,   21},    /*  "a quotedblleft,lowercase a */
{ 546,   11},    /*  "c quotedblleft,lowercase c */
{ 546,   13},    /*  "e quotedblleft,lowercase e */
{ 445, 1565},    /*  ". quotedblright,period  */
{ 445,   47},    /*  "A quotedblright,uppercase A */
{ 445,   37},    /*  "C quotedblright,uppercase C */
{ 445,   34},    /*  "G quotedblright,uppercase G */
{ 445,   28},    /*  "O quotedblright,uppercase O */
{ 445,   21},    /*  "a quotedblright,lowercase a */
{ 445,   11},    /*  "c quotedblright,lowercase c */
{ 445,   13},    /*  "e quotedblright,lowercase e */
{1566,   88},    /*  ,' comma,quoteright */
{1566,   87},    /*  ,` comma,quoteleft */
{1565,   88},    /*  .' period,quoteright */
{1565,   87},    /*  .` period,quoteleft */
{1601, 1601},    /*  00 zero,zero */
{1601, 1592},    /*  01 zero,one */
{1601, 1593},    /*  02 zero,two */
{1601, 1594},    /*  03 zero,three */
{1601, 1595},    /*  04 zero,four */
{1601, 1596},    /*  05 zero,five */
{1601, 1597},    /*  06 zero,six */
{1601, 1598},    /*  07 zero,seven */
{1601, 1599},    /*  08 zero,eight */
{1601, 1600},    /*  09 zero,nine */
{1592, 1601},    /*  10 one,zero */
{1592, 1592},    /*  11 one,one */
{1593, 1601},    /*  20 two,zero */
{1593, 1592},    /*  21 two,one */
{1594, 1601},    /*  30 three,zero */
{1594, 1592},    /*  31 three,one */
{1595, 1601},    /*  40 four,zero */
{1595, 1592},    /*  41 four,one */
{1596, 1601},    /*  50 five,zero */
{1596, 1592},    /*  51 five,one */
{1597, 1601},    /*  60 six,zero */
{1597, 1592},    /*  61 six,one */
{1598, 1601},    /*  70 seven,zero */
{1598, 1592},    /*  71 seven,one */
{1599, 1601},    /*  80 eight,zero */
{1599, 1592},    /*  81 eight,one */
{1600, 1601},    /*  90 nine,zero */
{1600, 1592},    /*  91 nine,one */
{  47,   88},    /*  A' uppercase A,quoteright */
{  47, 1568},    /*  A; uppercase A,semicolon */
{  47,  445},    /*  A" uppercase A,quotedblright */
{  47, 1573},    /*  A- uppercase A,hyphen */
{  47,   37},    /*  AC uppercase A,uppercase C */
{  47,   34},    /*  AG uppercase A,uppercase G */
{  47,   28},    /*  AO uppercase A,uppercase O */
{  47,   51},    /*  AQ uppercase A,uppercase Q */
{  47,   27},    /*  AT uppercase A,uppercase T */
{  47,   50},    /*  AU uppercase A,uppercase U */
{  47,   38},    /*  AV uppercase A,uppercase V */
{  47,   48},    /*  AW uppercase A,uppercase W */
{  47,   46},    /*  AX uppercase A,uppercase X */
{  47,   44},    /*  AY uppercase A,uppercase Y */
{  47,   16},    /*  Ab uppercase A,lowercase b */
{  47,   11},    /*  Ac uppercase A,lowercase c */
{  47,   15},    /*  Ad uppercase A,lowercase d */
{  47,   13},    /*  Ae uppercase A,lowercase e */
{  47,   19},    /*  Af uppercase A,lowercase f */
{  47,    8},    /*  Ag uppercase A,lowercase g */
{  47,    2},    /*  Ao uppercase A,lowercase o */
{  47,   10},    /*  Ap uppercase A,lowercase p */
{  47,   25},    /*  Aq uppercase A,lowercase q */
{  47,   17},    /*  As uppercase A,lowercase s */
{  47,    1},    /*  At uppercase A,lowercase t */
{  47,   24},    /*  Au uppercase A,lowercase u */
{  47,   12},    /*  Av uppercase A,lowercase v */
{  47,   22},    /*  Aw uppercase A,lowercase w */
{  47,   18},    /*  Ay uppercase A,lowercase y */
{  42, 1565},    /*  B. uppercase B,period */
{  42,   47},    /*  BA uppercase B,uppercase A */
{  42,   35},    /*  BI uppercase B,uppercase I */
{  42,   33},    /*  BR uppercase B,uppercase R */
{  42,   27},    /*  BT uppercase B,uppercase T */
{  42,   50},    /*  BU uppercase B,uppercase U */
{  42,   38},    /*  BV uppercase B,uppercase V */
{  42,   48},    /*  BW uppercase B,uppercase W */
{  42,   44},    /*  BY uppercase B,uppercase Y */
{  42,   13},    /*  Be uppercase B,lowercase e */
{  42,    9},    /*  Bi uppercase B,lowercase i */
{  42,   26},    /*  Bk uppercase B,lowercase k */
{  42,    6},    /*  Bl uppercase B,lowercase l */
{  42,    7},    /*  Br uppercase B,lowercase r */
{  42,   24},    /*  Bu uppercase B,lowercase u */
{  42,   18},    /*  By uppercase B,lowercase y */
{  37,   47},    /*  CA uppercase C,uppercase A */
{  37,   34},    /*  CG uppercase C,uppercase G */
{  37,   35},    /*  CI uppercase C,uppercase I */
{  37,   28},    /*  CO uppercase C,uppercase O */
{  37,   43},    /*  CS uppercase C,uppercase S */
{  37,   27},    /*  CT uppercase C,uppercase T */
{  37,   50},    /*  CU uppercase C,uppercase U */
{  37,   38},    /*  CV uppercase C,uppercase V */
{  37,   44},    /*  CY uppercase C,uppercase Y */
{  37,   21},    /*  Ca uppercase C,lowercase a */
{  37,   13},    /*  Ce uppercase C,lowercase e */
{  37,    3},    /*  Ch uppercase C,lowercase h */
{  37,    9},    /*  Ci uppercase C,lowercase i */
{  37,    6},    /*  Cl uppercase C,lowercase l */
{  37,    2},    /*  Co uppercase C,lowercase o */
{  37,    7},    /*  Cr uppercase C,lowercase r */
{  37,   24},    /*  Cu uppercase C,lowercase u */
{  37,   18},    /*  Cy uppercase C,lowercase y */
{  41,   47},    /*  DA uppercase D,uppercase A */
{  41,   35},    /*  DI uppercase D,uppercase I */
{  41,   43},    /*  DS uppercase D,uppercase S */
{  41,   27},    /*  DT uppercase D,uppercase T */
{  41,   38},    /*  DV uppercase D,uppercase V */
{  41,   44},    /*  DY uppercase D,uppercase Y */
{  41,   13},    /*  De uppercase D,lowercase e */
{  41,    9},    /*  Di uppercase D,lowercase i */
{  41,    2},    /*  Do uppercase D,lowercase o */
{  41,   24},    /*  Du uppercase D,lowercase u */
{  41,   18},    /*  Dy uppercase D,lowercase y */
{  39, 1566},    /*  E, uppercase E,comma */
{  39, 1565},    /*  E. uppercase E,period */
{  39,   28},    /*  EO uppercase E,uppercase O */
{  39,   38},    /*  EV uppercase E,uppercase V */
{  39,   51},    /*  EQ uppercase E,uppercase Q */
{  38,   16},    /*  Eb uppercase E,lowercase b */
{  39,   11},    /*  Ec uppercase E,lowercase c */
{  39,   15},    /*  Ed uppercase E,lowercase d */
{  39,   19},    /*  Ef uppercase E,lowercase f */
{  39,    8},    /*  Eg uppercase E,lowercase g */
{  39,    9},    /*  Ei uppercase E,lowercase i */
{  39,   23},    /*  Ej uppercase E,lowercase j */
{  39,    6},    /*  El uppercase E,lowercase l */
{  39,    5},    /*  Em uppercase E,lowercase m */
{  39,    4},    /*  En uppercase E,lowercase n */
{  39,   10},    /*  Ep uppercase E,lowercase p */
{  39,   25},    /*  Eq uppercase E,lowercase q */
{  39,    7},    /*  Er uppercase E,lowercase r */
{  39,   17},    /*  Es uppercase E,lowercase s */
{  39,    1},    /*  Et uppercase E,lowercase t */
{  39,   24},    /*  Eu uppercase E,lowercase u */
{  39,   12},    /*  Ev uppercase E,lowercase v */
{  39,   18},    /*  Ey uppercase E,lowercase y */
{  45, 1566},    /*  F, uppercase F,comma */
{  45, 1573},    /*  F- uppercase F,hyphen */
{  45, 1565},    /*  F. uppercase F,period */
{  45,   47},    /*  FA uppercase F,uppercase A  */
{  45,   34},    /*  FG uppercase F,uppercase G */
{  45,   28},    /*  FO uppercase F,uppercase O */
{  45,   43},    /*  FS uppercase F,uppercase S */
{  45,   21},    /*  Fa uppercase F,lowercase a */
{  45,   13},    /*  Fe uppercase F,lowercase e */
{  45,    9},    /*  Fi uppercase F,lowercase i */
{  45,    6},    /*  Fl uppercase F,lowercase l */
{  45,    2},    /*  Fo uppercase F,lowercase o */
{  45,    7},    /*  Fr uppercase F,lowercase r */
{  45,   24},    /*  Fu uppercase F,lowercase u */
{  34,   47},    /*  GA uppercase G,uppercase A */
{  34,   35},    /*  GI uppercase G,uppercase I */
{  34,   27},    /*  GT uppercase G,uppercase T */
{  34,   38},    /*  GV uppercase G,uppercase V */
{  34,   46},    /*  GY uppercase G,uppercase Y */
{  34,   21},    /*  Ga uppercase G,lowercase a */
{  34,    9},    /*  Gi uppercase G,lowercase i */
{  34,    6},    /*  Gl uppercase G,lowercase l */
{  34,    4},    /*  Gn uppercase G,lowercase n */
{  34,    2},    /*  Go uppercase G,lowercase o */
{  34,    7},    /*  Gr uppercase G,lowercase r */
{  34,   24},    /*  Gu uppercase G,lowercase u */
{  34,   18},    /*  Gy uppercase G,lowercase y */
{  29,   28},    /*  HO uppercase H,uppercase O */
{  29,   43},    /*  HS uppercase H,uppercase S */
{  29,   50},    /*  HU uppercase H,uppercase U */
{  29,   21},    /*  Ha uppercase H,lowercase a */
{  29,   13},    /*  He uppercase H,lowercase e */
{  29,    9},    /*  Hi uppercase H,lowercase i */
{  29,    2},    /*  Ho uppercase H,lowercase o */
{  29,    7},    /*  Hr uppercase H,lowercase r */
{  29,   24},    /*  Hu uppercase H,lowercase u */
{  29,   18},    /*  Hy uppercase H,lowercase y */
{  35,   37},    /*  IC uppercase I,uppercase C */
{  35,   34},    /*  IG uppercase I,uppercase G */
{  35,   28},    /*  IO uppercase I,uppercase O */
{  35,   51},    /*  IQ uppercase I,uppercase Q */
{  35,   43},    /*  IS uppercase I,uppercase S */
{  35,   11},    /*  Ic uppercase I,lowercase c */
{  35,   15},    /*  Id uppercase I,lowercase d */
{  35,   13},    /*  Ie uppercase I,lowercase e */
{  35,   19},    /*  If uppercase I,lowercase f */
{  35,    8},    /*  Ig uppercase I,lowercase g */
{  35,    3},    /*  Ih uppercase I,lowercase h */
{  35,   23},    /*  Ij uppercase I,lowercase j */
{  35,    6},    /*  Il uppercase I,lowercase l */
{  35,    5},    /*  Im uppercase I,lowercase m */
{  35,    4},    /*  In uppercase I,lowercase n */
{  35,    2},    /*  Io uppercase I,lowercase o */
{  35,   10},    /*  Ip uppercase I,lowercase p */
{  35,    7},    /*  Ir uppercase I,lowercase r */
{  35,   17},    /*  Is uppercase I,lowercase s */
{  35,    1},    /*  It uppercase I,lowercase t */
{  35,   24},    /*  Iu uppercase I,lowercase u */
{  35,   12},    /*  Iv uppercase I,lowercase v */
{  35,   22},    /*  Iw uppercase I,lowercase w */
{  35,   18},    /*  Iy uppercase I,lowercase y */
{  49,   47},    /*  JA uppercase J,uppercase A */
{  49,   28},    /*  JO uppercase J,uppercase O */
{  49,   21},    /*  Ja uppercase J,lowercase a */
{  49,   13},    /*  Je uppercase J,lowercase e */
{  49,    3},    /*  Jh uppercase J,lowercase h */
{  49,    9},    /*  Ji uppercase J,lowercase i */
{  49,    2},    /*  Jo uppercase J,lowercase o */
{  49,    7},    /*  Jr uppercase J,lowercase r */
{  49,   24},    /*  Ju uppercase J,lowercase u */
{  49,   18},    /*  Jy uppercase J,lowercase y */
{  52, 1573},    /*  K- uppercase K,hyphen */
{  52,   37},    /*  KC uppercase K,uppercase C */
{  52,   34},    /*  KG uppercase K,uppercase G */
{  52,   28},    /*  KO uppercase K,uppercase O */
{  52,   51},    /*  KQ uppercase K,uppercase Q */
{  52,   43},    /*  KS uppercase K,uppercase S */
{  52,   50},    /*  KU uppercase K,uppercase U */
{  52,   21},    /*  Ka uppercase K,lowercase a */
{  52,   13},    /*  Ke uppercase K,lowercase e */
{  52,    9},    /*  Ki uppercase K,lowercase i */
{  52,    4},    /*  Kn uppercase K,lowercase n */
{  52,    2},    /*  Ko uppercase K,lowercase o */
{  52,    7},    /*  Kr uppercase K,lowercase r */
{  52,   24},    /*  Ku uppercase K,lowercase u */
{  52,   12},    /*  Kv uppercase K,lowercase v */
{  52,   22},    /*  Kw uppercase K,lowercase w */
{  52,   18},    /*  Ky uppercase K,lowercase y */
{  32,   88},    /*  L' uppercase L,quoteright */
{  32, 1573},    /*  L- uppercase L,hyphen */
{  32,   37},    /*  LC uppercase L,uppercase C */
{  32,   34},    /*  LG uppercase L,uppercase G */
{  32,   28},    /*  LO uppercase L,uppercase O */
{  32,   43},    /*  LS uppercase L,uppercase S */
{  32,   27},    /*  LT uppercase L,uppercase T */
{  32,   50},    /*  LU uppercase L,uppercase U */
{  32,   38},    /*  LV uppercase L,uppercase V */
{  32,   48},    /*  LW uppercase L,uppercase W */
{  32,   44},    /*  LY uppercase L,uppercase Y */
{  32,   21},    /*  La uppercase L,lowercase a */
{  32,   13},    /*  Le uppercase L,lowercase e */
{  32,    9},    /*  Li uppercase L,lowercase i */
{  32,    6},    /*  Ll uppercase L,lowercase l */
{  32,    2},    /*  Lo uppercase L,lowercase o */
{  32,    7},    /*  Lr uppercase L,lowercase r */
{  32,   24},    /*  Lu uppercase L,lowercase u */
{  32,   18},    /*  Ly uppercase L,lowercase y */
{  31,   28},    /*  MO uppercase M,uppercase O */
{  31,   43},    /*  MS uppercase M,uppercase S */
{  31,   21},    /*  Ma uppercase M,lowercase a */
{  31,   11},    /*  Mc uppercase M,lowercase c */
{  31,   13},    /*  Me uppercase M,lowercase e */
{  31,    9},    /*  Mi uppercase M,lowercase i */
{  31,    2},    /*  Mo uppercase M,lowercase o */
{  31,    7},    /*  Mr uppercase M,lowercase r */
{  31,   24},    /*  Mu uppercase M,lowercase u */
{  31,   18},    /*  My uppercase M,lowercase y */
{  30,   47},    /*  NA uppercase N,uppercase A */
{  30,   28},    /*  NO uppercase N,uppercase O */
{  30,   21},    /*  Na uppercase N,lowercase a */
{  30,   13},    /*  Ne uppercase N,lowercase e */
{  30,    9},    /*  Ni uppercase N,lowercase i */
{  30,    2},    /*  No uppercase N,lowercase o */
{  30,   24},    /*  Nu uppercase N,lowercase u */
{  28, 1566},    /*  O, uppercase O,comma */
{  28, 1565},    /*  O. uppercase O,period */
{  28,   47},    /*  OA uppercase O,uppercase A */
{  28,   42},    /*  OB uppercase O,uppercase B */
{  28,   41},    /*  OD uppercase O,uppercase D */
{  28,   45},    /*  OF uppercase O,uppercase F */
{  28,   29},    /*  OH uppercase O,uppercase H */
{  38,   35},    /*  OI uppercase O,uppercase I */
{  38,   49},    /*  OJ uppercase O,uppercase J */
{  28,   52},    /*  OK uppercase O,uppercase K */
{  28,   32},    /*  OL uppercase O,uppercase L */
{  28,   31},    /*  OM uppercase O,uppercase M */
{  28,   30},    /*  ON uppercase O,uppercase N */
{  28,   36},    /*  OP uppercase O,uppercase P */
{  28,   33},    /*  OR uppercase O,uppercase R */
{  28,   27},    /*  OT uppercase O,uppercase T */
{  28,   50},    /*  OU uppercase O,uppercase U */
{  28,   38},    /*  OV uppercase O,uppercase V */
{  28,   48},    /*  OW uppercase O,uppercase W */
{  28,   46},    /*  OX uppercase O,uppercase X */
{  28,   44},    /*  OY uppercase O,uppercase Y */
{  28,   40},    /*  OZ uppercase O,uppercase Z */
{  28,   16},    /*  Ob uppercase O,lowercase b */
{  28,   11},    /*  Oc uppercase O,lowercase c */
{  28,   13},    /*  Oe uppercase O,lowercase e */
{  28,    3},    /*  Oh uppercase O,lowercase h */
{  28,   23},    /*  Oj uppercase O,lowercase j */
{  28,   26},    /*  Ok uppercase O,lowercase k */
{  28,    6},    /*  Ol uppercase O,lowercase l */
{  28,    5},    /*  Om uppercase O,lowercase m */
{  28,    4},    /*  On uppercase O,lowercase n */
{  28,   10},    /*  Op uppercase O,lowercase p */
{  28,   14},    /*  Oz uppercase O,lowercase z */
{  36, 1566},    /*  P, uppercase P,comma */
{  36, 1573},    /*  P- uppercase P,hyphen */
{  36, 1565},    /*  P. uppercase P,period */
{  36, 1567},    /*  P: uppercase P,colon */
{  36, 1568},    /*  P; uppercase P,semicolon */
{  36,   47},    /*  PA uppercase P,uppercase A */
{  36,   39},    /*  PE uppercase P,uppercase E */
{  36,   29},    /*  PH uppercase P,uppercase H */
{  36,   35},    /*  PI uppercase P,uppercase I  */
{  36,   49},    /*  PJ uppercase P,uppercase J */
{  36,   28},    /*  PO uppercase P,uppercase O */
{  36,   43},    /*  PS uppercase P,uppercase S */
{  36,   38},    /*  PV uppercase P,uppercase V */
{  36,   46},    /*  PX uppercase P,uppercase X */
{  36,   44},    /*  PY uppercase P,uppercase Y */
{  36,   21},    /*  Pa uppercase P,lowercase a */
{  36,   11},    /*  Pc uppercase P,lowercase c */
{  36,   13},    /*  Pe uppercase P,lowercase e  */
{  36,    3},    /*  Ph uppercase P,lowercase h */
{  36,    9},    /*  Pi uppercase P,lowercase i */
{  36,    6},    /*  Pl uppercase P,lowercase l */
{  36,    2},    /*  Po uppercase P,lowercase o */
{  36,    7},    /*  Pr uppercase P,lowercase r */
{  36,   24},    /*  Pu uppercase P,lowercase u */
{  51,   47},    /*  QA uppercase Q,uppercase A */
{  51,   50},    /*  QU uppercase Q,uppercase U */
{  51,   38},    /*  QV uppercase Q,uppercase V */
{  51,   48},    /*  QW uppercase Q,uppercase W */
{  51,   44},    /*  QY uppercase Q,uppercase Y */
{  51,    3},    /*  Qh uppercase Q,lowercase h */
{  51,   24},    /*  Qu uppercase Q,lowercase u */
{  33, 1573},    /*  R- uppercase R,hyphen */
{  33,   37},    /*  RC uppercase R,uppercase C */
{  33,   28},    /*  RO uppercase R,uppercase O */
{  33,   43},    /*  RS uppercase R,uppercase S */
{  33,   27},    /*  RT uppercase R,uppercase T */
{  33,   50},    /*  RU uppercase R,uppercase U */
{  33,   38},    /*  RV uppercase R,uppercase V */
{  33,   48},    /*  RW uppercase R,uppercase W */
{  33,   44},    /*  RY uppercase R,uppercase Y */
{  33,   21},    /*  Ra uppercase R,lowercase a */
{  33,   13},    /*  Re uppercase R,lowercase e */
{  33,    3},    /*  Rh uppercase R,lowercase h */
{  33,    9},    /*  Ri uppercase R,lowercase i */
{  33,    2},    /*  Ro uppercase R,lowercase o */
{  33,   24},    /*  Ru uppercase R,lowercase u */
{  33,   12},    /*  Rv uppercase R,lowercase v */
{  33,   18},    /*  Ry uppercase R,lowercase y */
{  43,   47},    /*  SA uppercase S,uppercase A */
{  43,   37},    /*  SC uppercase S,uppercase C */
{  43,   35},    /*  SI uppercase S,uppercase I */
{  43,   32},    /*  SL uppercase S,uppercase L */
{  43,   36},    /*  SP uppercase S,uppercase P */
{  43,   46},    /*  SX uppercase S,uppercase X */
{  43,   44},    /*  SY uppercase S,uppercase Y */
{  43,   21},    /*  Sa uppercase S,lowercase a */
{  43,   11},    /*  Sc uppercase S,lowercase c */
{  43,   13},    /*  Se uppercase S,lowercase e */
{  43,    8},    /*  Sg uppercase S,lowercase g */
{  43,    3},    /*  Sh uppercase S,lowercase h */
{  43,    9},    /*  Si uppercase S,lowercase i */
{  43,   23},    /*  Sj uppercase S,lowercase j */
{  43,   26},    /*  Sk uppercase S,lowercase k */
{  43,    6},    /*  Sl uppercase S,lowercase l */
{  43,    5},    /*  Sm uppercase S,lowercase m */
{  43,   25},    /*  Sq uppercase S,lowercase q */
{  43,    7},    /*  Sr uppercase S,lowercase r */
{  43,    1},    /*  St uppercase S,lowercase t */
{  43,   24},    /*  Su uppercase S,lowercase u */
{  43,   22},    /*  Sw uppercase S,lowercase w */
{  43,   18},    /*  Sy uppercase S,lowercase y */
{  27, 1566},    /*  T, uppercase T,comma */
{  27, 1573},    /*  T- uppercase T,hyphen */
{  27, 1565},    /*  T. uppercase T,period */
{  27, 1567},    /*  T: uppercase T,colon */
{  27, 1568},    /*  T; uppercase T,semicolon */
{  27,   47},    /*  TA uppercase T,uppercase A */
{  27,   37},    /*  TC uppercase T,uppercase C */
{  27,   34},    /*  TG uppercase T,uppercase G */
{  27,   28},    /*  TO uppercase T,uppercase O */
{  27,   43},    /*  TS uppercase T,uppercase S */
{  27,   21},    /*  Ta uppercase T,lowercase a */
{  27,   11},    /*  Tc uppercase T,lowercase c */
{  27,   13},    /*  Te uppercase T,lowercase e */
{  27,    3},    /*  Th uppercase T,lowercase h */
{  27,    9},    /*  Ti uppercase T,lowercase i */
{  27,    2},    /*  To uppercase T,lowercase o */
{  27,    7},    /*  Tr uppercase T,lowercase r */
{  27,   17},    /*  Ts uppercase T,lowercase s */
{  27,   24},    /*  Tu uppercase T,lowercase u */
{  27,   22},    /*  Tw uppercase T,lowercase w */
{  27,   18},    /*  Ty uppercase T,lowercase y */
{  50,   47},    /*  UA uppercase U,uppercase A */
{  50,   43},    /*  US uppercase U,uppercase S */
{  50,   21},    /*  Ua uppercase U,lowercase a */
{  50,   19},    /*  Uf uppercase U,lowercase f */
{  50,   26},    /*  Uk uppercase U,lowercase k */
{  50,    6},    /*  Ul uppercase U,lowercase l */
{  50,    5},    /*  Um uppercase U,lowercase m */
{  50,    4},    /*  Un uppercase U,lowercase n */
{  50,   17},    /*  Us uppercase U,lowercase s */
{  50,    1},    /*  Ut uppercase U,lowercase t */
{  38, 1566},    /*  V, uppercase V,comma */
{  38, 1573},    /*  V- uppercase V,hyphen */
{  38, 1565},    /*  V. uppercase V,period */
{  38, 1567},    /*  V: uppercase V,colon */
{  38, 1568},    /*  V; uppercase V,semicolon */
{  38,   47},    /*  VA uppercase V,uppercase A  */
{  38,   34},    /*  VG uppercase V,uppercase G */
{  38,   28},    /*  VO uppercase V,uppercase O */
{  38,   43},    /*  VS uppercase V,uppercase S */
{  38,   21},    /*  Va uppercase V,lowercase a */
{  38,   13},    /*  Ve uppercase V,lowercase e */
{  38,    9},    /*  Vi uppercase V,lowercase i */
{  38,    2},    /*  Vo uppercase V,lowercase o */
{  38,    7},    /*  Vr uppercase V,lowercase r */
{  38,   24},    /*  Vu uppercase V,lowercase u */
{  38,   22},    /*  Vw uppercase V,lowercase w */
{  38,   18},    /*  Vy uppercase V,lowercase y */
{  48, 1566},    /*  W, uppercase W,comma */
{  48, 1573},    /*  W- uppercase W,hyphen */
{  48, 1565},    /*  W. uppercase W,period */
{  48, 1567},    /*  W: uppercase W,colon */
{  48, 1568},    /*  W; uppercase W,semicolon */
{  48,   47},    /*  WA uppercase W,uppercase A */
{  48,   37},    /*  WC uppercase W,uppercase C */
{  48,   34},    /*  WG uppercase W,uppercase G */
{  48,   28},    /*  WO uppercase W,uppercase O */
{  48,   21},    /*  Wa uppercase W,lowercase a */
{  48,   13},    /*  We uppercase W,lowercase e */
{  48,    3},    /*  Wh uppercase W,lowercase h */
{  48,    9},    /*  Wi uppercase W,lowercase i */
{  48,    6},    /*  Wl uppercase W,lowercase l */
{  48,    2},    /*  Wo uppercase W,lowercase o */
{  48,    7},    /*  Wr uppercase W,lowercase r */
{  48,   43},    /*  Ws uppercase W,lowercase s */
{  48,   24},    /*  Wu uppercase W,lowercase u */
{  48,   18},    /*  Wy uppercase w,lowercase y */
{  46,   37},    /*  XC uppercase X,uppercase C */
{  46,   28},    /*  XO uppercase X,uppercase O */
{  46,   43},    /*  XS uppercase X,uppercase S */
{  46,   21},    /*  Xa uppercase X,lowercase a */
{  46,   13},    /*  Xe uppercase X,lowercase e */
{  46,   18},    /*  Xy uppercase X,lowercase y */
{  44, 1566},    /*  Y, uppercase Y,comma */
{  44, 1573},    /*  Y- uppercase Y,hyphen */
{  44, 1565},    /*  Y. uppercase Y,period */
{  44, 1567},    /*  Y: uppercase Y,colon */
{  44, 1568},    /*  Y; uppercase Y,semicolon */
{  44,   47},    /*  YA uppercase Y,uppercase A */
{  44,   28},    /*  YO uppercase Y,uppercase O  */
{  44,   21},    /*  Ya uppercase Y,lowercase a */
{  44,   13},    /*  Ye uppercase Y,lowercase e */
{  44,    9},    /*  Yi uppercase Y,lowercase i */
{  44,    2},    /*  Yo uppercase Y,lowercase o */
{  44,   10},    /*  Yp uppercase Y,lowercase p */
{  44,   25},    /*  Yq uppercase Y,lowercase q */
{  44,   24},    /*  Yu uppercase Y,lowercase u */
{  44,   12},    /*  Yv uppercase Y,lowercase v */
{  40,   21},    /*  Za uppercase Z,lowercase a  */
{  40,   13},    /*  Ze uppercase Z,lowercase e */
{  40,    9},    /*  Zi uppercase Z,lowercase i */
{  40,    2},    /*  Zo uppercase Z,lowercase o */
{  40,   24},    /*  Zu uppercase Z,lowercase u */
{  40,   18},    /*  Zy uppercase Z,lowercase y */
{  87,   87},    /*  `` quoteleft,quoteleft */
{  21,   21},    /*  aa lowercase a,lowercase a */
{  21,   16},    /*  ab lowercase a,lowercase b */
{  21,   11},    /*  ac lowercase a,lowercase c */
{  21,   15},    /*  ad lowercase a,lowercase d */
{  21,   13},    /*  ae lowercase a,lowercase e */
{  21,    8},    /*  ag lowercase a,lowercase g */
{  21,    3},    /*  ah lowercase a,lowercase h */
{  21,    9},    /*  ai lowercase a,lowercase i */
{  21,   26},    /*  ak lowercase a,lowercase k */
{  21,    2},    /*  ao lowercase a,lowercase o */
{  21,   10},    /*  ap lowercase a,lowercase p */
{  21,    7},    /*  ar lowercase a,lowercase r */
{  21,    1},    /*  at lowercase a,lowercase t */
{  21,   24},    /*  au lowercase a,lowercase u */
{  21,   12},    /*  av lowercase a,lowercase v */
{  21,   22},    /*  aw lowercase a,lowercase w */
{  21,   18},    /*  ay lowercase a,lowercase y */
{  16, 1566},    /*  b, lowercase b,comma */
{  16, 1565},    /*  b. lowercase b,period */
{  16,   21},    /*  ba lowercase b,lowercase a */
{  16,   13},    /*  be lowercase b,lowercase e */
{  16,    3},    /*  bh lowercase b,lowercase h */
{  16,    9},    /*  bi lowercase b,lowercase i */
{  16,   26},    /*  bk lowercase b,lowercase k */
{  16,    6},    /*  bl lowercase b,lowercase l */
{  16,    4},    /*  bn lowercase b,lowercase n */
{  16,   10},    /*  bp lowercase b,lowercase p */
{  16,    7},    /*  br lowercase b,lowercase r */
{  16,   24},    /*  bu lowercase b,lowercase u */
{  16,   22},    /*  bw lowercase b,lowercase w */
{  16,   18},    /*  by lowercase b,lowercase y */
{  11, 1566},    /*  c, lowercase c,comma */
{  11, 1565},    /*  c. lowercase c,period */
{  11,   21},    /*  ca lowercase c,lowercase a */
{  11,   11},    /*  cc lowercase c,lowercase c */
{  11,   15},    /*  cd lowercase c,lowercase d */
{  11,   13},    /*  ce lowercase c,lowercase e */
{  11,    3},    /*  ch lowercase c,lowercase h */
{  11,    9},    /*  ci lowercase c,lowercase i */
{  11,   26},    /*  ck lowercase c,lowercase k */
{  11,    6},    /*  cl lowercase c,lowercase l */
{  11,    5},    /*  cm lowercase c,lowercase m */
{  11,    2},    /*  co lowercase c,lowercase o */
{  11,   10},    /*  cp lowercase c,lowercase p */
{  11,    7},    /*  cr lowercase c,lowercase r */
{  11,   24},    /*  cu lowercase c,lowercase u */
{  11,   18},    /*  cy lowercase c,lowercase y */
{  15, 1566},    /*  d, lowercase d,comma */
{  15, 1565},    /*  d. lowercase d,period */
{  15,   21},    /*  da lowercase d,lowercase a */
{  15,   11},    /*  dc lowercase d,lowercase c */
{  15,   15},    /*  dd lowercase d,lowercase d */
{  15,   13},    /*  de lowercase d,lowercase e */
{  15,    8},    /*  dg lowercase d,lowercase g */
{  15,    5},    /*  dm lowercase d,lowercase m */
{  15,    2},    /*  do lowercase d,lowercase o */
{  15,    7},    /*  dr lowercase d,lowercase r */
{  15,    1},    /*  dt lowercase d,lowercase t */
{  15,   24},    /*  du lowercase d,lowercase u */
{  15,   22},    /*  dw lowercase d,lowercase w */
{  15,   18},    /*  dy lowercase d,lowercase y */
{  13, 1566},    /*  e, lowercase e,comma */
{  13, 1565},    /*  e. lowercase e,period */
{  13,    3},    /*  eh lowercase e,lowercase h */
{  13,    9},    /*  ei lowercase e,lowercase i */
{  13,   26},    /*  ek lowercase e,lowercase k */
{  13,    6},    /*  el lowercase e,lowercase l */
{  13,    5},    /*  em lowercase e,lowercase m */
{  13,   10},    /*  ep lowercase e,lowercase p */
{  13,    7},    /*  er lowercase e,lowercase r */
{  13,    1},    /*  et lowercase e,lowercase t */
{  13,   24},    /*  eu lowercase e,lowercase u */
{  13,   12},    /*  ev lowercase e,lowercase v */
{  13,   22},    /*  ew lowercase e,lowercase w */
{  13,   20},    /*  ex lowercase e,lowercase x */
{  13,   18},    /*  ey lowercase e,lowercase y */
{  19,   88},    /*  f' lowercase f,quoteright */
{  19,   21},    /*  fa lowercase f,lowercase a */
{  19,   11},    /*  fc lowercase f,lowercase c */
{  19,   15},    /*  fd lowercase f,lowercase d */
{  19,   19},    /*  ff lowercase f,lowercase f */
{  19,    8},    /*  fg lowercase f,lowercase g */
{  19,    9},    /*  fi lowercase f,lowercase i */
{  19,    6},    /*  fl lowercase f,lowercase l */
{  19,    5},    /*  fm lowercase f,lowercase m */
{  19,    2},    /*  fo lowercase f,lowercase o */
{  19,   10},    /*  fp lowercase f,lowercase p */
{  19,   17},    /*  fs lowercase f,lowercase s */
{  19,   24},    /*  fu lowercase f,lowercase u */
{   8,   11},    /*  gc lowercase g,lowercase c */
{   8,   15},    /*  gd lowercase g,lowercase d */
{   8,   13},    /*  ge lowercase g,lowercase e */
{   8,    3},    /*  gh lowercase g,lowercase h */
{   8,    9},    /*  gi lowercase g,lowercase i */
{   8,   26},    /*  gk lowercase g,lowercase k */
{   8,    6},    /*  gl lowercase g,lowercase l */
{   8,    2},    /*  go lowercase g,lowercase o */
{   8,   10},    /*  gp lowercase g,lowercase p */
{   8,   17},    /*  gs lowercase g,lowercase s */
{   8,   24},    /*  gu lowercase g,lowercase u */
{   8,   18},    /*  gy lowercase g,lowercase y */
{   3,   13},    /*  he lowercase h,lowercase e */
{   3,    5},    /*  hm lowercase h,lowercase m */
{   3,    2},    /*  ho lowercase h,lowercase o */
{   3,   17},    /*  hs lowercase h,lowercase s */
{   3,    1},    /*  ht lowercase h,lowercase t */
{   3,   24},    /*  hu lowercase h,lowercase u */
{   3,   18},    /*  hy lowercase h,lowercase y */
{   9,   21},    /*  ia lowercase i,lowercase a */
{   9,   11},    /*  ic lowercase i,lowercase c */
{   9,   15},    /*  id lowercase i,lowercase d */
{   9,   13},    /*  ie lowercase i,lowercase e */
{   9,   19},    /*  if lowercase i,lowercase f */
{   9,    8},    /*  ig lowercase i,lowercase g */
{   9,   23},    /*  ij lowercase i,lowercase j */
{   9,    5},    /*  im lowercase i,lowercase m */
{   9,    2},    /*  io lowercase i,lowercase o */
{   9,   10},    /*  ip lowercase i,lowercase p */
{   9,   17},    /*  is lowercase i,lowercase s */
{   9,    1},    /*  it lowercase i,lowercase t */
{  23,   21},    /*  ja lowercase j,lowercase a */
{  23,   15},    /*  jd lowercase j,lowercase d */
{  23,   13},    /*  je lowercase j,lowercase e */
{  23,    8},    /*  jg lowercase j,lowercase g */
{  23,    3},    /*  jh lowercase j,lowercase h */
{  23,    9},    /*  ji lowercase j,lowercase i */
{  23,   26},    /*  jk lowercase j,lowercase k */
{  23,    2},    /*  jo lowercase j,lowercase o */
{  23,   10},    /*  jp lowercase j,lowercase p */
{  23,   24},    /*  ju lowercase j,lowercase u */
{  26,   21},    /*  ka lowercase k,lowercase a */
{  26,   11},    /*  kc lowercase k,lowercase c */
{  26,   15},    /*  kd lowercase k,lowercase d */
{  26,   13},    /*  ke lowercase k,lowercase e */
{  26,    8},    /*  kg lowercase k,lowercase g */
{  26,    2},    /*  ko lowercase k,lowercase o */
{  26,   10},    /*  kp lowercase k,lowercase p */
{  26,   17},    /*  ks lowercase k,lowercase s */
{  26,   24},    /*  ku lowercase k,lowercase u */
{   6,   21},    /*  la lowercase l,lowercase a */
{   6,   11},    /*  lc lowercase l,lowercase c */
{   6,   15},    /*  ld lowercase l,lowercase d */
{   6,   13},    /*  le lowercase l,lowercase e */
{   6,   19},    /*  lf lowercase l,lowercase f */
{   6,    8},    /*  lg lowercase l,lowercase g */
{   6,    2},    /*  lo lowercase l,lowercase o */
{   6,   10},    /*  lp lowercase l,lowercase p */
{   6,   17},    /*  ls lowercase l,lowercase s */
{   6,    1},    /*  lt lowercase l,lowercase t */
{   6,   24},    /*  lu lowercase l,lowercase u */
{   6,   12},    /*  lv lowercase l,lowercase v */
{   6,   22},    /*  lw lowercase l,lowercase w */
{   6,   18},    /*  ly lowercase l,lowercase y */
{   5,   21},    /*  ma lowercase m,lowercase a */
{   5,   11},    /*  mc lowercase m,lowercase c */
{   5,   15},    /*  md lowercase m,lowercase d */
{   5,   13},    /*  me lowercase m,lowercase e */
{   5,    8},    /*  mg lowercase m,lowercase g */
{   5,    2},    /*  mo lowercase m,lowercase o */
{   5,   10},    /*  mp lowercase m,lowercase p */
{   5,   17},    /*  ms lowercase m,lowercase s */
{   5,   24},    /*  mu lowercase m,lowercase u */
{   5,   22},    /*  mw lowercase m,lowercase w */
{   5,   18},    /*  my lowercase m,lowercase y */
{   4,   21},    /*  na lowercase n,lowercase a */
{   4,   16},    /*  nb lowercase n,lowercase b */
{   4,   11},    /*  nc lowercase n,lowercase c */
{   4,   15},    /*  nd lowercase n,lowercase d */
{   4,   13},    /*  ne lowercase n,lowercase e */
{   4,    8},    /*  ng lowercase n,lowercase g */
{   4,    2},    /*  no lowercase n,lowercase o */
{   4,   10},    /*  np lowercase n,lowercase p */
{   4,   17},    /*  ns lowercase n,lowercase s */
{   4,    1},    /*  nt lowercase n,lowercase t */
{   4,   24},    /*  nu lowercase n,lowercase u */
{   4,   22},    /*  nw lowercase n,lowercase w */
{   4,   18},    /*  ny lowercase n,lowercase y */
{   2,   16},    /*  ob lowercase o,lowercase b */
{   2,   19},    /*  of lowercase o,lowercase f */
{   2,    3},    /*  oh lowercase o,lowercase h */
{   2,    9},    /*  oi lowercase o,lowercase i */
{   2,   26},    /*  ok lowercase o,lowercase k */
{   2,    6},    /*  ol lowercase o,lowercase l */
{   2,    5},    /*  om lowercase o,lowercase m */
{   2,    4},    /*  on lowercase o,lowercase n */
{   2,   10},    /*  op lowercase o,lowercase p */
{   2,    7},    /*  or lowercase o,lowercase r */
{   2,    1},    /*  ot lowercase o,lowercase t */
{   2,   24},    /*  ou lowercase o,lowercase u */
{   2,   12},    /*  ov lowercase o,lowercase v */
{   2,   22},    /*  ow lowercase o,lowercase w */
{   2,   20},    /*  ox lowercase o,lowercase x */
{   2,   18},    /*  oy lowercase o,lowercase y */
{  10,   19},    /*  pf lowercase p,lowercase f */
{  10,    3},    /*  ph lowercase p,lowercase h */
{  10,    9},    /*  pi lowercase p,lowercase i */
{  10,   26},    /*  pk lowercase p,lowercase k */
{  10,    6},    /*  pl lowercase p,lowercase l */
{  10,   10},    /*  pp lowercase p,lowercase p */
{  10,    7},    /*  pr lowercase p,lowercase r */
{  10,   24},    /*  pu lowercase p,lowercase u */
{  10,   22},    /*  pw lowercase p,lowercase w */
{  10,   18},    /*  py lowercase p,lowercase y */
{  25,   24},    /*  qu lowercase q,lowercase u */
{   7,   88},    /*  r' lowercase r,quoteright */
{   7, 1566},    /*  r, lowercase r,comma */
{   7, 1573},    /*  r- lowercase r,hyphen */
{   7, 1565},    /*  r. lowercase r,period */
{   7,   21},    /*  ra lowercase r,lowercase a */
{   7,   16},    /*  rb lowercase r,lowercase b */
{   7,   11},    /*  rc lowercase r,lowercase c */
{   7,   15},    /*  rd lowercase r,lowercase d */
{   7,   13},    /*  re lowercase r,lowercase e */
{   7,   19},    /*  rf lowercase r,lowercase f */
{   7,    8},    /*  rg lowercase r,lowercase g */
{   7,    3},    /*  rh lowercase r,lowercase h */
{   7,   26},    /*  rk lowercase r,lowercase k */
{   7,    6},    /*  rl lowercase r,lowercase l */
{   7,    5},    /*  rm lowercase r,lowercase m */
{   7,    2},    /*  ro lowercase r,lowercase o */
{   7,   25},    /*  rq lowercase r,lowercase q */
{   7,   17},    /*  rs lowercase r,lowercase s */
{   7,   24},    /*  ru lowercase r,lowercase u */
{   7,   18},    /*  ry lowercase r,lowercase y */
{  17, 1566},    /*  s, lowercase s,comma */
{  17, 1565},    /*  s. lowercase s,period */
{  17,   21},    /*  sa lowercase s,lowercase a */
{  17,   16},    /*  sb lowercase s,lowercase b */
{  17,    3},    /*  sh lowercase s,lowercase h */
{  17,    9},    /*  si lowercase s,lowercase i */
{  17,   26},    /*  sk lowercase s,lowercase k */
{  17,    6},    /*  sl lowercase s,lowercase l */
{  17,    5},    /*  sm lowercase s,lowercase m */
{  17,   10},    /*  sp lowercase s,lowercase p */
{  17,    7},    /*  sr lowercase s,lowercase r */
{  17,   18},    /*  sy lowercase s,lowercase y */
{   1,   21},    /*  ta lowercase t,lowercase a */
{   1,   11},    /*  tc lowercase t,lowercase c */
{   1,   15},    /*  td lowercase t,lowercase d */
{   1,    8},    /*  tg lowercase t,lowercase g */
{   1,    3},    /*  th lowercase t,lowercase h */
{   1,    9},    /*  ti lowercase t,lowercase i */
{   1,   26},    /*  tk lowercase t,lowercase k */
{   1,    6},    /*  tl lowercase t,lowercase l */
{   1,    5},    /*  tm lowercase t,lowercase m */
{   1,    2},    /*  to lowercase t,lowercase o */
{   1,   17},    /*  ts lowercase t,lowercase s */
{  24,   21},    /*  ua lowercase u,lowercase a */
{  24,   16},    /*  ub lowercase u,lowercase b */
{  24,   11},    /*  uc lowercase u,lowercase c */
{  24,   15},    /*  ud lowercase u,lowercase d */
{  24,    9},    /*  ui lowercase u,lowercase i */
{  24,    4},    /*  un lowercase u,lowercase n */
{  24,    2},    /*  uo lowercase u,lowercase o */
{  24,   10},    /*  up lowercase u,lowercase p */
{  24,   17},    /*  us lowercase u,lowercase s */
{  12, 1566},    /*  v, lowercase v,comma */
{  12, 1573},    /*  v- lowercase v,hyphen */
{  12, 1565},    /*  v. lowercase v,period */
{  12,   21},    /*  va lowercase v,lowercase a */
{  12,   11},    /*  vc lowercase v,lowercase c */
{  12,   15},    /*  vd lowercase v,lowercase d */
{  12,   13},    /*  ve lowercase v,lowercase e */
{  12,    8},    /*  vg lowercase v,lowercase g */
{  12,    9},    /*  vi lowercase v,lowercase i */
{  12,    2},    /*  vo lowercase v,lowercase o */
{  12,   17},    /*  vs lowercase v,lowercase s */
{  22, 1566},    /*  w, lowercase w,comma */
{  22, 1573},    /*  w- lowercase w,hyphen */
{  22, 1565},    /*  w. lowercase w,period */
{  22,   21},    /*  wa lowercase w,lowercase a */
{  22,   11},    /*  wc lowercase w,lowercase c */
{  22,   15},    /*  wd lowercase w,lowercase d */
{  22,   13},    /*  we lowercase w,lowercase e */
{  22,    3},    /*  wh lowercase w,lowercase h */
{  22,    2},    /*  wo lowercase w,lowercase o */
{  22,   17},    /*  ws lowercase w,lowercase s */
{  20,   21},    /*  xa lowercase x,lowercase a */
{  20,   11},    /*  xc lowercase x,lowercase c */
{  20,   13},    /*  xe lowercase x,lowercase e */
{  20,    2},    /*  xo lowercase x,lowercase o */
{  18, 1566},    /*  y, lowercase y,comma */
{  18, 1565},    /*  y. lowercase y,period */
{  18,   21},    /*  ya lowercase y,lowercase a  */
{  18,   16},    /*  yb lowercase y,lowercase b */
{  18,   11},    /*  yc lowercase y,lowercase c */
{  18,   15},    /*  yd lowercase y,lowercase d */
{  18,   13},    /*  ye lowercase y,lowercase e */
{  18,    2},    /*  yo lowercase y,lowercase o */
{  18,   17},    /*  ys lowercase y,lowercase s */
{  14,   21},    /*  za lowercase z,lowercase a  */
{  14,   13},    /*  ze lowercase z,lowercase e */
{  14,    2},    /*  zo lowercase z,lowercase o */
};

/* nmKrnPrs is the total possible number of kern pairs in our master table */
#define nmKrnPrs_c (sizeof (cg_kern_tbl) / sizeof (cg_kern_tbl[0]))

GLOBAL KERN_PAIR kp_tbl[nmKrnPrs_c];	/* actual kern pair table for font */
GLOBAL SW16 nmKrnPrs = (sizeof (cg_kern_tbl) / sizeof (cg_kern_tbl[0]));

#else
#if (defined (__STDC__) && (__STDC__  > 0) && !defined(__i960)) || \
    (defined(__i960) && defined(ANSI_960))
int iPSKP = 0;
#endif /* __STDC__ */

#endif /* PST1 && IF_RDR */

