/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1idecod.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: t1idecod.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.45   18 Apr 1995 16:57:50   JOE
 * 
 * In psset_char() and psrom_set_char(), added support for the removal
 * of symbol set mapping.
 * 
 * Conditionally compiled PSdata[] and cm_cgidToIndex() based on
 * !NO_SYMSET_MAPPING.
 * 
 *    Rev 1.44   07 Apr 1995 10:27:26   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.43   02 Dec 1994 21:09:14   MIKE
 * 
 * KSC (YAN).
 * 
 *    Rev 1.42   22 Jun 1994 11:03:44   JOE
 * 
 * In psload_font() and psset_char(), when checking for type of ASIAN
 * encoding, added checks for UNICODE, BIG5, TCA and GB.
 * 
 *    Rev 1.41   22 Apr 1994 16:12:16   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.40   22 Apr 1994 14:45:44   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.39   22 Mar 1994 10:20:54   JOE
 * 
 * In PSROMload_font() and psset_char(), added Type 0 support.
 * 
 *    Rev 1.38   25 Feb 1994 09:47:02   JOE
 * 
 * AM29K changes for ROM support to fix compiler errors in PSROMfinddata(),
 * psrom_set_char() and PSROMload_font().
 * 
 *    Rev 1.37   09 Feb 1994 14:00:48   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.36   02 Feb 1994 10:12:04   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.35   08 Dec 1993 19:00:20   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.34   01 Dec 1993 09:31:42   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.33   19 Nov 1993 11:26:46   JOE
 * In psset_char(), expanded conditional compile statement used for setting
 * "if_state.char_buf = MEMptr(hchar_buf)" to include IF_PCLEOI.
 * 
 *    Rev 1.32   16 Nov 1993 14:33:02   JOE
 * In type1char(), added support for 'special' test font.
 * 
 *    Rev 1.31   27 Oct 1993 19:49:56   MIKE
 * 
 * if MULTICALLER, call PCLchId2ptr() with callerID argument.
 * 
 *    Rev 1.30   25 Oct 1993 10:50:48   JOE
 * In othersubr(), "fpush" the current point onto the stack because
 * "t1e_SETCURPT" attempts to pop it later.
 * In tye1char(), only simulate "closepath" if !record.
 * 
 *    Rev 1.29   15 Oct 1993 10:04:08   JOE
 * In type1char(), replaced disabled code associated with "t1e_SETCURPT"
 * (Fmoveto) with code to set the current point (curx,cury) to the 2
 * values popped off the stack to fix incorrect placement of accents on
 * several compound characters of "special" Type 1 fonts.
 * 
 *    Rev 1.28   14 Oct 1993 14:56:24   JOE
 * In type1char(), when processing a MOVETO, check if a closepath was
 * executed for the previous loop. If not, execute the closepath so that
 * the number of loops in the character will be updated properly.
 * 
 *    Rev 1.27   06 Oct 1993 09:43:20   JOE
 * 
 * In type1char(), cast call to GETECHAR() as UL32 because "<< 16" shift
 * was causing the hi-word to be lost.
 * 
 *    Rev 1.26   29 Sep 1993 12:04:30   JOE
 * 
 * In psload_font(), initialize "gpps->FontBBox[]".
 * 
 *    Rev 1.25   16 Aug 1993 16:11:58   JOE
 * In psrom_set_char(), conditionally compiled block of code pertaining
 * to "cur_ssnum != T1ENCODING" based on USE_UFST_MAPPING to resolve
 * compiler error.
 * 
 *    Rev 1.24   16 Aug 1993 10:58:20   JOE
 * In psrom_set_char(), processing encoding array mapping table as SW16's
 * instead of SB8's.
 * In psload_font(), conditionally compiling psunload_font() calls based
 * on USE_JUMP_TABLES.
 * 
 *    Rev 1.23   13 Aug 1993 17:54:14   JOE
 * 
 * In PSROMload_font(), added support for reading in offset to encoding
 * array table "hencodearray".
 * In same routine, no longer swapping in place.
 * In psrom_set_char(), added encoding array support.
 * 
 *    Rev 1.22   09 Aug 1993 10:29:30   JOE
 * 
 * In PSROM_load_font(), changed the way Blue values and StemSnap values
 * are processed from ROM. Only the number of values stored are read in, 
 * rather than the max number.
 * In same routine, was not loading bot_blues[] correctly from 
 * other_blues[].
 * 
 *    Rev 1.21   02 Aug 1993 16:17:12   JOE
 * In type1char(), was not checking for PS ROM input when processing
 * "t1_CALLSUBR" subr.
 * 
 *    Rev 1.20   02 Aug 1993 09:45:48   JOE
 * 
 * Added PS ROM support changes.
 * 
 *    Rev 1.19   26 Jul 1993 11:47:34   ROB
 * 
 * Add 'constant' variables 'FPZERO' & 'FPONEHALF' to 'psload_font()'.
 * 
 *    Rev 1.18   13 Jul 1993 13:05:38   JOE
 * Set "iT1IDECOD" = 0 if !PST1_RDR.
 * 
 *    Rev 1.17   01 Jul 1993 15:34:04   JOE
 * 
 * EUC KANJI support.
 * 
 *    Rev 1.16   01 Jul 1993 14:28:02   MAIB
 * fixed prototype
 * 
 *    Rev 1.15   15 Jun 1993 11:44:06   ROB
 * Move 'hexasciiflg' to type 1 bucket. Handle binary fonts w/o header.
 * 
 *    Rev 1.14   14 Jun 1993 17:13:02   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.13   09 Jun 1993 14:43:42   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.12   08 Jun 1993 18:06:14   ROB
 * Pipeline upgrade for type 1 quality improvements, mmaster support &
 * generic type 1 soft font downloader support.
 *
 *    Rev 1.11   30 Apr 1993 15:51:46   ROB
 * Change default BlueScale value from .0395 to .039625 per B&W 'psload_font()'.
 *
 *    Rev 1.10   29 Mar 1993 11:01:50   ROB
 * Kanji cleanup.
 * 
 *    Rev 1.9   25 Mar 1993 11:13:20   ROB
 * Improve quality on italic & oblique stems.
 *
 *    Rev 1.8   19 Mar 1993 11:40:02   JOE
 * **ROB** Changes for Kanji support.
 *
 *    Rev 1.7   03 Mar 1993 19:19:52   ROB
 * Utilize StemSnapH & StemSnapV hints for stem processing.
 * 
 *    Rev 1.6   01 Mar 1993 16:06:48   JOE
 * 
 * In psset_char(), make sure char_buf is pointing to the static buffer
 * and not to a previous reference to a character in ROM (like a plugin).
 * 
 *    Rev 1.5   15 Feb 1993 09:08:54   JOE
 * Changed all occurrences of READ to READF due to conflict with VXWorks.
 * 
 *    Rev 1.4   12 Feb 1993 15:45:56   JOE
 * VXWorks support.
 * 
 *    Rev 1.3   04 Feb 1993 14:04:08   JOE
 * In psget_width(), compensate for rounding when PS is converted to
 * 8782-based.
 *
 *    Rev 1.2   07 Jan 1993 08:44:08   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 10:01:10   LISA
 * Made change to Log keyword
 *
 *    Rev 1.0   10 Dec 1992 09:22:08   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* t1idecod.c */
/***********************************************************************
*                                                                      *
*
*
*            Copyright (c) 1989, 1990, 1991 by                         *
*            Pipeline Associates, Inc., Morris Plains, NJ              *
*                     All rights reserved.                             *
*                                                                      *
*   This software is furnished under a license and may be used and     *
*   copied  only  in accordance with the terms of such license and     *
*   with the  inclusion  of  the  above  copyright  notice.   This     *
*   software  or  any  other copies thereof may not be provided or     *
*   otherwise made available to any other person except as allowed     *
*   under   license.  No  title to and ownership of the software is    *
*   hereby transferred.                                                *
*                                                                      *
*   This software is proprietary to Pipeline Associates, Inc., and     *
*   is not to be disclosed without written permission from Pipeline    *
*   Associates, Inc.                                                   *
*                                                                      *
************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
pre-historic    Version 1.0 -- original
pre-historic    Version 1.1 -- minor cleanup
pre-historic    Version 1.3 -- got rid of split_bez
09/27/91  rs    Original file created from Pipeline Associates 't1decode.c'.
11/18/91  rs   Modify for binary or hex ascii font input.
12/02/91  rs   Error handling cleanup.
12/16/91  rs   Change argument stack from UWORD to LONG (for 32 bit div).
01/22/92  rs   Subdivide() now calls 'ras_lineto()' directly.
01/23/92  awr  Added translation to psrender()
01/28/92  rs   Add PBUCKET to psrender() calling args.
01/29/92  rs   Fix error return for compound chars in finddata(). Clean up
                  error return codes. Remove 'render()'.
02/06/92  rs   Optimization of font loading. Modify 'psset_char()' to call
                  'more_charstrings()' if character not loaded.
03/02/92  rs   Fix from Pipeline for HSBW bbox problem. There should be no
               MOVETO associated with the HSBW re:B&W book.
03/17/92  rs   Cleanup of 'invalid assigns'.
03/19/92  rs   Add PostScript PCLEO reader support 'PST1_PCLEOI'.
03/23/92  ss   Added conditional compile of "sys/..." includes.
04/03/92  rs   Portability cleanup (see port.h).
05/01/92  rs   Fix in 'psset_char()' - deref nil handle 'cptr->hname' causes
               problem on Sparc.
05/06/92  ss   Moved #endif to col 1 for SUN.
05/08/92  rs   PS PCLEO integration - #include "t1ipcleo.h".
               Add macro 'fpopx()' to clean up warnings.
05/21/92  jfd  In psrender(), when calling "ras_start_char()", pass
               a PVOID argument.
05/21/92  rs    Add character mapping support for various symbol sets.
05/27/92  rs   Modify 'finddata()' to always use standard encoding to find
               a PostScript compound character part.
06/02/92  jfd  Added function "estimate_ps_outline()" to estimate memory
               required to generate a PS outline.
               Added EXTERN olstats (used by outline functions).
               Wherever "gpcs->" stores a value, store the same value in
               "olstats.".
06/04/92  jfd  In psrender(), when calling "pras->ras_start_char(), pass
               "&olstats".
               Also in psrender(), check type of outline requested and call
               either ras_cubeto() (if cubic) or Subdivide() (if linear).
               Return error if quadratic is requested.
 6/5/92   ss   Changed decoding and unputflag from SW16 to int
               to match GLOBAL define (in t1iscan.c)
 6/8/92   jfd  Removed all references to "olstats".
               In psrender(), check return status from "ras_start_char()".
               In psmake_gaso_and_stats(), reset counters "ct_lineto",
               "ct_quadto" and "ct_cubeto".
06/11/92  rs/jd Update error codes.
06/21/92  awr  Changed calls to output functions
06/22/92  jfd  Changed last two arguments for "psrender()" from SL32 
               to INTR.
06/25/92  rs   Add support for 'true' 32 bit segments (INTR).
06/29/92  awr  Merged all versions of estimate_outline()
1 Jul 92  ss   Conditionally compile stdlib for !MIPS.  This may also be
               relevant for other UNIX SysV systems.
6 Jul 92  jfd  Added "psget_width()" function. (Disabled for now.)
8 Jul 92  jfd/rs Modified type1char() to support width only.
07/10/92  jfd  In psrender(), if quadratic outline is requested, return
               error because it is not supported by PS. 
               If linear is requested but not installed, return error.
               If cubic is requested but not installed, return error.
07/11/92  awr  Replaced bmras_cubeto() with AGFA version in raster.c
07/21/92  awr  Conditional compile changes.
30-Aug-92 rs   Optimize use of char_buf for gaso's.
04-Sep-92 jfd  Removed call to obsolete functifon "cm_ixToPSName()".
               In "psset_char()", loading "char_name" directly from
               PSdata[] array.
23-Sep-92 jfd  INTEL960 conditional compile changes.
15-Oct-92 mby  SYMmap() is called with 2 arguments in psset_char().
22-Nov-92 rs   Port to Macintosh - include files.
07-Jan-93 jfd  ANSI C function declaratioon changes.
04-Feb-93 jfd  In psget_width(), compensate for rounding when PS is 
               converted to 8782-based.
08-Feb-93 jfd  VXWorks support.
15-Feb-93 jfd  Changed READ to READF due to conflict with VXWorks.
01-Mar-93 ss/jfd/dbk
               In psset_char(), make sure char_buf is pointing to the static
               buffer and not to a previous reference to a character in ROM
               (like a plugin).
02-Mar-93 rs   Utilize 'StemSnapH' & 'StemSnapV' to process a stem hint.
15-Mar-93 rs   Modifications for type 0 fonts (JIS_ENCODING).
24-Mar-93 rs   Modify 'type1char()' to improve stem intelligence on fonts
               (courier oblique) with negative stem widths.
27-Mar-93 rs   Fix Kanji defines per cgconfig.h (KANJI_ENCODING).
30-Apr-93 rs   Change default value of 'BlueScale' from .0395 to .039625
               as spec'd in the B&W.
Version 1.9 -- structured for folding into PowerPage
Version 3.0 -- added new OtherSubrs for Multiple Master support
4/10/92 (PHW) -- added bbox check at end for chars with no data
4/14/92 (PHW) -- added sbw command for Windows 3.1
7/7/92  (SGK) -- added OtherSubrs 14-17 for MM fonts
7/11/92  (PHW) -- changed weights from float to long
7/13/92  (SGK) -- changed blend routines to work with > 2 design axes
9/9/92  (PHW) -- initialize mins and maxes
9/15/92  (PHW) -- added debugging output
1/4/93   (SGK) -- reset argsptr on entry (for Genoa)
14-May-93 rs   Integrate Pipeline upgrade.
04-Jun-93 jfd  In psset_char(), added support for using either Type 1
               encoding or symbol set.
06-Jun-93 rs   Add MultiMaster support.
09-Jun-93 jfd  Changed all references to "char" to "SB8" for transportability.
15-Jun-93 rs   Change refs to 'hexasciiflg' to 'gpps->hexascii'.
01-Jul-93 maib removed prototype from blend() non-lint declaration
30-Jun-93 jfd/gy
               EUC KANJI support.
13-Jul-93 jfd  Set "iT1IDECOD" = 0 if !PST1_RDR.
23-Jul-93 rs   Add constant variables FPZERO & FPONEHALF in psload_font().
02-Aug-93 jfd  Added PS ROM support changes.
02-Aug-93 jfd  In type1char(), was not checking for PS ROM input when
               processing "t1_CALLSUBR" subr.
04-Aug-93 jfd  In PSROM_load_font(), changed the way Blue values and
               StemSnap values are processed from ROM. Only the number
               of values stored are read in, rather than the max number.
06-Aug-93 jfd  In PSSROMload_font(), was not loading bot_blues[] correctly
               from other_blues[].
13-Aug-93 jfd  In PSROMload_font(), added support for reading in offset
               to encoding array table "hencodearray".
               In same routine, no longer swapping in place.
               In psrom_set_char(), added encoding array support.
16-Aug-93 jfd  In psrom_set_char(), processing encoding array mapping table
               as SW16's instead of SB8's.
               In psload_font(), conditionally calling psunload_font() based
               on USE_JUMP_TABLES.
               In psrom_set_char(), conditionally compiled block of code
               pertaining to "cur_ssnum != T1ENCODING" based on 
               USE_UFST_MAPPING to resolve compiler error.
28-Sep-93  jfd In psload_font (), initialize "gpps->FontBBox[]".
06-Oct-93  jfd In type1char(), cast call to GETECHAR() as UL32 because
               "<< 16" shift was causing the hi-word to be lost.
14-Oct-93  jfd In type1char(), when processing a MOVETO, check if a 
               closepath was executed for the previous loop. If not,
               execute the closepath so that the number of loops in
               the character will be updated properly.
15-Oct-93  jfd In type1char(), replaced disabled code associated with 
               "t1e_SETCURPT" (Fmoveto) with code to set the current point
               (curx,cury) to the 2 values popped off the stack to fix
               incorrect placement of accents on several compound characters
               of "special" Type 1 fonts.
22-Oct-93  jfd In othersubr(), "fpush" the current point onto the stack
               because "t1e_SETCURPT" attempts to pop them later.
25-Oct-93  jfd In type1char(), only perform closepath if "(!record)".
26-Oct-93  mby if MULTICALLER enabled, call PCLchId2ptr() with addtional
               argument. Declare uLastCallerId EXTERNAL.
16-Nov-93  jfd In type1char(), added support for 'special' test font.
19-Nov-93  jfd In psset_char(), expanded conditional compile statement
               used for setting "if_state.char_buf = MEMptr (hchar_buf)"
               to include "IF_PCLEOI".
01-Dec-93  jfd Changed KANJI_ENCODING to ASIAN_ENCODING.
08-Dec-93  rs  General cleanup - MSDOS & OS2.
27-Jan-94  jfd Conditionally compiled #include for fcntl.h based on
               (!defined(_AM29K) || (defined(_AM29K) && |defined(UNIX))).
04-Feb-94 jfd  Conditionally compile "sys\types.h" and "sys\stat.h"
               based on !_AM29K.
               Including "hif.h" if _AM29K.
25-Feb-94 dbk/jfd
               AM29K changes for ROM support to fix compiler errors in
               PSROMfinddata(), psrom_set_char() and PSROMload_font().
22-Mar-94 jfd  In PSROMload_font() and psset_char(), added Type 0 support.
22-Apr-94 jfd  Changed conditional compile statement prior to
               including <hif.h> to #if (_AM29K && !UNIX) to
               resolve UNIX Metaware compiler error.
22-Jun-94 jfd  In psload_font() and psset_char(), when checking for type of 
               ASIAN encoding, added checks for UNICODE, BIG5, TCA and GB.
18-Apr-95 jfd  In psset_char() and psrom_set_char(), added support for
               the removal of symbol set mapping.
               Conditionally compiled PSdata[] and cm_cgidToIndex()
               based on !NO_SYMSET_MAPPING.

*/

#include "cgconfig.h"

#if PST1_RDR    /* conditional compile entire module */ 

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include <stdio.h>
#include <math.h>
#include <string.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>      /* open() */
#endif

#include "port.h"   /* add 3/23/92 - rs */

#if defined (MSDOS) || defined (__OS2__)   /* needs port.h */
#include <sys\types.h>  /* open() */
#include <sys\stat.h>   /* open() */
#include <io.h>         /* close() */

#elif defined (MACINTOSH)
#include <unix.h>

#else /* unix */

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if !defined(_AM29K)
#include <sys/types.h>  /* open() */
#include <sys/stat.h>   /* open() */
#if !defined (__i960)
#include <unistd.h>     /* for SEEK_SET */
#endif  /* !__i960 */
#endif /* !_AM29K */
#endif  /* MSDOS || OS2 */

#if !defined(__i960) && !defined (MACINTOSH) && !defined(VXWORKS)
#include <malloc.h>
#endif  /* !__i960 */

#ifndef MIPS
#include <stdlib.h> /* need for 'abort()' i.e. ASSERT */
#endif

#include "debug.h"
#include "ifmem.h"
#include "mixmodel.h"
#include "cgif.h"
#include "fpmath.h" /* add 7/23/93 - rs */
#include "ix.h"     /* CHARBUFSIZE */
#include "if_type.h"
#include "cache.h"   /* CHARalloc() */
#include "dll.h"
#if (USE_UFST_MAPPING != 0)
#include "sym.h" /* SYMmap() - 5/27/92 - rs */
#endif

#include "t1itype1.h"
#include "t1isyntx.h"
#include "t1iproto.h"
#if PST1_PCLEOI
#include "t1ipcleo.h"
#endif
#if PST1_SFNTI
#include "t1isfnt.h"
#endif
#if ASIAN_ENCODING
#include "kanji.h"
#endif

#define MOVETO(x,y)  (t1moveto (x, y))
#define LINETO(x,y)  (t1lineto (x, y))
#define CURVETO(x1,y1,x2,y2,x3,y3) (t1curveto (x1, y1, x2, y2, x3, y3))
#define CLOSEPATH() (savex = curx, savey = cury, t1closepath(), t1moveto (savex, savey))
#define ENDCHAR()  t1endchar ()
#define fpop()    (*--argsptr)
#define fpopx()   (--argsptr)
#define fpush(x)  (*argsptr++ = (x))
#define GETECHAR()   ((UW16)(*edata++))

#ifdef LINT_ARGS

#if PST1_PCLEOI || PST1_SFNTI
#if !MULTICALLER
EXTERN LPUB8 PCLchId2ptr (UW16);
#else   /* Multicaller is enabled */
EXTERN LPUB8 PCLchId2ptr( UW16, UW16 );
#endif  /* MULTICALLER */
#endif

#if ((USE_UFST_MAPPING != 0) && !NO_SYMSET_MAPPING)
EXTERN UW16   cm_cgidToIndex(UW16);
#endif

MLOCAL PCDATASTR finddata (int);
MLOCAL VOID estart (LPUB8, SL32); /* change from SW16 to SL32 - 10/2/91 - rs */


GLOBAL UW16 psload_font (PFONT_DES, PBUCKET);
GLOBAL UW16 psset_char (PBUCKET, UW16);
GLOBAL UW16 psmake_gaso_and_stats (PBUCKET, PCHAR_STATS);
GLOBAL UW16 psrender (PBUCKET, INTR, INTR);
#if WIDTHS
GLOBAL UW16 psget_width (PBUCKET);
#endif /* WIDTHS */
GLOBAL int type1char (PCDATASTR, int);
MLOCAL UW16 othersubr (int num, SL32 arg);
#if T1MMASTER
MLOCAL SL32 blend (LPSL32);
#endif
#if PST1_ROM
MLOCAL LPUB8 PSROMfinddata (int);
GLOBAL UW16 PSROMload_font (LPUB8);
MLOCAL UW16 psrom_set_char (PBUCKET, UW16);
#endif

#else /* not LINT_ARGS */

#if PST1_PCLEOI || PST1_SFNTI
EXTERN LPUB8 PCLchId2ptr ();
#endif
#if ((USE_UFST_MAPPING != 0) && !NO_SYMSET_MAPPING)
EXTERN UW16   cm_cgidToIndex();
#endif

MLOCAL PCDATASTR finddata ();
MLOCAL VOID estart ();


GLOBAL UW16 psload_font ();
GLOBAL UW16 psset_char ();
GLOBAL UW16 psmake_gaso_and_stats ();
GLOBAL UW16 psrender ();
#if WIDTHS
GLOBAL UW16 psget_width ();
#endif /* WIDTHS */
GLOBAL int type1char ();
MLOCAL UW16 othersubr ();
#if T1MMASTER
MLOCAL SL32 blend ();
#endif

#if PST1_ROM
MLOCAL LPUB8 PSROMfinddata ();
GLOBAL UW16 PSROMload_font ();
MLOCAL UW16 psrom_set_char ();
#endif

#endif /* LINT_ARGS */


GLOBAL PBUCKET   gpxb; /* add 1/6/92 - rs */
GLOBAL PPS_BUCK   gpps;
GLOBAL PCHAR_STATS  gpcs;
GLOBAL SW16       last_cmd;   /* remember for 2 moveto's at char start */
GLOBAL FPNUM      FPZERO, FPONEHALF; /* add 7/23/93 - rs */

#if (((USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)) && !NO_SYMSET_MAPPING)
EXTERN LPSB8 PSdata[];
#endif

MLOCAL UW16 code   =  4330;
MLOCAL INTR    p0x, p0y; /* current locs while rasterizing */

/*
arguments for flexproc
add 12/16/91 - rs
and all arguments read from font
change from SW16 to SL32 to handle 32 bit div
*/
MLOCAL  SL32     args[50];

/*  5/14/93 - rs
   The following variables were move from 'type1char()' in order to
   integrade the Pipeline upgrade. They are now shared among multiple funcs.
*/
MLOCAL LPSL32  argsptr;
MLOCAL SL32  curve1[6], curve2[6];
MLOCAL int record; /* init FALSE - 4/14/93 - rs */
MLOCAL SL32  ex, ey, epx, epy;
MLOCAL SL32  curx, cury, x, y; /* init to 0 - 4/14/93 - rs */



/* subroutine call stack */
MLOCAL  struct
{
  SW16 key;
  LPUB8 data;
} subcalls[11];

/*
Global character buffer used for storing bezier data
*/
EXTERN MEM_HANDLE  hchar_buf;
EXTERN IF_STATE if_state;

#if MULTICALLER         /* mby, 10/26/93 */
EXTERN  UW16  uLastCallerId;
#endif

#if PST1_ROM

#include "psrom.h"

/* Swapping macros */

#if BYTEORDER == LOHI
#define WSWAP  tmpp.w = *(UW16*)p;  *p++ = tmpp.b.b1; *p++ = tmpp.b.b0;

#define LSWAP   \
  tmpp.w = *(LPUW16)p; \
  *((LPUW16)p) = *((LPUW16)(p+2)); \
  *((LPUW16)(p+2)) = tmpp.w; \
  WSWAP \
  WSWAP

#define PWSWAP tmpp.w = *(LPUW16)pp; *pp++ = tmpp.b.b1; *pp++ = tmpp.b.b0;

#else
/* don't swap in this case, just bump pointer to keep up w/code -ss 10/24/91 */
#define WSWAP   p += 2;
#define LSWAP   p += 4;
#define PWSWAP pp += 2;
#endif

union {
          SW16 w;
          struct{
                    SB8 b0;
                    SB8 b1;
                }b;
       } tmpp;

LPUB8  p;

MLOCAL UL32 Offset_Flags; 

#endif  /* PST1_ROM */


#if defined (ANSI_DEFS)
GLOBAL UW16 psload_font (PFONT_DES name, PBUCKET pxb)
#else
GLOBAL UW16 psload_font (name, pxb)
PFONT_DES name;
PBUCKET pxb;
#endif
/*
*/
{
              /* change to int to match GLOBAL def -ss 6/5/92 */
EXTERN int    decoding, unputflag;
UB8 tmpbuf[8];  /* large enough for section header */
int status;

   DBG ("\npsload_font()\n");

   /*
      Init some floating points constants which we'll need later
   */
   FPZERO = fpint2fp (0L); /* floating point 0.0 */
   FPONEHALF = fpdiv (fpint2fp (1L), fpint2fp (2L)); /* floating point 0.5 */

   /*
      Save our parameters in globals for efficient useage
   */
   gpxb = pxb;    /* ptr to XBUCKET */
   gpps = &pxb->p.ps;   /* ptr to PS specific info in bucket */
   gpcs = (PCHAR_STATS)0;  /* just in case */

   /*
      Initialize variables first time through for each bucket
   */
   code   =  4330;   /* init feedback code */
   gpps->hcharstrings = gpps->hsubrs = NIL_MH;
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2) /* 6-3-93 */
   gpps->hencodearray = NIL_MH;
#endif
#if ASIAN_ENCODING
   gpps->hCODarray = NIL_MH;
#endif
   gpps->lenIV = 4;
   gpps->numbblues = gpps->numtblues = 0;
   gpps->trans = 0;
   gpps->stem_adjust = STEMWID;   /* stem adjustment cutoff */
   gpps->stem_match = STEMMATCH;  /* horiz/vert stem matching cutoff */
   gpps->stem_min = STEMMIN;      /* minimum stem width (for ForceBold) */
   gpps->overshoot = OVERSHOOT;   /* suppress overshoots < this amount */
   gpps->useblues = USEBLUES;     /* use BlueScale and BlueShift */
   gpps->hint_gravity = 0;        /* distance in pixels that hints extend */
   gpps->iBlueScale = BLUESCALE;
   gpps->iBlueShift = BLUESHIFT;
   gpps->BlueFuzz = BLUEFUZZ;
   gpps->numStemSnapH = gpps->numStemSnapV = 0;

   gpps->FontBBox[0] = gpps->FontBBox[1] = gpps->FontBBox[2] =
     gpps->FontBBox[3] = 0;

#if (T1MMASTER)
/* Init MultiMaster */
   gpps->MMnaxes = -1;  /* # of MM axes */
   gpps->hMMblendmap = gpps->hMMblues = gpps->hMMotherblues = NIL_MH;
#endif /* T1MMASTER */

  /*
    Set up IF_CHAR struct 'c' for storing bezier data
  */
  if_state.char_buf = MEMptr (hchar_buf);
  if_state.expand_buf = if_state.char_buf;
  if_state.expand_size = CHARBUFSIZE;

  decoding = FALSE;
  unputflag = FALSE;

  /*
    Free any memory previously in use
       - charstrings[], subrs[] and encodearray[] if not stdencoding
  */

#if USE_JUMP_TABLES
  (*((PIF_FUNC_TBL)pxb->pft)->unload_font) (pxb);
#else
  psunload_font (pxb);
#endif /* USE_JUMP_TABLES */

  if (pxb->fh != -1)
  {
    CLOSE (pxb->fh);
    pxb->fh = -1;
  }

#if PST1_ROM

    /*  PS ROM font */

    if (pxb->rom_font & ROM_TYPE)
    {
       status = PSROMload_font ((LPUB8)name);
       if (status)
#if USE_JUMP_TABLES
         (*((PIF_FUNC_TBL)pxb->pft)->unload_font) (pxb);/* err - release alloc'd mem */
#else
         psunload_font (pxb);
#endif /* USE_JUMP_TABLES */
    }
    else    /* not PS ROM font */
#endif  /* PST1_ROM */
#if ASIAN_ENCODING
   if (pxb->cur_ssnum == JIS || pxb->cur_ssnum == SHIFT_JIS
           || pxb->cur_ssnum == EUC || pxb->cur_ssnum == UNICODE
           || pxb->cur_ssnum == BIG5 || pxb->cur_ssnum == TCA
           || pxb->cur_ssnum == GB  || pxb->cur_ssnum == KSC)
   {
      status = ps0load_font ((SB8 *)name); /* 6-9-93 jfd */
      if (status)
#if USE_JUMP_TABLES
         (*((PIF_FUNC_TBL)pxb->pft)->unload_font) (pxb);/* err - release alloc'd mem */
#else
         psunload_font (pxb);
#endif /* USE_JUMP_TABLES */
   }
   else 
#endif /* ASIAN_ENCODING */

#if PST1_PCLEOI
    /*
        Ifthis is an external (PCLEO) font, have it loaded by the special
        PS PCLEO loader.
    */
    if (pxb->extern_font)
    {   /* PS PCLEO */
        status = PSPCLload_font ((LPUB8)name);
    }
    else    /* not PCLEO, disk based PS font */
#endif /* PST1_PCLEOI */
#if PST1_SFNTI
    /*
        Ifthis is an external generic soft font, have it loaded by the
        application suplied callback soft font loader.
    */
    if (pxb->extern_font)
    {   /* PS soft font */
        status = PSSFNTload_font (name);
    }
    else    /* not downloaded soft font, disk based PS font */
#endif /* PST1_SFNTI */
    {
        STRCPY (pxb->pathname, name); /* copy font pathname to bucket */
        pxb->fh = OPEN (name, O_READFLAGS);
        if (pxb->fh == -1)
        {
            gpxb = (PBUCKET)0;
            gpps = (PPS_BUCK)0;
            DBG1 ("psload_font() - error opening Type 1 font:%s\n", name);
            return (ERR_psi_open_file);
        }

        /*
        Determine if this is a binary or hex ascii font.
        For binary input, throw away header (8001XXXXXXXX).
        */
        if (READF (pxb->fh, (SB8 *)tmpbuf, 6) != 6)  /* 6-9-93 jfd */
        {
            gpxb = (PBUCKET)0;
            gpps = (PPS_BUCK)0;
            DBG1 ("psload_font() - error reading file:%s\n", name);
            return (ERR_psi_rdfont);
        }
        if (tmpbuf[0] == 0x80)
            gpps->hexascii = 0;
        else    /* hex ascii font, put back the data we just threw away */
        {
            gpps->hexascii = 1;
            LSEEK (pxb->fh, 0L, SEEK_SET);
        }

        if (reader () == 0)
        {
            gpxb = (PBUCKET)0;
            gpps = (PPS_BUCK)0;
            DBG ("psload_font() - error reading file\n");
            return (ERR_psi_rdfont);
        }

        status = t1setup ();
        if (status)
#if USE_JUMP_TABLES
            (*((PIF_FUNC_TBL)pxb->pft)->unload_font) (pxb);/* err - release alloc'd mem */
#else
            psunload_font (pxb);
#endif /* USE_JUMP_TABLES */

        /* Close the font file! */

        if (pxb->fh != -1)
        {
            CLOSE (pxb->fh);
            pxb->fh = -1;
        }
    } /* else (!extern_font) */

  gpxb = (PBUCKET)0;
  gpps = (PPS_BUCK)0;
  return (status);
}

#if PST1_ROM
#if defined (ANSI_DEFS)
MLOCAL LPUB8 PSROMfinddata (int n)
#else
MLOCAL LPUB8 PSROMfinddata (n)
int n;
#endif
/*
PS ROM version of finddata()! 
Locate character data given character code (for composites)
always use PostSCript standard encoding
returns offset into char names table for character or NULL if missing.
*/
{
int i;
LPUB8 ph;
LPUB8 ps;
LPUB8 pname;
UW16 wval;
UL32 lval;
int tab_size;
register LPSB8 name;

   /*
      Pieces of compound characters must be in the standard encoding array.
      Therefore, they must be between 0 and 256. Get character name.
   */
   if (n < 0 || n > 256)
   {
      DBG1 ("finddata() bad character code:(%d)\n", n);
       return (NULL);
   }
   name = stdencoding[n];
   DBG1 ("name is %s\n", name);

   /*
      Get pointer to charstring for this character if it has been read into
      memory.
   */

   ph = ps = gpxb->cur_font_hdr + gpps->ocharnames;

   for (i=0; i<gpps->n_chars; i++)
   {
      if (Offset_Flags & LONG_CHARNAM_OFFSETS)
      {
         /* Charnames offsets table contains LONG entries. */

         lval = *(LPUL32)ps;  /* offset to this charname */
         p = (LPUB8)&lval;
         LSWAP

         tab_size = gpps->n_chars * sizeof(UL32);

         pname = ph + (UL32)tab_size + (UL32)lval;
         if (STRCMP ((LPSB8)pname, name) == 0) /*AM29K*/
         {
            ps = gpxb->cur_font_hdr + (UL32)gpps->hcharstrings;

            if (Offset_Flags & LONG_CHARSTR_OFFSETS)
            {
            /* Charstrings offsets table contains LONG entries. */

               lval = *(LPUL32)(ps + (i * sizeof(UL32)));  /* offset to this charstring */
               p = (LPUB8)&lval;
               LSWAP

               tab_size = gpps->n_chars * sizeof(UL32);
               return (LPUB8)(ps + tab_size + lval);
            }
            else
            {
            /* Charstrings offsets table contains WORD entries. */

               wval = *(LPUW16)(ps + (i * sizeof(UW16)));  /* offset to this charstring */
               p = (LPUB8)&wval;
               WSWAP

               tab_size = gpps->n_chars * sizeof(UW16);
               tab_size += 3;
               tab_size &= ~3;

               return (LPUB8)(ps + tab_size + wval);
            }
         }
         ps += sizeof(UL32);
      }
      else
      {
         /* Charnames offsets table contains WORD entries. */

         wval = *(LPUW16)ps;  /* offset to this charname */
         p = (LPUB8)&wval;
         WSWAP

         tab_size = gpps->n_chars * sizeof(UW16);
         tab_size += 3;
         tab_size &= ~3;  /* quad-align table length */

         pname = ph + (UL32)tab_size + (UL32)wval;
         if (STRCMP ((LPSB8)pname, name) == 0)  /*AM29K*/
         {
            ps = gpxb->cur_font_hdr + (UL32)gpps->hcharstrings;

            if (Offset_Flags & LONG_CHARSTR_OFFSETS)
            {
            /* Charstrings offsets table contains LONG entries. */

               lval = *(LPUL32)(ps + (i * sizeof(UL32)));  /* offset to this charstring */
               p = (LPUB8)&lval;
               LSWAP

               tab_size = gpps->n_chars * sizeof(UL32);
               return (LPUB8)(ps + tab_size + lval);
            }
            else
            {
            /* Charstrings offsets table contains WORD entries. */

               wval = *(LPUW16)(ps + (i * sizeof(UW16)));  /* offset to this charstring */
               p = (LPUB8)&wval;
               WSWAP

               tab_size = gpps->n_chars * sizeof(UW16);
               tab_size += 3;
               tab_size &= ~3;

               return (LPUB8)(ps + tab_size + wval);
            }
         }
         ps += sizeof(UW16);
      }
   }
   return (NULL);   /* can't find charname */
}
#endif  /* PST1_ROM */


#if defined (ANSI_DEFS)
MLOCAL PCDATASTR finddata (int n)
#else
MLOCAL PCDATASTR finddata (n)
int n;
#endif
/*
locate character data given character code (for composites)
always uses PostScript standard encoding
returns PCDATASTR for character or NULL if missing
*/
{
register PCDATASTR cptr, cend = ((PCDATASTR)MEMptr (gpps->hcharstrings)
                                    + gpps->curr_char + 1);
register LPSB8 name;
PCDATASTR   savecptr; /* save current ptr while reading more charstrings */
int   status;

   /*
      Pieces of compound characters must be in the standard encoding array.
      Therefore, they must be between 0 and 256. Get character name.
   */
   if (n < 0 || n > 256)
   {
      DBG1 ("finddata() bad character code:(%d)\n", n);
       return (NULL);
   }

   name = stdencoding[n];
   DBG1 ("name is %s\n", name);

   /*
      Get pointer to charstring for this character if it has been read into
      memory.
   */
   for (cptr = (PCDATASTR)MEMptr (gpps->hcharstrings); cptr < cend; ++cptr) 
      if (STRCMP ((LPSB8)MEMptr (cptr->hname), name) == 0)
         break;

    if (cptr != cend)
      return cptr;

    /*
       Character is not in charstrings. Perhaps it has not been loaded yet.
      Save current charstring ptr, load desired charstring & restore ptr.
   */
    if (gpps->curr_char < gpps->n_chars)
   {
      savecptr = gpps->pthis_charstring;
       status = more_charstrings (name, 1);
      cptr = gpps->pthis_charstring;
      gpps->pthis_charstring = savecptr;
   }
   if (status)
       return (NULL);  /* charstring not found */
   else return cptr;
}

#if defined (ANSI_DEFS)
MLOCAL VOID estart (register LPUB8 s, SL32 len)
#else
MLOCAL VOID estart (s, len)
register LPUB8 s;
SL32      len; /* change from SW16 to SL32 - 10/2/91 - rs */
#endif
/*
decrypt a string
*/
{
register UW16  x; /* change from SW16 to UW16 - 10/4/91 - rs */
register SW16  i;

  code = 4330;

  for (i = 0; i < (SW16)len; ++i) /* add cast of (SW16) - 10/2/91 - rs */
  {
    x = (UW16)*s;
    *s++ = (UB8)((x ^ (code >> 8)) & 0x00ff);
    code = 0x58bf + (code + x) * 0xce6d;
  }
}

#if defined (ANSI_DEFS)
GLOBAL int type1char (PCDATASTR cptr, int wflag)
#else
GLOBAL int type1char (cptr, wflag)
PCDATASTR cptr;
int       wflag;  /* 0==build character, 1==get width only */
#endif
/*
** type1char does all the hard work of decoding the Type 1 format.
** Each time it encounters a path drawing command or hint, it calls the
** relevant routine in t1hints.c.

3/20/92 - rs - Add support for PS PCLEO characters
*/
{
register LPUB8 edata;
register UL32 c; /* UW16 to UL32 - 12/16/91 - rs */
SL32  arg;  /* UW16 to SL32 - 12/16/91 - rs */
SL32  xadv, yadv, savex, savey, llx=0L, lly=0L; /* SW16 to SL32 - 12/16/91 - rs */
SL32  llx_accent;   /* 11-16-93 jfd */
SW16  num, sublevel = 0;
SL32  x1, y1, x2, y2, x3, y3;
SL32  sx=0L, sy=0L; /* SW16 to SL32 - 12/16/91 - rs */
int  composite = FALSE;
int  cc1, cc2, donecc2 = FALSE;
SL32  deltax, deltay; /* SW16 to SL32 12/16/91 - rs */
UW16  tmp;
UW16 inchar, inchar2;
int status;
LPUB8   pdata;   /* add 1/3/92 - rs */
PSUBS_STR psubrs; /* add 1/3/92 - rs */
int   PCLflag = 0;

#if PST1_PCLEOI || PST1_SFNTI
LPUB8 ph;
SW16  Namelen, Datalen;
UB8   Decryptflag; /* Decrypt byte */
#endif

#if PST1_ROM
LPUB8 ps;
UW16 wval;
UL32 lval;
int i;
UW16 tab_size;
#endif

int closepath_called = 0;  /* flag indicating whether t1closepath()
                            * has been called
                            *  10-13-93 jfd
                            */

int seacs_called = 0;      /* 11-16-93 jfd */
int ccparts_processed = 0; /* 11-16-93 jfd */
int ccparts_needed = 0;    /* 11-16-93 jfd */

/* Incorporating array to handle mltiple SEAC commands for a given character
 *    11-16-93 jfd
 */
SL32 deltax_buf[4];      /* 11-16-93 jfd */
SL32 deltay_buf[4];      /* 11-16-93 jfd */
SL32 llx_accent_buf[4];  /* 11-16-93 jfd */
SL32 llx_buf[4];         /* 11-16-93 jfd */
int  cc2_buf[4];         /* 11-16-93 jfd */
int  cc1_buf[4];         /* 11-16-93 jfd */

   argsptr = args;
   record = FALSE;   /* now used outside this function - 5/14/93 - rs */
   curx = cury = 0L; /* now used outside this function - 5/14/93 - rs */

#if PST1_PCLEOI
  if (gpxb->extern_font)   /* see if this is a PS PCLEO */
   {
      PCLflag = 1;            /* indicate a PCLEO */
      ph = (LPUB8)((LPUB8)cptr + sizeof (PS_CHAR_HDR)); /* -> Namelen */
      UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
      UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
      ph += Namelen;           /* -> Data */
      Decryptflag = *(ph + Datalen); /* get Decrypt byte */
      if (!Decryptflag) /* only handle decrypted data for now */
         return (ERR_psi_pcleo_encr);
      pdata = ph;
   }
  else                     /* not PCLEO, disk based */
#endif /* PST1_PCLEOI */
#if PST1_SFNTI
/*
NOTE:
   The following code is to support generic downloaded soft fonts.
   It is up to the application to provide a call back loader to handle
   them. During DEBUG, we will assume that they look like PSEO's.
*/
  if (gpxb->extern_font)   /* see if this is a type 1 downloaded soft font */
   {
      PCLflag = 1;            /* indicate a downloaded soft font */
      ph = (LPUB8)((LPUB8)cptr + sizeof (PS_CHAR_HDR)); /* -> Namelen */
      UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
      UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
      ph += Namelen;           /* -> Data */
      Decryptflag = *(ph + Datalen); /* get Decrypt byte */
      if (!Decryptflag) /* only handle decrypted data for now */
         return (ERR_psi_pcleo_encr);
      pdata = ph;
   }
  else                     /* not PCLEO, disk based */
#endif /* PST1_SFNTI */
#if PST1_ROM
  if (gpxb->rom_font & ROM_TYPE)
  {
     pdata = (LPUB8)cptr;
  }
  else
#endif  /* PST1_ROM */
  {
     pdata = (LPUB8)MEMptr (cptr->hdata); /* add 1/3/92 - rs */
     if (!cptr->decrypted)
     {
     estart (pdata, cptr->len);
       cptr->decrypted = TRUE;
     }
  }

  edata = pdata + gpps->lenIV;

  while (1)
  {
    inchar = GETECHAR ();

    if (inchar <= 0xf6)
      c = inchar;
    else
    {
      inchar2 = GETECHAR ();
      c = ((inchar << 8) | inchar2);
    }

    if (/*(c < 0) compiler warning - 2/5/92 - rs || */ (c >= 0x20))
    {

    /* see if we should flush them out */

      if (c >= 0x20 && c < 0xf7)
      {
        arg = (SL32)c - 0x20L - 107L;
      }
      else if (c >= 0xf700 && c < 0xfb00)
      {
        arg = (SL32)c - 0xf700L + 108L;
      }
      else if (c >= 0xfb00 && c < 0xff00)
      {
        arg = (-((SL32)c - 0xfb00L + 108L));
      }
      else
      {  /* next four bytes contain a long */
        c =  (c << 24) | ((UL32)GETECHAR () << 16);  /* 10-06-93 jfd */
        c |= GETECHAR () << 8;
        arg = (SL32)(c | GETECHAR ());
      }
      fpush (arg);
#ifdef SUPERDEBUG
      DBG1 ("Push: %ld\n", arg);
#endif /* SUPERDEBUG */
      continue;
    }

    /* opcode */

    switch ((SW16)(c & 0xffff))
    {
      case t1_HSTEM:  /* hstem */
        DBG ("hstem\n");

        y2 = fpop ();
        y1 = fpop () + sy;

        status = hstem (y1, y1 + y2);
        if (status)
            return (status);
        break;
      case t1_VSTEM:  /* vstem */
        DBG ("vstem\n");

        x2 = fpop ();
        x1 = fpop () + sx;

        status = vstem (x1, x1 + x2);
        if (status)
            return (status);
        break;
      case t1_YRMOVETO:  /* yrmoveto */
        cury += fpop ();
        DBG2 ("yrmoveto %ld %ld\n", curx, cury);

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         */

        if (!record)  /* 10-25-93 jfd */
        {

        if (!closepath_called)
        {
           savex = curx;
           savey = cury;
           status = t1closepath();
           if (status)
             return (status);
        }
        else
           closepath_called = 0;

        }  /* 10-25-93 jfd */


        /* In an interpreter environment, eliminate this "record" nonsense,
          (i.e., it's always FALSE), since it's handled by OtherSubrs
          calls in preparation for executing OtherSubrs[0] (FlxProc).
        */

        if (!record) 
            status = MOVETO (curx, cury);
            if (status)
                return (status);

        break;
      case t1_RLINETO:  /* rlineto */
        cury += fpop ();
        curx += fpop ();
        DBG2 ("rlineto %ld %ld\n", curx, cury);
        status = LINETO (curx, cury);
        if (status)
            return (status);
        break;
      case t1_XRLINETO:  /* xrlineto (horiz line) */
        curx += fpop ();
        DBG2 ("xrlineto %ld %ld\n", curx, cury);
        status = LINETO (curx, cury);
        if (status)
            return (status);
        break;
      case t1_YRLINETO:  /* yrlineto (vert line) */
        cury += fpop ();
        DBG2 ("yrlineto %ld %ld\n", curx, cury);
        status = LINETO (curx, cury);
        if (status)
            return (status);
        break;
      case t1_RRCURVETO:  /* rcurveto */
        DBG ("rcurveto\n");
        y3 = fpop ();
        x3 = fpop ();
        y2 = fpop ();
        x2 = fpop ();
        y1 = fpop ();
        x1 = fpop ();

        x1 += curx;
        y1 += cury;
        x2 += x1;
        y2 += y1;
        x3 += x2;
        y3 += y2;

        DBG8 ("curveto %ld,%ld %ld,%ld %ld,%ld %ld,%ld\n",
          curx, cury, x1, y1, x2, y2, x3, y3);
        status = CURVETO (x1, y1, x2, y2, x3, y3);
        if (status)
            return (status);

        curx = x3;
        cury = y3;
        break;
      case t1_CLOSEPATH:  /* closepath */
        DBG ("closepath\n");
        /* CLOSEPATH (); error mgt:replace macro w/inline code 12/3/91 - rs */
        savex = curx;
        savey = cury;
        status = t1closepath();
        if (status)
          return (status);

        closepath_called = 1;   /* 10-13-93 jfd */

        status = MOVETO (savex, savey);
        if (status)
          return (status);

        break;
      case t1_CALLSUBR:  /* subr */
        /* In an interpreter environment, a lookup would be made
           inside the Subrs array, stored inside the Private 
           dictionary, for the subroutine to execute.  */
           
        num = (SW16)(fpop () & 0xffff);
        DBG1 ("calling subr %d\n", num);
        subcalls[sublevel].data = edata;
        subcalls[sublevel++].key = code;
        if (num >= gpps->nsubs)
        {
          DBG2 ("type1char() - subnum:%d > # of subs:%d\n", num, gpps->nsubs);
          return (ERR_psi_Subr_too_hi);
        }
#if PST1_ROM
        if (gpxb->rom_font & ROM_TYPE)
        {
           if (Offset_Flags & LONG_SUBRS_OFFSETS)
           {
           /* Subrs offsets table contains LONG entries. */

              ps = gpxb->cur_font_hdr + (UL32)gpps->hsubrs +
                 (UL32)(num * sizeof(UL32));

              lval = *(LPUL32)ps;  /* offset to this subr */
              p = (LPUB8)&lval;
              LSWAP
              edata = gpxb->cur_font_hdr + (UL32)gpps->hsubrs +
                 (UL32)(gpps->nsubs * sizeof(UL32)) + (UL32)lval;
           }
           else
           {
           /* Subrs offsets table contains WORD entries. */

              ps = gpxb->cur_font_hdr + (UL32)gpps->hsubrs +
                 (UL32)(num * sizeof(UW16));

              wval = *(LPUW16)ps;  /* offset to this subr */
              p = (LPUB8)&wval;
              WSWAP

              tab_size = gpps->nsubs * sizeof(UW16);
              tab_size += 3;
              tab_size &= ~3;

              edata = gpxb->cur_font_hdr + (UL32)gpps->hsubrs + 
                 tab_size + (UL32)wval;
           }
        }
        else
#endif
        {
           psubrs = (PSUBS_STR)MEMptr (gpps->hsubrs);
           if (!psubrs[num].decrypted)
           {
              estart ((LPUB8)MEMptr (psubrs[num].hdata), psubrs[num].len);
              psubrs[num].decrypted = TRUE;
           }
           edata = (LPUB8)MEMptr (psubrs[num].hdata) + gpps->lenIV;
        }
        break;
      case t1_RETURN:  /* rets */
        DBG ("rets\n");
        edata = subcalls[--sublevel].data;
        code = subcalls[sublevel].key;

        break;
      case t1_ESCAPE:
        tmp = GETECHAR ();

        switch  (tmp)
        {
          case t1e_DOTSECTION: /* dotsection */
            DBG ("dotsection\n");
            break;
          case t1e_VSTEM3: /* vstem6 */
            DBG ("vstem6\n");

            curve1[5] = fpop ();
            curve1[4] = fpop () + sx;
            curve1[3] = fpop ();
            curve1[2] = fpop () + sx;
            curve1[1] = fpop ();
            curve1[0] = fpop () + sx;

            curve1[1] += curve1[0];
            curve1[3] += curve1[2];
            curve1[5] += curve1[4];

            status = vstem6 (curve1);
            if (status)
                    return (status);

            break;

          case t1e_HSTEM3: /* hstem6 */
            DBG ("hstem6\n");
            curve1[5] = fpop ();
            curve1[4] = fpop () + sy;
            curve1[3] = fpop ();
            curve1[2] = fpop () + sy;
            curve1[1] = fpop ();
            curve1[0] = fpop () + sy;

            curve1[1] += curve1[0];
            curve1[3] += curve1[2];
            curve1[5] += curve1[4];

            status = hstem6 (curve1);
            if (status)
                    return (status);

            break;

          case t1e_SEAC: /* composite-char */
            DBG ("composite\n");

            /* 11-16-93 jfd
             *
             * Save 'cc2', 'cc1','deltay', 'deltax' and 'llx_accent'
             * in a buffer in case we need them later for positioning
             * a compound character part.
             *
             */

            cc2 = cc2_buf[seacs_called] = (int)(fpop () & 0xffff);
            cc1 = cc1_buf[seacs_called] = (int)(fpop () & 0xffff);
            deltay = deltay_buf[seacs_called] = fpop ();
            deltax = deltax_buf[seacs_called] = fpop ();
#if 0   /* 11-16-93 jfd */
            fpopx(); /* fpop (); 5/8/92 cleanup - rs */
                     /* do not throw away this value   11-16-93 jfd */
#endif  /* 11-16-93 jfd */
            llx_accent = llx_accent_buf[seacs_called] = fpop ();

           /* 11-16-93 jfd
            *
            * Save 'llx' associated with this SEAC.
            *
            */

            llx_buf[seacs_called] = llx;

           /* 11-16-93 jfd
            *
            * Keep count of compound character parts being processed.
            *
            */

            ccparts_needed += 2;


           /* 11-16-93 jfd
            *
            * If any points have been processed prior to a SEAC command,
            * throw them away,
            */

            if (gpcs->ct_lineto || gpcs->ct_quadto || gpcs->ct_cubeto)
					status = t1startchar (sx, sy, xadv);

           /* 11-16-93 jfd
            *
            * Keep count of SEAC commands processed.
            *
            */

            seacs_called++;

            composite = TRUE;
            donecc2 = FALSE;

            curx = sx = llx;
            cury = sy = 0;

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         */
           if (!closepath_called)
           {
              savex = curx;
              savey = cury;
              status = t1closepath();
              if (status)
                return (status);
           }
           else
              closepath_called = 0;

            status = MOVETO (sx, sy);
            if (status)
                    return (status);

            /* do cc1 here, cc2 is done at endchar  */

         DBG1 ("Begin character decoding for comp char %d\n", cc1);

#if PST1_PCLEOI
         if (PCLflag)
         {
#if !MULTICALLER        /* mby, 10/26/93 */
              ph = PCLchId2ptr (cc1);
#else   /* Multicaller is enabled */
              ph = PCLchId2ptr (uLastCallerId, cc1);
#endif  /* MULTICALLER */
               if (!ph)
            {
                  DBG1 ("type1char() - can't find PCLEO compound char 1:%d\n",
                     cc1);
                  return (ERR_psi_cc_missing);
            }
            ph += sizeof (PS_CHAR_HDR); /* -> Namelen */
            UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
            UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
            ph += Namelen;           /* -> Data */
            Decryptflag = *(ph + Datalen); /* get Decrypt byte */
            if (!Decryptflag) /* only handle decrypted data for now */
               return (ERR_psi_pcleo_encr);
            pdata = ph;
         }
         else
#endif /* PST1_PCLEOI */
#if PST1_SFNTI
/*
NOTE:
   The following code is to support generic downloaded soft fonts.
   It is up to the application to provide a call back loader to handle
   them. During DEBUG, we will assume that they look like PSEO's.
*/
         if (PCLflag)
         {
#if !MULTICALLER        /* mby, 10/26/93 */
            ph = PCLchId2ptr (cc1);
#else   /* Multicaller is enabled */
            ph = PCLchId2ptr (uLastCallerId, cc1);
#endif  /* MULTICALLER */
            if (!ph)
            {
                  DBG1 ("type1char() - can't find PCLEO compound char 1:%d\n",
                     cc1);
                  return (ERR_psi_cc_missing);
            }
            ph += sizeof (PS_CHAR_HDR); /* -> Namelen */
            UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
            UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
            ph += Namelen;           /* -> Data */
            Decryptflag = *(ph + Datalen); /* get Decrypt byte */
            if (!Decryptflag) /* only handle decrypted data for now */
               return (ERR_psi_pcleo_encr);
            pdata = ph;
         }
         else
#endif /* PST1_SFNTI */
#if PST1_ROM
         if (gpxb->rom_font & FC_ROM_TYPE)
         {
            pdata = PSROMfinddata (cc1);  /* get 1st part of compound char */
            if (!pdata)
               return (ERR_psi_cc_missing);
         }
         else
#endif
         {
               cptr = finddata (cc1);  /* get 1st part of compound char */
               if (!cptr)
                  return (ERR_psi_cc_missing);
            pdata = (LPUB8)MEMptr (cptr->hdata); /* add 1/3/92 - rs */

            if (!cptr->decrypted)
            {
                  estart (pdata, cptr->len);
               cptr->decrypted = TRUE;
            }
         } /* else not PCLEO */

         ccparts_processed++;  /* 11-16-93 jfd */

         edata = pdata + gpps->lenIV;
         break;

          case t1e_SBW: /* set x,y sidebearing and width */
			   DBG ("sbw: ");
				yadv = fpop ();
				DBG1 ("yadv = %ld, ", yadv);
				if (!composite)
                {
					xadv = fpop ();
					DBG1 ("xadv = %ld, ", xadv);

					cury = lly = sy = fpop ();
					curx = llx = sx = fpop ();
					DBG2 ("curx = %ld, cury = %ld", curx, cury);

					status = t1startchar (sx, sy, xadv);

               /* Set flag indicating whether  closepath() was called
                * for previous loop to 1 since this is the start of 
                * the character and there is no previous loop. This
                * is being done so that when MOVETO is processed,
                * closepath() will not be called by us.
                *
                * 10-13-93 jfd
                */

               closepath_called = 1;  

               if (status || wflag)
                  return (status);
					/* moveto (sx, sy); */
				}
				else if (!donecc2)
            {
					fpopx ();
					curx = sx = fpop ();

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         */
              if (!closepath_called)
              {
                 savex = curx;
                 savey = cury;
                 status = t1closepath();
                 if (status)
                   return (status);
              }
              else
                 closepath_called = 0;

					status = MOVETO (curx, cury);
               if (status)
                  return (status);
			   }
				else
            {
					fpopx ();
               fpopx ();
				}
				DBG ("\n");

				break;

          case t1e_DIV: /* div */
            /*
            ** This is the only place that I see the
            ** need for floating point, and it only appears
            ** to be used for the hints.  We'll do the divide
            ** at a higher precision, round the result, and
            ** convert it back to an integer.  There seems to
            ** no loss of detail when this is done
            */
               
            DBG ("div\n");
            x2 = fpop ();
            x1 = fpop ();
            /* compute in 16ths, round, and put back */
            fpush (T1ROUND ((((SL32) x1) << 4) / x2) >> 4);
            break;

          case t1e_CALLOTHERSUBR: 
            /* OtherSubrs calls -- In a PostScript interpreter,
               this would end up executing a PostScript procedure
               indexed by "num" inside  OtherSubrs,
               (which is an array of procs stored inside the font's
               Private dictionary)
              */

            num = (SW16)(fpop () & 0xffff);
            arg = fpop (); /* number of args to push onto the PostScript stack */

            DBG1 ("OtherSubr %d\n", num);
            othersubr (num, arg);
            break;

         case t1e_POP: /* push-result */
            DBG ("push result\n");
            /* In a PostScript interpreter, this means to pop the top
               of the PostScript stack and push it onto the internal stack */
            break;

          case 0x20: /* push-curr-pt */
            DBG ("push-curr-pt!\n");
            /* In a PostScript interpreter, this means to push the current internal
               point onto the PostScript stack */
            break;

          case t1e_SETCURPT: /* Fmoveto */
            DBG ("Fmoveto\n");
            /* In a PostScript interpreter, this means to set the current
               point to the two values popped off the internal stack */
#if 0
            /* y1 = fpop ();  COMMENTED OUT BY PIPELINE - 5/14/93 - rs
               x1 = fpop (); */
#endif
            /* Added these lines based on the comment above to fix placement 
               of accents on compound characters of "special" Type 1 fonts
               - 10/15/93 - jfd
             */
            cury = fpop ();
            curx = fpop ();
            break;
        } /* switch (tmp) - ESCAPE commands */
        break;

      case t1_HSBW:  /* offset width charwidth */
        DBG ("start char\n");
        if (!composite)
        {
          xadv = fpop ();

          curx = llx = sx = fpop ();
          cury = lly = sy = 0;

            status = t1startchar (sx, sy, xadv);

            /* Set flag indicating whether  closepath() was called
             * for previous loop to 1 since this is the start of 
             * the character and there is no previous loop. This
             * is being done so that when MOVETO is processed,
             * closepath() will not be called by us.
             *
             * 10-13-93 jfd
             */

            closepath_called = 1;  

            if (status || wflag)
                return (status);
        }
        else if (!donecc2)
        {
            fpopx ();
            curx = sx = fpop ();

            llx = curx;  /* 11-16-93 jfd */

            /* If closepath has not been executed for prevvious loop,
             * we will do it ourselves here!
             *
             *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             */

            if (!closepath_called)
            {
               savex = curx;
               savey = cury;
               status = t1closepath();
               if (status)
                 return (status);
            }
            else
               closepath_called = 0;

            status = MOVETO (curx, cury);
            if (status)
               return (status);
        }
        else
        {
            fpopx (); /* fpop (); 5/8/92 cleanup - rs */
#if 0   /* 11-16-93 jfd */
            fpopx (); /* fpop (); 5/8/92 cleanup - rs */
                      /* do not throw this value away   11-16-93 jfd */
#endif  /* 11-16-93 jfd */
            curx += fpop (); /* fpop (); 5/8/92 cleanup - rs */
            sx = curx;
        }

        break;

      case t1_ENDCHAR: /* endchar */
        DBG ("end char\n");
#if 0   /* 11-16-93 jfd */
        if (composite && !donecc2)
#endif  /* 11-16-93 jfd */

       /* 11-16-93 jfd
        *
        * Check for multiple SEACs so as not to stop processing
        * prematurely.
        *
        */

        if (composite && (!donecc2 || (seacs_called > 1)) )
        {
          /* end cc1, now do cc2 */

        /* 11-16-93 jfd
         *
         * If multiple SEACs, use correct displacements.
         *
         */

          ccparts_processed++;
          if (ccparts_processed >= ccparts_needed)
          {
             seacs_called--;

             if (seacs_called)
             {
                deltax = deltax_buf[seacs_called-1];
                llx_accent = llx_accent_buf[seacs_called-1];
                llx = llx_buf[seacs_called-1];
             }
             else
                llx = llx_buf[0];

          }

         /* 11-16-93 jfd
          *
          * Set 'curx' using accent origin 'deltax' and left side bearing.
          *
          */

#if 0   /* 11-16-93 jfd */
          curx = sx = llx + deltax;
#endif  /* 11-16-93 jfd */

          curx = sx = (llx + deltax) - llx_accent;
          cury = sy = deltay;

           /* If closepath has not been executed for prevvious loop,
            * we will do it ourselves here!
            *
            *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            */

            if (!closepath_called)
            {
               savex = curx;
               savey = cury;
               status = t1closepath();
               if (status)
                 return (status);
            }
            else
               closepath_called = 0;

            status = MOVETO (sx, sy);
            if (status)
                return (status);

          DBG1 ("Rendering composite char %d\n", cc2);
          /* Note: in an interpreter environment, look up cc2 based
             upon the standard encoding for the font, not based upon
             the current Encoding array (the font may have been
             reencoded) */

#if PST1_PCLEOI
            if (PCLflag)
            {
#if !MULTICALLER        /* mby, 10/26/93 */
               ph = PCLchId2ptr (cc2);
#else   /* Multicaller is enabled */
               ph = PCLchId2ptr (uLastCallerId, cc2);
#endif  /* MULTICALLER */
               if (!ph)
               {
                     DBG1 ("type1char() - can't find PCLEO compound char 2:%d\n",
                        cc2);
                     return (ERR_psi_cc_missing);
               }
               ph += sizeof (PS_CHAR_HDR); /* -> Namelen */
               UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
               UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
               ph += Namelen;           /* -> Data */
               Decryptflag = *(ph + Datalen); /* get Decrypt byte */
               if (!Decryptflag) /* only handle decrypted data for now */
                  return (ERR_psi_pcleo_encr);
               pdata = ph;
            }
            else 
#endif /* PST1_PCLEOI */
#if PST1_SFNTI
/*
NOTE:
   The following code is to support generic downloaded soft fonts.
   It is up to the application to provide a call back loader to handle
   them. During DEBUG, we will assume that they look like PSEO's.
*/
            if (PCLflag)
            {
#if !MULTICALLER        /* mby, 10/26/93 */
               ph = PCLchId2ptr (cc2);
#else   /* Multicaller is enabled */
               ph = PCLchId2ptr (uLastCallerId, cc2);
#endif  /* MULTICALLER */
               if (!ph)
               {
                     DBG1 ("type1char() - can't find PCLEO compound char 2:%d\n",
                        cc2);
                     return (ERR_psi_cc_missing);
               }
               ph += sizeof (PS_CHAR_HDR); /* -> Namelen */
               UNPACK_WORD((LPUB8)&Namelen);   /* get Namelen */
               UNPACK_WORD((LPUB8)&Datalen);   /* get Datalen */
               ph += Namelen;           /* -> Data */
               Decryptflag = *(ph + Datalen); /* get Decrypt byte */
               if (!Decryptflag) /* only handle decrypted data for now */
                  return (ERR_psi_pcleo_encr);
               pdata = ph;
            }
            else 
#endif /* PST1_SFNTI */
#if PST1_ROM
            if (gpxb->rom_font & FC_ROM_TYPE)
            {
               pdata = PSROMfinddata (cc2);  /* get 2nd part of compound char */
               if (!pdata)
                  return (ERR_psi_cc_missing);
            }
            else
#endif
            {
                 cptr = finddata (cc2); /* get 2nd part of compound char */
                 if (!cptr)
                  return (ERR_psi_cc_missing);

               pdata = (LPUB8)MEMptr (cptr->hdata);  /* add 1/3/92 - rs */
               if (!cptr->decrypted)
               {
                     estart (pdata, cptr->len);
                  cptr->decrypted = TRUE;
               }
            } /* else not PCLEO compound char */

            edata = pdata + gpps->lenIV;
            donecc2 = TRUE;
        }
        else
          /* we're done here; exit the processing loop */
          goto EXITLOOP;

        break;

      case 0x0f:  /* moveto */
        cury = fpop ();
        curx = fpop ();
        DBG2 ("moveto %ld %ld\n", curx, cury);

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         */

        if (!record)  /* 10-25-93 jfd */
        {

        if (!closepath_called)
        {
           savex = curx;
           savey = cury;
           status = t1closepath();
           if (status)
             return (status);
        }
        else
           closepath_called = 0;

        }  /* 10-25-93 jfd */

        if (!record)
            status = MOVETO (curx, cury);
            if (status)
                return (status);
        break;

      case 0x10:  /* lineto */
        cury = fpop ();
        curx = fpop ();
        DBG2 ("lineto %ld %ld\n", curx, cury);
        status = LINETO (curx, cury);
        if (status)
           return (status);
        break;

      case 0x11:  /* curveto */
        DBG ("curveto\n");
        y3 = fpop ();
        x3 = fpop ();
        y2 = fpop ();
        x2 = fpop ();
        y1 = fpop ();
        x1 = fpop ();

        DBG6 ("curveto %ld %ld %ld %ld %ld %ld\n",
               x1, y1, x2, y2, x3, y3);
        status = CURVETO (x1, y1, x2, y2, x3, y3);
        if (status)
            return (status);

        curx = x3;
        cury = y3;
        break;

      case t1_RMOVETO:  /* rmoveto */
        cury += fpop ();
        curx += fpop ();
        DBG2 ("rmoveto %ld %ld\n", curx, cury);

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd 
         */

        if (!record)  /* 10-25-93 jfd */
        {

        if (!closepath_called)
        {
           savex = curx;
           savey = cury;
           status = t1closepath();
           if (status)
             return (status);
        }
        else
           closepath_called = 0;

        } /* 10-25-93 jfd */

        if (!record)
        {
            status = MOVETO (curx, cury);
            if (status)
                return (status);
        }
        break;

      case t1_HMOVETO:  /* xrmoveto */
        curx += fpop ();
        DBG2 ("xrmoveto %ld %ld\n", curx, cury);

        /* If closepath has not been executed for prevvious loop,
         * we will do it ourselves here!
         *
         *  10-13-93 jfd !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         */

        if (!record)  /* 10-25-93 jfd */
        {

        if (!closepath_called)
        {
           savex = curx;
           savey = cury;
           status = t1closepath();
           if (status)
             return (status);
        }
        else
           closepath_called = 0;

        }  /* 10-25-93 jfd */

        if (!record)
        {
            status = MOVETO (curx, cury);
            if (status)
                return (status);
        }

        break;

      case t1_VHCURVETO:  /* yrcurveto */
        DBG ("yrcurveto\n");
        x2 = fpop ();
        y2 = fpop ();
        x1 = fpop ();
        y1 = fpop ();
        DBG6 ("yrcurveto %ld %ld %ld %ld %ld %ld\n", curx, cury+y1,
             curx+x1, cury+y1+y2, curx+x1+x2, cury+y1+y2);

        status = CURVETO (curx, cury + y1, curx + x1, cury + y1 + y2,
          curx + x1 + x2, cury + y1 + y2);
        if (status)
                return (status);

        curx += x1 + x2;
        cury += y1 + y2;
        break;

      case t1_HVCURVETO:  /* xrcurveto */
        DBG ("xrcurveto\n");
        y2 = fpop ();
        y1 = fpop ();
        x2 = fpop ();
        x1 = fpop ();
        DBG6 ("xrcurveto %ld %ld %ld %ld %ld %ld\n", curx+x1, cury,
           curx+x1+x2, cury+y1, curx+x1+x2, cury+y1+y2);

        status = CURVETO (curx + x1, cury, curx + x1 + x2, cury + y1,
          curx + x1 + x2, cury + y1 + y2);
        if (status)
                return (status);

        curx += x1 + x2;
        cury += y1 + y2;
        break;

      default:
        DBG ("%%%%%% Unknown opcode %%%%%%\n");
        return (ERR_psi_rdfont);
        break;
    } /* switch ((SW16)(c & 0xffff)) */
  }

EXITLOOP:

  /* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */

  /* 10-13-93 jfd   
   * If CLOSEPATH has not been called, call it here!
   */
 
  if (!closepath_called)
  {
        savex = curx;
        savey = cury;
        status = t1closepath();
        if (status)
          return (status);
        status = MOVETO (savex, savey);
        if (status)
          return (status);
  }

  /* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */

  status = ENDCHAR ();
  if (status)
     return (status);

  DBG ("type1char - done rendering character\n"); 
  return (SUCCESS);
}

#if T1MMASTER
#define blendround(a)	(((a) + (1 << 15)) >> 16)

#if defined (ANSI_DEFS)
MLOCAL SL32 blend (LPSL32 x)
#else
MLOCAL SL32 blend (x)
LPSL32 x;
#endif
{
	register SL32  result = 0;
	int	 i;

	DBG1 ("blend (%ld", x[0]);
			
	for  (i = 1; i < gpps->Weightvals; ++i)
   {
		result += x[i] * gpps->weights[gpps->Weightvals - i];
		DBG1 (" %ld", x[i]);
	}

	result = blendround (result + (x[0] << 16));

	DBG1 (") = %ld\n", result);

	return (result);
}
#endif /* T1MMASTER */

#if defined (ANSI_DEFS)
MLOCAL UW16 othersubr (int num, SL32 arg)
#else
MLOCAL UW16 othersubr (num, arg)
int   num;
SL32  arg;
#endif
/*
      num = subroutine number
      arg = number of args to push onto the PostScript stack 
*/
{
int   i;
SL32  dmin;
int   status;

#if T1MMASTER
SL32 bargs[128], blends[128];
int firstarg, blendn, j, k;
#endif

      /* OtherSubrs calls -- In a PostScript interpreter,
         this would end up executing a PostScript procedure
         indexed by "num" inside  OtherSubrs,
         (which is an array of procs stored inside the font's
         Private dictionary)
         */
         

      DBG1 ("OtherSubr %d\n", num);

      switch (num)
      {
         case 0x00: /* FlxProc */
            record = FALSE;
            ey = fpop ();
            ex = fpop ();
            dmin = fpop ();
            curve2[5] = fpop ();
            curve2[4] = fpop ();
            curve2[3] = fpop ();
            curve2[2] = fpop ();
            curve2[1] = fpop ();
            curve2[0] = fpop ();
            curve1[5] = fpop ();
            curve1[4] = fpop ();
            curve1[3] = fpop ();
            curve1[2] = fpop ();
            curve1[1] = fpop ();
            curve1[0] = fpop ();
            y = fpop ();
            x = fpop ();

            status = flexproc (epx, epy, curve1, curve2, dmin);
            if (status)
                return (status);

#if 0 /* don't think this is needed - 5/15/93 - rs */
            minxy (ex, ey);
#endif

  /* TRY PUSHING ex and ey ONTO STACK FOR LATER USE BY t1e_SETCURPT 
   *  10-22-93 jfd 
   */
            curx = ex;
            cury = ey;
            fpush (ex); /* 10-22-93 jfd */
            fpush (ey); /* 10-22-93 jfd */
            break;

         case 0x01: /* begin-record */
            record = TRUE;
            epx = curx;
            epy = cury;
            break;

         case 0x02: /* Push current point */
            fpush (curx);
            fpush (cury);
            break;

         case 0x03: /* strlck or startlock */
            /* leave subr number on the stack */
            for (i = 0; i < (SW16)(arg & 0xffff) - 1; ++i)
                  fpopx ();

            break;

#if T1MMASTER
		case 14:
		case 15:
		case 16:
		case 17:
			blendn = num - 13;

			for (i = blendn, k = 0; i > 0; --i, ++k)
         {
				/* there are blendn sets of (Weightvals - 1) args on 
				   the stack, the first args are after all these  */

				firstarg = i * (gpps->Weightvals - 1) + k;

				bargs[0] = *(argsptr - firstarg - 1);
		
				for (j = 1; j < gpps->Weightvals; ++j) 
					bargs[j] = fpop ();

				blends[i] = blend (bargs);
			}

			for (i = 0; i < blendn; ++i)
				fpop ();

			for (i = 0; i < blendn; ++i)
				fpush (blends[i + 1]);

			break;
#endif /* T1MMASTER */

         default:
            for (i = 0; i < (SW16)(arg & 0xffff); ++i)
            fpopx ();
            break;
      }

   return (SUCCESS);
}

#if PST1_ROM

#if defined (ANSI_DEFS)
MLOCAL UW16 psrom_set_char (PBUCKET pxb, UW16 chId)
#else
MLOCAL UW16 psrom_set_char (pxb, chId)
PBUCKET  pxb;
UW16      chId;
#endif
/*
    7-27-93 jfd 
*/
{
LPSB8       char_name;
int       status;
LPSB8 p, p1;
LPSB8 pcharnam;
LPSB8 poff_tab, pchar_tab, penc_tab;
int tab_size;
register PPS_BUCK    pps;
int i;
int j;
#if (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)
#if !NO_SYMSET_MAPPING
UW16    cgnum;
#endif /* !NO_SYMSET_MAPPING */
UW16    mapidx;
#endif
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
 /* use PostScript font mapping */
PMEM_HANDLE pencodearray;
#endif
UB8  offsetb;
UW16 offset;
UL32 offsetl;
LPUL32 poffsetl;

   DBG ("psrom_set_char()\n");

    gpxb = pxb;
   gpps = pps = &pxb->p.ps;

      /*
         First get the name of this character from symbol set
      */
#if (USE_UFST_MAPPING == 2)
    if (pxb->cur_ssnum != T1ENCODING)
    {
#endif  /* USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)
#if !NO_SYMSET_MAPPING
    cgnum = SYMmap (chId, FC_PST1_TYPE);
    if (!cgnum)
    {
        DBG1 ("Unable to get cgnum for chId %d\n", chId);
        return (ERR_no_cgnum);
    }
    mapidx = cm_cgidToIndex (cgnum);
    if (!mapidx)
    {
        DBG1 ("Unable to get map index for cgnum %d\n", cgnum);
        return (ERR_psi_cg2idx);
    }
   char_name = PSdata[mapidx];
#else
   char_name = if_state.PSchar_name;
#endif  /* !NO_SYMSET_MAPPING */
    if (!char_name)
    {
        DBG1 ("Unable to get PS name for map index %d\n", mapidx);
        return (ERR_psi_idx2psname);
    }

#endif  /* (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2) */

#if (USE_UFST_MAPPING == 2)
    }
    else
    {
#endif  /* USE_UFST_MAPPING == 2 */

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)

#if !NO_SYMSET_MAPPING
      /* use mapping from PostScript font */
      if (pps->hencodearray)
      {
         penc_tab = (LPSB8)pxb->cur_font_hdr + (UL32)pps->hencodearray; /* start of enc array mapping */

         i = *(LPSW16)(penc_tab + (chId * sizeof(SW16)));         /* index into charname offsets */

         p = (LPSB8)&i; /*AM29K*/
         WSWAP

         if (i == 0xFFFF)
         { 
            gpxb = (NULL);
            gpps = (NULL);
            return (ERR_no_cgnum);  /* char not found */
         }
      }
      else
      {
         char_name = stdencoding[chId];

      /*
         If this character is not defined in the symbol set, return an error
      */
         if (!char_name)
         {
            gpxb = (NULL);
            gpps = (NULL);
            return (ERR_no_cgnum);  /* char not in symbol set */
         }
      }
#else
      char_name = if_state.PSchar_name;

      /* use mapping from PostScript font */
      if (pps->hencodearray)
      {
         penc_tab = (LPSB8)pxb->cur_font_hdr + (UL32)pps->hencodearray; /* start of enc array mapping */
         for (j=0; j<256; j++)
         {
            i = *(LPSW16)(penc_tab + (j * sizeof(SW16)));         /* index into charname offsets */

            p = (LPSB8)&i; /*AM29K*/
            WSWAP

            if ((UW16)i != 0xFFFF)
            { 
               poffsetl = (LPUL32)(penc_tab + (UL32)(256 * sizeof(UW16)) + (UL32)(i * sizeof(UL32)));
               p = (LPSB8)poffsetl;
               LSWAP
               pcharnam = (LPUL32)(penc_tab + (UL32)(256 * sizeof(UW16)) + (UL32)(pps->n_chars * sizeof(UL32))
                  + (UL32)(*poffsetl));

               if (! (STRCMP(char_name, pcharnam)) )
               {
                  DBG1 ("\n Found character %s", pcharnam);
                  break;
               }
            }
         }
         if (j >= 256)
            char_name = NULL;
      }
      else
         char_name = NULL;

      /*
         If this character is not defined in the symbol set, return an error
      */
      if (!char_name)
      {
         gpxb = (NULL);
         gpps = (NULL);
         return (ERR_no_cgnum);  /* char not in symbol set */
      }
#endif /* !NO_SYMSET_MAPPING */
#endif /* !USE_UFST_MAPPING || USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 2)
     }
#endif /* USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 2)
      if (pxb->cur_ssnum != T1ENCODING)
      {
#endif  /* USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)

      /*
         Character is defined, search the charnames and get a ptr to it
      */

         poff_tab = p1 = (LPSB8)pxb->cur_font_hdr + pps->ocharnames;  /* offset table */

         if (Offset_Flags & LONG_CHARNAM_OFFSETS)
         {
         /* Charnames offsets table contains LONG entries. */

            tab_size = (pps->n_chars * sizeof(UL32));
         }
         else
         {
         /* Charnames offsets table contains WORD entries. */

            tab_size = (pps->n_chars * sizeof(UW16));
            tab_size += 3;
            tab_size &= ~3;  /* quad-align offset table size */
         }

         pchar_tab = poff_tab + tab_size;   /* char names data */

         for (i=0; i<pps->n_chars; i++)
         {
            if (Offset_Flags & LONG_CHARNAM_OFFSETS)
            {
            /* Charnames offsets table contains LONG entries. */

               offsetl = *(LPUL32)p1;
               p = (LPSB8)&offsetl;  /*AM29K*/
               LSWAP
               pcharnam = pchar_tab + offsetl;    /* individual char name */
            }
            else
            {
            /* Charnames offsets table contains WORD entries. */

               offset = *(LPUW16)p1;
               p = (LPSB8)&offset; /*AM29K*/
               WSWAP
               pcharnam = pchar_tab + offset;    /* individual char name */
            }

            if (! (STRCMP(char_name, pcharnam)) )
            {
               DBG1 ("\n Found character %s", pcharnam);
               break;
            }

            if (Offset_Flags & LONG_CHARNAM_OFFSETS)
               p1 += sizeof(UL32);
            else
               p1 += sizeof(UW16);
         }
#endif  /* (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2) */

#if (USE_UFST_MAPPING == 2)
      }
#endif /* USE_UFST_MAPPING == 2 */

      if (i < pps->n_chars)
      {
       /*
           Found character name in char names table.
           Get corresponding pointer to character data table.
       */
         poff_tab = p1 = (LPSB8)pxb->cur_font_hdr + (UL32)pps->hcharstrings; /* offset table */

         if (Offset_Flags & LONG_CHARSTR_OFFSETS)
         {
         /* Charnames offsets table contains LONG entries. */

            p = poff_tab + (i * sizeof(UL32));
            offsetl = *(LPUL32)p;

            p = (LPSB8)&offsetl; /*AM29K*/
            LSWAP

            tab_size = (pps->n_chars * sizeof(UL32));

            pps->pthis_charstring = poff_tab + tab_size + offsetl;
         }
         else
         {
         /* Charnames offsets table contains WORD entries. */

            p = poff_tab + (i * sizeof(UW16));
            offset = *(LPUW16)p;

            p = (LPSB8)&offset; /*AM29K*/
            WSWAP

            tab_size = (pps->n_chars * sizeof(UW16));
            tab_size += 3;
            tab_size &= ~3;  /* quad-align offset table size */

            pps->pthis_charstring = poff_tab + tab_size + offset;
         }

         gpxb = (NULL);
         gpps = (NULL);
         return (SUCCESS);
      }
      else
      {
         gpxb = (NULL);
         gpps = (NULL);
         return (ERR_no_cgnum);
      }
}

#endif  /* PST1_ROM */

#if defined (ANSI_DEFS)
GLOBAL UW16 psset_char (PBUCKET pxb, UW16 chId)
#else
GLOBAL UW16 psset_char (pxb, chId)
PBUCKET  pxb;
UW16      chId;
#endif
/*
NOTE: This scheme depends upon memory not moving between this call to
      'set_char()' and the followup call to 'make_gaso...()'.

03/20/92 - rs - Add support for PostScript PCLEO
*/
{
register PPS_BUCK    pps;
PCDATASTR   cptr, cend;
LPSB8       char_name;
int       status;
int i;

#if (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)
#if NO_SYMSET_MAPPING
VOID   *cgnum;
#else
UW16    cgnum;
#endif  /* NO_SYMSET_MAPPING */
UW16    mapidx;
#endif

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
 /* use PostScript font mapping */
PMEM_HANDLE pencodearray;
#endif

   DBG ("ps_set_char()\n");

    gpxb = pxb;
   gpps = pps = &pxb->p.ps;

#if PST1_ROM

    /* PS ROM font */

#if PS_PLUGINS || IF_PCLEOI
   /* make sure char_buf is pointing at the static buffer and not to a  */
   /* previous reference to a character in ROM (like a plugin.)         */
   /*                                            -ss,jfd,dbk 2/16/93    */

   if_state.char_buf = MEMptr (hchar_buf);
#endif

    if (pxb->rom_font & ROM_TYPE)
    {
#if ASIAN_ENCODING
       if (pxb->cur_ssnum == JIS || pxb->cur_ssnum == SHIFT_JIS
           || pxb->cur_ssnum == EUC || pxb->cur_ssnum == UNICODE
           || pxb->cur_ssnum == BIG5 || pxb->cur_ssnum == TCA
           || pxb->cur_ssnum == GB  || pxb->cur_ssnum == KSC)
       {
          return (ps0set_char (chId));
       }
       else
#endif /* ASIAN_ENCODING */
       return (psrom_set_char (pxb, chId));
    }

#endif  /* PST1_ROM */
#if PST1_PCLEOI
    /*
        Ifthis is an external (PCLEO) font, have it loaded by the special
        PS PCLEO loader.
    */

#if (ROM && PS_PLUGINS) || IF_PCLEOI
   /* make sure char_buf is pointing at the static buffer and not to a  */
   /* previous reference to a character in ROM (like a plugin.)         */
   /*                                            -ss,jfd,dbk 2/16/93    */

   if_state.char_buf = MEMptr (hchar_buf);
#endif

    if (pxb->extern_font)
    {   /* PS PCLEO */
#if !MULTICALLER        /* mby, 10/26/93 */
        pps->pthis_charstring = PCLchId2ptr (chId);
#else   /* Multicaller is enabled */
        pps->pthis_charstring = PCLchId2ptr (uLastCallerId, chId);
#endif  /* MULTICALLER */
      if (!pps->pthis_charstring)
      {
         DBG("Could not find PS PCLEO character data\n");
         return (ERR_psi_pcleo_nodata);
      }
      return (SUCCESS);
    }
    else    /* not PCLEO, disk based PS font */
#endif /* PST1_PCLEOI */
#if PST1_SFNTI
    /*
        Ifthis is an external (generic downloaded) soft font, have it
        loaded by the application's type 1 soft font loader.
    */

#if (ROM && PS_PLUGINS) || IF_PCLEOI
   /* make sure char_buf is pointing at the static buffer and not to a  */
   /* previous reference to a character in ROM (like a plugin.)         */
   /*                                            -ss,jfd,dbk 2/16/93    */

   if_state.char_buf = MEMptr (hchar_buf);
#endif

    if (pxb->extern_font)
    {   /* PS type 1 downloaded soft font */
#if !MULTICALLER        /* mby, 10/26/93 */
        pps->pthis_charstring = PCLchId2ptr (chId);
#else   /* Multicaller is enabled */
        pps->pthis_charstring = PCLchId2ptr (uLastCallerId, chId);
#endif  /* MULTICALLER */
      if (!pps->pthis_charstring)
      {
         DBG("Could not find PS PCLEO character data\n");
         return (ERR_psi_pcleo_nodata);
      }
      return (SUCCESS);
    }
    else    /* not PCLEO, disk based PS font */
#endif /* PST1_SFNTI */
#if ASIAN_ENCODING
   if (pxb->cur_ssnum == JIS || pxb->cur_ssnum == SHIFT_JIS
           || pxb->cur_ssnum == EUC || pxb->cur_ssnum == UNICODE
           || pxb->cur_ssnum == BIG5 || pxb->cur_ssnum == TCA
           || pxb->cur_ssnum == GB  || pxb->cur_ssnum == KSC)
   {
       return (ps0set_char (chId));
   }
   else
#endif /* ASIAN_ENCODING */
   {
      /*
         First get the name of this character from symbol set
      */
#if (USE_UFST_MAPPING == 2)
    if (pxb->cur_ssnum != T1ENCODING)
    {
#endif  /* USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2)
#if NO_SYMSET_MAPPING
    cgnum = if_state.PSchar_name;
#else
    cgnum = SYMmap (chId, FC_PST1_TYPE);
#endif  /* NO_SYMSET_MAPPING */
    if (!cgnum)
    {
        DBG1 ("Unable to get cgnum for chId %d\n", chId);
        return (ERR_no_cgnum);
    }
#if !NO_SYMSET_MAPPING
    mapidx = cm_cgidToIndex (cgnum);
    if (!mapidx)
    {
        DBG1 ("Unable to get map index for cgnum %d\n", cgnum);
        return (ERR_psi_cg2idx);
    }
   char_name = PSdata[mapidx];
    if (!char_name)
    {
        DBG1 ("Unable to get PS name for map index %d\n", mapidx);
        return (ERR_psi_idx2psname);
    }
#else
   char_name = if_state.PSchar_name;
#endif  /* !NO_SYMSET_MAPPING */

#endif  /* (USE_UFST_MAPPING == 1) || (USE_UFST_MAPPING == 2) */

#if (USE_UFST_MAPPING == 2)
    }
    else
    {
#endif  /* USE_UFST_MAPPING == 2 */

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)

#if !NO_SYMSET_MAPPING

      /* use mapping from PostScript font */
      if (pps->hencodearray)
      {
         pencodearray = (PMEM_HANDLE)MEMptr (pps->hencodearray);
         if (!pencodearray[chId])
            char_name = NULL;
         else char_name = (LPSB8)MEMptr (pencodearray[chId]);
      }
      else
         char_name = stdencoding[chId];
#else
      char_name = if_state.PSchar_name;

      /* use mapping from PostScript font */
      if (pps->hencodearray)
      {
         pencodearray = (PMEM_HANDLE)MEMptr (pps->hencodearray);
         for (i=0; i<256; i++)
         {
            if (!STRCMP ((LPSB8)MEMptr (pencodearray[i]), char_name))
            {
               chId = i;
               break;
            }
         }
         if (i >= pps->n_chars)
            char_name = NULL;
      }
      else
         char_name = NULL;
#endif  /* !NO_SYMSET_MAPPING */

      /*
         If this character is not defined in the symbol set, return an error
      */
      if (!char_name)
       {
           gpxb = (NULL);
           gpps = (NULL);
           return (ERR_no_cgnum);  /* char not in symbol set */
       }
#endif /* !USE_UFST_MAPPING || USE_UFST_MAPPING == 2 */

#if (USE_UFST_MAPPING == 2)
     }
#endif /* USE_UFST_MAPPING == 2 */

      /*
         Character is defined, search the charstrings and get a ptr to it
      */

      cend =(PCDATASTR)MEMptr (pps->hcharstrings) + pps->n_chars;
      for (cptr = (PCDATASTR)MEMptr (pps->hcharstrings); cptr < cend; ++cptr)
      {
         /*
            add 5/1/92 - 2 line fix for Sparc crash w/ext mem - rs
         */
         if (cptr->hname == NIL_MH)
            break;
         if (!STRCMP ((LPSB8)MEMptr (cptr->hname), char_name))
         {
            pps->pthis_charstring = cptr;
               gpxb = (NULL);
           gpps = (NULL);
            return (SUCCESS);
         }
      } /* for (cptr = ...) */

       /*
           Character is not in charstrings, see if it has not been loaded yet...
       */
       if (pps->curr_char < pps->n_chars)
      {
           status = more_charstrings (char_name, 1);
       gpxb = (NULL);
           gpps = (NULL);
         return (status);
      }
      else
      {
       gpxb = (NULL);
           gpps = (NULL);
         return (ERR_no_cgnum);
      }
   } /* else (pxb->extern_font) */
}


#if defined (ANSI_DEFS)
GLOBAL UW16 psmake_gaso_and_stats (PBUCKET pxb, PCHAR_STATS pcs)
#else
GLOBAL UW16 psmake_gaso_and_stats (pxb, pcs)
PBUCKET     pxb;
PCHAR_STATS pcs;
#endif
{
int status;

   DBG ("psmake_gaso_and_stats()\n");

   gpxb = pxb;    /* ptr to XBUCKET */
   gpps = &pxb->p.ps;   /* ptr to PS specific info in bucket */
   gpcs = pcs;    /* ptr to CHAR_STATS */

   /* reset counters */
   gpcs->ct_lineto = gpcs->ct_quadto = gpcs->ct_cubeto = 0;

   status = type1char (gpps->pthis_charstring, 0);
   if(status)
      return status;

   gpxb = (PBUCKET)0;
   gpps = (PPS_BUCK)0;
   gpcs = (PCHAR_STATS)0;
   return (status);
}

#if INTR_SIZE == 16
#define rs(v)    (INTR)((v) >> if_state.right_shift)
#else
#define rs(v)    (INTR)v
#endif

#if defined (ANSI_DEFS)
GLOBAL UW16 psrender (PBUCKET pxb, INTR xt, INTR yt)
#else
GLOBAL UW16 psrender (pxb, xt, yt)
PBUCKET  pxb;
INTR xt, yt;
#endif
{
INTR  c0x, c0y, c1x, c1y;
INTR  px, py;
LPSB8 p;
LPSL32 cv;
UW16 loopct, npnt;
#if defined (DEBUG)
UW16 nbez;
#endif
UW16 polarity;

int status;

   DBG ("\npsrender()\n");

   /* Make certain that output format is valid for PS */

#if !LINEAR
   if (if_state.cs.format == FC_LINEAR_TYPE)
      return ERR_linear_not_installed;
#endif
#if !CUBIC
   if (if_state.cs.format == FC_CUBIC_TYPE)
      return ERR_cubic_not_installed;
#endif
   if (if_state.cs.format == FC_QUAD_TYPE)
      return ERRinvalid_outproc_type;

   status = if_state.out.start_char ((PVOID)&if_state.cs);  /* 6-8-92 */
   if (status)
      return (status);

   /*
      Point to start of 1st loop
   */
   cv = (LPSL32)(if_state.char_buf);    /* XY coordinates */
   p =
        (LPSB8)((((SL32)if_state.char_buf + CHARBUFSIZE) >> 1) << 1);

   DBG1 ("%d loops\n", if_state.num_loops);
   for(loopct = 0; loopct < if_state.num_loops; loopct++)
   {
      /*
         Set up for next loop ->

           Type 1 input contains bezier data in character buffer.
         The XY coordinates begin at 'if_state.char_buf' and work
         upward. At the top of the buffer, (char_buf+CHARBUFSIZ-2),
         is the remainder of the data working downward. First, 'npnt'
         equals the number of vertex codes. This is followed by 'nbez'
         OR'd with the polarity. 'nbez' is the number of curves in the
         contour.
           Each curve has 1 SL32VECTOR accounted for in 'npnt' plus
           2 additional SL32VECTOR's accounted for in 'nbez'.
      */
      DBG("N e x t    L o o p\n");

      p = (LPSB8)(((SL32)p >> 1) << 1);  /* align to SW16 boundary */
       p -= sizeof(SW16);
      npnt     = *(LPSW16)p;        /* # of segments in this loop */
       p -= sizeof(SW16);
      polarity = (*(LPUW16)p & 0x8000) ? 1 : 0;
#if defined (DEBUG)
      nbez = *(LPSW16)p & 0x7fff;   /* # of cubic beziers in this loop */
      DBG3 ("npnt:%d nbez:%d polarity:%d\n", npnt, nbez, polarity);
#endif
      p--;  /* point to 1st vertex code in loop */

      status = if_state.out.start_loop (polarity);
      if (status)
         return (status);

      /*
         Starting coord of loop
      */
      p0x = rs(*cv++ + xt);
      p0y = rs(*cv++ + yt);
#if INTR_SIZE == 16
      DBG2 ("moveto:%d %d\n", p0x, p0y);
#else
      DBG2 ("moveto:%ld %ld\n", p0x, p0y);
#endif
      status = if_state.out.moveto (p0x, p0y);
      if (status)
         return (status);

      /*
         Process each of the coords in this loop
      */
      while(npnt--)
      {
         if (!(*p--))        /* is this a cubic bezier? */
         {                          /*     yes    */
            DBG("vectorizing type 1 bezier\n");
                c0x = rs(*cv++ + xt);   /* 1st control point */
            c0y = rs(*cv++ + yt);
                c1x = rs(*cv++ + xt);   /* 2nd control point */
            c1y = rs(*cv++ + yt);
                px  = rs(*cv++ + xt);   /* end point */
            py  = rs(*cv++ + yt);
            /* Check for type of outline */

#if INTR_SIZE == 16
            DBG6 ("cubeto:%d %d %d %d %d %d\n", c0x, c0y, c1x, c1y, px, py);
#else
            DBG6 ("cubeto:%ld %ld %ld %ld %ld %ld\n", c0x, c0y, c1x, c1y, px, py);
#endif
            status = if_state.out.cubeto (c0x, c0y, c1x, c1y, px, py);
            if (status)
               return (status);

            p0x = px;
            p0y = py;

         } /* if (*p--)) */
         else  /* LINETO */
         {
                px = rs(*cv++ + xt);  /* end point */
            py = rs(*cv++ + yt);
#if INTR_SIZE == 16
            DBG2 ("lineto:%d %d\n", px, py);
#else
            DBG2 ("lineto:%ld %ld\n", px, py);
#endif
            status = if_state.out.lineto (px, py);
            if (status)
               return (status);
            p0x = px;
            p0y = py;
         }
      } /*  while(npnt--) */
      if_state.out.end_loop ();
   } /* for(loopct = 0;...) end of a loop */

   /*
      End of character
   */
   return if_state.out.end_char ();
}

#if WIDTHS
#if defined (ANSI_DEFS)
GLOBAL UW16 psget_width (PBUCKET pbuck)
#else
GLOBAL UW16 psget_width (pbuck)
PBUCKET pbuck;
#endif
/*
Get width (escapement) of a type 1 character

return (width) if no error, else (0)
*/
{
int status;
UW16 width;

   /*
      Set up global PostScript pointers for use by lower level functions
   */
   gpxb = pbuck;    /* ptr to XBUCKET */
   gpps = &pbuck->p.ps;   /* ptr to PS specific info in bucket */
   gpcs = &if_state.cs;    /* ptr to CHAR_STATS */

   status = type1char (gpps->pthis_charstring, 1);
   width = (UW16)gpcs->escapement;

#if !DU_ESCAPEMENT
   /* Compensate for rounding when PS or TT is converted to 8782-based
      Multiply by TT or PS point size / Inteliifont point size
              = (1/72) / 0.01383 = 100,000/(72 * 1383)
              = 12500 / (9 * 1383) = 12500 / 12447     -ss,awr 8/20/92
   */
   if( if_state.pbucket->fst_type == FC_PST1_TYPE )
   {
      width       = (UW16)( (((SL32)width * 12500L) + 6223L) / 12447L );
      gpcs->escapement = width;
   }
#endif  /* !DU_ESCAPEMENT */

   /*
      Clear global PostScript pointers for error control
   */
   gpxb = (PBUCKET)0;
   gpps = (PPS_BUCK)0;
   gpcs = (PCHAR_STATS)0;

   if (status)
      return 0;  /* error */
   else
      return (width);
}
#endif /* WIDTHS */

#if PST1_ROM

#if defined (ANSI_DEFS)
GLOBAL UW16 PSROMload_font (LPUB8 ph)
#else
GLOBAL UW16 PSROMload_font (ph)
LPUB8  ph;
#endif
/*
Load a PostScript Type 1 ROM font

load the PostScript specific 'global data' into our bucket
bucket should be initialized prior to getting here (ie 0's)

global values:
	gpxb = ptr to our bucket
	gpps = ptr to our PS specific bucket

return (SUCCESS), else error code
*/
{
PBUCKET     pxb;
PPS_BUCK    pps;
LPUB8  quad_aligned_p;
int i, k;
int FontMatrixLen;
register SW16 bluefuzz;
SW16 nBlues;
SW16 blues[MAXBLUES];
SW16 other_blues[MAXOTHERBLUES];
SW16 nOtherBlues;
SW16 nFamilyBlues;
SW16 nFamilyOtherBlues;
LPUB8 ps;
UL32 temp;  /* 2-1-94 */

	DBG ("\nPSROMload_font()\n");

	pxb = gpxb;
	pps = gpps;

   /* Load PS_BUCK with contents of PS ROM block */

   ps = (LPUB8)ph;
   ps += 2;                /* Font_Format */

   ps += 2;                /* Reserved1 */

   Offset_Flags = *(LPUL32)ps;     /* Flags */
   p = (LPUB8)&Offset_Flags;
   LSWAP                  /* Flags */
   ps += 4;

   ps += 4;               /* Reserved2 */

#if ASIAN_ENCODING   /* 3-1-94 jfd */
   gpps->hCODarray = *(LPUL32)ps;
   p = (LPUB8)&gpps->hCODarray;
   LSWAP
   ps += 4;               /* CODarray_Offset */

   gpps->hCOD_Offset = *(LPUL32)ps;
   p = (LPUB8)&gpps->hCOD_Offset;
   LSWAP
   ps += 4;               /* COD_Offset */

   gpps->hCSA_Offset = *(LPUL32)ps;
   p = (LPUB8)&gpps->hCSA_Offset;
   LSWAP
   ps += 4;               /* CSA_Offset */
#endif               /* 3-1-94 jfd */

   gpps->nsubs = *(LPUW16)ps;
   p = (LPUB8)&gpps->nsubs;
   WSWAP
   ps += 2;
   
   gpps->n_chars = *(LPUW16)ps;
   p = (LPUB8)&gpps->n_chars;
   WSWAP
   ps += 2;

   temp = *(LPUL32)((MEM_HANDLE)ps);
   gpps->hsubrs = (MEM_HANDLE)temp;
   p = (LPUB8)&gpps->hsubrs;
   LSWAP
   ps += 4;

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)  /* 2-1-94 */
   temp = *(LPUL32)((MEM_HANDLE)ps);
   gpps->hencodearray = (MEM_HANDLE)temp;
   p = (LPUB8)&gpps->hencodearray;
   LSWAP
   ps += 4;
#endif

   gpps->ocharnames = *(LPUL32)ps;
   p = (LPUB8)&gpps->ocharnames;
   LSWAP
   ps += 4;

   temp = *(LPUL32)((MEM_HANDLE)ps);
   gpps->hcharstrings = (MEM_HANDLE)temp;
   p = (LPUB8)&gpps->hcharstrings;
   LSWAP
   ps += 4;

   FontMatrixLen = 0;
   quad_aligned_p = ps;
   for (i=0; i<6; i++)
   {
      gpps->fontmatrix[i] = fpatof((LPSB8)ps); /*AM29K*/
      k = strlen((LPSB8)ps) + 1;   /*AM29K*/
      FontMatrixLen += k;
      ps += k;
   }
   FontMatrixLen += 3;
   FontMatrixLen &= ~3;   /* quad-align */
   ps = (LPUB8)(quad_aligned_p + FontMatrixLen);

   ps += 4;               /* UniqueID */


   gpps->iBlueScale = *(LPUL32)ps;
   p = (LPUB8)&gpps->iBlueScale;
   LSWAP
   ps += 4;

   ps += 2;               /* weight */

   ps += 2;               /* ItalicAngle */

   ps += 2;               /* isFixedPitch */

   ps += 2;               /* UnderLinePosition */

   ps += 2;               /* UnderLineThickness */

   ps += 2;               /* FontType */

   for (i=0; i<4; i++)
   {
      ps += 2;            /* FontBBox[i] */
   }

   nBlues = *(LPUW16)ps;
   p = (LPUB8)&nBlues;
   WSWAP
   ps += 2;

   for (i=0; i<nBlues; i++)
   {
      blues[i] = *(LPUW16)ps;
      p = (LPUB8)&blues[i];
      WSWAP
      ps += 2;
   }

   nOtherBlues = *(LPUW16)ps;
   p = (LPUB8)&nOtherBlues;
   WSWAP
   ps += 2;

   for (i=0; i<nOtherBlues; i++)
   {
      other_blues[i] = *(LPUW16)ps;
      p = (LPUB8)&other_blues[i];
      WSWAP
      ps += 2;
   }

   nFamilyBlues = *(LPUW16)ps;
   p = (LPUB8)&nFamilyBlues;
   WSWAP
   ps += 2;

   for (i=0; i<nFamilyBlues; i++)
   {
      ps += 2;               /* FamilyBlues[i] */
   }

   nFamilyOtherBlues = *(LPUW16)ps;
   p = (LPUB8)&nFamilyOtherBlues;
   WSWAP
   ps += 2;

   for (i=0; i<nFamilyOtherBlues; i++)
   {
      ps += 2;               /* FamilyOtherBlues[i] */
   }

   gpps->iBlueShift = *(LPUW16)ps;
   p = (LPUB8)&gpps->iBlueShift;
   WSWAP
   ps += 2;

   gpps->BlueFuzz = *(LPUW16)ps;
   p = (LPUB8)&gpps->BlueFuzz;
   WSWAP
   ps += 2;


   /* Now store top and bottom blue values from blues saved earlier */

   bluefuzz = gpps->BlueFuzz;
	gpps->numbblues = gpps->numtblues = 0;

   for (i = 0; i < nBlues; i++)
   {
      if (i < 2)
        gpps->bot_blues[gpps->numbblues++] = blues[i] - bluefuzz;
      else
        gpps->top_blues[gpps->numtblues++] = blues[i] - bluefuzz;
      bluefuzz = -bluefuzz;
   }

   /* Now store other blue values from those saved earlier */

   bluefuzz = gpps->BlueFuzz;

   for (i = 0; i < nOtherBlues; i++)
   {
      pps->bot_blues[gpps->numbblues++] = other_blues[i] - bluefuzz;
      bluefuzz = -bluefuzz;
   }

   gpps->inStdHW = *(LPUW16)ps;   /* ???? */
   p = (LPUB8)&gpps->inStdHW;
   WSWAP
   ps += 2;

   gpps->inStdVW = *(LPUW16)ps;   /* ???? */
   p = (LPUB8)&gpps->inStdVW;
   WSWAP
   ps += 2;

   gpps->numStemSnapH = *(LPUW16)ps;
   p = (LPUB8)&gpps->numStemSnapH;
   WSWAP
   ps += 2;

   for (i=0; i<gpps->numStemSnapH; i++)
   {
      gpps->StemSnapH[i] = *(LPUW16)ps;
      p = (LPUB8)&gpps->StemSnapH[i];
      WSWAP
      ps += 2;
   }

   gpps->numStemSnapV = *(LPUW16)ps;
   p = (LPUB8)&gpps->numStemSnapV;
   WSWAP
   ps += 2;

   for (i=0; i<gpps->numStemSnapV; i++)
   {
      gpps->StemSnapV[i] = *(LPUW16)ps;
      p = (LPUB8)&gpps->StemSnapV[i];
      WSWAP
      ps += 2;
   }

   ps += 2;               /* ForceBold */

   ps += 2;               /* LanguageGroup */

   gpps->lenIV = *(LPUW16)ps;
   p = (LPUB8)&gpps->lenIV;
   WSWAP
   ps += 2;

   return SUCCESS;
}
#endif  /* PST1_ROM */
#else
int iT1IDECOD=0;
#endif /* PST1_RDR */
