/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1ihints.c,v 1.2 2003/05/07 23:02:25 Lann Exp $ */
/* $Log: t1ihints.c,v $
/* Revision 1.2  2003/05/07 23:02:25  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.22   05 Sep 1995 08:07:08   JOE
 * In flexproc(), fixed snapping problem for 90 degree rotation.
 * (by awr/dbk).
 * 
 *    Rev 1.21   07 Apr 1995 10:27:16   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.20   14 Dec 1994 15:33:30   JOE
 * Changed all references of "origin.x" and "origin.y" to "origin_cs.x"
 * and "origin_cs.y" due to change in field name of structure.
 * 
 *    Rev 1.19   22 Apr 1994 14:45:48   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.18   09 Feb 1994 14:03:54   JOE
 * 
 * Changed arg 2 of function prototype for sort() from SW16 to int
 * to resolve _AM29K compiler error.
 * 
 *    Rev 1.17   08 Dec 1993 18:57:42   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.16   20 Oct 1993 11:07:42   JOE
 * 
 * In t1closepath(), t1moveto(), t1lineto() and t1curveto(), if NON_Z_WIND
 * is enabled, check if it is being selected before executing NON_Z_WIND
 * code.
 * 
 *    Rev 1.15   15 Oct 1993 10:47:16   JOE
 * In t1startchar(), using fontmatrix value instead of hard-wiring "1000"
 * when storing em box size if DU_ESCAPEMENT.
 * 
 *    Rev 1.14   14 Oct 1993 15:01:54   JOE
 * 
 * In t1startchar(), using fontmatrix value instead of hard-wiring "1000"
 * when calculating escapement.
 * 
 *    Rev 1.13   08 Oct 1993 16:05:08   JOE
 * PostScript non-zero winding support.
 * 
 *    Rev 1.12   26 Jul 1993 11:48:52   ROB
 * Change 'xnum' & 'ynum' from SW16 to int.
 * 
 *    Rev 1.11   21 Jun 1993 12:50:08   ROB
 * Incorporate Pipeline update to improve flattening of round characters.
 * 
 *    Rev 1.10   15 Jun 1993 11:01:34   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * Set "iT1IHINTS" to 0 if !PST1_RDR because of ANSI requirements.
 * 
 *    Rev 1.9   08 Jun 1993 18:04:18   ROB
 * Pipeline upgrade for type 1 quality improvements & multimaster support.
 * 
 *    Rev 1.8   03 May 1993 10:23:08   ROB
 * Modify 'bluescale()' to accept SL32 instead of SW16.
 * 
 *    Rev 1.7   31 Mar 1993 09:50:46   ROB
 * Fix nested comment warning.
 * 
 *    Rev 1.6   03 Mar 1993 19:20:58   ROB
 * Add 'stemsnaph()' & 'stemsnapv()' for processing stem hints.
 * 
 *    Rev 1.5   12 Feb 1993 15:52:00   JOE
 * VXWorks support.
 * 
 *    Rev 1.4   29 Jan 1993 09:36:50   JOE
 * In t1startchar(), saved em box size and escapement in either native
 * design units or 8782's based on DU_ESCAPEMENT.
 * 
 *    Rev 1.3   07 Jan 1993 15:35:04   JOE
 * Corrected argument list in ANSI function declaration for flexproc().
 * 
 *    Rev 1.2   07 Jan 1993 09:40:02   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 10:00:26   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:26   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:25 $ */
/* t1ihints.c */
/***********************************************************************
 *                                                                      *
 *
 *
 *       Copyright (c) 1989, 1990, and 1991 by                          *
 *       Pipeline Associates, Inc., Morris Plains, NJ                   *
 *          All rights reserved.                                        *
 *                                                                      *
 *   This software is furnished under a license and may be used and     *
 *   copied  only  in accordance with the terms of such license and     *
 *   with the  inclusion  of  the  above  copyright  notice.   This     *
 *   software  or  any  other copies thereof may not be provided or     *
 *   otherwise made available to any other person except as allowed     *
 *   under   license.  No  title to and ownership of the software is    *
 *   hereby transferred.                                                *
 *                                                                      *
 *   This software is proprietary to Pipeline Associates, Inc., and     *
 *   is not to be disclosed without written permission from Pipeline    *
 *   Associates, Inc.                                                   *
 *                                                                      *
 ************************************************************************/
 /***********************************************************************
 *									*
 *		  Copyright (c) 1989, 1990, 1991, 1992 by		*
 *		Pipeline Associates, Inc., Morris Plains, NJ		*
 *			   All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person except as allowed	*
 *   under   license.  No  title to and ownership of the software is	*
 *   hereby transferred.						*
 *									*
 *   This software is proprietary to Pipeline Associates, Inc., and	*
 *   is not to be disclosed without written permission from Pipeline	*
 *   Associates, Inc.							*
 *									*
 ************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
pre-historic    Version 1.0 -- original
pre-historic    Version 1.1 -- minor cleanups
pre-historic    Version 1.2 -- stem adjustments added
pre-historic    Version 1.3 -- got rid of split_bez, optimized Subdivide
pre-historic    Version 1.4 -- added overshoot control
pre-historic    Version 1.5 -- added hooks for new scanner
pre-historic    Version 1.6 -- optionally uses BlueScale and BlueShift
09/27/91  rs    Original file created from Pipeline Associates 't1hints.c'
10/15/91  rs    Adapt interface to 'raster()'. First version, use entire
                    char_buf + expand_buf for storing MT, LT & CT.
10/28/91  rs    Modify VOID Subdivide() to UWORD for interface with raster().
11/01/91  rs    Init 'numbblues', 'numtblues' & 'trans' = 0 at compile.
11/19/91  rs    Add high water marks for working buffer overflow control:
                    'pv_hwm' & 'pxy_hwm'.
11/20/91  rs    Change calls to 'raster()' & 'fill()' for 'bold_buf2'.
12/06/91  rs   Change names of 'stdhw()' & 'stdvw()' to 'stdhwx()' &
               'stdvwx()' because there were no global vars declared for
               'StdHW' & 'StdVW'. Compiler was causing funcs to be modified.
               Add the global vars here.
01/22/92  rs   Modify Subdivide() to call 'ras_lineto()' directly, doesn't
               take ptr to vector array any more.
01/27/92  rs   Transform char origin for char_stats in 't1startchar()'.
01/29/92  rs   Clean up error return codes.
02/06/92  rs   Fixed origin in t1startchar() and fixed sort_hints() if
               no hints available.
02/24/92  jfd  In hstem(), cast 3rd arg in stemadj() calls to LONG.
02/25/92  rs   Integrate changes for 'vstem()' from Pipeline to eliminate
               duplicate hints.
03/17/92  rs   Cleanup of 'invalid assigns'.
03/23/92  ss   Fixed casts.
               Added define for "const", a key word which doesn't exist on SUN.
04/03/92  rs   Portability cleanup (see port.h).
04/08/92  rs   Init 'CHAR_STATS' struct in 't1startchar()' to set 
               'gpcs->ct_loop' = 0. This allows handling of space char, etc.
               Modify 't1endchar()' to copy 'if_state.num_loops' to
               'gpcs->ct_loop' and set bbox = (0,0,0,0) if 0 contours.
04/22/92  rs   Incorporate Pipeline fix for hint (Palatino) problem. Modify
               'hstem()' & 'sort_hints()', add new function 'order_hints()'.
05/07/92  jfd  In hstem(), cast certain variables to SL32 in statements
               involving stemadj() calls and T1SIGN.
05/29/92  jfd  The following name changes were made to fields which had
               belonged to the old CHAR_STATS structure and which are now
               a part of the new CHAR_STATS which combines parts of OLSTATS
               and parts of CHAR_STATS:
                  ct_loop --> nloop
                  x0_pix  --> xscale
                  y0_pix  --> yscale
06/01/92  jfd  In t1startchar(), when storing "gpcs->escapement", cast value
               as a SW16.
06/02/92  jfd  Added EXTERN olstats (used by outline functions).
               Wherever "gpcs->" stores a value, store the same value in
               "olstats.".
6/08/92   jfd  Removed all references to "olstats".
6/09/92   jfd  In t1startchar(), initialize "gpcs->dorigin" to 0.
6/10/92   jfd  In t1endchar(), load "gpcs->xscale" and "gpcs->yscale" with
               "if_state.x.pixel_size" and "if_state.y.pixel_size".
6/29/92   awr  Changed t1endchar() to return pixel size in char stats
          jfd  Changed all occurrences of INTR to SL32 (except in
               Subdivide().
1 Jul 92  ss   Moved port.h to top to access defines earlier.
               Conditionally compile stdlib for !MIPS.  This may also be
               relevant for other UNIX SysV systems.
9 Jul 92  jfd  In t1closepath(), when checking for overflow of expansion
               buffer, cast result of first operand as LPSL32 to prevent
               incorrect calculation.
19-Jul-92 awr  Removed Subdivide()
20-Jul-92 rs   Fix char_stat count of cubic bezier curves in 't1closepath()'.
21-Jul-92 awr  Conditional compile changes.
08-Aug-92 rs    Changed SW16 arg in hstem(), hstem6(), vstem() & vstem6()
                    from SW16 to int. Fatal error in Watcom C386.
                    Change proto for QSORT to look like unix for Watcom.
10-Aug-92 jfd  In t1closepath(), t1lineto() and t1curveto(), corrected
               invalid error return (ERR_psi_wkbuf_ovflow) when checking
               for overflow of expansion buffer.
               Changed MAXT1SEGS from 128 to 144.
13-Aug-92 rs    Fix problem in 'cmp_int()' on Sparc.
20-Aug-92 jfd  In t1startchar(), rounded escapement to nearest unit.
30-Aug-92 rs   Optimization of work buffer usage for building gaso's.
22-Nov-92 rs   Port to Macintosh - proto of blue_values() & other_bules() to int.
07-Jan-93 jfd  ANSI C function declaration changes.
               Order of arguments was incorrect in ANSI function declaration
               of flexproc().
25-Jan-93 jfd  In t1startchar(), store em box size and escapement based on
               DU_ESCAPEMENT.
08-Feb-93 jfd  VXWorks support.
02-Mar-93 rs   Add 'stemsnaph()' & 'stemsnapv()'.
30-Mar-93 rs   Fix nested comment in 't1startchar()'.
30-Apr-93 rs   Modify 'bluescale()' to accept SL32 argument instead of SW16.
Version 1.7 -- moved Nimbus Q and filling stuff to t1fill.c
Version 1.8 -- parameterized size of hints and coords arrays
             -- turned off call to inithints() in t1hintrep()
             -- moved t1curve to t1fill.c
Version 1.9 -- folded into PowerPage
Version 1.9.2 -- added BlueFuzz, changed reference line handling
Version 2.0 -- added filltype to handle even-odd or nonzero-winding fill
Version 2.1 -- process overlapping hints
Version 2.2.1 -- fixed hole filling above char max
Version 2.2.1 -- fixed bug in flexproc for rotated characters
Version 3.0  -- added handling of WeightVector array for MM fonts
1/23/92 (PHW) -- added SIGN computation to overshoot tests in hstem
2/11/92 (PHW) -- fixed ordering of hints in hstem
4/14/92 (PHW) -- minor adjustment to flexproc
5/9/92 (PHW) -- made min and max values global
5/27/92 (PHW) -- added a CLOSEPATH point type
7/5/92 (PHW) -- added WeightVector for MM fonts
9/2/92  (PHW) -- added path closing code to t1makechar; needed for TrueType
9/15/92  (PHW) -- changed fprintf to debug
13-May-93 rs   Integrate upgrade from Pipeline.
Version 3.2.1  -- changed overshoot handling
24-May-93 rs   Integrate '3.2.1' changes from Pipeline.
15-Jun-93 jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
               Set "iT1IHINTS" to 0 if !PST1_RDR because of ANSI requirements.
18-Jun-93 rs   Incorporate Pipeline upgrade '6/14/93' to address the problem
               of flattening round characters.
23-Jul-93 rs   Change 'xnum' & 'ynum' from SW16 to int.
08-Oct-93 jfd  PostScript non-zero winding support. The following functions
               have been modified: t1startchar(), t1closepath(), t1moveto(),
               t1lineto() and t1curveto().
14-Oct-93 jfd  In t1startchar(), using fontmatrix value instead of hard-wiring
               "1000" when calculating escapement.
15-Oct-93 jfd  In t1startchar(), using fontmatrix value instead of hard-wiring
               "1000" when storing em box size if DU_ESCAPEMENT.
20-Oct-93 jfd  In t1closepath(), t1moveto(), t1lineto() and t1curveto(), if
               NON_Z_WIND is enabled, check if it is being selected before
               executing NON_Z_WIND code.
08-Dec-93 rs   General cleanup - MSDOS & FLAT -> CGFLAT32.
07-Feb-94 jfd  Changed arg 2 of function prototype for sort() from SW16 to int
               to resolve _AM29K compiler error.
14-Dec-94 jfd  Changed all references to "origin.x" and "origin.y" to
               "origin_cs.x" and "origin_cs.y" due to change in field name
               of structure.
05-Sep-95 awr/dbk In flexproc(), fixed snapping problem for 90 degree rotation.
*/

#include "cgconfig.h"

#if PST1_RDR    /* conditional compile entire module */ 

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>

#ifndef MIPS
#include <stdlib.h> /* 'qsort()' */
#endif

#include <string.h> /* 'memset()' */
#include "debug.h"

/*
May not need all of the following group, but better check...
*/
#include "ifmem.h"  /* MEM_HANDLE */
#include "mixmodel.h"
#include "cgif.h"       /* DLL */
#include "ix.h"     /* CHARBUFSIZE */
#include "if_type.h"
#include "cache.h"  /* CHARalloc() */
#include "bitmap.h"
/*
End of "the group"
*/

#include "fpmath.h"
#include "t1itype1.h"
#include "t1iproto.h"



#ifdef LINT_ARGS

#if defined(MSDOS) && !defined(CGFLAT32)
#if (defined(M_I86SM)||defined(M_I86MM)||defined(M_I86TM)||defined(_WINDOWS))
#ifdef _WINDOWS
EXTERN VOID far pascal _fqsort(LPSB8, UW16, UW16,
   int(*)(PVOID, PVOID));
#else /* not _WINDOWS */
EXTERN VOID _fqsort(LPSB8, UW16, UW16, int(*)(PVOID, PVOID));
#endif /* _WINDOWS */
#endif /* not smaller or WINDOWS */
#endif /* MSDOS */

EXTERN VOID transfn8 (SL32, SL32, LPSL32, LPSL32);

MLOCAL int t1toprefline (SL32);
MLOCAL int t1botrefline (SL32);
MLOCAL VOID sort_hints (VOID);
MLOCAL VOID sort (PT1I_HINT_STR, int); /* 2-7-94 jfd */
#ifdef __WATCOMC__
MLOCAL int  cmp_int (const void *, const void *);
#else
MLOCAL int  cmp_int (LPSL32, LPSL32); /* LPSW16 to LPSL32 - 12/16/91 - rs */
#endif /* __WATCOMC__ */
MLOCAL SL32 xstemadj (SL32 left, SL32 right);
MLOCAL SL32 ystemadj (SL32 left, SL32 right);
MLOCAL int addyhint (SL32, SL32);
MLOCAL VOID order_hints (PT1I_HINT_STR, int);

GLOBAL int inithints (VOID);
GLOBAL int t1startchar (SL32, SL32, SL32);
GLOBAL int vstem (SL32, SL32);
GLOBAL int hstem (SL32, SL32);
GLOBAL int vstem6 (LPSL32);
GLOBAL int hstem6 (LPSL32);
GLOBAL int t1endchar (VOID);
GLOBAL int t1closepath (VOID);
GLOBAL int t1moveto (SL32, SL32);
GLOBAL int t1lineto (SL32, SL32);
GLOBAL int t1curveto (SL32, SL32, SL32, SL32, SL32, SL32);
GLOBAL int flexproc (SL32, SL32, LPSL32, LPSL32, SL32);
GLOBAL VOID  blue_values (LPSW16, int);
GLOBAL VOID other_blues (LPSW16, int);
GLOBAL VOID stdhwx (SW16);
GLOBAL VOID stdvwx (SW16);
GLOBAL VOID blueshift (SL32);
GLOBAL VOID bluescale (SL32);
GLOBAL VOID stemsnaph (LPSW16, int);
GLOBAL VOID stemsnapv (LPSW16, int);

#else
EXTERN VOID transfn8 ();

MLOCAL int t1toprefline ();
MLOCAL int t1botrefline ();
MLOCAL VOID sort_hints ();
MLOCAL VOID sort ();
MLOCAL int  cmp_int ();
MLOCAL SL32 xstemadj ();
MLOCAL SL32 ystemadj ();
MLOCAL int addyhint ();
MLOCAL VOID order_hints ();

GLOBAL int inithints ();
GLOBAL int t1startchar ();
GLOBAL int vstem ();
GLOBAL int hstem ();
GLOBAL int vstem6 ();
GLOBAL int hstem6 ();
GLOBAL int t1endchar ();
GLOBAL int t1closepath ();
GLOBAL int t1moveto ();
GLOBAL int t1lineto ();
GLOBAL int t1curveto ();
GLOBAL int flexproc ();
GLOBAL VOID blue_values ();
GLOBAL VOID other_blues ();
GLOBAL VOID stdhwx ();
GLOBAL VOID stdvwx ();
GLOBAL VOID blueshift ();
GLOBAL VOID bluescale ();
GLOBAL VOID stemsnaph ();
GLOBAL VOID stemsnapv ();
#endif  /* LINT_ARGS */

/*
External data refereces
*/
EXTERN IF_STATE if_state;

/*
Global data declarations
*/
GLOBAL T1I_HINT_STR xhints[NUMHINTS], yhints[NUMHINTS];
GLOBAL int xnum, ynum;

/*
Static data
*/
MLOCAL SL32 startx, starty;
MLOCAL SL32 minx, miny, maxx, maxy;
MLOCAL SW16 hintssorted;

#if defined (DEBUG)
char pvov_txt[] = "Work buffer overflow\n"; /* debug only */
#endif /* DEBUG */

/*
Add following section to interface w/'raster()' - 10/15/91 - rs
*/
/*
Type 1 vertex definitions
*/
#define T1LINE          1               /* Type 1 line segment */
#define T1BEZ           0               /* Type 1 bezier curve segment */

/*
Type 1 working buffer definitions
*/

/*
Type 1 input bitmap buffer definitions


Type 1 local variables
*/
MLOCAL LPUB8 pvert;          /* ptr to vertex codes in work buff */ 
MLOCAL LPSL32 pxy;             /* ptr to XY coords in work buff */  /* 6-29-92 */
MLOCAL SW16 num_vects;          /* # of vectors in contour */
MLOCAL SW16 num_bez;                /* # of bezier curves in contour */

MLOCAL LPSW16 p_vloop;        /* ptr to start of loop in expand buff */ 
MLOCAL LPSL32 p_xyloop;       /* ptr to start of loop in expand buff */ 

#if NON_Z_WIND                     /* 10-07-93 jfd */
MLOCAL SW16   y_goes_up;           /* 10-07-93 jfd */
MLOCAL SL32   firstY;              /* 10-07-93 jfd */
MLOCAL SL32   yprev;               /* 10-07-93 jfd */
MLOCAL SW16   last_pt_is_start_pt; /* 10-07-93 jfd */
#endif                             /* 10-07-93 jfd */

/*
End of 'raster()' interface section
*/

#if defined (ANSI_DEFS)
GLOBAL int inithints ()
#else
GLOBAL int inithints ()
#endif
/*
initialize hints
*/
{
int status;

  hintssorted = 0;

  /* default hints */
  xnum = ynum = 0;
  status = hstem ((SL32)-2047L, (SL32)2047L);
  if (status)
     return (status);
  status = vstem ((SL32)-2047L, (SL32)2047L);
  if (status)
     return (status);

  DBG ("%% inithints\n");
  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int t1startchar (SL32 org_x, SL32 org_y, SL32 escapement)
#else
GLOBAL int t1startchar (org_x, org_y, escapement)
SL32  org_x, org_y;  /* add 1/20/92 - rs */
SL32  escapement; /* SW16 to SL32 - 12/16/91 - rs */
#endif
/*
start character
*/
{
int status;
SL32  tx, ty;
FPNUM tmp_fp_esc;
UW16  matrix_val;

  DBG2 ("\nt1startchar(%ld,%ld)\n", org_x, org_y);

#if NON_Z_WIND                    /* 10-07-93 jfd */
  if_state.cs.tran_run_ct = 0;    /* 10-07-93 jfd */
#endif                            /* 10-07-93 jfd */

  minx = miny = 32000L;
  maxx = maxy = -32000L;

  status = inithints ();
  if (status)
     return (status);

  /* transform the point (do not grid align) */
  transfn8 (org_x, org_y, &tx, &ty);

  gpcs->origin_cs.x =  gpcs->origin_cs.y = 0;
  gpcs->dorigin.x =  gpcs->dorigin.y = 0;  /* 6-9-92 */

  /* Store escapement in either native units or 8782/em  01-25-93 - jfd */

  tmp_fp_esc = fpdiv( fplongexp(1L, 0), if_state.pbucket->p.ps.fontmatrix[0]);
  matrix_val = fp2word( tmp_fp_esc );
#if DU_ESCAPEMENT
#if 0
  gpcs->du_emx      = (SW16)1000;
  gpcs->du_emy      = (SW16)1000;
#endif
  gpcs->du_emx      = (SW16)matrix_val;
  gpcs->du_emy      = (SW16)matrix_val;
  gpcs->escapement  = (SW16)escapement;
#else
  gpcs->du_emx      = (SW16)8782;
  gpcs->du_emy      = (SW16)8782;
#if 0
  gpcs->escapement  = (SW16)(((escapement * 8782L) + 500L) / 1000L);
#endif
  gpcs->escapement  = (SW16)(((escapement * 8782L) + (matrix_val / 2)) / 
     matrix_val);
#endif

  DBG4 ("origin:%d,%d esc:%ld %d\n", gpcs->origin_cs.x, gpcs->origin_cs.y,
         escapement, gpcs->escapement);

   /*
      Init the CHAR_STATS structure so that we can track if a character
      has any contours (ie space).
   */
   gpcs->nloop = 0;   /* no loops in this char (yet) */

    /*
        setup output pointers in character  and expansion buffers. The vertex
        codes work down from the top (after a couple of size info words. The
        XY coordinates work up from the bottom.

        bottom up:
        SL32    cv[npnt+(2*nbez)]   line coordinates & curves interleaved

        top down:
        UW16            npnt            # of vertices
      UW16          nbez        # of bezier curves in contour (OR'd w/polarity)
        SB8         v[npnt]     vertex codes
        SB8         pad         if needed to align to SW16 boundary
    */
                                    /* align to SW16 boundary */
    if_state.expand_buf = 
        (LPSB8)((((SL32)if_state.char_buf + CHARBUFSIZE) >> 1) << 1)
         - sizeof(SW16);
   p_vloop = (LPSW16)if_state.expand_buf;  /* vertex codes */
    pvert = (LPUB8)((LPUB8)p_vloop - sizeof(SW16) - sizeof(SB8));
   p_xyloop = (LPSL32)(if_state.char_buf);    /* XY coordinates */
   pxy = p_xyloop + 2; /* 1st coord after (startx,starty) */

   num_vects = 0;
    num_bez = 0;    /* no bezier curves in loop (yet!) */
   if_state.num_loops  = 0;

   return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int vstem (SL32 x0, SL32 x1)
#else
GLOBAL int vstem (x0, x1)
SL32 x0, x1; /* SW16 to SL32 - 12/16/91 - rs */
#endif
/*
deal with a vstem hint
 - Pipeline upgrade - 4-May-93 - rs
*/
{
register SL32 i;
register int j;

   DBG2 ("\nvstem(x0:%ld x1:%ld) 'xhint'\n", x0, x1);

   if (!gpps->t1xtrans)
      return (SUCCESS);

   if ((xnum + 1) >= (sizeof (xhints) / sizeof (xhints[0])))
       return (ERR_psi_hint_ovflow);

   hintssorted = 0;

   i = scale (gpps->t1xtrans, x0);
   i = T1ROUND (i);

   /*
      Pipeline fix to eliminate duplicate hints - 2/25/92 - rs
   */
   for (j = 0; j < xnum; j++)
      if (xhints[j].hint == x0)
         break;

   if (j != xnum)
   { /* Found an old hint at same coordinate */
      xhints[j].hint = x0;
      xhints[j].pixel = i;
   }
   else /* add new hint to end of list */
   {
      xhints[xnum].hint = x0;
      xhints[xnum++].pixel = i;
   }
   DBG2 ("%ld %ld\n", i, xhints[j].pixel);

   /*
      Do the same for the other side of the hint
   */
   for (j = 0; j < xnum; j++)
      if (xhints[j].hint == x1)
         break;

   if (j != xnum)
   { /* Found an old hint at same coordinate */
      xhints[j].hint = x1;
      xhints[j].pixel = i + xstemadj (x0, x1);
   }
   else /* add new hint to end of list */
   {
      xhints[xnum].hint = x1;
      xhints[xnum++].pixel = i + xstemadj (x0, x1);
   }
   DBG2 ("%ld %ld\n", i, xhints[j].pixel);
   return (SUCCESS);
}

/* deal with an hstem hint
 - updated from Pipeline - 2/12/92
 - updated from Pipeline (replace function) - 4/22/92
 - Pipeline upgrade - 4-May-93 - rs
*/
#if defined (ANSI_DEFS)
GLOBAL int hstem (SL32 y0, SL32 y1)
#else
GLOBAL int hstem (y0, y1)
SL32 y0, y1;   /* SW16 to SL32 - 12/16/91 - rs */
#endif
{
SL32 i; /* SW16 to SL32 - 12/16/91 - rs */
SL32 sy0, sy1;
int ref;
int status;

   DBG2 ("\nhstem(y0:%ld y1:%ld)\n", y0, y1);

   if (!gpps->t1ytrans)
       return (SUCCESS);

   DBG2 ("%% yhint: %ld %ld ", y0, y1);

    hintssorted = 0;

    /* order ascending */
    if (y0 > y1)
    {
        i = y0;
        y0 = y1;
        y1 = i;
    }

    /*
    ** when we're done with all this hand waving,
    ** sy0 and sy1 will be properly scaled
    ** and y0 and y1 will contain correctly ordered points
    */

    /* is the bottom hint in a bottom zone? */
    if ((ref = t1botrefline (y0)) >= 0) {
        i = scale (y0, gpps->t1ytrans) - gpps->bot_refs[ref];
        sy0 = gpps->bot_refs[ref];
        /* are we below BlueScale size? */
        if (PSABS (gpps->t1ytrans) < gpps->iBlueScale) {
            /* this zone should be truncated */
            status = addyhint ((SL32)gpps->bot_blues[ref * 2], sy0);
            if (status)
                return (status);
            status = addyhint (gpps->bot_blues[ref * 2 + 1], sy0);
            if (status)
                return (status);

            /* is the top hint outside the alignment zone? */
            if (t1botrefline (y1) < 0) {
                /* okay put a hint here, too */
                sy1 = sy0 + ystemadj (y0, y1);
                status = addyhint (y1, sy1);
            if (status)
               return (status);
            }
        }
        /* should y be forced up? */
        else if (PSABS (i) < (SL32)gpps->overshoot) {
            /* this zone should be truncated */
            status =
            addyhint ((SL32)(gpps->bot_blues[ref * 2 + 1] - gpps->iBlueShift),
                sy0);
            if (status)
                return (status);
            status = addyhint (gpps->bot_blues[ref * 2 + 1], sy0);
            if (status)
                return (status);

            /* is the top hint outside the alignment zone? */
            if (t1botrefline (y1) < 0) {
                /* okay put a hint here, too */
                sy1 = sy0 + ystemadj (y0, y1);
                status = addyhint (y1, sy1);
                if (status)
                    return (status);
            }
        }
        else {
            /* use the hints, along with the reference line */
            status = addyhint ((SL32)gpps->bot_blues[ref * 2 + 1], sy0);
            if (status)
                return (status);
            sy0 = scale (gpps->t1ytrans, y0);

			   /* force y below reference line */
/* Pipeline update - 14-Jun-93 - add 6/18/93 - rs */

			if (T1SIGN (gpps->t1ytrans) > 0) {
				if (gpps->bot_refs[ref] - sy0 < ONE)
					sy0 = gpps->bot_refs[ref] - ONE;
				else
					sy0 = T1ROUND (sy0);
			}
			else {
				if (sy0 - gpps->bot_refs[ref] < ONE)
					sy0 = gpps->bot_refs[ref] + ONE;
				else
					sy0 = T1ROUND (sy0);
			}
/* end of Pipeline update - replaces block of code previously here */

            status = addyhint (y0, sy0);
            if (status)
                return (status);

			   /* is the top hint outside the alignment zone? */
			   if (t1botrefline (y1) < 0) {
				    /* okay put a hint here, too */
				    sy1 = sy0 + ystemadj (y0, y1);
				    status = addyhint (y1, sy1);
                if (status)
                  return (status);
			   }
        }
    }

    /* is the top hint in a top zone? */
    else if ((ref = t1toprefline (y1)) >= 0) {
        i = scale (gpps->t1ytrans, y1 - gpps->top_blues[ref * 2]);
        sy1 = gpps->top_refs[ref];
        /* are we below BlueScale size? */
        if (PSABS (gpps->t1ytrans) < gpps->iBlueScale) {
            /* this zone should be truncated */
            status = addyhint ((SL32)gpps->top_blues[ref * 2], sy1);
            if (status)
               return (status);
            status = addyhint (gpps->top_blues[ref * 2 + 1], sy1);
            if (status)
               return (status);

            /* is the bottom hint outside the alignment zone? */
            if (t1toprefline (y0) < 0) {
                /* okay put a hint here, too */
                sy0 = sy1 + ystemadj (y1, y0);
                status = addyhint (y0, sy0);
                if (status)
                   return (status);
            }
        }
        /* should y be forced down? */
        else if (PSABS (i) < (SL32)gpps->overshoot) {
            /* this zone should be truncated */
            status = addyhint ((SL32)gpps->top_blues[ref * 2], sy1);
            if (status)
               return (status);
            status = addyhint (gpps->top_blues[ref * 2] + gpps->iBlueShift, sy1);
            if (status)
               return (status);

            /* is the bottom hint outside the alignment zone? */
            if (t1toprefline (y0) < 0) {
                /* okay put a hint here, too */
                sy0 = sy1 + ystemadj (y1, y0);
                status = addyhint (y0, sy0);
                if (status)
                   return (status);
            }
        }
        else {
            /* use the hints, along with the reference line */
            status = addyhint ((SL32)gpps->top_blues[ref * 2], sy1);
            if (status)
               return (status);
            sy1 = scale (gpps->t1ytrans, y1);

			   /* force y above reference line */
/* Pipeline update - 14-Jun-93 - add 6/18/93 - rs */
			if (T1SIGN (gpps->t1ytrans) > 0) {
				if (sy1 - gpps->top_refs[ref] < ONE)
					sy1 = gpps->top_refs[ref] + ONE;
				else
					sy1 = T1ROUND (sy1);
			}
			else {
				if (gpps->top_refs[ref] - sy1 < ONE)
					sy1 = gpps->top_refs[ref] - ONE;
				else
					sy1 = T1ROUND (sy1);
			}
/* end of Pipeline update */

            status = addyhint (y1, sy1);
            if (status)
               return (status);

			   /* is the bottom hint outside the alignment zone? */
			   if (t1toprefline (y0) < 0) {
				    /* okay put a hint here, too */
				    sy0 = sy1 + ystemadj (y1, y0);
				    status = addyhint (y0, sy0);
                if (status)
                  return (status);
			   }
        }
    }

    /* neither is in a zone */
    else {
        sy0 = scale (gpps->t1ytrans, y0);
        sy0 = T1ROUND (sy0);
        sy1 = sy0 + ystemadj (y0, y1);

        status = addyhint (y0, sy0);
        if (status)
           return (status);
        status = addyhint (y1, sy1);
        if (status)
           return (status);
    }
    return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int addyhint (SL32 y, SL32 sy)
#else
MLOCAL int addyhint (y, sy)
SL32 y;
SL32 sy;
#endif
{
register int i;

    /* eliminate duplicate hints */
    for (i = 0; i < ynum; i++)
    {
        if (yhints[i].hint == y)
            break;
    }
    /* found an old hint at same coordinate */
    if (i != ynum)
    {
        yhints[i].hint = y;
        yhints[i].pixel = sy;
    }
    /* add new hint to end of list */
    else
    {
      /* Make sure there is room for this hint - 2/12/92 - rs */
        if ((ynum + 1) >= (sizeof (yhints) / sizeof (yhints[0])))
           return (ERR_psi_hint_ovflow);

        yhints[ynum].hint = y;
        yhints[ynum++].pixel = sy;
    }
    DBG2 ("yhint map %ld to %ld\n", y, sy);
   return (SUCCESS);
}

/* does y fall in a top zone? */
#if defined (ANSI_DEFS)
MLOCAL int t1toprefline (SL32 y)
#else
MLOCAL int t1toprefline (y)
SL32 y; /* SW16 to SL32 - 12/16/91 - rs */
#endif
{
register int i;

    for (i = 0; i < gpps->numtblues; i += 2)
    {
      if (y >= (SL32)gpps->top_blues[i] && y <= (SL32)gpps->top_blues[i + 1])
      {
            return (i / 2);
      }
    }
    return (-1);
}

/* does y fall in a bottom zone? */
#if defined (ANSI_DEFS)
MLOCAL int t1botrefline (SL32 y)
#else
MLOCAL int t1botrefline (y)
SL32 y;  /* SW16 to SL32 - 12/16/91 - rs */
#endif
{
register int i;

    for (i = 0; i < gpps->numbblues; i += 2)
    {
        if (y >= (SL32)gpps->bot_blues[i] && y <= (SL32)gpps->bot_blues[i + 1])
        {
            return (i / 2);
        }
    }
    return (-1);
}

#ifdef __WATCOMC__
#if defined (ANSI_DEFS)
MLOCAL int cmp_int (const void *a, const void *b)
#else
MLOCAL int cmp_int (a, b)
const void *a;
const void *b;
#endif /* ANSI_DEFS */
#else
#if defined (ANSI_DEFS)
MLOCAL int cmp_int (LPSL32 a, LPSL32 b)
#else
MLOCAL int cmp_int (a, b)
LPSL32 a, b; /* LPSW16 to LPSL32 - 12/16/91 - rs */
#endif /* ANSI_DEFS */
#endif
/*
   NOTE: This function will not work for data > 16 bits
*/
{
#if defined (MSDOS) && !defined(CGFLAT32)
  return (*(int *)a - *(int *)b);   /* 32 bit platform version */
#else /* DOS version needs to compare longs & return int */
register long lresult;

  lresult = *(long *)a - *(long *)b;
  if (lresult < 0L)
   return (-1);
  else if (!lresult)
   return (0);
 else return (1);
#endif /* MSDOS && CGFLAT32 */
}

#if defined (ANSI_DEFS)
GLOBAL int vstem6 (LPSL32 vals)
#else
GLOBAL int vstem6 (vals)
LPSL32 vals; /* LPSW16 to LPSL32 - 12/16/91 - rs */
#endif
/*
process x triple hint
this is used to maintain stem consistency on glyphs like 'm' and '...'
*/
{
SL32 dxmin, dxmid, dxmax; /* SW16 to SL32 - 12/16/91 - rs */
SL32 midstem; /* SW16 to SL32 - 12/16/91 - rs */
int status;

  DBG ("\nvstem6()\n");

  if (!gpps->t1xtrans)
    return (SUCCESS);

  /* throw away all previous x hints */
  xnum = 0;

  QSORT ((PVOID)vals, (UW16)6, (UW16)sizeof (SL32),
#ifdef LINT_ARGS
   (int (*)(const void *, const void *))cmp_int);
#else
  (int *)cmp_int);
#endif
  DBG6 ("%% tripleV: %ld %ld %ld %ld %ld %ld\n",
    vals[0], vals[1], vals[2], vals[3], vals[4], vals[5]);

  status = vstem (vals[0], vals[1]);
  if (status)
    return (status);
  status = vstem (vals[2], vals[3]);
  if (status)
    return (status);

  dxmin = vals[1] - vals[0];
  dxmid = vals[3] - vals[2];
  dxmax = vals[5] - vals[4];

  DBG3 ("%% dxmin = %ld, dxmid = %ld, dxmax = %ld\n", dxmin, dxmid, dxmax);

  if (dxmin == dxmax &&
     (vals[2] + dxmid / 2) - (vals[0] + dxmin / 2) ==
     (vals[4] + dxmax / 2) - (vals[2] + dxmid / 2))
  {
    if ((xnum + 1) >= (sizeof (xhints) / sizeof (xhints[0])))
        return (ERR_psi_hint_ovflow);

    /* width of first stem in pixels */
    dxmin = xhints[xnum - 3].pixel - xhints[xnum - 4].pixel;
    /* width of first counter in pixels */
    dxmax = xhints[xnum - 2].pixel - xhints[xnum - 3].pixel;
    /* position of right edge of middle stem */
    midstem = xhints[xnum - 1].pixel;

    /* okay, now offset the last stem so everything is equal */
    xhints[xnum].hint = vals[4];
    xhints[xnum++].pixel = midstem + dxmax;  /* add counter width */
    xhints[xnum].hint = vals[5];
    xhints[xnum++].pixel = midstem + dxmax + dxmin;  /* and stem width */
    DBG2 ("%% xhint: %ld %ld ", vals[4], vals[5]);
    DBG2 ("%ld %ld\n", xhints[xnum - 2].pixel, xhints[xnum - 1].pixel);
  }
  else
    return (vstem (vals[4], vals[5]));

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int hstem6 (LPSL32 vals)
#else
GLOBAL int hstem6 (vals)
LPSL32 vals; /* LPSW16 to LPSL32 - 12/16/91 - rs */
#endif
/*
process y triple hint
*/
{
int status;

  DBG ("\nhstem6()\n");

  if (!gpps->t1xtrans)
    return (SUCCESS);

  DBG ("%% tripleH\n");
  QSORT ((PVOID)vals, (UW16)6, (UW16)sizeof (SL32),
#ifdef LINT_ARGS
   (int (*)(const void *, const void *))cmp_int);
#else
   (int *)cmp_int);
#endif
  status = hstem (vals[0], vals[1]);
  if (status)
    return (status);
  status = hstem (vals[2], vals[3]);
  if (status)
    return (status);
  status = hstem (vals[4], vals[5]);
  if (status)
    return (status);

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int t1endchar ()
#else
GLOBAL int t1endchar ()
#endif
/*
end character

Ifthe char has 0 loops (ie. space), set the bbox = (0,0,0,0).
*/
{
   DBG ("\nt1endchar()\n");
   DBG4 ("bbox:%ld %ld %ld %ld\n", minx, miny, maxx, maxy);

   /* add 4/8/92 - rs
      Remember the number of contours for handling fixed space char.
   */
   gpcs->nloop = if_state.num_loops;
   if (!gpcs->nloop)
   {
      gpcs->xmin = gpcs->ymin = gpcs->xmax = gpcs->ymax = 0L;
   }
   else 
   {
      gpcs->xmin = minx;
      gpcs->ymin = miny;
      gpcs->xmax = maxx;
      gpcs->ymax = maxy;
   }
   gpcs->xscale = 16;
   gpcs->yscale = 16;

   return (SUCCESS);
}

/*
** All the path generation routines transform the point(s) passed to them
** by calling *transptr.  Then they add the point(s) to the work buffer
** along with the appropriate vertex command.
** For integrating with different rasterizers, the work buffer
** could go away and the transformed points could be passed directly to
** the rasterizer (before or after Bezier flattening).
*/

#if defined (ANSI_DEFS)
GLOBAL int t1closepath ()
#else
GLOBAL int t1closepath ()
#endif
/*
closepath
*/
{
  DBG2 ("\nt1closepath(): %ld %ld\n", startx, starty);

    *pvert-- = (SB8)T1LINE; /* ending line segment */
    *pxy++ = startx; /* 6-29-92 */
    *pxy++ = starty; /* 6-29-92 */

#if NON_Z_WIND
    if (if_state.non_z_wind)
    {

    if((y_goes_up && (yprev > starty)) || (!y_goes_up && (yprev < starty)))
        ++if_state.cs.tran_run_ct;

    }
#endif

    /*
        Check for overflow of working buffer
    */
    if ((SL32)pxy >= (SL32)pvert)
    {
        DBG1 ("t1closepath() - %s", pvov_txt);
        return (ERR_psi_wkbuf_ovflow);
    }

    num_vects++;

    /*
        Store the number of vectors & beziers as well as polarity at the
        start of the vertex codes for this loop. Store the starting xy
        coordinate at the start of the coordinates for this loop.
    */
   *p_vloop-- = num_vects;
    *p_vloop = (num_bez | 0x8000); /* number of beziers + polarity = 1 */
    *p_xyloop++ = startx; /* 6-29-92 */
    *p_xyloop++ = starty; /* 6-29-92 */
   gpcs->ct_lineto += (num_vects - num_bez);
   gpcs->ct_cubeto += num_bez;

   if_state.num_loops++;
    num_vects = num_bez = 0;    /* next loop has no vectors */
                    /* ptr to vertex codes in work buff Added cast -3/223/92 */
   pvert = (LPUB8)(((SL32)pvert >> 1) << 1); /* align to SW16 boundary */
    p_vloop = (LPSW16)((LPUB8)pvert - sizeof(SW16));
    pvert = (LPUB8)((LPUB8)p_vloop - sizeof(SW16) - sizeof(SB8));
    p_xyloop = pxy;
   pxy += 2; /* leave room for starting coord */

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int t1moveto (SL32 x, SL32 y)
#else
GLOBAL int t1moveto (x, y)
SL32 x, y;  /* SW16 to SL32 - 12/16/91 - rs */
#endif
/*
moveto
*/
{
SL32 x1, y1;

  DBG2 ("\nt1moveto(%ld,%ld)\n", x, y);

  sort_hints ();

  /* transform the point (also does grid aligning) */
  (*gpps->transptr) (x, y, &x1, &y1);

  startx = x1;
  starty = y1;

#if NON_Z_WIND    /* 10-07-93 jfd */
    if (if_state.non_z_wind)
    {

    yprev = firstY = starty;
    ++if_state.cs.tran_run_ct;   /*  bump for first tran run;
                                  *  assumes this contour is not empty
                                  */
    last_pt_is_start_pt = TRUE;

    }
#endif            /* 10-07-93 jfd */

  /* keep track of MIN and MAX values for bounding box */
  minxy (x1, y1);
  DBG2 ("%ld %ld moveto\n", x1, y1);

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int t1lineto (SL32 x, SL32 y)
#else
GLOBAL int t1lineto (x, y)
SL32 x, y;  /* SW16 to SL32 - 12/16/91 -  rs */
#endif
/*
lineto
*/
{
SL32 x1, y1;

  DBG2 ("\nt1lineto(%ld %ld)\n", x, y);

  sort_hints ();

  /* transform the point (also does grid aligning) */
  (*gpps->transptr) (x, y, &x1, &y1);

  /* keep track of MIN and MAX values for bounding box */
  minxy (x1, y1);
  DBG2 ("%ld %ld lineto\n", x1, y1);

#if NON_Z_WIND   /* 10-07-93 jfd */
  if (if_state.non_z_wind)
  {

  if(last_pt_is_start_pt)
  {
     y_goes_up = (starty <= y1);   /* modified by jfd  10-07-93 */
     last_pt_is_start_pt = FALSE; /* modified by jfd  10-07-93 */
  }
  if((y_goes_up && (yprev > y1)) || (!y_goes_up && (yprev < y1)))
      {
      ++if_state.cs.tran_run_ct;
      y_goes_up = !y_goes_up;
      }
  yprev = y1;

  }
#endif           /* 10-07-93 jfd */

    *(pvert--) = (SB8)T1LINE;   /* line segment */
    *pxy++ = x1; /* 6-29-92 */
    *pxy++ = y1; /* 6-29-92 */

   /*
        Check for overflow of working buffer
    */
    if ((SL32)pxy >= (SL32)pvert)
    {
        DBG1 ("t1lineto() - %s", pvov_txt);
        return (ERR_psi_wkbuf_ovflow);
    }

    num_vects++;

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int t1curveto (SL32 cx1, SL32 cy1, SL32 cx2, SL32 cy2, 
   SL32 xe, SL32 ye)
#else
GLOBAL int t1curveto (cx1, cy1, cx2, cy2, xe, ye)
SL32 cx1, cy1, cx2, cy2, xe, ye; /* SW16 to SL32 - 12/16/91 - rs */
#endif
/*
curveto
*/
{
SL32 x1, y1;

   sort_hints ();
   DBG6 ("\nt1curveto(%ld %ld %ld %ld %ld %ld)\n", cx1, cy1, cx2, cy2, xe, ye);

   (*gpps->transptr) (cx1, cy1, &x1, &y1);

   minxy (x1, y1);
   DBG2 ("%ld %ld  ", x1, y1);

#if NON_Z_WIND   /* 10-07-93 jfd */
  if (if_state.non_z_wind)
  {

  if(last_pt_is_start_pt)
  {
     y_goes_up = (starty <= y1);   /* modified by jfd  10-07-93 */
     last_pt_is_start_pt = FALSE; /* modified by jfd  10-07-93 */
  }

  if((y_goes_up && (yprev > y1)) || (!y_goes_up && (yprev < y1)))
      {
      ++if_state.cs.tran_run_ct;
      y_goes_up = !y_goes_up;
      }
  yprev = y1;

  }
#endif           /* 10-07-93 jfd */

    *(pvert--) = (SB8)T1BEZ;        /* bezier curve segment */
    *pxy++ = x1; /* 6-29-92 */
    *pxy++ = y1; /* 6-29-92 */

    num_vects++;

   (*gpps->transptr) (cx2, cy2, &x1, &y1);
   minxy (x1, y1);
   DBG2 ("%ld %ld  ", x1, y1);

#if NON_Z_WIND   /* 10-07-93 jfd */
  if (if_state.non_z_wind)
  {

  if(last_pt_is_start_pt)
  {
     y_goes_up = (starty <= y1);   /* modified by jfd  10-07-93 */
     last_pt_is_start_pt = FALSE; /* modified by jfd  10-07-93 */
  }

  if((y_goes_up && (yprev > y1)) || (!y_goes_up && (yprev < y1)))
      {
      ++if_state.cs.tran_run_ct;
      y_goes_up = !y_goes_up;
      }
  yprev = y1;

  }
#endif           /* 10-07-93 jfd */

    *pxy++ = x1; /* 6-29-92 */
    *pxy++ = y1; /* 6-29-92 */

   (*gpps->transptr) (xe, ye, &x1, &y1);
   minxy (x1, y1);
   DBG2 ("%ld %ld curveto\n", x1, y1);


#if NON_Z_WIND   /* 10-07-93 jfd */
  if (if_state.non_z_wind)
  {

  if(last_pt_is_start_pt)
  {
     y_goes_up = (starty <= y1);   /* modified by jfd  10-07-93 */
     last_pt_is_start_pt = FALSE; /* modified by jfd  10-07-93 */
  }

  if((y_goes_up && (yprev > y1)) || (!y_goes_up && (yprev < y1)))
      {
      ++if_state.cs.tran_run_ct;
      y_goes_up = !y_goes_up;
      }
  yprev = y1;

  }
#endif           /* 10-07-93 jfd */

    *pxy++ = x1; /* 6-29-92 */
    *pxy++ = y1; /* 6-29-92 */

   /*
        Check for overflow of working buffer
    */
    if ((SL32)pxy >= (SL32)pvert)
    {
        DBG1 ("t1curveto() - %s", pvov_txt);
        return (ERR_psi_wkbuf_ovflow);
    }

    num_bez++;

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int flexproc (SL32 bx, SL32 by, LPSL32 curve1, LPSL32 curve2, SL32 dmin)
#else
GLOBAL int flexproc (bx, by, curve1, curve2, dmin)
SL32    bx, by;
LPSL32 curve1, curve2;
SL32   dmin;
#endif
/*
Handle a Flex curve.  See the White book for information on Flex
*/
{
register SL32  delta;
register SL32  ref;
LPSL32 xptr, yptr;
SL32  dm;
int status;

  DBG1 ("\nflexproc(): dmin = %ld", dmin);

	/* current point (may be adjusted later) */
#if 0 /* NOTE: probably need to reference (px-1) here - rs - 5/13/93 */
	xptr = xcoords + numpts - 1;
	yptr = ycoords + numpts - 1;
#endif /* 0 */
	xptr = pxy - 2; /* point to last x coord */
	yptr = pxy - 1; /* point to last y coord */

	/* convert dmin to 64ths of a pixel */
	dm = ((SL32) dmin << 6) / 100L;

	DBG ("Flexproc entered\n");
	DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld\n", curve1[0],
			curve1[1], curve1[2], curve1[3], curve1[4], curve1[5]);
	DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld\n", curve2[0],
			curve2[1], curve2[2], curve2[3], curve2[4], curve2[5]);

	/* is the char aligned in the X or Y direction? */
	if (gpps->t1auxytrans && PSABS (curve2[4] - bx) > PSABS (curve2[5] - by)) {
		/* the curve is longer in the X direction */

		DBG ("Flexproc in the if\n");

		/* compute y delta */
		ref = curve2[5] - curve1[5];
		DBG1 ("ydelta = %ld\n", ref);

		ref <<= 2;	/* dm is in 64ths of a pixel */

		/* convert to pixel space */
		delta = scale (ref, gpps->t1auxytrans);
		delta = PSABS (delta);

		if (delta >= dm) {
			/*
			** if the depth of the curve is large enough
			** (usually, 1/2 pixel), a curve is placed here;
			** otherwise, just put down a line
			*/

			/* put hints here for rendering */
			status = hstem (curve1[5], by);
            if (status)
                return (status);

			status = t1curveto (curve1[0], curve1[1], curve1[2],
                curve1[3], curve1[4], curve1[5]);
            if (status)
                return (status);
			status = t1curveto (curve2[0], curve2[1], curve2[2],
                curve2[3], curve2[4], curve2[5]);
            if (status)
                return (status);

			/* the auto hint above may end up modifying the endpoint */
#if 0 /* NOTE: probably need to reference *(px-1) here - rs - 5/13/93 */
			if (ABS (*yptr - ycoords[numpts - 1]) < TWO)
				*yptr = ycoords[numpts - 1];
#endif /* 0 - the following block replaces the one above */
         /* This code was set up for no rotatation.  The snapping
          * is done after rotation so that for 90 degree rotation we
          * were still snapping the y coordinate when we should have
          * done x. The following test fixes this.  18-Aug-95
          */

            if(if_state.quadrant ==  ROT0   || 
               if_state.quadrant ==  ROT180 || 
               if_state.quadrant == -ROT0   || 
               if_state.quadrant == -ROT180)
            {
            if (PSABS (*yptr - *(pxy-1)) < TWO) /* 5/13/93 - rs */
            *yptr = *(pxy - 1);              /*  " */
            }
            else
            {
            if (PSABS (*xptr - *(pxy-2)) < TWO)
               *xptr = *(pxy-2);
            }
         }
         else
         {
         status = t1lineto (curve2[4], curve2[5]);
         if (status)
           return (status);
         }
      }
      else if (gpps->t1auxxtrans && PSABS (curve2[4] - bx) <
      PSABS (curve2[5] - by)) {
		/* the curve is longer in the Y direction */

		DBG ("Flexproc: in first else");
		/* compute x delta */
		ref = curve2[4] - curve1[4];
		DBG1 ("xdelta = %ld\n", ref);
		ref <<= 2;	/* dm is in 64ths of a pixel */

		/* convert to pixel space */
		delta = scale (ref, gpps->t1auxxtrans);
		delta = PSABS (delta);

		if (delta >= dm) {
			/*
			** if the depth of the curve is large enough
			** (usually, 1/2 pixel), a curve is placed here;
			** otherwise, just put down a line
			*/
			/* put hints here for rendering */
			status = vstem (curve1[4], 2000);
            if (status)
                return (status);
			status = vstem (bx, 2000);
            if (status)
                return (status);
			DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld", curve1[0],
					curve1[1], curve1[2], curve1[3], curve1[4], curve1[5]);
			DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld", curve2[0],
					curve2[1], curve2[2], curve2[3], curve2[4], curve2[5]);
			status = t1curveto (curve1[0], curve1[1], curve1[2],
                curve1[3], curve1[4], curve1[5]);
            if (status)
                return (status);
			status = t1curveto (curve2[0], curve2[1], curve2[2],
                curve2[3], curve2[4], curve2[5]);
            if (status)
                return (status);
			/* the auto hint above may end up modifying the endpoint */
#if 0 /* NOTE: probably need to reference *(px-1) here - rs - 5/13/93 */
			if (ABS (*xptr - xcoords[numpts - 1]) < TWO)
				*xptr = xcoords[numpts - 1];
#endif /* 0 - the following block replaces the one above */
            if(if_state.quadrant ==  ROT0   || 
               if_state.quadrant ==  ROT180 || 
               if_state.quadrant == -ROT0   || 
               if_state.quadrant == -ROT180)
            {
            if (PSABS (*xptr - *(pxy-2)) < TWO)
               *xptr = *(pxy-2);
            }
            else
            {
            if (PSABS (*yptr - *(pxy-1)) < TWO) /* 5/13/93 - rs */
               *yptr = *(pxy - 1);              /*  " */
            }
        }
	else
        {
	status = t1lineto (curve2[4], curve2[5]);
            if (status)
                return (status);
        }
	}
	else {
		DBG ("Flexproc: in the last else");
		DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld", curve1[0],
				curve1[1], curve1[2], curve1[3], curve1[4], curve1[5]);
		DBG6 ("Flexproc: making curves %ld %ld %ld %ld %ld %ld", curve2[0],
				curve2[1], curve2[2], curve2[3], curve2[4], curve2[5]);
		/* this curve isn't parallel to the X or Y axis */
		status = t1curveto (curve1[0], curve1[1], curve1[2], curve1[3],
            curve1[4], curve1[5]);
        if (status)
            return (status);
		status = t1curveto (curve2[0], curve2[1], curve2[2], curve2[3],
            curve2[4], curve2[5]);
        if (status)
            return (status);
	}

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL VOID stemsnaph (LPSW16 vals, int n)
#else
GLOBAL VOID stemsnaph (vals, n)
LPSW16 vals;
int n;
#endif
{
int i;

   DBG ("\n%% StemSnapH [");
   gpps->numStemSnapH = 0;
   for (i = 0; i < n; i++)
   {
      DBG1 ("%d ", vals[i]);
      gpps->StemSnapH[gpps->numStemSnapH++] =
         (vals[i] + ONE_HALF) >> 4;
   }

   DBG ("]\n");
   return ;
}

#if defined (ANSI_DEFS)
GLOBAL VOID stemsnapv (LPSW16 vals, int n)
#else
GLOBAL VOID stemsnapv (vals, n)
LPSW16 vals;
int n;
#endif
{
int i;

   DBG ("\n%% StemSnapV [");
   gpps->numStemSnapV = 0;
   for (i = 0; i < n; i++)
   {
      DBG1 ("%d ", vals[i]);
      gpps->StemSnapV[gpps->numStemSnapV++] =
         (vals[i] + ONE_HALF) >> 4;
   }

   DBG ("]\n");
   return ;
}

/* 
** These handle the BlueValues arrays.  They are pairs of vertical values
** representing "overshoot zones", where one number represents the "flat"
** position, and the other represents the "overshoot" or curve position.
** A horizontal stem hint must also exist that has either a start or
** end value that falls within the range of a BlueValues pair
** for that BlueValue to have an effect on the character.  Typical entries in
** the BlueValues array include the baseline, x-height, o-height, cap-height,
** etc.  The first pair *must* be a "bottom" zone, or a down-pointing curve
** (typically, the baseline).  All other pairs in BlueValues are "top" zones,
** or up-pointing curves.  The OtherBlues array is used to specify more
** bottom zones.  Up to seven pairs may be given in the BlueValues array and
** up to five in the OtherBlues (for a total of six pairs each for bottom and
** top zones).
** 
** See Adobe's White Book for more details on how these work.
**
** called from scan.c
*/

#if defined (ANSI_DEFS)
GLOBAL VOID blue_values (LPSW16 vals, int n)
#else
GLOBAL VOID blue_values (vals, n)
LPSW16 vals;
int n;
#endif
{
register int i;
register SW16 bluefuzz = gpps->BlueFuzz;

  DBG ("\n%% BlueValues: ");
  
	/* we can assume here that blue_values will be called before other_blues */
	gpps->numbblues = gpps->numtblues = 0;

  for (i = 0; i < n; i++)
  {
    if (i < 2)
      gpps->bot_blues[gpps->numbblues++] = vals[i] - bluefuzz;
    else
      gpps->top_blues[gpps->numtblues++] = vals[i] - bluefuzz;
 	 bluefuzz = -bluefuzz;
  }

#if defined (DEBUG)
  DBG ("[ ");
  for (i = 0; i < gpps->numbblues; i++)
    DBG1 ("%d ", gpps->bot_blues[i]);
  for (i = 0; i < gpps->numtblues; i++)
    DBG1 ("%d ", gpps->top_blues[i]);
  DBG ("]\n");
#endif /* DEBUG */
}

#if (T1MMASTER)
/* more bottom zones */
#if defined (ANSI_DEFS)
GLOBAL int add_weights (PFPNUM vals, int n)
#else
GLOBAL int add_weights (vals, n)
register PFPNUM vals;
int n;
#endif
{
register int i;

   DBG ("*** add_weights ***\n");
	DBG ("%% WeightVector: ");
	
	for (i = 0; i < n; i++)
		gpps->weights[i] = fp2long (fpmul (vals[i], fpint2fp (1L << 16)));

	gpps->Weightvals = n;

#if defined DEBUG
	DBG ("[ ");
	for (i = 0; i < n; i++)
		DBG1 ("%d ", gpps->weights[i]);
	DBG ("]\n");
#endif /* DEBUG */
    return (SUCCESS);
}
#endif /* (T1MMASTER ) */

#if defined (ANSI_DEFS)
GLOBAL VOID other_blues (LPSW16 vals, int n)
#else
GLOBAL VOID other_blues (vals, n)
LPSW16 vals;
int n;
#endif
/*
more bottom zones
*/
{
register int i;
register SW16 bluefuzz = gpps->BlueFuzz;

  DBG ("%% OtherBlues: ");
  
  for (i = 0; i < n; i++) {
    gpps->bot_blues[gpps->numbblues++] = vals[i] - bluefuzz;
	 bluefuzz = -bluefuzz;
  }

#if defined (DEBUG)    
  DBG ("[ ");
  for (i = 0; i < gpps->numbblues; i++)
    DBG1 ("%d ", gpps->bot_blues[i]);
  DBG ("]\n");
#endif /* DEBUG */
}

#if defined (ANSI_DEFS)
GLOBAL VOID stdhwx (SW16 hw)
#else
GLOBAL VOID stdhwx (hw)
SW16 hw;
#endif
/*
save StdHW value; also called from scan.c
*/
{
  /* value comes in excess 16 fixed precision */
  gpps->inStdHW = (hw + ONE_HALF) >> 4;
}

#if defined (ANSI_DEFS)
GLOBAL VOID stdvwx (SW16 vw)
#else
GLOBAL VOID stdvwx (vw)
SW16 vw;
#endif
/*
save StdVW value; also called from scan.c
*/
{
  /* value comes in excess 16 fixed precision */
  gpps->inStdVW = (vw + ONE_HALF) >> 4;
}

#if defined (ANSI_DEFS)
GLOBAL VOID blueshift (SL32 bshift)
#else
GLOBAL VOID blueshift (bshift)
SL32 bshift;
#endif
/*
save BlueShift value; also called from scan.c
*/
{
  gpps->iBlueShift = (SW16)bshift;
}

#if defined (ANSI_DEFS)
GLOBAL VOID bluescale (SL32 bscale)
#else
GLOBAL VOID bluescale (bscale)
SL32 bscale;
#endif
/*
save BlueScale value; also called from scan.c
*/
{
  gpps->iBlueScale = bscale;
}

/*
** order_hints makes a pass over the y hint data to make sure all hint/pixel
** pairs are monotonic; it adjusts the hints outwards from the Blue points.
** The hints must be sorted at this point.
*/
#define INTOPBLUE 1
#define INBOTBLUE 2
#define NEGSCALE 4

#if defined (ANSI_DEFS)
MLOCAL VOID order_hints (PT1I_HINT_STR hints, int num)
#else
MLOCAL VOID order_hints (hints, num)
PT1I_HINT_STR hints;
int num;
#endif
{
register PT1I_HINT_STR t, tend;
register int i;
register int dir = T1SIGN (gpps->t1ytrans);

    /* first, mark hints */
    for (t = hints + 1, tend = hints + num; t < tend; t++) {
        t->pixscale = 0;
        if (dir > 0 && (t->pixel < (t - 1)->pixel) ||
            dir < 0 && (t->pixel > (t - 1)->pixel))
            t->pixscale |= NEGSCALE;
        if ((i = t1toprefline (t->hint)) >= 0)
            t->pixscale |= INTOPBLUE | (i << 8);
/* COMMENTED OUT BY PIPELINE in 5/4/93 upgrade - 5/13/93 - rs 
        else if ((i = t1botrefline ((SL32)t->hint)) >= 0)
            t->pixscale |= INBOTBLUE | (i << 8);
*/

DBG5 ("yhints[%08lX]: hint = %d, pixel = %ld, ref = %ld, flags = %08lX\n",
    t - hints, t->hint, t->pixel, t->pixscale >> 8, t->pixscale & 0xF);

        /* if this hint conflicts with another */
        if (t->pixscale & NEGSCALE) {
            /* don't delete the Blue one! */
            if ((t->pixscale & INTOPBLUE) &&
                !((t - 1)->pixscale & INTOPBLUE)) {
                (t - 1)->hint = 32000;
                ynum--;
            }
            else {
                /* "delete" the top hint */
                t->hint = 32000;
                ynum--;
            }
        }
    }

    /* keep it up until we get them all */
    if (ynum > 2 && num != ynum) {
        /* resort, removing deleted hints */
        sort (hints, num);
        order_hints (hints, ynum);
    }
}

#if defined (ANSI_DEFS)
MLOCAL VOID sort (PT1I_HINT_STR hints, int num)
#else
MLOCAL VOID sort (hints, num)
PT1I_HINT_STR hints;
int num;
#endif
/*
sort the hints array
*/
{
register PT1I_HINT_STR t;
register int gap, j;
register int i;
T1I_HINT_STR tmp;

/*
** sort on hint values
*/
    for (gap = num / 2; gap > 0; gap /= 2)
        for (i = gap; i < num; i++)
            for (j = i - gap; j >= 0; j -= gap)
            {
                t = hints + j;
                if (t->hint < (t + gap)->hint)
                    break;
                tmp = *t;
                *t = t[gap];
                t[gap] = tmp;
            }
}

#if defined (ANSI_DEFS)
MLOCAL VOID sort_hints ()
#else
MLOCAL VOID sort_hints ()
#endif
/*
sort hints and compute scale factor for inter-hint spacing
update w/fix from Pipeline to correct hint (Palatino) problem - 4/22/92
*/
{
register PT1I_HINT_STR ptr, next;
register SL32 tmp;
register int  i;

  if (hintssorted)
    return;

  hintssorted = 1;

  /* first sort hints in ascending order */
  sort (xhints, xnum);
  sort (yhints, ynum);

   /*
      Addition to correct hint (Palatino) problem - 4/22/92
   */
    /* make sure all yhint/pixel pairs are monotonic */
    order_hints (yhints, ynum);

   /* now compute scale factor for inter-hint spacing */
   for (i = 0, ptr = xhints, next = xhints + 1; i < xnum - 1;
      ptr++, next++, i++)
   {
      tmp = next->pixel - ptr->pixel;
      ptr->pixscale = (tmp << 11) / (next->hint - ptr->hint);
   }

  /* same for y hints */
   for (i = 0, ptr = yhints, next = yhints + 1; i < ynum - 1;
      ptr++, next++, i++)
   {
      tmp = next->pixel - ptr->pixel;
      ptr->pixscale = (tmp << 11) / (next->hint - ptr->hint);
   }
   return ;
}

/* adjust vertical stems based on canonical and real widths */
#if defined (ANSI_DEFS)
MLOCAL SL32 xstemadj (SL32 left, SL32 right)
#else
MLOCAL SL32 xstemadj (left, right)
SL32 left;
SL32 right;
#endif
{
	register int i;
	register SL32 width;
	register int sign = 0;
	
	/* real width in pixel space */
	left = scale (gpps->t1xtrans, right - left);
	if (left < 0) {
		/* save sign */
		sign = 1;
		left = -left;
	}

	/* use canonical width if < tolerance, real width otherwise */
	width = T1ROUND (left);
	for (i = 0; i < gpps->numStemSnapV * 3; i += 3) {
		if (left > gpps->stem_refv[i] && left < gpps->stem_refv[i + 1]) {
			width = gpps->stem_refv[i + 2];
			break;
		}
	}
	
	/* clamp at stem_min width */
	if (width < gpps->stem_min)
		width = gpps->stem_min;
	
	/* return with proper sign */
	return (sign ? -width : width);
}

/* adjust horizontal stems based on canonical and real widths */
#if defined (ANSI_DEFS)
MLOCAL SL32 ystemadj (SL32 left, SL32 right)
#else
MLOCAL SL32 ystemadj (left, right)
register SL32 left;
SL32 right;
#endif
{
	register int i;
	register SL32 width;
	register int sign = 0;
	
	/* real width in pixel space */
	left = scale (gpps->t1ytrans, right - left);
	if (left < 0) {
		/* save sign */
		sign = 1;
		left = -left;
	}

	/* use canonical width if < tolerance, real width otherwise */
	width = T1ROUND (left);
	for (i = 0; i < gpps->numStemSnapH * 3; i += 3) {
		if (left > gpps->stem_refh[i] && left < gpps->stem_refh[i + 1]) {
			width = gpps->stem_refh[i + 2];
			break;
		}
	}
	
	/* clamp at stem_min width */
	if (width < gpps->stem_min)
		width = gpps->stem_min;
	
	/* return with proper sign */
	return (sign ? -width : width);
}

#else /* ANSI requirements for at least 1 external declaration */
int iT1IHINTS = 0;
#endif /* PST1_RDR */

