/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1imap.c,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1imap.c,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.10   18 Apr 1995 16:56:24   JOE
 * 
 * Conditionally compiled cm_cgidToIndex(), cmpgle(), cgnum_list[] and
 * PSdata[] based on !NO_SYMSET_MAPPING.
 * 
 *    Rev 1.9   07 Apr 1995 10:27:30   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.8   22 Apr 1994 14:45:50   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   02 Feb 1994 09:16:50   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.6   15 Jun 1993 11:07:38   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.5   22 Feb 1993 11:07:18   JOE
 * 
 * Not including "search.h" if VXWORKS.
 * 
 *    Rev 1.4   15 Feb 1993 12:06:30   JOE
 * In PSdata[] table, removed "spacing" from the names of several characters.
 * This resolved the acute spacing problem.
 * 
 *    Rev 1.3   12 Feb 1993 15:36:26   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 08:50:32   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 10:00:00   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:22   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:27 $ */
/* t1ipsdat.c */
/*************************************************************************
 *                                                                       *
 *
 *
 *                 Copyright (c) 1989, 1990, 1991 by                     *
 *            Pipeline Associates, Inc., Morris Plains, NJ               *
 *                        All rights reserved.                           *
 *                                                                       *
 *   This software is furnished under a license and may be used and      *
 *   copied  only  in accordance with the terms of such license and      *
 *   with the  inclusion  of  the  above  copyright  notice.   This      *
 *   software  or  any  other copies thereo0f may not be provided or     *
 *   otherwise made available to any other person except as allowed      *
 *   under  license.  No  title to and ownership of the software is      *
 *   hereby transferred.                                                 *
 *                                                                       *
 *   This software is proprietary to Pipeline Associates, Inc., and      *
 *   is not to be disclosed without written permission from Pipeline     *
 *   Associates, Inc.                                                    *
 *                                                                       *
 *                                                                       *
 *  Converts Agfa ID number to TrueType Unicode or PostScript name string.
 *
 *
 *  If the TrueType or Type 1 reader is enabled, character mapping
 *  works as follows:
 *  (1) Do this step only if Type 1 is enabled.
 *      At init time call cm_load_psname(char* pathname), which loads a data
 *      file containing all PostScript character names into dynamic memory.
 *  (2) Call SYMmap(ushort charcode), which maps
 *      (symbol set, character code) ==> Agfa character ID.
 *  (3) Call cm_cgidToIndex(ushort AgID), which searches for the AgID in a
 *      sorted table and returns the index into that table.
 *  (4) Call cm_ixToTTCode(ushort index) or cm_ixToPSName(ushort index).
 *      Uses the index number to look into a table. Returns either a
 *      Microsoft Unicode or a PostScript name.
 *
 ************************************************************************/

/*
REVISION HISTORY
-----------------------------------------------------------------------
09/02/90  jfd	Original. Extracted standard encoding array "stdencoding[]"
               from "t1iscan.c".
10/07/92  jfd  Changed conditional compile statement surrounding PSdata[]
               from "PST1_DISK" to "PST1_RDR".
10/20/92  jfd  Merged CHARMAP.C. into this file. 
               (Formerly known as T1IPSDAT.C)
11/05/92  jfd  Conditionally compiled include file "stdlib.h" based on
               !MIPS.
11/06/92  jfd  Conditionally including "stddef.h" if MIPS.
11/28/92  rs   Conditionally don't include <search.h> on Macintosh.
07-Jan-93 jfd  ANSI C function declaration changes.
08-Feb-93 jfd  VXWorks support.
15-Feb-93 jfd  In PSdata[] table, removed the string "spacing" from the 
               following character names:

               "Caronspacing", "Cedillaspacing", "Gravespacing", 
               "Acutespacing", "Dieresisspacing", "Circumflexspacing", 
               "Tildespacing", "Macronspacing", "Ringspacing", "gravespacing", 
               "acutespacing", "dieresisspacing", "circumflexspacing", 
               "tildespacing", "macronspacing", "ringspacing", 
               "cedillaspacing", "caronspacing", "hungarumlautspacing", 
               "Hungarumlautspacing", "brevespacing", "Brevespacing", 
               "Dotaccentspacing", "dotaccentspacing", "ogonekspacing" and
               "Ogonekspacing"

               This fixes the acute spacing bug.
18-Feb-93 jfd  For VXWORKS, conditionally compiled out "search.h" include.
15-Jun-93  jfd Moved "vxWorks.h" before "port.h" to resolve conflicts.
27-Jan-94 jfd  Conditionallyy compiled out #include for search.h based
               on !defined(_AM29K).
18-Apr-95 jfd  Conditionally compiled cm_CgidToIndex(), cmpgle(),
               cgnum_list[] and PSdata[] based on !NO_SYMSET_MAPPING.
*/

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>
#ifndef MIPS
#include <stdlib.h>
#else
#include <stddef.h>
#endif

#if !defined (MACINTOSH) && !defined(VXWORKS) && !defined(_AM29K)
#include <search.h>
#endif

#if PST1_RDR && !NO_SYMSET_MAPPING	/* conditional compile entire module */ 

#ifdef LINT_ARGS

GLOBAL UW16   cm_cgidToIndex(UW16);
MLOCAL int    cmpgle( UW16*, UW16* );

#else  /* !LINT_ARGS */

GLOBAL UW16   cm_cgidToIndex();
MLOCAL int    cmpgle();
#endif  /* LINT_ARGS */

MLOCAL UW16 cgnum_list[644] = { 643,
        1, 2, 3, 4, 5, 6, 7, 8, 
        9, 10, 11, 12, 13, 14, 15, 16, 
        17, 18, 19, 20, 21, 22, 23, 24, 
        25, 26, 27, 28, 29, 30, 31, 32, 
        33, 34, 35, 36, 37, 38, 39, 40, 
        41, 42, 43, 44, 45, 46, 47, 48, 
        49, 50, 51, 52, 53, 85, 86, 87, 
        88, 93, 96, 97, 98, 99, 106, 172, 
        173, 174, 175, 176, 177, 231, 232, 233, 
        234, 235, 236, 238, 239, 240, 241, 242, 
        243, 244, 245, 246, 247, 248, 249, 250, 
        251, 252, 253, 254, 255, 256, 257, 258, 
        259, 260, 268, 269, 276, 291, 298, 299, 
        306, 307, 308, 349, 363, 364, 365, 366, 
        367, 368, 369, 370, 371, 375, 376, 377, 
        378, 380, 381, 382, 383, 384, 385, 386, 
        387, 389, 390, 391, 392, 411, 412, 423, 
        424, 444, 445, 447, 448, 480, 493, 497, 
        540, 541, 542, 551, 558, 562, 563, 564, 
        565, 566, 567, 568, 569, 570, 571, 572, 
        573, 574, 575, 576, 577, 578, 579, 581, 
        582, 583, 584, 585, 587, 588, 589, 591, 
        593, 594, 595, 596, 597, 599, 719, 720, 
        721, 733, 749, 757, 758, 759, 777, 790, 
        791, 812, 813, 814, 839, 843, 844, 1094, 
        1215, 1219, 1228, 1231, 1234, 1237, 1240, 1241, 
        1242, 1243, 1246, 1248, 1250, 1254, 1261, 1267, 
        1273, 1282, 1283, 1286, 1303, 1307, 1323, 1324, 
        1335, 1374, 1404, 1406, 1407, 1408, 1451, 1565, 
        1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 
        1574, 1575, 1576, 1591, 1592, 1593, 1594, 1595, 
        1596, 1597, 1598, 1599, 1600, 1601, 1602, 1603, 
        1619, 1620, 1621, 1622, 1623, 1624, 1625, 1626, 
        1627, 1628, 1656, 1673, 1674, 1675, 1684, 1700, 
        1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 
        1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 
        1719, 1722, 1725, 1727, 1728, 1751, 1752, 1753, 
        1807, 1825, 1827, 1846, 1847, 1851, 1852, 1853, 
        1854, 1855, 1856, 1857, 1858, 1859, 1860, 1861, 
        1873, 1874, 1878, 1879, 1880, 1881, 1882, 1883, 
        1884, 1885, 1886, 1887, 1888, 1904, 1905, 3171, 
        4662, 4757, 4758, 4759, 4760, 4761, 4767, 4768, 
        4770, 4771, 4793, 7002, 7004, 7005, 7006, 7009, 
        7018, 7248, 7249, 7250, 7251, 7252, 7253, 7254, 
        7255, 7256, 7257, 7258, 7259, 7260, 7274, 7275, 
        7276, 7277, 7278, 7279, 7280, 7281, 7282, 7283, 
        7284, 7286, 7287, 7291, 7295, 7297, 7304, 7305, 
        7306, 7307, 7308, 7309, 7310, 7311, 7312, 7313, 
        7314, 7315, 7316, 7317, 7318, 7319, 7320, 7321, 
        7322, 7323, 7345, 7346, 7347, 7348, 7349, 7350, 
        7378, 7379, 7380, 7381, 7382, 7383, 7384, 7385, 
        7386, 7387, 7388, 7389, 7390, 7391, 7392, 7393, 
        7394, 7395, 7396, 7397, 7398, 7399, 7400, 7401, 
        7402, 7403, 7404, 7405, 7406, 7407, 7408, 7409, 
        7410, 7411, 7412, 7413, 7414, 7415, 7416, 7417, 
        7418, 7419, 7420, 7421, 7422, 7423, 7424, 7425, 
        7426, 7427, 7428, 7429, 7430, 7431, 7432, 7433, 
        7434, 7435, 7436, 7437, 7438, 7439, 7440, 7441, 
        7442, 7444, 7445, 7446, 7447, 7448, 7449, 7450, 
        7451, 7452, 7453, 7454, 7455, 7456, 7457, 7458, 
        7459, 7460, 7461, 7462, 7463, 7464, 7466, 7467, 
        7468, 7469, 7470, 7471, 7472, 7473, 7474, 7475, 
        7476, 7477, 7478, 7479, 7480, 7481, 7482, 7483, 
        7484, 7485, 7486, 7487, 7488, 7489, 7490, 7491, 
        7492, 7493, 7494, 7495, 7496, 7497, 7498, 7499, 
        7500, 7501, 7502, 7503, 7504, 7505, 7506, 7507, 
        7508, 7509, 7510, 7511, 7512, 7513, 7514, 7515, 
        7516, 7517, 7518, 7519, 7520, 7521, 7522, 7523, 
        7524, 7525, 7526, 7527, 7528, 7529, 7530, 7531, 
        7532, 7533, 7534, 7535, 7536, 7537, 7538, 7539, 
        7540, 7541, 7542, 7543, 7544, 7545, 7546, 7547, 
        7548, 7549, 7550, 7551, 7552, 7553, 7554, 7555, 
        7556, 7557, 7558, 7559, 7560, 7561, 7562, 7563, 
        7564, 7565, 7566, 7567, 7568, 7569, 7570, 7571, 
        7572, 7573, 7574, 7575, 7576, 7577, 7578, 7579, 
        7580, 7581, 7582, 7583, 7584, 7585, 7586, 7587, 
        7588, 7589, 7590, 7591, 7592, 7593, 7594, 7595, 
        7596, 7597, 7598, 7599, 7600, 7601, 7602, 7603, 
        7604, 7605, 7607, 7608, 7609, 7610, 7611, 7612, 
        7613, 7615, 7616, 7617, 7618, 7619, 7620, 7621, 
        7622, 7623, 7679 };


/*
 *  Search sorted array of CGID numbers for chId
 */
#if defined (ANSI_DEFS)
GLOBAL UW16  cm_cgidToIndex( UW16 chId )
#else
UW16 
GLOBAL cm_cgidToIndex( chId )
   UW16 chId;
#endif
{
UW16 *result;

result = (UW16 *)bsearch( (void *)&chId, (void *)(cgnum_list + 1),
                           (size_t)*cgnum_list, sizeof(UW16),
#ifdef LINT_ARGS /* add cast - 5/6/92 - rs */
                           (int (*)(const void *, const void *))cmpgle );
#else
                           (int (*)())cmpgle );
#endif
if (result == NULL)
    return (UW16)0;
else
    return (result - cgnum_list);
}


#if defined (ANSI_DEFS)
MLOCAL int cmpgle( UW16* key, UW16* data )
#else
MLOCAL int 
cmpgle( key, data )
   UW16* key;
   UW16* data;
#endif
{
if (*key > *data)
    return 1;
else if (*key < *data)
    return -1;
else
    return 0;
}

#endif  /* PST1_RDR && !NO_SYMSET_MAPPING */

#if (PST1_RDR && USE_UFST_MAPPING && !NO_SYMSET_MAPPING)

  /* This table eliminates the need for the "psname.cfg" data file
     as well as the functions cm_load_psname() and cm_free_psname().
   */

GLOBAL LPSB8 PSdata[644] =
{ "",
"t", "o", "h", "n", "m", "l", "r", "g",
"i", "p", "c", "v", "e", "z", "d", "b",
"s", "y", "f", "x", "a", "w", "j", "u",
"q", "k", "T", "O", "H", "N", "M", "L",
"R", "G", "I", "P", "C", "V", "E", "Z",
"D", "B", "S", "Y", "F", "X", "A", "W",
"J", "U", "Q", "K",
"ampersand", "exclam", "question", "quoteleft",
"quoteright", "sfthyphen", "guillemotleft", "guillemotright",
"exclamdown", "questiondown", "exclamdbl", "AE",
"OE", "ae", "oe", "ij",
"germandbls", "agrave", "aacute", "adieresis",
"acircumflex", "atilde", "aring", "ccedilla",
"egrave", "eacute", "edieresis", "ecircumflex",
"dotlessi", "iacute", "igrave", "idieresis",
"icircumflex", "ntilde", "oacute", "ograve",
"odieresis", "ocircumflex", "oslash", "uacute",
"ugrave", "udieresis", "ucircumflex", "otilde",
"abreve", "ecaron", "ractue", "rcaron",
"Ccedilla", "Oslash", "tcedilla", "tcaron",
"odblacute", "udblacute", "dmacron", "IJ",
"Eth", "Thorn", "eth", "thorn",
"Yacute", "yacute", "Gbreve", "Scedilla",
"Idot", "Aogonek", "Cacute", "Eogonek",
"Nacute", "Sacute", "Zacute", "Zdot",
"aogonek", "cacute", "eogonek", "lslash",
"nacute", "sacute", "zacute", "zdot",
"Lslash", "Odblacute", "Udblacute", "guilsinglright",
"guilsinglleft", "quotedblleft", "quotedblright", "uring",
"Uring", "prescription", "copyrightlarge", "trademarksans",
"Ccaron", "Zcaron", "Scaron", "Egrave",
"Odieresis", "Tcedilla", "Adieresis", "Aring",
"Aacute", "Agrave", "Acircumflex", "Atilde",
"Ocircumflex", "Eacute", "Ecircumflex", "Edieresis",
"Igrave", "Iacute", "Icircumflex", "Idieresis",
"Ntilde", "Ograve", "Oacute", "Otilde",
"Uacute", "Ugrave", "Ucircumflex", "Udieresis",
"Dcaron", "Lcaron", "Ncaron", "Tcaron",
"ccaron", "dcaron", "lcaron", "ncaron",
"scaron", "zcaron", "Ecaron", "ydieresis",
"Ydieresis", "Abreve", "franc", "Lacute",
"lacute", "Racute", "Rcaron", "quotesinglbase",
"registersans", "space", "enspacereverse", "emspacereverse",
"perthousand", "gbreve", "scedilla", "quotedblbase",
"Gamma", "Delta", "Sigma", "Theta",
"Phi", "Omega", "alpha", "beta",
"delta", "eta", "mu", "pi",
"sigma", "epsilon", "tau", "approxequal",
"equivalence", "register2", "copyright2", "radical",
"opensquare", "encirclemedium", "greaterequal", "lessequal",
"intersection", "phi", "filledbox", "embulletsolid",
"encircleopen", "bullet", "emboxopen1", "period",
"comma", "colon", "semicolon", "parenleft",
"parenright", "bracketleft", "bracketright", "hyphen",
"endash", "emdash", "slash", "nsuperior",
"one", "two", "three", "four",
"five", "six", "seven", "eight",
"nine", "zero", "dollar", "cent",
"onesuperior", "twosuperior", "threesuperior", "foursuperior",
"fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior",
"ninesuperior", "zerosuperior", "fraction", "onehalf",
"onequarter", "threequarters", "periodcentered", "sterling",
"percent", "florin", "plus", "minus",
"plusminus", "equal", "multiply", "divide",
"ordfeminine", "ordmasculine", "degree", "dagger",
"daggerdbl", "section", "paragraph", "asterisk",
"numbersign", "ellipsis", "yen", "minute",
"second", "thinspace", "enspace", "emspace",
"peseta", "currency", "backslash", "ogonek",
"hungarumlaut", "cedilla", "acute", "grave",
"dieresis", "circumflex", "tilde", "ring",
"caron", "macron", "breve", "dotaccent",
"Ogonek", "Hungarumlaut", "Cedilla", "Acute",
"Grave", "Dieresis", "Circumflex", "Tilde",
"Ring", "Caron", "Macron", "Breve",
"Dotaccent", "middot", "Catalan", "careofscript",
"carriagereturn", "fi", "fl", "ff",
"ffi", "ffl", "registered", "copyright",
"trademark", "slogan", "carriagereturn1", "triagdn",
"triagup", "triaglf", "triagrt", "emboxsolid",
"logicalnot", "liter", "at", "braceleft",
"braceright", "enboxsolid", "enboxopen", "trademark",
"quotesingle", "quotedbl", "visibledischyphen", "embox",
"arrowtab", "hardspace", "overscore", "underscoredbl",
"revlogicalnot", "logicalnotflopped", "greater", "less",
"asciicircum", "bar", "underscore", "asciitilde",
"asciigrave", "brokenbar", "apostrophen", "Ldot",
"ldot", "lira", "Caron", "Cedilla",
"Grave", "Acute", "Dieresis", "Circumflex", 
"Tilde", "Macron", "Ring", "grave", 
"acute", "dieresis", "circumflex", "tilde", 
"macron", "ring", "cedilla", "caron", 
"hungarumlaut", "Hungarumlaut", "breve", "Breve", 
"Dotaccent", "dotaccent", "ogonek", "Ogonek",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"block", "dnblock", "upblock",
"lfblock", "rtblock", "filledrect", "dkshade",
"ltshade", "shade", "heart", "diamond",
"club", "spade", "smileface", "invsmileface",
"musicalnote", "musicalnotedbl", "female", "male",
"compass", "circle", "emcircleopen", "invbullet",
"invcircle", "infinity", "integraltp", "integralbt", 
"arrowdown", "arrowup", "arrowleft", "arrowright", 
"arrowupdn", "arrowupdnbse", "arrowboth", "northwestarrow", 
"northeastarrow", "southeastarrow", "southwestarrow",
"arrowdblleft", "arrowdblright", "arrowdbldown", "arrowdblup",
"arrowdblboth", "doublearrowupdown", "radical", "isproportionalserif",
"baseofnaturallog", "Epsilon", "therefore", "Gamma",
"Delta", "Theta", "Lambda", "Xi",
"product", "Sigma", "Upsilon", "Phi",
"Psi", "Omega", "gradient", "partialdiff",
"sigma1", "notequal", "summationbottomrule", "alpha",
"beta", "gamma", "delta", "epsilon",
"zeta", "eta", "theta", "iota",
"kappa", "lambda", "mu", "nu",
"xi", "omicron", "pi", "rho",
"sigma", "tau", "upsilon", "phi",
"chi", "psi", "omega", "theta1",
"phiopenalternate", "pialternate", "approximatelyequal", "notidenticalwith",
"rghtarrwoverleftarrw", "reversiblereaction", "vectorsymbol", "summationtoprule",
"universal", "existential", "perpndiclarupsidedwn", "perpendicular",
"union", "element", "suchthat", "notelement",
"propersubset", "propersuperset", "notsubset", "doesnotcontain",
"reflexsubset", "reflexsuperset", "circleplus", "sun",
"circlemultiply", "abstractminus", "abstractdivide", "logicaland",
"logicalor", "exclusiveor", "functionalcomposite", "circlelarge",
"perpendicularleft", "perpendicularright", "integral", "contourintegral",
"orthogonal", "emptyset", "Aleph", "Beth",
"Gimel", "cblackletter", "iblackletter", "Rfraktur",
"zblackletter", "bracketlefttp", "bracketleftbt", "bracelefttp",
"braceleftmid", "braceleftbt", "contourintegcenter", "summationtoplftcrner",
"centerlinedbl", "summatnbottmlftcrner", "summationlowerdiag", "bracketrighttp",
"bracketrightbt", "bracerighttp", "bracerightmid", "bracerightbt",
"braceverticalpiece", "histogram", "radicalcomposite", "summationtopright",
"summationcenterpiece", "summationbottomright", "summationupperdiag", "minusplus",
"obtuselessthan", "obtusegreaterthan", "masksymbol", "congruent",
"triangleup", "triangleright", "triangledown", "triangleleft",
"muchlessthan", "muchgreaterthan", "identical", "definedas",
"Digamma", "plancksconstant", "lagrangian", "powerset",
"weierstrass", "summation", "bracketleftdouble", "bracketdoublemiddle",
"bracketrightdouble", "quartercircletopleft", "qrtrcrclbottomleft", "unioncompositemiddle",
"intersection", "union", "brackleftdbltp", "brackleftdblebottom",
"lozenge", "quartrcircletopright", "qrtrcirclbottomright", "productbottom",
"producttop", "brackrghtdbltop", "brackleftdblbottom", "diamond",
"suchthatrotated", "asterisk", "arrowextndrsnglhoriz", "arrowextndrdblehoriz",
"revsummationcenter", "because", "house", "rightanglesymbol",
"apple"
};

#endif /* (PST1_DISK && USE_UFST_MAPPING && !NO_SYMSET_MAPPING) */

#if PST1_RDR	/* conditional compile entire module */ 

/*
Encoding stuff

Clean up 3/24/92 - rs : replace 'NOTDEF' with 'NULL' to eliminate problem
of dealing with handles to NOTDEF if not standardencoding.
*/

GLOBAL SB8 NOTDEF[] = ".notdef";

GLOBAL LPSB8  stdencoding[256] =
{
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  "space",  "exclam",  "quotedbl",  "numbersign",
  "dollar",  "percent",  "ampersand",  "quoteright",
  "parenleft",  "parenright",  "asterisk",  "plus",
  "comma",  "hyphen",  "period",  "slash",
  "zero",    "one",    "two",    "three",
  "four",    "five",    "six",    "seven",
  "eight",  "nine",    "colon",  "semicolon",
  "less",    "equal",  "greater",  "question",
  "at",    "A",    "B",    "C",
  "D",    "E",    "F",    "G",
  "H",    "I",    "J",    "K",
  "L",    "M",    "N",    "O",
  "P",    "Q",    "R",    "S",
  "T",    "U",    "V",    "W",
  "X",    "Y",    "Z",    "bracketleft",
  "backslash",  "bracketright",  "asciicircum",  "underscore",
  "quoteleft",  "a",    "b",    "c",
  "d",    "e",    "f",    "g",
  "h",    "i",    "j",    "k",
  "l",    "m",    "n",    "o",
  "p",    "q",    "r",    "s",
  "t",    "u",    "v",    "w",
  "x",    "y",    "z",    "braceleft",
  "bar",    "braceright",  "asciitilde",  NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,      "exclamdown",  "cent",    "sterling",
  "fraction",  "yen",    "florin",  "section",
  "currency",  "quotesingle",  "quotedblleft",  "guillemotleft",
  "guilsinglleft","guilsinglright","fi",    "fl",
  NULL,      "endash",  "dagger",  "daggerdbl",
  "periodcentered",NULL,      "paragraph",  "bullet",
  "quotesinglbase","quotedblbase","quotedblright","guillemotright",
  "ellipsis",  "perthousand",  NULL,      "questiondown",
  NULL,      "grave",  "acute",  "circumflex",
  "tilde",  "macron",  "breve",  "dotaccent",
  "dieresis",  NULL,      "ring",    "cedilla",
  NULL,      "hungarumlaut",  "ogonek",  "caron",
  "emdash",  NULL,      NULL,      NULL,  
  NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,    NULL,  
  NULL,      NULL,      NULL,      NULL,  
  NULL,      "AE",    NULL,      "ordfeminine",
  NULL,      NULL,      NULL,      NULL,  
  "Lslash",  "Oslash",  "OE",    "ordmasculine",
  NULL,      NULL,      NULL,      NULL,  
  NULL,      "ae",    NULL,      NULL,  
  NULL,      "dotlessi",  NULL,      NULL,  
  "lslash",  "oslash",  "oe",    "germandbls",
  NULL,      NULL,      NULL,      NULL
};




#else /* ANSI requirements for at least 1 external declaration */
int iT1IMAP = 0;
#endif /* PST1_RDR */

