/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1imm.c,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1imm.c,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   07 Apr 1995 10:27:32   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   25 Jul 1994 11:50:36   JOE
 * 
 * In MMsetdesignvec(), moved initialization of structures fpone and
 * fp1sl16 to within function instead of at declaration time to resolve
 * compiler error.
 * 
 *    Rev 1.4   22 Apr 1994 14:45:38   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   26 Jul 1993 11:48:14   ROB
 * Add support for 'T1REMASTER'.
 * 
 *    Rev 1.2   13 Jul 1993 13:07:28   JOE
 * 
 * Set "iT1IMM" = 0 if !(PST1_RDR && T1MMASTER).
 * 
 *    Rev 1.1   21 Jun 1993 09:08:48   JOE
 * Changed include statement (t1iproto.h instead of t1iprotos.h).
 * 
 *    Rev 1.0   08 Jun 1993 18:16:16   ROB
 * Initial revision.
 * 
*/
/* $Date: 2003/05/07 23:02:27 $ */

/* t1imm.c Multiple Master standalone support code */
/************************************************************************
 *									*
 *			Copyright (c) 1990, 1991 by			*
 *		Pipeline Associates, Inc., Morris Plains, NJ		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person except as allowed	*
 *   under  license.  No  title to and ownership of the software is	*
 *   hereby transferred.						*
 *									*
 *   This software is proprietary to Pipeline Associates, Inc., and	*
 *   is not to be disclosed without written permission from Pipeline	*
 *   Associates, Inc.							*
 *									*
 ************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
Version 3.0 -- original
06-Jun-93  rs  Integrate Pipeline code into UFST.
16-Jun-93  jfd Changed include statement (t1iprotos.h to t1iproto.h).
13-Jul-93  jfd Set "iT1IMM" = 0 if !(PST1_RDR && T1MMASTER).
23-Jul-93  rs  Add support for 'T1REMASTER'.
25-Jul-94  jfd In MMsetdesignvec(), moved initialization of structures
               fpone and fp1sl16 to within function instead of at
               declaration time to resolve compiler error.
*/

#include "cgconfig.h"

#if (PST1_RDR && T1MMASTER)

#include "port.h"
#include "debug.h"
#include "ifmem.h"
#include "cgif.h"
#if T1REMASTER
#include "fpmath.h"
#endif
#include "ix.h"

#include "t1itype1.h"
#include "t1iproto.h"

/*
Function prototypes
*/
#ifdef LINT_ARGS
GLOBAL int MMsetup (VOID);
#else
GLOBAL int MMsetup ();
#endif /* LINT_ARGS */


/*
** set up rasterizer values from Multiple Master arrays via interpolation
*/
GLOBAL int MMsetup ()
{
	register int i, j;
	register SL32 tmp;
    LPSW16 pMMblues;
	SW16 blues[MAXBLUES];

	if (gpps->MMnaxes == -1)
		return (SUCCESS); /* we're called on all fonts, just return */

	/* compute StdHW */
	if (gpps->Weightvals && gpps->MMstdhw && gpps->Weightvals == gpps->MMnstdhw)
   {
		for (tmp = 0L, i = 0; i < gpps->MMnstdhw; i++)
			tmp += gpps->weights[i] * (gpps->MMstdhw[i]);
		tmp = (tmp + (1 << 15)) >> 16;	/* round */
		stdhwx ((SW16)tmp);
	}
	/* compute StdVW */
	if (gpps->Weightvals && gpps->MMstdvw && gpps->Weightvals == gpps->MMnstdvw)
   {
		for (tmp = 0L, i = 0; i < gpps->MMnstdvw; i++)
			tmp += gpps->weights[i] * (gpps->MMstdvw[i]);
		tmp = (tmp + (1 << 15)) >> 16;	/* round */
		stdvwx ((SW16)tmp);
	}
	/* compute BlueValues */
	if (gpps->Weightvals && gpps->hMMblues)
   {
       pMMblues = (LPSW16)MEMptr (gpps->hMMblues);
		for (i = 0; i < gpps->MMnblues / gpps->Weightvals; i++)
      {
			for (tmp = 0L, j = 0; j < gpps->Weightvals; j++)
				tmp += gpps->weights[j] * (pMMblues[i * gpps->Weightvals + j]);
			blues[i] = (SW16)(tmp + (1 << 15)) >> 16;	/* round */
		}
		blue_values (blues, gpps->MMnblues / gpps->Weightvals);
	}
	/* compute OtherBlues */
	if (gpps->Weightvals && gpps->hMMotherblues)
   {
        pMMblues = (LPSW16)MEMptr (gpps->hMMotherblues);
		for (i = 0; i < gpps->MMnotherblues / gpps->Weightvals; i++)
        {
			for (tmp = 0L, j = 0; j < gpps->Weightvals; j++)
				tmp +=
               gpps->weights[j] * (pMMblues[i * gpps->Weightvals + j]);
			blues[i] = (SW16)(tmp + (1 << 15)) >> 16;	/* round */
		}
		other_blues (blues, gpps->MMnotherblues / gpps->Weightvals);
	}
   return (SUCCESS);
}

#if T1REMASTER
/*
** compute interpolation array (WeightVector) from design vector
*/
#if 0 /* original Pipeline interface 7/23/93 - rs */
GLOBAL int MMsetdesignvec (vector)
register int *vector;
#endif

#ifdef LINT_ARGS
GLOBAL int MMsetdesignvec (PFPNUM vector)
#else
GLOBAL int MMsetdesignvec (vector)
PFPNUM vector;
#endif
{
register int i, j;
FPNUM tmpvec[MAXAXES];
PFPNUM pMMblendmap;
FPNUM ftmp0, ftmp1, ftmp2, fpone, fp1sl16;

   fpone = fpint2fp (1L);
   fp1sl16 = fpint2fp (1L << 16);

	if (!gpps->MMnblendmap)
		return (SUCCESS);
	if (fpiszero (fpadd (fpone, vector[0]))) /* if *vector == -1, just exit */
		return (SUCCESS);

   /*
      If the count is !0, the handle better be valid!
   */
   pMMblendmap = (PFPNUM)MEMptr (gpps->hMMblendmap);
   
   /*
	** normalize design rules from 0 to 1
	** interpolate based on BlendDesignMap array
	*/
	for (i = 0, j = 0; i < gpps->MMnaxes && j < gpps->MMnblendmap; i++)
   {
		/* first entry in blend map better be zero */
		if (!fpiszero (pMMblendmap[j + 1]))
			return (ERR_psi_badMMblendmap);

#if 0 /* substitute following block of code - 7/23/93 - rs */
		/* find vector corresponding to incoming value */
		for (j += 2; vector[i] > MMblendmap[j]; j += 2) {
      {
			if (pMMblendmap[j + 1] == 1)
				break;
		}
#endif /* 0 */

/*
NEW BLOCK OF CODE
*/
		/* find vector corresponding to incoming value */

   j += 2;
   do
   {
      ftmp0 = fpsub (vector[i], pMMblendmap[j]);
      if (fpisneg (ftmp0) || fpiszero (ftmp0))
         break;
		if fpiszero ((fpsub (pMMblendmap[j + 1], fpone)))
         break;
      j += 2;
   } while (1);
/*
END OF NEW BLOCK
*/

		/* now normalize value */
		tmpvec[i] = fpsub (vector[i], pMMblendmap[j - 2]);
		tmpvec[i] = fpmul (fpdiv (fpadd (pMMblendmap[j - 1], tmpvec[i]),
			fpsub (pMMblendmap[j], pMMblendmap[j - 2])),
			    fpsub (pMMblendmap[j + 1], pMMblendmap[j - 1]));
		j += 2;
	}

	/* up to three design axes for now */
	/* number of weights == 2^naxes */
   ftmp0 = fpsub (fpone, tmpvec[0]);
   ftmp1 = fpsub (fpone, tmpvec[1]);
   ftmp2 = fpsub (fpone, tmpvec[2]);
	switch (gpps->MMnaxes)
   {
		case 1:
			gpps->weights[0] = fp2long ( fpmul (ftmp0, fp1sl16));
			gpps->weights[1] = (1L << 16) - gpps->weights[0];
			break;
		case 2:
			gpps->weights[0] = fp2long (fpmul (fpmul (ftmp0, ftmp1), fp1sl16));
			gpps->weights[1] = fp2long (fpmul (fpmul (tmpvec[0], ftmp1), fp1sl16));
			gpps->weights[2] = fp2long (fpmul (fpmul (ftmp0, tmpvec[1]), fp1sl16));
			gpps->weights[3] = fp2long (fpmul (fpmul (tmpvec[0], tmpvec[1]),
                                fp1sl16));
			break;
		case 3:
			gpps->weights[1] = fp2long (fpmul (fpmul (fpmul (tmpvec[0], ftmp1),
                                     ftmp2), fp1sl16));
			gpps->weights[2] = fp2long (fpmul (fpmul (fpmul (ftmp0, tmpvec[1]),
                                     ftmp2), fp1sl16));
			gpps->weights[3] = fp2long (fpmul (fpmul (fpmul (tmpvec[0], tmpvec[1]),
				                         ftmp2), fp1sl16));
			gpps->weights[4] = fp2long (fpmul (fpmul (fpmul (ftmp0, ftmp1),
				                         tmpvec[2]), fp1sl16));
			gpps->weights[5] = fp2long (fpmul (fpmul (fpmul (tmpvec[0], ftmp1),
				                         tmpvec[2]), fp1sl16));
			gpps->weights[6] = fp2long (fpmul (fpmul (fpmul (ftmp0, tmpvec[1]),
				                         tmpvec[2]), fp1sl16));
			gpps->weights[7] = fp2long (fpmul (fpmul (fpmul (tmpvec[0], tmpvec[1]),
				                         tmpvec[2]), fp1sl16));

			/* sum weights and subtract from one */
			gpps->weights[0] = 0L;
			for (i = 1; i < 8; i++)
				gpps->weights[0] += gpps->weights[i];
			gpps->weights[0] = (1L << 16) - gpps->weights[0];
			break;
		case 4:
			/* don't know the right formula yet */
         DBG ("MMsetdesignvec() - Don't know how to handle this formula - Pipeline\n");
			break;
	}
	/* now install the new values */
	return (MMsetup ());
}
#endif /* T1REMASTER */

#else
int iT1IMM = 0;
#endif /* (PST1_RDR && T1MMASTER) */
