/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1ipcleo.c,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1ipcleo.c,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.13   07 Apr 1995 10:27:20   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   22 Apr 1994 14:45:42   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.11   29 Sep 1993 12:18:56   JOE
 * 
 * In PSPCLload_font(), save font bounding box information from PSEO.
 * 
 *    Rev 1.10   21 Jun 1993 09:14:46   JOE
 * Corrected include statement (t1iproto.h instead of t1iprotos.h).
 * 
 *    Rev 1.9   15 Jun 1993 11:12:54   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.8   14 Jun 1993 17:15:26   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.7   08 Jun 1993 18:27:52   ROB
 * Pipeline upgrade for type 1 quality improvements.
 * 
 *    Rev 1.6   05 May 1993 17:21:54   ROB
 * Modify PSPCLload_font() to support unbound PSEOs by getting the font
 * descriptor size from the PSEO instead of hard wiring 80 bytes.
 * 
 *    Rev 1.5   30 Apr 1993 16:45:38   ROB
 * Add support to 'PSPCLload_font()' to read 'StemSnapH' & 'StemSnapV' values
 * from PSEO.
 * 
 *    Rev 1.4   24 Mar 1993 15:18:36   JOE
 * Fix for oblique fonts.
 * 
 *    Rev 1.3   12 Feb 1993 15:42:00   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 08:54:28   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:59:36   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:12   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:27 $ */
/* t1ipcleo.c - UFST PostScript Type 1 PCLEO reader

************************************************************************

REVISION HISTORY
-----------------------------------------------------------------------
19-Mar-92  rs	Original file created (cloned from 'pcleoutl.c'.
03-Apr-92  rs  Portability cleanup (see port.h).
21 May 92  ss  In pcpcl_get_subrs() changed declaration of subnum to SW16
               to ensure it is a word at all times. Needed for portability.
11-Jun-92 rs/jd Update error codes.
1 Jul 92  ss   Moved port.h to top to access defines earlier.
               Conditionally compile stdlib for !MIPS.  This may also be
               relevant for other UNIX SysV systems.
14-Aug-92 rs   Fix conditional problem for Watcom C386 - include 'string.h'
               instead of 'memory.h'.
25-Sep-92 jfd  INTEL960 conditional compiles.
07-Jan-93 jfd  ANSI C function declaration changes.
08-Feb-93 jfd  VXWorks support.
23-Mar-93 rs   Modify UPSFH struct - add PSEOFormat & change FontMatrix from
               long[6] to (char *)[6].
30-Apr-93 rs   Add support to read StemSnapH & StemSnapV values from PSEO in
               'PSPCLload_font()'.
05-May-93 rs   Modify PSPCLload_font() to use value of font descriptor size
               from PSEO instead of hard wiring 80. This helps support
               unbound PSEOs.
15-May-93 rs   Changes to support Pipeline upgrade.
03-Jun-93 jfd  Added function pspcl_get_encoding() and call to function in
               PSPCLload_font().
               Added error codes ERR_psi_EncStr_mem and ERR_psi_Encdat_mem.
07-Jun-93 jfd  Editted pspcl_get_encoding() to skip over encoding data
               since it is never accessed by UFST.
15-Jun-93  jfd Moved "vxWorks.h" before "port.h" to resolve conflicts.
16-Jun-93  jfd Changed include statement (t1iprotos.h to t1iproto.h).
28-Sep-93  jfd In PSPCLload_font(), save font bounding box information
               from PSEO.
*/

#include "cgconfig.h"

#if PST1_PCLEOI

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>
#if defined (__WATCOMC__) || defined(__i960) || defined(VXWORKS) || defined (MSDOS)
#include <string.h>
#else
#include <memory.h>
#endif

#ifndef MIPS
#include <stdlib.h> /* atof() if not using internal FP - 5/8/92 - rs */
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "fpmath.h" /* add 5/8/92 for 'fpatof()' - rs */
#include "t1ipcleo.h"
#include "cgif.h"
#include "ix.h"
#include "t1itype1.h"
#include "t1iproto.h"



#ifdef LINT_ARGS
EXTERN MEM_HANDLE   BUFalloc(SL32);

MLOCAL int	pspcl_get_subrs (LPUB8);

GLOBAL UW16 PSPCLload_font (LPUB8);

MLOCAL int	pspcl_get_encoding (LPUB8, LPUB8 *);
#else /* not LINT_ARGS */
EXTERN MEM_HANDLE   BUFalloc();

MLOCAL int	pspcl_get_subrs ();

GLOBAL UW16 PSPCLload_font ();

MLOCAL int	pspcl_get_encoding ();
#endif /* LINT_ARGS */


MLOCAL PBUCKET 		pxb;
MLOCAL PPS_BUCK   	pps;


#if defined (ANSI_DEFS)
GLOBAL UW16 PSPCLload_font (LPUB8 ph)
#else
GLOBAL UW16 PSPCLload_font (ph)
LPUB8  ph;
#endif
/*
Load a PostScript Type 1 PCLEO

skip over the standard HP PCLEO header
load the PostScript specific 'global data' into our bucket
bucket should be initialized prior to getting here (ie 0's)

global values:
	gpxb = ptr to our bucket
	gpps = ptr to our PS specific bucket

return (SUCCESS), else error code
*/
{
SW16        tmpwarray[MAXSTEMS];
SW16			tw;
SL32        tl;
int			j, k, status = SUCCESS;
LPUB8       newph; /* used to process encoding arrays */

	DBG ("\nPSPCLload_font()\n");

	pxb = gpxb;
	pps = gpps;
	UNPACK_WORD((LPUB8)&tw);		/* get font descriptor size */
	ph += ((UL32)tw - 2L);         /* point to PS global data */
	while ((UL32)ph & 0x03)	      /* align to QUADWORD */
		ph++;

   /*
      We will use the old code to be backward compatible.
      If the first long == '1', this is the new format.
      Another test is if the 1st 24 bytes == 0, then old format.
   */
	UNPACK_LONG((LPUB8)&tl);		/* get format */
   if (tl != 1L)
   {
   /* already added 4 to 'ph' for 1 long (add anothre (6-1) longs) */
      ph += (5 * sizeof(UL32));     /* skip reserved1 */
	/*
		Set up default FontMatrix [.001 0 0 .001 0 0]
	*/
	pps->fontmatrix[0] = pps->fontmatrix[3] =  fpatof (".001");
	pps->fontmatrix[1] = pps->fontmatrix[2] = pps->fontmatrix[4] =
		pps->fontmatrix[5] = fpatof ("0");
   } /* else if (tl == 1L) */
   else
   {
      for (j = 0; j < 6; j++)
      {

         k = strlen ((LPSB8)ph);
         pps->fontmatrix[j] = fpatof ((LPSB8)ph);
         ph += k+1;
      }
      /* quad align the ptr */
      while ((unsigned long)ph & 0x3L)
         ph++;
   } /* if (tl != 1L) */

	UNPACK_LONG((LPUB8)&pxb->tfnum);		/* get UniqueID */

	UNPACK_LONG((LPUB8)&pps->iBlueScale);

	UNPACK_WORD((LPUB8)&tw);		/* get Weight */
	if (tw > 550)
		pxb->bucket_num |= B_BOLD;

	UNPACK_WORD((LPUB8)&tw);		/* get ItalicAngle */
	if (tw)
		pxb->bucket_num |= B_ITALIC;

   /* skip IsFixedPitch, UnderLinePosition, UnderlineThickness */
   ph += (3 * sizeof(UW16));

	UNPACK_WORD((LPUB8)&tw);		/* get FontType */
	if (tw != 1)			         /* only handle Type 1 fonts */
		return (ERR_psi_pcleo_not1);

  /* Save font bounding box   9-28-93 jfd */

   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pps->FontBBox[0] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pps->FontBBox[1] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pps->FontBBox[2] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pps->FontBBox[3] = (SW16)tw;

	UNPACK_WORD((LPUB8)&tw);		/* get # of BlueValues */
	pps->numbblues = pps->numtblues = 0;
	if (tw)
	{
		for (j = 0; j < tw; j++)
		{
			if (j < 2)
         {
				UNPACK_WORD((LPUB8)&pps->bot_blues[pps->numbblues]); /* get a BlueValues */
            pps->numbblues++;
         }
			else
         {
				UNPACK_WORD((LPUB8)&pps->top_blues[pps->numtblues]); /* get a BlueValues */
            pps->numtblues++;
         }
		}
	} /* if (tw) */

   /*
      skip past the dummy BlueValues
   */
   ph += ((14 - tw) * sizeof(UW16));

	UNPACK_WORD((LPUB8)&tw);		/* get # of OtherBlues */
	ph += (10 * sizeof(UW16));    /* skip past OtherBlues */

	UNPACK_WORD((LPUB8)&tw);		/* get # of FamilyBlues */
	ph += (14 * sizeof(UW16));		/* skip past FamilyBlues */

	UNPACK_WORD((LPUB8)&tw);		/* get # of FamilyOtherBlues */
	ph += (10 * sizeof(UW16));		/* skip past FamilyOtherBlues */

	UNPACK_WORD((LPUB8)&pps->iBlueShift);

	UNPACK_WORD((LPUB8)&pps->BlueFuzz);

	UNPACK_WORD((LPUB8)&pps->StdHW);
	UNPACK_WORD((LPUB8)&pps->StdVW);

	UNPACK_WORD((LPUB8)&tw); /* get # of StemSnapH values */
   for (j = 0; j < 12; j++)
   {
	   UNPACK_WORD((LPUB8)&tmpwarray[j]); /* get StemSnapH value */
   }
   stemsnaph ((LPSW16)tmpwarray, tw);

	UNPACK_WORD((LPUB8)&tw); /* get # of StemSnapV values */
   for (j = 0; j < 12; j++)
   {
	   UNPACK_WORD((LPUB8)&tmpwarray[j]); /* get StemSnapV value */
   }
   stemsnapv ((LPSW16)tmpwarray, tw);

	UNPACK_WORD((LPUB8)&tw);		/* get ForceBold */
	if (tw)
		pxb->bucket_num |= B_BOLD;

	ph += sizeof(UW16);			   /* skip past LanguageGroup */

	UNPACK_WORD((LPUB8)&pps->lenIV);

	ph += (12 * sizeof(UW16));	   /* skip past Reserved2 */

   /*
      Skip over encoding array data if present.
      This info is not presently needed by nor used by UFST.
  */
   newph = ph;
   status = pspcl_get_encoding(ph, &newph);
   ph = newph;

	status = pspcl_get_subrs (ph);

	return (status);
}


#if defined (ANSI_DEFS)
MLOCAL int	pspcl_get_encoding (LPUB8 ph, LPUB8 *newph)
#else
MLOCAL int	pspcl_get_encoding (ph, newph)
LPUB8 ph;
LPUB8 *newph;
#endif
/*
Read PostScript PCLEO encoding array

return (SUCCESS), else error code
*/
{
SW16	numEncodingChars, namelen, charId, encnum, j;
PMEM_HANDLE   pencs;
LPSB8 s;

	DBG ("\npspcl_get_encoding()\n");

   *newph = ph;

   if (strncmp(ph, "Encoding array", 14) != 0)
      return SUCCESS;;

   ph += 14;

	UNPACK_WORD((LPUB8)&numEncodingChars);	/* get # of encoding array chars */
   DBG1 ("numEncodingChars:%d ", numEncodingChars);

#if 0 /* This data is not needed by nor used by UFST for downloads */
   pps->hencodearray = BUFalloc ((SL32)(256 * sizeof (MEM_HANDLE)));
   if (pps->hencodearray == NIL_MH)
   {
    	DBG ("pspcl_getencoding() - unable to alloc memory for enc struct\n");
	 	return (ERR_psi_Encode_mem);
   }
   pencs = (PMEM_HANDLE)MEMptr (pps->hencodearray);

  	/*
    	Initialize the encoding array so we can free it later
  	*/
  	for (encnum = 0; encnum < 256; encnum++)
    	pencs[encnum] = NIL_MH;
#endif

   for (j = 0; j < numEncodingChars; j++)
   {
#if 0 /* This data is not needed by nor used by UFST for downloads */
	   UNPACK_WORD((LPUB8)&charId);	/* get encoding character number */
      DBG1 ("charId:%d ", charId);
#else
      ph += 2;   /* skip over character ID */
#endif

	   UNPACK_WORD((LPUB8)&namelen);	/* get encoding character name length */
      DBG1 ("namelen:%d ", namelen);

#if 0 /* This data is not needed by nor used by UFST for downloads */
      pencs[charId] = BUFalloc ((SL32)(namelen+1));

      if (pencs[charId] == NIL_MH)
      {
         DBG1 ("Unable to alloc memory for encoding character %d name\n", charId);
         return (ERR_psi_Encodename_mem);
      }

      s = (LPUB8)MEMptr (pencs[charId]);/* get memory for encoding name */
      while (namelen--)                             /* read encoding name */
         *s++  = *ph++;
      *s++ = '\0';
#else
      ph += namelen;  /* skip over character name */
#endif
   }
   *newph = ph;

   return (SUCCESS);

}

#if defined (ANSI_DEFS)
MLOCAL int	pspcl_get_subrs (LPUB8 ph)
#else
MLOCAL int	pspcl_get_subrs (ph)
LPUB8 ph;
#endif
/*
Read PostScript PCLEO Subrs

return (SUCCESS), else error code
*/
{
register LPUB8 s;
SW16	nSubrs, len;
SW16	subnum;  /* changed from int to set with UNPACK_WORD() */
                 /* Int on SUN is 32 bits not 16 for word -ss 5/21/92 */
int     j;
PSUBS_STR   psubrs;

	DBG ("\npspcl_get_subrs()\n");

	UNPACK_WORD((LPUB8)&nSubrs);	/* get # of subrs */
	pps->nsubs = nSubrs;

	pps->hsubrs = BUFalloc ((SL32)(nSubrs * sizeof (SUBS_STR)));
  	if (pps->hsubrs == NIL_MH)
  	{
    	DBG ("pspcl_getsubrs() - unable to alloc memory for subr struct\n");
	 	return (ERR_psi_SubrStr_mem);
  	}
  	psubrs = (PSUBS_STR)MEMptr (pps->hsubrs);

  	/*
    	Initialize the subrs array so we can free it later
  	*/
  	for (subnum = 0; subnum < nSubrs; subnum++)
    	psubrs[subnum].hdata = NIL_MH;

        for (j = 0; j < nSubrs; j++)
        {
           UNPACK_WORD((LPUB8)&subnum);

      if ((UW16)subnum == 0xffff)
         break;   /* no more subroutines! */

      DBG2 ("%d Subr:%d ", j, subnum);
	   if (subnum >= pps->nsubs)
	   {
	      DBG2 ("subnum too high:%d nsubs %d\n", subnum, pps->nsubs);
		   return (ERR_psi_Subr_too_hi);
	   }
	   UNPACK_WORD((LPUB8)&len);	/* get subr length */
      psubrs[subnum].len = len;
      DBG1 ("len:%d ", len);

      psubrs[subnum].hdata = BUFalloc ((SL32)len);
      if (psubrs[subnum].hdata == NIL_MH)
      {
         DBG1 ("Unable to alloc memory for subr %d data\n", subnum);
         return (ERR_psi_Subrdat_mem);
      }
      psubrs[subnum].decrypted = *ph++;         /* get flag byte */
      DBG1 ("flag:%X\n", psubrs[subnum].decrypted);

      s = (LPUB8)MEMptr (psubrs[subnum].hdata);/* get memory for subr data */
      while (len--)                             /* read subr data */
         *s++  = *ph++;
   }
   return (SUCCESS);
}

#else /* ANSI requirements for at least 1 external declaration */
int iT1IPCLEO = 0;
#endif /* PST1_PCLEOI */

