/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1ipcleo.h,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1ipcleo.h,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   07 Apr 1995 10:33:10   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 14:49:30   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.6   16 Sep 1993 10:08:48   JOE
 * 
 * Conditionally compiled typedef for PS_CHAR_HDR because it is also
 * defined in T1ISFNT.H .
 * 
 *    Rev 1.5   09 Jun 1993 14:47:04   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.4   24 Mar 1993 15:31:20   JOE
 * 
 * Fix for oblique fonts.
 * 
 *    Rev 1.3   01 Mar 1993 10:17:30   JOE
 * For VXWORKS and 960, byte align structure PS_CHAR_HDR.
 * 
 *    Rev 1.2   15 Jan 1993 10:29:32   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:58:28   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:23:02   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:27 $ */
/* t1ipcleo.h - UFST PostScript Type 1 PCLEO header file

************************************************************************
*                                                                      *
*
************************************************************************

REVISION HISTORY
-----------------------------------------------------------------------
19-Mar-92  rs	Original file created.
04-Apr-92  rs	Portability cleanup (see port.h).
25-Sep-92  jfd Changed UNPACK_WORD() and UNPACK_LONG() macros for
               BYTEORDER == LOHI ( Changed "(LPUB8)ph += 2" to
               "ph = (LPUB8)(ph + 2)", etc.
24-Feb-93  jfd For VXWORKS and 960, to resolve alignment problem, align
               "PS_CHAR_HDR" structure on byte boundary. 
23-Mar-93  rs  Modify UPSFH struct - add PSEOFormat & change FontMatrix from
               long[6] to 6 variable length null terminated strings.
09-Jun-93 jfd  Changed all references to "char" to "SB8" for transportability.
16-Sep-93  jfd Conditionally compiled typedef for PS_CHAR_HDR because
               it is also defined in T1ISFNT.H.
*/

/*
Note: 
	The PS global data must begin on a QUADWORD boundary!

	The PS global Subr data is variable sized depending upon the font.
   Therefore this portion cannot be loaded into an actual structure.
   The information presented for the Subrs below is for documentation
   purposes only.
*/

/*
Note:
      These swapping & unpacking macros will not work in place. The source
      and destination must be different. The destination must be a LPSB8.
*/
#if (BYTEORDER == LOHI) /* ie. Intel */
#if 0
#define UNPACK_WORD(pb) *(pb) = *(LPUB8)((LPUB8)ph+1); \
      *(pb+1) = *(LPUB8)ph;  (LPUB8)ph += 2;
#define UNPACK_LONG(pb) *(pb) = *(LPUB8)((LPUB8)ph+3); \
      *(pb+3) = *(LPUB8)ph; *(pb+1) = *(LPUB8)((LPUB8)ph+2); \
      *(pb+2) = *(LPUB8)((LPUB8)ph+1); (LPUB8)ph += 4;
#endif
#define UNPACK_WORD(pb) *(pb) = *(LPUB8)((LPUB8)ph+1); \
      *(pb+1) = *(LPUB8)ph;  ph = (LPUB8)(ph + 2);
#define UNPACK_LONG(pb) *(pb) = *(LPUB8)((LPUB8)ph+3); \
      *(pb+3) = *(LPUB8)ph; *(pb+1) = *(LPUB8)((LPUB8)ph+2); \
      *(pb+2) = *(LPUB8)((LPUB8)ph+1); ph = (LPUB8)(ph + 4);

#else /* HILO (ie. Motorola) - don't swap bytes */
#define UNPACK_WORD(pb) *(pb) = *(LPUB8)ph; \
      *((pb)+1) = *(LPUB8)((LPUB8)ph+1);  (LPUB8)ph += 2;
#define UNPACK_LONG(pb) *(pb) = *ph; \
      *((pb)+1) = *(LPUB8)((LPUB8)ph+1); *((pb)+2) = *(LPUB8)((LPUB8)ph+2); \
      *((pb)+3) = *(LPUB8)((LPUB8)ph+3); (LPUB8)ph += 4;

#endif /* BYTEORDER */


#define	UHPFHSIZE 80 /* # bytes in UFST HP PCLEO hdr prior to global data */

typedef struct
{
/* pad - 0..3 bytes of pad data to begin on QUADWORD boundary */

UL32     PSEOFormat;          /* PSEO format - add 3/23/93 - rs */
/*
SB8		FontMatrix[6][]; **variable length strings add 3/23/93 - rs**
*/
SL32		UniqueID;               /* not used */
SL32		BlueScale;              /* fontvalue times 32768 */
SW16		weight;					/* use MicroSoft weights (1..1000) DDK 11-5 */
SW16		ItalicAngle;
SW16		isFixedPitch;			/* 0 == not fixed pitch */
SW16		UnderLinePosition;      /* not used */
SW16		UnderLineThickness;     /* not used */
SW16		FontType;				/* 1 == PostScript Type 1 */
SW16		FontBBox[4];			/* all 0's if not available */
SW16		nBlues;					/* # of BlueValues (0..14) */
SW16		BlueValues[14];    		/* BlueValue data */
SW16		nOtherBlues;			/* # of OtherBlues (0..10) */
SW16		OtherBlues[10]; 	    /* OtherBlues data */
SW16		nFamilyBlues;			/* # of FamilyBlues (0..14) */
SW16		FamilyBlues[14];	    /* FamilyBlues data */
SW16		nFamilyOtherBlues;		/* # of FamilyOtherBlues (0..10) */
SW16		FamilyOtherBlues[10];   /* FamilyOtherBlues data */
SW16		BlueShift;              /* not used */
SW16		BlueFuzz;               /* not used */
SW16		StdHW;
SW16		StdVW;
SW16		nStemSnapH;				/* # of values in StemSnapH array (0..12) */
SW16		StemSnapH[12];	        /* StemSnapH array values */
SW16		nStemSnapV;				/* # of values in StemSnapV array (0..12) */
SW16		StemSnapV[12];	        /* StemSnapV array values */
SW16		ForceBold;				/* 1 == ForceBold as per B&W book */
SW16		LanguageGroup;			/* not used, set to 0 */
SW16		lenIV;					/* applies to Subr & CharString data (dflt 4) */
SW16		Reserved2[12];			/* for future expansion */
SW16		nSubrs;					/* # of Subrs in font */
#if 0  /* following for DOCUMENTATION PURPOSES ONLY! */
struct {
   SW16  subnum;                 /* # of this subroutine (0xffff = end) */
	SW16	len;					/* # of bytes in this Subr */
	SB8	flag;						/* XXXXXXX1 == decrypted */
	UB8	data[len];					/* actual Subr data */
} Subr[nSubrs]; /* some may be missing, but max # if (nSubrs-1) */
#endif /* 0 - DOCUMENTATION PURPOSES ONLY */

} UPSFH;
typedef UPSFH FARPTR *PUPSFH;

/* Byte-align this data structure for VXWORKS and 960 */

#if defined(VXWORKS) || defined(__i960)
#pragma align 1
#endif

/*
PostScript PCLEO character data structure
*/
#ifndef PS_CHAR_HDR_DEFINED
typedef struct {
UB8      format;           /* raster=4, DJ=5, IF=10, TT=15, PS=30 */
UB8      continuation;     /* always 0 */
UB8      descriptorsize;   /* always 2 */
UB8      class;            /* contour=3, compound=4, tt=10, ps=11 */
SW16     len;              /* # of bytes to follow (not including csum) */
} PS_CHAR_HDR;
#define PS_CHAR_HDR_DEFINED
#endif

/* Reset alignment back to long from now on */

#if defined(VXWORKS) || defined(__i960)
#pragma align 0
#endif

#if 0 /* the following structure is for documentation purposes only */
typedef struct {
PS_CHAR_HDR header;
SW16     Namelen;          /* # of bytes in character name */
SW16     Datalen;          /* # of bytes in character data */
UB8      Name[Namelen];    /* Postscript character name */
UB8      Data[Datalen];    /* Postscript character data */
UB8      Decrypt;          /* !0 -> decrypted data */
UB8      reserved;
UB8      Checksum;
} PS_CHAR;
#endif  /* 0 - the following structure is for documentation purposes only */

