/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1iscan.c,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1iscan.c,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.29   07 Apr 1995 10:27:22   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.28   31 May 1994 09:31:44   JOE
 * In get_italic(), corrected test for valid token. (Changed to "if
 * (t1scanone() <= 0 || elt.type != TYPE_INTEGER)". )
 * 
 *    Rev 1.27   22 Apr 1994 16:10:02   JOE
 * 
 * Changed conditional compile statement prior to including <hif.h>
 * to #if (_AM29K && !UNIX) to resolve UNIX Metaware compiler error.
 * 
 *    Rev 1.26   22 Apr 1994 14:45:38   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.25   09 Feb 1994 13:56:48   JOE
 * 
 * More _AM29K changes.
 * 
 *    Rev 1.24   02 Feb 1994 10:00:48   JOE
 * 
 * Replaced I/O calls with macros in get_psfont_encoding_chars().
 * AM29K changes.
 * 
 *    Rev 1.23   08 Dec 1993 19:00:34   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.22   01 Dec 1993 09:33:00   JOE
 * 
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.21   28 Oct 1993 17:04:18   JOE
 * 
 * Conditionally compiled get_psfont_encoding_chars() and declaration
 * for encodearray based on (PST1_DISK && (!USE_UFST_MAPPING || USE_UFST_
 * MAPPING == 2))).
 * 
 *    Rev 1.20   14 Oct 1993 14:59:10   JOE
 * 
 * In t1setup(), removed check for "foundmtx" before processing font matrix
 * because encountered a special font which had 2 font matrices and wanted
 * to use the latter one.
 * 
 *    Rev 1.19   06 Oct 1993 10:25:38   JOE
 * Changes for processing "special" Type 1 fonts.
 * 
 *    Rev 1.18   29 Sep 1993 12:13:10   JOE
 * 
 * Added function get_ps_font_bbox() for PS bounding box support.
 * 
 *    Rev 1.17   22 Sep 1993 11:51:36   JOE
 * 
 * Moved "get_psfont_encoding_chars()" from PCLEOMGT.C to this module.
 * Added argument to get_psfont_encoding_chars() function - name of
 * Type 1 library file.
 * 
 *    Rev 1.16   10 Aug 1993 15:07:52   JOE
 * 
 * In psunload_font(), check that we are not processing PS ROM input
 * before freeing everything.
 * 
 *    Rev 1.15   26 Jul 1993 11:52:02   ROB
 * Change error check in call to t1scanone() from MMget_weights() to
 * '<=0' instead of '== NULL'.
 * 
 *    Rev 1.14   15 Jun 1993 15:48:02   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.13   15 Jun 1993 11:53:18   ROB
 * Move 'hexasciiflg' to type 1 bucket 'hexascii'. Fix 'get_StemSnapH()' and
 * 'get_StemSnapV()' when maximum # of stems.
 * 
 *    Rev 1.11   14 Jun 1993 17:16:02   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.10   09 Jun 1993 14:40:04   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.9   08 Jun 1993 18:02:48   ROB
 * Pipeline upgrade for type 1 quality improvements & multimaster support.
 * 
 *    Rev 1.8   03 May 1993 10:22:16   ROB
 * Modify 'get_bluescale()' to call 'bluescale()' w/SL32 instead of SW16.
 * 
 *    Rev 1.7   29 Mar 1993 11:00:12   ROB
 * Kanji cleanup.
 * 
 *    Rev 1.6   19 Mar 1993 11:40:34   JOE
 * **ROB** Changes for Kanji support.
 * 
 *    Rev 1.5   03 Mar 1993 19:21:44   ROB
 * Add support for StemSnapH[] & StemSnapV[] hints.
 * Fix bug in 'get_blues()' & 'get_other_blues()' which had the potential to
 * cause problems due to improper parsing of the font.
 * 
 *    Rev 1.4   15 Feb 1993 09:06:50   JOE
 * Changed all occurrences of READ to READF due to conflict with VXWorks.
 * 
 *    Rev 1.3   12 Feb 1993 15:49:08   JOE
 * VXWorks support.
 * 
 *    Rev 1.2   07 Jan 1993 10:06:54   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 09:59:16   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:14   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:27 $ */
/* t1iscan.c */
/*************************************************************************
 *                                                                       *
 *
 *
 *                 Copyright (c) 1989, 1990, 1991 by                     *
 *            Pipeline Associates, Inc., Morris Plains, NJ               *
 *                        All rights reserved.                           *
 *                                                                       *
 *   This software is furnished under a license and may be used and      *
 *   copied  only  in accordance with the terms of such license and      *
 *   with the  inclusion  of  the  above  copyright  notice.   This      *
 *   software  or  any  other copies thereo0f may not be provided or     *
 *   otherwise made available to any other person except as allowed      *
 *   under  license.  No  title to and ownership of the software is      *
 *   hereby transferred.                                                 *
 *                                                                       *
 *   This software is proprietary to Pipeline Associates, Inc., and      *
 *   is not to be disclosed without written permission from Pipeline     *
 *   Associates, Inc.                                                    *
 *                                                                       *
 ************************************************************************/
 
/* Note: when integrating into an interpreter environment, almost all the
   code in this file disappears; it's handled by the interpreter's scanner */

/*
REVISION HISTORY
-----------------------------------------------------------------------
03/12/90  PLA   accept |-, -|, and | as alternates for ND, RD, & NP
                    look for StdHW and StdVW values (Nimbus Q version)
                    get rid of strncmp's and replace with streq
03/19/90  PLA   look for lenIV
05/14/90  PLA   accept BitStream Type 1 fonts
08/16/90  PLA   allocate subrs array based on actual count
02/13/91  PLA   change to get_subrs to handle new optima font
04/02/91  PLA   PHW changes for UNIX and own grid alignment
09/27/91  rs    Original file created from Pipeline Associates 'scan.c'.
11/18/91  rs   Modify for binary or hex ascii font input.
11/19/91  rs    Add 'hexasciiflg' for binary vs hex ascii fonts.
11/26/91  rs   Memory mgt control on charstrings, subrs, encoding arrays.
               More error handling cleanup.
12/06/91  rs   StdHW, StdVW not being scanned in excess 16 bit, have to
               always multiply by 16 in 'get_stdhw()' & 'get_stdvw().
           No globals 'StdHW' & 'StdVW' in original Pipline code. Compiler
           is using function addresses and modifying code. Add globals
               and change functions to 'stdhwx()' & 'stdvwx()'.
01/03/92  rs   Convert ptrs to handles for memory useage.
01/23/92  rs   Convert to 'BUFalloc()' from 'CHARalloc()'.
02/06/92  rs   Modify 'get_charstrings()' and add 'more_charstrings()' for
               optimization of font loading.
02/14/92  rs   Add support for bucket types, 'get_famname()', 'get_italic()'
               & 'get_weight()'.
03/09/92  rs   Add support for internal floating point.
03/17/92  rs   Cleanup of 'invalid assigns'.
03/23/92  ss   Added conditional compile of "sys/..." includes.
03/24/92  rs   Clean up memory mgt issues w/NOTDEF, replace w/NULL.
03/26/92  rs   Change open flags in 'more_charstrings()' from
               'O_RDONLY|O_BINARY' to 'O_READFLAGS' because it did not work
               in Windows.
04/03/92  rs   Portability cleanup (see port.h).
05/22/92  rs   Make 'get_encoding()' and everything associated with it be
               conditional upon "!USE_UFST_ENCODING". This allows UFST to use
               its own encoding & symbol sets.
1 Jul 92  ss   Moved port.h to top to access defines earlier.
               Conditionally compile stdlib for !MIPS.  This may also be
               relevant for other UNIX SysV systems.
21-Jul-92 awr  Conditional compile changes.
29-Aug-92 rs   Fix 'get_blues() to handle Fontographer generated type 1 fonts
                    /BlueValues[-10.000 0.000 etc].
02-Sep-92 jfd  Moved standard encoding array "stdencoding[]" and notdef array
               NOTDEF[] into module "t1ipsdat.c".
23-Sep-92 jfd  INTEL960 conditional compile changes.
28-Sep-92 jfd  In get_charstrings() and more_charstrings(), replaced tell()
               call with lseek() call (Intel960 does not have "tell()" 
               function).
22-Nov-92 rs   Port to Macintosh - include <unix.h>.
07-Jan-93 jfd  ANSI C function deeclaration changes.
08-Feb-93 jfd  VXWorks support.
15-Feb-93 jfd  Changed READ to READF due to conflict with VXWorks.
02-Mar-93 rs   Add support for StemSnapH[] & StemSnapV[].
               Fix bug in 'get_blues()' & 'get_other_blues()'.
15-Mar-93 rs   Changes to support type 0 files (JIS_ENCODING).
27-Mar-93 rs   Fix Kanji defines per cgconfig.h (KANJI_ENCODING).
30-Apr-93 rs   Change 'get_bluescale()' to call 'bluescale()' with an 'SL32'
               instead of 'SW16'.
********************
9/23/91    PHW changed setup and startread to deal with        *
           unencrypted fonts                                   *
10/11/91   PHW look for ForceBold in Private dict              *
7/10/92    PHW added parsing for Multiple Master Parameters    *
7/18/92    PHW added lookup for StemSnapH and V                *
7/18/92    PHW changed malloc to palloc, free to pfree         *
14-May-93 rs   Integrate Pipeline upgrade. Above comments are from their
               upgraded file.
01-Jun-93 rs   Modify 'free_subrs()' to not free the individual subroutine
               data if using a "PostScript" downloaded soft font
               'PST1_SFNTI'.
06-Jun-93 rs   Add MultiMaster support.
09-Jun-93 jfd  Changed all references to "char" to "SB8" for transportability.
14-Jun-93 jfd  Support for type 1 encoding arrays.
15-Jun-93 rs   Remove global 'hexasciiflg' & replace with 'hexascii' in
               type 1 bucket. Fix problem in 'get_StemSnapH()' &
               'get_StemSnapV()' when maximum number of stems - produced
               an error when it shouldn't. ']' followed in font.
15-Jun-93 jfd  Moved "vxWorks.h" before "port.h" to resolve conflicts.
23-Jul-93 rs   Change error check in call to t1scanone() from MMget_weights()
               to '<= 0' instead of '== NULL'.
10-Aug-93 jfd  In psunload_font(), check that we are not PS ROM before
               freeing everything.
22-Sep-93 jfd  Moved "get_psfont_encoding_chars()" from PCLEOMGT.C to
               this module. Added argument to get_psfont_encoding_chars() 
               function - name of Type 1 library file.
29-Sep-93 jfd  Added function get_ps_font_bbox() for PS bounding box support.
06-Oct-93 jfd  In get_encoding(), modified scanning of encoding array
               to support "special" Type 1 fonts.
               In get_ps_font_bbox(), for "special" Type 1 fonts, check
               if bounding box info is delimited by '{' as well as '['.
               In get_psfont_encoding_chars(), added support for "special"
               Type 1 fonts.
               Changed declaration of "encodearray" from GLOBAL
               to EXTERN to resolve linker problem.
               In more_charstrings(), replaced "return 666" with "break"
               if end of character list is encountered before expected.
14-Oct-93 jfd  In t1setup(), removed check for "foundmtx" before processing
               font matrix because encountered a special font which had
               2 font matrix entries and wanted to use the latter one.
26-Oct-93 jfd  Conditionally compiled get_psfont_encoding_chars() and
               declaration for encodearray based on (PST1_DISK && 
               (!USE_UFST_MAPPING || (USE_UFST_MAPPING == 2))).
01-Dec-93 jfd  Changed KANJI_ENCODING to ASIAN_ENCODING.
08-Dec-93 rs   General cleanup - MSDOS & OS2.
27-Jan-94 jfd  Conditionally compile #include for fcntl.h based on
               (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX))).
               Replaces I/O calls with macros in get_psfont_encoding_chars().
04-Feb-94 jfd  Conditionally compile "sys\types.h" and "sys\stat.h"
               based on !_AM29K.
               Including "hif.h" if _AM29K.
               In get_psfont_encoding_chars(), cast arg 1 of OPEN call
               to LPSB8 to resolve _AM29K compiler error.
22-Apr-94 jfd  Changed conditional compile statement prior to
               including <hif.h> to #if (_AM29K && !UNIX) to
               resolve UNIX Metaware compiler error.
31-May-94 jfd  In get_italic(), corrected test for valid token. (Changed
               to "if (t1scanone () <= 0 || elt.type != TYPE_INTEGER)". )
*/

#include "cgconfig.h"

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#if PST1_RDR    /* conditional compile entire module */ 

#define SHOWINPUT    0  /* 3/13/92 - rs */

#include <stdio.h>

#ifndef MIPS
#include <stdlib.h>
#endif

#include <string.h>

#if (!defined(_AM29K) || (defined(_AM29K) && !defined(UNIX)))
#include <fcntl.h>      /* open() */
#endif

#if (defined(_AM29K) && !defined(UNIX))
#include <hif.h>  /* 2-7-94 jfd */
#endif

#if defined (MSDOS) || defined (__OS2__) /* needs port.h */
#include <sys\types.h>  /* open() */
#include <sys\stat.h>   /* open() */
#include <io.h>         /* close() */

#elif defined (MACINTOSH)
#include <unix.h>

#else /* unix */

#if !defined(_AM29K)
#include <sys/types.h>  /* open() */
#include <sys/stat.h>   /* open() */
#if !defined(__i960)
#include <unistd.h>     /* for SEEK_SET */
#define  O_BINARY      0
#endif  /* !__i960 */
#endif /* !_AM29K */
#endif /* MSDOS || OS2 */

#include "debug.h"
#include "mixmodel.h"
#include "ifmem.h"
#include "cgif.h"
#include "fpmath.h"
#include "ix.h"   /* PFONT_DES */
#include "cache.h"   /* CHARalloc() */
#include "t1isyntx.h"
#include "t1itype1.h"
#include "t1iproto.h"




#ifdef LINT_ARGS
EXTERN MEM_HANDLE   BUFalloc(SL32);
EXTERN VOID         BUFfree(MEM_HANDLE);

GLOBAL UW16  psunload_font (PBUCKET);
GLOBAL int  more_charstrings (LPSB8, int);
#if SHOWINPUT
MLOCAL int t1getbyte (VOID);
#endif /* SHOWINPUT */
GLOBAL int  get_matrix (VOID);
GLOBAL int  get_stdhw (VOID);
GLOBAL int  get_stdvw (VOID);
GLOBAL int  get_blues (VOID);
MLOCAL int  get_other_blues (VOID);
MLOCAL int  get_StemSnapH (VOID);
MLOCAL int  get_StemSnapV (VOID);
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
MLOCAL int  get_encoding (VOID);
#endif
MLOCAL int  get_bluescale (VOID);
MLOCAL int  get_blueshift (VOID);
MLOCAL int  get_subrs (VOID);
MLOCAL int  get_charstrings (VOID);
MLOCAL int  get_italic (VOID);
MLOCAL int  get_weight (VOID);
MLOCAL int  get_famname (VOID);
GLOBAL VOID t1startread (VOID);
GLOBAL int  t1scanone (VOID);
MLOCAL int  checkreal (LPSB8);
MLOCAL int  checkinteger (LPSB8, LPSL32);
MLOCAL int  scanto (LPSB8);
MLOCAL int  check (LPSB8);
MLOCAL int  checkND (VOID);
MLOCAL int  checkNP (VOID);
MLOCAL int  checkRD (VOID);
MLOCAL int  readhex (int, LPUB8);
MLOCAL int  ncheck (LPSB8);
MLOCAL int  gethex (VOID);
MLOCAL MEM_HANDLE namesave (LPSB8, int);
MLOCAL VOID free_charstrings (PPS_BUCK);
MLOCAL VOID free_subrs (PPS_BUCK);
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
MLOCAL VOID free_encoding (PPS_BUCK);
#endif

MLOCAL int  get_ps_font_bbox (VOID);  /* 9-27-93 jfd */

#if (T1MMASTER)
MLOCAL int MMget_weights (VOID);
MLOCAL int MMget_stdvw (VOID);
MLOCAL int MMget_stdhw (VOID);
MLOCAL int MMget_blendtypes (VOID);
MLOCAL int MMget_blendmap (VOID);
MLOCAL int MMget_blendpos (VOID);
MLOCAL int MMget_blues (VOID);
MLOCAL int MMget_otherblues (VOID);
MLOCAL int MMget_stemh (VOID);
MLOCAL int MMget_stemv (VOID);
MLOCAL VOID free_MMaster (PPS_BUCK);
#endif /* T1MMASTER */

#ifdef DEBUG  
MLOCAL VOID print_token (VOID);
#endif /* DEBUG */

#if (PST1_DISK && (!USE_UFST_MAPPING || (USE_UFST_MAPPING == 2)))
GLOBAL UW16    get_psfont_encoding_chars(LPUB8);  /* 9-13-93 jfd */
#endif

#else /* no LINT_ARGS */
EXTERN MEM_HANDLE   BUFalloc();
EXTERN VOID         BUFfree();

GLOBAL UW16 psunload_font ();
GLOBAL int  more_charstrings ();
#if SHOWINPUT
MLOCAL int t1getbyte (VOID);
#endif /* SHOWINPUT */
GLOBAL int  get_matrix ();
GLOBAL int  get_stdhw ();
GLOBAL int  get_stdvw ();
GLOBAL int  get_blues ();
MLOCAL int  get_other_blues ();
MLOCAL int  get_StemSnapH ();
MLOCAL int  get_StemSnapV ();
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
MLOCAL int  get_encoding ();
#endif
MLOCAL int  get_bluescale ();
MLOCAL int  get_blueshift ();
MLOCAL int  get_subrs ();
MLOCAL int  get_charstrings ();
MLOCAL int  get_italic ();
MLOCAL int  get_weight ();
MLOCAL int  get_famname ();
GLOBAL VOID t1startread ();
GLOBAL int  t1scanone ();
MLOCAL int  checkreal ();
MLOCAL int  checkinteger ();
MLOCAL int  scanto ();
MLOCAL int  check ();
MLOCAL int  checkND ();
MLOCAL int  checkNP ();
MLOCAL int  checkRD ();
MLOCAL int  readhex ();
MLOCAL int  ncheck ();
MLOCAL int  gethex ();
MLOCAL MEM_HANDLE namesave ();
MLOCAL VOID free_charstrings ();
MLOCAL VOID free_subrs ();
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
MLOCAL VOID free_encoding ();
#endif

MLOCAL int  get_ps_font_bbox ();  /* 9-27-93 jfd */

#if (T1MMASTER)
MLOCAL int MMget_weights ();
MLOCAL int MMget_stdvw ();
MLOCAL int MMget_stdhw ();
MLOCAL int MMget_blendtypes ();
MLOCAL int MMget_blendmap ();
MLOCAL int MMget_blendpos ();
MLOCAL int MMget_blues ();
MLOCAL int MMget_otherblues ();
MLOCAL int MMget_stemh ();
MLOCAL int MMget_stemv ();
MLOCAL VOID free_MMaster ();
#endif /* T1MMASTER */

#ifdef DEBUG  
MLOCAL VOID print_token ();
#endif /* DEBUG */

#if (PST1_DISK && (!USE_UFST_MAPPING || (USE_UFST_MAPPING == 2)))
GLOBAL UW16    get_psfont_encoding_chars();  /* 9-13-93 jfd */
#endif

#endif /* LINT_ARGS */

MLOCAL int   __savec;
GLOBAL int   unputflag = FALSE;
MLOCAL int  scanning_proc = 0;  /* recursion of procedure scan */
GLOBAL UB8  token[1025];
GLOBAL TOKENSTR elt;

MLOCAL LPUB8 t1bufptr, t1bufend;   /* start and end of this 'POST' resource */
GLOBAL int    decoding = FALSE;  /* until we see currentfile eexec */

/* cleanup of I/O & decryption stuff - 3/13/92 - rs */
MLOCAL UW16  code = 0xd971; /* Type 1 decryption */
MLOCAL UW16  c1 = 0xce6d;   /* Type 1 decryption */
MLOCAL UW16  c2 = 0x58bf;   /* Type 1 decryption */

MLOCAL UB8  buf[128];

#ifdef DEBUG
/*
Error message text used within this file during debugging
*/
MLOCAL SB8  t_efs[] = " - error from t1scanone()\n";
MLOCAL SB8  t_malloc[] = " - error allocating memory\n";
MLOCAL SB8  t_t1setup[] = "t1setup()";
MLOCAL SB8  t_get_matrix[] = "get_matrix()";
MLOCAL SB8  t_get_stdvw[] = "get_stdvw()";
MLOCAL SB8  t_get_stdhw[] = "get_stdhw()";
MLOCAL SB8  t_get_blues[] = "get_blues()";
MLOCAL SB8  t_get_other_blues[] = "get_other_blues()";
MLOCAL SB8  t_get_bluescale[] = "get_bluescale()";
MLOCAL SB8  t_get_blueshift[] = "get_blueshift()";
MLOCAL SB8  t_get_ps_font_bbox[] = "get_ps_font_bbox()";
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
MLOCAL SB8  t_get_encoding[] = "get_encoding()";
#endif
MLOCAL SB8  t_ncheck[] = "ncheck()";
MLOCAL SB8  t_get_subrs[] = "get_subrs()";
MLOCAL SB8  t_get_charstrings[] = "get_charstrings()";
MLOCAL SB8  t_checkRD[] = "checkRD()";
MLOCAL SB8  t_checkNP[] = "checkNP()";
MLOCAL SB8  t_checkND[] = "checkND()";
#endif /* DEBUG */

/*
 * 9/22/93 jfd, required to read PS font encoding array
 */
#if (PST1_DISK && (!USE_UFST_MAPPING || (USE_UFST_MAPPING == 2)))
/* EXTERN UW16 encodearray[256]; */
GLOBAL UW16 encodearray[256];
#endif /* PST1_DISK */

EXTERN UW16 Meto_encodearray ; /* For Meto Use Only  6-23-97  by jqz */
EXTERN UW16 cache_Meto_font; /*keb*/

#if defined (ANSI_DEFS)
GLOBAL int reader ()
#else
GLOBAL int reader ()
#endif
/* This next subroutine is OS specific. */
/*    remove MAC specific code - 9/30/91 - rs */
{
int nbytes = 1;

    t1bufptr = t1bufend = buf;

  if (!decoding)
  {
    if (READF (gpxb->fh, (SB8 *)buf, 1) <= 0)
      return (EOF);
  }
  else   /* decoding */
  {
     if (!gpps->hexascii)
     {
       nbytes = READF (gpxb->fh, (SB8 *)buf, 128);
       if (nbytes <= 0)
         return (EOF);
     }
     else
     {
       nbytes = readhex (128, buf);
     }
  }

  if (nbytes != EOF)
      t1bufend = buf + nbytes;
  else
      t1bufend = buf;

  return (nbytes);
}

#if defined (ANSI_DEFS)
MLOCAL int readhex (int n, register LPUB8 buf)
#else
MLOCAL int readhex (n, buf)
int n;
register LPUB8 buf;
#endif
{
register int c;
register int nbytes;

  for (nbytes = 0; nbytes < n; nbytes++)
  {
    c = gethex ();
    if (c == EOF)
    {
      if (nbytes > 0)
         return (nbytes);
      else
          return (EOF);
    }
    *buf++ = (UB8)c;
  }
  return (nbytes);
}

#if defined (ANSI_DEFS)
MLOCAL int gethex ()
#else
MLOCAL int gethex ()
#endif
{
register int x;
register int c;
SB8 tbuf[2];

  if (gpps->hexascii)  /* hex ascii font */
  {
    while  (READF (gpxb->fh,tbuf,1) && ((c = tbuf[0]) != EOF) && !ishex (c))
      ;
    if (c == EOF)
      return (EOF);

    if (c >= 'a')
      x = (c - 'a' + 10) << 4;
    else if (c >= 'A')
      x = (c - 'A' + 10) << 4;
    else
      x = (c - '0') << 4;

    while (READF (gpxb->fh,tbuf,1) && ((c = tbuf[0]) != EOF) && !ishex (c))
      ;

    if (c == EOF)
      return (EOF);

    if (c >= 'a')
      x |= c - 'a' + 10;
    else if (c >= 'A')
      x |= c - 'A' + 10;
    else
      x |= c - '0';

    return (x);
  } /* if (gpps->hexascii) */
  else  /* binary font */
  {
    if (READF (gpxb->fh, tbuf, 1) <= 0)
      return (EOF);
    return ((SW16)tbuf[0] & 0xff);
  }
}

/* define (SHOWINPUT != 0) to see all the input */
#if SHOWINPUT
#if defined (ANSI_DEFS)
MLOCAL int t1getbyte ()
#else
MLOCAL int t1getbyte ()
#endif
{
register int  x;
register int  y;

  x = psgetc();
  if (x == EOF)
    return EOF;

  if (! decoding )
  {
    printf ("%c", x);
    return x;
  }
  else
  {
    y = (int)((UW16)x ^ ((UW16)code >> 8));
    code = ((UW16)x + code) * c1 + c2;
    DBG1 ("%c", y);
    return y;
  }
}
#else /* !SHOWINPUT */
#define t1getbyte() ((x = psgetc()) == EOF ? EOF :  (!decoding) ? x : \
    (y = (int)((UW16)x ^ ((UW16)code >> 8)), \
    code = ((UW16)x + code) * c1 + c2, \
    (int)y & 0xff))
#endif /* SHOWINPUT */

#if defined (ANSI_DEFS)
GLOBAL VOID t1startread ()
#else
GLOBAL VOID t1startread ()
#endif
{
#if !SHOWINPUT
register int x; /* used by 't1getbyte()' macro SHOWINPUT */
register int y; /* used by 't1getbyte()' macro SHOWINPUT */
#endif /* !SHOWINPUT */
int i;

  code = 0xd971;/* initial decryption key B&W book - 3/13/92 - rs */

  unputflag = FALSE;
  for (i = 0; i < 4; ++i)
    t1getbyte ();
}

/*
 *  Read one PostScript token (value) on the currently open
 *  channel.  We depend on the t1input macros above and their
 *  supporting routines below and the syntax macros from
 *  "syntax.h".  Returns null on end
 */

#if defined (ANSI_DEFS)
GLOBAL int t1scanone ()
#else
GLOBAL int t1scanone ()
#endif
/*
Modify to return (-1) on error - 11/27/91 - rs
used to call error() and abort.
returns (EOF) on EOF and (1) otherwise.
*/
{
register LPUB8  tp = token, tend = token + sizeof (token) - 1;
register int  in;
#if !SHOWINPUT
register int   x; /* used by 't1getbyte()' macro if SHOWINPUT */
register int   y; /* used by 't1getbyte()' macro if SHOWINPUT */
#endif /* !SHOWINPUT */

scan:  /* skip leading spaces and comments */
  do
  {
    in = t1input ();
    if (in == EOF)
       return (EOF);
  }
  while (isblank (in));

  if (iscomment (in))
  {
    while (in != EOF && !isreturn (in))
      in = t1input ();
    if (in == EOF)
       return (EOF);
    goto scan;
  }

  /*
   *  Read the syntactic token now.  This gets gross.
   *  we have macro-ized all the syntacitic categories,
   *  but it doesn't make things a whole lot better
   *  really.
   *
   *  The table of characters and their syntax classes is
   *  declared in syntab.c as large array of shorts.  The
   *  syntax of any character can be changed by modifying
   *  its entry in that table.
   */
  if (isstring (in) && isopen (in))
  {
int  level = 1;

    in = t1input ();
    for (tp = token; in != EOF && tp <= tend; tp++)
    {
newchar:
      if (isescape (in))
      {
        /* a character escape */
        in = t1input ();
        if (isoctal (in))
        {
          /* octal number \xxx */
      int i, num = 0;

          for (i = 0; i < 3 && isoctal (in); i++)
          {
            num = num * 8 + in - '0';
            in = t1input ();
          }
          unput (in);
          in = num & 0xFF;
        }
        else switch (in)
        {
          case 'n':
            in = '\n';
            break;
          case 'r':
            in = '\r';
            break;
          case 't':
            in = '\t';
            break;
          case 'b':
            in = '\b';
            break;
          case 'f':
            in = '\f';
            break;
          case '\n':
            in = t1input ();
              goto newchar;
          default:
            /* just the character itself */
            break;
        }
      }
      else if (isstring (in))
      {
        if (isopen (in))
        {
          /* down another level of parens */
          level++;
        }
        else if (isclose (in) && --level < 1)
        {
          /* done with the string */
          break;
    }
      }
      *tp = (SB8)in;
      in = t1input ();
    }

    if ( tp == tend )
    {
      DBG ("t1scanone() - (tp == tend)\n");
      return (-1);
    }

    elt.type = TYPE_STRING;
    elt.len = tp - token;
  }
  else if (isintro (in))
  {
      /* is there another '/' after first '/' */
      in = t1input ();
      if (isintro (in))
      {
        /* collect rest of characters which could be a name */
        in = t1input ();
      }
      else
      {
        /* collect rest of characters which could be a name */
        tp = token;
        while (tp < tend && in != EOF && isname (in))
        {
            *tp++ = (SB8)in;
            in = t1input ();
        }
        if (in != EOF && !isblank (in))
            unput (in);

        elt.type = TYPE_NAME;
        elt.len = tp - token;
        *tp = '\0';
        DBG3 ("Name: <%.*s> (%d)   ", elt.len, token, elt.len);
      } /* else (isintro (in)) */
  } /* else else (isintro (in)) */
  else if (isproc (in) && isopen (in))
  {

    /* scan elements of the procedure */
    scanning_proc++;

    /* make a procedure type */
    elt.type = TYPE_ARRAY;
  } /* else if (isproc (in) && isopen (in)) */
  else if (scanning_proc > 0 && isproc (in) && isclose (in))
  {
    /* the end of the procedure body */
    scanning_proc--;
    elt.type = TYPE_ARRAY;
  }
  else if (isarray (in) && isopen (in))
  {
    /* make the [ name object */
    elt.type = TYPE_STRING;
    *token = '[';
    elt.len = 1;
  }
  else if (isarray (in) && isclose (in))
  {
    /* make the ] name object */
    elt.type = TYPE_STRING;
    *token = ']';
    elt.len = 1;
  }
  else if (isxdata (in) && isopen (in))
  {
    UW16 u4, l4;

    /* a hex data segment */
    for (in = t1input (); isblank (in); in = t1input ())
      ;
    tp = token;
    while (in != EOF && ishex (in))
    {
      /* extract the high half-byte */
      u4 = digitval (in);
      for (in = t1input (); isblank (in); in = t1input ())
        ;
      if (!ishex (in))
      {
        /* the low half-byte is zero */
        l4 = 0;
      }
      else
      {
        /* extract the low half-byte */
        l4 = digitval (in);
    for (in = t1input (); isblank (in); in = t1input ())
          ;
      }
      *tp++ = (SB8)((u4 << 4) | l4);
    } /* while (in != EOF .... */
    if (!isxdata (in) || !isclose (in))
    {
      DBG2 ("t1scanone() - invalid character %c (0x%x) in hex data.\n", in, in);
      return (-1);
    }
    elt.type = TYPE_STRING;
    elt.len = tp - token;
  }
  else if (isclose (in))
  {
    /* too many close delimiters */
    DBG1 ("t1scanone() - too many %c closing delimiters.\n", in);
    return (-1);
  }  
  else if (isname (in))
  {
    /* it's an executable name or a number */
    tp = token;
    while (tp < tend && in != EOF && isname (in))
    {
      *tp++ = (SB8)in;
      in = t1input ();
    }
    *tp = '\0';

    /* put back the ``extra'' input we just read */
    if (in != EOF && !isblank (in))
      unput (in);

    /* leading character in an integer */
#define isintfirst(c)  (isdigit (c) || isminus (c) || isplus (c))

    /* make the correct type of object and return */
    if (isreal (*token) && checkreal ((LPSB8)token))
    {
      /* make a real number */
      elt.type = TYPE_REAL;
      elt.realval = fpatof ((LPSB8)token); /* FP - 3/9/92 - rs */
    }
    else if (isintfirst (*token) && checkinteger ((LPSB8)token, &elt.intval))
    {
      /* make an integer */
      elt.type = TYPE_INTEGER;
    }
    else
    {
      /* make an executable name */
      elt.type = TYPE_NAME;
      elt.len = tp - token;
      *tp = '\0';
      DBG3 ("Name2: <%.*s> (%d)  ", elt.len, token, elt.len);
    }
  }
  else
  {
    /* this is an illegal character */
    DBG2 ("t1scanone() - illegal character '%c' (0x%x)\n", in, in);
    return (-1);
  }

  return (1);
}

#if defined (ANSI_DEFS)
MLOCAL int checkreal (LPSB8 token)
#else
MLOCAL int checkreal (token)
LPSB8 token;
#endif
{
register LPSB8 tp;
register int  seendigit = 0, seenminus = 0, seenplus = 0;
register int  seenpoint = 0, seenexp = 0;

  /* it has to contain some characters */
  if (token == NULL || *token == '\0')
    return (FALSE);

  /* figure out what the token contains */
  for (tp = (LPSB8)token; *tp != '\0'; tp++)
  {
    if (ispoint (*tp))
      seenpoint++;
    else if (isexponent (*tp))
      if (!seendigit)
        return (FALSE);
      else
        seenexp++;
    else if (isminus (*tp))
      seenminus++;
    else if (isplus (*tp))
      seenplus++;
    else if (isdigit (*tp))
      seendigit++;
    else if (isblank (*tp))
      break;
    else
      return (FALSE);
  }

  /* is it a non-number? */
  if (!seendigit)
    return (FALSE);

  /* is it an integer? */
  if (!seenpoint && !seenexp)
    return (FALSE);

  /* would it cause a syntaxerror? */
  if ( seenplus > 1 && seenminus > 1 )
    return (FALSE);
  if ( seenplus && seenminus && !seenexp )
    return (FALSE);
  if (seenpoint > 1 || seenexp > 1)
    return (FALSE);
  if (seenminus > 2 || (seenminus > 1 && !seenexp))
    return (FALSE);
  if (seenplus > 2 || (seenplus > 1 && !seenexp))
    return (FALSE);

  /* must be okay */
  return (TRUE);
}

#if defined (ANSI_DEFS)
MLOCAL int checkinteger (LPSB8 token, LPSL32 ret)
#else
MLOCAL int checkinteger (token, ret)
LPSB8 token;
LPSL32 ret;
#endif
{
register LPSB8 tp;
register long num = 0;
register int  radix = 10, dig;
int  seendigit = 0, seenradix = 0;
int  sign = 1;

  /* it has to contain some characters */
  if (token == NULL || *token == '\0')
    return (FALSE);

  /* a leading minus or plus is okay */
  if (isminus (*token) || isplus (*token))
  {
    if (isminus (*token))
      sign = -1;
    token++;
  }

  /* figure out what the token contains */
  for (tp = (LPSB8)token; *tp != '\0'; tp++)
  {
    if (isdigit (*tp))
    {
      dig = digitval (*tp);
      if (dig < 0 || dig >= radix)
        return (FALSE);
      num = num * radix + dig;
      seendigit++;
    }
    else if (isradix (*tp))
    {
      if (seenradix)
        return (FALSE);
      radix = (int)num;
      if (radix < 2 || radix > 36)
        return (FALSE);
      seendigit = 0;
      num = 0;
      seenradix++;
    }
    else if (isletter (*tp))
    {
      dig = digitval (*tp);
      if (dig < 0 || dig >= radix)
        return (FALSE);
      num = num * radix + dig;
      seendigit++;
    }
    else if (isblank (*tp))
      break;
    else
      return (FALSE);
  }

  /* did it contain digits? */
  if (seendigit)
  {
    *ret = num * sign;
    return (TRUE);
  }
  else
    return (FALSE);
}

#if defined (ANSI_DEFS)
MLOCAL MEM_HANDLE namesave (LPSB8 s, int n)
#else
MLOCAL MEM_HANDLE namesave (s, n)
LPSB8 s;
int n;
#endif
/*
Allocate memory using 'BUFalloc()' and return handle
*/
{
MEM_HANDLE  hndl;
LPSB8 ptr;
  
  hndl = BUFalloc ((SL32)(n + 1));
  if (!hndl)
    return (hndl);

  ptr = (LPSB8)MEMptr (hndl); 
  STRNCPY (ptr, s, n);
  *(ptr + n) = '\0';

  DBG1 ("Saved name %s\n", ptr);
  return hndl;
}

#if defined (ANSI_DEFS)
GLOBAL int t1setup ()
#else
GLOBAL int t1setup ()
#endif
/*
get the tables set up correctly
*/
{
#if !SHOWINPUT
register int x,y; /* used by 't1input()' & 't1getbyte()' macro if !SHOWINPUT */
#endif /* !SHOWINPUT */
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
int  foundenc = FALSE;
#endif
int  foundmtx = FALSE, foundsubs = FALSE, foundchars = FALSE;
int  foundfamname = FALSE, founditalic = FALSE, foundwt = FALSE;
int  foundbbox = FALSE;
int wstat, j;
long  saveint;
int status = SUCCESS;
UB8 tmpbuf[8];
#if T1MMASTER
int  foundweights = FALSE, foundblendaxis = FALSE;
#endif
  
  /* assume FontMatrix  and  Encoding can occur in any order */

  while ((wstat = t1scanone ()) > 0)
  {
    if (wstat < 0)
    {
       DBG2 ("%s%s", t_t1setup, t_efs);
      return (ERR_psi_scan_matrix);
    }
    if (elt.type == TYPE_NAME)
      if (streq ("FontMatrix", (LPSB8)token))  /* 10-13-93 jfd */
      {
        foundmtx = TRUE;
         status = get_matrix ();
         if (status)
             return (status);
      }
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
      else if (!foundenc && streq ("Encoding", (LPSB8)token))
      {
        foundenc = TRUE;
         status = get_encoding ();
         if (status)
          return (status);
      }
#endif /* !USE_UFST_MAPPING || USE_UFST_MAPPING == 2 */
      else if (!foundwt && streq ("Weight", (LPSB8)token))
      {
        foundwt = TRUE;
         status = get_weight ();
        if (status)
          return (status);
      }
      else if (!foundfamname && streq ("FamilyName", (LPSB8)token))
      {
        foundfamname = TRUE;
         status = get_famname ();
        if (status)
          return (status);
      }
      else if (!founditalic && streq ("ItalicAngle", (LPSB8)token))
      {
        founditalic = TRUE;
         status = get_italic ();
        if (status)
          return (status);
      }
      else if (!foundbbox && streq ("FontBBox", (LPSB8)token))
      {
        foundbbox = TRUE;
         status = get_ps_font_bbox ();
        if (status)
          return (status);
      }
#if T1MMASTER
			else if (!foundweights && streq ("WeightVector", (LPSB8)token))
         {
				DBG ("found WeightVector!\n");
				status = MMget_weights ();
            if (status)
               return (status);
				foundweights = TRUE;
			}
			else if (!foundblendaxis && streq ("BlendAxisTypes", (LPSB8)token))
         {
				status = MMget_blendtypes ();
            if (status)
               return (status);
            foundblendaxis = TRUE; /* added 6/8/93 - rs */
			}
			else if (streq ("BlendDesignPositions", (LPSB8)token))
         {
				status = MMget_blendpos ();
            if (status)
               return (status);
			}
			else if (streq ("BlendDesignMap", (LPSB8)token))
         {
				status = MMget_blendmap ();
            if (status)
               return (status);
			}
#endif /* T1MMASTER */
      else if (streq ("eexec", (LPSB8)token))
      {
        DBG ("found eexec!\n");
        break;
      }
  }
/*
For binary input, throw away header (8002XXXXXXXX)
*/
  if (READF (gpxb->fh, (SB8 *)tmpbuf, 6) != 6)
  {
    DBG ("t1setup() - error reading binary file header\n");
    return (ERR_psi_rd_bhdr);
  }
  if (gpps->hexascii)
  {
      LSEEK (gpxb->fh, -6L, SEEK_CUR); /* get back to start of segment */
      /*
         This could be a binary font with no header
         We will do the best we can to determine this
      */
      for (j = 0; j < 6; j++)
         if (!ishex (tmpbuf[j]))
             gpps->hexascii = 0; /* this is a binary font in disguise */
  }

  /* now let's get to the good stuff */

  decoding = TRUE;

  /* skip four key bytes */  
  t1startread ();

  /* Scan to the start of the Private dictionary */
  
  if (scanto ("Private") <= 0)
  {
    DBG ("t1setup() - error scanning to 'Private'\n");
    return (ERR_psi_scan_private);
  }
      
  /*
    now we'll get the Subrs Array, CharStrings dictionary, BlueValues,
    OtherBlues, etc.
  */

  while (!foundchars && ((wstat = t1scanone ()) > 0) )
  {
    if (wstat < 0)
    {
       DBG2 ("%s%s", t_t1setup, t_efs);
      return (ERR_psi_scan_file);
    }
    if (elt.type == TYPE_INTEGER)
    {
      saveint = elt.intval;
      continue;
    }
    else if (elt.type == TYPE_NAME )
    {
      if ( saveint && checkRD () )
      {
          while (saveint--)
        t1input ();
      }
      else if (!foundsubs && streq ("Subrs", (LPSB8)token) )
      {
        foundsubs = TRUE;
         status = get_subrs ();
        if (status)
          return (status);
      }
      else if (!foundchars && streq ("CharStrings", (LPSB8)token))
      {
        foundchars = TRUE;
         status = get_charstrings ();
        if (status)
          return (status);
      }      
      else if (streq ("BlueValues", (LPSB8)token) )
        {
        status = get_blues ();
        if (status)
          return (status);
        }
      else if (streq ("OtherBlues", (LPSB8)token) )
        {
        status = get_other_blues ();
        if (status)
          return (status);
        }
      /* PHW -- added following for BlueScale and BlueShift */
      else if (streq ("BlueScale", (LPSB8)token) ) 
        {
        status = get_bluescale ();
        if (status)
          return (status);
        }
      else if (streq ("BlueShift", (LPSB8)token) ) 
        {
        status = get_blueshift ();
        if (status)
          return (status);
        }
      else if (streq ("StdHW", (LPSB8)token)) 
        {
        status = get_stdhw ();
        if (status)
          return (status);
        }
      else if (streq ("StdVW", (LPSB8)token)) 
        {
        status = get_stdvw ();
        if (status)
          return (status);
        }
      else if (streq ("StemSnapH", (LPSB8)token)) 
        {
        status = get_StemSnapH ();
        if (status)
          return (status);
        }
      else if (streq ("StemSnapV", (LPSB8)token)) 
        {
        status = get_StemSnapV ();
        if (status)
          return (status);
        }
      else if (streq ("lenIV", (LPSB8)token))
      {
        wstat = t1scanone ();
        if ((elt.type != TYPE_INTEGER) || (wstat <= 0))
        {
          DBG2 ("%s%s", t_t1setup, t_efs);
          return (ERR_psi_scan_LenIV);
        }
        gpps->lenIV = (SW16)elt.intval;
      }
    } /* else if (elt.type == TYPE_NAME ) */
      
    saveint = 0;
  } /* while (t1scanone () > 0 && !foundchars) */

#if (T1MMASTER)
	/* compute instance of BlueValues, StdHW, and StdVW */
	status = MMsetup ();
#endif /* T1MMASTER */

  return (status);
}

#if defined (ANSI_DEFS)
MLOCAL int scanto (LPSB8 s)
#else
MLOCAL int scanto (s)
LPSB8 s;
#endif
/*
scan up to a particular name token
modify to return (-1) on error from 't1scanone()' - 11/27/91 - rs
*/
{
int wstat;

  DBG1 ("scanning to %s\n", s);
    
  while (((wstat = t1scanone ()) > 0) && ! ncheck (s))
    ;

  if (wstat < 0)
    return (-1);

  return streq (s, (LPSB8)token);
}

#if defined (ANSI_DEFS)
GLOBAL int get_matrix ()
#else
GLOBAL int get_matrix ()
#endif
{
int i;
  
  /* /FontMatrix [0.001 0 0 0.001 0 0] readonly def */

  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
  {
    DBG2 ("%s%s", t_get_matrix, t_efs);
    return (ERR_psi_scan_matrix);
  }
  
  for (i = 0; i < 6; ++i)
  {
    if (t1scanone () < 0)
    {
      DBG2 ("%s%s", t_get_matrix, t_efs);
      return (ERR_psi_scan_matrix);
    }
    if (elt.type == TYPE_INTEGER)
      gpps->fontmatrix[i] = fpint2fp ((SL32)elt.intval);/* FP - 3/9/92 - rs */
    else if (elt.type == TYPE_REAL)
      gpps->fontmatrix[i] = elt.realval;
    else
    {
      DBG2 ("%s%s", t_get_matrix, t_efs);
      return (ERR_psi_scan_matrix);
    }
  }

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int get_stdvw ()
#else
GLOBAL int get_stdvw ()
#endif
{
int status = SUCCESS;

  /* /StdVW [x1] ND */
  /* or (for MM) /StdVW [[x1 x2 ... xn]] ND */

  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
  {
    DBG2 ("%s%s", t_get_stdvw, t_efs);
    return (ERR_psi_scan_StdVW);
  }
  
  if (t1scanone () < 0)
  {
    DBG2 ("%s%s", t_get_stdvw, t_efs);
    return (ERR_psi_scan_StdVW);
  }

  /* PHW -- changed call to fixed precision */
  /* since this entry is almost alway integer, let's avoid FP here */
  if (elt.type == TYPE_INTEGER)
  {
    /* multiply by 16 */
    stdvwx ((SW16)elt.intval << 4);
  }
  else if (elt.type == TYPE_REAL)
  {
    stdvwx (ifpmul (16, elt.realval));/* FP - 3/9/92 - rs */
  }
#if T1MMASTER
	else if (*token == '[')
   {
		status = MMget_stdvw ();
	}
#endif /* T1MMASTER */
  else
  {
    DBG1 ("%s - bad type\n", t_get_stdvw);
    return (ERR_psi_scan_StdVW);
  }

    return (status);
}

#if defined (ANSI_DEFS)
GLOBAL int get_stdhw ()
#else
GLOBAL int get_stdhw ()
#endif
{
int status = SUCCESS;

  /* /StdHW [x1] ND */
  /* or (for MM) /StdHW [[x1 x2 ... xn]] ND */

  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
  {
    DBG2 ("%s%s", t_get_stdhw, t_efs);
    return (ERR_psi_scan_StdHW);
  }
  
  if (t1scanone () < 0)
  {
    DBG2 ("%s%s", t_get_stdhw, t_efs);
    return (ERR_psi_scan_StdHW);
  }

  /* PHW -- changed call to fixed precision */
  /* since this entry is almost alway integer, let's avoid FP here */
  if (elt.type == TYPE_INTEGER)
   {
    /* multiply by 16 */
    stdhwx ((SW16)elt.intval << 4);
	}
  else if (elt.type == TYPE_REAL)
   {
    stdhwx (ifpmul (16, elt.realval));/* FP - 3/9/92 - rs */
	}
#if T1MMASTER
	else if (*token == '[')
   {
		status = MMget_stdhw ();
	}
#endif
  else
  {
    DBG1 ("%s - bad type\n", t_get_stdhw);
    return (ERR_psi_scan_StdHW);
  }

  return (status);
}

#if defined (ANSI_DEFS)
MLOCAL int get_StemSnapH ()
#else
MLOCAL int get_StemSnapH ()
#endif
{
/* /StemSnapH [x1 x2 x3 ... x12] */

SW16  num = 0, stems[MAXSTEMS];

   if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
      return (ERR_psi_scan_StemSnapH);
  
   while (1)
   {
      if (t1scanone () < 0)
         return (ERR_psi_scan_StemSnapH);

      /* since this entry is almost alway integer, let's avoid FP here */
      if (elt.type == TYPE_INTEGER)
      {
         if (num >= MAXSTEMS)
            return (ERR_psi_scan_StemSnapH); /* too many values */
         stems[num++] = ((SW16)elt.intval) << 4;
      }
      else if (elt.type == TYPE_REAL)
      {
         if (num >= MAXSTEMS)
            return (ERR_psi_scan_StemSnapH); /* too many values */
         stems[num++] = ifpmul (16, elt.realval);
      }
      else
         break;
   } /* while (1) */

#if T1MMASTER
	if (*token == '[')
   {
		num = MMget_stemh ();
		return (num);
	}
#endif /* T1MMASTER */

   if (num)
       stemsnaph ((LPSW16)(&stems), num);

   return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int get_StemSnapV ()
#else
MLOCAL int get_StemSnapV ()
#endif
{
/* /StemSnapV [x1 x2 x3 ... x12] */

SW16  num = 0, stems[MAXSTEMS];

   if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
      return (ERR_psi_scan_StemSnapV);
  
   while (1)
   {
      if (t1scanone () < 0)
         return (ERR_psi_scan_StemSnapV);

      /* since this entry is almost alway integer, let's avoid FP here */
      if (elt.type == TYPE_INTEGER)
      {
         if (num >= MAXSTEMS)
            return (ERR_psi_scan_StemSnapV); /* too many values */
         stems[num++] = (SW16)elt.intval << 4;
      }
      else if (elt.type == TYPE_REAL)
      {
         if (num >= MAXSTEMS)
            return (ERR_psi_scan_StemSnapV); /* too many values */
         stems[num++] = ifpmul (16, elt.realval);
      }
      else
         break;
   } /* while (1) */

#if T1MMASTER
	if (*token == '[')
   {
		num = MMget_stemv ();
		return (num);
	}
#endif /* T1MMASTER */

   if (num)
       stemsnapv ((LPSW16)(&stems), num);

   return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int get_blues ()
#else
GLOBAL int get_blues ()
#endif
{
int  i = 0;
  /* PHW -- changed to 14 SW16s as per White Book */
SW16  blues[MAXBLUES];
  
  /* /BlueValues [x1 x2 ... x14] ND */

  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
  {
    DBG2 ("%s%s", t_get_blues, t_efs);
    return (ERR_psi_scan_Blues);
  }
  
  while (1)
  {
    if (t1scanone () < 0)
    {
      DBG2 ("%s%s", t_get_blues, t_efs);
      return (ERR_psi_scan_Blues);
    }

    if (elt.type == TYPE_INTEGER)
      blues[i++] = (SW16)elt.intval;
    else if (elt.type == TYPE_REAL)
      blues[i++] = fp2word (T1ROUND2 (elt.realval));
    else
      break;

    if (i >= MAXBLUES)
    {
      DBG1 ("%s - too many blues\n", t_get_blues);
      return (ERR_psi_scan_Blues);
    }
  } /* while (1) */

#if (T1MMASTER)
	if (*token == '[')
   {
		i = MMget_blues ();
		return (i);
	}
#endif

  if (i)      
      blue_values (blues, i);

  return (SUCCESS);
}
    
#if defined (ANSI_DEFS)
MLOCAL int get_other_blues ()
#else
MLOCAL int get_other_blues ()
#endif
{
int i = 0;
  /* PHW -- changed to 10 SW16s as per White Book */
SW16 blues[MAXOTHERBLUES];
  
  /* /OtherBlues [x1 x2 ... x10] ND */

  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
  {
    DBG2 ("%s%s", t_get_other_blues, t_efs);
    return (ERR_psi_scan_OBlues);
  }
  
  while (1)
  {
    if (t1scanone () < 0)
    {
      DBG2 ("%s%s", t_get_other_blues, t_efs);
      return (ERR_psi_scan_OBlues);
    }

    if (elt.type == TYPE_INTEGER)
      blues[i++] = (SW16)elt.intval;
    else if (elt.type == TYPE_REAL)
      blues[i++] = fp2word (T1ROUND2 (elt.realval));
    else
      break;

    if (i >= MAXOTHERBLUES)
    {
      DBG1 ("%s - too many other blues\n", t_get_other_blues);
      return (ERR_psi_scan_OBlues);
    }
  }

#if T1MMASTER
	if (*token == '[')
   {
		i = MMget_otherblues ();
		return (i);
	}
#endif

  if (i)
      other_blues (blues, i);

  return (SUCCESS);
}

/* PHW -- added get_bluescale and get_blueshift */
#if defined (ANSI_DEFS)
MLOCAL int get_bluescale ()
#else
MLOCAL int get_bluescale ()
#endif
{
  if (t1scanone () <= 0)
  {
    DBG2 ("%s%s", t_get_bluescale, t_efs);
    return (ERR_psi_scan_BScale);
  }

  if (elt.type == TYPE_INTEGER)
    bluescale ((SL32)(elt.intval * 32768L));
  else if (elt.type == TYPE_REAL)
    bluescale (fp2long((fpmul (elt.realval, fpint2fp(32768L)))));/* FP - 3/9/92 - rs */
  else
  {
    DBG1 ("%s - bad type\n", t_get_bluescale);
    return (ERR_psi_scan_BScale);
  }

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int get_blueshift ()
#else
MLOCAL int get_blueshift ()
#endif
{
  if (t1scanone () <= 0)
  {
    DBG2 ("%s%s", t_get_blueshift, t_efs);
    return (ERR_psi_scan_BShift);
  }

  if (elt.type == TYPE_INTEGER)
    blueshift (elt.intval);
  else if (elt.type == TYPE_REAL)
    blueshift(fp2long (elt.realval));
  else
  {
    DBG1 ("%s - bad type\n", t_get_blueshift);
    return (ERR_psi_scan_BShift);
  }

  return (SUCCESS);
}

/*
Add change 5/22/92 - rs
Use UFST mapping to enable all symbol sets with PostScript. The PostScript
standard or custom encoding will be left in the code for other products. It
should be conditioned out in the regular UFST product, however.
*/
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
#if defined (ANSI_DEFS)
MLOCAL int get_encoding ()
#else
MLOCAL int get_encoding ()
#endif
{
SW16     charid;
int      i;
PMEM_HANDLE pencodearray;
BOOLEAN  firstTime;
BOOLEAN  special_font;
    
 tryagain:
  /* found the start of some Encoding stuff */
  
  if (t1scanone () < 0)
  {
    DBG2 ("%s%s", t_get_encoding, t_efs);
    return (ERR_psi_scan_Encode);
  }

  if (ncheck ("StandardEncoding"))
  {
    DBG ("Using StandardEncoding\n");
    gpps->hencodearray = NIL_MH;

    Meto_encodearray = 0 ; /* For Meto Use Only  6-23-97  by jqz */
	cache_Meto_font = 0; /*keb*/
  }
  else
  {
    /* let's do another check here (for 256 following Encoding) */

    Meto_encodearray = 1 ; /* For Meto Use Only  6-23-97  by jqz */
	cache_Meto_font = 0; /*keb*/

    if (elt.type != TYPE_INTEGER || elt.intval != 256 )
    {
      if (scanto ("Encoding") < 0)
      {
        DBG2 ("%s%s", t_get_encoding, t_efs);
    return (ERR_psi_scan_Encode);
      }
      goto tryagain;
    }
      
    DBG ("Using non standard encoding\n");

    gpps->hencodearray = BUFalloc ((SL32)(256 * sizeof (MEM_HANDLE)));
    if (!gpps->hencodearray)
    {
        DBG2 ("%s%s", t_get_encoding, t_malloc);
      return (ERR_psi_Encode_mem);
    }
    pencodearray = (PMEM_HANDLE)MEMptr (gpps->hencodearray);
    for (i = 0; i < 256; ++i)
      pencodearray[i] = NIL_MH;
    
    firstTime = TRUE;  /* 9-29-93 jfd */
    
    /* now find the start of the names, in the format dup <n> name put */
    /* or Encoding <n> name put   9-29-93 jfd */
    
    while (((i = t1scanone ()) > 0) && ! ncheck ("readonly") )
    {
        if (i < 0)
        {
            DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
        }
        if ((! streq ("dup", (LPSB8)token)) &&
            (! streq ("Encoding", (LPSB8)token)) )  /* dup or Encoding */
          continue;

        /* set font type flag based on token ("dup" or "Encoding")
         * so that we will know when to exit
         *   9-29-93 jfd
         */

        if (firstTime)
        {
           special_font = FALSE;
           if (streq ("Encoding", (LPSB8)token))
              special_font = TRUE;
           firstTime = FALSE;
        }
           
        if (t1scanone () <= 0 || elt.type != TYPE_INTEGER )  /* n */
        {
          /* If processing "special" Type 1 font, break out of loop here */

            if (special_font)
               break;   /* 9-29-93 jfd */
            DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
        }
          
        charid = (SW16)elt.intval;
        if (!(t1scanone ()) || elt.type != TYPE_NAME 
          || charid < 0 || charid > 255)   /* name */
        {
            DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
        }
          
         pencodearray [charid] = namesave ((LPSB8)token, elt.len);
         if (!pencodearray [charid])
        {
          DBG2 ("%s%s", t_get_encoding, t_malloc);
          return (ERR_psi_Encodename_mem);
        }
        if (t1scanone () < 0)
        {
            DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
        }

    if ( ! ncheck ("put") )  /* put */
        {
            DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
        }
    } /* while (t1scanone() && ncheck()) */
                     
    if (!special_font)                     
       if ( ! streq ("readonly", (LPSB8)token) )
       {
          DBG2 ("%s%s", t_get_encoding, t_efs);
          return (ERR_psi_scan_Encode);
       }
      
    DBG ("finished setting up encoding array:\n");
  }

  return (SUCCESS);
}      
#endif /* (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2) */

#if defined (ANSI_DEFS)
MLOCAL int get_weight ()
#else
MLOCAL int get_weight ()
#endif
  /* /Weight (xxxx) */
{
SB8 tbuf[60];

  if (t1scanone () <= 0 || elt.type != TYPE_STRING)
  {
    DBG1 ("/Weight messed up:%s\n", token);
    return (SUCCESS);
  }
  
   if (elt.len > sizeof (tbuf))
      return (SUCCESS);
   MEMCPY (tbuf, token, elt.len);
   tbuf[elt.len] = '\0';

   DBG1 ("Found /Weight:%s\n", tbuf);
   if (strstr ("Bold", tbuf))
      gpxb->bucket_num |= B_BOLD;

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int get_italic ()
#else
MLOCAL int get_italic ()
#endif
  /* /ItalicAngle x */
{  
   if (t1scanone () <= 0 || elt.type != TYPE_INTEGER)
   {
      DBG1 ("ItalicAngle messed up%s\n", token);
      return (SUCCESS);
   }

   DBG1 ("Found ItalicAngle:%d\n", elt.intval);
   if (elt.intval)
      gpxb->bucket_num |= B_ITALIC;
  
    return (SUCCESS);
}


#if defined (ANSI_DEFS)
MLOCAL int get_ps_font_bbox ()
#else
MLOCAL int get_ps_font_bbox ()
#endif
{
int  i;
  /* /FontBBox [x1 x2 x3 x4] */
#if 0
  if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
#endif
  if (t1scanone () <= 0 || (elt.type != TYPE_STRING && elt.type != TYPE_ARRAY) )
  {
    DBG2 ("%s%s", t_get_ps_font_bbox, t_efs);
    return (ERR_psi_scan_ps_font_bbox);
  }
  
  for (i=0; i<4; i++)
  {
    if (t1scanone () < 0)
    {
      DBG2 ("%s%s", t_get_ps_font_bbox, t_efs);
      return (ERR_psi_scan_ps_font_bbox);
    }

    if (elt.type == TYPE_INTEGER)
      gpps->FontBBox[i] = (int)elt.intval;
    else if (elt.type == TYPE_REAL)
      gpps->FontBBox[i] = fp2word (T1ROUND2 (elt.realval));
    else
      break;

  }
  return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int get_famname ()
#else
MLOCAL int get_famname ()
#endif
  /* /FamilyName x */
{
SB8  tbuf[60];

   if (t1scanone () <= 0 || elt.type != TYPE_STRING)
   {
      DBG1 ("/FamilyName messed up:%s\n", token);
      return (SUCCESS);
   }

   if (elt.len > sizeof (tbuf))
      return (SUCCESS);
   MEMCPY (tbuf, token, elt.len);
   tbuf[elt.len] = '\0';

   DBG1 ("/FamilyName:%s\n", tbuf);
   if (strstr ("Univers", tbuf) || strstr ("Helvetica", tbuf))
      gpxb->bucket_num |= B_SANS_SERIF;

    return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int checkRD ()
#else
MLOCAL int checkRD ()
#endif
{
  if ( ncheck ("RD") ||  ncheck ("-|") ||  ncheck ("XD") )
    return (1);
  else if  ( ncheck ("VD") )    /* BitStream */
    return (2);
  else
    return (0);
}

#if defined (ANSI_DEFS)
MLOCAL int checkND ()
#else
MLOCAL int checkND ()
#endif
{
  return ncheck ("ND")  || ncheck ("|-") ;
}

#if defined (ANSI_DEFS)
MLOCAL int checkNP ()
#else
MLOCAL int checkNP ()
#endif
{
  return  ncheck ("|") ||  ncheck ("NP");
}

#if defined (ANSI_DEFS)
MLOCAL int check (LPSB8 s)
#else
MLOCAL int check (s)
LPSB8 s;
#endif
/* 11/26/91 - rs
Modified to return TRUE (1) if successfule, FALSE (0) if not to
facilitate error control - used to call 'error()' and abort.
*/
{
int wstat;

  wstat = t1scanone ();
  if (wstat <= 0 || !ncheck (s))
  {
      if (wstat < 0)
      {
          DBG2 ("%s%s", t_ncheck, t_efs);
          return (ERR_psi_scan_file);
      }
#ifdef DEBUG
       print_token ();
#endif
       return (0);
  }

  return (1);
}

#if defined (ANSI_DEFS)
MLOCAL int ncheck (LPSB8 s)
#else
MLOCAL int ncheck (s)
LPSB8 s;
#endif
{
  return ((elt.type == TYPE_NAME || elt.type == TYPE_OPERATOR)
      && streq (s, (LPSB8)token));
}

#if defined (ANSI_DEFS)
MLOCAL int get_subrs ()
#else
MLOCAL int get_subrs ()
#endif
{
#if !SHOWINPUT
register int x; /* used by macro for 't1input()' & 't1getbyte()' if !SHOWINPUT */
register int y; /* used by macro for 't1input()' & 't1getbyte()' if !SHOWINPUT */
#endif /* !SHOWINPUT */
SW16    subnum;
register LPUB8 s;
int rdflag;
int wstat;
PSUBS_STR   psubrs;  /* add 1/3/92 for handle changes - rs */

  /* /Subrs n array  */      

  if (t1scanone () <= 0 || elt.type != TYPE_INTEGER )
  {
    DBG2 ("%s%s", t_get_subrs, t_efs);
    return (ERR_psi_scan_Subrs);
  }

  if (!check ("array")) /* add test for error - 11/26/91 - rs */
  {
    DBG2 ("%s%s", t_get_subrs, t_efs);
    return (ERR_psi_scan_Subrs);
  }

  gpps->nsubs = (SW16)elt.intval;  
  DBG1 ("found Subrs, %d subroutines\n", gpps->nsubs);

  /* following changed because mesquite needs over 1,000 subrs!!! */

  gpps->hsubrs = BUFalloc ((SL32)(gpps->nsubs * sizeof (SUBS_STR)));
  if (!gpps->hsubrs)
  {
    DBG ("getsubrs() - unable to allocate memory\n");
     return (ERR_psi_SubrStr_mem);
  }
  psubrs = (PSUBS_STR)MEMptr (gpps->hsubrs);
  /*
    Initialize the subrs array so we can free it later
  */
  for (subnum = 0; subnum < gpps->nsubs; subnum++)
    psubrs[subnum].hdata = NIL_MH;

  /* let's build the subrs array now */
  /* dup sub# count RD <bindata> NP */
  /* dup sub# count Rd <bindata> noaccess put  (older fonts) */

  while (1)
  {
    wstat = t1scanone();
    if (wstat < 0)
    {
      DBG2 ("%s%s", t_get_subrs, t_efs);
      return (ERR_psi_scan_Subrs);
    }
    if (!wstat)
      return (SUCCESS);
      
    if (ncheck ("noaccess"))
    {
      if (t1scanone () < 0)
      {
        DBG2 ("%s%s", t_get_subrs, t_efs);
        return (ERR_psi_scan_Subrs);
      }
    }
      
    if ( checkND () || streq ("def", (LPSB8)token) || ncheck ("hires"))
      return (SUCCESS);

    if (! streq ("dup", (LPSB8)token))
      return (SUCCESS);

    if (t1scanone () <= 0 || elt.type != TYPE_INTEGER ) 
    {
      DBG2 ("%s%s", t_get_subrs, t_efs);
      return (ERR_psi_scan_Subrs);
    }
      
    subnum = (SW16)elt.intval;
    if (t1scanone () <= 0 || elt.type != TYPE_INTEGER)
    {
      DBG1 ("%s - bad type\n", t_get_subrs);
      return (ERR_psi_scan_Subrs);
    }
  
     if (subnum >= gpps->nsubs)
     {
       DBG3 ("%s: subnum too high:%d nsubs %d\n", t_get_subrs,
               subnum, gpps->nsubs);
        return (ERR_psi_Subr_too_hi);
     }
        
    DBG2 ("subr %d (%ld bytes)\n", subnum, elt.intval);
  
    psubrs[subnum].len = elt.intval;
    psubrs[subnum].hdata = BUFalloc ((SL32) elt.intval);
    if (psubrs[subnum].hdata == NIL_MH)
    {
      DBG2 ("%s%s", t_get_subrs, t_malloc);
      return (ERR_psi_Subrdat_mem);
    }
    s = (LPUB8)MEMptr (psubrs[subnum].hdata);

    if ( t1scanone () <= 0 || ! (rdflag = checkRD ()) )
    {
      DBG2 ("%s%s", t_get_subrs, t_efs);
      return (ERR_psi_scan_Subrs);
    }

    /* okay, now read in the subroutine definition */    

    while (elt.intval--)
      *s++  = (UB8)t1input ();

    psubrs[subnum].decrypted = FALSE;      
    if (t1scanone () < 0)
    {
      DBG2 ("%s%s", t_get_subrs, t_efs);
      return (ERR_psi_scan_Subrs);
    }

    if (rdflag == 1)
    {
      if ( ncheck ("noaccess") )
      {
    if (t1scanone () <= 0 || ! ncheck ("put") )
        {
          DBG2 ("%s%s", t_get_subrs, t_efs);
          return (ERR_psi_scan_Subrs);
        }
      }
      else if ( ! checkNP () )
      {
        DBG2 ("%s from %s\n", t_get_subrs, t_checkNP);
        return (ERR_psi_scan_Subrs);
      }
    }  
  }

  return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL int get_charstrings ()
#else
MLOCAL int get_charstrings ()
#endif
{
SW16 i, nchars;
PCDATASTR  pcharstrings;   /* add 1/3/92 - rs */

  DBG ("found CharStrings\n");

  /* <name> n RD <bindata> ND */

  /* PHW -- added to free data that may have already been allocated */
  free_charstrings (gpps);  /* free existing charstrings array */

  /* PHW -- added this */
  /* get next integer arg (size of CharStrings dictionary) */
  do
  {
    if (t1scanone () <= 0)
    {
      DBG2 ("%s%s", t_get_charstrings, t_efs);
      return (ERR_psi_scan_Charstr);
    }
  } while (elt.type != TYPE_INTEGER);

  gpps->n_chars = nchars = (SW16)elt.intval;

  /* allocate charstrings dictionary here based on actual size */
  gpps->hcharstrings = BUFalloc ((SL32)(nchars * sizeof (CDATASTR)));
  if (!gpps->hcharstrings)
  {
    DBG2 ("%s%s", t_get_charstrings, t_malloc);
     return (ERR_psi_CharStr_mem);
  }
  pcharstrings = (PCDATASTR)MEMptr (gpps->hcharstrings);

  /*
    Init charstrings array so we can free it later
  */
  for (i = 0; i < nchars; i++)
  {
    pcharstrings[i].hname = NIL_MH;
    pcharstrings[i].hdata = NIL_MH;
  }

  if (scanto ("begin") < 0)
  {
    DBG2 ("%s%s", t_get_charstrings, t_efs);
    return (ERR_psi_scan_Charstr);
  }
  gpps->curr_char = 0;
#if 0
  gpps->last_seek = tell (gpxb->fh) - (SL32)(t1bufend - t1bufptr);
#endif
  gpps->last_seek = LSEEK (gpxb->fh, 0L, SEEK_CUR) - (SL32)(t1bufend - t1bufptr);
  gpps->last_key = code;
  t1bufptr = t1bufend;
  return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL int more_charstrings (LPSB8 cname, int flg)
#else
GLOBAL int more_charstrings (cname, flg)
LPSB8   cname;  /* last char name to read */
int flg;        /* 0 if higher level handling, 1 if we are in control */
#endif
{
#if !SHOWINPUT
register int x, y; /* used by macros for t1input() & t1getbyte() if !SHOWINPUT */
#endif /* !SHOWINPUT */
register    LPUB8 s;
PCDATASTR   pcharstrings;
int        rdflag;
int        j, found = FALSE;

    if ((gpxb->fh == -1) && flg)
    {
      /*
         change from 'O_RDONLY|O_BINARY' to 'O_READFLAGS' because it did
         not work in Windows - 3/26/92 - rs
      */
        gpxb->fh = OPEN (gpxb->pathname, O_READFLAGS);
        if (gpxb->fh == -1)
        {
            DBG1 ("more_charstrings() - error opening Type 1 font:%s\n",
                gpxb->pathname);
            return (ERR_psi_open_file);
        }
       LSEEK (gpxb->fh, gpps->last_seek, SEEK_SET);
        code = gpps->last_key;
    }

  pcharstrings = (PCDATASTR)MEMptr (gpps->hcharstrings);

  while (!found)
  {
    j = t1scanone ();
    if (j < 0)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG2 ("%s%s", t_get_charstrings, t_efs);
      return (ERR_psi_scan_Charstr);
    }
    if (!j || ncheck ("end"))
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG1 ("Found %d character definitions\n", gpps->curr_char);
      break;  /* 10-06-93 jfd */
    }

    /* PHW -- added this sanity check */
    if (gpps->curr_char >= gpps->n_chars)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG3 ("%s: char #:%d > # chars in font:%d\n",
        t_get_charstrings, gpps->curr_char, gpps->n_chars);
      return (ERR_psi_Char_too_hi);
    }
      
    if (elt.type != TYPE_NAME)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG1 ("%s - bad type - expected name\n", t_get_charstrings);
      return (ERR_psi_scan_Charstr);
    }
      
    pcharstrings[gpps->curr_char].hname = namesave ((LPSB8)token, elt.len);
    if (!pcharstrings[gpps->curr_char].hname)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG2 ("%s%s", t_get_charstrings, t_malloc);
      return (ERR_psi_Charname_mem);
    }
    pcharstrings[gpps->curr_char].decrypted = FALSE;
    if (t1scanone() <= 0 || elt.type != TYPE_INTEGER)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG2 ("%s%s", t_get_charstrings, t_efs);
      return (ERR_psi_scan_Charstr);
    }

    if ( t1scanone () <= 0 || ! (rdflag = checkRD ()) )
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
      DBG3 ("%s or %s%s", t_get_charstrings, t_checkRD, t_efs);
      return (ERR_psi_scan_Charstr);
    }
    
    pcharstrings[gpps->curr_char].len = elt.intval;  
    pcharstrings[gpps->curr_char].hdata = BUFalloc ((SL32) elt.intval);
    if (!pcharstrings[gpps->curr_char].hdata)
    {
        if (flg)
        {
            CLOSE (gpxb->fh);
            gpxb->fh = -1;
        }
       DBG2 ("%s%s", t_get_charstrings, t_malloc);
      return (ERR_psi_Chardat_mem);
    }

    /* okay, now read in the character definition */    

    s = (LPUB8)MEMptr (pcharstrings[gpps->curr_char].hdata);
    while (elt.intval--)
      *s++  = (UB8)t1input ();

    if (rdflag == 1)
      if (t1scanone () <= 0 || ! checkND ())
      {
            if (flg)
            {
                CLOSE (gpxb->fh);
                gpxb->fh = -1;
            }
        DBG3 ("%s or %s%s", t_get_charstrings, t_checkND, t_efs);
        return (ERR_psi_scan_Charstr);
      }
    if (!STRCMP (MEMptr (pcharstrings[gpps->curr_char].hname), cname))
     {
    gpps->pthis_charstring = &pcharstrings[gpps->curr_char];
      found = TRUE;
     }
    gpps->curr_char++;  
  }

  if (flg)
  {
#if 0
     gpps->last_seek = tell (gpxb->fh) - (SL32)(t1bufend - t1bufptr);
#endif
    gpps->last_seek = LSEEK (gpxb->fh, 0L, SEEK_CUR) - (SL32)(t1bufend - t1bufptr);
    gpps->last_key = code;
    t1bufptr = t1bufend;
    CLOSE (gpxb->fh);
    gpxb->fh = -1;
  }
  if (found)
     return (SUCCESS);
  else return (ERR_no_cgnum);
}

#if (T1MMASTER)
MLOCAL int MMget_weights ()
{
	FPNUM	weights[MAXWEIGHTS];
	register int		i;

	/* /WeightVector [xxx xxx ...] def */

   DBG ("*** MMget_weights() ***\n");

	if (t1scanone () <= 0 || elt.type != TYPE_STRING || *token != '[')
   {
      DBG ("Error scanning WeightVector\n");
	  return (ERR_psi_WeightVector);
   }

   DBG ("[");

   for (i = 0; i < MAXWEIGHTS; i++)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
			weights[i] = fpint2fp (elt.intval);
		else if (elt.type == TYPE_REAL)
			weights[i] = elt.realval;
		else if (*token == ']')
			break;
		else
       {
         DBG ("Error scanning WeightVector\n");
		 return (ERR_psi_WeightVector);
       }

       DBG1 ("%f ", &weights[i]);
	}

   DBG ("]\n");

	if (gpps->MMnaxes != -1 && (1 << gpps->MMnaxes) != i)
   {
      DBG ("Error scanning WeightVector\n");
		return (ERR_psi_WeightVector);
   }

	i = add_weights (weights, i);
	return (i);
}

MLOCAL int MMget_stdvw ()
{
   DBG ("*** MMget_stdvw() ***\n");

   DBG ("MMstdvw [");
	for (gpps->MMnstdvw = 0; gpps->MMnstdvw < MAXAXES; gpps->MMnstdvw++)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
			gpps->MMstdvw[gpps->MMnstdvw] = (SW16)elt.intval << 4;
		else if (elt.type == TYPE_REAL)
			gpps->MMstdvw[gpps->MMnstdvw] = ifpmul (16, elt.realval);
		else if (*token == ']')
			break;
		else
      {
         DBG ("Error scanning MMstdvw\n");
			return (ERR_psi_MMstdvw);
      }
      DBG1 ("%d ", gpps->MMstdvw[gpps->MMnstdvw]);
	}
   DBG ("]\n");
   return (SUCCESS);
}

MLOCAL int MMget_stdhw ()
{
   DBG ("*** MMget_stdhw() ***\n");

   DBG ("MMstdhw [");
	for (gpps->MMnstdhw = 0; gpps->MMnstdhw < MAXAXES; gpps->MMnstdhw++)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
			gpps->MMstdhw[gpps->MMnstdhw] = (SW16)elt.intval << 4;
		else if (elt.type == TYPE_REAL)
			gpps->MMstdhw[gpps->MMnstdhw] =  ifpmul (16, elt.realval);
		else if (*token == ']')
			break;
		else
      {
         DBG ("Error scanning MMstdhw\n");
			return (ERR_psi_MMstdhw);
      }
      DBG1 ("%d ", gpps->MMstdhw[gpps->MMnstdhw]);
	}
   DBG ("]\n");
   return (SUCCESS);
}

MLOCAL int MMget_blendtypes ()
{
	register int i;

   DBG ("*** MMget_blendtypes() ***\n");

	t1scanone ();
	if (*token != '[')
   {
      DBG ("Error scanning MMblendtypes\n");
		return (ERR_psi_MMblendtypes);
   }

   DBG ("MMblendtypes [");
	t1scanone ();
	for (i = 0; *token != ']'; i++)
		t1scanone ();

	if (gpps->MMnaxes != -1 && gpps->MMnaxes != i)
   {
      DBG ("Error scanning MMblendtypes\n");
		return (ERR_psi_MMblendtypes);
   }
	else
		gpps->MMnaxes = i;

   DBG1 ("MMBlendtypes:%d", gpps->MMnaxes);
   return (SUCCESS);
}

MLOCAL int MMget_blendmap ()
{
	register int balance;
	PFPNUM pMMblendmap;

   DBG ("*** MMget_blendmap() ***\n");

	if (!gpps->hMMblendmap)
   {
		gpps->hMMblendmap = BUFalloc ((SL32)(50 * sizeof (FPNUM) * 2));
      if (!gpps->hMMblendmap)
      {
         DBG ("Error allocating hMMblendmap[]\n");
         return (ERR_psi_alloc_MMblendmap);
      }
   }
  pMMblendmap = (PFPNUM)MEMptr (gpps->hMMblendmap);

	t1scanone ();
	for (gpps->MMnblendmap = 0, balance = 1; balance;)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
      {
			pMMblendmap[gpps->MMnblendmap++] = fpint2fp (elt.intval);
         DBG1 ("%f ", &pMMblendmap[gpps->MMnblendmap-1]);
      }
		else if (elt.type == TYPE_REAL)
      {
			pMMblendmap[gpps->MMnblendmap++] = elt.realval;
         DBG1 ("%f ", &pMMblendmap[gpps->MMnblendmap-1]);
      }
		else if (*token == '[')
      {
         DBG ("[");
			balance++;
      }
		else if (*token == ']')
      {
         DBG ("]");
			balance--;
			if (!balance)
				break;
		}
		else
      {
         DBG ("Error scanning MMblendmap\n");
			return (ERR_psi_MMblendmap);
		}
	}
   return (SUCCESS);
}

MLOCAL int MMget_blues ()
{
	register int balance;
	LPSW16 pMMblues;

	if (!gpps->hMMblues)
   {
		gpps->hMMblues = BUFalloc ((SL32)(MAXAXES * MAXBLUES * sizeof (SW16)));
      if (!gpps->hMMblues)
      {
         DBG ("Error allocating hMMblues\n");
         return (ERR_psi_alloc_MMblues);
      }
   }
   pMMblues = (LPSW16)MEMptr (gpps->hMMblues);

	for (gpps->MMnblues = 0, balance = 2; gpps->MMnblues < MAXAXES * MAXBLUES;)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
      {
			pMMblues[gpps->MMnblues++] = (SW16)elt.intval;
         DBG1 ("%d ", pMMblues[gpps->MMnblues-1]);
      }
		else if (elt.type == TYPE_REAL)
      {
      /*
         NOTE: need to round this value!!!
      */
			pMMblues[gpps->MMnblues++] = fp2word (T1ROUND2 (elt.realval));
         DBG1 ("%d ", pMMblues[gpps->MMnblues-1]);
      }
		else if (*token == '[')
      {
         DBG ("[");
			balance++;
		}
		else if (*token == ']')
      {
         DBG ("]");
			balance--;
			if (!balance)
				break;
		}
	}
/*
NOTE: Should add some error checking to this function - 6/6/93 - rs
*/
   DBG ("\n");
   return (SUCCESS);
}

MLOCAL int MMget_otherblues ()
{
	register int balance;
   LPSW16 pMMotherblues;

   DBG ("*** MMget_otherblues() ***\n");

	if (!gpps->hMMotherblues)
   {
		gpps->hMMotherblues = BUFalloc (
         (SL32)(MAXAXES * MAXOTHERBLUES * sizeof (SW16)));
      if (!gpps->hMMotherblues)
      {
         DBG ("Error allocating hMMotherblues\n");
         return (ERR_psi_alloc_MMotherblues);
      }
   }
   pMMotherblues = (LPSW16)MEMptr (gpps->hMMotherblues);

	for (gpps->MMnotherblues = 0, balance = 2;
        gpps->MMnotherblues < MAXAXES * MAXBLUES;)
   {
		t1scanone ();
		if (elt.type == TYPE_INTEGER)
      {
			pMMotherblues[gpps->MMnotherblues++] = (SW16)elt.intval;
         DBG1 ("%d ", pMMotherblues[gpps->MMnotherblues-1]);
      }
		else if (elt.type == TYPE_REAL)
      {
			pMMotherblues[gpps->MMnotherblues++] =
                fp2word (T1ROUND2 (elt.realval));
         DBG1 ("%d ", pMMotherblues[gpps->MMnotherblues-1]);
      }
		else if (*token == '[')
      {
         DBG ("[");
			balance++;
		}
		else if (*token == ']')
      {
         DBG ("]");
			balance--;
			if (!balance)
				break;
		}
	}
/*
NOTE: Should add some error checking to this function - 6/6/93 - rs
*/
   DBG ("\n");
   return (SUCCESS);
}

MLOCAL int MMget_stemh ()
{
   DBG ("*** MMget_stemh() ***\n");
   return (SUCCESS);
}

MLOCAL int MMget_stemv ()
{
   DBG ("*** MMget_stemv() ***\n");
   return (SUCCESS);
}

MLOCAL int MMget_blendpos ()
{
   DBG ("*** MMget_blendpos() ***\n");
   return (SUCCESS);
}
#endif /* T1MMASTER */

#if defined (ANSI_DEFS)
GLOBAL UW16 psunload_font (PBUCKET pxb)
#else
GLOBAL UW16 psunload_font (pxb)
PBUCKET  pxb;
#endif
/*
Free all memory allocated for Type 1 input
*/
{
  DBG ("\npsunload_font()\n");

  if (! (pxb->rom_font & ROM_TYPE) )
  {
     free_charstrings (&pxb->p.ps);
     free_subrs (&pxb->p.ps);
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
     free_encoding (&pxb->p.ps);
#endif

#if T1MMASTER
     free_MMaster (&pxb->p.ps);
#endif

#if ASIAN_ENCODING
     free_COD (&pxb->p.ps);
#endif

  }
  return (SUCCESS);
}

#if defined (ANSI_DEFS)
MLOCAL VOID free_charstrings (PPS_BUCK lpps)
#else
MLOCAL VOID free_charstrings (lpps)
PPS_BUCK lpps;
#endif
{
SW16    i;
PCDATASTR pcharstrings;

  if (lpps->hcharstrings)
  {
    pcharstrings = (PCDATASTR)MEMptr (lpps->hcharstrings);
    for (i = 0; i < lpps->n_chars; ++i)
    {
      if (pcharstrings[i].hdata)
        BUFfree (pcharstrings[i].hdata);
      if (pcharstrings[i].hname)
        BUFfree (pcharstrings[i].hname);
    }
    BUFfree (lpps->hcharstrings);
    lpps->hcharstrings = NIL_MH;
  }

  return ;
}

#if defined (ANSI_DEFS)
MLOCAL VOID free_subrs (PPS_BUCK lpps)
#else
MLOCAL VOID free_subrs (lpps)
PPS_BUCK lpps;
#endif
/*
Ifthis is a "PostScript" downloaded soft font 'PST1_SFNTI', do not
free the individual surbroutine data strings. They will be freed by
the printer O/S.
*/
{
SW16    i;
PSUBS_STR   psubrs;

  if (lpps->hsubrs)
  {
    psubrs = (PSUBS_STR)MEMptr (lpps->hsubrs);
#if !PST1_SFNTI || defined (ROB_TEST) /* our local test does not free them */
/* do not free each subr data for PostScript type soft font */
    for (i = 0; i < lpps->nsubs; i++)
      if (psubrs[i].hdata)
        BUFfree (psubrs[i].hdata);
#endif
     BUFfree (lpps->hsubrs);
    lpps->hsubrs = NIL_MH;
  }

  return ;
}

#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
#if defined (ANSI_DEFS)
MLOCAL VOID free_encoding (PPS_BUCK lpps)
#else
MLOCAL VOID free_encoding (lpps)
PPS_BUCK lpps;
#endif
{
SW16    i;
PMEM_HANDLE pencodearray;

  if (lpps->hencodearray)
  {
    pencodearray = (PMEM_HANDLE)MEMptr (lpps->hencodearray);
    for (i = 0; i < 256; ++i)
      if (pencodearray[i])
         BUFfree (pencodearray[i]);
    BUFfree (lpps->hencodearray);
    lpps->hencodearray = NIL_MH;
  }

  return ;
}
#endif /* (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)*/

#if (T1MMASTER)
#if defined (ANSI_DEFS)
MLOCAL VOID free_MMaster (PPS_BUCK lpps)
#else
MLOCAL VOID free_MMaster (lpps)
PPS_BUCK lpps;
#endif
{

   DBG ("*** free_MMaster() ***\n");

   if (lpps->hMMblendmap)
   {
      BUFfree (lpps->hMMblendmap);
      lpps->hMMblendmap  = NIL_MH;
      lpps->MMnblendmap = 0;
   }

   if (lpps->hMMblues)
   {
      BUFfree (lpps->hMMblues);
      lpps->hMMblues = NIL_MH;
      lpps->MMnblues = 0;
   }

   if (lpps->hMMotherblues)
   {
      BUFfree (lpps->hMMotherblues);
      lpps->hMMotherblues = NIL_MH;
      lpps->MMnotherblues = 0;
   }
}
#endif /* (T1MMASTER) */

#ifdef DEBUG  
#if defined (ANSI_DEFS)
MLOCAL VOID print_token ()
#else
MLOCAL VOID print_token ()
#endif
{
  switch (elt.type)
  {
    case TYPE_INTEGER:
      DBG1 ("Integer token: %ld\n", elt.intval);
      break;
    case TYPE_REAL:
      DBG1 ("FPNUM token: %f\n", &elt.realval);
      break;
    case TYPE_NAME:
      DBG2 ("Name token: %.*s\n", elt.len, token);
      break;
    case TYPE_STRING:            
      DBG2 ("String token: %.*s\n", elt.len, token);
      break;
    default:
      DBG1 ("Token type: %d\n", elt.type);
  }
}
#endif /* DEBUG */

#if (PST1_DISK && (!USE_UFST_MAPPING || (USE_UFST_MAPPING == 2)))
/*
 * 9-13-93 jfd
 */
GLOBAL UW16
get_psfont_encoding_chars(fname)
LPUB8 fname;
{
  int fh;
  SB8 *fptr;
  SB8 *token;
  SB8 *encptr;
  UL32 hdr_len;
  int num_bytes;
  int j=0;

  DBG ("\nget_psfont_encoding_chars()\n");

  memset (encodearray, 0, sizeof(encodearray));

  if ((fh = OPEN((LPSB8)fname, O_READFLAGS)) == -1)  /* 2-7-94 jfd */
  {
     printf("Error - can't open file %s\n", fname);
     return ERR_open_lib;
  }

  LSEEK(fh, 2L, SEEK_SET);

  /* NOTE: DO WE HAVE TO SWAP THE FOLLOWING 4 BYTES WHEN RUNNING
   *       ON A MOTOROLA PLATFORM????
   */

  num_bytes = READF(fh, (SB8 *)&hdr_len, 4);

  if ((fptr = malloc((UW16)hdr_len)) == NULL)
  {
      printf("\n Can't malloc to find PS encoding array");
      CLOSE (fh);
      return ERRmem;
  }

  num_bytes = READF(fh, (SB8 *)fptr, (UW16)hdr_len);

  if ((encptr = strstr(fptr, "Encoding Standard")) != NULL)
  {
      printf("\n This font uses standard encoding");
      CLOSE (fh);
      free(fptr);
      return ERR_psi_scan_Encode;
  }

  if ((encptr = strstr(fptr, "Encoding")) == NULL)
  {
      printf("\n This font has neither encoding array");
      CLOSE (fh);
      free(fptr);
      return ERR_psi_scan_Encode;
  }

  token = strtok(encptr, " ");

  while ((strncmp(token, "put}", 4)) != 0)
  {
     /* Get next token */

     token = strtok(NULL, " ");
  }

  /* check for different formats of "for....dup" and
   * parse to start of encoding array data
   */

  if (strncmp(token, "put}for", 7) == 0)  /* e.g., ny.pfb */
  {
    /* next token should be charatcer ID */
  }
  else 
  {
    /* next comes either 
     * 1.) one token ("for.dup") followed by the character ID
     * 2.) two tokens ("for" and "def....Encoding") followed by the 
     *     character ID
     */

     token = strtok(NULL, " ");  /* "for.dup" or "for" */

     if ((strstr(token, "dup")) == 0)
     {
        while (strstr(token, "ncoding") == 0)
           token = strtok(NULL, " ");  /* parse to next 'Encoding' */
     }
  }

  /* We should be at start of encoding array */

  token = strtok(NULL, " ");  /* character id */
  encodearray[j++] = atoi(token);
  token = strtok(NULL, " ");  /* character name */
  token = strtok(NULL, " ");  /* "put.dup" or "put.Encoding: */

   while (((strstr(token, "ncoding")) != 0) || (strstr(token, "dup")) != 0)
   {
     token = strtok(NULL, " ");  /* character id */
     encodearray[j++] = atoi(token);
     token = strtok(NULL, " ");  /* character name */
     token = strtok(NULL, " ");  /* "put.dup" or "put.Encoding" */
   }

  CLOSE (fh);
  free(fptr);
  return SUCCESS;

}
#endif  /* PST1_DISK */

#else /* Ansi C - need at least 1 global */
int iT1ISCAN = 0;
#endif /* PST1_RDR */

