/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1isfnt.c,v 1.2 2003/05/07 23:02:27 Lann Exp $ */
/* $Log: t1isfnt.c,v $
/* Revision 1.2  2003/05/07 23:02:27  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.7   07 Apr 1995 10:27:20   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.6   22 Apr 1994 14:45:36   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   29 Sep 1993 12:16:12   JOE
 * 
 * In t1sfnt_info_callback(), save font bounding box info in
 * PS bucket.
 * 
 *    Rev 1.4   18 Aug 1993 16:29:44   JOE
 * 
 * Removed unnecessary ";" at end of function declaration for
 * PSSFNTload_font() to resolve compiler error on MIPS.
 * 
 *    Rev 1.3   21 Jun 1993 09:16:22   JOE
 * Corrected include statement (t1iproto.h insted of t1iprotos.h).
 * 
 *    Rev 1.2   15 Jun 1993 11:14:18   JOE
 * Moved "vxWorks.h" before "port.h" to resolve conflicts.
 * 
 *    Rev 1.1   14 Jun 1993 10:49:06   ROB
 * Ansi C requirement to have at least 1 global (ie when not enabled).
 * 
 *    Rev 1.0   08 Jun 1993 18:16:48   ROB
 * Initial revision.
 * 
*/
/* $Date: 2003/05/07 23:02:27 $ */

/* t1isfnt.c - UFST PostScript Type 1 downloaded soft font reader


REVISION HISTORY
-----------------------------------------------------------------------
29-May-93  rs	Original file created.
07-Jun-93  rs   Add call to 'MMsetup()' for multimaster.
11-Jun-93  rs  Ansi C requirement to have at least 1 global even if
               conditionals cause this code to not be used.
15-Jun-93  jfd Moved "vxWorks.h" before "port.h" to resolve conflicts.
16-Jun-93  jfd Changed include statement (t1iprotos.h to t1iproto.h).
18-Aug-93  jfd Removed unnecessary ";" at end of function declaration for
               PSSFNTload_font() to resolve compiler error on MIPS.
28-Sep-93  jfd In t1sfnt_info_callback (), save font bounding box info
               in PS bucket.

*/

#include "cgconfig.h"

#if PST1_SFNTI     /* conditionalize entire file */

#ifdef VXWORKS
#include "vxWorks.h"
#endif

#include "port.h"

#include <stdio.h>
#if defined (__WATCOMC__) || defined(__i960) || defined(VXWORKS) || defined (MSDOS)
#include <string.h>
#else
#include <memory.h>
#endif

#ifndef MIPS
#include <stdlib.h> /* atof() if not using internal FP - 5/8/92 - rs */
#endif

#include "debug.h"
#include "ifmem.h"                     /* 17-Feb-91 awr */
#include "mixmodel.h"
#include "fpmath.h" /* add 5/8/92 for 'fpatof()' - rs */
#include "cgif.h"
#include "ix.h"
#include "t1itype1.h"
#include "t1iproto.h"
#include "t1isfnt.h"



/*
Function prototypes
*/
#ifdef LINT_ARGS
EXTERN MEM_HANDLE   BUFalloc(SL32);

GLOBAL UW16 PSSFNTload_font (PFONT_DES);

GLOBAL int t1sfnt_info_callback (PFONT_DES, PPS_BUCK); /* MOVE TO APPLIC */
GLOBAL int get_t1sfnt_number_of_subrs (PFONT_DES);      /* MOVE TO APPLIC */
GLOBAL int get_t1sfnt_subrs (PFONT_DES, PSUBS_STR);     /* MOVE TO APPLIC */
GLOBAL SL32 get_t1sfnt_UniqueID (PFONT_DES); /* MOVE TO APPLIC  */

#else /* not LINT_ARGS */
EXTERN MEM_HANDLE   BUFalloc();

GLOBAL UW16 PSSFNTload_font ();

GLOBAL int  t1sfnt_info_callback ();         /* THIS WILL MOVE TO APPLIC */
GLOBAL int get_t1sfnt_number_of_subrs ();          /* THIS WILL MOVE TO APPLIC */
GLOBAL int get_t1sfnt_subrs ();                    /* THIS WILL MOVE TO APPLIC */
GLOBAL int get_t1sfnt_UniqueID (); /* MOVE TO APPLIC  */

#endif /* LINT_ARGS */


MLOCAL PBUCKET 		pxb;
MLOCAL PPS_BUCK   	pps;
MLOCAL LPUB8 ph; /* this will probably go away when the real thing is done */

#if defined (ANSI_DEFS)
GLOBAL UW16 PSSFNTload_font (PFONT_DES cur_font_hdr)
#else
GLOBAL UW16 PSSFNTload_font (cur_font_hdr)
PFONT_DES  cur_font_hdr;
#endif
/*
Load a PostScript Type 1 Soft Font

bucket should be initialized prior to getting here (ie 0's)

global values:
	gpxb = ptr to our bucket
	gpps = ptr to our PS specific bucket

NOTE: uses global ptr to our old PSEO header during debug - 'ph' !!!!
return (SUCCESS), else error code
*/
{
PSUBS_STR  pSUBS;
int status = SUCCESS;

	DBG ("\nPSSFNTload_font()\n");

   /*
      local pointers to bucket and type 1 sub-bucket
   */
	pxb = gpxb;
	pps = gpps;

   ph = (LPUB8)cur_font_hdr; /* use global ptr during debug !!!! */

   /*
      load the type 1 globals
   */
   status = t1sfnt_info_callback (pxb->cur_font_hdr, pps); /* load our globals */
   if (status)
      return (status);

   /*
      get the number of type 1 subroutines, then allocate memory to
      hold the subrs structure
   */
	pps->nsubs = get_t1sfnt_number_of_subrs (pxb->cur_font_hdr);
	pps->hsubrs = BUFalloc ((SL32)(pps->nsubs * sizeof (SUBS_STR)));
  	if (pps->hsubrs == NIL_MH)
  	{
    	DBG ("pspcl_getsubrs() - unable to alloc memory for subr struct\n");
	 	return (ERR_psi_SubrStr_mem);
  	}
  	pSUBS = (PSUBS_STR)MEMptr (pps->hsubrs);

   /*
      load the type 1 subroutines
   */
	status = get_t1sfnt_subrs (pxb->cur_font_hdr, pSUBS);
    if (status)
        return (status);

#if T1MMASTER
    status = MMsetup ();
#endif

	return (status);
}

#if defined (ANSI_DEFS)
GLOBAL int  t1sfnt_info_callback (PFONT_DES cur_font_hdr, PPS_BUCK pBUCK) /* MOVE TO APPLIC */
#else
GLOBAL int  t1sfnt_info_callback (cur_font_hdr, pBUCK) /* MOVE TO APPLIC */
PFONT_DES cur_font_hdr;
PPS_BUCK pBUCK;
#endif
/*
NOTE: uses global ptr to PSEO 'ph' during debug!!!!
*/
{
SW16        tmpwarray[MAXSTEMS];
SW16			tw;
SL32        tl;
int			j, k, status = SUCCESS;


   UNPACK_WORD((LPUB8)&tw);		/* get font descriptor size */
	ph += ((UL32)tw - 2L);         /* point to PS global data */
	while ((UL32)ph & 0x03)	      /* align to QUADWORD */
		ph++;

   /*
      We will use the old code to be backward compatible.
      If the first long == '1', this is the new format.
      Another test is if the 1st 24 bytes == 0, then old format.
   */
	UNPACK_LONG((LPUB8)&tl);		/* get format */
   if (tl != 1L)
   {
   /* already added 4 to 'ph' for 1 long (add anothre (6-1) longs) */
      ph += (5 * sizeof(UL32));     /* skip reserved1 */
	/*
		Set up default FontMatrix [.001 0 0 .001 0 0]
	*/
	pBUCK->fontmatrix[0] = pBUCK->fontmatrix[3] =  fpatof (".001");
	pBUCK->fontmatrix[1] = pBUCK->fontmatrix[2] = pBUCK->fontmatrix[4] =
		pBUCK->fontmatrix[5] = fpatof ("0");
   } /* else if (tl == 1L) */
   else
   {
      for (j = 0; j < 6; j++)
      {

         k = strlen ((LPSB8)ph);
         pBUCK->fontmatrix[j] = fpatof ((LPSB8)ph);
         ph += k+1;
      }
      /* quad align the ptr */
      while ((unsigned long)ph & 0x3L)
         ph++;
   } /* if (tl != 1L) */

/*
NOTE:  PATRICK
       how do we get the 'UniqueID' into higher level bucket???
       how do we get 'bucket_num' - used for plugin augmentation
       also may require pitch info
           maybe you do not use it?
*/
	UNPACK_LONG((LPUB8)&pxb->tfnum);		/* get UniqueID */

	UNPACK_LONG((LPUB8)&pBUCK->iBlueScale);

	UNPACK_WORD((LPUB8)&tw);		/* get Weight */
	if (tw > 550)
		pxb->bucket_num |= B_BOLD;

	UNPACK_WORD((LPUB8)&tw);		/* get ItalicAngle */
	if (tw)
		pxb->bucket_num |= B_ITALIC;

   /* skip IsFixedPitch, UnderLinePosition, UnderlineThickness */
   ph += (3 * sizeof(UW16));

	UNPACK_WORD((LPUB8)&tw);		/* get FontType */
	if (tw != 1)			         /* only handle Type 1 fonts */
		return (ERR_psi_pcleo_not1);

  /* Save font bounding box   9-28-93 jfd */

   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pBUCK->FontBBox[0] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pBUCK->FontBBox[1] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pBUCK->FontBBox[2] = (SW16)tw;
   UNPACK_WORD((LPUB8)&tw);       /* get xmin of Font BBOX */
   pBUCK->FontBBox[3] = (SW16)tw;

	UNPACK_WORD((LPUB8)&tw);		/* get # of BlueValues */
	pBUCK->numbblues = pBUCK->numtblues = 0;
	if (tw)
	{
		for (j = 0; j < tw; j++)
		{
			if (j < 2)
         {
				UNPACK_WORD((LPUB8)&pBUCK->bot_blues[pBUCK->numbblues]); /* get a BlueValues */
            pBUCK->numbblues++;
         }
			else
         {
				UNPACK_WORD((LPUB8)&pBUCK->top_blues[pBUCK->numtblues]); /* get a BlueValues */
            pBUCK->numtblues++;
         }
		}
	} /* if (tw) */

   /*
      skip past the dummy BlueValues
   */
   ph += ((14 - tw) * sizeof(UW16));

	UNPACK_WORD((LPUB8)&tw);		/* get # of OtherBlues */
	ph += (10 * sizeof(UW16));    /* skip past OtherBlues */

	UNPACK_WORD((LPUB8)&tw);		/* get # of FamilyBlues */
	ph += (14 * sizeof(UW16));		/* skip past FamilyBlues */

	UNPACK_WORD((LPUB8)&tw);		/* get # of FamilyOtherBlues */
	ph += (10 * sizeof(UW16));		/* skip past FamilyOtherBlues */

	UNPACK_WORD((LPUB8)&pBUCK->iBlueShift);

	UNPACK_WORD((LPUB8)&pBUCK->BlueFuzz);

	UNPACK_WORD((LPUB8)&pBUCK->StdHW);
	UNPACK_WORD((LPUB8)&pBUCK->StdVW);

	UNPACK_WORD((LPUB8)&tw); /* get # of StemSnapH values */
   for (j = 0; j < 12; j++)
   {
	   UNPACK_WORD((LPUB8)&tmpwarray[j]); /* get StemSnapH value */
   }
   stemsnaph ((LPSW16)tmpwarray, tw);

	UNPACK_WORD((LPUB8)&tw); /* get # of StemSnapV values */
   for (j = 0; j < 12; j++)
   {
	   UNPACK_WORD((LPUB8)&tmpwarray[j]); /* get StemSnapV value */
   }
   stemsnapv ((LPSW16)tmpwarray, tw);

	UNPACK_WORD((LPUB8)&tw);		/* get ForceBold */
	if (tw)
		pxb->bucket_num |= B_BOLD;

	ph += sizeof(UW16);			   /* skip past LanguageGroup */

	UNPACK_WORD((LPUB8)&pBUCK->lenIV);

	ph += (12 * sizeof(UW16));	   /* skip past Reserved2 */

   return (status);
}

#if defined (ANSI_DEFS)
GLOBAL int get_t1sfnt_number_of_subrs (PFONT_DES cur_font_hdr)    /* MOVE TO APPLIC */
#else
GLOBAL int get_t1sfnt_number_of_subrs (cur_font_hdr)    /* MOVE TO APPLIC */
PFONT_DES cur_font_hdr;
#endif
/*
NOTE: uses global ptr to PSEO 'ph' during debug!!!!
*/
{
SW16  nSubrs;

	DBG ("\nget_subrs()\n");

	UNPACK_WORD((LPUB8)&nSubrs);	/* get # of subrs */
   return (nSubrs);
}

#if defined (ANSI_DEFS)
GLOBAL int	get_t1sfnt_subrs (PFONT_DES cur_font_hdr, PSUBS_STR psubrs) /* MOVE TO APPLIC */
#else
GLOBAL int	get_t1sfnt_subrs (cur_font_hdr, psubrs) /* MOVE TO APPLIC */
PFONT_DES cur_font_hdr;
PSUBS_STR  psubrs;
#endif
/*
Read PostScript PCLEO Subrs

NOTE: uses global ptr to PSEO 'ph' during debug!!!!
return (SUCCESS), else error code
*/
{
register LPUB8 s;
SW16	nSubrs = gpps->nsubs, len;
SW16	subnum;  /* changed from int to set with UNPACK_WORD() */
                 /* Int on SUN is 32 bits not 16 for word -ss 5/21/92 */
int     j;

  	/*
    	Initialize the subrs array so we can free it later
  	*/
  	for (subnum = 0; subnum < nSubrs; subnum++)
    	psubrs[subnum].hdata = NIL_MH;

        for (j = 0; j < nSubrs; j++)
        {
           UNPACK_WORD((LPUB8)&subnum);

      if ((UW16)subnum == 0xffff)
         break;   /* no more subroutines! */

      DBG2 ("%d Subr:%d ", j, subnum);
	   if (subnum >= pps->nsubs)
	   {
	      DBG2 ("subnum too high:%d nsubs %d\n", subnum, pps->nsubs);
		   return (ERR_psi_Subr_too_hi);
	   }
	   UNPACK_WORD((LPUB8)&len);	/* get subr length */
      psubrs[subnum].len = len;
      DBG1 ("len:%d ", len);

      psubrs[subnum].hdata = BUFalloc ((SL32)len);
      if (psubrs[subnum].hdata == NIL_MH)
      {
         DBG1 ("Unable to alloc memory for subr %d data\n", subnum);
         return (ERR_psi_Subrdat_mem);
      }
      psubrs[subnum].decrypted = *ph++;         /* get flag byte */
      DBG1 ("flag:%X\n", psubrs[subnum].decrypted);

      s = (LPUB8)MEMptr (psubrs[subnum].hdata);/* get memory for subr data */
      while (len--)                             /* read subr data */
         *s++  = *ph++;
   }
   return (SUCCESS);
}

#if defined (ANSI_DEFS)
GLOBAL SL32 get_t1sfnt_UniqueID (PFONT_DES cur_font_hdr)
#else
GLOBAL SL32 get_t1sfnt_UniqueID (cur_font_hdr)
PFONT_DES cur_font_hdr;
#endif
/*
Return the UniqueID of the specified soft font
*/
{
   return (gpxb->tfnum); /* debug only */
}
#else /* Ansi C - need at least 1 global */
int iT1ISFNT = 0;
#endif /* PST1_SFNTI */

