/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1isfnt.h,v 1.2 2003/05/07 23:02:29 Lann Exp $ */
/* $Log: t1isfnt.h,v $
/* Revision 1.2  2003/05/07 23:02:29  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.3   07 Apr 1995 10:33:08   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.2   22 Apr 1994 14:49:10   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.1   16 Sep 1993 10:05:56   JOE
 * Conditionally compiled typedef for PS_CHAR_HDR because it is also 
 * defined in T1IPCLEO.H .
 * 
 *    Rev 1.0   08 Jun 1993 18:17:12   ROB
 * Initial revision.
 * 
*/
/* $Date: 2003/05/07 23:02:29 $ */

/* t1isfnt.h - UFST PostScript Type 1 down loaded soft font header file

************************************************************************
*                                                                      *
*
************************************************************************

REVISION HISTORY
-----------------------------------------------------------------------
29-May-92  rs	Original file created.
16-Sep-93  jfd Conditionally compiled typedef for PS_CHAR_HDR because
               it is also defined in T1IPCLEO.H.
*/

/*
cgconfig.h and port.h must be loaded prior to including this file
*/


#if PST1_SFNTI    /* conditionalize entire file */

/*
NOTE: These defines may only be required during DEBUG, the application will
      know how to extract the information from the down loaded font.
*/

#if (BYTEORDER == LOHI) /* ie. Intel */
#define UNPACK_WORD(pb) *(pb) = *(LPUB8)((LPUB8)ph+1); \
      *(pb+1) = *(LPUB8)ph;  ph = (LPUB8)(ph + 2);
#define UNPACK_LONG(pb) *(pb) = *(LPUB8)((LPUB8)ph+3); \
      *(pb+3) = *(LPUB8)ph; *(pb+1) = *(LPUB8)((LPUB8)ph+2); \
      *(pb+2) = *(LPUB8)((LPUB8)ph+1); ph = (LPUB8)(ph + 4);

#else /* HILO (ie. Motorola) - don't swap bytes */
#define UNPACK_WORD(pb) *(pb) = *(LPUB8)ph; \
      *((pb)+1) = *(LPUB8)((LPUB8)ph+1);  (LPUB8)ph += 2;
#define UNPACK_LONG(pb) *(pb) = *ph; \
      *((pb)+1) = *(LPUB8)((LPUB8)ph+1); *((pb)+2) = *(LPUB8)((LPUB8)ph+2); \
      *((pb)+3) = *(LPUB8)((LPUB8)ph+3); (LPUB8)ph += 4;

#endif /* BYTEORDER */


/*
PostScript PSEO character data structure
*/

#ifndef PS_CHAR_HDR_DEFINED
typedef struct {
UB8      format;           /* raster=4, DJ=5, IF=10, TT=15, PS=30 */
UB8      continuation;     /* always 0 */
UB8      descriptorsize;   /* always 2 */
UB8      class;            /* contour=3, compound=4, tt=10, ps=11 */
SW16     len;              /* # of bytes to follow (not including csum) */
} PS_CHAR_HDR;
#define PS_CHAR_HDR_DEFINED
#endif

#endif /* PST1_SFNTI */

