/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1isyntb.c,v 1.2 2003/05/07 23:02:29 Lann Exp $ */
/* $Log: t1isyntb.c,v $
/* Revision 1.2  2003/05/07 23:02:29  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   07 Apr 1995 10:27:34   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 14:45:36   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   13 Jul 1993 13:09:26   JOE
 * 
 * Set "iT1ISYNTB" = 0 if !PST1_RDR.
 * 
 *    Rev 1.2   07 Jan 1993 08:46:40   JOE
 * Removed CTRL-Z at end of file.
 * 
 *    Rev 1.1   14 Dec 1992 09:58:52   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:30   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:29 $ */
/* t1isyntb.c */
/************************************************************************
 *                                                                      *
 *
 *
 *    Copyright (c) 1989 by                                             *
 *    Pipeline Associates, Inc., Morris Plains, NJ                      *
 *      All rights reserved.                                            *
 *                                                                      *
 *   This software is furnished under a license and may be used and     *
 *   copied  only  in accordance with the terms of such license and     *
 *   with the  inclusion  of  the  above  copyright  notice.   This     *
 *   software  or  any  other copies thereof may not be provided or     *
 *   otherwise made available to any other person except as allowed     *
 *   under  license.  No  title to and ownership of the software is     *
 *   hereby transferred.                                                *
 *                                                                      *
 *   This software is proprietary to Pipeline Associates, Inc., and     *
 *   is not to be disclosed without written permission from Pipeline    *
 *   Associates, Inc.                                                   *
 *                                                                      *
 ************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
09/27/91  rs	Original file created from Pipeline Associates 'syntab.c'.
04/03/92  rs   Portability cleanup (see port.h).
21-Jul-92 awr  Conditional compile changes.
08-Aug-92 rs	Change 'syntax_flagtab[]' from 'UL32' to 'unsigned long' to
					fix fatal compiler error with Watcom C386.
07-Jan-93 jfd  Removed CTRL-Z at end of file.
13-Jul-93 jfd  Set "iT1ISYNTB" = 0 if !PST1_RDR.
*/
 
#include "cgconfig.h"

#if PST1_RDR	/* conditional compile entire module */ 

#include "port.h"
#include "t1isyntx.h"

/*
 *  This table contains the syntax of all the 8-bit characters
 *  which may be encountered by the interpreter when reading
 *  files or strings.  Note that all the meta-characters are
 *  given with _0 (zero) so that they are ``nothing special''
 *  characters.  This defines the meaning of all the characters
 *  which the PostScript interpreter recognizes.
 *
 *  Current syntax classes:
 *  Intro    /
 *  Open    ( < { [
 *  Close    ) > } ]
 *  String    ( )
 *  Array    [ ]
 *  Proc    { }
 *  Hex    < >
 *  Escape    \
 *  Octal    0-7
 *  Digit    8 9
 *  Hexadecimal  a-f A-F
 *  Radix    #
 *  Minus    -
 *  Plus    +
 *  Point    .
 *  Exponent  e E
 *  Lower case  a-z
 *  Upper case  A-Z
 *  Blank    SPC TAB LFD RET NULL CTRL-D CTRL-Z
 *  Return    RET LFD
 *  Comment    %
 */
GLOBAL unsigned long syntax_flagtab[256] =
{
/* octal:  00  01  02  03  04  05  06  07 */
/* 00n */  _B,  _0,  _0,  _0,  _B,  _0,  _0,  _0,
/* 01n */  _0,  _B,  _B|_R,  _0,  _0,  _B|_R,  _0,  _0,
/* 02n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 03n */  _0,  _0,  _B,  _0,  _0,  _0,  _0,  _0,
/* 04n */  _B,  _0,  _0,  _X,  _0,  _O|_M,  _0,  _0,
/* 05n */  _O|_S,  _C|_S,  _0,  _Y,  _0,  _G,  _T,  _O|_N,
/* 06n */  _D|_8,  _D|_8,  _D|_8,  _D|_8,  _D|_8,  _D|_8,  _D|_8,  _D|_8,
/* 07n */  _D,  _D,  _0,  _0,  _O|_H,  _0,  _C|_H,  _0,
/* 10n */  _0,  _U|_6,  _U|_6,  _U|_6,  _U|_6,  _U|_6|_W,_U|_6,  _U,
/* 11n */  _U,  _U,  _U,  _U,  _U,  _U,   _U,  _U,
/* 12n */  _U,  _U,  _U,  _U,  _U,  _U,  _U,  _U,
/* 13n */  _U,  _U,  _U,  _A|_O,  _E,  _A|_C,  _0,  _0,
/* 14n */  _0,  _L|_6,  _L|_6,  _L|_6,  _L|_6,  _L|_6|_W,_L|_6,  _L,
/* 15n */  _L,  _L,  _L,  _L,  _L,  _L,  _L,  _L,
/* 16n */  _L,  _L,  _L,  _L,  _L,  _L,  _L,  _L,
/* 17n */  _L,  _L,  _L,  _O|_P,  _0,  _C|_P,  _0,  _0,
/* 20n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 21n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 22n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 23n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 24n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 25n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 26n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 27n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 30n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 31n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 32n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 33n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 34n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 35n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 36n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0,
/* 37n */  _0,  _0,  _0,  _0,  _0,  _0,  _0,  _0
};

/*
 *  The table below provides a mapping between ASCII characters
 *  and the numbers they represent as a digit.  Valid ``digits''
 *  are [0-9a-zA-Z] which means the largest valid radix is 36
 *  (the smallest valid radix is 2, of course).
 */
GLOBAL SB8 digit_convtab[128] =
{
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, -1, -1, -1, -1, -1, -1,
  -1, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
  25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, -1, -1, -1, -1, -1,
  -1, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
  25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, -1, -1, -1, -1, -1
};

#else
int iT1ISYNTB = 0;
#endif /* PST1_RDR */
