/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1isyntx.h,v 1.2 2003/05/07 23:02:29 Lann Exp $ */
/* $Log: t1isyntx.h,v $
/* Revision 1.2  2003/05/07 23:02:29  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   07 Apr 1995 10:33:12   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 14:49:28   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   09 Jun 1993 14:45:28   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.2   15 Jan 1993 10:29:38   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 10:00:14   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:23:14   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:29 $ */
/* t1isyntx.h */
/************************************************************************
 *                                                                      *
 *      Copyright (c) 1989 by                                           *
 *    Pipeline Associates, Inc., Morris Plains, NJ                      *
 *    All rights reserved.                                              *
 *                                                                      *
 *   This software is furnished under a license and may be used and     *
 *   copied  only  in accordance with the terms of such license and     *
 *   with the  inclusion  of  the  above  copyright  notice.   This     *
 *   software  or  any  other copies thereof may not be provided or     *
 *   otherwise made available to any other person except as allowed     *
 *   under  license.  No  title to and ownership of the software is     *
 *   hereby transferred.                                                *
 *                                                                      *
 *   This software is proprietary to Pipeline Associates, Inc., and     *
 *   is not to be disclosed without written permission from Pipeline    *
 *   Associates, Inc.                                                   *
 *                                                                      *
 ************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
09/27/91  rs	Original file created from Pipeline Associates 'syntax.h'.
06/09/93  jfd  Changed all references to "char" to "SB8" for transportability.

*/

#define _0 0           /* nothing special about this   */
#define _N (1L << 0)   /* introduces a literal name    */
#define _O (1L << 1)   /* an open delimiter            */
#define _C (1L << 2)   /* a close delimiter            */
#define _S (1L << 3)   /* string delimiter             */
#define _A (1L << 4)   /* array delimiter              */
#define _P (1L << 5)   /* proc array delimiter         */
#define _H (1L << 6)   /* hex data delimiter           */
#define _E (1L << 7)   /* introduces an escape         */
#define _D (1L << 8)   /* a digit                      */
#define _8 (1L << 9)   /* an octal digit               */
#define _6 (1L << 10)  /* an hexadecimal digit         */
#define _L (1L << 11)  /* a lower case letter          */
#define _U (1L << 12)  /* an upper case letter         */
#define _X (1L << 13)  /* radix extension for integers */
#define _G (1L << 14)  /* minus sign                   */
#define _T (1L << 15)  /* decimal point                */
#define _W (1L << 16)  /* exponent leader              */
#define _B (1L << 17)  /* a blank character            */
#define _R (1L << 18)  /* a newline (or return)        */
#define _M (1L << 19)  /* a comment-start character    */
#define _Y (1L << 20)  /* a plus sign                  */

/*
 *  Table which specifies the syntax of all 256 possible 8-bit
 *  characters the interpreter may encounter.  This table may be
 *  changed, to create a new syntax, but this is probably unwise.
 *  This table is declared in "src/syntab.c".  In essence, it
 *  implements the standard PostScript syntax for the ASCII
 *  character set.
 */

extern unsigned long  syntax_flagtab[256];

#define TYPE_NULL     0  /* special object null                 */
#define TYPE_INTEGER  1  /* signed integer value                */
#define TYPE_REAL     2  /* signed floating point value         */
#define TYPE_BOOL     3  /* boolean value                       */
#define TYPE_STRING   4  /* string (array of bytes)             */
#define TYPE_NAME     5  /* a name token                        */
#define TYPE_ARRAY    6  /* array of objects                    */
#define TYPE_DICT     7  /* a PostScript dictionary             */
#define TYPE_MARK     8  /* a mark object                       */
#define TYPE_OPERATOR 9  /* an operator (C-coded routine)       */
#define TYPE_FILE     10 /* a file (created by file operator)   */
#define TYPE_SAVE     11 /* an object created by save           */
#define TYPE_FONTID   12 /* a font handle (font machinery only) */
#define TYPE_PACKED   13 /* a packed array                      */
#define TYPE_USTRING  14 /* un-encrypted string (for type1)     */



#define SYNFLAGS(c)  syntax_flagtab[(c) & 0377]

/*
 *  Numbers are a pain.  We have lots of macros because numbers are
 *  so variable in their format.  Not only do we have to deal with
 *  integer vs. real, but we also have the awful radix extension
 *  thingy for integers.  Note that isdigit() and isoctal() are
 *  declared above with the more sane syntax classes.
 */
#define isexponent(c) ((SYNFLAGS(c) & _W) != 0)
#define isinteger(c)  ((SYNFLAGS(c) & (_D|_X|_G|_L|_Y)) != 0)
#define isreal(c)     ((SYNFLAGS(c) & (_D|_G|_T|_W|_Y)) != 0)
#define isplus(c)     ((SYNFLAGS(c) & _Y) != 0)

/*
 *  These macros test for the specific syntax of various
 *  characters.  Usually, only one character will fulfill
 *  the test.  For example '(' is the only character for
 *  which ``isopen(c) && isstring(c)'' is true.
 */
#define isopen(c)    ((SYNFLAGS(c) & _O) != 0)
#define isclose(c)   ((SYNFLAGS(c) & _C) != 0)
#define isstring(c)  ((SYNFLAGS(c) & _S) != 0)
#define isarray(c)   ((SYNFLAGS(c) & _A) != 0)
#define isproc(c)    ((SYNFLAGS(c) & _P) != 0)
#define isxdata(c)   ((SYNFLAGS(c) & _H) != 0)
#define isescape(c)  ((SYNFLAGS(c) & _E) != 0)
#define isradix(c)   ((SYNFLAGS(c) & _X) != 0)
#define isminus(c)   ((SYNFLAGS(c) & _G) != 0)
#define ispoint(c)   ((SYNFLAGS(c) & _T) != 0)
#define isintro(c)   ((SYNFLAGS(c) & _N) != 0)
#define iscomment(c) ((SYNFLAGS(c) & _M) != 0)

/*
 *  Character class macros which are used to determine the
 *  syntactic class of characters.  These are based on PostScript
 *  syntax rules; special characters are ( ) [ ] { } < > / and %,
 *  all other characters are regular.  Blank (space) characters are
 *  SPC \t \n and \r (the last two are also return characters).
 *  Names may contain regular characters that aren't blanks.  We
 *  also recognize octal decimal and hexadecimal digits and letters
 *  for the purposes of scanning numbers.
 */
#define isspecial(c) ((SYNFLAGS(c) & (_S|_A|_P|_H|_N|_M)) != 0)
#define isregular(c) ((SYNFLAGS(c) & (_S|_A|_P|_H|_N|_M)) == 0)
#define isname(c)    ((SYNFLAGS(c) & (_S|_A|_P|_H|_N|_M|_B)) == 0)
#define isblank(c)   ((SYNFLAGS(c) & _B) != 0)
#define isreturn(c)  ((SYNFLAGS(c) & _R) != 0)
#define isdigit(c)   ((SYNFLAGS(c) & (_8|_D)) != 0)
#define isoctal(c)   ((SYNFLAGS(c) & _8) != 0)
#define ishex(c)     ((SYNFLAGS(c) & (_8|_D|_6)) != 0)
#define isupper(c)   ((SYNFLAGS(c) & _U) != 0)
#define islower(c)   ((SYNFLAGS(c) & _L) != 0)
#define isletter(c)  ((SYNFLAGS(c) & (_L|_U)) != 0)

/*
 *  We keep a table of signed characters to convert ASCII
 *  digits into the values they represent.  The digitval()
 *  macro simply looks the digit up in the table.  If the
 *  value is not a digit (a number or letter), this macro
 *  will return -1.
 */
extern SB8  digit_convtab[128];

#define digitval(c)  (digit_convtab[c & 0177])

/*
 *  Generally useful macros, but ones that aren't based on the
 *  syntax table and thus are dependent on the ASCII character
 *  set.  If this program is ever expected to run on an EBCDIC
 *  machine (God help us), a ``printable'' flag will need to be
 *  added to the table.  Probably the difference between ``control''
 *  and ``meta'' won't make sense anyway.
 */
#define isctrl(c)  ((c) < ' ')
#define ismeta(c)  ((c) > '~')
#define isimage(c) ((c) >= ' ' && (c) <= '~')
#define isprint(c) (isblank(c) || isreturn(c) || isimage(c))

/*
 *  We have to assume the syntax codes below, which are pretty much
 *  the standard ones, because looking though the syntax table would
 *  be too slow and prone to problems.  These are used for printing
 *  values--not for input.
 */
#define ESCAPECHAR  '\\'
#define BEGINSTRING '('
#define ENDSTRING   ')'
#define BEGINARRAY  '['
#define ENDARRAY    ']'
#define BEGINPROC   '{'
#define ENDPROC     '}'
#define BEGINHEX    '<'
#define ENDHEX      '<'
#define NAMEINTRO   '/'

#define TABWIDTH  8

