/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1itrans.c,v 1.2 2003/05/07 23:02:29 Lann Exp $ */
/* $Log: t1itrans.c,v $
/* Revision 1.2  2003/05/07 23:02:29  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.9   07 Apr 1995 10:27:14   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.8   22 Apr 1994 14:45:42   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   22 Feb 1994 16:16:04   JOE
 * In psset_trans(), re-disabled block of code which dealt with horizontal
 * and vertical stem widths due to inconsistencies.
 * 
 *    Rev 1.6   26 Jul 1993 11:51:10   ROB
 * n
 * Change 'xnum' & 'ynum' from SW16 to int.
 * 
 *    Rev 1.5   13 Jul 1993 13:11:12   JOE
 * 
 * Set "iT1ITRANS" = 0 if !PST1_RDR.
 * 
 *    Rev 1.4   18 Jun 1993 18:44:46   ROB
 * Re-enabled a block of code which Pipeline recommended removing as a temp
 * fix for stem weight problems. This is now handled by other improvements.
 * 
 *    Rev 1.3   08 Jun 1993 18:08:34   ROB
 * Pipeline upgrade for type 1 quality improvements.
 * 
 *    Rev 1.2   07 Jan 1993 09:03:02   JOE
 * ANSI C function declaration changes.
 * 
 *    Rev 1.1   14 Dec 1992 10:00:56   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:22:18   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:29 $ */
/* t1itrans.c */
/************************************************************************
 *									*
 *			Copyright (c) 1990, 1991 by			*
 *		Pipeline Associates, Inc., Morris Plains, NJ		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person except as allowed	*
 *   under  license.  No  title to and ownership of the software is	*
 *   hereby transferred.						*
 *									*
 *   This software is proprietary to Pipeline Associates, Inc., and	*
 *   is not to be disclosed without written permission from Pipeline	*
 *   Associates, Inc.							*
 *									*
 ************************************************************************/
 /*
REVISION HISTORY
-----------------------------------------------------------------------
pre-historic	Version 1.0 -- original
pre-historic	Version 1.1 -- added better handling of BlueValues and OtherBlues
pre-historic	Version 1.2 -- stem adjustments added
pre-historic	Version 1.3 -- no change
pre-historic	Version 1.4 -- added overshoot control, oblique and rotated transforms
pre-historic	Version 1.5 -- fixed bug with StdHW/VW
pre-historic	Version 1.6 -- optionally uses BlueScale and BlueShift
09/27/91  rs	Original file created from Pipeline Associates 'trans.c'.
12/17/91  rs   Make 'transfn8()' global to scale escapement.
01/29/92  rs   Error return code cleanup.
04/03/92  rs   Portability cleanup (see port.h).
21-Jul-92 awr  Conditional compile changes.
07-Jan-93 jfd  ANSI C function declaration changes.
***********************************************************************
12-May-93 rs   Integrate upgrade from Pipeline ***
               Their comments follow this line ***
     Version 1.0 -- original
     Version 1.1 -- added better handling of BlueValues and OtherBlues
     Version 1.2 -- stem adjustments added
     Version 1.3 -- no change
     Version 1.4 -- added overshoot control, oblique and rotated Transforms
     Version 1.5 -- fixed bug with StdHW/VW
     Version 1.6 -- optionally uses BlueScale and BlueShift
     Version 1.9 -- changed transform to Transform
     Version 1.9.1 -- added tests for zero to trans functions
     Version 1.9.2 -- added tests for emboldening
     Version 3.1 -- added floating-point scaling for > 30,000 pixels
***********************************************************************
17-May-93 rs   Disable removing of StemSnap in psset_trans() when StdHW &
               StdVW are close.
Version 3.2.1 -- changed overshoot computation and defaults in custom.h
24-May-93 rs   Integrate Pipeline '3.2.1'.
06-Jun-93 rs   Update from Pipeline for 'psset_trans()' to correct smaller
               character heights upwards by about 1/2 pixel.
18-Jun-93 rs   Remove temp patch from Pipeline (now handled differently).
13-Jul-93 jfd  Set "iT1ITRANS" = 0 if !PST1_RDR.
23-Jul-93 rs   Change 'xnum' & 'ynum' from SW16 to int.
22-Feb-94 jfd  In psset_trans(), re-disabled block of code which dealt with
               horizontal and vertical stem widths due to inconsistencies.
*/



#include "cgconfig.h"

#if PST1_RDR	/* conditional compile entire module */ 


#include "port.h"
#include "ifmem.h"
#include "cgif.h"
#include "ix.h"   /* PFONT_DES */
#include "fpmath.h"
#include "t1itype1.h"
#include "t1iproto.h"


#if 0
#include "type1.h"
#include "protos.h"
#include "hints.h"
#include "custom.h"
#include "t1error.h"
#endif /* 0 */

#ifdef LINT_ARGS
GLOBAL UW16 psset_trans (PBUCKET, SL32, SL32, SL32, SL32);
MLOCAL VOID transfn1 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn2 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn3 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn5 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn6 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn7 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
GLOBAL VOID transfn8 (SL32, SL32, LPSL32, LPSL32); /* SW16 to SL32 11/16/91 rs*/
MLOCAL VOID transfn9 (SL32, SL32, LPSL32, LPSL32); /* floating pt version */
#if 0
MLOCAL t1setauxtrans (SL32 a, SL32 b, SL32 c, SL32d);
#endif

MLOCAL VOID (*trans_funcs[]) (SL32, SL32, LPSL32, LPSL32) =
{
  transfn8, transfn1, transfn2,
  transfn3,  transfn8, transfn5,
  transfn6, transfn7, transfn8, transfn9
};

#else /* no LINT_ARGS */
GLOBAL UW16 psset_trans ();
MLOCAL VOID transfn1 ();
MLOCAL VOID transfn2 ();
MLOCAL VOID transfn3 ();
MLOCAL VOID transfn5 ();
MLOCAL VOID transfn6 ();
MLOCAL VOID transfn7 ();
GLOBAL VOID transfn8 ();
MLOCAL VOID transfn9 ();
#if 0
MLOCAL t1setauxtrans ();
#endif

MLOCAL VOID (*trans_funcs[]) () =
{
  transfn8, transfn1, transfn2,
  transfn3,  transfn8, transfn5,
  transfn6, transfn7, transfn8, transfn9
};

#endif /* LINT_ARGS */




EXTERN T1I_HINT_STR xhints[], yhints[];
EXTERN int xnum, ynum;

#if defined (ANSI_DEFS)
GLOBAL UW16 psset_trans (PBUCKET pxb, SL32 a, SL32 b, SL32 c, SL32 d)
#else
GLOBAL UW16 psset_trans (pxb, a, b, c, d)
PBUCKET pxb;
SL32 a, b, c, d;
#endif
/*
** set the Transformation matrix for the rasterizer
** all values << 15
*/
{
	register int i;
	register SL32 tmp;
	register SL32 scalefac;

  gpps = &pxb->p.ps;

	/* any scale factor > 30,000 pixels? */
	if (ABS(a) >= 983040L || ABS(b) >= 983040L ||
	    ABS(c) >= 983040L || ABS(d) >= 983040L) {
		gpps->Transform[0] = a;
		gpps->Transform[1] = b;
		gpps->Transform[2] = c;
		gpps->Transform[3] = d;
		gpps->transptr = transfn9;
                gpps = (PPS_BUCK)0;
		return (SUCCESS);
	}

	if (!a && !b && !c && !d)
		/* error (UNDEFINEDRESULT); */
		a = 1L;

	/* decide which Transformation elements are small enough to ignore */
	if (PSABS (scale (a, 2048)) < ONE_HALF)
		gpps->Transform[0] = 0;
	else
		gpps->Transform[0] = a;
	if (PSABS (scale (b, 2048)) < ONE_HALF)
		gpps->Transform[1] = 0;
	else
		gpps->Transform[1] = b;
	if (PSABS (scale (c, 2048)) < ONE_HALF)
		gpps->Transform[2] = 0;
	else
		gpps->Transform[2] = c;
	if (PSABS (scale (d, 2048)) < ONE_HALF)
		gpps->Transform[3] = 0;
	else
		gpps->Transform[3] = d;

	/* determine which coordinates depend on x, y, or both */
	gpps->trans = gpps->Transform[0] ? (gpps->Transform[1] ? 6 : 3) : 0;
	gpps->trans += gpps->Transform[2] ? (gpps->Transform[3] ? 2 : 1) : 0;

	/* set the function pointer */
	gpps->transptr = trans_funcs[gpps->trans];

	/* x transfer value */
	if (gpps->trans == 3 || gpps->trans == 5)
		gpps->t1auxxtrans = gpps->t1xtrans = gpps->Transform[0];
	else if (gpps->trans == 1 || gpps->trans == 7)
		gpps->t1auxxtrans = gpps->t1xtrans = gpps->Transform[2];
	else
		gpps->t1auxxtrans = gpps->t1xtrans = 0;

	/* y transfer value */
	if (gpps->trans == 3 || gpps->trans == 6)
		gpps->t1auxytrans = gpps->t1ytrans = gpps->Transform[3];
	else if (gpps->trans == 1 || gpps->trans == 2)
		gpps->t1auxytrans = gpps->t1ytrans = gpps->Transform[1];
	else
		gpps->t1auxytrans = gpps->t1ytrans = 0;

	/* do we need blue values? */
	if (gpps->t1ytrans) {
		for (i = 0; i < gpps->numbblues; i += 2) {
			tmp = scale (gpps->t1ytrans, gpps->bot_blues[i + 1]);
			/* truncate */
			if (T1SIGN (gpps->t1ytrans) > 0)
				gpps->bot_refs[i / 2] = tmp & ~0xF;
			else
				gpps->bot_refs[i / 2] = (tmp + 15) & ~0xF;
		}
		for (i = 0; i < gpps->numtblues; i += 2) {
			tmp = scale (gpps->t1ytrans, gpps->top_blues[i]);
			/* ceiling */
			if (T1SIGN (gpps->t1ytrans) > 0)
				gpps->top_refs[i / 2] = (tmp + 15) & ~0xF;
			else
				gpps->top_refs[i / 2] = tmp & ~0xF;
		}
	}

	if (!gpps->numStemSnapH) {
		gpps->numStemSnapH = 1;
		gpps->StemSnapH[0] = gpps->inStdHW;
	}
	if (!gpps->numStemSnapV) {
		gpps->numStemSnapV = 1;
		gpps->StemSnapV[0] = gpps->inStdVW;
	}

	/* if StdHW - StdVW <= stem_match pixels, set to same for consistency */
	tmp = PSABS (gpps->inStdHW - gpps->inStdVW);
	scalefac = PSMAX (PSABS (a), PSABS (b));
	scalefac = PSMAX (PSABS (c), scalefac);
	scalefac = PSMAX (PSABS (d), scalefac);

/*  5/17/93 - rs
NOTE:
   Re: conversation with Pat Wood - disable the following block of code
   which essentially disables StemSnap use when StdHW & StdVW are close.
   6/18/93 - re-enable the block of code - this is now handled by
   other code improvements
   2/22/94 - re-disable the block of code due to inconsistent stem widths
             (jfd)
*/
#if 0 /* 2-22-94 jfd */
	if (scale (tmp, scalefac) <= gpps->stem_match) {
	    /* set canonical stem width to average of StdHW and StdVW */
	    gpps->StdVW = gpps->StdHW = (gpps->inStdHW + gpps->inStdVW) / 2;
	    tmp = scale (gpps->t1xtrans, gpps->StdVW);
	    tmp = PSABS (tmp);
	    gpps->stem_refv[0] = tmp - gpps->stem_adjust;
	    gpps->stem_refv[1] = tmp + gpps->stem_adjust;
	    gpps->stem_refv[2] = T1ROUND (tmp);

	    tmp = scale (gpps->t1ytrans, gpps->StdHW);
	    tmp = PSABS (tmp);
	    gpps->stem_refh[0] = tmp - gpps->stem_adjust;
	    gpps->stem_refh[1] = tmp + gpps->stem_adjust;
	    gpps->stem_refh[2] = T1ROUND (tmp);
	    gpps->numStemSnapH = gpps->numStemSnapV = 1;
	}
	else {
	    /*
	    ** set canonical stem width to value in stemsnap if
	    ** difference between value and StdHW/VW is > stem_adjust
	    ** (nominally 1) pixels; otherwise use StdHW/VW
	    */
	    gpps->StdHW = scale (gpps->t1ytrans, gpps->inStdHW);
	    gpps->StdHW = PSABS (gpps->StdHW);
	    gpps->StdVW = scale (gpps->t1xtrans, gpps->inStdVW);
	    gpps->StdVW = PSABS (gpps->StdVW);
	    for (i = 0; i < gpps->numStemSnapH; i++) {
	    	tmp = scale (gpps->t1ytrans, gpps->StemSnapH[i]);
		tmp = PSABS (tmp);
		if (PSABS (tmp - gpps->StdHW) > gpps->stem_adjust) {
		    gpps->stem_refh[i * 3] = tmp - gpps->stem_adjust;
		    gpps->stem_refh[i * 3 + 1] = tmp + gpps->stem_adjust;
		    gpps->stem_refh[i * 3 + 2] = T1ROUND (tmp);
		}
		else {
		    gpps->stem_refh[i * 3] = gpps->StdHW - gpps->stem_adjust;
		    gpps->stem_refh[i * 3 + 1] = gpps->StdHW + gpps->stem_adjust;
		    gpps->stem_refh[i * 3 + 2] = T1ROUND (gpps->StdHW);
		}
	    }
	    for (i = 0; i < gpps->numStemSnapV; i++) {
	        tmp = scale (gpps->t1xtrans, gpps->StemSnapV[i]);
		tmp = PSABS (tmp);
		if (PSABS (tmp - gpps->StdVW) > gpps->stem_adjust) {
		    gpps->stem_refv[i * 3] = tmp - gpps->stem_adjust;
		    gpps->stem_refv[i * 3 + 1] = tmp + gpps->stem_adjust;
		    gpps->stem_refv[i * 3 + 2] = T1ROUND (tmp);
		}
		else {
		    gpps->stem_refv[i * 3] = gpps->StdVW - gpps->stem_adjust;
		    gpps->stem_refv[i * 3 + 1] = gpps->StdVW + gpps->stem_adjust;
		    gpps->stem_refv[i * 3 + 2] = T1ROUND (gpps->StdVW);
		}
	    }
	}
#endif  /* 0  2-22-94 jfd */

#if defined (PS_PSEUDO_ENBOLDEN) /* not supported at this time - rs 5/15/93 */
	/*
	** if normal stem width > 1.5 or size > 15 pixels/em,
	** turn off emboldening, so we only force emboldening
	** at smallest sizes
	*/
	tmp = MAX (gpps->inStdVW, gpps->inStdHW);
	if (scale (tmp, scalefac) >= ONE + ONE_HALF || scalefac > 490)
		bolden = 0;
#endif

	/* deal with BlueScale and BlueShift parameter */
	if (gpps->useblues && gpps->t1ytrans) {
	    if (PSABS (gpps->t1ytrans) < gpps->iBlueScale)
		     gpps->overshoot = (gpps->iBlueScale << 4) / PSABS (gpps->t1ytrans);
	    else {
			  gpps->overshoot = scale (gpps->iBlueShift, PSABS (gpps->t1ytrans));
		     gpps->overshoot = PSMIN (gpps->overshoot, ONE_HALF);
       }
	}

    gpps = (PPS_BUCK)0;
    return (SUCCESS);	/* we have an OK Transformation */
}

#if 0 /* not used at this time */
#if defined (ANSI_DEFS)
MLOCAL VOID t1setauxtrans (SL32 a, SL32 b, SL32 c, SL32 d)
#else
MLOCAL VOID t1setauxtrans (a, b, c, d)
long a, b, c, d;
#endif
{
	int trans;

	/* decide which Transformation elements are small enough to ignore */
	if (ABS (scale (a, 2048)) < ONE_HALF)
		a = 0;
	if (ABS (scale (b, 2048)) < ONE_HALF)
		b = 0;
	if (ABS (scale (c, 2048)) < ONE_HALF)
		c = 0;
	if (ABS (scale (d, 2048)) < ONE_HALF)
		d = 0;

	/* determine which coordinates depend on x, y, or both */
	trans = a ? (b ? 6 : 3) : 0;
	trans += c ? (d ? 2 : 1) : 0;

	/* x transfer value */
	if (trans == 3 || trans == 5)
		t1auxxtrans = a;
	else if (trans == 1 || trans == 7)
		t1auxxtrans = c;
	else
		t1auxxtrans = 0;

	/* y transfer value */
	if (trans == 3 || trans == 6)
		t1auxytrans = d;
	else if (trans == 1 || trans == 2)
		t1auxytrans = b;
	else
		t1auxytrans = 0;
}
#endif /* 0 */

/*
** The following transfer functions are based on how the glyph is
** oriented in device space.  Anything that is rotated off a 90 degree
** angle is calculated with the normal (matrix) Transformation methods.
** All values that are parallel to the X or Y axis are computed using
** the hint structure array.
*/

#if defined (ANSI_DEFS)
MLOCAL VOID transfn1 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn1 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 90 degree rotation -- x' depends on y and y' depends on x */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;

	end = xhints + xnum - 1;

	for (ptr = xhints + 1; ptr < end && ptr->hint < x; ptr++)
		;
	if (x == ptr->hint)
		*y1 = ptr->pixel;
	else {
		ptr--;
		*y1 = scale ((x - ptr->hint), ptr->pixscale) + ptr->pixel;
	}

	end = yhints + ynum - 1;

	for (ptr = yhints + 1; ptr < end && ptr->hint < y; ptr++)
		;
	if (y == ptr->hint)
		*x1 = ptr->pixel;
	else {
		ptr--;
		*x1 = scale ((y - ptr->hint), ptr->pixscale) + ptr->pixel;
	}
}

#if defined (ANSI_DEFS)
MLOCAL VOID transfn2 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn2 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 90 degree rotation and oblique y -- x' depends on y and y' depends on both */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;

	end = yhints + ynum - 1;

	for (ptr = yhints + 1; ptr < end && ptr->hint < y; ptr++)
		;
	if (y == ptr->hint)
		*x1 = ptr->pixel;
	else {
		ptr--;
		*x1 = scale ((y - ptr->hint), ptr->pixscale) + ptr->pixel;
	}

	*y1 = scale (x,gpps->Transform[2]) + scale (y,gpps->Transform[3]);
}

#if defined (ANSI_DEFS)
MLOCAL VOID transfn3 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn3 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 0 degree rotation -- x' depends on x and y' depends on y */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;
register PT1I_HINT_STR ptr1;

	end = xhints + xnum - 1;

	for (ptr = xhints + 1; ptr < end && ptr->hint < x; ptr++)
		;
	if (x == ptr->hint)
		/* a hit! */
		*x1 = ptr->pixel;
	else {
		ptr1 = ptr;
		/* see if we have a near miss */
		ptr--;
		*x1 = scale ((x - ptr->hint), ptr->pixscale) + ptr->pixel;
		if (PSABS (*x1 - ptr->pixel) < gpps->hint_gravity)
			*x1 = ptr->pixel;
		else if (PSABS (*x1 - ptr1->pixel) < gpps->hint_gravity)
			*x1 = ptr1->pixel;
	}

	end = yhints + ynum - 1;

	for (ptr = yhints + 1; ptr < end && ptr->hint < y; ptr++)
		;
	if (y == ptr->hint)
		*y1 = ptr->pixel;
	else {
        ptr1 = ptr;
		/* see if we have a near miss */
		ptr--;
		*y1 = scale ((y - ptr->hint), ptr->pixscale) + ptr->pixel;
		if (PSABS (*y1 - ptr->pixel) < gpps->hint_gravity)
			*y1 = ptr->pixel;
		else if (PSABS (*y1 - ptr1->pixel) < gpps->hint_gravity)
			*y1 = ptr1->pixel;
	}
}

#if defined (ANSI_DEFS)
MLOCAL VOID transfn5 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn5 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 0 degree rotation and oblique y -- x' depends on x and y' depends on both */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;

	end = xhints + xnum - 1;

	for (ptr = xhints + 1; ptr < end && ptr->hint < x; ptr++)
		;
	if (x == ptr->hint)
		*x1 = ptr->pixel;
	else {
		ptr--;
		*x1 = scale ((x - ptr->hint), ptr->pixscale) + ptr->pixel;
	}

	*y1 = scale (x, gpps->Transform[2]) + scale (y, gpps->Transform[3]);
}

#if defined (ANSI_DEFS)
MLOCAL VOID transfn6 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn6 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 0 degree rotation and oblique x -- x' depends on both and y' depends on y */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;

	end = yhints + ynum - 1;

	for (ptr = yhints + 1; ptr < end && ptr->hint < y; ptr++)
		;
	if (y == ptr->hint)
		*y1 = ptr->pixel;
	else {
		ptr--;
		*y1 = scale ((y - ptr->hint), ptr->pixscale) + ptr->pixel;
	}

	*x1 = scale (x, gpps->Transform[0]) + scale (y, gpps->Transform[1]);
}

#if defined (ANSI_DEFS)
MLOCAL VOID transfn7 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn7 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* 90 degree rotation and oblique x -- x' depends on both and y' depends on x */
{
register PT1I_HINT_STR ptr;
register PT1I_HINT_STR end;

	end = xhints + xnum - 1;

	for (ptr = xhints + 1; ptr < end && ptr->hint < x; ptr++)
		;
	if (x == ptr->hint)
		*y1 = ptr->pixel;
	else {
		ptr--;
		*y1 = scale ((x - ptr->hint), ptr->pixscale) + ptr->pixel;
	}

	*x1 = scale (x, gpps->Transform[0]) + scale (y, gpps->Transform[1]);
}

#if defined (ANSI_DEFS)
GLOBAL VOID transfn8 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
GLOBAL VOID transfn8 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
/* non 90 degree rotation -- x depends on both and y depends on both */
{
	*x1 = scale (x, gpps->Transform[0]) + scale (y, gpps->Transform[1]);
	*y1 = scale (x, gpps->Transform[2]) + scale (y, gpps->Transform[3]);
}

/* floating pt transformation -- because the values are too large */

#if defined (ANSI_DEFS)
MLOCAL VOID transfn9 (SL32 x, SL32 y, LPSL32 x1, LPSL32 y1)
#else
MLOCAL VOID transfn9 (x, y, x1, y1)
SL32 x, y;
LPSL32 x1, y1;
#endif
{
#if 0 /* original code */
	float t1, t2;

	t1 = (float) x * Transform[0]  + (float) y * Transform[1];
	t2 = (float) x * Transform[2]  + (float) y * Transform[3];
	*x1 =  t1 / 2048;
	*y1 =  t2 / 2048;
#else /* modified for UFST floating point 5-12-93 - rs */
FPNUM t1, t2;

	t1 =  fpadd (fpint2fp (x * gpps->Transform[0]),
            fpint2fp (y * gpps->Transform[1]));
	t2 =  fpadd (fpint2fp (x * gpps->Transform[2]),
            fpint2fp (y * gpps->Transform[3]));
	*x1 =  fp2long (fpdiv (t1, fpint2fp (2048L)));
	*y1 =  fp2long (fpdiv (t2, fpint2fp (2048L)));
#endif
}

#else
int iT1ITRANS = 0;
#endif /* PST1_RDR */

