/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/psi/t1itype1.h,v 1.2 2003/05/07 23:02:29 Lann Exp $ */
/* $Log: t1itype1.h,v $
/* Revision 1.2  2003/05/07 23:02:29  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   07 Apr 1995 10:33:14   LISA
 * 
 * Changed copyright from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   22 Apr 1994 14:49:26   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.6   26 Jul 1993 11:50:20   ROB
 * Add 'constant
 * ' variables 'FPZERO' & 'FPONEHALF'.
 * 
 *    Rev 1.5   15 Jun 1993 11:54:48   ROB
 * Remove global 'hexasciiflg' & replace with entry in type 1 bucket 'hexascii'.
 * 
 *    Rev 1.4   08 Jun 1993 17:59:00   ROB
 * Type 1 quality improvements as per Pipeline upgrade.
 * 
 *    Rev 1.3   19 Mar 1993 11:42:44   JOE
 * **ROB** Changes for Kanji support.
 * 
 *    Rev 1.2   15 Jan 1993 10:29:42   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:59:02   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:23:16   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:29 $ */
/* t1itype1.h */
/*************************************************************************
 *                                                                       *
 *                 Copyright (c) 1989, 1990, 1991 by                     *
 *            Pipeline Associates, Inc., Morris Plains, NJ               *
 *                        All rights reserved.                           *
 *                                                                       *
 *   This software is furnished under a license and may be used and      *
 *   copied  only  in accordance with the terms of such license and      *
 *   with the  inclusion  of  the  above  copyright  notice.   This      *
 *   software  or  any  other copies thereo0f may not be provided or     *
 *   otherwise made available to any other person except as allowed      *
 *   under  license.  No  title to and ownership of the software is      *
 *   hereby transferred.                                                 *
 *                                                                       *
 *   This software is proprietary to Pipeline Associates, Inc., and      *
 *   is not to be disclosed without written permission from Pipeline     *
 *   Associates, Inc.                                                    *
 *                                                                       *
 ************************************************************************/
/*
REVISION HISTORY
-----------------------------------------------------------------------
09/27/91  rs	Original file created from Pipeline Associates 'type1.h'.
11/01/91  rs	Combine 't1ihints.h' with this file.
11/19/91  rs	Add 'hexasciiflg' for binary vs hex ascii fonts.
01/21/92  rs   Remove 't1sub_vecs' - not needed by Subdivide() any more.
01/23/92  rs   Additional cleanup.
01/31/92  rs   Add defines for PostScript Charstrings commands.
02/12/92  rs   Incorporate changes from Pipeline. Change macro 'ROUND' to
               'T1ROUND'. Add macro 'T1SIGN'.
03/10/92  rs   Remove 'ROUND2' macro, not used.
03/23/92  ss   Changed hexasciiflg from WORD to int to match declaration in
               t1iscan.c.
04/04/92  rs	Portability cleanup (see port.h).
03/15/93  rs   Changes for type 0 fonts (JIS_ENCODING).
05/13/93  rs   Integrate Pipeline upgrade.
05/24/93  rs   Pipeline adjustments for 'STEMWID' & 'STEMMATCH'.
06/06/93  rs   Add 'T1ROUND2(f)' macro, MuliMaster support.
06/15/93  rs   Remove global 'hexasciiflg', replace with entry in type 1
               bucket 'hexascii'.
07/23/93  rs   Add constants for FPZERO & FPONEHALF;
*/

/*
Note: requires 'port.h' to be #included prior to this file.
*/

/*
PostScript Charstring commands
*/
#define t1_HSTEM			   1
#define t1_VSTEM			   3
#define t1_YRMOVETO		   4
#define t1_RLINETO		   5
#define t1_XRLINETO		   6
#define t1_YRLINETO		   7
#define t1_RRCURVETO	      8
#define t1_CLOSEPATH		   9
#define t1_CALLSUBR		   10
#define t1_RETURN 		   11
#define t1_ESCAPE 		   12
#define t1_HSBW			   13
#define t1_ENDCHAR		   14
#define t1_RMOVETO		   21
#define t1_HMOVETO		   22
#define t1_VHCURVETO		   30
#define t1_HVCURVETO		   31

/*
Charstring multi-byte "escape" command codes
*/
#define t1e_DOTSECTION	   0
#define t1e_VSTEM3		   1
#define t1e_HSTEM3		   2
#define t1e_SEAC   		   6
#define t1e_SBW   		   7
#define t1e_DIV   		   12
#define t1e_CALLOTHERSUBR  16
#define t1e_POP   		   17
#define t1e_SETCURPT 	   33


typedef struct {
  MEM_HANDLE   hdata; /* was LPUB8 */
  SL32	      len;
  SB8	      decrypted;
} SUBS_STR; 
typedef SUBS_STR FARPTR * PSUBS_STR;

/* this is the table of the character descriptions */

typedef struct {
  MEM_HANDLE   hname; /* was LPSB8 */
  MEM_HANDLE   hdata; /* was LPUB8 */
  SL32    len;
  SB8    decrypted;
} CDATASTR;
typedef CDATASTR FARPTR * PCDATASTR;

typedef struct {
  SW16  type;
  SL32  intval;  /* or size of string or name */
  FPNUM  realval;
  SW16  len;
} TOKENSTR;
typedef TOKENSTR FARPTR * PTOKENSTR;

typedef struct {
	SL32 hint;		/* pos of hint in character units - SW16 to SL32 12/16/91 */
	SL32 pixscale;	/* scale factor for interpolation */
	SL32 pixel;		/* scaled value in pixel space for this hint */
} T1I_HINT_STR;
typedef T1I_HINT_STR FARPTR * PT1I_HINT_STR;

#define PSABS(x) (((x) < 0) ? -(x) : (x))
#define PSMIN(x,y) (((x) < (y)) ? (x) : (y))
#define PSMAX(x,y) (((x) > (y)) ? (x) : (y))
#define EOF (-1)
#define ONE_HALF 8   /* 1/2 pixel in FOPS */
#define ONE 16       /* 1 pixel in FOPS */
#define TWO 32       /* 2 pixels in FOPS */
#define T1ROUND(p)   (((p) + 8) & ~0xF)
#define T1SIGN(x)  ((x) < 0 ? -1 : 1)
#define scale(a, b) (SL32) ((1024 + (SL32) (a) * (b)) >> 11)
#define T1ROUND2(f) (f) /* need to add this!!!! */

/* move minxy() from t1ihints.c - 5/14/93 - rs */
#define minxy(x,y)  (minx = PSMIN (minx, x), miny = PSMIN (miny, y), \
           maxx = PSMAX (maxx, x), maxy = PSMAX (maxy, y))


#define NUMHINTS    50
#define MAXBLUES	14		/* from the White Book */
#define MAXOTHERBLUES	10		/* from the White Book */

#define STEMWID	ONE_HALF	/* stem adjustment cutoff */
#define STEMMATCH	0  	   /* stem adjustment cutoff */
#define STEMMIN	ONE		/* stem adjustment cutoff */
#define OVERSHOOT	ONE_HALF	/* suppress overshoots < this amount */
#define USEBLUES	TRUE		/* use BlueScale and BlueShift */
#define BLUESHIFT	7		/* from the White Book */
#define BLUESCALE	((SL32)(.039625 * 32768L)) /* from the White Book */
#define BLUEFUZZ	1		/* from the White Book */
#define MAXBLUES	14		/* from the White Book */
#define MAXOTHERBLUES	10		/* from the White Book */



/*
  Move these defines from t1iscan.c to support Kanji
*/
#define streq(s1,s2)  (*(s1) == *(s2) && STRCMP(s1,s2) == 0)
#define unput(c)  (__savec = c, unputflag = TRUE)
#define t1input()    (unputflag ? (unputflag = FALSE, __savec) :  t1getbyte())
/*
add cast to UW16 to clean up warnings - 10/2/91 - rs
#define psgetc()  ((t1bufptr >= t1bufend && reader () == 0) ? EOF :  *t1bufptr++)
*/
#if 0 /* change this 3/16/93 - rs */
#define psgetc()  ((t1bufptr >= t1bufend && reader () == 0) ? EOF :  ((int)(*t1bufptr++)&0xff) )
#endif

#define psgetc()  \
  ( (t1bufptr >= t1bufend) ? \
     (reader () <= 0) ? (EOF) : ((int)(*t1bufptr++)&0xff) \
      : ((int)(*t1bufptr++)&0xff) )

EXTERN LPSB8 stdencoding[];
EXTERN SB8 NOTDEF[];
EXTERN SW16 last_cmd;   /* remember for 2 moveto's at char start */
EXTERN PBUCKET    gpxb; /* add 1/6/92 - rs */
EXTERN PPS_BUCK   gpps;
EXTERN PCHAR_STATS gpcs;
EXTERN UB8  token[1025];
EXTERN TOKENSTR elt;
EXTERN FPNUM  FPZERO;   /* floating point 0.0 */
EXTERN FPNUM  FPONEHALF;/* floating point 0.5 */


