/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/fontmath.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: fontmath.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.6   07 Apr 1995 11:20:02   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   22 Apr 1994 14:59:56   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   06 Aug 1993 17:24:26   MIKE
 * 
 * Change NEGINFINITY #define to 0x80000001 from 0x80000000.
 * 
 *    Rev 1.3   15 Jan 1993 10:26:12   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.2   31 Dec 1992 14:49:46   MIKE
 * 
 *    Rev 1.1   14 Dec 1992 09:51:02   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:17:44   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
   File:    FontMath.h

 

   Copyright:  1990 by Apple Computer, Inc., all rights reserved.



    Change History (most recent first):

    AGFA changes:

       06-Aug-93  mby   Change NEGINFINITY def to 80000001, from 80000000
       28-Nov-92  rs    Conditionalize on _H_MacHeaders.
       22-Nov-92  rs    Port to Macintosh - conditionally remove FixRatio, FixMul.
       27-Apr-92  mby   Conditionally compile function defs with LINT_ARGS.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		 <4+>	7/11/91		CKL		Added standard header conditionals
		 <4>	11/27/90	MR		make pascal declaration a macro, conditionalize traps -vs-
									externs for Fix/Frac math routines. [ph]
		 <3>	 11/5/90	MR		Move [U]SHORTMUL into FSCdefs.h Rename FixMulDiv to LongMulDiv.
									[rb]
		 <2>	10/20/90	MR		Add some new math routines (stolen from skia). [rj]
		 <1>	 4/11/90	dba		first checked in

	To Do:
*/

#ifndef __FONTMATH__
#define __FONTMATH__

#define HIBITSET			0x80000000L
#define POSINFINITY			0x7FFFFFFFL
#define NEGINFINITY			0x80000001L    /* -7FFFFFFF */
#define HIWORDMASK			0xffff0000L
#define LOWORDMASK			0x0000ffffL
#define FIXONEHALF			0x00008000
#define ONESHORTFRAC		(1 << 14)

#define FIXROUND( x )		(int16)(((x) + FIXONEHALF) >> 16)
#define ROUNDFIXED( x )		(((x) + FIXONEHALF) & HIWORDMASK)
#define DOT6TOFIX(n)		((n) << 10)
#define HIWORD(n)			((uint16)((uint32)(n) >> 16))
#define LOWORD(n)			((uint16)(n))
#define LOWSIXBITS			63

typedef short ShortFrac;			/* 2.14 */

#ifdef NOT_ON_THE_MAC

#ifdef LINT_ARGS
#if !defined (_H_MacHeaders)
    Fixed FIXMATH_ENTRY FixRatio(short numer,short denom);
    Fixed FIXMATH_ENTRY FixMul(Fixed a,Fixed b);
#endif
    Fixed FIXMATH_ENTRY FixDiv(Fixed x,Fixed y);
    Fract FIXMATH_ENTRY FracMul(Fract x,Fract y);
    Fract FIXMATH_ENTRY FracDiv(Fract x,Fract y);
    Fract FIXMATH_ENTRY FracSqrt(Fract x);

#else /* !LINT_ARGS */
    Fixed FIXMATH_ENTRY FixRatio();
    Fixed FIXMATH_ENTRY FixMul();
    Fixed FIXMATH_ENTRY FixDiv();
    Fract FIXMATH_ENTRY FracMul();
    Fract FIXMATH_ENTRY FracDiv();
    Fract FIXMATH_ENTRY FracSqrt();
#endif /* LINT_ARGS */

#else                   /* !NOT_ON_THE_MAC */
#ifndef __TOOLUTILS__
	PASCAL Fixed FixRatio(short numer,short denom) = 0xA869;
	PASCAL Fixed FixMul(Fixed a,Fixed b) = 0xA868;
#endif
#ifndef __FIXMATH__
	PASCAL Fixed FixDiv(Fixed x,Fixed y) = 0xA84D;
	PASCAL Fract FracMul(Fract x,Fract y) = 0xA84A;
	PASCAL Fract FracDiv(Fract x,Fract y) = 0xA84B;
	PASCAL Fract FracSqrt(Fract x) = 0xA849;
#endif
#endif                  /* NOT_ON_THE_MAC */

#ifdef LINT_ARGS
long LongMulDiv(long a, long b, long c);		/* (a*b)/c */
F26Dot6 ShortFracMul(F26Dot6 a, ShortFrac b);
ShortFrac ShortFracDot(ShortFrac a, ShortFrac b);
int32 ShortMulDiv(int32 a, int16 b, int16 c);	/* (a*b)/c */
F26Dot6 Mul26Dot6(F26Dot6 a, F26Dot6 b);
F26Dot6 Div26Dot6(F26Dot6 a, F26Dot6 b);

#else /* !LINT_ARGS */
long LongMulDiv();
F26Dot6 ShortFracMul();
ShortFrac ShortFracDot();
int32 ShortMulDiv();
F26Dot6 Mul26Dot6();
F26Dot6 Div26Dot6();
#endif /* LINT_ARGS */


#endif  /* __FONTMATH__ */

/* -------------------------------------------------------------------
                            END OF "FontMath.h"
   ------------------------------------------------------------------- */

