/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/fontscal.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: fontscal.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.8   07 Apr 1995 11:20:02   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.7   11 Dec 1994 17:13:24   MIKE
 * 
 * Added new args to prototype for fs_FindCharBearings()
 * 
 *    Rev 1.6   22 Apr 1994 15:00:16   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   16 Jul 1993 14:52:38   MAIB
 * added prototypes for new function fs_FindCharBearings
 * 
 *    Rev 1.4   06 May 1993 15:25:14   MIKE
 * Comments for metricsType structure.
 * 
 *    Rev 1.3   08 Feb 1993 13:47:34   MIKE
 * Added function prototypes for interface routines fs_GetFontBBox() and
 * fs_GetCharBBox(). Added bboxInfo to fs_GlyphInfoType structure.
 * Removed outlineCacheSize from fs_GlyphInfoType.
 * Changed fs_GetDesignWidth to int.
 * 
 *    Rev 1.2   15 Jan 1993 10:26:04   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:51:14   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:17:48   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
   File:    FontScaler.h

 
 

   Copyright:  1988-1990 by Apple Computer, Inc., all rights reserved.



    Change History (most recent first):

    AGFA changes:

       11-Dec-94  mby   Added new args to prototype for fs_FindCharBearings()
       16-Jul-93  maib  Added prototype for fs_FindCharBearings()
       15-Jan-93  mby   Added function prototypes for interface routines
                        fs_GetFontBBox() and fs_GetCharBBox().
                        Added bboxInfo  to fs_GlyphInfoType struct.
                        Removed outlineCacheSize from fs_GlyphInfoType.
                        Change fs_GetDesignWidth to int.

       25-Nov-92  mby   changed PASCAL 'int32' to 'int32 PASCAL' in function
                        declarations with !LINT_ARGS.

       26-Oct-92  mby   Add "fs_GlyphInfoType.contourPolarity" to indicate
                        loop polarity reversal (for mirrored components).

       03-Oct-92  rs    Changes toward ANSI C - pascal -> PASCAL.

       20-Jul-92  mby   GlyphInputType changes:  GetSfntGlyphPtr() replaces
                        GetHSfntGlyphPtr() and GetMSfntGlyphPtr().
                        RelSfntGlyphPtr replaces RelHSfntGlyphPtr().

       07-Jul-92  mby   fs_GetDesignWidth() <== fs_GetNonScaledWidth()
                        Change prototype of fs_GetDesignWidth()
                        Delete glyphPtr, glyphLen, charID from InputType structure.

       04-Jun-92  mby   In fs_GlyphInputType: add extern_font; clientID is
                        now a voidPtr; add function pointer GetHSfntGlyphPtr;
                        if TT PCLEO reader enabled, add glyphPtr, glyphLen,
                        charID, and function pointer GetMSfntGlyphPtr.
                        Add func. prototype for fs_GetTablePtr()

       28-Apr-92  mby   Port to SUN.

       09-Apr-92  mby   Don't need fs_SizeOfOutlines(),
                        fs_SaveOutlines(), and fs_RestoreOutlines()

       17-Mar-92  mby   In fs_GlyphInputType structure, memoryBases and
                        transformMatrix declared with MEM_HANDLE.

       20-Feb-92  mby   #ifdef UFST_SUBSYSTEM ==>
                        don't need fs_FindBitmapSize(),
                        fs_ContourScan(),and fs_GetAdvanceWidth()

       31-Jan-92  mby   Added 'emResolution' to fs_GlyphInfoType.

       28-Jan-92  mby   Added 'escapement' to metricsType.

       20-Sep-91  mby   Client interface function declarations must be
                        "int32 pascal ..." instead of "pascal int32 ..."
                        with Microsoft compilers.

TO DO:  In fs_GlyphInfoType change data pointers to handle-offset pairs.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		 <3+>	7/11/91		CKL		Added standard header conditionals
		 <3>	11/27/90	MR		Correctly seperate definitions of Rect and Bitmap
		 <2>	 11/5/90	MR		Clean up includes/definitions to ease porting to non-mac
									environments (ex. don't include QuickDraw.h) [rb]
		<10>	 7/18/90	MR		Conditionalize names in FSInput
		 <9>	 7/14/90	MR		rename SQRT2 to FIXEDSQRT2, removed specificID and lowestRecPPEM
									from FSInfo
		 <8>	 7/13/90	MR		FSInput now has a union to save space, points to matrix instead
									of storing it
		 <6>	 6/21/90	MR		Change fillFunc to ReleaseSfntFrag
		 <5>	  6/5/90	MR		remove readmvt and mapcharcodes
		 <4>	  5/3/90	RB		Added memory area for new scan converter. MIKE REED - Removed
									.error from fsinfo structure. Added MapCharCodes and ReadMVT
									calls.
		 <3>	 3/20/90	CL		New comment style for BBS. 
		 <2>	 2/27/90	CL		New CharToIndexMap Table format.
	   <3.5>	11/15/89	CEL		Placed an ifdef around inline MPW calls to the trap. This makes
									it easier to compile for skia and the likes who do not use the
									MPW compiler.
	   <3.4>	11/14/89	CEL		Left Side Bearing should work right for any transformation. The
									phantom points are in, even for components in a composite glyph.
									They should also work for transformations. Device metric are
									passed out in the output data structure. This should also work
									with transformations. Another leftsidebearing along the advance
									width vector is also passed out. whatever the metrics are for
									the component at it's level. Instructions are legal in
									components. Instructions are legal in components. Five
									unnecessary element in the output data structure have been
									deleted. (All the information is passed out in the bitmap data
									structure) fs_FindBMSize now also returns the bounding box.
	   <3.3>	 9/27/89	CEL		Took out devAdvanceWidth & devLeftSideBearing.
	   <3.2>	 9/25/89	CEL		Took out Mac specific functions.
	   <3.1>	 9/15/89	CEL		Re-working dispatcher
	   <3.0>	 8/28/89	sjk		Cleanup and one transformation bugfix
	   <2.2>	 8/14/89	sjk		1 point contours now OK
	   <2.1>	  8/8/89	sjk		Improved encryption handling
	   <2.0>	  8/2/89	sjk		Just fixed EASE comment
	   <1.5>	  8/1/89	sjk		Added composites and encryption. Plus some enhancements
	   <1.4>	 6/13/89	SJK		Comment
	   <1.3>	  6/2/89	CEL		16.16 scaling of metrics, minimum recommended ppem, point size 0
									bug, correct transformed integralized ppem behavior, pretty much
									so
	   <1.2>	 5/26/89	CEL		EASE messed up on c comments
	  <1.1>	 5/26/89	CEL		Integrated the new Font Scaler 1.0 into Spline Fonts
	   <1.0>	 5/25/89	CEL		Integrated 1.0 Font scaler into Bass code for the first time

	To Do:
*/

#ifndef __FONTSCALER__
#define __FONTSCALER__

#ifndef _MacTypes_
#ifndef __TYPES__
	typedef struct Rect {
		int16 top;
		int16 left;
		int16 bottom;
		int16 right;
	} Rect;
#endif
#endif

#ifndef _Quickdraw_
#ifndef __QUICKDRAW__	
	typedef struct BitMap {
		char* baseAddr;
		int16 rowBytes;
		Rect bounds;
	} BitMap;
#endif
#endif


#define MEMORYFRAGMENTS 8
#define NONVALID 0xffff

/* For the flags field in the flags field */

/* set on 68020, do not set on 68000 */
#define READ_NONALIGNED_SHORT_IS_OK	0x0001			/* set when calling fs_OpenFonts() */
/* set on 68020, do not set on 68000 */
#define READ_NONALIGNED_LONG_IS_OK	0x0002			/* set when calling fs_OpenFonts() */

typedef struct {
    vectorType  advanceWidth;         /* scaled, linear width */
    vectorType  leftSideBearing;      /* leftSideBearingLine + upper left vector */
    vectorType  leftSideBearingLine;     /* see FindBitMapSize */
    vectorType  devLeftSideBearingLine;  /* same as devAdvanceWidth */
    vectorType  devAdvanceWidth;      /* *** NONLINEAR WIDTH ***/
    vectorType  devLeftSideBearing;   /* devAdvanceWidth + upper left vector */
    uint16      escapement;           /* UFST; nonscaled width in D.U. (linear) */
} metricsType;

typedef struct {                /* UFST needs bounding box information */
    int16  xMin;
    int16  yMin;
    int16  xMax;
    int16  yMax;
} BBoxType;

/*
 * Output data structure to the Font Scaler.
 */
typedef struct {
	int32       memorySizes[MEMORYFRAGMENTS];

	uint16      glyphIndex;
	uint16      numberOfBytesTaken; /* from the character code */

	metricsType metricInfo;
    BBoxType    bboxInfo;
	BitMap      bitMapInfo;

	/* Spline Data */
	uint16		outlinesExist;
	uint16		numberOfContours;
	F26Dot6		*xPtr, *yPtr;
	int16		*startPtr;
	int16		*endPtr;
    uint8       *contourPolarity;   /* 1=reversed from base character,
                         0=same direction as base char. -mby 10/26/92 */
	uint8		*onCurve;
    uint16      emResolution;       /* mby 1/31/92 */
	/* End of spline data */

	/* Only of interest to editors */
	F26Dot6		*scaledCVT;

} fs_GlyphInfoType;

/*
 * Input data structure to the Font Scaler.
 *
 * if styleFunc is set to non-zero it will be called just before the transformation
 * will be applied, but after the grid-fitting with a pointer to fs_GlyphInfoType.
 * so this is what styleFunc should be voidFunc StyleFunc( fs_GlyphInfoType *data );
 * For normal operation set this function pointer to zero. */

#ifndef UNNAMED_UNION

typedef struct {
	Fixed				version;
    MEM_HANDLE          memoryBases[MEMORYFRAGMENTS];
	GetSFNTFunc			GetSfntFragmentPtr; /* ( clientID, offset, length ) */
	ReleaseSFNTFunc		ReleaseSfntFrag;
#ifdef LINT_ARGS
    voidPtr (*GetSfntGlyphPtr) (voidPtr, uint16, uint32, uint32*, PMEM_HANDLE);
    void                (*RelSfntGlyphPtr) (MEM_HANDLE);
#else /* !LINT_ARGS */
    voidPtr             (*GetSfntGlyphPtr) ();
    void                (*RelSfntGlyphPtr) ();
#endif /* LINT_ARGS */
    voidPtr             clientID;     /* client private id/stamp (eg. handle for the sfnt ) */
/** int32              *sfntDirectory; **/

	union {
		struct {
			uint16	platformID;
			uint16	specificID;
            uint16  extern_font;  /* "normal" font=0; PCLEO=1 */
                 /* must be set even if PCLEOs aren't enabled */
		} newsfnt;
		struct {
			Fixed			pointSize;
			int16			xResolution;
			int16			yResolution;
			Fixed			pixelDiameter;		/* compute engine char from this */
            MEM_HANDLE      transformMatrix;    /* dereference and cast
                                                   to (transMatrix *)  */
			voidFunc		traceFunc;
		} newtrans;
		struct {
			uint16	characterCode;
			uint16	glyphIndex;
		} newglyph;
		struct {
            voidFunc        traceFunc;
#ifdef LINT_ARGS
            void            (*styleFunc) (fs_GlyphInfoType*);
#else /* !LINT_ARGS */
            void            (*styleFunc) ();
#endif /* LINT_ARGS */

		} gridfit;
		int32*	outlineCache;
		struct {
			int16	bottomClip;
			int16	topClip;
			int32*	outlineCache;
		} scan;
	} param;
} fs_GlyphInputType;

#else

typedef struct {
	Fixed				version;
    MEM_HANDLE          memoryBases[MEMORYFRAGMENTS];
	GetSFNTFunc			GetSfntFragmentPtr; /* ( clientID, offset, length ) */
	ReleaseSFNTFunc		ReleaseSfntFrag;
#ifdef LINT_ARGS
    voidPtr (*GetSfntGlyphPtr) (voidPtr, uint16, uint32, uint32*, PMEM_HANDLE);
    void                (*RelSfntGlyphPtr) (MEM_HANDLE);
#else /* !LINT_ARGS */
    voidPtr             (*GetSfntGlyphPtr) ();
    void                (*RelSfntGlyphPtr) ();
#endif /* LINT_ARGS */
    voidPtr             clientID;     /* client private id/stamp (eg. handle for the sfnt ) */
/** int32              *sfntDirectory; **/

	union {
		struct {
			uint16	platformID;
			uint16	specificID;
            uint16  extern_font;  /* "normal" font=0; PCLEO=1 */
                 /* must be set even if PCLEOs aren't enabled */
		};
		struct {
			Fixed			pointSize;
			int16			xResolution;
			int16			yResolution;
			Fixed			pixelDiameter;		/* compute engine char from this */
            MEM_HANDLE      transformMatrix;    /* dereference and cast
                                                   to (transMatrix *)  */
			voidFunc		tracePreProgramFunc;
		};
		struct {
			uint16	characterCode;
			uint16	glyphIndex;
		};
		struct {
            voidFunc        traceGridFitFunc;
#ifdef LINT_ARGS
            void            (*traceStyleFunc) (fs_GlyphInfoType*);
#else /* !LINT_ARGS */
            void            (*traceStyleFunc) ();
#endif /* LINT_ARGS */

		};
		int32*	outlineCache;
		struct {
			int16	bottomClip;
			int16	topClip;
			int32*	outlineCache;
		};
	};
} fs_GlyphInputType;

#endif		/* unnamed union */

#ifndef FIXEDSQRT2
#define FIXEDSQRT2 0x00016A0AL
#endif

/* Font scaler trap selctors */
#define OUTLINEFONTTRAP		0xA854
#define FS_OPENFONTS 		0x8000
#define FS_INITIALIZE 		0x8001
#define FS_NEWSFNT 			0x8002
#define FS_NEWTRANS 		0x8003
#define FS_NEWGLYPH 		0x8004
#define FS_GETAW 			0x8005
#define FS_GRIDFITT 		0x8006
#define FS_NOGRIDFITT 		0x8007
#define FS_FINDBMSIZE 		0x8008
#define FS_SIZEOFOUTLINES 	0x8009
#define FS_SAVEOUTLINES 	0x800a
#define FS_RESTOREOUTLINES 	0x800b
#define FS_CONTOURSCAN 		0x800c
#define FS_CLOSE 			0x800d
#define FS_READMVT 			0x800e
#define FS_MAPCHAR_CODES 	0x800f

#ifdef LINT_ARGS 

#ifdef MACINIT
extern pascal int32 fs__OpenFonts(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_OPENFONTS,0xA854};
extern pascal int32 fs__Initialize(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_INITIALIZE,0xA854};
extern pascal int32 fs__NewSfnt(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_NEWSFNT,0xA854};
extern pascal int32 fs__NewTransformation(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_NEWTRANS,0xA854};
extern pascal int32 fs__NewGlyph(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_NEWGLYPH,0xA854};
extern pascal int32 fs__GetAdvanceWidth(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_GETAW,0xA854};
extern pascal int32 fs__ContourGridFit(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_GRIDFITT,0xA854};
extern pascal int32 fs__ContourNoGridFit(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_NOGRIDFITT,0xA854};
extern pascal int32 fs__FindBitMapSize(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_FINDBMSIZE,0xA854};

/* these three optional calls are for caching the outlines */
extern pascal int32 fs__SizeOfOutlines(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_SIZEOFOUTLINES,0xA854};
extern pascal int32 fs__SaveOutlines(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_SAVEOUTLINES,0xA854};
extern pascal int32 fs__RestoreOutlines(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_RESTOREOUTLINES,0xA854};

extern pascal int32 fs__ContourScan(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_CONTOURSCAN,0xA854};
extern pascal int32 fs__CloseFonts(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr)
	= {0x303C,FS_CLOSE,0xA854};

#else  /* !MACINIT */

/*** Direct Calls to Font Scaler Client Interface, for Clients not using the trap mechanism ***/
extern int32 PASCAL fs_OpenFonts( fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_Initialize( fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_NewSfnt(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_NewTransformation(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_NewGlyph(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_ContourGridFit(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_FindCharBearings(fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr,
                                        int32 xmin, int32 ymin, int32 xmax, int32 ymax);
extern int32 PASCAL fs_ContourNoGridFit(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int          fs_GetDesignWidth (fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr, int n);
extern int          fs_GetFontBBox (fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr);
extern int          fs_GetCharBBox (fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr);
extern void*        fs_GetTablePtr (fs_GlyphInputType *inputPtr, int table);
extern int32 PASCAL fs_CloseFonts(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );

#ifndef UFST_SUBSYSTEM
extern int32 PASCAL fs_GetAdvanceWidth(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_FindBitMapSize(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_ContourScan(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
#endif  /* UFST_SUBSYSTEM */

#if 0           /* USE_OUTLINE_CACHE code was removed from fontscal.c */
/* these three optional calls are for caching the outlines */
extern int32 PASCAL fs_SizeOfOutlines(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_SaveOutlines(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
extern int32 PASCAL fs_RestoreOutlines(  fs_GlyphInputType *inputPtr, fs_GlyphInfoType *outputPtr );
#endif

#endif /* MACINIT */


#else /* !LINT_ARGS */

#ifdef MACINIT
extern pascal int32 fs__OpenFonts ()         = {0x303C,FS_OPENFONTS,0xA854};
extern pascal int32 fs__Initialize ()        = {0x303C,FS_INITIALIZE,0xA854};
extern pascal int32 fs__NewSfnt ()           = {0x303C,FS_NEWSFNT,0xA854};
extern pascal int32 fs__NewTransformation () = {0x303C,FS_NEWTRANS,0xA854};
extern pascal int32 fs__NewGlyph ()          = {0x303C,FS_NEWGLYPH,0xA854};
extern pascal int32 fs__GetAdvanceWidth ()   = {0x303C,FS_GETAW,0xA854};
extern pascal int32 fs__ContourGridFit ()    = {0x303C,FS_GRIDFITT,0xA854};
extern pascal int32 fs__ContourNoGridFit ()  = {0x303C,FS_NOGRIDFITT,0xA854};
extern pascal int32 fs__FindBitMapSize ()    = {0x303C,FS_FINDBMSIZE,0xA854};

/* these three optional calls are for caching the outlines */
extern pascal int32 fs__SizeOfOutlines ()    = {0x303C,FS_SIZEOFOUTLINES,0xA854};
extern pascal int32 fs__SaveOutlines ()      = {0x303C,FS_SAVEOUTLINES,0xA854};
extern pascal int32 fs__RestoreOutlines ()   = {0x303C,FS_RESTOREOUTLINES,0xA854};

extern pascal int32 fs__ContourScan ()       = {0x303C,FS_CONTOURSCAN,0xA854};
extern pascal int32 fs__CloseFonts ()        = {0x303C,FS_CLOSE,0xA854};

#else  /* !MACINIT */

/*** Direct Calls to Font Scaler Client Interface, for Clients not using the trap mechanism ***/

extern int32 PASCAL fs_OpenFonts ();
extern int32 PASCAL fs_Initialize ();
extern int32 PASCAL fs_NewSfnt ();
extern int32 PASCAL fs_NewTransformation ();
extern int32 PASCAL fs_NewGlyph ();
extern int32 PASCAL fs_ContourGridFit ();
extern int32 PASCAL fs_FindCharBearings();
extern int32 PASCAL fs_ContourNoGridFit ();
extern int          fs_GetDesignWidth ();
extern int          fs_GetFontBBox ();
extern int          fs_GetCharBBox ();
extern void*        fs_GetTablePtr ();
extern int32 PASCAL fs_CloseFonts (); 

#ifndef UFST_SUBSYSTEM
extern int32 PASCAL fs_GetAdvanceWidth ();
extern int32 PASCAL fs_FindBitMapSize ();
extern int32 PASCAL fs_ContourScan ();
#endif  /* UFST_SUBSYSTEM */ 

#if 0           /* USE_OUTLINE_CACHE code was removed from fontscal.c */
/* these three optional calls are for caching the outlines */
extern int32 PASCAL fs_SizeOfOutlines ();
extern int32 PASCAL fs_SaveOutlines ();
extern int32 PASCAL fs_RestoreOutlines ();
#endif

#endif /* MACINIT */

#endif /* LINT_ARGS */


#endif  /* __FONTSCALER__ */

/* -------------------------------------------------------------------
                            END OF "FontScaler.h"
   ------------------------------------------------------------------- */

