/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/fscdefs.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: fscdefs.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.11   07 Apr 1995 11:20:04   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.10   13 Jan 1995 18:08:36   ROB
 * Add support for > 64KB memory blocks in DOS. Remove code which is contained
 * in ifmem.h.
 * 
 *    Rev 1.9   22 Apr 1994 15:00:14   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.8   10 Jun 1993 09:05:26   JOE
 * Changed all references to "char" to "SB8" for portability.
 * 
 *    Rev 1.7   24 May 1993 13:24:28   JOE
 * In Motorola byte order section, changed casts in SHORTMUL/DIV macros
 * to int32; changed LoopCount to int. For HILO byte oorder, change defs of
 * USHORTMUL, SHORTMUL & SHORTDIV; cast arguments to 32 bits. Change LoopCount
 * typedef from int16 to int.
 * 
 *    Rev 1.6   12 Feb 1993 16:02:48   JOE
 * VXWorks support.
 * 
 *    Rev 1.5   15 Jan 1993 10:26:28   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.4   05 Jan 1993 08:44:40   JOE
 * For 960, do not define ANSI_DEFS.
 * 
 *    Rev 1.3   15 Dec 1992 15:30:52   JOE
 * Added back TT typedefs, but disabled them.
 * 
 *    Rev 1.2   15 Dec 1992 13:16:50   JOE
 * Moved some typedefsto PORT.H
 * 
 *    Rev 1.1   14 Dec 1992 09:49:52   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:18:00   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
   File:    FSCdefs.h

 


   Copyright:  1988-1990 by Apple Computer, Inc., all rights reserved.



    Change History (most recent first):

    AGFA changes:

       10-Jun-93  jfd   Changed all references to "char" to "SB8" for portability.

       18-May-93  mby   In Motorola byte order section, changed casts in
                        SHORTMUL/DIV macros to int32; changed LoopCount to int.

       17-May-93  mby   For HILO byte order, change defs of USHORTMUL,
                        SHORTMUL & SHORTDIV; cast arguments to 32 bits.
                        Change LoopCount typedef from int16 to int.

       08-Feb-93  jfd   VXWorks support.

       21-Dec-92  jfd   If INTEL960, do not define ANSI_DEFS.
       15-Dec-92  jfd   Disabled data typedefs for short, int, long, int8,
                        uint8. (Now defined in PORT.H)
       03-Dec-92  rs    Conditionally compile typedefs for int16, uint16,
                        int32 and uint32 based on INTLENGTH (as is done
                        in port.h) to resolve BORLAND compiler errros.
                        Always define ANSI_DEFS.
       25-Nov-92  mby   Use BYTEORDER == LOHI instead of #ifdef INTEL.
                        Remove #defines for INTEL.
       22-Nov-92  rs    Port to Macintosh - don't typedef Fixed, Fract, Boolean.
       16-Nov-92  mby   Undid change to SWAPW from 10/20. SWAPW has to be cast
                        unsigned short (imagine the result is 0x8001 and it
                        needs to be cast to 32 bits).
       21-Oct-92  mby   Removed GET_x...() macros. See "cgmacros.h"
       20-Oct-92  mby   Fixed bug in SWAPL; cleaned up SWAPW. SWAPX() should
                        always be cast!!
       16-Oct-92  jfd   No longer undefining INTEL if INTEL960.
       05-Oct-92  jfd   Removed define for PASCAL (it is now done in PORT.H)
       28-Sep-92  jfd   Changed conditional compile statement to read 
                        "#if defined(SUN)  || defined(MIPS) || defined(__i960)"
       20-Jul-92  mby   Added typedef for PMEM_HANDLE.
                        Ripped out code that duplicates port.h. port.h is
                        always included before fscdefs.h
       08-Jul-92  rs    Change 'GET_$...' to 'GET_x...', could not compile
                        with BCC.
       07-Jul-92  mby   Added GET_$WORD, GET_$LONG, GET_$BYTE_OFF,
                        GET_$WORD_OFF, & GET_$LONG_OFF macros. These are
                        CPU-independent and require no address alignment.
                        Will eventually replace SWAPW, SWAPL, etc. in the
                        TrueType core.
       01-Jul-92  ss    Changed SUN defines to UNIX to be more general -
                        except for the system specific test for INTEL.
       19-Jun-92  mby   In SWAPL macro make constants long
       27-Apr-92  mby   #define FIXMATH_ENTRY for fontmath.c routines.
                        remove NOT_ON_MOTOROLA
       10-Apr-92  mby   ReleaseSFNTFunc and GetSFNTFunc data types use
                          MEM_HANDLE.
                        Move transMatrix and vectorType typedefs from
                          fontscal.h
                        #define UFST_SUBSYSTEM
       13-Mar-92  ss    Conditionally compile function prototypes for LINT_ARGS.

       02-Oct-91  mby   Add #defines for Intel CPU and ~MAC.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		 <3+>	7/11/91		CKL		Added standard header conditionals
		 <3>	11/27/90	MR		Add #define for PASCAL. [ph]
		 <2>	 11/5/90	MR		Move USHORTMUL from FontMath.h, add Debug definition [rb]
		 <7>	 7/18/90	MR		Add byte swapping macros for INTEL, moved rounding macros from
									fnt.h to here
		 <6>	 7/14/90	MR		changed defines to typedefs for int[8,16,32] and others
		 <5>	 7/13/90	MR		Declared ReleaseSFNTFunc and GetSFNTFunc
		 <4>	  5/3/90	RB		cant remember any changes
		 <3>	 3/20/90	CL		type changes for Microsoft
		 <2>	 2/27/90	CL		getting bbs headers
	   <3.0>	 8/28/89	sjk		Cleanup and one transformation bugfix
	   <2.2>	 8/14/89	sjk		1 point contours now OK
	   <2.1>	  8/8/89	sjk		Improved encryption handling
	   <2.0>	  8/2/89	sjk		Just fixed EASE comment
	   <1.5>	  8/1/89	sjk		Added composites and encryption. Plus some enhancements
	   <1.4>	 6/13/89	SJK		Comment
	   <1.3>	  6/2/89	CEL		16.16 scaling of metrics, minimum recommended ppem, point size 0
									bug, correct transformed integralized ppem behavior, pretty much
									so
	   <1.2>	 5/26/89	CEL		EASE messed up on c comments
	  <1.1>	 5/26/89	CEL		Integrated the new Font Scaler 1.0 into Spline Fonts
	   <1.0>	 5/25/89	CEL		Integrated 1.0 Font scaler into Bass code for the first time

	To Do:
*/

#if !defined(__i960) && ! defined(VXWORKS)
#if defined(LINT_ARGS)
#if !defined (ANSI_DEFS)
#define ANSI_DEFS 1
#endif
#endif
#endif

#ifndef __FSCDEFS__
#define __FSCDEFS__

/* #define DEBUG			*/

#define FIXMATH_ENTRY   /* pascal */        /* 4-27-92, mby */

/************************************************************************/
/************************************************************************/
/* Customize for DOS; Intel processor          */
/*     and UFST                                */

#define NOT_ON_THE_MAC
#define RELEASE_MEM_FRAG
#define NO_CHECK_TRASHED_MEMORY
#define COMPILER_CASE_INT_ONLY
#define UFST_SUBSYSTEM

/* cgconfig.h & port.h MUST be #included in the source */
/* file because we're using INT_MEM_MGT and LINT_ARGS. */

/*                                             */
/***********************************************/
#if defined(SUN)  || defined(MIPS)
#define   pascal
#endif /* SUN || MIPS */

#if defined(__i960) || defined (VXWORKS)
#define pascal 
#endif /* __i960 */

/************************************************************************/

#define true 1
#define false 0

#define ONEFIX 		( 1L << 16 )
#define ONEFRAC 	( 1L << 30 )
#define ONEHALFFIX	0x8000L
#define ONEVECSHIFT	16
#define HALFVECDIV	(1L << (ONEVECSHIFT-1))

/*
#define USETTTYPEDEFS
*/
#ifdef USETTTYPEDEFS

typedef char int8;
typedef unsigned char uint8;

#if INTLENGTH == 16
typedef int int16;
typedef unsigned int uint16;
typedef long int32;
typedef unsigned long uint32;
#endif /* INTLENGTH == 16 */

#if INTLENGTH == 32
typedef short int16;
typedef unsigned short uint16;
typedef int int32;
typedef unsigned int uint32;
#endif /* INTLENGTH == 32 */

#endif /* USETTTYPEDEFS */

typedef short FWord;
typedef unsigned short uFWord;

typedef long F26Dot6;

#if !defined (MACINTOSH)
typedef long Fixed;
typedef long Fract;
#endif

typedef int  boolean;

typedef struct {
    Fixed        transform[3][3];
} transMatrix;

typedef struct {
    Fixed        x, y;
} vectorType;

typedef void    (*voidFunc) ();
typedef void FARPTR * voidPtr;

#ifdef LINT_ARGS
typedef void (*ReleaseSFNTFunc) (void);
typedef voidPtr (*GetSFNTFunc) (voidPtr, long, long);

#else  /* !LINT_ARGS */

typedef void (*ReleaseSFNTFunc) ();
typedef voidPtr (*GetSFNTFunc) ();
#endif /* LINT_ARGS */

#if (BYTEORDER == LOHI)

#define SWAPW(a)        (unsigned short)(((unsigned char)((a) >> 8)) | ((unsigned char)(a) << 8))
#define SWAPWINC(a)     SWAPW(*(a)); a++
#define SWAPL(a)        ((((a)&0xffL) << 24) | (((a)&0xff00L) << 8) | \
                         (((a)&0xff0000L) >> 8) | ((unsigned long)(a) >> 24))

typedef int	LoopCount;
typedef int	ArrayIndex;

#define USHORTMUL(a, b)	((uint32)((uint32)(a)*(uint32)(b)))
#define SHORTMUL(a,b)	(int32)((int32)(a) * (int32)(b))
#define SHORTDIV(a,b)	(int32)((int32)(a) / (int32)(b))

#else                   /* byte order matches Motorola 680x0 */

#define SWAPW(a)		(a)
#define SWAPWINC(a)		(*(a)++)
#define SWAPL(a)		(a)

typedef int     LoopCount;      /* changed to int, 5-17-93,mby */
typedef int32	ArrayIndex;		/* avoids EXT.L */

                                /* cast a,b to 32 bit, 5-17-93,mby */
#define USHORTMUL(a, b) ((uint32)((uint32)(a) * (uint32)(b)))
#define SHORTMUL(a,b)   (int32)((int32)(a) * (int32)(b))
#define SHORTDIV(a,b)   (int32)((int32)(a) / (int32)(b))

#endif	/* Motorla byte order */

/* d is half of the denumerator */
#define FROUND( x, n, d, s ) \
	    x = SHORTMUL(x, n); x += d; x >>= s;

/* <3> */
#define SROUND( x, n, d, halfd ) \
    if ( x < 0 ) { \
	    x = -x; x = SHORTMUL(x, n); x += halfd; x /= d; x = -x; \
	} else { \
	    x = SHORTMUL(x, n); x += halfd; x /= d; \
	}

#ifdef DEBUG
#ifndef NOT_ON_THE_MAC
#ifndef __TYPES__
	pascal void Debugger(void) = 0xA9FF; 
	pascal void DebugStr(SB8* aStr) = 0xABFF; 
#endif
#endif
#endif


#if 0   /* remove; include in cgmacros.h  - mby 10/21/92 */

/* Processor-independent macros to read 1, 2, or 4 bytes from memory in
 * high, ..., low order. Alignment on 2- or 4-byte boundaries is not required.
 */
#define GET_xWORD(a) (unsigned short)((unsigned char)(*a) << 8) | (unsigned char)(*(a+1))

#define GET_xLONG(a) ((unsigned long)*((unsigned char*)a) << 24) |      \
                     ((unsigned long)*((unsigned char*)a + 1) << 16) |  \
                     ((unsigned long)*((unsigned char*)a + 2) << 8) |   \
                      (unsigned long)*((unsigned char*)a + 3)

#define GET_xBYTE_OFF(a,OFFSET)  ((unsigned char)(*(a+OFFSET)))

#define GET_xWORD_OFF(a,OFFSET)  \
                     ((unsigned short)((unsigned char)(*(a+OFFSET)) << 8) | \
                      (unsigned char)(*(a+OFFSET+1)))

#define GET_xLONG_OFF(a,OFFSET)  \
                     (((unsigned long)*((unsigned char*)a+OFFSET) << 24) |   \
                      ((unsigned long)*((unsigned char*)a+OFFSET+1) << 16) | \
                      ((unsigned long)*((unsigned char*)a+OFFSET+2) << 8) |  \
                       (unsigned long)*((unsigned char*)a+OFFSET+3))
#endif  /* 0 */


#endif /*  __FSCDEFS__  */

/* -------------------------------------------------------------------
                            END OF "FSCdefs.h"
   ------------------------------------------------------------------- */

