/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/privsfnt.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: privsfnt.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   07 Apr 1995 11:19:56   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 15:00:12   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   08 Feb 1993 13:40:30   MIKE
 * Added sfnt_GetGlyphLocation(). Changed last two args from int32* to uint32*
 * 
 *    Rev 1.2   15 Jan 1993 10:25:58   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:49:22   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:17:58   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
   File:    private sfnt.h

 

   Copyright:  1990 by Apple Computer, Inc., all rights reserved.



    Change History (most recent first):

    AGFA changes:

       18-Jan-93  mby   Added sfnt_GetGlyphLocation(). Changed last two parameters
                        from int32* to uint32*

       28-Apr-92  mby   Conditionally compile function protos for LINT_ARGS.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		 <4+>	 7/11/91	CKL		Added standard header conditionals
		 <4>	 7/18/90	MR		Change return types to int for computemapping and readsfnt
		 <3>	 7/14/90	MR		changed SQRT to conditional FIXEDSQRT2
		 <2>	 7/13/90	MR		Change parameters to ReadSFNT and ComputeMapping
		<1+>	 4/18/90	CL		
		 <1>	 3/21/90	EMT		First checked in with Mike Reed's blessing.
*/

#ifndef __PRIVATESFNT__
#define __PRIVATESFNT__

/* PUBLIC PROTOTYPE CALLS */

/*
 * Below we have private stuff
 * This has nothing to do with the file format.
 */

#ifdef LINT_ARGS
extern void* sfnt_GetTablePtr (register fsg_SplineKey *key, register sfnt_tableIndex n, register boolean mustHaveTable);

#else /* !LINT_ARGS */
extern void* sfnt_GetTablePtr ();
#endif /* LINT_ARGS */


/*
 * Creates mapping for finding offset table
 */
#ifdef LINT_ARGS
extern void sfnt_DoOffsetTableMap(fsg_SplineKey *key);
#else /* !LINT_ARGS */
extern void sfnt_DoOffsetTableMap();
#endif /* LINT_ARGS */

/* perfect spot size (Fixed) */
#ifndef FIXEDSQRT2
#define FIXEDSQRT2 0x00016A0A
#endif

#ifdef LINT_ARGS
/*
 * Returns offset and length for table n
 */
extern void sfnt_GetOffsetAndLength(fsg_SplineKey *key, int32 *offsetT, unsigned *lengthT, sfnt_tableIndex n);
extern int sfnt_ComputeMapping(fsg_SplineKey *key, uint16 platformID, uint16 specificID);
extern void sfnt_ReadSFNTMetrics(fsg_SplineKey *key, uint16 glyphIndex);
extern int sfnt_ReadSFNT(fsg_SplineKey *key, int16 *elementCount, uint16 gIndex, boolean useHints, voidFunc traceFunc);
extern void sfnt_GetGlyphLocation( fsg_SplineKey* key, uint16 gIndex, uint32* offset, uint32* length );

#else /* !LINT_ARGS */

extern void sfnt_GetOffsetAndLength();
extern int sfnt_ComputeMapping();
extern void sfnt_ReadSFNTMetrics();
extern int sfnt_ReadSFNT();
extern void sfnt_GetGlyphLocation();
#endif /* LINT_ARGS */


#endif  /* __PRIVATESFNT__ */

/* -------------------------------------------------------------------
                            END OF "privateSFNT.h"
   ------------------------------------------------------------------- */

