/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/sfntenum.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: sfntenum.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.4   07 Apr 1995 11:20:08   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 15:00:20   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   15 Jan 1993 10:26:00   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:52:18   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:17:38   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
   File:    sfnt_enum.h

   Written by: Mike Reed

 

   Copyright:  1988-1990 by Apple Computer, Inc., all rights reserved.



    Change History (most recent first):

    AGFA changes:

       25-Nov-92  mby   Use BYTEORDER == LOHI instead of #ifdef INTEL.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		 <3+>	7/11/91		CKL		Added standard header conditionals
		 <3>	12/20/90	MR		Correct INTEL definition of tag_FontProgram. [rb]
		 <2>	12/11/90	MR		Add trademark selector to naming table list. [rb]
		<10>	  8/8/90	JT		Fixed spelling of SFNT_ENUMS semaphore at the top of the file.
									This prevents the various constants from being included twice.
		 <9>	 7/18/90	MR		Fixed INTEL version of tag_GlyphData
		 <8>	 7/16/90	MR		Conditionalize redefinition of script codes
		 <7>	 7/13/90	MR		Conditionalize enums to allow for byte-reversal on INTEL chips
		 <6>	 6/30/90	MR		Remove tag reference to mvt  and cryp
		 <4>	 6/26/90	MR		Add all script codes, with SM naming conventions
		 <3>	 6/20/90	MR		Change tag enums to #defines to be ansi-correct
		 <2>	  6/1/90	MR		Add postscript name to sfnt_NameIndex and post to tags.
	To Do:
*/

#ifndef __SFNT_ENUM__
#define __SFNT_ENUM__

typedef enum {
	plat_Unicode,
	plat_Macintosh,
	plat_ISO,
	plat_MS
} sfnt_PlatformEnum;

#ifndef smRoman
typedef enum {
	smRoman,
	smJapanese,
	smTradChinese,
	smChinese = smTradChinese,
	smKorean,
	smArabic,
	smHebrew,
	smGreek,
	smCyrillic,
	smRussian = smCyrillic,
	smRSymbol,
	smDevanagari,
	smGurmukhi,
	smGujarati,
	smOriya,
	smBengali,
	smTamil,
	smTelugu,
	smKannada,
	smMalayalam,
	smSinhalese,
	smBurmese,
	smKhmer,
	smThai,
	smLaotian,
	smGeorgian,
	smArmenian,
	smSimpChinese,
	smTibetan,
	smMongolian,
	smGeez,
	smEthiopic = smGeez,
	smAmharic = smGeez,
	smSlavic,
	smEastEurRoman = smSlavic,
	smVietnamese,
	smExtArabic,
	smSindhi = smExtArabic,
	smUninterp
} sfnt_ScriptEnum;
#endif

typedef enum {
	lang_English,
	lang_French,
	lang_German,
	lang_Italian,
	lang_Dutch,
	lang_Swedish,
	lang_Spanish,
	lang_Danish,
	lang_Portuguese,
	lang_Norwegian,
	lang_Hebrew,
	lang_Japanese,
	lang_Arabic,
	lang_Finnish,
	lang_Greek,
	lang_Icelandic,
	lang_Maltese,
	lang_Turkish,
	lang_Yugoslavian,
	lang_Chinese,
	lang_Urdu,
	lang_Hindi,
	lang_Thai
} sfnt_LanguageEnum;

typedef enum {
	name_Copyright,
	name_Family,
	name_Subfamily,
	name_UniqueName,
	name_FullName,
	name_Version,
	name_Postscript,
	name_Trademark
} sfnt_NameIndex;

typedef long sfnt_TableTag;

#if (BYTEORDER == HILO)      /* Motorola byte order */

#define tag_FontHeader          0x68656164L        /* 'head' */
#define tag_HoriHeader          0x68686561L        /* 'hhea' */
#define tag_IndexToLoc          0x6c6f6361L        /* 'loca' */
#define tag_MaxProfile          0x6d617870L        /* 'maxp' */
#define tag_ControlValue        0x63767420L        /* 'cvt ' */
#define tag_PreProgram          0x70726570L        /* 'prep' */
#define tag_GlyphData           0x676c7966L        /* 'glyf' */
#define tag_HorizontalMetrics   0x686d7478L        /* 'hmtx' */
#define tag_CharToIndexMap      0x636d6170L        /* 'cmap' */
#define tag_Kerning             0x6b65726eL        /* 'kern' */
#define tag_HoriDeviceMetrics   0x68646d78L        /* 'hdmx' */
#define tag_NamingTable         0x6e616d65L        /* 'name' */
#define tag_FontProgram         0x6670676dL        /* 'fpgm' */
#define tag_Postscript          0x706f7374L        /* 'post' */
#define tag_OS_2                0x4f532f32L        /* 'OS/2' */
#define tag_PCLT                0x50434c54L        /* 'PCLT' */

#else               /* Intel byte order */

#define tag_FontHeader          0x64616568L        /* 'head' */
#define tag_HoriHeader          0x61656868L        /* 'hhea' */
#define tag_IndexToLoc          0x61636f6cL        /* 'loca' */
#define tag_MaxProfile          0x7078616dL        /* 'maxp' */
#define tag_ControlValue        0x20747663L        /* 'cvt ' */
#define tag_PreProgram          0x70657270L        /* 'prep' */
#define tag_GlyphData           0x66796c67L        /* 'glyf' */
#define tag_HorizontalMetrics   0x78746d68L        /* 'hmtx' */
#define tag_CharToIndexMap      0x70616d63L        /* 'cmap' */
#define tag_Kerning             0x6e72656bL        /* 'kern' */
#define tag_HoriDeviceMetrics   0x786d6468L        /* 'hdmx' */
#define tag_NamingTable         0x656d616eL        /* 'name' */
#define tag_FontProgram         0x6d677066L        /* 'fpgm' */
#define tag_Postscript          0x74736f70L        /* 'post' */
#define tag_OS_2                0x322f534fL        /* 'OS/2' */
#define tag_PCLT                0x544c4350L        /* 'PCLT' */

#endif  /* BYTEORDER */

#endif  /*  __SFNT_ENUM__  */

/* -------------------------------------------------------------------
                            END OF "sfnt_enum.h"
   ------------------------------------------------------------------- */


