/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/rts/tt/ttpcleo.h,v 1.2 2003/05/07 23:02:30 Lann Exp $ */
/* $Log: ttpcleo.h,v $
/* Revision 1.2  2003/05/07 23:02:30  Lann
/* Revision V1_00_02
/*
/* Revision 1.1.1.1  2003/05/07 21:50:39  Lann
/* First Release Version
/* 
 * 
 *    Rev 1.5   07 Apr 1995 11:19:56   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 15:00:18   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   15 Jun 1993 17:38:40   MIKE
 * Added #ifndef NOT_UFST so we can use this module in standalone programs.
 * 
 *    Rev 1.2   15 Jan 1993 10:25:50   LISA
 * Removed CtrlZ character from end of file
 * 
 *    Rev 1.1   14 Dec 1992 09:53:46   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   10 Dec 1992 09:18:04   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:02:30 $ */
/*
 *                      T T P C L E O . H
 *
 *
 *
 *  Revision history:
 *
 *  13-Jul-92  mby  Moved PTO_ #defines from 64 and above to <pcleo.h>
 *  07-Jul-92  mby  Added constants for PCLETTO font header access.
 *  29-May-92  mby  Created.
 */

#define    CHARHEADERSIZE      4
#define    CONTHEADERSIZE      2
#define    CHARDESCRIPTORSIZE  2
#define    PCLETTOFONTHDRSIZE    72


/* Offsets into font descriptor format 15 font header data when not
 * referencing via structure.
 * Note: from 0 to 63, these constants are the SAME as for both the
 *       Bitmap font descriptor (format 0) or Intellifont Scalable
 *       font descriptor (format 10).
 */
#define    PTO_FONTDECSCRIPTORSIZE  0
#define    PTO_DESCRIPTORFORMAT     2
#define    PTO_FONTTYPE             3
#define    PTO_STYLE_MSB            4
#define    PTO_BASELINEPOSITION     6
#define    PTO_CELLWIDTH            8
#define    PTO_CELLHEIGHT          10
#define    PTO_ORIENTATION         12
#define    PTO_SPACING             13
#define    PTO_CHARACTERSET        14
#define    PTO_PITCH               16
#define    PTO_HEIGHT              18
#define    PTO_XHEIGHT             20
#define    PTO_WIDTHTYPE           22
#define    PTO_STYLE_LSB           23
#define    PTO_STROKEWEIGHT        24
#define    PTO_TYPEFACE_LSB        25
#define    PTO_TYPEFACE_MSB        26
#define    PTO_SERIFSTYLE          27
#define    PTO_QUALITY             28
#define    PTO_PLACEMENT           29
#define    PTO_UNDERLINEPOSITION   30
#define    PTO_UNDERLINEHEIGHT     31
#define    PTO_TEXTHEIGHT          32
#define    PTO_TEXTWIDTH           34
#define    PTO_FIRSTCODE           36
#define    PTO_LASTCODE            38
#define    PTO_PITCH_EXT           40
#define    PTO_HEIGHT_EXT          41
#define    PTO_CAPHEIGHT           42
#define    PTO_FONTNUMBER          44
#define    PTO_FONTNAME            48

#if 0       /* see pcleo.h */
#define    PTO_SCALEFACTOR         64
#define    PTO_MASTERULINEPOSITION 66
#define    PTO_MASTERULINEHEIGHT   68
#define    PTO_FST                 70
#define    PTO_VARIETY             71
#endif


typedef struct
{
    UW16   fontDescriptorSize;      /*  0- PCLETTOFONTHDRSIZE from above */
    UB8    descriptorFormat;        /*  2- 15 */
    UB8    fontType;                /*  3- 11=Unicode; 0,1,2 also possible */
    UB8    style_msb;               /*  4- from PCLT table in TrueType font */
    UB8    reserved1;
    UW16   baselinePosition;        /*  6- from head table in TT font; = 0 */
    UW16   cellWidth;               /*  8- head, use xMax - xMin */
    UW16   cellHeight;              /* 10- head, use yMax - yMin */
    UB8    orientation;             /* 12- 0 */
    UB8    spacing;                 /* 13- 1=proportional, 0-fixed pitch */
    UW16   characterSet;            /* 14- same as symSetCode; =56 if unbound. */
    UW16   pitch;                   /* 16- PCLT */
    UW16   height;                  /* 18- 0 if TrueType */
    UW16   xHeight;                 /* 20- PCLT */
    SB8    widthType;               /* 22- PCLT */
    UB8    style_lsb;               /* 23- PCLT */
    SB8    strokeWeight;            /* 24- PCLT */
    UB8    typeface_lsb;            /* 25- PCLT */
    UB8    typeface_msb;            /* 26- PCLT */
    UB8    serifStyle;              /* 27- PCLT */
    UB8    quality;                 /* 28- 2 if TrueType */
    UB8    placement;               /* 29- 0 if TrueType */
    SB8    underlinePosition;       /* 30- 0 */
    UB8    underlineHeight;         /* 31- 0 */
    UW16   textHeight;              /* 32- from OS/2 table in TT font */
    UW16   textWidth;               /* 34- OS/2 */
    UW16   firstCode;               /* 36- set to 0 if unbound */
    UW16   lastCode;                /* 38- max number of downloadable chars if unbound */
    UB8    pitch_ext;               /* 40- 0 if TrueType */
    UB8    height_ext;              /* 41- 0 if TrueType */
    UW16   capHeight;               /* 42- PCLT */
    UL32   fontNumber;              /* 44- PCLT */
    UB8    fontName[16];            /* 48- PCLT */
    UW16   scaleFactor;             /* 64- head:unitsPerEm */
    SW16   masterUnderlinePosition; /* 66- post table, or -20% of em */
    UW16   masterUnderlineHeight;   /* 68- post table, or 5% of em */
    UB8    fontScalingTechnology;   /* 70- 1=TrueType; 0=Intellifont */
    UB8    variety;                 /* 71- 0 if TrueType */
} PCLETTO_FHDR;

typedef PCLETTO_FHDR FARPTR * PPCLETTO_FHDR;



typedef struct {
   UB8 format;
   UB8 continuation;
   UB8 descriptorsize;
   UB8 class;
} PCLETTO_CHR_HDR;
typedef PCLETTO_CHR_HDR FARPTR * PPCLETTO_CHR_HDR;


#ifndef NOT_UFST

#ifdef LINT_ARGS
GLOBAL int  ttload_PCLEO (LPUB8, PBUCKET);
GLOBAL void get_TTFHDR (PHPFH, LPUB8);

#else /* !LINT_ARGS */
GLOBAL int  ttload_PCLEO ();
GLOBAL void get_TTFHDR ();
#endif /* LINT_ARGS */

#endif  /* !NOT_UFST */

