/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/adj_skel.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: adj_skel.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.4   07 Apr 1995 11:30:46   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 15:31:06   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   14 Jan 1993 11:04:52   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:48:04   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:37:54   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*
*  adjust_skel.h
*
*
*
* 
*  History:
*  ---------
*    1-Nov-87    Initial Release
*   23-Jan-88    incorporated intermed in adjust_skel_type struct (tbh)
*    4-Feb-88    changed num_seg_p_loop from UWORD to WORD (tbh)
*   31-Jan-91    Changed history order, added support for MSC multi-model
*                compilation.  change "adjusted_skel_type" to uppercase
*                "ADJUSTED_SKEL" to be consistent with the rest of the code.
*    8-Jul-91    Added elasticity
*    2-Apr-92 jfd  In structure ADJUSTED_SKEL, made the following changes:
*                  1.) Added field "baseproj".
*                  2.) Removed fields "pixel_grid_line", "processing_status"
*                      and "parent".
*                  3.) Conditionally compiled fields "remainder" and 
*                      "num_breaks" based on ELASTIC*.
*                These changes are in conjunction with changes made to IF 3.0
*   02-Apr-92    Portability cleanup (BYTE, WORD, LONG, etc) (see port.h).
*   14-Nov-92 rs Port to Mac - rename italic() to cgitalic(), bold() to cgbold().
* 
*/

/*      IC1.0           Adjusted Skeletal Data                        */

typedef struct
        {
        SW16    original;       /*  original value of skel point      */
        SW16    intermed;   /*  intermediate "original" value     */
        SW16    adjusted;       /*  current abs skel point coord valu */

        SW16    baseproj;       /*  for yskel: same as original       */
                                /*  for xskel: baseline projection    */

#if ((ELASTIC_Y) | (ELASTIC_X))
        /*      Elasicity Data */
        SW16    remainder;      /*  round error carried fwrd for elast*/
        UB8   num_breaks;     /*  num of elasticity breaks in assoc */
#endif

        UB8   round_i;        /*  "R" type index for association    */

        }  ADJUSTED_SKEL;

typedef ADJUSTED_SKEL FARPTR * PADJUSTED_SKEL;

#ifdef LINT_ARGS
#else
#endif

#ifdef LINT_ARGS
EXTERN VOID    yclass(PADJUSTED_SKEL);
EXTERN BOOLEAN skel_proc(PSKEL, PDIMENSION, PCOORD_DATA,
                                            PADJUSTED_SKEL, SW16);
EXTERN VOID    cgitalic(PADJUSTED_SKEL, PADJUSTED_SKEL);
EXTERN VOID    cgbold(PADJUSTED_SKEL, PADJUSTED_SKEL);
EXTERN UW16   manipulate(PADJUSTED_SKEL, PADJUSTED_SKEL);
EXTERN VOID    init_xy_tran(PADJUSTED_SKEL, PADJUSTED_SKEL);
#else
EXTERN VOID    yclass();
EXTERN BOOLEAN skel_proc ();
EXTERN VOID    cgitalic();
EXTERN VOID    cgbold();
EXTERN UW16   manipulate();
EXTERN VOID    init_xy_tran();
#endif

