/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/bitmap.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: bitmap.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.11   07 Apr 1995 11:31:22   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.10   14 Feb 1995 20:40:26   MIKE
 * 
 * Changed COUNTER to NZCOUNTER in NZ_NODE & RASTER structs.
 * 
 *    Rev 1.9   22 Apr 1994 15:31:32   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.8   15 Apr 1994 16:10:36   JOE
 * Added new function prototype for char_left_ref().
 * Changed prototype for find_part2whole().
 * 
 *    Rev 1.7   16 Dec 1993 10:41:56   JOE
 * 
 * In RASTER structure, added field "tran_run_ct".
 * 
 *    Rev 1.6   29 Jul 1993 12:07:40   AL
 * More nzw changes
 * 
 *    Rev 1.4   13 Apr 1993 09:15:08   JOE
 * Moved "bit[]" table to RASTER.C .
 * 
 *    Rev 1.3   07 Apr 1993 10:55:28   JOE
 * Added raster line organization support.
 * 
 *    Rev 1.2   14 Jan 1993 11:14:10   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:46:26   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:37:48   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* bitmap.h */


/* History

  01-Sep-91 awr Created.
  18-Oct-91 jfd Declare "SCAN_CONVERT" conditionally based on TILE.
   7-Mar-92 awr Changed metrics() parameters
  19-Mar-92 awr Changed bitmap_dimensions() to take LONGs
  02-Apr-92 rs  Portability cleanup (see port.h).
  18-Apr-92 awr Removed clip_tile()
  21-Apr-92 jfd Temporarily removed conditional compile for SCAN_CONVERT
                until BITMAP.C is settled.
  14-Jul-92 awr Changed function prototype for make_gaso().
  21-Sep-92 jfd Moved typedef for RASTER from RASTER.C.
  14-Nov-92 rs  Port to Mac - fill() renamed to cgfill().
  22-Mar-93 jfd Added raster line organizations.
  13-Apr-93 jfd Moved "bit[]" table to RASTER.C.
   2-Jul-93 awr Changes for new nzw fill.
  16-Dec-93 jfd/jc In RASTER structure, added field "tran_run_ct".
  13-Apr-94 awr Added new function prototype for char_left_ref(). 
                Changed prototype for find_part2whole().
  15-Apr-94 jfd Added arg to char_left_ref() function prototype - y offset.
  14-Feb-95 mby Changed 'COUNTER', 'PCOUNTER' types in NZ_NODE and RASTER to
                'PNZCOUNTER', 'NZCOUNTER' to save memory on 32-bit CPUs.
*/


/* #if TILE */
typedef struct
{
    int tile_on;
    BOX tb;   /* box in output bitmap to clip to */
    SW16 clip_fops_bot; /* top and bottom clip in fops     */
    SW16 clip_fops_top;
} SCAN_CONVERT;
/* #endif */

#if NON_Z_WIND
typedef struct NZ_NODE
        {
            struct NZ_NODE FARPTR * link;
            PNZCOUNTER  pval;
            NZCOUNTER   onoff;
            NZCOUNTER   lowRow;
            NZCOUNTER   valCount;
        } NZ_NODE;

typedef NZ_NODE FARPTR * PNZ_NODE;
#endif


typedef struct
{
    CHAR_STATS o;
    LPUB8      tran_buffer;
    LPUB8      or_buffer;
    SW16VECTOR bmdim;     /* bitmap dimensions */
#if NON_Z_WIND
    NZ_NODE    nz_pend_list;
    NZ_NODE    nz_active_list;
    NZCOUNTER  nz_start_row;
    NZCOUNTER  nz_valCount;
    NZCOUNTER  nz_overflow;
    NZCOUNTER  nz_done;
    LPUB8      nz_buffer;
    PNZ_NODE   nz_nodes;
    NZCOUNTER  nz_cur_node;

    PNZCOUNTER nz_pval;
    NZCOUNTER  tran_run_ct;  /* number of transition runs = number of
                              * changes in y direction in character outline
                              */
#endif

    UW16       polarity;

#ifdef DEBUG
    int         elem_num;
#endif
    int         ydir;
    SL32        tsize;       /* transition array size in bytes */
    int         dytran;
    int         yraster;
    SL32        toff;        /* offset to current raster in trans array */
    int         xx;          /* Bit offset into raster of transition */

  /* Missing Pixel Recovery */

    BOOLEAN     beam;         /*  TRUE if current segment makes on trans */

    BOOLEAN     first_tran;   /*  TRUE until 1st transition is produced  */

    int         ptran;        /*  previous transition: last xx produced  */
                              /*  by previous line segment.              */
    BOOLEAN     seton;        /*  Current line segment is producing on   */
                              /*  transitions.                           */
    BOOLEAN     wason;        /*  Previous line segment was producing on */
                              /*  transitions.                           */

        /*  Values when first transition is produced. These values are
         *  used to close the loop by linking the last transition in
         *  the loop to the first transition.
         */

    int         ydir1;
    BOOLEAN     seton1;
    int         xx1;
    int         dytran1;
    SL32        toff1;

#if TILE
    int  above;
    int  below;
    INTR clip_fops_top;
    INTR clip_fops_bot;
#endif
} RASTER;

/*****************************************/
/*                                       */
/*      Raster Line Organizations        */
/*                                       */
/*****************************************/
#if (RASTER_ORG == EIGHT_BIT_CHUNK)

typedef UB8           CHUNK;
typedef UB8  FARPTR * LPCHUNK;
#define CHUNK_COUNT   1
#define CHUNK_SHIFT   3
#define CHUNK_MASK    7

#elif (RASTER_ORG == SIXTEEN_BIT_CHUNK)

typedef UW16          CHUNK;
typedef UW16 FARPTR * LPCHUNK;
#define CHUNK_COUNT   2
#define CHUNK_SHIFT   4
#define CHUNK_MASK    15

#elif (RASTER_ORG == THIRTYTWO_BIT_CHUNK)

typedef UL32          CHUNK;
typedef UL32 FARPTR * LPCHUNK;
#define CHUNK_COUNT   4
#define CHUNK_SHIFT   5
#define CHUNK_MASK    31

#elif (RASTER_ORG == SIXTYFOUR_BIT_CHUNK)

typedef double        CHUNK;
typedef double FARPTR * LPCHUNK;
#define CHUNK_COUNT   8
#define CHUNK_SHIFT   6
#define CHUNK_MASK    63

#endif  /* RASTER_ORG == EIGHT_BIT_CHUNK */


#ifdef LINT_ARGS
EXTERN BOOLEAN    structs_are_equal(LPSB8, LPSB8, int);
EXTERN VOID       translate_coords(SW16, SW16);
EXTERN UW16       make_gaso(int, PCHR_DEF);
EXTERN BOX        char_left_ref(SW16VECTOR, BOX, SW16);
EXTERN SW16VECTOR find_part2whole(SW16VECTOR, SW16VECTOR, PCHR_DEF);
EXTERN VOID       bitmap_dimensions(SL32, SL32, PSW16VECTOR);
EXTERN VOID       union_bound_boxes(PBOX, PBOX, SW16, SW16);
EXTERN UW16       raster(LPUB8, LPUB8, LPUB8, SW16VECTOR);
EXTERN VOID       cgfill(LPUB8, LPUB8, int, int, LPUB8);
EXTERN VOID       metrics(PIFBITMAP);
EXTERN VOID       merge(PIFBITMAP, PIFBITMAP, SW16VECTOR);

#ifdef DEBUG
EXTERN VOID       print_bm(PIFBITMAP);
#else
#define           print_bm(v)     /**/
#endif

#else /* no LINT_ARGS */
EXTERN BOOLEAN    structs_are_equal();
EXTERN VOID       translate_coords();
EXTERN UW16       make_gaso();
EXTERN BOX        char_left_ref();
EXTERN SW16VECTOR find_part2whole();
EXTERN VOID       bitmap_dimensions();
EXTERN VOID       union_bound_boxes();
EXTERN UW16       raster();
EXTERN VOID       cgfill();
EXTERN VOID       metrics();
EXTERN VOID       merge();
#ifdef DEBUG
EXTERN VOID       print_bm();
#else
#define           print_bm(v)     /**/
#endif
#endif /* LINT_ARGS */

