/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/cgifwin.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log:   I:/bull/urip/sys/inc/cgifwin.h_v  
 * 
 *    Rev 1.0   09 Dec 1992 11:37:32   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* cgifwin.h  -- a windows version of cgif.h */

/*   08-13-90   jfd   Re-arranged the CGIFpcleo declarations so that        */
/*                    if MULTICALLER, version of CGIFpcleo with three       */
/*                    arguments is declared, rather than two                */
/*   13-Jan-91  awr   Added ERRhix_extra error code.                        */
/*   28-Jan-91  jfd   Declared "...cc_buf_size" conditionally based         */
/*                    on (MAX_BM_BITS > 16)                                  */
/*                    Declared size arg of CGIFchar_size() conditionally    */
/*                    based on (MAX_BM_BITS > 16)                            */
/*                    Added type FPLONG                                     */ 
/*                       Declared xorigin and yorigin from structure IFBITMAP*/
/*                       conditionally based oon (MAX_BM_BITS > 16).        */
/*                       ADDed MASK defines for FONTCONTEXT.format bit usage */
/*                       for point size units designation.                   */
/*   23-Jul-91  jfd   Added typedefs for PHIFBITMAP and PHIFOUTLINE which    */
/*                    exist in cgif.h.                                       */
/*                    Added function prototype for CGIFchar_handle().        */
/*                    Disabled first 3 typedefs at atop (because they do not */
/*                    appear in CGIF.H.                                      */
/*                    Added typedef for HIFOUTLINE                           */
/*                    Disabled typedef for FIXED                             */
/*                    Added DEFINE for NIL_MH                                */
/*                    Removed DEFINE for ERRhix_extra                        */
/*                    Added DEFINEs for ERRinvalid_seg_key, ERRmem,          */
/*                    ERRoutline_mem and ERRcc_outline_mem                   */
/*                    Added DEFINEs for ERRtfheader_missing, ERR_ps_pfb_open,*/
/*                    ERR_ps_afm_open, ERR_ps_pfm_open, ERR_ps_vfm_open,     */
/*                    ERR_no_vfm_font_id, ERR_ps_toomanysegs and             */
/*                    ERR_ps_unk_seg                                         */
/*                    Added DEFINES for ERRmatrix_range and ERRdu_pix_range  */
/*                    Added DEFINE for ERRsingular_matrix                    */
/*                    Added DEFINE for ERRmult_call                          */
/*                    Added DEFINE for ERRinvalid_outproc_type,              */
/*                    ERR_bitmap_not_installed, ERR_outline_not_installed,   */
/*                    ERR_quadratic_not_installed and                        */
/*                    ERR_linear_not_installed                               */
/*                    Added typedef for PIFCONFIG;                           */
/*                    Added DEFINES for FC_... 's                            */
/*                    Replaced FONTCONTEXT structure with new 1.5 version    */
/*                    (copied from CGIF.H)                                   */
/*                    Added typedef for PDLL                                 */
/*                    Added typedefs for PIFBITMAP and PPIFBITMAP            */
/*                    Disabled typedef for POINTFX                           */
/*      1-Aug-91  awr   Chg'd IFBITMAP and IFOUTLINE arrays from 1 to 4 bytes*/
/*                      (Was affecting conputation of HEADERSIZE)            */
/*      7-Aug-91  jfd Enabled typedef for POINTFX                           */
/*     09-Sep-91  awr   Replaced "#define HEADERSIZE..." with "define       */
/*                      BMHEADERSIZE..." and #define OLHEADERSIZE...".      */
/*                      In structure IFOUTLINE, no longer conditionally     */
/*                      compiling xscale and yscale based on MAX_BM_BITS.   */
/*     16-Sep-91  jfd   Added error codes ERR_ps_toomanystems and           */
/*                      ERR_ps_toomanystdwid.                               */
/*     17-Sep-91  jfd   In structure IFBITMAP, changed xorigin and yorigin  */
/*                      to LONG instead of either LONG or WORD.             */
/*     05-Mar-92  rs    Update for UFST                                     */
/*     13-aPR-92  rs    Add section for Borland C++ (w/o port.h).           */

/*
   Add following section for Borland C++, since not including port.h. Attempt
   to make this look like MSC 6.0. - 4/13/92 - rs
*/
#if defined(__BORLANDC__)          /* Borland C++ - MSDOS or Windows   */

#if defined (__WINDOWS__)
#if !defined (_WINDOWS)
#define _WINDOWS  1
#endif /* _WINDOWS */
#endif /* __WINDOWS__ */

#if defined(__TINY__)
#define M_I86TM	1
#elif defined(__SMALL__)
#define M_I86SM	1
#elif defined(__MEDIUM__)
#define M_I86MM	1
#elif defined(__COMPACT__)
#define M_I86CM	1
#elif defined(__LARGE__)
#define M_I86LM	1
#endif /* (__TINY__) */

#endif /* defined(__BORLANDC__) */



/* Added the following since we are not including PORT.H  (07-23-91 jfd ) */
/* if small or medium (tiny?) MS `C' model then define pointers as far */

#if (defined(MSC) || defined(_WINDOWS))

#if (defined(M_I86SM) || defined(M_I86MM) || defined (M_I86TM))
#define FARPTR far
#else
#define FARPTR
#endif

#else                  /* !MSC, !_WINDOWS, must be a real system */
#define FARPTR
#endif

typedef unsigned char  UBYTE;        /*                        or UBYTE */

typedef UBYTE FARPTR * PUBYTE;

typedef unsigned long  ULONG;        /* windows.h does not define ULONG */
typedef unsigned short UWORD;        /*                        or UWORD */
typedef ULONG        MEM_HANDLE;
typedef MEM_HANDLE   HIFFONT;
typedef MEM_HANDLE   HIFBITMAP;
typedef MEM_HANDLE   HIFOUTLINE;
typedef HIFBITMAP  FARPTR * PHIFBITMAP;
typedef HIFOUTLINE FARPTR * PHIFOUTLINE;



#define NIL_MH       ((MEM_HANDLE)0L)
/*----------------------------------*/
/*         Memory Pools             */
/*----------------------------------*/
#define CACHE_POOL   0
#define BUFFER_POOL  1

/*----------------------------------*/
/*      CGIFkern() query codes        */
/*----------------------------------*/
#define  TEXT_KERN    0
#define  DESIGN_KERN  1

/*-----------------------------------*/
/* CGIFsegments() data segment codes */
/*-----------------------------------*/
#define FACE_GLOBAL_KEY   0    /* Entire face global segment */
#define GIF_KEY         100    /* Global Intellifont segment */
#define TRACK_KERN_KEY  101    /* track kerning              */
#define TEXT_KERN_KEY   102    /* text kerning               */
#define DESIGN_KERN_KEY 103    /* designer kerning           */
#define WIDTH_KEY       104    /* character width segment    */
#define ATTRIBUTE_KEY   105    /* Attribute header           */
#define RASTER_KEY      106    /* Raster parameter           */
#define TF_HEADER_KEY   107    /* Typeface Header segment    */
#define COMPOUND_KEY    108    /* Compound character         */
#define DISPLAY_KEY     109    /* Display header             */
#define FONT_ALIAS_KEY  110    /* Font Alias segment         */
#define COPYRIGHT_KEY   111    /* Copyright notice           */

/*----------------------------------*/
/*        Error Return Codes        */
/*----------------------------------*/
#define ERR_bad_bitmap_width   1
#define ERR_no_font_index      3   /* can't open font index file */
#define ERR_rd_font_index      4   /* can't allocate or read font index */
#define ERR_missing_plugin     5   /* missing one or more plugin lib    */
#define ERR_no_symbol_set      6   /* can't open symbol set file        */
#define ERR_rd_symbol_set      7   /* can't allocate or read symbol set */
#define  ERR_bad_pool          21
#define  ERR_CACinit           32
#define  ERR_no_font           53
#define  ERR_IXnew_ss          54
#define  ERR_bad_chID          61
#define  ERR_bm_buff           63
#define  ERR_no_cgnum          64  /* ss id does not map to a cgnum */
#define  ERR_no_fi_entry       65  /* no font index */
#define  ERR_open_lib          66  /* Error opening library file */
#define  ERR_mem_face_hdr      67  /* Mallac failed for face header */
#define  ERR_face_abort        68
#define  ERR_find_cgnum        69  /* Can't find cgnum in char. index */
#define  ERR_rd_char_data      70  /* Can't read character data       */
#define  ERR_buffer_too_small  71
#define  ERR_bad_kern_code     81
#define  ERRinvalid_seg_key    91  /* bad key param in CGIFsegments()  */
#define  ERRmem                92  /* general memory allocation error  */
#define  ERRoutline_mem        93
#define  ERRcc_outline_mem     94

/* pcleo.c */
#define ERRnot_ready_lpt      100  /* printer not ready during write   */
#define ERRwrite              101  /* fwrite() error                   */
#define ERRopen_printer       102  /* LPT not ready during open_file() */
#define ERRopen_file          103  /* fopen() error   "      "    "    */
#define ERRfstat              104  /* fstat() error   "      "    "    */
#define ERRrastparam_missing  105  /* missing raster parameter segment */
#define ERRattribseg_missing  106  /*    "    font attribute      "    */
#define ERRdispheader_missing 107  /*    "    display header      "    */
#define ERRfat_missing        108  /*    "    font alias table         */
#define ERRbadchar            109  /* Inconsistent skeletal char data  */
#define ERRvertesc            110  /* Non-zero vertical escapement     */
/*
PostScript Output error messages
*/
#define  ERRtfheader_missing   200	/* typeface header not in library */
#define  ERR_ps_pfb_open       201	/* error opening pfb file */
#define  ERR_ps_afm_open       202	/* error opening afm file */
#define  ERR_ps_pfm_open       203	/* error opening pfm file */
#define  ERR_ps_vfm_open       204	/* error opening vfm file */
#define  ERR_no_vfm_font_id    205
#define	ERR_ps_toomanysegs	206	/* too many segments in type 1 outline */
#define	ERR_ps_unk_seg			207	/* unknown segment outline */
#define	ERR_ps_toomanystems	208	/* no room to add stem to stem str */
#define	ERR_ps_toomanystdwid	209	/* no room to add std dim to array */

/*---------*/
#define  ERR_bm_gt_oron       599  /* Char bitmap too big for on array */
#define  ERR_bm_too_big       600  /* Char bitmap too big */
#define  ERR_mem_char_buf     602  /* Can't malloc character buffer */
#define  ERRmatrix_range      603  /* scaling outside of range */
#define  ERRdu_pix_range      604  /* scaling outside of range */
#define  ERR_if_init_glob     605  /* if_init_glob() failed */
#define  ERR_comp_pix         606  /* com_pix() failed */
#define  ERR_fixed_space      607  /* character is a fixed space */
#define  ERRsingular_matrix   608  /* scaling matrix has 0 determinate */
#define  ERR_skeletal_init    610
#define  ERR_y_skel_proc      611
#define  ERR_x_skel_proc      612
#define  ERR_bold_buf         613
#define  ERR_no_contour       701
#define  ERR_not_hq3          702
#define  ERR_ov_char_buf      703
#define  ERR_out_of_handles   800
#define  ERR_bad_handle       801
#define  ERR_lost_mem         802  /* CGIFdefund() didnot free whole block */
#define  ERR_IXopen_file      803
#define  ERR_no_buck_mem      804  /* BUCKnew couldn't get memory */
#define  ERR_cc_complex       805  /* Compound character hs too many parts */
#define  ERR_no_cc_part       806  /* Can't find compound character part */
#define  ERR_missing_block    807  /* CGIFdefund() can't find the block */
#define  ERR_max_callers      900  /* maximum number of callers         */
#define  ERR_bad_ID           901  /* Caller ID is out of range         */
#define  ERR_not_valid_ID     902  /* ID passed is not active           */
#define  ERR_ccBuff_alloc     903  /* cannot allocate comp-char buffer  */
#define  ERRtoo_many_dup_skel 904  /* too many duplicate skel points    */
#define  ERRmult_call         905

/*  output processor installation errors */
#define  ERRinvalid_outproc_type     950
#define  ERR_bitmap_not_installed    951
#define  ERR_outline_not_installed   952
#define  ERR_quadratic_not_installed 953
#define  ERR_linear_not_installed    954


/*----------------------------------*/
/* Intellifont Configuration Block  */
/*----------------------------------*/
#define PATHNAMELEN  63

typedef struct
{
    UWORD  max_char_size;   /* max cached character bitmap size  */
    UWORD  bit_map_width;   /* width of char bitmap in bytes     */
    PUBYTE cc_buf_ptr;      /* compound character buffer pointer */
#if (MAX_BM_BITS > 16)
    LONG   cc_buf_size;     /*    "        "        "       "    */
#else
    UWORD  cc_buf_size;     /*    "        "        "       "    */
#endif
    UWORD  num_files;       /* max number of open library files  */
    BYTE   bulletPath[PATHNAMELEN];  /* location of Bullet files.         */
    BYTE   typePath[PATHNAMELEN];    /* location of typeface files.    */
} IFCONFIG;
#if JFDTEST
typedef IFCONFIG FARPTR * PIFCONFIG;
#endif


typedef long  SLONG;   /* windows.h does not define a signed long */
typedef int   SWORD;   /*                        or a signed word */
typedef LONG  FIXED;   /* 32 bit fixed point number               */
                       /* with 16 bit fractional part             */

typedef struct
{
    FIXED x;
    FIXED y;
} POINTFX;


/*----------------------------------*/
/*       Font Context               */
/*----------------------------------*/
/*  Masks and field values for FONTCONTEXT format field

    UWORD   format;

        output format
        bit 15-14    0  Auto-quality
                     1  quality level 1
                     2  quality level 2
                     3  quality level 3
        Bits 13-10  type file descriptors
        Value  (in word)
          0    (0x0000)  Disk based library file
          1    (0x0400)  PCLEO file format

        Bits 9-8    FONTCONTEXT.format point size
                    units descriptors
        Value (in word)
          0    (0x0000)  8ths of a point
          1    (0x0100)  16ths of a point

        Bits 7  Resolution units

        Value
          0    (0x0000)  Pixels per meter
          1    (0x0080)  Pixels per inch

        Bits 6-4 Reserved

        Bits 3-0  Output character type
        Value  (in word)
          0    (0x0000)  Bitmap
          1    (0x0001)  not implemented
          2    (0x0002)  Quadratic outline
          3    (0x0003)  Cubic outline
*/

#define FC_PSUNITS_MASK   0x0300   /* Pt sz units bits w/in format fld   */
#define FC_8THS_TYPE      0x0000   /* Pt sz in 8ths (default)            */
#define FC_16THS_TYPE     0x0100   /* Pt sz in 16ths                     */

#define FC_INCHES_TYPE    0x0000   /* Output resolution is in pixels/inch */

#define FC_OUTPUT_MASK    0x000f   /* output type bits w/in format field */
#define FC_BITMAP_TYPE    0x0000   /* bitmap                             */
#define FC_LINEAR_TYPE    0x0001   /* reserved-not implemented           */
#define FC_QUAD_TYPE      0x0002   /* quadratic outline                  */
#define FC_CUBIC_TYPE     0x0003   /* cubic outline                      */
#define FC_ISBITMAP(fc) (( (fc)->format & FC_OUTPUT_MASK ) == FC_BITMAP_TYPE)
#define FC_ISLINEAR(fc) (( (fc)->format & FC_OUTPUT_MASK ) == FC_LINEAR_TYPE)
#define FC_ISQUAD(fc)   (( (fc)->format & FC_OUTPUT_MASK ) == FC_QUAD_TYPE)
#define FC_ISCUBIC(fc)  (( (fc)->format & FC_OUTPUT_MASK ) == FC_CUBIC_TYPE)
#define FC_ISOUTLINE(fc) ( (fc)->format & FC_OUTPUT_MASK )

#define FC_EXTERN_TYPE     0x0400   /* PCLEO file format                  */
#define FC_DISK_TYPE       0x0800   /* Disk based file                    */
#define FC_ROM_TYPE        0x0800   /* ROM based file                     */

#define FC_FONTTYPE_MASK  0x3000
#define FC_IF_TYPE        0x0000   /* Intellifont                        */
#define FC_PST1_TYPE      0x1000   /* PostScript Type 1 font             */
#define FC_TT_TYPE        0x2000   /* TrueType font                      */

#define FC_ISEXTERN(fc) ( (fc)->format & FC_EXTERN_TYPE)
#define FC_ISIF(fc)    (( (fc)->format & FC_FONTTYPE_MASK ) == FC_IF_TYPE)
#define FC_ISPST1(fc)  (( (fc)->format & FC_FONTTYPE_MASK ) == FC_PST1_TYPE)
#define FC_ISTT(fc)    (( (fc)->format & FC_FONTTYPE_MASK ) == FC_TT_TYPE)




#if 0
/*  56 bytes */
typedef struct
{
    SLONG   font_id;      /* font number                                */
    SWORD   point_size;   /* point size of this character in 1/8th pts  */
    SWORD   set_size;     /* set   size of this character in 1/8th pts  */
    POINTFX shear;        /* cosine & sine of vertical stroke angle     */
    POINTFX rotate;       /* cosine & sine of baseline rotation         */
    ULONG   xres;         /* output pixels per meter                    */
    ULONG   yres;
    FIXED   xspot;
    FIXED   yspot;
    SWORD   xbold;
    SWORD   ybold;
    UWORD   ssnum;
    UWORD   format;       /* output format                              */
                          /* bit 15-14    0  Auto-quality               */
                          /*              1  quality level 1            */
                          /*              2  quality level 2            */
                          /*              3  quality level 3            */

                          /* Bits 9-8    FONTCONTEXT.format point size  */
                          /*             units descriptors              */
                          /* Value (in word)                            */
                          /*   0    (0x0000)  8ths of a point           */
                          /*   1    (0x0100)  16ths of a point          */               
                          /*                                            */
                    
}
FONTCONTEXT;
#endif


#if !SCALE_MATRIX    /* typographer version only */

/*  48 bytes */
typedef struct
{
    LONG    font_id;      /* font number                                */
    WORD    point_size;   /* point size of this character in 1/8th pts  */
    WORD    set_size;     /* set   size of this character in 1/8th pts  */
    POINTFX shear;        /* cosine & sine of vertical stroke angle     */
    POINTFX rotate;       /* cosine & sine of baseline rotation         */
    ULONG   xres;         /* output pixels per meter                    */
    ULONG   yres;
    FIXED   xspot;
    FIXED   yspot;
    WORD    xbold;
    WORD    ybold;
    UWORD   ssnum;
    UWORD   format;       /* format flags                               */
#if (PCLEO_RDR || PST1I || TT_RDR)
	LPBYTE  font_hdr;     /* pointer to font header               */
#endif                   
}  FONTCONTEXT;

#else                /* typographer and all matrix versions */

/* The following 4 typedefs are different ways of specifying the scaling
   parameters. They are all combined in a union in the FONTCONTEXT
   structure defined after.
*/

#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
typedef struct
{
    WORD    point_size;   /* point size of this character in 1/8th pts  */
    WORD    set_size;     /* set   size of this character in 1/8th pts  */
    POINTFX shear;        /* cosine & sine of vertical stroke angle     */
    POINTFX rotate;       /* cosine & sine of baseline rotation         */
    ULONG   xres;         /* output pixels per meter                    */
    ULONG   yres;
}  TYPO;
#endif


#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
/*  Design space to output space */

typedef struct
{
    LONG    m[4];         /* Design space to output space               */
    WORD    matrix_scale; /* number of fractional bits in m[] values    */
} MAT0;
#endif



#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
/* world to output and em box */

typedef struct
{
    LONG    m[4];         /* matrix from world space to output space    */
    LONG    em_width;     /* size of em box in world units              */
    LONG    em_depth;
    WORD    matrix_scale; /* number of fractional bits in m[] values    */
    WORD    em_scale;     /*   "     "     "        "   " em sizes      */
} MAT1;
#endif



#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
/* world to output and world res and pt and set */

typedef struct
{
    LONG    m[4];         /* matrix from world space to output space    */
    LONG    xworld_res;   /* world space resolution */
    LONG    yworld_res;
    WORD    matrix_scale; /* number of fractional bits in m[] values    */
    WORD    world_scale;  /*   "     "     "        "   " resolution    */
    WORD    point_size;
    WORD    set_size;
} MAT2;
#endif


/* FONTCONTEXT structure */

typedef struct
{
    LONG    font_id;      /* font number                                */
    FIXED   xspot;
    FIXED   yspot;
    WORD    xbold;
    WORD    ybold;
    UWORD   ssnum;
    UWORD   format;       /* format flags                               */
#if (PCLEO_RDR || PST1I || TT_RDR)
	LPBYTE  font_hdr;     /* pointer to font header               */
#endif


    UWORD  fc_type;     /* selector indicates which union type */
    union
    {
#if (SCALE_MATRIX & TYPO_SCALE_MATRIX)
        TYPO  t;
#endif
#if (SCALE_MATRIX & MAT0_SCALE_MATRIX)
        MAT0  m0;
#endif
#if (SCALE_MATRIX & MAT1_SCALE_MATRIX)
        MAT1  m1;
#endif
#if (SCALE_MATRIX & MAT2_SCALE_MATRIX)
        MAT2  m2;    
#endif
    } s;
} FONTCONTEXT;

/* values for fc_type */

#define FC_TYPO_TYPE      0   /* Typographer                        */
#define FC_MAT0_TYPE      1   /* Matrix design unit to output       */
#define FC_MAT1_TYPE      2   /*        world to output   em box    */
#define FC_MAT2_TYPE      3   /*                          pt, set   */

#endif  /*  SCALE_MATRIX not 0 */

#if JFDTEST
typedef FONTCONTEXT FARPTR * PFONTCONTEXT;
#endif



/*----------------------------------*/
/*    Character Bitmap              */
/*----------------------------------*/

/*----------------------*/
/*  Doubly Linked Lists */
/*----------------------*/
typedef struct
{ 
    MEM_HANDLE  f;  /* forward pointer */
    MEM_HANDLE  b;  /* backward pointer */
} DLL;
typedef DLL FARPTR * PDLL;

typedef struct
{
    DLL     link;          /* doubly linked list pointers                  */
    UWORD   notmru;        /* set to 0 if recently made most recently used */
    HIFFONT hiffont;       /* Font handle of the owner of this IFBITMAP    */
    SWORD   index;         /* index to IFBITMAP in above FONT's table      */

    SWORD   width;         /* bit map width (bytes)                 */
    SWORD   depth;         /*  "   "  depth (pixels)                */
    SWORD   left_indent;
    SWORD   top_indent;
    SWORD   black_width;
    SWORD   black_depth;
    LONG    xorigin;       /*  (1/16th pixel)  */
    LONG    yorigin;       /*  (1/16th pixel)  */
    SWORD   escapement;    /* character body width (design units)  */

    UBYTE   bm[4];         /* character bit map                     */
} IFBITMAP;
#if JFDTEST
typedef IFBITMAP FARPTR * PIFBITMAP;
typedef IFBITMAP FARPTR * FARPTR * PPIFBITMAP;
#endif

#define BMHEADERSIZE   (sizeof(IFBITMAP) - 4) /* IFBITMAP header size  */

typedef struct
{
    DLL     link;          /* doubly linked list pointers                  */
    UWORD   notmru;        /* set to 0 if recently made most recently used */
    HIFFONT hiffont;       /* Font handle of the owner of this IFBITMAP    */
    WORD    index;         /* index to IFBITMAP in above FONT's table      */

    WORD    size;          /* size of header w/out metrics */
    WORD    depth;         /*  always 1                */
    WORD    left;
    WORD    top;
    WORD    right;
    WORD    bottom;
    WORD    xscale;
    WORD    yscale;
    WORD    escapement;    /* character body width (design units)  */

    UBYTE   bm[4];         /* character bit map                     */
} IFOUTLINE;
typedef IFOUTLINE FARPTR * PIFOUTLINE;

#define OLHEADERSIZE   (sizeof(IFOUTLINE) - 4) /* IFOUTLINE header size */

typedef struct {
    UWORD num_segmts;
    UWORD num_coords;
    UWORD polarity;
    UWORD segmt_offset;
    UWORD coord_offset;
} OUTLINE_LOOP;
typedef OUTLINE_LOOP FARPTR * POUTLINE_LOOP;

typedef struct {
  UWORD size;
  UWORD num_loops;
  OUTLINE_LOOP loop[4];
} OUTLINE_CHAR;
typedef OUTLINE_CHAR FARPTR * POUTLINE_CHAR;

/*----------------------------------*/
/*    Kerning Pair                  */
/*----------------------------------*/

typedef struct
{
    UWORD chId0, chId1;
    SWORD adj;
}  KERN_PAIR;
#if JFDTEST
typedef KERN_PAIR FARPTR * PKERN_PAIR;
#endif

#if TILE
/*----------------------------------*/
/*    Tile structures               */
/*----------------------------------*/
typedef struct
{
    WORD x;      /* coordinate of upper left corner of tile  */
    WORD y;
    WORD width;  /* dimensions of tile */
    WORD depth;

}  IFTILE;
typedef IFTILE FARPTR * PIFTILE;


#endif /* TILE */




/*----------------------------------*/
/*    Windows specific typedefs     */
/*----------------------------------*/


typedef KERN_PAIR * PKERN_PAIR;
typedef KERN_PAIR far * FPKERN_PAIR;

typedef IFBITMAP * PIFBITMAP;
typedef IFBITMAP ** PPIFBITMAP;
typedef IFBITMAP far * FPIFBITMAP;
typedef IFBITMAP far * far * FPFPIFBITMAP;

typedef FONTCONTEXT * PFONTCONTEXT;
typedef FONTCONTEXT far  * FPFONTCONTEXT;

typedef IFCONFIG * PIFCONFIG;
typedef IFCONFIG far * FPIFCONFIG;

typedef char  far *FPBYTE;
typedef short far *FPWORD;
typedef long  far *FPLONG;  /* 01-28-91 jfd */
typedef unsigned char  far *FPUBYTE;
typedef unsigned short far *FPUWORD;

#if MULTICALLER
WORD  FAR PASCAL  CGIFinit(LPWORD, LPDWORD, LPDWORD);
WORD  FAR PASCAL  CGIFconfig(WORD, FPIFCONFIG);
WORD  FAR PASCAL  CGIFfund(WORD, WORD, FPBYTE, LONG, FPWORD);
WORD  FAR PASCAL  CGIFenter(WORD);
VOID  FAR PASCAL  CGIFexit(WORD);
WORD  FAR PASCAL  CGIFfont(WORD, FPFONTCONTEXT);
WORD  FAR PASCAL  CGIFwidth(WORD, WORD, WORD, WORD, FPWORD);
WORD  FAR PASCAL  CGIFkern(WORD, WORD, WORD, FPKERN_PAIR);
WORD  FAR PASCAL  CGIFmove_block(WORD, FPBYTE);

#if CACHE
WORD  FAR PASCAL  CGIFchar(WORD, WORD, FPFPIFBITMAP, WORD);
#else
#if (MAX_BM_BITS > 16)
WORD  FAR PASCAL  CGIFchar_size(WORD, WORD, FPLONG, WORD);
#else
WORD  FAR PASCAL  CGIFchar_size(WORD, WORD, FPWORD, WORD);
#endif
WORD  FAR PASCAL  MAKbitMap(FPIFBITMAP, FPBYTE, FPBYTE);
#endif

#if DEFUND
WORD  FAR PASCAL  CGIFdefund(WORD, UWORD);
#endif

#if PCLEO
WORD  FAR PASCAL  CGIFpcleo(UWORD, LPSTR, LPLONG);
#endif

#if SEGACCESS
WORD  FAR PASCAL  CGIFsegments(LONG, WORD, FPWORD, LPBYTE);
#endif

UWORD FAR PASCAL  CGIFchar_handle(UWORD, UWORD, PHIFBITMAP, WORD);

#else

WORD  FAR PASCAL  CGIFinit(VOID);
WORD  FAR PASCAL  CGIFconfig(FPIFCONFIG);
WORD  FAR PASCAL  CGIFfund(WORD, FPBYTE, LONG, FPWORD );
WORD  FAR PASCAL  CGIFenter(VOID);
VOID  FAR PASCAL  CGIFexit(VOID);
WORD  FAR PASCAL  CGIFfont(FPFONTCONTEXT);
WORD  FAR PASCAL  CGIFwidth(WORD, WORD, WORD, FPWORD);
WORD  FAR PASCAL  CGIFkern(WORD, WORD, FPKERN_PAIR );
WORD  FAR PASCAL  CGIFmove_block(UWORD, FPBYTE);

#if CACHE
WORD  FAR PASCAL  CGIFchar(WORD, FPFPIFBITMAP, WORD);
#else
#if (MAX_BM_BITS > 16)
WORD  FAR PASCAL  CGIFchar_size(WORD,   FPLONG , WORD);
#else
WORD  FAR PASCAL  CGIFchar_size(WORD,   FPWORD , WORD);
#endif
WORD  FAR PASCAL  MAKbitMap(FPIFBITMAP,  FPBYTE ,  FPBYTE);
#endif

#if DEFUND
WORD  FAR PASCAL  CGIFdefund(UWORD);
#endif

#if PCLEO
WORD  FAR PASCAL  CGIFpcleo(LPSTR, LPLONG);
#endif

#if SEGACCESS
WORD   FAR PASCAL CGIFsegments(LONG, WORD, FPWORD, LPBYTE);
#endif

UWORD  FAR PASCAL CGIFchar_handle(UWORD, PHIFBITMAP, WORD);

#endif

