/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/cgmacros.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: cgmacros.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.5   07 Apr 1995 11:31:12   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 15:31:30   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   02 Feb 1994 09:21:52   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.2   14 Jan 1993 11:05:52   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:45:18   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:38:08   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*  cgmacros.h  */

/*
 *  Miscellaneous macros.
 *
 *  Modification History:
 *  26 Sep 92  jfd    Original (Leveraged from CGSPARC.H)
 *                    Made conditional compile based on BYTEORDER.
 *                    Added macros GET_xWORD() and GET_xLONG() from
 *                    PCLEOMGT.C.
 *  21-Oct-92  mby    Added processor-independent macros GET_xBYTE_OFF()
 *                    GET_xWORD_OFF(), GET_xLONG_OFF(). Removed conditional
 *                    compile for GET_xWORD() and GET_xLONG().
 *  27-Jan-94  jfd    If building for _AM29K, define BITSPERBYTE to 8
 *                    instead of including <values.h>.
 */

#if (BYTEORDER == HILO) /* Motorola format, don't swap bytes */

#if defined(_AM29K)
#define BITSPERBYTE 8
#else
#include    <values.h>                /* for BITSPERBYTE */
#endif

MLOCAL UW16    hiword, loword;
MLOCAL UB8    hibyte, lobyte;
MLOCAL LPUB8   b0, b1, b2, b3;

/* make long from words  */
#define MAKELONG( dest, srcp )  \
    hiword = *( (LPUW16)(srcp) ); \
    loword = *( (LPUW16)(srcp+2) ); \
    dest   =  ( (UL32)hiword << (2*BITSPERBYTE) ) + loword;


/* make word from bytes  */
#define MAKEWORD(p)  \
    ( ((UW16)*((LPUB8)(p)+1) << BITSPERBYTE) + (UW16)(*(LPUB8)(p)) )


/* set word into byte pointer  */
#define SETWORD( destp, src )		\
    *(LPUB8)destp = (short)src >> 8;	\
    *((LPUB8)destp + 1) = (short)src & 0xFF; 


/* make long from bytes  */
#define MAKELONGB( dest, srcp )  \
    b0   = (LPUB8)(srcp); b1 = b0 + 1; b2 = b1 + 1; b3 = b2 + 1; \
    dest = ((UL32)*b0 << (3*BITSPERBYTE) ) \
	 + (*b1 << (2*BITSPERBYTE))  \
	 + (*b2 << (1*BITSPERBYTE))  \
	 +  *b3;

#if 0
#define GET_xWORD(a)   \
            (((unsigned short)(*(unsigned char*)a)    << BITSPERBYTE ) \
	                  +   *((unsigned char*)a+1) )
/*...rs*/

#define GET_xLONG(a) \
            (((unsigned long)(*(unsigned char*)a)    << (3*BITSPERBYTE) ) \
	                  + ( *((unsigned char*)a+1) << (2*BITSPERBYTE) ) \
	                  + ( *((unsigned char*)a+2) <<  BITSPERBYTE    ) \
	                  +   *((unsigned char*)a+3) )
#endif  /* 0 */


#endif  /* BYTEORDER == HILO */




/* Processor-independent macros to read 1, 2, or 4 bytes from memory in
 * high, ..., low order. Alignment on 2- or 4-byte boundaries is not required.
 */

#define GET_xWORD(a)  \
           ( ((unsigned short) *(unsigned char*)(a) << 8) |      \
              (unsigned short) *((unsigned char*)(a)+1) )

#define GET_xLONG(a)  \
           ( ((unsigned long) *(unsigned char*)(a) << 24)     |  \
             ((unsigned long) *((unsigned char*)(a)+1) << 16) |  \
             ((unsigned long) *((unsigned char*)(a)+2) << 8)  |  \
              (unsigned long) *((unsigned char*)(a)+3) )

#define GET_xBYTE_OFF(a,OFFSET)  ( *((unsigned char*)(a)+OFFSET) )

#define GET_xWORD_OFF(a,OFFSET)  \
           ( ((unsigned short) *((unsigned char*)(a)+OFFSET) << 8) |    \
              (unsigned short) *((unsigned char*)(a)+OFFSET+1) )

#define GET_xLONG_OFF(a,OFFSET)  \
           ( ((unsigned long) *((unsigned char*)(a)+OFFSET) << 24)   |  \
             ((unsigned long) *((unsigned char*)(a)+OFFSET+1) << 16) |  \
             ((unsigned long) *((unsigned char*)(a)+OFFSET+2) << 8)  |  \
              (unsigned long) *((unsigned char*)(a)+OFFSET+3) )

