/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/if_type.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: if_type.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.14   18 Apr 1995 17:03:12   JOE
 * 
 * Added "chIdptr" and "PSchar_name" fields to IF_STATE.
 * 
 *    Rev 1.13   07 Apr 1995 11:31:18   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   27 Jan 1995 11:34:38   MIKE
 * 
 * Added 'IF_STATE.fcoCleanup'.
 * 
 *    Rev 1.11   03 Aug 1994 13:58:26   MIKE
 * Added FCO change from 1.6.1.1
 * 
 *    Rev 1.10   26 Apr 1994 17:53:28   MIKE
 * Added IF_STATE.shear, for orthogonal rotation & nonzero shear.
 * 
 *    Rev 1.9   22 Apr 1994 15:31:20   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.8   06 Mar 1994 12:52:22   MIKE
 * 
 * In IF_STATE, conditionally compile lsb_adj if CONVERGENT_FONTS == 1.
 * 
 *    Rev 1.7   03 Feb 1994 11:40:12   MIKE
 * Added awtsub_on and lsb_adj to IF_STATE for Convergent Fonts.
 * 
 *    Rev 1.6   23 Sep 1993 17:21:42   MIKE
 * Add IF_STATE.usePlugins; ROM1 support. Remove IF_STATE.extern_font
 * 
 *    Rev 1.5   09 Jul 1993 11:01:58   MAIB
 * added back making_bold field
 * 
 *    Rev 1.4   01 Jul 1993 14:28:50   MAIB
 * changed making_bold to non_z_wind
 * 
 *    Rev 1.3   14 May 1993 16:14:40   JOE
 * In structure IF_STATE, conditionally compiled "pathname" and "font_name"
 * based on (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK)) to resolve
 * compiler errors.
 * 
 *    Rev 1.2   14 Jan 1993 11:06:04   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:47:28   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:37:28   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* if_type.h */

/* History
 *    05-May-90 awr  moved char_buf into IF_CHAR structure
 *    15-Jun-90 awr  added max_des field to COORD_DATA
 *    28-Jun-90 bjg  added OUTLINE_PARAMS structure definition. 
 *    27-Jul-90 awr  corrected structure sizes in comments
 *    29_Nov-90 tbh  Changed COORD_DATA structure by adding field 
 *                   "st_variation[4]"
 *    09-Dec-90 awr  added fields in COORD_DATA for new tx() ty() calcs.
 *    15-Jan-91 jfd  Changed field "baseline_offset" in structure IF_CHAR
 *                   from UWORD to WORD.
 *    20-Dec-90 dET  add support for multi-model MSC compilation.
 *                   changed COORD_DATA comment to reflect 66 bytes.
 *    10-Feb-91 awr  Made global flag char_is_if part of IF_CHAR structure.
 *                   Made Global or_on part of IF_DATA structure.
 *                   Added making_bold to IF_DATA structure.
 *     9-Mar-91 awr  Removed OUTLINE_PARAMS.
 *    25-Apr-91 awr  reorg'd if_type to distinguish IF Scaling Intelligence
 *                   stuff from output scaling.
 *    19-May-91 awr  Changed IF_CHAR structure for next_loop()
 *     3-Jun-91 awr  HQ4 changes
 *     9-Jun-91 awr  removed bmwidth & depth from SCALE structure
 *    16-Jun-91 awr  changed XY structure references to WORDVECTOR
 *     4-Jul-91 awr  Removed COORD_DATA "max_des" field. No longer used.
 *                   In SCALE added "wrong_read" field
 *                            changed "quadrant" from UWORD to WORD
 *                            removed "px" and "py"
 *     5-Aug-91 bjg  Changed "defined(ELASTIC... to (ELASTIC....
 *    25-Aug-91 awr  Moved function decls from c modules
 *     3-Sep-92 awr  removed scale.tt0 and reduced scale.m[] to 4 elements
 *    24-Nov-91 awr  added log_xpix & log_ypix defines
 *     7-Mar-92 awr  added CHAR_STATS to if_stat
 *    19-Mar-92 awr  Moved BOX to port.h.
 *    02-Apr-92 jfd  Added diag_control_tol and margin to COORD_DATA
 *                   Added stan_STAN_i to DIMENSION
 *                   Added stan_STAN_dim_lim to IF_STATE
 *    02-Apr-92 rs   Portability cleanup (see port.h).
 *    12 May 92 ss   Changed conditional compile of EXTERN_FONT to use the
 *                   new define NON_IF_FONT.
 *    14-Jun-92 awr  Changed type of xlate, and tbound to INTRs
 *    18-Jul-92 awr  Added est_ouline flag to if_state structure.
 *    21-Jul-92 awr  Conditional compile changes.
 *    07-Aug-92 rs   Compatibility w/Windows 3.1 (FIXED, POINTFX).
 *    14-May-93 jd   In structure IF_STATE, conditionally compiled
 *                   "pathname" and "font_name" based on
 *                   (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
 *                   to resolve compiler errors.
 *    01-Jul-93 maib changed making_bold to non_z_wind
 *    09-Jul-93 awr  Added back making_bold to IF_STATE structure
 *    22-Sep-93 mby  Add IF_STATE.usePlugins; ROM1 support.
 *                   Remove IF_STATE.extern_font (never used).
 *    03-Feb-94 mby  For CONVERGENT_FONTS, added awtsub_on (used to be in
 *                   FONTINDEX structure) and lsb_adj (horizontal offset)
 *                   to IF_STATE.
 *    06-Mar-94 mby  Convergent fonts: in IF_STATE, lsb_adj is conditionally compiled.
 *    26-Apr-94 mby  Added IF_STATE.shear to detect situations of orthogonal
 *                   rotation and nonzero shear.
 *    26-May-94 mby  FCO change from 1.6.1.1:
 *                     Added if_state.FCObject - FCO font handle.
 *    27-Jan-95 mby  Added 'fcoCleanup' flag to IF_STATE structure.
 *    18-Apr-95 jfd  Added 'chIdptr' and 'PSchar_name' fields to IF_STATE 
 *                   structure (loaded by CGIFchIdptr() call).
 */


#define  MAX_DESIGN  0x3fff    /* 16K - 1, max design unit coordinate */
#define  MAX_LOOPS    64
#define  MAX_YCLASS  256
#define  MAX_YLINES  256
#define  MAX_SKEL    96
#define ROOT            (0xff)  /*  init value: assoc's parent spec   */
#define PROCESSED       1       /*  status of skel pnt: processed     */
#define NOT_PROC        0       /*  status of skel pnt: not processed */
#define NOT_ALIGNED     -1      /*  alignment status for skel points  */

#define R_TYPES         1       /*  1 turns on "R" type functionality */
#define R_TWO_I         2       /*  "R" type index of two             */
#define YPROC           1
#define XPROC           2


/* vertex code macros */

#define V_CONTACT(v)  (BOOLEAN)(((v)&1) == 0)
#define V_XSKEL(v)    ((v)&4)
#define V_YSKEL(v)    ((v)&8)


typedef struct
{
    SW16 xyoff;
    SB8 spare;
    SB8 polarity;
    SW16 child;
    SW16 sibling;
}
CTREE;
typedef CTREE FARPTR * PCTREE;

/*---------------------------------------------------------------------*/
#ifdef LINT_ARGS

typedef struct {
    UW16 (*start_char) (PVOID);  /* 5-21-92 !!! */
    UW16 (*end_char)   (VOID);
    UW16 (*start_loop) (UW16);
    UW16 (*end_loop)   (VOID);
    UW16 (*moveto)     (INTR, INTR);
    UW16 (*lineto)     (INTR, INTR);
    UW16 (*quadto)     (INTR, INTR, INTR, INTR);
    UW16 (*cubeto)     (INTR, INTR, INTR, INTR, INTR, INTR);
} OUT_TBL;
typedef OUT_TBL FARPTR * POUT_TBL;

#else  /* !LINT_ARGS */

typedef struct {
    UW16 (*start_char) ();
    UW16 (*end_char)   ();
    UW16 (*start_loop) ();
    UW16 (*end_loop)   ();
    UW16 (*moveto)     ();
    UW16 (*lineto)     ();
    UW16 (*quadto)     ();
    UW16 (*cubeto)     ();
} OUT_TBL;
typedef OUT_TBL FARPTR * POUT_TBL;

#endif /* LINT_ARGS */

typedef struct
{
    PSW16VECTOR cv;         /* coordinates (contacts are interleaved)     */ 
    LPSB8       v;          /* vertex codes                               */
    UW16       npnt;       /* number of curve points                     */
    UW16       ncontact;   /* number of contact points                   */
    UW16       ncoords;    /* number of vector coordinates               */
    SB8        polarity;
}
LOOP;
typedef LOOP FARPTR * PLOOP;

#ifdef LINT_ARGS
EXTERN VOID       first_loop (VOID);
EXTERN VOID       next_loop (PLOOP);
#else
EXTERN VOID       first_loop ();
EXTERN VOID       next_loop ();
#endif

/*---------------------------------------------------------------------*/
/*                      I F _ C H A R                                  */


/*---------------------------*/
/*     DIMENSION             */
/*---------------------------*/

typedef struct
{
    UB8   num_dim;       /*  number of dimensions              */
    UB8   stan_STAN_i;   /*  index to STANDARD standard dim    */
    LPUW16  value;         /*  arr of dimension values           */
    LPUB8  attrib;        /*  arr of dim flags (RTZ = bit 0)    */

}  DIMENSION;
typedef DIMENSION FARPTR * PDIMENSION;



/*---------------------------*/
/*   yclass_def_type         */
/*---------------------------*/

typedef struct
{
    UB8   num_yclass_def; /*  num of loc Y class definitions    */
    LPUB8  yline_high_i;   /*  arr of loc Y line indices         */
    LPUB8  yline_low_i;    /*  arr of loc Y line indices         */

}  YCLASS_DEF;
typedef YCLASS_DEF FARPTR * PYCLASS_DEF;



/* 38 or 43 SB8s */
typedef struct
{
    UB8  num_skel;        /* number of skels         */
    LPUB8 num_skel_loop;   /*  num of skel per loop   */
    LPUW16 skel_to_contr;   /*  skel indices to contr  */
    UB8  num_trees;       /* number of trees (roots) */
    UB8  num_nodes;       /* number of tree nodes    */
    LPUB8 tree_skel_i;     /* skeletal indices        */
    LPUB8 tree_attrib;     /* skeletal attributes     */

    UB8  stan_dim_i;

/** I6.2.3   Interpolated Association data */

    UB8  num_intrp;             /* number of pairs of interp skels */
    LPUB8 intrp1_skel_i;         /* 1st interp skel indices    */
    LPUB8 intrp2_skel_i;         /* 2nd interp skel indices    */
    LPUB8 num_intrp_assoc;       /* number of interps per pair */
    UB8  tot_num_intrp_assoc;   /* number of interp assocs    */
    LPUB8 intrp_assoc_skel_i;    /* interp assoc indices       */

#if ((ELASTIC_Y) | (ELASTIC_X))
/** Elasicity Data */

    SB8   num_breaks_per_char;   /* num of elasticity breaks per character */
    LPUB8 elasticityData;        /* array of indices and num of breaks per assoc */
#endif

}
SKEL;
typedef SKEL FARPTR * PSKEL;


/*                          I F _ C H A R                              */
/*---------------------------------------------------------------------*/
/*                             S C A L E                               */

/*  NOTE: that all macros work properly regardless
 *        of the sign of the argument.
 */
#define log_xpix      if_state.x.grid_shift
#define log_ypix      if_state.y.grid_shift
#define xpix          if_state.x.pixel_size
#define ypix          if_state.y.pixel_size
#define half_xpix     if_state.x.half_pixel
#define half_ypix     if_state.y.half_pixel
#define XCEILING(v)   (1 + (((v) - 1) >> if_state.x.grid_shift))
#define XFLOOR(v)     ((v) >> if_state.x.grid_shift)
#define YCEILING(v)   (1 + (((v) - 1) >> if_state.y.grid_shift))
#define YFLOOR(v)     ((v) >> if_state.y.grid_shift)
#define XPIXEL(v)     (((v) + half_xpix) >> if_state.x.grid_shift)
#define YPIXEL(v)     (((v) + half_ypix) >> if_state.y.grid_shift)

/* 70 or 72 bytes */  /* 01-11-91 awr */
typedef struct
{
  /* -----------Intellifont Scaling Intelligence  values----------- */

    SW16    orig_pixel;     /*  Original imprecise pixel size       */
    SW16    p_pixel;        /*  precise pixel - shifted so that     */
                            /*    16K <= p_size < 32K               */
    SW16    p_half_pix;     /*  half precise pixel                  */
    SW16    bin_places;     /*  bits after the binary point above   */
    SL32    round[4];       /*  rounding value for 4 "R" types      */
    SW16    shut_off;       /*  value of "1-1/4" pixel shut-off     */
    SW16    con_size;       /*  min value for constrained dim       */
    SW16    diag_control_tol;   /*  DWU tolerance for diag control  */

  /* --------------- Elasticity ----------------------------------- */

#if ( (ELASTIC_Y) | (ELASTIC_X))
    SW16    elastic_input;  /*  elast to be inserted at each break  */
#endif
  /* --------------- Standard Dimensions -------------------------- */

    SW16 stand_value;       /* Standard dimension in design units   */
    SW16 st_value[4];       /* These two arrays are results of      */
    SW16 st_pixels[4];      /* pixel_align() using all 4 R-types    */
    SW16 st_variation[4];   /* AMount stan dim rounds 11-29-90 tbh  */

  /* --------------  Scaling to Output Space ---------------------- */

    SW16    pixel_size;     /*  pixel dimension (power of 2)        */
    SW16    half_pixel;     /*  half pixel dimension (power of 2)   */
    INTR    grid_align;     /*  x & grid_align is truncated to grid */
    SW16    grid_shift;     /*  x >> grid_shift is grid number      */
    SW16    shift;          /* 16 - bin_places - grid_shift         */
    SW16    shift_rnd;      /* 2 ** (shift - 1)                     */
    SW16    margin;         /* add to work sp coord to shift to     */
                            /* bitmap coordinate                    */
}  COORD_DATA;
typedef COORD_DATA FARPTR * PCOORD_DATA;


/*  Values for quadrant field below.
 * A value of 0 means arbitrary rotation.
 */
#define ROT0    1
#define ROT90   2
#define ROT180  3
#define ROT270  4

/*---------------------------------------------------------------------*/
/*                         I F _ S T A T E                             */

typedef struct
{
/*                             S C A L E                               */
  /* was in SCALE structure */

    COORD_DATA   x;           /* x grid alignment and scaling           */
    COORD_DATA   y;           /* y grid alignment and scaling           */
    FPNUM        m[4];        /* matrix trsnsform from design to output */
    SW16VECTOR   tt;
    INTRVECTOR   xlate;
    int          right_shift;

    SW16     origBaseline;    /* Original baseline in Design units (DU) */
    SW16     aBaselnVal;      /* grid aligned baseline value (DU)       */
    UW16     bit_map_width;   /* bitmap alignment                       */
    INTRBOX  tbound;          /* bounding box in working bitmap space   */
    SW16     quadrant;        /* 90 rotations: ROT0 ROT90 ROT180 ROT270 */
    int      shear;           /* detects shear; see matrix_to_scale()   */
    BOOLEAN  or_on;           /* 1 if or on transitions, 0 otherwise    */
    BOOLEAN  wrong_read;      /* TRUE if wrong reading                  */
    UW16     quality;         /* qulaity level 1, 2 or 3                */
    BOOLEAN  making_bold;     /* 1 if psuedo bold, 0 otherwise          */
    BOOLEAN  non_z_wind;      /* 1 if non-zero winding, 0 otherwise     */

/*----------------------------------------------------------------------*/

    INTRVECTOR  p0;           /* Current point in output path           */
    OUT_TBL     out;          /* Table of current output functions      */

/*                           A L I G N E D                             */
     /* was ALIGNED structure */

    SW16 value;         /* aligned value */
    SW16 grid_line;     /* grid number   */
#if ( (ELASTIC_Y) |  (ELASTIC_X))
    SW16 remainder;     /* elastic input lost or gained during alignment */
#endif




    SL32    if_init_face;    /* last typeface run through if_init. */
    PBUCKET pbucket;         /* current typeface bucket */
    UW16    fst_type;
    UW16    usePlugins;      /* true: character set Augmentation with buckets;
                              * false: no augmentation */
#if FCO_RDR
    MEM_HANDLE FCObject;     /* for Font Collection Object, from CGIFfont(). */
    UW16       fcoCleanup;   /* signals MAKifbmheader to call fco_CharCleanup() */
#endif

#if TT_ROM1
    BOOLEAN  rom_thing;
#endif

#if NO_SYMSET_MAPPING
    VOID  *chIdptr;          /* ptr to chId (used if ss mapping is removed) */
#if PST1_RDR
    VOID  *PSchar_name;      /* ptr to PS character name ( "  "   "  "    ) */
#endif  /* PST1_RDR */
#endif  /* NO_SYMSET_MAPPING */

    FONTCONTEXT cur_loc_fc; /* The last font context used by comp_pix() */

#if (PST1_DISK || TT_DISK || (DYNAMIC_FONTS && IF_DISK))
    BOOLEAN  has_path;
    PATHNAME font_name;
#endif
    BOOLEAN    est_outline;
    CHAR_STATS cs;          /* character stats */

/*                         I F _ C H A R                               */
            /* was IF_CHAR structure */

    LPSB8   char_buf;           /* character data buffer      */
    LPSB8   expand_buf;         /* character expansion buffer */
    UW16    expand_size;        /* size of expansion buffer   */

    BOX     bound_box;          /* character bounding box- design units */
    BOX     escape_box;         /* character escapement bex-  "     "   */

    SW16    loc_ital_ang;
    UW16    italic_flag;

    BOOLEAN char_is_if;    /* 10_feb-91 awr */

    SKEL    xskel;
    SKEL    yskel;

    SW16  baseline_offset;

  /* y-classes */
/*** I6.2.1.7   Y-class Character (local) data */
    UB8    num_yclass_ass;    /* number of y class assignments */
    LPUB8  num_root_p_ass;    /* number of roots per y class   */
    LPUB8  root_skel_i;       /* root indices in y class order */
    LPUB8  yclass_i;          /* y class indices */

/** local y classes */

    UB8    num_yclass_def;     /* number of local y class definitions */
    LPUB8  yline_high_i;       /* high y line indices */
    LPUB8  yline_low_i;        /* low y line indices */

/*** local y class definitions */

    UW16    num_ylines;         /* number of local y lines */
    LPUW16  ylines;             /* local y line values */


    UW16    num_loops;          /* number of loops */

    UW16    contour_flag;       /* Bits in this word are processed to  */
                                /* the next 3 variables.               */
    UW16    PreBrokenContrs;    /* Boolean flag for contour data with  */
                                /* local and global extreme points.    */
    UW16    HqFormat;           /* Hi-Q data format: 1 = HQ1 (tangent) */
                                /* 2 = HQ2 (contact) 3 = HQ3 (compact) */
    UW16    ConnectingChar;



    PCTREE  ctree;

    LPSB8   contour_data;       /* start of contour data */

    SW16    alt_width;          /* if>0, alternate character width */
    SW16    alt_black_width;    /* if!=0, alternate black width        */
    SW16    alt_black_height;   /* if!=0, alternate black height       */

#if CONVERGENT_FONTS            /*   mby, 2/03/94 */
    UW16    awtsub_on;          /* = 1 if font substitution is enabled. */
#if (CONVERGENT_FONTS == 1)
    SW16    lsb_adj;            /* AWT can have optional horizontal adjustment */
#endif
#endif

    LPSB8    next_coord_data;

/*-----------------------------------*/
/*  Global Intellifont segment (100) */
/*    20-Mar-90  jfd                 */
/*      Added "glob_ital_tan" to end */
/*      of structure                 */
/*-----------------------------------*/
        UW16    orThreshold;    /* Pixel size threshold above which ON */
                                /* transitions may be OR-ed to bitmap. */

/*      I5.0            Face Identifier                               */

        UW16    if_flag;        /*  flag to indicate if intellifont   */
                                /*  data is present                   */  

/*      I5.1            Global Y Class Definition Data                */

        UW16    num_gylines;     /*  number of Y lines                 */
        LPUW16  gylines;         /*  single arr of Y class Y lines     */
        YCLASS_DEF glob_yclass;
                                /*  actual Y class definitions        */

/*      I5.2            Global Dimension Data                         */

        DIMENSION   glob_x_dim;
        DIMENSION   glob_y_dim;

/*      I5.3            Global Italic Angle Data                      */

        SW16    glob_ital_ang;

/*      I5.4.1          Global Standard Dimension Data                */

        UW16    stan_dim_lim;   /*  pix size above which standrd used */

        UW16    stan_STAN_dim_lim; /* size above which STAN stan used */

/*      I5.4.2          [Generic Screen] Face Substituion Data        */

        UW16    subst_wdth_fac; /*  width fac. to adjust subst face   */

        UW16    subst_cutin;    /*  width fac. to adjust subst face   */

        CGFIXED glob_ital_tan;  /*  tangent of angle in radians       */

} IF_STATE;


/*                         I F _ S T A T I C                           */
/*---------------------------------------------------------------------*/

/*---------------------------------------------------------------------*/
/*                 Function Prototypes                                 */

#ifdef LINT_ARGS

#if ((ELASTIC_Y) | (ELASTIC_X))
EXTERN VOID       pixel_align (SW16, PCOORD_DATA, UW16, UW16);
EXTERN VOID       sd_pixel_align (SW16, PCOORD_DATA, UW16, UW16);
#else
EXTERN VOID       pixel_align (SW16, PCOORD_DATA, UW16);
EXTERN VOID       sd_pixel_align (SW16, PCOORD_DATA, UW16);
#endif

EXTERN UW16   intel_char(VOID);

EXTERN SW16VECTOR  des2bm(SW16VECTOR);
EXTERN SW16VECTOR  inv_des2bm(SW16VECTOR);
#else     /* LINT_ARGS not defined */

EXTERN VOID       pixel_align ();
EXTERN VOID       sd_pixel_align ();

EXTERN UW16   intel_char();

EXTERN SW16VECTOR  des2bm();
EXTERN SW16VECTOR  inv_des2bm();
#endif
