; /* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/if_type.inc,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
; /* $Log: if_type.inc,v $
; /* Revision 1.4  2003/05/07 23:45:01  Lann
; /* Revision V1_00_04
; /* */
   
      Rev 1.3   02 Dec 1994 13:25:52   JOE
   
   Added missing comment delimiters ";" at start of file.
;     
;        Rev 1.2   14 Jan 1993 11:16:34   LISA
;     Removed CntrlZ character
;     
;        Rev 1.1   14 Dec 1992 08:45:10   LISA
;     Made change to Log keyword
;   
;     Rev 1.0   09 Dec 1992 11:38:00   LISA
;   Initial revision.
; /* $Date: 2003/05/07 23:45:01 $ */
;**********************************************************************
; if_type.inc                                                       
; -------------------------------------------------------------    
;
;  Copyright (C) 1991, 1992, all rights reserved, 
;  by Miles Inc., Agfa Division, Wilmington, MA.
; 
;  This software is furnished under a license and may be used and
;  copied only in accordance with the terms of such license and with
;  the inclusion of the above copyright notice. This software or any
;  other copies thereof may not be provided or otherwise made
;  available to any other person except as allowed under license. No
;  title to and ownership of the software is hereby transferred.
; 
;  This information in this software is subject to change without notice
;  and should not be construed as a commitment by Miles Inc., Agfa
;  Division.
; 
;*********************************************************************
;
; This module contains structures used by imath.asm. It is made up of
; information from 'cgif.h', 'if_type.h' and 'tr_type.h'.
;  
;*********************************************************************
; REVISION HISTORY
; ---------------------------------------------------------------------
; 16-FEB-91 dET original
; 17-Feb-91 dET added or_on and making_bold into STRUCT IF_DATA per 'C' code.
; 16-Jun-91 awr changed XY structure to WORDVECTOR
; 17-Sep-91 jfd changed xorigin and yorigin in IFBITMAP structure to
;               dd to match change in CGIF.H .
; 08-Nov-91 rs  Updated for Intellifont 3.0.
; 10-Mar-92 jfd Added "xlate" field to SCALE structure.
;               Added LONGVECTOR structure.
; 02-Apr-92 tbh Added diag_control_tol and margin to COORD_DATA
;               Added right_shift to SCALE
; 03-Apr-92 rs  Portability cleanup (see port.h).
; 27-Jul-92 jfd Added structures INTRVECTOR and INTRBOX.
;               In structure COORD_DATA, declared "grid_align" based on
;               INTR_SIZE.
;               In structure SCALE, declared "xlate" based on size of
;               INTRVECTOR and "tbound" based on size of INTRBOX.
; 02-Dec-94 jfd Added missing comment delimiters ";" at start of file.
;*********************************************************************
;
;---------------------------  FROM CGIF.H  ------------------------

DLL     struc
    f   dd ?    ;  /* forward pointer */
    b   dd ?    ;  /* backward pointer */
DLL     ends

IF INT_FP
FPNUM	struc
 n	dd ?	; normalized, signed mantissa
 e	dw ?	; exponent
FPNUM	ends
ELSE
FPNUM	struc
n	dq ?	; double type
FPNUM	ends
ENDIF

IFBITMAP        struc
 link           db (size DLL) DUP(?); /* doubly linked list pointers */
 notmru         dw ?    ; /* 0 if recently made most recently used */
 hiffont        dd ?    ; /* Font handle of owner of this IFBITMAP */
 index          dw ?    ; /* index to IFBITMAP in above IFFONT's tbl */

 bm_width       dw ?    ; /* bit map width (bytes)   */
 depth          dw ?    ; /*  "   "  depth (pixels) */
 left_indent    dw ?    ; 
 top_indent     dw ?    ; 
 black_width    dw ?    ;
 black_depth    dw ?    ;
 xorigin        dd ?    ; /*  (1/16th pixel)  */
 yorigin        dd ?    ; *  (1/16th pixel)  */
 escapement     dw ?    ; char body wid (1/16th pix)
 char_bm        dd ?    ; /* character bit map */
IFBITMAP        ends



;---------------------------  FROM IF_TYPE.H  ------------------------


SW16VECTOR struc 
    xx          dw ?
    yy          dw ?
SW16VECTOR ends


SL32VECTOR struc
    xxx         dd ?
    yyy         dd ?
SL32VECTOR ends


BOX struc
    ll          db (size SW16VECTOR) DUP(?)
    ur          db (size SW16VECTOR) DUP(?)
BOX ends 

IF INTR_SIZE EQ 16
INTRVECTOR struc 
    xxxx        dw ?
    yyyy        dw ?
INTRVECTOR ends
ELSE
INTRVECTOR struc 
    xxxx        dd ?
    yyyy        dd ?
INTRVECTOR ends
ENDIF

INTRBOX struc
    ll0          db (size INTRVECTOR) DUP(?)
    ur0          db (size INTRVECTOR) DUP(?)
INTRBOX ends 

COORD_DATA      struc
 orig_pixel     dw ?    ; /*  Original imprecise pixel size       */
 p_pixel        dw ?    ; /*  precise pixel - shifted so that     */
                        ; /*    16K <= p_size < 32K               */
 p_half_pix     dw ?    ; /*  half precise pixel                  */
 bin_places     dw ?    ; /*  bits after the binary point above   */
 round          dd 4 DUP(?);     /*  rounding value for 4 "R" types      */
 shut_off       dw ?    ; /*  value of "1-1/4" pixel shut-off     */
 con_size       dw ?    ; /*  min value for constrained dim       */
 diag_control_tol dw ?  ; /*  DWU tolerance for diag control  */

;  /* --------------- Elasticity ----------------------------------- */

IF ( (ELASTIC_Y) OR (ELASTIC_X))
 elastic_input  dw ?    ;  /*  elast to be inserted at each break  */
ENDIF

;  /* --------------- Standard Dimensions -------------------------- */

 stand_value    dw ?    ; /* Standard dimension in design units   */
 st_value       dw 4 DUP (?) ; /* These two arrays are results of      */
 st_pixels      dw 4 DUP (?) ; /* pixel_align() using all 4 R-types    */
 st_variation   dw 4 DUP (?) ; /* AMount stan dim rounds 11-29-90 tbh  */

;  /* --------------  Scaling to Output Space ---------------------- */

 pixel_size     dw ?    ; /*  pixel dimension (power of 2)        */
 half_pixel     dw ?    ; /*  half pixel dimension (power of 2)   */
IF INTR_SIZE EQ 32
 grid_align     dd ?    ; /*  x & grid_align is truncated to grid */
ELSE
 grid_align     dw ?    ; /*  x & grid_align is truncated to grid */
ENDIF
 grid_shift     dw ?    ; /*  x >> grid_shift is grid number      */
 shift          dw ?    ; /* 16 - bin_places - grid_shift         */
 shift_rnd      dw ?    ; /* 2 ** (shift - 1)                     */
 margin         dw ?    ; /* add to work sp coord to shift to     */
                        ; /* bitmap coordinate                    */
COORD_DATA ends
 
;/*  Values for quadrant field below.
; * A value of 0 means arbitrary rotation.
; */
ROT0    EQU	1
ROT90   EQU	2
ROT180  EQU	3
ROT270  EQU	4

 
SCALE  struc

  x             db (size COORD_DATA) DUP (?) ; x grid alignment & scaling
  y             db (size COORD_DATA) DUP (?) ; y grid alignment & scaling
  m		db (4 * size FPNUM) DUP (?)  ; matrix trnsfrm design to output
  tt            db (size SW16VECTOR) DUP (?) ;
  xlate         db (size INTRVECTOR) DUP (?) ;
  right_shift   dw ?    ;

  origBaseline  dw ?    ; /* Design units                        */
  aBaselnVal    dw ?    ; /* grid aligned baseline value (DU)    */
  bit_map_width dw ?    ; /* width of bitmap in SW16s               */
  tbound        db (size INTRBOX) DUP (?) ;/* bounding box in working bitmap space */
  quadrant      dw ?    ; /* 90 rotations: ROT0 ROT90 ROT180 ROT270 */
  or_on         dw ?    ; 1 if or on transitions, 0 otherwise
  wrong_read    dw ?    ; /* TRUE if wrong reading                  */
  quality       dw ?    ; /* quality level 1, 2 or 3                */
  making_bold   dw ?    ; 1 if psuedo bold, 0 otherwise
SCALE ends 



;-----------------------------  FROM TR_TYPE.H ---------------------- 
TRAN   struc
                                ;/* the current transform */
 num            dw ? 
 den            dw ?            ;
 old0           dw ?            ;
 new0           dw ?            ;/* adjusted coordinate values */
 half_den       dw ?            ;

; /*-------- above is locked for assembly language access */

 old1           dw ?            ;
 new1           dw ?            ;

 num_skel_loop  dd ?            ;/* Number of skeletal points in next loop */
 skel           dd ?            ;/*  ptr to original & adjusted values */
                                ;/*  of next segment end               */
 skel_to_contr  dd ?            ;/*  skel indices to contr             */

 nsk            dw ?            ;/* number of skels in current loop */

;    /* Current character */

 cend           dw ?            ;/* end vector number in scaling  segment */
 sct            dw ?            ;/* number of skels processed in current loop  */

;/* Values at the start of a loop. These values will also */
;/* be used at the end of the loop.                       */

 num0           dw ?            ;
 den0           dw ?            ;
 half_den0      dw ?            ;
 end0           dw ?            ;
 old00          dw ?            ;
 new00          dw ?            ;
TRAN  ends


