/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/ix.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: ix.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.46   27 Jul 1995 11:36:22   MIKE
 * Added "FCO_BUCK.matrixType" for othogonal rotation support
 * 
 *    Rev 1.45   22 Jun 1995 19:45:34   MIKE
 * Added FCO_BUCK.identityMatrix. Conditionally compiled BUCKET.p.xx
 * 
 *    Rev 1.44   01 Jun 1995 17:09:04   MIKE
 * Removed "fcoFontSh" from FCO_BUCK structure
 * 
 *    Rev 1.43   24 May 1995 19:03:54   MIKE
 * Added argument to declaration of fco_get_FontBBox()
 * 
 *    Rev 1.42   24 May 1995 18:43:04   MIKE
 * Added FCO_BUCK.oblMatrix[] for Convergent Fonts.
 * 
 *    Rev 1.41   07 Apr 1995 11:31:14   LISA
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.40   26 Feb 1995 14:35:14   JOE
 * In DISK version of INDEX_ENTRY structure, if WATCOM, added pad word
 * following "name_off" field to resolve alignment problem introduced
 * when NAT_ALIGN was changed from 2 to 4.
 * 
 *    Rev 1.39   10 Feb 1995 11:26:52   JOE
 * In FCO_BUCK structure, added fields ThinSpace, ENSpace and EMSpace.
 * 
 *    Rev 1.38   11 Dec 1994 17:20:42   MIKE
 * Changed CHAR_STATS.origin_cs from SW16VECTOR to SL32VECTOR
 * 
 *    Rev 1.37   14 Oct 1994 14:45:00   MIKE
 * Added orThreshold to FCO_BUCK.
 * 
 *    Rev 1.36   21 Sep 1994 18:14:30   MIKE
 * Added 'FONTCONTEXT fcoFC' to FCO_BUCK structure.
 * 
 *    Rev 1.35   13 Sep 1994 19:24:38   MIKE
 * Added FCO_BUCK.fcoFontSh for outline sharing.
 * 
 *    Rev 1.34   02 Sep 1994 12:49:58   MIKE
 * Added new items to FONTINDEX for FCO plugins.
 * 
 *    Rev 1.33   31 Aug 1994 17:44:02   MIKE
 * 
 * Added 'spaceBand', 'compositionFlag' to FCO_BUCK.
 * 
 *    Rev 1.32   03 Aug 1994 19:14:06   MIKE
 * Added FCO changes from 1.27.1.3
 * 
 *    Rev 1.31   22 Apr 1994 15:31:32   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.30   22 Mar 1994 09:55:16   JOE
 * In structure PS_BUCK, added fields hCOD_Offset and hCSA_Offset for
 * ASIAN ROM support.
 * 
 *    Rev 1.29   06 Mar 1994 12:50:38   MIKE
 * If CONVERGENT_FONTS == 1, use AWT4 format; if == 3, use AWT3 format.
 * 
 *    Rev 1.28   03 Feb 1994 11:57:08   MIKE
 * 
 * Changes to support italicized Convergent Fonts. AWT4.
 * 
 *    Rev 1.27   10 Jan 1994 15:40:14   MIKE
 * Changed AWT_ID to 'A' 'W' 'T' '3'
 * 
 *    Rev 1.26   01 Dec 1993 08:23:52   JOE
 * Changed KANJI_ENCODING to ASIAN_ENCODING.
 * 
 *    Rev 1.25   11 Oct 1993 12:47:18   MIKE
 * 
 * Added "scaleFactor" to AWT_TABLE struct. Added "FontBBox[4]" to TT_BUCK str
 * Added #defines CVF_NO_INDEX, CVF_REQU_FNT, CVF_SUBST_FNT.
 * 
 *    Rev 1.24   29 Sep 1993 11:37:00   JOE
 * Added field "FontBBox[4]" to PS_BUCK structure.
 * 
 *    Rev 1.23   23 Sep 1993 12:08:56   MIKE
 * Added BUCKET.usePlugins; restructured TT_BUCK; ifxxx() declaration cleanup.
 * 
 *    Rev 1.22   30 Aug 1993 10:50:12   MIKE
 * 
 * Changed AWT_ID to 'A' 'W' 'T' '2'.
 * 
 *    Rev 1.21   26 Aug 1993 10:31:18   MAIB
 * Added spotsize field to TT_BUCK struct 
 * 
 *    Rev 1.20   12 Aug 1993 10:07:54   MIKE
 * For CONVERGENT_FONTS: Added awtsub_on to FONTINDEX; reorganized AWT_TABLE.
 * 
 *    Rev 1.19   02 Aug 1993 09:08:30   JOE
 * 
 * In PS_BUCK structure, added field "ocharnames" to get to char names
 * data for PS ROM input.
 * 
 *    Rev 1.18   27 Jul 1993 13:11:22   AL
 * Non-zero winding changes
 * 
 *    Rev 1.17   15 Jul 1993 11:39:54   MIKE
 * Moved CONVERGENT_FONT #defines and AWT_TABLE structure here.
 * 
 *    Rev 1.16   15 Jul 1993 09:26:14   MIKE
 * Convergent font changes: added noTFS, plugintt_pix to FONTINDEX;
 * Used bit 6 in bucket_num for plugin font type.
 * 
 *    Rev 1.15   15 Jun 1993 11:55:48   ROB
 * Add entry to type 1 bucket 'hexascii', replaces global 'hexasciiflg'.
 * 
 *    Rev 1.14   14 Jun 1993 17:17:46   ROB
 * Type 1 encoding array support.
 * 
 *    Rev 1.13   08 Jun 1993 15:48:42   ROB
 * Changes for type 1 quality improvements and multimaster support.
 * 
 *    Rev 1.12   22 Apr 1993 10:58:06   MIKE
 * Remove rom_font_ptr from fontindex structure.
 * 
 *    Rev 1.11   15 Apr 1993 18:24:52   MIKE
 * Made changes for DYNAMIC_FONTS. Added "dynIFActive" flag to BUCKET.
 * Added "rom_font_ptr" and "dynix" to fontindex.
 * 
 *    Rev 1.10   06 Apr 1993 15:47:42   ROB
 * Change CHARBUFSIZE from 6000 to 8000 because 4 chars would not rasterize.
 * 
 *    Rev 1.9   31 Mar 1993 09:49:36   ROB
 * Conditionally make CHARBUF 6000 bytes if KANJI_ENCODING is enabled.
 * 
 *    Rev 1.8   29 Mar 1993 10:43:40   ROB
 * Change defines for Kanji support (KANJI_ENCODING).
 * 
 *    Rev 1.7   17 Mar 1993 18:06:28   ROB
 * Changes to support PostScript Kanji fonts (PS_BUCK).
 * 
 *    Rev 1.6   03 Mar 1993 19:32:48   ROB
 * Add 'StemSnapH[]' & 'StemSnapV[]' to 'PS_BUCK' for stem hint processing.
 * 
 *    Rev 1.5   05 Feb 1993 13:54:02   MIKE
 * dir ix
 * Ignore previous line
 * Added BBoxRes structure.
 * Added function prototypes for xxget_FontBBox()  (if FONTBBOX = 1).
 * 
 *    Rev 1.4   29 Jan 1993 08:58:16   JOE
 * Added em box size fields to CHAR_STATS structure.
 * 
 *    Rev 1.3   14 Jan 1993 11:13:58   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.2   15 Dec 1992 13:29:58   MIKE
 * No change.
 * 
 *    Rev 1.1   14 Dec 1992 08:45:36   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:38:24   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* ix.h */

/*  01-Apr-90  awr  Expanded SS_DIRECTORY to include pcleo info
 *  12-Apr-90  jfd  Added handles for Typeface Header and Font
 *                    Alias segments to BUCKET structure
 *  07-Jun-90  dah  Added input_filetype to INDEX_ENTRY and BUCKET structs.
 *  01-Jul-90  awr  Corrected comments, added bit flag definitions and
 *                  screen font definitions.
 *  15-Aug-90  awr  added BUCKET's handle to BUCKET structure.
 *  17-Sep-90  jfd  Changed CHARBUFSIZE from 2048 to 4096
 *  02-Jan-91  jfd  Added struct CHR_DEF_HDR
 *  02-Jan 91  ss   Added (ROM defined) lib_offset field to INDEX_ENTRY struct
 *                  Added lib_handle in BUCKET struct
 *                  Added EXPBUFSIZE for expansion buffer size only
 *  08-Jan-91  ss   Changed INDEX_ENTRY to union lib_offset with font_hdr and
 *                  Added pgif field to CHR_DEF for PCLEO_RDR
 *  09 Jan 91  ss   Added B_ISPCLEO, B_ISROM macros
 *  14-Jan-91  awr  Added font_hdr field and ssnum field to FONTINDEX
 *  24-Jan-91  awr  Changed INDEX_ENTRY structure (#if ROM) so that it
 *                  will be LONG-aligned.
 *  29-Jan-91  jfd  Added description for bits 8-9 of format field.
 *  31-Jan-91  dET  Add support for MSC multi-model compilation.
 *  23-Feb-91  awr  Changed bucket sub-segment handles to offsets.
 *  19-May-91  awr  Changed CHARBUFSIZE to 6000
 *  14 May 91  ss   Added support for new plugin scheme w/ 15 buckets
 *                   at 3 levels of limited sensitive
 *  19-May-91  awr  Changed CHARBUFSIZE to 6000
 *   3 Jun 91  ss   Added SLIM_FONTS mirror flags to CHR_DEF_HDR struct.
 *   5-Jun-91  jfd  Changed HUGE define to MSHUGE to avoid conflict 
 *                  w/Sun system define
 *                  (FIX FROM EARLIER VERSION)
 *   6-Jun-91  jfd  In macros CD_ISPCLEO and CD_ISROM, changed FILETYPE_MASK
 *                  to FC_FILETYPE_MASK
 *   5 Jun 91  ss   Added Fixed Pitch defines.
 *                  Deleted COMPRESS define, no longer needed.
 *  19 Jun 91  ss   Cleaned up defines not used. Added MIRROR mask defines.
 *                  Changed CHR_DEF element name from bucknum to
 *                  buck_search_lvl
 *  21 Jun 91  ss   Moved prototype for fgseg() to modules that actually
 *                  use it due to problem with prototypes on SUN3.
 *  24 Jun 91  ss   Changed PBYTE fontindex.pfnt_index to PUBYTE.
 *                  Changed PBYTE bucket.plibfont to PUBYTE.
 *   4-Jul-91  awr  changed types in CHR_DEF to WORDVECTOR
 *  10 Aug 91  ss   Changed CHR_DEF_HDR.mirror flags to one word.
 *                  Added and corrected defines for CHR_DEF_HDR.mirror_flags.
 *  16 Sep 91  ss   Added font_hdr field in CHR_DEF_HDR for PCLEO_RDR and disk
 *   1 Oct 91  ss   Made EXPBUFSIZE larger.
 *   7 Oct 91  jfd  Changed typedef statements for PCHR_DEF and PCHR_DEF_HDR
 *                  to "... FARPTR * ... ".
 *  01-Nov-91  jfd  Changed CHARBUFSIZE to from 6000 to 4096.
 *   7 Nov 91  ss   Conditionally compiled EXPBUFSIZE cuz SUN seems to need
 *                  a bigger buffer.
 *   3-Jan-92  awr  Removed font_open field from BUCKET
 *   8-Jan-92  rs   Modify BUCKET for the unions (ps, tt, if).
 *  13-Jan-92  rs   Add ptr to charstring to PS_BUCK when char is selected.
 *                  Stored in 'VOID *pthis_charstring'. Add 'fontmatrix[6]'
 *                  to PS_BUCK.
 *  14-Jan-92  rs   Add 'CHAR_STATS' struct definition.
 *  22-Jan-92  rs   Set up 'IF_FUNC_TBL' & 'IF_RAS_TBL' structures to call
 *                  font + rasterizer functions through ptrs.
 *  23-Jan-92  rs   Add 'overshoot' to ps bucket.
 *  28-Jan-92  rs   Add 'PIF_FUNC_TBL pft' to external font bucket.
 *  22-Jan-92  mby  Defined TT_BUCK structure.
 *  31-Jan-92  mby  Added emResolution to TT_BUCK.
 *  06-Feb-92  rs   Add 'last_seek', 'last_key' & 'curr_char' to 'ps_buck'.
 *  10-Feb-92  awr  Added "locked" field to BUCKET structure.
 *  26-Feb-92  bg   Changed EXPBUFSIZE (ifndef SUN) from 700 to 2096
 *                  (4096 - 2000).
 *   4 Mar 92  ss   Added !LINT_ARGS prototypes for functions in structs
 *                  IF_FUNC_TBL and IF_RAS_TBL.
 *   7-Mar-92  awr  added compound character design unit bounding box
 *                  to if_state.
 *   8-Mar-92  awr  added has_path field to BUCKET
 *  13-Mar-92  rs   Change 'last_key' in PS_BUCK from ULONG to UWORD
 *  17-Mar-92  mby  declared elements of TT_BUCK as MEM_HANDLE instead of
 *                  pointers.
 *  02-Apr-92  rs   Portability cleanup (see port.h).
 *  06-Apr-92  rs   Change 'FIXED_PITCH' to 'CGFIXED_PITCH' (portability).
 *  20-Apr-92  awr  Added pix_bound field to CHR_DEF structure
 *  11 May 92  ss   Changed FONTINDEX.small_plugins to plugin_set to use
 *                  as a flag for different plugin sets that can be loaded
 *                  in addition to the small_plugin set.
 *  21-May-92  jfd  Added prototypes for outline functions to support
 *                  function table.
 *                  Changed function prototype for bmras_start_char()
 *                  and _olstartchar() so that argument is PVOID.
 *  21 May 92  ss   Cleaned up references to Letter Gothic to implement
 *                  the plugins now available.
 *  29 May 92  jfd  Disabled old "CHAR_STATS" structure. Replaced with
 *                  "CHAR_STATS" which is combination of old CHAR_STATS 
 *                  and OLSTATS.
 *  17-Jun-92  awr  Changed CHAR_STATS.olbox to an INTRBOX type
 *  24-Jun-92  mby  Modified TT_BUCK structure for PCLEO support
 *   6-Jul-92  jfd  Added "get_width" to IF_FUNC_TBL structure.
 *   6-Jul-92  mby  Removed GlobalTTPtr from TT_BUCK structure.
 *  21-Jul-92  awr  Conditional compile changes.
 *  16-Aug-92  rs   Fix typo for 'USE_UFST_MAPPING'.
 *  23-Sep-92  awr  Added "platID" & "specID" to TT_BUCK.
 *                  Removed media in FONTINDEX and BUCKET
 *                  Changed CHR_DEF.buck_search_lvl to int.
 *                  Changed FONTINDEX.num_searches to int.
 *                  Added font_type field in FONTCONTEXT and BUCKET
 *  14-Oct-92  awr  Added cur_ssnum filed to BUCKET
 *  15-Oct-92  mby  Added "FONTCONTEXT TTfc" to TT_BUCK.
 *  25-Jan-93  jfd  Added fields "du_emx" and "du_emy" to CHAR_STATS 
 *                  structure
 *  04-Feb-93  mby  Added BBoxRes structure. Added get_FontBBox() function
 *                  prototype declarations (FONTBBOX must be set)
 *  02-Mar-93  rs   Add StemSnapV[] & StemSnapH[] to PS_BUCK.
 *  15-Mar-93  rs   Modify PS_BUCK for type 0 fonts.
 *  27-Mar-93  rs   Add define for 'KANJI_ENCODING'.
 *  30-Mar-93  rs   Make CHARBUFSIZE 6000 if 'KANJI_ENCODING'.
 *  06-Apr-93  rs   Make CHARBUFSIZE 8000 if 'KANJI_ENCODING' (there were
 *                  still 4 chars which could not rasterize).
 *  12-Apr-93  mby  Changes for DYNAMIC_FONTS. Added "dynIFActive" flag to
 *                  BUCKET. Added "rom_font_ptr" and "dynix" to fontindex.
 *  21-Apr-93  mby  Remove rom_font_ptr from fontindex structure.
 *  14-May-93  rs   Pipeline upgrade - type 1 quality improvements.
 *  03-Jun-93  jfd  In PS_BUCK struct, changed conditional compile statement
 *                  for hencodearray to "#if !USE_UFST_MAPPING || 
 *                  (USE_UFST_MAPPING == 2)"
 *  06-Jun-93  rs   MultiMaster support 'T1MMASTER'.
 *  15-Jun-93  rs   Add 'hexascii' to type 1 bucket.
 *  12-Jul-93  mby  Added noTFS to FONTINDEX for CONVERGENT_FONTS.
 *                  Added plugintt_pix to FONTINDEX for TT_PLUG_IF.
 *                  Use bit 6 in bucket_num (MULTIFORMAT only). UFST uses
 *                  this to decide if plugin font type is IF or TT. 
 *  15-Jul-93  mby  Moved CONVERGENT_FONT #defines and AWT_TABLE structure
 *                  into this module.
 *  23-Jul-93  awr  Added tran_run_ct field to CHAR_STATS structure to
 *                  support non-zero winding bitmap fill
 *  02-Aug-93  jfd  In PS_BUCK structure, added field "ocharnames" (offset
 *                  to char names table) based on PST1_ROM.
 *  12-Aug-93  mby  Added 'awtsub_on' to FONTINDEX structure for CONVERGENT_FONTS.
 *                  Reorganized AWT_TABLE structure.
 *  26-Aug-93 maib  Added spotsize field to TT_BUCK struct.
 *  26-Aug-93  mby  Changed AWT_ID to 'A' 'W' 'T' '2'.
 *  23-Sep-93  mby  Replaced fontHndl by diskHndl & ROMHndl in TT_BUCK.
 *                  Put conditional compiles in TT_BUCK; added ROM1 support.
 *                  Added BUCKET.usePlugins.
 *                  Made ifxxx() function declarations conditional on IF_RDR.
 *  29-Sep-93  jfd  Added field "FontBBox[4]" to PS_BUCK structure.
 *  01-Oct-93  mby  Added "scaleFactor" to AWT_TABLE structure.
 *                  Added FontBBox[4] to TT_BUCK.
 *  05-Oct-93  mby  Added #defines CVF_NO_INDEX, CVF_REQU_FNT, CVF_SUBST_FNT
 *  01-Dec-93  jfd  Changed KANJI_ENCODING to ASIAN_ENCODING.
 *  06-Jan-94  mby  Changed AWT_ID to 'A' 'W' 'T' '3'.
 *  03-Feb-94  mby  Convergent font changes. 'AWT3' -> 'AWT4'. Moved awtsub_on
 *                  to IF_STATE (see if_type.h). Added font italic angle,
 *                  horizontal offset data, and prohibit italic information
 *                  to AWT_TABLE structure.
 *  06-Mar-94  mby  Convergent fonts: Build UFST to use either AWT3 or AWT4
 *                  format. AWT_ID -> AWT_ID3 and AWT_ID4. Part of AWT_TABLE
 *                  is conditionally compiled.
 *  22-Mar-94  jfd  In structure PS_BUCK, added fields hCOD_Offset and
 *                  hCSA_Offset for ASIAN ROM support.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 * FCO Changes from 1.27.1.3:
 *  14-Mar-94  mby  Added function prototypes for pointer callable "fco_"
 *                   UFST functions - fco_load_font, etc.
 *                  Added FCO_BUCK structure inside BUCKET.
 *                  Added FCObject to FONTINDEX structure.
 *  26-May-94  mby  Removed FCObject from FONTINDEX. It's now in IF_STATE.
 *  03-Jun-94  mby  Added 'design_EmRes' to FCO_BUCK.
 *  03-Aug-94  mby  Added 'fcoChar' and 'charCloseFlag' to FCO_BUCK.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *  31-Aug-94  mby  Added 'spaceBand' and 'compositionFlag' to FCO_BUCK.
 *  02-Sep-94  mby  Added fcoSearchPath_on, fcoSearchPath, fcoPlugHndl to
 *                  FONTINDEX. They're used in BUCKfind().
 *  13-Sep-94  mby  For outline sharing, added MEM_HANDLE fcoFontSh to FCO_BUCK.
 *  21-Sep-94  mby  Added 'FONTCONTEXT fcoFC' to FCO_BUCK structure.
 *  13-Oct-94  mby  Added 'orThreshold' to FCO_BUCK.
 *  11-Dec-94  mby  Changed SW16VECTOR CHAR_STATS.origin to
 *                  SL32VECTOR CHAR_STATS.origin_cs to fix 16-bit origin
 *                  overflow at very large sizes.
 *  09-Feb-95  jfd  In FCO_BUCK structure, added fields ThinSpace, ENSpace
 *                  and EMSpace.
 *  26-Feb-95  jfd  In DISK version of INDEX_ENTRY structure, if WATCOM,
 *                  added pad word following "name_off" field to resolve
 *                  alignment problem introduced when NAT_ALIGN was
 *                  changed from 2 to 4 for WATCOM.
 *  24-May-95  mby  Added FCO_BUCK.oblMatrix[] obliqued transformation matrix
 *                  for Convergent Fonts. Added FCO_BUCK.xbold, ybold
 *                  for experimental pseudobold.
 *  23-May-95  mby  Add argument to declaration of fco_get_FontBBox().
 *  01-Jun-95  mby  Removed "fcoFontSh" from FCO_BUCK structure.
 *  14-Jun-95  mby  Added FCO_BUCK.identityMatrix. In BUCKET.p union,
 *                  conditionally compiled, "in", "ps", "tt", "fco".
 *  26-Jul-95  mby  Added 'FCO_BUCK.matrixType' for orthogonal rotation support.
 */

#define MAX_CC_PARTS  10    /* maximum number of parts in a compound ch. */

#if ASIAN_ENCODING   /* add 3/30/93 - rs */
#define CHARBUFSIZE  8000   /* character buffer size */
#else
#define CHARBUFSIZE  4096   /* character buffer size */
#endif

#ifdef SUN
#define EXPBUFSIZE   2048  /* expansion buffer size, chg'd size -ss 11/7/91 */
#else
#define EXPBUFSIZE   2096  /* expansion buffer size, changed size -bg 02/26/92 */
#endif

/* Bucket Types */
#define  TF_SENSITIVE    0      /* Always the first bucket in icur_index */
#define  CREATE_BUCKET   0      /* Argument for BUCKfind()               */
#define  PURGE_BUCKET    1      /*    "      "      "                    */

/*  Typeface number definitions for generic screen faces and plugin faces */
#define FACE_S_SCR       5500L  /* serif screen font                     */
#define FACE_SS_SCR      5501L  /* sans serif screen font                */


/*--------------------------------*/
/*       font index entry         */
/*--------------------------------*/

/*  Definitions and macros for the file type bits within bucket_num   */

#define EXTERN_TYPE    0x0400   /* External vs. Internal              */
#define ROM_TYPE       0x0800   /* ROM based file vs. Disk            */

#define FILEORG_MASK   0x3000   /* file org bits                      */
#define D_LIB          0x0000   /* "D" standard typeface library      */
#define S_LIB          0x1000   /* "S" slim library                   */
#define U_LIB          0x2000   /* "U" ultraslim library              */

/* These macros can be used for both INDEX_ENTRY & BUCKET bucket_num fields */

#define B_ISROM(b)   ((b)->bucket_num & ROM_TYPE)
#define B_ISEXTERN(b) ((b)->bucket_num & EXTERN_TYPE)


#if 0
            never referenced
#define B_D_LIB(b)   (( (b)->bucket_num & FILEORG_MASK ) == D_LIB)
#define B_S_LIB(b)   (( (b)->bucket_num & FILEORG_MASK ) == S_LIB)
#endif

#define B_U_LIB(b)   (( (b)->bucket_num & FILEORG_MASK ) == U_LIB)

#define B_LS_MASK       0x0007     /* low 3 bits of bucket_num is lim sens */
#define B_BOLD          0x0001
#define B_SANS_SERIF    0x0002
#define B_ITALIC        0x0004

#if CGFIXED_PITCH                       /* added  -ss 6/5/91    */
#define NFP_BUCKET_LEVELS    3
#define B_FP_PLUGIN_MASK     0x0038   /* 3 fixed pitch bits in IX.bucknum */
#define B_FIXED_PITCH        0x0008   /* FP, no plugins                   */
#define B_COURIER            0x0010   /* courier plugins                  */
#define B_LETTER_GOTHIC      0x0020   /* letter gothic plugins            */

#define COURIER_WIDTH        5291
#define LETTER_GOTHIC_WIDTH  4409
#define B_ISFPITCH(b) ((b)->bucket_num & B_FP_PLUGIN_MASK )
#endif

#define B_PLUGIN_TYPE_TT     0x0040   /* for MULTIFORMAT in cgconfig.h */

#if ROM
typedef struct
{
    SL32    tfnum;        /* typeface number                          */
    UL32   fhoff;        /* offset in library file for face header   */
   union {
      UL32  lib_offset;  /* offset to appropriate lib within a font block  */
      LPUB8 font_hdr;    /*  Used for PCLEO - pointer to font header       */
   } p_r;  /* pcleo-rom pointers to beginning of lib or pcleo data          */

    UW16   fhcount;      /* BYTE count of face header                */
    SW16    bucket_num;   /* Bit flags
                           *
                           * Bit 15      Compressed Library Flag
                           *  Value:
                           *    0    Normal library file
                           *    1    Compressed library file
                           *
                           * Bit 10  Internal / External flag
                           *
                           *    0    (0x0000)  Internal font
                           *    1    (0x0400)  PCLEO (external) font
                           *
                           * Bit 11  Physical media for internal fonts
                           *
                           *    0    (0x0000)  Disk based
                           *    1    (0x0800)  ROM based
                           *
                           * Bits 12-13  Font data organization
                           *
                           *    0    (0x0000)  "D" standard library file
                           *    1    (0x1000)  "S" slim font library
                           *    2    (0x2000)  "U" ultra-slim font library
                           *
                           * Bits 9-7    Reserved
                           *
                           * Bit 6   Used only #if MULTIFORMAT = 1
                           *    0      Use IF compatible plugins
                           *    1      Use TT compatible plugins
                           *
                           * Bits 5-3    Fixed Pitch plugin description
                           *   Value   Meaning
                           * (3 bits)
                           *    000     Proportional
                           *  >0 is a fixed pitch typeface
                           *    001     no plugins, all chars in TFS
                           *    010     Courier plugins, pitch =
                           *    100     Letter Gothic plugins, pitch =
                           *
                           *
                           * Bits 2-0  Typeface characteristics
                           *      bit/value    0           1     
                           *       0         normal      bold
                           *       1         serif       sans-serif
                           *       2         non-italic  italic
                           *
                           */
} INDEX_ENTRY;
#else
typedef struct
{
    SL32    tfnum;        /* typeface number                          */
    UW16   name_off;     /* offset to full path name of library file */
#if defined(__WATCOMC__)
    UW16   watpad;       /* pad word for WATCOM only */
#endif
    UL32   fhoff;        /* offset in library file for face header   */
    UW16   fhcount;      /* BYTE count of face header                */
    SW16    bucket_num;   /* Bit flags 
                           *   SAME AS bucket_num description ABOVE.  */
} INDEX_ENTRY;
#endif

typedef INDEX_ENTRY FARPTR * PINDEX_ENTRY;


/*--------------------------------*/
/*     FONTINDEX                  */
/*--------------------------------*/

/*  Defines for Limited Sensitive Buckets                                 */
#define NPSW_FACES           8     /* # of posture/serif/weight LS faces  */
#define NSW_FACES            4     /* # of serif/weight LS faces          */
#define NW_FACES             2     /* # of weight only LS faces           */

#if SLIM_FONTS
#define NBUCKET_LEVELS       5
#define NMAX_PLUGINS        15     /* 14 lim sensitive, universal         */

#define MIRROR_MASK          0x7000
#define ROT90_MASK           (0x1000 >> 12)
#define MIRROR_X_MASK        (0x2000 >> 12)
#define MIRROR_Y_MASK        (0x4000 >> 12)
#define NPARTS_MASK          0x07FF
                                  /* shift over to fit in a byte -ss 8/12/91*/
#define MIRROR_FLAGS( num_parts )  ( (num_parts & MIRROR_MASK) >> 12 )
#define NUM_PARTS( num_parts )     (  num_parts & NPARTS_MASK )

/* defines for mirror flag mapping used in comp_pix.c                     */
#define MIRROR_ROT0          0
#define MIRROR_ROT90         1
#define MIRROR_ROT180        6
#define MIRROR_ROT270        7
#define MIRROR_NEGROT0       2
#define MIRROR_NEGROT90      3
#define MIRROR_NEGROT180     4
#define MIRROR_NEGROT270     5
#else
#define NBUCKET_LEVELS       3
#define NMAX_PLUGINS         5     /* 4 lim sensitive, universal          */
#endif  /* SLIM_FONTS  */

#if CGFIXED_PITCH
#define NFP_PLUGINS          3 /* exact # of plugins for each FP typeface */
#endif
#if FCO_RDR
#define FCO_NPLUGIN_LEVELS   4
#endif

typedef struct
{
#if ROM
    LPUB8       pfnt_index;      /* pointer: font index buffer            */
#else
    MEM_HANDLE  hfnt_index;      /* handle font index buffer              */
#endif

    SW16        entry_ct;        /* number of entries in index            */
    UW16        olibnames;       /* path names of library files in index  */

  /*  The current typeface. */

    int         font_type;       /*  FONTCONTEXT format filed bits 10-13   */
    LPUB8       cur_font_hdr;    /* current pcleo header                 */
    UW16        cur_ssnum;       /* current symbol set number            */
    SL32        cur_tf_num;      /* current type face number             */
    PINDEX_ENTRY cur_pix;        /* TFS INDEX_ENTRY                      */
    int         has_path;
    PATHNAME    pathname;
#if DYNAMIC_FONTS
    INDEX_ENTRY dynix;           /* passes info for dynamically loaded IF */
#endif

#if PLUGINS
    int         plug_type;
#endif

    PINDEX_ENTRY pix;            /* INDEX_ENTRY for search level */
    int          num_searches;   /* # searches possible. TFS + LS + U      */
                                 /* PS,TT have an extra level for core.    */

    UW16        icur_index[NBUCKET_LEVELS]; /* Indexes to the buckets of the
                                             * current typeface.
                                             */
                                   /*  indexes of plugin INDEX_ENTRY's    */
    UW16        iplugin[NMAX_PLUGINS]; 
    BOOLEAN     plugin_set;       /*  Describes the set of plugins loaded.
                                   *  #defines given in ix.c
                                   */
#if SCREEN_FONTS
    UW16        screen_fnt_ct;    /*  Number of Generic screen fonts
                                   *  installed. Must be 2 to enable screen
                                   *  font substitution
                                   */
#endif

#if CGFIXED_PITCH
    UW16        courier_iplugin[ NFP_PLUGINS ];  /*  Courier plugins     */
    UW16        lgothic_iplugin[ NFP_PLUGINS ];  /* LetterGothic plugins */
#endif

#if (NON_IF_FONT)
    int icore[8];     /* font index indices to core fonts. This arrary is
                       *  parallel to core_list[] in ix.c. It is used to
                       *  substitute the core 8 for PS and TT.
                       */
#endif

#if CONVERGENT_FONTS
    UW16  noTFS;      /* Tells bucket search that there is no TFS level. */
#endif
#if TT_TTPLUG_IF      /* Saves plugin-TT index when TT plugin is IF. */
    PINDEX_ENTRY plugintt_pix;
#endif

#if FCO_RDR
    int   fcoSearchPath_on;    /* if 0, must call fco_pluginSearchPath() */
    UB8   fcoSearchPath[FCO_NPLUGIN_LEVELS];  /* indices of plugin faces */
    MEM_HANDLE  fcoPlugHndl;   /* handle to FCO for plugin faces */
#endif

} FONTINDEX;
typedef FONTINDEX FARPTR * PFONTINDEX;

typedef MEM_HANDLE HBUCKET;

/*-------------------------------*/
/*    union stuff                */
/*-------------------------------*/

typedef  LPSB8  PFONT_DES; /* ptr to font path name */

#define MAXSTEMS    12    /* from the White Book */
#define BOTBLUES    12    /* from the White Book */
#define TOPBLUES    12    /* from the White Book */
#define MAXWEIGHTS  16    /* from Pipeline */
#define MAXAXES      4    /* four design axes */

typedef struct {
#if (!USE_UFST_MAPPING) || (USE_UFST_MAPPING == 2)
/* only enable for non-UFST (ie PostScript encoding) - 5/22/92 - rs */
   MEM_HANDLE  hencodearray;
#endif
#if (ASIAN_ENCODING)
   MEM_HANDLE  hCODarray;
#if PST1_ROM
   MEM_HANDLE  hCOD_Offset;
   MEM_HANDLE  hCSA_Offset;
#endif  /* PST1_ROM */
#endif  /* ASIAN_ENCODING */
#if PST1_ROM
   UL32        ocharnames;   /* offset to char names table inside PS ROM block */
                             /*   7-27-93 jfd */
#endif
   MEM_HANDLE  hcharstrings;
   MEM_HANDLE  hsubrs;
   SW16 nsubs;       /* number of subs */
   SW16 n_chars;     /* number of chars in font */
   SW16 curr_char;   /* next char to read from font */
   SW16 StdHW;
   SW16 StdVW;
   SW16 lenIV;
   SW16 inStdHW;
   SW16 inStdVW;
   SW16 numStemSnapH;
   SW16 numStemSnapV;
   SW16 StemSnapH[MAXSTEMS];     /* add 3/2/93 - rs */
   SW16 StemSnapV[MAXSTEMS];     /* add 3/2/93 - rs */
   SL32 bot_refs[BOTBLUES / 2];
   SL32 top_refs[TOPBLUES / 2];
   SL32 stem_refh[MAXSTEMS * 3]; /* 4-May-93 upgrade - rs */
   SL32 stem_refv[MAXSTEMS * 3]; /* 4-May-93 upgrade - rs */
   SL32 t1xtrans;
   SL32 t1ytrans;
   SL32 t1auxxtrans;             /* 4-May-93 upgrade - rs */
   SL32 t1auxytrans;             /* 4-May-93 upgrade - rs */
   SW16 numbblues;
   SW16 numtblues;
   SW16 bot_blues[BOTBLUES];
   SW16 top_blues[TOPBLUES];
   SL32 Transform[4];
   SL32 iBlueScale;
   SW16 useblues;               /* !0 -> use BlueScale and BlueShift */
   SW16 iBlueShift;
   SW16 BlueFuzz;                /* 4-May-93 upgrade - rs */
   SW16 trans;
   SW16 overshoot;               /* suppress overshoots < this amount */
   SW16 stem_min;                /* 4-May-93 upgrade - rs */
   SW16 stem_adjust;             /* 4-May-93 upgrade - rs */
   SW16 stem_match;              /* 4-May-93 upgrade - rs */
   SW16 hint_gravity;            /* 4-May-93 upgrade - rs */
   SW16 FontBBox[4];             /* 28-Sep-93 jfd         */
#if (T1MMASTER )
   SW16 MMnaxes;                 /* 6/6/93 - rs */
   SW16 Weightvals;              /* 4-May-93 upgrade - rs */
   SL32 weights[MAXWEIGHTS];     /* excess 16 fixed - 4-May-93 upgrade - rs */
   SW16 MMnstdvw;                /* 6/6/93 - rs */
   SW16 MMstdvw[MAXAXES];        /* 6/6/93 - rs */
   SW16 MMnstdhw;                /* 6/6/93 - rs */
   SW16 MMstdhw[MAXAXES];        /* 6/6/93 - rs */
   SW16 MMnblendmap;             /* 6/6/93 - rs */
   MEM_HANDLE hMMblendmap;       /* 6/6/93 - rs */
   SW16 MMnblues;                /* 6/6/93 - rs */
   MEM_HANDLE hMMblues;          /* 6/6/93 - rs */
   SW16 MMnotherblues;           /* 6/6/93 - rs */
   MEM_HANDLE hMMotherblues;     /* 6/6/93 - rs */
#endif /* T1MMASTER */
   FPNUM fontmatrix[6];          /* from original font */
#ifdef LINT_ARGS
   VOID (*transptr) (SL32, SL32, LPSL32, LPSL32);
#else
   VOID (*transptr) ();
#endif /* LINT_ARGS */
/*
Info stored by 'psset_char()'
NOTE: Memory WARANTEED NOT TO MOVE BETWEEN 'set_char()' & 'make_gaso...()'!
PCDATASTR not defined up to here, use VOID for now & fix later
*/
   VOID  *pthis_charstring;/* PCDATASTR - ptr to this charstring */
   long   last_seek;/* last position seeked to */
   UW16 last_key; /* last decryption key UL32 to UW16 3/13/92 rs*/
   UW16 hexascii; /* 0 - binary, 1 - hex ascii */
} PS_BUCK;
typedef PS_BUCK FARPTR *PPS_BUCK;

typedef struct {
  /*  character directory  (face header segment) */

    LPSB8          pface_header_seg;
    MEM_HANDLE     hface_header_seg;
    UW16          ch_count;             /* Number of characters */

  /*  FACE GLOBAL SEGMENT.  Subsegments are broken out by offsets
   *  from start of face global segment and size in bytes
   */

    LPSB8      pfgseg;           /* Pointer to face global segment */
    MEM_HANDLE hfgseg;           /* Handle of    "     "      "    */
    UW16      sfgseg;             
    UW16      ogif;              /* Global Intellifont segment */
    UW16      gifct;
    UW16      otrack_kern_seg;   /* track kerning              */
    UW16      strack_kern_seg;
    UW16      otext_kern_seg;    /* text kerning               */
    UW16      stext_kern_seg;
    UW16      odesign_kern_seg;  /* designer kerning           */
    UW16      sdesign_kern_seg;
    UW16      owidth_seg;        /* character width segment    */
    UW16      swidth_seg;
    UW16      oattribute;        /* Attribute header           */
    UW16      sattribute;
    UW16      orast;             /* Raster parameter           */
    UW16      srast;
    UW16      otf_header_seg;    /* Typeface Header segment    */
    UW16      stf_header_seg;
    UW16      ocompound_seg;     /* Compound character         */
    UW16      scompound_seg;
    UW16      odisplay;          /* Display header             */
    UW16      sdisplay;
    UW16      ofont_alias_seg;   /* Font Alias segment         */
    UW16      sfont_alias_seg;
    UW16      ocopy;             /* Copyright notice           */
    UW16      scopy;

#if ROM
    LPUB8      plibfont;         /* "pointer" to lib in font block */
#endif
} IF_BUCK;

#define TT_PLUGPLID  3           /* platformID default for TT plugin   */
#define TT_PLUGSPID  1           /* specificID default for TT plugin   */
                                 /*   Microsoft Unicode, UGL           */
typedef struct {
    MEM_HANDLE buffInfo;         /* fs_GlyphInfoType structure         */
    MEM_HANDLE buffInput;        /* fs_GlyphInputType structure        */
    MEM_HANDLE trMatrix;         /* 3x3 transformation matrix          */
    MEM_HANDLE GlobalTTHndl;     /* memory handle for global TT data   */
#if TT_DISK
    LPUB8      diskHndl;         /* file pointer to disk font file     */
#endif
#if  (TT_ROM || TT_ROM1)
    LPUB8      ROMHndl;          /* pointer to font data in ROM        */
#endif
#if TT_PCLEOI
    LPUB8      baseGlyphPtr;     /* PCLEO: saves ptr to glyph data     */
    UW16       baseGlyphID;      /* Distinguishes comp char ID from components */
    UW16       baseGlyphLen;     /* Size of glyph data                 */
#endif
#if  (TT_ROM || TT_DISK || TT_ROM1)
    UL32       glyphTableOffset; /* offset to glyph table in disk/ROM font */
    UL32       glyphTableSize;   /* size of glyph table in disk/ROM font */
#endif
    UL32       GlobalTTSize;     /* size of global font data           */
    UW16       platId;           /* platform id (for character mapping)*/
    UW16       specId;           /* specific id   "      "        "    */
    CGFIXED    spotsize;
#if FONTBBOX
    SW16       FontBBox[4];      /* xmin,ymin,xmax,ymax   10-01-93 mby */
    UW16       emResolution;     /* font resolution in design units    */
#endif  /* FONTBBOX */
#if TT_TTPLUG
    FONTCONTEXT  TTfc;           /* FC for each TrueType font          */
#endif
#if TT_ROM1
    UW16       entity1;
    LPUB8      hPtr;
    UW16       first_code;
    UW16       last_code;
#endif
} TT_BUCK;

#if FCO_RDR
typedef struct {
    MEM_HANDLE fcoFont;          /* Handle to FONTTYPE object */
    MEM_HANDLE fcoChar;          /* Handle to CHARTYPE object */
    MEM_HANDLE fcoTrans;         /* Handle to PIXEL_DATA object (x and y) */
    SL32       tMatrix[4];       /* Transformation matrix     */
    UW16       matrixType;       /* identity, orthogonal, or arbitrary */
    SL32       oblMatrix[4];     /* Obliqued matrix for Convergent Fonts */
    UW16       design_EmRes;     /* Design unit resolution per em */
    UW16       spaceBand;        /* Width of spaceband in design units */
    UW16       unicode;          /* Unicode of current character */
    UW16       orThreshold;      /* orThreshold from TTFONTINFOTYPE  */
   FONTCONTEXT fcoFC;            /* Save fontcontext of each bucket. */
    SB8        compositionFlag;  /* 0=IF compatible; 1=TT compatible */
    SB8        charCloseFlag;    /* Tells us if FCcharNew() has been called but not FCcharClose() */
    UW16       ThinSpace;        /* Width of Thin space in design units */
    UW16       ENSpace;          /* Width of EN space in design units */
    UW16       EMSpace;          /* Width of EM space in design units */
#ifdef PSEUDO_BOLD_FCO
    SW16       xbold;
    SW16       ybold;
#endif
}  FCO_BUCK;
#endif


/*--------------------------------*/
/*     BUCKET                     */
/*--------------------------------*/

typedef struct
{
    DLL       link;
    HBUCKET   my_handle;      /* memory handle of this structure */
    BOOLEAN   locked;         /* BUFalloc() can't free if locked */
    SW16      bucket_num;     /* See INDEX_ENTRY.bucket_num. Used
                               * by IF_RDR, TT_IFPLUG, PS_IFPLUG */
    SL32      tfnum;          /* Typeface number                 */
    int       fh;             /* File handle, -1 if no open file */
    UW16      cur_ssnum;      /* current symbol set number       */
    UW16      usePlugins;     /* 1 = character set Augmentation with buckets;
                               * 0 = no plugins                  */
    int       font_type;      /* FONTCONTEXT format field bits 10-13  */
    int       rom_font;       /* FC_ROM_TYPE bit                 */
    BOOLEAN   extern_font;    /* FC_EXTERN_TYPE bit              */
    UW16      fst_type;       /* FC_IF_TYPE    0x0000  Intellifont
                               * FC_PST1_TYPE  0x1000  PostScript Type 1
                               * FC_TT_TYPE    0x2000  TrueType
                               * FC_FCO_TYPE   0x3000  MicroType */
    LPUB8     cur_font_hdr;   /* current pcleo header              */
    BOOLEAN   has_path;       /* Use pathname to identify the font */
    PATHNAME  pathname;
#if DYNAMIC_FONTS
    int       dynIFActive;    /* Dynamic font (Intellifont)      */
#endif

    VOID     *pft;            /* ptr to struct of functions to handle font */

    union {                   /* FST specific */
#if PST1_RDR
        PS_BUCK  ps;
#endif
#if IF_RDR
        IF_BUCK  in;
#endif
#if TT_RDR
        TT_BUCK  tt;
#endif
#if FCO_RDR
        FCO_BUCK fco;
#endif
    } p;
} BUCKET;
typedef BUCKET FARPTR * PBUCKET;
typedef BUCKET FARPTR * FARPTR * PPBUCKET;





/*------------------------------*/
/*   Per Character Definition   */
/*------------------------------*/

typedef struct
{
     SW16VECTOR origin;
     SW16VECTOR escape;

     SW16    num_parts;      /* number of parts in the character    */
     BOOLEAN is_compound;    /*  Flag this character as compound    */
#if SLIM_FONTS
     UB8   mirror_flags;   /* flags from num_parts to describe mirroring */
#endif /* SLIM_FONTS */
}  CHR_DEF_HDR;
typedef CHR_DEF_HDR FARPTR * PCHR_DEF_HDR;



/*------------------------------*/
/*  Character (Part) Definition */
/*------------------------------*/

typedef struct
{
    UW16 cgnum;
    int  buck_search_lvl;       /* bucket level where this part "lives" */
    SW16  index;
    SW16VECTOR   offset;
    SW16VECTOR   bmorigin;
    BOX          pix_bound;
#if PCLEO_RDR
    LPUB8       pgif;           /*  ptr to global IF data in PCLEO hdr */
#endif
} CHR_DEF;
typedef CHR_DEF FARPTR * PCHR_DEF;

#if 0
typedef struct {
   SL32  xmin, xmax, ymin, ymax;       /* char bbox in fops */
   int   ct_loop;
   int   ct_lineto;
   int   ct_quadto;
   int   ct_cubeto;
   int   x0_pix, y0_pix;
   SW16VECTOR origin;
   SL32  escapement; /* in what units ???? */
   int   dxmin, dxmax, dymin, dymax; /* char bounding box in design units */
} CHAR_STATS;
#endif

typedef struct
{
    SW16   format;      /* 1, 2, 3 for linear, quadra, cubic             */
    SW16   nloop;       /* Number of contour loops in character          */
    UW16   est_pnts;    /* estimated number of vector points             */
    UW16   est_segs;    /* estimated number of segments                  */
    SL32   est_size;    /* Estimated outline size including OLHEADERISIZ */

    SW16   xscale;
    SW16   yscale;
    SW16   escapement;
    INTRBOX olbox;
    SL32VECTOR origin_cs;  /* char origin in fops; changed to SL32VECTOR, mby 12-11-94 */

    COUNTER  tran_run_ct;   /* number of transition runs = number of
                             * changes in y direction in character outline
                             */

   /* The following fields were added from old CHAR_STATS structure. */

    SL32  xmin, xmax, ymin, ymax;       /* char bbox in fops */
#if 0
    int   ct_loop;                    /* Number of contour loops in part   */
#endif
    int   ct_lineto;
    int   ct_quadto;
    int   ct_cubeto;
    SW16VECTOR dorigin;               /* char origin in design units       */
    int   dxmin, dxmax, dymin, dymax; /* char bounding box in design units */

   /* The following fields were added to support the new compile option    */
   /* DU_ESCAPEMENT.                                                       */

    SW16 du_emx;               /* x-size of em box in font design units    */
    SW16 du_emy;               /* y-size of em box in font design units    */

} CHAR_STATS;
typedef CHAR_STATS FARPTR * PCHAR_STATS;

typedef struct {
    int  BBox[4];
    int  emRes;
} BBoxRes;


#if CONVERGENT_FONTS
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  Convergent font definitions -- mby 7/15/93
 */
#if BYTEORDER == HILO
#define AWT_ID4             0x41575434L     /* 'A' 'W' 'T' '4' */
#define AWT_ID3             0x41575433L     /* 'A' 'W' 'T' '3' */
#else
#define AWT_ID4             0x34545741L
#define AWT_ID3             0x33545741L
#endif
#define AW_TFN_BIT          0x4000
#define AW_FONTTYPE_MASK    0x3000
#define AW_IF_TYPE          0x0000
#define AW_SSTFS_BIT        0x8000
#define AW_PLUGIN_TYPE_BIT  0x0040
#define AW_IFPLUGIN_MASK    0x003F

#define CVF_NO_INDEX    0   /* Used by the function CVFget_fnt_index() */
#define CVF_REQU_FNT    1
#define CVF_SUBST_FNT   2

typedef struct {
    LPUB8  awtPtr;          /* pointer to AWT, from fc->p_AltWidTab */
    UL32   subst_tfnum;     /* tfnum of substitute font */
    UL32   sstfs_tfnum;     /* tfnum of supersensitive font. */
    UW16   subst_fType;     /* font type of subst. font (must be IF). */
    UW16   sstfs_fType;     /* font type supersensitive (must be IF). */
    UW16   no_sstfs;        /* AW_SSTFS_BIT */
    UW16   useIFplugins;    /* Boolean */
    UW16   IFpluginDesc;    /* bits 0-5 used for setting search path. */
    UW16   nchIDs;          /* from AWT table. */
    UW16   scaleFactor;     /* substitute font scale factor. */
#if (CONVERGENT_FONTS == 1)     /* 3/6/94, mby */
    SL32   italTan;         /* tangent of vertical stroke angle */
    SW16   globalHorAdj;    /* global horizontal adjustment */
    UW16   nHorAdj;         /* nr horiz offset corrections */
    UB8    charProhbItal;   /* PROHIBIT_ITALIC bit set on this char */
    UB8    charProhbItalLast; /* save state of previous character */
#endif
} AWT_TABLE;
#endif  /* CONVERGENT_FONTS */


#ifdef LINT_ARGS
typedef struct {
    UW16 (*load_font) (PFONT_DES, PBUCKET);
    UW16 (*unload_font) (PBUCKET);
    UW16 (*set_trans) (PBUCKET, SL32, SL32, SL32, SL32);
    UW16 (*set_char) (PBUCKET, UW16);
    UW16 (*make_gaso_and_stats) (PBUCKET, PCHAR_STATS);
    UW16 (*render) (PBUCKET, INTR, INTR);
#if WIDTHS
   UW16 (*get_width) (PBUCKET);
#endif /* WIDTHS */
} IF_FUNC_TBL;
typedef IF_FUNC_TBL FARPTR * PIF_FUNC_TBL;

EXTERN BOOLEAN if_init_glob(PBUCKET);
EXTERN UW16   if_init_char(VOID);
EXTERN UW16   IXinit(VOID);
EXTERN VOID    IXexit(VOID);
EXTERN UW16   IXget_fnt_index(PFONTCONTEXT);

/*
pointer callable UFST functions
*/
#if IF_RDR
EXTERN UW16 ifload_font (PFONT_DES, PBUCKET);
EXTERN UW16 ifunload_font (PBUCKET);
EXTERN UW16 ifset_trans (PBUCKET, SL32, SL32, SL32, SL32);
EXTERN UW16 ifset_char (PBUCKET, UW16);
EXTERN UW16 ifmake_gaso_and_stats (PBUCKET, PCHAR_STATS);
EXTERN UW16 ifrender (PBUCKET, INTR, INTR);
#if WIDTHS
EXTERN UW16 ifget_width (PBUCKET);
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 ifget_FontBBox( PBUCKET, BBoxRes* );
#endif
#endif  /* IF_RDR */

#if PST1_RDR
EXTERN UW16 psload_font (PFONT_DES, PBUCKET);
EXTERN UW16 psunload_font (PBUCKET);
EXTERN UW16 psset_trans (PBUCKET, SL32, SL32, SL32, SL32);
EXTERN UW16 psset_char (PBUCKET, UW16);
EXTERN UW16 psmake_gaso_and_stats (PBUCKET, PCHAR_STATS);
EXTERN UW16 psrender (PBUCKET, INTR, INTR);
#if WIDTHS
EXTERN UW16 psget_width (PBUCKET);
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 psget_FontBBox( PBUCKET, BBoxRes* );
#endif
#endif /* PST1_RDR */

#if TT_RDR
EXTERN UW16 ttload_font (PFONT_DES, PBUCKET);
EXTERN UW16 ttunload_font (PBUCKET);
EXTERN UW16 ttset_trans (PBUCKET, SL32, SL32, SL32, SL32);
EXTERN UW16 ttset_char (PBUCKET, UW16);
EXTERN UW16 ttmake_gaso_and_stats (PBUCKET, PCHAR_STATS);
EXTERN UW16 ttrender (PBUCKET, INTR, INTR);
#if WIDTHS
EXTERN UW16 ttget_width (PBUCKET);
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 ttget_FontBBox( PBUCKET, BBoxRes* );
#endif
#endif /* TT_RDR */

#if FCO_RDR
EXTERN UW16 fco_load_font( PFONT_DES, PBUCKET );
EXTERN UW16 fco_unload_font( PBUCKET );
EXTERN UW16 fco_set_trans( PBUCKET, SL32, SL32, SL32, SL32 );
EXTERN UW16 fco_set_char( PBUCKET, UW16 );
EXTERN UW16 fco_make_gaso_and_stats( PBUCKET, PCHAR_STATS );
EXTERN UW16 fco_render( PBUCKET, INTR, INTR );
#if WIDTHS
EXTERN UW16 fco_get_width( PBUCKET );
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 fco_get_FontBBox( PBUCKET, int, BBoxRes* );
#endif
#endif /* FCO_RDR */


#else  /* !LINT_ARGS */

typedef struct {
    UW16 (*load_font) ();
    UW16 (*unload_font) ();
    UW16 (*set_trans) ();
    UW16 (*set_char) ();
    UW16 (*make_gaso_and_stats) ();
    UW16 (*render) ();
#if WIDTHS
   UW16 (*get_width) ();
#endif /* WIDTHS */
} IF_FUNC_TBL;
typedef IF_FUNC_TBL FARPTR * PIF_FUNC_TBL;


EXTERN BOOLEAN if_init_glob();
EXTERN UW16   if_init_char();
EXTERN UW16   IXinit();
EXTERN VOID    IXexit();
EXTERN UW16   IXget_fnt_index();

/*
pointer callable URIP functions
*/
#if IF_RDR
EXTERN UW16 ifload_font ();
EXTERN UW16 ifunload_font ();
EXTERN UW16 ifset_trans ();
EXTERN UW16 ifset_char ();
EXTERN UW16 ifmake_gaso_and_stats ();
EXTERN UW16 ifrender ();
#if WIDTHS
EXTERN UW16 ifget_width ();
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 ifget_FontBBox();
#endif
#endif  /* IF_RDR */

#if PST1_RDR
EXTERN UW16 psload_font ();
EXTERN UW16 psunload_font ();
EXTERN UW16 psset_trans ();
EXTERN UW16 psset_char ();
EXTERN UW16 psmake_gaso_and_stats ();
EXTERN UW16 psrender ();
#if WIDTHS
EXTERN UW16 psget_width ();
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 psget_FontBBox();
#endif
#endif /* PST1_RDR */

#if TT_RDR
EXTERN UW16 ttload_font ();
EXTERN UW16 ttunload_font ();
EXTERN UW16 ttset_trans ();
EXTERN UW16 ttset_char ();
EXTERN UW16 ttmake_gaso_and_stats ();
EXTERN UW16 ttrender ();
#if WIDTHS
EXTERN UW16 ttget_width ();
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 ttget_FontBBox();
#endif
#endif /* TT_RDR */

#if FCO_RDR
EXTERN UW16 fco_load_font();
EXTERN UW16 fco_unload_font();
EXTERN UW16 fco_set_trans();
EXTERN UW16 fco_set_char();
EXTERN UW16 fco_make_gaso_and_stats();
EXTERN UW16 fco_render();
#if WIDTHS
EXTERN UW16 fco_get_width();
#endif /* WIDTHS */
#if FONTBBOX
EXTERN UW16 fco_get_FontBBox();
#endif
#endif /* FCO_RDR */

#endif /* LINT_ARGS */

