/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/pcleo.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: pcleo.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.5   07 Apr 1995 11:31:26   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   22 Apr 1994 15:31:26   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.3   05 May 1993 18:43:36   MIKE
 * Cast PCLFONT_NUMBER_MASK to long to fix warning.
 * 
 *    Rev 1.2   14 Jan 1993 11:06:16   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:44:44   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:37:42   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*  pcleo.h  */

/* History:
 * 
 * 20-Dec-90 dET  remove unused structure definition "fontCopyrightType"
 * 05-Feb-91 jfd  Corrected typeo in typedef statements for PPCL_CHR_HDR, 
 *                PPCL_CC_COMPONENT and PPCL_CC_DESC.
 *                Added typedef for PHPFH.
 * 05-Mar-91 jfd  In structure HPFH, changed field "UWORD typeface"
 *                to "UBYTE lsb_typeface" and "UBYTE msb_typeface".
 *                Changed copyright statement at top.
 * 05-Jun-91 jfd  In structure PCL_CC_DESC, delete field "UWORD nparts"
 *                and add fields "UBYTE nparts" and "BYTE pad".
 *                (FIX FROM EARLIER VERSION)
 * 02-Apr-92 rs   Portability cleanup (see port.h).
 *  8 Jul 92 ss   Added defines for byte offsets into HPFH (pcleo font hdr.)
 * 13-Jul-92 mby  Added #defines for byte offsets into PCLEO font header
 *                for font descr format = 15 (TrueType)
 */

#define    CHARHEADERSIZE      4
#define    CONTHEADERSIZE      2
#define    CHARDESCRIPTORSIZE  2    /* for scaleable fonts */
#define    COPYRIGHTCODE   1

#if 0
#define  MAX_FONT_FILES          32
#define  MAX_COMPOUND_PARTS      10
#define  CHECKSIZE               2
#define  DEFAULT_OUTPUT          "**DEFAULT**"
#endif




/* Offsets into font header data when not referencing via struct -ss 6/2/92 */
#define    FNT_DESC_SIZE        (0)
#define    DESC_FORMAT          (2)
#define    SS_ORG               (3)
#define    STYLE_MSB            (4)
#define    BASELINE_POS         (6)
#define    CELL_WIDTH           (8)
#define    CELL_HEIGHT          (10)
#define    ORIENTATION          (11)
#define    SPACING              (12)
#define    SS_CODE              (14)
#define    PITCH                (16)
#define    HEIGHT               (18)
#define    XHEIGHT              (20)
#define    APPEAR_WIDTH         (22)
#define    STYLE_LSB            (23)
#define    STROKE_WT            (24)
#define    TYPEFACE_LSB         (25)
#define    TYPEFACE_MSB         (26)
#define    SERIF_STYLE          (27)
#define    QUALITY              (28)
#define    PLACEMENT            (29)
#define    WAS_ULINE_POS        (30)
#define    WAS_ULINE_HT         (31)
#define    TEXT_HEIGHT          (32)
#define    TEXT_WIDTH           (34)
#define    FIRST_CODE           (36)
#define    LAST_CODE            (38)
#define    PITCH_EXT            (40)
#define    HEIGHT_EXT           (41)
#define    CAP_HEIGHT           (42)
#define    FONT_NUMBER          (44)
#define    FONT_NAME            (48)
#define    SCALE_FACTOR         (64)
#define    XRES                 (66)
#define    YRES                 (68)
#define    ULINE_POS            (70)
#define    ULINE_HT             (72)
#define    OR_THRESH            (74)
#define    GLOBAL_IT_ANG        (76)
#define    GIFCT                (78)
/* Offsets into font descriptor format 15 header data for values >= 64 */
#define    PTO_SCALEFACTOR         64
#define    PTO_MASTERULINEPOSITION 66
#define    PTO_MASTERULINEHEIGHT   68
#define    PTO_FST                 70
#define    PTO_VARIETY             71

#define    PCLFONT_NUMBER_MASK  (0x00FFFFFFL) /* actual # in low 6 bytes */
#define    PCLFONTHEADERSIZE    80      /* has grown from 64 */

typedef struct
{
    UW16    fontDescriptorSize;       /* PCLFONTHEADERSIZE from above */
    UB8    descriptorFormat;         /* 10-Intellifont */
    UB8    symbolSetOrganization;    /* FontType from symset map */
    UB8    style_msb;                /* from Font Alias Table = FAT */
    UB8    Reserved1;
    UW16    baselinePosition;         /* Attr Hdr, also Display Hdr */
    UW16    cellWidth;                /* ignored by Galaxy */
    UW16    cellHeight;               /* ignored by Galaxy */
    UB8    orientation;              /* 0, not used */
    UB8    spacing;                  /* fixed/proportional, FAT */
    UW16    symSetCode;               /* derived from symset map */
    UW16    pitch;                    /* spaceband from Attr Hdr */
    UW16    height;                   /* master pt size from Display Hdr */
    UW16    xHeight;                  /* Attr Hdr */
    SB8     appearanceWidth;          /* WidthType, FAT */
    UB8    style_lsb;                /* posture, FAT */
    SB8     strokeWeight;             /* from FAT */
    UB8    lsb_typeface;             /* from FAT (LSB) (02-20-91 jfd) */
    UB8    msb_typeface;             /* from FAT (MSB) (02-20-91 jfd) */
    UB8    serifStyle;               /* from FAT */
    UB8    quality;                  /* 2, ignored */
    UB8    placement;                /* 0, ignored */
    SB8     was_underlinePosition;    /* Attr Hdr value needs word */
    UB8    was_underlineHeight;      /* Attr Hdr value needs word */
    UW16    textHeight;               /* for HPGL */
    UW16    textWidth;                /* for HPGL */
    UW16    firstCode;                /* from symset map */
    UW16    lastCode;                 /* from symset map */
    UB8    pitch_ext;                /* 0, ignored */
    UB8    height_ext;               /* 0, ignored */
    UW16    capHeight;                /* Attr Hdr */
    UL32    fontNumber;               /* FAT */
    UB8    fontName[16];             /* FAT */
    UW16    scaleFactor;              /* Attr Hdr */
    UW16    xRes;                     /* Display Hdr */
    UW16    yRes;                     /* Display Hdr */
    SW16     underlinePosition;        /* Attr Hdr */
    UW16    underlineHeight;          /* Attr Hdr */
    UW16    orThreshold;              /* from Raster Params */
    UW16    globItalAng;              /* from Raster Params */
    UW16    gifct;                    /* global IF size */
} HPFH;
typedef HPFH FARPTR * PHPFH;

/* actual # of bytes in struct w/out alignment padding  -ss 10/9/91 */
#define HPFH_SIZE  80


/****************************************************************************
     The extended description (or extended header) is added by Type Director
     to fonts that it creates.  This item contains information which Type
     Director uses to "consume" and manage fonts.
 ****************************************************************************/

#define    HPFONTHDR_EXT_HEADER_TYPE    2      /* app support area */

typedef struct
{
  UW16   ehHSize;         /* extended header size                  */
  UB8   ehHType;         /* EXTHEADER, defined above              */
  UB8   ehTreatment;     /* HP/CG Family treatment character      */
  UW16   ehFamilynumb;    /* HP number for family                  */
  UB8   ehFamilydes[2];  /* HP designation of family              */
  UW16   ehStyle;         /* only 8 bits are actually used         */
  UW16   ehClassIndex;    /* family classification                 */
  UW16   ehExtleading;    /* optimal leading (design)              */
  UW16   ehIntleading;    /* optimal leading (design)              */
  UB8   ehStemStyle;     /* stem style                            */
  UB8   ehStemMod;       /* stem modifier                         */
  UB8   ehSymdes[2];     /* designator: HP cust friendly code     */
  UW16   ehSymclass;      /* symbol set classification             */
  UB8   ehType;          /* type (screen or printer)              */
  UB8   ehClass;         /* device class                          */
  UW16   ehXres;          /* x resolution (dots per inch)          */
  UW16   ehYres;          /* y resolution (dots per inch)          */
  UW16   ehXdot;          /* x dot size                            */
  UW16   ehYdot;          /* y dot size                            */
  UW16   ehGrays;         /* number of grey levels for anti alias  */
  UB8   pad;
  UB8   check;
} HPEFH;




typedef struct
{
   SB8  PCLalfa[2];
   SB8  treatment;
   SB8  fixPitch;
   SW16  PCLwidth;
   SW16  structure;
   SW16  face_width;
   SW16  posture;
   SW16  stem_wt;
   SW16  family;
   SW16  serif_style;
   SW16  serif_flag;
   SB8  compress;
   SB8  font_name[17];
   SW16  FAIS_file_num;
   SW16  class_index;
}  HPFAT;



#if PCLEO_RDR

#define PCL_SIMPLE_CHR     3
#define PCL_COMPOUND_CHR   4

typedef struct {
   UB8 format;
   UB8 continuation;
   UB8 descriptorsize;
   UB8 class;
} PCL_CHR_HDR;
typedef PCL_CHR_HDR FARPTR * PPCL_CHR_HDR;
#define PCL_CHR_HDR_SIZE   4

/*  format of compound character part  */
typedef struct {
   UW16             chId;            /*  ascii character code      */
   UW16             xoffset;
   UW16             yoffset;
} PCL_CC_COMPONENT;
typedef PCL_CC_COMPONENT FARPTR * PPCL_CC_COMPONENT;

typedef struct {
   PCL_CHR_HDR       hdr;             /*  common PCLEO char header  */
   UW16             cc_esc;          /*  escapement                */
   UB8             nparts;          /*  # parts of components     */
   SB8              pad;             /*           added -ss 4/2/91 */
   PPCL_CC_COMPONENT cc_list;         /*  ptr to list of components */
} PCL_CC_DESC;
typedef PCL_CC_DESC FARPTR * PPCL_CC_DESC;

#endif  /*  PCLEO_RDR  */

