/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/port.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: port.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.1   15 Dec 1996 12:34:08   Keith Roseberry
 * Modified to compile without errors as a Windows console program.
 * 
 *    Rev 1.0   11 Dec 1996 18:31:34   unknown
 * Checked in from initial workfile by PVCS Version Manager Project Assistant.
 * 
 *    Rev 1.0   11 Dec 1996 18:12:32   unknown
 * Checked in from initial workfile by PVCS Version Manager Project Assistant.
 * 
 *    Rev 1.26   07 Apr 1995 11:31:30   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.25   23 Feb 1995 14:21:46   JOE
 * For WATCOM, changed NAT_ALIGN from 2 to 4.
 * 
 *    Rev 1.24   14 Feb 1995 20:39:52   MIKE
 * Defined "NZCOUNTER" type for NON_Z_WIND support
 * 
 *    Rev 1.23   13 Jan 1995 18:06:42   ROB
 * Support for > 64KB memory blocks in DOS.
 * 
 *    Rev 1.22   15 Dec 1994 14:37:54   JOE
 * More cleaning up (by rs).
 * 
 *    Rev 1.21   14 Dec 1994 08:27:54   JOE
 * 
 * Added typedef for LPHPUB8.
 * Added define for HUGEPTR.
 * General cleanup (by rs).
 * 
 *    Rev 1.20   17 Sep 1994 13:53:16   JOE
 * If _WINDOWS, define ANSI_DEFS and LINT_ARGS (by rs).
 * 
 *    Rev 1.19   26 Aug 1994 08:22:10   JOE
 * 
 * Added typedef for LPLPUB8.
 * 
 *    Rev 1.18   11 Aug 1994 08:18:58   JOE
 * Removed MBY's Borland 3.1 Windows change due to compiler error using
 * Borland 4.0 .
 * 
 *    Rev 1.17   03 Aug 1994 10:45:28   MIKE
 * Added FCO change from 1.12.1.1
 * 
 *    Rev 1.16   03 Jun 1994 10:07:18   JOE
 * 
 * Changed all occurrences of ENTRY to CGENTRY to resolve conflict on
 * some compilers.
 * 
 *    Rev 1.15   22 Apr 1994 15:31:36   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.14   09 Feb 1994 11:33:10   JOE
 * More _AM29K changes.
 * 
 *    Rev 1.13   02 Feb 1994 09:25:18   JOE
 * 
 * AM29K changes.
 * 
 *    Rev 1.12   13 Dec 1993 14:07:02   JOE
 * Fixed typo within bblock "#if (defined(_WINDOWS) && !defined(__BORLANDC__)
 * && !defined(__WATCOMC__))".
 * 
 *    Rev 1.11   09 Dec 1993 16:12:08   ROB
 * Modifications for OS/2 2.X.
 * 
 *    Rev 1.10   08 Dec 1993 18:58:08   ROB
 * General cleanup for MSDOS, FLAT, OS2.
 * 
 *    Rev 1.9   27 Jul 1993 13:11:44   AL
 * Non-zero winding changes
 * 

 *    Rev 1.8   10 Jun 1993 08:22:40   JOE
 * Changed SIGNEDCHAR for VXWORKS to NO.
 * Changed typedef for "int8" from "char" to "SB8" for portability.
 * 
 *    Rev 1.7   31 Mar 1993 09:49:08   ROB
 * Enable 'ANSI_DEFS' for Borland & Watcom compilers.
 * 
 *    Rev 1.6   12 Feb 1993 09:30:02   JOE
 * VXWorks support.
 * 
 *    Rev 1.5   18 Jan 1993 16:03:00   LISA
 * Fixed typo
 * 
 *    Rev 1.4   14 Jan 1993 11:14:14   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.3   15 Dec 1992 13:14:00   JOE
 * Moved typedefs from FSCDEFS.H and STDEF.H
 * 
 *    Rev 1.2   14 Dec 1992 18:36:20   ROB
 * Changed NAT_ALIGN from 2 to 4 for Macintosh.
 * 
 *    Rev 1.1   14 Dec 1992 08:45:48   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:37:50   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*
*  port.h
*
*
* 
*  History:
*  ---------
*   19-Jul-91 jfd Changed "MSWINDOWS" to "_WINDOWS".
*   10-Jun-91 jfd Made declaration of FPNUM conditional absed on INT_FP.
*   06-Apr-91 awr Added floating point definition.
*   30-Jan-91 dET Added definitions for pointer types.
*   27-Nov-90 cg  Changed typedef statement for BOOLEAN from int to WORD
*   07-Aug-88 mac Changed VOIDTYPE definition to YES for MSC
*   07-Jul-88 mac Changed VOID definition from typedef to #define because
*                 VOID does not apply to variables, only to functions.
*                 Defined MAX_LONG, MIN_LONG, and MAX_ULONG.
*   27-Jun-88 mac Fixed BOOLEAN typedef comment ( TRUE=1, FALSE=0 ).
*   07-Jun-88 mac Added configuration definitions and conditionals.
*             mac Added ABS and LABS macro definitions.
*   11-May-88 mac Change PATHNAMELEN to 63 for MS-DOS
*   16-Mar-88 mac Added typedef FIXED : 32 bit fixed point number
*   23-Feb-88 mac Added MIN_WORD
*   15-Feb-88 mac Clean up and reorganization of typedefs
*    1-Nov-87     Initial Release
*   15-Dec-91 awr Added typedefs LONGVECTOR, PLONGVECTOR.
*   07-Mar-92 rs  Add support for Borland C++ compiler.
*    8-Mar-92 awr Changed exponent of FPNUM structure to int from WORD
*   13-Mar-92 rs  Cleanup of constants '(LONG)0x...' to '0x...L'.
*   19-Mar-92 awr Moved BOX from if_type.h and added LONGBOX
*   24 Mar 92 ss  Conditional compile of MAX_UWORD & MAX_ULONG with 'U'
*                 modifier for MSDOS only. (not available on Sun)
*   02-Apr-92 rs  Software portability changes:
*                 BYTE  -> SB8,  PBYTE  -> LPSB8
*                 UBYTE -> UB8,  PUBYTE -> LPUB8
*                 WORD  -> SW16, PWORD  -> LPSW16
*                 UWORD -> UB16, PUWORD -> LPUW16
*                 LONG  -> SL32, PLONG  -> LPSL32
*                 ULONG -> UL32, PULONG -> LPUL32
*   21-Apr-92 rs  Conditionalize 'TRUE' & 'FALSE' to work w/Windows.
*   14-Jun-92 awr Added typedefs INTR, INTRVECTOR, INTRBOX
*   25-Jun-92 rs  Add 'PINTR'.
*   28 Jun 92 ss  Added entry for MIPS machine.
*   07-Aug-92 rs  Compatibility w/Windows 3.1 (FIXED, POINTFX).
*   08-Aug-92 rs    Changes for Watcom C386 compiler.
*   23-Sep-92 jfd Added entry for INTEL960 machine (__i960) .
*   30-Sep-92 jfd Added NAT_ALIGN values (natural alignment of a structure)
*                 for each entry.
*   05-Oct-92 jfd Added define for PASCAL based on ANSI C.
*                 Changed define for ENTRY for windows callback entry 
*                 function from "pascal" to "PASCAL".
*   14-Nov-92 rs  Port to Macintosh.
*   05-Dec-92 rs  Temporarily change NAT_ALIGN to 4 for Mac because fm.c
*                 expects 4 or "nothing" for expand_buf, etc.
*   15-Dec-92 jfd Moved data typedefs for short, int and long from FSCDEFS.H.
*                 Moved data typedefs for uint8, ufix8, fix15, ufix16,
*                 fix31, and ufix32 from STDEF.H.
*   08-Feb-93 jfd VXWorks support.
*                 Deleted #define LOCAL from storage class definitions
*                 because it is never referenced.
*  30-Mar-93  rs  Add '#define ANSI_DEFS' for Borland & Watcom compilers.
*  10-Jun-93  jfd Set SIGNEDCHAR to NO for VXWORKS, eliminating the need to
*                 use the "-f" switch when compiling.
*                 Changed the typedef for "int8" from "char" to "SB8".
*  22-Jul-93  awr Added typedef PCOUNTER
*  08-Dec-93  rs  General cleanup - break Watcom into DOS vs OS2.
*                 Add #define of "CGFLAT32" to indicate 32 bit addresss
*                 space (only checked on DOS & OS2 platforms for now).
*  13-Dec-93  jfd Fixed typo within block "#if (defined(_WINDOWS) && 
*                 !defined(__BORLANDC__) && !defined(__WATCOMC__))" -
*                 Comment had been added in front of "#ifndef MSDOS"
*                 statement making it invalid.
*  28-Jan-94  jfd For SUN compiles using metaware compiler (for 29k),
*                 #define LINTARGS and ANSI_DEFS.
*  04-Feb-94  jfd/dbk Added support for _AM29K.
*  03-Jun-94  jfd Changed all occurrences of ENTRY to CGENTRY to resolve
*                 conflict on some compilers.
*  05-Jul-94 mby  FCO change from 1.12.1.1: Made changes for Borland 3.1 Windows compilation.
*  10-Aug-94 jfd  Removed MBY's Borland 3.1 Windows change due to problem
*                 with Borland 4.0 .
*  18-Aug-94 jfd  Added typedef for LPLPUB8.
*  17-Sep-94 rs   If _WINDOWS, define ANSI_DEFS and LINT_ARGS.
*  14-Dec-94 rs   Added typedef for LPHPUB8.
*                 Added define for HUGEPTR.
*                 General cleanup.
*  09-Jan-95 rob  Add 'HPSB8' for > 64KB support in DOS/Windows.
*  14-Feb-95 mby  Defined 'NZCOUNTER' type for NON_Z_WIND support.
*  23-Feb-95 jfd  For WATCOM, changed NAT_ALIGN from 2 to 4.
*/
/************************************************************************/
/*                      Configuration Define                            */
/************************************************************************/
/*                Identifier Definition for the                         */
/*                Compiler - OS Configuration.                          */
/*                Use make file to Define only one of the following:    */
/* #define  _WINDOWS                   Microsoft Windows                */
/* #define  MSC                        Microsoft C - MSDOS              */
/* #define __BORLANDC__ (compiler)      Borland C++ (DOS or Windows)    */
/* #define  SUN                        SUN C - UNIX                     */
/* #define  VAX                        VAX C - VMS                      */
/* #define  MACINTOSH (based on THINK_C)                                */
/* #define __WATCOMC__ (compiler)      Watcom 32 bit DOS or OS/2        */
/* #define _AM29K                      AMD 29K HighC Compiler           */
/*                                                                      */
/************************************************************************/

/************************************************************************/
/*                      Configuration Conditionals                      */
/************************************************************************/

#define  YES            1           /* Configuration feature enable     */
#define  NO             0           /* Configuration feature disable    */
#define  LOHI           1           /* Addr:LoByte, Addr+1:HiByte       */
#define  HILO           0           /* Addr:HiByte, Addr+1:LoByte       */

#if (defined (__WINDOWS_H))      /* Borland C Windows 3.1  - mby, 07-05-94 */
#else
#if (defined (__STDC__) && (__STDC__ > 0) && !defined(__i960) && !defined(VXWORKS) && !defined (_AM29K))
#define PASCAL //__pascal
#elif _AM29K
#define PASCAL
#else
#define PASCAL pascal
#endif /* __STDC__ */
#endif /* !(defined (__WINDOWS_H)) */

#ifdef SIMULATE
#undef PASCAL
#define PASCAL
#endif

#if defined (THINK_C)
#if !defined (MACINTOSH)
#define MACINTOSH   1
#endif /* MACINTOSH */
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      HILO        /* byte ordering is Hi-Lo bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#define  LINT_ARGS      YES         /* function decl with arguments     */
#define  ENTRYTYPE      NO          /* _export callback function def    */
/* Temp fix for alignment problems in fm.c, etc for expand_buf - long */
#define  NAT_ALIGN      4           /* natural struct alignment is word */
#endif /* THINK_C */

#if defined (_AM29K)                /* AMD 29K Compiler                 */
#define  ANSI_DEFS
#define  CGFLAT32       1           /*Flat memory model*/
#define  NAT_ALIGN      4           /* natural struct alignment is long */
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      HILO        /* byte ordering is Hi-Lo bytes     */
#define  SIGNEDCHAR     YES          /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#ifdef   LINT_ARGS
#undef   LINT_ARGS
#endif
#define  LINT_ARGS      YES         /* function decl with arguments     */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#endif /* AM29K */

#if defined (__WATCOMC__) /* only support 32 bit Watcom at this time */
#if defined (__386__) /* add 12/8/93 - rs */
#define CGFLAT32  1
#define  ANSI_DEFS
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      LOHI        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#define  LINT_ARGS      YES         /* argument checking identifier */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#define  NAT_ALIGN      4           /* natural struct alignment is long */
//#ifdef SIMULATE
//#define MSDOS
//#endif
#endif /* __386__ */
#endif /* __WATCOMC__ */

#if (defined(MSC) || (defined(_WINDOWS) && !defined(__BORLANDC__) && !defined(__WATCOMC__)))
 /* Microsoft C - Windows 3.0 */
//#ifndef  MSDOS
//#define  MSDOS                      /* MSDOS                            */
//#endif
#define  ANSI_DEFS
#define  INTLENGTH      16          /* int length of 16 bits            */
#define  BYTEORDER      LOHI        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#define  LINT_ARGS      YES         /* argument checking identifier */
#if defined(_WINDOWS)
#define  ENTRYTYPE      YES         /* _export callback function def    */
#else
#define  ENTRYTYPE      NO          /* _export callback function def    */
#endif
#define  NAT_ALIGN      2           /* natural struct alignment is word */
#if (defined(M_I86SM) || defined(M_I86MM) || defined(M_I86TM))
#define FARPTR __far
#else
#define FARPTR 
#endif
#if (FCO_TT) || (HUGE_PTR_SUPPORT)
#define HUGEPTR __huge
#endif
#endif /* Windows w/MSC compiler */

#if defined(__BORLANDC__)          /* Borland C++ - MSDOS or Windows   */
/*
	make this look like MSC 6.0+
*/
#define _MSC_VER    600
#if defined(__TINY__)
#define M_I86TM 1
#elif defined(__SMALL__)
#define M_I86SM 1
#elif defined(__MEDIUM__)
#define M_I86MM 1
#elif defined(__COMPACT__)
#define M_I86CM 1
#elif defined(__LARGE__)
#define M_I86LM 1
#endif /* (__TINY__) */

#ifndef  MSDOS
#define  MSDOS                      /* MSDOS                            */
#endif /* MSDOS */

#define  ANSI_DEFS
#define  INTLENGTH      16          /* int length of 16 bits            */
#define  BYTEORDER      LOHI        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#define  LINT_ARGS      YES         /* argument checking identifier */
#define  NAT_ALIGN      2           /* natural struct alignment is word */
#if (defined(M_I86SM) || defined(M_I86MM) || defined(M_I86TM))
#define FARPTR __far
#else
#define FARPTR 
#endif
#if (FCO_TT) || (HUGE_PTR_SUPPORT)
#define HUGEPTR __huge
#endif

#if (!defined(_Windows))
#define  ENTRYTYPE      NO          /* _export callback function def    */
#else /* Borland C++ & Windows */
#define  ENTRYTYPE      YES         /* _export callback function def    */
#if (!defined(_WINDOWS))
#define _WINDOWS    1       
#endif                      
#endif /* (!defined(_Windows)) */
#endif /* defined(__BORLANDC__) */

#ifdef   SUN                        /* SUN C - UNIX                     */
#ifndef  UNIX
#define  UNIX                       /* UNIX                             */
#endif
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      HILO        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#if defined(_AM29K)
#define  LINTARGS       YES         /* function decl with arguments     */
#define  ANSI_DEFS
#else
#define  LINTARGS       NO          /* function decl without arguments  */
#endif
#define  ENTRYTYPE      NO          /* _export callback function def    */
#ifdef   SPARC
#define  NAT_ALIGN      4           /* natural struct alignment is long */
#else
#define  NAT_ALIGN      2           /* natural struct alignment is word */
#endif
#endif

#if defined(MIPS) && !defined(VXWORKS) /* MIPS - UNIX SYS V             */
#ifndef  UNIX
#define  UNIX                       /* UNIX                             */
#endif

#define  UNIX_SYSV
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      HILO        /* byte ordering is Lo-Hi bytes     */

   /* System defaults char to unsigned, but forced to signed by -signed */
   /* on link line (CFLAGS)                                             */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       NO          /* function decl without arguments  */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#define  NAT_ALIGN      4           /* natural struct alignment is long */
#endif  /* MIPS && !VXWORKS */

#ifdef VXWORKS
#ifndef UNIX
#define UNIX  
#endif
#pragma align 4
#endif

#if   defined(__i960) || defined(VXWORKS) /* INTEL960 or VXWORKS        */
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      LOHI        /* byte ordering is Lo-Hi bytes     */

   /* System defaults char to unsigned for VXWORKS, signed for i960     */
#if defined(__i960)
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#else
#define  SIGNEDCHAR     NO          /* char is treated as unsigned byte */
#endif
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       NO          /* function decl without arguments  */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#define  NAT_ALIGN      4           /* natural struct alignment is long */
#endif  /* __i960 || VXWORKS */


#ifdef   VAX                        /* VAX C - VMS                      */
#ifndef  VMS  
#define  VMS                        /* VMS                              */
#endif
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      LOHI        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     YES         /* char is treated as signed byte   */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments     */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#define  NAT_ALIGN      2           /* natural struct alignment is word */
#endif

#ifdef   LAMIGA                     /* Lattice C - AmigaDOS             */
#ifndef  AMIGA
#define  AMIGA                      /* AMIGA                            */
#endif
#define  INTLENGTH      32          /* int length of 32 bits            */
#define  BYTEORDER      HILO        /* byte ordering is Lo-Hi bytes     */
#define  SIGNEDCHAR     NO          /* char not treated as signed byte  */
#define  VOIDTYPE       YES         /* compiler does have void type     */
#define  LINTARGS       YES         /* function decl with arguments */
#define  ENTRYTYPE      NO          /* _export callback function def    */
#define  NAT_ALIGN      2           /* natural struct alignment is word */
#endif

#if      LINTARGS == NO
#undef   LINTARGS
#endif

/************************************************************************/
/*                      Typedef Definitions                             */
/************************************************************************/

#if ENTRYTYPE == YES
#define CGENTRY _export far PASCAL  /* windows callback entry function  */
#else
#define CGENTRY
#endif


#if SIGNEDCHAR == YES
typedef  char           SB8;        /* signed byte ( -127, 128 )        */
typedef  unsigned char  UB8;        /* unsigned byte ( 0, 255 )         */
#else
typedef  signed char    SB8;        /* signed byte ( -127, 128 )        */
typedef  unsigned char  UB8;        /* unsigned byte ( 0, 255 )         */
#endif


#if INTLENGTH == 16
typedef  int            SW16;       /* 16-bit signed word               */
typedef  int            int16;
typedef  unsigned int   UW16;       /* 16-bit unsigned word             */
typedef  unsigned int   uint16;
typedef  long           SL32;       /* 32-bit signed longword           */
typedef  long           int32;
typedef  unsigned long  UL32;       /* 32-bit unsigned longword         */
typedef  unsigned long  uint32;
#endif
#if INTLENGTH == 32
typedef  short          SW16;       /* 16-bit signed word               */
typedef  short          int16;
typedef  unsigned short UW16;       /* 16-bit unsigned word             */
typedef  unsigned short uint16;
typedef  int            SL32;       /* 32-bit signed longword           */
typedef  int            int32;
typedef  unsigned int   UL32;       /* 32-bit unsigned longword         */
typedef  unsigned int   uint32;
#endif


/* The following typedefs are used by UFSTINST and PSNAME software */

typedef SB8             int8;
typedef unsigned char   uint8;
typedef unsigned char   ufix8;
typedef short           fix15;
typedef unsigned short  ufix16;
typedef long            fix31;
typedef unsigned long   ufix32;

/* End of UFSTINST and PSNAME block */


#if VOIDTYPE == YES
#define  VOID           void        /* void data type                   */
#else
#define  VOID           int         /* void data type changed to int    */
#endif

#ifdef SIMULATE
typedef  unsigned char  BOOLEAN;
#else
typedef  SW16           BOOLEAN;    /* boolean ( TRUE = 1, FALSE = 0 )  */
#endif
typedef  int            COUNTER;    /* machine's word signed counter    */
typedef  unsigned int   UCOUNTER;   /* machine's word unsigned counter  */
typedef  double         DOUBLE;     /* floating point double precision  */
typedef  SL32           CGFIXED;    /* 32 bit fixed point number        */

typedef  SW16           NZCOUNTER;  /* used for NON_Z_WIND = 1          */

#if INT_FP                          /* with 16 bit fractional part      */
typedef struct                      /* Floating point                   */
{
    SL32 n;    /* normalized, signed mantissa */
    int  e;    /* exponent                    */
} FPNUM;
#else
typedef double FPNUM;
#endif
/************************************************************************/
/*                      Data Types Definitions                          */
/************************************************************************/
/* 
** The common problem of mapping various pointer types is partialy
** addressed here.
*/

#if !defined FARPTR
#define FARPTR
#endif
#if !defined HUGEPTR
#define HUGEPTR
#endif

    /* Pointer Data Types Definitions */
typedef COUNTER FARPTR  * PCOUNTER;
typedef NZCOUNTER FARPTR *  PNZCOUNTER;
typedef SB8   FARPTR * LPSB8;
#if (HUGE_PTR_SUPPORT)
typedef SB8   HUGEPTR * HPSB8;
typedef UB8   HUGEPTR * HPUB8;
#endif
typedef UB8   FARPTR * LPUB8;
typedef UW16  FARPTR * LPUW16;
typedef SW16  FARPTR * LPSW16;
typedef SL32  FARPTR * LPSL32;
typedef UL32  FARPTR * LPUL32;
typedef CGFIXED FARPTR * PCGFIXED;
typedef SB8   FARPTR * FARPTR * LPLPSB8;
typedef UB8   FARPTR * FARPTR * LPLPUB8;
typedef UB8   HUGEPTR * FARPTR * LPHPUB8;
typedef SB8   HUGEPTR * FARPTR * LPHPSB8;
typedef VOID  FARPTR * PVOID;
typedef FPNUM FARPTR * PFPNUM;


                       /* Data Types Definitions */

typedef struct word_point_struct {
   SW16 x;                      /* point x coordinate                   */
   SW16 y;                      /* point y coordinate                   */
} SW16POINT;
typedef SW16POINT FARPTR * PSW16POINT;

typedef struct word_vector_struct {
   SW16 x;                      /* vector x component                   */
   SW16 y;                      /* vector y component                   */
} SW16VECTOR;
typedef  SW16VECTOR FARPTR * PSW16VECTOR;

typedef struct
{
    SW16VECTOR ll;
    SW16VECTOR ur;
} BOX;
typedef BOX FARPTR * PBOX;

typedef struct
{
    SL32 x;
    SL32 y;
} SL32VECTOR;
typedef  SL32VECTOR FARPTR * PSL32VECTOR;

typedef struct
{
    SL32VECTOR ll;
    SL32VECTOR ur;
} SL32BOX;
typedef SL32BOX FARPTR * PSL32BOX;

typedef struct word_window_struct {
   SW16 Top;                    /* top edge coordinate                  */
   SW16 Left;                   /* left edge coordinate                 */
   SW16 Bottom;                 /* bottom edge coordinate               */
   SW16 Right;                  /* right edge coordinate                */
} SW16WINDOW;
typedef  SW16WINDOW FARPTR * PSW16WINDOW;

typedef struct
{
    CGFIXED x;
    CGFIXED y;
} CGPOINTFX;
typedef CGPOINTFX FARPTR * PCGPOINTFX;


#if (INTR_SIZE == 16)
typedef  SW16        INTR;
typedef  SW16VECTOR  INTRVECTOR;
typedef  BOX         INTRBOX;
#elif (INTR_SIZE == 32)
typedef  SL32        INTR;
typedef  SL32VECTOR  INTRVECTOR;
typedef  SL32BOX     INTRBOX;
#endif

typedef  INTR  FARPTR * PINTR;
typedef  INTRVECTOR  FARPTR * PINTRVECTOR;
typedef  INTRBOX     FARPTR * PINTRBOX;

/************************************************************************/
/*                      Storage Class Definitions                       */
/************************************************************************/

#define  REG            register    /* register variable                */
#define  EXTERN         extern      /* external variable                */
#define  MLOCAL         static      /* local to module                  */
#define  GLOBAL         /**/        /* global variable                  */

/************************************************************************/
/*                      Path and File name lengths                      */
/************************************************************************/

#if defined  (MSDOS) || defined (__OS2__) 
#define FILENAMELEN  13
#define PATHNAMELEN  63
typedef SB8 FILECHAR;
/*typedef FILECHAR FILENAME [FILENAMELEN]; Borland problem 4/21/92 rs*/
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif

#if  defined(SUN) || defined(MIPS) || defined(__i960) || defined (VXWORKS) || defined(_AM29K) /* 2-4-94 */
#define FILENAMELEN  13
#define PATHNAMELEN  63
typedef SB8 FILECHAR;
typedef FILECHAR FILENAME [FILENAMELEN];
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif

#ifdef  VAX
#define FILENAMELEN  13
#define PATHNAMELEN  63
typedef SB8 FILECHAR;
typedef FILECHAR FILENAME [FILENAMELEN];
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif

#ifdef  LAMIGA
#define FILENAMELEN  30
#define PATHNAMELEN  256
typedef SB8 FILECHAR;
typedef FILECHAR FILENAME [FILENAMELEN];
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif

#if defined (__linux__)
#define FILENAMELEN  30
#define PATHNAMELEN  256
typedef SB8 FILECHAR;
typedef FILECHAR FILENAME [FILENAMELEN];
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif

#if  defined(MACINTOSH)
#define FILENAMELEN  13
#define PATHNAMELEN  63
typedef SB8 FILECHAR;
typedef FILECHAR FILENAME [FILENAMELEN];
typedef FILECHAR PATHNAME [PATHNAMELEN];
typedef FILECHAR DIRNAME [PATHNAMELEN];
#endif


/************************************************************************/
/*                      Macro Definitions                               */
/************************************************************************/

#define ABS(a)    ( ((a) < (SW16)0) ? -(a) : (a) )
#define LABS(a)   ( ((a) < 0L) ? -(a) : (a) )
#define MIN(a,b)  ( ((a) < (b)) ? (a) : (b) )
#define MAX(a,b)  ( ((a) < (b)) ? (b) : (a) )

/************************************************************************/
/*                      Miscellaneous Definitions                       */
/************************************************************************/

#define  FAILURE        (-1)        /* Function failure return val      */
#define  SUCCESS        (0)         /* Function success return val      */

#ifndef TRUE /* conditionalize to work w/Windows - 4/211/92 - rs */
#define  TRUE           (1)         /* Function TRUE  value             */
#endif
#ifndef FALSE /* conditionalize to work w/Windows - 4/211/92 - rs */
#define  FALSE          (0)         /* Function FALSE value             */
#endif

#define  MAX_WORD       ((SW16)(0x7FFF))
#define  MIN_WORD       ((SW16)(0x8000))
#if defined (MSDOS) || defined (__OS2__)
#define  MAX_UWORD       ((UW16)(0xFFFFU))
#else
#define  MAX_UWORD       ((UW16)(0xFFFF))
#endif

#define  MAX_LONG       (0x7FFFFFFFL)
#define  MIN_LONG       (0x80000000L)
#if defined (MSDOS) || defined (__OS2__)
#define  MAX_ULONG       (0xFFFFFFFFUL)
#else
#define  MAX_ULONG       (0xFFFFFFFFL)
#endif

