/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/ps_type1.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: ps_type1.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.5   07 Apr 1995 11:31:26   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.4   04 May 1994 14:33:54   JOE
 * 
 * Changed MAXSTEMS to MAXCHARSTEMS due to naming conflict.
 * 
 *    Rev 1.3   22 Apr 1994 15:31:38   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   14 Jan 1993 11:14:04   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:45:28   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:38:06   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*
 * PS_TYPE1.H
 *
 *
 *  20-May-91  jfd  Original Program
 *  31-May-91  rs   Add 'MAXPS_SYMBOLS' = 256
 *  03-Jun-91  rs   Add defs for some cg numbers
 *  17-Jun-91  jfd  Added DESCR_SET_LEN definition
 *                  Added definitions for FW_EXTRALIGHT, FW_LIGHT,
 *                  FW_BOLD and FW_EXTRABOLD
 *                  Added definitions for SLANTSTYLE_OFF and STEMWEIGHT_OFF.
 *                  Added definitions for FF_SWISS, FF_ROMAN, FF_SCRIPT,
 *                  FF_DECORATIVE and FF_MODERN.
 *  20-Jun-91  jfd  Added "#define  ERR_no_vfm_font_id    99".
 *  20-Jun-91  rs    Add 'MAXPATHLEN', MAXPFMDATA.
 *  27-Jun-91  rs    Add struct 'CG_KERN_TBL' for kern support.
 *  01-Jul-91  rs		Add bounding box info to WIDTABSTR for AFM file.
 *							Remove 'pfmCode' from PS1Codes structure. Move
 *							declaration of struct TF from iftops1.c to here.
 *  05-Jul-91  rs		Clean up error codes, move to cgif.h.
 *  10-Jul-91  rs		Add 'MAXKernPair' for max # of kern pairs.
 *  19-Jul-91  rs		Add defs for cg descriptor set values.
 *  25-Jul-91  jfd   Removed declaration of *PPSPARAMSTR (moved to cgif.h)
 *                   Removed #define for MAXPATHLEN (moved to cgif.h)
 *  27-Jul-91  jfd   Declared PWIDTABSTR in a separate typedef statement.
 *  23-Aug-91  rs		Begin adding phase 1 hinting code for stems (lite).
 *  04-Sep-91  rs		Begin 2nd phase of hinting code (lite+). Add definitions
 *							for key cgnums (used for blue values + hints).
 *  25-Sep-91  jfd   Changed type of "adobeName" in PS1CODESTR structure
 *                   from "PBYTE" to "BYTE *" to get rid of compiler warning
 *                   when building medium model.
 *  19-Nov-91  jfd   Increased MAXSTEMS from 20 to 30.
 *  02-Apr-92  rs    Portability cleanup (see port.h).
 *  04-May-94 jfd    Changed MAXSTEMS to MAXCHARSTEMS due to naming conflict.
 */


#define T1HINTS	1		/* 1st attempt at type 1 hints - 8/23/91 - rs */

/*
String length defines
*/
#define  TF_NAME_LEN           50
#define  FAM_NAME_LEN          20
#define  WEIGHT_DSC_LEN        20
#define  DESCR_SET_LEN         8		/* added 6/17/91 - jfd */

#define faceIsHollow(f)	(f->class & 0x10)

typedef struct PS1CodeStr {
	SB8     *adobeName;
	SW16      cgCode;
/*	SW16      pfmCode; - NOT USED AT THIS TIME - 7/1/91 - rs */
} PS1CODESTR;

typedef struct widTabStr
{
	SW16	ps1_off;
	UW16	cg_width;
	SW16	bboxllx;	/* bounding box used for afm file - 7/1/91 - rs */
	SW16	bboxlly;
	SW16	bboxurx;
	SW16	bboxury;
} WIDTABSTR;
typedef WIDTABSTR  FARPTR * PWIDTABSTR;  /* 07-26-91 jfd */

typedef struct {
UW16 cgnuml;
UW16 cgnumr;
} CG_KERN_TBL;

/*
Note: Library does not null terminate fields in typeface header. They are
		padded out with spaces. If length ever fills out field, we will
		discard the last character.
		*** Move from iftops1.c on 7/1/91 - rs ***
*/
typedef struct {
   UW16   NFACES;
   SB8    typeFaceName[TF_NAME_LEN];
   SB8    familyName[FAM_NAME_LEN];
   SB8    weight[WEIGHT_DSC_LEN];
   UL32   typeFaceSet;
   SB8    descriptorSet[DESCR_SET_LEN];
} TF;

typedef TF FARPTR *PTF;

/*
bit definitions for PSparamSTR filetypes field
*/
#define PS_PFB_FILE     0x0001
#define PS_PFM_FILE     0x0002
#define PS_AFM_FILE     0x0004
#define PS_VFM_FILE     0x0008
#define OPTIONALFILES	(PS_PFM_FILE | PS_AFM_FILE | PS_VFM_FILE)

#if 0
typedef struct PSparamSTR
{
	UW16	filetypes;				/* afm, pfm, vfm requested */
	SB8	outFile[MAXPATHLEN];	/* output file base name */
#if VFM
	SL32	vfm_font_id;			/* as per Ventura spec */
#endif
} PSPARAMSTR;
#endif

/* Application IDs for PostScript */
#define APP_ATM		0
#define APP_VP			1
#define APP_WINDOWS	2
#define APP_WP50		3
#define APP_WP51		4
#define APP_OTHER		5
#define APP_NONE		-1

/**************************
* Atech Font Classes

Characteristics (by bit) - class in faceNamStr
 0 - Thin
 1 - Condensed
 2 - Wide
 3 - Expanded
 4 - Hollow
 5 - Bold
 6 - Italic
 7 - Other
**************************/
#define CL_THIN			0x01
#define CL_CONDENSED		0x02
#define CL_WIDE			0x04
#define CL_EXPANDED		0x08
#define CL_HOLLOW			0x10
#define CL_BOLD			0x20
#define CL_ITALIC			0x40
#define CL_OTHER			0x80


#define FS_BOLDITALIC   3       /* bold italic */


#define PFB_ASCII		1		/* pfb ascii section header code */
#define PFB_BINARY	2		/* pfb binary section header code */
#define PFB_END		3		/* pfb end section header code */

#define ENCVECSIZE  		2500		/* size of encryption/encoding buffers */
#define MAXOLDATA   		8192		/* max outline data size allowed */
#define LIMITCHECK		1500		/* max # of flattened path elements per char */
#define MAXPS_SYMBOLS	256		/* max # of postscript symbols in a set */
#define MAXPFMDATA  		8192		/* max pfm data size allowed */
#define MAXVFMTFNAME		15			/* max size of VFM typeface name */
#define MAXKERNPAIRS		512		/* max # of etmKernPairs */

#define ANSI_CHARSET    0

/*
Definitions for cg 'detailFaceDescriptor' array from library - 7/19/91 - rs
*/
/*
detailFaceDescriptor stemWeight definitions
*/
#define cg_EXTRALIGHT	10
#define cg_LIGHT			20
#define cg_NORMAL			30
#define cg_BOLD			40
#define cg_EXTRABOLD		50
#define cg_OUTLINE		60

/*
detailFaceDescriptor slantStyle definitions
*/
#define cg_SLANTNORMAL	10
#define cg_SLANTITALIC	20
#define cg_SLANTLITALIC	30

/*
detailFaceDescriptor stemMod definitions
*/
#define cg_SM_SERIF		10
#define cg_SM_SERIFx		20		/* old style */
#define cg_SM_SQUARE		30
#define cg_SM_SSERIF		40
#define cg_SM_SSERIFx	50		/* modified */
#define cg_SM_SCRIPTC	60		/* connecting */
#define cg_SM_SCRIPTNC	70		/* non-connecting */

/*
detailFaceDescriptor stemStyle definitions
*/
#define cg_SS_SSERIF		10		/* sans serif */
#define cg_SS_SERIF		20		/* serif */
#define cg_SS_SCRIPT		30
#define cg_SS_NOVELTY	40
#define cg_SS_SPECIAL	50

/* - this block added 6/17/91 - jfd, modified 7/10/91 - rs
 * Font weight values for 'dfWeight'
 * value ranges from 1 to 1000, values taken from Microsoft DDK
 * "printers and fonts" manual 11-5
 */
#define FW_THIN			100
#define FW_EXTRALIGHT   200
#define FW_LIGHT        300
#define FW_NORMAL			400
#define FW_MEDIUM			500
#define FW_SEMIBOLD		600
#define FW_BOLD         700
#define FW_EXTRABOLD    800
#define FW_HEAVY			900

/*
 * The following values are offsets into the descriptorSet array - jfd
 */
#define SLANTSTYLE_OFF  3
#define STEMWEIGHT_OFF  2
#define STEMSTYLE_OFF   0
/*
 * The following values are font family types used to set the value
 * "dfPitchAndFamily" in the PFM file - jfd
 */

#define FF_DONTCARE		(0)
#define FF_ROMAN        (1<<4)
#define FF_SWISS        (2<<4)
#define FF_MODERN       (3<<4)
#define FF_SCRIPT       (4<<4)
#define FF_DECORATIVE   (5<<4)
/*
End of block added 6/17/91 - jfd
*/

#define FS_NORMAL       0

/*
IF outline segment types
*/
#define IFMOVETO		0
#define IFLINETO		1
#define IFCURVETO		2
#define IFBEZIERTO	3

/*
PostScript Charstring commands
*/
#define c_ENDCHAR			14
#define c_HSBW				13
#define c_CLOSEPATH		9
#define c_HLINETO			6
#define c_HMOVETO			22
#define c_HCURVETO		31
#define c_RLINETO			5
#define c_RMOVETO			21
#define c_RRCURVETO		8
#define c_VHCURVETO		30
#define c_VLINETO			7
#define c_VMOVETO			4
#define c_HSTEM			1
#define c_VSTEM			3

/*
Some important cg character numbers
*/
#define CG_O				28		/* CG number of 'O' */
#define CG_X				46 	/* CG number of 'X' */
#define CG_o 				2	  	/* CG number of 'o' */
#define CG_x				20		/* CG number of 'x' */
#define CG_H				29		/* cgnum of letter 'H' */
#define CG_l				6		/* cgnum of letter 'l' */
#define CG_0				1601	/* cgnum of numeral '0' */
#define CG_1				1592	/* cgnum of numeral '1' */
#define CG_2				1593	/* cgnum of numeral '2' */
#define CG_7				1598	/* cgnum of numeral '7' */
#define CGSPACE			812	/* CG code for fixed space character */


#if T1HINTS					/* add 8/23/91 - rs */
#define MAXCHARSTEMS	30		/* maximum allowed stems per character */
typedef struct
{
	SW16	rep;			/* repeat count for this stem */
	SW16	loc;			/* start point X or Y for this stem */
	SW16	width;		/* dx or dy */
}  ASTEMSTRUC;
typedef ASTEMSTRUC FARPTR *PASTEMSTRUC;

typedef struct
{
	SW16	numStems;		/* total # of different stems in structure */
	ASTEMSTRUC a [MAXCHARSTEMS];
} STEMSTRUC;
typedef STEMSTRUC FARPTR *PSTEMSTRUC;

#define MAXSTDWIDTHS	12	/* maximum entries in StemSnapH & StemSnapV arrays */
#endif /* T1HINTS */

