/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/psrom.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: psrom.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/*
 * 
 *    Rev 1.9   07 Apr 1995 11:31:34   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.8   22 Apr 1994 15:31:20   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.7   22 Mar 1994 09:57:38   JOE
 * 
 * Added fields CODarray_Offset, COD_Offset and CSA_Offset to
 * PSOUT_DATA structure for ASIAN support.
 * 
 *    Rev 1.6   02 Sep 1993 10:49:36   JOE
 * In PSFONT_ENTRY structure, added fields "Panose_rev" and "Panose_length"
 * and changed "Panose" from a fixed 10-byte string to a variable length
 * string.
 * 
 *    Rev 1.5   16 Aug 1993 11:12:18   JOE
 * 
 * Changed documentation of data layout to include encoding array
 * mapping table.
 * 
 *    Rev 1.4   13 Aug 1993 17:44:56   JOE
 * 
 * Added "oencodearray" field to PSOUT_DATA structure.
 * 
 *    Rev 1.3   09 Aug 1993 08:49:24   JOE
 * Added field "FontType" to PSTON_ENTRY structure.
 * Added #defines for WORD_SUBRS_OFFSETS and LONG_SUBRS_OFFSETS.
 * 
 *    Rev 1.2   02 Aug 1993 14:31:24   JOE
 * 
 * PVCS cleanup.
 * 
 *    Rev 1.1   02 Aug 1993 13:46:24   JOE
 * 
 * PVCS cleanup.
 * 
 *    Rev 1.0   02 Aug 1993 09:03:08   JOE
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $   */
/* ix.h */

/*  16-Jul-93  jfd  Original
    02-Aug-93  jfd  PVCS cleanup.
    04-Aug-93  jfd  Added field "FontType" to PSFONT_ENTRY structure.
    05-Aug-93  jfd  Added #defines for WORD_SUBRS_OFFSETS and 
                    LONG_SUBRS_OFFSETS.
    13-Aug-93  jfd  Added "oencodearray" field to PSOUT_DATA structure.
    16-Aug-93  jfd  Changed documentation of data layout to include
                    encoding array mapping table.
    02-Sep-93  jfd  In PSFONT_ENTRY structure, added fields "Panose_rev"
                    and "Panose_length" and changed field "Panose" from
                    a fixed 10-byte string to a variable length string.
    22-Mar-94  jfd  Added fields CODarray_Offset, COD_Offset and
                    CSA_Offset to PSOUT_DATA structure for ASIAN
                    support.


 */

#if PST1_RDR


  /* This file describes PostScript Type 1 ROM font format. The initial
   * release will support a single font per block. The format will allow
   * for multiple fonts to reside within a single block. All blocks will
   * be stored in MOTOROLA format (byte order hi-lo). Therefore it may
   * be necessary to unpack bytes during runtime.
   */

  /* Each ROM block will begin on a quad boundary. The following block
   * header will reside at the start of all ROM blocks.
   */


#define MAXBLUES            14    /* from the White Book */
#define MAXOTHERBLUES       10    /* from the White Book */
#define MAXFAMBLUES         14    /* from the White Book */
#define MAXFAMOTHERBLUES    10    /* from the White Book */
#define MAXSTEMS            12    /* from the White Book */


#define WORD_CHARNAM_OFFSETS  0x0000
#define LONG_CHARNAM_OFFSETS  0x0001
#define WORD_CHARSTR_OFFSETS  0x0000
#define LONG_CHARSTR_OFFSETS  0x0002
#define WORD_SUBRS_OFFSETS  0x0000
#define LONG_SUBRS_OFFSETS  0x0004


/* Set the following offset values to the corresponding word or long
 * value defined above to write out the offsets tables of the PS font
 * block in the desired format.
 */

#define CHARNAM_OFFSETS   LONG_CHARNAM_OFFSETS
#define CHARSTR_OFFSETS   LONG_CHARSTR_OFFSETS
#define SUBRS_OFFSETS     LONG_SUBRS_OFFSETS

typedef struct
{
    UL32    FontType;          /* 0 == compositite, 1 == Latin */
    UL32    Font_Offset;       /* offset to this font */
    UL32    Font_Length;       /* # of bytes in this font */
    UW16    Panose_rev;        /* hi byte = major rev #, */
                               /* lo byte = minor rev #  */
    UW16    Panose_length;     /* # of bytes in Panose classification */
    UB8    *Panose;            /* variable length Panose classification */
    SB8    *FontName;          /* variable length name */
} PSFONT_ENTRY;

typedef PSFONT_ENTRY FARPTR * PPSFONT_ENTRY;

typedef struct
{
    UW16    ROM_Block_Format;  /* format of block (always 0 ) */
    UW16    Num_Fonts;         /* # of fonts in block */
    UL32    Flags;             /*  */
    UL32    Reserved;          /* reserved for future expansion */
    UL32    ROM_Block_Length;  /* # of bytes in entire block */

} PSROM_INDEX_ENTRY;

typedef PSROM_INDEX_ENTRY FARPTR * PPSROM_INDEX_ENTRY;


  /* PostScript ROM fonts will be defined by the following data
   * structure. It will always begin on a quad boundary.
   */

typedef struct
{
    UW16    Font_Format;       /* format of this entry (0=Asian, 1=Latin) */
    UW16    Reserved1;         /* reserved for future expansion */
    UL32    Flags;             /* flag entry */
                               /* bit 0 - 0 = 16-bit charname table offsets */
                               /*         1 = 32-bit    "        "      "     */
                               /* bit 1 - 0 = 16-bit charstrings table offsets */
                               /*         1 = 32-bit  "    "     "      "      */
                               /* bit 2 - 0 = 16-bit subr table offsets */
                               /*         1 = 32-bit  "    "     "      */
                               /* bit 3 - 0 = 16-bit encoding array table offsets */
                               /*         1 = 8-bit   "    "     "      */
                               /* (NOTE: Bit 3 not implemented at this time! */
                               /*        Hard-wired for 16-bits always. )    */
    UL32    Reserved2;         /* reserved for future expansion */
#if ASIAN_ENCODING
    UL32    CODarray_Offset;   /* offset to COD array */
    UL32    COD_Offset;        /* offset to COD data  */
    UL32    CSA_Offset;        /* offset to CSA data  */
#endif
    UW16    numSubrs;          /* # of Subrs */
    UW16    numChars;          /* # of chars in font block */
    UL32    Subr_Offset;       /* offset to table of Subrs offsets */
    UL32    oencodearray;      /* offset to encoding array mapping table */
    UL32    ocharnames;        /* offset to table of char name offsets */
    UL32    ocharstrings;      /* offset to table of charstrings offsets */

    SB8     *FontMatrix[6];    /* 6 var len strings FontMatrix */    
    SL32    UniqueID;          /*  */
    SL32    BlueScale;         /* fontvalue times 32768 */
    SW16    weight;            /* MicroSoft weights (1..1000) */
    SW16    ItalicAngle;       /*  */
    SW16    isFixedPitch;      /* 0 == not fixed pitch */
    SW16    UnderLinePosition; /*  */
    SW16    UnderLineThickness;/*  */
    SW16    FontType;          /* 4 == PostScript ROM font, decrypted */
    SW16    FontBBox[4];       /* all 0's if not available */
    SW16    nBlues;            /* # of BlueValues (0..14) */
    SW16    BlueValues[MAXBLUES];
                               /* BlueValue data */
    SW16    nOtherBlues;       /* # of OtherBlues (0..10) */
    SW16    OtherBlues[MAXOTHERBLUES];
                               /* OtherBlues data */
    SW16    nFamilyBlues;      /* # of FamilyBlues (0..14) */
    SW16    FamilyBlues[MAXFAMBLUES];
                               /* FamilyBlues data */
    SW16    nFamilyOtherBlues; /* # of FamilyOtherBlues (0..10) */
    SW16    FamilyOtherBlues[MAXFAMOTHERBLUES];
                               /*FamilyOtherBlues data */
    SW16    BlueShift;         /* not used */
    SW16    BlueFuzz;          /* not used */
    SW16    StdHW;             /*  */
    SW16    StdVW;             /*  */
    SW16    nStemSnapH;        /* # StemSnapH entries (0..12) */
    SW16    StemSnapH[MAXSTEMS];    /* StemSnapH array values */
    SW16    nStemSnapV;        /* # StemSnapV entries (0..12) */
    SW16    StemSnapV[MAXSTEMS];    /* StemSnapV array values */
    SW16    ForceBold;         /* 1 == ForceBold per B&W book */
    SW16    LanguageGroup;     /*  */
    SW16    lenIV;             /* always write 0, read whatever */

  /* The offsets table for the Subrs data follows. (Use 'Subr_Offset'
   * to get here!)
   */


  /* Subrs follow (if any). All data will be decrypted in this format.
   * (Use offsets from 'Subr_Offset' table to get to correct entry!)
   */


  /* The encoding array mapping table (if present) follows the
   * Subrs data.
   * (Use 'oencodearray' to get here!)
   */


  /* The offsets table for the char names data follows the
   * encoding array mapping table (if present).
   * (Use 'ocharnames' to get here!)
   */


  /* The char names data follows.
   * (Use offsets from 'ocharnames' table to get to correct entry!)
   */


  /* The offsets table for the charstrings data follows the
   * char names data.
   * (Use 'ocharstrings' to get here!)
   */


  /* The charstrings data follows.
   * (Use offsets from 'ocharstrings' table to get to correct entry!)
   */


} PSOUT_DATA;

#endif  /* PST1_ROM */







