/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/q3.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: q3.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.5   06 Jul 1995 08:21:46   JOE
 * 
 * Basic 1200 dpi support.
 * 
 *    Rev 1.4   07 Apr 1995 11:31:24   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 15:31:36   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   14 Jan 1993 11:06:26   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:46:50   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:38:28   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* q3.h */

/*
  19-May-91 awr  Changed parameters of q3 to vectors
  27-Dec-91 awr  Defined MAX_SD_LEVS
  02-Apr-92 rs   Portability cleanup (see port.h).
  14-Jun-92 awr  Added 16/32 changes from version 2.32.  Changed
                 parameters of q3() and control_points to INTRVECTORS
  06-Jul-95 mac  Basic 1200 dpi support.
*/

#define MAX_SD_LEVS  4  /*  Max number of Chaikin subdivide levels,
                         *  1<<MAX_SD_LEVS is the max number of lineto's
                         *  that a quadratic bezier can produce.
                         *  2*(1<<MAX_SD_LEVS) + 1 is the number of
                         *  coordinates that the return buffer for q3()
                         *  should hold.
                         */


#ifdef NOT1200DPI

#if INTR_SIZE == 16
#define	powincr	( 1 )						/* power increment for pixel size   */
#define	powmins	( 0 )						/* power increment minus = powincr-1*/
#define	powplus	( 2 )						/* power increment plus  = powincr+1*/
#define	areadiv	( 6 )						/* area shift divisor = 4+2*powincr */
#define	incr(t)	( ((SW16)(t)) << 1 )
#define	decr(t)	( (SW16)((t) >> 1) )
#define	xcrd(x)	(( x + xt ) << 1)
#define	ycrd(y)	(( y + yt ) << 1)
#endif                        
#if INTR_SIZE == 32
#define	powincr	( 3 )						/* power increment for pixel size   */
#define	powmins	( 2 )						/* power increment minus = powincr-1*/
#define	powplus	( 4 )						/* power increment plus  = powincr+1*/
#define	areadiv	( 10 )					/* area shift divisor = 4+2*powincr */
#define	incr(t)	( ((SL32)(t)) << 3 )
#define	decr(t)	( (SW16)((t) >> 3) )
#define	xcrd(x)	( ((SL32)x + xt) << 3 )
#define	ycrd(y)	( ((SL32)y + yt) << 3 )
#endif                        

#else

#if INTR_SIZE == 16
#define	powincr	( 1 )						/* power increment for pixel size   */
#define	powmins	( 0 )						/* power increment minus = powincr-1*/
#define	powplus	( 2 )						/* power increment plus  = powincr+1*/
#define	areadiv	( 6 )						/* area shift divisor = 4+2*powincr */
#define	incr(t)	( ((SW16)(t)) << 1 )
#define	decr(t)	( (SW16)((t) >> 1) )
#define	xcrd(x)	(( x + xt ) << 1)
#define	ycrd(y)	(( y + yt ) << 1)
#endif                        
#if INTR_SIZE == 32
#define	powincr	( 3 )						/* power increment for pixel size   */
#define	powmins	( 2 )						/* power increment minus = powincr-1*/
#define	powplus	( 4 )						/* power increment plus  = powincr+1*/
#define	areadiv	( 10 )					/* area shift divisor = 4+2*powincr */
#define	incr(t)	( ((SL32)(t)) << 3 )
#define	decr(t)	( (SW16)((t) >> 3) )
#define	xcrd(x)	( ((SL32)(x) + xt) << 3 )
#define	ycrd(y)	( ((SL32)(y) + yt) << 3 )
#endif                        

#endif  /* NOT1200DPI */

#ifdef LINTARGS
EXTERN UW16 q3(INTRVECTOR, INTRVECTOR, INTRVECTOR);
EXTERN VOID  control_points(INTRVECTOR, INTRVECTOR, INTRVECTOR,
                                        PINTRVECTOR, PINTRVECTOR);
#else
EXTERN UW16 q3();
EXTERN VOID  control_points();
#endif

