/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/segments.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: segments.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.4   07 Apr 1995 11:31:16   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.3   22 Apr 1994 15:31:22   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.2   14 Jan 1993 11:06:22   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:47:46   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.0   09 Dec 1992 11:38:02   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/*  segments.h */


/*  Typedefs for the various segments in a typeface library file
 *     20-Mar-90   jfd   Added "glob_ital_tan" to FACE structure
 *                       Added parameter definition "NO_TANGENT"
 *     21-Jul-90   awr   moved segment definitions for CGIFsegments()
 *                       to cgif.h
 *     31-Jan-91   dET   add support for MSC multi-model compilation.
 *                       channged lower case typedefs to uppercase to be 
 *                       consistent with the rest of the code.
 *     26-May-91   awr   added ultra-slim "face header" entry structure
 *                       definition.
 *      4 Oct 91   ss    Added defines CH_DIR_ENTRY_SIZE and 
 *                       US_CH_DIR_ENTRY_SIZE to help with SPARC port.
 *     02-Apr-92   rs    Portability cleanup (see port.h).
 */


#define NO_TANGENT   0x20000L  /* Flag indicating that a screen font */
                              /* has been substituted and an italic */
                              /* tangent has been calculated, so due*/
                              /* not recompute the tangent using the*/
                              /* sin and cos                        */



/*---------------------------------------------------------*/
/*   Face Header Segment (Character Directory)             */
/*---------------------------------------------------------*/

/*  Normal version for 'D' and 'S' libraries */

typedef struct
{
    UW16  charnum;
    UL32  charoff;
    UW16  charcount;

} CH_DIR_ENTRY;
typedef CH_DIR_ENTRY FARPTR * PCH_DIR_ENTRY;

/* need this to be explicit for SPARC which would long align fields */
/* before computing 'sizeof'                            -ss 8/28/91 */
#define CH_DIR_ENTRY_SIZE  ( 2 * sizeof(UW16) + sizeof(SL32) )


/*  Version for 'U' ultra-slim libraries. This version doesn't have
 *  the sizes of characters.  Sizes are computed by subtracting the
 *  pointers to successive characters
 */

typedef struct
{
    UW16  charnum;
    UL32  charoff;

} US_CH_DIR_ENTRY;
typedef US_CH_DIR_ENTRY FARPTR * PUS_CH_DIR_ENTRY;

/* need this to be explicit for SPARC which would long align fields */
/* before computing 'sizeof'                            -ss 8/28/91 */
#define US_CH_DIR_ENTRY_SIZE  ( sizeof(UW16) + sizeof(SL32) )


/*--------------------------------*/
/*  Character Width Segment (104) */
/*--------------------------------*/
typedef struct
{
    UW16 width;
    UW16 flags;

} CHARWIDTH;
typedef CHARWIDTH FARPTR * PCHARWIDTH;




/*--------------------------------*/
/* Display Header Segment (109)   */
/*--------------------------------*/

typedef struct
{
  UW16     NCHAR;
  SB8      binaryFileName[12];
  UW16     fontLimits[4];
  UW16     reverseVideoLimits[4];
  UW16     leftReference;
  UW16     baselinePosition;
  UW16     minimumPointSize;
  UW16     maximumPointSize;
  UW16     minimumSetSize;
  UW16     maximumSetSize;
  UB8     controlCode[4];
  UW16     masterPointSize;
  UW16     scanDirection;
  SW16      italicAngle;
  SW16      xHeight;
  UW16     scanResolutionY;
  UW16     scanResolutionX;
  UW16     outputEnable;
} DISPLAY;

typedef DISPLAY FARPTR * PDISPLAY;


/*--------------------------------*/
/*  Face Attribute Segment (105)  */
/*--------------------------------*/

typedef struct
{
  UB8         languageType;
  UB8         fontUsage;
  UB8         isFixedPitch;
  UB8         escapeUnit;
  UW16         scaleFactor;
  UW16         fixedSpaceRelWidths[3];
  UW16         leftReference;
  UW16         baselinePosition;
  SW16          windowTop;
  SW16          windowBottom;
  struct {
    SW16   zeroPoint;
    SW16   variablePoint;
  } autoVarComp[3];
  SW16          ascender;
  SW16          descender;
  SW16          capHeight;
  SW16          xHeight;
  SW16          lcAccenHeight;
  SW16          ucAccentHeight;
  UW16         charPica;
  SW16          leftAlign;
  SW16          rightAlign;
  SW16          uscoreDepth;
  UW16         uscoreThickness;
  SW16          windowLeft;
  SW16          windowRight;
  UW16         spaceBand;
}
FACE_ATT;
typedef FACE_ATT FARPTR * PFACE_ATT;

