/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/sym.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: sym.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.13   07 Apr 1995 11:31:20   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.12   19 Jan 1995 16:20:40   MARTIN
 * 
 * Added SYMmapTT.
 * 
 *    Rev 1.11   16 Jan 1995 14:14:52   JOE
 * 
 * Added support for MicroType symbol sets.
 * 
 *    Rev 1.10   16 Dec 1994 14:23:56   MARTIN
 * 
 * Added FCO_TT conditional around SYMmapReverse.
 * 
 *    Rev 1.9   15 Dec 1994 20:02:56   MARTIN
 * 
 * Added SYMmapReverse.
 * 
 *    Rev 1.8   08 Sep 1994 18:02:04   MIKE
 * #define SYMBOLSET_TT if FCO_RDR is enabled.
 * 
 *    Rev 1.7   08 Jun 1994 12:00:28   MIKE
 * Added prototype for SYMnoMap().
 * 
 *    Rev 1.6   22 Apr 1994 15:31:24   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.5   15 Jun 1993 11:14:22   ROB
 * Add 'T1ENCODING' to support type 1 encoding arrays.
 * 
 *    Rev 1.4   14 Jan 1993 11:14:20   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.3   15 Dec 1992 13:30:12   MIKE
 * No change.
 * 
 *    Rev 1.2   14 Dec 1992 08:47:54   LISA
 * No change.
 * 
 *    Rev 1.1   11 Dec 1992 15:05:12   LISA
 * Made change to keyword Log
 * 
 *    Rev 1.0   09 Dec 1992 11:38:30   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* sym.h */




/*--------------------------------*/
/* Symbol set file directoy entry */
/*--------------------------------*/

/*  Modification History:
 *
 *  24 Jun 91  ss   Changed PBYTE SYMBOLSET.pss_directory to PUBYTE.
 *  28 Jun 91  rs   Added prototype for SYMmapR().
 *  25 Oct 91  ss   Added SS_COUNT_SIZE and SS_COUNT_TYPE defines.
 *  28-Oct-91  jfd  Changed typedef for PSS_ENTRY from * to FARPTR * to get
 *                  rid of compiler warning when building medium model.
 *  02-Apr-92  rs   Portability cleanup (see port.h).
 *  08-Jul-92  jfd  Code cleanup.
 *  24-Sep-92  mby  Added UFSS_DIRECTORY structure; file IDs for UIF.SS and
 *                  UTT.SS file formats; #defined offsets into SS_DIR... and
 *                  UFSS_DIR... structures.
 *  29-Sep-92  mby  SYMBOLSET has pointers/handles to two symbol set directories.
 *                  Added GET_xWORD... GET_xLONG... macros.
 *  30-Sep-92  mby  Change SYMBOLSET.pss_entry declaration from PSS_ENTRY to
 *                  LPUW16. Change function declaration to SYMnew(UW16, UW16);
 *  30-Sep-92  jfd  Removed conditional compiles based on SPARC and
 *                  replaced with conditional compiles based on
 *                  (NAT_ALIGN == 4) wherever possible.
 *  08-Oct-92  mby  #defined SYMBOLSET_IF, SYMBOLSET_TT, NSS_FILES, whose
 *                  values depend on which FSTs are enabled. Changed SYMBOLSET
 *                  structure. Added SYMBOLSET.platID & SYMBOLSET.specID
 *  21-Oct-92  mby  Moved GET_x...() macros into "cgmacros.h"
 *  04-Jun-93  jfd  Added define for T1ENCODING (Type 1 Encoding).
 *  06-Jun-94  mby  Added prototype for SYMnoMap().
 *  08-Sep-94  mby  #define SYMBOLSET_TT if FCO_RDR is enabled.
 *  15-Dec-94  SBM  Added  SYMmapReverse.
 *  16-Dec-94  SBM  Added FCO_TT conditional around SYMmapReverse. Only the
 *                  TrueType generator uses this code for now.
 *  04-Jan-95  jfd  Added support for MicroType symbol sets.
 *  19-Jan-95  SBM  Added SYMmapTT.
 */

/* Size and type for symbol set count (entry count)   -ss 10/25/91 */
#if (NAT_ALIGN == 4)  /* changed from "ifdef SPARC" -jfd 9/30/92 */
#define SS_COUNT_SIZE  sizeof(SL32)
#define SS_COUNT_TYPE  SL32
#else
#define SS_COUNT_SIZE  sizeof(SW16)
#define SS_COUNT_TYPE  SW16
#endif  /* (NAT_ALIGN == 4)  */

/*
Type 1 related items
*/
#define     T1ENCODING  0x8100   /* Type 1 Encoding */


typedef struct
{
    UW16 ss_code;    /* symbol set code */
    UW16 symSetCode; /* 32 * PCLnum + (short)PCLchar - 64 */
    UW16 type;
    UW16 class;
    UW16 first_code; /* first code */
    UW16 num_codes;  /* number of codes */
    UL32 offset;     /* offset to symbol set in symbol set file */

}  SS_DIRECTORY;

typedef SS_DIRECTORY FARPTR * PSS_DIRECTORY;

typedef struct
{
    UW16 ss_code;    /* symbol set code */
    UW16 symSetCode; /* 32 * PCLnum + (short)PCLchar - 64 */
    UW16 type;
    UW16 class;
    UW16 first_code; /* first code */
    UW16 num_codes;  /* number of codes */
    UL32 offset;     /* offset to symbol set in symbol set file */
    UW16 platformID; /* Character mapping information required */
    UW16 specificID; /*   when loading TrueType fonts. */

}  UFSS_DIRECTORY;

typedef UFSS_DIRECTORY FARPTR * PUFSS_DIRECTORY;


#define IFSSIDN   0x55494631L   /* UIF.SS file identifier -- 9-24-92 */
#define TTSSIDN   0x55545431L   /* UTT.SS file identifier */
#define MTSSIDN   0x554D5431L   /* UMT.SS file identifier */

/* Offsets into SS_DIRECTORY and UFSS_DIRECTORY structures.    */
#define SSDIR_SIZE   16
#define UFSSDIR_SIZE 20
#define SSD_FILEID    0         /* 'UIF1', 'UTT1 or 'UMT1' */
#define SSD_NSS       4         /* Number of symbol sets */
#define SSD_DIRSIZE   6         /* sizeof(SS_DIRECTORY or UFSS_DIRECTORY) */
#define SSD_DOFF      8         /* Offset to start of directory table */
#define SSD_CODE      0         /* ss_code    */
#define SSD_SYMCODE   2         /* symSetCode */
#define SSD_TYPE      4         /* type       */
#define SSD_CLASS     6         /* class      */
#define SSD_FIRSTC    8         /* first code */
#define SSD_NUMC     10         /* num_codes  */
#define SSD_OFF      12         /* offset     */
#define SSD_PLID     16         /* platformID */
#define SSD_SPID     18         /* specificID */


/*--------------------------------*/
/*        Symbol set entry        */
/*--------------------------------*/

typedef struct
{
    UW16 cgnum;
    UW16 bucket_type;   /* no longer used */
} SS_ENTRY;
typedef SS_ENTRY FARPTR * PSS_ENTRY;

#if (IF_RDR || PST1_RDR)

#if FCO_RDR
#define  SYMBOLSET_IF  0
#define  SYMBOLSET_TT  1
#define  SYMBOLSET_MT  2
#define  NSS_FILES     3
#endif
#if (TT_RDR && !FCO_RDR)
#define  SYMBOLSET_IF  0
#define  SYMBOLSET_TT  1
#define  NSS_FILES     2
#endif
#if !(TT_RDR || FCO_RDR)
#define  SYMBOLSET_IF  0
#define  NSS_FILES     1
#endif

#else

#if FCO_RDR
#define  SYMBOLSET_TT  0
#define  SYMBOLSET_MT  1
#define  NSS_FILES     2
#endif
#if (TT_RDR && !FCO_RDR)
#define  SYMBOLSET_TT  0
#define  NSS_FILES     1
#endif

#endif



typedef struct
{
#if ROM
    LPUB8        pss_directory[NSS_FILES];
#else
    MEM_HANDLE   hss_directory[NSS_FILES];    /* directory of symbol sets */
#endif

    LPUW16       pss_entry[NSS_FILES];     /* array of entries for cur IF ss */
    UW16         curssnum;                 /* current symbol set number     */
    UW16         ss_first_code[NSS_FILES]; /* current symbol set first code */
    UW16         ss_last_code[NSS_FILES];  /*  "        "     "  last code  */
    UW16         ss_symSetCode[NSS_FILES];
    UW16         ss_type[NSS_FILES];
    UW16         ss_class[NSS_FILES];
    UB8          ss_enabled[NSS_FILES];    /* 1 = YES; 0 = NO */
#if TT_RDR
    UW16         tt_platID;
    UW16         tt_specID;
#endif

} SYMBOLSET;



#ifdef LINT_ARGS
EXTERN UW16    SYMmap(SW16, int);
EXTERN UW16    SYMinit(VOID);
EXTERN VOID    SYMexit(VOID);
EXTERN BOOLEAN SYMnew(UW16, UW16);
EXTERN BOOLEAN SYMnoMap(LPUB8, UW16);
EXTERN SW16    SYMmapR(UW16);       /* add 6/27/91 - rs */
#if FCO_TT
EXTERN SW16    SYMmapReverse(UW16, int);
EXTERN UW16    SYMmapTT(SW16, int);
#endif
#else
EXTERN UW16    SYMmap();
EXTERN UW16    SYMinit();
EXTERN VOID    SYMexit();
EXTERN BOOLEAN SYMnew();
EXTERN BOOLEAN SYMnoMap();
EXTERN SW16    SYMmapR();           /* add 6/27/91 - rs */
#if FCO_TT
EXTERN SW16    SYMmapReverse();
EXTERN UW16    SYMmapTT();
#endif
#endif


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/* Processor-independent macros to read 1, 2, or 4 bytes from memory in
 * high, ..., low order. Alignment on 2- or 4-byte boundaries is not required.
 */

#if 0   /* remove; include in cgmacros.h  - mby 10/21/92 */

#define GET_xWORD(a) (unsigned short)( (*(unsigned char*)(a) << 8) |   \
                                        *((unsigned char*)(a)+1) )

#define GET_xLONG(a) ( ((unsigned long) *(unsigned char*)(a) << 24) |      \
                       ((unsigned long) *((unsigned char*)(a)+1) << 16) |  \
                       ((unsigned long) *((unsigned char*)(a)+2) << 8)  |  \
                        (unsigned long) *((unsigned char*)(a)+3) )

#define GET_xBYTE_OFF(a,OFFSET)  ( *((unsigned char*)(a)+OFFSET) )

#define GET_xWORD_OFF(a,OFFSET)  \
             (unsigned short)( (*((unsigned char*)(a)+OFFSET) << 8) |  \
                                *((unsigned char*)(a)+OFFSET+1) )

#define GET_xLONG_OFF(a,OFFSET)  \
           ( ((unsigned long) *((unsigned char*)(a)+OFFSET) << 24) |    \
             ((unsigned long) *((unsigned char*)(a)+OFFSET+1) << 16) |  \
             ((unsigned long) *((unsigned char*)(a)+OFFSET+2) << 8) |   \
              (unsigned long) *((unsigned char*)(a)+OFFSET+3)  )
#endif  /* 0 */

