/* Copyright (C) 1989, 1990, 1991, 1992, 1993, 1994, 1995 all rights reserved, 
 * by Bayer Corp., Agfa Division, Wilmington, MA.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and with
 * the inclusion of the above copyright notice. This software or any
 * other copies thereof may not be provided or otherwise made
 * available to any other person except as allowed under license. No
 * title to and ownership of the software is hereby transferred.
 *
 * This information in this software is subject to change without notice
 */
/* $Header: /usr/local/cvsrep/Genesis/ufst/sys/inc/ut.h,v 1.4 2003/05/07 23:45:01 Lann Exp $ */
/* $Log: ut.h,v $
/* Revision 1.4  2003/05/07 23:45:01  Lann
/* Revision V1_00_04
/* 
 * 
 *    Rev 1.6   07 Apr 1995 11:31:22   LISA
 * 
 * Changed copyright information from Miles Inc. to Bayer Corp.
 * 
 *    Rev 1.5   22 Apr 1994 15:31:40   LISA
 * 
 * Made modifications to copyright/disclaimer notice.
 * 
 *    Rev 1.4   10 Jun 1993 08:13:58   JOE
 * Changed all references to "char" to "SB8" for transportability.
 * 
 *    Rev 1.3   14 Jan 1993 11:19:56   LISA
 * Made change to Log keyword
 * 
 *    Rev 1.2   14 Jan 1993 11:13:52   LISA
 * Removed CntrlZ character
 * 
 *    Rev 1.1   14 Dec 1992 08:47:20   LISA
 * No change.
 * 
 *    Rev 1.0   09 Dec 1992 11:38:18   LISA
 * Initial revision.
*/
/* $Date: 2003/05/07 23:45:01 $ */
/* ut.h */
/*
 * Copyright (C) Hewlett Packard, 1990. All rights reserved.
 */

/******************************************************************
 *   Include file for Utility functions
 ******************************************************************/
/* History:
 *
 *    6-Jun-90 rcm  Created.
 *   22-Jun-90 jfd  Added declarations for _lopen, _lread, _llseek
 *                  and _lwrite
 *   26-Jun-90 jfd  Commented out declarations for UTfileSize, UTgetString,
 *                  atol, atoi
 *   27-Jun-90 jfd  Added declaration for "lstrcmpi"
 *   24-Aug-90 jfd  Moved function declarations to end of file
 *   29-Nov-90 jfd  Removed second argument from myaccess() because it
 *                  was never used.
 *   19-Jul-91 jfd  Changed "MSWINDOWS" to "_WINDOWS".
 *   10-Jun-93 jfd  Changed all references to "char" to "SB8" for portability.
 */


/* use the WINDOWS file open function if _WINDOWS is defined  */
/* Cannot include "windows.h" because of the type redefinition */

#ifdef _WINDOWS
#ifndef OF_READ
typedef struct tagOFSTRUCT
  {
    SB8    cBytes;
    SB8    fFixedDisk;
    SW16    nErrCode;
    SB8    reserved[4];
    SB8    szPathName[128];
  } OFSTRUCT;

typedef OFSTRUCT       *POFSTRUCT;
typedef OFSTRUCT near  *NPOFSTRUCT;
typedef OFSTRUCT far   *LPOFSTRUCT;

/* OpenFile() Flags */
#define OF_READ             0x0000
#define OF_WRITE            0x0001
#define OF_READWRITE        0x0002
#define OF_SHARE_COMPAT     0x0000
#define OF_SHARE_EXCLUSIVE  0x0010
#define OF_SHARE_DENY_WRITE 0x0020
#define OF_SHARE_DENY_READ  0x0030
#define OF_SHARE_DENY_NONE  0x0040
#define OF_PARSE            0x0100
#define OF_DELETE           0x0200
#define OF_VERIFY           0x0400
#define OF_CANCEL           0x0800
#define OF_CREATE           0x1000
#define OF_PROMPT           0x2000
#define OF_EXIST            0x4000
#define OF_REOPEN           0x8000

typedef SB8 far	    *LPSTR;                  /* 06-22-90 jfd */
typedef UW16 far * LPUWORD;                   /* 06-26-90 jfd */
typedef struct stat far *LPSTAT;               /* 06-26-90 jfd */
typedef SW16 far * LPWORD;                     /* 06-26-90 jfd */
typedef UL32 far * LPULONG;                   /* 06-26-90 jfd */

int  far pascal OpenFile(LPSTR, LPOFSTRUCT, SW16);
int  far cdecl  wsprintf(LPSTR, LPSTR,...);

int  far pascal _lopen( LPSTR, int );           /* 06-26-90 jfd */
int  far pascal _lclose( int );                 /* 06-22-90 jfd */
int  far pascal _lcreat( LPSTR, int );          /* 06-22-90 jfd */
SL32 far pascal _llseek( int, long, int );      /* 06-22-90 jfd */
SW16 far pascal _lread( int, LPSTR, int );      /* 06-22-90 jfd */
SW16 far pascal _lwrite( int, LPSTR, int );     /* 06-22-90 jfd */

#define LSEEK_SET (int) 0
#define LSEEK_CUR (int) 1
#define LSEEK_END (int) 2

EXTERN int far pascal latoi(LPSTR);
EXTERN int far pascal myfstat(int, LPSTAT);
SL32 far pascal myfilelength(int);
EXTERN int far pascal lstrncmp(LPSTR, LPSTR, int);
EXTERN int far pascal lstrnicmp(LPSTR, LPSTR, int);
EXTERN VOID far pascal MyFreeMem(HANDLE);
EXTERN LPSTR far pascal lstrncat(LPSTR, LPSTR, int);
EXTERN int far pascal lstrcmpi(LPSTR, LPSTR);


LPSTR		far pascal lmemcpy( LPSTR, LPSTR, SW16 );
LPSTR		far pascal lmemset( LPSTR, SB8, SW16 );

int         far pascal lstrcmp( LPSTR, LPSTR );
LPSTR       far pascal lstrcpy( LPSTR, LPSTR );
LPSTR       far pascal lstrcat( LPSTR, LPSTR );
int         far pascal lstrlen( LPSTR );
LPSTR       far pascal lstrncpy( LPSTR, LPSTR, int );
int         far pascal lmemcmp( LPSTR, LPSTR, int );
VOID far pascal MyRewind(int);
SL32 far pascal myftell(int);
int far pascal myaccess(LPSTR);

#endif
#endif


